<!--
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      https://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<!-- Need a better picture, removed for now
#### [Next Hadoop Wave][revolution]

[![Next Hadoop Wave](images/carousel/revolution.png)][revolution]

Trafodion brings enterprise-class operational workloads to Hadoop! You can now run all of your data workloads on a single platform based on Hadoop.
-->

#### [Hadoop-Scale with SQL Access][scale]

[![Hadoop Scale](images/carousel/scale.png)][scale]

Running out of room with your current SQL solution? Starting a new operational application? Trafodion allows you to work in SQL at Hadoop-scale levels.

#### [Fully Integrated with HBase and Hive][stack]

[![Trafodion Stack](images/carousel/stack.png)][stack]

Trafodion provides SQL access to structured, semi-structured, and unstructured data allowing you to run operational, historical, and analytical workloads on a single platform.

[revolution]: https://trafodion.apache.org
[scale]: https://trafodion.apache.org
[stack]: index.html


---

## News


<table><tr><td>
  <p><h5>We're working on release 2.4!</h5></p>
  <p>Check out the <a href="https://cwiki.apache.org/confluence/display/TRAFODION/Roadmap">Roadmap</a> page for planned content.</p>
  <p><h5>Apache Trafodion 2.3.0 was released February 28, 2019.</h5></p>
  <p>Check it out on the <a href="https://trafodion.apache.org/download.html">Download</a> page.</p>
  <p><h5>Apache Trafodion 2.2.0, our first release as a Top Level Project, was released on March 12, 2018.</h5></p>
  <p>Check it out on the <a href="https://trafodion.apache.org/download.html">Download</a> page.</p>
  <p><h5>Apache Trafodion is now a Top Level Project!</h5></p>
  <p>See the <a href="https://globenewswire.com/news-release/2018/01/10/1286517/0/en/The-Apache-Software-Foundation-Announces-Apache-Trafodion-as-a-Top-Level-Project.html">NewsWire</a> article for the official announcement.</p>
  <p>See also this nice <a href="https://thenewstack.io/sql-hadoop-database-trafodion-bridges-transactions-analysis-divide/">article</a> where Trafodion's own Suresh Subbiah spreads the word on Trafodion's features.</p>
  <p><h5>Apache Trafodion 2.1.0-incubating was released on May 1, 2017.</h5></p>  
  <p><h5>Want to discuss Trafodion in Chinese? Join the Trafodion discussion on Tencent QQ!</h5></p> 
  <p><a href="https://im.qq.com/">QQ</a> Group ID: 233105278.</p>
</td></tr></table>

<!-- 20160524 GTA Need more logos before using this part.

Powered by Trafodion

#### Join the Trafodion Movement

![Slide 1](images/logo-carousel/slide-1.png)

Contribution opportunites: usage, code, tests, presentations, documentations, web sites, and things we didn't think of yet.

#### Powered By Trafodion

![Slide 2](images/logo-carousel/slide-2.png)

Are you using Trafodion? We need permission to add your company's logo here. 

-->

## About

Apache Trafodion is a webscale SQL-on-Hadoop solution enabling transactional or operational workloads on Apache Hadoop. 

The name &quot;Trafodion&quot; (the Welsh word for transactions, pronounced &quot;Tra-vod-eee-on&quot;) was chosen specifically to emphasize the differentiation that Trafodion provides in closing a critical gap in the Hadoop ecosystem. 

Trafodion builds on the scalability, elasticity, and flexibility of Hadoop. Trafodion extends Hadoop to provide guaranteed transactional integrity, enabling new kinds of big data applications to run on Hadoop. 

---

## Key Features

* Full-functioned ANSI SQL language support
* JDBC/ODBC connectivity for Linux/Windows clients
* Distributed ACID transaction protection across multiple statements, tables and rows
* Performance improvements for OLTP workloads with compile-time and run-time optimizations
* Support for large data sets using a parallel-aware query optimizer


## Key Benefits

* Reuse existing SQL skills and improve developer productivity
* Distributed ACID transactions guarantee data consistency across multiple rows and tables
* Interoperability with existing tools and applications
* Hadoop and Linux distribution neutral
* Easy to add to your existing Hadoop infrastructure

---

<table>
  <tr>
    <td width="33%" valign="top">
      <center>
        <h2>Understand</h2>
        <img src="images/logos/understand.png" width="108" height="108"/>
        <h4>What makes Trafodion unique</h4>
        <div class="customHr">.</div>
      </center>
      <ul>
        <li><a href="architecture-overview.html">Architecture</a></li>
        <li><a href="documentation.html">Documentation</a></li>
        <li><a href="faq.html">FAQ</a></li>
      </ul>
    </td>
    <td width="33%" valign="top">
      <center>
        <h2>Use</h2>
        <img src="images/logos/use.png" width="108" height="108"/>
        <h4>Download and try Trafodion</h4>
        <div class="customHr">.</div>
      </center>
      <ul>
        <li><a href="download.html">Download</a></li>
        <li><a href="quickstart.html">Quick Start</a></li>
        <li><a href="release-notes.html">Release Notes</a></li>
      </ul>
    </td>
    <td width="33%" valign="top">
      <center>
        <h2>Community</h2>
        <img src="images/logos/community.png" width="108" height="108"/>
        <h4>Be part of Trafodion</h4>
        <div class="customHr">.</div>
      </center>
      <ul>
        <li><a href="contributing-redirect.html">Contribute</a></li>
        <li><a href="mail-lists.html">Discuss</a></li>
        <li><a href="https://cwiki.apache.org/confluence/display/TRAFODION/Apache+Trafodion+Home">Wiki</a></li>
      </ul>
    </td>
  </tr>
</table>
