/**********************************************************************
// @@@ START COPYRIGHT @@@
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//
// @@@ END COPYRIGHT @@@
**********************************************************************/
/*
 * HISTORY
 * $Log: UCS_jp_data.c,v $
 * Revision 1.1.9.2  2002/01/28  15:20:13
 * 	Fix QAR 91429 by mapping SJIS 0x8160 (JISX0208 2141) to U+FF5E
 * 	(fullwidth tilde) instead of U+301C (wave dash). The JISX0212
 * 	mapping from 2237 was also changed from 7E to U+301C.
 *
 * Revision 1.1.9.1  2001/12/07  15:36:12
 * 	Map all the previously unmapped character to UDC.
 * 	Map ASCII directly to ASCII characters.
 *
 * Revision 1.1.5.1  2000/01/13  20:24:41
 * 	New data files for supporting Unicode 3.0.
 *
 * Revision 1.1.3.3  1997/03/07  18:53:21
 * 	Reduce overall table size & support more PC code pages.
 * 	[1997/03/06  19:58:10  Long_Man]
 *
 * $EndLog$
 */

#ifndef USE_OUR_MB_WC_DATA_TABLES

/********************************************************************
 * Data for mapping between Japanese code sets and Unicode
 * This file is software-generated.  Do not manually edit it.
 ********************************************************************/

#include "fcconv.h"

#define _sjis_to_ucs_cell2	_jp_to_ucs_cell2
#define _sjis_to_ucs_cell4	NULL
#define _deckanji_to_ucs_cell2	_jp_to_ucs_cell2
#define _deckanji_to_ucs_cell4	NULL
#define _eucjp_to_ucs_cell2	_jp_to_ucs_cell2
#define _eucjp_to_ucs_cell4	NULL
#define _sdeckanji_to_ucs_cell2	_jp_to_ucs_cell2
#define _sdeckanji_to_ucs_cell4	NULL

#define _ucs_to_sjis_cell2	_ucs_to_jp_cell2
#define _ucs_to_sjis_cell4	NULL
#define _ucs_to_deckanji_cell2	_ucs_to_jp_cell2
#define _ucs_to_deckanji_cell4	NULL
#define _ucs_to_eucjp_cell2	_ucs_to_jp_cell2
#define _ucs_to_eucjp_cell4	_ucs_to_jp_cell4
#define _ucs_to_sdeckanji_cell2	_ucs_to_jp_cell2
#define _ucs_to_sdeckanji_cell4	_ucs_to_jp_cell4

/* Row table for mapping SJIS to Unicode */

#define	sjis_to_ucs_DMAP	1
static row_t _sjis_to_ucs_row[] = {
/* 000 */  0x000,  0x001,  0x002,    BAD,    BAD,    BAD,  0x003,  0x004,
/* 008 */  0x005,  0x006,  0x007,  0x008,  0x009,  0x00a,  0x00b,  0x00c,
/* 010 */  0x00d,  0x00e,  0x00f,  0x010,  0x011,  0x012,  0x013,  0x014,
/* 018 */  0x015,  0x016,  0x017,  0x018,  0x019,  0x01a,  0x01b,  0x01c,
/* 020 */  0x01d,  0x01e,  0x01f,  0x020,  0x021,  0x022,  0x023,  0x024,
/* 028 */  0x025,  0x026,  0x027,  0x028,  0x029,  0x02a,  0x02b,  0x02c,
/* 030 */  0x02d,  0x02e,  0x02f,  0x030,  0x031,  0x032,  0x033,  0x034,
/* 038 */  0x035,  0x036,  0x037,  0x038,  0x039,  0x03a,  0x03b,  0x03c,
/* 040 */  0x03d,  0x03e,  0x03f,  0x040,  0x041,  0x042,  0x043,  0x044,
/* 048 */  0x045,  0x046,  0x047,  0x048,  0x049,  0x04a,  0x04b,  0x04c,
/* 050 */  0x04d,  0x04e,  0x04f,  0x050,  0x051,  0x052,  0x053,  0x054,
/* 058 */  0x055,  0x056,  0x057,  0x058,  0x059,  0x05a,  0x05b,  0x05c,
/* 060 */  0x05d,  0x05e,  0x05f,  0x060,    BAD,    BAD,    BAD,    BAD,
/* 068 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 070 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 078 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 080 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 088 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 090 */    BAD,    BAD,    BAD,    BAD,  0x061,  0x062,  0x063,  0x064,
/* 098 */  0x065,  0x066,  0x067,  0x068,  0x069,  0x06a,  0x06b,  0x06c,
/* 0a0 */  0x06d,  0x06e,  0x06f,  0x070,  0x071,  0x072,  0x073,  0x074,
/* 0a8 */  0x075,  0x076,  0x077,  0x078,  0x079,  0x07a,  0x07b,  0x07c,
/* 0b0 */  0x07d,  0x07e,  0x07f,  0x080,  0x081
};

/* Row table for mapping deckanji to Unicode */

#define	deckanji_to_ucs_DMAP	1
static row_t _deckanji_to_ucs_row[] = {
/* 000 */  0x000,  0x001,  0x082,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 008 */  0x005,  0x083,  0x084,  0x085,  0x086,  0x087,  0x00b,  0x088,
/* 010 */  0x089,  0x08a,  0x08b,  0x08c,  0x08d,  0x08e,  0x08f,  0x090,
/* 018 */  0x091,  0x092,  0x093,  0x094,  0x095,  0x096,  0x097,  0x01c,
/* 020 */  0x01d,  0x01e,  0x01f,  0x020,  0x021,  0x022,  0x023,  0x024,
/* 028 */  0x025,  0x026,  0x027,  0x028,  0x029,  0x02a,  0x02b,  0x02c,
/* 030 */  0x02d,  0x02e,  0x02f,  0x030,  0x031,  0x032,  0x033,  0x034,
/* 038 */  0x035,  0x036,  0x037,  0x038,  0x039,  0x03a,  0x03b,  0x03c,
/* 040 */  0x03d,  0x03e,  0x03f,  0x040,  0x041,  0x042,  0x043,  0x044,
/* 048 */  0x045,  0x046,  0x047,  0x048,  0x098,  0x099,  0x04b,  0x04c,
/* 050 */  0x04d,  0x04e,  0x04f,  0x050,  0x051,  0x052,  0x053,  0x054,
/* 058 */  0x055,  0x056,  0x057,  0x058,  0x059,  0x05a,  0x05b,  0x05c,
/* 060 */  0x05d,  0x05e,  0x05f,  0x09a,  0x09b,  0x09c,  0x09d,  0x09e,
/* 068 */  0x09f,  0x0a0,  0x0a1,  0x0a2,  0x0a3,  0x0a4,  0x0a5,  0x0a6,
/* 070 */  0x0a7,  0x0a8,  0x0a9,  0x0aa,  0x0ab,  0x0ac,  0x0ad,  0x0ae,
/* 078 */  0x0af,  0x0b0,  0x0b1,  0x0b2,  0x0b3,  0x0b4,  0x0b5,  0x0b6,
/* 080 */  0x0b7,  0x0b8,  0x0b9,  0x0ba
};

/* Row table for mapping eucJP to Unicode */

#define	eucjp_to_ucs_DMAP	1
static row_t _eucjp_to_ucs_row[] = {
/* 000 */  0x000,  0x001,  0x0bb,    BAD,    BAD,    BAD,  0x003,  0x004,
/* 008 */  0x005,  0x083,  0x084,  0x085,  0x086,  0x087,  0x00b,  0x088,
/* 010 */  0x089,  0x08a,  0x08b,  0x08c,  0x08d,  0x08e,  0x08f,  0x090,
/* 018 */  0x091,  0x092,  0x093,  0x094,  0x095,  0x096,  0x097,  0x01c,
/* 020 */  0x01d,  0x01e,  0x01f,  0x020,  0x021,  0x022,  0x023,  0x024,
/* 028 */  0x025,  0x026,  0x027,  0x028,  0x029,  0x02a,  0x02b,  0x02c,
/* 030 */  0x02d,  0x02e,  0x02f,  0x030,  0x031,  0x032,  0x033,  0x034,
/* 038 */  0x035,  0x036,  0x037,  0x038,  0x039,  0x03a,  0x03b,  0x03c,
/* 040 */  0x03d,  0x03e,  0x03f,  0x040,  0x041,  0x042,  0x043,  0x044,
/* 048 */  0x045,  0x046,  0x047,  0x048,  0x098,  0x099,  0x04b,  0x04c,
/* 050 */  0x04d,  0x04e,  0x04f,  0x050,  0x051,  0x052,  0x053,  0x054,
/* 058 */  0x055,  0x056,  0x057,  0x058,  0x059,  0x05a,  0x05b,  0x05c,
/* 060 */  0x05d,  0x05e,  0x05f,  0x09a,  0x09b,  0x09c,  0x09d,  0x09e,
/* 068 */  0x09f,  0x0a0,  0x0a1,  0x0a2,  0x0a3,  0x0a4,  0x0a5,  0x0a6,
/* 070 */  0x0a7,  0x0a8,  0x0a9,  0x0aa,  0x0ab,  0x0ac,  0x0ad,  0x0ae,
/* 078 */  0x0af,  0x0b0,  0x0b1,  0x0b2,  0x0b3,  0x0b4,  0x0b5,  0x0b6,
/* 080 */  0x0b7,  0x0b8,  0x0b9,  0x0ba,    BAD,    BAD,    BAD,    BAD,
/* 088 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 090 */    BAD,    BAD,    BAD,    BAD,  0x0bc,  0x0bd,  0x0be,  0x0bf,
/* 098 */  0x0c0,  0x0c1,  0x0c2,  0x0c3,  0x0c4,  0x0c5,  0x0c6,  0x0c7,
/* 0a0 */  0x0c8,  0x0c9,  0x0ca,  0x0cb,  0x0cc,  0x0cd,  0x0ce,  0x0cf,
/* 0a8 */  0x0d0,  0x0d1,  0x0d2,  0x0d3,  0x0d4,  0x0d5,  0x0d6,  0x0d7,
/* 0b0 */  0x0d8,  0x0d9,  0x0da,  0x0db,  0x0dc,  0x0dd,  0x0de,  0x0df,
/* 0b8 */  0x0e0,  0x0e1,  0x0e2,  0x0e3,  0x0e4,  0x0e5,  0x0e6,  0x0e7,
/* 0c0 */  0x0e8,  0x0e9,  0x0ea,  0x0eb,  0x0ec,  0x0ed,  0x0ee,  0x0ef,
/* 0c8 */  0x0f0,  0x0f1,  0x0f2,  0x0f3,  0x0f4,  0x0f5,  0x0f6,  0x0f7,
/* 0d0 */  0x0f8,  0x0f9,  0x0fa,  0x0fb,  0x0fc,  0x0fd,  0x0fe,  0x0ff,
/* 0d8 */  0x100,  0x101,  0x102,  0x103,  0x104,  0x105,  0x106,  0x107,
/* 0e0 */  0x108,  0x109,  0x10a,  0x10b,  0x10c,  0x10d,  0x10e,  0x10f,
/* 0e8 */  0x110,  0x111,  0x112,  0x113,  0x114,  0x115,  0x116,  0x117,
/* 0f0 */  0x118,  0x119,  0x11a,  0x11b,  0x11c,  0x11d,  0x11e,  0x11f,
/* 0f8 */  0x120,  0x121,  0x122,  0x123,  0x124,  0x125,  0x126,  0x127,
/* 100 */  0x128,  0x129,  0x12a,  0x12b,  0x12c,  0x12d
};

/* Row table for mapping sdeckanji to Unicode */

#define	sdeckanji_to_ucs_DMAP	1
#define	_sdeckanji_to_ucs_row	_eucjp_to_ucs_row

/* Mapping table from Japanese to Unicode */

static cell2_t _jp_to_ucs_cell2[] = {
/* Row 0x000 */
{
/* 00 */ 0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007,
/* 08 */ 0x0008, 0x0009, 0x000a, 0x000b, 0x000c, 0x000d, 0x000e, 0x000f,
/* 10 */ 0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017,
/* 18 */ 0x0018, 0x0019, 0x001a, 0x001b, 0x001c, 0x001d, 0x001e, 0x001f,
/* 20 */ 0x0020, 0x0021, 0x0022, 0x0023, 0x0024, 0x0025, 0x0026, 0x0027,
/* 28 */ 0x0028, 0x0029, 0x002a, 0x002b, 0x002c, 0x002d, 0x002e, 0x002f,
/* 30 */ 0x0030, 0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037,
/* 38 */ 0x0038, 0x0039, 0x003a, 0x003b, 0x003c, 0x003d, 0x003e, 0x003f
},

/* Row 0x001 */
{
/* 00 */ 0x0040, 0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047,
/* 08 */ 0x0048, 0x0049, 0x004a, 0x004b, 0x004c, 0x004d, 0x004e, 0x004f,
/* 10 */ 0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057,
/* 18 */ 0x0058, 0x0059, 0x005a, 0x005b, 0x005c, 0x005d, 0x005e, 0x005f,
/* 20 */ 0x0060, 0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067,
/* 28 */ 0x0068, 0x0069, 0x006a, 0x006b, 0x006c, 0x006d, 0x006e, 0x006f,
/* 30 */ 0x0070, 0x0071, 0x0072, 0x0073, 0x0074, 0x0075, 0x0076, 0x0077,
/* 38 */ 0x0078, 0x0079, 0x007a, 0x007b, 0x007c, 0x007d, 0x007e, 0x007f
},

/* Row 0x002 */
{
/* 00 */ 0x0080,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x003 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xff61, 0xff62, 0xff63, 0xff64, 0xff65, 0xff66, 0xff67,
/* 28 */ 0xff68, 0xff69, 0xff6a, 0xff6b, 0xff6c, 0xff6d, 0xff6e, 0xff6f,
/* 30 */ 0xff70, 0xff71, 0xff72, 0xff73, 0xff74, 0xff75, 0xff76, 0xff77,
/* 38 */ 0xff78, 0xff79, 0xff7a, 0xff7b, 0xff7c, 0xff7d, 0xff7e, 0xff7f
},

/* Row 0x004 */
{
/* 00 */ 0xff80, 0xff81, 0xff82, 0xff83, 0xff84, 0xff85, 0xff86, 0xff87,
/* 08 */ 0xff88, 0xff89, 0xff8a, 0xff8b, 0xff8c, 0xff8d, 0xff8e, 0xff8f,
/* 10 */ 0xff90, 0xff91, 0xff92, 0xff93, 0xff94, 0xff95, 0xff96, 0xff97,
/* 18 */ 0xff98, 0xff99, 0xff9a, 0xff9b, 0xff9c, 0xff9d, 0xff9e, 0xff9f,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x005 */
{
/* 00 */ 0x3000, 0x3001, 0x3002, 0xff0c, 0xff0e, 0x30fb, 0xff1a, 0xff1b,
/* 08 */ 0xff1f, 0xff01, 0x309b, 0x309c, 0x00b4, 0xff40, 0x00a8, 0xff3e,
/* 10 */ 0xffe3, 0xff3f, 0x30fd, 0x30fe, 0x309d, 0x309e, 0x3003, 0x4edd,
/* 18 */ 0x3005, 0x3006, 0x3007, 0x30fc, 0x2015, 0x2010, 0xff0f, 0xff3c,
/* 20 */ 0xff5e, 0x2016, 0xff5c, 0x2026, 0x2025, 0x2018, 0x2019, 0x201c,
/* 28 */ 0x201d, 0xff08, 0xff09, 0x3014, 0x3015, 0xff3b, 0xff3d, 0xff5b,
/* 30 */ 0xff5d, 0x3008, 0x3009, 0x300a, 0x300b, 0x300c, 0x300d, 0x300e,
/* 38 */ 0x300f, 0x3010, 0x3011, 0xff0b, 0x2212, 0x00b1, 0x00d7, 0x00f7
},

/* Row 0x006 */
{
/* 00 */ 0xff1d, 0x2260, 0xff1c, 0xff1e, 0x2266, 0x2267, 0x221e, 0x2234,
/* 08 */ 0x2642, 0x2640, 0x00b0, 0x2032, 0x2033, 0x2103, 0xffe5, 0xff04,
/* 10 */ 0x00a2, 0x00a3, 0xff05, 0xff03, 0xff06, 0xff0a, 0xff20, 0x00a7,
/* 18 */ 0x2606, 0x2605, 0x25cb, 0x25cf, 0x25ce, 0x25c7, 0x25c6, 0x25a1,
/* 20 */ 0x25a0, 0x25b3, 0x25b2, 0x25bd, 0x25bc, 0x203b, 0x3012, 0x2192,
/* 28 */ 0x2190, 0x2191, 0x2193, 0x3013, 0xed38, 0xed39, 0xed3a, 0xed3b,
/* 30 */ 0xed3c, 0xed3d, 0xed3e, 0xed3f, 0xed40, 0xed41, 0xed42, 0x2208,
/* 38 */ 0x220b, 0x2286, 0x2287, 0x2282, 0x2283, 0x222a, 0x2229, 0xed43
},

/* Row 0x007 */
{
/* 00 */ 0xed44, 0xed45, 0xed46, 0xed47, 0xed48, 0xed49, 0xed4a, 0x2227,
/* 08 */ 0x2228, 0x00ac, 0x21d2, 0x21d4, 0x2200, 0x2203, 0xed4b, 0xed4c,
/* 10 */ 0xed4d, 0xed4e, 0xed4f, 0xed50, 0xed51, 0xed52, 0xed53, 0xed54,
/* 18 */ 0xed55, 0x2220, 0x22a5, 0x2312, 0x2202, 0x2207, 0x2261, 0x2252,
/* 20 */ 0x226a, 0x226b, 0x221a, 0x223d, 0x221d, 0x2235, 0x222b, 0x222c,
/* 28 */ 0xed56, 0xed57, 0xed58, 0xed59, 0xed5a, 0xed5b, 0xed5c, 0x212b,
/* 30 */ 0x2030, 0x266f, 0x266d, 0x266a, 0x2020, 0x2021, 0x00b6, 0xed5d,
/* 38 */ 0xed5e, 0xed5f, 0xed60, 0x25ef, 0xed61, 0xed62, 0xed63, 0xed64
},

/* Row 0x008 */
{
/* 00 */ 0xed65, 0xed66, 0xed67, 0xed68, 0xed69, 0xed6a, 0xed6b, 0xed6c,
/* 08 */ 0xed6d, 0xed6e, 0xed6f, 0xff10, 0xff11, 0xff12, 0xff13, 0xff14,
/* 10 */ 0xff15, 0xff16, 0xff17, 0xff18, 0xff19, 0xed70, 0xed71, 0xed72,
/* 18 */ 0xed73, 0xed74, 0xed75, 0xed76, 0xff21, 0xff22, 0xff23, 0xff24,
/* 20 */ 0xff25, 0xff26, 0xff27, 0xff28, 0xff29, 0xff2a, 0xff2b, 0xff2c,
/* 28 */ 0xff2d, 0xff2e, 0xff2f, 0xff30, 0xff31, 0xff32, 0xff33, 0xff34,
/* 30 */ 0xff35, 0xff36, 0xff37, 0xff38, 0xff39, 0xff3a, 0xed77, 0xed78,
/* 38 */ 0xed79, 0xed7a, 0xed7b, 0xed7c, 0xff41, 0xff42, 0xff43, 0xff44
},

/* Row 0x009 */
{
/* 00 */ 0xff45, 0xff46, 0xff47, 0xff48, 0xff49, 0xff4a, 0xff4b, 0xff4c,
/* 08 */ 0xff4d, 0xff4e, 0xff4f, 0xff50, 0xff51, 0xff52, 0xff53, 0xff54,
/* 10 */ 0xff55, 0xff56, 0xff57, 0xff58, 0xff59, 0xff5a, 0xed7d, 0xed7e,
/* 18 */ 0xed7f, 0xed80, 0x3041, 0x3042, 0x3043, 0x3044, 0x3045, 0x3046,
/* 20 */ 0x3047, 0x3048, 0x3049, 0x304a, 0x304b, 0x304c, 0x304d, 0x304e,
/* 28 */ 0x304f, 0x3050, 0x3051, 0x3052, 0x3053, 0x3054, 0x3055, 0x3056,
/* 30 */ 0x3057, 0x3058, 0x3059, 0x305a, 0x305b, 0x305c, 0x305d, 0x305e,
/* 38 */ 0x305f, 0x3060, 0x3061, 0x3062, 0x3063, 0x3064, 0x3065, 0x3066
},

/* Row 0x00a */
{
/* 00 */ 0x3067, 0x3068, 0x3069, 0x306a, 0x306b, 0x306c, 0x306d, 0x306e,
/* 08 */ 0x306f, 0x3070, 0x3071, 0x3072, 0x3073, 0x3074, 0x3075, 0x3076,
/* 10 */ 0x3077, 0x3078, 0x3079, 0x307a, 0x307b, 0x307c, 0x307d, 0x307e,
/* 18 */ 0x307f, 0x3080, 0x3081, 0x3082, 0x3083, 0x3084, 0x3085, 0x3086,
/* 20 */ 0x3087, 0x3088, 0x3089, 0x308a, 0x308b, 0x308c, 0x308d, 0x308e,
/* 28 */ 0x308f, 0x3090, 0x3091, 0x3092, 0x3093, 0xed81, 0xed82, 0xed83,
/* 30 */ 0xed84, 0xed85, 0xed86, 0xed87, 0xed88, 0xed89, 0xed8a, 0xed8b,
/* 38 */ 0x30a1, 0x30a2, 0x30a3, 0x30a4, 0x30a5, 0x30a6, 0x30a7, 0x30a8
},

/* Row 0x00b */
{
/* 00 */ 0x30a9, 0x30aa, 0x30ab, 0x30ac, 0x30ad, 0x30ae, 0x30af, 0x30b0,
/* 08 */ 0x30b1, 0x30b2, 0x30b3, 0x30b4, 0x30b5, 0x30b6, 0x30b7, 0x30b8,
/* 10 */ 0x30b9, 0x30ba, 0x30bb, 0x30bc, 0x30bd, 0x30be, 0x30bf, 0x30c0,
/* 18 */ 0x30c1, 0x30c2, 0x30c3, 0x30c4, 0x30c5, 0x30c6, 0x30c7, 0x30c8,
/* 20 */ 0x30c9, 0x30ca, 0x30cb, 0x30cc, 0x30cd, 0x30ce, 0x30cf, 0x30d0,
/* 28 */ 0x30d1, 0x30d2, 0x30d3, 0x30d4, 0x30d5, 0x30d6, 0x30d7, 0x30d8,
/* 30 */ 0x30d9, 0x30da, 0x30db, 0x30dc, 0x30dd, 0x30de, 0x30df, 0x30e0,
/* 38 */ 0x30e1, 0x30e2, 0x30e3, 0x30e4, 0x30e5, 0x30e6, 0x30e7, 0x30e8
},

/* Row 0x00c */
{
/* 00 */ 0x30e9, 0x30ea, 0x30eb, 0x30ec, 0x30ed, 0x30ee, 0x30ef, 0x30f0,
/* 08 */ 0x30f1, 0x30f2, 0x30f3, 0x30f4, 0x30f5, 0x30f6, 0xed8c, 0xed8d,
/* 10 */ 0xed8e, 0xed8f, 0xed90, 0xed91, 0xed92, 0xed93, 0x0391, 0x0392,
/* 18 */ 0x0393, 0x0394, 0x0395, 0x0396, 0x0397, 0x0398, 0x0399, 0x039a,
/* 20 */ 0x039b, 0x039c, 0x039d, 0x039e, 0x039f, 0x03a0, 0x03a1, 0x03a3,
/* 28 */ 0x03a4, 0x03a5, 0x03a6, 0x03a7, 0x03a8, 0x03a9, 0xed94, 0xed95,
/* 30 */ 0xed96, 0xed97, 0xed98, 0xed99, 0xed9a, 0xed9b, 0x03b1, 0x03b2,
/* 38 */ 0x03b3, 0x03b4, 0x03b5, 0x03b6, 0x03b7, 0x03b8, 0x03b9, 0x03ba
},

/* Row 0x00d */
{
/* 00 */ 0x03bb, 0x03bc, 0x03bd, 0x03be, 0x03bf, 0x03c0, 0x03c1, 0x03c3,
/* 08 */ 0x03c4, 0x03c5, 0x03c6, 0x03c7, 0x03c8, 0x03c9, 0xed9c, 0xed9d,
/* 10 */ 0xed9e, 0xed9f, 0xeda0, 0xeda1, 0xeda2, 0xeda3, 0xeda4, 0xeda5,
/* 18 */ 0xeda6, 0xeda7, 0xeda8, 0xeda9, 0xedaa, 0xedab, 0xedac, 0xedad,
/* 20 */ 0xedae, 0xedaf, 0xedb0, 0xedb1, 0xedb2, 0xedb3, 0xedb4, 0xedb5,
/* 28 */ 0xedb6, 0xedb7, 0xedb8, 0xedb9, 0xedba, 0xedbb, 0xedbc, 0xedbd,
/* 30 */ 0xedbe, 0xedbf, 0xedc0, 0xedc1, 0x0410, 0x0411, 0x0412, 0x0413,
/* 38 */ 0x0414, 0x0415, 0x0401, 0x0416, 0x0417, 0x0418, 0x0419, 0x041a
},

/* Row 0x00e */
{
/* 00 */ 0x041b, 0x041c, 0x041d, 0x041e, 0x041f, 0x0420, 0x0421, 0x0422,
/* 08 */ 0x0423, 0x0424, 0x0425, 0x0426, 0x0427, 0x0428, 0x0429, 0x042a,
/* 10 */ 0x042b, 0x042c, 0x042d, 0x042e, 0x042f, 0xedc2, 0xedc3, 0xedc4,
/* 18 */ 0xedc5, 0xedc6, 0xedc7, 0xedc8, 0xedc9, 0xedca, 0xedcb, 0xedcc,
/* 20 */ 0xedcd, 0xedce, 0xedcf, 0xedd0, 0x0430, 0x0431, 0x0432, 0x0433,
/* 28 */ 0x0434, 0x0435, 0x0451, 0x0436, 0x0437, 0x0438, 0x0439, 0x043a,
/* 30 */ 0x043b, 0x043c, 0x043d, 0x043e, 0x043f, 0x0440, 0x0441, 0x0442,
/* 38 */ 0x0443, 0x0444, 0x0445, 0x0446, 0x0447, 0x0448, 0x0449, 0x044a
},

/* Row 0x00f */
{
/* 00 */ 0x044b, 0x044c, 0x044d, 0x044e, 0x044f, 0xedd1, 0xedd2, 0xedd3,
/* 08 */ 0xedd4, 0xedd5, 0xedd6, 0xedd7, 0xedd8, 0xedd9, 0xedda, 0xeddb,
/* 10 */ 0xeddc, 0xeddd, 0x2500, 0x2502, 0x250c, 0x2510, 0x2518, 0x2514,
/* 18 */ 0x251c, 0x252c, 0x2524, 0x2534, 0x253c, 0x2501, 0x2503, 0x250f,
/* 20 */ 0x2513, 0x251b, 0x2517, 0x2523, 0x2533, 0x252b, 0x253b, 0x254b,
/* 28 */ 0x2520, 0x252f, 0x2528, 0x2537, 0x253f, 0x251d, 0x2530, 0x2525,
/* 30 */ 0x2538, 0x2542, 0xedde, 0xeddf, 0xede0, 0xede1, 0xede2, 0xede3,
/* 38 */ 0xede4, 0xede5, 0xede6, 0xede7, 0xede8, 0xede9, 0xedea, 0xedeb
},

/* Row 0x010 */
{
/* 00 */ 0xedec, 0xeded, 0xedee, 0xedef, 0xedf0, 0xedf1, 0xedf2, 0xedf3,
/* 08 */ 0xedf4, 0xedf5, 0xedf6, 0xedf7, 0xedf8, 0xedf9, 0xedfa, 0xedfb,
/* 10 */ 0xedfc, 0xedfd, 0xedfe, 0xedff, 0xee00, 0xee01, 0xee02, 0xee03,
/* 18 */ 0xee04, 0xee05, 0xee06, 0xee07, 0xee08, 0xee09, 0xee0a, 0xee0b,
/* 20 */ 0xee0c, 0xee0d, 0xee0e, 0xee0f, 0xee10, 0xee11, 0xee12, 0xee13,
/* 28 */ 0xee14, 0xee15, 0xee16, 0xee17, 0xee18, 0xee19, 0xee1a, 0xee1b,
/* 30 */ 0xee1c, 0xee1d, 0xee1e, 0xee1f, 0xee20, 0xee21, 0xee22, 0xee23,
/* 38 */ 0xee24, 0xee25, 0xee26, 0xee27, 0xee28, 0xee29, 0xee2a, 0xee2b
},

/* Row 0x011 */
{
/* 00 */ 0xee2c, 0xee2d, 0xee2e, 0xee2f, 0xee30, 0xee31, 0xee32, 0xee33,
/* 08 */ 0xee34, 0xee35, 0xee36, 0xee37, 0xee38, 0xee39, 0xee3a, 0xee3b,
/* 10 */ 0xee3c, 0xee3d, 0xee3e, 0xee3f, 0xee40, 0xee41, 0xee42, 0xee43,
/* 18 */ 0xee44, 0xee45, 0xee46, 0xee47, 0xee48, 0xee49, 0xee4a, 0xee4b,
/* 20 */ 0xee4c, 0xee4d, 0xee4e, 0xee4f, 0xee50, 0xee51, 0xee52, 0xee53,
/* 28 */ 0xee54, 0xee55, 0xee56, 0xee57, 0xee58, 0xee59, 0xee5a, 0xee5b,
/* 30 */ 0xee5c, 0xee5d, 0xee5e, 0xee5f, 0xee60, 0xee61, 0xee62, 0xee63,
/* 38 */ 0xee64, 0xee65, 0xee66, 0xee67, 0xee68, 0xee69, 0xee6a, 0xee6b
},

/* Row 0x012 */
{
/* 00 */ 0xee6c, 0xee6d, 0xee6e, 0xee6f, 0xee70, 0xee71, 0xee72, 0xee73,
/* 08 */ 0xee74, 0xee75, 0xee76, 0xee77, 0xee78, 0xee79, 0xee7a, 0xee7b,
/* 10 */ 0xee7c, 0xee7d, 0xee7e, 0xee7f, 0xee80, 0xee81, 0xee82, 0xee83,
/* 18 */ 0xee84, 0xee85, 0xee86, 0xee87, 0xee88, 0xee89, 0xee8a, 0xee8b,
/* 20 */ 0xee8c, 0xee8d, 0xee8e, 0xee8f, 0xee90, 0xee91, 0xee92, 0xee93,
/* 28 */ 0xee94, 0xee95, 0xee96, 0xee97, 0xee98, 0xee99, 0xee9a, 0xee9b,
/* 30 */ 0xee9c, 0xee9d, 0xee9e, 0xee9f, 0xeea0, 0xeea1, 0xeea2, 0xeea3,
/* 38 */ 0xeea4, 0xeea5, 0xeea6, 0xeea7, 0xeea8, 0xeea9, 0xeeaa, 0xeeab
},

/* Row 0x013 */
{
/* 00 */ 0xeeac, 0xeead, 0xeeae, 0xeeaf, 0xeeb0, 0xeeb1, 0xeeb2, 0xeeb3,
/* 08 */ 0xeeb4, 0xeeb5, 0xeeb6, 0xeeb7, 0xeeb8, 0xeeb9, 0xeeba, 0xeebb,
/* 10 */ 0xeebc, 0xeebd, 0xeebe, 0xeebf, 0xeec0, 0xeec1, 0xeec2, 0xeec3,
/* 18 */ 0xeec4, 0xeec5, 0xeec6, 0xeec7, 0xeec8, 0xeec9, 0xeeca, 0xeecb,
/* 20 */ 0xeecc, 0xeecd, 0xeece, 0xeecf, 0xeed0, 0xeed1, 0xeed2, 0xeed3,
/* 28 */ 0xeed4, 0xeed5, 0xeed6, 0xeed7, 0xeed8, 0xeed9, 0xeeda, 0xeedb,
/* 30 */ 0xeedc, 0xeedd, 0xeede, 0xeedf, 0xeee0, 0xeee1, 0xeee2, 0xeee3,
/* 38 */ 0xeee4, 0xeee5, 0xeee6, 0xeee7, 0xeee8, 0xeee9, 0xeeea, 0xeeeb
},

/* Row 0x014 */
{
/* 00 */ 0xeeec, 0xeeed, 0xeeee, 0xeeef, 0xeef0, 0xeef1, 0xeef2, 0xeef3,
/* 08 */ 0xeef4, 0xeef5, 0xeef6, 0xeef7, 0xeef8, 0xeef9, 0xeefa, 0xeefb,
/* 10 */ 0xeefc, 0xeefd, 0xeefe, 0xeeff, 0xef00, 0xef01, 0xef02, 0xef03,
/* 18 */ 0xef04, 0xef05, 0xef06, 0xef07, 0xef08, 0xef09, 0xef0a, 0xef0b,
/* 20 */ 0xef0c, 0xef0d, 0xef0e, 0xef0f, 0xef10, 0xef11, 0xef12, 0xef13,
/* 28 */ 0xef14, 0xef15, 0xef16, 0xef17, 0xef18, 0xef19, 0xef1a, 0xef1b,
/* 30 */ 0xef1c, 0xef1d, 0xef1e, 0xef1f, 0xef20, 0xef21, 0xef22, 0xef23,
/* 38 */ 0xef24, 0xef25, 0xef26, 0xef27, 0xef28, 0xef29, 0xef2a, 0xef2b
},

/* Row 0x015 */
{
/* 00 */ 0xef2c, 0xef2d, 0xef2e, 0xef2f, 0xef30, 0xef31, 0xef32, 0xef33,
/* 08 */ 0xef34, 0xef35, 0xef36, 0xef37, 0xef38, 0xef39, 0xef3a, 0xef3b,
/* 10 */ 0xef3c, 0xef3d, 0xef3e, 0xef3f, 0xef40, 0xef41, 0xef42, 0xef43,
/* 18 */ 0xef44, 0xef45, 0xef46, 0xef47, 0xef48, 0xef49, 0xef4a, 0xef4b,
/* 20 */ 0xef4c, 0xef4d, 0xef4e, 0xef4f, 0xef50, 0xef51, 0xef52, 0xef53,
/* 28 */ 0xef54, 0xef55, 0xef56, 0xef57, 0xef58, 0xef59, 0xef5a, 0xef5b,
/* 30 */ 0xef5c, 0xef5d, 0xef5e, 0xef5f, 0xef60, 0xef61, 0xef62, 0xef63,
/* 38 */ 0xef64, 0xef65, 0xef66, 0xef67, 0xef68, 0xef69, 0xef6a, 0xef6b
},

/* Row 0x016 */
{
/* 00 */ 0xef6c, 0xef6d, 0xef6e, 0xef6f, 0xef70, 0xef71, 0xef72, 0xef73,
/* 08 */ 0xef74, 0xef75, 0xef76, 0xef77, 0xef78, 0xef79, 0xef7a, 0xef7b,
/* 10 */ 0xef7c, 0xef7d, 0xef7e, 0xef7f, 0xef80, 0xef81, 0xef82, 0xef83,
/* 18 */ 0xef84, 0xef85, 0xef86, 0xef87, 0xef88, 0xef89, 0xef8a, 0xef8b,
/* 20 */ 0xef8c, 0xef8d, 0xef8e, 0xef8f, 0xef90, 0xef91, 0xef92, 0xef93,
/* 28 */ 0xef94, 0xef95, 0xef96, 0xef97, 0xef98, 0xef99, 0xef9a, 0xef9b,
/* 30 */ 0xef9c, 0xef9d, 0xef9e, 0xef9f, 0xefa0, 0xefa1, 0xefa2, 0xefa3,
/* 38 */ 0xefa4, 0xefa5, 0xefa6, 0xefa7, 0xefa8, 0xefa9, 0xefaa, 0xefab
},

/* Row 0x017 */
{
/* 00 */ 0xefac, 0xefad, 0xefae, 0xefaf, 0xefb0, 0xefb1, 0xefb2, 0xefb3,
/* 08 */ 0xefb4, 0xefb5, 0xefb6, 0xefb7, 0xefb8, 0xefb9, 0xefba, 0xefbb,
/* 10 */ 0xefbc, 0xefbd, 0xefbe, 0xefbf, 0xefc0, 0xefc1, 0xefc2, 0xefc3,
/* 18 */ 0xefc4, 0xefc5, 0xefc6, 0xefc7, 0xefc8, 0xefc9, 0xefca, 0xefcb,
/* 20 */ 0xefcc, 0xefcd, 0xefce, 0xefcf, 0xefd0, 0xefd1, 0xefd2, 0xefd3,
/* 28 */ 0xefd4, 0xefd5, 0xefd6, 0xefd7, 0xefd8, 0xefd9, 0xefda, 0xefdb,
/* 30 */ 0xefdc, 0xefdd, 0xefde, 0xefdf, 0xefe0, 0xefe1, 0xefe2, 0xefe3,
/* 38 */ 0xefe4, 0xefe5, 0xefe6, 0xefe7, 0xefe8, 0xefe9, 0xefea, 0xefeb
},

/* Row 0x018 */
{
/* 00 */ 0xefec, 0xefed, 0xefee, 0xefef, 0xeff0, 0xeff1, 0xeff2, 0xeff3,
/* 08 */ 0xeff4, 0xeff5, 0xeff6, 0xeff7, 0xeff8, 0xeff9, 0xeffa, 0xeffb,
/* 10 */ 0xeffc, 0xeffd, 0xeffe, 0xefff, 0xf000, 0xf001, 0xf002, 0xf003,
/* 18 */ 0xf004, 0xf005, 0xf006, 0xf007, 0xf008, 0xf009, 0xf00a, 0xf00b,
/* 20 */ 0xf00c, 0xf00d, 0xf00e, 0xf00f, 0xf010, 0xf011, 0xf012, 0xf013,
/* 28 */ 0xf014, 0xf015, 0xf016, 0xf017, 0xf018, 0xf019, 0xf01a, 0xf01b,
/* 30 */ 0xf01c, 0xf01d, 0xf01e, 0xf01f, 0xf020, 0xf021, 0xf022, 0xf023,
/* 38 */ 0xf024, 0xf025, 0xf026, 0xf027, 0xf028, 0xf029, 0xf02a, 0xf02b
},

/* Row 0x019 */
{
/* 00 */ 0xf02c, 0xf02d, 0xf02e, 0xf02f, 0xf030, 0xf031, 0xf032, 0xf033,
/* 08 */ 0xf034, 0xf035, 0xf036, 0xf037, 0xf038, 0xf039, 0xf03a, 0xf03b,
/* 10 */ 0xf03c, 0xf03d, 0xf03e, 0xf03f, 0xf040, 0xf041, 0xf042, 0xf043,
/* 18 */ 0xf044, 0xf045, 0xf046, 0xf047, 0xf048, 0xf049, 0xf04a, 0xf04b,
/* 20 */ 0xf04c, 0xf04d, 0xf04e, 0xf04f, 0xf050, 0xf051, 0xf052, 0xf053,
/* 28 */ 0xf054, 0xf055, 0xf056, 0xf057, 0xf058, 0xf059, 0xf05a, 0xf05b,
/* 30 */ 0xf05c, 0xf05d, 0xf05e, 0xf05f, 0xf060, 0xf061, 0xf062, 0xf063,
/* 38 */ 0xf064, 0xf065, 0xf066, 0xf067, 0xf068, 0xf069, 0xf06a, 0xf06b
},

/* Row 0x01a */
{
/* 00 */ 0xf06c, 0xf06d, 0xf06e, 0xf06f, 0xf070, 0xf071, 0xf072, 0xf073,
/* 08 */ 0xf074, 0xf075, 0xf076, 0xf077, 0xf078, 0xf079, 0xf07a, 0xf07b,
/* 10 */ 0xf07c, 0xf07d, 0xf07e, 0xf07f, 0xf080, 0xf081, 0xf082, 0xf083,
/* 18 */ 0xf084, 0xf085, 0xf086, 0xf087, 0xf088, 0xf089, 0xf08a, 0xf08b,
/* 20 */ 0xf08c, 0xf08d, 0xf08e, 0xf08f, 0xf090, 0xf091, 0xf092, 0xf093,
/* 28 */ 0xf094, 0xf095, 0xf096, 0xf097, 0xf098, 0xf099, 0xf09a, 0xf09b,
/* 30 */ 0xf09c, 0xf09d, 0xf09e, 0xf09f, 0xf0a0, 0xf0a1, 0xf0a2, 0xf0a3,
/* 38 */ 0xf0a4, 0xf0a5, 0xf0a6, 0xf0a7, 0xf0a8, 0xf0a9, 0xf0aa, 0xf0ab
},

/* Row 0x01b */
{
/* 00 */ 0xf0ac, 0xf0ad, 0x4e9c, 0x5516, 0x5a03, 0x963f, 0x54c0, 0x611b,
/* 08 */ 0x6328, 0x59f6, 0x9022, 0x8475, 0x831c, 0x7a50, 0x60aa, 0x63e1,
/* 10 */ 0x6e25, 0x65ed, 0x8466, 0x82a6, 0x9bf5, 0x6893, 0x5727, 0x65a1,
/* 18 */ 0x6271, 0x5b9b, 0x59d0, 0x867b, 0x98f4, 0x7d62, 0x7dbe, 0x9b8e,
/* 20 */ 0x6216, 0x7c9f, 0x88b7, 0x5b89, 0x5eb5, 0x6309, 0x6697, 0x6848,
/* 28 */ 0x95c7, 0x978d, 0x674f, 0x4ee5, 0x4f0a, 0x4f4d, 0x4f9d, 0x5049,
/* 30 */ 0x56f2, 0x5937, 0x59d4, 0x5a01, 0x5c09, 0x60df, 0x610f, 0x6170,
/* 38 */ 0x6613, 0x6905, 0x70ba, 0x754f, 0x7570, 0x79fb, 0x7dad, 0x7def
},

/* Row 0x01c */
{
/* 00 */ 0x80c3, 0x840e, 0x8863, 0x8b02, 0x9055, 0x907a, 0x533b, 0x4e95,
/* 08 */ 0x4ea5, 0x57df, 0x80b2, 0x90c1, 0x78ef, 0x4e00, 0x58f1, 0x6ea2,
/* 10 */ 0x9038, 0x7a32, 0x8328, 0x828b, 0x9c2f, 0x5141, 0x5370, 0x54bd,
/* 18 */ 0x54e1, 0x56e0, 0x59fb, 0x5f15, 0x98f2, 0x6deb, 0x80e4, 0x852d,
/* 20 */ 0x9662, 0x9670, 0x96a0, 0x97fb, 0x540b, 0x53f3, 0x5b87, 0x70cf,
/* 28 */ 0x7fbd, 0x8fc2, 0x96e8, 0x536f, 0x9d5c, 0x7aba, 0x4e11, 0x7893,
/* 30 */ 0x81fc, 0x6e26, 0x5618, 0x5504, 0x6b1d, 0x851a, 0x9c3b, 0x59e5,
/* 38 */ 0x53a9, 0x6d66, 0x74dc, 0x958f, 0x5642, 0x4e91, 0x904b, 0x96f2
},

/* Row 0x01d */
{
/* 00 */ 0x834f, 0x990c, 0x53e1, 0x55b6, 0x5b30, 0x5f71, 0x6620, 0x66f3,
/* 08 */ 0x6804, 0x6c38, 0x6cf3, 0x6d29, 0x745b, 0x76c8, 0x7a4e, 0x9834,
/* 10 */ 0x82f1, 0x885b, 0x8a60, 0x92ed, 0x6db2, 0x75ab, 0x76ca, 0x99c5,
/* 18 */ 0x60a6, 0x8b01, 0x8d8a, 0x95b2, 0x698e, 0x53ad, 0x5186, 0x5712,
/* 20 */ 0x5830, 0x5944, 0x5bb4, 0x5ef6, 0x6028, 0x63a9, 0x63f4, 0x6cbf,
/* 28 */ 0x6f14, 0x708e, 0x7114, 0x7159, 0x71d5, 0x733f, 0x7e01, 0x8276,
/* 30 */ 0x82d1, 0x8597, 0x9060, 0x925b, 0x9d1b, 0x5869, 0x65bc, 0x6c5a,
/* 38 */ 0x7525, 0x51f9, 0x592e, 0x5965, 0x5f80, 0x5fdc, 0x62bc, 0x65fa
},

/* Row 0x01e */
{
/* 00 */ 0x6a2a, 0x6b27, 0x6bb4, 0x738b, 0x7fc1, 0x8956, 0x9d2c, 0x9d0e,
/* 08 */ 0x9ec4, 0x5ca1, 0x6c96, 0x837b, 0x5104, 0x5c4b, 0x61b6, 0x81c6,
/* 10 */ 0x6876, 0x7261, 0x4e59, 0x4ffa, 0x5378, 0x6069, 0x6e29, 0x7a4f,
/* 18 */ 0x97f3, 0x4e0b, 0x5316, 0x4eee, 0x4f55, 0x4f3d, 0x4fa1, 0x4f73,
/* 20 */ 0x52a0, 0x53ef, 0x5609, 0x590f, 0x5ac1, 0x5bb6, 0x5be1, 0x79d1,
/* 28 */ 0x6687, 0x679c, 0x67b6, 0x6b4c, 0x6cb3, 0x706b, 0x73c2, 0x798d,
/* 30 */ 0x79be, 0x7a3c, 0x7b87, 0x82b1, 0x82db, 0x8304, 0x8377, 0x83ef,
/* 38 */ 0x83d3, 0x8766, 0x8ab2, 0x5629, 0x8ca8, 0x8fe6, 0x904e, 0x971e
},

/* Row 0x01f */
{
/* 00 */ 0x868a, 0x4fc4, 0x5ce8, 0x6211, 0x7259, 0x753b, 0x81e5, 0x82bd,
/* 08 */ 0x86fe, 0x8cc0, 0x96c5, 0x9913, 0x99d5, 0x4ecb, 0x4f1a, 0x89e3,
/* 10 */ 0x56de, 0x584a, 0x58ca, 0x5efb, 0x5feb, 0x602a, 0x6094, 0x6062,
/* 18 */ 0x61d0, 0x6212, 0x62d0, 0x6539, 0x9b41, 0x6666, 0x68b0, 0x6d77,
/* 20 */ 0x7070, 0x754c, 0x7686, 0x7d75, 0x82a5, 0x87f9, 0x958b, 0x968e,
/* 28 */ 0x8c9d, 0x51f1, 0x52be, 0x5916, 0x54b3, 0x5bb3, 0x5d16, 0x6168,
/* 30 */ 0x6982, 0x6daf, 0x788d, 0x84cb, 0x8857, 0x8a72, 0x93a7, 0x9ab8,
/* 38 */ 0x6d6c, 0x99a8, 0x86d9, 0x57a3, 0x67ff, 0x86ce, 0x920e, 0x5283
},

/* Row 0x020 */
{
/* 00 */ 0x5687, 0x5404, 0x5ed3, 0x62e1, 0x64b9, 0x683c, 0x6838, 0x6bbb,
/* 08 */ 0x7372, 0x78ba, 0x7a6b, 0x899a, 0x89d2, 0x8d6b, 0x8f03, 0x90ed,
/* 10 */ 0x95a3, 0x9694, 0x9769, 0x5b66, 0x5cb3, 0x697d, 0x984d, 0x984e,
/* 18 */ 0x639b, 0x7b20, 0x6a2b, 0x6a7f, 0x68b6, 0x9c0d, 0x6f5f, 0x5272,
/* 20 */ 0x559d, 0x6070, 0x62ec, 0x6d3b, 0x6e07, 0x6ed1, 0x845b, 0x8910,
/* 28 */ 0x8f44, 0x4e14, 0x9c39, 0x53f6, 0x691b, 0x6a3a, 0x9784, 0x682a,
/* 30 */ 0x515c, 0x7ac3, 0x84b2, 0x91dc, 0x938c, 0x565b, 0x9d28, 0x6822,
/* 38 */ 0x8305, 0x8431, 0x7ca5, 0x5208, 0x82c5, 0x74e6, 0x4e7e, 0x4f83
},

/* Row 0x021 */
{
/* 00 */ 0x51a0, 0x5bd2, 0x520a, 0x52d8, 0x52e7, 0x5dfb, 0x559a, 0x582a,
/* 08 */ 0x59e6, 0x5b8c, 0x5b98, 0x5bdb, 0x5e72, 0x5e79, 0x60a3, 0x611f,
/* 10 */ 0x6163, 0x61be, 0x63db, 0x6562, 0x67d1, 0x6853, 0x68fa, 0x6b3e,
/* 18 */ 0x6b53, 0x6c57, 0x6f22, 0x6f97, 0x6f45, 0x74b0, 0x7518, 0x76e3,
/* 20 */ 0x770b, 0x7aff, 0x7ba1, 0x7c21, 0x7de9, 0x7f36, 0x7ff0, 0x809d,
/* 28 */ 0x8266, 0x839e, 0x89b3, 0x8acc, 0x8cab, 0x9084, 0x9451, 0x9593,
/* 30 */ 0x9591, 0x95a2, 0x9665, 0x97d3, 0x9928, 0x8218, 0x4e38, 0x542b,
/* 38 */ 0x5cb8, 0x5dcc, 0x73a9, 0x764c, 0x773c, 0x5ca9, 0x7feb, 0x8d0b
},

/* Row 0x022 */
{
/* 00 */ 0x96c1, 0x9811, 0x9854, 0x9858, 0x4f01, 0x4f0e, 0x5371, 0x559c,
/* 08 */ 0x5668, 0x57fa, 0x5947, 0x5b09, 0x5bc4, 0x5c90, 0x5e0c, 0x5e7e,
/* 10 */ 0x5fcc, 0x63ee, 0x673a, 0x65d7, 0x65e2, 0x671f, 0x68cb, 0x68c4,
/* 18 */ 0x6a5f, 0x5e30, 0x6bc5, 0x6c17, 0x6c7d, 0x757f, 0x7948, 0x5b63,
/* 20 */ 0x7a00, 0x7d00, 0x5fbd, 0x898f, 0x8a18, 0x8cb4, 0x8d77, 0x8ecc,
/* 28 */ 0x8f1d, 0x98e2, 0x9a0e, 0x9b3c, 0x4e80, 0x507d, 0x5100, 0x5993,
/* 30 */ 0x5b9c, 0x622f, 0x6280, 0x64ec, 0x6b3a, 0x72a0, 0x7591, 0x7947,
/* 38 */ 0x7fa9, 0x87fb, 0x8abc, 0x8b70, 0x63ac, 0x83ca, 0x97a0, 0x5409
},

/* Row 0x023 */
{
/* 00 */ 0x5403, 0x55ab, 0x6854, 0x6a58, 0x8a70, 0x7827, 0x6775, 0x9ecd,
/* 08 */ 0x5374, 0x5ba2, 0x811a, 0x8650, 0x9006, 0x4e18, 0x4e45, 0x4ec7,
/* 10 */ 0x4f11, 0x53ca, 0x5438, 0x5bae, 0x5f13, 0x6025, 0x6551, 0x673d,
/* 18 */ 0x6c42, 0x6c72, 0x6ce3, 0x7078, 0x7403, 0x7a76, 0x7aae, 0x7b08,
/* 20 */ 0x7d1a, 0x7cfe, 0x7d66, 0x65e7, 0x725b, 0x53bb, 0x5c45, 0x5de8,
/* 28 */ 0x62d2, 0x62e0, 0x6319, 0x6e20, 0x865a, 0x8a31, 0x8ddd, 0x92f8,
/* 30 */ 0x6f01, 0x79a6, 0x9b5a, 0x4ea8, 0x4eab, 0x4eac, 0x4f9b, 0x4fa0,
/* 38 */ 0x50d1, 0x5147, 0x7af6, 0x5171, 0x51f6, 0x5354, 0x5321, 0x537f
},

/* Row 0x024 */
{
/* 00 */ 0x53eb, 0x55ac, 0x5883, 0x5ce1, 0x5f37, 0x5f4a, 0x602f, 0x6050,
/* 08 */ 0x606d, 0x631f, 0x6559, 0x6a4b, 0x6cc1, 0x72c2, 0x72ed, 0x77ef,
/* 10 */ 0x80f8, 0x8105, 0x8208, 0x854e, 0x90f7, 0x93e1, 0x97ff, 0x9957,
/* 18 */ 0x9a5a, 0x4ef0, 0x51dd, 0x5c2d, 0x6681, 0x696d, 0x5c40, 0x66f2,
/* 20 */ 0x6975, 0x7389, 0x6850, 0x7c81, 0x50c5, 0x52e4, 0x5747, 0x5dfe,
/* 28 */ 0x9326, 0x65a4, 0x6b23, 0x6b3d, 0x7434, 0x7981, 0x79bd, 0x7b4b,
/* 30 */ 0x7dca, 0x82b9, 0x83cc, 0x887f, 0x895f, 0x8b39, 0x8fd1, 0x91d1,
/* 38 */ 0x541f, 0x9280, 0x4e5d, 0x5036, 0x53e5, 0x533a, 0x72d7, 0x7396
},

/* Row 0x025 */
{
/* 00 */ 0x77e9, 0x82e6, 0x8eaf, 0x99c6, 0x99c8, 0x99d2, 0x5177, 0x611a,
/* 08 */ 0x865e, 0x55b0, 0x7a7a, 0x5076, 0x5bd3, 0x9047, 0x9685, 0x4e32,
/* 10 */ 0x6adb, 0x91e7, 0x5c51, 0x5c48, 0x6398, 0x7a9f, 0x6c93, 0x9774,
/* 18 */ 0x8f61, 0x7aaa, 0x718a, 0x9688, 0x7c82, 0x6817, 0x7e70, 0x6851,
/* 20 */ 0x936c, 0x52f2, 0x541b, 0x85ab, 0x8a13, 0x7fa4, 0x8ecd, 0x90e1,
/* 28 */ 0x5366, 0x8888, 0x7941, 0x4fc2, 0x50be, 0x5211, 0x5144, 0x5553,
/* 30 */ 0x572d, 0x73ea, 0x578b, 0x5951, 0x5f62, 0x5f84, 0x6075, 0x6176,
/* 38 */ 0x6167, 0x61a9, 0x63b2, 0x643a, 0x656c, 0x666f, 0x6842, 0x6e13
},

/* Row 0x026 */
{
/* 00 */ 0x7566, 0x7a3d, 0x7cfb, 0x7d4c, 0x7d99, 0x7e4b, 0x7f6b, 0x830e,
/* 08 */ 0x834a, 0x86cd, 0x8a08, 0x8a63, 0x8b66, 0x8efd, 0x981a, 0x9d8f,
/* 10 */ 0x82b8, 0x8fce, 0x9be8, 0x5287, 0x621f, 0x6483, 0x6fc0, 0x9699,
/* 18 */ 0x6841, 0x5091, 0x6b20, 0x6c7a, 0x6f54, 0x7a74, 0x7d50, 0x8840,
/* 20 */ 0x8a23, 0x6708, 0x4ef6, 0x5039, 0x5026, 0x5065, 0x517c, 0x5238,
/* 28 */ 0x5263, 0x55a7, 0x570f, 0x5805, 0x5acc, 0x5efa, 0x61b2, 0x61f8,
/* 30 */ 0x62f3, 0x6372, 0x691c, 0x6a29, 0x727d, 0x72ac, 0x732e, 0x7814,
/* 38 */ 0x786f, 0x7d79, 0x770c, 0x80a9, 0x898b, 0x8b19, 0x8ce2, 0x8ed2
},

/* Row 0x027 */
{
/* 00 */ 0x9063, 0x9375, 0x967a, 0x9855, 0x9a13, 0x9e78, 0x5143, 0x539f,
/* 08 */ 0x53b3, 0x5e7b, 0x5f26, 0x6e1b, 0x6e90, 0x7384, 0x73fe, 0x7d43,
/* 10 */ 0x8237, 0x8a00, 0x8afa, 0x9650, 0x4e4e, 0x500b, 0x53e4, 0x547c,
/* 18 */ 0x56fa, 0x59d1, 0x5b64, 0x5df1, 0x5eab, 0x5f27, 0x6238, 0x6545,
/* 20 */ 0x67af, 0x6e56, 0x72d0, 0x7cca, 0x88b4, 0x80a1, 0x80e1, 0x83f0,
/* 28 */ 0x864e, 0x8a87, 0x8de8, 0x9237, 0x96c7, 0x9867, 0x9f13, 0x4e94,
/* 30 */ 0x4e92, 0x4f0d, 0x5348, 0x5449, 0x543e, 0x5a2f, 0x5f8c, 0x5fa1,
/* 38 */ 0x609f, 0x68a7, 0x6a8e, 0x745a, 0x7881, 0x8a9e, 0x8aa4, 0x8b77
},

/* Row 0x028 */
{
/* 00 */ 0x9190, 0x4e5e, 0x9bc9, 0x4ea4, 0x4f7c, 0x4faf, 0x5019, 0x5016,
/* 08 */ 0x5149, 0x516c, 0x529f, 0x52b9, 0x52fe, 0x539a, 0x53e3, 0x5411,
/* 10 */ 0x540e, 0x5589, 0x5751, 0x57a2, 0x597d, 0x5b54, 0x5b5d, 0x5b8f,
/* 18 */ 0x5de5, 0x5de7, 0x5df7, 0x5e78, 0x5e83, 0x5e9a, 0x5eb7, 0x5f18,
/* 20 */ 0x6052, 0x614c, 0x6297, 0x62d8, 0x63a7, 0x653b, 0x6602, 0x6643,
/* 28 */ 0x66f4, 0x676d, 0x6821, 0x6897, 0x69cb, 0x6c5f, 0x6d2a, 0x6d69,
/* 30 */ 0x6e2f, 0x6e9d, 0x7532, 0x7687, 0x786c, 0x7a3f, 0x7ce0, 0x7d05,
/* 38 */ 0x7d18, 0x7d5e, 0x7db1, 0x8015, 0x8003, 0x80af, 0x80b1, 0x8154
},

/* Row 0x029 */
{
/* 00 */ 0x818f, 0x822a, 0x8352, 0x884c, 0x8861, 0x8b1b, 0x8ca2, 0x8cfc,
/* 08 */ 0x90ca, 0x9175, 0x9271, 0x783f, 0x92fc, 0x95a4, 0x964d, 0x9805,
/* 10 */ 0x9999, 0x9ad8, 0x9d3b, 0x525b, 0x52ab, 0x53f7, 0x5408, 0x58d5,
/* 18 */ 0x62f7, 0x6fe0, 0x8c6a, 0x8f5f, 0x9eb9, 0x514b, 0x523b, 0x544a,
/* 20 */ 0x56fd, 0x7a40, 0x9177, 0x9d60, 0x9ed2, 0x7344, 0x6f09, 0x8170,
/* 28 */ 0x7511, 0x5ffd, 0x60da, 0x9aa8, 0x72db, 0x8fbc, 0x6b64, 0x9803,
/* 30 */ 0x4eca, 0x56f0, 0x5764, 0x58be, 0x5a5a, 0x6068, 0x61c7, 0x660f,
/* 38 */ 0x6606, 0x6839, 0x68b1, 0x6df7, 0x75d5, 0x7d3a, 0x826e, 0x9b42
},

/* Row 0x02a */
{
/* 00 */ 0x4e9b, 0x4f50, 0x53c9, 0x5506, 0x5d6f, 0x5de6, 0x5dee, 0x67fb,
/* 08 */ 0x6c99, 0x7473, 0x7802, 0x8a50, 0x9396, 0x88df, 0x5750, 0x5ea7,
/* 10 */ 0x632b, 0x50b5, 0x50ac, 0x518d, 0x6700, 0x54c9, 0x585e, 0x59bb,
/* 18 */ 0x5bb0, 0x5f69, 0x624d, 0x63a1, 0x683d, 0x6b73, 0x6e08, 0x707d,
/* 20 */ 0x91c7, 0x7280, 0x7815, 0x7826, 0x796d, 0x658e, 0x7d30, 0x83dc,
/* 28 */ 0x88c1, 0x8f09, 0x969b, 0x5264, 0x5728, 0x6750, 0x7f6a, 0x8ca1,
/* 30 */ 0x51b4, 0x5742, 0x962a, 0x583a, 0x698a, 0x80b4, 0x54b2, 0x5d0e,
/* 38 */ 0x57fc, 0x7895, 0x9dfa, 0x4f5c, 0x524a, 0x548b, 0x643e, 0x6628
},

/* Row 0x02b */
{
/* 00 */ 0x6714, 0x67f5, 0x7a84, 0x7b56, 0x7d22, 0x932f, 0x685c, 0x9bad,
/* 08 */ 0x7b39, 0x5319, 0x518a, 0x5237, 0x5bdf, 0x62f6, 0x64ae, 0x64e6,
/* 10 */ 0x672d, 0x6bba, 0x85a9, 0x96d1, 0x7690, 0x9bd6, 0x634c, 0x9306,
/* 18 */ 0x9bab, 0x76bf, 0x6652, 0x4e09, 0x5098, 0x53c2, 0x5c71, 0x60e8,
/* 20 */ 0x6492, 0x6563, 0x685f, 0x71e6, 0x73ca, 0x7523, 0x7b97, 0x7e82,
/* 28 */ 0x8695, 0x8b83, 0x8cdb, 0x9178, 0x9910, 0x65ac, 0x66ab, 0x6b8b,
/* 30 */ 0x4ed5, 0x4ed4, 0x4f3a, 0x4f7f, 0x523a, 0x53f8, 0x53f2, 0x55e3,
/* 38 */ 0x56db, 0x58eb, 0x59cb, 0x59c9, 0x59ff, 0x5b50, 0x5c4d, 0x5e02
},

/* Row 0x02c */
{
/* 00 */ 0x5e2b, 0x5fd7, 0x601d, 0x6307, 0x652f, 0x5b5c, 0x65af, 0x65bd,
/* 08 */ 0x65e8, 0x679d, 0x6b62, 0x6b7b, 0x6c0f, 0x7345, 0x7949, 0x79c1,
/* 10 */ 0x7cf8, 0x7d19, 0x7d2b, 0x80a2, 0x8102, 0x81f3, 0x8996, 0x8a5e,
/* 18 */ 0x8a69, 0x8a66, 0x8a8c, 0x8aee, 0x8cc7, 0x8cdc, 0x96cc, 0x98fc,
/* 20 */ 0x6b6f, 0x4e8b, 0x4f3c, 0x4f8d, 0x5150, 0x5b57, 0x5bfa, 0x6148,
/* 28 */ 0x6301, 0x6642, 0x6b21, 0x6ecb, 0x6cbb, 0x723e, 0x74bd, 0x75d4,
/* 30 */ 0x78c1, 0x793a, 0x800c, 0x8033, 0x81ea, 0x8494, 0x8f9e, 0x6c50,
/* 38 */ 0x9e7f, 0x5f0f, 0x8b58, 0x9d2b, 0x7afa, 0x8ef8, 0x5b8d, 0x96eb
},

/* Row 0x02d */
{
/* 00 */ 0x4e03, 0x53f1, 0x57f7, 0x5931, 0x5ac9, 0x5ba4, 0x6089, 0x6e7f,
/* 08 */ 0x6f06, 0x75be, 0x8cea, 0x5b9f, 0x8500, 0x7be0, 0x5072, 0x67f4,
/* 10 */ 0x829d, 0x5c61, 0x854a, 0x7e1e, 0x820e, 0x5199, 0x5c04, 0x6368,
/* 18 */ 0x8d66, 0x659c, 0x716e, 0x793e, 0x7d17, 0x8005, 0x8b1d, 0x8eca,
/* 20 */ 0x906e, 0x86c7, 0x90aa, 0x501f, 0x52fa, 0x5c3a, 0x6753, 0x707c,
/* 28 */ 0x7235, 0x914c, 0x91c8, 0x932b, 0x82e5, 0x5bc2, 0x5f31, 0x60f9,
/* 30 */ 0x4e3b, 0x53d6, 0x5b88, 0x624b, 0x6731, 0x6b8a, 0x72e9, 0x73e0,
/* 38 */ 0x7a2e, 0x816b, 0x8da3, 0x9152, 0x9996, 0x5112, 0x53d7, 0x546a
},

/* Row 0x02e */
{
/* 00 */ 0x5bff, 0x6388, 0x6a39, 0x7dac, 0x9700, 0x56da, 0x53ce, 0x5468,
/* 08 */ 0x5b97, 0x5c31, 0x5dde, 0x4fee, 0x6101, 0x62fe, 0x6d32, 0x79c0,
/* 10 */ 0x79cb, 0x7d42, 0x7e4d, 0x7fd2, 0x81ed, 0x821f, 0x8490, 0x8846,
/* 18 */ 0x8972, 0x8b90, 0x8e74, 0x8f2f, 0x9031, 0x914b, 0x916c, 0x96c6,
/* 20 */ 0x919c, 0x4ec0, 0x4f4f, 0x5145, 0x5341, 0x5f93, 0x620e, 0x67d4,
/* 28 */ 0x6c41, 0x6e0b, 0x7363, 0x7e26, 0x91cd, 0x9283, 0x53d4, 0x5919,
/* 30 */ 0x5bbf, 0x6dd1, 0x795d, 0x7e2e, 0x7c9b, 0x587e, 0x719f, 0x51fa,
/* 38 */ 0x8853, 0x8ff0, 0x4fca, 0x5cfb, 0x6625, 0x77ac, 0x7ae3, 0x821c
},

/* Row 0x02f */
{
/* 00 */ 0x99ff, 0x51c6, 0x5faa, 0x65ec, 0x696f, 0x6b89, 0x6df3, 0x6e96,
/* 08 */ 0x6f64, 0x76fe, 0x7d14, 0x5de1, 0x9075, 0x9187, 0x9806, 0x51e6,
/* 10 */ 0x521d, 0x6240, 0x6691, 0x66d9, 0x6e1a, 0x5eb6, 0x7dd2, 0x7f72,
/* 18 */ 0x66f8, 0x85af, 0x85f7, 0x8af8, 0x52a9, 0x53d9, 0x5973, 0x5e8f,
/* 20 */ 0x5f90, 0x6055, 0x92e4, 0x9664, 0x50b7, 0x511f, 0x52dd, 0x5320,
/* 28 */ 0x5347, 0x53ec, 0x54e8, 0x5546, 0x5531, 0x5617, 0x5968, 0x59be,
/* 30 */ 0x5a3c, 0x5bb5, 0x5c06, 0x5c0f, 0x5c11, 0x5c1a, 0x5e84, 0x5e8a,
/* 38 */ 0x5ee0, 0x5f70, 0x627f, 0x6284, 0x62db, 0x638c, 0x6377, 0x6607
},

/* Row 0x030 */
{
/* 00 */ 0x660c, 0x662d, 0x6676, 0x677e, 0x68a2, 0x6a1f, 0x6a35, 0x6cbc,
/* 08 */ 0x6d88, 0x6e09, 0x6e58, 0x713c, 0x7126, 0x7167, 0x75c7, 0x7701,
/* 10 */ 0x785d, 0x7901, 0x7965, 0x79f0, 0x7ae0, 0x7b11, 0x7ca7, 0x7d39,
/* 18 */ 0x8096, 0x83d6, 0x848b, 0x8549, 0x885d, 0x88f3, 0x8a1f, 0x8a3c,
/* 20 */ 0x8a54, 0x8a73, 0x8c61, 0x8cde, 0x91a4, 0x9266, 0x937e, 0x9418,
/* 28 */ 0x969c, 0x9798, 0x4e0a, 0x4e08, 0x4e1e, 0x4e57, 0x5197, 0x5270,
/* 30 */ 0x57ce, 0x5834, 0x58cc, 0x5b22, 0x5e38, 0x60c5, 0x64fe, 0x6761,
/* 38 */ 0x6756, 0x6d44, 0x72b6, 0x7573, 0x7a63, 0x84b8, 0x8b72, 0x91b8
},

/* Row 0x031 */
{
/* 00 */ 0x9320, 0x5631, 0x57f4, 0x98fe, 0x62ed, 0x690d, 0x6b96, 0x71ed,
/* 08 */ 0x7e54, 0x8077, 0x8272, 0x89e6, 0x98df, 0x8755, 0x8fb1, 0x5c3b,
/* 10 */ 0x4f38, 0x4fe1, 0x4fb5, 0x5507, 0x5a20, 0x5bdd, 0x5be9, 0x5fc3,
/* 18 */ 0x614e, 0x632f, 0x65b0, 0x664b, 0x68ee, 0x699b, 0x6d78, 0x6df1,
/* 20 */ 0x7533, 0x75b9, 0x771f, 0x795e, 0x79e6, 0x7d33, 0x81e3, 0x82af,
/* 28 */ 0x85aa, 0x89aa, 0x8a3a, 0x8eab, 0x8f9b, 0x9032, 0x91dd, 0x9707,
/* 30 */ 0x4eba, 0x4ec1, 0x5203, 0x5875, 0x58ec, 0x5c0b, 0x751a, 0x5c3d,
/* 38 */ 0x814e, 0x8a0a, 0x8fc5, 0x9663, 0x976d, 0x7b25, 0x8acf, 0x9808
},

/* Row 0x032 */
{
/* 00 */ 0x9162, 0x56f3, 0x53a8, 0x9017, 0x5439, 0x5782, 0x5e25, 0x63a8,
/* 08 */ 0x6c34, 0x708a, 0x7761, 0x7c8b, 0x7fe0, 0x8870, 0x9042, 0x9154,
/* 10 */ 0x9310, 0x9318, 0x968f, 0x745e, 0x9ac4, 0x5d07, 0x5d69, 0x6570,
/* 18 */ 0x67a2, 0x8da8, 0x96db, 0x636e, 0x6749, 0x6919, 0x83c5, 0x9817,
/* 20 */ 0x96c0, 0x88fe, 0x6f84, 0x647a, 0x5bf8, 0x4e16, 0x702c, 0x755d,
/* 28 */ 0x662f, 0x51c4, 0x5236, 0x52e2, 0x59d3, 0x5f81, 0x6027, 0x6210,
/* 30 */ 0x653f, 0x6574, 0x661f, 0x6674, 0x68f2, 0x6816, 0x6b63, 0x6e05,
/* 38 */ 0x7272, 0x751f, 0x76db, 0x7cbe, 0x8056, 0x58f0, 0x88fd, 0x897f
},

/* Row 0x033 */
{
/* 00 */ 0x8aa0, 0x8a93, 0x8acb, 0x901d, 0x9192, 0x9752, 0x9759, 0x6589,
/* 08 */ 0x7a0e, 0x8106, 0x96bb, 0x5e2d, 0x60dc, 0x621a, 0x65a5, 0x6614,
/* 10 */ 0x6790, 0x77f3, 0x7a4d, 0x7c4d, 0x7e3e, 0x810a, 0x8cac, 0x8d64,
/* 18 */ 0x8de1, 0x8e5f, 0x78a9, 0x5207, 0x62d9, 0x63a5, 0x6442, 0x6298,
/* 20 */ 0x8a2d, 0x7a83, 0x7bc0, 0x8aac, 0x96ea, 0x7d76, 0x820c, 0x8749,
/* 28 */ 0x4ed9, 0x5148, 0x5343, 0x5360, 0x5ba3, 0x5c02, 0x5c16, 0x5ddd,
/* 30 */ 0x6226, 0x6247, 0x64b0, 0x6813, 0x6834, 0x6cc9, 0x6d45, 0x6d17,
/* 38 */ 0x67d3, 0x6f5c, 0x714e, 0x717d, 0x65cb, 0x7a7f, 0x7bad, 0x7dda
},

/* Row 0x034 */
{
/* 00 */ 0x7e4a, 0x7fa8, 0x817a, 0x821b, 0x8239, 0x85a6, 0x8a6e, 0x8cce,
/* 08 */ 0x8df5, 0x9078, 0x9077, 0x92ad, 0x9291, 0x9583, 0x9bae, 0x524d,
/* 10 */ 0x5584, 0x6f38, 0x7136, 0x5168, 0x7985, 0x7e55, 0x81b3, 0x7cce,
/* 18 */ 0x564c, 0x5851, 0x5ca8, 0x63aa, 0x66fe, 0x66fd, 0x695a, 0x72d9,
/* 20 */ 0x758f, 0x758e, 0x790e, 0x7956, 0x79df, 0x7c97, 0x7d20, 0x7d44,
/* 28 */ 0x8607, 0x8a34, 0x963b, 0x9061, 0x9f20, 0x50e7, 0x5275, 0x53cc,
/* 30 */ 0x53e2, 0x5009, 0x55aa, 0x58ee, 0x594f, 0x723d, 0x5b8b, 0x5c64,
/* 38 */ 0x531d, 0x60e3, 0x60f3, 0x635c, 0x6383, 0x633f, 0x63bb, 0x64cd
},

/* Row 0x035 */
{
/* 00 */ 0x65e9, 0x66f9, 0x5de3, 0x69cd, 0x69fd, 0x6f15, 0x71e5, 0x4e89,
/* 08 */ 0x75e9, 0x76f8, 0x7a93, 0x7cdf, 0x7dcf, 0x7d9c, 0x8061, 0x8349,
/* 10 */ 0x8358, 0x846c, 0x84bc, 0x85fb, 0x88c5, 0x8d70, 0x9001, 0x906d,
/* 18 */ 0x9397, 0x971c, 0x9a12, 0x50cf, 0x5897, 0x618e, 0x81d3, 0x8535,
/* 20 */ 0x8d08, 0x9020, 0x4fc3, 0x5074, 0x5247, 0x5373, 0x606f, 0x6349,
/* 28 */ 0x675f, 0x6e2c, 0x8db3, 0x901f, 0x4fd7, 0x5c5e, 0x8cca, 0x65cf,
/* 30 */ 0x7d9a, 0x5352, 0x8896, 0x5176, 0x63c3, 0x5b58, 0x5b6b, 0x5c0a,
/* 38 */ 0x640d, 0x6751, 0x905c, 0x4ed6, 0x591a, 0x592a, 0x6c70, 0x8a51
},

/* Row 0x036 */
{
/* 00 */ 0x553e, 0x5815, 0x59a5, 0x60f0, 0x6253, 0x67c1, 0x8235, 0x6955,
/* 08 */ 0x9640, 0x99c4, 0x9a28, 0x4f53, 0x5806, 0x5bfe, 0x8010, 0x5cb1,
/* 10 */ 0x5e2f, 0x5f85, 0x6020, 0x614b, 0x6234, 0x66ff, 0x6cf0, 0x6ede,
/* 18 */ 0x80ce, 0x817f, 0x82d4, 0x888b, 0x8cb8, 0x9000, 0x902e, 0x968a,
/* 20 */ 0x9edb, 0x9bdb, 0x4ee3, 0x53f0, 0x5927, 0x7b2c, 0x918d, 0x984c,
/* 28 */ 0x9df9, 0x6edd, 0x7027, 0x5353, 0x5544, 0x5b85, 0x6258, 0x629e,
/* 30 */ 0x62d3, 0x6ca2, 0x6fef, 0x7422, 0x8a17, 0x9438, 0x6fc1, 0x8afe,
/* 38 */ 0x8338, 0x51e7, 0x86f8, 0x53ea, 0x53e9, 0x4f46, 0x9054, 0x8fb0
},

/* Row 0x037 */
{
/* 00 */ 0x596a, 0x8131, 0x5dfd, 0x7aea, 0x8fbf, 0x68da, 0x8c37, 0x72f8,
/* 08 */ 0x9c48, 0x6a3d, 0x8ab0, 0x4e39, 0x5358, 0x5606, 0x5766, 0x62c5,
/* 10 */ 0x63a2, 0x65e6, 0x6b4e, 0x6de1, 0x6e5b, 0x70ad, 0x77ed, 0x7aef,
/* 18 */ 0x7baa, 0x7dbb, 0x803d, 0x80c6, 0x86cb, 0x8a95, 0x935b, 0x56e3,
/* 20 */ 0x58c7, 0x5f3e, 0x65ad, 0x6696, 0x6a80, 0x6bb5, 0x7537, 0x8ac7,
/* 28 */ 0x5024, 0x77e5, 0x5730, 0x5f1b, 0x6065, 0x667a, 0x6c60, 0x75f4,
/* 30 */ 0x7a1a, 0x7f6e, 0x81f4, 0x8718, 0x9045, 0x99b3, 0x7bc9, 0x755c,
/* 38 */ 0x7af9, 0x7b51, 0x84c4, 0x9010, 0x79e9, 0x7a92, 0x8336, 0x5ae1
},

/* Row 0x038 */
{
/* 00 */ 0x7740, 0x4e2d, 0x4ef2, 0x5b99, 0x5fe0, 0x62bd, 0x663c, 0x67f1,
/* 08 */ 0x6ce8, 0x866b, 0x8877, 0x8a3b, 0x914e, 0x92f3, 0x99d0, 0x6a17,
/* 10 */ 0x7026, 0x732a, 0x82e7, 0x8457, 0x8caf, 0x4e01, 0x5146, 0x51cb,
/* 18 */ 0x558b, 0x5bf5, 0x5e16, 0x5e33, 0x5e81, 0x5f14, 0x5f35, 0x5f6b,
/* 20 */ 0x5fb4, 0x61f2, 0x6311, 0x66a2, 0x671d, 0x6f6e, 0x7252, 0x753a,
/* 28 */ 0x773a, 0x8074, 0x8139, 0x8178, 0x8776, 0x8abf, 0x8adc, 0x8d85,
/* 30 */ 0x8df3, 0x929a, 0x9577, 0x9802, 0x9ce5, 0x52c5, 0x6357, 0x76f4,
/* 38 */ 0x6715, 0x6c88, 0x73cd, 0x8cc3, 0x93ae, 0x9673, 0x6d25, 0x589c
},

/* Row 0x039 */
{
/* 00 */ 0x690e, 0x69cc, 0x8ffd, 0x939a, 0x75db, 0x901a, 0x585a, 0x6802,
/* 08 */ 0x63b4, 0x69fb, 0x4f43, 0x6f2c, 0x67d8, 0x8fbb, 0x8526, 0x7db4,
/* 10 */ 0x9354, 0x693f, 0x6f70, 0x576a, 0x58f7, 0x5b2c, 0x7d2c, 0x722a,
/* 18 */ 0x540a, 0x91e3, 0x9db4, 0x4ead, 0x4f4e, 0x505c, 0x5075, 0x5243,
/* 20 */ 0x8c9e, 0x5448, 0x5824, 0x5b9a, 0x5e1d, 0x5e95, 0x5ead, 0x5ef7,
/* 28 */ 0x5f1f, 0x608c, 0x62b5, 0x633a, 0x63d0, 0x68af, 0x6c40, 0x7887,
/* 30 */ 0x798e, 0x7a0b, 0x7de0, 0x8247, 0x8a02, 0x8ae6, 0x8e44, 0x9013,
/* 38 */ 0x90b8, 0x912d, 0x91d8, 0x9f0e, 0x6ce5, 0x6458, 0x64e2, 0x6575
},

/* Row 0x03a */
{
/* 00 */ 0x6ef4, 0x7684, 0x7b1b, 0x9069, 0x93d1, 0x6eba, 0x54f2, 0x5fb9,
/* 08 */ 0x64a4, 0x8f4d, 0x8fed, 0x9244, 0x5178, 0x586b, 0x5929, 0x5c55,
/* 10 */ 0x5e97, 0x6dfb, 0x7e8f, 0x751c, 0x8cbc, 0x8ee2, 0x985b, 0x70b9,
/* 18 */ 0x4f1d, 0x6bbf, 0x6fb1, 0x7530, 0x96fb, 0x514e, 0x5410, 0x5835,
/* 20 */ 0x5857, 0x59ac, 0x5c60, 0x5f92, 0x6597, 0x675c, 0x6e21, 0x767b,
/* 28 */ 0x83df, 0x8ced, 0x9014, 0x90fd, 0x934d, 0x7825, 0x783a, 0x52aa,
/* 30 */ 0x5ea6, 0x571f, 0x5974, 0x6012, 0x5012, 0x515a, 0x51ac, 0x51cd,
/* 38 */ 0x5200, 0x5510, 0x5854, 0x5858, 0x5957, 0x5b95, 0x5cf6, 0x5d8b
},

/* Row 0x03b */
{
/* 00 */ 0x60bc, 0x6295, 0x642d, 0x6771, 0x6843, 0x68bc, 0x68df, 0x76d7,
/* 08 */ 0x6dd8, 0x6e6f, 0x6d9b, 0x706f, 0x71c8, 0x5f53, 0x75d8, 0x7977,
/* 10 */ 0x7b49, 0x7b54, 0x7b52, 0x7cd6, 0x7d71, 0x5230, 0x8463, 0x8569,
/* 18 */ 0x85e4, 0x8a0e, 0x8b04, 0x8c46, 0x8e0f, 0x9003, 0x900f, 0x9419,
/* 20 */ 0x9676, 0x982d, 0x9a30, 0x95d8, 0x50cd, 0x52d5, 0x540c, 0x5802,
/* 28 */ 0x5c0e, 0x61a7, 0x649e, 0x6d1e, 0x77b3, 0x7ae5, 0x80f4, 0x8404,
/* 30 */ 0x9053, 0x9285, 0x5ce0, 0x9d07, 0x533f, 0x5f97, 0x5fb3, 0x6d9c,
/* 38 */ 0x7279, 0x7763, 0x79bf, 0x7be4, 0x6bd2, 0x72ec, 0x8aad, 0x6803
},

/* Row 0x03c */
{
/* 00 */ 0x6a61, 0x51f8, 0x7a81, 0x6934, 0x5c4a, 0x9cf6, 0x82eb, 0x5bc5,
/* 08 */ 0x9149, 0x701e, 0x5678, 0x5c6f, 0x60c7, 0x6566, 0x6c8c, 0x8c5a,
/* 10 */ 0x9041, 0x9813, 0x5451, 0x66c7, 0x920d, 0x5948, 0x90a3, 0x5185,
/* 18 */ 0x4e4d, 0x51ea, 0x8599, 0x8b0e, 0x7058, 0x637a, 0x934b, 0x6962,
/* 20 */ 0x99b4, 0x7e04, 0x7577, 0x5357, 0x6960, 0x8edf, 0x96e3, 0x6c5d,
/* 28 */ 0x4e8c, 0x5c3c, 0x5f10, 0x8fe9, 0x5302, 0x8cd1, 0x8089, 0x8679,
/* 30 */ 0x5eff, 0x65e5, 0x4e73, 0x5165, 0x5982, 0x5c3f, 0x97ee, 0x4efb,
/* 38 */ 0x598a, 0x5fcd, 0x8a8d, 0x6fe1, 0x79b0, 0x7962, 0x5be7, 0x8471
},

/* Row 0x03d */
{
/* 00 */ 0x732b, 0x71b1, 0x5e74, 0x5ff5, 0x637b, 0x649a, 0x71c3, 0x7c98,
/* 08 */ 0x4e43, 0x5efc, 0x4e4b, 0x57dc, 0x56a2, 0x60a9, 0x6fc3, 0x7d0d,
/* 10 */ 0x80fd, 0x8133, 0x81bf, 0x8fb2, 0x8997, 0x86a4, 0x5df4, 0x628a,
/* 18 */ 0x64ad, 0x8987, 0x6777, 0x6ce2, 0x6d3e, 0x7436, 0x7834, 0x5a46,
/* 20 */ 0x7f75, 0x82ad, 0x99ac, 0x4ff3, 0x5ec3, 0x62dd, 0x6392, 0x6557,
/* 28 */ 0x676f, 0x76c3, 0x724c, 0x80cc, 0x80ba, 0x8f29, 0x914d, 0x500d,
/* 30 */ 0x57f9, 0x5a92, 0x6885, 0x6973, 0x7164, 0x72fd, 0x8cb7, 0x58f2,
/* 38 */ 0x8ce0, 0x966a, 0x9019, 0x877f, 0x79e4, 0x77e7, 0x8429, 0x4f2f
},

/* Row 0x03e */
{
/* 00 */ 0x5265, 0x535a, 0x62cd, 0x67cf, 0x6cca, 0x767d, 0x7b94, 0x7c95,
/* 08 */ 0x8236, 0x8584, 0x8feb, 0x66dd, 0x6f20, 0x7206, 0x7e1b, 0x83ab,
/* 10 */ 0x99c1, 0x9ea6, 0x51fd, 0x7bb1, 0x7872, 0x7bb8, 0x8087, 0x7b48,
/* 18 */ 0x6ae8, 0x5e61, 0x808c, 0x7551, 0x7560, 0x516b, 0x9262, 0x6e8c,
/* 20 */ 0x767a, 0x9197, 0x9aea, 0x4f10, 0x7f70, 0x629c, 0x7b4f, 0x95a5,
/* 28 */ 0x9ce9, 0x567a, 0x5859, 0x86e4, 0x96bc, 0x4f34, 0x5224, 0x534a,
/* 30 */ 0x53cd, 0x53db, 0x5e06, 0x642c, 0x6591, 0x677f, 0x6c3e, 0x6c4e,
/* 38 */ 0x7248, 0x72af, 0x73ed, 0x7554, 0x7e41, 0x822c, 0x85e9, 0x8ca9
},

/* Row 0x03f */
{
/* 00 */ 0x7bc4, 0x91c6, 0x7169, 0x9812, 0x98ef, 0x633d, 0x6669, 0x756a,
/* 08 */ 0x76e4, 0x78d0, 0x8543, 0x86ee, 0x532a, 0x5351, 0x5426, 0x5983,
/* 10 */ 0x5e87, 0x5f7c, 0x60b2, 0x6249, 0x6279, 0x62ab, 0x6590, 0x6bd4,
/* 18 */ 0x6ccc, 0x75b2, 0x76ae, 0x7891, 0x79d8, 0x7dcb, 0x7f77, 0x80a5,
/* 20 */ 0x88ab, 0x8ab9, 0x8cbb, 0x907f, 0x975e, 0x98db, 0x6a0b, 0x7c38,
/* 28 */ 0x5099, 0x5c3e, 0x5fae, 0x6787, 0x6bd8, 0x7435, 0x7709, 0x7f8e,
/* 30 */ 0x9f3b, 0x67ca, 0x7a17, 0x5339, 0x758b, 0x9aed, 0x5f66, 0x819d,
/* 38 */ 0x83f1, 0x8098, 0x5f3c, 0x5fc5, 0x7562, 0x7b46, 0x903c, 0x6867
},

/* Row 0x040 */
{
/* 00 */ 0x59eb, 0x5a9b, 0x7d10, 0x767e, 0x8b2c, 0x4ff5, 0x5f6a, 0x6a19,
/* 08 */ 0x6c37, 0x6f02, 0x74e2, 0x7968, 0x8868, 0x8a55, 0x8c79, 0x5edf,
/* 10 */ 0x63cf, 0x75c5, 0x79d2, 0x82d7, 0x9328, 0x92f2, 0x849c, 0x86ed,
/* 18 */ 0x9c2d, 0x54c1, 0x5f6c, 0x658c, 0x6d5c, 0x7015, 0x8ca7, 0x8cd3,
/* 20 */ 0x983b, 0x654f, 0x74f6, 0x4e0d, 0x4ed8, 0x57e0, 0x592b, 0x5a66,
/* 28 */ 0x5bcc, 0x51a8, 0x5e03, 0x5e9c, 0x6016, 0x6276, 0x6577, 0x65a7,
/* 30 */ 0x666e, 0x6d6e, 0x7236, 0x7b26, 0x8150, 0x819a, 0x8299, 0x8b5c,
/* 38 */ 0x8ca0, 0x8ce6, 0x8d74, 0x961c, 0x9644, 0x4fae, 0x64ab, 0x6b66
},

/* Row 0x041 */
{
/* 00 */ 0x821e, 0x8461, 0x856a, 0x90e8, 0x5c01, 0x6953, 0x98a8, 0x847a,
/* 08 */ 0x8557, 0x4f0f, 0x526f, 0x5fa9, 0x5e45, 0x670d, 0x798f, 0x8179,
/* 10 */ 0x8907, 0x8986, 0x6df5, 0x5f17, 0x6255, 0x6cb8, 0x4ecf, 0x7269,
/* 18 */ 0x9b92, 0x5206, 0x543b, 0x5674, 0x58b3, 0x61a4, 0x626e, 0x711a,
/* 20 */ 0x596e, 0x7c89, 0x7cde, 0x7d1b, 0x96f0, 0x6587, 0x805e, 0x4e19,
/* 28 */ 0x4f75, 0x5175, 0x5840, 0x5e63, 0x5e73, 0x5f0a, 0x67c4, 0x4e26,
/* 30 */ 0x853d, 0x9589, 0x965b, 0x7c73, 0x9801, 0x50fb, 0x58c1, 0x7656,
/* 38 */ 0x78a7, 0x5225, 0x77a5, 0x8511, 0x7b86, 0x504f, 0x5909, 0x7247
},

/* Row 0x042 */
{
/* 00 */ 0x7bc7, 0x7de8, 0x8fba, 0x8fd4, 0x904d, 0x4fbf, 0x52c9, 0x5a29,
/* 08 */ 0x5f01, 0x97ad, 0x4fdd, 0x8217, 0x92ea, 0x5703, 0x6355, 0x6b69,
/* 10 */ 0x752b, 0x88dc, 0x8f14, 0x7a42, 0x52df, 0x5893, 0x6155, 0x620a,
/* 18 */ 0x66ae, 0x6bcd, 0x7c3f, 0x83e9, 0x5023, 0x4ff8, 0x5305, 0x5446,
/* 20 */ 0x5831, 0x5949, 0x5b9d, 0x5cf0, 0x5cef, 0x5d29, 0x5e96, 0x62b1,
/* 28 */ 0x6367, 0x653e, 0x65b9, 0x670b, 0x6cd5, 0x6ce1, 0x70f9, 0x7832,
/* 30 */ 0x7e2b, 0x80de, 0x82b3, 0x840c, 0x84ec, 0x8702, 0x8912, 0x8a2a,
/* 38 */ 0x8c4a, 0x90a6, 0x92d2, 0x98fd, 0x9cf3, 0x9d6c, 0x4e4f, 0x4ea1
},

/* Row 0x043 */
{
/* 00 */ 0x508d, 0x5256, 0x574a, 0x59a8, 0x5e3d, 0x5fd8, 0x5fd9, 0x623f,
/* 08 */ 0x66b4, 0x671b, 0x67d0, 0x68d2, 0x5192, 0x7d21, 0x80aa, 0x81a8,
/* 10 */ 0x8b00, 0x8c8c, 0x8cbf, 0x927e, 0x9632, 0x5420, 0x982c, 0x5317,
/* 18 */ 0x50d5, 0x535c, 0x58a8, 0x64b2, 0x6734, 0x7267, 0x7766, 0x7a46,
/* 20 */ 0x91e6, 0x52c3, 0x6ca1, 0x6b86, 0x5800, 0x5e4c, 0x5954, 0x672c,
/* 28 */ 0x7ffb, 0x51e1, 0x76c6, 0x6469, 0x78e8, 0x9b54, 0x9ebb, 0x57cb,
/* 30 */ 0x59b9, 0x6627, 0x679a, 0x6bce, 0x54e9, 0x69d9, 0x5e55, 0x819c,
/* 38 */ 0x6795, 0x9baa, 0x67fe, 0x9c52, 0x685d, 0x4ea6, 0x4fe3, 0x53c8
},

/* Row 0x044 */
{
/* 00 */ 0x62b9, 0x672b, 0x6cab, 0x8fc4, 0x4fad, 0x7e6d, 0x9ebf, 0x4e07,
/* 08 */ 0x6162, 0x6e80, 0x6f2b, 0x8513, 0x5473, 0x672a, 0x9b45, 0x5df3,
/* 10 */ 0x7b95, 0x5cac, 0x5bc6, 0x871c, 0x6e4a, 0x84d1, 0x7a14, 0x8108,
/* 18 */ 0x5999, 0x7c8d, 0x6c11, 0x7720, 0x52d9, 0x5922, 0x7121, 0x725f,
/* 20 */ 0x77db, 0x9727, 0x9d61, 0x690b, 0x5a7f, 0x5a18, 0x51a5, 0x540d,
/* 28 */ 0x547d, 0x660e, 0x76df, 0x8ff7, 0x9298, 0x9cf4, 0x59ea, 0x725d,
/* 30 */ 0x6ec5, 0x514d, 0x68c9, 0x7dbf, 0x7dec, 0x9762, 0x9eba, 0x6478,
/* 38 */ 0x6a21, 0x8302, 0x5984, 0x5b5f, 0x6bdb, 0x731b, 0x76f2, 0x7db2
},

/* Row 0x045 */
{
/* 00 */ 0x8017, 0x8499, 0x5132, 0x6728, 0x9ed9, 0x76ee, 0x6762, 0x52ff,
/* 08 */ 0x9905, 0x5c24, 0x623b, 0x7c7e, 0x8cb0, 0x554f, 0x60b6, 0x7d0b,
/* 10 */ 0x9580, 0x5301, 0x4e5f, 0x51b6, 0x591c, 0x723a, 0x8036, 0x91ce,
/* 18 */ 0x5f25, 0x77e2, 0x5384, 0x5f79, 0x7d04, 0x85ac, 0x8a33, 0x8e8d,
/* 20 */ 0x9756, 0x67f3, 0x85ae, 0x9453, 0x6109, 0x6108, 0x6cb9, 0x7652,
/* 28 */ 0x8aed, 0x8f38, 0x552f, 0x4f51, 0x512a, 0x52c7, 0x53cb, 0x5ba5,
/* 30 */ 0x5e7d, 0x60a0, 0x6182, 0x63d6, 0x6709, 0x67da, 0x6e67, 0x6d8c,
/* 38 */ 0x7336, 0x7337, 0x7531, 0x7950, 0x88d5, 0x8a98, 0x904a, 0x9091
},

/* Row 0x046 */
{
/* 00 */ 0x90f5, 0x96c4, 0x878d, 0x5915, 0x4e88, 0x4f59, 0x4e0e, 0x8a89,
/* 08 */ 0x8f3f, 0x9810, 0x50ad, 0x5e7c, 0x5996, 0x5bb9, 0x5eb8, 0x63da,
/* 10 */ 0x63fa, 0x64c1, 0x66dc, 0x694a, 0x69d8, 0x6d0b, 0x6eb6, 0x7194,
/* 18 */ 0x7528, 0x7aaf, 0x7f8a, 0x8000, 0x8449, 0x84c9, 0x8981, 0x8b21,
/* 20 */ 0x8e0a, 0x9065, 0x967d, 0x990a, 0x617e, 0x6291, 0x6b32, 0x6c83,
/* 28 */ 0x6d74, 0x7fcc, 0x7ffc, 0x6dc0, 0x7f85, 0x87ba, 0x88f8, 0x6765,
/* 30 */ 0x83b1, 0x983c, 0x96f7, 0x6d1b, 0x7d61, 0x843d, 0x916a, 0x4e71,
/* 38 */ 0x5375, 0x5d50, 0x6b04, 0x6feb, 0x85cd, 0x862d, 0x89a7, 0x5229
},

/* Row 0x047 */
{
/* 00 */ 0x540f, 0x5c65, 0x674e, 0x68a8, 0x7406, 0x7483, 0x75e2, 0x88cf,
/* 08 */ 0x88e1, 0x91cc, 0x96e2, 0x9678, 0x5f8b, 0x7387, 0x7acb, 0x844e,
/* 10 */ 0x63a0, 0x7565, 0x5289, 0x6d41, 0x6e9c, 0x7409, 0x7559, 0x786b,
/* 18 */ 0x7c92, 0x9686, 0x7adc, 0x9f8d, 0x4fb6, 0x616e, 0x65c5, 0x865c,
/* 20 */ 0x4e86, 0x4eae, 0x50da, 0x4e21, 0x51cc, 0x5bee, 0x6599, 0x6881,
/* 28 */ 0x6dbc, 0x731f, 0x7642, 0x77ad, 0x7a1c, 0x7ce7, 0x826f, 0x8ad2,
/* 30 */ 0x907c, 0x91cf, 0x9675, 0x9818, 0x529b, 0x7dd1, 0x502b, 0x5398,
/* 38 */ 0x6797, 0x6dcb, 0x71d0, 0x7433, 0x81e8, 0x8f2a, 0x96a3, 0x9c57
},

/* Row 0x048 */
{
/* 00 */ 0x9e9f, 0x7460, 0x5841, 0x6d99, 0x7d2f, 0x985e, 0x4ee4, 0x4f36,
/* 08 */ 0x4f8b, 0x51b7, 0x52b1, 0x5dba, 0x601c, 0x73b2, 0x793c, 0x82d3,
/* 10 */ 0x9234, 0x96b7, 0x96f6, 0x970a, 0x9e97, 0x9f62, 0x66a6, 0x6b74,
/* 18 */ 0x5217, 0x52a3, 0x70c8, 0x88c2, 0x5ec9, 0x604b, 0x6190, 0x6f23,
/* 20 */ 0x7149, 0x7c3e, 0x7df4, 0x806f, 0x84ee, 0x9023, 0x932c, 0x5442,
/* 28 */ 0x9b6f, 0x6ad3, 0x7089, 0x8cc2, 0x8def, 0x9732, 0x52b4, 0x5a41,
/* 30 */ 0x5eca, 0x5f04, 0x6717, 0x697c, 0x6994, 0x6d6a, 0x6f0f, 0x7262,
/* 38 */ 0x72fc, 0x7bed, 0x8001, 0x807e, 0x874b, 0x90ce, 0x516d, 0x9e93
},

/* Row 0x049 */
{
/* 00 */ 0x7984, 0x808b, 0x9332, 0x8ad6, 0x502d, 0x548c, 0x8a71, 0x6b6a,
/* 08 */ 0x8cc4, 0x8107, 0x60d1, 0x67a0, 0x9df2, 0x4e99, 0x4e98, 0x9c10,
/* 10 */ 0x8a6b, 0x85c1, 0x8568, 0x6900, 0x6e7e, 0x7897, 0x8155, 0xf0ae,
/* 18 */ 0xf0af, 0xf0b0, 0xf0b1, 0xf0b2, 0xf0b3, 0xf0b4, 0xf0b5, 0xf0b6,
/* 20 */ 0xf0b7, 0xf0b8, 0xf0b9, 0xf0ba, 0xf0bb, 0xf0bc, 0xf0bd, 0xf0be,
/* 28 */ 0xf0bf, 0xf0c0, 0xf0c1, 0xf0c2, 0xf0c3, 0xf0c4, 0xf0c5, 0xf0c6,
/* 30 */ 0xf0c7, 0xf0c8, 0xf0c9, 0xf0ca, 0xf0cb, 0xf0cc, 0xf0cd, 0xf0ce,
/* 38 */ 0xf0cf, 0xf0d0, 0xf0d1, 0xf0d2, 0xf0d3, 0xf0d4, 0xf0d5, 0xf0d6
},

/* Row 0x04a */
{
/* 00 */ 0xf0d7, 0xf0d8, 0x5f0c, 0x4e10, 0x4e15, 0x4e2a, 0x4e31, 0x4e36,
/* 08 */ 0x4e3c, 0x4e3f, 0x4e42, 0x4e56, 0x4e58, 0x4e82, 0x4e85, 0x8c6b,
/* 10 */ 0x4e8a, 0x8212, 0x5f0d, 0x4e8e, 0x4e9e, 0x4e9f, 0x4ea0, 0x4ea2,
/* 18 */ 0x4eb0, 0x4eb3, 0x4eb6, 0x4ece, 0x4ecd, 0x4ec4, 0x4ec6, 0x4ec2,
/* 20 */ 0x4ed7, 0x4ede, 0x4eed, 0x4edf, 0x4ef7, 0x4f09, 0x4f5a, 0x4f30,
/* 28 */ 0x4f5b, 0x4f5d, 0x4f57, 0x4f47, 0x4f76, 0x4f88, 0x4f8f, 0x4f98,
/* 30 */ 0x4f7b, 0x4f69, 0x4f70, 0x4f91, 0x4f6f, 0x4f86, 0x4f96, 0x5118,
/* 38 */ 0x4fd4, 0x4fdf, 0x4fce, 0x4fd8, 0x4fdb, 0x4fd1, 0x4fda, 0x4fd0
},

/* Row 0x04b */
{
/* 00 */ 0x4fe4, 0x4fe5, 0x501a, 0x5028, 0x5014, 0x502a, 0x5025, 0x5005,
/* 08 */ 0x4f1c, 0x4ff6, 0x5021, 0x5029, 0x502c, 0x4ffe, 0x4fef, 0x5011,
/* 10 */ 0x5006, 0x5043, 0x5047, 0x6703, 0x5055, 0x5050, 0x5048, 0x505a,
/* 18 */ 0x5056, 0x506c, 0x5078, 0x5080, 0x509a, 0x5085, 0x50b4, 0x50b2,
/* 20 */ 0x50c9, 0x50ca, 0x50b3, 0x50c2, 0x50d6, 0x50de, 0x50e5, 0x50ed,
/* 28 */ 0x50e3, 0x50ee, 0x50f9, 0x50f5, 0x5109, 0x5101, 0x5102, 0x5116,
/* 30 */ 0x5115, 0x5114, 0x511a, 0x5121, 0x513a, 0x5137, 0x513c, 0x513b,
/* 38 */ 0x513f, 0x5140, 0x5152, 0x514c, 0x5154, 0x5162, 0x7af8, 0x5169
},

/* Row 0x04c */
{
/* 00 */ 0x516a, 0x516e, 0x5180, 0x5182, 0x56d8, 0x518c, 0x5189, 0x518f,
/* 08 */ 0x5191, 0x5193, 0x5195, 0x5196, 0x51a4, 0x51a6, 0x51a2, 0x51a9,
/* 10 */ 0x51aa, 0x51ab, 0x51b3, 0x51b1, 0x51b2, 0x51b0, 0x51b5, 0x51bd,
/* 18 */ 0x51c5, 0x51c9, 0x51db, 0x51e0, 0x8655, 0x51e9, 0x51ed, 0x51f0,
/* 20 */ 0x51f5, 0x51fe, 0x5204, 0x520b, 0x5214, 0x520e, 0x5227, 0x522a,
/* 28 */ 0x522e, 0x5233, 0x5239, 0x524f, 0x5244, 0x524b, 0x524c, 0x525e,
/* 30 */ 0x5254, 0x526a, 0x5274, 0x5269, 0x5273, 0x527f, 0x527d, 0x528d,
/* 38 */ 0x5294, 0x5292, 0x5271, 0x5288, 0x5291, 0x8fa8, 0x8fa7, 0x52ac
},

/* Row 0x04d */
{
/* 00 */ 0x52ad, 0x52bc, 0x52b5, 0x52c1, 0x52cd, 0x52d7, 0x52de, 0x52e3,
/* 08 */ 0x52e6, 0x98ed, 0x52e0, 0x52f3, 0x52f5, 0x52f8, 0x52f9, 0x5306,
/* 10 */ 0x5308, 0x7538, 0x530d, 0x5310, 0x530f, 0x5315, 0x531a, 0x5323,
/* 18 */ 0x532f, 0x5331, 0x5333, 0x5338, 0x5340, 0x5346, 0x5345, 0x4e17,
/* 20 */ 0x5349, 0x534d, 0x51d6, 0x535e, 0x5369, 0x536e, 0x5918, 0x537b,
/* 28 */ 0x5377, 0x5382, 0x5396, 0x53a0, 0x53a6, 0x53a5, 0x53ae, 0x53b0,
/* 30 */ 0x53b6, 0x53c3, 0x7c12, 0x96d9, 0x53df, 0x66fc, 0x71ee, 0x53ee,
/* 38 */ 0x53e8, 0x53ed, 0x53fa, 0x5401, 0x543d, 0x5440, 0x542c, 0x542d
},

/* Row 0x04e */
{
/* 00 */ 0x543c, 0x542e, 0x5436, 0x5429, 0x541d, 0x544e, 0x548f, 0x5475,
/* 08 */ 0x548e, 0x545f, 0x5471, 0x5477, 0x5470, 0x5492, 0x547b, 0x5480,
/* 10 */ 0x5476, 0x5484, 0x5490, 0x5486, 0x54c7, 0x54a2, 0x54b8, 0x54a5,
/* 18 */ 0x54ac, 0x54c4, 0x54c8, 0x54a8, 0x54ab, 0x54c2, 0x54a4, 0x54be,
/* 20 */ 0x54bc, 0x54d8, 0x54e5, 0x54e6, 0x550f, 0x5514, 0x54fd, 0x54ee,
/* 28 */ 0x54ed, 0x54fa, 0x54e2, 0x5539, 0x5540, 0x5563, 0x554c, 0x552e,
/* 30 */ 0x555c, 0x5545, 0x5556, 0x5557, 0x5538, 0x5533, 0x555d, 0x5599,
/* 38 */ 0x5580, 0x54af, 0x558a, 0x559f, 0x557b, 0x557e, 0x5598, 0x559e
},

/* Row 0x04f */
{
/* 00 */ 0x55ae, 0x557c, 0x5583, 0x55a9, 0x5587, 0x55a8, 0x55da, 0x55c5,
/* 08 */ 0x55df, 0x55c4, 0x55dc, 0x55e4, 0x55d4, 0x5614, 0x55f7, 0x5616,
/* 10 */ 0x55fe, 0x55fd, 0x561b, 0x55f9, 0x564e, 0x5650, 0x71df, 0x5634,
/* 18 */ 0x5636, 0x5632, 0x5638, 0x566b, 0x5664, 0x562f, 0x566c, 0x566a,
/* 20 */ 0x5686, 0x5680, 0x568a, 0x56a0, 0x5694, 0x568f, 0x56a5, 0x56ae,
/* 28 */ 0x56b6, 0x56b4, 0x56c2, 0x56bc, 0x56c1, 0x56c3, 0x56c0, 0x56c8,
/* 30 */ 0x56ce, 0x56d1, 0x56d3, 0x56d7, 0x56ee, 0x56f9, 0x5700, 0x56ff,
/* 38 */ 0x5704, 0x5709, 0x5708, 0x570b, 0x570d, 0x5713, 0x5718, 0x5716
},

/* Row 0x050 */
{
/* 00 */ 0x55c7, 0x571c, 0x5726, 0x5737, 0x5738, 0x574e, 0x573b, 0x5740,
/* 08 */ 0x574f, 0x5769, 0x57c0, 0x5788, 0x5761, 0x577f, 0x5789, 0x5793,
/* 10 */ 0x57a0, 0x57b3, 0x57a4, 0x57aa, 0x57b0, 0x57c3, 0x57c6, 0x57d4,
/* 18 */ 0x57d2, 0x57d3, 0x580a, 0x57d6, 0x57e3, 0x580b, 0x5819, 0x581d,
/* 20 */ 0x5872, 0x5821, 0x5862, 0x584b, 0x5870, 0x6bc0, 0x5852, 0x583d,
/* 28 */ 0x5879, 0x5885, 0x58b9, 0x589f, 0x58ab, 0x58ba, 0x58de, 0x58bb,
/* 30 */ 0x58b8, 0x58ae, 0x58c5, 0x58d3, 0x58d1, 0x58d7, 0x58d9, 0x58d8,
/* 38 */ 0x58e5, 0x58dc, 0x58e4, 0x58df, 0x58ef, 0x58fa, 0x58f9, 0x58fb
},

/* Row 0x051 */
{
/* 00 */ 0x58fc, 0x58fd, 0x5902, 0x590a, 0x5910, 0x591b, 0x68a6, 0x5925,
/* 08 */ 0x592c, 0x592d, 0x5932, 0x5938, 0x593e, 0x7ad2, 0x5955, 0x5950,
/* 10 */ 0x594e, 0x595a, 0x5958, 0x5962, 0x5960, 0x5967, 0x596c, 0x5969,
/* 18 */ 0x5978, 0x5981, 0x599d, 0x4f5e, 0x4fab, 0x59a3, 0x59b2, 0x59c6,
/* 20 */ 0x59e8, 0x59dc, 0x598d, 0x59d9, 0x59da, 0x5a25, 0x5a1f, 0x5a11,
/* 28 */ 0x5a1c, 0x5a09, 0x5a1a, 0x5a40, 0x5a6c, 0x5a49, 0x5a35, 0x5a36,
/* 30 */ 0x5a62, 0x5a6a, 0x5a9a, 0x5abc, 0x5abe, 0x5acb, 0x5ac2, 0x5abd,
/* 38 */ 0x5ae3, 0x5ad7, 0x5ae6, 0x5ae9, 0x5ad6, 0x5afa, 0x5afb, 0x5b0c
},

/* Row 0x052 */
{
/* 00 */ 0x5b0b, 0x5b16, 0x5b32, 0x5ad0, 0x5b2a, 0x5b36, 0x5b3e, 0x5b43,
/* 08 */ 0x5b45, 0x5b40, 0x5b51, 0x5b55, 0x5b5a, 0x5b5b, 0x5b65, 0x5b69,
/* 10 */ 0x5b70, 0x5b73, 0x5b75, 0x5b78, 0x6588, 0x5b7a, 0x5b80, 0x5b83,
/* 18 */ 0x5ba6, 0x5bb8, 0x5bc3, 0x5bc7, 0x5bc9, 0x5bd4, 0x5bd0, 0x5be4,
/* 20 */ 0x5be6, 0x5be2, 0x5bde, 0x5be5, 0x5beb, 0x5bf0, 0x5bf6, 0x5bf3,
/* 28 */ 0x5c05, 0x5c07, 0x5c08, 0x5c0d, 0x5c13, 0x5c20, 0x5c22, 0x5c28,
/* 30 */ 0x5c38, 0x5c39, 0x5c41, 0x5c46, 0x5c4e, 0x5c53, 0x5c50, 0x5c4f,
/* 38 */ 0x5b71, 0x5c6c, 0x5c6e, 0x4e62, 0x5c76, 0x5c79, 0x5c8c, 0x5c91
},

/* Row 0x053 */
{
/* 00 */ 0x5c94, 0x599b, 0x5cab, 0x5cbb, 0x5cb6, 0x5cbc, 0x5cb7, 0x5cc5,
/* 08 */ 0x5cbe, 0x5cc7, 0x5cd9, 0x5ce9, 0x5cfd, 0x5cfa, 0x5ced, 0x5d8c,
/* 10 */ 0x5cea, 0x5d0b, 0x5d15, 0x5d17, 0x5d5c, 0x5d1f, 0x5d1b, 0x5d11,
/* 18 */ 0x5d14, 0x5d22, 0x5d1a, 0x5d19, 0x5d18, 0x5d4c, 0x5d52, 0x5d4e,
/* 20 */ 0x5d4b, 0x5d6c, 0x5d73, 0x5d76, 0x5d87, 0x5d84, 0x5d82, 0x5da2,
/* 28 */ 0x5d9d, 0x5dac, 0x5dae, 0x5dbd, 0x5d90, 0x5db7, 0x5dbc, 0x5dc9,
/* 30 */ 0x5dcd, 0x5dd3, 0x5dd2, 0x5dd6, 0x5ddb, 0x5deb, 0x5df2, 0x5df5,
/* 38 */ 0x5e0b, 0x5e1a, 0x5e19, 0x5e11, 0x5e1b, 0x5e36, 0x5e37, 0x5e44
},

/* Row 0x054 */
{
/* 00 */ 0x5e43, 0x5e40, 0x5e4e, 0x5e57, 0x5e54, 0x5e5f, 0x5e62, 0x5e64,
/* 08 */ 0x5e47, 0x5e75, 0x5e76, 0x5e7a, 0x9ebc, 0x5e7f, 0x5ea0, 0x5ec1,
/* 10 */ 0x5ec2, 0x5ec8, 0x5ed0, 0x5ecf, 0x5ed6, 0x5ee3, 0x5edd, 0x5eda,
/* 18 */ 0x5edb, 0x5ee2, 0x5ee1, 0x5ee8, 0x5ee9, 0x5eec, 0x5ef1, 0x5ef3,
/* 20 */ 0x5ef0, 0x5ef4, 0x5ef8, 0x5efe, 0x5f03, 0x5f09, 0x5f5d, 0x5f5c,
/* 28 */ 0x5f0b, 0x5f11, 0x5f16, 0x5f29, 0x5f2d, 0x5f38, 0x5f41, 0x5f48,
/* 30 */ 0x5f4c, 0x5f4e, 0x5f2f, 0x5f51, 0x5f56, 0x5f57, 0x5f59, 0x5f61,
/* 38 */ 0x5f6d, 0x5f73, 0x5f77, 0x5f83, 0x5f82, 0x5f7f, 0x5f8a, 0x5f88
},

/* Row 0x055 */
{
/* 00 */ 0x5f91, 0x5f87, 0x5f9e, 0x5f99, 0x5f98, 0x5fa0, 0x5fa8, 0x5fad,
/* 08 */ 0x5fbc, 0x5fd6, 0x5ffb, 0x5fe4, 0x5ff8, 0x5ff1, 0x5fdd, 0x60b3,
/* 10 */ 0x5fff, 0x6021, 0x6060, 0x6019, 0x6010, 0x6029, 0x600e, 0x6031,
/* 18 */ 0x601b, 0x6015, 0x602b, 0x6026, 0x600f, 0x603a, 0x605a, 0x6041,
/* 20 */ 0x606a, 0x6077, 0x605f, 0x604a, 0x6046, 0x604d, 0x6063, 0x6043,
/* 28 */ 0x6064, 0x6042, 0x606c, 0x606b, 0x6059, 0x6081, 0x608d, 0x60e7,
/* 30 */ 0x6083, 0x609a, 0x6084, 0x609b, 0x6096, 0x6097, 0x6092, 0x60a7,
/* 38 */ 0x608b, 0x60e1, 0x60b8, 0x60e0, 0x60d3, 0x60b4, 0x5ff0, 0x60bd
},

/* Row 0x056 */
{
/* 00 */ 0x60c6, 0x60b5, 0x60d8, 0x614d, 0x6115, 0x6106, 0x60f6, 0x60f7,
/* 08 */ 0x6100, 0x60f4, 0x60fa, 0x6103, 0x6121, 0x60fb, 0x60f1, 0x610d,
/* 10 */ 0x610e, 0x6147, 0x613e, 0x6128, 0x6127, 0x614a, 0x613f, 0x613c,
/* 18 */ 0x612c, 0x6134, 0x613d, 0x6142, 0x6144, 0x6173, 0x6177, 0x6158,
/* 20 */ 0x6159, 0x615a, 0x616b, 0x6174, 0x616f, 0x6165, 0x6171, 0x615f,
/* 28 */ 0x615d, 0x6153, 0x6175, 0x6199, 0x6196, 0x6187, 0x61ac, 0x6194,
/* 30 */ 0x619a, 0x618a, 0x6191, 0x61ab, 0x61ae, 0x61cc, 0x61ca, 0x61c9,
/* 38 */ 0x61f7, 0x61c8, 0x61c3, 0x61c6, 0x61ba, 0x61cb, 0x7f79, 0x61cd
},

/* Row 0x057 */
{
/* 00 */ 0x61e6, 0x61e3, 0x61f6, 0x61fa, 0x61f4, 0x61ff, 0x61fd, 0x61fc,
/* 08 */ 0x61fe, 0x6200, 0x6208, 0x6209, 0x620d, 0x620c, 0x6214, 0x621b,
/* 10 */ 0x621e, 0x6221, 0x622a, 0x622e, 0x6230, 0x6232, 0x6233, 0x6241,
/* 18 */ 0x624e, 0x625e, 0x6263, 0x625b, 0x6260, 0x6268, 0x627c, 0x6282,
/* 20 */ 0x6289, 0x627e, 0x6292, 0x6293, 0x6296, 0x62d4, 0x6283, 0x6294,
/* 28 */ 0x62d7, 0x62d1, 0x62bb, 0x62cf, 0x62ff, 0x62c6, 0x64d4, 0x62c8,
/* 30 */ 0x62dc, 0x62cc, 0x62ca, 0x62c2, 0x62c7, 0x629b, 0x62c9, 0x630c,
/* 38 */ 0x62ee, 0x62f1, 0x6327, 0x6302, 0x6308, 0x62ef, 0x62f5, 0x6350
},

/* Row 0x058 */
{
/* 00 */ 0x633e, 0x634d, 0x641c, 0x634f, 0x6396, 0x638e, 0x6380, 0x63ab,
/* 08 */ 0x6376, 0x63a3, 0x638f, 0x6389, 0x639f, 0x63b5, 0x636b, 0x6369,
/* 10 */ 0x63be, 0x63e9, 0x63c0, 0x63c6, 0x63e3, 0x63c9, 0x63d2, 0x63f6,
/* 18 */ 0x63c4, 0x6416, 0x6434, 0x6406, 0x6413, 0x6426, 0x6436, 0x651d,
/* 20 */ 0x6417, 0x6428, 0x640f, 0x6467, 0x646f, 0x6476, 0x644e, 0x652a,
/* 28 */ 0x6495, 0x6493, 0x64a5, 0x64a9, 0x6488, 0x64bc, 0x64da, 0x64d2,
/* 30 */ 0x64c5, 0x64c7, 0x64bb, 0x64d8, 0x64c2, 0x64f1, 0x64e7, 0x8209,
/* 38 */ 0x64e0, 0x64e1, 0x62ac, 0x64e3, 0x64ef, 0x652c, 0x64f6, 0x64f4
},

/* Row 0x059 */
{
/* 00 */ 0x64f2, 0x64fa, 0x6500, 0x64fd, 0x6518, 0x651c, 0x6505, 0x6524,
/* 08 */ 0x6523, 0x652b, 0x6534, 0x6535, 0x6537, 0x6536, 0x6538, 0x754b,
/* 10 */ 0x6548, 0x6556, 0x6555, 0x654d, 0x6558, 0x655e, 0x655d, 0x6572,
/* 18 */ 0x6578, 0x6582, 0x6583, 0x8b8a, 0x659b, 0x659f, 0x65ab, 0x65b7,
/* 20 */ 0x65c3, 0x65c6, 0x65c1, 0x65c4, 0x65cc, 0x65d2, 0x65db, 0x65d9,
/* 28 */ 0x65e0, 0x65e1, 0x65f1, 0x6772, 0x660a, 0x6603, 0x65fb, 0x6773,
/* 30 */ 0x6635, 0x6636, 0x6634, 0x661c, 0x664f, 0x6644, 0x6649, 0x6641,
/* 38 */ 0x665e, 0x665d, 0x6664, 0x6667, 0x6668, 0x665f, 0x6662, 0x6670
},

/* Row 0x05a */
{
/* 00 */ 0x6683, 0x6688, 0x668e, 0x6689, 0x6684, 0x6698, 0x669d, 0x66c1,
/* 08 */ 0x66b9, 0x66c9, 0x66be, 0x66bc, 0x66c4, 0x66b8, 0x66d6, 0x66da,
/* 10 */ 0x66e0, 0x663f, 0x66e6, 0x66e9, 0x66f0, 0x66f5, 0x66f7, 0x670f,
/* 18 */ 0x6716, 0x671e, 0x6726, 0x6727, 0x9738, 0x672e, 0x673f, 0x6736,
/* 20 */ 0x6741, 0x6738, 0x6737, 0x6746, 0x675e, 0x6760, 0x6759, 0x6763,
/* 28 */ 0x6764, 0x6789, 0x6770, 0x67a9, 0x677c, 0x676a, 0x678c, 0x678b,
/* 30 */ 0x67a6, 0x67a1, 0x6785, 0x67b7, 0x67ef, 0x67b4, 0x67ec, 0x67b3,
/* 38 */ 0x67e9, 0x67b8, 0x67e4, 0x67de, 0x67dd, 0x67e2, 0x67ee, 0x67b9
},

/* Row 0x05b */
{
/* 00 */ 0x67ce, 0x67c6, 0x67e7, 0x6a9c, 0x681e, 0x6846, 0x6829, 0x6840,
/* 08 */ 0x684d, 0x6832, 0x684e, 0x68b3, 0x682b, 0x6859, 0x6863, 0x6877,
/* 10 */ 0x687f, 0x689f, 0x688f, 0x68ad, 0x6894, 0x689d, 0x689b, 0x6883,
/* 18 */ 0x6aae, 0x68b9, 0x6874, 0x68b5, 0x68a0, 0x68ba, 0x690f, 0x688d,
/* 20 */ 0x687e, 0x6901, 0x68ca, 0x6908, 0x68d8, 0x6922, 0x6926, 0x68e1,
/* 28 */ 0x690c, 0x68cd, 0x68d4, 0x68e7, 0x68d5, 0x6936, 0x6912, 0x6904,
/* 30 */ 0x68d7, 0x68e3, 0x6925, 0x68f9, 0x68e0, 0x68ef, 0x6928, 0x692a,
/* 38 */ 0x691a, 0x6923, 0x6921, 0x68c6, 0x6979, 0x6977, 0x695c, 0x6978
},

/* Row 0x05c */
{
/* 00 */ 0x696b, 0x6954, 0x697e, 0x696e, 0x6939, 0x6974, 0x693d, 0x6959,
/* 08 */ 0x6930, 0x6961, 0x695e, 0x695d, 0x6981, 0x696a, 0x69b2, 0x69ae,
/* 10 */ 0x69d0, 0x69bf, 0x69c1, 0x69d3, 0x69be, 0x69ce, 0x5be8, 0x69ca,
/* 18 */ 0x69dd, 0x69bb, 0x69c3, 0x69a7, 0x6a2e, 0x6991, 0x69a0, 0x699c,
/* 20 */ 0x6995, 0x69b4, 0x69de, 0x69e8, 0x6a02, 0x6a1b, 0x69ff, 0x6b0a,
/* 28 */ 0x69f9, 0x69f2, 0x69e7, 0x6a05, 0x69b1, 0x6a1e, 0x69ed, 0x6a14,
/* 30 */ 0x69eb, 0x6a0a, 0x6a12, 0x6ac1, 0x6a23, 0x6a13, 0x6a44, 0x6a0c,
/* 38 */ 0x6a72, 0x6a36, 0x6a78, 0x6a47, 0x6a62, 0x6a59, 0x6a66, 0x6a48
},

/* Row 0x05d */
{
/* 00 */ 0x6a38, 0x6a22, 0x6a90, 0x6a8d, 0x6aa0, 0x6a84, 0x6aa2, 0x6aa3,
/* 08 */ 0x6a97, 0x8617, 0x6abb, 0x6ac3, 0x6ac2, 0x6ab8, 0x6ab3, 0x6aac,
/* 10 */ 0x6ade, 0x6ad1, 0x6adf, 0x6aaa, 0x6ada, 0x6aea, 0x6afb, 0x6b05,
/* 18 */ 0x8616, 0x6afa, 0x6b12, 0x6b16, 0x9b31, 0x6b1f, 0x6b38, 0x6b37,
/* 20 */ 0x76dc, 0x6b39, 0x98ee, 0x6b47, 0x6b43, 0x6b49, 0x6b50, 0x6b59,
/* 28 */ 0x6b54, 0x6b5b, 0x6b5f, 0x6b61, 0x6b78, 0x6b79, 0x6b7f, 0x6b80,
/* 30 */ 0x6b84, 0x6b83, 0x6b8d, 0x6b98, 0x6b95, 0x6b9e, 0x6ba4, 0x6baa,
/* 38 */ 0x6bab, 0x6baf, 0x6bb2, 0x6bb1, 0x6bb3, 0x6bb7, 0x6bbc, 0x6bc6
},

/* Row 0x05e */
{
/* 00 */ 0x6bcb, 0x6bd3, 0x6bdf, 0x6bec, 0x6beb, 0x6bf3, 0x6bef, 0x9ebe,
/* 08 */ 0x6c08, 0x6c13, 0x6c14, 0x6c1b, 0x6c24, 0x6c23, 0x6c5e, 0x6c55,
/* 10 */ 0x6c62, 0x6c6a, 0x6c82, 0x6c8d, 0x6c9a, 0x6c81, 0x6c9b, 0x6c7e,
/* 18 */ 0x6c68, 0x6c73, 0x6c92, 0x6c90, 0x6cc4, 0x6cf1, 0x6cd3, 0x6cbd,
/* 20 */ 0x6cd7, 0x6cc5, 0x6cdd, 0x6cae, 0x6cb1, 0x6cbe, 0x6cba, 0x6cdb,
/* 28 */ 0x6cef, 0x6cd9, 0x6cea, 0x6d1f, 0x884d, 0x6d36, 0x6d2b, 0x6d3d,
/* 30 */ 0x6d38, 0x6d19, 0x6d35, 0x6d33, 0x6d12, 0x6d0c, 0x6d63, 0x6d93,
/* 38 */ 0x6d64, 0x6d5a, 0x6d79, 0x6d59, 0x6d8e, 0x6d95, 0x6fe4, 0x6d85
},

/* Row 0x05f */
{
/* 00 */ 0x6df9, 0x6e15, 0x6e0a, 0x6db5, 0x6dc7, 0x6de6, 0x6db8, 0x6dc6,
/* 08 */ 0x6dec, 0x6dde, 0x6dcc, 0x6de8, 0x6dd2, 0x6dc5, 0x6dfa, 0x6dd9,
/* 10 */ 0x6de4, 0x6dd5, 0x6dea, 0x6dee, 0x6e2d, 0x6e6e, 0x6e2e, 0x6e19,
/* 18 */ 0x6e72, 0x6e5f, 0x6e3e, 0x6e23, 0x6e6b, 0x6e2b, 0x6e76, 0x6e4d,
/* 20 */ 0x6e1f, 0x6e43, 0x6e3a, 0x6e4e, 0x6e24, 0x6eff, 0x6e1d, 0x6e38,
/* 28 */ 0x6e82, 0x6eaa, 0x6e98, 0x6ec9, 0x6eb7, 0x6ed3, 0x6ebd, 0x6eaf,
/* 30 */ 0x6ec4, 0x6eb2, 0x6ed4, 0x6ed5, 0x6e8f, 0x6ea5, 0x6ec2, 0x6e9f,
/* 38 */ 0x6f41, 0x6f11, 0x704c, 0x6eec, 0x6ef8, 0x6efe, 0x6f3f, 0x6ef2
},

/* Row 0x060 */
{
/* 00 */ 0x6f31, 0x6eef, 0x6f32, 0x6ecc,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x061 */
{
/* 00 */ 0x6f3e, 0x6f13, 0x6ef7, 0x6f86, 0x6f7a, 0x6f78, 0x6f81, 0x6f80,
/* 08 */ 0x6f6f, 0x6f5b, 0x6ff3, 0x6f6d, 0x6f82, 0x6f7c, 0x6f58, 0x6f8e,
/* 10 */ 0x6f91, 0x6fc2, 0x6f66, 0x6fb3, 0x6fa3, 0x6fa1, 0x6fa4, 0x6fb9,
/* 18 */ 0x6fc6, 0x6faa, 0x6fdf, 0x6fd5, 0x6fec, 0x6fd4, 0x6fd8, 0x6ff1,
/* 20 */ 0x6fee, 0x6fdb, 0x7009, 0x700b, 0x6ffa, 0x7011, 0x7001, 0x700f,
/* 28 */ 0x6ffe, 0x701b, 0x701a, 0x6f74, 0x701d, 0x7018, 0x701f, 0x7030,
/* 30 */ 0x703e, 0x7032, 0x7051, 0x7063, 0x7099, 0x7092, 0x70af, 0x70f1,
/* 38 */ 0x70ac, 0x70b8, 0x70b3, 0x70ae, 0x70df, 0x70cb, 0x70dd, 0x70d9
},

/* Row 0x062 */
{
/* 00 */ 0x7109, 0x70fd, 0x711c, 0x7119, 0x7165, 0x7155, 0x7188, 0x7166,
/* 08 */ 0x7162, 0x714c, 0x7156, 0x716c, 0x718f, 0x71fb, 0x7184, 0x7195,
/* 10 */ 0x71a8, 0x71ac, 0x71d7, 0x71b9, 0x71be, 0x71d2, 0x71c9, 0x71d4,
/* 18 */ 0x71ce, 0x71e0, 0x71ec, 0x71e7, 0x71f5, 0x71fc, 0x71f9, 0x71ff,
/* 20 */ 0x720d, 0x7210, 0x721b, 0x7228, 0x722d, 0x722c, 0x7230, 0x7232,
/* 28 */ 0x723b, 0x723c, 0x723f, 0x7240, 0x7246, 0x724b, 0x7258, 0x7274,
/* 30 */ 0x727e, 0x7282, 0x7281, 0x7287, 0x7292, 0x7296, 0x72a2, 0x72a7,
/* 38 */ 0x72b9, 0x72b2, 0x72c3, 0x72c6, 0x72c4, 0x72ce, 0x72d2, 0x72e2
},

/* Row 0x063 */
{
/* 00 */ 0x72e0, 0x72e1, 0x72f9, 0x72f7, 0x500f, 0x7317, 0x730a, 0x731c,
/* 08 */ 0x7316, 0x731d, 0x7334, 0x732f, 0x7329, 0x7325, 0x733e, 0x734e,
/* 10 */ 0x734f, 0x9ed8, 0x7357, 0x736a, 0x7368, 0x7370, 0x7378, 0x7375,
/* 18 */ 0x737b, 0x737a, 0x73c8, 0x73b3, 0x73ce, 0x73bb, 0x73c0, 0x73e5,
/* 20 */ 0x73ee, 0x73de, 0x74a2, 0x7405, 0x746f, 0x7425, 0x73f8, 0x7432,
/* 28 */ 0x743a, 0x7455, 0x743f, 0x745f, 0x7459, 0x7441, 0x745c, 0x7469,
/* 30 */ 0x7470, 0x7463, 0x746a, 0x7476, 0x747e, 0x748b, 0x749e, 0x74a7,
/* 38 */ 0x74ca, 0x74cf, 0x74d4, 0x73f1, 0x74e0, 0x74e3, 0x74e7, 0x74e9
},

/* Row 0x064 */
{
/* 00 */ 0x74ee, 0x74f2, 0x74f0, 0x74f1, 0x74f8, 0x74f7, 0x7504, 0x7503,
/* 08 */ 0x7505, 0x750c, 0x750e, 0x750d, 0x7515, 0x7513, 0x751e, 0x7526,
/* 10 */ 0x752c, 0x753c, 0x7544, 0x754d, 0x754a, 0x7549, 0x755b, 0x7546,
/* 18 */ 0x755a, 0x7569, 0x7564, 0x7567, 0x756b, 0x756d, 0x7578, 0x7576,
/* 20 */ 0x7586, 0x7587, 0x7574, 0x758a, 0x7589, 0x7582, 0x7594, 0x759a,
/* 28 */ 0x759d, 0x75a5, 0x75a3, 0x75c2, 0x75b3, 0x75c3, 0x75b5, 0x75bd,
/* 30 */ 0x75b8, 0x75bc, 0x75b1, 0x75cd, 0x75ca, 0x75d2, 0x75d9, 0x75e3,
/* 38 */ 0x75de, 0x75fe, 0x75ff, 0x75fc, 0x7601, 0x75f0, 0x75fa, 0x75f2
},

/* Row 0x065 */
{
/* 00 */ 0x75f3, 0x760b, 0x760d, 0x7609, 0x761f, 0x7627, 0x7620, 0x7621,
/* 08 */ 0x7622, 0x7624, 0x7634, 0x7630, 0x763b, 0x7647, 0x7648, 0x7646,
/* 10 */ 0x765c, 0x7658, 0x7661, 0x7662, 0x7668, 0x7669, 0x766a, 0x7667,
/* 18 */ 0x766c, 0x7670, 0x7672, 0x7676, 0x7678, 0x767c, 0x7680, 0x7683,
/* 20 */ 0x7688, 0x768b, 0x768e, 0x7696, 0x7693, 0x7699, 0x769a, 0x76b0,
/* 28 */ 0x76b4, 0x76b8, 0x76b9, 0x76ba, 0x76c2, 0x76cd, 0x76d6, 0x76d2,
/* 30 */ 0x76de, 0x76e1, 0x76e5, 0x76e7, 0x76ea, 0x862f, 0x76fb, 0x7708,
/* 38 */ 0x7707, 0x7704, 0x7729, 0x7724, 0x771e, 0x7725, 0x7726, 0x771b
},

/* Row 0x066 */
{
/* 00 */ 0x7737, 0x7738, 0x7747, 0x775a, 0x7768, 0x776b, 0x775b, 0x7765,
/* 08 */ 0x777f, 0x777e, 0x7779, 0x778e, 0x778b, 0x7791, 0x77a0, 0x779e,
/* 10 */ 0x77b0, 0x77b6, 0x77b9, 0x77bf, 0x77bc, 0x77bd, 0x77bb, 0x77c7,
/* 18 */ 0x77cd, 0x77d7, 0x77da, 0x77dc, 0x77e3, 0x77ee, 0x77fc, 0x780c,
/* 20 */ 0x7812, 0x7926, 0x7820, 0x792a, 0x7845, 0x788e, 0x7874, 0x7886,
/* 28 */ 0x787c, 0x789a, 0x788c, 0x78a3, 0x78b5, 0x78aa, 0x78af, 0x78d1,
/* 30 */ 0x78c6, 0x78cb, 0x78d4, 0x78be, 0x78bc, 0x78c5, 0x78ca, 0x78ec,
/* 38 */ 0x78e7, 0x78da, 0x78fd, 0x78f4, 0x7907, 0x7912, 0x7911, 0x7919
},

/* Row 0x067 */
{
/* 00 */ 0x792c, 0x792b, 0x7940, 0x7960, 0x7957, 0x795f, 0x795a, 0x7955,
/* 08 */ 0x7953, 0x797a, 0x797f, 0x798a, 0x799d, 0x79a7, 0x9f4b, 0x79aa,
/* 10 */ 0x79ae, 0x79b3, 0x79b9, 0x79ba, 0x79c9, 0x79d5, 0x79e7, 0x79ec,
/* 18 */ 0x79e1, 0x79e3, 0x7a08, 0x7a0d, 0x7a18, 0x7a19, 0x7a20, 0x7a1f,
/* 20 */ 0x7980, 0x7a31, 0x7a3b, 0x7a3e, 0x7a37, 0x7a43, 0x7a57, 0x7a49,
/* 28 */ 0x7a61, 0x7a62, 0x7a69, 0x9f9d, 0x7a70, 0x7a79, 0x7a7d, 0x7a88,
/* 30 */ 0x7a97, 0x7a95, 0x7a98, 0x7a96, 0x7aa9, 0x7ac8, 0x7ab0, 0x7ab6,
/* 38 */ 0x7ac5, 0x7ac4, 0x7abf, 0x9083, 0x7ac7, 0x7aca, 0x7acd, 0x7acf
},

/* Row 0x068 */
{
/* 00 */ 0x7ad5, 0x7ad3, 0x7ad9, 0x7ada, 0x7add, 0x7ae1, 0x7ae2, 0x7ae6,
/* 08 */ 0x7aed, 0x7af0, 0x7b02, 0x7b0f, 0x7b0a, 0x7b06, 0x7b33, 0x7b18,
/* 10 */ 0x7b19, 0x7b1e, 0x7b35, 0x7b28, 0x7b36, 0x7b50, 0x7b7a, 0x7b04,
/* 18 */ 0x7b4d, 0x7b0b, 0x7b4c, 0x7b45, 0x7b75, 0x7b65, 0x7b74, 0x7b67,
/* 20 */ 0x7b70, 0x7b71, 0x7b6c, 0x7b6e, 0x7b9d, 0x7b98, 0x7b9f, 0x7b8d,
/* 28 */ 0x7b9c, 0x7b9a, 0x7b8b, 0x7b92, 0x7b8f, 0x7b5d, 0x7b99, 0x7bcb,
/* 30 */ 0x7bc1, 0x7bcc, 0x7bcf, 0x7bb4, 0x7bc6, 0x7bdd, 0x7be9, 0x7c11,
/* 38 */ 0x7c14, 0x7be6, 0x7be5, 0x7c60, 0x7c00, 0x7c07, 0x7c13, 0x7bf3
},

/* Row 0x069 */
{
/* 00 */ 0x7bf7, 0x7c17, 0x7c0d, 0x7bf6, 0x7c23, 0x7c27, 0x7c2a, 0x7c1f,
/* 08 */ 0x7c37, 0x7c2b, 0x7c3d, 0x7c4c, 0x7c43, 0x7c54, 0x7c4f, 0x7c40,
/* 10 */ 0x7c50, 0x7c58, 0x7c5f, 0x7c64, 0x7c56, 0x7c65, 0x7c6c, 0x7c75,
/* 18 */ 0x7c83, 0x7c90, 0x7ca4, 0x7cad, 0x7ca2, 0x7cab, 0x7ca1, 0x7ca8,
/* 20 */ 0x7cb3, 0x7cb2, 0x7cb1, 0x7cae, 0x7cb9, 0x7cbd, 0x7cc0, 0x7cc5,
/* 28 */ 0x7cc2, 0x7cd8, 0x7cd2, 0x7cdc, 0x7ce2, 0x9b3b, 0x7cef, 0x7cf2,
/* 30 */ 0x7cf4, 0x7cf6, 0x7cfa, 0x7d06, 0x7d02, 0x7d1c, 0x7d15, 0x7d0a,
/* 38 */ 0x7d45, 0x7d4b, 0x7d2e, 0x7d32, 0x7d3f, 0x7d35, 0x7d46, 0x7d73
},

/* Row 0x06a */
{
/* 00 */ 0x7d56, 0x7d4e, 0x7d72, 0x7d68, 0x7d6e, 0x7d4f, 0x7d63, 0x7d93,
/* 08 */ 0x7d89, 0x7d5b, 0x7d8f, 0x7d7d, 0x7d9b, 0x7dba, 0x7dae, 0x7da3,
/* 10 */ 0x7db5, 0x7dc7, 0x7dbd, 0x7dab, 0x7e3d, 0x7da2, 0x7daf, 0x7ddc,
/* 18 */ 0x7db8, 0x7d9f, 0x7db0, 0x7dd8, 0x7ddd, 0x7de4, 0x7dde, 0x7dfb,
/* 20 */ 0x7df2, 0x7de1, 0x7e05, 0x7e0a, 0x7e23, 0x7e21, 0x7e12, 0x7e31,
/* 28 */ 0x7e1f, 0x7e09, 0x7e0b, 0x7e22, 0x7e46, 0x7e66, 0x7e3b, 0x7e35,
/* 30 */ 0x7e39, 0x7e43, 0x7e37, 0x7e32, 0x7e3a, 0x7e67, 0x7e5d, 0x7e56,
/* 38 */ 0x7e5e, 0x7e59, 0x7e5a, 0x7e79, 0x7e6a, 0x7e69, 0x7e7c, 0x7e7b
},

/* Row 0x06b */
{
/* 00 */ 0x7e83, 0x7dd5, 0x7e7d, 0x8fae, 0x7e7f, 0x7e88, 0x7e89, 0x7e8c,
/* 08 */ 0x7e92, 0x7e90, 0x7e93, 0x7e94, 0x7e96, 0x7e8e, 0x7e9b, 0x7e9c,
/* 10 */ 0x7f38, 0x7f3a, 0x7f45, 0x7f4c, 0x7f4d, 0x7f4e, 0x7f50, 0x7f51,
/* 18 */ 0x7f55, 0x7f54, 0x7f58, 0x7f5f, 0x7f60, 0x7f68, 0x7f69, 0x7f67,
/* 20 */ 0x7f78, 0x7f82, 0x7f86, 0x7f83, 0x7f88, 0x7f87, 0x7f8c, 0x7f94,
/* 28 */ 0x7f9e, 0x7f9d, 0x7f9a, 0x7fa3, 0x7faf, 0x7fb2, 0x7fb9, 0x7fae,
/* 30 */ 0x7fb6, 0x7fb8, 0x8b71, 0x7fc5, 0x7fc6, 0x7fca, 0x7fd5, 0x7fd4,
/* 38 */ 0x7fe1, 0x7fe6, 0x7fe9, 0x7ff3, 0x7ff9, 0x98dc, 0x8006, 0x8004
},

/* Row 0x06c */
{
/* 00 */ 0x800b, 0x8012, 0x8018, 0x8019, 0x801c, 0x8021, 0x8028, 0x803f,
/* 08 */ 0x803b, 0x804a, 0x8046, 0x8052, 0x8058, 0x805a, 0x805f, 0x8062,
/* 10 */ 0x8068, 0x8073, 0x8072, 0x8070, 0x8076, 0x8079, 0x807d, 0x807f,
/* 18 */ 0x8084, 0x8086, 0x8085, 0x809b, 0x8093, 0x809a, 0x80ad, 0x5190,
/* 20 */ 0x80ac, 0x80db, 0x80e5, 0x80d9, 0x80dd, 0x80c4, 0x80da, 0x80d6,
/* 28 */ 0x8109, 0x80ef, 0x80f1, 0x811b, 0x8129, 0x8123, 0x812f, 0x814b,
/* 30 */ 0x968b, 0x8146, 0x813e, 0x8153, 0x8151, 0x80fc, 0x8171, 0x816e,
/* 38 */ 0x8165, 0x8166, 0x8174, 0x8183, 0x8188, 0x818a, 0x8180, 0x8182
},

/* Row 0x06d */
{
/* 00 */ 0x81a0, 0x8195, 0x81a4, 0x81a3, 0x815f, 0x8193, 0x81a9, 0x81b0,
/* 08 */ 0x81b5, 0x81be, 0x81b8, 0x81bd, 0x81c0, 0x81c2, 0x81ba, 0x81c9,
/* 10 */ 0x81cd, 0x81d1, 0x81d9, 0x81d8, 0x81c8, 0x81da, 0x81df, 0x81e0,
/* 18 */ 0x81e7, 0x81fa, 0x81fb, 0x81fe, 0x8201, 0x8202, 0x8205, 0x8207,
/* 20 */ 0x820a, 0x820d, 0x8210, 0x8216, 0x8229, 0x822b, 0x8238, 0x8233,
/* 28 */ 0x8240, 0x8259, 0x8258, 0x825d, 0x825a, 0x825f, 0x8264, 0x8262,
/* 30 */ 0x8268, 0x826a, 0x826b, 0x822e, 0x8271, 0x8277, 0x8278, 0x827e,
/* 38 */ 0x828d, 0x8292, 0x82ab, 0x829f, 0x82bb, 0x82ac, 0x82e1, 0x82e3
},

/* Row 0x06e */
{
/* 00 */ 0x82df, 0x82d2, 0x82f4, 0x82f3, 0x82fa, 0x8393, 0x8303, 0x82fb,
/* 08 */ 0x82f9, 0x82de, 0x8306, 0x82dc, 0x8309, 0x82d9, 0x8335, 0x8334,
/* 10 */ 0x8316, 0x8332, 0x8331, 0x8340, 0x8339, 0x8350, 0x8345, 0x832f,
/* 18 */ 0x832b, 0x8317, 0x8318, 0x8385, 0x839a, 0x83aa, 0x839f, 0x83a2,
/* 20 */ 0x8396, 0x8323, 0x838e, 0x8387, 0x838a, 0x837c, 0x83b5, 0x8373,
/* 28 */ 0x8375, 0x83a0, 0x8389, 0x83a8, 0x83f4, 0x8413, 0x83eb, 0x83ce,
/* 30 */ 0x83fd, 0x8403, 0x83d8, 0x840b, 0x83c1, 0x83f7, 0x8407, 0x83e0,
/* 38 */ 0x83f2, 0x840d, 0x8422, 0x8420, 0x83bd, 0x8438, 0x8506, 0x83fb
},

/* Row 0x06f */
{
/* 00 */ 0x846d, 0x842a, 0x843c, 0x855a, 0x8484, 0x8477, 0x846b, 0x84ad,
/* 08 */ 0x846e, 0x8482, 0x8469, 0x8446, 0x842c, 0x846f, 0x8479, 0x8435,
/* 10 */ 0x84ca, 0x8462, 0x84b9, 0x84bf, 0x849f, 0x84d9, 0x84cd, 0x84bb,
/* 18 */ 0x84da, 0x84d0, 0x84c1, 0x84c6, 0x84d6, 0x84a1, 0x8521, 0x84ff,
/* 20 */ 0x84f4, 0x8517, 0x8518, 0x852c, 0x851f, 0x8515, 0x8514, 0x84fc,
/* 28 */ 0x8540, 0x8563, 0x8558, 0x8548, 0x8541, 0x8602, 0x854b, 0x8555,
/* 30 */ 0x8580, 0x85a4, 0x8588, 0x8591, 0x858a, 0x85a8, 0x856d, 0x8594,
/* 38 */ 0x859b, 0x85ea, 0x8587, 0x859c, 0x8577, 0x857e, 0x8590, 0x85c9
},

/* Row 0x070 */
{
/* 00 */ 0x85ba, 0x85cf, 0x85b9, 0x85d0, 0x85d5, 0x85dd, 0x85e5, 0x85dc,
/* 08 */ 0x85f9, 0x860a, 0x8613, 0x860b, 0x85fe, 0x85fa, 0x8606, 0x8622,
/* 10 */ 0x861a, 0x8630, 0x863f, 0x864d, 0x4e55, 0x8654, 0x865f, 0x8667,
/* 18 */ 0x8671, 0x8693, 0x86a3, 0x86a9, 0x86aa, 0x868b, 0x868c, 0x86b6,
/* 20 */ 0x86af, 0x86c4, 0x86c6, 0x86b0, 0x86c9, 0x8823, 0x86ab, 0x86d4,
/* 28 */ 0x86de, 0x86e9, 0x86ec, 0x86df, 0x86db, 0x86ef, 0x8712, 0x8706,
/* 30 */ 0x8708, 0x8700, 0x8703, 0x86fb, 0x8711, 0x8709, 0x870d, 0x86f9,
/* 38 */ 0x870a, 0x8734, 0x873f, 0x8737, 0x873b, 0x8725, 0x8729, 0x871a
},

/* Row 0x071 */
{
/* 00 */ 0x8760, 0x875f, 0x8778, 0x874c, 0x874e, 0x8774, 0x8757, 0x8768,
/* 08 */ 0x876e, 0x8759, 0x8753, 0x8763, 0x876a, 0x8805, 0x87a2, 0x879f,
/* 10 */ 0x8782, 0x87af, 0x87cb, 0x87bd, 0x87c0, 0x87d0, 0x96d6, 0x87ab,
/* 18 */ 0x87c4, 0x87b3, 0x87c7, 0x87c6, 0x87bb, 0x87ef, 0x87f2, 0x87e0,
/* 20 */ 0x880f, 0x880d, 0x87fe, 0x87f6, 0x87f7, 0x880e, 0x87d2, 0x8811,
/* 28 */ 0x8816, 0x8815, 0x8822, 0x8821, 0x8831, 0x8836, 0x8839, 0x8827,
/* 30 */ 0x883b, 0x8844, 0x8842, 0x8852, 0x8859, 0x885e, 0x8862, 0x886b,
/* 38 */ 0x8881, 0x887e, 0x889e, 0x8875, 0x887d, 0x88b5, 0x8872, 0x8882
},

/* Row 0x072 */
{
/* 00 */ 0x8897, 0x8892, 0x88ae, 0x8899, 0x88a2, 0x888d, 0x88a4, 0x88b0,
/* 08 */ 0x88bf, 0x88b1, 0x88c3, 0x88c4, 0x88d4, 0x88d8, 0x88d9, 0x88dd,
/* 10 */ 0x88f9, 0x8902, 0x88fc, 0x88f4, 0x88e8, 0x88f2, 0x8904, 0x890c,
/* 18 */ 0x890a, 0x8913, 0x8943, 0x891e, 0x8925, 0x892a, 0x892b, 0x8941,
/* 20 */ 0x8944, 0x893b, 0x8936, 0x8938, 0x894c, 0x891d, 0x8960, 0x895e,
/* 28 */ 0x8966, 0x8964, 0x896d, 0x896a, 0x896f, 0x8974, 0x8977, 0x897e,
/* 30 */ 0x8983, 0x8988, 0x898a, 0x8993, 0x8998, 0x89a1, 0x89a9, 0x89a6,
/* 38 */ 0x89ac, 0x89af, 0x89b2, 0x89ba, 0x89bd, 0x89bf, 0x89c0, 0x89da
},

/* Row 0x073 */
{
/* 00 */ 0x89dc, 0x89dd, 0x89e7, 0x89f4, 0x89f8, 0x8a03, 0x8a16, 0x8a10,
/* 08 */ 0x8a0c, 0x8a1b, 0x8a1d, 0x8a25, 0x8a36, 0x8a41, 0x8a5b, 0x8a52,
/* 10 */ 0x8a46, 0x8a48, 0x8a7c, 0x8a6d, 0x8a6c, 0x8a62, 0x8a85, 0x8a82,
/* 18 */ 0x8a84, 0x8aa8, 0x8aa1, 0x8a91, 0x8aa5, 0x8aa6, 0x8a9a, 0x8aa3,
/* 20 */ 0x8ac4, 0x8acd, 0x8ac2, 0x8ada, 0x8aeb, 0x8af3, 0x8ae7, 0x8ae4,
/* 28 */ 0x8af1, 0x8b14, 0x8ae0, 0x8ae2, 0x8af7, 0x8ade, 0x8adb, 0x8b0c,
/* 30 */ 0x8b07, 0x8b1a, 0x8ae1, 0x8b16, 0x8b10, 0x8b17, 0x8b20, 0x8b33,
/* 38 */ 0x97ab, 0x8b26, 0x8b2b, 0x8b3e, 0x8b28, 0x8b41, 0x8b4c, 0x8b4f
},

/* Row 0x074 */
{
/* 00 */ 0x8b4e, 0x8b49, 0x8b56, 0x8b5b, 0x8b5a, 0x8b6b, 0x8b5f, 0x8b6c,
/* 08 */ 0x8b6f, 0x8b74, 0x8b7d, 0x8b80, 0x8b8c, 0x8b8e, 0x8b92, 0x8b93,
/* 10 */ 0x8b96, 0x8b99, 0x8b9a, 0x8c3a, 0x8c41, 0x8c3f, 0x8c48, 0x8c4c,
/* 18 */ 0x8c4e, 0x8c50, 0x8c55, 0x8c62, 0x8c6c, 0x8c78, 0x8c7a, 0x8c82,
/* 20 */ 0x8c89, 0x8c85, 0x8c8a, 0x8c8d, 0x8c8e, 0x8c94, 0x8c7c, 0x8c98,
/* 28 */ 0x621d, 0x8cad, 0x8caa, 0x8cbd, 0x8cb2, 0x8cb3, 0x8cae, 0x8cb6,
/* 30 */ 0x8cc8, 0x8cc1, 0x8ce4, 0x8ce3, 0x8cda, 0x8cfd, 0x8cfa, 0x8cfb,
/* 38 */ 0x8d04, 0x8d05, 0x8d0a, 0x8d07, 0x8d0f, 0x8d0d, 0x8d10, 0x9f4e
},

/* Row 0x075 */
{
/* 00 */ 0x8d13, 0x8ccd, 0x8d14, 0x8d16, 0x8d67, 0x8d6d, 0x8d71, 0x8d73,
/* 08 */ 0x8d81, 0x8d99, 0x8dc2, 0x8dbe, 0x8dba, 0x8dcf, 0x8dda, 0x8dd6,
/* 10 */ 0x8dcc, 0x8ddb, 0x8dcb, 0x8dea, 0x8deb, 0x8ddf, 0x8de3, 0x8dfc,
/* 18 */ 0x8e08, 0x8e09, 0x8dff, 0x8e1d, 0x8e1e, 0x8e10, 0x8e1f, 0x8e42,
/* 20 */ 0x8e35, 0x8e30, 0x8e34, 0x8e4a, 0x8e47, 0x8e49, 0x8e4c, 0x8e50,
/* 28 */ 0x8e48, 0x8e59, 0x8e64, 0x8e60, 0x8e2a, 0x8e63, 0x8e55, 0x8e76,
/* 30 */ 0x8e72, 0x8e7c, 0x8e81, 0x8e87, 0x8e85, 0x8e84, 0x8e8b, 0x8e8a,
/* 38 */ 0x8e93, 0x8e91, 0x8e94, 0x8e99, 0x8eaa, 0x8ea1, 0x8eac, 0x8eb0
},

/* Row 0x076 */
{
/* 00 */ 0x8ec6, 0x8eb1, 0x8ebe, 0x8ec5, 0x8ec8, 0x8ecb, 0x8edb, 0x8ee3,
/* 08 */ 0x8efc, 0x8efb, 0x8eeb, 0x8efe, 0x8f0a, 0x8f05, 0x8f15, 0x8f12,
/* 10 */ 0x8f19, 0x8f13, 0x8f1c, 0x8f1f, 0x8f1b, 0x8f0c, 0x8f26, 0x8f33,
/* 18 */ 0x8f3b, 0x8f39, 0x8f45, 0x8f42, 0x8f3e, 0x8f4c, 0x8f49, 0x8f46,
/* 20 */ 0x8f4e, 0x8f57, 0x8f5c, 0x8f62, 0x8f63, 0x8f64, 0x8f9c, 0x8f9f,
/* 28 */ 0x8fa3, 0x8fad, 0x8faf, 0x8fb7, 0x8fda, 0x8fe5, 0x8fe2, 0x8fea,
/* 30 */ 0x8fef, 0x9087, 0x8ff4, 0x9005, 0x8ff9, 0x8ffa, 0x9011, 0x9015,
/* 38 */ 0x9021, 0x900d, 0x901e, 0x9016, 0x900b, 0x9027, 0x9036, 0x9035
},

/* Row 0x077 */
{
/* 00 */ 0x9039, 0x8ff8, 0x904f, 0x9050, 0x9051, 0x9052, 0x900e, 0x9049,
/* 08 */ 0x903e, 0x9056, 0x9058, 0x905e, 0x9068, 0x906f, 0x9076, 0x96a8,
/* 10 */ 0x9072, 0x9082, 0x907d, 0x9081, 0x9080, 0x908a, 0x9089, 0x908f,
/* 18 */ 0x90a8, 0x90af, 0x90b1, 0x90b5, 0x90e2, 0x90e4, 0x6248, 0x90db,
/* 20 */ 0x9102, 0x9112, 0x9119, 0x9132, 0x9130, 0x914a, 0x9156, 0x9158,
/* 28 */ 0x9163, 0x9165, 0x9169, 0x9173, 0x9172, 0x918b, 0x9189, 0x9182,
/* 30 */ 0x91a2, 0x91ab, 0x91af, 0x91aa, 0x91b5, 0x91b4, 0x91ba, 0x91c0,
/* 38 */ 0x91c1, 0x91c9, 0x91cb, 0x91d0, 0x91d6, 0x91df, 0x91e1, 0x91db
},

/* Row 0x078 */
{
/* 00 */ 0x91fc, 0x91f5, 0x91f6, 0x921e, 0x91ff, 0x9214, 0x922c, 0x9215,
/* 08 */ 0x9211, 0x925e, 0x9257, 0x9245, 0x9249, 0x9264, 0x9248, 0x9295,
/* 10 */ 0x923f, 0x924b, 0x9250, 0x929c, 0x9296, 0x9293, 0x929b, 0x925a,
/* 18 */ 0x92cf, 0x92b9, 0x92b7, 0x92e9, 0x930f, 0x92fa, 0x9344, 0x932e,
/* 20 */ 0x9319, 0x9322, 0x931a, 0x9323, 0x933a, 0x9335, 0x933b, 0x935c,
/* 28 */ 0x9360, 0x937c, 0x936e, 0x9356, 0x93b0, 0x93ac, 0x93ad, 0x9394,
/* 30 */ 0x93b9, 0x93d6, 0x93d7, 0x93e8, 0x93e5, 0x93d8, 0x93c3, 0x93dd,
/* 38 */ 0x93d0, 0x93c8, 0x93e4, 0x941a, 0x9414, 0x9413, 0x9403, 0x9407
},

/* Row 0x079 */
{
/* 00 */ 0x9410, 0x9436, 0x942b, 0x9435, 0x9421, 0x943a, 0x9441, 0x9452,
/* 08 */ 0x9444, 0x945b, 0x9460, 0x9462, 0x945e, 0x946a, 0x9229, 0x9470,
/* 10 */ 0x9475, 0x9477, 0x947d, 0x945a, 0x947c, 0x947e, 0x9481, 0x947f,
/* 18 */ 0x9582, 0x9587, 0x958a, 0x9594, 0x9596, 0x9598, 0x9599, 0x95a0,
/* 20 */ 0x95a8, 0x95a7, 0x95ad, 0x95bc, 0x95bb, 0x95b9, 0x95be, 0x95ca,
/* 28 */ 0x6ff6, 0x95c3, 0x95cd, 0x95cc, 0x95d5, 0x95d4, 0x95d6, 0x95dc,
/* 30 */ 0x95e1, 0x95e5, 0x95e2, 0x9621, 0x9628, 0x962e, 0x962f, 0x9642,
/* 38 */ 0x964c, 0x964f, 0x964b, 0x9677, 0x965c, 0x965e, 0x965d, 0x965f
},

/* Row 0x07a */
{
/* 00 */ 0x9666, 0x9672, 0x966c, 0x968d, 0x9698, 0x9695, 0x9697, 0x96aa,
/* 08 */ 0x96a7, 0x96b1, 0x96b2, 0x96b0, 0x96b4, 0x96b6, 0x96b8, 0x96b9,
/* 10 */ 0x96ce, 0x96cb, 0x96c9, 0x96cd, 0x894d, 0x96dc, 0x970d, 0x96d5,
/* 18 */ 0x96f9, 0x9704, 0x9706, 0x9708, 0x9713, 0x970e, 0x9711, 0x970f,
/* 20 */ 0x9716, 0x9719, 0x9724, 0x972a, 0x9730, 0x9739, 0x973d, 0x973e,
/* 28 */ 0x9744, 0x9746, 0x9748, 0x9742, 0x9749, 0x975c, 0x9760, 0x9764,
/* 30 */ 0x9766, 0x9768, 0x52d2, 0x976b, 0x9771, 0x9779, 0x9785, 0x977c,
/* 38 */ 0x9781, 0x977a, 0x9786, 0x978b, 0x978f, 0x9790, 0x979c, 0x97a8
},

/* Row 0x07b */
{
/* 00 */ 0x97a6, 0x97a3, 0x97b3, 0x97b4, 0x97c3, 0x97c6, 0x97c8, 0x97cb,
/* 08 */ 0x97dc, 0x97ed, 0x9f4f, 0x97f2, 0x7adf, 0x97f6, 0x97f5, 0x980f,
/* 10 */ 0x980c, 0x9838, 0x9824, 0x9821, 0x9837, 0x983d, 0x9846, 0x984f,
/* 18 */ 0x984b, 0x986b, 0x986f, 0x9870, 0x9871, 0x9874, 0x9873, 0x98aa,
/* 20 */ 0x98af, 0x98b1, 0x98b6, 0x98c4, 0x98c3, 0x98c6, 0x98e9, 0x98eb,
/* 28 */ 0x9903, 0x9909, 0x9912, 0x9914, 0x9918, 0x9921, 0x991d, 0x991e,
/* 30 */ 0x9924, 0x9920, 0x992c, 0x992e, 0x993d, 0x993e, 0x9942, 0x9949,
/* 38 */ 0x9945, 0x9950, 0x994b, 0x9951, 0x9952, 0x994c, 0x9955, 0x9997
},

/* Row 0x07c */
{
/* 00 */ 0x9998, 0x99a5, 0x99ad, 0x99ae, 0x99bc, 0x99df, 0x99db, 0x99dd,
/* 08 */ 0x99d8, 0x99d1, 0x99ed, 0x99ee, 0x99f1, 0x99f2, 0x99fb, 0x99f8,
/* 10 */ 0x9a01, 0x9a0f, 0x9a05, 0x99e2, 0x9a19, 0x9a2b, 0x9a37, 0x9a45,
/* 18 */ 0x9a42, 0x9a40, 0x9a43, 0x9a3e, 0x9a55, 0x9a4d, 0x9a5b, 0x9a57,
/* 20 */ 0x9a5f, 0x9a62, 0x9a65, 0x9a64, 0x9a69, 0x9a6b, 0x9a6a, 0x9aad,
/* 28 */ 0x9ab0, 0x9abc, 0x9ac0, 0x9acf, 0x9ad1, 0x9ad3, 0x9ad4, 0x9ade,
/* 30 */ 0x9adf, 0x9ae2, 0x9ae3, 0x9ae6, 0x9aef, 0x9aeb, 0x9aee, 0x9af4,
/* 38 */ 0x9af1, 0x9af7, 0x9afb, 0x9b06, 0x9b18, 0x9b1a, 0x9b1f, 0x9b22
},

/* Row 0x07d */
{
/* 00 */ 0x9b23, 0x9b25, 0x9b27, 0x9b28, 0x9b29, 0x9b2a, 0x9b2e, 0x9b2f,
/* 08 */ 0x9b32, 0x9b44, 0x9b43, 0x9b4f, 0x9b4d, 0x9b4e, 0x9b51, 0x9b58,
/* 10 */ 0x9b74, 0x9b93, 0x9b83, 0x9b91, 0x9b96, 0x9b97, 0x9b9f, 0x9ba0,
/* 18 */ 0x9ba8, 0x9bb4, 0x9bc0, 0x9bca, 0x9bb9, 0x9bc6, 0x9bcf, 0x9bd1,
/* 20 */ 0x9bd2, 0x9be3, 0x9be2, 0x9be4, 0x9bd4, 0x9be1, 0x9c3a, 0x9bf2,
/* 28 */ 0x9bf1, 0x9bf0, 0x9c15, 0x9c14, 0x9c09, 0x9c13, 0x9c0c, 0x9c06,
/* 30 */ 0x9c08, 0x9c12, 0x9c0a, 0x9c04, 0x9c2e, 0x9c1b, 0x9c25, 0x9c24,
/* 38 */ 0x9c21, 0x9c30, 0x9c47, 0x9c32, 0x9c46, 0x9c3e, 0x9c5a, 0x9c60
},

/* Row 0x07e */
{
/* 00 */ 0x9c67, 0x9c76, 0x9c78, 0x9ce7, 0x9cec, 0x9cf0, 0x9d09, 0x9d08,
/* 08 */ 0x9ceb, 0x9d03, 0x9d06, 0x9d2a, 0x9d26, 0x9daf, 0x9d23, 0x9d1f,
/* 10 */ 0x9d44, 0x9d15, 0x9d12, 0x9d41, 0x9d3f, 0x9d3e, 0x9d46, 0x9d48,
/* 18 */ 0x9d5d, 0x9d5e, 0x9d64, 0x9d51, 0x9d50, 0x9d59, 0x9d72, 0x9d89,
/* 20 */ 0x9d87, 0x9dab, 0x9d6f, 0x9d7a, 0x9d9a, 0x9da4, 0x9da9, 0x9db2,
/* 28 */ 0x9dc4, 0x9dc1, 0x9dbb, 0x9db8, 0x9dba, 0x9dc6, 0x9dcf, 0x9dc2,
/* 30 */ 0x9dd9, 0x9dd3, 0x9df8, 0x9de6, 0x9ded, 0x9def, 0x9dfd, 0x9e1a,
/* 38 */ 0x9e1b, 0x9e1e, 0x9e75, 0x9e79, 0x9e7d, 0x9e81, 0x9e88, 0x9e8b
},

/* Row 0x07f */
{
/* 00 */ 0x9e8c, 0x9e92, 0x9e95, 0x9e91, 0x9e9d, 0x9ea5, 0x9ea9, 0x9eb8,
/* 08 */ 0x9eaa, 0x9ead, 0x9761, 0x9ecc, 0x9ece, 0x9ecf, 0x9ed0, 0x9ed4,
/* 10 */ 0x9edc, 0x9ede, 0x9edd, 0x9ee0, 0x9ee5, 0x9ee8, 0x9eef, 0x9ef4,
/* 18 */ 0x9ef6, 0x9ef7, 0x9ef9, 0x9efb, 0x9efc, 0x9efd, 0x9f07, 0x9f08,
/* 20 */ 0x76b7, 0x9f15, 0x9f21, 0x9f2c, 0x9f3e, 0x9f4a, 0x9f52, 0x9f54,
/* 28 */ 0x9f63, 0x9f5f, 0x9f60, 0x9f61, 0x9f66, 0x9f67, 0x9f6c, 0x9f6a,
/* 30 */ 0x9f77, 0x9f72, 0x9f76, 0x9f95, 0x9f9c, 0x9fa0, 0x582f, 0x69c7,
/* 38 */ 0x9059, 0x7464, 0x51dc, 0x7199, 0xf0d9, 0xf0da, 0xf0db, 0xf0dc
},

/* Row 0x080 */
{
/* 00 */ 0xf0dd, 0xf0de, 0xf0df, 0xf0e0, 0xf0e1, 0xf0e2, 0xf0e3, 0xf0e4,
/* 08 */ 0xf0e5, 0xf0e6, 0xf0e7, 0xf0e8, 0xf0e9, 0xf0ea, 0xf0eb, 0xf0ec,
/* 10 */ 0xf0ed, 0xf0ee, 0xf0ef, 0xf0f0, 0xf0f1, 0xf0f2, 0xf0f3, 0xf0f4,
/* 18 */ 0xf0f5, 0xf0f6, 0xf0f7, 0xf0f8, 0xf0f9, 0xf0fa, 0xf0fb, 0xf0fc,
/* 20 */ 0xf0fd, 0xf0fe, 0xf0ff, 0xf100, 0xf101, 0xf102, 0xf103, 0xf104,
/* 28 */ 0xf105, 0xf106, 0xf107, 0xf108, 0xf109, 0xf10a, 0xf10b, 0xf10c,
/* 30 */ 0xf10d, 0xf10e, 0xf10f, 0xf110, 0xf111, 0xf112, 0xf113, 0xf114,
/* 38 */ 0xf115, 0xf116, 0xf117, 0xf118, 0xf119, 0xf11a, 0xf11b, 0xf11c
},

/* Row 0x081 */
{
/* 00 */ 0xf11d, 0xf11e, 0xf11f, 0xf120, 0xf121, 0xf122, 0xf123, 0xf124,
/* 08 */ 0xf125, 0xf126, 0xf127, 0xf128, 0xf129, 0xf12a, 0xf12b, 0xf12c,
/* 10 */ 0xf12d, 0xf12e, 0xf12f, 0xf130,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x082 */
{
/* 00 */ 0x0080, 0x0081, 0x0082, 0x0083, 0x0084, 0x0085, 0x0086, 0x0087,
/* 08 */ 0x0088, 0x0089, 0x008a, 0x008b, 0x008c, 0x008d, 0x008e, 0x008f,
/* 10 */ 0x0090, 0x0091, 0x0092, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097,
/* 18 */ 0x0098, 0x0099, 0x009a, 0x009b, 0x009c, 0x009d, 0x009e, 0x009f,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x083 */
{
/* 00 */ 0xff1d, 0x2260, 0xff1c, 0xff1e, 0x2266, 0x2267, 0x221e, 0x2234,
/* 08 */ 0x2642, 0x2640, 0x00b0, 0x2032, 0x2033, 0x2103, 0xffe5, 0xff04,
/* 10 */ 0x00a2, 0x00a3, 0xff05, 0xff03, 0xff06, 0xff0a, 0xff20, 0x00a7,
/* 18 */ 0x2606, 0x2605, 0x25cb, 0x25cf, 0x25ce, 0x25c7, 0x25c6, 0x25a1,
/* 20 */ 0x25a0, 0x25b3, 0x25b2, 0x25bd, 0x25bc, 0x203b, 0x3012, 0x2192,
/* 28 */ 0x2190, 0x2191, 0x2193, 0x3013, 0xe9ea, 0xe9eb, 0xe9ec, 0xe9ed,
/* 30 */ 0xe9ee, 0xe9ef, 0xe9f0, 0xe9f1, 0xe9f2, 0xe9f3, 0xe9f4, 0x2208,
/* 38 */ 0x220b, 0x2286, 0x2287, 0x2282, 0x2283, 0x222a, 0x2229, 0xe9f5
},

/* Row 0x084 */
{
/* 00 */ 0xe9f6, 0xe9f7, 0xe9f8, 0xe9f9, 0xe9fa, 0xe9fb, 0xe9fc, 0x2227,
/* 08 */ 0x2228, 0x00ac, 0x21d2, 0x21d4, 0x2200, 0x2203, 0xe9fd, 0xe9fe,
/* 10 */ 0xe9ff, 0xea00, 0xea01, 0xea02, 0xea03, 0xea04, 0xea05, 0xea06,
/* 18 */ 0xea07, 0x2220, 0x22a5, 0x2312, 0x2202, 0x2207, 0x2261, 0x2252,
/* 20 */ 0x226a, 0x226b, 0x221a, 0x223d, 0x221d, 0x2235, 0x222b, 0x222c,
/* 28 */ 0xea08, 0xea09, 0xea0a, 0xea0b, 0xea0c, 0xea0d, 0xea0e, 0x212b,
/* 30 */ 0x2030, 0x266f, 0x266d, 0x266a, 0x2020, 0x2021, 0x00b6, 0xea0f,
/* 38 */ 0xea10, 0xea11, 0xea12, 0x25ef, 0xea13, 0xea14, 0xea15, 0xea16
},

/* Row 0x085 */
{
/* 00 */ 0xea17, 0xea18, 0xea19, 0xea1a, 0xea1b, 0xea1c, 0xea1d, 0xea1e,
/* 08 */ 0xea1f, 0xea20, 0xea21, 0xff10, 0xff11, 0xff12, 0xff13, 0xff14,
/* 10 */ 0xff15, 0xff16, 0xff17, 0xff18, 0xff19, 0xea22, 0xea23, 0xea24,
/* 18 */ 0xea25, 0xea26, 0xea27, 0xea28, 0xff21, 0xff22, 0xff23, 0xff24,
/* 20 */ 0xff25, 0xff26, 0xff27, 0xff28, 0xff29, 0xff2a, 0xff2b, 0xff2c,
/* 28 */ 0xff2d, 0xff2e, 0xff2f, 0xff30, 0xff31, 0xff32, 0xff33, 0xff34,
/* 30 */ 0xff35, 0xff36, 0xff37, 0xff38, 0xff39, 0xff3a, 0xea29, 0xea2a,
/* 38 */ 0xea2b, 0xea2c, 0xea2d, 0xea2e, 0xff41, 0xff42, 0xff43, 0xff44
},

/* Row 0x086 */
{
/* 00 */ 0xff45, 0xff46, 0xff47, 0xff48, 0xff49, 0xff4a, 0xff4b, 0xff4c,
/* 08 */ 0xff4d, 0xff4e, 0xff4f, 0xff50, 0xff51, 0xff52, 0xff53, 0xff54,
/* 10 */ 0xff55, 0xff56, 0xff57, 0xff58, 0xff59, 0xff5a, 0xea2f, 0xea30,
/* 18 */ 0xea31, 0xea32, 0x3041, 0x3042, 0x3043, 0x3044, 0x3045, 0x3046,
/* 20 */ 0x3047, 0x3048, 0x3049, 0x304a, 0x304b, 0x304c, 0x304d, 0x304e,
/* 28 */ 0x304f, 0x3050, 0x3051, 0x3052, 0x3053, 0x3054, 0x3055, 0x3056,
/* 30 */ 0x3057, 0x3058, 0x3059, 0x305a, 0x305b, 0x305c, 0x305d, 0x305e,
/* 38 */ 0x305f, 0x3060, 0x3061, 0x3062, 0x3063, 0x3064, 0x3065, 0x3066
},

/* Row 0x087 */
{
/* 00 */ 0x3067, 0x3068, 0x3069, 0x306a, 0x306b, 0x306c, 0x306d, 0x306e,
/* 08 */ 0x306f, 0x3070, 0x3071, 0x3072, 0x3073, 0x3074, 0x3075, 0x3076,
/* 10 */ 0x3077, 0x3078, 0x3079, 0x307a, 0x307b, 0x307c, 0x307d, 0x307e,
/* 18 */ 0x307f, 0x3080, 0x3081, 0x3082, 0x3083, 0x3084, 0x3085, 0x3086,
/* 20 */ 0x3087, 0x3088, 0x3089, 0x308a, 0x308b, 0x308c, 0x308d, 0x308e,
/* 28 */ 0x308f, 0x3090, 0x3091, 0x3092, 0x3093, 0xea33, 0xea34, 0xea35,
/* 30 */ 0xea36, 0xea37, 0xea38, 0xea39, 0xea3a, 0xea3b, 0xea3c, 0xea3d,
/* 38 */ 0x30a1, 0x30a2, 0x30a3, 0x30a4, 0x30a5, 0x30a6, 0x30a7, 0x30a8
},

/* Row 0x088 */
{
/* 00 */ 0x30e9, 0x30ea, 0x30eb, 0x30ec, 0x30ed, 0x30ee, 0x30ef, 0x30f0,
/* 08 */ 0x30f1, 0x30f2, 0x30f3, 0x30f4, 0x30f5, 0x30f6, 0xea3e, 0xea3f,
/* 10 */ 0xea40, 0xea41, 0xea42, 0xea43, 0xea44, 0xea45, 0x0391, 0x0392,
/* 18 */ 0x0393, 0x0394, 0x0395, 0x0396, 0x0397, 0x0398, 0x0399, 0x039a,
/* 20 */ 0x039b, 0x039c, 0x039d, 0x039e, 0x039f, 0x03a0, 0x03a1, 0x03a3,
/* 28 */ 0x03a4, 0x03a5, 0x03a6, 0x03a7, 0x03a8, 0x03a9, 0xea46, 0xea47,
/* 30 */ 0xea48, 0xea49, 0xea4a, 0xea4b, 0xea4c, 0xea4d, 0x03b1, 0x03b2,
/* 38 */ 0x03b3, 0x03b4, 0x03b5, 0x03b6, 0x03b7, 0x03b8, 0x03b9, 0x03ba
},

/* Row 0x089 */
{
/* 00 */ 0x03bb, 0x03bc, 0x03bd, 0x03be, 0x03bf, 0x03c0, 0x03c1, 0x03c3,
/* 08 */ 0x03c4, 0x03c5, 0x03c6, 0x03c7, 0x03c8, 0x03c9, 0xea4e, 0xea4f,
/* 10 */ 0xea50, 0xea51, 0xea52, 0xea53, 0xea54, 0xea55, 0xea56, 0xea57,
/* 18 */ 0xea58, 0xea59, 0xea5a, 0xea5b, 0xea5c, 0xea5d, 0xea5e, 0xea5f,
/* 20 */ 0xea60, 0xea61, 0xea62, 0xea63, 0xea64, 0xea65, 0xea66, 0xea67,
/* 28 */ 0xea68, 0xea69, 0xea6a, 0xea6b, 0xea6c, 0xea6d, 0xea6e, 0xea6f,
/* 30 */ 0xea70, 0xea71, 0xea72, 0xea73, 0x0410, 0x0411, 0x0412, 0x0413,
/* 38 */ 0x0414, 0x0415, 0x0401, 0x0416, 0x0417, 0x0418, 0x0419, 0x041a
},

/* Row 0x08a */
{
/* 00 */ 0x041b, 0x041c, 0x041d, 0x041e, 0x041f, 0x0420, 0x0421, 0x0422,
/* 08 */ 0x0423, 0x0424, 0x0425, 0x0426, 0x0427, 0x0428, 0x0429, 0x042a,
/* 10 */ 0x042b, 0x042c, 0x042d, 0x042e, 0x042f, 0xea74, 0xea75, 0xea76,
/* 18 */ 0xea77, 0xea78, 0xea79, 0xea7a, 0xea7b, 0xea7c, 0xea7d, 0xea7e,
/* 20 */ 0xea7f, 0xea80, 0xea81, 0xea82, 0x0430, 0x0431, 0x0432, 0x0433,
/* 28 */ 0x0434, 0x0435, 0x0451, 0x0436, 0x0437, 0x0438, 0x0439, 0x043a,
/* 30 */ 0x043b, 0x043c, 0x043d, 0x043e, 0x043f, 0x0440, 0x0441, 0x0442,
/* 38 */ 0x0443, 0x0444, 0x0445, 0x0446, 0x0447, 0x0448, 0x0449, 0x044a
},

/* Row 0x08b */
{
/* 00 */ 0x044b, 0x044c, 0x044d, 0x044e, 0x044f, 0xea83, 0xea84, 0xea85,
/* 08 */ 0xea86, 0xea87, 0xea88, 0xea89, 0xea8a, 0xea8b, 0xea8c, 0xea8d,
/* 10 */ 0xea8e, 0xea8f, 0x2500, 0x2502, 0x250c, 0x2510, 0x2518, 0x2514,
/* 18 */ 0x251c, 0x252c, 0x2524, 0x2534, 0x253c, 0x2501, 0x2503, 0x250f,
/* 20 */ 0x2513, 0x251b, 0x2517, 0x2523, 0x2533, 0x252b, 0x253b, 0x254b,
/* 28 */ 0x2520, 0x252f, 0x2528, 0x2537, 0x253f, 0x251d, 0x2530, 0x2525,
/* 30 */ 0x2538, 0x2542, 0xea90, 0xea91, 0xea92, 0xea93, 0xea94, 0xea95,
/* 38 */ 0xea96, 0xea97, 0xea98, 0xea99, 0xea9a, 0xea9b, 0xea9c, 0xea9d
},

/* Row 0x08c */
{
/* 00 */ 0xea9e, 0xea9f, 0xeaa0, 0xeaa1, 0xeaa2, 0xeaa3, 0xeaa4, 0xeaa5,
/* 08 */ 0xeaa6, 0xeaa7, 0xeaa8, 0xeaa9, 0xeaaa, 0xeaab, 0xeaac, 0xeaad,
/* 10 */ 0xeaae, 0xeaaf, 0xeab0, 0xeab1, 0xeab2, 0xeab3, 0xeab4, 0xeab5,
/* 18 */ 0xeab6, 0xeab7, 0xeab8, 0xeab9, 0xeaba, 0xeabb, 0xeabc, 0xeabd,
/* 20 */ 0xeabe, 0xeabf, 0xeac0, 0xeac1, 0xeac2, 0xeac3, 0xeac4, 0xeac5,
/* 28 */ 0xeac6, 0xeac7, 0xeac8, 0xeac9, 0xeaca, 0xeacb, 0xeacc, 0xeacd,
/* 30 */ 0xeace, 0xeacf, 0xead0, 0xead1, 0xead2, 0xead3, 0xead4, 0xead5,
/* 38 */ 0xead6, 0xead7, 0xead8, 0xead9, 0xeada, 0xeadb, 0xeadc, 0xeadd
},

/* Row 0x08d */
{
/* 00 */ 0xeade, 0xeadf, 0xeae0, 0xeae1, 0xeae2, 0xeae3, 0xeae4, 0xeae5,
/* 08 */ 0xeae6, 0xeae7, 0xeae8, 0xeae9, 0xeaea, 0xeaeb, 0xeaec, 0xeaed,
/* 10 */ 0xeaee, 0xeaef, 0xeaf0, 0xeaf1, 0xeaf2, 0xeaf3, 0xeaf4, 0xeaf5,
/* 18 */ 0xeaf6, 0xeaf7, 0xeaf8, 0xeaf9, 0xeafa, 0xeafb, 0xeafc, 0xeafd,
/* 20 */ 0xeafe, 0xeaff, 0xeb00, 0xeb01, 0xeb02, 0xeb03, 0xeb04, 0xeb05,
/* 28 */ 0xeb06, 0xeb07, 0xeb08, 0xeb09, 0xeb0a, 0xeb0b, 0xeb0c, 0xeb0d,
/* 30 */ 0xeb0e, 0xeb0f, 0xeb10, 0xeb11, 0xeb12, 0xeb13, 0xeb14, 0xeb15,
/* 38 */ 0xeb16, 0xeb17, 0xeb18, 0xeb19, 0xeb1a, 0xeb1b, 0xeb1c, 0xeb1d
},

/* Row 0x08e */
{
/* 00 */ 0xeb1e, 0xeb1f, 0xeb20, 0xeb21, 0xeb22, 0xeb23, 0xeb24, 0xeb25,
/* 08 */ 0xeb26, 0xeb27, 0xeb28, 0xeb29, 0xeb2a, 0xeb2b, 0xeb2c, 0xeb2d,
/* 10 */ 0xeb2e, 0xeb2f, 0xeb30, 0xeb31, 0xeb32, 0xeb33, 0xeb34, 0xeb35,
/* 18 */ 0xeb36, 0xeb37, 0xeb38, 0xeb39, 0xeb3a, 0xeb3b, 0xeb3c, 0xeb3d,
/* 20 */ 0xeb3e, 0xeb3f, 0xeb40, 0xeb41, 0xeb42, 0xeb43, 0xeb44, 0xeb45,
/* 28 */ 0xeb46, 0xeb47, 0xeb48, 0xeb49, 0xeb4a, 0xeb4b, 0xeb4c, 0xeb4d,
/* 30 */ 0xeb4e, 0xeb4f, 0xeb50, 0xeb51, 0xeb52, 0xeb53, 0xeb54, 0xeb55,
/* 38 */ 0xeb56, 0xeb57, 0xeb58, 0xeb59, 0xeb5a, 0xeb5b, 0xeb5c, 0xeb5d
},

/* Row 0x08f */
{
/* 00 */ 0xeb5e, 0xeb5f, 0xeb60, 0xeb61, 0xeb62, 0xeb63, 0xeb64, 0xeb65,
/* 08 */ 0xeb66, 0xeb67, 0xeb68, 0xeb69, 0xeb6a, 0xeb6b, 0xeb6c, 0xeb6d,
/* 10 */ 0xeb6e, 0xeb6f, 0xeb70, 0xeb71, 0xeb72, 0xeb73, 0xeb74, 0xeb75,
/* 18 */ 0xeb76, 0xeb77, 0xeb78, 0xeb79, 0xeb7a, 0xeb7b, 0xeb7c, 0xeb7d,
/* 20 */ 0xeb7e, 0xeb7f, 0xeb80, 0xeb81, 0xeb82, 0xeb83, 0xeb84, 0xeb85,
/* 28 */ 0xeb86, 0xeb87, 0xeb88, 0xeb89, 0xeb8a, 0xeb8b, 0xeb8c, 0xeb8d,
/* 30 */ 0xeb8e, 0xeb8f, 0xeb90, 0xeb91, 0xeb92, 0xeb93, 0xeb94, 0xeb95,
/* 38 */ 0xeb96, 0xeb97, 0xeb98, 0xeb99, 0xeb9a, 0xeb9b, 0xeb9c, 0xeb9d
},

/* Row 0x090 */
{
/* 00 */ 0xeb9e, 0xeb9f, 0xeba0, 0xeba1, 0xeba2, 0xeba3, 0xeba4, 0xeba5,
/* 08 */ 0xeba6, 0xeba7, 0xeba8, 0xeba9, 0xebaa, 0xebab, 0xebac, 0xebad,
/* 10 */ 0xebae, 0xebaf, 0xebb0, 0xebb1, 0xebb2, 0xebb3, 0xebb4, 0xebb5,
/* 18 */ 0xebb6, 0xebb7, 0xebb8, 0xebb9, 0xebba, 0xebbb, 0xebbc, 0xebbd,
/* 20 */ 0xebbe, 0xebbf, 0xebc0, 0xebc1, 0xebc2, 0xebc3, 0xebc4, 0xebc5,
/* 28 */ 0xebc6, 0xebc7, 0xebc8, 0xebc9, 0xebca, 0xebcb, 0xebcc, 0xebcd,
/* 30 */ 0xebce, 0xebcf, 0xebd0, 0xebd1, 0xebd2, 0xebd3, 0xebd4, 0xebd5,
/* 38 */ 0xebd6, 0xebd7, 0xebd8, 0xebd9, 0xebda, 0xebdb, 0xebdc, 0xebdd
},

/* Row 0x091 */
{
/* 00 */ 0xebde, 0xebdf, 0xebe0, 0xebe1, 0xebe2, 0xebe3, 0xebe4, 0xebe5,
/* 08 */ 0xebe6, 0xebe7, 0xebe8, 0xebe9, 0xebea, 0xebeb, 0xebec, 0xebed,
/* 10 */ 0xebee, 0xebef, 0xebf0, 0xebf1, 0xebf2, 0xebf3, 0xebf4, 0xebf5,
/* 18 */ 0xebf6, 0xebf7, 0xebf8, 0xebf9, 0xebfa, 0xebfb, 0xebfc, 0xebfd,
/* 20 */ 0xebfe, 0xebff, 0xec00, 0xec01, 0xec02, 0xec03, 0xec04, 0xec05,
/* 28 */ 0xec06, 0xec07, 0xec08, 0xec09, 0xec0a, 0xec0b, 0xec0c, 0xec0d,
/* 30 */ 0xec0e, 0xec0f, 0xec10, 0xec11, 0xec12, 0xec13, 0xec14, 0xec15,
/* 38 */ 0xec16, 0xec17, 0xec18, 0xec19, 0xec1a, 0xec1b, 0xec1c, 0xec1d
},

/* Row 0x092 */
{
/* 00 */ 0xec1e, 0xec1f, 0xec20, 0xec21, 0xec22, 0xec23, 0xec24, 0xec25,
/* 08 */ 0xec26, 0xec27, 0xec28, 0xec29, 0xec2a, 0xec2b, 0xec2c, 0xec2d,
/* 10 */ 0xec2e, 0xec2f, 0xec30, 0xec31, 0xec32, 0xec33, 0xec34, 0xec35,
/* 18 */ 0xec36, 0xec37, 0xec38, 0xec39, 0xec3a, 0xec3b, 0xec3c, 0xec3d,
/* 20 */ 0xec3e, 0xec3f, 0xec40, 0xec41, 0xec42, 0xec43, 0xec44, 0xec45,
/* 28 */ 0xec46, 0xec47, 0xec48, 0xec49, 0xec4a, 0xec4b, 0xec4c, 0xec4d,
/* 30 */ 0xec4e, 0xec4f, 0xec50, 0xec51, 0xec52, 0xec53, 0xec54, 0xec55,
/* 38 */ 0xec56, 0xec57, 0xec58, 0xec59, 0xec5a, 0xec5b, 0xec5c, 0xec5d
},

/* Row 0x093 */
{
/* 00 */ 0xec5e, 0xec5f, 0xec60, 0xec61, 0xec62, 0xec63, 0xec64, 0xec65,
/* 08 */ 0xec66, 0xec67, 0xec68, 0xec69, 0xec6a, 0xec6b, 0xec6c, 0xec6d,
/* 10 */ 0xec6e, 0xec6f, 0xec70, 0xec71, 0xec72, 0xec73, 0xec74, 0xec75,
/* 18 */ 0xec76, 0xec77, 0xec78, 0xec79, 0xec7a, 0xec7b, 0xec7c, 0xec7d,
/* 20 */ 0xec7e, 0xec7f, 0xec80, 0xec81, 0xec82, 0xec83, 0xec84, 0xec85,
/* 28 */ 0xec86, 0xec87, 0xec88, 0xec89, 0xec8a, 0xec8b, 0xec8c, 0xec8d,
/* 30 */ 0xec8e, 0xec8f, 0xec90, 0xec91, 0xec92, 0xec93, 0xec94, 0xec95,
/* 38 */ 0xec96, 0xec97, 0xec98, 0xec99, 0xec9a, 0xec9b, 0xec9c, 0xec9d
},

/* Row 0x094 */
{
/* 00 */ 0xec9e, 0xec9f, 0xeca0, 0xeca1, 0xeca2, 0xeca3, 0xeca4, 0xeca5,
/* 08 */ 0xeca6, 0xeca7, 0xeca8, 0xeca9, 0xecaa, 0xecab, 0xecac, 0xecad,
/* 10 */ 0xecae, 0xecaf, 0xecb0, 0xecb1, 0xecb2, 0xecb3, 0xecb4, 0xecb5,
/* 18 */ 0xecb6, 0xecb7, 0xecb8, 0xecb9, 0xecba, 0xecbb, 0xecbc, 0xecbd,
/* 20 */ 0xecbe, 0xecbf, 0xecc0, 0xecc1, 0xecc2, 0xecc3, 0xecc4, 0xecc5,
/* 28 */ 0xecc6, 0xecc7, 0xecc8, 0xecc9, 0xecca, 0xeccb, 0xeccc, 0xeccd,
/* 30 */ 0xecce, 0xeccf, 0xecd0, 0xecd1, 0xecd2, 0xecd3, 0xecd4, 0xecd5,
/* 38 */ 0xecd6, 0xecd7, 0xecd8, 0xecd9, 0xecda, 0xecdb, 0xecdc, 0xecdd
},

/* Row 0x095 */
{
/* 00 */ 0xecde, 0xecdf, 0xece0, 0xece1, 0xece2, 0xece3, 0xece4, 0xece5,
/* 08 */ 0xece6, 0xece7, 0xece8, 0xece9, 0xecea, 0xeceb, 0xecec, 0xeced,
/* 10 */ 0xecee, 0xecef, 0xecf0, 0xecf1, 0xecf2, 0xecf3, 0xecf4, 0xecf5,
/* 18 */ 0xecf6, 0xecf7, 0xecf8, 0xecf9, 0xecfa, 0xecfb, 0xecfc, 0xecfd,
/* 20 */ 0xecfe, 0xecff, 0xed00, 0xed01, 0xed02, 0xed03, 0xed04, 0xed05,
/* 28 */ 0xed06, 0xed07, 0xed08, 0xed09, 0xed0a, 0xed0b, 0xed0c, 0xed0d,
/* 30 */ 0xed0e, 0xed0f, 0xed10, 0xed11, 0xed12, 0xed13, 0xed14, 0xed15,
/* 38 */ 0xed16, 0xed17, 0xed18, 0xed19, 0xed1a, 0xed1b, 0xed1c, 0xed1d
},

/* Row 0x096 */
{
/* 00 */ 0xed1e, 0xed1f, 0xed20, 0xed21, 0xed22, 0xed23, 0xed24, 0xed25,
/* 08 */ 0xed26, 0xed27, 0xed28, 0xed29, 0xed2a, 0xed2b, 0xed2c, 0xed2d,
/* 10 */ 0xed2e, 0xed2f, 0xed30, 0xed31, 0xed32, 0xed33, 0xed34, 0xed35,
/* 18 */ 0xed36, 0xed37, 0xed38, 0xed39, 0xed3a, 0xed3b, 0xed3c, 0xed3d,
/* 20 */ 0xed3e, 0xed3f, 0xed40, 0xed41, 0xed42, 0xed43, 0xed44, 0xed45,
/* 28 */ 0xed46, 0xed47, 0xed48, 0xed49, 0xed4a, 0xed4b, 0xed4c, 0xed4d,
/* 30 */ 0xed4e, 0xed4f, 0xed50, 0xed51, 0xed52, 0xed53, 0xed54, 0xed55,
/* 38 */ 0xed56, 0xed57, 0xed58, 0xed59, 0xed5a, 0xed5b, 0xed5c, 0xed5d
},

/* Row 0x097 */
{
/* 00 */ 0xed5e, 0xed5f, 0x4e9c, 0x5516, 0x5a03, 0x963f, 0x54c0, 0x611b,
/* 08 */ 0x6328, 0x59f6, 0x9022, 0x8475, 0x831c, 0x7a50, 0x60aa, 0x63e1,
/* 10 */ 0x6e25, 0x65ed, 0x8466, 0x82a6, 0x9bf5, 0x6893, 0x5727, 0x65a1,
/* 18 */ 0x6271, 0x5b9b, 0x59d0, 0x867b, 0x98f4, 0x7d62, 0x7dbe, 0x9b8e,
/* 20 */ 0x6216, 0x7c9f, 0x88b7, 0x5b89, 0x5eb5, 0x6309, 0x6697, 0x6848,
/* 28 */ 0x95c7, 0x978d, 0x674f, 0x4ee5, 0x4f0a, 0x4f4d, 0x4f9d, 0x5049,
/* 30 */ 0x56f2, 0x5937, 0x59d4, 0x5a01, 0x5c09, 0x60df, 0x610f, 0x6170,
/* 38 */ 0x6613, 0x6905, 0x70ba, 0x754f, 0x7570, 0x79fb, 0x7dad, 0x7def
},

/* Row 0x098 */
{
/* 00 */ 0x7984, 0x808b, 0x9332, 0x8ad6, 0x502d, 0x548c, 0x8a71, 0x6b6a,
/* 08 */ 0x8cc4, 0x8107, 0x60d1, 0x67a0, 0x9df2, 0x4e99, 0x4e98, 0x9c10,
/* 10 */ 0x8a6b, 0x85c1, 0x8568, 0x6900, 0x6e7e, 0x7897, 0x8155, 0xed60,
/* 18 */ 0xed61, 0xed62, 0xed63, 0xed64, 0xed65, 0xed66, 0xed67, 0xed68,
/* 20 */ 0xed69, 0xed6a, 0xed6b, 0xed6c, 0xed6d, 0xed6e, 0xed6f, 0xed70,
/* 28 */ 0xed71, 0xed72, 0xed73, 0xed74, 0xed75, 0xed76, 0xed77, 0xed78,
/* 30 */ 0xed79, 0xed7a, 0xed7b, 0xed7c, 0xed7d, 0xed7e, 0xed7f, 0xed80,
/* 38 */ 0xed81, 0xed82, 0xed83, 0xed84, 0xed85, 0xed86, 0xed87, 0xed88
},

/* Row 0x099 */
{
/* 00 */ 0xed89, 0xed8a, 0x5f0c, 0x4e10, 0x4e15, 0x4e2a, 0x4e31, 0x4e36,
/* 08 */ 0x4e3c, 0x4e3f, 0x4e42, 0x4e56, 0x4e58, 0x4e82, 0x4e85, 0x8c6b,
/* 10 */ 0x4e8a, 0x8212, 0x5f0d, 0x4e8e, 0x4e9e, 0x4e9f, 0x4ea0, 0x4ea2,
/* 18 */ 0x4eb0, 0x4eb3, 0x4eb6, 0x4ece, 0x4ecd, 0x4ec4, 0x4ec6, 0x4ec2,
/* 20 */ 0x4ed7, 0x4ede, 0x4eed, 0x4edf, 0x4ef7, 0x4f09, 0x4f5a, 0x4f30,
/* 28 */ 0x4f5b, 0x4f5d, 0x4f57, 0x4f47, 0x4f76, 0x4f88, 0x4f8f, 0x4f98,
/* 30 */ 0x4f7b, 0x4f69, 0x4f70, 0x4f91, 0x4f6f, 0x4f86, 0x4f96, 0x5118,
/* 38 */ 0x4fd4, 0x4fdf, 0x4fce, 0x4fd8, 0x4fdb, 0x4fd1, 0x4fda, 0x4fd0
},

/* Row 0x09a */
{
/* 00 */ 0x6f31, 0x6eef, 0x6f32, 0x6ecc, 0x6f3e, 0x6f13, 0x6ef7, 0x6f86,
/* 08 */ 0x6f7a, 0x6f78, 0x6f81, 0x6f80, 0x6f6f, 0x6f5b, 0x6ff3, 0x6f6d,
/* 10 */ 0x6f82, 0x6f7c, 0x6f58, 0x6f8e, 0x6f91, 0x6fc2, 0x6f66, 0x6fb3,
/* 18 */ 0x6fa3, 0x6fa1, 0x6fa4, 0x6fb9, 0x6fc6, 0x6faa, 0x6fdf, 0x6fd5,
/* 20 */ 0x6fec, 0x6fd4, 0x6fd8, 0x6ff1, 0x6fee, 0x6fdb, 0x7009, 0x700b,
/* 28 */ 0x6ffa, 0x7011, 0x7001, 0x700f, 0x6ffe, 0x701b, 0x701a, 0x6f74,
/* 30 */ 0x701d, 0x7018, 0x701f, 0x7030, 0x703e, 0x7032, 0x7051, 0x7063,
/* 38 */ 0x7099, 0x7092, 0x70af, 0x70f1, 0x70ac, 0x70b8, 0x70b3, 0x70ae
},

/* Row 0x09b */
{
/* 00 */ 0x70df, 0x70cb, 0x70dd, 0x70d9, 0x7109, 0x70fd, 0x711c, 0x7119,
/* 08 */ 0x7165, 0x7155, 0x7188, 0x7166, 0x7162, 0x714c, 0x7156, 0x716c,
/* 10 */ 0x718f, 0x71fb, 0x7184, 0x7195, 0x71a8, 0x71ac, 0x71d7, 0x71b9,
/* 18 */ 0x71be, 0x71d2, 0x71c9, 0x71d4, 0x71ce, 0x71e0, 0x71ec, 0x71e7,
/* 20 */ 0x71f5, 0x71fc, 0x71f9, 0x71ff, 0x720d, 0x7210, 0x721b, 0x7228,
/* 28 */ 0x722d, 0x722c, 0x7230, 0x7232, 0x723b, 0x723c, 0x723f, 0x7240,
/* 30 */ 0x7246, 0x724b, 0x7258, 0x7274, 0x727e, 0x7282, 0x7281, 0x7287,
/* 38 */ 0x7292, 0x7296, 0x72a2, 0x72a7, 0x72b9, 0x72b2, 0x72c3, 0x72c6
},

/* Row 0x09c */
{
/* 00 */ 0x72c4, 0x72ce, 0x72d2, 0x72e2, 0x72e0, 0x72e1, 0x72f9, 0x72f7,
/* 08 */ 0x500f, 0x7317, 0x730a, 0x731c, 0x7316, 0x731d, 0x7334, 0x732f,
/* 10 */ 0x7329, 0x7325, 0x733e, 0x734e, 0x734f, 0x9ed8, 0x7357, 0x736a,
/* 18 */ 0x7368, 0x7370, 0x7378, 0x7375, 0x737b, 0x737a, 0x73c8, 0x73b3,
/* 20 */ 0x73ce, 0x73bb, 0x73c0, 0x73e5, 0x73ee, 0x73de, 0x74a2, 0x7405,
/* 28 */ 0x746f, 0x7425, 0x73f8, 0x7432, 0x743a, 0x7455, 0x743f, 0x745f,
/* 30 */ 0x7459, 0x7441, 0x745c, 0x7469, 0x7470, 0x7463, 0x746a, 0x7476,
/* 38 */ 0x747e, 0x748b, 0x749e, 0x74a7, 0x74ca, 0x74cf, 0x74d4, 0x73f1
},

/* Row 0x09d */
{
/* 00 */ 0x74e0, 0x74e3, 0x74e7, 0x74e9, 0x74ee, 0x74f2, 0x74f0, 0x74f1,
/* 08 */ 0x74f8, 0x74f7, 0x7504, 0x7503, 0x7505, 0x750c, 0x750e, 0x750d,
/* 10 */ 0x7515, 0x7513, 0x751e, 0x7526, 0x752c, 0x753c, 0x7544, 0x754d,
/* 18 */ 0x754a, 0x7549, 0x755b, 0x7546, 0x755a, 0x7569, 0x7564, 0x7567,
/* 20 */ 0x756b, 0x756d, 0x7578, 0x7576, 0x7586, 0x7587, 0x7574, 0x758a,
/* 28 */ 0x7589, 0x7582, 0x7594, 0x759a, 0x759d, 0x75a5, 0x75a3, 0x75c2,
/* 30 */ 0x75b3, 0x75c3, 0x75b5, 0x75bd, 0x75b8, 0x75bc, 0x75b1, 0x75cd,
/* 38 */ 0x75ca, 0x75d2, 0x75d9, 0x75e3, 0x75de, 0x75fe, 0x75ff, 0x75fc
},

/* Row 0x09e */
{
/* 00 */ 0x7601, 0x75f0, 0x75fa, 0x75f2, 0x75f3, 0x760b, 0x760d, 0x7609,
/* 08 */ 0x761f, 0x7627, 0x7620, 0x7621, 0x7622, 0x7624, 0x7634, 0x7630,
/* 10 */ 0x763b, 0x7647, 0x7648, 0x7646, 0x765c, 0x7658, 0x7661, 0x7662,
/* 18 */ 0x7668, 0x7669, 0x766a, 0x7667, 0x766c, 0x7670, 0x7672, 0x7676,
/* 20 */ 0x7678, 0x767c, 0x7680, 0x7683, 0x7688, 0x768b, 0x768e, 0x7696,
/* 28 */ 0x7693, 0x7699, 0x769a, 0x76b0, 0x76b4, 0x76b8, 0x76b9, 0x76ba,
/* 30 */ 0x76c2, 0x76cd, 0x76d6, 0x76d2, 0x76de, 0x76e1, 0x76e5, 0x76e7,
/* 38 */ 0x76ea, 0x862f, 0x76fb, 0x7708, 0x7707, 0x7704, 0x7729, 0x7724
},

/* Row 0x09f */
{
/* 00 */ 0x771e, 0x7725, 0x7726, 0x771b, 0x7737, 0x7738, 0x7747, 0x775a,
/* 08 */ 0x7768, 0x776b, 0x775b, 0x7765, 0x777f, 0x777e, 0x7779, 0x778e,
/* 10 */ 0x778b, 0x7791, 0x77a0, 0x779e, 0x77b0, 0x77b6, 0x77b9, 0x77bf,
/* 18 */ 0x77bc, 0x77bd, 0x77bb, 0x77c7, 0x77cd, 0x77d7, 0x77da, 0x77dc,
/* 20 */ 0x77e3, 0x77ee, 0x77fc, 0x780c, 0x7812, 0x7926, 0x7820, 0x792a,
/* 28 */ 0x7845, 0x788e, 0x7874, 0x7886, 0x787c, 0x789a, 0x788c, 0x78a3,
/* 30 */ 0x78b5, 0x78aa, 0x78af, 0x78d1, 0x78c6, 0x78cb, 0x78d4, 0x78be,
/* 38 */ 0x78bc, 0x78c5, 0x78ca, 0x78ec, 0x78e7, 0x78da, 0x78fd, 0x78f4
},

/* Row 0x0a0 */
{
/* 00 */ 0x7907, 0x7912, 0x7911, 0x7919, 0x792c, 0x792b, 0x7940, 0x7960,
/* 08 */ 0x7957, 0x795f, 0x795a, 0x7955, 0x7953, 0x797a, 0x797f, 0x798a,
/* 10 */ 0x799d, 0x79a7, 0x9f4b, 0x79aa, 0x79ae, 0x79b3, 0x79b9, 0x79ba,
/* 18 */ 0x79c9, 0x79d5, 0x79e7, 0x79ec, 0x79e1, 0x79e3, 0x7a08, 0x7a0d,
/* 20 */ 0x7a18, 0x7a19, 0x7a20, 0x7a1f, 0x7980, 0x7a31, 0x7a3b, 0x7a3e,
/* 28 */ 0x7a37, 0x7a43, 0x7a57, 0x7a49, 0x7a61, 0x7a62, 0x7a69, 0x9f9d,
/* 30 */ 0x7a70, 0x7a79, 0x7a7d, 0x7a88, 0x7a97, 0x7a95, 0x7a98, 0x7a96,
/* 38 */ 0x7aa9, 0x7ac8, 0x7ab0, 0x7ab6, 0x7ac5, 0x7ac4, 0x7abf, 0x9083
},

/* Row 0x0a1 */
{
/* 00 */ 0x7ac7, 0x7aca, 0x7acd, 0x7acf, 0x7ad5, 0x7ad3, 0x7ad9, 0x7ada,
/* 08 */ 0x7add, 0x7ae1, 0x7ae2, 0x7ae6, 0x7aed, 0x7af0, 0x7b02, 0x7b0f,
/* 10 */ 0x7b0a, 0x7b06, 0x7b33, 0x7b18, 0x7b19, 0x7b1e, 0x7b35, 0x7b28,
/* 18 */ 0x7b36, 0x7b50, 0x7b7a, 0x7b04, 0x7b4d, 0x7b0b, 0x7b4c, 0x7b45,
/* 20 */ 0x7b75, 0x7b65, 0x7b74, 0x7b67, 0x7b70, 0x7b71, 0x7b6c, 0x7b6e,
/* 28 */ 0x7b9d, 0x7b98, 0x7b9f, 0x7b8d, 0x7b9c, 0x7b9a, 0x7b8b, 0x7b92,
/* 30 */ 0x7b8f, 0x7b5d, 0x7b99, 0x7bcb, 0x7bc1, 0x7bcc, 0x7bcf, 0x7bb4,
/* 38 */ 0x7bc6, 0x7bdd, 0x7be9, 0x7c11, 0x7c14, 0x7be6, 0x7be5, 0x7c60
},

/* Row 0x0a2 */
{
/* 00 */ 0x7c00, 0x7c07, 0x7c13, 0x7bf3, 0x7bf7, 0x7c17, 0x7c0d, 0x7bf6,
/* 08 */ 0x7c23, 0x7c27, 0x7c2a, 0x7c1f, 0x7c37, 0x7c2b, 0x7c3d, 0x7c4c,
/* 10 */ 0x7c43, 0x7c54, 0x7c4f, 0x7c40, 0x7c50, 0x7c58, 0x7c5f, 0x7c64,
/* 18 */ 0x7c56, 0x7c65, 0x7c6c, 0x7c75, 0x7c83, 0x7c90, 0x7ca4, 0x7cad,
/* 20 */ 0x7ca2, 0x7cab, 0x7ca1, 0x7ca8, 0x7cb3, 0x7cb2, 0x7cb1, 0x7cae,
/* 28 */ 0x7cb9, 0x7cbd, 0x7cc0, 0x7cc5, 0x7cc2, 0x7cd8, 0x7cd2, 0x7cdc,
/* 30 */ 0x7ce2, 0x9b3b, 0x7cef, 0x7cf2, 0x7cf4, 0x7cf6, 0x7cfa, 0x7d06,
/* 38 */ 0x7d02, 0x7d1c, 0x7d15, 0x7d0a, 0x7d45, 0x7d4b, 0x7d2e, 0x7d32
},

/* Row 0x0a3 */
{
/* 00 */ 0x7d3f, 0x7d35, 0x7d46, 0x7d73, 0x7d56, 0x7d4e, 0x7d72, 0x7d68,
/* 08 */ 0x7d6e, 0x7d4f, 0x7d63, 0x7d93, 0x7d89, 0x7d5b, 0x7d8f, 0x7d7d,
/* 10 */ 0x7d9b, 0x7dba, 0x7dae, 0x7da3, 0x7db5, 0x7dc7, 0x7dbd, 0x7dab,
/* 18 */ 0x7e3d, 0x7da2, 0x7daf, 0x7ddc, 0x7db8, 0x7d9f, 0x7db0, 0x7dd8,
/* 20 */ 0x7ddd, 0x7de4, 0x7dde, 0x7dfb, 0x7df2, 0x7de1, 0x7e05, 0x7e0a,
/* 28 */ 0x7e23, 0x7e21, 0x7e12, 0x7e31, 0x7e1f, 0x7e09, 0x7e0b, 0x7e22,
/* 30 */ 0x7e46, 0x7e66, 0x7e3b, 0x7e35, 0x7e39, 0x7e43, 0x7e37, 0x7e32,
/* 38 */ 0x7e3a, 0x7e67, 0x7e5d, 0x7e56, 0x7e5e, 0x7e59, 0x7e5a, 0x7e79
},

/* Row 0x0a4 */
{
/* 00 */ 0x7e6a, 0x7e69, 0x7e7c, 0x7e7b, 0x7e83, 0x7dd5, 0x7e7d, 0x8fae,
/* 08 */ 0x7e7f, 0x7e88, 0x7e89, 0x7e8c, 0x7e92, 0x7e90, 0x7e93, 0x7e94,
/* 10 */ 0x7e96, 0x7e8e, 0x7e9b, 0x7e9c, 0x7f38, 0x7f3a, 0x7f45, 0x7f4c,
/* 18 */ 0x7f4d, 0x7f4e, 0x7f50, 0x7f51, 0x7f55, 0x7f54, 0x7f58, 0x7f5f,
/* 20 */ 0x7f60, 0x7f68, 0x7f69, 0x7f67, 0x7f78, 0x7f82, 0x7f86, 0x7f83,
/* 28 */ 0x7f88, 0x7f87, 0x7f8c, 0x7f94, 0x7f9e, 0x7f9d, 0x7f9a, 0x7fa3,
/* 30 */ 0x7faf, 0x7fb2, 0x7fb9, 0x7fae, 0x7fb6, 0x7fb8, 0x8b71, 0x7fc5,
/* 38 */ 0x7fc6, 0x7fca, 0x7fd5, 0x7fd4, 0x7fe1, 0x7fe6, 0x7fe9, 0x7ff3
},

/* Row 0x0a5 */
{
/* 00 */ 0x7ff9, 0x98dc, 0x8006, 0x8004, 0x800b, 0x8012, 0x8018, 0x8019,
/* 08 */ 0x801c, 0x8021, 0x8028, 0x803f, 0x803b, 0x804a, 0x8046, 0x8052,
/* 10 */ 0x8058, 0x805a, 0x805f, 0x8062, 0x8068, 0x8073, 0x8072, 0x8070,
/* 18 */ 0x8076, 0x8079, 0x807d, 0x807f, 0x8084, 0x8086, 0x8085, 0x809b,
/* 20 */ 0x8093, 0x809a, 0x80ad, 0x5190, 0x80ac, 0x80db, 0x80e5, 0x80d9,
/* 28 */ 0x80dd, 0x80c4, 0x80da, 0x80d6, 0x8109, 0x80ef, 0x80f1, 0x811b,
/* 30 */ 0x8129, 0x8123, 0x812f, 0x814b, 0x968b, 0x8146, 0x813e, 0x8153,
/* 38 */ 0x8151, 0x80fc, 0x8171, 0x816e, 0x8165, 0x8166, 0x8174, 0x8183
},

/* Row 0x0a6 */
{
/* 00 */ 0x8188, 0x818a, 0x8180, 0x8182, 0x81a0, 0x8195, 0x81a4, 0x81a3,
/* 08 */ 0x815f, 0x8193, 0x81a9, 0x81b0, 0x81b5, 0x81be, 0x81b8, 0x81bd,
/* 10 */ 0x81c0, 0x81c2, 0x81ba, 0x81c9, 0x81cd, 0x81d1, 0x81d9, 0x81d8,
/* 18 */ 0x81c8, 0x81da, 0x81df, 0x81e0, 0x81e7, 0x81fa, 0x81fb, 0x81fe,
/* 20 */ 0x8201, 0x8202, 0x8205, 0x8207, 0x820a, 0x820d, 0x8210, 0x8216,
/* 28 */ 0x8229, 0x822b, 0x8238, 0x8233, 0x8240, 0x8259, 0x8258, 0x825d,
/* 30 */ 0x825a, 0x825f, 0x8264, 0x8262, 0x8268, 0x826a, 0x826b, 0x822e,
/* 38 */ 0x8271, 0x8277, 0x8278, 0x827e, 0x828d, 0x8292, 0x82ab, 0x829f
},

/* Row 0x0a7 */
{
/* 00 */ 0x82bb, 0x82ac, 0x82e1, 0x82e3, 0x82df, 0x82d2, 0x82f4, 0x82f3,
/* 08 */ 0x82fa, 0x8393, 0x8303, 0x82fb, 0x82f9, 0x82de, 0x8306, 0x82dc,
/* 10 */ 0x8309, 0x82d9, 0x8335, 0x8334, 0x8316, 0x8332, 0x8331, 0x8340,
/* 18 */ 0x8339, 0x8350, 0x8345, 0x832f, 0x832b, 0x8317, 0x8318, 0x8385,
/* 20 */ 0x839a, 0x83aa, 0x839f, 0x83a2, 0x8396, 0x8323, 0x838e, 0x8387,
/* 28 */ 0x838a, 0x837c, 0x83b5, 0x8373, 0x8375, 0x83a0, 0x8389, 0x83a8,
/* 30 */ 0x83f4, 0x8413, 0x83eb, 0x83ce, 0x83fd, 0x8403, 0x83d8, 0x840b,
/* 38 */ 0x83c1, 0x83f7, 0x8407, 0x83e0, 0x83f2, 0x840d, 0x8422, 0x8420
},

/* Row 0x0a8 */
{
/* 00 */ 0x83bd, 0x8438, 0x8506, 0x83fb, 0x846d, 0x842a, 0x843c, 0x855a,
/* 08 */ 0x8484, 0x8477, 0x846b, 0x84ad, 0x846e, 0x8482, 0x8469, 0x8446,
/* 10 */ 0x842c, 0x846f, 0x8479, 0x8435, 0x84ca, 0x8462, 0x84b9, 0x84bf,
/* 18 */ 0x849f, 0x84d9, 0x84cd, 0x84bb, 0x84da, 0x84d0, 0x84c1, 0x84c6,
/* 20 */ 0x84d6, 0x84a1, 0x8521, 0x84ff, 0x84f4, 0x8517, 0x8518, 0x852c,
/* 28 */ 0x851f, 0x8515, 0x8514, 0x84fc, 0x8540, 0x8563, 0x8558, 0x8548,
/* 30 */ 0x8541, 0x8602, 0x854b, 0x8555, 0x8580, 0x85a4, 0x8588, 0x8591,
/* 38 */ 0x858a, 0x85a8, 0x856d, 0x8594, 0x859b, 0x85ea, 0x8587, 0x859c
},

/* Row 0x0a9 */
{
/* 00 */ 0x8577, 0x857e, 0x8590, 0x85c9, 0x85ba, 0x85cf, 0x85b9, 0x85d0,
/* 08 */ 0x85d5, 0x85dd, 0x85e5, 0x85dc, 0x85f9, 0x860a, 0x8613, 0x860b,
/* 10 */ 0x85fe, 0x85fa, 0x8606, 0x8622, 0x861a, 0x8630, 0x863f, 0x864d,
/* 18 */ 0x4e55, 0x8654, 0x865f, 0x8667, 0x8671, 0x8693, 0x86a3, 0x86a9,
/* 20 */ 0x86aa, 0x868b, 0x868c, 0x86b6, 0x86af, 0x86c4, 0x86c6, 0x86b0,
/* 28 */ 0x86c9, 0x8823, 0x86ab, 0x86d4, 0x86de, 0x86e9, 0x86ec, 0x86df,
/* 30 */ 0x86db, 0x86ef, 0x8712, 0x8706, 0x8708, 0x8700, 0x8703, 0x86fb,
/* 38 */ 0x8711, 0x8709, 0x870d, 0x86f9, 0x870a, 0x8734, 0x873f, 0x8737
},

/* Row 0x0aa */
{
/* 00 */ 0x873b, 0x8725, 0x8729, 0x871a, 0x8760, 0x875f, 0x8778, 0x874c,
/* 08 */ 0x874e, 0x8774, 0x8757, 0x8768, 0x876e, 0x8759, 0x8753, 0x8763,
/* 10 */ 0x876a, 0x8805, 0x87a2, 0x879f, 0x8782, 0x87af, 0x87cb, 0x87bd,
/* 18 */ 0x87c0, 0x87d0, 0x96d6, 0x87ab, 0x87c4, 0x87b3, 0x87c7, 0x87c6,
/* 20 */ 0x87bb, 0x87ef, 0x87f2, 0x87e0, 0x880f, 0x880d, 0x87fe, 0x87f6,
/* 28 */ 0x87f7, 0x880e, 0x87d2, 0x8811, 0x8816, 0x8815, 0x8822, 0x8821,
/* 30 */ 0x8831, 0x8836, 0x8839, 0x8827, 0x883b, 0x8844, 0x8842, 0x8852,
/* 38 */ 0x8859, 0x885e, 0x8862, 0x886b, 0x8881, 0x887e, 0x889e, 0x8875
},

/* Row 0x0ab */
{
/* 00 */ 0x887d, 0x88b5, 0x8872, 0x8882, 0x8897, 0x8892, 0x88ae, 0x8899,
/* 08 */ 0x88a2, 0x888d, 0x88a4, 0x88b0, 0x88bf, 0x88b1, 0x88c3, 0x88c4,
/* 10 */ 0x88d4, 0x88d8, 0x88d9, 0x88dd, 0x88f9, 0x8902, 0x88fc, 0x88f4,
/* 18 */ 0x88e8, 0x88f2, 0x8904, 0x890c, 0x890a, 0x8913, 0x8943, 0x891e,
/* 20 */ 0x8925, 0x892a, 0x892b, 0x8941, 0x8944, 0x893b, 0x8936, 0x8938,
/* 28 */ 0x894c, 0x891d, 0x8960, 0x895e, 0x8966, 0x8964, 0x896d, 0x896a,
/* 30 */ 0x896f, 0x8974, 0x8977, 0x897e, 0x8983, 0x8988, 0x898a, 0x8993,
/* 38 */ 0x8998, 0x89a1, 0x89a9, 0x89a6, 0x89ac, 0x89af, 0x89b2, 0x89ba
},

/* Row 0x0ac */
{
/* 00 */ 0x89bd, 0x89bf, 0x89c0, 0x89da, 0x89dc, 0x89dd, 0x89e7, 0x89f4,
/* 08 */ 0x89f8, 0x8a03, 0x8a16, 0x8a10, 0x8a0c, 0x8a1b, 0x8a1d, 0x8a25,
/* 10 */ 0x8a36, 0x8a41, 0x8a5b, 0x8a52, 0x8a46, 0x8a48, 0x8a7c, 0x8a6d,
/* 18 */ 0x8a6c, 0x8a62, 0x8a85, 0x8a82, 0x8a84, 0x8aa8, 0x8aa1, 0x8a91,
/* 20 */ 0x8aa5, 0x8aa6, 0x8a9a, 0x8aa3, 0x8ac4, 0x8acd, 0x8ac2, 0x8ada,
/* 28 */ 0x8aeb, 0x8af3, 0x8ae7, 0x8ae4, 0x8af1, 0x8b14, 0x8ae0, 0x8ae2,
/* 30 */ 0x8af7, 0x8ade, 0x8adb, 0x8b0c, 0x8b07, 0x8b1a, 0x8ae1, 0x8b16,
/* 38 */ 0x8b10, 0x8b17, 0x8b20, 0x8b33, 0x97ab, 0x8b26, 0x8b2b, 0x8b3e
},

/* Row 0x0ad */
{
/* 00 */ 0x8b28, 0x8b41, 0x8b4c, 0x8b4f, 0x8b4e, 0x8b49, 0x8b56, 0x8b5b,
/* 08 */ 0x8b5a, 0x8b6b, 0x8b5f, 0x8b6c, 0x8b6f, 0x8b74, 0x8b7d, 0x8b80,
/* 10 */ 0x8b8c, 0x8b8e, 0x8b92, 0x8b93, 0x8b96, 0x8b99, 0x8b9a, 0x8c3a,
/* 18 */ 0x8c41, 0x8c3f, 0x8c48, 0x8c4c, 0x8c4e, 0x8c50, 0x8c55, 0x8c62,
/* 20 */ 0x8c6c, 0x8c78, 0x8c7a, 0x8c82, 0x8c89, 0x8c85, 0x8c8a, 0x8c8d,
/* 28 */ 0x8c8e, 0x8c94, 0x8c7c, 0x8c98, 0x621d, 0x8cad, 0x8caa, 0x8cbd,
/* 30 */ 0x8cb2, 0x8cb3, 0x8cae, 0x8cb6, 0x8cc8, 0x8cc1, 0x8ce4, 0x8ce3,
/* 38 */ 0x8cda, 0x8cfd, 0x8cfa, 0x8cfb, 0x8d04, 0x8d05, 0x8d0a, 0x8d07
},

/* Row 0x0ae */
{
/* 00 */ 0x8d0f, 0x8d0d, 0x8d10, 0x9f4e, 0x8d13, 0x8ccd, 0x8d14, 0x8d16,
/* 08 */ 0x8d67, 0x8d6d, 0x8d71, 0x8d73, 0x8d81, 0x8d99, 0x8dc2, 0x8dbe,
/* 10 */ 0x8dba, 0x8dcf, 0x8dda, 0x8dd6, 0x8dcc, 0x8ddb, 0x8dcb, 0x8dea,
/* 18 */ 0x8deb, 0x8ddf, 0x8de3, 0x8dfc, 0x8e08, 0x8e09, 0x8dff, 0x8e1d,
/* 20 */ 0x8e1e, 0x8e10, 0x8e1f, 0x8e42, 0x8e35, 0x8e30, 0x8e34, 0x8e4a,
/* 28 */ 0x8e47, 0x8e49, 0x8e4c, 0x8e50, 0x8e48, 0x8e59, 0x8e64, 0x8e60,
/* 30 */ 0x8e2a, 0x8e63, 0x8e55, 0x8e76, 0x8e72, 0x8e7c, 0x8e81, 0x8e87,
/* 38 */ 0x8e85, 0x8e84, 0x8e8b, 0x8e8a, 0x8e93, 0x8e91, 0x8e94, 0x8e99
},

/* Row 0x0af */
{
/* 00 */ 0x8eaa, 0x8ea1, 0x8eac, 0x8eb0, 0x8ec6, 0x8eb1, 0x8ebe, 0x8ec5,
/* 08 */ 0x8ec8, 0x8ecb, 0x8edb, 0x8ee3, 0x8efc, 0x8efb, 0x8eeb, 0x8efe,
/* 10 */ 0x8f0a, 0x8f05, 0x8f15, 0x8f12, 0x8f19, 0x8f13, 0x8f1c, 0x8f1f,
/* 18 */ 0x8f1b, 0x8f0c, 0x8f26, 0x8f33, 0x8f3b, 0x8f39, 0x8f45, 0x8f42,
/* 20 */ 0x8f3e, 0x8f4c, 0x8f49, 0x8f46, 0x8f4e, 0x8f57, 0x8f5c, 0x8f62,
/* 28 */ 0x8f63, 0x8f64, 0x8f9c, 0x8f9f, 0x8fa3, 0x8fad, 0x8faf, 0x8fb7,
/* 30 */ 0x8fda, 0x8fe5, 0x8fe2, 0x8fea, 0x8fef, 0x9087, 0x8ff4, 0x9005,
/* 38 */ 0x8ff9, 0x8ffa, 0x9011, 0x9015, 0x9021, 0x900d, 0x901e, 0x9016
},

/* Row 0x0b0 */
{
/* 00 */ 0x900b, 0x9027, 0x9036, 0x9035, 0x9039, 0x8ff8, 0x904f, 0x9050,
/* 08 */ 0x9051, 0x9052, 0x900e, 0x9049, 0x903e, 0x9056, 0x9058, 0x905e,
/* 10 */ 0x9068, 0x906f, 0x9076, 0x96a8, 0x9072, 0x9082, 0x907d, 0x9081,
/* 18 */ 0x9080, 0x908a, 0x9089, 0x908f, 0x90a8, 0x90af, 0x90b1, 0x90b5,
/* 20 */ 0x90e2, 0x90e4, 0x6248, 0x90db, 0x9102, 0x9112, 0x9119, 0x9132,
/* 28 */ 0x9130, 0x914a, 0x9156, 0x9158, 0x9163, 0x9165, 0x9169, 0x9173,
/* 30 */ 0x9172, 0x918b, 0x9189, 0x9182, 0x91a2, 0x91ab, 0x91af, 0x91aa,
/* 38 */ 0x91b5, 0x91b4, 0x91ba, 0x91c0, 0x91c1, 0x91c9, 0x91cb, 0x91d0
},

/* Row 0x0b1 */
{
/* 00 */ 0x91d6, 0x91df, 0x91e1, 0x91db, 0x91fc, 0x91f5, 0x91f6, 0x921e,
/* 08 */ 0x91ff, 0x9214, 0x922c, 0x9215, 0x9211, 0x925e, 0x9257, 0x9245,
/* 10 */ 0x9249, 0x9264, 0x9248, 0x9295, 0x923f, 0x924b, 0x9250, 0x929c,
/* 18 */ 0x9296, 0x9293, 0x929b, 0x925a, 0x92cf, 0x92b9, 0x92b7, 0x92e9,
/* 20 */ 0x930f, 0x92fa, 0x9344, 0x932e, 0x9319, 0x9322, 0x931a, 0x9323,
/* 28 */ 0x933a, 0x9335, 0x933b, 0x935c, 0x9360, 0x937c, 0x936e, 0x9356,
/* 30 */ 0x93b0, 0x93ac, 0x93ad, 0x9394, 0x93b9, 0x93d6, 0x93d7, 0x93e8,
/* 38 */ 0x93e5, 0x93d8, 0x93c3, 0x93dd, 0x93d0, 0x93c8, 0x93e4, 0x941a
},

/* Row 0x0b2 */
{
/* 00 */ 0x9414, 0x9413, 0x9403, 0x9407, 0x9410, 0x9436, 0x942b, 0x9435,
/* 08 */ 0x9421, 0x943a, 0x9441, 0x9452, 0x9444, 0x945b, 0x9460, 0x9462,
/* 10 */ 0x945e, 0x946a, 0x9229, 0x9470, 0x9475, 0x9477, 0x947d, 0x945a,
/* 18 */ 0x947c, 0x947e, 0x9481, 0x947f, 0x9582, 0x9587, 0x958a, 0x9594,
/* 20 */ 0x9596, 0x9598, 0x9599, 0x95a0, 0x95a8, 0x95a7, 0x95ad, 0x95bc,
/* 28 */ 0x95bb, 0x95b9, 0x95be, 0x95ca, 0x6ff6, 0x95c3, 0x95cd, 0x95cc,
/* 30 */ 0x95d5, 0x95d4, 0x95d6, 0x95dc, 0x95e1, 0x95e5, 0x95e2, 0x9621,
/* 38 */ 0x9628, 0x962e, 0x962f, 0x9642, 0x964c, 0x964f, 0x964b, 0x9677
},

/* Row 0x0b3 */
{
/* 00 */ 0x965c, 0x965e, 0x965d, 0x965f, 0x9666, 0x9672, 0x966c, 0x968d,
/* 08 */ 0x9698, 0x9695, 0x9697, 0x96aa, 0x96a7, 0x96b1, 0x96b2, 0x96b0,
/* 10 */ 0x96b4, 0x96b6, 0x96b8, 0x96b9, 0x96ce, 0x96cb, 0x96c9, 0x96cd,
/* 18 */ 0x894d, 0x96dc, 0x970d, 0x96d5, 0x96f9, 0x9704, 0x9706, 0x9708,
/* 20 */ 0x9713, 0x970e, 0x9711, 0x970f, 0x9716, 0x9719, 0x9724, 0x972a,
/* 28 */ 0x9730, 0x9739, 0x973d, 0x973e, 0x9744, 0x9746, 0x9748, 0x9742,
/* 30 */ 0x9749, 0x975c, 0x9760, 0x9764, 0x9766, 0x9768, 0x52d2, 0x976b,
/* 38 */ 0x9771, 0x9779, 0x9785, 0x977c, 0x9781, 0x977a, 0x9786, 0x978b
},

/* Row 0x0b4 */
{
/* 00 */ 0x978f, 0x9790, 0x979c, 0x97a8, 0x97a6, 0x97a3, 0x97b3, 0x97b4,
/* 08 */ 0x97c3, 0x97c6, 0x97c8, 0x97cb, 0x97dc, 0x97ed, 0x9f4f, 0x97f2,
/* 10 */ 0x7adf, 0x97f6, 0x97f5, 0x980f, 0x980c, 0x9838, 0x9824, 0x9821,
/* 18 */ 0x9837, 0x983d, 0x9846, 0x984f, 0x984b, 0x986b, 0x986f, 0x9870,
/* 20 */ 0x9871, 0x9874, 0x9873, 0x98aa, 0x98af, 0x98b1, 0x98b6, 0x98c4,
/* 28 */ 0x98c3, 0x98c6, 0x98e9, 0x98eb, 0x9903, 0x9909, 0x9912, 0x9914,
/* 30 */ 0x9918, 0x9921, 0x991d, 0x991e, 0x9924, 0x9920, 0x992c, 0x992e,
/* 38 */ 0x993d, 0x993e, 0x9942, 0x9949, 0x9945, 0x9950, 0x994b, 0x9951
},

/* Row 0x0b5 */
{
/* 00 */ 0x9952, 0x994c, 0x9955, 0x9997, 0x9998, 0x99a5, 0x99ad, 0x99ae,
/* 08 */ 0x99bc, 0x99df, 0x99db, 0x99dd, 0x99d8, 0x99d1, 0x99ed, 0x99ee,
/* 10 */ 0x99f1, 0x99f2, 0x99fb, 0x99f8, 0x9a01, 0x9a0f, 0x9a05, 0x99e2,
/* 18 */ 0x9a19, 0x9a2b, 0x9a37, 0x9a45, 0x9a42, 0x9a40, 0x9a43, 0x9a3e,
/* 20 */ 0x9a55, 0x9a4d, 0x9a5b, 0x9a57, 0x9a5f, 0x9a62, 0x9a65, 0x9a64,
/* 28 */ 0x9a69, 0x9a6b, 0x9a6a, 0x9aad, 0x9ab0, 0x9abc, 0x9ac0, 0x9acf,
/* 30 */ 0x9ad1, 0x9ad3, 0x9ad4, 0x9ade, 0x9adf, 0x9ae2, 0x9ae3, 0x9ae6,
/* 38 */ 0x9aef, 0x9aeb, 0x9aee, 0x9af4, 0x9af1, 0x9af7, 0x9afb, 0x9b06
},

/* Row 0x0b6 */
{
/* 00 */ 0x9b18, 0x9b1a, 0x9b1f, 0x9b22, 0x9b23, 0x9b25, 0x9b27, 0x9b28,
/* 08 */ 0x9b29, 0x9b2a, 0x9b2e, 0x9b2f, 0x9b32, 0x9b44, 0x9b43, 0x9b4f,
/* 10 */ 0x9b4d, 0x9b4e, 0x9b51, 0x9b58, 0x9b74, 0x9b93, 0x9b83, 0x9b91,
/* 18 */ 0x9b96, 0x9b97, 0x9b9f, 0x9ba0, 0x9ba8, 0x9bb4, 0x9bc0, 0x9bca,
/* 20 */ 0x9bb9, 0x9bc6, 0x9bcf, 0x9bd1, 0x9bd2, 0x9be3, 0x9be2, 0x9be4,
/* 28 */ 0x9bd4, 0x9be1, 0x9c3a, 0x9bf2, 0x9bf1, 0x9bf0, 0x9c15, 0x9c14,
/* 30 */ 0x9c09, 0x9c13, 0x9c0c, 0x9c06, 0x9c08, 0x9c12, 0x9c0a, 0x9c04,
/* 38 */ 0x9c2e, 0x9c1b, 0x9c25, 0x9c24, 0x9c21, 0x9c30, 0x9c47, 0x9c32
},

/* Row 0x0b7 */
{
/* 00 */ 0x9c46, 0x9c3e, 0x9c5a, 0x9c60, 0x9c67, 0x9c76, 0x9c78, 0x9ce7,
/* 08 */ 0x9cec, 0x9cf0, 0x9d09, 0x9d08, 0x9ceb, 0x9d03, 0x9d06, 0x9d2a,
/* 10 */ 0x9d26, 0x9daf, 0x9d23, 0x9d1f, 0x9d44, 0x9d15, 0x9d12, 0x9d41,
/* 18 */ 0x9d3f, 0x9d3e, 0x9d46, 0x9d48, 0x9d5d, 0x9d5e, 0x9d64, 0x9d51,
/* 20 */ 0x9d50, 0x9d59, 0x9d72, 0x9d89, 0x9d87, 0x9dab, 0x9d6f, 0x9d7a,
/* 28 */ 0x9d9a, 0x9da4, 0x9da9, 0x9db2, 0x9dc4, 0x9dc1, 0x9dbb, 0x9db8,
/* 30 */ 0x9dba, 0x9dc6, 0x9dcf, 0x9dc2, 0x9dd9, 0x9dd3, 0x9df8, 0x9de6,
/* 38 */ 0x9ded, 0x9def, 0x9dfd, 0x9e1a, 0x9e1b, 0x9e1e, 0x9e75, 0x9e79
},

/* Row 0x0b8 */
{
/* 00 */ 0x9e7d, 0x9e81, 0x9e88, 0x9e8b, 0x9e8c, 0x9e92, 0x9e95, 0x9e91,
/* 08 */ 0x9e9d, 0x9ea5, 0x9ea9, 0x9eb8, 0x9eaa, 0x9ead, 0x9761, 0x9ecc,
/* 10 */ 0x9ece, 0x9ecf, 0x9ed0, 0x9ed4, 0x9edc, 0x9ede, 0x9edd, 0x9ee0,
/* 18 */ 0x9ee5, 0x9ee8, 0x9eef, 0x9ef4, 0x9ef6, 0x9ef7, 0x9ef9, 0x9efb,
/* 20 */ 0x9efc, 0x9efd, 0x9f07, 0x9f08, 0x76b7, 0x9f15, 0x9f21, 0x9f2c,
/* 28 */ 0x9f3e, 0x9f4a, 0x9f52, 0x9f54, 0x9f63, 0x9f5f, 0x9f60, 0x9f61,
/* 30 */ 0x9f66, 0x9f67, 0x9f6c, 0x9f6a, 0x9f77, 0x9f72, 0x9f76, 0x9f95,
/* 38 */ 0x9f9c, 0x9fa0, 0x582f, 0x69c7, 0x9059, 0x7464, 0x51dc, 0x7199
},

/* Row 0x0b9 */
{
/* 00 */ 0xed8b, 0xed8c, 0xed8d, 0xed8e, 0xed8f, 0xed90, 0xed91, 0xed92,
/* 08 */ 0xed93, 0xed94, 0xed95, 0xed96, 0xed97, 0xed98, 0xed99, 0xed9a,
/* 10 */ 0xed9b, 0xed9c, 0xed9d, 0xed9e, 0xed9f, 0xeda0, 0xeda1, 0xeda2,
/* 18 */ 0xeda3, 0xeda4, 0xeda5, 0xeda6, 0xeda7, 0xeda8, 0xeda9, 0xedaa,
/* 20 */ 0xedab, 0xedac, 0xedad, 0xedae, 0xedaf, 0xedb0, 0xedb1, 0xedb2,
/* 28 */ 0xedb3, 0xedb4, 0xedb5, 0xedb6, 0xedb7, 0xedb8, 0xedb9, 0xedba,
/* 30 */ 0xedbb, 0xedbc, 0xedbd, 0xedbe, 0xedbf, 0xedc0, 0xedc1, 0xedc2,
/* 38 */ 0xedc3, 0xedc4, 0xedc5, 0xedc6, 0xedc7, 0xedc8, 0xedc9, 0xedca
},

/* Row 0x0ba */
{
/* 00 */ 0xedcb, 0xedcc, 0xedcd, 0xedce, 0xedcf, 0xedd0, 0xedd1, 0xedd2,
/* 08 */ 0xedd3, 0xedd4, 0xedd5, 0xedd6, 0xedd7, 0xedd8, 0xedd9, 0xedda,
/* 10 */ 0xeddb, 0xeddc, 0xeddd, 0xedde, 0xeddf, 0xede0, 0xede1, 0xede2,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0bb */
{
/* 00 */ 0x0080, 0x0081, 0x0082, 0x0083, 0x0084, 0x0085, 0x0086, 0x0087,
/* 08 */ 0x0088, 0x0089, 0x008a, 0x008b, 0x008c, 0x008d,    BAD,    BAD,
/* 10 */ 0x0090, 0x0091, 0x0092, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097,
/* 18 */ 0x0098, 0x0099, 0x009a, 0x009b, 0x009c, 0x009d, 0x009e, 0x009f,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0bc */
{
/* 00 */ 0xede3, 0xede4, 0xede5, 0xede6, 0xede7, 0xede8, 0xede9, 0xedea,
/* 08 */ 0xedeb, 0xedec, 0xeded, 0xedee, 0xedef, 0xedf0, 0xedf1, 0xedf2,
/* 10 */ 0xedf3, 0xedf4, 0xedf5, 0xedf6, 0xedf7, 0xedf8, 0xedf9, 0xedfa,
/* 18 */ 0xedfb, 0xedfc, 0xedfd, 0xedfe, 0xedff, 0xee00, 0xee01, 0xee02,
/* 20 */ 0xee03, 0xee04, 0xee05, 0xee06, 0xee07, 0xee08, 0xee09, 0xee0a,
/* 28 */ 0xee0b, 0xee0c, 0xee0d, 0xee0e, 0xee0f, 0xee10, 0xee11, 0xee12,
/* 30 */ 0xee13, 0xee14, 0xee15, 0xee16, 0xee17, 0xee18, 0xee19, 0xee1a,
/* 38 */ 0xee1b, 0xee1c, 0xee1d, 0xee1e, 0xee1f, 0xee20, 0xee21, 0xee22
},

/* Row 0x0bd */
{
/* 00 */ 0xee23, 0xee24, 0xee25, 0xee26, 0xee27, 0xee28, 0xee29, 0xee2a,
/* 08 */ 0xee2b, 0xee2c, 0xee2d, 0xee2e, 0xee2f, 0xee30, 0xee31, 0xee32,
/* 10 */ 0xee33, 0xee34, 0xee35, 0xee36, 0xee37, 0xee38, 0xee39, 0xee3a,
/* 18 */ 0xee3b, 0xee3c, 0xee3d, 0xee3e, 0xee3f, 0xee40, 0xee41, 0xee42,
/* 20 */ 0xee43, 0xee44, 0xee45, 0xee46, 0xee47, 0xee48, 0xee49, 0xee4a,
/* 28 */ 0xee4b, 0xee4c, 0xee4d, 0xee4e, 0x02d8, 0x02c7, 0x00b8, 0x02d9,
/* 30 */ 0x02dd, 0x00af, 0x02db, 0x02da, 0x301c, 0x0384, 0x0385, 0xee4f,
/* 38 */ 0xee50, 0xee51, 0xee52, 0xee53, 0xee54, 0xee55, 0xee56, 0x00a1
},

/* Row 0x0be */
{
/* 00 */ 0x00a6, 0x00bf, 0xee57, 0xee58, 0xee59, 0xee5a, 0xee5b, 0xee5c,
/* 08 */ 0xee5d, 0xee5e, 0xee5f, 0xee60, 0xee61, 0xee62, 0xee63, 0xee64,
/* 10 */ 0xee65, 0xee66, 0xee67, 0xee68, 0xee69, 0xee6a, 0xee6b, 0xee6c,
/* 18 */ 0xee6d, 0xee6e, 0xee6f, 0xee70, 0xee71, 0xee72, 0xee73, 0xee74,
/* 20 */ 0xee75, 0xee76, 0xee77, 0xee78, 0xee79, 0xee7a, 0xee7b, 0xee7c,
/* 28 */ 0x00ba, 0x00aa, 0x00a9, 0x00ae, 0x2122, 0x00a4, 0x2116, 0xee7d,
/* 30 */ 0xee7e, 0xee7f, 0xee80, 0xee81, 0xee82, 0xee83, 0xee84, 0xee85,
/* 38 */ 0xee86, 0xee87, 0xee88, 0xee89, 0xee8a, 0xee8b, 0xee8c, 0xee8d
},

/* Row 0x0bf */
{
/* 00 */ 0xee8e, 0xee8f, 0xee90, 0xee91, 0xee92, 0xee93, 0xee94, 0xee95,
/* 08 */ 0xee96, 0xee97, 0xee98, 0xee99, 0xee9a, 0xee9b, 0xee9c, 0xee9d,
/* 10 */ 0xee9e, 0xee9f, 0xeea0, 0xeea1, 0xeea2, 0xeea3, 0xeea4, 0xeea5,
/* 18 */ 0xeea6, 0xeea7, 0xeea8, 0xeea9, 0xeeaa, 0xeeab, 0xeeac, 0xeead,
/* 20 */ 0xeeae, 0xeeaf, 0xeeb0, 0xeeb1, 0xeeb2, 0xeeb3, 0xeeb4, 0xeeb5,
/* 28 */ 0xeeb6, 0xeeb7, 0xeeb8, 0xeeb9, 0xeeba, 0xeebb, 0xeebc, 0xeebd,
/* 30 */ 0xeebe, 0xeebf, 0xeec0, 0xeec1, 0xeec2, 0xeec3, 0xeec4, 0xeec5,
/* 38 */ 0xeec6, 0xeec7, 0xeec8, 0xeec9, 0xeeca, 0xeecb, 0xeecc, 0xeecd
},

/* Row 0x0c0 */
{
/* 00 */ 0xeece, 0xeecf, 0xeed0, 0xeed1, 0xeed2, 0xeed3, 0xeed4, 0xeed5,
/* 08 */ 0xeed6, 0xeed7, 0xeed8, 0xeed9, 0xeeda, 0xeedb, 0xeedc, 0xeedd,
/* 10 */ 0xeede, 0xeedf, 0xeee0, 0xeee1, 0xeee2, 0xeee3, 0xeee4, 0xeee5,
/* 18 */ 0xeee6, 0xeee7, 0xeee8, 0xeee9, 0xeeea, 0xeeeb, 0xeeec, 0xeeed,
/* 20 */ 0xeeee, 0xeeef, 0xeef0, 0xeef1, 0xeef2, 0xeef3, 0xeef4, 0xeef5,
/* 28 */ 0xeef6, 0xeef7, 0xeef8, 0xeef9, 0xeefa, 0xeefb, 0xeefc, 0xeefd,
/* 30 */ 0xeefe, 0xeeff, 0xef00, 0xef01, 0xef02, 0xef03, 0xef04, 0xef05,
/* 38 */ 0xef06, 0xef07, 0xef08, 0xef09, 0xef0a, 0xef0b, 0xef0c, 0xef0d
},

/* Row 0x0c1 */
{
/* 00 */ 0xef0e, 0xef0f, 0xef10, 0xef11, 0xef12, 0xef13, 0xef14, 0xef15,
/* 08 */ 0xef16, 0xef17, 0xef18, 0xef19, 0xef1a, 0xef1b, 0xef1c, 0xef1d,
/* 10 */ 0xef1e, 0xef1f, 0xef20, 0xef21, 0xef22, 0xef23, 0xef24, 0xef25,
/* 18 */ 0xef26, 0xef27, 0xef28, 0xef29, 0xef2a, 0xef2b, 0xef2c, 0xef2d,
/* 20 */ 0xef2e, 0xef2f, 0xef30, 0xef31, 0xef32, 0xef33, 0xef34, 0xef35,
/* 28 */ 0xef36, 0xef37, 0xef38, 0xef39, 0xef3a, 0xef3b, 0xef3c, 0xef3d,
/* 30 */ 0xef3e, 0xef3f, 0xef40, 0xef41, 0xef42, 0xef43, 0xef44, 0xef45,
/* 38 */ 0xef46, 0xef47, 0xef48, 0xef49, 0xef4a, 0xef4b, 0xef4c, 0xef4d
},

/* Row 0x0c2 */
{
/* 00 */ 0xef4e, 0xef4f, 0xef50, 0xef51, 0xef52, 0xef53, 0xef54, 0xef55,
/* 08 */ 0xef56, 0xef57, 0xef58, 0xef59, 0xef5a, 0xef5b, 0xef5c, 0xef5d,
/* 10 */ 0xef5e, 0xef5f, 0xef60, 0xef61, 0xef62, 0xef63, 0xef64, 0xef65,
/* 18 */ 0xef66, 0xef67, 0xef68, 0xef69, 0xef6a, 0xef6b, 0xef6c, 0xef6d,
/* 20 */ 0xef6e, 0xef6f, 0xef70, 0xef71, 0xef72, 0xef73, 0xef74, 0xef75,
/* 28 */ 0xef76, 0xef77, 0xef78, 0xef79, 0xef7a, 0xef7b, 0xef7c, 0xef7d,
/* 30 */ 0xef7e, 0xef7f, 0xef80, 0xef81, 0xef82, 0xef83, 0xef84, 0xef85,
/* 38 */ 0xef86, 0xef87, 0xef88, 0xef89, 0xef8a, 0xef8b, 0xef8c, 0xef8d
},

/* Row 0x0c3 */
{
/* 00 */ 0xef8e, 0xef8f, 0xef90, 0xef91, 0xef92, 0xef93, 0xef94, 0xef95,
/* 08 */ 0xef96, 0xef97, 0xef98, 0xef99, 0xef9a, 0xef9b, 0xef9c, 0xef9d,
/* 10 */ 0xef9e, 0xef9f, 0xefa0, 0xefa1, 0xefa2, 0xefa3, 0xefa4, 0xefa5,
/* 18 */ 0xefa6, 0xefa7, 0xefa8, 0xefa9, 0xefaa, 0xefab, 0xefac, 0xefad,
/* 20 */ 0xefae, 0xefaf, 0xefb0, 0xefb1, 0xefb2, 0xefb3, 0xefb4, 0xefb5,
/* 28 */ 0xefb6, 0xefb7, 0xefb8, 0xefb9, 0xefba, 0xefbb, 0xefbc, 0xefbd,
/* 30 */ 0xefbe, 0xefbf, 0xefc0, 0xefc1, 0xefc2, 0xefc3, 0xefc4, 0xefc5,
/* 38 */ 0xefc6, 0xefc7, 0xefc8, 0xefc9, 0xefca, 0xefcb, 0xefcc, 0xefcd
},

/* Row 0x0c4 */
{
/* 00 */ 0xefce, 0xefcf, 0xefd0, 0xefd1, 0xefd2, 0xefd3, 0xefd4, 0xefd5,
/* 08 */ 0xefd6, 0xefd7, 0xefd8, 0xefd9, 0xefda, 0xefdb, 0xefdc, 0xefdd,
/* 10 */ 0xefde, 0xefdf, 0xefe0, 0xefe1, 0xefe2, 0xefe3, 0x0386, 0x0388,
/* 18 */ 0x0389, 0x038a, 0x03aa, 0xefe4, 0x038c, 0xefe5, 0x038e, 0x03ab,
/* 20 */ 0xefe6, 0x038f, 0xefe7, 0xefe8, 0xefe9, 0xefea, 0x03ac, 0x03ad,
/* 28 */ 0x03ae, 0x03af, 0x03ca, 0x0390, 0x03cc, 0x03c2, 0x03cd, 0x03cb,
/* 30 */ 0x03b0, 0x03ce, 0xefeb, 0xefec, 0xefed, 0xefee, 0xefef, 0xeff0,
/* 38 */ 0xeff1, 0xeff2, 0xeff3, 0xeff4, 0xeff5, 0xeff6, 0xeff7, 0xeff8
},

/* Row 0x0c5 */
{
/* 00 */ 0xeff9, 0xeffa, 0xeffb, 0xeffc, 0xeffd, 0xeffe, 0xefff, 0xf000,
/* 08 */ 0xf001, 0xf002, 0xf003, 0xf004, 0xf005, 0xf006, 0xf007, 0xf008,
/* 10 */ 0xf009, 0xf00a, 0xf00b, 0xf00c, 0xf00d, 0x0402, 0x0403, 0x0404,
/* 18 */ 0x0405, 0x0406, 0x0407, 0x0408, 0x0409, 0x040a, 0x040b, 0x040c,
/* 20 */ 0x040e, 0x040f, 0xf00e, 0xf00f, 0xf010, 0xf011, 0xf012, 0xf013,
/* 28 */ 0xf014, 0xf015, 0xf016, 0xf017, 0xf018, 0xf019, 0xf01a, 0xf01b,
/* 30 */ 0xf01c, 0xf01d, 0xf01e, 0xf01f, 0xf020, 0xf021, 0xf022, 0xf023,
/* 38 */ 0xf024, 0xf025, 0xf026, 0xf027, 0xf028, 0xf029, 0xf02a, 0xf02b
},

/* Row 0x0c6 */
{
/* 00 */ 0xf02c, 0xf02d, 0xf02e, 0xf02f, 0xf030, 0x0452, 0x0453, 0x0454,
/* 08 */ 0x0455, 0x0456, 0x0457, 0x0458, 0x0459, 0x045a, 0x045b, 0x045c,
/* 10 */ 0x045e, 0x045f, 0xf031, 0xf032, 0xf033, 0xf034, 0xf035, 0xf036,
/* 18 */ 0xf037, 0xf038, 0xf039, 0xf03a, 0xf03b, 0xf03c, 0xf03d, 0xf03e,
/* 20 */ 0xf03f, 0xf040, 0xf041, 0xf042, 0xf043, 0xf044, 0xf045, 0xf046,
/* 28 */ 0xf047, 0xf048, 0xf049, 0xf04a, 0xf04b, 0xf04c, 0xf04d, 0xf04e,
/* 30 */ 0xf04f, 0xf050, 0xf051, 0xf052, 0xf053, 0xf054, 0xf055, 0xf056,
/* 38 */ 0xf057, 0xf058, 0xf059, 0xf05a, 0xf05b, 0xf05c, 0xf05d, 0xf05e
},

/* Row 0x0c7 */
{
/* 00 */ 0xf05f, 0xf060, 0xf061, 0xf062, 0xf063, 0xf064, 0xf065, 0xf066,
/* 08 */ 0xf067, 0xf068, 0xf069, 0xf06a, 0xf06b, 0xf06c, 0xf06d, 0xf06e,
/* 10 */ 0xf06f, 0xf070, 0xf071, 0xf072, 0xf073, 0xf074, 0xf075, 0xf076,
/* 18 */ 0xf077, 0xf078, 0xf079, 0xf07a, 0xf07b, 0xf07c, 0xf07d, 0xf07e,
/* 20 */ 0xf07f, 0xf080, 0xf081, 0xf082, 0xf083, 0xf084, 0xf085, 0xf086,
/* 28 */ 0xf087, 0xf088, 0xf089, 0xf08a, 0xf08b, 0xf08c, 0xf08d, 0xf08e,
/* 30 */ 0x00c6, 0x0110, 0xf08f, 0x0126, 0xf090, 0x0132, 0xf091, 0x0141,
/* 38 */ 0x013f, 0xf092, 0x014a, 0x00d8, 0x0152, 0xf093, 0x0166, 0x00de
},

/* Row 0x0c8 */
{
/* 00 */ 0xf094, 0xf095, 0xf096, 0xf097, 0xf098, 0xf099, 0xf09a, 0xf09b,
/* 08 */ 0xf09c, 0xf09d, 0xf09e, 0xf09f, 0xf0a0, 0xf0a1, 0xf0a2, 0xf0a3,
/* 10 */ 0x00e6, 0x0111, 0x00f0, 0x0127, 0x0131, 0x0133, 0x0138, 0x0142,
/* 18 */ 0x0140, 0x0149, 0x014b, 0x00f8, 0x0153, 0x00df, 0x0167, 0x00fe,
/* 20 */ 0xf0a4, 0xf0a5, 0xf0a6, 0xf0a7, 0xf0a8, 0xf0a9, 0xf0aa, 0xf0ab,
/* 28 */ 0xf0ac, 0xf0ad, 0xf0ae, 0xf0af, 0xf0b0, 0xf0b1, 0xf0b2, 0xf0b3,
/* 30 */ 0xf0b4, 0xf0b5, 0xf0b6, 0xf0b7, 0xf0b8, 0xf0b9, 0xf0ba, 0xf0bb,
/* 38 */ 0xf0bc, 0xf0bd, 0xf0be, 0xf0bf, 0xf0c0, 0xf0c1, 0xf0c2, 0xf0c3
},

/* Row 0x0c9 */
{
/* 00 */ 0xf0c4, 0xf0c5, 0xf0c6, 0xf0c7, 0xf0c8, 0xf0c9, 0xf0ca, 0xf0cb,
/* 08 */ 0xf0cc, 0xf0cd, 0xf0ce, 0xf0cf, 0xf0d0, 0xf0d1, 0x00c1, 0x00c0,
/* 10 */ 0x00c4, 0x00c2, 0x0102, 0x01cd, 0x0100, 0x0104, 0x00c5, 0x00c3,
/* 18 */ 0x0106, 0x0108, 0x010c, 0x00c7, 0x010a, 0x010e, 0x00c9, 0x00c8,
/* 20 */ 0x00cb, 0x00ca, 0x011a, 0x0116, 0x0112, 0x0118, 0xf0d2, 0x011c,
/* 28 */ 0x011e, 0x0122, 0x0120, 0x0124, 0x00cd, 0x00cc, 0x00cf, 0x00ce,
/* 30 */ 0x01cf, 0x0130, 0x012a, 0x012e, 0x0128, 0x0134, 0x0136, 0x0139,
/* 38 */ 0x013d, 0x013b, 0x0143, 0x0147, 0x0145, 0x00d1, 0x00d3, 0x00d2
},

/* Row 0x0ca */
{
/* 00 */ 0x00d6, 0x00d4, 0x01d1, 0x0150, 0x014c, 0x00d5, 0x0154, 0x0158,
/* 08 */ 0x0156, 0x015a, 0x015c, 0x0160, 0x015e, 0x0164, 0x0162, 0x00da,
/* 10 */ 0x00d9, 0x00dc, 0x00db, 0x016c, 0x01d3, 0x0170, 0x016a, 0x0172,
/* 18 */ 0x016e, 0x0168, 0x01d7, 0x01db, 0x01d9, 0x01d5, 0x0174, 0x00dd,
/* 20 */ 0x0178, 0x0176, 0x0179, 0x017d, 0x017b, 0xf0d3, 0xf0d4, 0xf0d5,
/* 28 */ 0xf0d6, 0xf0d7, 0xf0d8, 0xf0d9, 0x00e1, 0x00e0, 0x00e4, 0x00e2,
/* 30 */ 0x0103, 0x01ce, 0x0101, 0x0105, 0x00e5, 0x00e3, 0x0107, 0x0109,
/* 38 */ 0x010d, 0x00e7, 0x010b, 0x010f, 0x00e9, 0x00e8, 0x00eb, 0x00ea
},

/* Row 0x0cb */
{
/* 00 */ 0x011b, 0x0117, 0x0113, 0x0119, 0x01f5, 0x011d, 0x011f, 0xf0da,
/* 08 */ 0x0121, 0x0125, 0x00ed, 0x00ec, 0x00ef, 0x00ee, 0x01d0, 0xf0db,
/* 10 */ 0x012b, 0x012f, 0x0129, 0x0135, 0x0137, 0x013a, 0x013e, 0x013c,
/* 18 */ 0x0144, 0x0148, 0x0146, 0x00f1, 0x00f3, 0x00f2, 0x00f6, 0x00f4,
/* 20 */ 0x01d2, 0x0151, 0x014d, 0x00f5, 0x0155, 0x0159, 0x0157, 0x015b,
/* 28 */ 0x015d, 0x0161, 0x015f, 0x0165, 0x0163, 0x00fa, 0x00f9, 0x00fc,
/* 30 */ 0x00fb, 0x016d, 0x01d4, 0x0171, 0x016b, 0x0173, 0x016f, 0x0169,
/* 38 */ 0x01d8, 0x01dc, 0x01da, 0x01d6, 0x0175, 0x00fd, 0x00ff, 0x0177
},

/* Row 0x0cc */
{
/* 00 */ 0x017a, 0x017e, 0x017c, 0xf0dc, 0xf0dd, 0xf0de, 0xf0df, 0xf0e0,
/* 08 */ 0xf0e1, 0xf0e2, 0xf0e3, 0xf0e4, 0xf0e5, 0xf0e6, 0xf0e7, 0xf0e8,
/* 10 */ 0xf0e9, 0xf0ea, 0xf0eb, 0xf0ec, 0xf0ed, 0xf0ee, 0xf0ef, 0xf0f0,
/* 18 */ 0xf0f1, 0xf0f2, 0xf0f3, 0xf0f4, 0xf0f5, 0xf0f6, 0xf0f7, 0xf0f8,
/* 20 */ 0xf0f9, 0xf0fa, 0xf0fb, 0xf0fc, 0xf0fd, 0xf0fe, 0xf0ff, 0xf100,
/* 28 */ 0xf101, 0xf102, 0xf103, 0xf104, 0xf105, 0xf106, 0xf107, 0xf108,
/* 30 */ 0xf109, 0xf10a, 0xf10b, 0xf10c, 0xf10d, 0xf10e, 0xf10f, 0xf110,
/* 38 */ 0xf111, 0xf112, 0xf113, 0xf114, 0xf115, 0xf116, 0xf117, 0xf118
},

/* Row 0x0cd */
{
/* 00 */ 0xf119, 0xf11a, 0xf11b, 0xf11c, 0xf11d, 0xf11e, 0xf11f, 0xf120,
/* 08 */ 0xf121, 0xf122, 0xf123, 0xf124, 0xf125, 0xf126, 0xf127, 0xf128,
/* 10 */ 0xf129, 0xf12a, 0xf12b, 0xf12c, 0xf12d, 0xf12e, 0xf12f, 0xf130,
/* 18 */ 0xf131, 0xf132, 0xf133, 0xf134, 0xf135, 0xf136, 0xf137, 0xf138,
/* 20 */ 0xf139, 0xf13a, 0xf13b, 0xf13c, 0xf13d, 0xf13e, 0xf13f, 0xf140,
/* 28 */ 0xf141, 0xf142, 0xf143, 0xf144, 0xf145, 0xf146, 0xf147, 0xf148,
/* 30 */ 0xf149, 0xf14a, 0xf14b, 0xf14c, 0xf14d, 0xf14e, 0xf14f, 0xf150,
/* 38 */ 0xf151, 0xf152, 0xf153, 0xf154, 0xf155, 0xf156, 0xf157, 0xf158
},

/* Row 0x0ce */
{
/* 00 */ 0xf159, 0xf15a, 0xf15b, 0xf15c, 0xf15d, 0xf15e, 0xf15f, 0xf160,
/* 08 */ 0xf161, 0xf162, 0xf163, 0xf164, 0xf165, 0xf166, 0xf167, 0xf168,
/* 10 */ 0xf169, 0xf16a, 0xf16b, 0xf16c, 0xf16d, 0xf16e, 0xf16f, 0xf170,
/* 18 */ 0xf171, 0xf172, 0xf173, 0xf174, 0xf175, 0xf176, 0xf177, 0xf178,
/* 20 */ 0xf179, 0xf17a, 0xf17b, 0xf17c, 0xf17d, 0xf17e, 0xf17f, 0xf180,
/* 28 */ 0xf181, 0xf182, 0xf183, 0xf184, 0xf185, 0xf186, 0xf187, 0xf188,
/* 30 */ 0xf189, 0xf18a, 0xf18b, 0xf18c, 0xf18d, 0xf18e, 0xf18f, 0xf190,
/* 38 */ 0xf191, 0xf192, 0xf193, 0xf194, 0xf195, 0xf196, 0xf197, 0xf198
},

/* Row 0x0cf */
{
/* 00 */ 0xf199, 0xf19a, 0xf19b, 0xf19c, 0xf19d, 0xf19e, 0xf19f, 0xf1a0,
/* 08 */ 0xf1a1, 0xf1a2, 0xf1a3, 0xf1a4, 0xf1a5, 0xf1a6, 0xf1a7, 0xf1a8,
/* 10 */ 0xf1a9, 0xf1aa, 0xf1ab, 0xf1ac, 0xf1ad, 0xf1ae, 0xf1af, 0xf1b0,
/* 18 */ 0xf1b1, 0xf1b2, 0xf1b3, 0xf1b4, 0xf1b5, 0xf1b6, 0xf1b7, 0xf1b8,
/* 20 */ 0xf1b9, 0xf1ba, 0xf1bb, 0xf1bc, 0xf1bd, 0xf1be, 0xf1bf, 0xf1c0,
/* 28 */ 0xf1c1, 0xf1c2, 0xf1c3, 0xf1c4, 0xf1c5, 0xf1c6, 0xf1c7, 0xf1c8,
/* 30 */ 0xf1c9, 0xf1ca, 0xf1cb, 0xf1cc, 0xf1cd, 0xf1ce, 0xf1cf, 0xf1d0,
/* 38 */ 0xf1d1, 0xf1d2, 0xf1d3, 0xf1d4, 0xf1d5, 0xf1d6, 0xf1d7, 0xf1d8
},

/* Row 0x0d0 */
{
/* 00 */ 0xf1d9, 0xf1da, 0xf1db, 0xf1dc, 0xf1dd, 0xf1de, 0xf1df, 0xf1e0,
/* 08 */ 0xf1e1, 0xf1e2, 0xf1e3, 0xf1e4, 0xf1e5, 0xf1e6, 0xf1e7, 0xf1e8,
/* 10 */ 0xf1e9, 0xf1ea, 0xf1eb, 0xf1ec, 0xf1ed, 0xf1ee, 0xf1ef, 0xf1f0,
/* 18 */ 0xf1f1, 0xf1f2, 0xf1f3, 0xf1f4, 0xf1f5, 0xf1f6, 0xf1f7, 0xf1f8,
/* 20 */ 0xf1f9, 0xf1fa, 0xf1fb, 0xf1fc, 0xf1fd, 0xf1fe, 0xf1ff, 0xf200,
/* 28 */ 0xf201, 0xf202, 0xf203, 0xf204, 0xf205, 0xf206, 0xf207, 0xf208,
/* 30 */ 0xf209, 0xf20a, 0xf20b, 0xf20c, 0xf20d, 0xf20e, 0xf20f, 0xf210,
/* 38 */ 0xf211, 0xf212, 0xf213, 0xf214, 0xf215, 0xf216, 0xf217, 0xf218
},

/* Row 0x0d1 */
{
/* 00 */ 0xf219, 0xf21a, 0xf21b, 0xf21c, 0xf21d, 0xf21e, 0xf21f, 0xf220,
/* 08 */ 0xf221, 0xf222, 0xf223, 0xf224, 0xf225, 0xf226, 0xf227, 0xf228,
/* 10 */ 0xf229, 0xf22a, 0xf22b, 0xf22c, 0xf22d, 0xf22e, 0xf22f, 0xf230,
/* 18 */ 0xf231, 0xf232, 0xf233, 0xf234, 0xf235, 0xf236, 0xf237, 0xf238,
/* 20 */ 0xf239, 0xf23a, 0xf23b, 0xf23c, 0xf23d, 0xf23e, 0xf23f, 0xf240,
/* 28 */ 0xf241, 0xf242, 0xf243, 0xf244, 0xf245, 0xf246, 0xf247, 0xf248,
/* 30 */ 0xf249, 0xf24a, 0xf24b, 0xf24c, 0xf24d, 0xf24e, 0xf24f, 0xf250,
/* 38 */ 0xf251, 0xf252, 0xf253, 0xf254, 0xf255, 0xf256, 0xf257, 0xf258
},

/* Row 0x0d2 */
{
/* 00 */ 0xf259, 0xf25a, 0x4e02, 0x4e04, 0x4e05, 0x4e0c, 0x4e12, 0x4e1f,
/* 08 */ 0x4e23, 0x4e24, 0x4e28, 0x4e2b, 0x4e2e, 0x4e2f, 0x4e30, 0x4e35,
/* 10 */ 0x4e40, 0x4e41, 0x4e44, 0x4e47, 0x4e51, 0x4e5a, 0x4e5c, 0x4e63,
/* 18 */ 0x4e68, 0x4e69, 0x4e74, 0x4e75, 0x4e79, 0x4e7f, 0x4e8d, 0x4e96,
/* 20 */ 0x4e97, 0x4e9d, 0x4eaf, 0x4eb9, 0x4ec3, 0x4ed0, 0x4eda, 0x4edb,
/* 28 */ 0x4ee0, 0x4ee1, 0x4ee2, 0x4ee8, 0x4eef, 0x4ef1, 0x4ef3, 0x4ef5,
/* 30 */ 0x4efd, 0x4efe, 0x4eff, 0x4f00, 0x4f02, 0x4f03, 0x4f08, 0x4f0b,
/* 38 */ 0x4f0c, 0x4f12, 0x4f15, 0x4f16, 0x4f17, 0x4f19, 0x4f2e, 0x4f31
},

/* Row 0x0d3 */
{
/* 00 */ 0x4f60, 0x4f33, 0x4f35, 0x4f37, 0x4f39, 0x4f3b, 0x4f3e, 0x4f40,
/* 08 */ 0x4f42, 0x4f48, 0x4f49, 0x4f4b, 0x4f4c, 0x4f52, 0x4f54, 0x4f56,
/* 10 */ 0x4f58, 0x4f5f, 0x4f63, 0x4f6a, 0x4f6c, 0x4f6e, 0x4f71, 0x4f77,
/* 18 */ 0x4f78, 0x4f79, 0x4f7a, 0x4f7d, 0x4f7e, 0x4f81, 0x4f82, 0x4f84,
/* 20 */ 0x4f85, 0x4f89, 0x4f8a, 0x4f8c, 0x4f8e, 0x4f90, 0x4f92, 0x4f93,
/* 28 */ 0x4f94, 0x4f97, 0x4f99, 0x4f9a, 0x4f9e, 0x4f9f, 0x4fb2, 0x4fb7,
/* 30 */ 0x4fb9, 0x4fbb, 0x4fbc, 0x4fbd, 0x4fbe, 0x4fc0, 0x4fc1, 0x4fc5,
/* 38 */ 0x4fc6, 0x4fc8, 0x4fc9, 0x4fcb, 0x4fcc, 0x4fcd, 0x4fcf, 0x4fd2
},

/* Row 0x0d4 */
{
/* 00 */ 0x4fdc, 0x4fe0, 0x4fe2, 0x4ff0, 0x4ff2, 0x4ffc, 0x4ffd, 0x4fff,
/* 08 */ 0x5000, 0x5001, 0x5004, 0x5007, 0x500a, 0x500c, 0x500e, 0x5010,
/* 10 */ 0x5013, 0x5017, 0x5018, 0x501b, 0x501c, 0x501d, 0x501e, 0x5022,
/* 18 */ 0x5027, 0x502e, 0x5030, 0x5032, 0x5033, 0x5035, 0x5040, 0x5041,
/* 20 */ 0x5042, 0x5045, 0x5046, 0x504a, 0x504c, 0x504e, 0x5051, 0x5052,
/* 28 */ 0x5053, 0x5057, 0x5059, 0x505f, 0x5060, 0x5062, 0x5063, 0x5066,
/* 30 */ 0x5067, 0x506a, 0x506d, 0x5070, 0x5071, 0x503b, 0x5081, 0x5083,
/* 38 */ 0x5084, 0x5086, 0x508a, 0x508e, 0x508f, 0x5090, 0x5092, 0x5093
},

/* Row 0x0d5 */
{
/* 00 */ 0x5094, 0x5096, 0x509b, 0x509c, 0x509e, 0x509f, 0x50a0, 0x50a1,
/* 08 */ 0x50a2, 0x50aa, 0x50af, 0x50b0, 0x50b9, 0x50ba, 0x50bd, 0x50c0,
/* 10 */ 0x50c3, 0x50c4, 0x50c7, 0x50cc, 0x50ce, 0x50d0, 0x50d3, 0x50d4,
/* 18 */ 0x50d8, 0x50dc, 0x50dd, 0x50df, 0x50e2, 0x50e4, 0x50e6, 0x50e8,
/* 20 */ 0x50e9, 0x50ef, 0x50f1, 0x50f6, 0x50fa, 0x50fe, 0x5103, 0x5106,
/* 28 */ 0x5107, 0x5108, 0x510b, 0x510c, 0x510d, 0x510e, 0x50f2, 0x5110,
/* 30 */ 0x5117, 0x5119, 0x511b, 0x511c, 0x511d, 0x511e, 0x5123, 0x5127,
/* 38 */ 0x5128, 0x512c, 0x512d, 0x512f, 0x5131, 0x5133, 0x5134, 0x5135
},

/* Row 0x0d6 */
{
/* 00 */ 0x5138, 0x5139, 0x5142, 0x514a, 0x514f, 0x5153, 0x5155, 0x5157,
/* 08 */ 0x5158, 0x515f, 0x5164, 0x5166, 0x517e, 0x5183, 0x5184, 0x518b,
/* 10 */ 0x518e, 0x5198, 0x519d, 0x51a1, 0x51a3, 0x51ad, 0x51b8, 0x51ba,
/* 18 */ 0x51bc, 0x51be, 0x51bf, 0x51c2, 0x51c8, 0x51cf, 0x51d1, 0x51d2,
/* 20 */ 0x51d3, 0x51d5, 0x51d8, 0x51de, 0x51e2, 0x51e5, 0x51ee, 0x51f2,
/* 28 */ 0x51f3, 0x51f4, 0x51f7, 0x5201, 0x5202, 0x5205, 0x5212, 0x5213,
/* 30 */ 0x5215, 0x5216, 0x5218, 0x5222, 0x5228, 0x5231, 0x5232, 0x5235,
/* 38 */ 0x523c, 0x5245, 0x5249, 0x5255, 0x5257, 0x5258, 0x525a, 0x525c
},

/* Row 0x0d7 */
{
/* 00 */ 0x525f, 0x5260, 0x5261, 0x5266, 0x526e, 0x5277, 0x5278, 0x5279,
/* 08 */ 0x5280, 0x5282, 0x5285, 0x528a, 0x528c, 0x5293, 0x5295, 0x5296,
/* 10 */ 0x5297, 0x5298, 0x529a, 0x529c, 0x52a4, 0x52a5, 0x52a6, 0x52a7,
/* 18 */ 0x52af, 0x52b0, 0x52b6, 0x52b7, 0x52b8, 0x52ba, 0x52bb, 0x52bd,
/* 20 */ 0x52c0, 0x52c4, 0x52c6, 0x52c8, 0x52cc, 0x52cf, 0x52d1, 0x52d4,
/* 28 */ 0x52d6, 0x52db, 0x52dc, 0x52e1, 0x52e5, 0x52e8, 0x52e9, 0x52ea,
/* 30 */ 0x52ec, 0x52f0, 0x52f1, 0x52f4, 0x52f6, 0x52f7, 0x5300, 0x5303,
/* 38 */ 0x530a, 0x530b, 0x530c, 0x5311, 0x5313, 0x5318, 0x531b, 0x531c
},

/* Row 0x0d8 */
{
/* 00 */ 0x531e, 0x531f, 0x5325, 0x5327, 0x5328, 0x5329, 0x532b, 0x532c,
/* 08 */ 0x532d, 0x5330, 0x5332, 0x5335, 0x533c, 0x533d, 0x533e, 0x5342,
/* 10 */ 0x534c, 0x534b, 0x5359, 0x535b, 0x5361, 0x5363, 0x5365, 0x536c,
/* 18 */ 0x536d, 0x5372, 0x5379, 0x537e, 0x5383, 0x5387, 0x5388, 0x538e,
/* 20 */ 0x5393, 0x5394, 0x5399, 0x539d, 0x53a1, 0x53a4, 0x53aa, 0x53ab,
/* 28 */ 0x53af, 0x53b2, 0x53b4, 0x53b5, 0x53b7, 0x53b8, 0x53ba, 0x53bd,
/* 30 */ 0x53c0, 0x53c5, 0x53cf, 0x53d2, 0x53d3, 0x53d5, 0x53da, 0x53dd,
/* 38 */ 0x53de, 0x53e0, 0x53e6, 0x53e7, 0x53f5, 0x5402, 0x5413, 0x541a
},

/* Row 0x0d9 */
{
/* 00 */ 0x5421, 0x5427, 0x5428, 0x542a, 0x542f, 0x5431, 0x5434, 0x5435,
/* 08 */ 0x5443, 0x5444, 0x5447, 0x544d, 0x544f, 0x545e, 0x5462, 0x5464,
/* 10 */ 0x5466, 0x5467, 0x5469, 0x546b, 0x546d, 0x546e, 0x5474, 0x547f,
/* 18 */ 0x5481, 0x5483, 0x5485, 0x5488, 0x5489, 0x548d, 0x5491, 0x5495,
/* 20 */ 0x5496, 0x549c, 0x549f, 0x54a1, 0x54a6, 0x54a7, 0x54a9, 0x54aa,
/* 28 */ 0x54ad, 0x54ae, 0x54b1, 0x54b7, 0x54b9, 0x54ba, 0x54bb, 0x54bf,
/* 30 */ 0x54c6, 0x54ca, 0x54cd, 0x54ce, 0x54e0, 0x54ea, 0x54ec, 0x54ef,
/* 38 */ 0x54f6, 0x54fc, 0x54fe, 0x54ff, 0x5500, 0x5501, 0x5505, 0x5508
},

/* Row 0x0da */
{
/* 00 */ 0x5509, 0x550c, 0x550d, 0x550e, 0x5515, 0x552a, 0x552b, 0x5532,
/* 08 */ 0x5535, 0x5536, 0x553b, 0x553c, 0x553d, 0x5541, 0x5547, 0x5549,
/* 10 */ 0x554a, 0x554d, 0x5550, 0x5551, 0x5558, 0x555a, 0x555b, 0x555e,
/* 18 */ 0x5560, 0x5561, 0x5564, 0x5566, 0x557f, 0x5581, 0x5582, 0x5586,
/* 20 */ 0x5588, 0x558e, 0x558f, 0x5591, 0x5592, 0x5593, 0x5594, 0x5597,
/* 28 */ 0x55a3, 0x55a4, 0x55ad, 0x55b2, 0x55bf, 0x55c1, 0x55c3, 0x55c6,
/* 30 */ 0x55c9, 0x55cb, 0x55cc, 0x55ce, 0x55d1, 0x55d2, 0x55d3, 0x55d7,
/* 38 */ 0x55d8, 0x55db, 0x55de, 0x55e2, 0x55e9, 0x55f6, 0x55ff, 0x5605
},

/* Row 0x0db */
{
/* 00 */ 0x5608, 0x560a, 0x560d, 0x560e, 0x560f, 0x5610, 0x5611, 0x5612,
/* 08 */ 0x5619, 0x562c, 0x5630, 0x5633, 0x5635, 0x5637, 0x5639, 0x563b,
/* 10 */ 0x563c, 0x563d, 0x563f, 0x5640, 0x5641, 0x5643, 0x5644, 0x5646,
/* 18 */ 0x5649, 0x564b, 0x564d, 0x564f, 0x5654, 0x565e, 0x5660, 0x5661,
/* 20 */ 0x5662, 0x5663, 0x5666, 0x5669, 0x566d, 0x566f, 0x5671, 0x5672,
/* 28 */ 0x5675, 0x5684, 0x5685, 0x5688, 0x568b, 0x568c, 0x5695, 0x5699,
/* 30 */ 0x569a, 0x569d, 0x569e, 0x569f, 0x56a6, 0x56a7, 0x56a8, 0x56a9,
/* 38 */ 0x56ab, 0x56ac, 0x56ad, 0x56b1, 0x56b3, 0x56b7, 0x56be, 0x56c5
},

/* Row 0x0dc */
{
/* 00 */ 0x56c9, 0x56ca, 0x56cb, 0x56cf, 0x56d0, 0x56cc, 0x56cd, 0x56d9,
/* 08 */ 0x56dc, 0x56dd, 0x56df, 0x56e1, 0x56e4, 0x56e5, 0x56e6, 0x56e7,
/* 10 */ 0x56e8, 0x56f1, 0x56eb, 0x56ed, 0x56f6, 0x56f7, 0x5701, 0x5702,
/* 18 */ 0x5707, 0x570a, 0x570c, 0x5711, 0x5715, 0x571a, 0x571b, 0x571d,
/* 20 */ 0x5720, 0x5722, 0x5723, 0x5724, 0x5725, 0x5729, 0x572a, 0x572c,
/* 28 */ 0x572e, 0x572f, 0x5733, 0x5734, 0x573d, 0x573e, 0x573f, 0x5745,
/* 30 */ 0x5746, 0x574c, 0x574d, 0x5752, 0x5762, 0x5765, 0x5767, 0x5768,
/* 38 */ 0x576b, 0x576d, 0x576e, 0x576f, 0x5770, 0x5771, 0x5773, 0x5774
},

/* Row 0x0dd */
{
/* 00 */ 0x5775, 0x5777, 0x5779, 0x577a, 0x577b, 0x577c, 0x577e, 0x5781,
/* 08 */ 0x5783, 0x578c, 0x5794, 0x5797, 0x5799, 0x579a, 0x579c, 0x579d,
/* 10 */ 0x579e, 0x579f, 0x57a1, 0x5795, 0x57a7, 0x57a8, 0x57a9, 0x57ac,
/* 18 */ 0x57b8, 0x57bd, 0x57c7, 0x57c8, 0x57cc, 0x57cf, 0x57d5, 0x57dd,
/* 20 */ 0x57de, 0x57e4, 0x57e6, 0x57e7, 0x57e9, 0x57ed, 0x57f0, 0x57f5,
/* 28 */ 0x57f6, 0x57f8, 0x57fd, 0x57fe, 0x57ff, 0x5803, 0x5804, 0x5808,
/* 30 */ 0x5809, 0x57e1, 0x580c, 0x580d, 0x581b, 0x581e, 0x581f, 0x5820,
/* 38 */ 0x5826, 0x5827, 0x582d, 0x5832, 0x5839, 0x583f, 0x5849, 0x584c
},

/* Row 0x0de */
{
/* 00 */ 0x584d, 0x584f, 0x5850, 0x5855, 0x585f, 0x5861, 0x5864, 0x5867,
/* 08 */ 0x5868, 0x5878, 0x587c, 0x587f, 0x5880, 0x5881, 0x5887, 0x5888,
/* 10 */ 0x5889, 0x588a, 0x588c, 0x588d, 0x588f, 0x5890, 0x5894, 0x5896,
/* 18 */ 0x589d, 0x58a0, 0x58a1, 0x58a2, 0x58a6, 0x58a9, 0x58b1, 0x58b2,
/* 20 */ 0x58c4, 0x58bc, 0x58c2, 0x58c8, 0x58cd, 0x58ce, 0x58d0, 0x58d2,
/* 28 */ 0x58d4, 0x58d6, 0x58da, 0x58dd, 0x58e1, 0x58e2, 0x58e9, 0x58f3,
/* 30 */ 0x5905, 0x5906, 0x590b, 0x590c, 0x5912, 0x5913, 0x5914, 0x8641,
/* 38 */ 0x591d, 0x5921, 0x5923, 0x5924, 0x5928, 0x592f, 0x5930, 0x5933
},

/* Row 0x0df */
{
/* 00 */ 0x5935, 0x5936, 0x593f, 0x5943, 0x5946, 0x5952, 0x5953, 0x5959,
/* 08 */ 0x595b, 0x595d, 0x595e, 0x595f, 0x5961, 0x5963, 0x596b, 0x596d,
/* 10 */ 0x596f, 0x5972, 0x5975, 0x5976, 0x5979, 0x597b, 0x597c, 0x598b,
/* 18 */ 0x598c, 0x598e, 0x5992, 0x5995, 0x5997, 0x599f, 0x59a4, 0x59a7,
/* 20 */ 0x59ad, 0x59ae, 0x59af, 0x59b0, 0x59b3, 0x59b7, 0x59ba, 0x59bc,
/* 28 */ 0x59c1, 0x59c3, 0x59c4, 0x59c8, 0x59ca, 0x59cd, 0x59d2, 0x59dd,
/* 30 */ 0x59de, 0x59df, 0x59e3, 0x59e4, 0x59e7, 0x59ee, 0x59ef, 0x59f1,
/* 38 */ 0x59f2, 0x59f4, 0x59f7, 0x5a00, 0x5a04, 0x5a0c, 0x5a0d, 0x5a0e
},

/* Row 0x0e0 */
{
/* 00 */ 0x5a12, 0x5a13, 0x5a1e, 0x5a23, 0x5a24, 0x5a27, 0x5a28, 0x5a2a,
/* 08 */ 0x5a2d, 0x5a30, 0x5a44, 0x5a45, 0x5a47, 0x5a48, 0x5a4c, 0x5a50,
/* 10 */ 0x5a55, 0x5a5e, 0x5a63, 0x5a65, 0x5a67, 0x5a6d, 0x5a77, 0x5a7a,
/* 18 */ 0x5a7b, 0x5a7e, 0x5a8b, 0x5a90, 0x5a93, 0x5a96, 0x5a99, 0x5a9c,
/* 20 */ 0x5a9e, 0x5a9f, 0x5aa0, 0x5aa2, 0x5aa7, 0x5aac, 0x5ab1, 0x5ab2,
/* 28 */ 0x5ab3, 0x5ab5, 0x5ab8, 0x5aba, 0x5abb, 0x5abf, 0x5ac4, 0x5ac6,
/* 30 */ 0x5ac8, 0x5acf, 0x5ada, 0x5adc, 0x5ae0, 0x5ae5, 0x5aea, 0x5aee,
/* 38 */ 0x5af5, 0x5af6, 0x5afd, 0x5b00, 0x5b01, 0x5b08, 0x5b17, 0x5b34
},

/* Row 0x0e1 */
{
/* 00 */ 0x5b19, 0x5b1b, 0x5b1d, 0x5b21, 0x5b25, 0x5b2d, 0x5b38, 0x5b41,
/* 08 */ 0x5b4b, 0x5b4c, 0x5b52, 0x5b56, 0x5b5e, 0x5b68, 0x5b6e, 0x5b6f,
/* 10 */ 0x5b7c, 0x5b7d, 0x5b7e, 0x5b7f, 0x5b81, 0x5b84, 0x5b86, 0x5b8a,
/* 18 */ 0x5b8e, 0x5b90, 0x5b91, 0x5b93, 0x5b94, 0x5b96, 0x5ba8, 0x5ba9,
/* 20 */ 0x5bac, 0x5bad, 0x5baf, 0x5bb1, 0x5bb2, 0x5bb7, 0x5bba, 0x5bbc,
/* 28 */ 0x5bc0, 0x5bc1, 0x5bcd, 0x5bcf, 0x5bd6, 0x5bd7, 0x5bd8, 0x5bd9,
/* 30 */ 0x5bda, 0x5be0, 0x5bef, 0x5bf1, 0x5bf4, 0x5bfd, 0x5c0c, 0x5c17,
/* 38 */ 0x5c1e, 0x5c1f, 0x5c23, 0x5c26, 0x5c29, 0x5c2b, 0x5c2c, 0x5c2e
},

/* Row 0x0e2 */
{
/* 00 */ 0x5c30, 0x5c32, 0x5c35, 0x5c36, 0x5c59, 0x5c5a, 0x5c5c, 0x5c62,
/* 08 */ 0x5c63, 0x5c67, 0x5c68, 0x5c69, 0x5c6d, 0x5c70, 0x5c74, 0x5c75,
/* 10 */ 0x5c7a, 0x5c7b, 0x5c7c, 0x5c7d, 0x5c87, 0x5c88, 0x5c8a, 0x5c8f,
/* 18 */ 0x5c92, 0x5c9d, 0x5c9f, 0x5ca0, 0x5ca2, 0x5ca3, 0x5ca6, 0x5caa,
/* 20 */ 0x5cb2, 0x5cb4, 0x5cb5, 0x5cba, 0x5cc9, 0x5ccb, 0x5cd2, 0x5cdd,
/* 28 */ 0x5cd7, 0x5cee, 0x5cf1, 0x5cf2, 0x5cf4, 0x5d01, 0x5d06, 0x5d0d,
/* 30 */ 0x5d12, 0x5d2b, 0x5d23, 0x5d24, 0x5d26, 0x5d27, 0x5d31, 0x5d34,
/* 38 */ 0x5d39, 0x5d3d, 0x5d3f, 0x5d42, 0x5d43, 0x5d46, 0x5d48, 0x5d55
},

/* Row 0x0e3 */
{
/* 00 */ 0x5d51, 0x5d59, 0x5d4a, 0x5d5f, 0x5d60, 0x5d61, 0x5d62, 0x5d64,
/* 08 */ 0x5d6a, 0x5d6d, 0x5d70, 0x5d79, 0x5d7a, 0x5d7e, 0x5d7f, 0x5d81,
/* 10 */ 0x5d83, 0x5d88, 0x5d8a, 0x5d92, 0x5d93, 0x5d94, 0x5d95, 0x5d99,
/* 18 */ 0x5d9b, 0x5d9f, 0x5da0, 0x5da7, 0x5dab, 0x5db0, 0x5db4, 0x5db8,
/* 20 */ 0x5db9, 0x5dc3, 0x5dc7, 0x5dcb, 0x5dd0, 0x5dce, 0x5dd8, 0x5dd9,
/* 28 */ 0x5de0, 0x5de4, 0x5de9, 0x5df8, 0x5df9, 0x5e00, 0x5e07, 0x5e0d,
/* 30 */ 0x5e12, 0x5e14, 0x5e15, 0x5e18, 0x5e1f, 0x5e20, 0x5e2e, 0x5e28,
/* 38 */ 0x5e32, 0x5e35, 0x5e3e, 0x5e4b, 0x5e50, 0x5e49, 0x5e51, 0x5e56
},

/* Row 0x0e4 */
{
/* 00 */ 0x5e58, 0x5e5b, 0x5e5c, 0x5e5e, 0x5e68, 0x5e6a, 0x5e6b, 0x5e6c,
/* 08 */ 0x5e6d, 0x5e6e, 0x5e70, 0x5e80, 0x5e8b, 0x5e8e, 0x5ea2, 0x5ea4,
/* 10 */ 0x5ea5, 0x5ea8, 0x5eaa, 0x5eac, 0x5eb1, 0x5eb3, 0x5ebd, 0x5ebe,
/* 18 */ 0x5ebf, 0x5ec6, 0x5ecc, 0x5ecb, 0x5ece, 0x5ed1, 0x5ed2, 0x5ed4,
/* 20 */ 0x5ed5, 0x5edc, 0x5ede, 0x5ee5, 0x5eeb, 0x5f02, 0x5f06, 0x5f07,
/* 28 */ 0x5f08, 0x5f0e, 0x5f19, 0x5f1c, 0x5f1d, 0x5f21, 0x5f22, 0x5f23,
/* 30 */ 0x5f24, 0x5f28, 0x5f2b, 0x5f2c, 0x5f2e, 0x5f30, 0x5f34, 0x5f36,
/* 38 */ 0x5f3b, 0x5f3d, 0x5f3f, 0x5f40, 0x5f44, 0x5f45, 0x5f47, 0x5f4d
},

/* Row 0x0e5 */
{
/* 00 */ 0x5f50, 0x5f54, 0x5f58, 0x5f5b, 0x5f60, 0x5f63, 0x5f64, 0x5f67,
/* 08 */ 0x5f6f, 0x5f72, 0x5f74, 0x5f75, 0x5f78, 0x5f7a, 0x5f7d, 0x5f7e,
/* 10 */ 0x5f89, 0x5f8d, 0x5f8f, 0x5f96, 0x5f9c, 0x5f9d, 0x5fa2, 0x5fa7,
/* 18 */ 0x5fab, 0x5fa4, 0x5fac, 0x5faf, 0x5fb0, 0x5fb1, 0x5fb8, 0x5fc4,
/* 20 */ 0x5fc7, 0x5fc8, 0x5fc9, 0x5fcb, 0x5fd0, 0x5fd1, 0x5fd2, 0x5fd3,
/* 28 */ 0x5fd4, 0x5fde, 0x5fe1, 0x5fe2, 0x5fe8, 0x5fe9, 0x5fea, 0x5fec,
/* 30 */ 0x5fed, 0x5fee, 0x5fef, 0x5ff2, 0x5ff3, 0x5ff6, 0x5ffa, 0x5ffc,
/* 38 */ 0x6007, 0x600a, 0x600d, 0x6013, 0x6014, 0x6017, 0x6018, 0x601a
},

/* Row 0x0e6 */
{
/* 00 */ 0x601f, 0x6024, 0x602d, 0x6033, 0x6035, 0x6040, 0x6047, 0x6048,
/* 08 */ 0x6049, 0x604c, 0x6051, 0x6054, 0x6056, 0x6057, 0x605d, 0x6061,
/* 10 */ 0x6067, 0x6071, 0x607e, 0x607f, 0x6082, 0x6086, 0x6088, 0x608a,
/* 18 */ 0x608e, 0x6091, 0x6093, 0x6095, 0x6098, 0x609d, 0x609e, 0x60a2,
/* 20 */ 0x60a4, 0x60a5, 0x60a8, 0x60b0, 0x60b1, 0x60b7, 0x60bb, 0x60be,
/* 28 */ 0x60c2, 0x60c4, 0x60c8, 0x60c9, 0x60ca, 0x60cb, 0x60ce, 0x60cf,
/* 30 */ 0x60d4, 0x60d5, 0x60d9, 0x60db, 0x60dd, 0x60de, 0x60e2, 0x60e5,
/* 38 */ 0x60f2, 0x60f5, 0x60f8, 0x60fc, 0x60fd, 0x6102, 0x6107, 0x610a
},

/* Row 0x0e7 */
{
/* 00 */ 0x610c, 0x6110, 0x6111, 0x6112, 0x6113, 0x6114, 0x6116, 0x6117,
/* 08 */ 0x6119, 0x611c, 0x611e, 0x6122, 0x612a, 0x612b, 0x6130, 0x6131,
/* 10 */ 0x6135, 0x6136, 0x6137, 0x6139, 0x6141, 0x6145, 0x6146, 0x6149,
/* 18 */ 0x615e, 0x6160, 0x616c, 0x6172, 0x6178, 0x617b, 0x617c, 0x617f,
/* 20 */ 0x6180, 0x6181, 0x6183, 0x6184, 0x618b, 0x618d, 0x6192, 0x6193,
/* 28 */ 0x6197, 0x6198, 0x619c, 0x619d, 0x619f, 0x61a0, 0x61a5, 0x61a8,
/* 30 */ 0x61aa, 0x61ad, 0x61b8, 0x61b9, 0x61bc, 0x61c0, 0x61c1, 0x61c2,
/* 38 */ 0x61ce, 0x61cf, 0x61d5, 0x61dc, 0x61dd, 0x61de, 0x61df, 0x61e1
},

/* Row 0x0e8 */
{
/* 00 */ 0x61e2, 0x61e7, 0x61e9, 0x61e5, 0x61ec, 0x61ed, 0x61ef, 0x6201,
/* 08 */ 0x6203, 0x6204, 0x6207, 0x6213, 0x6215, 0x621c, 0x6220, 0x6222,
/* 10 */ 0x6223, 0x6227, 0x6229, 0x622b, 0x6239, 0x623d, 0x6242, 0x6243,
/* 18 */ 0x6244, 0x6246, 0x624c, 0x6250, 0x6251, 0x6252, 0x6254, 0x6256,
/* 20 */ 0x625a, 0x625c, 0x6264, 0x626d, 0x626f, 0x6273, 0x627a, 0x627d,
/* 28 */ 0x628d, 0x628e, 0x628f, 0x6290, 0x62a6, 0x62a8, 0x62b3, 0x62b6,
/* 30 */ 0x62b7, 0x62ba, 0x62be, 0x62bf, 0x62c4, 0x62ce, 0x62d5, 0x62d6,
/* 38 */ 0x62da, 0x62ea, 0x62f2, 0x62f4, 0x62fc, 0x62fd, 0x6303, 0x6304
},

/* Row 0x0e9 */
{
/* 00 */ 0x630a, 0x630b, 0x630d, 0x6310, 0x6313, 0x6316, 0x6318, 0x6329,
/* 08 */ 0x632a, 0x632d, 0x6335, 0x6336, 0x6339, 0x633c, 0x6341, 0x6342,
/* 10 */ 0x6343, 0x6344, 0x6346, 0x634a, 0x634b, 0x634e, 0x6352, 0x6353,
/* 18 */ 0x6354, 0x6358, 0x635b, 0x6365, 0x6366, 0x636c, 0x636d, 0x6371,
/* 20 */ 0x6374, 0x6375, 0x6378, 0x637c, 0x637d, 0x637f, 0x6382, 0x6384,
/* 28 */ 0x6387, 0x638a, 0x6390, 0x6394, 0x6395, 0x6399, 0x639a, 0x639e,
/* 30 */ 0x63a4, 0x63a6, 0x63ad, 0x63ae, 0x63af, 0x63bd, 0x63c1, 0x63c5,
/* 38 */ 0x63c8, 0x63ce, 0x63d1, 0x63d3, 0x63d4, 0x63d5, 0x63dc, 0x63e0
},

/* Row 0x0ea */
{
/* 00 */ 0x63e5, 0x63ea, 0x63ec, 0x63f2, 0x63f3, 0x63f5, 0x63f8, 0x63f9,
/* 08 */ 0x6409, 0x640a, 0x6410, 0x6412, 0x6414, 0x6418, 0x641e, 0x6420,
/* 10 */ 0x6422, 0x6424, 0x6425, 0x6429, 0x642a, 0x642f, 0x6430, 0x6435,
/* 18 */ 0x643d, 0x643f, 0x644b, 0x644f, 0x6451, 0x6452, 0x6453, 0x6454,
/* 20 */ 0x645a, 0x645b, 0x645c, 0x645d, 0x645f, 0x6460, 0x6461, 0x6463,
/* 28 */ 0x646d, 0x6473, 0x6474, 0x647b, 0x647d, 0x6485, 0x6487, 0x648f,
/* 30 */ 0x6490, 0x6491, 0x6498, 0x6499, 0x649b, 0x649d, 0x649f, 0x64a1,
/* 38 */ 0x64a3, 0x64a6, 0x64a8, 0x64ac, 0x64b3, 0x64bd, 0x64be, 0x64bf
},

/* Row 0x0eb */
{
/* 00 */ 0x64c4, 0x64c9, 0x64ca, 0x64cb, 0x64cc, 0x64ce, 0x64d0, 0x64d1,
/* 08 */ 0x64d5, 0x64d7, 0x64e4, 0x64e5, 0x64e9, 0x64ea, 0x64ed, 0x64f0,
/* 10 */ 0x64f5, 0x64f7, 0x64fb, 0x64ff, 0x6501, 0x6504, 0x6508, 0x6509,
/* 18 */ 0x650a, 0x650f, 0x6513, 0x6514, 0x6516, 0x6519, 0x651b, 0x651e,
/* 20 */ 0x651f, 0x6522, 0x6526, 0x6529, 0x652e, 0x6531, 0x653a, 0x653c,
/* 28 */ 0x653d, 0x6543, 0x6547, 0x6549, 0x6550, 0x6552, 0x6554, 0x655f,
/* 30 */ 0x6560, 0x6567, 0x656b, 0x657a, 0x657d, 0x6581, 0x6585, 0x658a,
/* 38 */ 0x6592, 0x6595, 0x6598, 0x659d, 0x65a0, 0x65a3, 0x65a6, 0x65ae
},

/* Row 0x0ec */
{
/* 00 */ 0x65b2, 0x65b3, 0x65b4, 0x65bf, 0x65c2, 0x65c8, 0x65c9, 0x65ce,
/* 08 */ 0x65d0, 0x65d4, 0x65d6, 0x65d8, 0x65df, 0x65f0, 0x65f2, 0x65f4,
/* 10 */ 0x65f5, 0x65f9, 0x65fe, 0x65ff, 0x6600, 0x6604, 0x6608, 0x6609,
/* 18 */ 0x660d, 0x6611, 0x6612, 0x6615, 0x6616, 0x661d, 0x661e, 0x6621,
/* 20 */ 0x6622, 0x6623, 0x6624, 0x6626, 0x6629, 0x662a, 0x662b, 0x662c,
/* 28 */ 0x662e, 0x6630, 0x6631, 0x6633, 0x6639, 0x6637, 0x6640, 0x6645,
/* 30 */ 0x6646, 0x664a, 0x664c, 0x6651, 0x664e, 0x6657, 0x6658, 0x6659,
/* 38 */ 0x665b, 0x665c, 0x6660, 0x6661, 0x66fb, 0x666a, 0x666b, 0x666c
},

/* Row 0x0ed */
{
/* 00 */ 0x667e, 0x6673, 0x6675, 0x667f, 0x6677, 0x6678, 0x6679, 0x667b,
/* 08 */ 0x6680, 0x667c, 0x668b, 0x668c, 0x668d, 0x6690, 0x6692, 0x6699,
/* 10 */ 0x669a, 0x669b, 0x669c, 0x669f, 0x66a0, 0x66a4, 0x66ad, 0x66b1,
/* 18 */ 0x66b2, 0x66b5, 0x66bb, 0x66bf, 0x66c0, 0x66c2, 0x66c3, 0x66c8,
/* 20 */ 0x66cc, 0x66ce, 0x66cf, 0x66d4, 0x66db, 0x66df, 0x66e8, 0x66eb,
/* 28 */ 0x66ec, 0x66ee, 0x66fa, 0x6705, 0x6707, 0x670e, 0x6713, 0x6719,
/* 30 */ 0x671c, 0x6720, 0x6722, 0x6733, 0x673e, 0x6745, 0x6747, 0x6748,
/* 38 */ 0x674c, 0x6754, 0x6755, 0x675d, 0x6766, 0x676c, 0x676e, 0x6774
},

/* Row 0x0ee */
{
/* 00 */ 0x6776, 0x677b, 0x6781, 0x6784, 0x678e, 0x678f, 0x6791, 0x6793,
/* 08 */ 0x6796, 0x6798, 0x6799, 0x679b, 0x67b0, 0x67b1, 0x67b2, 0x67b5,
/* 10 */ 0x67bb, 0x67bc, 0x67bd, 0x67f9, 0x67c0, 0x67c2, 0x67c3, 0x67c5,
/* 18 */ 0x67c8, 0x67c9, 0x67d2, 0x67d7, 0x67d9, 0x67dc, 0x67e1, 0x67e6,
/* 20 */ 0x67f0, 0x67f2, 0x67f6, 0x67f7, 0x6852, 0x6814, 0x6819, 0x681d,
/* 28 */ 0x681f, 0x6828, 0x6827, 0x682c, 0x682d, 0x682f, 0x6830, 0x6831,
/* 30 */ 0x6833, 0x683b, 0x683f, 0x6844, 0x6845, 0x684a, 0x684c, 0x6855,
/* 38 */ 0x6857, 0x6858, 0x685b, 0x686b, 0x686e, 0x686f, 0x6870, 0x6871
},

/* Row 0x0ef */
{
/* 00 */ 0x6872, 0x6875, 0x6879, 0x687a, 0x687b, 0x687c, 0x6882, 0x6884,
/* 08 */ 0x6886, 0x6888, 0x6896, 0x6898, 0x689a, 0x689c, 0x68a1, 0x68a3,
/* 10 */ 0x68a5, 0x68a9, 0x68aa, 0x68ae, 0x68b2, 0x68bb, 0x68c5, 0x68c8,
/* 18 */ 0x68cc, 0x68cf, 0x68d0, 0x68d1, 0x68d3, 0x68d6, 0x68d9, 0x68dc,
/* 20 */ 0x68dd, 0x68e5, 0x68e8, 0x68ea, 0x68eb, 0x68ec, 0x68ed, 0x68f0,
/* 28 */ 0x68f1, 0x68f5, 0x68f6, 0x68fb, 0x68fc, 0x68fd, 0x6906, 0x6909,
/* 30 */ 0x690a, 0x6910, 0x6911, 0x6913, 0x6916, 0x6917, 0x6931, 0x6933,
/* 38 */ 0x6935, 0x6938, 0x693b, 0x6942, 0x6945, 0x6949, 0x694e, 0x6957
},

/* Row 0x0f0 */
{
/* 00 */ 0x695b, 0x6963, 0x6964, 0x6965, 0x6966, 0x6968, 0x6969, 0x696c,
/* 08 */ 0x6970, 0x6971, 0x6972, 0x697a, 0x697b, 0x697f, 0x6980, 0x698d,
/* 10 */ 0x6992, 0x6996, 0x6998, 0x69a1, 0x69a5, 0x69a6, 0x69a8, 0x69ab,
/* 18 */ 0x69ad, 0x69af, 0x69b7, 0x69b8, 0x69ba, 0x69bc, 0x69c5, 0x69c8,
/* 20 */ 0x69d1, 0x69d6, 0x69d7, 0x69e2, 0x69e5, 0x69ee, 0x69ef, 0x69f1,
/* 28 */ 0x69f3, 0x69f5, 0x69fe, 0x6a00, 0x6a01, 0x6a03, 0x6a0f, 0x6a11,
/* 30 */ 0x6a15, 0x6a1a, 0x6a1d, 0x6a20, 0x6a24, 0x6a28, 0x6a30, 0x6a32,
/* 38 */ 0x6a34, 0x6a37, 0x6a3b, 0x6a3e, 0x6a3f, 0x6a45, 0x6a46, 0x6a49
},

/* Row 0x0f1 */
{
/* 00 */ 0x6a4a, 0x6a4e, 0x6a50, 0x6a51, 0x6a52, 0x6a55, 0x6a56, 0x6a5b,
/* 08 */ 0x6a64, 0x6a67, 0x6a6a, 0x6a71, 0x6a73, 0x6a7e, 0x6a81, 0x6a83,
/* 10 */ 0x6a86, 0x6a87, 0x6a89, 0x6a8b, 0x6a91, 0x6a9b, 0x6a9d, 0x6a9e,
/* 18 */ 0x6a9f, 0x6aa5, 0x6aab, 0x6aaf, 0x6ab0, 0x6ab1, 0x6ab4, 0x6abd,
/* 20 */ 0x6abe, 0x6abf, 0x6ac6, 0x6ac9, 0x6ac8, 0x6acc, 0x6ad0, 0x6ad4,
/* 28 */ 0x6ad5, 0x6ad6, 0x6adc, 0x6add, 0x6ae4, 0x6ae7, 0x6aec, 0x6af0,
/* 30 */ 0x6af1, 0x6af2, 0x6afc, 0x6afd, 0x6b02, 0x6b03, 0x6b06, 0x6b07,
/* 38 */ 0x6b09, 0x6b0f, 0x6b10, 0x6b11, 0x6b17, 0x6b1b, 0x6b1e, 0x6b24
},

/* Row 0x0f2 */
{
/* 00 */ 0x6b28, 0x6b2b, 0x6b2c, 0x6b2f, 0x6b35, 0x6b36, 0x6b3b, 0x6b3f,
/* 08 */ 0x6b46, 0x6b4a, 0x6b4d, 0x6b52, 0x6b56, 0x6b58, 0x6b5d, 0x6b60,
/* 10 */ 0x6b67, 0x6b6b, 0x6b6e, 0x6b70, 0x6b75, 0x6b7d, 0x6b7e, 0x6b82,
/* 18 */ 0x6b85, 0x6b97, 0x6b9b, 0x6b9f, 0x6ba0, 0x6ba2, 0x6ba3, 0x6ba8,
/* 20 */ 0x6ba9, 0x6bac, 0x6bad, 0x6bae, 0x6bb0, 0x6bb8, 0x6bb9, 0x6bbd,
/* 28 */ 0x6bbe, 0x6bc3, 0x6bc4, 0x6bc9, 0x6bcc, 0x6bd6, 0x6bda, 0x6be1,
/* 30 */ 0x6be3, 0x6be6, 0x6be7, 0x6bee, 0x6bf1, 0x6bf7, 0x6bf9, 0x6bff,
/* 38 */ 0x6c02, 0x6c04, 0x6c05, 0x6c09, 0x6c0d, 0x6c0e, 0x6c10, 0x6c12
},

/* Row 0x0f3 */
{
/* 00 */ 0x6c19, 0x6c1f, 0x6c26, 0x6c27, 0x6c28, 0x6c2c, 0x6c2e, 0x6c33,
/* 08 */ 0x6c35, 0x6c36, 0x6c3a, 0x6c3b, 0x6c3f, 0x6c4a, 0x6c4b, 0x6c4d,
/* 10 */ 0x6c4f, 0x6c52, 0x6c54, 0x6c59, 0x6c5b, 0x6c5c, 0x6c6b, 0x6c6d,
/* 18 */ 0x6c6f, 0x6c74, 0x6c76, 0x6c78, 0x6c79, 0x6c7b, 0x6c85, 0x6c86,
/* 20 */ 0x6c87, 0x6c89, 0x6c94, 0x6c95, 0x6c97, 0x6c98, 0x6c9c, 0x6c9f,
/* 28 */ 0x6cb0, 0x6cb2, 0x6cb4, 0x6cc2, 0x6cc6, 0x6ccd, 0x6ccf, 0x6cd0,
/* 30 */ 0x6cd1, 0x6cd2, 0x6cd4, 0x6cd6, 0x6cda, 0x6cdc, 0x6ce0, 0x6ce7,
/* 38 */ 0x6ce9, 0x6ceb, 0x6cec, 0x6cee, 0x6cf2, 0x6cf4, 0x6d04, 0x6d07
},

/* Row 0x0f4 */
{
/* 00 */ 0x6d0a, 0x6d0e, 0x6d0f, 0x6d11, 0x6d13, 0x6d1a, 0x6d26, 0x6d27,
/* 08 */ 0x6d28, 0x6c67, 0x6d2e, 0x6d2f, 0x6d31, 0x6d39, 0x6d3c, 0x6d3f,
/* 10 */ 0x6d57, 0x6d5e, 0x6d5f, 0x6d61, 0x6d65, 0x6d67, 0x6d6f, 0x6d70,
/* 18 */ 0x6d7c, 0x6d82, 0x6d87, 0x6d91, 0x6d92, 0x6d94, 0x6d96, 0x6d97,
/* 20 */ 0x6d98, 0x6daa, 0x6dac, 0x6db4, 0x6db7, 0x6db9, 0x6dbd, 0x6dbf,
/* 28 */ 0x6dc4, 0x6dc8, 0x6dca, 0x6dce, 0x6dcf, 0x6dd6, 0x6ddb, 0x6ddd,
/* 30 */ 0x6ddf, 0x6de0, 0x6de2, 0x6de5, 0x6de9, 0x6def, 0x6df0, 0x6df4,
/* 38 */ 0x6df6, 0x6dfc, 0x6e00, 0x6e04, 0x6e1e, 0x6e22, 0x6e27, 0x6e32
},

/* Row 0x0f5 */
{
/* 00 */ 0x6e36, 0x6e39, 0x6e3b, 0x6e3c, 0x6e44, 0x6e45, 0x6e48, 0x6e49,
/* 08 */ 0x6e4b, 0x6e4f, 0x6e51, 0x6e52, 0x6e53, 0x6e54, 0x6e57, 0x6e5c,
/* 10 */ 0x6e5d, 0x6e5e, 0x6e62, 0x6e63, 0x6e68, 0x6e73, 0x6e7b, 0x6e7d,
/* 18 */ 0x6e8d, 0x6e93, 0x6e99, 0x6ea0, 0x6ea7, 0x6ead, 0x6eae, 0x6eb1,
/* 20 */ 0x6eb3, 0x6ebb, 0x6ebf, 0x6ec0, 0x6ec1, 0x6ec3, 0x6ec7, 0x6ec8,
/* 28 */ 0x6eca, 0x6ecd, 0x6ece, 0x6ecf, 0x6eeb, 0x6eed, 0x6eee, 0x6ef9,
/* 30 */ 0x6efb, 0x6efd, 0x6f04, 0x6f08, 0x6f0a, 0x6f0c, 0x6f0d, 0x6f16,
/* 38 */ 0x6f18, 0x6f1a, 0x6f1b, 0x6f26, 0x6f29, 0x6f2a, 0x6f2f, 0x6f30
},

/* Row 0x0f6 */
{
/* 00 */ 0x6f33, 0x6f36, 0x6f3b, 0x6f3c, 0x6f2d, 0x6f4f, 0x6f51, 0x6f52,
/* 08 */ 0x6f53, 0x6f57, 0x6f59, 0x6f5a, 0x6f5d, 0x6f5e, 0x6f61, 0x6f62,
/* 10 */ 0x6f68, 0x6f6c, 0x6f7d, 0x6f7e, 0x6f83, 0x6f87, 0x6f88, 0x6f8b,
/* 18 */ 0x6f8c, 0x6f8d, 0x6f90, 0x6f92, 0x6f93, 0x6f94, 0x6f96, 0x6f9a,
/* 20 */ 0x6f9f, 0x6fa0, 0x6fa5, 0x6fa6, 0x6fa7, 0x6fa8, 0x6fae, 0x6faf,
/* 28 */ 0x6fb0, 0x6fb5, 0x6fb6, 0x6fbc, 0x6fc5, 0x6fc7, 0x6fc8, 0x6fca,
/* 30 */ 0x6fda, 0x6fde, 0x6fe8, 0x6fe9, 0x6ff0, 0x6ff5, 0x6ff9, 0x6ffc,
/* 38 */ 0x6ffd, 0x7000, 0x7005, 0x7006, 0x7007, 0x700d, 0x7017, 0x7020
},

/* Row 0x0f7 */
{
/* 00 */ 0x7023, 0x702f, 0x7034, 0x7037, 0x7039, 0x703c, 0x7043, 0x7044,
/* 08 */ 0x7048, 0x7049, 0x704a, 0x704b, 0x7054, 0x7055, 0x705d, 0x705e,
/* 10 */ 0x704e, 0x7064, 0x7065, 0x706c, 0x706e, 0x7075, 0x7076, 0x707e,
/* 18 */ 0x7081, 0x7085, 0x7086, 0x7094, 0x7095, 0x7096, 0x7097, 0x7098,
/* 20 */ 0x709b, 0x70a4, 0x70ab, 0x70b0, 0x70b1, 0x70b4, 0x70b7, 0x70ca,
/* 28 */ 0x70d1, 0x70d3, 0x70d4, 0x70d5, 0x70d6, 0x70d8, 0x70dc, 0x70e4,
/* 30 */ 0x70fa, 0x7103, 0x7104, 0x7105, 0x7106, 0x7107, 0x710b, 0x710c,
/* 38 */ 0x710f, 0x711e, 0x7120, 0x712b, 0x712d, 0x712f, 0x7130, 0x7131
},

/* Row 0x0f8 */
{
/* 00 */ 0x7138, 0x7141, 0x7145, 0x7146, 0x7147, 0x714a, 0x714b, 0x7150,
/* 08 */ 0x7152, 0x7157, 0x715a, 0x715c, 0x715e, 0x7160, 0x7168, 0x7179,
/* 10 */ 0x7180, 0x7185, 0x7187, 0x718c, 0x7192, 0x719a, 0x719b, 0x71a0,
/* 18 */ 0x71a2, 0x71af, 0x71b0, 0x71b2, 0x71b3, 0x71ba, 0x71bf, 0x71c0,
/* 20 */ 0x71c1, 0x71c4, 0x71cb, 0x71cc, 0x71d3, 0x71d6, 0x71d9, 0x71da,
/* 28 */ 0x71dc, 0x71f8, 0x71fe, 0x7200, 0x7207, 0x7208, 0x7209, 0x7213,
/* 30 */ 0x7217, 0x721a, 0x721d, 0x721f, 0x7224, 0x722b, 0x722f, 0x7234,
/* 38 */ 0x7238, 0x7239, 0x7241, 0x7242, 0x7243, 0x7245, 0x724e, 0x724f
},

/* Row 0x0f9 */
{
/* 00 */ 0x7250, 0x7253, 0x7255, 0x7256, 0x725a, 0x725c, 0x725e, 0x7260,
/* 08 */ 0x7263, 0x7268, 0x726b, 0x726e, 0x726f, 0x7271, 0x7277, 0x7278,
/* 10 */ 0x727b, 0x727c, 0x727f, 0x7284, 0x7289, 0x728d, 0x728e, 0x7293,
/* 18 */ 0x729b, 0x72a8, 0x72ad, 0x72ae, 0x72b1, 0x72b4, 0x72be, 0x72c1,
/* 20 */ 0x72c7, 0x72c9, 0x72cc, 0x72d5, 0x72d6, 0x72d8, 0x72df, 0x72e5,
/* 28 */ 0x72f3, 0x72f4, 0x72fa, 0x72fb, 0x72fe, 0x7302, 0x7304, 0x7305,
/* 30 */ 0x7307, 0x730b, 0x730d, 0x7312, 0x7313, 0x7318, 0x7319, 0x731e,
/* 38 */ 0x7322, 0x7324, 0x7327, 0x7328, 0x732c, 0x7331, 0x7332, 0x7335
},

/* Row 0x0fa */
{
/* 00 */ 0x733a, 0x733b, 0x733d, 0x7343, 0x734d, 0x7350, 0x7352, 0x7356,
/* 08 */ 0x7358, 0x735d, 0x735e, 0x735f, 0x7360, 0x7366, 0x7367, 0x7369,
/* 10 */ 0x736b, 0x736c, 0x736e, 0x736f, 0x7371, 0x7377, 0x7379, 0x737c,
/* 18 */ 0x7380, 0x7381, 0x7383, 0x7385, 0x7386, 0x738e, 0x7390, 0x7393,
/* 20 */ 0x7395, 0x7397, 0x7398, 0x739c, 0x739e, 0x739f, 0x73a0, 0x73a2,
/* 28 */ 0x73a5, 0x73a6, 0x73aa, 0x73ab, 0x73ad, 0x73b5, 0x73b7, 0x73b9,
/* 30 */ 0x73bc, 0x73bd, 0x73bf, 0x73c5, 0x73c6, 0x73c9, 0x73cb, 0x73cc,
/* 38 */ 0x73cf, 0x73d2, 0x73d3, 0x73d6, 0x73d9, 0x73dd, 0x73e1, 0x73e3
},

/* Row 0x0fb */
{
/* 00 */ 0x73e6, 0x73e7, 0x73e9, 0x73f4, 0x73f5, 0x73f7, 0x73f9, 0x73fa,
/* 08 */ 0x73fb, 0x73fd, 0x73ff, 0x7400, 0x7401, 0x7404, 0x7407, 0x740a,
/* 10 */ 0x7411, 0x741a, 0x741b, 0x7424, 0x7426, 0x7428, 0x7429, 0x742a,
/* 18 */ 0x742b, 0x742c, 0x742d, 0x742e, 0x742f, 0x7430, 0x7431, 0x7439,
/* 20 */ 0x7440, 0x7443, 0x7444, 0x7446, 0x7447, 0x744b, 0x744d, 0x7451,
/* 28 */ 0x7452, 0x7457, 0x745d, 0x7462, 0x7466, 0x7467, 0x7468, 0x746b,
/* 30 */ 0x746d, 0x746e, 0x7471, 0x7472, 0x7480, 0x7481, 0x7485, 0x7486,
/* 38 */ 0x7487, 0x7489, 0x748f, 0x7490, 0x7491, 0x7492, 0x7498, 0x7499
},

/* Row 0x0fc */
{
/* 00 */ 0x749a, 0x749c, 0x749f, 0x74a0, 0x74a1, 0x74a3, 0x74a6, 0x74a8,
/* 08 */ 0x74a9, 0x74aa, 0x74ab, 0x74ae, 0x74af, 0x74b1, 0x74b2, 0x74b5,
/* 10 */ 0x74b9, 0x74bb, 0x74bf, 0x74c8, 0x74c9, 0x74cc, 0x74d0, 0x74d3,
/* 18 */ 0x74d8, 0x74da, 0x74db, 0x74de, 0x74df, 0x74e4, 0x74e8, 0x74ea,
/* 20 */ 0x74eb, 0x74ef, 0x74f4, 0x74fa, 0x74fb, 0x74fc, 0x74ff, 0x7506,
/* 28 */ 0x7512, 0x7516, 0x7517, 0x7520, 0x7521, 0x7524, 0x7527, 0x7529,
/* 30 */ 0x752a, 0x752f, 0x7536, 0x7539, 0x753d, 0x753e, 0x753f, 0x7540,
/* 38 */ 0x7543, 0x7547, 0x7548, 0x754e, 0x7550, 0x7552, 0x7557, 0x755e
},

/* Row 0x0fd */
{
/* 00 */ 0x755f, 0x7561, 0x756f, 0x7571, 0x7579, 0x757a, 0x757b, 0x757c,
/* 08 */ 0x757d, 0x757e, 0x7581, 0x7585, 0x7590, 0x7592, 0x7593, 0x7595,
/* 10 */ 0x7599, 0x759c, 0x75a2, 0x75a4, 0x75b4, 0x75ba, 0x75bf, 0x75c0,
/* 18 */ 0x75c1, 0x75c4, 0x75c6, 0x75cc, 0x75ce, 0x75cf, 0x75d7, 0x75dc,
/* 20 */ 0x75df, 0x75e0, 0x75e1, 0x75e4, 0x75e7, 0x75ec, 0x75ee, 0x75ef,
/* 28 */ 0x75f1, 0x75f9, 0x7600, 0x7602, 0x7603, 0x7604, 0x7607, 0x7608,
/* 30 */ 0x760a, 0x760c, 0x760f, 0x7612, 0x7613, 0x7615, 0x7616, 0x7619,
/* 38 */ 0x761b, 0x761c, 0x761d, 0x761e, 0x7623, 0x7625, 0x7626, 0x7629
},

/* Row 0x0fe */
{
/* 00 */ 0x762d, 0x7632, 0x7633, 0x7635, 0x7638, 0x7639, 0x763a, 0x763c,
/* 08 */ 0x764a, 0x7640, 0x7641, 0x7643, 0x7644, 0x7645, 0x7649, 0x764b,
/* 10 */ 0x7655, 0x7659, 0x765f, 0x7664, 0x7665, 0x766d, 0x766e, 0x766f,
/* 18 */ 0x7671, 0x7674, 0x7681, 0x7685, 0x768c, 0x768d, 0x7695, 0x769b,
/* 20 */ 0x769c, 0x769d, 0x769f, 0x76a0, 0x76a2, 0x76a3, 0x76a4, 0x76a5,
/* 28 */ 0x76a6, 0x76a7, 0x76a8, 0x76aa, 0x76ad, 0x76bd, 0x76c1, 0x76c5,
/* 30 */ 0x76c9, 0x76cb, 0x76cc, 0x76ce, 0x76d4, 0x76d9, 0x76e0, 0x76e6,
/* 38 */ 0x76e8, 0x76ec, 0x76f0, 0x76f1, 0x76f6, 0x76f9, 0x76fc, 0x7700
},

/* Row 0x0ff */
{
/* 00 */ 0x7706, 0x770a, 0x770e, 0x7712, 0x7714, 0x7715, 0x7717, 0x7719,
/* 08 */ 0x771a, 0x771c, 0x7722, 0x7728, 0x772d, 0x772e, 0x772f, 0x7734,
/* 10 */ 0x7735, 0x7736, 0x7739, 0x773d, 0x773e, 0x7742, 0x7745, 0x7746,
/* 18 */ 0x774a, 0x774d, 0x774e, 0x774f, 0x7752, 0x7756, 0x7757, 0x775c,
/* 20 */ 0x775e, 0x775f, 0x7760, 0x7762, 0x7764, 0x7767, 0x776a, 0x776c,
/* 28 */ 0x7770, 0x7772, 0x7773, 0x7774, 0x777a, 0x777d, 0x7780, 0x7784,
/* 30 */ 0x778c, 0x778d, 0x7794, 0x7795, 0x7796, 0x779a, 0x779f, 0x77a2,
/* 38 */ 0x77a7, 0x77aa, 0x77ae, 0x77af, 0x77b1, 0x77b5, 0x77be, 0x77c3
},

/* Row 0x100 */
{
/* 00 */ 0x77c9, 0x77d1, 0x77d2, 0x77d5, 0x77d9, 0x77de, 0x77df, 0x77e0,
/* 08 */ 0x77e4, 0x77e6, 0x77ea, 0x77ec, 0x77f0, 0x77f1, 0x77f4, 0x77f8,
/* 10 */ 0x77fb, 0x7805, 0x7806, 0x7809, 0x780d, 0x780e, 0x7811, 0x781d,
/* 18 */ 0x7821, 0x7822, 0x7823, 0x782d, 0x782e, 0x7830, 0x7835, 0x7837,
/* 20 */ 0x7843, 0x7844, 0x7847, 0x7848, 0x784c, 0x784e, 0x7852, 0x785c,
/* 28 */ 0x785e, 0x7860, 0x7861, 0x7863, 0x7864, 0x7868, 0x786a, 0x786e,
/* 30 */ 0x787a, 0x787e, 0x788a, 0x788f, 0x7894, 0x7898, 0x78a1, 0x789d,
/* 38 */ 0x789e, 0x789f, 0x78a4, 0x78a8, 0x78ac, 0x78ad, 0x78b0, 0x78b1
},

/* Row 0x101 */
{
/* 00 */ 0x78b2, 0x78b3, 0x78bb, 0x78bd, 0x78bf, 0x78c7, 0x78c8, 0x78c9,
/* 08 */ 0x78cc, 0x78ce, 0x78d2, 0x78d3, 0x78d5, 0x78d6, 0x78e4, 0x78db,
/* 10 */ 0x78df, 0x78e0, 0x78e1, 0x78e6, 0x78ea, 0x78f2, 0x78f3, 0x7900,
/* 18 */ 0x78f6, 0x78f7, 0x78fa, 0x78fb, 0x78ff, 0x7906, 0x790c, 0x7910,
/* 20 */ 0x791a, 0x791c, 0x791e, 0x791f, 0x7920, 0x7925, 0x7927, 0x7929,
/* 28 */ 0x792d, 0x7931, 0x7934, 0x7935, 0x793b, 0x793d, 0x793f, 0x7944,
/* 30 */ 0x7945, 0x7946, 0x794a, 0x794b, 0x794f, 0x7951, 0x7954, 0x7958,
/* 38 */ 0x795b, 0x795c, 0x7967, 0x7969, 0x796b, 0x7972, 0x7979, 0x797b
},

/* Row 0x102 */
{
/* 00 */ 0x797c, 0x797e, 0x798b, 0x798c, 0x7991, 0x7993, 0x7994, 0x7995,
/* 08 */ 0x7996, 0x7998, 0x799b, 0x799c, 0x79a1, 0x79a8, 0x79a9, 0x79ab,
/* 10 */ 0x79af, 0x79b1, 0x79b4, 0x79b8, 0x79bb, 0x79c2, 0x79c4, 0x79c7,
/* 18 */ 0x79c8, 0x79ca, 0x79cf, 0x79d4, 0x79d6, 0x79da, 0x79dd, 0x79de,
/* 20 */ 0x79e0, 0x79e2, 0x79e5, 0x79ea, 0x79eb, 0x79ed, 0x79f1, 0x79f8,
/* 28 */ 0x79fc, 0x7a02, 0x7a03, 0x7a07, 0x7a09, 0x7a0a, 0x7a0c, 0x7a11,
/* 30 */ 0x7a15, 0x7a1b, 0x7a1e, 0x7a21, 0x7a27, 0x7a2b, 0x7a2d, 0x7a2f,
/* 38 */ 0x7a30, 0x7a34, 0x7a35, 0x7a38, 0x7a39, 0x7a3a, 0x7a44, 0x7a45
},

/* Row 0x103 */
{
/* 00 */ 0x7a47, 0x7a48, 0x7a4c, 0x7a55, 0x7a56, 0x7a59, 0x7a5c, 0x7a5d,
/* 08 */ 0x7a5f, 0x7a60, 0x7a65, 0x7a67, 0x7a6a, 0x7a6d, 0x7a75, 0x7a78,
/* 10 */ 0x7a7e, 0x7a80, 0x7a82, 0x7a85, 0x7a86, 0x7a8a, 0x7a8b, 0x7a90,
/* 18 */ 0x7a91, 0x7a94, 0x7a9e, 0x7aa0, 0x7aa3, 0x7aac, 0x7ab3, 0x7ab5,
/* 20 */ 0x7ab9, 0x7abb, 0x7abc, 0x7ac6, 0x7ac9, 0x7acc, 0x7ace, 0x7ad1,
/* 28 */ 0x7adb, 0x7ae8, 0x7ae9, 0x7aeb, 0x7aec, 0x7af1, 0x7af4, 0x7afb,
/* 30 */ 0x7afd, 0x7afe, 0x7b07, 0x7b14, 0x7b1f, 0x7b23, 0x7b27, 0x7b29,
/* 38 */ 0x7b2a, 0x7b2b, 0x7b2d, 0x7b2e, 0x7b2f, 0x7b30, 0x7b31, 0x7b34
},

/* Row 0x104 */
{
/* 00 */ 0x7b3d, 0x7b3f, 0x7b40, 0x7b41, 0x7b47, 0x7b4e, 0x7b55, 0x7b60,
/* 08 */ 0x7b64, 0x7b66, 0x7b69, 0x7b6a, 0x7b6d, 0x7b6f, 0x7b72, 0x7b73,
/* 10 */ 0x7b77, 0x7b84, 0x7b89, 0x7b8e, 0x7b90, 0x7b91, 0x7b96, 0x7b9b,
/* 18 */ 0x7b9e, 0x7ba0, 0x7ba5, 0x7bac, 0x7baf, 0x7bb0, 0x7bb2, 0x7bb5,
/* 20 */ 0x7bb6, 0x7bba, 0x7bbb, 0x7bbc, 0x7bbd, 0x7bc2, 0x7bc5, 0x7bc8,
/* 28 */ 0x7bca, 0x7bd4, 0x7bd6, 0x7bd7, 0x7bd9, 0x7bda, 0x7bdb, 0x7be8,
/* 30 */ 0x7bea, 0x7bf2, 0x7bf4, 0x7bf5, 0x7bf8, 0x7bf9, 0x7bfa, 0x7bfc,
/* 38 */ 0x7bfe, 0x7c01, 0x7c02, 0x7c03, 0x7c04, 0x7c06, 0x7c09, 0x7c0b
},

/* Row 0x105 */
{
/* 00 */ 0x7c0c, 0x7c0e, 0x7c0f, 0x7c19, 0x7c1b, 0x7c20, 0x7c25, 0x7c26,
/* 08 */ 0x7c28, 0x7c2c, 0x7c31, 0x7c33, 0x7c34, 0x7c36, 0x7c39, 0x7c3a,
/* 10 */ 0x7c46, 0x7c4a, 0x7c55, 0x7c51, 0x7c52, 0x7c53, 0x7c59, 0x7c5a,
/* 18 */ 0x7c5b, 0x7c5c, 0x7c5d, 0x7c5e, 0x7c61, 0x7c63, 0x7c67, 0x7c69,
/* 20 */ 0x7c6d, 0x7c6e, 0x7c70, 0x7c72, 0x7c79, 0x7c7c, 0x7c7d, 0x7c86,
/* 28 */ 0x7c87, 0x7c8f, 0x7c94, 0x7c9e, 0x7ca0, 0x7ca6, 0x7cb0, 0x7cb6,
/* 30 */ 0x7cb7, 0x7cba, 0x7cbb, 0x7cbc, 0x7cbf, 0x7cc4, 0x7cc7, 0x7cc8,
/* 38 */ 0x7cc9, 0x7ccd, 0x7ccf, 0x7cd3, 0x7cd4, 0x7cd5, 0x7cd7, 0x7cd9
},

/* Row 0x106 */
{
/* 00 */ 0x7cda, 0x7cdd, 0x7ce6, 0x7ce9, 0x7ceb, 0x7cf5, 0x7d03, 0x7d07,
/* 08 */ 0x7d08, 0x7d09, 0x7d0f, 0x7d11, 0x7d12, 0x7d13, 0x7d16, 0x7d1d,
/* 10 */ 0x7d1e, 0x7d23, 0x7d26, 0x7d2a, 0x7d2d, 0x7d31, 0x7d3c, 0x7d3d,
/* 18 */ 0x7d3e, 0x7d40, 0x7d41, 0x7d47, 0x7d48, 0x7d4d, 0x7d51, 0x7d53,
/* 20 */ 0x7d57, 0x7d59, 0x7d5a, 0x7d5c, 0x7d5d, 0x7d65, 0x7d67, 0x7d6a,
/* 28 */ 0x7d70, 0x7d78, 0x7d7a, 0x7d7b, 0x7d7f, 0x7d81, 0x7d82, 0x7d83,
/* 30 */ 0x7d85, 0x7d86, 0x7d88, 0x7d8b, 0x7d8c, 0x7d8d, 0x7d91, 0x7d96,
/* 38 */ 0x7d97, 0x7d9d, 0x7d9e, 0x7da6, 0x7da7, 0x7daa, 0x7db3, 0x7db6
},

/* Row 0x107 */
{
/* 00 */ 0x7db7, 0x7db9, 0x7dc2, 0x7dc3, 0x7dc4, 0x7dc5, 0x7dc6, 0x7dcc,
/* 08 */ 0x7dcd, 0x7dce, 0x7dd7, 0x7dd9, 0x7e00, 0x7de2, 0x7de5, 0x7de6,
/* 10 */ 0x7dea, 0x7deb, 0x7ded, 0x7df1, 0x7df5, 0x7df6, 0x7df9, 0x7dfa,
/* 18 */ 0x7e08, 0x7e10, 0x7e11, 0x7e15, 0x7e17, 0x7e1c, 0x7e1d, 0x7e20,
/* 20 */ 0x7e27, 0x7e28, 0x7e2c, 0x7e2d, 0x7e2f, 0x7e33, 0x7e36, 0x7e3f,
/* 28 */ 0x7e44, 0x7e45, 0x7e47, 0x7e4e, 0x7e50, 0x7e52, 0x7e58, 0x7e5f,
/* 30 */ 0x7e61, 0x7e62, 0x7e65, 0x7e6b, 0x7e6e, 0x7e6f, 0x7e73, 0x7e78,
/* 38 */ 0x7e7e, 0x7e81, 0x7e86, 0x7e87, 0x7e8a, 0x7e8d, 0x7e91, 0x7e95
},

/* Row 0x108 */
{
/* 00 */ 0x7e98, 0x7e9a, 0x7e9d, 0x7e9e, 0x7f3c, 0x7f3b, 0x7f3d, 0x7f3e,
/* 08 */ 0x7f3f, 0x7f43, 0x7f44, 0x7f47, 0x7f4f, 0x7f52, 0x7f53, 0x7f5b,
/* 10 */ 0x7f5c, 0x7f5d, 0x7f61, 0x7f63, 0x7f64, 0x7f65, 0x7f66, 0x7f6d,
/* 18 */ 0x7f71, 0x7f7d, 0x7f7e, 0x7f7f, 0x7f80, 0x7f8b, 0x7f8d, 0x7f8f,
/* 20 */ 0x7f90, 0x7f91, 0x7f96, 0x7f97, 0x7f9c, 0x7fa1, 0x7fa2, 0x7fa6,
/* 28 */ 0x7faa, 0x7fad, 0x7fb4, 0x7fbc, 0x7fbf, 0x7fc0, 0x7fc3, 0x7fc8,
/* 30 */ 0x7fce, 0x7fcf, 0x7fdb, 0x7fdf, 0x7fe3, 0x7fe5, 0x7fe8, 0x7fec,
/* 38 */ 0x7fee, 0x7fef, 0x7ff2, 0x7ffa, 0x7ffd, 0x7ffe, 0x7fff, 0x8007
},

/* Row 0x109 */
{
/* 00 */ 0x8008, 0x800a, 0x800d, 0x800e, 0x800f, 0x8011, 0x8013, 0x8014,
/* 08 */ 0x8016, 0x801d, 0x801e, 0x801f, 0x8020, 0x8024, 0x8026, 0x802c,
/* 10 */ 0x802e, 0x8030, 0x8034, 0x8035, 0x8037, 0x8039, 0x803a, 0x803c,
/* 18 */ 0x803e, 0x8040, 0x8044, 0x8060, 0x8064, 0x8066, 0x806d, 0x8071,
/* 20 */ 0x8075, 0x8081, 0x8088, 0x808e, 0x809c, 0x809e, 0x80a6, 0x80a7,
/* 28 */ 0x80ab, 0x80b8, 0x80b9, 0x80c8, 0x80cd, 0x80cf, 0x80d2, 0x80d4,
/* 30 */ 0x80d5, 0x80d7, 0x80d8, 0x80e0, 0x80ed, 0x80ee, 0x80f0, 0x80f2,
/* 38 */ 0x80f3, 0x80f6, 0x80f9, 0x80fa, 0x80fe, 0x8103, 0x810b, 0x8116
},

/* Row 0x10a */
{
/* 00 */ 0x8117, 0x8118, 0x811c, 0x811e, 0x8120, 0x8124, 0x8127, 0x812c,
/* 08 */ 0x8130, 0x8135, 0x813a, 0x813c, 0x8145, 0x8147, 0x814a, 0x814c,
/* 10 */ 0x8152, 0x8157, 0x8160, 0x8161, 0x8167, 0x8168, 0x8169, 0x816d,
/* 18 */ 0x816f, 0x8177, 0x8181, 0x8190, 0x8184, 0x8185, 0x8186, 0x818b,
/* 20 */ 0x818e, 0x8196, 0x8198, 0x819b, 0x819e, 0x81a2, 0x81ae, 0x81b2,
/* 28 */ 0x81b4, 0x81bb, 0x81cb, 0x81c3, 0x81c5, 0x81ca, 0x81ce, 0x81cf,
/* 30 */ 0x81d5, 0x81d7, 0x81db, 0x81dd, 0x81de, 0x81e1, 0x81e4, 0x81eb,
/* 38 */ 0x81ec, 0x81f0, 0x81f1, 0x81f2, 0x81f5, 0x81f6, 0x81f8, 0x81f9
},

/* Row 0x10b */
{
/* 00 */ 0x81fd, 0x81ff, 0x8200, 0x8203, 0x820f, 0x8213, 0x8214, 0x8219,
/* 08 */ 0x821a, 0x821d, 0x8221, 0x8222, 0x8228, 0x8232, 0x8234, 0x823a,
/* 10 */ 0x8243, 0x8244, 0x8245, 0x8246, 0x824b, 0x824e, 0x824f, 0x8251,
/* 18 */ 0x8256, 0x825c, 0x8260, 0x8263, 0x8267, 0x826d, 0x8274, 0x827b,
/* 20 */ 0x827d, 0x827f, 0x8280, 0x8281, 0x8283, 0x8284, 0x8287, 0x8289,
/* 28 */ 0x828a, 0x828e, 0x8291, 0x8294, 0x8296, 0x8298, 0x829a, 0x829b,
/* 30 */ 0x82a0, 0x82a1, 0x82a3, 0x82a4, 0x82a7, 0x82a8, 0x82a9, 0x82aa,
/* 38 */ 0x82ae, 0x82b0, 0x82b2, 0x82b4, 0x82b7, 0x82ba, 0x82bc, 0x82be
},

/* Row 0x10c */
{
/* 00 */ 0x82bf, 0x82c6, 0x82d0, 0x82d5, 0x82da, 0x82e0, 0x82e2, 0x82e4,
/* 08 */ 0x82e8, 0x82ea, 0x82ed, 0x82ef, 0x82f6, 0x82f7, 0x82fd, 0x82fe,
/* 10 */ 0x8300, 0x8301, 0x8307, 0x8308, 0x830a, 0x830b, 0x8354, 0x831b,
/* 18 */ 0x831d, 0x831e, 0x831f, 0x8321, 0x8322, 0x832c, 0x832d, 0x832e,
/* 20 */ 0x8330, 0x8333, 0x8337, 0x833a, 0x833c, 0x833d, 0x8342, 0x8343,
/* 28 */ 0x8344, 0x8347, 0x834d, 0x834e, 0x8351, 0x8355, 0x8356, 0x8357,
/* 30 */ 0x8370, 0x8378, 0x837d, 0x837f, 0x8380, 0x8382, 0x8384, 0x8386,
/* 38 */ 0x838d, 0x8392, 0x8394, 0x8395, 0x8398, 0x8399, 0x839b, 0x839c
},

/* Row 0x10d */
{
/* 00 */ 0x839d, 0x83a6, 0x83a7, 0x83a9, 0x83ac, 0x83be, 0x83bf, 0x83c0,
/* 08 */ 0x83c7, 0x83c9, 0x83cf, 0x83d0, 0x83d1, 0x83d4, 0x83dd, 0x8353,
/* 10 */ 0x83e8, 0x83ea, 0x83f6, 0x83f8, 0x83f9, 0x83fc, 0x8401, 0x8406,
/* 18 */ 0x840a, 0x840f, 0x8411, 0x8415, 0x8419, 0x83ad, 0x842f, 0x8439,
/* 20 */ 0x8445, 0x8447, 0x8448, 0x844a, 0x844d, 0x844f, 0x8451, 0x8452,
/* 28 */ 0x8456, 0x8458, 0x8459, 0x845a, 0x845c, 0x8460, 0x8464, 0x8465,
/* 30 */ 0x8467, 0x846a, 0x8470, 0x8473, 0x8474, 0x8476, 0x8478, 0x847c,
/* 38 */ 0x847d, 0x8481, 0x8485, 0x8492, 0x8493, 0x8495, 0x849e, 0x84a6
},

/* Row 0x10e */
{
/* 00 */ 0x84a8, 0x84a9, 0x84aa, 0x84af, 0x84b1, 0x84b4, 0x84ba, 0x84bd,
/* 08 */ 0x84be, 0x84c0, 0x84c2, 0x84c7, 0x84c8, 0x84cc, 0x84cf, 0x84d3,
/* 10 */ 0x84dc, 0x84e7, 0x84ea, 0x84ef, 0x84f0, 0x84f1, 0x84f2, 0x84f7,
/* 18 */ 0x8532, 0x84fa, 0x84fb, 0x84fd, 0x8502, 0x8503, 0x8507, 0x850c,
/* 20 */ 0x850e, 0x8510, 0x851c, 0x851e, 0x8522, 0x8523, 0x8524, 0x8525,
/* 28 */ 0x8527, 0x852a, 0x852b, 0x852f, 0x8533, 0x8534, 0x8536, 0x853f,
/* 30 */ 0x8546, 0x854f, 0x8550, 0x8551, 0x8552, 0x8553, 0x8556, 0x8559,
/* 38 */ 0x855c, 0x855d, 0x855e, 0x855f, 0x8560, 0x8561, 0x8562, 0x8564
},

/* Row 0x10f */
{
/* 00 */ 0x856b, 0x856f, 0x8579, 0x857a, 0x857b, 0x857d, 0x857f, 0x8581,
/* 08 */ 0x8585, 0x8586, 0x8589, 0x858b, 0x858c, 0x858f, 0x8593, 0x8598,
/* 10 */ 0x859d, 0x859f, 0x85a0, 0x85a2, 0x85a5, 0x85a7, 0x85b4, 0x85b6,
/* 18 */ 0x85b7, 0x85b8, 0x85bc, 0x85bd, 0x85be, 0x85bf, 0x85c2, 0x85c7,
/* 20 */ 0x85ca, 0x85cb, 0x85ce, 0x85ad, 0x85d8, 0x85da, 0x85df, 0x85e0,
/* 28 */ 0x85e6, 0x85e8, 0x85ed, 0x85f3, 0x85f6, 0x85fc, 0x85ff, 0x8600,
/* 30 */ 0x8604, 0x8605, 0x860d, 0x860e, 0x8610, 0x8611, 0x8612, 0x8618,
/* 38 */ 0x8619, 0x861b, 0x861e, 0x8621, 0x8627, 0x8629, 0x8636, 0x8638
},

/* Row 0x110 */
{
/* 00 */ 0x863a, 0x863c, 0x863d, 0x8640, 0x8642, 0x8646, 0x8652, 0x8653,
/* 08 */ 0x8656, 0x8657, 0x8658, 0x8659, 0x865d, 0x8660, 0x8661, 0x8662,
/* 10 */ 0x8663, 0x8664, 0x8669, 0x866c, 0x866f, 0x8675, 0x8676, 0x8677,
/* 18 */ 0x867a, 0x868d, 0x8691, 0x8696, 0x8698, 0x869a, 0x869c, 0x86a1,
/* 20 */ 0x86a6, 0x86a7, 0x86a8, 0x86ad, 0x86b1, 0x86b3, 0x86b4, 0x86b5,
/* 28 */ 0x86b7, 0x86b8, 0x86b9, 0x86bf, 0x86c0, 0x86c1, 0x86c3, 0x86c5,
/* 30 */ 0x86d1, 0x86d2, 0x86d5, 0x86d7, 0x86da, 0x86dc, 0x86e0, 0x86e3,
/* 38 */ 0x86e5, 0x86e7, 0x8688, 0x86fa, 0x86fc, 0x86fd, 0x8704, 0x8705
},

/* Row 0x111 */
{
/* 00 */ 0x8707, 0x870b, 0x870e, 0x870f, 0x8710, 0x8713, 0x8714, 0x8719,
/* 08 */ 0x871e, 0x871f, 0x8721, 0x8723, 0x8728, 0x872e, 0x872f, 0x8731,
/* 10 */ 0x8732, 0x8739, 0x873a, 0x873c, 0x873d, 0x873e, 0x8740, 0x8743,
/* 18 */ 0x8745, 0x874d, 0x8758, 0x875d, 0x8761, 0x8764, 0x8765, 0x876f,
/* 20 */ 0x8771, 0x8772, 0x877b, 0x8783, 0x8784, 0x8785, 0x8786, 0x8787,
/* 28 */ 0x8788, 0x8789, 0x878b, 0x878c, 0x8790, 0x8793, 0x8795, 0x8797,
/* 30 */ 0x8798, 0x8799, 0x879e, 0x87a0, 0x87a3, 0x87a7, 0x87ac, 0x87ad,
/* 38 */ 0x87ae, 0x87b1, 0x87b5, 0x87be, 0x87bf, 0x87c1, 0x87c8, 0x87c9
},

/* Row 0x112 */
{
/* 00 */ 0x87ca, 0x87ce, 0x87d5, 0x87d6, 0x87d9, 0x87da, 0x87dc, 0x87df,
/* 08 */ 0x87e2, 0x87e3, 0x87e4, 0x87ea, 0x87eb, 0x87ed, 0x87f1, 0x87f3,
/* 10 */ 0x87f8, 0x87fa, 0x87ff, 0x8801, 0x8803, 0x8806, 0x8809, 0x880a,
/* 18 */ 0x880b, 0x8810, 0x8819, 0x8812, 0x8813, 0x8814, 0x8818, 0x881a,
/* 20 */ 0x881b, 0x881c, 0x881e, 0x881f, 0x8828, 0x882d, 0x882e, 0x8830,
/* 28 */ 0x8832, 0x8835, 0x883a, 0x883c, 0x8841, 0x8843, 0x8845, 0x8848,
/* 30 */ 0x8849, 0x884a, 0x884b, 0x884e, 0x8851, 0x8855, 0x8856, 0x8858,
/* 38 */ 0x885a, 0x885c, 0x885f, 0x8860, 0x8864, 0x8869, 0x8871, 0x8879
},

/* Row 0x113 */
{
/* 00 */ 0x887b, 0x8880, 0x8898, 0x889a, 0x889b, 0x889c, 0x889f, 0x88a0,
/* 08 */ 0x88a8, 0x88aa, 0x88ba, 0x88bd, 0x88be, 0x88c0, 0x88ca, 0x88cb,
/* 10 */ 0x88cc, 0x88cd, 0x88ce, 0x88d1, 0x88d2, 0x88d3, 0x88db, 0x88de,
/* 18 */ 0x88e7, 0x88ef, 0x88f0, 0x88f1, 0x88f5, 0x88f7, 0x8901, 0x8906,
/* 20 */ 0x890d, 0x890e, 0x890f, 0x8915, 0x8916, 0x8918, 0x8919, 0x891a,
/* 28 */ 0x891c, 0x8920, 0x8926, 0x8927, 0x8928, 0x8930, 0x8931, 0x8932,
/* 30 */ 0x8935, 0x8939, 0x893a, 0x893e, 0x8940, 0x8942, 0x8945, 0x8946,
/* 38 */ 0x8949, 0x894f, 0x8952, 0x8957, 0x895a, 0x895b, 0x895c, 0x8961
},

/* Row 0x114 */
{
/* 00 */ 0x8962, 0x8963, 0x896b, 0x896e, 0x8970, 0x8973, 0x8975, 0x897a,
/* 08 */ 0x897b, 0x897c, 0x897d, 0x8989, 0x898d, 0x8990, 0x8994, 0x8995,
/* 10 */ 0x899b, 0x899c, 0x899f, 0x89a0, 0x89a5, 0x89b0, 0x89b4, 0x89b5,
/* 18 */ 0x89b6, 0x89b7, 0x89bc, 0x89d4, 0x89d5, 0x89d6, 0x89d7, 0x89d8,
/* 20 */ 0x89e5, 0x89e9, 0x89eb, 0x89ed, 0x89f1, 0x89f3, 0x89f6, 0x89f9,
/* 28 */ 0x89fd, 0x89ff, 0x8a04, 0x8a05, 0x8a07, 0x8a0f, 0x8a11, 0x8a12,
/* 30 */ 0x8a14, 0x8a15, 0x8a1e, 0x8a20, 0x8a22, 0x8a24, 0x8a26, 0x8a2b,
/* 38 */ 0x8a2c, 0x8a2f, 0x8a35, 0x8a37, 0x8a3d, 0x8a3e, 0x8a40, 0x8a43
},

/* Row 0x115 */
{
/* 00 */ 0x8a45, 0x8a47, 0x8a49, 0x8a4d, 0x8a4e, 0x8a53, 0x8a56, 0x8a57,
/* 08 */ 0x8a58, 0x8a5c, 0x8a5d, 0x8a61, 0x8a65, 0x8a67, 0x8a75, 0x8a76,
/* 10 */ 0x8a77, 0x8a79, 0x8a7a, 0x8a7b, 0x8a7e, 0x8a7f, 0x8a80, 0x8a83,
/* 18 */ 0x8a86, 0x8a8b, 0x8a8f, 0x8a90, 0x8a92, 0x8a96, 0x8a97, 0x8a99,
/* 20 */ 0x8a9f, 0x8aa7, 0x8aa9, 0x8aae, 0x8aaf, 0x8ab3, 0x8ab6, 0x8ab7,
/* 28 */ 0x8abb, 0x8abe, 0x8ac3, 0x8ac6, 0x8ac8, 0x8ac9, 0x8aca, 0x8ad1,
/* 30 */ 0x8ad3, 0x8ad4, 0x8ad5, 0x8ad7, 0x8add, 0x8adf, 0x8aec, 0x8af0,
/* 38 */ 0x8af4, 0x8af5, 0x8af6, 0x8afc, 0x8aff, 0x8b05, 0x8b06, 0x8b0b
},

/* Row 0x116 */
{
/* 00 */ 0x8b11, 0x8b1c, 0x8b1e, 0x8b1f, 0x8b0a, 0x8b2d, 0x8b30, 0x8b37,
/* 08 */ 0x8b3c, 0x8b42, 0x8b43, 0x8b44, 0x8b45, 0x8b46, 0x8b48, 0x8b52,
/* 10 */ 0x8b53, 0x8b54, 0x8b59, 0x8b4d, 0x8b5e, 0x8b63, 0x8b6d, 0x8b76,
/* 18 */ 0x8b78, 0x8b79, 0x8b7c, 0x8b7e, 0x8b81, 0x8b84, 0x8b85, 0x8b8b,
/* 20 */ 0x8b8d, 0x8b8f, 0x8b94, 0x8b95, 0x8b9c, 0x8b9e, 0x8b9f, 0x8c38,
/* 28 */ 0x8c39, 0x8c3d, 0x8c3e, 0x8c45, 0x8c47, 0x8c49, 0x8c4b, 0x8c4f,
/* 30 */ 0x8c51, 0x8c53, 0x8c54, 0x8c57, 0x8c58, 0x8c5b, 0x8c5d, 0x8c59,
/* 38 */ 0x8c63, 0x8c64, 0x8c66, 0x8c68, 0x8c69, 0x8c6d, 0x8c73, 0x8c75
},

/* Row 0x117 */
{
/* 00 */ 0x8c76, 0x8c7b, 0x8c7e, 0x8c86, 0x8c87, 0x8c8b, 0x8c90, 0x8c92,
/* 08 */ 0x8c93, 0x8c99, 0x8c9b, 0x8c9c, 0x8ca4, 0x8cb9, 0x8cba, 0x8cc5,
/* 10 */ 0x8cc6, 0x8cc9, 0x8ccb, 0x8ccf, 0x8cd6, 0x8cd5, 0x8cd9, 0x8cdd,
/* 18 */ 0x8ce1, 0x8ce8, 0x8cec, 0x8cef, 0x8cf0, 0x8cf2, 0x8cf5, 0x8cf7,
/* 20 */ 0x8cf8, 0x8cfe, 0x8cff, 0x8d01, 0x8d03, 0x8d09, 0x8d12, 0x8d17,
/* 28 */ 0x8d1b, 0x8d65, 0x8d69, 0x8d6c, 0x8d6e, 0x8d7f, 0x8d82, 0x8d84,
/* 30 */ 0x8d88, 0x8d8d, 0x8d90, 0x8d91, 0x8d95, 0x8d9e, 0x8d9f, 0x8da0,
/* 38 */ 0x8da6, 0x8dab, 0x8dac, 0x8daf, 0x8db2, 0x8db5, 0x8db7, 0x8db9
},

/* Row 0x118 */
{
/* 00 */ 0x8dbb, 0x8dc0, 0x8dc5, 0x8dc6, 0x8dc7, 0x8dc8, 0x8dca, 0x8dce,
/* 08 */ 0x8dd1, 0x8dd4, 0x8dd5, 0x8dd7, 0x8dd9, 0x8de4, 0x8de5, 0x8de7,
/* 10 */ 0x8dec, 0x8df0, 0x8dbc, 0x8df1, 0x8df2, 0x8df4, 0x8dfd, 0x8e01,
/* 18 */ 0x8e04, 0x8e05, 0x8e06, 0x8e0b, 0x8e11, 0x8e14, 0x8e16, 0x8e20,
/* 20 */ 0x8e21, 0x8e22, 0x8e23, 0x8e26, 0x8e27, 0x8e31, 0x8e33, 0x8e36,
/* 28 */ 0x8e37, 0x8e38, 0x8e39, 0x8e3d, 0x8e40, 0x8e41, 0x8e4b, 0x8e4d,
/* 30 */ 0x8e4e, 0x8e4f, 0x8e54, 0x8e5b, 0x8e5c, 0x8e5d, 0x8e5e, 0x8e61,
/* 38 */ 0x8e62, 0x8e69, 0x8e6c, 0x8e6d, 0x8e6f, 0x8e70, 0x8e71, 0x8e79
},

/* Row 0x119 */
{
/* 00 */ 0x8e7a, 0x8e7b, 0x8e82, 0x8e83, 0x8e89, 0x8e90, 0x8e92, 0x8e95,
/* 08 */ 0x8e9a, 0x8e9b, 0x8e9d, 0x8e9e, 0x8ea2, 0x8ea7, 0x8ea9, 0x8ead,
/* 10 */ 0x8eae, 0x8eb3, 0x8eb5, 0x8eba, 0x8ebb, 0x8ec0, 0x8ec1, 0x8ec3,
/* 18 */ 0x8ec4, 0x8ec7, 0x8ecf, 0x8ed1, 0x8ed4, 0x8edc, 0x8ee8, 0x8eee,
/* 20 */ 0x8ef0, 0x8ef1, 0x8ef7, 0x8ef9, 0x8efa, 0x8eed, 0x8f00, 0x8f02,
/* 28 */ 0x8f07, 0x8f08, 0x8f0f, 0x8f10, 0x8f16, 0x8f17, 0x8f18, 0x8f1e,
/* 30 */ 0x8f20, 0x8f21, 0x8f23, 0x8f25, 0x8f27, 0x8f28, 0x8f2c, 0x8f2d,
/* 38 */ 0x8f2e, 0x8f34, 0x8f35, 0x8f36, 0x8f37, 0x8f3a, 0x8f40, 0x8f41
},

/* Row 0x11a */
{
/* 00 */ 0x8f43, 0x8f47, 0x8f4f, 0x8f51, 0x8f52, 0x8f53, 0x8f54, 0x8f55,
/* 08 */ 0x8f58, 0x8f5d, 0x8f5e, 0x8f65, 0x8f9d, 0x8fa0, 0x8fa1, 0x8fa4,
/* 10 */ 0x8fa5, 0x8fa6, 0x8fb5, 0x8fb6, 0x8fb8, 0x8fbe, 0x8fc0, 0x8fc1,
/* 18 */ 0x8fc6, 0x8fca, 0x8fcb, 0x8fcd, 0x8fd0, 0x8fd2, 0x8fd3, 0x8fd5,
/* 20 */ 0x8fe0, 0x8fe3, 0x8fe4, 0x8fe8, 0x8fee, 0x8ff1, 0x8ff5, 0x8ff6,
/* 28 */ 0x8ffb, 0x8ffe, 0x9002, 0x9004, 0x9008, 0x900c, 0x9018, 0x901b,
/* 30 */ 0x9028, 0x9029, 0x902f, 0x902a, 0x902c, 0x902d, 0x9033, 0x9034,
/* 38 */ 0x9037, 0x903f, 0x9043, 0x9044, 0x904c, 0x905b, 0x905d, 0x9062
},

/* Row 0x11b */
{
/* 00 */ 0x9066, 0x9067, 0x906c, 0x9070, 0x9074, 0x9079, 0x9085, 0x9088,
/* 08 */ 0x908b, 0x908c, 0x908e, 0x9090, 0x9095, 0x9097, 0x9098, 0x9099,
/* 10 */ 0x909b, 0x90a0, 0x90a1, 0x90a2, 0x90a5, 0x90b0, 0x90b2, 0x90b3,
/* 18 */ 0x90b4, 0x90b6, 0x90bd, 0x90cc, 0x90be, 0x90c3, 0x90c4, 0x90c5,
/* 20 */ 0x90c7, 0x90c8, 0x90d5, 0x90d7, 0x90d8, 0x90d9, 0x90dc, 0x90dd,
/* 28 */ 0x90df, 0x90e5, 0x90d2, 0x90f6, 0x90eb, 0x90ef, 0x90f0, 0x90f4,
/* 30 */ 0x90fe, 0x90ff, 0x9100, 0x9104, 0x9105, 0x9106, 0x9108, 0x910d,
/* 38 */ 0x9110, 0x9114, 0x9116, 0x9117, 0x9118, 0x911a, 0x911c, 0x911e
},

/* Row 0x11c */
{
/* 00 */ 0x9120, 0x9125, 0x9122, 0x9123, 0x9127, 0x9129, 0x912e, 0x912f,
/* 08 */ 0x9131, 0x9134, 0x9136, 0x9137, 0x9139, 0x913a, 0x913c, 0x913d,
/* 10 */ 0x9143, 0x9147, 0x9148, 0x914f, 0x9153, 0x9157, 0x9159, 0x915a,
/* 18 */ 0x915b, 0x9161, 0x9164, 0x9167, 0x916d, 0x9174, 0x9179, 0x917a,
/* 20 */ 0x917b, 0x9181, 0x9183, 0x9185, 0x9186, 0x918a, 0x918e, 0x9191,
/* 28 */ 0x9193, 0x9194, 0x9195, 0x9198, 0x919e, 0x91a1, 0x91a6, 0x91a8,
/* 30 */ 0x91ac, 0x91ad, 0x91ae, 0x91b0, 0x91b1, 0x91b2, 0x91b3, 0x91b6,
/* 38 */ 0x91bb, 0x91bc, 0x91bd, 0x91bf, 0x91c2, 0x91c3, 0x91c5, 0x91d3
},

/* Row 0x11d */
{
/* 00 */ 0x91d4, 0x91d7, 0x91d9, 0x91da, 0x91de, 0x91e4, 0x91e5, 0x91e9,
/* 08 */ 0x91ea, 0x91ec, 0x91ed, 0x91ee, 0x91ef, 0x91f0, 0x91f1, 0x91f7,
/* 10 */ 0x91f9, 0x91fb, 0x91fd, 0x9200, 0x9201, 0x9204, 0x9205, 0x9206,
/* 18 */ 0x9207, 0x9209, 0x920a, 0x920c, 0x9210, 0x9212, 0x9213, 0x9216,
/* 20 */ 0x9218, 0x921c, 0x921d, 0x9223, 0x9224, 0x9225, 0x9226, 0x9228,
/* 28 */ 0x922e, 0x922f, 0x9230, 0x9233, 0x9235, 0x9236, 0x9238, 0x9239,
/* 30 */ 0x923a, 0x923c, 0x923e, 0x9240, 0x9242, 0x9243, 0x9246, 0x9247,
/* 38 */ 0x924a, 0x924d, 0x924e, 0x924f, 0x9251, 0x9258, 0x9259, 0x925c
},

/* Row 0x11e */
{
/* 00 */ 0x925d, 0x9260, 0x9261, 0x9265, 0x9267, 0x9268, 0x9269, 0x926e,
/* 08 */ 0x926f, 0x9270, 0x9275, 0x9276, 0x9277, 0x9278, 0x9279, 0x927b,
/* 10 */ 0x927c, 0x927d, 0x927f, 0x9288, 0x9289, 0x928a, 0x928d, 0x928e,
/* 18 */ 0x9292, 0x9297, 0x9299, 0x929f, 0x92a0, 0x92a4, 0x92a5, 0x92a7,
/* 20 */ 0x92a8, 0x92ab, 0x92af, 0x92b2, 0x92b6, 0x92b8, 0x92ba, 0x92bb,
/* 28 */ 0x92bc, 0x92bd, 0x92bf, 0x92c0, 0x92c1, 0x92c2, 0x92c3, 0x92c5,
/* 30 */ 0x92c6, 0x92c7, 0x92c8, 0x92cb, 0x92cc, 0x92cd, 0x92ce, 0x92d0,
/* 38 */ 0x92d3, 0x92d5, 0x92d7, 0x92d8, 0x92d9, 0x92dc, 0x92dd, 0x92df
},

/* Row 0x11f */
{
/* 00 */ 0x92e0, 0x92e1, 0x92e3, 0x92e5, 0x92e7, 0x92e8, 0x92ec, 0x92ee,
/* 08 */ 0x92f0, 0x92f9, 0x92fb, 0x92ff, 0x9300, 0x9302, 0x9308, 0x930d,
/* 10 */ 0x9311, 0x9314, 0x9315, 0x931c, 0x931d, 0x931e, 0x931f, 0x9321,
/* 18 */ 0x9324, 0x9325, 0x9327, 0x9329, 0x932a, 0x9333, 0x9334, 0x9336,
/* 20 */ 0x9337, 0x9347, 0x9348, 0x9349, 0x9350, 0x9351, 0x9352, 0x9355,
/* 28 */ 0x9357, 0x9358, 0x935a, 0x935e, 0x9364, 0x9365, 0x9367, 0x9369,
/* 30 */ 0x936a, 0x936d, 0x936f, 0x9370, 0x9371, 0x9373, 0x9374, 0x9376,
/* 38 */ 0x937a, 0x937d, 0x937f, 0x9380, 0x9381, 0x9382, 0x9388, 0x938a
},

/* Row 0x120 */
{
/* 00 */ 0x938b, 0x938d, 0x938f, 0x9392, 0x9395, 0x9398, 0x939b, 0x939e,
/* 08 */ 0x93a1, 0x93a3, 0x93a4, 0x93a6, 0x93a8, 0x93ab, 0x93b4, 0x93b5,
/* 10 */ 0x93b6, 0x93ba, 0x93a9, 0x93c1, 0x93c4, 0x93c5, 0x93c6, 0x93c7,
/* 18 */ 0x93c9, 0x93ca, 0x93cb, 0x93cc, 0x93cd, 0x93d3, 0x93d9, 0x93dc,
/* 20 */ 0x93de, 0x93df, 0x93e2, 0x93e6, 0x93e7, 0x93f9, 0x93f7, 0x93f8,
/* 28 */ 0x93fa, 0x93fb, 0x93fd, 0x9401, 0x9402, 0x9404, 0x9408, 0x9409,
/* 30 */ 0x940d, 0x940e, 0x940f, 0x9415, 0x9416, 0x9417, 0x941f, 0x942e,
/* 38 */ 0x942f, 0x9431, 0x9432, 0x9433, 0x9434, 0x943b, 0x943f, 0x943d
},

/* Row 0x121 */
{
/* 00 */ 0x9443, 0x9445, 0x9448, 0x944a, 0x944c, 0x9455, 0x9459, 0x945c,
/* 08 */ 0x945f, 0x9461, 0x9463, 0x9468, 0x946b, 0x946d, 0x946e, 0x946f,
/* 10 */ 0x9471, 0x9472, 0x9484, 0x9483, 0x9578, 0x9579, 0x957e, 0x9584,
/* 18 */ 0x9588, 0x958c, 0x958d, 0x958e, 0x959d, 0x959e, 0x959f, 0x95a1,
/* 20 */ 0x95a6, 0x95a9, 0x95ab, 0x95ac, 0x95b4, 0x95b6, 0x95ba, 0x95bd,
/* 28 */ 0x95bf, 0x95c6, 0x95c8, 0x95c9, 0x95cb, 0x95d0, 0x95d1, 0x95d2,
/* 30 */ 0x95d3, 0x95d9, 0x95da, 0x95dd, 0x95de, 0x95df, 0x95e0, 0x95e4,
/* 38 */ 0x95e6, 0x961d, 0x961e, 0x9622, 0x9624, 0x9625, 0x9626, 0x962c
},

/* Row 0x122 */
{
/* 00 */ 0x9631, 0x9633, 0x9637, 0x9638, 0x9639, 0x963a, 0x963c, 0x963d,
/* 08 */ 0x9641, 0x9652, 0x9654, 0x9656, 0x9657, 0x9658, 0x9661, 0x966e,
/* 10 */ 0x9674, 0x967b, 0x967c, 0x967e, 0x967f, 0x9681, 0x9682, 0x9683,
/* 18 */ 0x9684, 0x9689, 0x9691, 0x9696, 0x969a, 0x969d, 0x969f, 0x96a4,
/* 20 */ 0x96a5, 0x96a6, 0x96a9, 0x96ae, 0x96af, 0x96b3, 0x96ba, 0x96ca,
/* 28 */ 0x96d2, 0x5db2, 0x96d8, 0x96da, 0x96dd, 0x96de, 0x96df, 0x96e9,
/* 30 */ 0x96ef, 0x96f1, 0x96fa, 0x9702, 0x9703, 0x9705, 0x9709, 0x971a,
/* 38 */ 0x971b, 0x971d, 0x9721, 0x9722, 0x9723, 0x9728, 0x9731, 0x9733
},

/* Row 0x123 */
{
/* 00 */ 0x9741, 0x9743, 0x974a, 0x974e, 0x974f, 0x9755, 0x9757, 0x9758,
/* 08 */ 0x975a, 0x975b, 0x9763, 0x9767, 0x976a, 0x976e, 0x9773, 0x9776,
/* 10 */ 0x9777, 0x9778, 0x977b, 0x977d, 0x977f, 0x9780, 0x9789, 0x9795,
/* 18 */ 0x9796, 0x9797, 0x9799, 0x979a, 0x979e, 0x979f, 0x97a2, 0x97ac,
/* 20 */ 0x97ae, 0x97b1, 0x97b2, 0x97b5, 0x97b6, 0x97b8, 0x97b9, 0x97ba,
/* 28 */ 0x97bc, 0x97be, 0x97bf, 0x97c1, 0x97c4, 0x97c5, 0x97c7, 0x97c9,
/* 30 */ 0x97ca, 0x97cc, 0x97cd, 0x97ce, 0x97d0, 0x97d1, 0x97d4, 0x97d7,
/* 38 */ 0x97d8, 0x97d9, 0x97dd, 0x97de, 0x97e0, 0x97db, 0x97e1, 0x97e4
},

/* Row 0x124 */
{
/* 00 */ 0x97ef, 0x97f1, 0x97f4, 0x97f7, 0x97f8, 0x97fa, 0x9807, 0x980a,
/* 08 */ 0x9819, 0x980d, 0x980e, 0x9814, 0x9816, 0x981c, 0x981e, 0x9820,
/* 10 */ 0x9823, 0x9826, 0x982b, 0x982e, 0x982f, 0x9830, 0x9832, 0x9833,
/* 18 */ 0x9835, 0x9825, 0x983e, 0x9844, 0x9847, 0x984a, 0x9851, 0x9852,
/* 20 */ 0x9853, 0x9856, 0x9857, 0x9859, 0x985a, 0x9862, 0x9863, 0x9865,
/* 28 */ 0x9866, 0x986a, 0x986c, 0x98ab, 0x98ad, 0x98ae, 0x98b0, 0x98b4,
/* 30 */ 0x98b7, 0x98b8, 0x98ba, 0x98bb, 0x98bf, 0x98c2, 0x98c5, 0x98c8,
/* 38 */ 0x98cc, 0x98e1, 0x98e3, 0x98e5, 0x98e6, 0x98e7, 0x98ea, 0x98f3
},

/* Row 0x125 */
{
/* 00 */ 0x98f6, 0x9902, 0x9907, 0x9908, 0x9911, 0x9915, 0x9916, 0x9917,
/* 08 */ 0x991a, 0x991b, 0x991c, 0x991f, 0x9922, 0x9926, 0x9927, 0x992b,
/* 10 */ 0x9931, 0x9932, 0x9933, 0x9934, 0x9935, 0x9939, 0x993a, 0x993b,
/* 18 */ 0x993c, 0x9940, 0x9941, 0x9946, 0x9947, 0x9948, 0x994d, 0x994e,
/* 20 */ 0x9954, 0x9958, 0x9959, 0x995b, 0x995c, 0x995e, 0x995f, 0x9960,
/* 28 */ 0x999b, 0x999d, 0x999f, 0x99a6, 0x99b0, 0x99b1, 0x99b2, 0x99b5,
/* 30 */ 0x99b9, 0x99ba, 0x99bd, 0x99bf, 0x99c3, 0x99c9, 0x99d3, 0x99d4,
/* 38 */ 0x99d9, 0x99da, 0x99dc, 0x99de, 0x99e7, 0x99ea, 0x99eb, 0x99ec
},

/* Row 0x126 */
{
/* 00 */ 0x99f0, 0x99f4, 0x99f5, 0x99f9, 0x99fd, 0x99fe, 0x9a02, 0x9a03,
/* 08 */ 0x9a04, 0x9a0b, 0x9a0c, 0x9a10, 0x9a11, 0x9a16, 0x9a1e, 0x9a20,
/* 10 */ 0x9a22, 0x9a23, 0x9a24, 0x9a27, 0x9a2d, 0x9a2e, 0x9a33, 0x9a35,
/* 18 */ 0x9a36, 0x9a38, 0x9a47, 0x9a41, 0x9a44, 0x9a4a, 0x9a4b, 0x9a4c,
/* 20 */ 0x9a4e, 0x9a51, 0x9a54, 0x9a56, 0x9a5d, 0x9aaa, 0x9aac, 0x9aae,
/* 28 */ 0x9aaf, 0x9ab2, 0x9ab4, 0x9ab5, 0x9ab6, 0x9ab9, 0x9abb, 0x9abe,
/* 30 */ 0x9abf, 0x9ac1, 0x9ac3, 0x9ac6, 0x9ac8, 0x9ace, 0x9ad0, 0x9ad2,
/* 38 */ 0x9ad5, 0x9ad6, 0x9ad7, 0x9adb, 0x9adc, 0x9ae0, 0x9ae4, 0x9ae5
},

/* Row 0x127 */
{
/* 00 */ 0x9ae7, 0x9ae9, 0x9aec, 0x9af2, 0x9af3, 0x9af5, 0x9af9, 0x9afa,
/* 08 */ 0x9afd, 0x9aff, 0x9b00, 0x9b01, 0x9b02, 0x9b03, 0x9b04, 0x9b05,
/* 10 */ 0x9b08, 0x9b09, 0x9b0b, 0x9b0c, 0x9b0d, 0x9b0e, 0x9b10, 0x9b12,
/* 18 */ 0x9b16, 0x9b19, 0x9b1b, 0x9b1c, 0x9b20, 0x9b26, 0x9b2b, 0x9b2d,
/* 20 */ 0x9b33, 0x9b34, 0x9b35, 0x9b37, 0x9b39, 0x9b3a, 0x9b3d, 0x9b48,
/* 28 */ 0x9b4b, 0x9b4c, 0x9b55, 0x9b56, 0x9b57, 0x9b5b, 0x9b5e, 0x9b61,
/* 30 */ 0x9b63, 0x9b65, 0x9b66, 0x9b68, 0x9b6a, 0x9b6b, 0x9b6c, 0x9b6d,
/* 38 */ 0x9b6e, 0x9b73, 0x9b75, 0x9b77, 0x9b78, 0x9b79, 0x9b7f, 0x9b80
},

/* Row 0x128 */
{
/* 00 */ 0x9b84, 0x9b85, 0x9b86, 0x9b87, 0x9b89, 0x9b8a, 0x9b8b, 0x9b8d,
/* 08 */ 0x9b8f, 0x9b90, 0x9b94, 0x9b9a, 0x9b9d, 0x9b9e, 0x9ba6, 0x9ba7,
/* 10 */ 0x9ba9, 0x9bac, 0x9bb0, 0x9bb1, 0x9bb2, 0x9bb7, 0x9bb8, 0x9bbb,
/* 18 */ 0x9bbc, 0x9bbe, 0x9bbf, 0x9bc1, 0x9bc7, 0x9bc8, 0x9bce, 0x9bd0,
/* 20 */ 0x9bd7, 0x9bd8, 0x9bdd, 0x9bdf, 0x9be5, 0x9be7, 0x9bea, 0x9beb,
/* 28 */ 0x9bef, 0x9bf3, 0x9bf7, 0x9bf8, 0x9bf9, 0x9bfa, 0x9bfd, 0x9bff,
/* 30 */ 0x9c00, 0x9c02, 0x9c0b, 0x9c0f, 0x9c11, 0x9c16, 0x9c18, 0x9c19,
/* 38 */ 0x9c1a, 0x9c1c, 0x9c1e, 0x9c22, 0x9c23, 0x9c26, 0x9c27, 0x9c28
},

/* Row 0x129 */
{
/* 00 */ 0x9c29, 0x9c2a, 0x9c31, 0x9c35, 0x9c36, 0x9c37, 0x9c3d, 0x9c41,
/* 08 */ 0x9c43, 0x9c44, 0x9c45, 0x9c49, 0x9c4a, 0x9c4e, 0x9c4f, 0x9c50,
/* 10 */ 0x9c53, 0x9c54, 0x9c56, 0x9c58, 0x9c5b, 0x9c5d, 0x9c5e, 0x9c5f,
/* 18 */ 0x9c63, 0x9c69, 0x9c6a, 0x9c5c, 0x9c6b, 0x9c68, 0x9c6e, 0x9c70,
/* 20 */ 0x9c72, 0x9c75, 0x9c77, 0x9c7b, 0x9ce6, 0x9cf2, 0x9cf7, 0x9cf9,
/* 28 */ 0x9d0b, 0x9d02, 0x9d11, 0x9d17, 0x9d18, 0x9d1c, 0x9d1d, 0x9d1e,
/* 30 */ 0x9d2f, 0x9d30, 0x9d32, 0x9d33, 0x9d34, 0x9d3a, 0x9d3c, 0x9d45,
/* 38 */ 0x9d3d, 0x9d42, 0x9d43, 0x9d47, 0x9d4a, 0x9d53, 0x9d54, 0x9d5f
},

/* Row 0x12a */
{
/* 00 */ 0x9d63, 0x9d62, 0x9d65, 0x9d69, 0x9d6a, 0x9d6b, 0x9d70, 0x9d76,
/* 08 */ 0x9d77, 0x9d7b, 0x9d7c, 0x9d7e, 0x9d83, 0x9d84, 0x9d86, 0x9d8a,
/* 10 */ 0x9d8d, 0x9d8e, 0x9d92, 0x9d93, 0x9d95, 0x9d96, 0x9d97, 0x9d98,
/* 18 */ 0x9da1, 0x9daa, 0x9dac, 0x9dae, 0x9db1, 0x9db5, 0x9db9, 0x9dbc,
/* 20 */ 0x9dbf, 0x9dc3, 0x9dc7, 0x9dc9, 0x9dca, 0x9dd4, 0x9dd5, 0x9dd6,
/* 28 */ 0x9dd7, 0x9dda, 0x9dde, 0x9ddf, 0x9de0, 0x9de5, 0x9de7, 0x9de9,
/* 30 */ 0x9deb, 0x9dee, 0x9df0, 0x9df3, 0x9df4, 0x9dfe, 0x9e0a, 0x9e02,
/* 38 */ 0x9e07, 0x9e0e, 0x9e10, 0x9e11, 0x9e12, 0x9e15, 0x9e16, 0x9e19
},

/* Row 0x12b */
{
/* 00 */ 0x9e1c, 0x9e1d, 0x9e7a, 0x9e7b, 0x9e7c, 0x9e80, 0x9e82, 0x9e83,
/* 08 */ 0x9e84, 0x9e85, 0x9e87, 0x9e8e, 0x9e8f, 0x9e96, 0x9e98, 0x9e9b,
/* 10 */ 0x9e9e, 0x9ea4, 0x9ea8, 0x9eac, 0x9eae, 0x9eaf, 0x9eb0, 0x9eb3,
/* 18 */ 0x9eb4, 0x9eb5, 0x9ec6, 0x9ec8, 0x9ecb, 0x9ed5, 0x9edf, 0x9ee4,
/* 20 */ 0x9ee7, 0x9eec, 0x9eed, 0x9eee, 0x9ef0, 0x9ef1, 0x9ef2, 0x9ef5,
/* 28 */ 0x9ef8, 0x9eff, 0x9f02, 0x9f03, 0x9f09, 0x9f0f, 0x9f10, 0x9f11,
/* 30 */ 0x9f12, 0x9f14, 0x9f16, 0x9f17, 0x9f19, 0x9f1a, 0x9f1b, 0x9f1f,
/* 38 */ 0x9f22, 0x9f26, 0x9f2a, 0x9f2b, 0x9f2f, 0x9f31, 0x9f32, 0x9f34
},

/* Row 0x12c */
{
/* 00 */ 0x9f37, 0x9f39, 0x9f3a, 0x9f3c, 0x9f3d, 0x9f3f, 0x9f41, 0x9f43,
/* 08 */ 0x9f44, 0x9f45, 0x9f46, 0x9f47, 0x9f53, 0x9f55, 0x9f56, 0x9f57,
/* 10 */ 0x9f58, 0x9f5a, 0x9f5d, 0x9f5e, 0x9f68, 0x9f69, 0x9f6d, 0x9f6e,
/* 18 */ 0x9f6f, 0x9f70, 0x9f71, 0x9f73, 0x9f75, 0x9f7a, 0x9f7d, 0x9f8f,
/* 20 */ 0x9f90, 0x9f91, 0x9f92, 0x9f94, 0x9f96, 0x9f97, 0x9f9e, 0x9fa1,
/* 28 */ 0x9fa2, 0x9fa3, 0x9fa5, 0xf25b, 0xf25c, 0xf25d, 0xf25e, 0xf25f,
/* 30 */ 0xf260, 0xf261, 0xf262, 0xf263, 0xf264, 0xf265, 0xf266, 0xf267,
/* 38 */ 0xf268, 0xf269, 0xf26a, 0xf26b, 0xf26c, 0xf26d, 0xf26e, 0xf26f
},

/* Row 0x12d */
{
/* 00 */ 0xf270, 0xf271, 0xf272, 0xf273, 0xf274, 0xf275,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
}
};

/* Row table for mapping Unicode to SJIS */

#define	ucs_to_sjis_DMAP	1
static row_t _ucs_to_sjis_row[] = {
/* 000 */  0x000,  0x001,  0x002,  0x003,    BAD,    BAD,    BAD,    BAD,
/* 008 */    BAD,    BAD,    BAD,    BAD,  0x004,    BAD,  0x005,  0x006,
/* 010 */  0x007,  0x008,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 018 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 020 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 028 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 030 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 038 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 040 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 048 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 050 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 058 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 060 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 068 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 070 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 078 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 080 */  0x009,    BAD,    BAD,    BAD,  0x00a,    BAD,  0x00b,  0x00c,
/* 088 */  0x00d,  0x00e,  0x00f,    BAD,  0x010,    BAD,    BAD,    BAD,
/* 090 */    BAD,    BAD,    BAD,    BAD,  0x011,  0x012,  0x013,  0x014,
/* 098 */  0x015,  0x016,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0c0 */  0x017,  0x018,  0x019,  0x01a,    BAD,    BAD,    BAD,    BAD,
/* 0c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 100 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 108 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 110 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 118 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 120 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 128 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 130 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 138 */  0x01b,  0x01c,  0x01d,  0x01e,  0x01f,  0x020,  0x021,  0x022,
/* 140 */  0x023,  0x024,  0x025,  0x026,  0x027,  0x028,  0x029,  0x02a,
/* 148 */  0x02b,  0x02c,  0x02d,  0x02e,  0x02f,  0x030,  0x031,  0x032,
/* 150 */  0x033,  0x034,  0x035,  0x036,  0x037,  0x038,  0x039,  0x03a,
/* 158 */  0x03b,  0x03c,  0x03d,  0x03e,  0x03f,  0x040,  0x041,  0x042,
/* 160 */  0x043,  0x044,  0x045,  0x046,  0x047,  0x048,  0x049,  0x04a,
/* 168 */  0x04b,  0x04c,  0x04d,  0x04e,  0x04f,  0x050,  0x051,  0x052,
/* 170 */  0x053,  0x054,  0x055,  0x056,  0x057,  0x058,  0x059,  0x05a,
/* 178 */  0x05b,  0x05c,  0x05d,  0x05e,  0x05f,  0x060,  0x061,  0x062,
/* 180 */  0x063,  0x064,  0x065,  0x066,  0x067,  0x068,  0x069,  0x06a,
/* 188 */  0x06b,  0x06c,  0x06d,  0x06e,  0x06f,  0x070,  0x071,  0x072,
/* 190 */  0x073,  0x074,  0x075,  0x076,  0x077,  0x078,  0x079,  0x07a,
/* 198 */  0x07b,  0x07c,  0x07d,  0x07e,  0x07f,  0x080,  0x081,  0x082,
/* 1a0 */  0x083,  0x084,  0x085,  0x086,  0x087,  0x088,  0x089,  0x08a,
/* 1a8 */  0x08b,  0x08c,  0x08d,  0x08e,  0x08f,  0x090,  0x091,  0x092,
/* 1b0 */  0x093,  0x094,  0x095,  0x096,  0x097,  0x098,  0x099,  0x09a,
/* 1b8 */  0x09b,  0x09c,  0x09d,  0x09e,  0x09f,  0x0a0,  0x0a1,  0x0a2,
/* 1c0 */  0x0a3,  0x0a4,  0x0a5,  0x0a6,  0x0a7,  0x0a8,  0x0a9,  0x0aa,
/* 1c8 */  0x0ab,  0x0ac,  0x0ad,  0x0ae,  0x0af,  0x0b0,  0x0b1,  0x0b2,
/* 1d0 */  0x0b3,  0x0b4,  0x0b5,  0x0b6,  0x0b7,  0x0b8,  0x0b9,  0x0ba,
/* 1d8 */  0x0bb,  0x0bc,  0x0bd,  0x0be,  0x0bf,  0x0c0,  0x0c1,  0x0c2,
/* 1e0 */  0x0c3,  0x0c4,  0x0c5,  0x0c6,  0x0c7,  0x0c8,  0x0c9,  0x0ca,
/* 1e8 */  0x0cb,  0x0cc,  0x0cd,  0x0ce,  0x0cf,  0x0d0,  0x0d1,  0x0d2,
/* 1f0 */  0x0d3,  0x0d4,  0x0d5,  0x0d6,  0x0d7,  0x0d8,  0x0d9,  0x0da,
/* 1f8 */  0x0db,  0x0dc,  0x0dd,    BAD,  0x0de,  0x0df,  0x0e0,  0x0e1,
/* 200 */  0x0e2,  0x0e3,  0x0e4,  0x0e5,  0x0e6,  0x0e7,  0x0e8,  0x0e9,
/* 208 */  0x0ea,  0x0eb,  0x0ec,  0x0ed,  0x0ee,  0x0ef,  0x0f0,  0x0f1,
/* 210 */  0x0f2,  0x0f3,  0x0f4,  0x0f5,  0x0f6,  0x0f7,  0x0f8,  0x0f9,
/* 218 */  0x0fa,  0x0fb,  0x0fc,  0x0fd,  0x0fe,  0x0ff,  0x100,  0x101,
/* 220 */  0x102,  0x103,  0x104,  0x105,  0x106,  0x107,  0x108,  0x109,
/* 228 */  0x10a,  0x10b,  0x10c,  0x10d,  0x10e,  0x10f,  0x110,    BAD,
/* 230 */  0x111,  0x112,  0x113,  0x114,  0x115,  0x116,  0x117,  0x118,
/* 238 */  0x119,  0x11a,  0x11b,  0x11c,  0x11d,  0x11e,  0x11f,  0x120,
/* 240 */  0x121,  0x122,  0x123,  0x124,  0x125,  0x126,  0x127,  0x128,
/* 248 */  0x129,  0x12a,  0x12b,  0x12c,  0x12d,  0x12e,  0x12f,  0x130,
/* 250 */  0x131,  0x132,  0x133,    BAD,    BAD,  0x134,  0x135,  0x136,
/* 258 */  0x137,  0x138,  0x139,  0x13a,  0x13b,  0x13c,  0x13d,  0x13e,
/* 260 */  0x13f,  0x140,  0x141,  0x142,  0x143,  0x144,  0x145,  0x146,
/* 268 */  0x147,  0x148,  0x149,  0x14a,  0x14b,  0x14c,  0x14d,  0x14e,
/* 270 */  0x14f,  0x150,    BAD,  0x151,  0x152,  0x153,  0x154,  0x155,
/* 278 */  0x156,  0x157,  0x158,  0x159,  0x15a,  0x15b,  0x15c,    BAD,
/* 280 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 288 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 290 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 298 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 300 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 308 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 310 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 318 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 320 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 328 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 330 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 338 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 340 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 348 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 350 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 358 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 360 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 368 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 370 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 378 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 380 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 388 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 390 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 398 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3b0 */    BAD,    BAD,    BAD,    BAD,  0x15d,  0x15e,  0x15f,  0x160,
/* 3b8 */  0x161,  0x162,  0x163,  0x164,  0x165,  0x166,  0x167,  0x168,
/* 3c0 */  0x169,  0x16a,  0x16b,  0x16c,  0x16d,    BAD,    BAD,    BAD,
/* 3c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f8 */    BAD,    BAD,    BAD,    BAD,  0x16e,  0x16f,  0x170,  0x171
};

/* Row table for mapping Unicode to deckanji */

#define	ucs_to_deckanji_DMAP	1
static row_t _ucs_to_deckanji_row[] = {
/* 000 */  0x000,  0x001,  0x172,  0x173,    BAD,    BAD,    BAD,    BAD,
/* 008 */    BAD,    BAD,    BAD,    BAD,  0x174,    BAD,  0x175,  0x176,
/* 010 */  0x177,  0x178,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 018 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 020 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 028 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 030 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 038 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 040 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 048 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 050 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 058 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 060 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 068 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 070 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 078 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 080 */  0x179,    BAD,    BAD,    BAD,  0x17a,    BAD,  0x17b,  0x17c,
/* 088 */  0x17d,  0x17e,  0x17f,    BAD,  0x180,    BAD,    BAD,    BAD,
/* 090 */    BAD,    BAD,    BAD,    BAD,  0x181,  0x182,  0x183,  0x184,
/* 098 */  0x185,  0x186,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0c0 */  0x187,  0x188,  0x189,  0x18a,    BAD,    BAD,    BAD,    BAD,
/* 0c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 100 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 108 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 110 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 118 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 120 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 128 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 130 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 138 */  0x18b,  0x18c,  0x18d,  0x18e,  0x18f,  0x190,  0x191,  0x192,
/* 140 */  0x193,  0x194,  0x195,  0x196,  0x197,  0x198,  0x199,  0x19a,
/* 148 */  0x19b,  0x19c,  0x19d,  0x19e,  0x19f,  0x1a0,  0x1a1,  0x1a2,
/* 150 */  0x1a3,  0x1a4,  0x1a5,  0x1a6,  0x1a7,  0x1a8,  0x1a9,  0x1aa,
/* 158 */  0x1ab,  0x1ac,  0x1ad,  0x1ae,  0x1af,  0x1b0,  0x1b1,  0x1b2,
/* 160 */  0x1b3,  0x1b4,  0x1b5,  0x1b6,  0x1b7,  0x1b8,  0x1b9,  0x1ba,
/* 168 */  0x1bb,  0x1bc,  0x1bd,  0x1be,  0x1bf,  0x1c0,  0x1c1,  0x1c2,
/* 170 */  0x1c3,  0x1c4,  0x1c5,  0x1c6,  0x1c7,  0x1c8,  0x1c9,  0x1ca,
/* 178 */  0x1cb,  0x1cc,  0x1cd,  0x1ce,  0x1cf,  0x1d0,  0x1d1,  0x1d2,
/* 180 */  0x1d3,  0x1d4,  0x1d5,  0x1d6,  0x1d7,  0x1d8,  0x1d9,  0x1da,
/* 188 */  0x1db,  0x1dc,  0x1dd,  0x1de,  0x1df,  0x1e0,  0x1e1,  0x1e2,
/* 190 */  0x1e3,  0x1e4,  0x1e5,  0x1e6,  0x1e7,  0x1e8,  0x1e9,  0x1ea,
/* 198 */  0x1eb,  0x1ec,  0x1ed,  0x1ee,  0x1ef,  0x1f0,  0x1f1,  0x1f2,
/* 1a0 */  0x1f3,  0x1f4,  0x1f5,  0x1f6,  0x1f7,  0x1f8,  0x1f9,  0x1fa,
/* 1a8 */  0x1fb,  0x1fc,  0x1fd,  0x1fe,  0x1ff,  0x200,  0x201,  0x202,
/* 1b0 */  0x203,  0x204,  0x205,  0x206,  0x207,  0x208,  0x209,  0x20a,
/* 1b8 */  0x20b,  0x20c,  0x20d,  0x20e,  0x20f,  0x210,  0x211,  0x212,
/* 1c0 */  0x213,  0x214,  0x215,  0x216,  0x217,  0x218,  0x219,  0x21a,
/* 1c8 */  0x21b,  0x21c,  0x21d,  0x21e,  0x21f,  0x220,  0x221,  0x222,
/* 1d0 */  0x223,  0x224,  0x225,  0x226,  0x227,  0x228,  0x229,  0x22a,
/* 1d8 */  0x22b,  0x22c,  0x22d,  0x22e,  0x22f,  0x230,  0x231,  0x232,
/* 1e0 */  0x233,  0x234,  0x235,  0x236,  0x237,  0x238,  0x239,  0x23a,
/* 1e8 */  0x23b,  0x23c,  0x23d,  0x23e,  0x23f,  0x240,  0x241,  0x242,
/* 1f0 */  0x243,  0x244,  0x245,  0x246,  0x247,  0x248,  0x249,  0x24a,
/* 1f8 */  0x24b,  0x24c,  0x24d,    BAD,  0x24e,  0x24f,  0x250,  0x251,
/* 200 */  0x252,  0x253,  0x254,  0x255,  0x256,  0x257,  0x258,  0x259,
/* 208 */  0x25a,  0x25b,  0x25c,  0x25d,  0x25e,  0x25f,  0x260,  0x261,
/* 210 */  0x262,  0x263,  0x264,  0x265,  0x266,  0x267,  0x268,  0x269,
/* 218 */  0x26a,  0x26b,  0x26c,  0x26d,  0x26e,  0x26f,  0x270,  0x271,
/* 220 */  0x272,  0x273,  0x274,  0x275,  0x276,  0x277,  0x278,  0x279,
/* 228 */  0x27a,  0x27b,  0x27c,  0x27d,  0x27e,  0x27f,  0x280,    BAD,
/* 230 */  0x281,  0x282,  0x283,  0x284,  0x285,  0x286,  0x287,  0x288,
/* 238 */  0x289,  0x28a,  0x28b,  0x28c,  0x28d,  0x28e,  0x28f,  0x290,
/* 240 */  0x291,  0x292,  0x293,  0x294,  0x295,  0x296,  0x297,  0x298,
/* 248 */  0x299,  0x29a,  0x29b,  0x29c,  0x29d,  0x29e,  0x29f,  0x2a0,
/* 250 */  0x2a1,  0x2a2,  0x2a3,    BAD,    BAD,  0x2a4,  0x2a5,  0x2a6,
/* 258 */  0x2a7,  0x2a8,  0x2a9,  0x2aa,  0x2ab,  0x2ac,  0x2ad,  0x2ae,
/* 260 */  0x2af,  0x2b0,  0x2b1,  0x2b2,  0x2b3,  0x2b4,  0x2b5,  0x2b6,
/* 268 */  0x2b7,  0x2b8,  0x2b9,  0x2ba,  0x2bb,  0x2bc,  0x2bd,  0x2be,
/* 270 */  0x2bf,  0x2c0,    BAD,  0x2c1,  0x2c2,  0x2c3,  0x2c4,  0x2c5,
/* 278 */  0x2c6,  0x2c7,  0x2c8,  0x2c9,  0x2ca,  0x2cb,  0x2cc,    BAD,
/* 280 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 288 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 290 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 298 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 300 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 308 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 310 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 318 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 320 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 328 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 330 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 338 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 340 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 348 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 350 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 358 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 360 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 368 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 370 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 378 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 380 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 388 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 390 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 398 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,  0x2cd,
/* 3a8 */  0x2ce,  0x2cf,  0x2d0,  0x2d1,  0x2d2,  0x2d3,  0x2d4,  0x2d5,
/* 3b0 */  0x2d6,  0x2d7,  0x2d8,  0x2d9,  0x2da,  0x2db,  0x2dc,  0x2dd,
/* 3b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f8 */    BAD,    BAD,    BAD,    BAD,  0x2de,  0x2df,    BAD,  0x2e0
};

/* Row table for mapping Unicode to eucJP */

#define	ucs_to_eucjp_DMAP	1
static row_t _ucs_to_eucjp_row[] = {
/* 000 */  0x000,  0x001,  0x800,  0x801,  0x802,  0x803,    BAD,  0x804,
/* 008 */    BAD,    BAD,    BAD,  0x805,  0x806,    BAD,  0x807,  0x808,
/* 010 */  0x809,  0x80a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 018 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 020 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 028 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 030 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 038 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 040 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 048 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 050 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 058 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 060 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 068 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 070 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 078 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 080 */  0x179,    BAD,    BAD,    BAD,  0x80b,    BAD,  0x17b,  0x17c,
/* 088 */  0x17d,  0x17e,  0x17f,    BAD,  0x180,    BAD,    BAD,    BAD,
/* 090 */    BAD,    BAD,    BAD,    BAD,  0x181,  0x182,  0x183,  0x184,
/* 098 */  0x185,  0x186,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0c0 */  0x80c,  0x188,  0x189,  0x18a,    BAD,    BAD,    BAD,    BAD,
/* 0c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 100 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 108 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 110 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 118 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 120 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 128 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 130 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 138 */  0x80d,  0x80e,  0x80f,  0x810,  0x811,  0x812,  0x813,  0x814,
/* 140 */  0x815,  0x816,  0x817,  0x818,  0x819,  0x81a,  0x81b,  0x81c,
/* 148 */  0x81d,  0x81e,  0x81f,  0x820,  0x821,  0x822,  0x823,  0x824,
/* 150 */  0x825,  0x826,  0x827,  0x828,  0x829,  0x82a,  0x82b,  0x82c,
/* 158 */  0x82d,  0x82e,  0x82f,  0x830,  0x831,  0x832,  0x833,  0x834,
/* 160 */  0x835,  0x836,  0x837,  0x838,  0x839,  0x83a,  0x83b,  0x83c,
/* 168 */  0x83d,  0x83e,  0x83f,  0x840,  0x841,  0x842,  0x843,  0x844,
/* 170 */  0x845,  0x846,  0x847,  0x848,  0x849,  0x84a,  0x84b,  0x84c,
/* 178 */  0x84d,  0x84e,  0x84f,  0x850,  0x851,  0x852,  0x853,  0x854,
/* 180 */  0x855,  0x856,  0x857,  0x858,  0x859,  0x85a,  0x85b,  0x85c,
/* 188 */  0x85d,  0x85e,  0x85f,  0x860,  0x861,  0x862,  0x863,  0x864,
/* 190 */  0x865,  0x866,  0x867,  0x868,  0x869,  0x86a,  0x86b,  0x86c,
/* 198 */  0x86d,  0x86e,  0x86f,  0x870,  0x871,  0x872,  0x873,  0x874,
/* 1a0 */  0x875,  0x876,  0x877,  0x878,  0x879,  0x87a,  0x87b,  0x87c,
/* 1a8 */  0x87d,  0x87e,  0x87f,  0x880,  0x881,  0x882,  0x883,  0x884,
/* 1b0 */  0x885,  0x886,  0x887,  0x888,  0x889,  0x88a,  0x88b,  0x88c,
/* 1b8 */  0x88d,  0x88e,  0x88f,  0x890,  0x891,  0x892,  0x893,  0x894,
/* 1c0 */  0x895,  0x896,  0x897,  0x898,  0x899,  0x89a,  0x89b,  0x89c,
/* 1c8 */  0x89d,  0x89e,  0x89f,  0x8a0,  0x8a1,  0x8a2,  0x8a3,  0x8a4,
/* 1d0 */  0x8a5,  0x8a6,  0x8a7,  0x8a8,  0x8a9,  0x8aa,  0x8ab,  0x8ac,
/* 1d8 */  0x8ad,  0x8ae,  0x8af,  0x8b0,  0x8b1,  0x8b2,  0x8b3,  0x8b4,
/* 1e0 */  0x8b5,  0x8b6,  0x8b7,  0x8b8,  0x8b9,  0x8ba,  0x8bb,  0x8bc,
/* 1e8 */  0x8bd,  0x8be,  0x8bf,  0x8c0,  0x8c1,  0x8c2,  0x8c3,  0x8c4,
/* 1f0 */  0x8c5,  0x8c6,  0x8c7,  0x8c8,  0x8c9,  0x8ca,  0x8cb,  0x8cc,
/* 1f8 */  0x8cd,  0x8ce,  0x8cf,    BAD,  0x8d0,  0x8d1,  0x8d2,  0x8d3,
/* 200 */  0x8d4,  0x8d5,  0x8d6,  0x8d7,  0x8d8,  0x8d9,  0x8da,  0x8db,
/* 208 */  0x8dc,  0x8dd,  0x8de,  0x8df,  0x8e0,  0x8e1,  0x8e2,  0x8e3,
/* 210 */  0x8e4,  0x8e5,  0x8e6,  0x8e7,  0x8e8,  0x8e9,  0x8ea,  0x8eb,
/* 218 */  0x8ec,  0x8ed,  0x8ee,  0x8ef,  0x8f0,  0x8f1,  0x8f2,  0x8f3,
/* 220 */  0x8f4,  0x8f5,  0x8f6,  0x8f7,  0x8f8,  0x8f9,  0x8fa,  0x8fb,
/* 228 */  0x8fc,  0x8fd,  0x8fe,  0x8ff,  0x900,  0x901,  0x902,    BAD,
/* 230 */  0x903,  0x904,  0x905,  0x906,  0x907,  0x908,  0x909,  0x90a,
/* 238 */  0x90b,  0x90c,  0x90d,  0x90e,  0x90f,  0x910,  0x911,  0x912,
/* 240 */  0x913,  0x914,  0x915,  0x916,  0x917,  0x918,  0x919,  0x91a,
/* 248 */  0x91b,  0x91c,  0x91d,  0x91e,  0x91f,  0x920,  0x921,  0x922,
/* 250 */  0x923,  0x924,  0x925,    BAD,    BAD,  0x926,  0x927,  0x928,
/* 258 */  0x929,  0x92a,  0x92b,  0x92c,  0x92d,  0x92e,  0x92f,  0x930,
/* 260 */  0x931,  0x932,  0x933,  0x934,  0x935,  0x936,  0x937,  0x938,
/* 268 */  0x939,  0x93a,  0x93b,  0x93c,  0x93d,  0x93e,  0x93f,  0x940,
/* 270 */  0x941,  0x942,    BAD,  0x943,  0x944,  0x945,  0x946,  0x947,
/* 278 */  0x948,  0x949,  0x94a,  0x94b,  0x94c,  0x94d,  0x94e,    BAD,
/* 280 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 288 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 290 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 298 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 300 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 308 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 310 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 318 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 320 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 328 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 330 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 338 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 340 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 348 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 350 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 358 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 360 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 368 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 370 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 378 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 380 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 388 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 390 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 398 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,  0x2cd,
/* 3a8 */  0x2ce,  0x2cf,  0x2d0,  0x2d1,  0x2d2,  0x2d3,  0x2d4,  0x2d5,
/* 3b0 */  0x2d6,  0x2d7,  0x2d8,  0x2d9,  0x2da,  0x2db,  0x2dc,  0x94f,
/* 3b8 */  0x950,  0x951,  0x952,  0x953,  0x954,  0x955,  0x956,  0x957,
/* 3c0 */  0x958,  0x959,  0x95a,  0x95b,  0x95c,  0x95d,  0x95e,  0x95f,
/* 3c8 */  0x960,  0x961,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f8 */    BAD,    BAD,    BAD,    BAD,  0x2de,  0x2e1,  0x2e2,  0x2e0
};

/* Row table for mapping Unicode to sdeckanji */

#define	ucs_to_sdeckanji_DMAP	1
#define	_ucs_to_sdeckanji_row	_ucs_to_eucjp_row

/* Mapping table from Unicode to Japanese */

static cell2_t _ucs_to_jp_cell2[] = {
/* Row 0x000 */
{
/* 00 */ 0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007,
/* 08 */ 0x0008, 0x0009, 0x000a, 0x000b, 0x000c, 0x000d, 0x000e, 0x000f,
/* 10 */ 0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017,
/* 18 */ 0x0018, 0x0019, 0x001a, 0x001b, 0x001c, 0x001d, 0x001e, 0x001f,
/* 20 */ 0x0020, 0x0021, 0x0022, 0x0023, 0x0024, 0x0025, 0x0026, 0x0027,
/* 28 */ 0x0028, 0x0029, 0x002a, 0x002b, 0x002c, 0x002d, 0x002e, 0x002f,
/* 30 */ 0x0030, 0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037,
/* 38 */ 0x0038, 0x0039, 0x003a, 0x003b, 0x003c, 0x003d, 0x003e, 0x003f
},

/* Row 0x001 */
{
/* 00 */ 0x0040, 0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047,
/* 08 */ 0x0048, 0x0049, 0x004a, 0x004b, 0x004c, 0x004d, 0x004e, 0x004f,
/* 10 */ 0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057,
/* 18 */ 0x0058, 0x0059, 0x005a, 0x005b, 0x005c, 0x005d, 0x005e, 0x005f,
/* 20 */ 0x0060, 0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067,
/* 28 */ 0x0068, 0x0069, 0x006a, 0x006b, 0x006c, 0x006d, 0x006e, 0x006f,
/* 30 */ 0x0070, 0x0071, 0x0072, 0x0073, 0x0074, 0x0075, 0x0076, 0x0077,
/* 38 */ 0x0078, 0x0079, 0x007a, 0x007b, 0x007c, 0x007d, 0x007e, 0x007f
},

/* Row 0x002 */
{
/* 00 */ 0x0080,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8191, 0x8192,    BAD,    BAD,    BAD, 0x8198,
/* 28 */ 0x814e,    BAD,    BAD,    BAD, 0x81ca,    BAD,    BAD,    BAD,
/* 30 */ 0x818b, 0x817d,    BAD,    BAD, 0x814c,    BAD, 0x81f7,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x003 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x817e,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8180,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x004 */
{
/* 00 */ 0x0060, 0x814c, 0x005e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x814e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x005f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x005 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x839f, 0x83a0, 0x83a1, 0x83a2, 0x83a3, 0x83a4, 0x83a5,
/* 18 */ 0x83a6, 0x83a7, 0x83a8, 0x83a9, 0x83aa, 0x83ab, 0x83ac, 0x83ad,
/* 20 */ 0x83ae, 0x83af,    BAD, 0x83b0, 0x83b1, 0x83b2, 0x83b3, 0x83b4,
/* 28 */ 0x83b5, 0x83b6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x83bf, 0x83c0, 0x83c1, 0x83c2, 0x83c3, 0x83c4, 0x83c5,
/* 38 */ 0x83c6, 0x83c7, 0x83c8, 0x83c9, 0x83ca, 0x83cb, 0x83cc, 0x83cd
},

/* Row 0x006 */
{
/* 00 */ 0x83ce, 0x83cf,    BAD, 0x83d0, 0x83d1, 0x83d2, 0x83d3, 0x83d4,
/* 08 */ 0x83d5, 0x83d6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x007 */
{
/* 00 */    BAD, 0x8446,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8440, 0x8441, 0x8442, 0x8443, 0x8444, 0x8445, 0x8447, 0x8448,
/* 18 */ 0x8449, 0x844a, 0x844b, 0x844c, 0x844d, 0x844e, 0x844f, 0x8450,
/* 20 */ 0x8451, 0x8452, 0x8453, 0x8454, 0x8455, 0x8456, 0x8457, 0x8458,
/* 28 */ 0x8459, 0x845a, 0x845b, 0x845c, 0x845d, 0x845e, 0x845f, 0x8460,
/* 30 */ 0x8470, 0x8471, 0x8472, 0x8473, 0x8474, 0x8475, 0x8477, 0x8478,
/* 38 */ 0x8479, 0x847a, 0x847b, 0x847c, 0x847d, 0x847e, 0x8480, 0x8481
},

/* Row 0x008 */
{
/* 00 */ 0x8482, 0x8483, 0x8484, 0x8485, 0x8486, 0x8487, 0x8488, 0x8489,
/* 08 */ 0x848a, 0x848b, 0x848c, 0x848d, 0x848e, 0x848f, 0x8490, 0x8491,
/* 10 */    BAD, 0x8476,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x009 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x815d,    BAD,    BAD,    BAD,    BAD, 0x815c, 0x8161,    BAD,
/* 18 */ 0x8165, 0x8166,    BAD,    BAD, 0x8167, 0x8168,    BAD,    BAD,
/* 20 */ 0x81f5, 0x81f6,    BAD,    BAD,    BAD, 0x8164, 0x8163,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x81f1,    BAD, 0x818c, 0x818d,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x81a6,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00a */
{
/* 00 */    BAD,    BAD,    BAD, 0x818e,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x81f0,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x81a9, 0x81aa, 0x81a8, 0x81ab,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x81cb,    BAD, 0x81cc,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00d */
{
/* 00 */ 0x81cd,    BAD, 0x81dd, 0x81ce,    BAD,    BAD,    BAD, 0x81de,
/* 08 */ 0x81b8,    BAD,    BAD, 0x81b9,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x817c,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x81e3,    BAD,    BAD, 0x81e5, 0x8187,    BAD,
/* 20 */ 0x81da,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x81c8,
/* 28 */ 0x81c9, 0x81bf, 0x81be, 0x81e7, 0x81e8,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8188, 0x81e6,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x81e4,    BAD,    BAD
},

/* Row 0x00e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x81e0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8182, 0x81df,    BAD,    BAD,    BAD,    BAD, 0x8185, 0x8186,
/* 28 */    BAD,    BAD, 0x81e1, 0x81e2,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00f */
{
/* 00 */    BAD,    BAD, 0x81bc, 0x81bd,    BAD,    BAD, 0x81ba, 0x81bb,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x81db,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x010 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x81dc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x011 */
{
/* 00 */ 0x849f, 0x84aa, 0x84a0, 0x84ab,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x84a1,    BAD,    BAD, 0x84ac,
/* 10 */ 0x84a2,    BAD,    BAD, 0x84ad, 0x84a4,    BAD,    BAD, 0x84af,
/* 18 */ 0x84a3,    BAD,    BAD, 0x84ae, 0x84a5, 0x84ba,    BAD,    BAD,
/* 20 */ 0x84b5,    BAD,    BAD, 0x84b0, 0x84a7, 0x84bc,    BAD,    BAD,
/* 28 */ 0x84b7,    BAD,    BAD, 0x84b2, 0x84a6,    BAD,    BAD, 0x84b6,
/* 30 */ 0x84bb,    BAD,    BAD, 0x84b1, 0x84a8,    BAD,    BAD, 0x84b8,
/* 38 */ 0x84bd,    BAD,    BAD, 0x84b3, 0x84a9,    BAD,    BAD, 0x84b9
},

/* Row 0x012 */
{
/* 00 */    BAD,    BAD, 0x84be,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x84b4,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x013 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x81a1, 0x81a0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x81a3, 0x81a2,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x81a5, 0x81a4,    BAD,    BAD
},

/* Row 0x014 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x819f, 0x819e,
/* 08 */    BAD,    BAD,    BAD, 0x819b,    BAD,    BAD, 0x819d, 0x819c,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x81fc,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x015 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x819a, 0x8199,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x016 */
{
/* 00 */ 0x818a,    BAD, 0x8189,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x81f4,    BAD,    BAD, 0x81f3,    BAD, 0x81f2,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x017 */
{
/* 00 */ 0x8140, 0x8141, 0x8142, 0x8156,    BAD, 0x8158, 0x8159, 0x815a,
/* 08 */ 0x8171, 0x8172, 0x8173, 0x8174, 0x8175, 0x8176, 0x8177, 0x8178,
/* 10 */ 0x8179, 0x817a, 0x81a7, 0x81ac, 0x816b, 0x816c,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x018 */
{
/* 00 */    BAD, 0x829f, 0x82a0, 0x82a1, 0x82a2, 0x82a3, 0x82a4, 0x82a5,
/* 08 */ 0x82a6, 0x82a7, 0x82a8, 0x82a9, 0x82aa, 0x82ab, 0x82ac, 0x82ad,
/* 10 */ 0x82ae, 0x82af, 0x82b0, 0x82b1, 0x82b2, 0x82b3, 0x82b4, 0x82b5,
/* 18 */ 0x82b6, 0x82b7, 0x82b8, 0x82b9, 0x82ba, 0x82bb, 0x82bc, 0x82bd,
/* 20 */ 0x82be, 0x82bf, 0x82c0, 0x82c1, 0x82c2, 0x82c3, 0x82c4, 0x82c5,
/* 28 */ 0x82c6, 0x82c7, 0x82c8, 0x82c9, 0x82ca, 0x82cb, 0x82cc, 0x82cd,
/* 30 */ 0x82ce, 0x82cf, 0x82d0, 0x82d1, 0x82d2, 0x82d3, 0x82d4, 0x82d5,
/* 38 */ 0x82d6, 0x82d7, 0x82d8, 0x82d9, 0x82da, 0x82db, 0x82dc, 0x82dd
},

/* Row 0x019 */
{
/* 00 */ 0x82de, 0x82df, 0x82e0, 0x82e1, 0x82e2, 0x82e3, 0x82e4, 0x82e5,
/* 08 */ 0x82e6, 0x82e7, 0x82e8, 0x82e9, 0x82ea, 0x82eb, 0x82ec, 0x82ed,
/* 10 */ 0x82ee, 0x82ef, 0x82f0, 0x82f1,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x814a, 0x814b, 0x814a, 0x814b, 0x8154, 0x8155,    BAD,
/* 20 */    BAD, 0x8340, 0x8341, 0x8342, 0x8343, 0x8344, 0x8345, 0x8346,
/* 28 */ 0x8347, 0x8348, 0x8349, 0x834a, 0x834b, 0x834c, 0x834d, 0x834e,
/* 30 */ 0x834f, 0x8350, 0x8351, 0x8352, 0x8353, 0x8354, 0x8355, 0x8356,
/* 38 */ 0x8357, 0x8358, 0x8359, 0x835a, 0x835b, 0x835c, 0x835d, 0x835e
},

/* Row 0x01a */
{
/* 00 */ 0x835f, 0x8360, 0x8361, 0x8362, 0x8363, 0x8364, 0x8365, 0x8366,
/* 08 */ 0x8367, 0x8368, 0x8369, 0x836a, 0x836b, 0x836c, 0x836d, 0x836e,
/* 10 */ 0x836f, 0x8370, 0x8371, 0x8372, 0x8373, 0x8374, 0x8375, 0x8376,
/* 18 */ 0x8377, 0x8378, 0x8379, 0x837a, 0x837b, 0x837c, 0x837d, 0x837e,
/* 20 */ 0x8380, 0x8381, 0x8382, 0x8383, 0x8384, 0x8385, 0x8386, 0x8387,
/* 28 */ 0x8388, 0x8389, 0x838a, 0x838b, 0x838c, 0x838d, 0x838e, 0x838f,
/* 30 */ 0x8390, 0x8391, 0x8392, 0x8393, 0x8394, 0x8395, 0x8396,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8145, 0x815b, 0x8152, 0x8153,    BAD
},

/* Row 0x01b */
{
/* 00 */ 0x88ea, 0x929a,    BAD, 0x8eb5,    BAD,    BAD,    BAD, 0x969c,
/* 08 */ 0x8fe4, 0x8e4f, 0x8fe3, 0x89ba,    BAD, 0x9573, 0x975e,    BAD,
/* 10 */ 0x98a0, 0x894e,    BAD,    BAD, 0x8a8e, 0x98a1, 0x90a2, 0x99c0,
/* 18 */ 0x8b75, 0x95b8,    BAD,    BAD,    BAD,    BAD, 0x8fe5,    BAD,
/* 20 */    BAD, 0x97bc,    BAD,    BAD,    BAD,    BAD, 0x95c0,    BAD,
/* 28 */    BAD,    BAD, 0x98a2,    BAD,    BAD, 0x9286,    BAD,    BAD,
/* 30 */    BAD, 0x98a3, 0x8bf8,    BAD,    BAD,    BAD, 0x98a4,    BAD,
/* 38 */ 0x8adb, 0x924f,    BAD, 0x8ee5, 0x98a5,    BAD,    BAD, 0x98a6
},

/* Row 0x01c */
{
/* 00 */    BAD,    BAD, 0x98a7, 0x9454,    BAD, 0x8b76,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x9456,    BAD, 0x93e1, 0x8cc1, 0x9652,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe568, 0x98a8, 0x8fe6,
/* 18 */ 0x98a9, 0x89b3,    BAD,    BAD,    BAD, 0x8be3, 0x8cee, 0x96e7,
/* 20 */    BAD,    BAD, 0x9ba4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x9790,    BAD, 0x93fb,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8aa3,    BAD
},

/* Row 0x01d */
{
/* 00 */ 0x8b54,    BAD, 0x98aa,    BAD,    BAD, 0x98ab, 0x97b9,    BAD,
/* 08 */ 0x975c, 0x9188, 0x98ad, 0x8e96, 0x93f1,    BAD, 0x98b0,    BAD,
/* 10 */    BAD, 0x895d, 0x8cdd,    BAD, 0x8cdc, 0x88e4,    BAD,    BAD,
/* 18 */ 0x986a, 0x9869,    BAD, 0x8db1, 0x889f,    BAD, 0x98b1, 0x98b2,
/* 20 */ 0x98b3, 0x9653, 0x98b4,    BAD, 0x8cf0, 0x88e5, 0x9692,    BAD,
/* 28 */ 0x8b9c,    BAD,    BAD, 0x8b9d, 0x8b9e, 0x92e0, 0x97ba,    BAD,
/* 30 */ 0x98b5,    BAD,    BAD, 0x98b6,    BAD,    BAD, 0x98b7,    BAD,
/* 38 */    BAD,    BAD, 0x906c,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x01e */
{
/* 00 */ 0x8f59, 0x906d, 0x98bc,    BAD, 0x98ba,    BAD, 0x98bb, 0x8b77,
/* 08 */    BAD,    BAD, 0x8da1, 0x89ee,    BAD, 0x98b9, 0x98b8, 0x95a7,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8e65, 0x8e64, 0x91bc, 0x98bd,
/* 18 */ 0x9574, 0x90e5,    BAD,    BAD,    BAD, 0x8157, 0x98be, 0x98c0,
/* 20 */    BAD,    BAD,    BAD, 0x91e3, 0x97df, 0x88c8,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x98bf, 0x89bc,    BAD,
/* 30 */ 0x8bc2,    BAD, 0x9287,    BAD,    BAD,    BAD, 0x8c8f, 0x98c1,
/* 38 */    BAD,    BAD,    BAD, 0x9443,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x01f */
{
/* 00 */    BAD, 0x8ae9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x98c2, 0x88c9,    BAD,    BAD, 0x8cde, 0x8aea, 0x959a,
/* 10 */ 0x94b0, 0x8b78,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x89ef,    BAD, 0x98e5, 0x9360,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x948c,
/* 30 */ 0x98c4,    BAD,    BAD,    BAD, 0x94ba,    BAD, 0x97e0,    BAD,
/* 38 */ 0x904c,    BAD, 0x8e66,    BAD, 0x8e97, 0x89be,    BAD,    BAD
},

/* Row 0x020 */
{
/* 00 */    BAD,    BAD,    BAD, 0x92cf,    BAD,    BAD, 0x9241, 0x98c8,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x88ca, 0x92e1, 0x8f5a,
/* 10 */ 0x8db2, 0x9743,    BAD, 0x91cc,    BAD, 0x89bd,    BAD, 0x98c7,
/* 18 */    BAD, 0x975d, 0x98c3, 0x98c5, 0x8dec, 0x98c6, 0x9b43,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x98ce,    BAD,    BAD,    BAD,    BAD,    BAD, 0x98d1,
/* 30 */ 0x98cf,    BAD,    BAD, 0x89c0,    BAD, 0x95b9, 0x98c9,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x98cd, 0x8cf1,    BAD,    BAD, 0x8e67
},

/* Row 0x021 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8aa4,    BAD,    BAD, 0x98d2,    BAD,
/* 08 */ 0x98ca,    BAD,    BAD, 0x97e1,    BAD, 0x8e98,    BAD, 0x98cb,
/* 10 */    BAD, 0x98d0,    BAD,    BAD,    BAD,    BAD, 0x98d3,    BAD,
/* 18 */ 0x98cc,    BAD,    BAD, 0x8b9f,    BAD, 0x88cb,    BAD,    BAD,
/* 20 */ 0x8ba0, 0x89bf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x9b44,    BAD, 0x9699, 0x958e, 0x8cf2,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x904e, 0x97b5,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95d6
},

/* Row 0x022 */
{
/* 00 */    BAD,    BAD, 0x8c57, 0x91a3, 0x89e2,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8f72,    BAD,    BAD,    BAD, 0x98d7,    BAD,
/* 10 */ 0x98dc, 0x98da,    BAD,    BAD, 0x98d5,    BAD,    BAD, 0x91ad,
/* 18 */ 0x98d8,    BAD, 0x98db, 0x98d9,    BAD, 0x95db,    BAD, 0x98d6,
/* 20 */    BAD, 0x904d,    BAD, 0x9693, 0x98dd, 0x98de,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f43, 0x98eb,
/* 30 */    BAD,    BAD,    BAD, 0x946f,    BAD, 0x9555, 0x98e6,    BAD,
/* 38 */ 0x95ee,    BAD, 0x89b4,    BAD,    BAD,    BAD, 0x98ea,    BAD
},

/* Row 0x023 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x98e4, 0x98ed,    BAD,
/* 08 */    BAD, 0x9171,    BAD, 0x8cc2,    BAD, 0x947b,    BAD, 0xe0c5,
/* 10 */    BAD, 0x98ec, 0x937c,    BAD, 0x98e1,    BAD, 0x8cf4,    BAD,
/* 18 */    BAD, 0x8cf3, 0x98df,    BAD,    BAD,    BAD,    BAD, 0x8ed8,
/* 20 */    BAD, 0x98e7,    BAD, 0x95ed, 0x926c, 0x98e3, 0x8c91,    BAD,
/* 28 */ 0x98e0, 0x98e8, 0x98e2, 0x97cf, 0x98e9, 0x9860,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8be4,    BAD,
/* 38 */    BAD, 0x8c90,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x024 */
{
/* 00 */    BAD,    BAD,    BAD, 0x98ee,    BAD,    BAD,    BAD, 0x98ef,
/* 08 */ 0x98f3, 0x88cc,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95ce,
/* 10 */ 0x98f2,    BAD,    BAD,    BAD,    BAD, 0x98f1, 0x98f5,    BAD,
/* 18 */    BAD,    BAD, 0x98f4,    BAD, 0x92e2,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8c92,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x98f6,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8ec3,    BAD, 0x91a4, 0x92e3, 0x8bf4,    BAD,
/* 38 */ 0x98f7,    BAD,    BAD,    BAD,    BAD, 0x8b55,    BAD,    BAD
},

/* Row 0x025 */
{
/* 00 */ 0x98f8,    BAD,    BAD,    BAD,    BAD, 0x98fa,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9654,    BAD,    BAD,
/* 10 */    BAD, 0x8c86,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8e50, 0x94f5, 0x98f9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8dc3, 0x9762,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x98fc, 0x9942, 0x98fb, 0x8dc2,    BAD, 0x8f9d,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8c58,    BAD
},

/* Row 0x026 */
{
/* 00 */    BAD,    BAD, 0x9943,    BAD,    BAD, 0x8bcd,    BAD,    BAD,
/* 08 */    BAD, 0x9940, 0x9941,    BAD,    BAD, 0x93ad,    BAD, 0x919c,
/* 10 */    BAD, 0x8ba1,    BAD,    BAD,    BAD, 0x966c, 0x9944,    BAD,
/* 18 */    BAD,    BAD, 0x97bb,    BAD,    BAD,    BAD, 0x9945,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9948,    BAD, 0x9946,    BAD, 0x916d,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9947, 0x9949,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x994b,    BAD,    BAD,
/* 38 */    BAD, 0x994a,    BAD, 0x95c6,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x027 */
{
/* 00 */ 0x8b56, 0x994d, 0x994e,    BAD, 0x89ad,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x994c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8ef2,    BAD, 0x9951, 0x9950, 0x994f,    BAD,
/* 18 */ 0x98d4,    BAD, 0x9952,    BAD,    BAD,    BAD,    BAD, 0x8f9e,
/* 20 */    BAD, 0x9953,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9744,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x96d7,    BAD,    BAD,    BAD,    BAD, 0x9955,
/* 38 */    BAD,    BAD, 0x9954, 0x9957, 0x9956,    BAD,    BAD, 0x9958
},

/* Row 0x028 */
{
/* 00 */ 0x9959, 0x88f2,    BAD, 0x8cb3, 0x8c5a, 0x8f5b, 0x929b, 0x8ba2,
/* 08 */ 0x90e6, 0x8cf5,    BAD, 0x8d8e, 0x995b, 0x96c6, 0x9365,    BAD,
/* 10 */ 0x8e99,    BAD, 0x995a,    BAD, 0x995c,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x937d,    BAD, 0x8a95,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x995d,    BAD,    BAD, 0x93fc,    BAD,    BAD,
/* 28 */ 0x9153, 0x995f, 0x9960, 0x94aa, 0x8cf6, 0x985a, 0x9961,    BAD,
/* 30 */    BAD, 0x8ba4,    BAD,    BAD,    BAD, 0x95ba, 0x91b4, 0x8bef,
/* 38 */ 0x9354,    BAD,    BAD,    BAD, 0x8c93,    BAD,    BAD,    BAD
},

/* Row 0x029 */
{
/* 00 */ 0x9962,    BAD, 0x9963,    BAD,    BAD, 0x93e0, 0x897e,    BAD,
/* 08 */    BAD, 0x9966, 0x8dfb,    BAD, 0x9965, 0x8dc4,    BAD, 0x9967,
/* 10 */ 0xe3ec, 0x9968, 0x9660, 0x9969,    BAD, 0x996a, 0x996b, 0x8fe7,
/* 18 */    BAD, 0x8eca,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8aa5,    BAD, 0x996e,    BAD, 0x996c, 0x96bb, 0x996d,    BAD,
/* 28 */ 0x9579, 0x996f, 0x9970, 0x9971, 0x937e,    BAD,    BAD,    BAD,
/* 30 */ 0x9975, 0x9973, 0x9974, 0x9972, 0x8de1, 0x9976, 0x96e8, 0x97e2,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9977,    BAD,    BAD
},

/* Row 0x02a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x90a6, 0x9978, 0x8f79,    BAD,
/* 08 */    BAD, 0x9979,    BAD, 0x929c, 0x97bd, 0x9380,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99c3,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x997a, 0xeaa3, 0x8bc3,    BAD,    BAD,
/* 20 */ 0x997b, 0x967d,    BAD,    BAD,    BAD,    BAD, 0x8f88, 0x91fa,
/* 28 */    BAD, 0x997d, 0x93e2,    BAD,    BAD, 0x997e,    BAD,    BAD,
/* 30 */ 0x9980, 0x8a4d,    BAD,    BAD,    BAD, 0x9981, 0x8ba5,    BAD,
/* 38 */ 0x93ca, 0x899a, 0x8f6f,    BAD,    BAD, 0x949f, 0x9982,    BAD
},

/* Row 0x02b */
{
/* 00 */ 0x9381,    BAD,    BAD, 0x906e, 0x9983,    BAD, 0x95aa, 0x90d8,
/* 08 */ 0x8aa0,    BAD, 0x8aa7, 0x9984,    BAD,    BAD, 0x9986,    BAD,
/* 10 */    BAD, 0x8c59,    BAD,    BAD, 0x9985,    BAD,    BAD, 0x97f1,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f89,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x94bb, 0x95ca,    BAD, 0x9987,
/* 28 */    BAD, 0x9798, 0x9988,    BAD,    BAD,    BAD, 0x9989,    BAD,
/* 30 */ 0x939e,    BAD,    BAD, 0x998a,    BAD,    BAD, 0x90a7, 0x8dfc,
/* 38 */ 0x8c94, 0x998b, 0x8e68, 0x8d8f,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x02c */
{
/* 00 */    BAD,    BAD,    BAD, 0x92e4, 0x998d,    BAD,    BAD, 0x91a5,
/* 08 */    BAD,    BAD, 0x8ded, 0x998e, 0x998f, 0x914f,    BAD, 0x998c,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x9991,    BAD, 0x9655,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8d84,    BAD,    BAD, 0x9990,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x8c95, 0x8ddc, 0x948d,    BAD,    BAD,
/* 28 */    BAD, 0x9994, 0x9992,    BAD,    BAD,    BAD,    BAD, 0x959b,
/* 30 */ 0x8fe8, 0x999b, 0x8a84, 0x9995, 0x9993, 0x916e,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9997,    BAD, 0x9996
},

/* Row 0x02d */
{
/* 00 */    BAD,    BAD,    BAD, 0x8a63,    BAD,    BAD,    BAD, 0x8c80,
/* 08 */ 0x999c, 0x97ab,    BAD,    BAD,    BAD, 0x9998,    BAD,    BAD,
/* 10 */    BAD, 0x999d, 0x999a,    BAD, 0x9999,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x97cd,    BAD,    BAD,    BAD, 0x8cf7,
/* 20 */ 0x89c1,    BAD,    BAD, 0x97f2,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8f95, 0x9377, 0x8d85, 0x99a0, 0x99a1,    BAD,    BAD,
/* 30 */    BAD, 0x97e3,    BAD,    BAD, 0x984a, 0x99a3,    BAD,    BAD,
/* 38 */    BAD, 0x8cf8,    BAD,    BAD, 0x99a2,    BAD, 0x8a4e,    BAD
},

/* Row 0x02e */
{
/* 00 */    BAD, 0x99a4,    BAD, 0x9675,    BAD, 0x92ba,    BAD, 0x9745,
/* 08 */    BAD, 0x95d7,    BAD,    BAD,    BAD, 0x99a5,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe8d3,    BAD,    BAD, 0x93ae,    BAD, 0x99a6,
/* 18 */ 0x8aa8, 0x96b1,    BAD,    BAD,    BAD, 0x8f9f, 0x99a7, 0x95e5,
/* 20 */ 0x99ab,    BAD, 0x90a8, 0x99a8, 0x8bce,    BAD, 0x99a9, 0x8aa9,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8c4d, 0x99ac,    BAD, 0x99ad,    BAD,    BAD,
/* 38 */ 0x99ae, 0x99af, 0x8ed9,    BAD,    BAD,    BAD, 0x8cf9, 0x96dc
},

/* Row 0x02f */
{
/* 00 */    BAD, 0x96e6, 0x93f5,    BAD,    BAD, 0x95ef, 0x99b0,    BAD,
/* 08 */ 0x99b1,    BAD,    BAD,    BAD,    BAD, 0x99b3,    BAD, 0x99b5,
/* 10 */ 0x99b4,    BAD,    BAD,    BAD,    BAD, 0x99b6, 0x89bb, 0x966b,
/* 18 */    BAD, 0x8dfa, 0x99b7,    BAD,    BAD, 0x9178,    BAD,    BAD,
/* 20 */ 0x8fa0, 0x8ba7,    BAD, 0x99b8,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x94d9,    BAD,    BAD,    BAD,    BAD, 0x99b9,
/* 30 */    BAD, 0x99ba,    BAD, 0x99bb,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x99bc, 0x9543, 0x8be6, 0x88e3,    BAD,    BAD,    BAD, 0x93bd
},

/* Row 0x030 */
{
/* 00 */ 0x99bd, 0x8f5c,    BAD, 0x90e7,    BAD, 0x99bf, 0x99be, 0x8fa1,
/* 08 */ 0x8cdf, 0x99c1, 0x94bc,    BAD,    BAD, 0x99c2,    BAD,    BAD,
/* 10 */    BAD, 0x94da, 0x91b2, 0x91ec, 0x8ba6,    BAD,    BAD, 0x93ec,
/* 18 */ 0x9250,    BAD, 0x948e,    BAD, 0x966d,    BAD, 0x99c4,    BAD,
/* 20 */ 0x90e8,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8c54,    BAD,
/* 28 */    BAD, 0x99c5,    BAD,    BAD,    BAD,    BAD, 0x99c6, 0x894b,
/* 30 */ 0x88f3, 0x8aeb,    BAD, 0x91a6, 0x8b70, 0x9791,    BAD, 0x99c9,
/* 38 */ 0x89b5,    BAD,    BAD, 0x99c8,    BAD,    BAD,    BAD, 0x8ba8
},

/* Row 0x031 */
{
/* 00 */    BAD,    BAD, 0x99ca,    BAD, 0x96ef,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99cb,    BAD,
/* 18 */ 0x97d0,    BAD, 0x8cfa,    BAD,    BAD,    BAD,    BAD, 0x8cb4,
/* 20 */ 0x99cc,    BAD,    BAD,    BAD,    BAD, 0x99ce, 0x99cd,    BAD,
/* 28 */ 0x907e, 0x8958,    BAD,    BAD,    BAD, 0x897d, 0x99cf,    BAD,
/* 30 */ 0x99d0,    BAD,    BAD, 0x8cb5,    BAD,    BAD, 0x99d1,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8b8e,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x032 */
{
/* 00 */    BAD,    BAD, 0x8e51, 0x99d2,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9694, 0x8db3, 0x8b79, 0x9746, 0x916f, 0x94bd, 0x8efb,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8f66,    BAD, 0x8ee6, 0x8ef3,
/* 18 */    BAD, 0x8f96,    BAD, 0x94be,    BAD,    BAD,    BAD, 0x99d5,
/* 20 */    BAD, 0x8962, 0x9170, 0x8cfb, 0x8cc3, 0x8be5,    BAD,    BAD,
/* 28 */ 0x99d9, 0x9240, 0x91fc, 0x8ba9, 0x8fa2, 0x99da, 0x99d8, 0x89c2,
/* 30 */ 0x91e4, 0x8eb6, 0x8e6a, 0x8945,    BAD,    BAD, 0x8a90, 0x8d86,
/* 38 */ 0x8e69,    BAD, 0x99db,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x033 */
{
/* 00 */    BAD, 0x99dc,    BAD, 0x8b68, 0x8a65,    BAD,    BAD,    BAD,
/* 08 */ 0x8d87, 0x8b67, 0x92dd, 0x8944, 0x93af, 0x96bc, 0x8d40, 0x9799,
/* 10 */ 0x9366, 0x8cfc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8c4e,    BAD, 0x99e5,    BAD, 0x8be1,
/* 20 */ 0x9669,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94db,    BAD,
/* 28 */    BAD, 0x99e4,    BAD, 0x8adc, 0x99df, 0x99e0, 0x99e2,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99e3,    BAD,
/* 38 */ 0x8b7a, 0x9081,    BAD, 0x95ab, 0x99e1, 0x99dd, 0x8ce1,    BAD
},

/* Row 0x034 */
{
/* 00 */ 0x99de,    BAD, 0x9843,    BAD,    BAD,    BAD, 0x95f0,    BAD,
/* 08 */ 0x92e6, 0x8ce0, 0x8d90,    BAD,    BAD,    BAD, 0x99e6,    BAD,
/* 10 */    BAD, 0x93db,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99ea,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8efc,    BAD, 0x8ef4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x99ed, 0x99eb,    BAD, 0x96a1,    BAD, 0x99e8, 0x99f1, 0x99ec,
/* 38 */    BAD,    BAD,    BAD, 0x99ef, 0x8cc4, 0x96bd,    BAD,    BAD
},

/* Row 0x035 */
{
/* 00 */ 0x99f0,    BAD,    BAD,    BAD, 0x99f2,    BAD, 0x99f4,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8dee, 0x9861,    BAD, 0x99e9, 0x99e7,
/* 10 */ 0x99f3,    BAD, 0x99ee,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x99f6,    BAD, 0x9a42, 0x99f8,    BAD,    BAD,
/* 28 */ 0x99fc,    BAD,    BAD, 0x9a40, 0x99f9,    BAD,    BAD, 0x9a5d,
/* 30 */    BAD,    BAD, 0x8de7, 0x8a50,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x99f7,    BAD,    BAD,    BAD, 0x9a44, 0x88f4, 0x9a43,    BAD
},

/* Row 0x036 */
{
/* 00 */ 0x88a3, 0x9569, 0x9a41,    BAD, 0x99fa,    BAD,    BAD, 0x99f5,
/* 08 */ 0x99fb, 0x8dc6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9a45,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x88f5, 0x9a4e,    BAD,    BAD, 0x9a46, 0x9a47,    BAD,
/* 28 */ 0x8fa3, 0x9689,    BAD,    BAD,    BAD, 0x9a4c, 0x9a4b,    BAD,
/* 30 */    BAD,    BAD, 0x934e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9a4d,    BAD,    BAD, 0x9a4a,    BAD,    BAD
},

/* Row 0x037 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8953,    BAD, 0x8db4, 0x904f,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a48,
/* 10 */ 0x9382,    BAD,    BAD,    BAD, 0x9a49,    BAD, 0x88a0,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a53, 0x9742,
/* 30 */    BAD, 0x8fa5,    BAD, 0x9a59,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9a58, 0x9a4f,    BAD,    BAD,    BAD,    BAD, 0x91c1,    BAD
},

/* Row 0x038 */
{
/* 00 */ 0x9a50,    BAD,    BAD,    BAD, 0x91ed, 0x9a55, 0x8fa4,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x9a52,    BAD,    BAD, 0x96e2,
/* 10 */    BAD,    BAD,    BAD, 0x8c5b,    BAD,    BAD, 0x9a56, 0x9a57,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9a54, 0x9a5a,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9a51,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9a60, 0x9a65,    BAD, 0x9a61,    BAD
},

/* Row 0x039 */
{
/* 00 */ 0x9a5c,    BAD,    BAD, 0x9a66, 0x9150,    BAD,    BAD, 0x9a68,
/* 08 */    BAD, 0x8d41, 0x9a5e, 0x929d,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9a62, 0x9a5b, 0x8aab,    BAD, 0x8aec, 0x8a85, 0x9a63, 0x9a5f,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8c96,
/* 28 */ 0x9a69, 0x9a67, 0x9172, 0x8b69, 0x8baa,    BAD, 0x9a64,    BAD,
/* 30 */ 0x8bf2,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8963,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x03a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x9a6d, 0x9a6b,    BAD, 0x9aa5,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x9a70,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9a6a,    BAD, 0x9a6e,    BAD,    BAD, 0x9a6c,
/* 20 */    BAD,    BAD,    BAD, 0x8e6b, 0x9a6f,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a72,
/* 38 */    BAD, 0x9a77,    BAD,    BAD,    BAD, 0x9a75, 0x9a74,    BAD
},

/* Row 0x03b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9251,    BAD,
/* 08 */    BAD, 0x89c3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x9a71,    BAD, 0x9a73, 0x8fa6,
/* 18 */ 0x8952,    BAD,    BAD, 0x9a76,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x89dc,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a82,
/* 30 */    BAD, 0x8ffa, 0x9a7d,    BAD, 0x9a7b,    BAD, 0x9a7c,    BAD,
/* 38 */ 0x9a7e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x03c */
{
/* 00 */    BAD,    BAD, 0x895c,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x9158,    BAD, 0x9a78,    BAD,
/* 10 */ 0x9a79,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8a9a,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9a81,    BAD,    BAD,    BAD,
/* 28 */ 0x8aed,    BAD, 0x9a84, 0x9a80, 0x9a83,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x95ac,    BAD,    BAD,    BAD,
/* 38 */ 0x93d3,    BAD, 0x94b6,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x03d */
{
/* 00 */ 0x9a86,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a85, 0x8a64,
/* 08 */    BAD,    BAD, 0x9a87,    BAD,    BAD,    BAD,    BAD, 0x9a8a,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x9a89,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9a88,    BAD, 0x9458,    BAD,    BAD, 0x9a8b,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a8c,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9a8e,    BAD, 0x9a8d,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9a90,    BAD,    BAD,    BAD
},

/* Row 0x03e */
{
/* 00 */ 0x9a93, 0x9a91, 0x9a8f, 0x9a92,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9a94,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a95,    BAD,
/* 10 */    BAD, 0x9a96,    BAD, 0x9a97,    BAD,    BAD,    BAD, 0x9a98,
/* 18 */ 0x9964,    BAD, 0x8efa, 0x8e6c,    BAD,    BAD, 0x89f1,    BAD,
/* 20 */ 0x88f6,    BAD,    BAD, 0x9263,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a99,    BAD,
/* 30 */ 0x8da2,    BAD, 0x88cd, 0x907d,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9a9a, 0x8cc5,    BAD,    BAD, 0x8d91,    BAD, 0x9a9c
},

/* Row 0x03f */
{
/* 00 */ 0x9a9b,    BAD,    BAD, 0x95de, 0x9a9d,    BAD,    BAD,    BAD,
/* 08 */ 0x9a9f, 0x9a9e,    BAD, 0x9aa0,    BAD, 0x9aa1,    BAD, 0x8c97,
/* 10 */    BAD,    BAD, 0x8980, 0x9aa2,    BAD,    BAD, 0x9aa4,    BAD,
/* 18 */ 0x9aa3,    BAD,    BAD,    BAD, 0x9aa6,    BAD,    BAD, 0x9379,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9aa7, 0x88b3,
/* 28 */ 0x8ddd,    BAD,    BAD,    BAD,    BAD, 0x8c5c,    BAD,    BAD,
/* 30 */ 0x926e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9aa8,
/* 38 */ 0x9aa9,    BAD,    BAD, 0x9aab,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x040 */
{
/* 00 */ 0x9aac,    BAD, 0x8de2,    BAD,    BAD,    BAD,    BAD, 0x8bcf,
/* 08 */    BAD,    BAD, 0x9656,    BAD,    BAD,    BAD, 0x9aaa, 0x9aad,
/* 10 */ 0x8dbf, 0x8d42,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9ab1,    BAD,    BAD, 0x8da3,    BAD, 0x9252,    BAD,
/* 28 */    BAD, 0x9aae, 0x92d8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ab2
},

/* Row 0x041 */
{
/* 00 */    BAD,    BAD, 0x9082,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9ab0, 0x9ab3,    BAD, 0x8c5e,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9ab4,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9ab5,    BAD, 0x8d43, 0x8a5f, 0x9ab7,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9ab8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9ab9,    BAD,    BAD, 0x9ab6,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x042 */
{
/* 00 */ 0x9aaf,    BAD,    BAD, 0x9aba,    BAD,    BAD, 0x9abb,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x9684,    BAD,    BAD, 0x8fe9,    BAD,
/* 10 */    BAD,    BAD, 0x9abd, 0x9abe, 0x9abc,    BAD, 0x9ac0,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9457,    BAD,    BAD, 0x88e6,
/* 20 */ 0x9575,    BAD,    BAD, 0x9ac1,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8ffb,    BAD,    BAD, 0x8eb7,
/* 38 */    BAD, 0x947c, 0x8aee,    BAD, 0x8de9,    BAD,    BAD,    BAD
},

/* Row 0x043 */
{
/* 00 */ 0x9678,    BAD, 0x93b0,    BAD,    BAD, 0x8c98, 0x91cd,    BAD,
/* 08 */    BAD,    BAD, 0x9abf, 0x9ac2,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x91c2,    BAD,    BAD,
/* 18 */    BAD, 0x9ac3,    BAD,    BAD,    BAD, 0x9ac4,    BAD,    BAD,
/* 20 */    BAD, 0x9ac6,    BAD,    BAD, 0x92e7,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8aac,    BAD,    BAD,    BAD,    BAD, 0xea9f,
/* 30 */ 0x8981, 0x95f1,    BAD,    BAD, 0x8fea, 0x9367,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8de4,    BAD,    BAD, 0x9acc,    BAD,    BAD
},

/* Row 0x044 */
{
/* 00 */ 0x95bb, 0x97db,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x89f2, 0x9ac8,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9159, 0x9acb,    BAD, 0x9383,    BAD,    BAD, 0x9368,
/* 18 */ 0x9384, 0x94b7, 0x92cb,    BAD,    BAD,    BAD, 0x8dc7,    BAD,
/* 20 */    BAD,    BAD, 0x9ac7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8996,    BAD, 0x9355,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9ac9,    BAD, 0x9ac5,    BAD,    BAD, 0x906f,    BAD,    BAD,
/* 38 */    BAD, 0x9acd,    BAD,    BAD,    BAD,    BAD, 0x8f6d,    BAD
},

/* Row 0x045 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8bab,    BAD, 0x9ace,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x95e6,    BAD,    BAD,    BAD, 0x919d,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x92c4,    BAD,    BAD, 0x9ad0,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x966e,    BAD,    BAD, 0x9ad1,    BAD,    BAD, 0x9ad6,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x95ad,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9ad5, 0x9acf, 0x9ad2, 0x9ad4,    BAD,    BAD, 0x8da4,    BAD
},

/* Row 0x046 */
{
/* 00 */    BAD, 0x95c7,    BAD,    BAD,    BAD, 0x9ad7,    BAD, 0x9264,
/* 08 */    BAD,    BAD, 0x89f3,    BAD, 0x8feb,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9ad9,    BAD, 0x9ad8,    BAD, 0x8d88,    BAD, 0x9ada,
/* 18 */ 0x9adc, 0x9adb,    BAD,    BAD, 0x9ade,    BAD, 0x9ad3, 0x9ae0,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9adf, 0x9add,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8e6d, 0x9070,    BAD, 0x9173, 0x9ae1,
/* 30 */ 0x90ba, 0x88eb, 0x9484,    BAD,    BAD,    BAD,    BAD, 0x92d9,
/* 38 */    BAD, 0x9ae3, 0x9ae2, 0x9ae4, 0x9ae5, 0x9ae6,    BAD,    BAD
},

/* Row 0x047 */
{
/* 00 */    BAD,    BAD, 0x9ae7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x95cf, 0x9ae8,    BAD,    BAD,    BAD,    BAD, 0x89c4,
/* 10 */ 0x9ae9,    BAD,    BAD,    BAD,    BAD, 0x975b, 0x8a4f,    BAD,
/* 18 */ 0x99c7, 0x8f67, 0x91bd, 0x9aea, 0x96e9,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x96b2,    BAD,    BAD, 0x9aec,    BAD, 0x91e5,
/* 28 */    BAD, 0x9356, 0x91be, 0x9576, 0x9aed, 0x9aee, 0x899b,    BAD,
/* 30 */    BAD, 0x8eb8, 0x9aef,    BAD,    BAD,    BAD,    BAD, 0x88ce,
/* 38 */ 0x9af0,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9af1,    BAD
},

/* Row 0x048 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8982,    BAD,    BAD, 0x8aef,
/* 08 */ 0x93de, 0x95f2,    BAD,    BAD,    BAD,    BAD, 0x9af5, 0x9174,
/* 10 */ 0x9af4, 0x8c5f,    BAD,    BAD, 0x967a, 0x9af3,    BAD, 0x9385,
/* 18 */ 0x9af7,    BAD, 0x9af6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9af9,    BAD, 0x9af8,    BAD,    BAD, 0x899c,    BAD, 0x9afa,
/* 28 */ 0x8fa7, 0x9afc, 0x9244,    BAD, 0x9afb,    BAD, 0x95b1,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x8f97, 0x937a,    BAD,    BAD,    BAD,
/* 38 */ 0x9b40,    BAD,    BAD,    BAD,    BAD, 0x8d44,    BAD,    BAD
},

/* Row 0x049 */
{
/* 00 */    BAD, 0x9b41, 0x9440, 0x94dc, 0x96cf,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9444,    BAD,    BAD, 0x9b4a,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8b57,    BAD,    BAD, 0x9764,    BAD,
/* 18 */    BAD, 0x96ad,    BAD, 0x9baa,    BAD, 0x9b42,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9b45,    BAD, 0x91c3,    BAD,    BAD,
/* 28 */ 0x9657,    BAD,    BAD,    BAD, 0x9369,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9b46,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9685,    BAD, 0x8dc8,    BAD,    BAD, 0x8fa8,    BAD
},

/* Row 0x04a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9b47,    BAD,
/* 08 */    BAD, 0x8e6f,    BAD, 0x8e6e,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x88b7, 0x8cc6,    BAD, 0x90a9, 0x88cf,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9b4b, 0x9b4c,    BAD, 0x9b49,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8957, 0x8aad,    BAD,
/* 28 */ 0x9b48,    BAD, 0x96c3, 0x9550,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x88a6,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x88f7,    BAD,    BAD,    BAD, 0x8e70
},

/* Row 0x04b */
{
/* 00 */    BAD, 0x88d0,    BAD, 0x88a1,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9b51,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9b4f,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x96ba,    BAD, 0x9b52,    BAD, 0x9b50,    BAD,    BAD, 0x9b4e,
/* 20 */ 0x9050,    BAD,    BAD,    BAD,    BAD, 0x9b4d,    BAD,    BAD,
/* 28 */    BAD, 0x95d8,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ce2,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9b56, 0x9b57,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x8fa9,    BAD,    BAD,    BAD
},

/* Row 0x04c */
{
/* 00 */ 0x9b53, 0x984b,    BAD,    BAD,    BAD,    BAD, 0x946b,    BAD,
/* 08 */    BAD, 0x9b55,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8da5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x9b58,    BAD,    BAD,    BAD, 0x9577,    BAD,
/* 28 */    BAD,    BAD, 0x9b59,    BAD, 0x9b54,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96b9
},

/* Row 0x04d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x947d,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9b5a, 0x9551,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9b5b, 0x9b5f, 0x9b5c,    BAD
},

/* Row 0x04e */
{
/* 00 */    BAD, 0x89c5, 0x9b5e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8eb9,    BAD, 0x9b5d, 0x8c99,    BAD,    BAD,    BAD,
/* 10 */ 0x9b6b,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9b64, 0x9b61,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9284,    BAD, 0x9b60,    BAD,    BAD, 0x9b62,    BAD,
/* 28 */    BAD, 0x9b63,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9b65, 0x9b66,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x04f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8af0,    BAD, 0x9b68, 0x9b67,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9b69,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8fec,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9b6c,    BAD, 0x92da,    BAD,    BAD,    BAD,
/* 30 */ 0x8964,    BAD, 0x9b6a,    BAD,    BAD,    BAD, 0x9b6d,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9b6e,    BAD
},

/* Row 0x050 */
{
/* 00 */ 0x9b71,    BAD,    BAD, 0x9b6f,    BAD, 0x9b70,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8e71, 0x9b72,    BAD,    BAD, 0x8d45, 0x9b73,    BAD, 0x8e9a,
/* 18 */ 0x91b6,    BAD, 0x9b74, 0x9b75, 0x8e79, 0x8d46,    BAD, 0x96d0,
/* 20 */    BAD,    BAD,    BAD, 0x8b47, 0x8cc7, 0x9b76, 0x8a77,    BAD,
/* 28 */    BAD, 0x9b77,    BAD, 0x91b7,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9b78, 0x9ba1,    BAD, 0x9b79,    BAD, 0x9b7a,    BAD,    BAD,
/* 38 */ 0x9b7b,    BAD, 0x9b7d,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x051 */
{
/* 00 */ 0x9b7e,    BAD,    BAD, 0x9b80,    BAD, 0x91ee,    BAD, 0x8946,
/* 08 */ 0x8ee7, 0x88c0,    BAD, 0x9176, 0x8aae, 0x8eb3,    BAD, 0x8d47,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9386,    BAD, 0x8f40,
/* 18 */ 0x8aaf, 0x9288, 0x92e8, 0x88b6, 0x8b58, 0x95f3,    BAD, 0x8ec0,
/* 20 */    BAD,    BAD, 0x8b71, 0x90e9, 0x8eba, 0x9747, 0x9b81,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b7b,    BAD,
/* 30 */ 0x8dc9,    BAD,    BAD, 0x8a51, 0x8983, 0x8faa, 0x89c6,    BAD,
/* 38 */ 0x9b82, 0x9765,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f68
},

/* Row 0x052 */
{
/* 00 */    BAD,    BAD, 0x8ee2, 0x9b83, 0x8af1, 0x93d0, 0x96a7, 0x9b84,
/* 08 */    BAD, 0x9b85,    BAD,    BAD, 0x9578,    BAD,    BAD,    BAD,
/* 10 */ 0x9b87,    BAD, 0x8aa6, 0x8bf5, 0x9b86,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8ab0,    BAD, 0x9051, 0x9b8b, 0x8e40,
/* 20 */    BAD, 0x89c7, 0x9b8a,    BAD, 0x9b88, 0x9b8c, 0x9b89, 0x944a,
/* 28 */ 0x9ecb, 0x9052,    BAD, 0x9b8d,    BAD,    BAD, 0x97be,    BAD,
/* 30 */ 0x9b8e,    BAD,    BAD, 0x9b90,    BAD, 0x929e, 0x9b8f,    BAD,
/* 38 */ 0x90a1,    BAD, 0x8e9b,    BAD,    BAD,    BAD, 0x91ce, 0x8ef5
},

/* Row 0x053 */
{
/* 00 */    BAD, 0x9595, 0x90ea,    BAD, 0x8ecb, 0x9b91, 0x8fab, 0x9b92,
/* 08 */ 0x9b93, 0x88d1, 0x91b8, 0x9071,    BAD, 0x9b94, 0x93b1, 0x8fac,
/* 10 */    BAD, 0x8fad,    BAD, 0x9b95,    BAD,    BAD, 0x90eb,    BAD,
/* 18 */    BAD,    BAD, 0x8fae,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9b96,    BAD, 0x9b97,    BAD, 0x96de,    BAD,    BAD,    BAD,
/* 28 */ 0x9b98,    BAD,    BAD,    BAD,    BAD, 0x8bc4,    BAD,    BAD,
/* 30 */    BAD, 0x8f41,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9b99, 0x9b9a, 0x8eda, 0x904b, 0x93f2, 0x9073, 0x94f6, 0x9441
},

/* Row 0x054 */
{
/* 00 */ 0x8bc7, 0x9b9b,    BAD,    BAD,    BAD, 0x8b8f, 0x9b9c,    BAD,
/* 08 */ 0x8bfc,    BAD, 0x93cd, 0x89ae,    BAD, 0x8e72, 0x9b9d, 0x9ba0,
/* 10 */ 0x9b9f, 0x8bfb,    BAD, 0x9b9e,    BAD, 0x9357,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x91ae,    BAD,
/* 20 */ 0x936a, 0x8ec6,    BAD,    BAD, 0x9177, 0x979a,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9ba2,    BAD, 0x9ba3, 0x93d4,
/* 30 */    BAD, 0x8e52,    BAD,    BAD,    BAD,    BAD, 0x9ba5,    BAD,
/* 38 */    BAD, 0x9ba6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x055 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x9ba7,    BAD,    BAD,    BAD,
/* 10 */ 0x8af2, 0x9ba8,    BAD,    BAD, 0x9ba9,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x89aa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x915a, 0x8ae2,    BAD, 0x9bab, 0x96a6,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x91d0,    BAD, 0x8a78,    BAD,    BAD, 0x9bad, 0x9baf,
/* 38 */ 0x8add,    BAD,    BAD, 0x9bac, 0x9bae,    BAD, 0x9bb1,    BAD
},

/* Row 0x056 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9bb0,    BAD, 0x9bb2,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9bb3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x93bb, 0x8bac,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x89e3, 0x9bb4, 0x9bb9,    BAD,    BAD, 0x9bb7,    BAD, 0x95f5,
/* 30 */ 0x95f4,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9387,    BAD,
/* 38 */    BAD,    BAD, 0x9bb6, 0x8f73,    BAD, 0x9bb5,    BAD,    BAD
},

/* Row 0x057 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9092,
/* 08 */    BAD,    BAD,    BAD, 0x9bba,    BAD,    BAD, 0x8de8,    BAD,
/* 10 */    BAD, 0x9bc0,    BAD,    BAD, 0x9bc1, 0x9bbb, 0x8a52, 0x9bbc,
/* 18 */ 0x9bc5, 0x9bc4, 0x9bc3, 0x9bbf,    BAD,    BAD,    BAD, 0x9bbe,
/* 20 */    BAD,    BAD, 0x9bc2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x95f6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x058 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x9bc9, 0x9bc6,    BAD, 0x9bc8,    BAD,
/* 10 */ 0x9792,    BAD, 0x9bc7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9bbd,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9093,    BAD,    BAD, 0x9bca,    BAD,    BAD, 0x8db5,
/* 30 */    BAD,    BAD,    BAD, 0x9bcb,    BAD,    BAD, 0x9bcc,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x059 */
{
/* 00 */    BAD,    BAD, 0x9bcf,    BAD, 0x9bce,    BAD,    BAD, 0x9bcd,
/* 08 */    BAD,    BAD,    BAD, 0x9388, 0x9bb8,    BAD,    BAD,    BAD,
/* 10 */ 0x9bd5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9bd1,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x9bd0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9bd2,    BAD, 0x9bd3,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9bd6,
/* 38 */    BAD,    BAD, 0x97e4,    BAD, 0x9bd7, 0x9bd4,    BAD,    BAD
},

/* Row 0x05a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9bd8,    BAD,    BAD, 0x8ade, 0x9bd9,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9bdb, 0x9bda,    BAD,    BAD, 0x9bdc,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x9bdd,    BAD, 0x90ec, 0x8f42,    BAD,
/* 20 */    BAD, 0x8f84,    BAD, 0x9183,    BAD, 0x8d48, 0x8db6, 0x8d49,
/* 28 */ 0x8b90,    BAD,    BAD, 0x9bde,    BAD,    BAD, 0x8db7,    BAD,
/* 30 */    BAD, 0x8cc8, 0x9bdf, 0x96a4, 0x9462, 0x9be0,    BAD, 0x8d4a,
/* 38 */    BAD,    BAD,    BAD, 0x8aaa,    BAD, 0x9246, 0x8bd0,    BAD
},

/* Row 0x05b */
{
/* 00 */    BAD,    BAD, 0x8e73, 0x957a,    BAD,    BAD, 0x94bf,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x9be1, 0x8af3,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9be4,    BAD,    BAD,    BAD,    BAD, 0x929f,    BAD,
/* 18 */    BAD, 0x9be3, 0x9be2, 0x9be5,    BAD, 0x92e9,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9083,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8e74,    BAD, 0x90c8,    BAD, 0x91d1,
/* 30 */ 0x8b41,    BAD,    BAD, 0x92a0,    BAD,    BAD, 0x9be6, 0x9be7,
/* 38 */ 0x8fed,    BAD,    BAD,    BAD,    BAD, 0x9658,    BAD,    BAD
},

/* Row 0x05c */
{
/* 00 */ 0x9bea,    BAD,    BAD, 0x9be9, 0x9be8, 0x959d,    BAD, 0x9bf1,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x9679,    BAD, 0x9beb,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x9bed, 0x968b,    BAD, 0x9bec,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9bee,
/* 20 */    BAD, 0x94a6, 0x9bef, 0x95bc, 0x9bf0,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8ab1, 0x95bd, 0x944e, 0x9bf2, 0x9bf3,    BAD,
/* 38 */ 0x8d4b, 0x8ab2, 0x9bf4, 0x8cb6, 0x9763, 0x9748, 0x8af4, 0x9bf6
},

/* Row 0x05d */
{
/* 00 */    BAD, 0x92a1,    BAD, 0x8d4c, 0x8faf,    BAD,    BAD, 0x94dd,
/* 08 */    BAD,    BAD, 0x8fb0,    BAD,    BAD,    BAD,    BAD, 0x8f98,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x92ea, 0x95f7, 0x9358,
/* 18 */    BAD,    BAD, 0x8d4d,    BAD, 0x957b,    BAD,    BAD,    BAD,
/* 20 */ 0x9bf7,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9378, 0x8dc0,
/* 28 */    BAD,    BAD,    BAD, 0x8cc9,    BAD, 0x92eb,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x88c1, 0x8f8e, 0x8d4e,
/* 38 */ 0x9766,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x05e */
{
/* 00 */    BAD, 0x9bf8, 0x9bf9, 0x9470,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9bfa, 0x97f5, 0x984c,    BAD,    BAD,    BAD,    BAD, 0x9bfc,
/* 10 */ 0x9bfb,    BAD,    BAD, 0x8a66,    BAD,    BAD, 0x9c40,    BAD,
/* 18 */    BAD,    BAD, 0x9c43, 0x9c44,    BAD, 0x9c42,    BAD, 0x955f,
/* 20 */ 0x8fb1, 0x9c46, 0x9c45, 0x9c41,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9c47, 0x9c48,    BAD,    BAD, 0x9c49,    BAD,    BAD,    BAD,
/* 30 */ 0x9c4c, 0x9c4a,    BAD, 0x9c4b, 0x9c4d,    BAD, 0x8984, 0x92ec,
/* 38 */ 0x9c4e,    BAD, 0x8c9a, 0x89f4, 0x9455,    BAD, 0x9c4f, 0x93f9
},

/* Row 0x05f */
{
/* 00 */    BAD, 0x95d9,    BAD, 0x9c50, 0x984d,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9c51, 0x95be, 0x9c54, 0x989f, 0x98af,    BAD, 0x8eae,
/* 10 */ 0x93f3, 0x9c55,    BAD, 0x8b7c, 0x92a2, 0x88f8, 0x9c56, 0x95a4,
/* 18 */ 0x8d4f,    BAD,    BAD, 0x926f,    BAD,    BAD,    BAD, 0x92ed,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x96ed, 0x8cb7, 0x8cca,
/* 28 */    BAD, 0x9c57,    BAD,    BAD,    BAD, 0x9c58,    BAD, 0x9c5e,
/* 30 */    BAD, 0x8ee3,    BAD,    BAD,    BAD, 0x92a3,    BAD, 0x8bad,
/* 38 */ 0x9c59,    BAD,    BAD,    BAD, 0x954a,    BAD, 0x9265,    BAD
},

/* Row 0x060 */
{
/* 00 */    BAD, 0x9c5a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9c5b,    BAD, 0x8bae,    BAD, 0x9c5c,    BAD, 0x9c5d,    BAD,
/* 10 */    BAD, 0x9c5f,    BAD, 0x9396,    BAD,    BAD, 0x9c60, 0x9c61,
/* 18 */    BAD, 0x9c62,    BAD,    BAD, 0x9c53, 0x9c52,    BAD,    BAD,
/* 20 */    BAD, 0x9c63, 0x8c60,    BAD,    BAD,    BAD, 0x9546,    BAD,
/* 28 */    BAD, 0x8dca, 0x9556, 0x92a4, 0x956a, 0x9c64,    BAD,    BAD,
/* 30 */ 0x8fb2, 0x8965,    BAD, 0x9c65,    BAD,    BAD,    BAD, 0x9c66,
/* 38 */    BAD, 0x96f0,    BAD,    BAD, 0x94de,    BAD,    BAD, 0x9c69
},

/* Row 0x061 */
{
/* 00 */ 0x899d, 0x90aa, 0x9c68, 0x9c67, 0x8c61, 0x91d2,    BAD, 0x9c6d,
/* 08 */ 0x9c6b,    BAD, 0x9c6a, 0x97a5, 0x8ce3,    BAD,    BAD,    BAD,
/* 10 */ 0x8f99, 0x9c6c, 0x936b, 0x8f5d,    BAD,    BAD,    BAD, 0x93be,
/* 18 */ 0x9c70, 0x9c6f,    BAD,    BAD,    BAD,    BAD, 0x9c6e,    BAD,
/* 20 */ 0x9c71, 0x8ce4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9c72, 0x959c, 0x8f7a,    BAD,    BAD, 0x9c73, 0x94f7,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x93bf, 0x92a5,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x934f,    BAD,    BAD, 0x9c74, 0x8b4a,    BAD,    BAD
},

/* Row 0x062 */
{
/* 00 */    BAD,    BAD,    BAD, 0x9053,    BAD, 0x954b,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x8af5, 0x9445,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c75, 0x8e75,
/* 18 */ 0x9659, 0x965a,    BAD,    BAD, 0x899e, 0x9c7a,    BAD,    BAD,
/* 20 */ 0x9289,    BAD,    BAD,    BAD, 0x9c77,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x89f5,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9cab, 0x9c79,    BAD,    BAD,    BAD, 0x944f,    BAD,    BAD,
/* 38 */ 0x9c78,    BAD,    BAD, 0x9c76,    BAD, 0x8d9a,    BAD, 0x9c7c
},

/* Row 0x063 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c83, 0x9c89,
/* 10 */ 0x9c81,    BAD, 0x937b,    BAD,    BAD, 0x9c86, 0x957c,    BAD,
/* 18 */    BAD, 0x9c80,    BAD, 0x9c85, 0x97e5, 0x8e76,    BAD,    BAD,
/* 20 */ 0x91d3, 0x9c7d,    BAD,    BAD,    BAD, 0x8b7d, 0x9c88, 0x90ab,
/* 28 */ 0x8985, 0x9c82, 0x89f6, 0x9c87,    BAD,    BAD,    BAD, 0x8baf,
/* 30 */    BAD, 0x9c84,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9c8a,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x064 */
{
/* 00 */    BAD, 0x9c8c, 0x9c96, 0x9c94,    BAD,    BAD, 0x9c91,    BAD,
/* 08 */    BAD,    BAD, 0x9c90, 0x97f6,    BAD, 0x9c92,    BAD,    BAD,
/* 10 */ 0x8bb0,    BAD, 0x8d50,    BAD,    BAD, 0x8f9a,    BAD,    BAD,
/* 18 */    BAD, 0x9c99, 0x9c8b,    BAD,    BAD,    BAD,    BAD, 0x9c8f,
/* 20 */ 0x9c7e,    BAD, 0x89f8, 0x9c93, 0x9c95, 0x9270,    BAD,    BAD,
/* 28 */ 0x8da6, 0x89b6, 0x9c8d, 0x9c98, 0x9c97, 0x8bb1,    BAD, 0x91a7,
/* 30 */ 0x8a86,    BAD,    BAD,    BAD,    BAD, 0x8c62,    BAD, 0x9c8e,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x065 */
{
/* 00 */    BAD, 0x9c9a,    BAD, 0x9c9d, 0x9c9f,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8ebb,    BAD, 0x9ca5, 0x92ee, 0x9c9b,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9ca3,    BAD, 0x89f7,    BAD, 0x9ca1, 0x9ca2,
/* 18 */    BAD,    BAD, 0x9c9e, 0x9ca0,    BAD,    BAD,    BAD, 0x8ce5,
/* 20 */ 0x9749,    BAD,    BAD, 0x8ab3,    BAD,    BAD, 0x8978, 0x9ca4,
/* 28 */    BAD, 0x9459, 0x88ab,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x94df, 0x9c7b, 0x9caa, 0x9cae, 0x96e3,    BAD,
/* 38 */ 0x9ca7,    BAD,    BAD,    BAD, 0x9389, 0x9cac,    BAD,    BAD
},

/* Row 0x066 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fee, 0x9cad, 0x93d5,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9866,    BAD, 0x9ca9,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9caf,    BAD, 0x8d9b,    BAD, 0x90c9,    BAD,    BAD, 0x88d2,
/* 20 */ 0x9ca8, 0x9ca6,    BAD, 0x9179,    BAD,    BAD,    BAD, 0x9c9c,
/* 28 */ 0x8e53,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x91c4, 0x9cbb,    BAD, 0x917a, 0x9cb6,    BAD, 0x9cb3, 0x9cb4,
/* 38 */    BAD, 0x8ee4, 0x9cb7, 0x9cba,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x067 */
{
/* 00 */ 0x9cb5, 0x8f44,    BAD, 0x9cb8,    BAD,    BAD, 0x9cb2,    BAD,
/* 08 */ 0x96fa, 0x96f9,    BAD,    BAD,    BAD, 0x9cbc, 0x9cbd, 0x88d3,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cb1,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8bf0, 0x88a4,    BAD,    BAD,    BAD, 0x8ab4,
/* 20 */    BAD, 0x9cb9,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cc1,
/* 28 */ 0x9cc0,    BAD,    BAD,    BAD, 0x9cc5,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9cc6,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9cc4, 0x9cc7, 0x9cbf, 0x9cc3
},

/* Row 0x068 */
{
/* 00 */    BAD,    BAD, 0x9cc8,    BAD, 0x9cc9,    BAD,    BAD, 0x9cbe,
/* 08 */ 0x8e9c,    BAD, 0x9cc2, 0x91d4, 0x8d51, 0x9cb0, 0x9054,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9cd6,    BAD, 0x95e7,    BAD,    BAD,
/* 18 */ 0x9ccc, 0x9ccd, 0x9cce,    BAD,    BAD, 0x9cd5,    BAD, 0x9cd4,
/* 20 */    BAD,    BAD, 0x969d, 0x8ab5,    BAD, 0x9cd2,    BAD, 0x8c64,
/* 28 */ 0x8a53,    BAD,    BAD, 0x9ccf,    BAD,    BAD, 0x97b6, 0x9cd1,
/* 30 */ 0x88d4, 0x9cd3,    BAD, 0x9cca, 0x9cd0, 0x9cd7, 0x8c63, 0x9ccb,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x977c,    BAD
},

/* Row 0x069 */
{
/* 00 */    BAD,    BAD, 0x974a,    BAD,    BAD,    BAD,    BAD, 0x9cda,
/* 08 */    BAD,    BAD, 0x9cde,    BAD,    BAD,    BAD, 0x919e,    BAD,
/* 10 */ 0x97f7, 0x9cdf,    BAD,    BAD, 0x9cdc,    BAD, 0x9cd9,    BAD,
/* 18 */    BAD, 0x9cd8, 0x9cdd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x95ae,    BAD,    BAD, 0x93b2,
/* 28 */    BAD, 0x8c65,    BAD, 0x9ce0, 0x9cdb,    BAD, 0x9ce1,    BAD,
/* 30 */    BAD,    BAD, 0x8c9b,    BAD,    BAD,    BAD, 0x89af,    BAD,
/* 38 */    BAD,    BAD, 0x9ce9,    BAD,    BAD,    BAD, 0x8ab6,    BAD
},

/* Row 0x06a */
{
/* 00 */    BAD,    BAD,    BAD, 0x9ce7,    BAD,    BAD, 0x9ce8, 0x8da7,
/* 08 */ 0x9ce6, 0x9ce4, 0x9ce3, 0x9cea, 0x9ce2, 0x9cec,    BAD,    BAD,
/* 10 */ 0x89f9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9cee,    BAD,    BAD, 0x9ced,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x92a6,    BAD, 0x9cf1,    BAD, 0x9cef, 0x9ce5,
/* 38 */ 0x8c9c,    BAD, 0x9cf0,    BAD, 0x9cf4, 0x9cf3, 0x9cf5, 0x9cf2
},

/* Row 0x06b */
{
/* 00 */ 0x9cf6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9cf7, 0x9cf8, 0x95e8,    BAD, 0x9cfa, 0x9cf9, 0x8f5e,    BAD,
/* 10 */ 0x90ac, 0x89e4, 0x89fa,    BAD, 0x9cfb,    BAD, 0x88bd,    BAD,
/* 18 */    BAD,    BAD, 0x90ca, 0x9cfc,    BAD, 0xe6c1, 0x9d40, 0x8c81,
/* 20 */    BAD, 0x9d41,    BAD,    BAD,    BAD,    BAD, 0x90ed,    BAD,
/* 28 */    BAD,    BAD, 0x9d42,    BAD,    BAD,    BAD, 0x9d43, 0x8b59,
/* 30 */ 0x9d44,    BAD, 0x9d45, 0x9d46, 0x91d5,    BAD,    BAD,    BAD,
/* 38 */ 0x8ccb,    BAD,    BAD, 0x96df,    BAD,    BAD,    BAD, 0x965b
},

/* Row 0x06c */
{
/* 00 */ 0x8f8a, 0x9d47,    BAD,    BAD,    BAD,    BAD,    BAD, 0x90ee,
/* 08 */ 0xe7bb, 0x94e0,    BAD, 0x8ee8,    BAD, 0x8dcb, 0x9d48,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x91c5,    BAD, 0x95a5,    BAD,    BAD,
/* 18 */ 0x91ef,    BAD,    BAD, 0x9d4b,    BAD,    BAD, 0x9d49,    BAD,
/* 20 */ 0x9d4c,    BAD,    BAD, 0x9d4a,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9d4d,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95af,    BAD,
/* 30 */    BAD, 0x88b5,    BAD,    BAD,    BAD,    BAD, 0x957d,    BAD,
/* 38 */    BAD, 0x94e1,    BAD,    BAD, 0x9d4e,    BAD, 0x9d51, 0x8fb3
},

/* Row 0x06d */
{
/* 00 */ 0x8b5a,    BAD, 0x9d4f, 0x9d56, 0x8fb4,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9d50, 0x9463,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x977d, 0x9d52, 0x9d53, 0x9d57, 0x938a, 0x9d54, 0x8d52,
/* 18 */ 0x90dc,    BAD,    BAD, 0x9d65, 0x94b2,    BAD, 0x91f0,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x94e2, 0x9dab,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x95f8,    BAD,    BAD,    BAD, 0x92ef,    BAD,    BAD,
/* 38 */    BAD, 0x9695,    BAD, 0x9d5a, 0x899f, 0x928a,    BAD,    BAD
},

/* Row 0x06e */
{
/* 00 */    BAD,    BAD, 0x9d63,    BAD,    BAD, 0x9253, 0x9d5d, 0x9d64,
/* 08 */ 0x9d5f, 0x9d66, 0x9d62,    BAD, 0x9d61, 0x948f,    BAD, 0x9d5b,
/* 10 */ 0x89fb, 0x9d59, 0x8b91, 0x91f1, 0x9d55,    BAD,    BAD, 0x9d58,
/* 18 */ 0x8d53, 0x90d9,    BAD, 0x8fb5, 0x9d60, 0x9471,    BAD,    BAD,
/* 20 */ 0x8b92, 0x8a67,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8a87, 0x9040, 0x9d68, 0x9d6d,
/* 30 */    BAD, 0x9d69,    BAD, 0x8c9d,    BAD, 0x9d6e, 0x8e41, 0x8d89,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f45, 0x9d5c
},

/* Row 0x06f */
{
/* 00 */    BAD, 0x8e9d, 0x9d6b,    BAD,    BAD,    BAD,    BAD, 0x8e77,
/* 08 */ 0x9d6c, 0x88c2,    BAD,    BAD, 0x9d67,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x92a7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x8b93,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8bb2,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d6a,
/* 28 */ 0x88a5,    BAD,    BAD, 0x8dc1,    BAD,    BAD,    BAD, 0x9055,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x92f0,    BAD,    BAD, 0x94d2, 0x9d70, 0x917d
},

/* Row 0x070 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x91a8,    BAD,    BAD, 0x8e4a, 0x9d71,    BAD, 0x9d73,
/* 10 */ 0x9d6f,    BAD,    BAD,    BAD,    BAD, 0x95df,    BAD, 0x92bb,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x917b,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95f9,
/* 28 */ 0x8ecc, 0x9d80,    BAD, 0x9d7e,    BAD,    BAD, 0x9098,    BAD,
/* 30 */    BAD,    BAD, 0x8c9e,    BAD,    BAD,    BAD, 0x9d78, 0x8fb7,
/* 38 */    BAD,    BAD, 0x93e6, 0x9450,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x071 */
{
/* 00 */ 0x9d76,    BAD,    BAD, 0x917c,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8ef6, 0x9d7b,    BAD,    BAD, 0x8fb6,    BAD, 0x9d75, 0x9d7a,
/* 10 */    BAD,    BAD, 0x9472,    BAD,    BAD,    BAD, 0x9d74,    BAD,
/* 18 */ 0x8c40,    BAD,    BAD, 0x8a7c,    BAD,    BAD,    BAD, 0x9d7c,
/* 20 */ 0x97a9, 0x8dcc, 0x9254, 0x9d79,    BAD, 0x90da,    BAD, 0x8d54,
/* 28 */ 0x9084, 0x8986, 0x915b, 0x9d77, 0x8b64,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8c66,    BAD, 0x92cd, 0x9d7d,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x917e,    BAD,    BAD, 0x9d81,    BAD
},

/* Row 0x072 */
{
/* 00 */ 0x9d83,    BAD,    BAD, 0x91b5, 0x9d89,    BAD, 0x9d84,    BAD,
/* 08 */    BAD, 0x9d86,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9560,
/* 10 */ 0x92f1,    BAD, 0x9d87,    BAD,    BAD,    BAD, 0x974b,    BAD,
/* 18 */    BAD,    BAD, 0x9767, 0x8ab7,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x88ac,    BAD, 0x9d85,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9d82,    BAD,    BAD,    BAD,    BAD, 0x8af6,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8987,    BAD, 0x9d88,    BAD,
/* 38 */    BAD,    BAD, 0x9768,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x073 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d8c,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x91b9,    BAD, 0x9d93,
/* 10 */    BAD,    BAD,    BAD, 0x9d8d,    BAD,    BAD, 0x9d8a, 0x9d91,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9d72,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d8e,    BAD,
/* 28 */ 0x9d92,    BAD,    BAD,    BAD, 0x94c0, 0x938b,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9d8b,    BAD, 0x9d8f,    BAD,
/* 38 */    BAD,    BAD, 0x8c67,    BAD,    BAD,    BAD, 0x8def,    BAD
},

/* Row 0x074 */
{
/* 00 */    BAD,    BAD, 0x90db,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d97,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9345,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d94,
/* 28 */    BAD, 0x9680,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d95,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d96,    BAD,
/* 38 */ 0x96cc,    BAD, 0x90a0,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x075 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8c82,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9d9d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8e54, 0x9d9a,    BAD, 0x9d99,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9451,    BAD,    BAD,    BAD, 0x93b3,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9350, 0x9d9b,    BAD,    BAD,
/* 28 */    BAD, 0x9d9c,    BAD, 0x958f,    BAD, 0x9464, 0x8e42,    BAD,
/* 30 */ 0x90ef,    BAD, 0x966f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8a68,    BAD, 0x9da3, 0x9d9e,    BAD,    BAD,    BAD
},

/* Row 0x076 */
{
/* 00 */    BAD, 0x9769, 0x9da5,    BAD,    BAD, 0x9da1,    BAD, 0x9da2,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9180,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9da0,    BAD, 0x9d5e,    BAD,    BAD,    BAD,
/* 18 */ 0x9da4,    BAD, 0x9d9f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9da9, 0x9daa, 0x9346, 0x9dac,    BAD,    BAD, 0x8e43, 0x9da7,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8b5b,    BAD,    BAD, 0x9dad,
/* 30 */    BAD, 0x9da6, 0x9db1,    BAD, 0x9db0,    BAD, 0x9daf,    BAD,
/* 38 */    BAD,    BAD, 0x9db2,    BAD,    BAD, 0x9db4, 0x8fef,    BAD
},

/* Row 0x077 */
{
/* 00 */ 0x9db3,    BAD,    BAD,    BAD,    BAD, 0x9db7,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9db5,    BAD,    BAD,    BAD, 0x9db6, 0x9d90,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9db9, 0x9db8,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9d98, 0x9dba, 0x9dae,    BAD,    BAD, 0x8e78,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9dbb, 0x9dbc, 0x9dbe, 0x9dbd,
/* 38 */ 0x9dbf, 0x89fc,    BAD, 0x8d55,    BAD,    BAD, 0x95fa, 0x90ad
},

/* Row 0x078 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ccc,    BAD,    BAD,
/* 08 */ 0x9dc1,    BAD,    BAD,    BAD,    BAD, 0x9dc4,    BAD, 0x9571,
/* 10 */    BAD, 0x8b7e,    BAD,    BAD,    BAD, 0x9dc3, 0x9dc2, 0x9473,
/* 18 */ 0x9dc5, 0x8bb3,    BAD,    BAD,    BAD, 0x9dc7, 0x9dc6,    BAD,
/* 20 */    BAD,    BAD, 0x8ab8, 0x8e55,    BAD,    BAD, 0x93d6,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8c68,    BAD,    BAD,    BAD,
/* 30 */ 0x9094,    BAD, 0x9dc8,    BAD, 0x90ae, 0x9347,    BAD, 0x957e,
/* 38 */ 0x9dc9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x079 */
{
/* 00 */    BAD,    BAD, 0x9dca, 0x9dcb,    BAD,    BAD,    BAD, 0x95b6,
/* 08 */ 0x9b7c, 0x90c4,    BAD,    BAD, 0x956b,    BAD, 0x8dd6,    BAD,
/* 10 */ 0x94e3, 0x94c1,    BAD,    BAD,    BAD,    BAD,    BAD, 0x936c,
/* 18 */    BAD, 0x97bf,    BAD, 0x9dcd, 0x8ece,    BAD,    BAD, 0x9dce,
/* 20 */    BAD, 0x88b4,    BAD,    BAD, 0x8bd2, 0x90cb,    BAD, 0x9580,
/* 28 */    BAD,    BAD,    BAD, 0x9dcf, 0x8e61, 0x9266,    BAD, 0x8e7a,
/* 30 */ 0x9056,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dd0,
/* 38 */    BAD, 0x95fb,    BAD,    BAD, 0x8997, 0x8e7b,    BAD,    BAD
},

/* Row 0x07a */
{
/* 00 */    BAD, 0x9dd3,    BAD, 0x9dd1, 0x9dd4, 0x97b7, 0x9dd2,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x90f9, 0x9dd5,    BAD,    BAD, 0x91b0,
/* 10 */    BAD,    BAD, 0x9dd6,    BAD,    BAD,    BAD,    BAD, 0x8af8,
/* 18 */    BAD, 0x9dd8,    BAD, 0x9dd7,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9dd9, 0x9dda, 0x8af9,    BAD,    BAD, 0x93fa, 0x9255, 0x8b8c,
/* 28 */ 0x8e7c, 0x9181,    BAD,    BAD, 0x8f7b, 0x88ae,    BAD,    BAD,
/* 30 */    BAD, 0x9ddb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x89a0, 0x9ddf,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x07b */
{
/* 00 */    BAD,    BAD, 0x8d56, 0x9dde,    BAD,    BAD, 0x8da9, 0x8fb8,
/* 08 */    BAD,    BAD, 0x9ddd,    BAD, 0x8fb9,    BAD, 0x96be, 0x8da8,
/* 10 */    BAD,    BAD,    BAD, 0x88d5, 0x90cc,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9de4,    BAD,    BAD, 0x90af,
/* 20 */ 0x8966,    BAD,    BAD,    BAD,    BAD, 0x8f74,    BAD, 0x9686,
/* 28 */ 0x8df0,    BAD,    BAD,    BAD,    BAD, 0x8fba,    BAD, 0x90a5,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9de3, 0x9de1, 0x9de2,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x928b,    BAD,    BAD, 0x9e45
},

/* Row 0x07c */
{
/* 00 */    BAD, 0x9de8, 0x8e9e, 0x8d57, 0x9de6,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9de7,    BAD, 0x9057,    BAD,    BAD,    BAD, 0x9de5,
/* 10 */    BAD,    BAD, 0x8e4e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dea, 0x9de9, 0x9dee,
/* 20 */    BAD,    BAD, 0x9def,    BAD, 0x9deb,    BAD, 0x8a41, 0x9dec,
/* 28 */ 0x9ded, 0x94d3,    BAD,    BAD,    BAD,    BAD, 0x9581, 0x8c69,
/* 30 */ 0x9df0,    BAD,    BAD,    BAD, 0x90b0,    BAD, 0x8fbb,    BAD,
/* 38 */    BAD,    BAD, 0x9271,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x07d */
{
/* 00 */    BAD, 0x8bc5,    BAD, 0x9df1, 0x9df5,    BAD,    BAD, 0x89c9,
/* 08 */ 0x9df2, 0x9df4,    BAD,    BAD,    BAD,    BAD, 0x9df3,    BAD,
/* 10 */    BAD, 0x8f8b,    BAD,    BAD,    BAD,    BAD, 0x9267, 0x88c3,
/* 18 */ 0x9df6,    BAD,    BAD,    BAD,    BAD, 0x9df7,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x92a8,    BAD,    BAD,    BAD, 0x97ef,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8e62,    BAD,    BAD, 0x95e9,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x965c,    BAD,    BAD,    BAD,
/* 38 */ 0x9e41, 0x9df9,    BAD,    BAD, 0x9dfc,    BAD, 0x9dfb,    BAD
},

/* Row 0x07e */
{
/* 00 */    BAD, 0x9df8,    BAD,    BAD, 0x9e40,    BAD,    BAD, 0x93dc,
/* 08 */    BAD, 0x9dfa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e42,    BAD,
/* 18 */    BAD, 0x8f8c, 0x9e43,    BAD, 0x976a, 0x9498,    BAD,    BAD,
/* 20 */ 0x9e44,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e46,    BAD,
/* 28 */    BAD, 0x9e47,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9e48,    BAD, 0x8bc8, 0x8967, 0x8d58, 0x9e49,    BAD, 0x9e4a,
/* 38 */ 0x8f91, 0x9182,    BAD,    BAD, 0x99d6, 0x915d, 0x915c, 0x91d6
},

/* Row 0x07f */
{
/* 00 */ 0x8dc5,    BAD,    BAD, 0x98f0,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8c8e, 0x974c,    BAD, 0x95fc,    BAD, 0x959e,    BAD, 0x9e4b,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8df1, 0x92bd, 0x9e4c, 0x984e,
/* 18 */    BAD,    BAD,    BAD, 0x965d,    BAD, 0x92a9, 0x9e4d, 0x8afa,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e4e, 0x9e4f,
/* 28 */ 0x96d8,    BAD, 0x96a2, 0x9696, 0x967b, 0x8e44, 0x9e51,    BAD,
/* 30 */    BAD, 0x8ee9,    BAD,    BAD, 0x9670,    BAD, 0x9e53, 0x9e56,
/* 38 */ 0x9e55,    BAD, 0x8af7,    BAD,    BAD, 0x8b80,    BAD, 0x9e52
},

/* Row 0x080 */
{
/* 00 */    BAD, 0x9e54,    BAD,    BAD,    BAD,    BAD, 0x9e57,    BAD,
/* 08 */    BAD, 0x9099,    BAD,    BAD,    BAD,    BAD, 0x979b, 0x88c7,
/* 10 */ 0x8dde, 0x91ba,    BAD, 0x8edb,    BAD,    BAD, 0x8ff1,    BAD,
/* 18 */    BAD, 0x9e5a,    BAD,    BAD, 0x936d,    BAD, 0x9e58, 0x91a9,
/* 20 */ 0x9e59, 0x8ff0, 0x96db, 0x9e5b, 0x9e5c, 0x9788,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9e61,    BAD,    BAD, 0x8d59,    BAD, 0x9474,
/* 30 */ 0x9e5e, 0x938c, 0x9ddc, 0x9de0,    BAD, 0x8b6e,    BAD, 0x9466,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9e60,    BAD, 0x8fbc, 0x94c2
},

/* Row 0x081 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e66,    BAD, 0x94f8,
/* 08 */    BAD, 0x9e5d,    BAD, 0x9e63, 0x9e62,    BAD,    BAD,    BAD,
/* 10 */ 0x90cd,    BAD,    BAD,    BAD,    BAD, 0x968d,    BAD, 0x97d1,
/* 18 */    BAD,    BAD, 0x9687,    BAD, 0x89ca, 0x8e7d,    BAD,    BAD,
/* 20 */ 0x9867, 0x9e65, 0x9095,    BAD,    BAD,    BAD, 0x9e64,    BAD,
/* 28 */    BAD, 0x9e5f,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ccd,
/* 30 */    BAD,    BAD,    BAD, 0x9e6b, 0x9e69,    BAD, 0x89cb, 0x9e67,
/* 38 */ 0x9e6d, 0x9e73,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x082 */
{
/* 00 */    BAD, 0x91c6,    BAD,    BAD, 0x95bf,    BAD, 0x9e75,    BAD,
/* 08 */    BAD,    BAD, 0x9541,    BAD,    BAD,    BAD, 0x9e74, 0x9490,
/* 10 */ 0x965e, 0x8ab9,    BAD, 0x90f5, 0x8f5f,    BAD,    BAD,    BAD,
/* 18 */ 0x92d1,    BAD, 0x974d,    BAD,    BAD, 0x9e70, 0x9e6f,    BAD,
/* 20 */    BAD,    BAD, 0x9e71,    BAD, 0x9e6e,    BAD,    BAD, 0x9e76,
/* 28 */    BAD, 0x9e6c,    BAD,    BAD, 0x9e6a,    BAD, 0x9e72, 0x9e68,
/* 30 */    BAD, 0x928c,    BAD, 0x96f6, 0x8ec4, 0x8df2,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8db8,    BAD,    BAD, 0x968f, 0x8a60
},

/* Row 0x083 */
{
/* 00 */    BAD,    BAD, 0x92cc, 0x93c8, 0x8968,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x90f0,    BAD,    BAD, 0x90b2, 0x8c49,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e78,    BAD,
/* 20 */    BAD, 0x8d5a, 0x8a9c,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9e7a, 0x8a94, 0x9e81,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9e7d,    BAD, 0x90f1,    BAD,    BAD,    BAD,
/* 38 */ 0x8a6a, 0x8daa,    BAD,    BAD, 0x8a69, 0x8dcd,    BAD,    BAD
},

/* Row 0x084 */
{
/* 00 */ 0x9e7b, 0x8c85, 0x8c6a, 0x938d,    BAD,    BAD, 0x9e79,    BAD,
/* 08 */ 0x88c4,    BAD,    BAD,    BAD,    BAD, 0x9e7c, 0x9e7e,    BAD,
/* 10 */ 0x8bcb, 0x8c4b,    BAD, 0x8aba, 0x8b6a,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9e82,    BAD,    BAD, 0x8df7, 0x9691,    BAD, 0x8e56,
/* 20 */    BAD,    BAD,    BAD, 0x9e83,    BAD,    BAD,    BAD, 0x954f,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9e8f,    BAD, 0x89b1, 0x9e84,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e95, 0x9e85
},

/* Row 0x085 */
{
/* 00 */    BAD, 0x97c0,    BAD, 0x9e8c,    BAD, 0x947e,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e94,    BAD, 0x9e87,
/* 10 */    BAD,    BAD,    BAD, 0x88b2, 0x9e89,    BAD,    BAD, 0x8d5b,
/* 18 */    BAD,    BAD,    BAD, 0x9e8b,    BAD, 0x9e8a,    BAD, 0x9e86,
/* 20 */ 0x9e91,    BAD, 0x8fbd,    BAD,    BAD,    BAD, 0x9aeb, 0x8ce6,
/* 28 */ 0x979c,    BAD,    BAD,    BAD,    BAD, 0x9e88,    BAD, 0x92f2,
/* 30 */ 0x8a42, 0x8dab,    BAD, 0x9e80,    BAD, 0x9e90, 0x8a81,    BAD,
/* 38 */    BAD, 0x9e8e, 0x9e92,    BAD, 0x938e,    BAD,    BAD,    BAD
},

/* Row 0x086 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8afc,    BAD, 0x9eb0,    BAD,
/* 08 */    BAD, 0x96c7, 0x9e97, 0x8afb,    BAD, 0x9e9e,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x965f,    BAD, 0x9e9f, 0x9ea1,    BAD, 0x9ea5,
/* 18 */ 0x9e99,    BAD, 0x9249,    BAD,    BAD,    BAD,    BAD, 0x938f,
/* 20 */ 0x9ea9, 0x9e9c,    BAD, 0x9ea6,    BAD,    BAD,    BAD, 0x9ea0,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9058, 0x9eaa,
/* 30 */    BAD,    BAD, 0x90b1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9ea8, 0x8abb,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x087 */
{
/* 00 */ 0x986f, 0x9e96,    BAD,    BAD, 0x9ea4, 0x88d6,    BAD,    BAD,
/* 08 */ 0x9e98,    BAD,    BAD, 0x96b8, 0x9e9d, 0x9041, 0x92c5, 0x9e93,
/* 10 */    BAD,    BAD, 0x9ea3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x909a, 0x9ead, 0x8a91, 0x8c9f,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9eaf, 0x9e9a, 0x9eae,    BAD, 0x9ea7, 0x9e9b,    BAD,
/* 28 */ 0x9eab,    BAD, 0x9eac,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9ebd,    BAD,    BAD,    BAD, 0x93cc,    BAD, 0x9ea2,    BAD,
/* 38 */    BAD, 0x9eb9,    BAD,    BAD,    BAD, 0x9ebb,    BAD, 0x92d6
},

/* Row 0x088 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x976b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9596, 0x9eb6, 0x91c8,    BAD,    BAD,
/* 18 */    BAD, 0x9ebc, 0x915e,    BAD, 0x9eb3, 0x9ec0, 0x9ebf,    BAD,
/* 20 */ 0x93ed, 0x9ebe, 0x93e8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9ec2, 0x9eb5,    BAD, 0x8bc6, 0x9eb8, 0x8f7c,
/* 30 */    BAD,    BAD,    BAD, 0x9480, 0x9eba, 0x8bc9,    BAD, 0x9eb2,
/* 38 */ 0x9eb4, 0x9eb1,    BAD,    BAD, 0x984f, 0x8a79, 0x9eb7,    BAD
},

/* Row 0x089 */
{
/* 00 */    BAD, 0x9ec1, 0x8a54,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8de5,    BAD,    BAD,    BAD, 0x897c,    BAD,
/* 10 */    BAD, 0x9ed2,    BAD,    BAD, 0x9850, 0x9ed5,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x9059, 0x9ed4,    BAD,    BAD,    BAD,
/* 20 */ 0x9ed3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ed0,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ec4,    BAD,
/* 30 */    BAD, 0x9ee1, 0x9ec3,    BAD, 0x9ed6,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9ece,    BAD,    BAD, 0x9ec9, 0x9ec6
},

/* Row 0x08a */
{
/* 00 */    BAD, 0x9ec7,    BAD, 0x9ecf,    BAD,    BAD,    BAD, 0xeaa0,
/* 08 */    BAD,    BAD, 0x9ecc, 0x8d5c, 0x92c6, 0x9184, 0x9eca,    BAD,
/* 10 */ 0x9ec5,    BAD,    BAD, 0x9ec8,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x976c, 0x968a,    BAD,    BAD,    BAD, 0x9ecd, 0x9ed7,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9edf,
/* 28 */ 0x9ed8,    BAD,    BAD, 0x9ee5,    BAD, 0x9ee3,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9ede,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9edd,    BAD, 0x92ce,    BAD, 0x9185,    BAD, 0x9edb
},

/* Row 0x08b */
{
/* 00 */    BAD,    BAD, 0x9ed9,    BAD,    BAD, 0x9ee0,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9ee6, 0x94f3, 0x9eec,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9ee7, 0x9eea, 0x9ee4,    BAD,    BAD, 0x9294,
/* 18 */    BAD, 0x9557,    BAD, 0x9eda,    BAD,    BAD, 0x9ee2, 0x8fbe,
/* 20 */    BAD, 0x96cd, 0x9ef6, 0x9ee9,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8ca0, 0x89a1, 0x8a7e,    BAD,    BAD, 0x9ed1,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbf, 0x9eee,    BAD,
/* 38 */ 0x9ef5, 0x8ef7, 0x8a92,    BAD,    BAD, 0x924d,    BAD,    BAD
},

/* Row 0x08c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x9eeb,    BAD,    BAD, 0x9ef0,
/* 08 */ 0x9ef4,    BAD,    BAD, 0x8bb4,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8b6b, 0x9ef2,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b40,
/* 20 */    BAD, 0x93c9, 0x9ef1,    BAD,    BAD,    BAD, 0x9ef3,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9eed,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9eef,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a80
},

/* Row 0x08d */
{
/* 00 */ 0x9268,    BAD,    BAD,    BAD, 0x9efa,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ef8, 0x8ce7,    BAD,
/* 10 */ 0x9ef7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9f40,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9e77,    BAD,    BAD,    BAD,
/* 20 */ 0x9ef9,    BAD, 0x9efb, 0x9efc,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9f4b,    BAD, 0x9f47,    BAD, 0x9e8d,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9f46,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9f45,    BAD,    BAD, 0x9f42,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x08e */
{
/* 00 */    BAD, 0x9ee8, 0x9f44, 0x9f43,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9f49,    BAD, 0x9845,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9f4c, 0x8bf9,    BAD,    BAD, 0x9f48, 0x9f4a,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x94a5,    BAD, 0x9f4d,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9f51, 0x9f4e,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x08f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x9793, 0x9f4f,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9edc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9f52,    BAD,    BAD,    BAD, 0x9f53,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8954,    BAD, 0x9f55,
/* 20 */ 0x8c87, 0x8e9f,    BAD, 0x8bd3,    BAD,    BAD,    BAD, 0x89a2,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x977e,    BAD,    BAD,    BAD,    BAD, 0x9f57,
/* 38 */ 0x9f56, 0x9f59, 0x8b5c,    BAD,    BAD, 0x8bd4, 0x8abc,    BAD
},

/* Row 0x090 */
{
/* 00 */    BAD,    BAD,    BAD, 0x9f5c,    BAD,    BAD,    BAD, 0x9f5b,
/* 08 */    BAD, 0x9f5d,    BAD,    BAD, 0x89cc,    BAD, 0x9256,    BAD,
/* 10 */ 0x9f5e,    BAD,    BAD, 0x8abd, 0x9f60,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9f5f,    BAD, 0x9f61,    BAD,    BAD,    BAD, 0x9f62,
/* 20 */    BAD, 0x9f63, 0x8e7e, 0x90b3, 0x8d9f,    BAD, 0x9590,    BAD,
/* 28 */    BAD, 0x95e0, 0x9863,    BAD,    BAD,    BAD,    BAD, 0x8e95,
/* 30 */    BAD,    BAD,    BAD, 0x8dce, 0x97f0,    BAD,    BAD,    BAD,
/* 38 */ 0x9f64, 0x9f65,    BAD, 0x8e80,    BAD,    BAD,    BAD, 0x9f66
},

/* Row 0x091 */
{
/* 00 */ 0x9f67,    BAD,    BAD, 0x9f69, 0x9f68,    BAD, 0x9677,    BAD,
/* 08 */    BAD, 0x8f7d, 0x8eea, 0x8e63,    BAD, 0x9f6a,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9f6c, 0x9042,    BAD,
/* 18 */ 0x9f6b,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9f6d,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9f6e,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9f6f, 0x9f70,    BAD,    BAD,    BAD, 0x9f71,
/* 30 */    BAD, 0x9f73, 0x9f72, 0x9f74, 0x89a3, 0x9269,    BAD, 0x9f75,
/* 38 */    BAD,    BAD, 0x8e45, 0x8a6b, 0x9f76,    BAD,    BAD, 0x9361
},

/* Row 0x092 */
{
/* 00 */ 0x9aca,    BAD,    BAD,    BAD,    BAD, 0x8b42, 0x9f77,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x9f78,    BAD, 0x95ea, 0x9688,    BAD,
/* 10 */    BAD,    BAD, 0x93c5, 0x9f79, 0x94e4,    BAD,    BAD,    BAD,
/* 18 */ 0x94f9,    BAD,    BAD, 0x96d1,    BAD,    BAD,    BAD, 0x9f7a,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x9f7c, 0x9f7b,    BAD,    BAD, 0x9f7e,
/* 30 */    BAD,    BAD,    BAD, 0x9f7d,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x093 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9f81,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8e81,
/* 10 */    BAD, 0x96af,    BAD, 0x9f82, 0x9f83,    BAD,    BAD, 0x8b43,
/* 18 */    BAD,    BAD,    BAD, 0x9f84,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9f86, 0x9f85,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9085,    BAD,    BAD, 0x9558,
/* 38 */ 0x8969,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94c3,    BAD
},

/* Row 0x094 */
{
/* 00 */ 0x92f3, 0x8f60, 0x8b81,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94c4,    BAD,
/* 10 */ 0x8eac,    BAD,    BAD,    BAD,    BAD, 0x9f88,    BAD, 0x8abe,
/* 18 */    BAD,    BAD, 0x8998,    BAD,    BAD, 0x93f0, 0x9f87, 0x8d5d,
/* 20 */ 0x9272,    BAD, 0x9f89,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9f91,    BAD, 0x9f8a,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x91bf,    BAD, 0x8b82, 0x9f92,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8c88,    BAD,    BAD, 0x8b44, 0x9f90,    BAD
},

/* Row 0x095 */
{
/* 00 */    BAD, 0x9f8e, 0x9f8b, 0x9780,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x92be,    BAD,    BAD,    BAD, 0x93d7, 0x9f8c,    BAD,    BAD,
/* 10 */ 0x9f94,    BAD, 0x9f93, 0x8c42,    BAD,    BAD, 0x89ab,    BAD,
/* 18 */    BAD, 0x8db9, 0x9f8d, 0x9f8f,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9676, 0x91f2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x9697,    BAD,    BAD, 0x9f9c,    BAD,
/* 30 */    BAD, 0x9f9d,    BAD, 0x89cd,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x95a6, 0x96fb, 0x9f9f, 0x8ea1, 0x8fc0, 0x9f98, 0x9f9e, 0x8988
},

/* Row 0x096 */
{
/* 00 */    BAD, 0x8bb5,    BAD,    BAD, 0x9f95, 0x9f9a,    BAD,    BAD,
/* 08 */    BAD, 0x90f2, 0x9491,    BAD, 0x94e5,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9f97,    BAD, 0x9640,    BAD, 0x9f99,
/* 18 */    BAD, 0x9fa2,    BAD, 0x9fa0,    BAD, 0x9f9b,    BAD,    BAD,
/* 20 */    BAD, 0x9641, 0x9467, 0x8b83,    BAD, 0x9344,    BAD,    BAD,
/* 28 */ 0x928d,    BAD, 0x9fa3,    BAD,    BAD,    BAD,    BAD, 0x9fa1,
/* 30 */ 0x91d7, 0x9f96,    BAD, 0x896a,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x097 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x976d, 0x9fae,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9fad,    BAD,    BAD,    BAD,    BAD, 0x90f4,
/* 18 */    BAD, 0x9faa,    BAD, 0x978c,    BAD,    BAD, 0x93b4, 0x9fa4,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x92c3,    BAD,    BAD,
/* 28 */    BAD, 0x896b, 0x8d5e, 0x9fa7,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8f46, 0x9fac,    BAD, 0x9fab, 0x9fa6,    BAD,
/* 38 */ 0x9fa9,    BAD,    BAD, 0x8a88,    BAD, 0x9fa8, 0x9468,    BAD
},

/* Row 0x098 */
{
/* 00 */    BAD, 0x97ac,    BAD,    BAD, 0x8ff2, 0x90f3,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9fb4, 0x9fb2,    BAD, 0x956c,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9faf, 0x9fb1,    BAD, 0x8959,    BAD,
/* 28 */    BAD, 0x8d5f, 0x9851,    BAD, 0x8a5c,    BAD, 0x9582,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9781,    BAD,    BAD, 0x8a43,
/* 38 */ 0x905a, 0x9fb3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x099 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9fb8,    BAD,    BAD,
/* 08 */ 0x8fc1,    BAD,    BAD,    BAD, 0x974f,    BAD, 0x9fb5,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9fb0,    BAD, 0x9fb6,    BAD,    BAD,
/* 18 */    BAD, 0x97dc,    BAD, 0x9393, 0x93c0,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a55,
/* 30 */    BAD,    BAD, 0x8974,    BAD,    BAD, 0x9fbc,    BAD,    BAD,
/* 38 */ 0x9fbf,    BAD,    BAD,    BAD, 0x97c1,    BAD,    BAD,    BAD
},

/* Row 0x09a */
{
/* 00 */ 0x9784,    BAD,    BAD,    BAD,    BAD, 0x9fc6, 0x9fc0, 0x9fbd,
/* 08 */    BAD,    BAD,    BAD, 0x97d2, 0x9fc3,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8f69, 0x9fc5,    BAD,    BAD, 0x9fca,    BAD,    BAD,
/* 18 */ 0x9391, 0x9fc8,    BAD,    BAD,    BAD,    BAD, 0x9fc2,    BAD,
/* 20 */    BAD, 0x9257,    BAD,    BAD, 0x9fc9,    BAD, 0x9fbe,    BAD,
/* 28 */ 0x9fc4,    BAD, 0x9fcb, 0x88fa, 0x9fc1,    BAD, 0x9fcc,    BAD,
/* 30 */    BAD, 0x905b,    BAD, 0x8f7e,    BAD, 0x95a3,    BAD, 0x8dac,
/* 38 */    BAD, 0x9fb9, 0x9fc7, 0x9359,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x09b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x90b4,    BAD, 0x8a89,
/* 08 */ 0x8dcf, 0x8fc2, 0x9fbb, 0x8f61,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8c6b,    BAD, 0x9fba,    BAD,    BAD,
/* 18 */    BAD, 0x9fd0, 0x8f8d, 0x8cb8,    BAD, 0x9fdf,    BAD, 0x9fd9,
/* 20 */ 0x8b94, 0x936e,    BAD, 0x9fd4, 0x9fdd, 0x88ad, 0x8951,    BAD,
/* 28 */    BAD, 0x89b7,    BAD, 0x9fd6, 0x91aa, 0x9fcd, 0x9fcf, 0x8d60,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9fe0,    BAD, 0x9fdb,    BAD,    BAD,    BAD, 0x9fd3,    BAD
},

/* Row 0x09c */
{
/* 00 */    BAD,    BAD,    BAD, 0x9fda,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x96a9,    BAD,    BAD, 0x9fd8, 0x9fdc,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8cce,    BAD,
/* 18 */ 0x8fc3,    BAD,    BAD, 0x9258,    BAD,    BAD,    BAD, 0x9fd2,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x974e,
/* 28 */    BAD,    BAD,    BAD, 0x9fd5,    BAD,    BAD, 0x9fce, 0x9392,
/* 30 */    BAD,    BAD, 0x9fd1,    BAD,    BAD,    BAD, 0x9fd7,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9870, 0x8ebc
},

/* Row 0x09d */
{
/* 00 */ 0x969e,    BAD, 0x9fe1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x94ac,    BAD,    BAD, 0x9fed,
/* 10 */ 0x8cb9,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f80,    BAD,
/* 18 */ 0x9fe3,    BAD,    BAD,    BAD, 0x97ad, 0x8d61,    BAD, 0x9ff0,
/* 20 */    BAD,    BAD, 0x88ec,    BAD,    BAD, 0x9fee,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9fe2,    BAD,    BAD,    BAD,    BAD, 0x9fe8,
/* 30 */    BAD,    BAD, 0x9fea,    BAD,    BAD,    BAD, 0x976e, 0x9fe5,
/* 38 */    BAD,    BAD, 0x934d,    BAD,    BAD, 0x9fe7,    BAD,    BAD
},

/* Row 0x09e */
{
/* 00 */    BAD,    BAD, 0x9fef,    BAD, 0x9fe9, 0x96c5,    BAD,    BAD,
/* 08 */    BAD, 0x9fe4,    BAD, 0x8ea0, 0x9ffc,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8a8a,    BAD, 0x9fe6, 0x9feb, 0x9fec,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x91ea, 0x91d8,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9ff4,    BAD,    BAD, 0x9ffa,
/* 30 */    BAD,    BAD, 0x9ff8,    BAD, 0x9348,    BAD,    BAD, 0xe042,
/* 38 */ 0x9ff5,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ff6, 0x9fde
},

/* Row 0x09f */
{
/* 00 */    BAD, 0x8b99, 0x9559,    BAD,    BAD,    BAD, 0x8ebd,    BAD,
/* 08 */    BAD, 0x8d97,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9852,
/* 10 */    BAD, 0x9ff2,    BAD, 0xe041, 0x8989, 0x9186,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9499,    BAD, 0x8abf, 0x97f8,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x969f, 0x92d0,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x9ff9, 0x9ffb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9151,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe040, 0x9ff7
},

/* Row 0x0a0 */
{
/* 00 */    BAD, 0x9ff1,    BAD,    BAD,    BAD, 0x8ac1,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8c89,    BAD,    BAD,    BAD,
/* 18 */ 0xe04e,    BAD,    BAD, 0xe049, 0x90f6,    BAD,    BAD, 0x8a83,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8f81,    BAD, 0xe052,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe04b, 0x92aa, 0xe048,
/* 30 */ 0x92d7,    BAD,    BAD,    BAD, 0xe06b,    BAD,    BAD,    BAD,
/* 38 */ 0xe045,    BAD, 0xe044,    BAD, 0xe04d,    BAD,    BAD,    BAD
},

/* Row 0x0a1 */
{
/* 00 */ 0xe047, 0xe046, 0xe04c,    BAD, 0x909f,    BAD, 0xe043,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe04f,    BAD,
/* 10 */    BAD, 0xe050,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ac0,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe055,    BAD, 0xe054, 0xe056,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xe059,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x9362,    BAD, 0xe053,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe057,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0a2 */
{
/* 00 */ 0x8c83, 0x91f7, 0xe051, 0x945a,    BAD,    BAD, 0xe058,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe05d, 0xe05b,    BAD,    BAD,
/* 18 */ 0xe05e,    BAD,    BAD, 0xe061,    BAD,    BAD,    BAD, 0xe05a,
/* 20 */ 0x8d8a, 0x9447,    BAD,    BAD, 0x9fb7,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x9794, 0xe05c,    BAD, 0xe060, 0x91f3,
/* 30 */    BAD, 0xe05f,    BAD, 0xe04a,    BAD,    BAD, 0xe889,    BAD,
/* 38 */    BAD,    BAD, 0xe064,    BAD,    BAD,    BAD, 0xe068,    BAD
},

/* Row 0x0a3 */
{
/* 00 */    BAD, 0xe066,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe062,    BAD, 0xe063,    BAD,    BAD,    BAD, 0xe067,
/* 10 */    BAD, 0xe065,    BAD,    BAD,    BAD, 0x956d,    BAD,    BAD,
/* 18 */ 0xe06d,    BAD, 0xe06a, 0xe069,    BAD, 0xe06c, 0x93d2, 0xe06e,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9295, 0x91eb,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x90a3,    BAD,    BAD,    BAD,
/* 30 */ 0xe06f,    BAD, 0xe071,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe070,    BAD
},

/* Row 0x0a4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x9ff3,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xe072,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x93e5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe073,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x89ce,    BAD,    BAD,    BAD, 0x9394,
/* 30 */ 0x8a44,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8b84,    BAD,    BAD,    BAD, 0x8edc, 0x8dd0,    BAD,    BAD
},

/* Row 0x0a5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9846, 0x9086,    BAD,    BAD,    BAD, 0x898a,    BAD,
/* 10 */    BAD,    BAD, 0xe075,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe074,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe078, 0x9259, 0xe07b, 0xe076,
/* 30 */    BAD,    BAD,    BAD, 0xe07a,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xe079, 0x935f, 0x88d7,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0a6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x97f3,    BAD,    BAD, 0xe07d,    BAD,    BAD,    BAD, 0x8947,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe080,    BAD,    BAD,    BAD, 0xe07e,    BAD, 0xe07c,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xe077,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9642,    BAD,    BAD,    BAD, 0xe082,    BAD,    BAD
},

/* Row 0x0a7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe081,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x898b,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe084, 0x95b0,    BAD, 0xe083,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x96b3,    BAD,    BAD,    BAD,    BAD, 0x8fc5,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9152,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x8fc4,    BAD,    BAD,    BAD
},

/* Row 0x0a8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x97f9,    BAD,    BAD, 0xe08a,    BAD, 0x90f7,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe086, 0xe08b,    BAD,
/* 18 */    BAD, 0x898c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xe089,    BAD, 0x9481, 0xe085, 0xe088, 0x8fc6,
/* 28 */    BAD, 0x94cf,    BAD,    BAD, 0xe08c,    BAD, 0x8ecf,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x90f8,    BAD,    BAD
},

/* Row 0x0a9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe08f,    BAD,    BAD,    BAD,
/* 08 */ 0xe087,    BAD, 0x8c46,    BAD,    BAD,    BAD,    BAD, 0xe08d,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x976f, 0xe090,    BAD,    BAD,
/* 18 */    BAD, 0xeaa4,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f6e,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe091,    BAD,    BAD,    BAD, 0xe092,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x944d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe094,    BAD,    BAD,    BAD,    BAD, 0xe095,    BAD
},

/* Row 0x0aa */
{
/* 00 */    BAD,    BAD,    BAD, 0x9452,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9395, 0xe097,    BAD,    BAD,    BAD,    BAD, 0xe099,    BAD,
/* 10 */ 0x97d3,    BAD, 0xe096,    BAD, 0xe098, 0x898d,    BAD, 0xe093,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a7a,
/* 20 */ 0xe09a,    BAD,    BAD,    BAD,    BAD, 0x9187, 0x8e57, 0xe09c,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe09b, 0x9043, 0x99d7,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe09d,    BAD,    BAD,
/* 38 */    BAD, 0xe09f,    BAD, 0xe08e, 0xe09e,    BAD,    BAD, 0xe0a0
},

/* Row 0x0ab */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x949a,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0a1,    BAD,    BAD,
/* 10 */ 0xe0a2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe0a3,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe0a4,    BAD, 0x92dc,    BAD, 0xe0a6, 0xe0a5,    BAD,    BAD,
/* 30 */ 0xe0a7,    BAD, 0xe0a8,    BAD,    BAD, 0x8edd, 0x9583,    BAD,
/* 38 */    BAD,    BAD, 0x96ea, 0xe0a9, 0xe0aa, 0x9175, 0x8ea2, 0xe0ab
},

/* Row 0x0ac */
{
/* 00 */ 0xe0ac,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0ad, 0x95d0,
/* 08 */ 0x94c5,    BAD,    BAD, 0xe0ae, 0x9476,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x92ab,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe0af, 0x89e5,    BAD, 0x8b8d,    BAD, 0x96c4,    BAD, 0x96b4,
/* 20 */    BAD, 0x89b2, 0x9853,    BAD,    BAD,    BAD,    BAD, 0x9671,
/* 28 */    BAD, 0x95a8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x90b5,    BAD, 0xe0b0,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x93c1,    BAD,    BAD,    BAD, 0x8ca1, 0xe0b1,    BAD
},

/* Row 0x0ad */
{
/* 00 */ 0x8dd2, 0xe0b3, 0xe0b2,    BAD,    BAD,    BAD,    BAD, 0xe0b4,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe0b5,    BAD,    BAD,    BAD, 0xe0b6,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8b5d,    BAD, 0xe0b7,    BAD,    BAD,    BAD,    BAD, 0xe0b8,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8ca2,    BAD,    BAD, 0x94c6,
/* 30 */    BAD,    BAD, 0xe0ba,    BAD,    BAD,    BAD, 0x8ff3,    BAD,
/* 38 */    BAD, 0xe0b9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0ae */
{
/* 00 */    BAD,    BAD, 0x8bb6, 0xe0bb, 0xe0bd,    BAD, 0xe0bc,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0be,    BAD,
/* 10 */ 0x8ccf,    BAD, 0xe0bf,    BAD,    BAD,    BAD,    BAD, 0x8be7,
/* 18 */    BAD, 0x915f,    BAD, 0x8d9d,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe0c1, 0xe0c2, 0xe0c0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8eeb,    BAD,    BAD, 0x93c6, 0x8bb7,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0c4,
/* 38 */ 0x924b, 0xe0c3,    BAD,    BAD, 0x9854, 0x9482,    BAD,    BAD
},

/* Row 0x0af */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xe0c7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0c9, 0xe0c6,
/* 18 */    BAD,    BAD,    BAD, 0x96d2, 0xe0c8, 0xe0ca,    BAD, 0x97c2,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0ce,    BAD,    BAD,
/* 28 */    BAD, 0xe0cd, 0x9296, 0x944c,    BAD,    BAD, 0x8ca3, 0xe0cc,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe0cb,    BAD, 0x9750, 0x9751,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0cf, 0x898e
},

/* Row 0x0b0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8d96, 0x8e82,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0d0, 0xe0d1,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0d3,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x8f62,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe0d5,    BAD, 0xe0d4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe0d6,    BAD, 0x8a6c,    BAD,    BAD, 0xe0d8,    BAD,    BAD,
/* 38 */ 0xe0d7,    BAD, 0xe0da, 0xe0d9,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0b1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8cba,    BAD,    BAD, 0x97a6,
/* 08 */    BAD, 0x8bca,    BAD, 0x89a4,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8be8,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8adf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x97e6, 0xe0dc,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe0de,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0b2 */
{
/* 00 */ 0xe0df,    BAD, 0x89cf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe0db,    BAD, 0x8e58,    BAD,    BAD, 0x92bf, 0xe0dd,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0e2,    BAD,
/* 20 */ 0x8eec,    BAD,    BAD,    BAD,    BAD, 0xe0e0,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8c5d,    BAD,    BAD, 0x94c7, 0xe0e1,    BAD,
/* 30 */    BAD, 0xe0fc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xe0e7,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8cbb,    BAD
},

/* Row 0x0b3 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8b85,    BAD, 0xe0e4, 0x979d,    BAD,
/* 08 */    BAD, 0x97ae,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x91f4,    BAD,    BAD, 0xe0e6,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xe0e8, 0x97d4, 0x8bd5, 0x94fa, 0x9469,    BAD,
/* 38 */    BAD,    BAD, 0xe0e9,    BAD,    BAD,    BAD,    BAD, 0xe0eb
},

/* Row 0x0b4 */
{
/* 00 */    BAD, 0xe0ee,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0ea,    BAD,    BAD,
/* 18 */    BAD, 0xe0ed, 0x8ce8, 0x896c, 0xe0ef,    BAD, 0x9090, 0xe0ec,
/* 20 */ 0x97da,    BAD,    BAD, 0xe0f2, 0xeaa2,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe0f0, 0xe0f3,    BAD,    BAD,    BAD,    BAD, 0xe0e5,
/* 30 */ 0xe0f1,    BAD,    BAD, 0x8dba,    BAD,    BAD, 0xe0f4,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0f5,    BAD
},

/* Row 0x0b5 */
{
/* 00 */    BAD,    BAD,    BAD, 0x979e,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe0f6,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0f7,    BAD,
/* 20 */    BAD,    BAD, 0xe0e3,    BAD,    BAD,    BAD,    BAD, 0xe0f8,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8ac2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ea3,    BAD,    BAD
},

/* Row 0x0b6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xe0f9,    BAD,    BAD,    BAD,    BAD, 0xe0fa,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe0fb,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x895a,    BAD,    BAD,    BAD,
/* 20 */ 0xe140,    BAD, 0x955a, 0xe141,    BAD,    BAD, 0x8aa2, 0xe142,
/* 28 */    BAD, 0xe143,    BAD,    BAD,    BAD,    BAD, 0xe144,    BAD,
/* 30 */ 0xe146, 0xe147, 0xe145,    BAD,    BAD,    BAD, 0x9572, 0xe149,
/* 38 */ 0xe148,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0b7 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe14b, 0xe14a, 0xe14c,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe14d, 0xe14f, 0xe14e,    BAD,
/* 10 */    BAD, 0x8d99,    BAD, 0xe151,    BAD, 0xe150,    BAD,    BAD,
/* 18 */ 0x8ac3,    BAD, 0x9072,    BAD, 0x935b,    BAD, 0xe152, 0x90b6,
/* 20 */    BAD,    BAD,    BAD, 0x8e59,    BAD, 0x8999, 0xe153,    BAD,
/* 28 */ 0x9770,    BAD,    BAD, 0x95e1, 0xe154,    BAD,    BAD,    BAD,
/* 30 */ 0x9363, 0x9752, 0x8d62, 0x905c,    BAD,    BAD,    BAD, 0x926a,
/* 38 */ 0x99b2,    BAD, 0x92ac, 0x89e6, 0xe155,    BAD,    BAD,    BAD
},

/* Row 0x0b8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe156,    BAD, 0xe15b,    BAD,
/* 08 */    BAD, 0xe159, 0xe158, 0x9dc0, 0x8a45, 0xe157,    BAD, 0x88d8,
/* 10 */    BAD, 0x94a8,    BAD,    BAD, 0x94c8,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x97af, 0xe15c, 0xe15a, 0x927b, 0x90a4,    BAD,    BAD,
/* 20 */ 0x94a9,    BAD, 0x954c,    BAD, 0xe15e, 0x97aa, 0x8c6c, 0xe15f,
/* 28 */    BAD, 0xe15d, 0x94d4, 0xe160,    BAD, 0xe161,    BAD,    BAD,
/* 30 */ 0x88d9,    BAD,    BAD, 0x8ff4, 0xe166,    BAD, 0xe163, 0x93eb,
/* 38 */ 0xe162,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b45
},

/* Row 0x0b9 */
{
/* 00 */    BAD,    BAD, 0xe169,    BAD,    BAD,    BAD, 0xe164, 0xe165,
/* 08 */    BAD, 0xe168, 0xe167, 0x9544,    BAD,    BAD, 0x9161, 0x9160,
/* 10 */    BAD, 0x8b5e,    BAD,    BAD, 0xe16a,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe16b,    BAD,    BAD, 0xe16c,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe16e,    BAD, 0xe16d,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8975,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xe176, 0x94e6, 0xe170,    BAD, 0xe172,    BAD,    BAD,
/* 38 */ 0xe174, 0x905d,    BAD,    BAD, 0xe175, 0xe173, 0x8ebe,    BAD
},

/* Row 0x0ba */
{
/* 00 */    BAD,    BAD, 0xe16f, 0xe171,    BAD, 0x9561,    BAD, 0x8fc7,
/* 08 */    BAD,    BAD, 0xe178,    BAD,    BAD, 0xe177,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe179,    BAD, 0x8ea4, 0x8dad,    BAD,    BAD,
/* 18 */ 0x9397, 0xe17a,    BAD, 0x92c9,    BAD,    BAD, 0xe17c,    BAD,
/* 20 */    BAD,    BAD, 0x979f, 0xe17b,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9189,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe182,    BAD, 0xe184, 0xe185, 0x9273,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe183,    BAD, 0xe180,    BAD, 0xe17d, 0xe17e
},

/* Row 0x0bb */
{
/* 00 */    BAD, 0xe181,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe188,    BAD, 0xe186,    BAD, 0xe187,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe189,
/* 20 */ 0xe18b, 0xe18c, 0xe18d,    BAD, 0xe18e,    BAD,    BAD, 0xe18a,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe190,    BAD,    BAD,    BAD, 0xe18f,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe191,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0bc */
{
/* 00 */    BAD,    BAD, 0x97c3,    BAD,    BAD,    BAD, 0xe194, 0xe192,
/* 08 */ 0xe193,    BAD,    BAD,    BAD, 0x8ae0,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x96fc,    BAD,    BAD,    BAD, 0x95c8,    BAD,
/* 18 */ 0xe196,    BAD,    BAD,    BAD, 0xe195,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe197, 0xe198,    BAD,    BAD,    BAD,    BAD, 0xe19c,
/* 28 */ 0xe199, 0xe19a, 0xe19b,    BAD, 0xe19d,    BAD,    BAD,    BAD,
/* 30 */ 0xe19e,    BAD, 0xe19f,    BAD,    BAD,    BAD, 0xe1a0,    BAD,
/* 38 */ 0xe1a1,    BAD, 0x94ad, 0x936f, 0xe1a2, 0x9492, 0x9553,    BAD
},

/* Row 0x0bd */
{
/* 00 */ 0xe1a3,    BAD,    BAD, 0xe1a4, 0x9349,    BAD, 0x8a46, 0x8d63,
/* 08 */ 0xe1a5,    BAD,    BAD, 0xe1a6,    BAD,    BAD, 0xe1a7,    BAD,
/* 10 */ 0x8e48,    BAD,    BAD, 0xe1a9,    BAD,    BAD, 0xe1a8,    BAD,
/* 18 */    BAD, 0xe1aa, 0xe1ab,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94e7,    BAD,
/* 30 */ 0xe1ac,    BAD,    BAD,    BAD, 0xe1ad,    BAD,    BAD, 0xea89,
/* 38 */ 0xe1ae, 0xe1af, 0xe1b0,    BAD,    BAD,    BAD,    BAD, 0x8e4d
},

/* Row 0x0be */
{
/* 00 */    BAD,    BAD, 0xe1b1, 0x9475,    BAD,    BAD, 0x967e,    BAD,
/* 08 */ 0x896d,    BAD, 0x8976,    BAD,    BAD, 0xe1b2,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe1b4,    BAD,    BAD,    BAD, 0xe1b3, 0x9390,
/* 18 */    BAD,    BAD,    BAD, 0x90b7, 0x9f58,    BAD, 0xe1b5, 0x96bf,
/* 20 */    BAD, 0xe1b6,    BAD, 0x8ac4, 0x94d5, 0xe1b7,    BAD, 0xe1b8,
/* 28 */    BAD,    BAD, 0xe1b9,    BAD,    BAD,    BAD, 0x96da,    BAD,
/* 30 */    BAD,    BAD, 0x96d3,    BAD, 0x92bc,    BAD,    BAD,    BAD,
/* 38 */ 0x918a,    BAD,    BAD, 0xe1bb,    BAD,    BAD, 0x8f82,    BAD
},

/* Row 0x0bf */
{
/* 00 */    BAD, 0x8fc8,    BAD,    BAD, 0xe1be,    BAD,    BAD, 0xe1bd,
/* 08 */ 0xe1bc, 0x94fb,    BAD, 0x8ac5, 0x8ca7,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe1c4,    BAD,    BAD, 0xe1c1, 0x905e,
/* 20 */ 0x96b0,    BAD,    BAD,    BAD, 0xe1c0, 0xe1c2, 0xe1c3,    BAD,
/* 28 */    BAD, 0xe1bf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1c5,
/* 38 */ 0xe1c6,    BAD, 0x92ad,    BAD, 0x8ae1,    BAD,    BAD,    BAD
},

/* Row 0x0c0 */
{
/* 00 */ 0x9285,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1c7,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe1c8, 0xe1cb,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9087,    BAD, 0x93c2,    BAD, 0xe1cc, 0x9672,    BAD,
/* 28 */ 0xe1c9,    BAD,    BAD, 0xe1ca,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe1cf,    BAD,    BAD,    BAD,    BAD, 0xe1ce, 0xe1cd
},

/* Row 0x0c1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe1d1,    BAD,    BAD, 0xe1d0,    BAD,
/* 10 */    BAD, 0xe1d2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1d4,    BAD,
/* 20 */ 0xe1d3,    BAD,    BAD,    BAD,    BAD, 0x95cb,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8f75, 0x97c4,    BAD,    BAD,
/* 30 */ 0xe1d5,    BAD,    BAD, 0x93b5,    BAD,    BAD, 0xe1d6,    BAD,
/* 38 */    BAD, 0xe1d7,    BAD, 0xe1db, 0xe1d9, 0xe1da,    BAD, 0xe1d8
},

/* Row 0x0c2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1dc,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1dd,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1de,
/* 18 */    BAD,    BAD, 0xe1df, 0x96b5, 0xe1e0,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x96ee, 0xe1e1,    BAD, 0x926d,    BAD, 0x948a,
/* 28 */    BAD, 0x8be9,    BAD,    BAD,    BAD, 0x925a, 0xe1e2, 0x8bb8,
/* 30 */    BAD,    BAD,    BAD, 0x90ce,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe1e3,    BAD,    BAD,    BAD
},

/* Row 0x0c3 */
{
/* 00 */    BAD,    BAD, 0x8dbb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe1e4,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe1e5,    BAD, 0x8ca4, 0x8dd3,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe1e7,    BAD,    BAD,    BAD,    BAD, 0x9375, 0x8dd4, 0x8b6d,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9643,    BAD, 0x946a,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9376,    BAD,    BAD,    BAD,    BAD, 0x8d7b
},

/* Row 0x0c4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1e9,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fc9,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x97b0, 0x8d64,    BAD,    BAD, 0x8ca5,
/* 30 */    BAD,    BAD, 0x94a1,    BAD, 0xe1eb,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe1ed,    BAD,    BAD,    BAD
},

/* Row 0x0c5 */
{
/* 00 */    BAD, 0x8ce9,    BAD,    BAD,    BAD,    BAD, 0xe1ec, 0x92f4,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe1ef, 0x8a56, 0xe1ea,    BAD,
/* 10 */    BAD, 0x94e8,    BAD, 0x894f,    BAD, 0x8dea,    BAD, 0x9871,
/* 18 */    BAD,    BAD, 0xe1ee,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe1f0,    BAD,    BAD,    BAD, 0x95c9,
/* 28 */    BAD, 0x90d7, 0xe1f2,    BAD,    BAD,    BAD,    BAD, 0xe1f3,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1f1,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8a6d,    BAD, 0xe1f9,    BAD, 0xe1f8,    BAD
},

/* Row 0x0c6 */
{
/* 00 */    BAD, 0x8ea5,    BAD,    BAD,    BAD, 0xe1fa, 0xe1f5,    BAD,
/* 08 */    BAD,    BAD, 0xe1fb, 0xe1f6,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x94d6, 0xe1f4,    BAD,    BAD, 0xe1f7,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe241,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe240,
/* 28 */ 0x9681,    BAD,    BAD,    BAD, 0xe1fc,    BAD,    BAD, 0x88e9,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe243,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe242,    BAD,    BAD
},

/* Row 0x0c7 */
{
/* 00 */    BAD, 0x8fca,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe244,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9162,    BAD,
/* 10 */    BAD, 0xe246, 0xe245,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe247,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1e6,    BAD,
/* 28 */    BAD,    BAD, 0xe1e8, 0xe249, 0xe248,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8ea6,    BAD, 0x97e7,    BAD, 0x8ed0,    BAD
},

/* Row 0x0c8 */
{
/* 00 */ 0xe24a, 0x8c56,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b5f,
/* 08 */ 0x8b46, 0x8e83,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x9753,    BAD,    BAD, 0xe250,    BAD, 0xe24f, 0x9163, 0xe24c,
/* 18 */    BAD,    BAD, 0xe24e,    BAD,    BAD, 0x8f6a, 0x905f, 0xe24d,
/* 20 */ 0xe24b,    BAD, 0x9449,    BAD,    BAD, 0x8fcb,    BAD,    BAD,
/* 28 */ 0x955b,    BAD,    BAD,    BAD,    BAD, 0x8dd5,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9398,
/* 38 */    BAD,    BAD, 0xe251,    BAD,    BAD,    BAD,    BAD, 0xe252
},

/* Row 0x0c9 */
{
/* 00 */ 0xe268, 0x8bd6,    BAD,    BAD, 0x985c, 0x9154,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xe253,    BAD,    BAD, 0x89d0, 0x92f5, 0x959f,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe254,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b9a, 0xe255,
/* 28 */    BAD,    BAD, 0xe257,    BAD,    BAD,    BAD, 0xe258,    BAD,
/* 30 */ 0x9448,    BAD,    BAD, 0xe259,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe25a, 0xe25b,    BAD,    BAD, 0x8bd7, 0x89d1, 0x93c3
},

/* Row 0x0ca */
{
/* 00 */ 0x8f47, 0x8e84,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe25c,    BAD, 0x8f48,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x89c8, 0x9562,    BAD,    BAD, 0xe25d,    BAD,    BAD,
/* 18 */ 0x94e9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9164,
/* 20 */    BAD, 0xe260,    BAD, 0xe261, 0x9489,    BAD, 0x9060, 0xe25e,
/* 28 */    BAD, 0x9281,    BAD,    BAD, 0xe25f,    BAD,    BAD,    BAD,
/* 30 */ 0x8fcc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x88da,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0cb */
{
/* 00 */ 0x8b48,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe262,    BAD,    BAD, 0x92f6,    BAD, 0xe263, 0x90c5,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x96ab,    BAD,    BAD, 0x9542,
/* 18 */ 0xe264, 0xe265, 0x9274,    BAD, 0x97c5,    BAD,    BAD, 0xe267,
/* 20 */ 0xe266,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8eed,    BAD,
/* 30 */    BAD, 0xe269, 0x88ee,    BAD,    BAD,    BAD,    BAD, 0xe26c,
/* 38 */    BAD,    BAD,    BAD, 0xe26a, 0x89d2, 0x8c6d, 0xe26b, 0x8d65
},

/* Row 0x0cc */
{
/* 00 */ 0x8d92,    BAD, 0x95e4, 0xe26d,    BAD,    BAD, 0x9673,    BAD,
/* 08 */    BAD, 0xe26f,    BAD,    BAD,    BAD, 0x90cf, 0x896e, 0x89b8,
/* 10 */ 0x88aa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe26e,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe270, 0xe271, 0x8ff5,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe272,    BAD, 0x8a6e,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe274,    BAD,    BAD,    BAD, 0x8c8a,    BAD, 0x8b86,    BAD,
/* 38 */    BAD, 0xe275, 0x8bf3,    BAD,    BAD, 0xe276,    BAD, 0x90fa
},

/* Row 0x0cd */
{
/* 00 */    BAD, 0x93cb,    BAD, 0x90de, 0x8df3,    BAD,    BAD,    BAD,
/* 08 */ 0xe277,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9282, 0x918b,    BAD, 0xe279, 0xe27b, 0xe278,
/* 18 */ 0xe27a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8c41,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe27c, 0x8c45,    BAD,    BAD,    BAD, 0x8b87, 0x9771,
/* 30 */ 0xe27e,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe280,    BAD,
/* 38 */    BAD,    BAD, 0x894d,    BAD,    BAD,    BAD,    BAD, 0xe283
},

/* Row 0x0ce */
{
/* 00 */    BAD,    BAD,    BAD, 0x8a96, 0xe282, 0xe281,    BAD, 0xe285,
/* 08 */ 0xe27d,    BAD, 0xe286, 0x97a7,    BAD, 0xe287,    BAD, 0xe288,
/* 10 */    BAD,    BAD, 0x9af2, 0xe28a,    BAD, 0xe289,    BAD,    BAD,
/* 18 */    BAD, 0xe28b, 0xe28c,    BAD, 0x97b3, 0xe28d,    BAD, 0xe8ed,
/* 20 */ 0x8fcd, 0xe28e, 0xe28f, 0x8f76,    BAD, 0x93b6, 0xe290,    BAD,
/* 28 */    BAD,    BAD, 0x9247,    BAD,    BAD, 0xe291,    BAD, 0x925b,
/* 30 */ 0xe292,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ba3,    BAD,
/* 38 */ 0x995e, 0x927c, 0x8eb1,    BAD,    BAD,    BAD,    BAD, 0x8ac6
},

/* Row 0x0cf */
{
/* 00 */    BAD,    BAD, 0xe293,    BAD, 0xe2a0,    BAD, 0xe296,    BAD,
/* 08 */ 0x8b88,    BAD, 0xe295, 0xe2a2,    BAD,    BAD,    BAD, 0xe294,
/* 10 */    BAD, 0x8fce,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe298, 0xe299,    BAD, 0x934a,    BAD,    BAD, 0xe29a,    BAD,
/* 20 */ 0x8a7d,    BAD,    BAD,    BAD,    BAD, 0x9079, 0x9584,    BAD,
/* 28 */ 0xe29c,    BAD,    BAD,    BAD, 0x91e6,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe297,    BAD, 0xe29b, 0xe29d,    BAD,
/* 38 */    BAD, 0x8df9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0d0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2a4, 0x954d,    BAD,
/* 08 */ 0x94a4, 0x9399,    BAD, 0x8bd8, 0xe2a3, 0xe2a1,    BAD, 0x94b3,
/* 10 */ 0xe29e, 0x927d, 0x939b,    BAD, 0x939a,    BAD, 0x8df4,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2b6,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2a6,    BAD, 0xe2a8,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe2ab,    BAD, 0xe2ac,    BAD,
/* 30 */ 0xe2a9, 0xe2aa,    BAD,    BAD, 0xe2a7, 0xe2a5,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe29f,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0d1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95cd, 0x89d3,
/* 08 */    BAD,    BAD,    BAD, 0xe2b3,    BAD, 0xe2b0,    BAD, 0xe2b5,
/* 10 */    BAD,    BAD, 0xe2b4,    BAD, 0x9493, 0x96a5,    BAD, 0x8e5a,
/* 18 */ 0xe2ae, 0xe2b7, 0xe2b2,    BAD, 0xe2b1, 0xe2ad,    BAD, 0xe2af,
/* 20 */    BAD, 0x8ac7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x925c,    BAD,    BAD, 0x90fb,    BAD,    BAD,
/* 30 */    BAD, 0x94a0,    BAD,    BAD, 0xe2bc,    BAD,    BAD,    BAD,
/* 38 */ 0x94a2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0d2 */
{
/* 00 */ 0x90df, 0xe2b9,    BAD,    BAD, 0x94cd,    BAD, 0xe2bd, 0x95d1,
/* 08 */    BAD, 0x927a,    BAD, 0xe2b8, 0xe2ba,    BAD,    BAD, 0xe2bb,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2be,    BAD,    BAD,
/* 20 */ 0x8ec2,    BAD,    BAD,    BAD, 0x93c4, 0xe2c3, 0xe2c2,    BAD,
/* 28 */    BAD, 0xe2bf,    BAD,    BAD,    BAD, 0x9855,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe2c8,    BAD,    BAD, 0xe2cc, 0xe2c9,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0d3 */
{
/* 00 */ 0xe2c5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2c6,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2cb,    BAD,    BAD,
/* 10 */    BAD, 0xe2c0, 0x99d3, 0xe2c7, 0xe2c1,    BAD,    BAD, 0xe2ca,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2d0,
/* 20 */    BAD, 0x8ac8,    BAD, 0xe2cd,    BAD,    BAD,    BAD, 0xe2ce,
/* 28 */    BAD,    BAD, 0xe2cf, 0xe2d2,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2d1,
/* 38 */ 0x94f4,    BAD,    BAD,    BAD,    BAD, 0xe2d3, 0x97fa, 0x95eb
},

/* Row 0x0d4 */
{
/* 00 */ 0xe2d8,    BAD,    BAD, 0xe2d5,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe2d4, 0x90d0,    BAD, 0xe2d7,
/* 10 */ 0xe2d9,    BAD,    BAD,    BAD, 0xe2d6,    BAD, 0xe2dd,    BAD,
/* 18 */ 0xe2da,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2db,
/* 20 */ 0xe2c4,    BAD,    BAD,    BAD, 0xe2dc, 0xe2de,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe2df,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x95c4,    BAD, 0xe2e0,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96e0,    BAD
},

/* Row 0x0d5 */
{
/* 00 */    BAD, 0x8bcc, 0x8c48, 0xe2e1,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x95b2,    BAD, 0x9088,    BAD, 0x96ae,    BAD,    BAD,
/* 10 */ 0xe2e2,    BAD, 0x97b1,    BAD,    BAD, 0x9494,    BAD, 0x9165,
/* 18 */ 0x9453,    BAD,    BAD, 0x8f6c,    BAD,    BAD,    BAD, 0x88be,
/* 20 */    BAD, 0xe2e7, 0xe2e5,    BAD, 0xe2e3, 0x8a9f,    BAD, 0x8fcf,
/* 28 */ 0xe2e8,    BAD,    BAD, 0xe2e6,    BAD, 0xe2e4, 0xe2ec,    BAD,
/* 30 */    BAD, 0xe2eb, 0xe2ea, 0xe2e9,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe2ed,    BAD,    BAD,    BAD, 0xe2ee, 0x90b8,    BAD
},

/* Row 0x0d6 */
{
/* 00 */ 0xe2ef,    BAD, 0xe2f1,    BAD,    BAD, 0xe2f0,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8cd0,    BAD,    BAD,    BAD, 0x9157,    BAD,
/* 10 */    BAD,    BAD, 0xe2f3,    BAD,    BAD,    BAD, 0x939c,    BAD,
/* 18 */ 0xe2f2,    BAD,    BAD,    BAD, 0xe2f4,    BAD, 0x95b3, 0x918c,
/* 20 */ 0x8d66,    BAD, 0xe2f5,    BAD,    BAD,    BAD,    BAD, 0x97c6,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2f7,
/* 30 */    BAD,    BAD, 0xe2f8,    BAD, 0xe2f9,    BAD, 0xe2fa,    BAD,
/* 38 */ 0x8e85,    BAD, 0xe2fb, 0x8c6e,    BAD,    BAD, 0x8b8a,    BAD
},

/* Row 0x0d7 */
{
/* 00 */ 0x8b49,    BAD, 0xe340,    BAD, 0x96f1, 0x8d67, 0xe2fc,    BAD,
/* 08 */    BAD,    BAD, 0xe343, 0x96e4,    BAD, 0x945b,    BAD,    BAD,
/* 10 */ 0x9552,    BAD,    BAD,    BAD, 0x8f83, 0xe342,    BAD, 0x8ed1,
/* 18 */ 0x8d68, 0x8e86, 0x8b89, 0x95b4, 0xe341,    BAD,    BAD,    BAD,
/* 20 */ 0x9166, 0x9661, 0x8df5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8e87, 0x92db,    BAD, 0xe346, 0x97dd,
/* 30 */ 0x8dd7,    BAD, 0xe347, 0x9061,    BAD, 0xe349,    BAD,    BAD,
/* 38 */    BAD, 0x8fd0, 0x8dae,    BAD,    BAD,    BAD,    BAD, 0xe348
},

/* Row 0x0d8 */
{
/* 00 */    BAD,    BAD, 0x8f49, 0x8cbc, 0x9167, 0xe344, 0xe34a,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe345, 0x8c6f,    BAD, 0xe34d, 0xe351,
/* 10 */ 0x8c8b,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe34c,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe355,    BAD,    BAD, 0x8d69,    BAD,
/* 20 */    BAD, 0x978d, 0x88ba, 0xe352,    BAD,    BAD, 0x8b8b,    BAD,
/* 28 */ 0xe34f,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe350,    BAD,
/* 30 */    BAD, 0x939d, 0xe34e, 0xe34b,    BAD, 0x8a47, 0x90e2,    BAD,
/* 38 */    BAD, 0x8ca6,    BAD,    BAD,    BAD, 0xe357,    BAD,    BAD
},

/* Row 0x0d9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe354,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe356,
/* 10 */    BAD,    BAD,    BAD, 0xe353,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x8c70, 0x91b1, 0xe358, 0x918e,    BAD,    BAD, 0xe365,
/* 20 */    BAD,    BAD, 0xe361, 0xe35b,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe35f, 0x8ef8, 0x88db, 0xe35a, 0xe362,
/* 30 */ 0xe366, 0x8d6a, 0x96d4,    BAD, 0x92d4, 0xe35c,    BAD,    BAD,
/* 38 */ 0xe364,    BAD, 0xe359, 0x925d,    BAD, 0xe35e, 0x88bb, 0x96c8
},

/* Row 0x0da */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe35d,
/* 08 */    BAD,    BAD, 0x8bd9, 0x94ea,    BAD,    BAD,    BAD, 0x918d,
/* 10 */    BAD, 0x97ce, 0x8f8f,    BAD,    BAD, 0xe38e,    BAD,    BAD,
/* 18 */ 0xe367,    BAD, 0x90fc,    BAD, 0xe363, 0xe368, 0xe36a,    BAD,
/* 20 */ 0x92f7, 0xe36d,    BAD,    BAD, 0xe369,    BAD,    BAD,    BAD,
/* 28 */ 0x95d2, 0x8ac9,    BAD,    BAD, 0x96c9,    BAD,    BAD, 0x88dc,
/* 30 */    BAD,    BAD, 0xe36c,    BAD, 0x97fb,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe36b,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0db */
{
/* 00 */    BAD, 0x898f,    BAD,    BAD, 0x93ea, 0xe36e,    BAD,    BAD,
/* 08 */    BAD, 0xe375, 0xe36f, 0xe376,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe372,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x949b,    BAD,    BAD, 0x8ec8, 0xe374,
/* 20 */    BAD, 0xe371, 0xe377, 0xe370,    BAD,    BAD, 0x8f63,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x9644,    BAD,    BAD, 0x8f6b,    BAD,
/* 30 */    BAD, 0xe373, 0xe380,    BAD,    BAD, 0xe37b,    BAD, 0xe37e,
/* 38 */    BAD, 0xe37c, 0xe381, 0xe37a,    BAD, 0xe360, 0x90d1,    BAD
},

/* Row 0x0dc */
{
/* 00 */    BAD, 0x94c9,    BAD, 0xe37d,    BAD,    BAD, 0xe378,    BAD,
/* 08 */    BAD,    BAD, 0x9140, 0x8c71,    BAD, 0x8f4a,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x9044, 0x9155, 0xe384,    BAD,
/* 18 */    BAD, 0xe386, 0xe387,    BAD,    BAD, 0xe383, 0xe385,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe379, 0xe382,
/* 28 */    BAD, 0xe38a, 0xe389,    BAD,    BAD, 0x969a,    BAD,    BAD,
/* 30 */ 0x8c4a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe388,    BAD, 0xe38c, 0xe38b, 0xe38f,    BAD, 0xe391
},

/* Row 0x0dd */
{
/* 00 */    BAD,    BAD, 0x8e5b, 0xe38d,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe392, 0xe393,    BAD,    BAD, 0xe394,    BAD, 0xe39a, 0x935a,
/* 10 */ 0xe396,    BAD, 0xe395, 0xe397, 0xe398,    BAD, 0xe399,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe39b, 0xe39c,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0de */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8aca,    BAD,
/* 38 */ 0xe39d,    BAD, 0xe39e,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0df */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe39f,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe3a0, 0xe3a1, 0xe3a2,    BAD,
/* 10 */ 0xe3a3, 0xe3a4,    BAD,    BAD, 0xe3a6, 0xe3a5,    BAD,    BAD,
/* 18 */ 0xe3a7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3a8,
/* 20 */ 0xe3a9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3ac,
/* 28 */ 0xe3aa, 0xe3ab, 0x8ddf, 0x8c72,    BAD,    BAD, 0x9275,    BAD,
/* 30 */ 0x94b1,    BAD, 0x8f90,    BAD,    BAD, 0x946c,    BAD, 0x94eb,
/* 38 */ 0xe3ad, 0x9ceb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0e0 */
{
/* 00 */    BAD,    BAD, 0xe3ae, 0xe3b0,    BAD, 0x9785, 0xe3af, 0xe3b2,
/* 08 */ 0xe3b1,    BAD, 0x9772,    BAD, 0xe3b3,    BAD, 0x94fc,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe3b4,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe3b7,    BAD,    BAD, 0xe3b6, 0xe3b5,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe3b8, 0x8c51,    BAD,    BAD,    BAD,
/* 28 */ 0x9141, 0x8b60,    BAD,    BAD,    BAD,    BAD, 0xe3bc, 0xe3b9,
/* 30 */    BAD,    BAD, 0xe3ba,    BAD,    BAD,    BAD, 0xe3bd,    BAD,
/* 38 */ 0xe3be, 0xe3bb,    BAD,    BAD,    BAD, 0x8948,    BAD,    BAD
},

/* Row 0x0e1 */
{
/* 00 */    BAD, 0x89a5,    BAD,    BAD,    BAD, 0xe3c0, 0xe3c1,    BAD,
/* 08 */    BAD,    BAD, 0xe3c2,    BAD, 0x9782,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8f4b,    BAD, 0xe3c4, 0xe3c3,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9089, 0xe3c5,    BAD,    BAD,    BAD,    BAD, 0xe3c6,    BAD,
/* 28 */    BAD, 0xe3c7,    BAD, 0x8ae3,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8acb,    BAD,    BAD, 0xe3c8,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe3c9,    BAD, 0x967c, 0x9783,    BAD,    BAD,    BAD
},

/* Row 0x0e2 */
{
/* 00 */ 0x9773, 0x9856,    BAD, 0x8d6c, 0xe3cc, 0x8ed2, 0xe3cb,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe3cd, 0x8ea7,    BAD,    BAD,    BAD,
/* 10 */ 0x91cf,    BAD, 0xe3ce,    BAD,    BAD, 0x8d6b,    BAD, 0x96d5,
/* 18 */ 0xe3cf, 0xe3d0,    BAD,    BAD, 0xe3d1,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe3d2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe3d3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x8ea8,    BAD,    BAD, 0x96eb,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe3d5,    BAD, 0x925e,    BAD, 0xe3d4
},

/* Row 0x0e3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3d7,    BAD,
/* 08 */    BAD,    BAD, 0xe3d6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe3d8,    BAD,    BAD,    BAD, 0x90b9,    BAD,
/* 18 */ 0xe3d9,    BAD, 0xe3da,    BAD,    BAD,    BAD, 0x95b7, 0xe3db,
/* 20 */    BAD, 0x918f, 0xe3dc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe3dd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97fc,
/* 30 */ 0xe3e0,    BAD, 0xe3df, 0xe3de, 0x92ae,    BAD, 0xe3e1, 0x9045,
/* 38 */    BAD, 0xe3e2,    BAD,    BAD,    BAD, 0xe3e3, 0x9857, 0xe3e4
},

/* Row 0x0e4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe3e5, 0xe3e7, 0xe3e6, 0x94a3,
/* 08 */    BAD, 0x93f7,    BAD, 0x985d, 0x94a7,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe3e9,    BAD,    BAD, 0x8fd1,    BAD,
/* 18 */ 0x9549,    BAD, 0xe3ea, 0xe3e8,    BAD, 0x8acc,    BAD,    BAD,
/* 20 */    BAD, 0x8cd2, 0x8e88,    BAD,    BAD, 0x94ec,    BAD,    BAD,
/* 28 */    BAD, 0x8ca8, 0x9662,    BAD, 0xe3ed, 0xe3eb,    BAD, 0x8d6d,
/* 30 */    BAD, 0x8d6e, 0x88e7,    BAD, 0x8de6,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9478,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0e5 */
{
/* 00 */    BAD,    BAD,    BAD, 0x88dd, 0xe3f2,    BAD, 0x925f,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x9477,    BAD, 0x91d9,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3f4,    BAD,
/* 18 */    BAD, 0xe3f0, 0xe3f3, 0xe3ee,    BAD, 0xe3f1, 0x9645,    BAD,
/* 20 */    BAD, 0x8cd3,    BAD,    BAD, 0x88fb, 0xe3ef,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3f6,
/* 30 */    BAD, 0xe3f7,    BAD,    BAD, 0x93b7,    BAD,    BAD,    BAD,
/* 38 */ 0x8bb9,    BAD,    BAD,    BAD, 0xe445, 0x945c,    BAD,    BAD
},

/* Row 0x0e6 */
{
/* 00 */    BAD,    BAD, 0x8e89,    BAD,    BAD, 0x8bba, 0x90c6, 0x9865,
/* 08 */ 0x96ac, 0xe3f5, 0x90d2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8b72, 0xe3f8,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe3fa,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe3f9,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3fb,
/* 30 */    BAD, 0x9245,    BAD, 0x945d,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x92af,    BAD,    BAD,    BAD,    BAD, 0xe442,    BAD
},

/* Row 0x0e7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe441,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe3fc,    BAD,    BAD, 0x9074,    BAD,
/* 10 */ 0x9585, 0xe444,    BAD, 0xe443, 0x8d6f, 0x9872,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe454,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe448, 0xe449,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8eee,    BAD,    BAD, 0xe447,    BAD,
/* 30 */ 0x8d98, 0xe446,    BAD,    BAD, 0xe44a,    BAD,    BAD,    BAD,
/* 38 */ 0x92b0, 0x95a0, 0x9142,    BAD,    BAD,    BAD,    BAD, 0x91da
},

/* Row 0x0e8 */
{
/* 00 */ 0xe44e,    BAD, 0xe44f, 0xe44b,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe44c,    BAD, 0xe44d,    BAD,    BAD,    BAD,    BAD, 0x8d70,
/* 10 */    BAD,    BAD,    BAD, 0xe455,    BAD, 0xe451,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9586,    BAD, 0x968c, 0x9547,    BAD,    BAD,
/* 20 */ 0xe450,    BAD,    BAD, 0xe453, 0xe452,    BAD,    BAD,    BAD,
/* 28 */ 0x9663, 0xe456,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe457,    BAD,    BAD, 0x9156,    BAD, 0xe458,    BAD,    BAD,
/* 38 */ 0xe45a,    BAD, 0xe45e,    BAD,    BAD, 0xe45b, 0xe459, 0x945e
},

/* Row 0x0e9 */
{
/* 00 */ 0xe45c,    BAD, 0xe45d,    BAD,    BAD,    BAD, 0x89b0,    BAD,
/* 08 */ 0xe464, 0xe45f,    BAD,    BAD,    BAD, 0xe460,    BAD,    BAD,
/* 10 */    BAD, 0xe461,    BAD, 0x919f,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe463, 0xe462, 0xe465,    BAD,    BAD,    BAD,    BAD, 0xe466,
/* 20 */ 0xe467,    BAD,    BAD, 0x9062,    BAD, 0x89e7,    BAD, 0xe468,
/* 28 */ 0x97d5,    BAD, 0x8ea9,    BAD,    BAD, 0x8f4c,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x8e8a, 0x9276,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe469, 0xe46a, 0x8950,    BAD, 0xe46b,    BAD
},

/* Row 0x0ea */
{
/* 00 */    BAD, 0xe46c, 0xe46d,    BAD,    BAD, 0xe46e,    BAD, 0xe46f,
/* 08 */ 0x8bbb, 0x9da8, 0xe470,    BAD, 0x90e3, 0xe471, 0x8ec9,    BAD,
/* 10 */ 0xe472,    BAD, 0x98ae,    BAD,    BAD,    BAD, 0xe473, 0x95dc,
/* 18 */ 0x8ada,    BAD,    BAD, 0x9143, 0x8f77,    BAD, 0x9591, 0x8f4d,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe474, 0x8d71, 0xe475, 0x94ca,    BAD, 0xe484,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe477,    BAD, 0x91c7, 0x9495, 0x8cbd,
/* 38 */ 0xe476, 0x9144,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0eb */
{
/* 00 */ 0xe478,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x92f8,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe47a, 0xe479, 0xe47c,    BAD,    BAD, 0xe47b,    BAD, 0xe47d,
/* 20 */    BAD,    BAD, 0xe480,    BAD, 0xe47e,    BAD, 0x8acd,    BAD,
/* 28 */ 0xe481,    BAD, 0xe482, 0xe483,    BAD,    BAD, 0x8daf, 0x97c7,
/* 30 */    BAD, 0xe485, 0x9046,    BAD,    BAD,    BAD, 0x8990, 0xe486,
/* 38 */ 0xe487,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe488,    BAD
},

/* Row 0x0ec */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x88f0,    BAD, 0xe489,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe48a,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9587,    BAD,    BAD,    BAD, 0x8ec5,    BAD, 0xe48c,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a48, 0x88b0,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe48b, 0xe48e, 0x946d,    BAD, 0x9063,
/* 30 */    BAD, 0x89d4,    BAD, 0x9646,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8c7c, 0x8bda,    BAD, 0xe48d,    BAD, 0x89e8,    BAD,    BAD
},

/* Row 0x0ed */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8aa1,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8991, 0xe492, 0x97e8, 0x91db,    BAD,    BAD, 0x9563,
/* 18 */    BAD, 0xe49e,    BAD, 0x89d5, 0xe49c,    BAD, 0xe49a, 0xe491,
/* 20 */    BAD, 0xe48f,    BAD, 0xe490,    BAD, 0x8ee1, 0x8bea, 0x9297,
/* 28 */    BAD,    BAD,    BAD, 0x93cf,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8970,    BAD, 0xe494, 0xe493,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe499, 0xe495, 0xe498,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0ee */
{
/* 00 */    BAD,    BAD, 0x96ce, 0xe497, 0x89d6, 0x8a9d, 0xe49b,    BAD,
/* 08 */    BAD, 0xe49d,    BAD,    BAD,    BAD,    BAD, 0x8c73,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4a1, 0xe4aa,
/* 18 */ 0xe4ab,    BAD,    BAD,    BAD, 0x88a9,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe4b2,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x88ef,    BAD,    BAD, 0xe4a9,    BAD,    BAD,    BAD, 0xe4a8,
/* 30 */    BAD, 0xe4a3, 0xe4a2,    BAD, 0xe4a0, 0xe49f, 0x9283,    BAD,
/* 38 */ 0x91f9, 0xe4a5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0ef */
{
/* 00 */ 0xe4a4,    BAD,    BAD,    BAD,    BAD, 0xe4a7,    BAD,    BAD,
/* 08 */    BAD, 0x9190, 0x8c74,    BAD,    BAD,    BAD,    BAD, 0x8960,
/* 10 */ 0xe4a6,    BAD, 0x8d72,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9191,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe4b8,    BAD, 0xe4b9,    BAD, 0x89d7,
/* 38 */    BAD,    BAD,    BAD, 0x89ac, 0xe4b6,    BAD,    BAD,    BAD
},

/* Row 0x0f0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4ac,    BAD, 0xe4b4,
/* 08 */    BAD, 0xe4bb, 0xe4b5,    BAD,    BAD,    BAD, 0xe4b3,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe496,    BAD,    BAD, 0xe4b1,    BAD,
/* 18 */    BAD,    BAD, 0xe4ad,    BAD,    BAD,    BAD, 0x8ace, 0xe4af,
/* 20 */ 0xe4ba,    BAD, 0xe4b0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe4bc,    BAD, 0xe4ae, 0x949c,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x9789,    BAD,    BAD,    BAD, 0xe4b7,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4cd,    BAD,    BAD
},

/* Row 0x0f1 */
{
/* 00 */    BAD, 0xe4c5,    BAD,    BAD,    BAD, 0x909b,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8b65,    BAD, 0x8bdb,    BAD, 0xe4c0,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x89d9,    BAD,    BAD, 0x8fd2,    BAD,
/* 18 */ 0xe4c3,    BAD,    BAD,    BAD, 0x8dd8,    BAD,    BAD, 0x9370,
/* 20 */ 0xe4c8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x95ec,    BAD, 0xe4bf,    BAD,    BAD,    BAD, 0x89d8,
/* 30 */ 0x8cd4, 0x9548, 0xe4c9,    BAD, 0xe4bd,    BAD,    BAD, 0xe4c6,
/* 38 */    BAD,    BAD,    BAD, 0xe4d0,    BAD, 0xe4c1,    BAD,    BAD
},

/* Row 0x0f2 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe4c2, 0x93b8,    BAD,    BAD, 0xe4c7,
/* 08 */    BAD,    BAD,    BAD, 0xe4c4, 0x9647, 0xe4ca, 0x88de,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe4be,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe4cc,    BAD, 0xe4cb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x948b, 0xe4d2,    BAD, 0xe4dd,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8a9e,    BAD,    BAD,    BAD, 0xe4e0,    BAD,    BAD,
/* 38 */ 0xe4ce,    BAD,    BAD,    BAD, 0xe4d3, 0x978e,    BAD,    BAD
},

/* Row 0x0f3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4dc,    BAD,
/* 08 */    BAD, 0x9774,    BAD,    BAD,    BAD,    BAD, 0x97a8,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9298,
/* 18 */    BAD,    BAD,    BAD, 0x8a8b,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9592, 0xe4e2, 0x939f,    BAD,    BAD, 0x88af,    BAD,
/* 28 */    BAD, 0xe4db,    BAD, 0xe4d7, 0x9192, 0xe4d1, 0xe4d9, 0xe4de,
/* 30 */    BAD, 0x944b,    BAD,    BAD,    BAD, 0x88a8,    BAD, 0xe4d6,
/* 38 */    BAD, 0xe4df, 0x9598,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0f4 */
{
/* 00 */    BAD,    BAD, 0xe4da,    BAD, 0xe4d5,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8fd3,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8f4e,    BAD,    BAD,    BAD, 0x8eaa,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x96d6,    BAD,    BAD, 0x9566,    BAD,    BAD, 0xe4e5,
/* 20 */    BAD, 0xe4ee,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4d8,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8a97,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8ff6, 0xe4e3,    BAD, 0xe4e8, 0x9193,    BAD,    BAD, 0xe4e4
},

/* Row 0x0f5 */
{
/* 00 */    BAD, 0xe4eb,    BAD,    BAD, 0x927e,    BAD, 0xe4ec,    BAD,
/* 08 */    BAD, 0x9775, 0xe4e1, 0x8a57,    BAD, 0xe4e7,    BAD,    BAD,
/* 10 */ 0xe4ea, 0x96aa,    BAD,    BAD,    BAD,    BAD, 0xe4ed,    BAD,
/* 18 */    BAD, 0xe4e6, 0xe4e9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9648,    BAD, 0x9840,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe4f1,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe4f8,    BAD,    BAD, 0xe4f0
},

/* Row 0x0f6 */
{
/* 00 */ 0x8ec1,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4cf,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x95cc,    BAD, 0x96a0, 0xe4f7, 0xe4f6,    BAD, 0xe4f2,
/* 18 */ 0xe4f3,    BAD, 0x8955,    BAD,    BAD,    BAD,    BAD, 0xe4f5,
/* 20 */    BAD, 0xe4ef,    BAD,    BAD,    BAD,    BAD, 0x92d3,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe4f4, 0x88fc,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x91a0,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x95c1,    BAD,    BAD
},

/* Row 0x0f7 */
{
/* 00 */ 0xe4f9, 0xe540,    BAD, 0x94d7,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe4fc, 0x8fd4, 0x8ec7, 0xe542,    BAD,    BAD, 0x8bbc,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe543,    BAD, 0x9599,
/* 18 */ 0xe4fb,    BAD, 0xe4d4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe4fa,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x986e, 0x93a0, 0x9593,    BAD,    BAD, 0xe54a,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe550,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe551,    BAD
},

/* Row 0x0f8 */
{
/* 00 */ 0xe544,    BAD,    BAD,    BAD, 0x9496,    BAD,    BAD, 0xe54e,
/* 08 */ 0xe546,    BAD, 0xe548,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xe552, 0xe547,    BAD,    BAD, 0xe54b,    BAD,    BAD, 0x8992,
/* 18 */    BAD, 0x93e3,    BAD, 0xe54c, 0xe54f,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xe545,    BAD, 0x9145,    BAD,
/* 28 */ 0xe549, 0x8e46, 0x9064, 0x8c4f, 0x96f2,    BAD, 0x96f7, 0x8f92,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe556, 0xe554,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0f9 */
{
/* 00 */    BAD, 0x986d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe553,    BAD,    BAD,    BAD, 0x9795,    BAD, 0xe555,
/* 10 */ 0xe557,    BAD,    BAD,    BAD,    BAD, 0xe558,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xe55b, 0xe559,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x93a1, 0xe55a,    BAD,    BAD,
/* 28 */    BAD, 0x94cb, 0xe54d,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f93,
/* 38 */    BAD, 0xe55c, 0xe561, 0x9194,    BAD,    BAD, 0xe560,    BAD
},

/* Row 0x0fa */
{
/* 00 */    BAD,    BAD, 0xe541,    BAD,    BAD,    BAD, 0xe562, 0x9168,
/* 08 */    BAD,    BAD, 0xe55d, 0xe55f,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe55e,    BAD,    BAD, 0x9f50, 0x9f41,
/* 18 */    BAD,    BAD, 0xe564,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xe563,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9796,    BAD, 0xe1ba,
/* 30 */ 0xe565,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe566
},

/* Row 0x0fb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe567, 0x8cd5,    BAD,
/* 10 */ 0x8b73,    BAD,    BAD,    BAD, 0xe569, 0x997c,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8b95,    BAD, 0x97b8,    BAD, 0x8bf1, 0xe56a,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe56b,
/* 28 */    BAD,    BAD,    BAD, 0x928e,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xe56c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x93f8,    BAD, 0x88b8,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0fc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x89e1, 0xe571, 0xe572,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe56d,    BAD, 0x8e5c,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe56e, 0x9461,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe56f, 0xe570, 0xe57a,    BAD,    BAD,    BAD, 0xe574,
/* 30 */ 0xe577,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe573,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0fd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe575,    BAD, 0xe576, 0x8ed6,
/* 08 */    BAD, 0xe578,    BAD, 0x9260,    BAD, 0x8c75, 0x8a61,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe57b,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x8a5e,    BAD, 0xe581,    BAD,    BAD, 0xe57c, 0xe580,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x94b8,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe57d,    BAD,    BAD, 0xe57e, 0x9567, 0x94d8, 0xe582,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x91fb, 0xe58c,    BAD, 0xe588,    BAD,    BAD, 0x89e9,    BAD
},

/* Row 0x0fe */
{
/* 00 */ 0xe586,    BAD, 0x9649, 0xe587,    BAD,    BAD, 0xe584,    BAD,
/* 08 */ 0xe585, 0xe58a, 0xe58d,    BAD,    BAD, 0xe58b,    BAD,    BAD,
/* 10 */    BAD, 0xe589, 0xe583,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9277,    BAD, 0xe594,    BAD, 0x96a8,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe592,    BAD,    BAD,
/* 28 */    BAD, 0xe593,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe58e,    BAD,    BAD, 0xe590,
/* 38 */    BAD,    BAD,    BAD, 0xe591,    BAD,    BAD,    BAD, 0xe58f
},

/* Row 0x0ff */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x90e4,    BAD, 0x9858, 0xe598,    BAD, 0xe599,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe59f,    BAD, 0x9049,    BAD, 0xe59b,
/* 18 */    BAD, 0xe59e,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe596,
/* 20 */ 0xe595,    BAD,    BAD, 0xe5a0,    BAD,    BAD, 0x89da,    BAD,
/* 28 */ 0xe59c,    BAD, 0xe5a1,    BAD,    BAD,    BAD, 0xe59d,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe59a,    BAD, 0x92b1,    BAD,
/* 38 */ 0xe597,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9488
},

/* Row 0x100 */
{
/* 00 */    BAD,    BAD, 0xe5a5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x975a,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5a4,
/* 20 */    BAD,    BAD, 0xe5a3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe5ac,    BAD,    BAD,    BAD, 0xe5a6,
/* 30 */    BAD,    BAD,    BAD, 0xe5ae,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9786, 0xe5b1,    BAD, 0xe5a8,    BAD,    BAD
},

/* Row 0x101 */
{
/* 00 */ 0xe5a9,    BAD,    BAD,    BAD, 0xe5ad,    BAD, 0xe5b0, 0xe5af,
/* 08 */    BAD,    BAD,    BAD, 0xe5a7,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xe5aa,    BAD, 0xe5bb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe5b4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5b2,
/* 30 */    BAD,    BAD, 0xe5b3,    BAD,    BAD,    BAD, 0xe5b8, 0xe5b9,
/* 38 */    BAD, 0x8a49,    BAD, 0x8b61,    BAD,    BAD, 0xe5b7,    BAD
},

/* Row 0x102 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5a2,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5b6, 0xe5ba, 0xe5b5,
/* 10 */    BAD, 0xe5bc,    BAD,    BAD,    BAD, 0xe5be, 0xe5bd,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe5c0, 0xe5bf, 0xe579,    BAD,    BAD,    BAD, 0xe5c4,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xe5c1,    BAD,    BAD,    BAD,    BAD, 0xe5c2,    BAD,
/* 38 */    BAD, 0xe5c3,    BAD, 0xe5c5,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x103 */
{
/* 00 */ 0x8c8c,    BAD, 0xe5c7,    BAD, 0xe5c6,    BAD, 0x8f4f,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x8d73, 0x9fa5,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe5c8, 0x8f70,    BAD,    BAD,    BAD, 0x8a58,
/* 18 */    BAD, 0xe5c9,    BAD, 0x8971,    BAD, 0x8fd5, 0xe5ca,    BAD,
/* 20 */    BAD, 0x8d74, 0xe5cb, 0x88df,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x955c,    BAD,    BAD, 0xe5cc,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x908a,    BAD, 0xe5d3,    BAD,    BAD, 0xe5d0,    BAD, 0x928f,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5d1, 0xe5ce, 0x8bdc
},

/* Row 0x104 */
{
/* 00 */    BAD, 0xe5cd, 0xe5d4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8c55,    BAD,    BAD, 0x91dc,    BAD, 0xe5da,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe5d6,    BAD,    BAD,    BAD, 0x91b3, 0xe5d5,
/* 18 */    BAD, 0xe5d8,    BAD,    BAD,    BAD,    BAD, 0xe5cf,    BAD,
/* 20 */    BAD,    BAD, 0xe5d9,    BAD, 0xe5db,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x94ed,    BAD,    BAD, 0xe5d7,    BAD,
/* 30 */ 0xe5dc, 0xe5de,    BAD,    BAD, 0x8cd1, 0xe5d2,    BAD, 0x88bf,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5dd
},

/* Row 0x105 */
{
/* 00 */    BAD, 0x8dd9, 0x97f4, 0xe5df, 0xe5e0, 0x9195,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97a0,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe5e1, 0x9754,    BAD,    BAD,
/* 18 */ 0xe5e2, 0xe5e3,    BAD,    BAD, 0x95e2, 0xe5e4,    BAD, 0x8dbe,
/* 20 */    BAD, 0x97a1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe5e9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xe5ea, 0x8fd6, 0xe5e8,    BAD,    BAD,    BAD,
/* 38 */ 0x9787, 0xe5e5,    BAD,    BAD, 0xe5e7, 0x90bb, 0x909e,    BAD
},

/* Row 0x106 */
{
/* 00 */    BAD,    BAD, 0xe5e6,    BAD, 0xe5eb,    BAD,    BAD, 0x95a1,
/* 08 */    BAD,    BAD, 0xe5ed,    BAD, 0xe5ec,    BAD,    BAD,    BAD,
/* 10 */ 0x8a8c,    BAD, 0x964a, 0xe5ee,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5fa, 0xe5f0,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5f1,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xe5f2, 0xe5f3,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5f7,    BAD,
/* 38 */ 0xe5f8,    BAD,    BAD, 0xe5f6,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x107 */
{
/* 00 */    BAD, 0xe5f4,    BAD, 0xe5ef, 0xe5f5,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe5f9, 0xe8b5,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x89a6,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5fc, 0x8bdd,
/* 20 */ 0xe5fb,    BAD,    BAD,    BAD, 0xe641,    BAD, 0xe640,    BAD,
/* 28 */    BAD,    BAD, 0xe643,    BAD,    BAD, 0xe642,    BAD, 0xe644,
/* 30 */    BAD,    BAD, 0x8f50,    BAD, 0xe645,    BAD,    BAD, 0xe646,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe647, 0x90bc
},

/* Row 0x108 */
{
/* 00 */    BAD, 0x9776,    BAD, 0xe648,    BAD,    BAD, 0x95a2, 0x9465,
/* 08 */ 0xe649,    BAD, 0xe64a, 0x8ca9,    BAD,    BAD,    BAD, 0x8b4b,
/* 10 */    BAD,    BAD,    BAD, 0xe64b,    BAD,    BAD, 0x8e8b, 0x9460,
/* 18 */ 0xe64c,    BAD, 0x8a6f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe64d,    BAD,    BAD,    BAD,    BAD, 0xe64f, 0x9797,
/* 28 */    BAD, 0xe64e, 0x9065,    BAD, 0xe650,    BAD,    BAD, 0xe651,
/* 30 */    BAD,    BAD, 0xe652, 0x8acf,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe653,    BAD,    BAD, 0xe654,    BAD, 0xe655
},

/* Row 0x109 */
{
/* 00 */ 0xe656,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8a70,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe657,    BAD, 0xe658, 0xe659,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x89f0,    BAD,    BAD, 0x9047, 0xe65a,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe65b,    BAD,    BAD,    BAD,
/* 38 */ 0xe65c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x10a */
{
/* 00 */ 0x8cbe,    BAD, 0x92f9, 0xe65d,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8c76,    BAD, 0x9075,    BAD, 0xe660,    BAD, 0x93a2,    BAD,
/* 10 */ 0xe65f,    BAD,    BAD, 0x8c50,    BAD,    BAD, 0xe65e, 0x91f5,
/* 18 */ 0x8b4c,    BAD,    BAD, 0xe661,    BAD, 0xe662,    BAD, 0x8fd7,
/* 20 */    BAD,    BAD,    BAD, 0x8c8d,    BAD, 0xe663,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x964b,    BAD,    BAD, 0x90dd,    BAD,    BAD,
/* 30 */    BAD, 0x8b96,    BAD, 0x96f3, 0x9169,    BAD, 0xe664,    BAD,
/* 38 */    BAD,    BAD, 0x9066, 0x9290, 0x8fd8,    BAD,    BAD,    BAD
},

/* Row 0x10b */
{
/* 00 */    BAD, 0xe665,    BAD,    BAD,    BAD,    BAD, 0xe668,    BAD,
/* 08 */ 0xe669,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8dbc, 0x91c0, 0xe667,    BAD, 0x8fd9, 0x955d,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe666,    BAD,    BAD, 0x8e8c,    BAD,
/* 20 */ 0x8972,    BAD, 0xe66d, 0x8c77,    BAD,    BAD, 0x8e8e,    BAD,
/* 28 */    BAD, 0x8e8d,    BAD, 0x986c, 0xe66c, 0xe66b, 0x9146,    BAD,
/* 30 */ 0x8b6c, 0x9862, 0x8a59, 0x8fda,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe66a,    BAD,    BAD,    BAD
},

/* Row 0x10c */
{
/* 00 */    BAD,    BAD, 0xe66f,    BAD, 0xe670, 0xe66e,    BAD, 0x8cd6,
/* 08 */    BAD, 0x975f,    BAD,    BAD, 0x8e8f, 0x9446,    BAD,    BAD,
/* 10 */    BAD, 0xe673,    BAD, 0x90be,    BAD, 0x9261,    BAD,    BAD,
/* 18 */ 0x9755,    BAD, 0xe676,    BAD,    BAD,    BAD, 0x8cea,    BAD,
/* 20 */ 0x90bd, 0xe672,    BAD, 0xe677, 0x8ceb, 0xe674, 0xe675,    BAD,
/* 28 */ 0xe671,    BAD,    BAD,    BAD, 0x90e0, 0x93c7,    BAD,    BAD,
/* 30 */ 0x924e,    BAD, 0x89db,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x94ee,    BAD,    BAD, 0x8b62,    BAD,    BAD, 0x92b2
},

/* Row 0x10d */
{
/* 00 */    BAD,    BAD, 0xe67a,    BAD, 0xe678,    BAD,    BAD, 0x926b,
/* 08 */    BAD,    BAD,    BAD, 0x90bf, 0x8ad0, 0xe679,    BAD, 0x907a,
/* 10 */    BAD,    BAD, 0x97c8,    BAD,    BAD,    BAD, 0x985f,    BAD,
/* 18 */    BAD,    BAD, 0xe67b, 0xe687, 0x92b3,    BAD, 0xe686,    BAD,
/* 20 */ 0xe683, 0xe68b, 0xe684,    BAD, 0xe680,    BAD, 0x92fa, 0xe67e,
/* 28 */    BAD,    BAD,    BAD, 0xe67c,    BAD, 0x9740, 0x8e90,    BAD,
/* 30 */    BAD, 0xe681,    BAD, 0xe67d,    BAD,    BAD,    BAD, 0xe685,
/* 38 */ 0x8f94,    BAD, 0x8cbf,    BAD,    BAD,    BAD, 0x91f8,    BAD
},

/* Row 0x10e */
{
/* 00 */ 0x9664, 0x8979, 0x88e0,    BAD, 0x93a3,    BAD,    BAD, 0xe689,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe688,    BAD, 0x93e4,    BAD,
/* 10 */ 0xe68d,    BAD,    BAD,    BAD, 0xe682,    BAD, 0xe68c, 0xe68e,
/* 18 */    BAD, 0x8caa, 0xe68a, 0x8d75,    BAD, 0x8ed3,    BAD,    BAD,
/* 20 */ 0xe68f, 0x9777,    BAD,    BAD,    BAD,    BAD, 0xe692,    BAD,
/* 28 */ 0xe695,    BAD,    BAD, 0xe693, 0x9554,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe690,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8bde,    BAD,    BAD,    BAD,    BAD, 0xe694,    BAD
},

/* Row 0x10f */
{
/* 00 */    BAD, 0xe696,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe69a,    BAD,    BAD, 0xe697,    BAD, 0xe699, 0xe698,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe69b,    BAD,
/* 18 */ 0x8eaf,    BAD, 0xe69d, 0xe69c, 0x9588,    BAD,    BAD, 0xe69f,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8c78,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe69e, 0xe6a0,    BAD,    BAD, 0xe6a1,
/* 30 */ 0x8b63, 0xe3bf, 0x8ff7,    BAD, 0xe6a2,    BAD,    BAD, 0x8cec,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6a3,    BAD,    BAD
},

/* Row 0x110 */
{
/* 00 */ 0xe6a4,    BAD,    BAD, 0x8e5d,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9dcc,    BAD, 0xe6a5,    BAD, 0xe6a6,    BAD,
/* 10 */ 0x8f51,    BAD, 0xe6a7, 0xe6a8,    BAD,    BAD, 0xe6a9,    BAD,
/* 18 */    BAD, 0xe6aa, 0xe6ab,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x111 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x924a,
/* 38 */    BAD,    BAD, 0xe6ac,    BAD,    BAD,    BAD,    BAD, 0xe6ae
},

/* Row 0x112 */
{
/* 00 */    BAD, 0xe6ad,    BAD,    BAD,    BAD,    BAD, 0x93a4,    BAD,
/* 08 */ 0xe6af,    BAD, 0x964c,    BAD, 0xe6b0,    BAD, 0xe6b1,    BAD,
/* 10 */ 0xe6b2,    BAD,    BAD,    BAD,    BAD, 0xe6b3,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x93d8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8fdb, 0xe6b4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8d8b, 0x98ac, 0xe6b5,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xe6b6, 0x955e, 0xe6b7,    BAD, 0xe6bf,    BAD,    BAD,    BAD
},

/* Row 0x113 */
{
/* 00 */    BAD,    BAD, 0xe6b8,    BAD,    BAD, 0xe6ba,    BAD,    BAD,
/* 08 */    BAD, 0xe6b9, 0xe6bb,    BAD, 0x9665, 0xe6bc, 0xe6bd,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe6be,    BAD,    BAD,    BAD,
/* 18 */ 0xe6c0,    BAD,    BAD,    BAD,    BAD, 0x8a4c, 0x92e5,    BAD,
/* 20 */ 0x9589, 0x8de0, 0x8d76,    BAD,    BAD,    BAD,    BAD, 0x956e,
/* 28 */ 0x89dd, 0x94cc, 0xe6c3, 0x8ad1, 0x90d3, 0xe6c2, 0xe6c7, 0x9299,
/* 30 */ 0x96e1,    BAD, 0xe6c5, 0xe6c6, 0x8b4d,    BAD, 0xe6c8, 0x9483,
/* 38 */ 0x91dd,    BAD,    BAD, 0x94ef, 0x935c, 0xe6c4,    BAD, 0x9666
},

/* Row 0x114 */
{
/* 00 */ 0x89ea, 0xe6ca, 0x9847, 0x92c0, 0x9864,    BAD,    BAD, 0x8e91,
/* 08 */ 0xe6c9,    BAD, 0x91af,    BAD,    BAD, 0xe6da, 0x9147,    BAD,
/* 10 */    BAD, 0x93f6,    BAD, 0x956f,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe6cd, 0x8e5e, 0x8e92,    BAD, 0x8fdc,    BAD,
/* 20 */ 0x9485,    BAD, 0x8cab, 0xe6cc, 0xe6cb,    BAD, 0x958a,    BAD,
/* 28 */    BAD,    BAD, 0x8ebf,    BAD,    BAD, 0x9371,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe6cf, 0xe6d0, 0x8d77, 0xe6ce,    BAD,    BAD
},

/* Row 0x115 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe6d1, 0xe6d2,    BAD, 0xe6d4,
/* 08 */ 0x91a1,    BAD, 0xe6d3, 0x8ae4,    BAD, 0xe6d6,    BAD, 0xe6d5,
/* 10 */ 0xe6d7,    BAD,    BAD, 0xe6d9, 0xe6db,    BAD, 0xe6dc,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x116 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x90d4,    BAD, 0x8ecd, 0xe6dd,
/* 28 */    BAD,    BAD,    BAD, 0x8a71,    BAD, 0xe6de,    BAD,    BAD,
/* 30 */ 0x9196, 0xe6df,    BAD, 0xe6e0, 0x958b,    BAD,    BAD, 0x8b4e,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x117 */
{
/* 00 */    BAD, 0xe6e1,    BAD,    BAD,    BAD, 0x92b4,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x897a,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe6e2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x8eef,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9096,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x91ab,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe6e5,    BAD,    BAD,    BAD, 0xe6e4,    BAD
},

/* Row 0x118 */
{
/* 00 */    BAD,    BAD, 0xe6e3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe6eb, 0xe6e9,    BAD,    BAD, 0xe6e6,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6e8,    BAD,
/* 18 */    BAD,    BAD, 0xe6e7, 0xe6ea,    BAD, 0x8b97,    BAD, 0xe6ee,
/* 20 */    BAD, 0x90d5,    BAD, 0xe6ef,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8cd7,    BAD, 0xe6ec, 0xe6ed,    BAD,    BAD,    BAD, 0x9848,
/* 30 */    BAD,    BAD,    BAD, 0x92b5,    BAD, 0x9148,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe6f0,    BAD,    BAD, 0xe6f3
},

/* Row 0x119 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe6f1, 0xe6f2, 0x9778,    BAD,    BAD,    BAD,    BAD, 0x93a5,
/* 10 */ 0xe6f6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6f4, 0xe6f5, 0xe6f7,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xe748,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe6fa,    BAD,    BAD,    BAD, 0xe6fb, 0xe6f9,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x11a */
{
/* 00 */    BAD,    BAD, 0xe6f8,    BAD, 0x92fb,    BAD,    BAD, 0xe740,
/* 08 */ 0xe744, 0xe741, 0xe6fc,    BAD, 0xe742,    BAD,    BAD,    BAD,
/* 10 */ 0xe743,    BAD,    BAD,    BAD,    BAD, 0xe74a,    BAD,    BAD,
/* 18 */    BAD, 0xe745,    BAD,    BAD,    BAD,    BAD,    BAD, 0x90d6,
/* 20 */ 0xe747,    BAD,    BAD, 0xe749, 0xe746,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xe74c,    BAD, 0x8f52,    BAD, 0xe74b,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe74d,    BAD,    BAD,    BAD
},

/* Row 0x11b */
{
/* 00 */    BAD, 0xe74e,    BAD,    BAD, 0xe751, 0xe750,    BAD, 0xe74f,
/* 08 */    BAD,    BAD, 0xe753, 0xe752,    BAD, 0x96f4,    BAD,    BAD,
/* 10 */    BAD, 0xe755,    BAD, 0xe754, 0xe756,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe757,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe759,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xe758, 0x9067, 0xe75a,    BAD,    BAD, 0x8beb,
/* 30 */ 0xe75b, 0xe75d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe75e,    BAD
},

/* Row 0x11c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe75f, 0xe75c,    BAD,
/* 08 */ 0xe760,    BAD, 0x8ed4, 0xe761, 0x8b4f, 0x8c52,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8cac,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe762,    BAD,    BAD,    BAD, 0x93ee,
/* 20 */    BAD,    BAD, 0x935d, 0xe763,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe766,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8eb2,    BAD,    BAD, 0xe765, 0xe764, 0x8c79, 0xe767,    BAD
},

/* Row 0x11d */
{
/* 00 */    BAD,    BAD,    BAD, 0x8a72,    BAD, 0xe769,    BAD,    BAD,
/* 08 */    BAD, 0x8dda, 0xe768,    BAD, 0xe771,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe76b, 0xe76d, 0x95e3, 0xe76a,    BAD,    BAD,
/* 18 */    BAD, 0xe76c,    BAD, 0xe770, 0xe76e, 0x8b50,    BAD, 0xe76f,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe772,    BAD,
/* 28 */    BAD, 0x9479, 0x97d6,    BAD,    BAD,    BAD,    BAD, 0x8f53,
/* 30 */    BAD,    BAD,    BAD, 0xe773,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9741, 0xe775,    BAD, 0xe774,    BAD,    BAD, 0xe778, 0x9760
},

/* Row 0x11e */
{
/* 00 */    BAD,    BAD, 0xe777,    BAD, 0x8a8d, 0xe776, 0xe77b,    BAD,
/* 08 */    BAD, 0xe77a,    BAD,    BAD, 0xe779, 0x9351, 0xe77c,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe77d,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xe77e,    BAD,    BAD, 0x8d8c,
/* 20 */    BAD, 0x8c44, 0xe780, 0xe781, 0xe782,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x11f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x9068, 0xe783,    BAD, 0x8eab, 0xe784,
/* 20 */    BAD,    BAD,    BAD, 0xe785,    BAD,    BAD,    BAD, 0x999f,
/* 28 */ 0x999e,    BAD,    BAD,    BAD,    BAD, 0xe786, 0xe390, 0xe787,
/* 30 */ 0x9243, 0x904a, 0x945f,    BAD,    BAD,    BAD,    BAD, 0xe788,
/* 38 */    BAD,    BAD, 0x95d3, 0x92d2, 0x8d9e,    BAD,    BAD, 0x9248
},

/* Row 0x120 */
{
/* 00 */    BAD,    BAD, 0x8949,    BAD, 0x9698, 0x9076,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8c7d,    BAD,
/* 10 */    BAD, 0x8bdf,    BAD,    BAD, 0x95d4,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe789,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xe78b,    BAD,    BAD, 0xe78a, 0x89de,    BAD,
/* 28 */    BAD, 0x93f4, 0xe78c, 0x9497,    BAD, 0x9352,    BAD, 0xe78d,
/* 30 */ 0x8f71,    BAD,    BAD,    BAD, 0xe78f,    BAD,    BAD, 0x96c0,
/* 38 */ 0xe79e, 0xe791, 0xe792,    BAD,    BAD, 0x92c7,    BAD,    BAD
},

/* Row 0x121 */
{
/* 00 */ 0x91de, 0x9197,    BAD, 0x93a6,    BAD, 0xe790, 0x8b74,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe799,    BAD, 0xe796, 0xe7a3, 0x93a7,
/* 10 */ 0x9280, 0xe793,    BAD, 0x92fc, 0x9372, 0xe794, 0xe798, 0x9080,
/* 18 */    BAD, 0x9487, 0x92ca,    BAD,    BAD, 0x90c0, 0xe797, 0x91ac,
/* 20 */ 0x91a2, 0xe795, 0x88a7, 0x9841,    BAD,    BAD,    BAD, 0xe79a,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x91df,    BAD,
/* 30 */    BAD, 0x8f54, 0x9069,    BAD,    BAD, 0xe79c, 0xe79b,    BAD,
/* 38 */ 0x88ed, 0xe79d,    BAD,    BAD, 0x954e,    BAD, 0xe7a5,    BAD
},

/* Row 0x122 */
{
/* 00 */    BAD, 0x93d9, 0x908b,    BAD,    BAD, 0x9278,    BAD, 0x8bf6,
/* 08 */    BAD, 0xe7a4, 0x9756, 0x895e,    BAD, 0x95d5, 0x89df, 0xe79f,
/* 10 */ 0xe7a0, 0xe7a1, 0xe7a2, 0x93b9, 0x9242, 0x88e1, 0xe7a6,    BAD,
/* 18 */ 0xe7a7, 0xeaa1,    BAD,    BAD, 0x91bb,    BAD, 0xe7a8,    BAD,
/* 20 */ 0x8993, 0x916b,    BAD, 0x8cad,    BAD, 0x9779,    BAD,    BAD,
/* 28 */ 0xe7a9, 0x934b,    BAD,    BAD,    BAD, 0x9198, 0x8ed5, 0xe7aa,
/* 30 */    BAD,    BAD, 0xe7ad,    BAD,    BAD, 0x8f85, 0xe7ab, 0x914a,
/* 38 */ 0x9149,    BAD, 0x88e2,    BAD, 0x97c9, 0xe7af,    BAD, 0x94f0
},

/* Row 0x123 */
{
/* 00 */ 0xe7b1, 0xe7b0, 0xe7ae, 0xe284, 0x8ad2,    BAD,    BAD, 0xe78e,
/* 08 */    BAD, 0xe7b3, 0xe7b2,    BAD,    BAD,    BAD,    BAD, 0xe7b4,
/* 10 */    BAD, 0x9757,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x93df,    BAD,    BAD, 0x964d,    BAD,
/* 28 */ 0xe7b5,    BAD, 0x8ed7,    BAD,    BAD,    BAD,    BAD, 0xe7b6,
/* 30 */    BAD, 0xe7b7,    BAD,    BAD,    BAD, 0xe7b8,    BAD,    BAD,
/* 38 */ 0x9340,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x124 */
{
/* 00 */    BAD, 0x88e8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8d78,    BAD,    BAD,    BAD, 0x9859,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe7bc,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8c53, 0xe7b9,    BAD, 0xe7ba,    BAD,    BAD,    BAD,
/* 28 */ 0x9594,    BAD,    BAD,    BAD,    BAD, 0x8a73,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9758,    BAD, 0x8bbd,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9373,    BAD,    BAD
},

/* Row 0x125 */
{
/* 00 */    BAD,    BAD, 0xe7bd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe7be,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe7bf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9341,    BAD,    BAD,
/* 30 */ 0xe7c1,    BAD, 0xe7c0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x126 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x93d1, 0xe7c2, 0x8f55, 0x8ede, 0x947a, 0x9291,    BAD,
/* 10 */    BAD,    BAD, 0x8ef0,    BAD, 0x908c,    BAD, 0xe7c3,    BAD,
/* 18 */ 0xe7c4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x907c, 0xe7c5,    BAD, 0xe7c6,    BAD,    BAD,
/* 28 */    BAD, 0xe7c7, 0x978f,    BAD, 0x8f56,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xe7c9, 0xe7c8,    BAD, 0x8d79,    BAD, 0x8d93,
/* 38 */ 0x8e5f,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x127 */
{
/* 00 */    BAD,    BAD, 0xe7cc,    BAD,    BAD,    BAD,    BAD, 0x8f86,
/* 08 */    BAD, 0xe7cb,    BAD, 0xe7ca,    BAD, 0x91e7,    BAD,    BAD,
/* 10 */ 0x8ced,    BAD, 0x90c1,    BAD,    BAD,    BAD,    BAD, 0x94ae,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x8f58,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xe7cd,    BAD, 0x8fdd,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xe7d0, 0xe7ce,    BAD,    BAD,    BAD, 0xe7cf,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe7d2, 0xe7d1,    BAD,    BAD,
/* 38 */ 0x8ff8,    BAD, 0xe7d3,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x128 */
{
/* 00 */ 0xe7d4, 0xe7d5,    BAD,    BAD,    BAD,    BAD, 0x94ce, 0x8dd1,
/* 08 */ 0x8edf, 0xe7d6,    BAD, 0xe7d7, 0x97a2, 0x8f64, 0x96ec, 0x97ca,
/* 10 */ 0xe7d8, 0x8be0,    BAD,    BAD,    BAD,    BAD, 0xe7d9,    BAD,
/* 18 */ 0x9342,    BAD,    BAD, 0xe7dc, 0x8a98, 0x906a,    BAD, 0xe7da,
/* 20 */    BAD, 0xe7db,    BAD, 0x92de,    BAD,    BAD, 0x9674, 0x8bfa,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7de, 0xe7df,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe7dd,    BAD,    BAD, 0xe7e1
},

/* Row 0x129 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x93dd, 0x8a62,    BAD,
/* 10 */    BAD, 0xe7e5,    BAD,    BAD, 0xe7e2, 0xe7e4,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7e0,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe86e,    BAD,    BAD, 0xe7e3,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x97e9,    BAD,    BAD, 0x8cd8,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7ed
},

/* Row 0x12a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x9353, 0xe7e8,    BAD,    BAD,
/* 08 */ 0xe7eb, 0xe7e9,    BAD, 0xe7ee,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xe7ef,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7e7,
/* 18 */    BAD,    BAD, 0xe7f4, 0x8994,    BAD,    BAD, 0xe7e6,    BAD,
/* 20 */    BAD,    BAD, 0x94ab,    BAD, 0xe7ea,    BAD, 0x8fde,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8d7a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9667,    BAD
},

/* Row 0x12b */
{
/* 00 */ 0x8be2,    BAD,    BAD, 0x8f65,    BAD, 0x93ba,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x914c,    BAD, 0xe7f2,    BAD, 0xe7ec, 0xe7f1,    BAD,
/* 18 */ 0x96c1,    BAD, 0x92b6, 0xe7f3, 0xe7f0,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x914b,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7f7,
/* 38 */    BAD, 0xe7f6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x12c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7f5,
/* 10 */    BAD,    BAD, 0x964e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8f9b,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe7f8, 0x95dd,    BAD,    BAD, 0x8973,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9565, 0x9292,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8b98,    BAD, 0xe7fa,    BAD, 0x8d7c,    BAD,    BAD,    BAD
},

/* Row 0x12d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8e4b,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7f9,
/* 10 */ 0x908d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x908e, 0xe840, 0xe842,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8ff9,    BAD, 0xe841, 0xe843,    BAD,    BAD, 0x8bd1,    BAD,
/* 28 */ 0x9564,    BAD,    BAD, 0x8ee0, 0x9842,    BAD, 0xe7fc, 0x8df6,
/* 30 */    BAD,    BAD, 0x985e,    BAD,    BAD, 0xe845,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe844, 0xe846,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x12e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe7fb,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x93e7,    BAD, 0x9374,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x92d5,    BAD, 0xe84b,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x9262, 0xe847,    BAD,    BAD,    BAD,
/* 20 */ 0xe848,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8c4c,    BAD, 0xe84a,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8cae,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe849,    BAD, 0x8fdf,    BAD
},

/* Row 0x12f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x8a99,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe84f,    BAD, 0x8dbd, 0x9199,
/* 18 */    BAD,    BAD, 0x92c8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a5a,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe84d, 0xe84e, 0x92c1,    BAD,
/* 30 */ 0xe84c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe850,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x130 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe856,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe859,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xe858, 0x934c,    BAD,    BAD,    BAD,    BAD, 0xe851, 0xe852,
/* 18 */ 0xe855,    BAD,    BAD,    BAD,    BAD, 0xe857,    BAD,    BAD,
/* 20 */    BAD, 0x8bbe,    BAD,    BAD, 0xe85a, 0xe854,    BAD,    BAD,
/* 28 */ 0xe853,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x131 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe85e,    BAD,    BAD,    BAD, 0xe85f,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xe860,    BAD,    BAD, 0xe85d, 0xe85c,    BAD,    BAD,    BAD,
/* 18 */ 0x8fe0, 0x93a8, 0xe85b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe864,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe862,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe863, 0xe861,    BAD,
/* 38 */ 0x91f6,    BAD, 0xe865,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x132 */
{
/* 00 */    BAD, 0xe866,    BAD,    BAD, 0xe868,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8ad3, 0xe867, 0x96f8,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe873, 0xe869,    BAD,    BAD, 0xe86c,    BAD,
/* 20 */ 0xe86a,    BAD, 0xe86b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xe86d,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe86f,    BAD,    BAD,    BAD,    BAD, 0xe870,    BAD, 0xe871,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe874, 0xe872, 0xe875, 0xe877
},

/* Row 0x133 */
{
/* 00 */    BAD, 0xe876,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x134 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x92b7,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x135 */
{
/* 00 */ 0x96e5,    BAD, 0xe878, 0x914d,    BAD,    BAD,    BAD, 0xe879,
/* 08 */    BAD, 0x95c2, 0xe87a, 0x8a4a,    BAD,    BAD,    BAD, 0x895b,
/* 10 */    BAD, 0x8ad5,    BAD, 0x8ad4, 0xe87b,    BAD, 0xe87c,    BAD,
/* 18 */ 0xe87d, 0xe87e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe880,    BAD, 0x8ad6, 0x8a74, 0x8d7d, 0x94b4,    BAD, 0xe882,
/* 28 */ 0xe881,    BAD,    BAD,    BAD,    BAD, 0xe883,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x897b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe886,    BAD, 0xe885, 0xe884,    BAD, 0xe887,    BAD
},

/* Row 0x136 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe88a,    BAD,    BAD,    BAD, 0x88c5,
/* 08 */    BAD,    BAD, 0xe888,    BAD, 0xe88c, 0xe88b,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe88e, 0xe88d, 0xe88f,    BAD,
/* 18 */ 0x93ac,    BAD,    BAD,    BAD, 0xe890,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe891, 0xe893,    BAD,    BAD, 0xe892,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x137 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x958c,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe894,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe895,    BAD, 0x8de3,    BAD,    BAD,    BAD, 0xe896, 0xe897,
/* 30 */    BAD,    BAD, 0x9668,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x916a,    BAD,    BAD,    BAD, 0x88a2
},

/* Row 0x138 */
{
/* 00 */ 0x91c9,    BAD, 0xe898,    BAD, 0x958d,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe89b, 0xe899, 0x8d7e,    BAD, 0xe89a,
/* 10 */ 0x8cc0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x95c3, 0xe89d, 0xe89f, 0xe89e, 0xe8a0,
/* 20 */    BAD,    BAD, 0x8940, 0x9077, 0x8f9c, 0x8ad7, 0xe8a1,    BAD,
/* 28 */    BAD,    BAD, 0x9486,    BAD, 0xe8a3,    BAD,    BAD,    BAD,
/* 30 */ 0x8941,    BAD, 0xe8a2, 0x92c2,    BAD, 0x97cb, 0x93a9, 0xe89c,
/* 38 */ 0x97a4,    BAD, 0x8caf,    BAD,    BAD, 0x977a,    BAD,    BAD
},

/* Row 0x139 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8bf7, 0x97b2,    BAD,
/* 08 */ 0x8c47,    BAD, 0x91e0, 0xe440,    BAD, 0xe8a4, 0x8a4b, 0x908f,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8a75, 0xe8a6,    BAD, 0xe8a7,
/* 18 */ 0xe8a5, 0x8c84,    BAD, 0x8ddb, 0x8fe1,    BAD,    BAD,    BAD,
/* 20 */ 0x8942,    BAD,    BAD, 0x97d7,    BAD,    BAD,    BAD, 0xe8a9,
/* 28 */ 0xe7ac,    BAD, 0xe8a8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe8ac, 0xe8aa, 0xe8ab,    BAD, 0xe8ad,    BAD, 0xe8ae, 0x97ea,
/* 38 */ 0xe8af, 0xe8b0,    BAD, 0x90c7, 0x94b9,    BAD,    BAD,    BAD
},

/* Row 0x13a */
{
/* 00 */ 0x909d, 0x8ae5,    BAD,    BAD, 0x9759, 0x89eb, 0x8f57, 0x8cd9,
/* 08 */    BAD, 0xe8b3,    BAD, 0xe8b2, 0x8e93, 0xe8b4, 0xe8b1,    BAD,
/* 10 */    BAD, 0x8e47,    BAD,    BAD,    BAD, 0xe8b8, 0xe5ab,    BAD,
/* 18 */    BAD, 0x99d4,    BAD, 0x9097, 0xe8b6,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x97a3, 0x93ef,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x894a,    BAD, 0x90e1, 0x8eb4,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x95b5,    BAD, 0x895f,    BAD,    BAD,    BAD, 0x97eb, 0x978b,
/* 38 */    BAD, 0xe8b9,    BAD, 0x9364,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x13b */
{
/* 00 */ 0x8ef9,    BAD,    BAD,    BAD, 0xe8ba,    BAD, 0xe8bb, 0x906b,
/* 08 */ 0xe8bc,    BAD, 0x97ec,    BAD,    BAD, 0xe8b7, 0xe8be, 0xe8c0,
/* 10 */    BAD, 0xe8bf,    BAD, 0xe8bd,    BAD,    BAD, 0xe8c1,    BAD,
/* 18 */    BAD, 0xe8c2,    BAD,    BAD, 0x919a,    BAD, 0x89e0,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xe8c3,    BAD,    BAD, 0x96b6,
/* 28 */    BAD,    BAD, 0xe8c4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe8c5,    BAD, 0x9849,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9e50, 0xe8c6,    BAD,    BAD,    BAD, 0xe8c7, 0xe8c8,    BAD
},

/* Row 0x13c */
{
/* 00 */    BAD,    BAD, 0xe8cc,    BAD, 0xe8c9,    BAD, 0xe8ca,    BAD,
/* 08 */ 0xe8cb, 0xe8cd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x90c2,    BAD,    BAD,    BAD, 0x96f5,    BAD,
/* 18 */    BAD, 0x90c3,    BAD,    BAD, 0xe8ce,    BAD, 0x94f1,    BAD,
/* 20 */ 0xe8cf, 0xea72, 0x96ca,    BAD, 0xe8d0,    BAD, 0xe8d1,    BAD,
/* 28 */ 0xe8d2, 0x8a76,    BAD, 0xe8d4,    BAD, 0x9078,    BAD,    BAD,
/* 30 */    BAD, 0xe8d5,    BAD,    BAD, 0x8c43,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe8d6, 0xe8da,    BAD, 0xe8d8,    BAD,    BAD,    BAD
},

/* Row 0x13d */
{
/* 00 */    BAD, 0xe8d9,    BAD,    BAD, 0x8a93, 0xe8d7, 0xe8db,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe8dc,    BAD, 0x88c6,    BAD, 0xe8dd,
/* 10 */ 0xe8de,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8fe2,    BAD,    BAD,    BAD, 0xe8df,    BAD,    BAD,    BAD,
/* 20 */ 0x8b66,    BAD,    BAD, 0xe8e2,    BAD,    BAD, 0xe8e1,    BAD,
/* 28 */ 0xe8e0,    BAD,    BAD, 0xe691,    BAD, 0x95da,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe8e3, 0xe8e4,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x13e */
{
/* 00 */    BAD,    BAD,    BAD, 0xe8e5,    BAD,    BAD, 0xe8e6,    BAD,
/* 08 */ 0xe8e7,    BAD,    BAD, 0xe8e8,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8ad8,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xe8e9,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8ea, 0x9442,    BAD,
/* 30 */    BAD,    BAD, 0xe8ec, 0x89b9,    BAD, 0xe8ef, 0xe8ee,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8943,    BAD,    BAD,    BAD, 0x8bbf
},

/* Row 0x13f */
{
/* 00 */    BAD, 0x95c5, 0x92b8, 0x8da0,    BAD, 0x8d80, 0x8f87,    BAD,
/* 08 */ 0x907b,    BAD,    BAD,    BAD, 0xe8f1,    BAD,    BAD, 0xe8f0,
/* 10 */ 0x9761, 0x8ae6, 0x94d0, 0x93da,    BAD,    BAD,    BAD, 0x909c,
/* 18 */ 0x97cc,    BAD, 0x8c7a,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe8f4,    BAD,    BAD, 0xe8f3,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x966a, 0x93aa,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x896f,    BAD,    BAD, 0xe8f5,
/* 38 */ 0xe8f2,    BAD,    BAD, 0x9570, 0x978a, 0xe8f6,    BAD,    BAD
},

/* Row 0x140 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8f7,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe8f9, 0x91e8, 0x8a7a, 0x8a7b, 0xe8f8,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8ae7, 0x8cb0,    BAD,    BAD,
/* 18 */ 0x8ae8,    BAD,    BAD, 0x935e,    BAD,    BAD, 0x97de,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8cda,
/* 28 */    BAD,    BAD,    BAD, 0xe8fa,    BAD,    BAD,    BAD, 0xe8fb,
/* 30 */ 0xe8fc, 0xe940,    BAD, 0xe942, 0xe941,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x141 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9597,    BAD, 0xe943,    BAD,    BAD,    BAD,    BAD, 0xe944,
/* 30 */    BAD, 0xe945,    BAD,    BAD,    BAD,    BAD, 0xe946,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x142 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe948, 0xe947,    BAD, 0xe949,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x94f2, 0xe3ca,    BAD,    BAD, 0x9048,
/* 20 */    BAD,    BAD, 0x8b51,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe94a,    BAD, 0xe94b,    BAD, 0x99aa, 0x9f5a, 0x94d1,
/* 30 */    BAD,    BAD, 0x88f9,    BAD, 0x88b9,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x8e94, 0x964f, 0x8ffc,    BAD
},

/* Row 0x143 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe94c,    BAD, 0x96dd,    BAD,    BAD,
/* 08 */    BAD, 0xe94d, 0x977b,    BAD, 0x8961,    BAD,    BAD,    BAD,
/* 10 */ 0x8e60,    BAD, 0xe94e, 0x89ec, 0xe94f,    BAD,    BAD,    BAD,
/* 18 */ 0xe950,    BAD,    BAD,    BAD,    BAD, 0xe952, 0xe953,    BAD,
/* 20 */ 0xe955, 0xe951,    BAD,    BAD, 0xe954,    BAD,    BAD,    BAD,
/* 28 */ 0x8ad9,    BAD,    BAD,    BAD, 0xe956,    BAD, 0xe957,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe958, 0xe959,    BAD
},

/* Row 0x144 */
{
/* 00 */    BAD,    BAD, 0xe95a,    BAD,    BAD, 0xe95c,    BAD,    BAD,
/* 08 */    BAD, 0xe95b,    BAD, 0xe95e, 0xe961,    BAD,    BAD,    BAD,
/* 10 */ 0xe95d, 0xe95f, 0xe960,    BAD,    BAD, 0xe962,    BAD, 0x8bc0,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x145 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ef1, 0xe963,
/* 18 */ 0xe964, 0x8d81,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe965,    BAD,    BAD,
/* 28 */ 0x8a5d,    BAD,    BAD,    BAD, 0x946e, 0xe966, 0xe967,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9279, 0x93e9,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe968,    BAD,    BAD,    BAD
},

/* Row 0x146 */
{
/* 00 */    BAD, 0x949d,    BAD,    BAD, 0x91ca, 0x8977, 0x8bec,    BAD,
/* 08 */ 0x8bed,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x9293, 0xe96d, 0x8bee,    BAD,    BAD, 0x89ed,    BAD,    BAD,
/* 18 */ 0xe96c,    BAD,    BAD, 0xe96a,    BAD, 0xe96b,    BAD, 0xe969,
/* 20 */    BAD,    BAD, 0xe977,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe96e, 0xe96f,    BAD,
/* 30 */    BAD, 0xe970, 0xe971,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xe973,    BAD,    BAD, 0xe972,    BAD,    BAD,    BAD, 0x8f78
},

/* Row 0x147 */
{
/* 00 */    BAD, 0xe974,    BAD,    BAD,    BAD, 0xe976,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b52, 0xe975,
/* 10 */    BAD,    BAD, 0x919b, 0x8cb1,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe978,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x91cb,    BAD,    BAD, 0xe979,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x93ab,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe97a,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe980,    BAD
},

/* Row 0x148 */
{
/* 00 */ 0xe97d,    BAD, 0xe97c, 0xe97e,    BAD, 0xe97b,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe982,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe981,    BAD, 0xe984,
/* 18 */    BAD,    BAD, 0x8bc1, 0xe983,    BAD,    BAD,    BAD, 0xe985,
/* 20 */    BAD,    BAD, 0xe986,    BAD, 0xe988, 0xe987,    BAD,    BAD,
/* 28 */    BAD, 0xe989, 0xe98b, 0xe98a,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x149 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8d9c,    BAD,    BAD,    BAD,    BAD, 0xe98c,    BAD,    BAD,
/* 30 */ 0xe98d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8a5b,    BAD,    BAD,    BAD, 0xe98e,    BAD,    BAD,    BAD
},

/* Row 0x14a */
{
/* 00 */ 0xe98f,    BAD,    BAD,    BAD, 0x9091,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe990,
/* 10 */    BAD, 0xe991,    BAD, 0xe992, 0xe993,    BAD,    BAD,    BAD,
/* 18 */ 0x8d82,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe994, 0xe995,
/* 20 */    BAD,    BAD, 0xe996, 0xe997,    BAD,    BAD, 0xe998,    BAD,
/* 28 */    BAD,    BAD, 0x94af, 0xe99a,    BAD, 0x9545, 0xe99b, 0xe999,
/* 30 */    BAD, 0xe99d,    BAD,    BAD, 0xe99c,    BAD,    BAD, 0xe99e,
/* 38 */    BAD,    BAD,    BAD, 0xe99f,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x14b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9a0,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe9a1,    BAD, 0xe9a2,    BAD,    BAD,    BAD,    BAD, 0xe9a3,
/* 20 */    BAD,    BAD, 0xe9a4, 0xe9a5,    BAD, 0xe9a6,    BAD, 0xe9a7,
/* 28 */ 0xe9a8, 0xe9a9, 0xe9aa,    BAD,    BAD,    BAD, 0xe9ab, 0xe9ac,
/* 30 */    BAD, 0x9f54, 0xe9ad,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe2f6, 0x8b53,    BAD,    BAD,    BAD
},

/* Row 0x14c */
{
/* 00 */    BAD, 0x8a40, 0x8db0, 0xe9af, 0xe9ae, 0x96a3,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9b1, 0xe9b2, 0xe9b0,
/* 10 */    BAD, 0xe9b3,    BAD,    BAD, 0x9682,    BAD,    BAD,    BAD,
/* 18 */ 0xe9b4,    BAD, 0x8b9b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9844,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe9b5,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x14d */
{
/* 00 */    BAD,    BAD,    BAD, 0xe9b7,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x88bc,    BAD,
/* 10 */    BAD, 0xe9b8, 0x95a9, 0xe9b6,    BAD,    BAD, 0xe9b9, 0xe9ba,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9bb,
/* 20 */ 0xe9bc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe9bd,    BAD, 0x968e, 0x8e4c,    BAD, 0x8df8, 0x914e,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe9be,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe9c1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x14e */
{
/* 00 */ 0xe9bf,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9c2,    BAD,
/* 08 */    BAD, 0x8cef, 0xe9c0,    BAD,    BAD,    BAD,    BAD, 0xe9c3,
/* 10 */    BAD, 0xe9c4, 0xe9c5,    BAD, 0xe9c9,    BAD, 0x8e49,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x91e2,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe9ca, 0xe9c7, 0xe9c6, 0xe9c8,    BAD,    BAD,    BAD,
/* 28 */ 0x8c7e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe9ce, 0xe9cd, 0xe9cc,    BAD,    BAD, 0x88b1,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x14f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe9d8,    BAD, 0xe9d4,    BAD,
/* 08 */ 0xe9d5, 0xe9d1, 0xe9d7,    BAD, 0xe9d3, 0x8a82,    BAD,    BAD,
/* 10 */ 0x986b,    BAD, 0xe9d6, 0xe9d2, 0xe9d0, 0xe9cf,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe9da,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe9dd,    BAD,    BAD, 0xe9dc, 0xe9db,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9568, 0xe9d9, 0x88f1,
/* 30 */ 0xe9de,    BAD, 0xe9e0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8a8f, 0xe9cb, 0x8956,    BAD,    BAD, 0xe9e2,    BAD
},

/* Row 0x150 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9e1, 0xe9df,
/* 08 */ 0x924c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9690,    BAD,    BAD,    BAD,    BAD, 0x97d8,
/* 18 */    BAD,    BAD, 0xe9e3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe9e4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9e5,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9e6,    BAD,
/* 38 */ 0xe9e7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x151 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x92b9,    BAD, 0xe9e8,
/* 28 */    BAD, 0x94b5,    BAD, 0xe9ed, 0xe9e9,    BAD,    BAD,    BAD,
/* 30 */ 0xe9ea,    BAD,    BAD, 0x9650, 0x96c2,    BAD, 0x93ce,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x152 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe9ee,    BAD,    BAD, 0xe9ef, 0x93bc,
/* 08 */ 0xe9ec, 0xe9eb,    BAD,    BAD,    BAD,    BAD, 0x89a8,    BAD,
/* 10 */    BAD,    BAD, 0xe9f7,    BAD,    BAD, 0xe9f6,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8995,    BAD,    BAD,    BAD, 0xe9f4,
/* 20 */    BAD,    BAD,    BAD, 0xe9f3,    BAD,    BAD, 0xe9f1,    BAD,
/* 28 */ 0x8a9b,    BAD, 0xe9f0, 0x8eb0, 0x89a7,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8d83,    BAD,    BAD, 0xe9fa, 0xe9f9
},

/* Row 0x153 */
{
/* 00 */    BAD, 0xe9f8,    BAD,    BAD, 0xe9f5,    BAD, 0xe9fb,    BAD,
/* 08 */ 0xe9fc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xea44, 0xea43,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xea45,    BAD,    BAD, 0x894c, 0xea40, 0xea41,    BAD,
/* 20 */ 0x8d94, 0x96b7,    BAD,    BAD, 0xea42,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9651,    BAD,    BAD, 0xea4a,
/* 30 */    BAD,    BAD, 0xea46,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xea4b,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x154 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xea48,
/* 08 */    BAD, 0xea47,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8c7b,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xea4c,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xea4d,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xea4e,    BAD, 0xea49,    BAD,    BAD,    BAD, 0xe9f2,
/* 30 */    BAD,    BAD, 0xea4f,    BAD, 0x92df,    BAD,    BAD,    BAD,
/* 38 */ 0xea53,    BAD, 0xea54, 0xea52,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x155 */
{
/* 00 */    BAD, 0xea51, 0xea57,    BAD, 0xea50,    BAD, 0xea55,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xea56,
/* 10 */    BAD,    BAD,    BAD, 0xea59,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xea58,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xea5b,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xea5c,    BAD, 0xea5d,
/* 30 */    BAD,    BAD, 0x9868,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xea5a, 0x91e9, 0x8deb,    BAD,    BAD, 0xea5e,    BAD,    BAD
},

/* Row 0x156 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xea5f, 0xea60,    BAD,    BAD, 0xea61,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x157 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xea62,    BAD,    BAD,
/* 38 */ 0x8cb2, 0xea63,    BAD,    BAD,    BAD, 0xea64,    BAD, 0x8ead
},

/* Row 0x158 */
{
/* 00 */    BAD, 0xea65,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xea66,    BAD,    BAD, 0xea67, 0xea68,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xea6b, 0xea69, 0x985b,    BAD, 0xea6a,    BAD, 0x97ed,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xea6c,    BAD, 0x97d9,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xea6d, 0x949e,    BAD,
/* 28 */    BAD, 0xea6e, 0xea70,    BAD,    BAD, 0xea71,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xea6f, 0x8d8d, 0x96cb, 0x9683, 0x9bf5,    BAD, 0x9f80, 0x969b
},

/* Row 0x159 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x89a9,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xea73, 0x8b6f, 0xea74, 0xea75,
/* 10 */ 0xea76,    BAD, 0x8d95,    BAD, 0xea77,    BAD,    BAD,    BAD,
/* 18 */ 0xe0d2, 0x96d9,    BAD, 0x91e1, 0xea78, 0xea7a, 0xea79,    BAD,
/* 20 */ 0xea7b,    BAD,    BAD,    BAD,    BAD, 0xea7c,    BAD,    BAD,
/* 28 */ 0xea7d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xea7e,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xea80,    BAD, 0xea81, 0xea82,
/* 38 */    BAD, 0xea83,    BAD, 0xea84, 0xea85, 0xea86,    BAD,    BAD
},

/* Row 0x15a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xea87,
/* 08 */ 0xea88,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9343,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8cdb,    BAD, 0xea8a,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x916c, 0xea8b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xea8c,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9540,    BAD,    BAD, 0xea8d,    BAD
},

/* Row 0x15b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xea8e, 0xe256,    BAD,    BAD, 0xe6d8, 0xe8eb,
/* 10 */    BAD,    BAD, 0xea8f,    BAD, 0xea90,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xea92,
/* 20 */ 0xea93, 0xea94, 0x97ee, 0xea91,    BAD,    BAD, 0xea95, 0xea96,
/* 28 */    BAD,    BAD, 0xea98,    BAD, 0xea97,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xea9a,    BAD,    BAD,    BAD, 0xea9b, 0xea99,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x15c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x97b4,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xea9c,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xea9d, 0xe273,    BAD,    BAD,
/* 20 */ 0xea9e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x15d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x81ad, 0x81ae, 0x81af, 0x81b0, 0x81b1, 0x81b2, 0x81b3, 0x81b4
},

/* Row 0x15e */
{
/* 00 */ 0x81b5, 0x81b6, 0x81b7, 0x81c0, 0x81c1, 0x81c2, 0x81c3, 0x81c4,
/* 08 */ 0x81c5, 0x81c6, 0x81c7, 0x81cf, 0x81d0, 0x81d1, 0x81d2, 0x81d3,
/* 10 */ 0x81d4, 0x81d5, 0x81d6, 0x81d7, 0x81d8, 0x81d9, 0x81e9, 0x81ea,
/* 18 */ 0x81eb, 0x81ec, 0x81ed, 0x81ee, 0x81ef, 0x81f8, 0x81f9, 0x81fa,
/* 20 */ 0x81fb, 0x8240, 0x8241, 0x8242, 0x8243, 0x8244, 0x8245, 0x8246,
/* 28 */ 0x8247, 0x8248, 0x8249, 0x824a, 0x824b, 0x824c, 0x824d, 0x824e,
/* 30 */ 0x8259, 0x825a, 0x825b, 0x825c, 0x825d, 0x825e, 0x825f, 0x827a,
/* 38 */ 0x827b, 0x827c, 0x827d, 0x827e, 0x8280, 0x829b, 0x829c, 0x829d
},

/* Row 0x15f */
{
/* 00 */ 0x829e, 0x82f2, 0x82f3, 0x82f4, 0x82f5, 0x82f6, 0x82f7, 0x82f8,
/* 08 */ 0x82f9, 0x82fa, 0x82fb, 0x82fc, 0x8397, 0x8398, 0x8399, 0x839a,
/* 10 */ 0x839b, 0x839c, 0x839d, 0x839e, 0x83b7, 0x83b8, 0x83b9, 0x83ba,
/* 18 */ 0x83bb, 0x83bc, 0x83bd, 0x83be, 0x83d7, 0x83d8, 0x83d9, 0x83da,
/* 20 */ 0x83db, 0x83dc, 0x83dd, 0x83de, 0x83df, 0x83e0, 0x83e1, 0x83e2,
/* 28 */ 0x83e3, 0x83e4, 0x83e5, 0x83e6, 0x83e7, 0x83e8, 0x83e9, 0x83ea,
/* 30 */ 0x83eb, 0x83ec, 0x83ed, 0x83ee, 0x83ef, 0x83f0, 0x83f1, 0x83f2,
/* 38 */ 0x83f3, 0x83f4, 0x83f5, 0x83f6, 0x83f7, 0x83f8, 0x83f9, 0x83fa
},

/* Row 0x160 */
{
/* 00 */ 0x83fb, 0x83fc, 0x8461, 0x8462, 0x8463, 0x8464, 0x8465, 0x8466,
/* 08 */ 0x8467, 0x8468, 0x8469, 0x846a, 0x846b, 0x846c, 0x846d, 0x846e,
/* 10 */ 0x846f, 0x8492, 0x8493, 0x8494, 0x8495, 0x8496, 0x8497, 0x8498,
/* 18 */ 0x8499, 0x849a, 0x849b, 0x849c, 0x849d, 0x849e, 0x84bf, 0x84c0,
/* 20 */ 0x84c1, 0x84c2, 0x84c3, 0x84c4, 0x84c5, 0x84c6, 0x84c7, 0x84c8,
/* 28 */ 0x84c9, 0x84ca, 0x84cb, 0x84cc, 0x84cd, 0x84ce, 0x84cf, 0x84d0,
/* 30 */ 0x84d1, 0x84d2, 0x84d3, 0x84d4, 0x84d5, 0x84d6, 0x84d7, 0x84d8,
/* 38 */ 0x84d9, 0x84da, 0x84db, 0x84dc, 0x84dd, 0x84de, 0x84df, 0x84e0
},

/* Row 0x161 */
{
/* 00 */ 0x84e1, 0x84e2, 0x84e3, 0x84e4, 0x84e5, 0x84e6, 0x84e7, 0x84e8,
/* 08 */ 0x84e9, 0x84ea, 0x84eb, 0x84ec, 0x84ed, 0x84ee, 0x84ef, 0x84f0,
/* 10 */ 0x84f1, 0x84f2, 0x84f3, 0x84f4, 0x84f5, 0x84f6, 0x84f7, 0x84f8,
/* 18 */ 0x84f9, 0x84fa, 0x84fb, 0x84fc, 0x8540, 0x8541, 0x8542, 0x8543,
/* 20 */ 0x8544, 0x8545, 0x8546, 0x8547, 0x8548, 0x8549, 0x854a, 0x854b,
/* 28 */ 0x854c, 0x854d, 0x854e, 0x854f, 0x8550, 0x8551, 0x8552, 0x8553,
/* 30 */ 0x8554, 0x8555, 0x8556, 0x8557, 0x8558, 0x8559, 0x855a, 0x855b,
/* 38 */ 0x855c, 0x855d, 0x855e, 0x855f, 0x8560, 0x8561, 0x8562, 0x8563
},

/* Row 0x162 */
{
/* 00 */ 0x8564, 0x8565, 0x8566, 0x8567, 0x8568, 0x8569, 0x856a, 0x856b,
/* 08 */ 0x856c, 0x856d, 0x856e, 0x856f, 0x8570, 0x8571, 0x8572, 0x8573,
/* 10 */ 0x8574, 0x8575, 0x8576, 0x8577, 0x8578, 0x8579, 0x857a, 0x857b,
/* 18 */ 0x857c, 0x857d, 0x857e, 0x8580, 0x8581, 0x8582, 0x8583, 0x8584,
/* 20 */ 0x8585, 0x8586, 0x8587, 0x8588, 0x8589, 0x858a, 0x858b, 0x858c,
/* 28 */ 0x858d, 0x858e, 0x858f, 0x8590, 0x8591, 0x8592, 0x8593, 0x8594,
/* 30 */ 0x8595, 0x8596, 0x8597, 0x8598, 0x8599, 0x859a, 0x859b, 0x859c,
/* 38 */ 0x859d, 0x859e, 0x859f, 0x85a0, 0x85a1, 0x85a2, 0x85a3, 0x85a4
},

/* Row 0x163 */
{
/* 00 */ 0x85a5, 0x85a6, 0x85a7, 0x85a8, 0x85a9, 0x85aa, 0x85ab, 0x85ac,
/* 08 */ 0x85ad, 0x85ae, 0x85af, 0x85b0, 0x85b1, 0x85b2, 0x85b3, 0x85b4,
/* 10 */ 0x85b5, 0x85b6, 0x85b7, 0x85b8, 0x85b9, 0x85ba, 0x85bb, 0x85bc,
/* 18 */ 0x85bd, 0x85be, 0x85bf, 0x85c0, 0x85c1, 0x85c2, 0x85c3, 0x85c4,
/* 20 */ 0x85c5, 0x85c6, 0x85c7, 0x85c8, 0x85c9, 0x85ca, 0x85cb, 0x85cc,
/* 28 */ 0x85cd, 0x85ce, 0x85cf, 0x85d0, 0x85d1, 0x85d2, 0x85d3, 0x85d4,
/* 30 */ 0x85d5, 0x85d6, 0x85d7, 0x85d8, 0x85d9, 0x85da, 0x85db, 0x85dc,
/* 38 */ 0x85dd, 0x85de, 0x85df, 0x85e0, 0x85e1, 0x85e2, 0x85e3, 0x85e4
},

/* Row 0x164 */
{
/* 00 */ 0x85e5, 0x85e6, 0x85e7, 0x85e8, 0x85e9, 0x85ea, 0x85eb, 0x85ec,
/* 08 */ 0x85ed, 0x85ee, 0x85ef, 0x85f0, 0x85f1, 0x85f2, 0x85f3, 0x85f4,
/* 10 */ 0x85f5, 0x85f6, 0x85f7, 0x85f8, 0x85f9, 0x85fa, 0x85fb, 0x85fc,
/* 18 */ 0x8640, 0x8641, 0x8642, 0x8643, 0x8644, 0x8645, 0x8646, 0x8647,
/* 20 */ 0x8648, 0x8649, 0x864a, 0x864b, 0x864c, 0x864d, 0x864e, 0x864f,
/* 28 */ 0x8650, 0x8651, 0x8652, 0x8653, 0x8654, 0x8655, 0x8656, 0x8657,
/* 30 */ 0x8658, 0x8659, 0x865a, 0x865b, 0x865c, 0x865d, 0x865e, 0x865f,
/* 38 */ 0x8660, 0x8661, 0x8662, 0x8663, 0x8664, 0x8665, 0x8666, 0x8667
},

/* Row 0x165 */
{
/* 00 */ 0x8668, 0x8669, 0x866a, 0x866b, 0x866c, 0x866d, 0x866e, 0x866f,
/* 08 */ 0x8670, 0x8671, 0x8672, 0x8673, 0x8674, 0x8675, 0x8676, 0x8677,
/* 10 */ 0x8678, 0x8679, 0x867a, 0x867b, 0x867c, 0x867d, 0x867e, 0x8680,
/* 18 */ 0x8681, 0x8682, 0x8683, 0x8684, 0x8685, 0x8686, 0x8687, 0x8688,
/* 20 */ 0x8689, 0x868a, 0x868b, 0x868c, 0x868d, 0x868e, 0x868f, 0x8690,
/* 28 */ 0x8691, 0x8692, 0x8693, 0x8694, 0x8695, 0x8696, 0x8697, 0x8698,
/* 30 */ 0x8699, 0x869a, 0x869b, 0x869c, 0x869d, 0x869e, 0x869f, 0x86a0,
/* 38 */ 0x86a1, 0x86a2, 0x86a3, 0x86a4, 0x86a5, 0x86a6, 0x86a7, 0x86a8
},

/* Row 0x166 */
{
/* 00 */ 0x86a9, 0x86aa, 0x86ab, 0x86ac, 0x86ad, 0x86ae, 0x86af, 0x86b0,
/* 08 */ 0x86b1, 0x86b2, 0x86b3, 0x86b4, 0x86b5, 0x86b6, 0x86b7, 0x86b8,
/* 10 */ 0x86b9, 0x86ba, 0x86bb, 0x86bc, 0x86bd, 0x86be, 0x86bf, 0x86c0,
/* 18 */ 0x86c1, 0x86c2, 0x86c3, 0x86c4, 0x86c5, 0x86c6, 0x86c7, 0x86c8,
/* 20 */ 0x86c9, 0x86ca, 0x86cb, 0x86cc, 0x86cd, 0x86ce, 0x86cf, 0x86d0,
/* 28 */ 0x86d1, 0x86d2, 0x86d3, 0x86d4, 0x86d5, 0x86d6, 0x86d7, 0x86d8,
/* 30 */ 0x86d9, 0x86da, 0x86db, 0x86dc, 0x86dd, 0x86de, 0x86df, 0x86e0,
/* 38 */ 0x86e1, 0x86e2, 0x86e3, 0x86e4, 0x86e5, 0x86e6, 0x86e7, 0x86e8
},

/* Row 0x167 */
{
/* 00 */ 0x86e9, 0x86ea, 0x86eb, 0x86ec, 0x86ed, 0x86ee, 0x86ef, 0x86f0,
/* 08 */ 0x86f1, 0x86f2, 0x86f3, 0x86f4, 0x86f5, 0x86f6, 0x86f7, 0x86f8,
/* 10 */ 0x86f9, 0x86fa, 0x86fb, 0x86fc, 0x8740, 0x8741, 0x8742, 0x8743,
/* 18 */ 0x8744, 0x8745, 0x8746, 0x8747, 0x8748, 0x8749, 0x874a, 0x874b,
/* 20 */ 0x874c, 0x874d, 0x874e, 0x874f, 0x8750, 0x8751, 0x8752, 0x8753,
/* 28 */ 0x8754, 0x8755, 0x8756, 0x8757, 0x8758, 0x8759, 0x875a, 0x875b,
/* 30 */ 0x875c, 0x875d, 0x875e, 0x875f, 0x8760, 0x8761, 0x8762, 0x8763,
/* 38 */ 0x8764, 0x8765, 0x8766, 0x8767, 0x8768, 0x8769, 0x876a, 0x876b
},

/* Row 0x168 */
{
/* 00 */ 0x876c, 0x876d, 0x876e, 0x876f, 0x8770, 0x8771, 0x8772, 0x8773,
/* 08 */ 0x8774, 0x8775, 0x8776, 0x8777, 0x8778, 0x8779, 0x877a, 0x877b,
/* 10 */ 0x877c, 0x877d, 0x877e, 0x8780, 0x8781, 0x8782, 0x8783, 0x8784,
/* 18 */ 0x8785, 0x8786, 0x8787, 0x8788, 0x8789, 0x878a, 0x878b, 0x878c,
/* 20 */ 0x878d, 0x878e, 0x878f, 0x8790, 0x8791, 0x8792, 0x8793, 0x8794,
/* 28 */ 0x8795, 0x8796, 0x8797, 0x8798, 0x8799, 0x879a, 0x879b, 0x879c,
/* 30 */ 0x879d, 0x879e, 0x879f, 0x87a0, 0x87a1, 0x87a2, 0x87a3, 0x87a4,
/* 38 */ 0x87a5, 0x87a6, 0x87a7, 0x87a8, 0x87a9, 0x87aa, 0x87ab, 0x87ac
},

/* Row 0x169 */
{
/* 00 */ 0x87ad, 0x87ae, 0x87af, 0x87b0, 0x87b1, 0x87b2, 0x87b3, 0x87b4,
/* 08 */ 0x87b5, 0x87b6, 0x87b7, 0x87b8, 0x87b9, 0x87ba, 0x87bb, 0x87bc,
/* 10 */ 0x87bd, 0x87be, 0x87bf, 0x87c0, 0x87c1, 0x87c2, 0x87c3, 0x87c4,
/* 18 */ 0x87c5, 0x87c6, 0x87c7, 0x87c8, 0x87c9, 0x87ca, 0x87cb, 0x87cc,
/* 20 */ 0x87cd, 0x87ce, 0x87cf, 0x87d0, 0x87d1, 0x87d2, 0x87d3, 0x87d4,
/* 28 */ 0x87d5, 0x87d6, 0x87d7, 0x87d8, 0x87d9, 0x87da, 0x87db, 0x87dc,
/* 30 */ 0x87dd, 0x87de, 0x87df, 0x87e0, 0x87e1, 0x87e2, 0x87e3, 0x87e4,
/* 38 */ 0x87e5, 0x87e6, 0x87e7, 0x87e8, 0x87e9, 0x87ea, 0x87eb, 0x87ec
},

/* Row 0x16a */
{
/* 00 */ 0x87ed, 0x87ee, 0x87ef, 0x87f0, 0x87f1, 0x87f2, 0x87f3, 0x87f4,
/* 08 */ 0x87f5, 0x87f6, 0x87f7, 0x87f8, 0x87f9, 0x87fa, 0x87fb, 0x87fc,
/* 10 */ 0x8840, 0x8841, 0x8842, 0x8843, 0x8844, 0x8845, 0x8846, 0x8847,
/* 18 */ 0x8848, 0x8849, 0x884a, 0x884b, 0x884c, 0x884d, 0x884e, 0x884f,
/* 20 */ 0x8850, 0x8851, 0x8852, 0x8853, 0x8854, 0x8855, 0x8856, 0x8857,
/* 28 */ 0x8858, 0x8859, 0x885a, 0x885b, 0x885c, 0x885d, 0x885e, 0x885f,
/* 30 */ 0x8860, 0x8861, 0x8862, 0x8863, 0x8864, 0x8865, 0x8866, 0x8867,
/* 38 */ 0x8868, 0x8869, 0x886a, 0x886b, 0x886c, 0x886d, 0x886e, 0x886f
},

/* Row 0x16b */
{
/* 00 */ 0x8870, 0x8871, 0x8872, 0x8873, 0x8874, 0x8875, 0x8876, 0x8877,
/* 08 */ 0x8878, 0x8879, 0x887a, 0x887b, 0x887c, 0x887d, 0x887e, 0x8880,
/* 10 */ 0x8881, 0x8882, 0x8883, 0x8884, 0x8885, 0x8886, 0x8887, 0x8888,
/* 18 */ 0x8889, 0x888a, 0x888b, 0x888c, 0x888d, 0x888e, 0x888f, 0x8890,
/* 20 */ 0x8891, 0x8892, 0x8893, 0x8894, 0x8895, 0x8896, 0x8897, 0x8898,
/* 28 */ 0x8899, 0x889a, 0x889b, 0x889c, 0x889d, 0x889e, 0x9873, 0x9874,
/* 30 */ 0x9875, 0x9876, 0x9877, 0x9878, 0x9879, 0x987a, 0x987b, 0x987c,
/* 38 */ 0x987d, 0x987e, 0x9880, 0x9881, 0x9882, 0x9883, 0x9884, 0x9885
},

/* Row 0x16c */
{
/* 00 */ 0x9886, 0x9887, 0x9888, 0x9889, 0x988a, 0x988b, 0x988c, 0x988d,
/* 08 */ 0x988e, 0x988f, 0x9890, 0x9891, 0x9892, 0x9893, 0x9894, 0x9895,
/* 10 */ 0x9896, 0x9897, 0x9898, 0x9899, 0x989a, 0x989b, 0x989c, 0x989d,
/* 18 */ 0x989e, 0xeaa5, 0xeaa6, 0xeaa7, 0xeaa8, 0xeaa9, 0xeaaa, 0xeaab,
/* 20 */ 0xeaac, 0xeaad, 0xeaae, 0xeaaf, 0xeab0, 0xeab1, 0xeab2, 0xeab3,
/* 28 */ 0xeab4, 0xeab5, 0xeab6, 0xeab7, 0xeab8, 0xeab9, 0xeaba, 0xeabb,
/* 30 */ 0xeabc, 0xeabd, 0xeabe, 0xeabf, 0xeac0, 0xeac1, 0xeac2, 0xeac3,
/* 38 */ 0xeac4, 0xeac5, 0xeac6, 0xeac7, 0xeac8, 0xeac9, 0xeaca, 0xeacb
},

/* Row 0x16d */
{
/* 00 */ 0xeacc, 0xeacd, 0xeace, 0xeacf, 0xead0, 0xead1, 0xead2, 0xead3,
/* 08 */ 0xead4, 0xead5, 0xead6, 0xead7, 0xead8, 0xead9, 0xeada, 0xeadb,
/* 10 */ 0xeadc, 0xeadd, 0xeade, 0xeadf, 0xeae0, 0xeae1, 0xeae2, 0xeae3,
/* 18 */ 0xeae4, 0xeae5, 0xeae6, 0xeae7, 0xeae8, 0xeae9, 0xeaea, 0xeaeb,
/* 20 */ 0xeaec, 0xeaed, 0xeaee, 0xeaef, 0xeaf0, 0xeaf1, 0xeaf2, 0xeaf3,
/* 28 */ 0xeaf4, 0xeaf5, 0xeaf6, 0xeaf7, 0xeaf8, 0xeaf9, 0xeafa, 0xeafb,
/* 30 */ 0xeafc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x16e */
{
/* 00 */    BAD, 0x8149,    BAD, 0x8194, 0x8190, 0x8193, 0x8195,    BAD,
/* 08 */ 0x8169, 0x816a, 0x8196, 0x817b, 0x8143,    BAD, 0x8144, 0x815e,
/* 10 */ 0x824f, 0x8250, 0x8251, 0x8252, 0x8253, 0x8254, 0x8255, 0x8256,
/* 18 */ 0x8257, 0x8258, 0x8146, 0x8147, 0x8183, 0x8181, 0x8184, 0x8148,
/* 20 */ 0x8197, 0x8260, 0x8261, 0x8262, 0x8263, 0x8264, 0x8265, 0x8266,
/* 28 */ 0x8267, 0x8268, 0x8269, 0x826a, 0x826b, 0x826c, 0x826d, 0x826e,
/* 30 */ 0x826f, 0x8270, 0x8271, 0x8272, 0x8273, 0x8274, 0x8275, 0x8276,
/* 38 */ 0x8277, 0x8278, 0x8279, 0x816d, 0x815f, 0x816e, 0x814f, 0x8151
},

/* Row 0x16f */
{
/* 00 */ 0x814d, 0x8281, 0x8282, 0x8283, 0x8284, 0x8285, 0x8286, 0x8287,
/* 08 */ 0x8288, 0x8289, 0x828a, 0x828b, 0x828c, 0x828d, 0x828e, 0x828f,
/* 10 */ 0x8290, 0x8291, 0x8292, 0x8293, 0x8294, 0x8295, 0x8296, 0x8297,
/* 18 */ 0x8298, 0x8299, 0x829a, 0x816f, 0x8162, 0x8170, 0x8160,    BAD,
/* 20 */    BAD, 0x00a1, 0x00a2, 0x00a3, 0x00a4, 0x00a5, 0x00a6, 0x00a7,
/* 28 */ 0x00a8, 0x00a9, 0x00aa, 0x00ab, 0x00ac, 0x00ad, 0x00ae, 0x00af,
/* 30 */ 0x00b0, 0x00b1, 0x00b2, 0x00b3, 0x00b4, 0x00b5, 0x00b6, 0x00b7,
/* 38 */ 0x00b8, 0x00b9, 0x00ba, 0x00bb, 0x00bc, 0x00bd, 0x00be, 0x00bf
},

/* Row 0x170 */
{
/* 00 */ 0x00c0, 0x00c1, 0x00c2, 0x00c3, 0x00c4, 0x00c5, 0x00c6, 0x00c7,
/* 08 */ 0x00c8, 0x00c9, 0x00ca, 0x00cb, 0x00cc, 0x00cd, 0x00ce, 0x00cf,
/* 10 */ 0x00d0, 0x00d1, 0x00d2, 0x00d3, 0x00d4, 0x00d5, 0x00d6, 0x00d7,
/* 18 */ 0x00d8, 0x00d9, 0x00da, 0x00db, 0x00dc, 0x00dd, 0x00de, 0x00df,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x171 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x8150,    BAD, 0x818f,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x172 */
{
/* 00 */ 0x0080, 0x0081, 0x0082, 0x0083, 0x0084, 0x0085, 0x0086, 0x0087,
/* 08 */ 0x0088, 0x0089, 0x008a, 0x008b, 0x008c, 0x008d, 0x008e, 0x008f,
/* 10 */ 0x0090, 0x0091, 0x0092, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097,
/* 18 */ 0x0098, 0x0099, 0x009a, 0x009b, 0x009c, 0x009d, 0x009e, 0x009f,
/* 20 */    BAD,    BAD, 0xa1f1, 0xa1f2,    BAD,    BAD,    BAD, 0xa1f8,
/* 28 */ 0xa1af,    BAD,    BAD,    BAD, 0xa2cc,    BAD,    BAD,    BAD,
/* 30 */ 0xa1eb, 0xa1de,    BAD,    BAD, 0xa1ad,    BAD, 0xa2f9,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x173 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1df,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1e0,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x174 */
{
/* 00 */ 0x0060, 0xa1ad, 0x005e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xa1af,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x005f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x175 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xa6a1, 0xa6a2, 0xa6a3, 0xa6a4, 0xa6a5, 0xa6a6, 0xa6a7,
/* 18 */ 0xa6a8, 0xa6a9, 0xa6aa, 0xa6ab, 0xa6ac, 0xa6ad, 0xa6ae, 0xa6af,
/* 20 */ 0xa6b0, 0xa6b1,    BAD, 0xa6b2, 0xa6b3, 0xa6b4, 0xa6b5, 0xa6b6,
/* 28 */ 0xa6b7, 0xa6b8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xa6c1, 0xa6c2, 0xa6c3, 0xa6c4, 0xa6c5, 0xa6c6, 0xa6c7,
/* 38 */ 0xa6c8, 0xa6c9, 0xa6ca, 0xa6cb, 0xa6cc, 0xa6cd, 0xa6ce, 0xa6cf
},

/* Row 0x176 */
{
/* 00 */ 0xa6d0, 0xa6d1,    BAD, 0xa6d2, 0xa6d3, 0xa6d4, 0xa6d5, 0xa6d6,
/* 08 */ 0xa6d7, 0xa6d8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x177 */
{
/* 00 */    BAD, 0xa7a7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xa7a1, 0xa7a2, 0xa7a3, 0xa7a4, 0xa7a5, 0xa7a6, 0xa7a8, 0xa7a9,
/* 18 */ 0xa7aa, 0xa7ab, 0xa7ac, 0xa7ad, 0xa7ae, 0xa7af, 0xa7b0, 0xa7b1,
/* 20 */ 0xa7b2, 0xa7b3, 0xa7b4, 0xa7b5, 0xa7b6, 0xa7b7, 0xa7b8, 0xa7b9,
/* 28 */ 0xa7ba, 0xa7bb, 0xa7bc, 0xa7bd, 0xa7be, 0xa7bf, 0xa7c0, 0xa7c1,
/* 30 */ 0xa7d1, 0xa7d2, 0xa7d3, 0xa7d4, 0xa7d5, 0xa7d6, 0xa7d8, 0xa7d9,
/* 38 */ 0xa7da, 0xa7db, 0xa7dc, 0xa7dd, 0xa7de, 0xa7df, 0xa7e0, 0xa7e1
},

/* Row 0x178 */
{
/* 00 */ 0xa7e2, 0xa7e3, 0xa7e4, 0xa7e5, 0xa7e6, 0xa7e7, 0xa7e8, 0xa7e9,
/* 08 */ 0xa7ea, 0xa7eb, 0xa7ec, 0xa7ed, 0xa7ee, 0xa7ef, 0xa7f0, 0xa7f1,
/* 10 */    BAD, 0xa7d7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x179 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xa1be,    BAD,    BAD,    BAD,    BAD, 0xa1bd, 0xa1c2,    BAD,
/* 18 */ 0xa1c6, 0xa1c7,    BAD,    BAD, 0xa1c8, 0xa1c9,    BAD,    BAD,
/* 20 */ 0xa2f7, 0xa2f8,    BAD,    BAD,    BAD, 0xa1c5, 0xa1c4,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xa2f3,    BAD, 0xa1ec, 0xa1ed,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xa2a8,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17a */
{
/* 00 */    BAD,    BAD,    BAD, 0xa1ee,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xa2f2,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xa2ab, 0xa2ac, 0xa2aa, 0xa2ad,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa2cd,    BAD, 0xa2ce,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17d */
{
/* 00 */ 0xa2cf,    BAD, 0xa2df, 0xa2d0,    BAD,    BAD,    BAD, 0xa2e0,
/* 08 */ 0xa2ba,    BAD,    BAD, 0xa2bb,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa1dd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xa2e5,    BAD,    BAD, 0xa2e7, 0xa1e7,    BAD,
/* 20 */ 0xa2dc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa2ca,
/* 28 */ 0xa2cb, 0xa2c1, 0xa2c0, 0xa2e9, 0xa2ea,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xa1e8, 0xa2e8,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa2e6,    BAD,    BAD
},

/* Row 0x17e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa2e2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xa1e2, 0xa2e1,    BAD,    BAD,    BAD,    BAD, 0xa1e5, 0xa1e6,
/* 28 */    BAD,    BAD, 0xa2e3, 0xa2e4,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17f */
{
/* 00 */    BAD,    BAD, 0xa2be, 0xa2bf,    BAD,    BAD, 0xa2bc, 0xa2bd,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa2dd,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x180 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa2de,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x181 */
{
/* 00 */ 0xa8a1, 0xa8ac, 0xa8a2, 0xa8ad,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xa8a3,    BAD,    BAD, 0xa8ae,
/* 10 */ 0xa8a4,    BAD,    BAD, 0xa8af, 0xa8a6,    BAD,    BAD, 0xa8b1,
/* 18 */ 0xa8a5,    BAD,    BAD, 0xa8b0, 0xa8a7, 0xa8bc,    BAD,    BAD,
/* 20 */ 0xa8b7,    BAD,    BAD, 0xa8b2, 0xa8a9, 0xa8be,    BAD,    BAD,
/* 28 */ 0xa8b9,    BAD,    BAD, 0xa8b4, 0xa8a8,    BAD,    BAD, 0xa8b8,
/* 30 */ 0xa8bd,    BAD,    BAD, 0xa8b3, 0xa8aa,    BAD,    BAD, 0xa8ba,
/* 38 */ 0xa8bf,    BAD,    BAD, 0xa8b5, 0xa8ab,    BAD,    BAD, 0xa8bb
},

/* Row 0x182 */
{
/* 00 */    BAD,    BAD, 0xa8c0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xa8b6,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x183 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xa2a3, 0xa2a2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xa2a5, 0xa2a4,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xa2a7, 0xa2a6,    BAD,    BAD
},

/* Row 0x184 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa2a1, 0xa1fe,
/* 08 */    BAD,    BAD,    BAD, 0xa1fb,    BAD,    BAD, 0xa1fd, 0xa1fc,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa2fe,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x185 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1fa, 0xa1f9,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x186 */
{
/* 00 */ 0xa1ea,    BAD, 0xa1e9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xa2f6,    BAD,    BAD, 0xa2f5,    BAD, 0xa2f4,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x187 */
{
/* 00 */ 0xa1a1, 0xa1a2, 0xa1a3, 0xa1b7,    BAD, 0xa1b9, 0xa1ba, 0xa1bb,
/* 08 */ 0xa1d2, 0xa1d3, 0xa1d4, 0xa1d5, 0xa1d6, 0xa1d7, 0xa1d8, 0xa1d9,
/* 10 */ 0xa1da, 0xa1db, 0xa2a9, 0xa2ae, 0xa1cc, 0xa1cd,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x188 */
{
/* 00 */    BAD, 0xa4a1, 0xa4a2, 0xa4a3, 0xa4a4, 0xa4a5, 0xa4a6, 0xa4a7,
/* 08 */ 0xa4a8, 0xa4a9, 0xa4aa, 0xa4ab, 0xa4ac, 0xa4ad, 0xa4ae, 0xa4af,
/* 10 */ 0xa4b0, 0xa4b1, 0xa4b2, 0xa4b3, 0xa4b4, 0xa4b5, 0xa4b6, 0xa4b7,
/* 18 */ 0xa4b8, 0xa4b9, 0xa4ba, 0xa4bb, 0xa4bc, 0xa4bd, 0xa4be, 0xa4bf,
/* 20 */ 0xa4c0, 0xa4c1, 0xa4c2, 0xa4c3, 0xa4c4, 0xa4c5, 0xa4c6, 0xa4c7,
/* 28 */ 0xa4c8, 0xa4c9, 0xa4ca, 0xa4cb, 0xa4cc, 0xa4cd, 0xa4ce, 0xa4cf,
/* 30 */ 0xa4d0, 0xa4d1, 0xa4d2, 0xa4d3, 0xa4d4, 0xa4d5, 0xa4d6, 0xa4d7,
/* 38 */ 0xa4d8, 0xa4d9, 0xa4da, 0xa4db, 0xa4dc, 0xa4dd, 0xa4de, 0xa4df
},

/* Row 0x189 */
{
/* 00 */ 0xa4e0, 0xa4e1, 0xa4e2, 0xa4e3, 0xa4e4, 0xa4e5, 0xa4e6, 0xa4e7,
/* 08 */ 0xa4e8, 0xa4e9, 0xa4ea, 0xa4eb, 0xa4ec, 0xa4ed, 0xa4ee, 0xa4ef,
/* 10 */ 0xa4f0, 0xa4f1, 0xa4f2, 0xa4f3,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xa1ab, 0xa1ac, 0xa1ab, 0xa1ac, 0xa1b5, 0xa1b6,    BAD,
/* 20 */    BAD, 0xa5a1, 0xa5a2, 0xa5a3, 0xa5a4, 0xa5a5, 0xa5a6, 0xa5a7,
/* 28 */ 0xa5a8, 0xa5a9, 0xa5aa, 0xa5ab, 0xa5ac, 0xa5ad, 0xa5ae, 0xa5af,
/* 30 */ 0xa5b0, 0xa5b1, 0xa5b2, 0xa5b3, 0xa5b4, 0xa5b5, 0xa5b6, 0xa5b7,
/* 38 */ 0xa5b8, 0xa5b9, 0xa5ba, 0xa5bb, 0xa5bc, 0xa5bd, 0xa5be, 0xa5bf
},

/* Row 0x18a */
{
/* 00 */ 0xa5c0, 0xa5c1, 0xa5c2, 0xa5c3, 0xa5c4, 0xa5c5, 0xa5c6, 0xa5c7,
/* 08 */ 0xa5c8, 0xa5c9, 0xa5ca, 0xa5cb, 0xa5cc, 0xa5cd, 0xa5ce, 0xa5cf,
/* 10 */ 0xa5d0, 0xa5d1, 0xa5d2, 0xa5d3, 0xa5d4, 0xa5d5, 0xa5d6, 0xa5d7,
/* 18 */ 0xa5d8, 0xa5d9, 0xa5da, 0xa5db, 0xa5dc, 0xa5dd, 0xa5de, 0xa5df,
/* 20 */ 0xa5e0, 0xa5e1, 0xa5e2, 0xa5e3, 0xa5e4, 0xa5e5, 0xa5e6, 0xa5e7,
/* 28 */ 0xa5e8, 0xa5e9, 0xa5ea, 0xa5eb, 0xa5ec, 0xa5ed, 0xa5ee, 0xa5ef,
/* 30 */ 0xa5f0, 0xa5f1, 0xa5f2, 0xa5f3, 0xa5f4, 0xa5f5, 0xa5f6,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xa1a6, 0xa1bc, 0xa1b3, 0xa1b4,    BAD
},

/* Row 0x18b */
{
/* 00 */ 0xb0ec, 0xc3fa,    BAD, 0xbcb7,    BAD,    BAD,    BAD, 0xcbfc,
/* 08 */ 0xbee6, 0xbbb0, 0xbee5, 0xb2bc,    BAD, 0xc9d4, 0xcdbf,    BAD,
/* 10 */ 0xd0a2, 0xb1af,    BAD,    BAD, 0xb3ee, 0xd0a3, 0xc0a4, 0xd2c2,
/* 18 */ 0xb5d6, 0xcaba,    BAD,    BAD,    BAD,    BAD, 0xbee7,    BAD,
/* 20 */    BAD, 0xcebe,    BAD,    BAD,    BAD,    BAD, 0xcac2,    BAD,
/* 28 */    BAD,    BAD, 0xd0a4,    BAD,    BAD, 0xc3e6,    BAD,    BAD,
/* 30 */    BAD, 0xd0a5, 0xb6fa,    BAD,    BAD,    BAD, 0xd0a6,    BAD,
/* 38 */ 0xb4dd, 0xc3b0,    BAD, 0xbce7, 0xd0a7,    BAD,    BAD, 0xd0a8
},

/* Row 0x18c */
{
/* 00 */    BAD,    BAD, 0xd0a9, 0xc7b5,    BAD, 0xb5d7,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xc7b7,    BAD, 0xc6e3, 0xb8c3, 0xcbb3,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9c9, 0xd0aa, 0xbee8,
/* 18 */ 0xd0ab, 0xb2b5,    BAD,    BAD,    BAD, 0xb6e5, 0xb8f0, 0xcce9,
/* 20 */    BAD,    BAD, 0xd6a6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xcdf0,    BAD, 0xc6fd,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb4a5,    BAD
},

/* Row 0x18d */
{
/* 00 */ 0xb5b5,    BAD, 0xd0ac,    BAD,    BAD, 0xd0ad, 0xcebb,    BAD,
/* 08 */ 0xcdbd, 0xc1e8, 0xd0af, 0xbbf6, 0xc6f3,    BAD, 0xd0b2,    BAD,
/* 10 */    BAD, 0xb1be, 0xb8df,    BAD, 0xb8de, 0xb0e6,    BAD,    BAD,
/* 18 */ 0xcfcb, 0xcfca,    BAD, 0xbab3, 0xb0a1,    BAD, 0xd0b3, 0xd0b4,
/* 20 */ 0xd0b5, 0xcbb4, 0xd0b6,    BAD, 0xb8f2, 0xb0e7, 0xcbf2,    BAD,
/* 28 */ 0xb5fc,    BAD,    BAD, 0xb5fd, 0xb5fe, 0xc4e2, 0xcebc,    BAD,
/* 30 */ 0xd0b7,    BAD,    BAD, 0xd0b8,    BAD,    BAD, 0xd0b9,    BAD,
/* 38 */    BAD,    BAD, 0xbfcd,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x18e */
{
/* 00 */ 0xbdba, 0xbfce, 0xd0be,    BAD, 0xd0bc,    BAD, 0xd0bd, 0xb5d8,
/* 08 */    BAD,    BAD, 0xbaa3, 0xb2f0,    BAD, 0xd0bb, 0xd0ba, 0xcaa9,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xbbc6, 0xbbc5, 0xc2be, 0xd0bf,
/* 18 */ 0xc9d5, 0xc0e7,    BAD,    BAD,    BAD, 0xa1b8, 0xd0c0, 0xd0c2,
/* 20 */    BAD,    BAD,    BAD, 0xc2e5, 0xcee1, 0xb0ca,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd0c1, 0xb2be,    BAD,
/* 30 */ 0xb6c4,    BAD, 0xc3e7,    BAD,    BAD,    BAD, 0xb7ef, 0xd0c3,
/* 38 */    BAD,    BAD,    BAD, 0xc7a4,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x18f */
{
/* 00 */    BAD, 0xb4eb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xd0c4, 0xb0cb,    BAD,    BAD, 0xb8e0, 0xb4ec, 0xc9fa,
/* 10 */ 0xc8b2, 0xb5d9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xb2f1,    BAD, 0xd0e7, 0xc5c1,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc7ec,
/* 30 */ 0xd0c6,    BAD,    BAD,    BAD, 0xc8bc,    BAD, 0xcee2,    BAD,
/* 38 */ 0xbfad,    BAD, 0xbbc7,    BAD, 0xbbf7, 0xb2c0,    BAD,    BAD
},

/* Row 0x190 */
{
/* 00 */    BAD,    BAD,    BAD, 0xc4d1,    BAD,    BAD, 0xc3a2, 0xd0ca,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb0cc, 0xc4e3, 0xbdbb,
/* 10 */ 0xbab4, 0xcda4,    BAD, 0xc2ce,    BAD, 0xb2bf,    BAD, 0xd0c9,
/* 18 */    BAD, 0xcdbe, 0xd0c5, 0xd0c7, 0xbaee, 0xd0c8, 0xd5a4,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xd0d0,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd0d3,
/* 30 */ 0xd0d1,    BAD,    BAD, 0xb2c2,    BAD, 0xcabb, 0xd0cb,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xd0cf, 0xb8f3,    BAD,    BAD, 0xbbc8
},

/* Row 0x191 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb4a6,    BAD,    BAD, 0xd0d4,    BAD,
/* 08 */ 0xd0cc,    BAD,    BAD, 0xcee3,    BAD, 0xbbf8,    BAD, 0xd0cd,
/* 10 */    BAD, 0xd0d2,    BAD,    BAD,    BAD,    BAD, 0xd0d5,    BAD,
/* 18 */ 0xd0ce,    BAD,    BAD, 0xb6a1,    BAD, 0xb0cd,    BAD,    BAD,
/* 20 */ 0xb6a2, 0xb2c1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xd5a5,    BAD, 0xcbf9, 0xc9ee, 0xb8f4,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xbfaf, 0xceb7,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcad8
},

/* Row 0x192 */
{
/* 00 */    BAD,    BAD, 0xb7b8, 0xc2a5, 0xb2e4,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xbdd3,    BAD,    BAD,    BAD, 0xd0d9,    BAD,
/* 10 */ 0xd0de, 0xd0dc,    BAD,    BAD, 0xd0d7,    BAD,    BAD, 0xc2af,
/* 18 */ 0xd0da,    BAD, 0xd0dd, 0xd0db,    BAD, 0xcadd,    BAD, 0xd0d8,
/* 20 */    BAD, 0xbfae,    BAD, 0xcbf3, 0xd0df, 0xd0e0,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbda4, 0xd0ed,
/* 30 */    BAD,    BAD,    BAD, 0xc7d0,    BAD, 0xc9b6, 0xd0e8,    BAD,
/* 38 */ 0xcaf0,    BAD, 0xb2b6,    BAD,    BAD,    BAD, 0xd0ec,    BAD
},

/* Row 0x193 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd0e6, 0xd0ef,    BAD,
/* 08 */    BAD, 0xc1d2,    BAD, 0xb8c4,    BAD, 0xc7dc,    BAD, 0xe0c7,
/* 10 */    BAD, 0xd0ee, 0xc5dd,    BAD, 0xd0e3,    BAD, 0xb8f6,    BAD,
/* 18 */    BAD, 0xb8f5, 0xd0e1,    BAD,    BAD,    BAD,    BAD, 0xbcda,
/* 20 */    BAD, 0xd0e9,    BAD, 0xcaef, 0xc3cd, 0xd0e5, 0xb7f1,    BAD,
/* 28 */ 0xd0e2, 0xd0ea, 0xd0e4, 0xced1, 0xd0eb, 0xcfc1,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb6e6,    BAD,
/* 38 */    BAD, 0xb7f0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x194 */
{
/* 00 */    BAD,    BAD,    BAD, 0xd0f0,    BAD,    BAD,    BAD, 0xd0f1,
/* 08 */ 0xd0f5, 0xb0ce,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcad0,
/* 10 */ 0xd0f4,    BAD,    BAD,    BAD,    BAD, 0xd0f3, 0xd0f7,    BAD,
/* 18 */    BAD,    BAD, 0xd0f6,    BAD, 0xc4e4,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7f2,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xd0f8,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xbcc5,    BAD, 0xc2a6, 0xc4e5, 0xb6f6,    BAD,
/* 38 */ 0xd0f9,    BAD,    BAD,    BAD,    BAD, 0xb5b6,    BAD,    BAD
},

/* Row 0x195 */
{
/* 00 */ 0xd0fa,    BAD,    BAD,    BAD,    BAD, 0xd0fc,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcbb5,    BAD,    BAD,
/* 10 */    BAD, 0xb7e6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xbbb1, 0xc8f7, 0xd0fb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xbac5, 0xcdc3,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xd0fe, 0xd1a3, 0xd0fd, 0xbac4,    BAD, 0xbdfd,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7b9,    BAD
},

/* Row 0x196 */
{
/* 00 */    BAD,    BAD, 0xd1a4,    BAD,    BAD, 0xb6cf,    BAD,    BAD,
/* 08 */    BAD, 0xd1a1, 0xd1a2,    BAD,    BAD, 0xc6af,    BAD, 0xc1fc,
/* 10 */    BAD, 0xb6a3,    BAD,    BAD,    BAD, 0xcbcd, 0xd1a5,    BAD,
/* 18 */    BAD,    BAD, 0xcebd,    BAD,    BAD,    BAD, 0xd1a6,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xd1a9,    BAD, 0xd1a7,    BAD, 0xc1ce,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd1a8, 0xd1aa,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd1ac,    BAD,    BAD,
/* 38 */    BAD, 0xd1ab,    BAD, 0xcac8,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x197 */
{
/* 00 */ 0xb5b7, 0xd1ae, 0xd1af,    BAD, 0xb2af,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xd1ad,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xbcf4,    BAD, 0xd1b2, 0xd1b1, 0xd1b0,    BAD,
/* 18 */ 0xd0d6,    BAD, 0xd1b3,    BAD,    BAD,    BAD,    BAD, 0xbdfe,
/* 20 */    BAD, 0xd1b4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xcda5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xccd9,    BAD,    BAD,    BAD,    BAD, 0xd1b6,
/* 38 */    BAD,    BAD, 0xd1b5, 0xd1b8, 0xd1b7,    BAD,    BAD, 0xd1b9
},

/* Row 0x198 */
{
/* 00 */ 0xd1ba, 0xb0f4,    BAD, 0xb8b5, 0xb7bb, 0xbdbc, 0xc3fb, 0xb6a4,
/* 08 */ 0xc0e8, 0xb8f7,    BAD, 0xb9ee, 0xd1bc, 0xccc8, 0xc5c6,    BAD,
/* 10 */ 0xbbf9,    BAD, 0xd1bb,    BAD, 0xd1bd,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xc5de,    BAD, 0xb3f5,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xd1be,    BAD,    BAD, 0xc6fe,    BAD,    BAD,
/* 28 */ 0xc1b4, 0xd1c0, 0xd1c1, 0xc8ac, 0xb8f8, 0xcfbb, 0xd1c2,    BAD,
/* 30 */    BAD, 0xb6a6,    BAD,    BAD,    BAD, 0xcabc, 0xc2b6, 0xb6f1,
/* 38 */ 0xc5b5,    BAD,    BAD,    BAD, 0xb7f3,    BAD,    BAD,    BAD
},

/* Row 0x199 */
{
/* 00 */ 0xd1c3,    BAD, 0xd1c4,    BAD,    BAD, 0xc6e2, 0xb1df,    BAD,
/* 08 */    BAD, 0xd1c7, 0xbafd,    BAD, 0xd1c6, 0xbac6,    BAD, 0xd1c8,
/* 10 */ 0xe6ee, 0xd1c9, 0xcbc1, 0xd1ca,    BAD, 0xd1cb, 0xd1cc, 0xbee9,
/* 18 */    BAD, 0xbccc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xb4a7,    BAD, 0xd1cf,    BAD, 0xd1cd, 0xccbd, 0xd1ce,    BAD,
/* 28 */ 0xc9da, 0xd1d0, 0xd1d1, 0xd1d2, 0xc5df,    BAD,    BAD,    BAD,
/* 30 */ 0xd1d6, 0xd1d4, 0xd1d5, 0xd1d3, 0xbae3, 0xd1d7, 0xccea, 0xcee4,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd1d8,    BAD,    BAD
},

/* Row 0x19a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xc0a8, 0xd1d9, 0xbdda,    BAD,
/* 08 */    BAD, 0xd1da,    BAD, 0xc3fc, 0xcebf, 0xc5e0,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd2c5,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xd1db, 0xf4a5, 0xb6c5,    BAD,    BAD,
/* 20 */ 0xd1dc, 0xcbde,    BAD,    BAD,    BAD,    BAD, 0xbde8, 0xc2fc,
/* 28 */    BAD, 0xd1de, 0xc6e4,    BAD,    BAD, 0xd1df,    BAD,    BAD,
/* 30 */ 0xd1e0, 0xb3ae,    BAD,    BAD,    BAD, 0xd1e1, 0xb6a7,    BAD,
/* 38 */ 0xc6cc, 0xb1fa, 0xbdd0,    BAD,    BAD, 0xc8a1, 0xd1e2,    BAD
},

/* Row 0x19b */
{
/* 00 */ 0xc5e1,    BAD,    BAD, 0xbfcf, 0xd1e3,    BAD, 0xcaac, 0xc0da,
/* 08 */ 0xb4a2,    BAD, 0xb4a9, 0xd1e4,    BAD,    BAD, 0xd1e6,    BAD,
/* 10 */    BAD, 0xb7ba,    BAD,    BAD, 0xd1e5,    BAD,    BAD, 0xcef3,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xbde9,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xc8bd, 0xcacc,    BAD, 0xd1e7,
/* 28 */    BAD, 0xcdf8, 0xd1e8,    BAD,    BAD,    BAD, 0xd1e9,    BAD,
/* 30 */ 0xc5fe,    BAD,    BAD, 0xd1ea,    BAD,    BAD, 0xc0a9, 0xbafe,
/* 38 */ 0xb7f4, 0xd1eb, 0xbbc9, 0xb9ef,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x19c */
{
/* 00 */    BAD,    BAD,    BAD, 0xc4e6, 0xd1ed,    BAD,    BAD, 0xc2a7,
/* 08 */    BAD,    BAD, 0xbaef, 0xd1ee, 0xd1ef, 0xc1b0,    BAD, 0xd1ec,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd1f1,    BAD, 0xcbb6,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xb9e4,    BAD,    BAD, 0xd1f0,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xb7f5, 0xbade, 0xc7ed,    BAD,    BAD,
/* 28 */    BAD, 0xd1f4, 0xd1f2,    BAD,    BAD,    BAD,    BAD, 0xc9fb,
/* 30 */ 0xbeea, 0xd1fb, 0xb3e4, 0xd1f5, 0xd1f3, 0xc1cf,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd1f7,    BAD, 0xd1f6
},

/* Row 0x19d */
{
/* 00 */    BAD,    BAD,    BAD, 0xb3c4,    BAD,    BAD,    BAD, 0xb7e0,
/* 08 */ 0xd1fc, 0xcead,    BAD,    BAD,    BAD, 0xd1f8,    BAD,    BAD,
/* 10 */    BAD, 0xd1fd, 0xd1fa,    BAD, 0xd1f9,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xcecf,    BAD,    BAD,    BAD, 0xb8f9,
/* 20 */ 0xb2c3,    BAD,    BAD, 0xcef4,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xbdf5, 0xc5d8, 0xb9e5, 0xd2a2, 0xd2a3,    BAD,    BAD,
/* 30 */    BAD, 0xcee5,    BAD,    BAD, 0xcfab, 0xd2a5,    BAD,    BAD,
/* 38 */    BAD, 0xb8fa,    BAD,    BAD, 0xd2a4,    BAD, 0xb3af,    BAD
},

/* Row 0x19e */
{
/* 00 */    BAD, 0xd2a6,    BAD, 0xcbd6,    BAD, 0xc4bc,    BAD, 0xcda6,
/* 08 */    BAD, 0xcad9,    BAD,    BAD,    BAD, 0xd2a7,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xf0d5,    BAD,    BAD, 0xc6b0,    BAD, 0xd2a8,
/* 18 */ 0xb4aa, 0xccb3,    BAD,    BAD,    BAD, 0xbea1, 0xd2a9, 0xcae7,
/* 20 */ 0xd2ad,    BAD, 0xc0aa, 0xd2aa, 0xb6d0,    BAD, 0xd2ab, 0xb4ab,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xb7ae, 0xd2ae,    BAD, 0xd2af,    BAD,    BAD,
/* 38 */ 0xd2b0, 0xd2b1, 0xbcdb,    BAD,    BAD,    BAD, 0xb8fb, 0xccde
},

/* Row 0x19f */
{
/* 00 */    BAD, 0xcce8, 0xc6f7,    BAD,    BAD, 0xcaf1, 0xd2b2,    BAD,
/* 08 */ 0xd2b3,    BAD,    BAD,    BAD,    BAD, 0xd2b5,    BAD, 0xd2b7,
/* 10 */ 0xd2b6,    BAD,    BAD,    BAD,    BAD, 0xd2b8, 0xb2bd, 0xcbcc,
/* 18 */    BAD, 0xbafc, 0xd2b9,    BAD,    BAD, 0xc1d9,    BAD,    BAD,
/* 20 */ 0xbea2, 0xb6a9,    BAD, 0xd2ba,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xc8db,    BAD,    BAD,    BAD,    BAD, 0xd2bb,
/* 30 */    BAD, 0xd2bc,    BAD, 0xd2bd,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xd2be, 0xc9a4, 0xb6e8, 0xb0e5,    BAD,    BAD,    BAD, 0xc6bf
},

/* Row 0x1a0 */
{
/* 00 */ 0xd2bf, 0xbdbd,    BAD, 0xc0e9,    BAD, 0xd2c1, 0xd2c0, 0xbea3,
/* 08 */ 0xb8e1, 0xd2c3, 0xc8be,    BAD,    BAD, 0xd2c4,    BAD,    BAD,
/* 10 */    BAD, 0xc8dc, 0xc2b4, 0xc2ee, 0xb6a8,    BAD,    BAD, 0xc6ee,
/* 18 */ 0xc3b1,    BAD, 0xc7ee,    BAD, 0xcbce,    BAD, 0xd2c6,    BAD,
/* 20 */ 0xc0ea,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7b5,    BAD,
/* 28 */    BAD, 0xd2c7,    BAD,    BAD,    BAD,    BAD, 0xd2c8, 0xb1ac,
/* 30 */ 0xb0f5, 0xb4ed,    BAD, 0xc2a8, 0xb5d1, 0xcdf1,    BAD, 0xd2cb,
/* 38 */ 0xb2b7,    BAD,    BAD, 0xd2ca,    BAD,    BAD,    BAD, 0xb6aa
},

/* Row 0x1a1 */
{
/* 00 */    BAD,    BAD, 0xd2cc,    BAD, 0xccf1,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd2cd,    BAD,
/* 18 */ 0xced2,    BAD, 0xb8fc,    BAD,    BAD,    BAD,    BAD, 0xb8b6,
/* 20 */ 0xd2ce,    BAD,    BAD,    BAD,    BAD, 0xd2d0, 0xd2cf,    BAD,
/* 28 */ 0xbfdf, 0xb1b9,    BAD,    BAD,    BAD, 0xb1de, 0xd2d1,    BAD,
/* 30 */ 0xd2d2,    BAD,    BAD, 0xb8b7,    BAD,    BAD, 0xd2d3,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xb5ee,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1a2 */
{
/* 00 */    BAD,    BAD, 0xbbb2, 0xd2d4,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xcbf4, 0xbab5, 0xb5da, 0xcda7, 0xc1d0, 0xc8bf, 0xbcfd,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xbdc7,    BAD, 0xbce8, 0xbcf5,
/* 18 */    BAD, 0xbdf6,    BAD, 0xc8c0,    BAD,    BAD,    BAD, 0xd2d7,
/* 20 */    BAD, 0xb1c3, 0xc1d1, 0xb8fd, 0xb8c5, 0xb6e7,    BAD,    BAD,
/* 28 */ 0xd2db, 0xc3a1, 0xc2fe, 0xb6ab, 0xbea4, 0xd2dc, 0xd2da, 0xb2c4,
/* 30 */ 0xc2e6, 0xbcb8, 0xbbcb, 0xb1a6,    BAD,    BAD, 0xb3f0, 0xb9e6,
/* 38 */ 0xbbca,    BAD, 0xd2dd,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1a3 */
{
/* 00 */    BAD, 0xd2de,    BAD, 0xb5c9, 0xb3c6,    BAD,    BAD,    BAD,
/* 08 */ 0xb9e7, 0xb5c8, 0xc4df, 0xb1a5, 0xc6b1, 0xccbe, 0xb9a1, 0xcdf9,
/* 10 */ 0xc5c7, 0xb8fe,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xb7af,    BAD, 0xd2e7,    BAD, 0xb6e3,
/* 20 */ 0xcbca,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8dd,    BAD,
/* 28 */    BAD, 0xd2e6,    BAD, 0xb4de, 0xd2e1, 0xd2e2, 0xd2e4,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd2e5,    BAD,
/* 38 */ 0xb5db, 0xbfe1,    BAD, 0xcaad, 0xd2e3, 0xd2df, 0xb8e3,    BAD
},

/* Row 0x1a4 */
{
/* 00 */ 0xd2e0,    BAD, 0xcfa4,    BAD,    BAD,    BAD, 0xcaf2,    BAD,
/* 08 */ 0xc4e8, 0xb8e2, 0xb9f0,    BAD,    BAD,    BAD, 0xd2e8,    BAD,
/* 10 */    BAD, 0xc6dd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd2ec,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xbcfe,    BAD, 0xbcf6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd2ef, 0xd2ed,    BAD, 0xcca3,    BAD, 0xd2ea, 0xd2f3, 0xd2ee,
/* 38 */    BAD,    BAD,    BAD, 0xd2f1, 0xb8c6, 0xccbf,    BAD,    BAD
},

/* Row 0x1a5 */
{
/* 00 */ 0xd2f2,    BAD,    BAD,    BAD, 0xd2f4,    BAD, 0xd2f6,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xbaf0, 0xcfc2,    BAD, 0xd2eb, 0xd2e9,
/* 10 */ 0xd2f5,    BAD, 0xd2f0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xd2f8,    BAD, 0xd3a3, 0xd2fa,    BAD,    BAD,
/* 28 */ 0xd2fe,    BAD,    BAD, 0xd3a1, 0xd2fb,    BAD,    BAD, 0xd3be,
/* 30 */    BAD,    BAD, 0xbae9, 0xb3b1,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xd2f9,    BAD,    BAD,    BAD, 0xd3a5, 0xb0f6, 0xd3a4,    BAD
},

/* Row 0x1a6 */
{
/* 00 */ 0xb0a5, 0xc9ca, 0xd3a2,    BAD, 0xd2fc,    BAD,    BAD, 0xd2f7,
/* 08 */ 0xd2fd, 0xbac8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xd3a6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xb0f7, 0xd3af,    BAD,    BAD, 0xd3a7, 0xd3a8,    BAD,
/* 28 */ 0xbea5, 0xcbe9,    BAD,    BAD,    BAD, 0xd3ad, 0xd3ac,    BAD,
/* 30 */    BAD,    BAD, 0xc5af,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xd3ae,    BAD,    BAD, 0xd3ab,    BAD,    BAD
},

/* Row 0x1a7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb1b4,    BAD, 0xbab6, 0xbfb0,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3a9,
/* 10 */ 0xc5e2,    BAD,    BAD,    BAD, 0xd3aa,    BAD, 0xb0a2,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3b4, 0xcda3,
/* 30 */    BAD, 0xbea7,    BAD, 0xd3ba,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xd3b9, 0xd3b0,    BAD,    BAD,    BAD,    BAD, 0xc2c3,    BAD
},

/* Row 0x1a8 */
{
/* 00 */ 0xd3b1,    BAD,    BAD,    BAD, 0xc2ef, 0xd3b6, 0xbea6,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xd3b3,    BAD,    BAD, 0xcce4,
/* 10 */    BAD,    BAD,    BAD, 0xb7bc,    BAD,    BAD, 0xd3b7, 0xd3b8,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xd3b5, 0xd3bb,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xd3b2,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xd3c1, 0xd3c6,    BAD, 0xd3c2,    BAD
},

/* Row 0x1a9 */
{
/* 00 */ 0xd3bd,    BAD,    BAD, 0xd3c7, 0xc1b1,    BAD,    BAD, 0xd3c9,
/* 08 */    BAD, 0xb9a2, 0xd3bf, 0xc3fd,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xd3c3, 0xd3bc, 0xb4ad,    BAD, 0xb4ee, 0xb3e5, 0xd3c4, 0xd3c0,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7f6,
/* 28 */ 0xd3ca, 0xd3c8, 0xc1d3, 0xb5ca, 0xb6ac,    BAD, 0xd3c5,    BAD,
/* 30 */ 0xb6f4,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb1c4,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1aa */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xd3ce, 0xd3cc,    BAD, 0xd4a7,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd3d1,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xd3cb,    BAD, 0xd3cf,    BAD,    BAD, 0xd3cd,
/* 20 */    BAD,    BAD,    BAD, 0xbbcc, 0xd3d0,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3d3,
/* 38 */    BAD, 0xd3d8,    BAD,    BAD,    BAD, 0xd3d6, 0xd3d5,    BAD
},

/* Row 0x1ab */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc3b2,    BAD,
/* 08 */    BAD, 0xb2c5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd3d2,    BAD, 0xd3d4, 0xbea8,
/* 18 */ 0xb1b3,    BAD,    BAD, 0xd3d7,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xb2de,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3e2,
/* 30 */    BAD, 0xbefc, 0xd3de,    BAD, 0xd3dc,    BAD, 0xd3dd,    BAD,
/* 38 */ 0xd3df,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ac */
{
/* 00 */    BAD,    BAD, 0xb1bd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xc1b9,    BAD, 0xd3d9,    BAD,
/* 10 */ 0xd3da,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xb3fa,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xd3e1,    BAD,    BAD,    BAD,
/* 28 */ 0xb4ef,    BAD, 0xd3e4, 0xd3e0, 0xd3e3,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xcaae,    BAD,    BAD,    BAD,
/* 38 */ 0xc6d5,    BAD, 0xc8b8,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ad */
{
/* 00 */ 0xd3e6,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3e5, 0xb3c5,
/* 08 */    BAD,    BAD, 0xd3e7,    BAD,    BAD,    BAD,    BAD, 0xd3ea,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd3e9,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xd3e8,    BAD, 0xc7b9,    BAD,    BAD, 0xd3eb,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3ec,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xd3ee,    BAD, 0xd3ed,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xd3f0,    BAD,    BAD,    BAD
},

/* Row 0x1ae */
{
/* 00 */ 0xd3f3, 0xd3f1, 0xd3ef, 0xd3f2,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd3f4,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3f5,    BAD,
/* 10 */    BAD, 0xd3f6,    BAD, 0xd3f7,    BAD,    BAD,    BAD, 0xd3f8,
/* 18 */ 0xd1c5,    BAD, 0xbcfc, 0xbbcd,    BAD,    BAD, 0xb2f3,    BAD,
/* 20 */ 0xb0f8,    BAD,    BAD, 0xc3c4,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3f9,    BAD,
/* 30 */ 0xbaa4,    BAD, 0xb0cf, 0xbfde,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xd3fa, 0xb8c7,    BAD,    BAD, 0xb9f1,    BAD, 0xd3fc
},

/* Row 0x1af */
{
/* 00 */ 0xd3fb,    BAD,    BAD, 0xcae0, 0xd3fd,    BAD,    BAD,    BAD,
/* 08 */ 0xd4a1, 0xd3fe,    BAD, 0xd4a2,    BAD, 0xd4a3,    BAD, 0xb7f7,
/* 10 */    BAD,    BAD, 0xb1e0, 0xd4a4,    BAD,    BAD, 0xd4a6,    BAD,
/* 18 */ 0xd4a5,    BAD,    BAD,    BAD, 0xd4a8,    BAD,    BAD, 0xc5da,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd4a9, 0xb0b5,
/* 28 */ 0xbadf,    BAD,    BAD,    BAD,    BAD, 0xb7bd,    BAD,    BAD,
/* 30 */ 0xc3cf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd4aa,
/* 38 */ 0xd4ab,    BAD,    BAD, 0xd4ad,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1b0 */
{
/* 00 */ 0xd4ae,    BAD, 0xbae4,    BAD,    BAD,    BAD,    BAD, 0xb6d1,
/* 08 */    BAD,    BAD, 0xcbb7,    BAD,    BAD,    BAD, 0xd4ac, 0xd4af,
/* 10 */ 0xbac1, 0xb9a3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xd4b3,    BAD,    BAD, 0xbaa5,    BAD, 0xc3b3,    BAD,
/* 28 */    BAD, 0xd4b0, 0xc4da,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd4b4
},

/* Row 0x1b1 */
{
/* 00 */    BAD,    BAD, 0xbfe2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd4b2, 0xd4b5,    BAD, 0xb7bf,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xd4b6,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xd4b7,    BAD, 0xb9a4, 0xb3c0, 0xd4b9,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xd4ba,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd4bb,    BAD,    BAD, 0xd4b8,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1b2 */
{
/* 00 */ 0xd4b1,    BAD,    BAD, 0xd4bc,    BAD,    BAD, 0xd4bd,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xcbe4,    BAD,    BAD, 0xbeeb,    BAD,
/* 10 */    BAD,    BAD, 0xd4bf, 0xd4c0, 0xd4be,    BAD, 0xd4c2,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xc7b8,    BAD,    BAD, 0xb0e8,
/* 20 */ 0xc9d6,    BAD,    BAD, 0xd4c3,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xbefd,    BAD,    BAD, 0xbcb9,
/* 38 */    BAD, 0xc7dd, 0xb4f0,    BAD, 0xbaeb,    BAD,    BAD,    BAD
},

/* Row 0x1b3 */
{
/* 00 */ 0xcbd9,    BAD, 0xc6b2,    BAD,    BAD, 0xb7f8, 0xc2cf,    BAD,
/* 08 */    BAD,    BAD, 0xd4c1, 0xd4c4,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc2c4,    BAD,    BAD,
/* 18 */    BAD, 0xd4c5,    BAD,    BAD,    BAD, 0xd4c6,    BAD,    BAD,
/* 20 */    BAD, 0xd4c8,    BAD,    BAD, 0xc4e9,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xb4ae,    BAD,    BAD,    BAD,    BAD, 0xf4a1,
/* 30 */ 0xb1e1, 0xcaf3,    BAD,    BAD, 0xbeec, 0xc5c8,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xbae6,    BAD,    BAD, 0xd4ce,    BAD,    BAD
},

/* Row 0x1b4 */
{
/* 00 */ 0xcabd, 0xcedd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xb2f4, 0xd4ca,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xc1ba, 0xd4cd,    BAD, 0xc5e3,    BAD,    BAD, 0xc5c9,
/* 18 */ 0xc5e4, 0xc8b9, 0xc4cd,    BAD,    BAD,    BAD, 0xbac9,    BAD,
/* 20 */    BAD,    BAD, 0xd4c9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xb1f6,    BAD, 0xc5b6,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd4cb,    BAD, 0xd4c7,    BAD,    BAD, 0xbfd0,    BAD,    BAD,
/* 38 */    BAD, 0xd4cf,    BAD,    BAD,    BAD,    BAD, 0xbdce,    BAD
},

/* Row 0x1b5 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb6ad,    BAD, 0xd4d0,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xcae8,    BAD,    BAD,    BAD, 0xc1fd,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xc4c6,    BAD,    BAD, 0xd4d2,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xcbcf,    BAD,    BAD, 0xd4d3,    BAD,    BAD, 0xd4d8,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xcaaf,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xd4d7, 0xd4d1, 0xd4d4, 0xd4d6,    BAD,    BAD, 0xbaa6,    BAD
},

/* Row 0x1b6 */
{
/* 00 */    BAD, 0xcac9,    BAD,    BAD,    BAD, 0xd4d9,    BAD, 0xc3c5,
/* 08 */    BAD,    BAD, 0xb2f5,    BAD, 0xbeed,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xd4db,    BAD, 0xd4da,    BAD, 0xb9e8,    BAD, 0xd4dc,
/* 18 */ 0xd4de, 0xd4dd,    BAD,    BAD, 0xd4e0,    BAD, 0xd4d5, 0xd4e2,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xd4e1, 0xd4df,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xbbce, 0xbfd1,    BAD, 0xc1d4, 0xd4e3,
/* 30 */ 0xc0bc, 0xb0ed, 0xc7e4,    BAD,    BAD,    BAD,    BAD, 0xc4db,
/* 38 */    BAD, 0xd4e5, 0xd4e4, 0xd4e6, 0xd4e7, 0xd4e8,    BAD,    BAD
},

/* Row 0x1b7 */
{
/* 00 */    BAD,    BAD, 0xd4e9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xcad1, 0xd4ea,    BAD,    BAD,    BAD,    BAD, 0xb2c6,
/* 10 */ 0xd4eb,    BAD,    BAD,    BAD,    BAD, 0xcdbc, 0xb3b0,    BAD,
/* 18 */ 0xd2c9, 0xbdc8, 0xc2bf, 0xd4ec, 0xcceb,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xccb4,    BAD,    BAD, 0xd4ee,    BAD, 0xc2e7,
/* 28 */    BAD, 0xc5b7, 0xc2c0, 0xc9d7, 0xd4ef, 0xd4f0, 0xb1fb,    BAD,
/* 30 */    BAD, 0xbcba, 0xd4f1,    BAD,    BAD,    BAD,    BAD, 0xb0d0,
/* 38 */ 0xd4f2,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd4f3,    BAD
},

/* Row 0x1b8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb1e2,    BAD,    BAD, 0xb4f1,
/* 08 */ 0xc6e0, 0xcaf4,    BAD,    BAD,    BAD,    BAD, 0xd4f7, 0xc1d5,
/* 10 */ 0xd4f6, 0xb7c0,    BAD,    BAD, 0xcbdb, 0xd4f5,    BAD, 0xc5e5,
/* 18 */ 0xd4f9,    BAD, 0xd4f8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xd4fb,    BAD, 0xd4fa,    BAD,    BAD, 0xb1fc,    BAD, 0xd4fc,
/* 28 */ 0xbea9, 0xd4fe, 0xc3a5,    BAD, 0xd4fd,    BAD, 0xcab3,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xbdf7, 0xc5db,    BAD,    BAD,    BAD,
/* 38 */ 0xd5a1,    BAD,    BAD,    BAD,    BAD, 0xb9a5,    BAD,    BAD
},

/* Row 0x1b9 */
{
/* 00 */    BAD, 0xd5a2, 0xc7a1, 0xc8de, 0xccd1,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xc7a5,    BAD,    BAD, 0xd5ab,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xb5b8,    BAD,    BAD, 0xcdc5,    BAD,
/* 18 */    BAD, 0xccaf,    BAD, 0xd6ac,    BAD, 0xd5a3,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xd5a6,    BAD, 0xc2c5,    BAD,    BAD,
/* 28 */ 0xcbb8,    BAD,    BAD,    BAD, 0xc5ca,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xd5a7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xcbe5,    BAD, 0xbaca,    BAD,    BAD, 0xbeaa,    BAD
},

/* Row 0x1ba */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd5a8,    BAD,
/* 08 */    BAD, 0xbbd0,    BAD, 0xbbcf,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xb0b9, 0xb8c8,    BAD, 0xc0ab, 0xb0d1,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xd5ac, 0xd5ad,    BAD, 0xd5aa,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb1b8, 0xb4af,    BAD,
/* 28 */ 0xd5a9,    BAD, 0xccc5, 0xc9b1,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb0a8,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xb0f9,    BAD,    BAD,    BAD, 0xbbd1
},

/* Row 0x1bb */
{
/* 00 */    BAD, 0xb0d2,    BAD, 0xb0a3,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xd5b2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xd5b0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xccbc,    BAD, 0xd5b3,    BAD, 0xd5b1,    BAD,    BAD, 0xd5af,
/* 20 */ 0xbfb1,    BAD,    BAD,    BAD,    BAD, 0xd5ae,    BAD,    BAD,
/* 28 */    BAD, 0xcada,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb8e4,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd5b7, 0xd5b8,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xbeab,    BAD,    BAD,    BAD
},

/* Row 0x1bc */
{
/* 00 */ 0xd5b4, 0xcfac,    BAD,    BAD,    BAD,    BAD, 0xc7cc,    BAD,
/* 08 */    BAD, 0xd5b6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xbaa7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xd5b9,    BAD,    BAD,    BAD, 0xc9d8,    BAD,
/* 28 */    BAD,    BAD, 0xd5ba,    BAD, 0xd5b5,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xccbb
},

/* Row 0x1bd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xc7de,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xd5bb, 0xc9b2,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xd5bc, 0xd5c0, 0xd5bd,    BAD
},

/* Row 0x1be */
{
/* 00 */    BAD, 0xb2c7, 0xd5bf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xbcbb,    BAD, 0xd5be, 0xb7f9,    BAD,    BAD,    BAD,
/* 10 */ 0xd5cc,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd5c5, 0xd5c2,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xc3e4,    BAD, 0xd5c1,    BAD,    BAD, 0xd5c3,    BAD,
/* 28 */    BAD, 0xd5c4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xd5c6, 0xd5c7,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1bf */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xb4f2,    BAD, 0xd5c9, 0xd5c8,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd5ca,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xbeee,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xd5cd,    BAD, 0xc4dc,    BAD,    BAD,    BAD,
/* 30 */ 0xb1c5,    BAD, 0xd5cb,    BAD,    BAD,    BAD, 0xd5ce,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd5cf,    BAD
},

/* Row 0x1c0 */
{
/* 00 */ 0xd5d2,    BAD,    BAD, 0xd5d0,    BAD, 0xd5d1,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xbbd2, 0xd5d3,    BAD,    BAD, 0xb9a6, 0xd5d4,    BAD, 0xbbfa,
/* 18 */ 0xc2b8,    BAD, 0xd5d5, 0xd5d6, 0xbbda, 0xb9a7,    BAD, 0xccd2,
/* 20 */    BAD,    BAD,    BAD, 0xb5a8, 0xb8c9, 0xd5d7, 0xb3d8,    BAD,
/* 28 */    BAD, 0xd5d8,    BAD, 0xc2b9,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd5d9, 0xd6a3,    BAD, 0xd5da,    BAD, 0xd5db,    BAD,    BAD,
/* 38 */ 0xd5dc,    BAD, 0xd5de,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c1 */
{
/* 00 */ 0xd5df,    BAD,    BAD, 0xd5e0,    BAD, 0xc2f0,    BAD, 0xb1a7,
/* 08 */ 0xbce9, 0xb0c2,    BAD, 0xc1d7, 0xb4b0, 0xbcb5,    BAD, 0xb9a8,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5e6,    BAD, 0xbda1,
/* 18 */ 0xb4b1, 0xc3e8, 0xc4ea, 0xb0b8, 0xb5b9, 0xcaf5,    BAD, 0xbcc2,
/* 20 */    BAD,    BAD, 0xb5d2, 0xc0eb, 0xbcbc, 0xcda8, 0xd5e1,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb5dc,    BAD,
/* 30 */ 0xbacb,    BAD,    BAD, 0xb3b2, 0xb1e3, 0xbeac, 0xb2c8,    BAD,
/* 38 */ 0xd5e2, 0xcdc6,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbdc9
},

/* Row 0x1c2 */
{
/* 00 */    BAD,    BAD, 0xbce4, 0xd5e3, 0xb4f3, 0xc6d2, 0xcca9, 0xd5e4,
/* 08 */    BAD, 0xd5e5,    BAD,    BAD, 0xc9d9,    BAD,    BAD,    BAD,
/* 10 */ 0xd5e7,    BAD, 0xb4a8, 0xb6f7, 0xd5e6,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xb4b2,    BAD, 0xbfb2, 0xd5eb, 0xbba1,
/* 20 */    BAD, 0xb2c9, 0xd5ea,    BAD, 0xd5e8, 0xd5ec, 0xd5e9, 0xc7ab,
/* 28 */ 0xdccd, 0xbfb3,    BAD, 0xd5ed,    BAD,    BAD, 0xcec0,    BAD,
/* 30 */ 0xd5ee,    BAD,    BAD, 0xd5f0,    BAD, 0xc3fe, 0xd5ef,    BAD,
/* 38 */ 0xc0a3,    BAD, 0xbbfb,    BAD,    BAD,    BAD, 0xc2d0, 0xbcf7
},

/* Row 0x1c3 */
{
/* 00 */    BAD, 0xc9f5, 0xc0ec,    BAD, 0xbccd, 0xd5f1, 0xbead, 0xd5f2,
/* 08 */ 0xd5f3, 0xb0d3, 0xc2ba, 0xbfd2,    BAD, 0xd5f4, 0xc6b3, 0xbeae,
/* 10 */    BAD, 0xbeaf,    BAD, 0xd5f5,    BAD,    BAD, 0xc0ed,    BAD,
/* 18 */    BAD,    BAD, 0xbeb0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xd5f6,    BAD, 0xd5f7,    BAD, 0xcce0,    BAD,    BAD,    BAD,
/* 28 */ 0xd5f8,    BAD,    BAD,    BAD,    BAD, 0xb6c6,    BAD,    BAD,
/* 30 */    BAD, 0xbda2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xd5f9, 0xd5fa, 0xbcdc, 0xbfac, 0xc6f4, 0xbfd4, 0xc8f8, 0xc7a2
},

/* Row 0x1c4 */
{
/* 00 */ 0xb6c9, 0xd5fb,    BAD,    BAD,    BAD, 0xb5ef, 0xd5fc,    BAD,
/* 08 */ 0xb6fe,    BAD, 0xc6cf, 0xb2b0,    BAD, 0xbbd3, 0xd5fd, 0xd6a2,
/* 10 */ 0xd6a1, 0xb6fd,    BAD, 0xd5fe,    BAD, 0xc5b8,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc2b0,    BAD,
/* 20 */ 0xc5cb, 0xbcc8,    BAD,    BAD, 0xc1d8, 0xcdfa,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xd6a4,    BAD, 0xd6a5, 0xc6d6,
/* 30 */    BAD, 0xbbb3,    BAD,    BAD,    BAD,    BAD, 0xd6a7,    BAD,
/* 38 */    BAD, 0xd6a8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xd6a9,    BAD,    BAD,    BAD,
/* 10 */ 0xb4f4, 0xd6aa,    BAD,    BAD, 0xd6ab,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xb2ac,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xc1bb, 0xb4e4,    BAD, 0xd6ad, 0xcca8,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xc2d2,    BAD, 0xb3d9,    BAD,    BAD, 0xd6af, 0xd6b1,
/* 38 */ 0xb4df,    BAD,    BAD, 0xd6ae, 0xd6b0,    BAD, 0xd6b3,    BAD
},

/* Row 0x1c6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd6b2,    BAD, 0xd6b4,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xd6b5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xc6bd, 0xb6ae,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb2e5, 0xd6b6, 0xd6bb,    BAD,    BAD, 0xd6b9,    BAD, 0xcaf7,
/* 30 */ 0xcaf6,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5e7,    BAD,
/* 38 */    BAD,    BAD, 0xd6b8, 0xbdd4,    BAD, 0xd6b7,    BAD,    BAD
},

/* Row 0x1c7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbff2,
/* 08 */    BAD,    BAD,    BAD, 0xd6bc,    BAD,    BAD, 0xbaea,    BAD,
/* 10 */    BAD, 0xd6c2,    BAD,    BAD, 0xd6c3, 0xd6bd, 0xb3b3, 0xd6be,
/* 18 */ 0xd6c7, 0xd6c6, 0xd6c5, 0xd6c1,    BAD,    BAD,    BAD, 0xd6c0,
/* 20 */    BAD,    BAD, 0xd6c4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xcaf8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xd6cb, 0xd6c8,    BAD, 0xd6ca,    BAD,
/* 10 */ 0xcdf2,    BAD, 0xd6c9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xd6bf,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xbff3,    BAD,    BAD, 0xd6cc,    BAD,    BAD, 0xbab7,
/* 30 */    BAD,    BAD,    BAD, 0xd6cd,    BAD,    BAD, 0xd6ce,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c9 */
{
/* 00 */    BAD,    BAD, 0xd6d1,    BAD, 0xd6d0,    BAD,    BAD, 0xd6cf,
/* 08 */    BAD,    BAD,    BAD, 0xc5e8, 0xd6ba,    BAD,    BAD,    BAD,
/* 10 */ 0xd6d7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd6d3,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xd6d2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xd6d4,    BAD, 0xd6d5,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd6d8,
/* 38 */    BAD,    BAD, 0xcee6,    BAD, 0xd6d9, 0xd6d6,    BAD,    BAD
},

/* Row 0x1ca */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xd6da,    BAD,    BAD, 0xb4e0, 0xd6db,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xd6dd, 0xd6dc,    BAD,    BAD, 0xd6de,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xd6df,    BAD, 0xc0ee, 0xbda3,    BAD,
/* 20 */    BAD, 0xbde4,    BAD, 0xc1e3,    BAD, 0xb9a9, 0xbab8, 0xb9aa,
/* 28 */ 0xb5f0,    BAD,    BAD, 0xd6e0,    BAD,    BAD, 0xbab9,    BAD,
/* 30 */    BAD, 0xb8ca, 0xd6e1, 0xcca6, 0xc7c3, 0xd6e2,    BAD, 0xb9ab,
/* 38 */    BAD,    BAD,    BAD, 0xb4ac,    BAD, 0xc3a7, 0xb6d2,    BAD
},

/* Row 0x1cb */
{
/* 00 */    BAD,    BAD, 0xbbd4, 0xc9db,    BAD,    BAD, 0xc8c1,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xd6e3, 0xb4f5,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xd6e6,    BAD,    BAD,    BAD,    BAD, 0xc4a1,    BAD,
/* 18 */    BAD, 0xd6e5, 0xd6e4, 0xd6e7,    BAD, 0xc4eb,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xbfe3,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xbbd5,    BAD, 0xc0ca,    BAD, 0xc2d3,
/* 30 */ 0xb5a2,    BAD,    BAD, 0xc4a2,    BAD,    BAD, 0xd6e8, 0xd6e9,
/* 38 */ 0xbeef,    BAD,    BAD,    BAD,    BAD, 0xcbb9,    BAD,    BAD
},

/* Row 0x1cc */
{
/* 00 */ 0xd6ec,    BAD,    BAD, 0xd6eb, 0xd6ea, 0xc9fd,    BAD, 0xd6f3,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xcbda,    BAD, 0xd6ed,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd6ef, 0xcbeb,    BAD, 0xd6ee,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd6f0,
/* 20 */    BAD, 0xc8a8, 0xd6f1, 0xcabe, 0xd6f2,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xb4b3, 0xcabf, 0xc7af, 0xd6f4, 0xd6f5,    BAD,
/* 38 */ 0xb9ac, 0xb4b4, 0xd6f6, 0xb8b8, 0xcdc4, 0xcda9, 0xb4f6, 0xd6f8
},

/* Row 0x1cd */
{
/* 00 */    BAD, 0xc4a3,    BAD, 0xb9ad, 0xbeb1,    BAD,    BAD, 0xc8df,
/* 08 */    BAD,    BAD, 0xbeb2,    BAD,    BAD,    BAD,    BAD, 0xbdf8,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4ec, 0xcaf9, 0xc5b9,
/* 18 */    BAD,    BAD, 0xb9ae,    BAD, 0xc9dc,    BAD,    BAD,    BAD,
/* 20 */ 0xd6f9,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5d9, 0xbac2,
/* 28 */    BAD,    BAD,    BAD, 0xb8cb,    BAD, 0xc4ed,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb0c3, 0xbdee, 0xb9af,
/* 38 */ 0xcdc7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ce */
{
/* 00 */    BAD, 0xd6fa, 0xd6fb, 0xc7d1,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd6fc, 0xcef7, 0xcfad,    BAD,    BAD,    BAD,    BAD, 0xd6fe,
/* 10 */ 0xd6fd,    BAD,    BAD, 0xb3c7,    BAD,    BAD, 0xd7a1,    BAD,
/* 18 */    BAD,    BAD, 0xd7a4, 0xd7a5,    BAD, 0xd7a3,    BAD, 0xc9c0,
/* 20 */ 0xbeb3, 0xd7a7, 0xd7a6, 0xd7a2,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xd7a8, 0xd7a9,    BAD,    BAD, 0xd7aa,    BAD,    BAD,    BAD,
/* 30 */ 0xd7ad, 0xd7ab,    BAD, 0xd7ac, 0xd7ae,    BAD, 0xb1e4, 0xc4ee,
/* 38 */ 0xd7af,    BAD, 0xb7fa, 0xb2f6, 0xc7b6,    BAD, 0xd7b0, 0xc6fb
},

/* Row 0x1cf */
{
/* 00 */    BAD, 0xcadb,    BAD, 0xd7b1, 0xcfae,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xd7b2, 0xcac0, 0xd7b5, 0xd0a1, 0xd0b1,    BAD, 0xbcb0,
/* 10 */ 0xc6f5, 0xd7b6,    BAD, 0xb5dd, 0xc4a4, 0xb0fa, 0xd7b7, 0xcaa6,
/* 18 */ 0xb9b0,    BAD,    BAD, 0xc3d0,    BAD,    BAD,    BAD, 0xc4ef,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xccef, 0xb8b9, 0xb8cc,
/* 28 */    BAD, 0xd7b8,    BAD,    BAD,    BAD, 0xd7b9,    BAD, 0xd7bf,
/* 30 */    BAD, 0xbce5,    BAD,    BAD,    BAD, 0xc4a5,    BAD, 0xb6af,
/* 38 */ 0xd7ba,    BAD,    BAD,    BAD, 0xc9ab,    BAD, 0xc3c6,    BAD
},

/* Row 0x1d0 */
{
/* 00 */    BAD, 0xd7bb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd7bc,    BAD, 0xb6b0,    BAD, 0xd7bd,    BAD, 0xd7be,    BAD,
/* 10 */    BAD, 0xd7c0,    BAD, 0xc5f6,    BAD,    BAD, 0xd7c1, 0xd7c2,
/* 18 */    BAD, 0xd7c3,    BAD,    BAD, 0xd7b4, 0xd7b3,    BAD,    BAD,
/* 20 */    BAD, 0xd7c4, 0xb7c1,    BAD,    BAD,    BAD, 0xc9a7,    BAD,
/* 28 */    BAD, 0xbacc, 0xc9b7, 0xc4a6, 0xc9cb, 0xd7c5,    BAD,    BAD,
/* 30 */ 0xbeb4, 0xb1c6,    BAD, 0xd7c6,    BAD,    BAD,    BAD, 0xd7c7,
/* 38 */    BAD, 0xccf2,    BAD,    BAD, 0xc8e0,    BAD,    BAD, 0xd7ca
},

/* Row 0x1d1 */
{
/* 00 */ 0xb1fd, 0xc0ac, 0xd7c9, 0xd7c8, 0xb7c2, 0xc2d4,    BAD, 0xd7ce,
/* 08 */ 0xd7cc,    BAD, 0xd7cb, 0xcea7, 0xb8e5,    BAD,    BAD,    BAD,
/* 10 */ 0xbdf9, 0xd7cd, 0xc5cc, 0xbdbe,    BAD,    BAD,    BAD, 0xc6c0,
/* 18 */ 0xd7d1, 0xd7d0,    BAD,    BAD,    BAD,    BAD, 0xd7cf,    BAD,
/* 20 */ 0xd7d2, 0xb8e6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xd7d3, 0xc9fc, 0xbddb,    BAD,    BAD, 0xd7d4, 0xc8f9,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xc6c1, 0xc4a7,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xc5b0,    BAD,    BAD, 0xd7d5, 0xb5ab,    BAD,    BAD
},

/* Row 0x1d2 */
{
/* 00 */    BAD,    BAD,    BAD, 0xbfb4,    BAD, 0xc9ac,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xb4f7, 0xc7a6,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd7d6, 0xbbd6,
/* 18 */ 0xcbba, 0xcbbb,    BAD,    BAD, 0xb1fe, 0xd7db,    BAD,    BAD,
/* 20 */ 0xc3e9,    BAD,    BAD,    BAD, 0xd7d8,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xb2f7,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd8ad, 0xd7da,    BAD,    BAD,    BAD, 0xc7b0,    BAD,    BAD,
/* 38 */ 0xd7d9,    BAD,    BAD, 0xd7d7,    BAD, 0xb9fa,    BAD, 0xd7dd
},

/* Row 0x1d3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd7e3, 0xd7e9,
/* 10 */ 0xd7e1,    BAD, 0xc5dc,    BAD,    BAD, 0xd7e6, 0xc9dd,    BAD,
/* 18 */    BAD, 0xd7e0,    BAD, 0xd7e5, 0xcee7, 0xbbd7,    BAD,    BAD,
/* 20 */ 0xc2d5, 0xd7de,    BAD,    BAD,    BAD, 0xb5de, 0xd7e8, 0xc0ad,
/* 28 */ 0xb1e5, 0xd7e2, 0xb2f8, 0xd7e7,    BAD,    BAD,    BAD, 0xb6b1,
/* 30 */    BAD, 0xd7e4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xd7ea,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d4 */
{
/* 00 */    BAD, 0xd7ec, 0xd7f6, 0xd7f4,    BAD,    BAD, 0xd7f1,    BAD,
/* 08 */    BAD,    BAD, 0xd7f0, 0xcef8,    BAD, 0xd7f2,    BAD,    BAD,
/* 10 */ 0xb6b2,    BAD, 0xb9b1,    BAD,    BAD, 0xbdfa,    BAD,    BAD,
/* 18 */    BAD, 0xd7f9, 0xd7eb,    BAD,    BAD,    BAD,    BAD, 0xd7ef,
/* 20 */ 0xd7df,    BAD, 0xb2fa, 0xd7f3, 0xd7f5, 0xc3d1,    BAD,    BAD,
/* 28 */ 0xbaa8, 0xb2b8, 0xd7ed, 0xd7f8, 0xd7f7, 0xb6b3,    BAD, 0xc2a9,
/* 30 */ 0xb3e6,    BAD,    BAD,    BAD,    BAD, 0xb7c3,    BAD, 0xd7ee,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d5 */
{
/* 00 */    BAD, 0xd7fa,    BAD, 0xd7fd, 0xd8a1,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xbcbd,    BAD, 0xd8a7, 0xc4f0, 0xd7fb,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xd8a5,    BAD, 0xb2f9,    BAD, 0xd8a3, 0xd8a4,
/* 18 */    BAD,    BAD, 0xd7fe, 0xd8a2,    BAD,    BAD,    BAD, 0xb8e7,
/* 20 */ 0xcdaa,    BAD,    BAD, 0xb4b5,    BAD,    BAD, 0xb1d9, 0xd8a6,
/* 28 */    BAD, 0xc7ba, 0xb0ad,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xc8e1, 0xd7dc, 0xd8ac, 0xd8b0, 0xcce5,    BAD,
/* 38 */ 0xd8a9,    BAD,    BAD,    BAD, 0xc5e9, 0xd8ae,    BAD,    BAD
},

/* Row 0x1d6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xbef0, 0xd8af, 0xc6d7,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xcfc7,    BAD, 0xd8ab,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xd8b1,    BAD, 0xb9fb,    BAD, 0xc0cb,    BAD,    BAD, 0xb0d4,
/* 20 */ 0xd8aa, 0xd8a8,    BAD, 0xc1da,    BAD,    BAD,    BAD, 0xd7fc,
/* 28 */ 0xbbb4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xc2c6, 0xd8bd,    BAD, 0xc1db, 0xd8b8,    BAD, 0xd8b5, 0xd8b6,
/* 38 */    BAD, 0xbce6, 0xd8b9, 0xd8bc,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d7 */
{
/* 00 */ 0xd8b7, 0xbda5,    BAD, 0xd8ba,    BAD,    BAD, 0xd8b4,    BAD,
/* 08 */ 0xccfc, 0xccfb,    BAD,    BAD,    BAD, 0xd8be, 0xd8bf, 0xb0d5,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd8b3,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xb6f2, 0xb0a6,    BAD,    BAD,    BAD, 0xb4b6,
/* 20 */    BAD, 0xd8bb,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd8c3,
/* 28 */ 0xd8c2,    BAD,    BAD,    BAD, 0xd8c7,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xd8c8,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xd8c6, 0xd8c9, 0xd8c1, 0xd8c5
},

/* Row 0x1d8 */
{
/* 00 */    BAD,    BAD, 0xd8ca,    BAD, 0xd8cb,    BAD,    BAD, 0xd8c0,
/* 08 */ 0xbbfc,    BAD, 0xd8c4, 0xc2d6, 0xb9b2, 0xd8b2, 0xbfb5,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xd8d8,    BAD, 0xcae9,    BAD,    BAD,
/* 18 */ 0xd8ce, 0xd8cf, 0xd8d0,    BAD,    BAD, 0xd8d7,    BAD, 0xd8d6,
/* 20 */    BAD,    BAD, 0xcbfd, 0xb4b7,    BAD, 0xd8d4,    BAD, 0xb7c5,
/* 28 */ 0xb3b4,    BAD,    BAD, 0xd8d1,    BAD,    BAD, 0xceb8, 0xd8d3,
/* 30 */ 0xb0d6, 0xd8d5,    BAD, 0xd8cc, 0xd8d2, 0xd8d9, 0xb7c4, 0xd8cd,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcddd,    BAD
},

/* Row 0x1d9 */
{
/* 00 */    BAD,    BAD, 0xcdab,    BAD,    BAD,    BAD,    BAD, 0xd8dc,
/* 08 */    BAD,    BAD, 0xd8e0,    BAD,    BAD,    BAD, 0xc1fe,    BAD,
/* 10 */ 0xcef9, 0xd8e1,    BAD,    BAD, 0xd8de,    BAD, 0xd8db,    BAD,
/* 18 */    BAD, 0xd8da, 0xd8df,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xcab0,    BAD,    BAD, 0xc6b4,
/* 28 */    BAD, 0xb7c6,    BAD, 0xd8e2, 0xd8dd,    BAD, 0xd8e3,    BAD,
/* 30 */    BAD,    BAD, 0xb7fb,    BAD,    BAD,    BAD, 0xb2b1,    BAD,
/* 38 */    BAD,    BAD, 0xd8eb,    BAD,    BAD,    BAD, 0xb4b8,    BAD
},

/* Row 0x1da */
{
/* 00 */    BAD,    BAD,    BAD, 0xd8e9,    BAD,    BAD, 0xd8ea, 0xbaa9,
/* 08 */ 0xd8e8, 0xd8e6, 0xd8e5, 0xd8ec, 0xd8e4, 0xd8ee,    BAD,    BAD,
/* 10 */ 0xb2fb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xd8f0,    BAD,    BAD, 0xd8ef,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xc4a8,    BAD, 0xd8f3,    BAD, 0xd8f1, 0xd8e7,
/* 38 */ 0xb7fc,    BAD, 0xd8f2,    BAD, 0xd8f6, 0xd8f5, 0xd8f7, 0xd8f4
},

/* Row 0x1db */
{
/* 00 */ 0xd8f8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd8f9, 0xd8fa, 0xcaea,    BAD, 0xd8fc, 0xd8fb, 0xbdbf,    BAD,
/* 10 */ 0xc0ae, 0xb2e6, 0xb2fc,    BAD, 0xd8fd,    BAD, 0xb0bf,    BAD,
/* 18 */    BAD,    BAD, 0xc0cc, 0xd8fe,    BAD, 0xecc3, 0xd9a1, 0xb7e1,
/* 20 */    BAD, 0xd9a2,    BAD,    BAD,    BAD,    BAD, 0xc0ef,    BAD,
/* 28 */    BAD,    BAD, 0xd9a3,    BAD,    BAD,    BAD, 0xd9a4, 0xb5ba,
/* 30 */ 0xd9a5,    BAD, 0xd9a6, 0xd9a7, 0xc2d7,    BAD,    BAD,    BAD,
/* 38 */ 0xb8cd,    BAD,    BAD, 0xcce1,    BAD,    BAD,    BAD, 0xcbbc
},

/* Row 0x1dc */
{
/* 00 */ 0xbdea, 0xd9a8,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc0f0,
/* 08 */ 0xeebd, 0xc8e2,    BAD, 0xbcea,    BAD, 0xbacd, 0xd9a9,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xc2c7,    BAD, 0xcaa7,    BAD,    BAD,
/* 18 */ 0xc2f1,    BAD,    BAD, 0xd9ac,    BAD,    BAD, 0xd9aa,    BAD,
/* 20 */ 0xd9ad,    BAD,    BAD, 0xd9ab,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xd9ae,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcab1,    BAD,
/* 30 */    BAD, 0xb0b7,    BAD,    BAD,    BAD,    BAD, 0xc9de,    BAD,
/* 38 */    BAD, 0xc8e3,    BAD,    BAD, 0xd9af,    BAD, 0xd9b2, 0xbeb5
},

/* Row 0x1dd */
{
/* 00 */ 0xb5bb,    BAD, 0xd9b0, 0xd9b7, 0xbeb6,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xd9b1, 0xc7c4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xcdde, 0xd9b3, 0xd9b4, 0xd9b8, 0xc5ea, 0xd9b5, 0xb9b3,
/* 18 */ 0xc0de,    BAD,    BAD, 0xd9c6, 0xc8b4,    BAD, 0xc2f2,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xc8e4, 0xdaad,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xcafa,    BAD,    BAD,    BAD, 0xc4f1,    BAD,    BAD,
/* 38 */    BAD, 0xcbf5,    BAD, 0xd9bb, 0xb2a1, 0xc3ea,    BAD,    BAD
},

/* Row 0x1de */
{
/* 00 */    BAD,    BAD, 0xd9c4,    BAD,    BAD, 0xc3b4, 0xd9be, 0xd9c5,
/* 08 */ 0xd9c0, 0xd9c7, 0xd9c3,    BAD, 0xd9c2, 0xc7ef,    BAD, 0xd9bc,
/* 10 */ 0xb2fd, 0xd9ba, 0xb5f1, 0xc2f3, 0xd9b6,    BAD,    BAD, 0xd9b9,
/* 18 */ 0xb9b4, 0xc0db,    BAD, 0xbeb7, 0xd9c1, 0xc7d2,    BAD,    BAD,
/* 20 */ 0xb5f2, 0xb3c8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xb3e7, 0xbfa1, 0xd9c9, 0xd9ce,
/* 30 */    BAD, 0xd9ca,    BAD, 0xb7fd,    BAD, 0xd9cf, 0xbba2, 0xb9e9,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbda6, 0xd9bd
},

/* Row 0x1df */
{
/* 00 */    BAD, 0xbbfd, 0xd9cc,    BAD,    BAD,    BAD,    BAD, 0xbbd8,
/* 08 */ 0xd9cd, 0xb0c4,    BAD,    BAD, 0xd9c8,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xc4a9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xb5f3,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb6b4,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9cb,
/* 28 */ 0xb0a7,    BAD,    BAD, 0xbac3,    BAD,    BAD,    BAD, 0xbfb6,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xc4f2,    BAD,    BAD, 0xc8d4, 0xd9d1, 0xc1de
},

/* Row 0x1e0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xc2aa,    BAD,    BAD, 0xbbab, 0xd9d2,    BAD, 0xd9d4,
/* 10 */ 0xd9d0,    BAD,    BAD,    BAD,    BAD, 0xcae1,    BAD, 0xc4bd,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xc1dc,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcafb,
/* 28 */ 0xbcce, 0xd9e0,    BAD, 0xd9df,    BAD,    BAD, 0xbff8,    BAD,
/* 30 */    BAD,    BAD, 0xb7fe,    BAD,    BAD,    BAD, 0xd9d9, 0xbeb9,
/* 38 */    BAD,    BAD, 0xc6e8, 0xc7b1,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e1 */
{
/* 00 */ 0xd9d7,    BAD,    BAD, 0xc1dd,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xbcf8, 0xd9dc,    BAD,    BAD, 0xbeb8,    BAD, 0xd9d6, 0xd9db,
/* 10 */    BAD,    BAD, 0xc7d3,    BAD,    BAD,    BAD, 0xd9d5,    BAD,
/* 18 */ 0xb7a1,    BAD,    BAD, 0xb3dd,    BAD,    BAD,    BAD, 0xd9dd,
/* 20 */ 0xceab, 0xbace, 0xc3b5, 0xd9da,    BAD, 0xc0dc,    BAD, 0xb9b5,
/* 28 */ 0xbfe4, 0xb1e6, 0xc1bc, 0xd9d8, 0xb5c5,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xb7c7,    BAD, 0xc4cf, 0xd9de,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xc1df,    BAD,    BAD, 0xd9e1,    BAD
},

/* Row 0x1e2 */
{
/* 00 */ 0xd9e3,    BAD,    BAD, 0xc2b7, 0xd9e9,    BAD, 0xd9e4,    BAD,
/* 08 */    BAD, 0xd9e6,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc9c1,
/* 10 */ 0xc4f3,    BAD, 0xd9e7,    BAD,    BAD,    BAD, 0xcdac,    BAD,
/* 18 */    BAD,    BAD, 0xcdc8, 0xb4b9,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xb0ae,    BAD, 0xd9e5,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xd9e2,    BAD,    BAD,    BAD,    BAD, 0xb4f8,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xb1e7,    BAD, 0xd9e8,    BAD,
/* 38 */    BAD,    BAD, 0xcdc9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9ec,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc2bb,    BAD, 0xd9f3,
/* 10 */    BAD,    BAD,    BAD, 0xd9ed,    BAD,    BAD, 0xd9ea, 0xd9f1,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xd9d3,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9ee,    BAD,
/* 28 */ 0xd9f2,    BAD,    BAD,    BAD, 0xc8c2, 0xc5eb,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xd9eb,    BAD, 0xd9ef,    BAD,
/* 38 */    BAD,    BAD, 0xb7c8,    BAD,    BAD,    BAD, 0xbaf1,    BAD
},

/* Row 0x1e4 */
{
/* 00 */    BAD,    BAD, 0xc0dd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9f7,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xc5a6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9f4,
/* 28 */    BAD, 0xcbe0,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9f5,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9f6,    BAD,
/* 38 */ 0xccce,    BAD, 0xc0a2,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e5 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb7e2,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd9fd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xbbb5, 0xd9fa,    BAD, 0xd9f9,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xc7b2,    BAD,    BAD,    BAD, 0xc6b5,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xc5b1, 0xd9fb,    BAD,    BAD,
/* 28 */    BAD, 0xd9fc,    BAD, 0xc9ef,    BAD, 0xc7c5, 0xbba3,    BAD,
/* 30 */ 0xc0f1,    BAD, 0xcbd0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb3c9,    BAD, 0xdaa5, 0xd9fe,    BAD,    BAD,    BAD
},

/* Row 0x1e6 */
{
/* 00 */    BAD, 0xcdca, 0xdaa7,    BAD,    BAD, 0xdaa3,    BAD, 0xdaa4,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc1e0,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xdaa2,    BAD, 0xd9bf,    BAD,    BAD,    BAD,
/* 18 */ 0xdaa6,    BAD, 0xdaa1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xdaab, 0xdaac, 0xc5a7, 0xdaae,    BAD,    BAD, 0xbba4, 0xdaa9,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xb5bc,    BAD,    BAD, 0xdaaf,
/* 30 */    BAD, 0xdaa8, 0xdab3,    BAD, 0xdab2,    BAD, 0xdab1,    BAD,
/* 38 */    BAD,    BAD, 0xdab4,    BAD,    BAD, 0xdab6, 0xbef1,    BAD
},

/* Row 0x1e7 */
{
/* 00 */ 0xdab5,    BAD,    BAD,    BAD,    BAD, 0xdab9,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xdab7,    BAD,    BAD,    BAD, 0xdab8, 0xd9f0,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xdabb, 0xdaba,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xd9f8, 0xdabc, 0xdab0,    BAD,    BAD, 0xbbd9,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xdabd, 0xdabe, 0xdac0, 0xdabf,
/* 38 */ 0xdac1, 0xb2fe,    BAD, 0xb9b6,    BAD,    BAD, 0xcafc, 0xc0af
},

/* Row 0x1e8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb8ce,    BAD,    BAD,
/* 08 */ 0xdac3,    BAD,    BAD,    BAD,    BAD, 0xdac6,    BAD, 0xc9d2,
/* 10 */    BAD, 0xb5df,    BAD,    BAD,    BAD, 0xdac5, 0xdac4, 0xc7d4,
/* 18 */ 0xdac7, 0xb6b5,    BAD,    BAD,    BAD, 0xdac9, 0xdac8,    BAD,
/* 20 */    BAD,    BAD, 0xb4ba, 0xbbb6,    BAD,    BAD, 0xc6d8,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xb7c9,    BAD,    BAD,    BAD,
/* 30 */ 0xbff4,    BAD, 0xdaca,    BAD, 0xc0b0, 0xc5a8,    BAD, 0xc9df,
/* 38 */ 0xdacb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e9 */
{
/* 00 */    BAD,    BAD, 0xdacc, 0xdacd,    BAD,    BAD,    BAD, 0xcab8,
/* 08 */ 0xd5dd, 0xc0c6,    BAD,    BAD, 0xc9cc,    BAD, 0xbad8,    BAD,
/* 10 */ 0xc8e5, 0xc8c3,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5cd,
/* 18 */    BAD, 0xcec1,    BAD, 0xdacf, 0xbcd0,    BAD,    BAD, 0xdad0,
/* 20 */    BAD, 0xb0b6,    BAD,    BAD, 0xb6d4, 0xc0cd,    BAD, 0xc9e0,
/* 28 */    BAD,    BAD,    BAD, 0xdad1, 0xbbc2, 0xc3c7,    BAD, 0xbbdb,
/* 30 */ 0xbfb7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdad2,
/* 38 */    BAD, 0xcafd,    BAD,    BAD, 0xb1f7, 0xbbdc,    BAD,    BAD
},

/* Row 0x1ea */
{
/* 00 */    BAD, 0xdad5,    BAD, 0xdad3, 0xdad6, 0xceb9, 0xdad4,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xc0fb, 0xdad7,    BAD,    BAD, 0xc2b2,
/* 10 */    BAD,    BAD, 0xdad8,    BAD,    BAD,    BAD,    BAD, 0xb4fa,
/* 18 */    BAD, 0xdada,    BAD, 0xdad9,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xdadb, 0xdadc, 0xb4fb,    BAD,    BAD, 0xc6fc, 0xc3b6, 0xb5ec,
/* 28 */ 0xbbdd, 0xc1e1,    BAD,    BAD, 0xbddc, 0xb0b0,    BAD,    BAD,
/* 30 */    BAD, 0xdadd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xb2a2, 0xdae1,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1eb */
{
/* 00 */    BAD,    BAD, 0xb9b7, 0xdae0,    BAD,    BAD, 0xbaab, 0xbeba,
/* 08 */    BAD,    BAD, 0xdadf,    BAD, 0xbebb,    BAD, 0xccc0, 0xbaaa,
/* 10 */    BAD,    BAD,    BAD, 0xb0d7, 0xc0ce,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xdae6,    BAD,    BAD, 0xc0b1,
/* 20 */ 0xb1c7,    BAD,    BAD,    BAD,    BAD, 0xbdd5,    BAD, 0xcbe6,
/* 28 */ 0xbaf2,    BAD,    BAD,    BAD,    BAD, 0xbebc,    BAD, 0xc0a7,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xdae5, 0xdae3, 0xdae4,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xc3eb,    BAD,    BAD, 0xdba6
},

/* Row 0x1ec */
{
/* 00 */    BAD, 0xdaea, 0xbbfe, 0xb9b8, 0xdae8,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xdae9,    BAD, 0xbfb8,    BAD,    BAD,    BAD, 0xdae7,
/* 10 */    BAD,    BAD, 0xbbaf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdaec, 0xdaeb, 0xdaf0,
/* 20 */    BAD,    BAD, 0xdaf1,    BAD, 0xdaed,    BAD, 0xb3a2, 0xdaee,
/* 28 */ 0xdaef, 0xc8d5,    BAD,    BAD,    BAD,    BAD, 0xc9e1, 0xb7ca,
/* 30 */ 0xdaf2,    BAD,    BAD,    BAD, 0xc0b2,    BAD, 0xbebd,    BAD,
/* 38 */    BAD,    BAD, 0xc3d2,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ed */
{
/* 00 */    BAD, 0xb6c7,    BAD, 0xdaf3, 0xdaf7,    BAD,    BAD, 0xb2cb,
/* 08 */ 0xdaf4, 0xdaf6,    BAD,    BAD,    BAD,    BAD, 0xdaf5,    BAD,
/* 10 */    BAD, 0xbdeb,    BAD,    BAD,    BAD,    BAD, 0xc3c8, 0xb0c5,
/* 18 */ 0xdaf8,    BAD,    BAD,    BAD,    BAD, 0xdaf9,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xc4aa,    BAD,    BAD,    BAD, 0xcef1,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xbbc3,    BAD,    BAD, 0xcaeb,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xcbbd,    BAD,    BAD,    BAD,
/* 38 */ 0xdba2, 0xdafb,    BAD,    BAD, 0xdafe,    BAD, 0xdafd,    BAD
},

/* Row 0x1ee */
{
/* 00 */    BAD, 0xdafa,    BAD,    BAD, 0xdba1,    BAD,    BAD, 0xc6de,
/* 08 */    BAD, 0xdafc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdba3,    BAD,
/* 18 */    BAD, 0xbdec, 0xdba4,    BAD, 0xcdcb, 0xc7f8,    BAD,    BAD,
/* 20 */ 0xdba5,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdba7,    BAD,
/* 28 */    BAD, 0xdba8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xdba9,    BAD, 0xb6ca, 0xb1c8, 0xb9b9, 0xdbaa,    BAD, 0xdbab,
/* 38 */ 0xbdf1, 0xc1e2,    BAD,    BAD, 0xd2d8, 0xc1be, 0xc1bd, 0xc2d8
},

/* Row 0x1ef */
{
/* 00 */ 0xbac7,    BAD,    BAD, 0xd0f2,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xb7ee, 0xcdad,    BAD, 0xcafe,    BAD, 0xc9fe,    BAD, 0xdbac,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xbaf3, 0xc4bf, 0xdbad, 0xcfaf,
/* 18 */    BAD,    BAD,    BAD, 0xcbbe,    BAD, 0xc4ab, 0xdbae, 0xb4fc,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdbaf, 0xdbb0,
/* 28 */ 0xccda,    BAD, 0xcca4, 0xcbf6, 0xcbdc, 0xbba5, 0xdbb2,    BAD,
/* 30 */    BAD, 0xbceb,    BAD,    BAD, 0xcbd1,    BAD, 0xdbb4, 0xdbb7,
/* 38 */ 0xdbb6,    BAD, 0xb4f9,    BAD,    BAD, 0xb5e0,    BAD, 0xdbb3
},

/* Row 0x1f0 */
{
/* 00 */    BAD, 0xdbb5,    BAD,    BAD,    BAD,    BAD, 0xdbb8,    BAD,
/* 08 */    BAD, 0xbff9,    BAD,    BAD,    BAD,    BAD, 0xcdfb, 0xb0c9,
/* 10 */ 0xbae0, 0xc2bc,    BAD, 0xbcdd,    BAD,    BAD, 0xbef3,    BAD,
/* 18 */    BAD, 0xdbbb,    BAD,    BAD, 0xc5ce,    BAD, 0xdbb9, 0xc2ab,
/* 20 */ 0xdbba, 0xbef2, 0xccdd, 0xdbbc, 0xdbbd, 0xcde8,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xdbc2,    BAD,    BAD, 0xb9ba,    BAD, 0xc7d5,
/* 30 */ 0xdbbf, 0xc5ec, 0xdade, 0xdae2,    BAD, 0xb5cf,    BAD, 0xc7c7,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xdbc1,    BAD, 0xbebe, 0xc8c4
},

/* Row 0x1f1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdbc7,    BAD, 0xc8fa,
/* 08 */    BAD, 0xdbbe,    BAD, 0xdbc4, 0xdbc3,    BAD,    BAD,    BAD,
/* 10 */ 0xc0cf,    BAD,    BAD,    BAD,    BAD, 0xcbed,    BAD, 0xced3,
/* 18 */    BAD,    BAD, 0xcbe7,    BAD, 0xb2cc, 0xbbde,    BAD,    BAD,
/* 20 */ 0xcfc8, 0xdbc6, 0xbff5,    BAD,    BAD,    BAD, 0xdbc5,    BAD,
/* 28 */    BAD, 0xdbc0,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb8cf,
/* 30 */    BAD,    BAD,    BAD, 0xdbcc, 0xdbca,    BAD, 0xb2cd, 0xdbc8,
/* 38 */ 0xdbce, 0xdbd4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1f2 */
{
/* 00 */    BAD, 0xc2c8,    BAD,    BAD, 0xcac1,    BAD, 0xdbd6,    BAD,
/* 08 */    BAD,    BAD, 0xc9a2,    BAD,    BAD,    BAD, 0xdbd5, 0xc7f0,
/* 10 */ 0xcbbf, 0xb4bb,    BAD, 0xc0f7, 0xbdc0,    BAD,    BAD,    BAD,
/* 18 */ 0xc4d3,    BAD, 0xcdae,    BAD,    BAD, 0xdbd1, 0xdbd0,    BAD,
/* 20 */    BAD,    BAD, 0xdbd2,    BAD, 0xdbcf,    BAD,    BAD, 0xdbd7,
/* 28 */    BAD, 0xdbcd,    BAD,    BAD, 0xdbcb,    BAD, 0xdbd3, 0xdbc9,
/* 30 */    BAD, 0xc3ec,    BAD, 0xccf8, 0xbcc6, 0xbaf4,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xbaba,    BAD,    BAD, 0xcbef, 0xb3c1
},

/* Row 0x1f3 */
{
/* 00 */    BAD,    BAD, 0xc4ce, 0xc6ca, 0xb1c9,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xc0f2,    BAD,    BAD, 0xc0b4, 0xb7aa,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdbd9,    BAD,
/* 20 */    BAD, 0xb9bb, 0xb3fc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xdbdb, 0xb3f4, 0xdbe1,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xdbde,    BAD, 0xc0f3,    BAD,    BAD,    BAD,
/* 38 */ 0xb3cb, 0xbaac,    BAD,    BAD, 0xb3ca, 0xbacf,    BAD,    BAD
},

/* Row 0x1f4 */
{
/* 00 */ 0xdbdc, 0xb7e5, 0xb7cb, 0xc5ed,    BAD,    BAD, 0xdbda,    BAD,
/* 08 */ 0xb0c6,    BAD,    BAD,    BAD,    BAD, 0xdbdd, 0xdbdf,    BAD,
/* 10 */ 0xb6cd, 0xb7ac,    BAD, 0xb4bc, 0xb5cb,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xdbe2,    BAD,    BAD, 0xbaf9, 0xcbf1,    BAD, 0xbbb7,
/* 20 */    BAD,    BAD,    BAD, 0xdbe3,    BAD,    BAD,    BAD, 0xc9b0,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xdbef,    BAD, 0xb2b3, 0xdbe4,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdbf5, 0xdbe5
},

/* Row 0x1f5 */
{
/* 00 */    BAD, 0xcec2,    BAD, 0xdbec,    BAD, 0xc7df,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdbf4,    BAD, 0xdbe7,
/* 10 */    BAD,    BAD,    BAD, 0xb0b4, 0xdbe9,    BAD,    BAD, 0xb9bc,
/* 18 */    BAD,    BAD,    BAD, 0xdbeb,    BAD, 0xdbea,    BAD, 0xdbe6,
/* 20 */ 0xdbf1,    BAD, 0xbebf,    BAD,    BAD,    BAD, 0xd4ed, 0xb8e8,
/* 28 */ 0xcdfc,    BAD,    BAD,    BAD,    BAD, 0xdbe8,    BAD, 0xc4f4,
/* 30 */ 0xb3a3, 0xbaad,    BAD, 0xdbe0,    BAD, 0xdbf0, 0xb3e1,    BAD,
/* 38 */    BAD, 0xdbee, 0xdbf2,    BAD, 0xc5ee,    BAD,    BAD,    BAD
},

/* Row 0x1f6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb4fe,    BAD, 0xdcb2,    BAD,
/* 08 */    BAD, 0xccc9, 0xdbf7, 0xb4fd,    BAD, 0xdbfe,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xcbc0,    BAD, 0xdca1, 0xdca3,    BAD, 0xdca7,
/* 18 */ 0xdbf9,    BAD, 0xc3aa,    BAD,    BAD,    BAD,    BAD, 0xc5ef,
/* 20 */ 0xdcab, 0xdbfc,    BAD, 0xdca8,    BAD,    BAD,    BAD, 0xdca2,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbfb9, 0xdcac,
/* 30 */    BAD,    BAD, 0xc0b3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdcaa, 0xb4bd,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1f7 */
{
/* 00 */ 0xcfd0, 0xdbf6,    BAD,    BAD, 0xdca6, 0xb0d8,    BAD,    BAD,
/* 08 */ 0xdbf8,    BAD,    BAD, 0xccba, 0xdbfd, 0xbfa2, 0xc4c7, 0xdbf3,
/* 10 */    BAD,    BAD, 0xdca5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xbffa, 0xdcaf, 0xb3f1, 0xb8a1,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xdcb1, 0xdbfa, 0xdcb0,    BAD, 0xdca9, 0xdbfb,    BAD,
/* 28 */ 0xdcad,    BAD, 0xdcae,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xdcbf,    BAD,    BAD,    BAD, 0xc6ce,    BAD, 0xdca4,    BAD,
/* 38 */    BAD, 0xdcbb,    BAD,    BAD,    BAD, 0xdcbd,    BAD, 0xc4d8
},

/* Row 0x1f8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xcdcc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xc9f6, 0xdcb8, 0xc2ca,    BAD,    BAD,
/* 18 */    BAD, 0xdcbe, 0xc1bf,    BAD, 0xdcb5, 0xdcc2, 0xdcc1,    BAD,
/* 20 */ 0xc6ef, 0xdcc0, 0xc6ea,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xdcc4, 0xdcb7,    BAD, 0xb6c8, 0xdcba, 0xbddd,
/* 30 */    BAD,    BAD,    BAD, 0xc7e0, 0xdcbc, 0xb6cb,    BAD, 0xdcb4,
/* 38 */ 0xdcb6, 0xdcb3,    BAD,    BAD, 0xcfb0, 0xb3da, 0xdcb9,    BAD
},

/* Row 0x1f9 */
{
/* 00 */    BAD, 0xdcc3, 0xb3b5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xbae7,    BAD,    BAD,    BAD, 0xb1dd,    BAD,
/* 10 */    BAD, 0xdcd4,    BAD,    BAD, 0xcfb1, 0xdcd7,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xbfba, 0xdcd6,    BAD,    BAD,    BAD,
/* 20 */ 0xdcd5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdcd2,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdcc6,    BAD,
/* 30 */    BAD, 0xdce3, 0xdcc5,    BAD, 0xdcd8,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xdcd0,    BAD,    BAD, 0xdccb, 0xdcc8
},

/* Row 0x1fa */
{
/* 00 */    BAD, 0xdcc9,    BAD, 0xdcd1,    BAD,    BAD,    BAD, 0xf4a2,
/* 08 */    BAD,    BAD, 0xdcce, 0xb9bd, 0xc4c8, 0xc1e4, 0xdccc,    BAD,
/* 10 */ 0xdcc7,    BAD,    BAD, 0xdcca,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xcdcd, 0xcbea,    BAD,    BAD,    BAD, 0xdccf, 0xdcd9,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdce1,
/* 28 */ 0xdcda,    BAD,    BAD, 0xdce7,    BAD, 0xdce5,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xdce0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdcdf,    BAD, 0xc4d0,    BAD, 0xc1e5,    BAD, 0xdcdd
},

/* Row 0x1fb */
{
/* 00 */    BAD,    BAD, 0xdcdb,    BAD,    BAD, 0xdce2,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xdce8, 0xc8f5, 0xdcee,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xdce9, 0xdcec, 0xdce6,    BAD,    BAD, 0xc3f4,
/* 18 */    BAD, 0xc9b8,    BAD, 0xdcdc,    BAD,    BAD, 0xdce4, 0xbec0,
/* 20 */    BAD, 0xcccf, 0xdcf8, 0xdceb,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xb8a2, 0xb2a3, 0xb3df,    BAD,    BAD, 0xdcd3,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xbec1, 0xdcf0,    BAD,
/* 38 */ 0xdcf7, 0xbcf9, 0xb3f2,    BAD,    BAD, 0xc3ae,    BAD,    BAD
},

/* Row 0x1fc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xdced,    BAD,    BAD, 0xdcf2,
/* 08 */ 0xdcf6,    BAD,    BAD, 0xb6b6,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xb5cc, 0xdcf4,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb5a1,
/* 20 */    BAD, 0xc6cb, 0xdcf3,    BAD,    BAD,    BAD, 0xdcf5,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xdcef,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xdcf1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb3e0
},

/* Row 0x1fd */
{
/* 00 */ 0xc3c9,    BAD,    BAD,    BAD, 0xdcfc,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdcfa, 0xb8e9,    BAD,
/* 10 */ 0xdcf9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdda1,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xdbd8,    BAD,    BAD,    BAD,
/* 20 */ 0xdcfb,    BAD, 0xdcfd, 0xdcfe,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xddac,    BAD, 0xdda8,    BAD, 0xdbed,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xdda7,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xdda6,    BAD,    BAD, 0xdda3,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1fe */
{
/* 00 */    BAD, 0xdcea, 0xdda5, 0xdda4,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xddaa,    BAD, 0xcfa6,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xddad, 0xb6fb,    BAD,    BAD, 0xdda9, 0xddab,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xc8a7,    BAD, 0xddae,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xddb2, 0xddaf,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ff */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xcdf3, 0xddb0,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xdcde,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xddb3,    BAD,    BAD,    BAD, 0xddb4,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb1b5,    BAD, 0xddb6,
/* 20 */ 0xb7e7, 0xbca1,    BAD, 0xb6d5,    BAD,    BAD,    BAD, 0xb2a4,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xcddf,    BAD,    BAD,    BAD,    BAD, 0xddb8,
/* 38 */ 0xddb7, 0xddba, 0xb5bd,    BAD,    BAD, 0xb6d6, 0xb4be,    BAD
},

/* Row 0x200 */
{
/* 00 */    BAD,    BAD,    BAD, 0xddbd,    BAD,    BAD,    BAD, 0xddbc,
/* 08 */    BAD, 0xddbe,    BAD,    BAD, 0xb2ce,    BAD, 0xc3b7,    BAD,
/* 10 */ 0xddbf,    BAD,    BAD, 0xb4bf, 0xddc1,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xddc0,    BAD, 0xddc2,    BAD,    BAD,    BAD, 0xddc3,
/* 20 */    BAD, 0xddc4, 0xbbdf, 0xc0b5, 0xbaa1,    BAD, 0xc9f0,    BAD,
/* 28 */    BAD, 0xcae2, 0xcfc4,    BAD,    BAD,    BAD,    BAD, 0xbbf5,
/* 30 */    BAD,    BAD,    BAD, 0xbad0, 0xcef2,    BAD,    BAD,    BAD,
/* 38 */ 0xddc5, 0xddc6,    BAD, 0xbbe0,    BAD,    BAD,    BAD, 0xddc7
},

/* Row 0x201 */
{
/* 00 */ 0xddc8,    BAD,    BAD, 0xddca, 0xddc9,    BAD, 0xcbd8,    BAD,
/* 08 */    BAD, 0xbdde, 0xbcec, 0xbbc4,    BAD, 0xddcb,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xddcd, 0xbfa3,    BAD,
/* 18 */ 0xddcc,    BAD,    BAD,    BAD,    BAD,    BAD, 0xddce,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xddcf,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xddd0, 0xddd1,    BAD,    BAD,    BAD, 0xddd2,
/* 30 */    BAD, 0xddd4, 0xddd3, 0xddd5, 0xb2a5, 0xc3ca,    BAD, 0xddd6,
/* 38 */    BAD,    BAD, 0xbba6, 0xb3cc, 0xddd7,    BAD,    BAD, 0xc5c2
},

/* Row 0x202 */
{
/* 00 */ 0xd4cc,    BAD,    BAD,    BAD,    BAD, 0xb5a3, 0xddd8,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xddd9,    BAD, 0xcaec, 0xcbe8,    BAD,
/* 10 */    BAD,    BAD, 0xc6c7, 0xddda, 0xc8e6,    BAD,    BAD,    BAD,
/* 18 */ 0xc8fb,    BAD,    BAD, 0xccd3,    BAD,    BAD,    BAD, 0xdddb,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xdddd, 0xdddc,    BAD,    BAD, 0xdddf,
/* 30 */    BAD,    BAD,    BAD, 0xddde,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x203 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xdde1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbbe1,
/* 10 */    BAD, 0xccb1,    BAD, 0xdde2, 0xdde3,    BAD,    BAD, 0xb5a4,
/* 18 */    BAD,    BAD,    BAD, 0xdde4,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xdde6, 0xdde5,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xbfe5,    BAD,    BAD, 0xc9b9,
/* 38 */ 0xb1ca,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8c5,    BAD
},

/* Row 0x204 */
{
/* 00 */ 0xc4f5, 0xbdc1, 0xb5e1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8c6,    BAD,
/* 10 */ 0xbcae,    BAD,    BAD,    BAD,    BAD, 0xdde8,    BAD, 0xb4c0,
/* 18 */    BAD,    BAD, 0xb1f8,    BAD,    BAD, 0xc6f2, 0xdde7, 0xb9be,
/* 20 */ 0xc3d3,    BAD, 0xdde9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xddf1,    BAD, 0xddea,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xc2c1,    BAD, 0xb5e2, 0xddf2,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xb7e8,    BAD,    BAD, 0xb5a5, 0xddf0,    BAD
},

/* Row 0x205 */
{
/* 00 */    BAD, 0xddee, 0xddeb, 0xcde0,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xc4c0,    BAD,    BAD,    BAD, 0xc6d9, 0xddec,    BAD,    BAD,
/* 10 */ 0xddf4,    BAD, 0xddf3, 0xb7a3,    BAD,    BAD, 0xb2ad,    BAD,
/* 18 */    BAD, 0xbabb, 0xdded, 0xddef,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xcbd7, 0xc2f4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xcbf7,    BAD,    BAD, 0xddfc,    BAD,
/* 30 */    BAD, 0xddfd,    BAD, 0xb2cf,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xcaa8, 0xccfd, 0xdea1, 0xbca3, 0xbec2, 0xddf8, 0xddfe, 0xb1e8
},

/* Row 0x206 */
{
/* 00 */    BAD, 0xb6b7,    BAD,    BAD, 0xddf5, 0xddfa,    BAD,    BAD,
/* 08 */    BAD, 0xc0f4, 0xc7f1,    BAD, 0xc8e7,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xddf7,    BAD, 0xcba1,    BAD, 0xddf9,
/* 18 */    BAD, 0xdea4,    BAD, 0xdea2,    BAD, 0xddfb,    BAD,    BAD,
/* 20 */    BAD, 0xcba2, 0xc7c8, 0xb5e3,    BAD, 0xc5a5,    BAD,    BAD,
/* 28 */ 0xc3ed,    BAD, 0xdea5,    BAD,    BAD,    BAD,    BAD, 0xdea3,
/* 30 */ 0xc2d9, 0xddf6,    BAD, 0xb1cb,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x207 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xcdce, 0xdeb0,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xdeaf,    BAD,    BAD,    BAD,    BAD, 0xc0f6,
/* 18 */    BAD, 0xdeac,    BAD, 0xcdec,    BAD,    BAD, 0xc6b6, 0xdea6,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4c5,    BAD,    BAD,
/* 28 */    BAD, 0xb1cc, 0xb9bf, 0xdea9,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xbda7, 0xdeae,    BAD, 0xdead, 0xdea8,    BAD,
/* 38 */ 0xdeab,    BAD,    BAD, 0xb3e8,    BAD, 0xdeaa, 0xc7c9,    BAD
},

/* Row 0x208 */
{
/* 00 */    BAD, 0xceae,    BAD,    BAD, 0xbef4, 0xc0f5,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xdeb6, 0xdeb4,    BAD, 0xc9cd,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xdeb1, 0xdeb3,    BAD, 0xb1ba,    BAD,
/* 28 */    BAD, 0xb9c0, 0xcfb2,    BAD, 0xb3bd,    BAD, 0xc9e2,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xcde1,    BAD,    BAD, 0xb3a4,
/* 38 */ 0xbfbb, 0xdeb5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x209 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdeba,    BAD,    BAD,
/* 08 */ 0xbec3,    BAD,    BAD,    BAD, 0xcdb0,    BAD, 0xdeb7,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xdeb2,    BAD, 0xdeb8,    BAD,    BAD,
/* 18 */    BAD, 0xcede,    BAD, 0xc5f3, 0xc6c2,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb3b6,
/* 30 */    BAD,    BAD, 0xb1d5,    BAD,    BAD, 0xdebe,    BAD,    BAD,
/* 38 */ 0xdec1,    BAD,    BAD,    BAD, 0xcec3,    BAD,    BAD,    BAD
},

/* Row 0x20a */
{
/* 00 */ 0xcde4,    BAD,    BAD,    BAD,    BAD, 0xdec8, 0xdec2, 0xdebf,
/* 08 */    BAD,    BAD,    BAD, 0xced4, 0xdec5,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xbdca, 0xdec7,    BAD,    BAD, 0xdecc,    BAD,    BAD,
/* 18 */ 0xc5f1, 0xdeca,    BAD,    BAD,    BAD,    BAD, 0xdec4,    BAD,
/* 20 */    BAD, 0xc3b8,    BAD,    BAD, 0xdecb,    BAD, 0xdec0,    BAD,
/* 28 */ 0xdec6,    BAD, 0xdecd, 0xb0fc, 0xdec3,    BAD, 0xdece,    BAD,
/* 30 */    BAD, 0xbfbc,    BAD, 0xbddf,    BAD, 0xcaa5,    BAD, 0xbaae,
/* 38 */    BAD, 0xdebb, 0xdec9, 0xc5ba,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x20b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc0b6,    BAD, 0xb3e9,
/* 08 */ 0xbad1, 0xbec4, 0xdebd, 0xbdc2,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xb7cc,    BAD, 0xdebc,    BAD,    BAD,
/* 18 */    BAD, 0xded2, 0xbded, 0xb8ba,    BAD, 0xdee1,    BAD, 0xdedb,
/* 20 */ 0xb5f4, 0xc5cf,    BAD, 0xded6, 0xdedf, 0xb0af, 0xb1b2,    BAD,
/* 28 */    BAD, 0xb2b9,    BAD, 0xded8, 0xc2ac, 0xdecf, 0xded1, 0xb9c1,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xdee2,    BAD, 0xdedd,    BAD,    BAD,    BAD, 0xded5,    BAD
},

/* Row 0x20c */
{
/* 00 */    BAD,    BAD,    BAD, 0xdedc,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xccab,    BAD,    BAD, 0xdeda, 0xdede,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb8d0,    BAD,
/* 18 */ 0xbec5,    BAD,    BAD, 0xc3b9,    BAD,    BAD,    BAD, 0xded4,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcdaf,
/* 28 */    BAD,    BAD,    BAD, 0xded7,    BAD,    BAD, 0xded0, 0xc5f2,
/* 30 */    BAD,    BAD, 0xded3,    BAD,    BAD,    BAD, 0xded9,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcfd1, 0xbcbe
},

/* Row 0x20d */
{
/* 00 */ 0xcbfe,    BAD, 0xdee3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xc8ae,    BAD,    BAD, 0xdeef,
/* 10 */ 0xb8bb,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbde0,    BAD,
/* 18 */ 0xdee5,    BAD,    BAD,    BAD, 0xceaf, 0xb9c2,    BAD, 0xdef2,
/* 20 */    BAD,    BAD, 0xb0ee,    BAD,    BAD, 0xdef0,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xdee4,    BAD,    BAD,    BAD,    BAD, 0xdeea,
/* 30 */    BAD,    BAD, 0xdeec,    BAD,    BAD,    BAD, 0xcdcf, 0xdee7,
/* 38 */    BAD,    BAD, 0xc5ae,    BAD,    BAD, 0xdee9,    BAD,    BAD
},

/* Row 0x20e */
{
/* 00 */    BAD,    BAD, 0xdef1,    BAD, 0xdeeb, 0xccc7,    BAD,    BAD,
/* 08 */    BAD, 0xdee6,    BAD, 0xbca2, 0xdefe,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xb3ea,    BAD, 0xdee8, 0xdeed, 0xdeee,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc2ec, 0xc2da,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xdef6,    BAD,    BAD, 0xdefc,
/* 30 */    BAD,    BAD, 0xdefa,    BAD, 0xc5a9,    BAD,    BAD, 0xdfa3,
/* 38 */ 0xdef7,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdef8, 0xdee0
},

/* Row 0x20f */
{
/* 00 */    BAD, 0xb5f9, 0xc9ba,    BAD,    BAD,    BAD, 0xbcbf,    BAD,
/* 08 */    BAD, 0xb9f7,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcfb3,
/* 10 */    BAD, 0xdef4,    BAD, 0xdfa2, 0xb1e9, 0xc1e6,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xc7f9,    BAD, 0xb4c1, 0xcefa,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xcca1, 0xc4d2,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xdefb, 0xdefd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xc1b2,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdfa1, 0xdef9
},

/* Row 0x210 */
{
/* 00 */    BAD, 0xdef3,    BAD,    BAD,    BAD, 0xb4c3,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xb7e9,    BAD,    BAD,    BAD,
/* 18 */ 0xdfaf,    BAD,    BAD, 0xdfaa, 0xc0f8,    BAD,    BAD, 0xb3e3,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xbde1,    BAD, 0xdfb3,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdfac, 0xc4ac, 0xdfa9,
/* 30 */ 0xc4d9,    BAD,    BAD,    BAD, 0xdfcc,    BAD,    BAD,    BAD,
/* 38 */ 0xdfa6,    BAD, 0xdfa5,    BAD, 0xdfae,    BAD,    BAD,    BAD
},

/* Row 0x211 */
{
/* 00 */ 0xdfa8, 0xdfa7, 0xdfad,    BAD, 0xc0a1,    BAD, 0xdfa4,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdfb0,    BAD,
/* 10 */    BAD, 0xdfb1,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb4c2,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xdfb6,    BAD, 0xdfb5, 0xdfb7,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xdfba,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xc5c3,    BAD, 0xdfb4,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdfb8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x212 */
{
/* 00 */ 0xb7e3, 0xc2f9, 0xdfb2, 0xc7bb,    BAD,    BAD, 0xdfb9,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xdfbe, 0xdfbc,    BAD,    BAD,
/* 18 */ 0xdfbf,    BAD,    BAD, 0xdfc2,    BAD,    BAD,    BAD, 0xdfbb,
/* 20 */ 0xb9ea, 0xc7a8,    BAD,    BAD, 0xdeb9,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xcdf4, 0xdfbd,    BAD, 0xdfc1, 0xc2f5,
/* 30 */    BAD, 0xdfc0,    BAD, 0xdfab,    BAD,    BAD, 0xefe9,    BAD,
/* 38 */    BAD,    BAD, 0xdfc5,    BAD,    BAD,    BAD, 0xdfc9,    BAD
},

/* Row 0x213 */
{
/* 00 */    BAD, 0xdfc7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xdfc3,    BAD, 0xdfc4,    BAD,    BAD,    BAD, 0xdfc8,
/* 10 */    BAD, 0xdfc6,    BAD,    BAD,    BAD, 0xc9ce,    BAD,    BAD,
/* 18 */ 0xdfce,    BAD, 0xdfcb, 0xdfca,    BAD, 0xdfcd, 0xc6d4, 0xdfcf,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc3f5, 0xc2ed,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xc0a5,    BAD,    BAD,    BAD,
/* 30 */ 0xdfd0,    BAD, 0xdfd2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdfd1,    BAD
},

/* Row 0x214 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xdef5,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xdfd3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xc6e7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xdfd4,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xb2d0,    BAD,    BAD,    BAD, 0xc5f4,
/* 30 */ 0xb3a5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xb5e4,    BAD,    BAD,    BAD, 0xbcde, 0xbad2,    BAD,    BAD
},

/* Row 0x215 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xcfa7, 0xbfe6,    BAD,    BAD,    BAD, 0xb1ea,    BAD,
/* 10 */    BAD,    BAD, 0xdfd6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xdfd5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xdfd9, 0xc3ba, 0xdfdc, 0xdfd7,
/* 30 */    BAD,    BAD,    BAD, 0xdfdb,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xdfda, 0xc5c0, 0xb0d9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x216 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xcef5,    BAD,    BAD, 0xdfde,    BAD,    BAD,    BAD, 0xb1a8,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xdfe0,    BAD,    BAD,    BAD, 0xdfdf,    BAD, 0xdfdd,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xdfd8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xcba3,    BAD,    BAD,    BAD, 0xdfe2,    BAD,    BAD
},

/* Row 0x217 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xdfe1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xb1eb,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xdfe4, 0xcab2,    BAD, 0xdfe3,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xccb5,    BAD,    BAD,    BAD,    BAD, 0xbec7,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc1b3,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xbec6,    BAD,    BAD,    BAD
},

/* Row 0x218 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xcefb,    BAD,    BAD, 0xdfea,    BAD, 0xc0f9,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdfe6, 0xdfeb,    BAD,
/* 18 */    BAD, 0xb1ec,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xdfe9,    BAD, 0xc7e1, 0xdfe5, 0xdfe8, 0xbec8,
/* 28 */    BAD, 0xc8d1,    BAD,    BAD, 0xdfec,    BAD, 0xbcd1,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc0fa,    BAD,    BAD
},

/* Row 0x219 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xdfef,    BAD,    BAD,    BAD,
/* 08 */ 0xdfe7,    BAD, 0xb7a7,    BAD,    BAD,    BAD,    BAD, 0xdfed,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xcdd0, 0xdff0,    BAD,    BAD,
/* 18 */    BAD, 0xf4a6,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbdcf,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xdff1,    BAD,    BAD,    BAD, 0xdff2,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xc7ae,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdff4,    BAD,    BAD,    BAD,    BAD, 0xdff5,    BAD
},

/* Row 0x21a */
{
/* 00 */    BAD,    BAD,    BAD, 0xc7b3,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xc5f5, 0xdff7,    BAD,    BAD,    BAD,    BAD, 0xdff9,    BAD,
/* 10 */ 0xced5,    BAD, 0xdff6,    BAD, 0xdff8, 0xb1ed,    BAD, 0xdff3,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3db,
/* 20 */ 0xdffa,    BAD,    BAD,    BAD,    BAD, 0xc1e7, 0xbbb8, 0xdffc,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xdffb, 0xbfa4, 0xd2d9,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdffd,    BAD,    BAD,
/* 38 */    BAD, 0xe0a1,    BAD, 0xdfee, 0xdffe,    BAD,    BAD, 0xe0a2
},

/* Row 0x21b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc7fa,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0a3,    BAD,    BAD,
/* 10 */ 0xe0a4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe0a5,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe0a6,    BAD, 0xc4de,    BAD, 0xe0a8, 0xe0a7,    BAD,    BAD,
/* 30 */ 0xe0a9,    BAD, 0xe0aa,    BAD,    BAD, 0xbcdf, 0xc9e3,    BAD,
/* 38 */    BAD,    BAD, 0xccec, 0xe0ab, 0xe0ac, 0xc1d6, 0xbca4, 0xe0ad
},

/* Row 0x21c */
{
/* 00 */ 0xe0ae,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0af, 0xcad2,
/* 08 */ 0xc8c7,    BAD,    BAD, 0xe0b0, 0xc7d7,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xc4ad,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe0b1, 0xb2e7,    BAD, 0xb5ed,    BAD, 0xccc6,    BAD, 0xccb6,
/* 20 */    BAD, 0xb2b4, 0xcfb4,    BAD,    BAD,    BAD,    BAD, 0xcbd2,
/* 28 */    BAD, 0xcaaa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xc0b7,    BAD, 0xe0b2,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xc6c3,    BAD,    BAD,    BAD, 0xb8a3, 0xe0b3,    BAD
},

/* Row 0x21d */
{
/* 00 */ 0xbad4, 0xe0b5, 0xe0b4,    BAD,    BAD,    BAD,    BAD, 0xe0b6,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe0b7,    BAD,    BAD,    BAD, 0xe0b8,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xb5be,    BAD, 0xe0b9,    BAD,    BAD,    BAD,    BAD, 0xe0ba,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xb8a4,    BAD,    BAD, 0xc8c8,
/* 30 */    BAD,    BAD, 0xe0bc,    BAD,    BAD,    BAD, 0xbef5,    BAD,
/* 38 */    BAD, 0xe0bb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x21e */
{
/* 00 */    BAD,    BAD, 0xb6b8, 0xe0bd, 0xe0bf,    BAD, 0xe0be,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0c0,    BAD,
/* 10 */ 0xb8d1,    BAD, 0xe0c1,    BAD,    BAD,    BAD,    BAD, 0xb6e9,
/* 18 */    BAD, 0xc1c0,    BAD, 0xb9fd,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe0c3, 0xe0c4, 0xe0c2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xbced,    BAD,    BAD, 0xc6c8, 0xb6b9,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0c6,
/* 38 */ 0xc3ac, 0xe0c5,    BAD,    BAD, 0xcfb5, 0xc7e2,    BAD,    BAD
},

/* Row 0x21f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xe0c9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0cb, 0xe0c8,
/* 18 */    BAD,    BAD,    BAD, 0xccd4, 0xe0ca, 0xe0cc,    BAD, 0xcec4,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0d0,    BAD,    BAD,
/* 28 */    BAD, 0xe0cf, 0xc3f6, 0xc7ad,    BAD,    BAD, 0xb8a5, 0xe0ce,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe0cd,    BAD, 0xcdb1, 0xcdb2,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0d1, 0xb1ee
},

/* Row 0x220 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb9f6, 0xbbe2,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0d2, 0xe0d3,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0d5,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xbdc3,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe0d7,    BAD, 0xe0d6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe0d8,    BAD, 0xb3cd,    BAD,    BAD, 0xe0da,    BAD,    BAD,
/* 38 */ 0xe0d9,    BAD, 0xe0dc, 0xe0db,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x221 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb8bc,    BAD,    BAD, 0xcea8,
/* 08 */    BAD, 0xb6cc,    BAD, 0xb2a6,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb6ea,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xb4e1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xcee8, 0xe0de,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe0e0,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x222 */
{
/* 00 */ 0xe0e1,    BAD, 0xb2d1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe0dd,    BAD, 0xbbb9,    BAD,    BAD, 0xc4c1, 0xe0df,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0e4,    BAD,
/* 20 */ 0xbcee,    BAD,    BAD,    BAD,    BAD, 0xe0e2,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xb7be,    BAD,    BAD, 0xc8c9, 0xe0e3,    BAD,
/* 30 */    BAD, 0xe0fe,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xe0e9,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb8bd,    BAD
},

/* Row 0x223 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb5e5,    BAD, 0xe0e6, 0xcdfd,    BAD,
/* 08 */    BAD, 0xceb0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xc2f6,    BAD,    BAD, 0xe0e8,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xe0ea, 0xced6, 0xb6d7, 0xc8fc, 0xc7ca,    BAD,
/* 38 */    BAD,    BAD, 0xe0eb,    BAD,    BAD,    BAD,    BAD, 0xe0ed
},

/* Row 0x224 */
{
/* 00 */    BAD, 0xe0f0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0ec,    BAD,    BAD,
/* 18 */    BAD, 0xe0ef, 0xb8ea, 0xb1cd, 0xe0f1,    BAD, 0xbff0, 0xe0ee,
/* 20 */ 0xcedc,    BAD,    BAD, 0xe0f4, 0xf4a4,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe0f2, 0xe0f5,    BAD,    BAD,    BAD,    BAD, 0xe0e7,
/* 30 */ 0xe0f3,    BAD,    BAD, 0xbabc,    BAD,    BAD, 0xe0f6,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0f7,    BAD
},

/* Row 0x225 */
{
/* 00 */    BAD,    BAD,    BAD, 0xcdfe,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe0f8,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0f9,    BAD,
/* 20 */    BAD,    BAD, 0xe0e5,    BAD,    BAD,    BAD,    BAD, 0xe0fa,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xb4c4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xbca5,    BAD,    BAD
},

/* Row 0x226 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xe0fb,    BAD,    BAD,    BAD,    BAD, 0xe0fc,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe0fd,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xb1bb,    BAD,    BAD,    BAD,
/* 20 */ 0xe1a1,    BAD, 0xc9bb, 0xe1a2,    BAD,    BAD, 0xb4a4, 0xe1a3,
/* 28 */    BAD, 0xe1a4,    BAD,    BAD,    BAD,    BAD, 0xe1a5,    BAD,
/* 30 */ 0xe1a7, 0xe1a8, 0xe1a6,    BAD,    BAD,    BAD, 0xc9d3, 0xe1aa,
/* 38 */ 0xe1a9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x227 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe1ac, 0xe1ab, 0xe1ad,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe1ae, 0xe1b0, 0xe1af,    BAD,
/* 10 */    BAD, 0xb9f9,    BAD, 0xe1b2,    BAD, 0xe1b1,    BAD,    BAD,
/* 18 */ 0xb4c5,    BAD, 0xbfd3,    BAD, 0xc5bc,    BAD, 0xe1b3, 0xc0b8,
/* 20 */    BAD,    BAD,    BAD, 0xbbba,    BAD, 0xb1f9, 0xe1b4,    BAD,
/* 28 */ 0xcdd1,    BAD,    BAD, 0xcae3, 0xe1b5,    BAD,    BAD,    BAD,
/* 30 */ 0xc5c4, 0xcdb3, 0xb9c3, 0xbfbd,    BAD,    BAD,    BAD, 0xc3cb,
/* 38 */ 0xd2b4,    BAD, 0xc4ae, 0xb2e8, 0xe1b6,    BAD,    BAD,    BAD
},

/* Row 0x228 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe1b7,    BAD, 0xe1bc,    BAD,
/* 08 */    BAD, 0xe1ba, 0xe1b9, 0xdac2, 0xb3a6, 0xe1b8,    BAD, 0xb0da,
/* 10 */    BAD, 0xc8aa,    BAD,    BAD, 0xc8ca,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xceb1, 0xe1bd, 0xe1bb, 0xc3dc, 0xc0a6,    BAD,    BAD,
/* 20 */ 0xc8ab,    BAD, 0xc9ad,    BAD, 0xe1bf, 0xceac, 0xb7cd, 0xe1c0,
/* 28 */    BAD, 0xe1be, 0xc8d6, 0xe1c1,    BAD, 0xe1c2,    BAD,    BAD,
/* 30 */ 0xb0db,    BAD,    BAD, 0xbef6, 0xe1c7,    BAD, 0xe1c4, 0xc6ed,
/* 38 */ 0xe1c3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb5a6
},

/* Row 0x229 */
{
/* 00 */    BAD,    BAD, 0xe1ca,    BAD,    BAD,    BAD, 0xe1c5, 0xe1c6,
/* 08 */    BAD, 0xe1c9, 0xe1c8, 0xc9a5,    BAD,    BAD, 0xc1c2, 0xc1c1,
/* 10 */    BAD, 0xb5bf,    BAD,    BAD, 0xe1cb,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe1cc,    BAD,    BAD, 0xe1cd,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe1cf,    BAD, 0xe1ce,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xb1d6,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xe1d7, 0xc8e8, 0xe1d1,    BAD, 0xe1d3,    BAD,    BAD,
/* 38 */ 0xe1d5, 0xbfbe,    BAD,    BAD, 0xe1d6, 0xe1d4, 0xbcc0,    BAD
},

/* Row 0x22a */
{
/* 00 */    BAD,    BAD, 0xe1d0, 0xe1d2,    BAD, 0xc9c2,    BAD, 0xbec9,
/* 08 */    BAD,    BAD, 0xe1d9,    BAD,    BAD, 0xe1d8,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe1da,    BAD, 0xbca6, 0xbaaf,    BAD,    BAD,
/* 18 */ 0xc5f7, 0xe1db,    BAD, 0xc4cb,    BAD,    BAD, 0xe1dd,    BAD,
/* 20 */    BAD,    BAD, 0xcea1, 0xe1dc,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xc1e9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe1e2,    BAD, 0xe1e4, 0xe1e5, 0xc3d4,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe1e3,    BAD, 0xe1e0,    BAD, 0xe1de, 0xe1df
},

/* Row 0x22b */
{
/* 00 */    BAD, 0xe1e1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe1e8,    BAD, 0xe1e6,    BAD, 0xe1e7,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe1e9,
/* 20 */ 0xe1eb, 0xe1ec, 0xe1ed,    BAD, 0xe1ee,    BAD,    BAD, 0xe1ea,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe1f0,    BAD,    BAD,    BAD, 0xe1ef,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe1f1,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x22c */
{
/* 00 */    BAD,    BAD, 0xcec5,    BAD,    BAD,    BAD, 0xe1f4, 0xe1f2,
/* 08 */ 0xe1f3,    BAD,    BAD,    BAD, 0xb4e2,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xccfe,    BAD,    BAD,    BAD, 0xcaca,    BAD,
/* 18 */ 0xe1f6,    BAD,    BAD,    BAD, 0xe1f5,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe1f7, 0xe1f8,    BAD,    BAD,    BAD,    BAD, 0xe1fc,
/* 28 */ 0xe1f9, 0xe1fa, 0xe1fb,    BAD, 0xe1fd,    BAD,    BAD,    BAD,
/* 30 */ 0xe1fe,    BAD, 0xe2a1,    BAD,    BAD,    BAD, 0xe2a2,    BAD,
/* 38 */ 0xe2a3,    BAD, 0xc8af, 0xc5d0, 0xe2a4, 0xc7f2, 0xc9b4,    BAD
},

/* Row 0x22d */
{
/* 00 */ 0xe2a5,    BAD,    BAD, 0xe2a6, 0xc5aa,    BAD, 0xb3a7, 0xb9c4,
/* 08 */ 0xe2a7,    BAD,    BAD, 0xe2a8,    BAD,    BAD, 0xe2a9,    BAD,
/* 10 */ 0xbba9,    BAD,    BAD, 0xe2ab,    BAD,    BAD, 0xe2aa,    BAD,
/* 18 */    BAD, 0xe2ac, 0xe2ad,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8e9,    BAD,
/* 30 */ 0xe2ae,    BAD,    BAD,    BAD, 0xe2af,    BAD,    BAD, 0xf3e9,
/* 38 */ 0xe2b0, 0xe2b1, 0xe2b2,    BAD,    BAD,    BAD,    BAD, 0xbbae
},

/* Row 0x22e */
{
/* 00 */    BAD,    BAD, 0xe2b3, 0xc7d6,    BAD,    BAD, 0xcbdf,    BAD,
/* 08 */ 0xb1ce,    BAD, 0xb1d7,    BAD,    BAD, 0xe2b4,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe2b6,    BAD,    BAD,    BAD, 0xe2b5, 0xc5f0,
/* 18 */    BAD,    BAD,    BAD, 0xc0b9, 0xddb9,    BAD, 0xe2b7, 0xccc1,
/* 20 */    BAD, 0xe2b8,    BAD, 0xb4c6, 0xc8d7, 0xe2b9,    BAD, 0xe2ba,
/* 28 */    BAD,    BAD, 0xe2bb,    BAD,    BAD,    BAD, 0xccdc,    BAD,
/* 30 */    BAD,    BAD, 0xccd5,    BAD, 0xc4be,    BAD,    BAD,    BAD,
/* 38 */ 0xc1ea,    BAD,    BAD, 0xe2bd,    BAD,    BAD, 0xbde2,    BAD
},

/* Row 0x22f */
{
/* 00 */    BAD, 0xbeca,    BAD,    BAD, 0xe2c0,    BAD,    BAD, 0xe2bf,
/* 08 */ 0xe2be, 0xc8fd,    BAD, 0xb4c7, 0xb8a9,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe2c6,    BAD,    BAD, 0xe2c3, 0xbfbf,
/* 20 */ 0xccb2,    BAD,    BAD,    BAD, 0xe2c2, 0xe2c4, 0xe2c5,    BAD,
/* 28 */    BAD, 0xe2c1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2c7,
/* 38 */ 0xe2c8,    BAD, 0xc4af,    BAD, 0xb4e3,    BAD,    BAD,    BAD
},

/* Row 0x230 */
{
/* 00 */ 0xc3e5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2c9,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe2ca, 0xe2cd,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xbfe7,    BAD, 0xc6c4,    BAD, 0xe2ce, 0xcbd3,    BAD,
/* 28 */ 0xe2cb,    BAD,    BAD, 0xe2cc,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe2d1,    BAD,    BAD,    BAD,    BAD, 0xe2d0, 0xe2cf
},

/* Row 0x231 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe2d3,    BAD,    BAD, 0xe2d2,    BAD,
/* 10 */    BAD, 0xe2d4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2d6,    BAD,
/* 20 */ 0xe2d5,    BAD,    BAD,    BAD,    BAD, 0xcacd,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xbdd6, 0xcec6,    BAD,    BAD,
/* 30 */ 0xe2d7,    BAD,    BAD, 0xc6b7,    BAD,    BAD, 0xe2d8,    BAD,
/* 38 */    BAD, 0xe2d9,    BAD, 0xe2dd, 0xe2db, 0xe2dc,    BAD, 0xe2da
},

/* Row 0x232 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2de,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2df,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2e0,
/* 18 */    BAD,    BAD, 0xe2e1, 0xccb7, 0xe2e2,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xccf0, 0xe2e3,    BAD, 0xc3ce,    BAD, 0xc7ea,
/* 28 */    BAD, 0xb6eb,    BAD,    BAD,    BAD, 0xc3bb, 0xe2e4, 0xb6ba,
/* 30 */    BAD,    BAD,    BAD, 0xc0d0,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe2e5,    BAD,    BAD,    BAD
},

/* Row 0x233 */
{
/* 00 */    BAD,    BAD, 0xbabd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe2e6,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe2e7,    BAD, 0xb8a6, 0xbad5,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe2e9,    BAD,    BAD,    BAD,    BAD, 0xc5d6, 0xbad6, 0xb5ce,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xcba4,    BAD, 0xc7cb,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xc5d7,    BAD,    BAD,    BAD,    BAD, 0xb9dc
},

/* Row 0x234 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2eb,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xbecb,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xceb2, 0xb9c5,    BAD,    BAD, 0xb8a7,
/* 30 */    BAD,    BAD, 0xc8a3,    BAD, 0xe2ed,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe2ef,    BAD,    BAD,    BAD
},

/* Row 0x235 */
{
/* 00 */    BAD, 0xb8eb,    BAD,    BAD,    BAD,    BAD, 0xe2ee, 0xc4f6,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe2f1, 0xb3b7, 0xe2ec,    BAD,
/* 10 */    BAD, 0xc8ea,    BAD, 0xb1b0,    BAD, 0xbaec,    BAD, 0xcfd2,
/* 18 */    BAD,    BAD, 0xe2f0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe2f2,    BAD,    BAD,    BAD, 0xcacb,
/* 28 */    BAD, 0xc0d9, 0xe2f4,    BAD,    BAD,    BAD,    BAD, 0xe2f5,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2f3,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xb3ce,    BAD, 0xe2fb,    BAD, 0xe2fa,    BAD
},

/* Row 0x236 */
{
/* 00 */    BAD, 0xbca7,    BAD,    BAD,    BAD, 0xe2fc, 0xe2f7,    BAD,
/* 08 */    BAD,    BAD, 0xe2fd, 0xe2f8,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xc8d8, 0xe2f6,    BAD,    BAD, 0xe2f9,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe3a2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3a1,
/* 28 */ 0xcbe1,    BAD,    BAD,    BAD, 0xe2fe,    BAD,    BAD, 0xb0eb,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe3a4,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3a3,    BAD,    BAD
},

/* Row 0x237 */
{
/* 00 */    BAD, 0xbecc,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3a5,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc1c3,    BAD,
/* 10 */    BAD, 0xe3a7, 0xe3a6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe3a8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe2e8,    BAD,
/* 28 */    BAD,    BAD, 0xe2ea, 0xe3aa, 0xe3a9,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xbca8,    BAD, 0xcee9,    BAD, 0xbcd2,    BAD
},

/* Row 0x238 */
{
/* 00 */ 0xe3ab, 0xb7b7,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb5c0,
/* 08 */ 0xb5a7, 0xbbe3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xcdb4,    BAD,    BAD, 0xe3b1,    BAD, 0xe3b0, 0xc1c4, 0xe3ad,
/* 18 */    BAD,    BAD, 0xe3af,    BAD,    BAD, 0xbdcb, 0xbfc0, 0xe3ae,
/* 20 */ 0xe3ac,    BAD, 0xc7aa,    BAD,    BAD, 0xbecd,    BAD,    BAD,
/* 28 */ 0xc9bc,    BAD,    BAD,    BAD,    BAD, 0xbad7,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5f8,
/* 38 */    BAD,    BAD, 0xe3b2,    BAD,    BAD,    BAD,    BAD, 0xe3b3
},

/* Row 0x239 */
{
/* 00 */ 0xe3c9, 0xb6d8,    BAD,    BAD, 0xcfbd, 0xc1b5,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xe3b4,    BAD,    BAD, 0xb2d2, 0xc4f7, 0xcaa1,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3b5,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb5fa, 0xe3b6,
/* 28 */    BAD,    BAD, 0xe3b8,    BAD,    BAD,    BAD, 0xe3b9,    BAD,
/* 30 */ 0xc7a9,    BAD,    BAD, 0xe3ba,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe3bb, 0xe3bc,    BAD,    BAD, 0xb6d9, 0xb2d3, 0xc6c5
},

/* Row 0x23a */
{
/* 00 */ 0xbda8, 0xbbe4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe3bd,    BAD, 0xbda9,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xb2ca, 0xc9c3,    BAD,    BAD, 0xe3be,    BAD,    BAD,
/* 18 */ 0xc8eb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc1c5,
/* 20 */    BAD, 0xe3c1,    BAD, 0xe3c2, 0xc7e9,    BAD, 0xbfc1, 0xe3bf,
/* 28 */    BAD, 0xc3e1,    BAD,    BAD, 0xe3c0,    BAD,    BAD,    BAD,
/* 30 */ 0xbece,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xb0dc,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x23b */
{
/* 00 */ 0xb5a9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe3c3,    BAD,    BAD, 0xc4f8,    BAD, 0xe3c4, 0xc0c7,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xccad,    BAD,    BAD, 0xc9a3,
/* 18 */ 0xe3c5, 0xe3c6, 0xc3d5,    BAD, 0xcec7,    BAD,    BAD, 0xe3c8,
/* 20 */ 0xe3c7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbcef,    BAD,
/* 30 */    BAD, 0xe3ca, 0xb0f0,    BAD,    BAD,    BAD,    BAD, 0xe3cd,
/* 38 */    BAD,    BAD,    BAD, 0xe3cb, 0xb2d4, 0xb7ce, 0xe3cc, 0xb9c6
},

/* Row 0x23c */
{
/* 00 */ 0xb9f2,    BAD, 0xcae6, 0xe3ce,    BAD,    BAD, 0xcbd4,    BAD,
/* 08 */    BAD, 0xe3d0,    BAD,    BAD,    BAD, 0xc0d1, 0xb1cf, 0xb2ba,
/* 10 */ 0xb0ac,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3cf,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe3d1, 0xe3d2, 0xbef7,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe3d3,    BAD, 0xb3cf,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe3d5,    BAD,    BAD,    BAD, 0xb7ea,    BAD, 0xb5e6,    BAD,
/* 38 */    BAD, 0xe3d6, 0xb6f5,    BAD,    BAD, 0xe3d7,    BAD, 0xc0fc
},

/* Row 0x23d */
{
/* 00 */    BAD, 0xc6cd,    BAD, 0xc0e0, 0xbaf5,    BAD,    BAD,    BAD,
/* 08 */ 0xe3d8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xc3e2, 0xc1eb,    BAD, 0xe3da, 0xe3dc, 0xe3d9,
/* 18 */ 0xe3db,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7a2,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe3dd, 0xb7a6,    BAD,    BAD,    BAD, 0xb5e7, 0xcdd2,
/* 30 */ 0xe3df,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3e0,    BAD,
/* 38 */    BAD,    BAD, 0xb1ae,    BAD,    BAD,    BAD,    BAD, 0xe3e3
},

/* Row 0x23e */
{
/* 00 */    BAD,    BAD,    BAD, 0xb3f6, 0xe3e2, 0xe3e1,    BAD, 0xe3e5,
/* 08 */ 0xe3de,    BAD, 0xe3e6, 0xcea9,    BAD, 0xe3e7,    BAD, 0xe3e8,
/* 10 */    BAD,    BAD, 0xd4f4, 0xe3ea,    BAD, 0xe3e9,    BAD,    BAD,
/* 18 */    BAD, 0xe3eb, 0xe3ec,    BAD, 0xceb5, 0xe3ed,    BAD, 0xf0ef,
/* 20 */ 0xbecf, 0xe3ee, 0xe3ef, 0xbdd7,    BAD, 0xc6b8, 0xe3f0,    BAD,
/* 28 */    BAD,    BAD, 0xc3a8,    BAD,    BAD, 0xe3f1,    BAD, 0xc3bc,
/* 30 */ 0xe3f2,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb6a5,    BAD,
/* 38 */ 0xd1bf, 0xc3dd, 0xbcb3,    BAD,    BAD,    BAD,    BAD, 0xb4c8
},

/* Row 0x23f */
{
/* 00 */    BAD,    BAD, 0xe3f3,    BAD, 0xe4a2,    BAD, 0xe3f6,    BAD,
/* 08 */ 0xb5e8,    BAD, 0xe3f5, 0xe4a4,    BAD,    BAD,    BAD, 0xe3f4,
/* 10 */    BAD, 0xbed0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe3f8, 0xe3f9,    BAD, 0xc5ab,    BAD,    BAD, 0xe3fa,    BAD,
/* 20 */ 0xb3de,    BAD,    BAD,    BAD,    BAD, 0xbfda, 0xc9e4,    BAD,
/* 28 */ 0xe3fc,    BAD,    BAD,    BAD, 0xc2e8,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe3f7,    BAD, 0xe3fb, 0xe3fd,    BAD,
/* 38 */    BAD, 0xbafb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x240 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4a6, 0xc9ae,    BAD,
/* 08 */ 0xc8a6, 0xc5f9,    BAD, 0xb6da, 0xe4a5, 0xe4a3,    BAD, 0xc8b5,
/* 10 */ 0xe3fe, 0xc3de, 0xc5fb,    BAD, 0xc5fa,    BAD, 0xbaf6,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4b8,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4a8,    BAD, 0xe4aa,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe4ad,    BAD, 0xe4ae,    BAD,
/* 30 */ 0xe4ab, 0xe4ac,    BAD,    BAD, 0xe4a9, 0xe4a7,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe4a1,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x241 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcacf, 0xb2d5,
/* 08 */    BAD,    BAD,    BAD, 0xe4b5,    BAD, 0xe4b2,    BAD, 0xe4b7,
/* 10 */    BAD,    BAD, 0xe4b6,    BAD, 0xc7f3, 0xcca7,    BAD, 0xbbbb,
/* 18 */ 0xe4b0, 0xe4b9, 0xe4b4,    BAD, 0xe4b3, 0xe4af,    BAD, 0xe4b1,
/* 20 */    BAD, 0xb4c9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xc3bd,    BAD,    BAD, 0xc0fd,    BAD,    BAD,
/* 30 */    BAD, 0xc8a2,    BAD,    BAD, 0xe4be,    BAD,    BAD,    BAD,
/* 38 */ 0xc8a4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x242 */
{
/* 00 */ 0xc0e1, 0xe4bb,    BAD,    BAD, 0xc8cf,    BAD, 0xe4bf, 0xcad3,
/* 08 */    BAD, 0xc3db,    BAD, 0xe4ba, 0xe4bc,    BAD,    BAD, 0xe4bd,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4c0,    BAD,    BAD,
/* 20 */ 0xbcc4,    BAD,    BAD,    BAD, 0xc6c6, 0xe4c5, 0xe4c4,    BAD,
/* 28 */    BAD, 0xe4c1,    BAD,    BAD,    BAD, 0xcfb6,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe4ca,    BAD,    BAD, 0xe4ce, 0xe4cb,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x243 */
{
/* 00 */ 0xe4c7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4c8,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4cd,    BAD,    BAD,
/* 10 */    BAD, 0xe4c2, 0xd2d5, 0xe4c9, 0xe4c3,    BAD,    BAD, 0xe4cc,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4d2,
/* 20 */    BAD, 0xb4ca,    BAD, 0xe4cf,    BAD,    BAD,    BAD, 0xe4d0,
/* 28 */    BAD,    BAD, 0xe4d1, 0xe4d4,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4d3,
/* 38 */ 0xc8f6,    BAD,    BAD,    BAD,    BAD, 0xe4d5, 0xcefc, 0xcaed
},

/* Row 0x244 */
{
/* 00 */ 0xe4da,    BAD,    BAD, 0xe4d7,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe4d6, 0xc0d2,    BAD, 0xe4d9,
/* 10 */ 0xe4db,    BAD,    BAD,    BAD, 0xe4d8,    BAD, 0xe4df,    BAD,
/* 18 */ 0xe4dc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4dd,
/* 20 */ 0xe4c6,    BAD,    BAD,    BAD, 0xe4de, 0xe4e0,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe4e1,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xcac6,    BAD, 0xe4e2,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcce2,    BAD
},

/* Row 0x245 */
{
/* 00 */    BAD, 0xb6ce, 0xb7a9, 0xe4e3,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xcab4,    BAD, 0xbfe8,    BAD, 0xccb0,    BAD,    BAD,
/* 10 */ 0xe4e4,    BAD, 0xceb3,    BAD,    BAD, 0xc7f4,    BAD, 0xc1c6,
/* 18 */ 0xc7b4,    BAD,    BAD, 0xbdcd,    BAD,    BAD,    BAD, 0xb0c0,
/* 20 */    BAD, 0xe4e9, 0xe4e7,    BAD, 0xe4e5, 0xb4a1,    BAD, 0xbed1,
/* 28 */ 0xe4ea,    BAD,    BAD, 0xe4e8,    BAD, 0xe4e6, 0xe4ee,    BAD,
/* 30 */    BAD, 0xe4ed, 0xe4ec, 0xe4eb,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe4ef,    BAD,    BAD,    BAD, 0xe4f0, 0xc0ba,    BAD
},

/* Row 0x246 */
{
/* 00 */ 0xe4f1,    BAD, 0xe4f3,    BAD,    BAD, 0xe4f2,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xb8d2,    BAD,    BAD,    BAD, 0xc1b8,    BAD,
/* 10 */    BAD,    BAD, 0xe4f5,    BAD,    BAD,    BAD, 0xc5fc,    BAD,
/* 18 */ 0xe4f4,    BAD,    BAD,    BAD, 0xe4f6,    BAD, 0xcab5, 0xc1ec,
/* 20 */ 0xb9c7,    BAD, 0xe4f7,    BAD,    BAD,    BAD,    BAD, 0xcec8,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4f9,
/* 30 */    BAD,    BAD, 0xe4fa,    BAD, 0xe4fb,    BAD, 0xe4fc,    BAD,
/* 38 */ 0xbbe5,    BAD, 0xe4fd, 0xb7cf,    BAD,    BAD, 0xb5ea,    BAD
},

/* Row 0x247 */
{
/* 00 */ 0xb5aa,    BAD, 0xe5a1,    BAD, 0xccf3, 0xb9c8, 0xe4fe,    BAD,
/* 08 */    BAD,    BAD, 0xe5a4, 0xcce6,    BAD, 0xc7bc,    BAD,    BAD,
/* 10 */ 0xc9b3,    BAD,    BAD,    BAD, 0xbde3, 0xe5a3,    BAD, 0xbcd3,
/* 18 */ 0xb9c9, 0xbbe6, 0xb5e9, 0xcab6, 0xe5a2,    BAD,    BAD,    BAD,
/* 20 */ 0xc1c7, 0xcbc2, 0xbaf7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xbbe7, 0xc4dd,    BAD, 0xe5a7, 0xcedf,
/* 30 */ 0xbad9,    BAD, 0xe5a8, 0xbfc2,    BAD, 0xe5aa,    BAD,    BAD,
/* 38 */    BAD, 0xbed2, 0xbab0,    BAD,    BAD,    BAD,    BAD, 0xe5a9
},

/* Row 0x248 */
{
/* 00 */    BAD,    BAD, 0xbdaa, 0xb8be, 0xc1c8, 0xe5a5, 0xe5ab,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe5a6, 0xb7d0,    BAD, 0xe5ae, 0xe5b2,
/* 10 */ 0xb7eb,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5ad,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe5b6,    BAD,    BAD, 0xb9ca,    BAD,
/* 20 */    BAD, 0xcded, 0xb0bc, 0xe5b3,    BAD,    BAD, 0xb5eb,    BAD,
/* 28 */ 0xe5b0,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5b1,    BAD,
/* 30 */    BAD, 0xc5fd, 0xe5af, 0xe5ac,    BAD, 0xb3a8, 0xc0e4,    BAD,
/* 38 */    BAD, 0xb8a8,    BAD,    BAD,    BAD, 0xe5b8,    BAD,    BAD
},

/* Row 0x249 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe5b5,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5b7,
/* 10 */    BAD,    BAD,    BAD, 0xe5b4,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xb7d1, 0xc2b3, 0xe5b9, 0xc1ee,    BAD,    BAD, 0xe5c6,
/* 20 */    BAD,    BAD, 0xe5c2, 0xe5bc,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe5c0, 0xbcfa, 0xb0dd, 0xe5bb, 0xe5c3,
/* 30 */ 0xe5c7, 0xb9cb, 0xccd6,    BAD, 0xc4d6, 0xe5bd,    BAD,    BAD,
/* 38 */ 0xe5c5,    BAD, 0xe5ba, 0xc3be,    BAD, 0xe5bf, 0xb0bd, 0xccca
},

/* Row 0x24a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5be,
/* 08 */    BAD,    BAD, 0xb6db, 0xc8ec,    BAD,    BAD,    BAD, 0xc1ed,
/* 10 */    BAD, 0xced0, 0xbdef,    BAD,    BAD, 0xe5ee,    BAD,    BAD,
/* 18 */ 0xe5c8,    BAD, 0xc0fe,    BAD, 0xe5c4, 0xe5c9, 0xe5cb,    BAD,
/* 20 */ 0xc4f9, 0xe5ce,    BAD,    BAD, 0xe5ca,    BAD,    BAD,    BAD,
/* 28 */ 0xcad4, 0xb4cb,    BAD,    BAD, 0xcccb,    BAD,    BAD, 0xb0de,
/* 30 */    BAD,    BAD, 0xe5cd,    BAD, 0xcefd,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe5cc,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x24b */
{
/* 00 */    BAD, 0xb1ef,    BAD,    BAD, 0xc6ec, 0xe5cf,    BAD,    BAD,
/* 08 */    BAD, 0xe5d6, 0xe5d0, 0xe5d7,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe5d3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xc7fb,    BAD,    BAD, 0xbcca, 0xe5d5,
/* 20 */    BAD, 0xe5d2, 0xe5d8, 0xe5d1,    BAD,    BAD, 0xbdc4,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xcba5,    BAD,    BAD, 0xbdcc,    BAD,
/* 30 */    BAD, 0xe5d4, 0xe5e0,    BAD,    BAD, 0xe5dc,    BAD, 0xe5df,
/* 38 */    BAD, 0xe5dd, 0xe5e1, 0xe5db,    BAD, 0xe5c1, 0xc0d3,    BAD
},

/* Row 0x24c */
{
/* 00 */    BAD, 0xc8cb,    BAD, 0xe5de,    BAD,    BAD, 0xe5d9,    BAD,
/* 08 */    BAD,    BAD, 0xc1a1, 0xb7d2,    BAD, 0xbdab,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xbfa5, 0xc1b6, 0xe5e4,    BAD,
/* 18 */    BAD, 0xe5e6, 0xe5e7,    BAD,    BAD, 0xe5e3, 0xe5e5,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe5da, 0xe5e2,
/* 28 */    BAD, 0xe5ea, 0xe5e9,    BAD,    BAD, 0xcbfa,    BAD,    BAD,
/* 30 */ 0xb7ab,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe5e8,    BAD, 0xe5ec, 0xe5eb, 0xe5ef,    BAD, 0xe5f1
},

/* Row 0x24d */
{
/* 00 */    BAD,    BAD, 0xbbbc, 0xe5ed,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe5f2, 0xe5f3,    BAD,    BAD, 0xe5f4,    BAD, 0xe5fa, 0xc5bb,
/* 10 */ 0xe5f6,    BAD, 0xe5f5, 0xe5f7, 0xe5f8,    BAD, 0xe5f9,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xe5fb, 0xe5fc,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x24e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb4cc,    BAD,
/* 38 */ 0xe5fd,    BAD, 0xe5fe,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x24f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6a1,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe6a2, 0xe6a3, 0xe6a4,    BAD,
/* 10 */ 0xe6a5, 0xe6a6,    BAD,    BAD, 0xe6a8, 0xe6a7,    BAD,    BAD,
/* 18 */ 0xe6a9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6aa,
/* 20 */ 0xe6ab,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6ae,
/* 28 */ 0xe6ac, 0xe6ad, 0xbae1, 0xb7d3,    BAD,    BAD, 0xc3d6,    BAD,
/* 30 */ 0xc8b3,    BAD, 0xbdf0,    BAD,    BAD, 0xc7cd,    BAD, 0xc8ed,
/* 38 */ 0xe6af, 0xd8ed,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x250 */
{
/* 00 */    BAD,    BAD, 0xe6b0, 0xe6b2,    BAD, 0xcde5, 0xe6b1, 0xe6b4,
/* 08 */ 0xe6b3,    BAD, 0xcdd3,    BAD, 0xe6b5,    BAD, 0xc8fe,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe6b6,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xe6b9,    BAD,    BAD, 0xe6b8, 0xe6b7,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe6ba, 0xb7b2,    BAD,    BAD,    BAD,
/* 28 */ 0xc1a2, 0xb5c1,    BAD,    BAD,    BAD,    BAD, 0xe6be, 0xe6bb,
/* 30 */    BAD,    BAD, 0xe6bc,    BAD,    BAD,    BAD, 0xe6bf,    BAD,
/* 38 */ 0xe6c0, 0xe6bd,    BAD,    BAD,    BAD, 0xb1a9,    BAD,    BAD
},

/* Row 0x251 */
{
/* 00 */    BAD, 0xb2a7,    BAD,    BAD,    BAD, 0xe6c2, 0xe6c3,    BAD,
/* 08 */    BAD,    BAD, 0xe6c4,    BAD, 0xcde2,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xbdac,    BAD, 0xe6c6, 0xe6c5,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xbfe9, 0xe6c7,    BAD,    BAD,    BAD,    BAD, 0xe6c8,    BAD,
/* 28 */    BAD, 0xe6c9,    BAD, 0xb4e5,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xb4cd,    BAD,    BAD, 0xe6ca,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe6cb,    BAD, 0xcbdd, 0xcde3,    BAD,    BAD,    BAD
},

/* Row 0x252 */
{
/* 00 */ 0xcdd4, 0xcfb7,    BAD, 0xb9cd, 0xe6ce, 0xbcd4, 0xe6cd,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe6cf, 0xbca9,    BAD,    BAD,    BAD,
/* 10 */ 0xc2d1,    BAD, 0xe6d0,    BAD,    BAD, 0xb9cc,    BAD, 0xccd7,
/* 18 */ 0xe6d1, 0xe6d2,    BAD,    BAD, 0xe6d3,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xe6d4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe6d5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xbcaa,    BAD,    BAD, 0xcced,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe6d7,    BAD, 0xc3bf,    BAD, 0xe6d6
},

/* Row 0x253 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6d9,    BAD,
/* 08 */    BAD,    BAD, 0xe6d8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe6da,    BAD,    BAD,    BAD, 0xc0bb,    BAD,
/* 18 */ 0xe6db,    BAD, 0xe6dc,    BAD,    BAD,    BAD, 0xcab9, 0xe6dd,
/* 20 */    BAD, 0xc1ef, 0xe6de,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe6df,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcefe,
/* 30 */ 0xe6e2,    BAD, 0xe6e1, 0xe6e0, 0xc4b0,    BAD, 0xe6e3, 0xbfa6,
/* 38 */    BAD, 0xe6e4,    BAD,    BAD,    BAD, 0xe6e5, 0xcfb8, 0xe6e6
},

/* Row 0x254 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe6e7, 0xe6e9, 0xe6e8, 0xc8a5,
/* 08 */    BAD, 0xc6f9,    BAD, 0xcfbe, 0xc8a9,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe6eb,    BAD,    BAD, 0xbed3,    BAD,
/* 18 */ 0xc9aa,    BAD, 0xe6ec, 0xe6ea,    BAD, 0xb4ce,    BAD,    BAD,
/* 20 */    BAD, 0xb8d4, 0xbbe8,    BAD,    BAD, 0xc8ee,    BAD,    BAD,
/* 28 */    BAD, 0xb8aa, 0xcbc3,    BAD, 0xe6ef, 0xe6ed,    BAD, 0xb9ce,
/* 30 */    BAD, 0xb9cf, 0xb0e9,    BAD, 0xbae8,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xc7d9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x255 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb0df, 0xe6f4,    BAD, 0xc3c0,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xc7d8,    BAD, 0xc2db,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6f6,    BAD,
/* 18 */    BAD, 0xe6f2, 0xe6f5, 0xe6f0,    BAD, 0xe6f3, 0xcba6,    BAD,
/* 20 */    BAD, 0xb8d5,    BAD,    BAD, 0xb0fd, 0xe6f1,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6f8,
/* 30 */    BAD, 0xe6f9,    BAD,    BAD, 0xc6b9,    BAD,    BAD,    BAD,
/* 38 */ 0xb6bb,    BAD,    BAD,    BAD, 0xe7a6, 0xc7bd,    BAD,    BAD
},

/* Row 0x256 */
{
/* 00 */    BAD,    BAD, 0xbbe9,    BAD,    BAD, 0xb6bc, 0xc0c8, 0xcfc6,
/* 08 */ 0xccae, 0xe6f7, 0xc0d4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xb5d3, 0xe6fa,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe6fc,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe6fb,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6fd,
/* 30 */    BAD, 0xc3a6,    BAD, 0xc7be,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xc4b1,    BAD,    BAD,    BAD,    BAD, 0xe7a3,    BAD
},

/* Row 0x257 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7a2,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe6fe,    BAD,    BAD, 0xbfd5,    BAD,
/* 10 */ 0xc9e5, 0xe7a5,    BAD, 0xe7a4, 0xb9d0, 0xcfd3,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7b5,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7a9, 0xe7aa,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xbcf0,    BAD,    BAD, 0xe7a8,    BAD,
/* 30 */ 0xb9f8, 0xe7a7,    BAD,    BAD, 0xe7ab,    BAD,    BAD,    BAD,
/* 38 */ 0xc4b2, 0xcaa2, 0xc1a3,    BAD,    BAD,    BAD,    BAD, 0xc2dc
},

/* Row 0x258 */
{
/* 00 */ 0xe7af,    BAD, 0xe7b0, 0xe7ac,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe7ad,    BAD, 0xe7ae,    BAD,    BAD,    BAD,    BAD, 0xb9d1,
/* 10 */    BAD,    BAD,    BAD, 0xe7b6,    BAD, 0xe7b2,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xc9e6,    BAD, 0xcbec, 0xc9a8,    BAD,    BAD,
/* 20 */ 0xe7b1,    BAD,    BAD, 0xe7b4, 0xe7b3,    BAD,    BAD,    BAD,
/* 28 */ 0xcbc4, 0xe7b7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xe7b8,    BAD,    BAD, 0xc1b7,    BAD, 0xe7b9,    BAD,    BAD,
/* 38 */ 0xe7bb,    BAD, 0xe7bf,    BAD,    BAD, 0xe7bc, 0xe7ba, 0xc7bf
},

/* Row 0x259 */
{
/* 00 */ 0xe7bd,    BAD, 0xe7be,    BAD,    BAD,    BAD, 0xb2b2,    BAD,
/* 08 */ 0xe7c5, 0xe7c0,    BAD,    BAD,    BAD, 0xe7c1,    BAD,    BAD,
/* 10 */    BAD, 0xe7c2,    BAD, 0xc2a1,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe7c4, 0xe7c3, 0xe7c6,    BAD,    BAD,    BAD,    BAD, 0xe7c7,
/* 20 */ 0xe7c8,    BAD,    BAD, 0xbfc3,    BAD, 0xb2e9,    BAD, 0xe7c9,
/* 28 */ 0xced7,    BAD, 0xbcab,    BAD,    BAD, 0xbdad,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xbbea, 0xc3d7,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe7ca, 0xe7cb, 0xb1b1,    BAD, 0xe7cc,    BAD
},

/* Row 0x25a */
{
/* 00 */    BAD, 0xe7cd, 0xe7ce,    BAD,    BAD, 0xe7cf,    BAD, 0xe7d0,
/* 08 */ 0xb6bd, 0xdaaa, 0xe7d1,    BAD, 0xc0e5, 0xe7d2, 0xbccb,    BAD,
/* 10 */ 0xe7d3,    BAD, 0xd0b0,    BAD,    BAD,    BAD, 0xe7d4, 0xcade,
/* 18 */ 0xb4dc,    BAD,    BAD, 0xc1a4, 0xbdd8,    BAD, 0xc9f1, 0xbdae,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe7d5, 0xb9d2, 0xe7d6, 0xc8cc,    BAD, 0xe7e4,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe7d8,    BAD, 0xc2c9, 0xc7f5, 0xb8bf,
/* 38 */ 0xe7d7, 0xc1a5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x25b */
{
/* 00 */ 0xe7d9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4fa,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xe7db, 0xe7da, 0xe7dd,    BAD,    BAD, 0xe7dc,    BAD, 0xe7de,
/* 20 */    BAD,    BAD, 0xe7e0,    BAD, 0xe7df,    BAD, 0xb4cf,    BAD,
/* 28 */ 0xe7e1,    BAD, 0xe7e2, 0xe7e3,    BAD,    BAD, 0xbab1, 0xcec9,
/* 30 */    BAD, 0xe7e5, 0xbfa7,    BAD,    BAD,    BAD, 0xb1f0, 0xe7e6,
/* 38 */ 0xe7e7,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7e8,    BAD
},

/* Row 0x25c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xb0f2,    BAD, 0xe7e9,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe7ea,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xc9e7,    BAD,    BAD,    BAD, 0xbcc7,    BAD, 0xe7ec,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb3a9, 0xb0b2,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe7eb, 0xe7ee, 0xc7ce,    BAD, 0xbfc4,
/* 30 */    BAD, 0xb2d6,    BAD, 0xcba7,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xb7dd, 0xb6dc,    BAD, 0xe7ed,    BAD, 0xb2ea,    BAD,    BAD
},

/* Row 0x25d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb4a3,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xb1f1, 0xe7f2, 0xceea, 0xc2dd,    BAD,    BAD, 0xc9c4,
/* 18 */    BAD, 0xe7fe,    BAD, 0xb2d7, 0xe7fc,    BAD, 0xe7fa, 0xe7f1,
/* 20 */    BAD, 0xe7ef,    BAD, 0xe7f0,    BAD, 0xbce3, 0xb6ec, 0xc3f7,
/* 28 */    BAD,    BAD,    BAD, 0xc6d1,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xb1d1,    BAD, 0xe7f4, 0xe7f3,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe7f9, 0xe7f5, 0xe7f8,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x25e */
{
/* 00 */    BAD,    BAD, 0xccd0, 0xe7f7, 0xb2d8, 0xb3fd, 0xe7fb,    BAD,
/* 08 */    BAD, 0xe7fd,    BAD,    BAD,    BAD,    BAD, 0xb7d4,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8a3, 0xe8ac,
/* 18 */ 0xe8ad,    BAD,    BAD,    BAD, 0xb0ab,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe8b4,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb0f1,    BAD,    BAD, 0xe8ab,    BAD,    BAD,    BAD, 0xe8aa,
/* 30 */    BAD, 0xe8a5, 0xe8a4,    BAD, 0xe8a2, 0xe8a1, 0xc3e3,    BAD,
/* 38 */ 0xc2fb, 0xe8a7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x25f */
{
/* 00 */ 0xe8a6,    BAD,    BAD,    BAD,    BAD, 0xe8a9,    BAD,    BAD,
/* 08 */    BAD, 0xc1f0, 0xb7d5,    BAD,    BAD,    BAD,    BAD, 0xb1c1,
/* 10 */ 0xe8a8,    BAD, 0xb9d3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xc1f1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe8ba,    BAD, 0xe8bb,    BAD, 0xb2d9,
/* 38 */    BAD,    BAD,    BAD, 0xb2ae, 0xe8b8,    BAD,    BAD,    BAD
},

/* Row 0x260 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8ae,    BAD, 0xe8b6,
/* 08 */    BAD, 0xe8bd, 0xe8b7,    BAD,    BAD,    BAD, 0xe8b5,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe7f6,    BAD,    BAD, 0xe8b3,    BAD,
/* 18 */    BAD,    BAD, 0xe8af,    BAD,    BAD,    BAD, 0xb4d0, 0xe8b1,
/* 20 */ 0xe8bc,    BAD, 0xe8b2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe8be,    BAD, 0xe8b0, 0xc7fc,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xcde9,    BAD,    BAD,    BAD, 0xe8b9,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8cf,    BAD,    BAD
},

/* Row 0x261 */
{
/* 00 */    BAD, 0xe8c7,    BAD,    BAD,    BAD, 0xbffb,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xb5c6,    BAD, 0xb6dd,    BAD, 0xe8c2,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xb2db,    BAD,    BAD, 0xbed4,    BAD,
/* 18 */ 0xe8c5,    BAD,    BAD,    BAD, 0xbada,    BAD,    BAD, 0xc5d1,
/* 20 */ 0xe8ca,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xcaee,    BAD, 0xe8c1,    BAD,    BAD,    BAD, 0xb2da,
/* 30 */ 0xb8d6, 0xc9a9, 0xe8cb,    BAD, 0xe8bf,    BAD,    BAD, 0xe8c8,
/* 38 */    BAD,    BAD,    BAD, 0xe8d2,    BAD, 0xe8c3,    BAD,    BAD
},

/* Row 0x262 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe8c4, 0xc6ba,    BAD,    BAD, 0xe8c9,
/* 08 */    BAD,    BAD,    BAD, 0xe8c6, 0xcba8, 0xe8cc, 0xb0e0,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe8c0,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe8ce,    BAD, 0xe8cd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xc7eb, 0xe8d4,    BAD, 0xe8df,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xb3fe,    BAD,    BAD,    BAD, 0xe8e2,    BAD,    BAD,
/* 38 */ 0xe8d0,    BAD,    BAD,    BAD, 0xe8d5, 0xcdee,    BAD,    BAD
},

/* Row 0x263 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8de,    BAD,
/* 08 */    BAD, 0xcdd5,    BAD,    BAD,    BAD,    BAD, 0xceaa,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc3f8,
/* 18 */    BAD,    BAD,    BAD, 0xb3eb,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xc9f2, 0xe8e4, 0xc6a1,    BAD,    BAD, 0xb0b1,    BAD,
/* 28 */    BAD, 0xe8dd,    BAD, 0xe8d9, 0xc1f2, 0xe8d3, 0xe8db, 0xe8e0,
/* 30 */    BAD, 0xc7ac,    BAD,    BAD,    BAD, 0xb0aa,    BAD, 0xe8d8,
/* 38 */    BAD, 0xe8e1, 0xc9f8,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x264 */
{
/* 00 */    BAD,    BAD, 0xe8dc,    BAD, 0xe8d7,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xbed5,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xbdaf,    BAD,    BAD,    BAD, 0xbcac,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xccd8,    BAD,    BAD, 0xc9c7,    BAD,    BAD, 0xe8e7,
/* 20 */    BAD, 0xe8f0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8da,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xb3f7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xbef8, 0xe8e5,    BAD, 0xe8ea, 0xc1f3,    BAD,    BAD, 0xe8e6
},

/* Row 0x265 */
{
/* 00 */    BAD, 0xe8ed,    BAD,    BAD, 0xc3df,    BAD, 0xe8ee,    BAD,
/* 08 */    BAD, 0xcdd6, 0xe8e3, 0xb3b8,    BAD, 0xe8e9,    BAD,    BAD,
/* 10 */ 0xe8ec, 0xccac,    BAD,    BAD,    BAD,    BAD, 0xe8ef,    BAD,
/* 18 */    BAD, 0xe8e8, 0xe8eb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xcba9,    BAD, 0xcfa1,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe8f3,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xe8fa,    BAD,    BAD, 0xe8f2
},

/* Row 0x266 */
{
/* 00 */ 0xbcc3,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8d1,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xcace,    BAD, 0xcca2, 0xe8f9, 0xe8f8,    BAD, 0xe8f4,
/* 18 */ 0xe8f5,    BAD, 0xb1b6,    BAD,    BAD,    BAD,    BAD, 0xe8f7,
/* 20 */    BAD, 0xe8f1,    BAD,    BAD,    BAD,    BAD, 0xc4d5,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe8f6, 0xb0fe,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc2a2,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcac3,    BAD,    BAD
},

/* Row 0x267 */
{
/* 00 */ 0xe8fb, 0xe9a1,    BAD, 0xc8d9,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe8fe, 0xbed6, 0xbcc9, 0xe9a3,    BAD,    BAD, 0xb6be,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9a4,    BAD, 0xc9f9,
/* 18 */ 0xe8fd,    BAD, 0xe8d6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe8fc,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xcfcf, 0xc6a2, 0xc9f3,    BAD,    BAD, 0xe9ab,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9b1,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9b2,    BAD
},

/* Row 0x268 */
{
/* 00 */ 0xe9a5,    BAD,    BAD,    BAD, 0xc7f6,    BAD,    BAD, 0xe9af,
/* 08 */ 0xe9a7,    BAD, 0xe9a9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xe9b3, 0xe9a8,    BAD,    BAD, 0xe9ac,    BAD,    BAD, 0xb1f2,
/* 18 */    BAD, 0xc6e5,    BAD, 0xe9ad, 0xe9b0,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xe9a6,    BAD, 0xc1a6,    BAD,
/* 28 */ 0xe9aa, 0xbba7, 0xbfc5, 0xb7b0, 0xccf4,    BAD, 0xccf9, 0xbdf2,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe9b7, 0xe9b5,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x269 */
{
/* 00 */    BAD, 0xcfce,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe9b4,    BAD,    BAD,    BAD, 0xcdf5,    BAD, 0xe9b6,
/* 10 */ 0xe9b8,    BAD,    BAD,    BAD,    BAD, 0xe9b9,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xe9bc, 0xe9ba,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xc6a3, 0xe9bb,    BAD,    BAD,
/* 28 */    BAD, 0xc8cd, 0xe9ae,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbdf3,
/* 38 */    BAD, 0xe9bd, 0xe9c2, 0xc1f4,    BAD,    BAD, 0xe9c1,    BAD
},

/* Row 0x26a */
{
/* 00 */    BAD,    BAD, 0xe9a2,    BAD,    BAD,    BAD, 0xe9c3, 0xc1c9,
/* 08 */    BAD,    BAD, 0xe9be, 0xe9c0,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe9bf,    BAD,    BAD, 0xddb1, 0xdda2,
/* 18 */    BAD,    BAD, 0xe9c5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xe9c4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcdf6,    BAD, 0xe2bc,
/* 30 */ 0xe9c6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9c7
},

/* Row 0x26b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9c8, 0xb8d7,    BAD,
/* 10 */ 0xb5d4,    BAD,    BAD,    BAD, 0xe9ca, 0xd1dd,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xb5f5,    BAD, 0xceba,    BAD, 0xb6f3, 0xe9cb,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9cc,
/* 28 */    BAD,    BAD,    BAD, 0xc3ee,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xe9cd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xc6fa,    BAD, 0xb0ba,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x26c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xb2e3, 0xe9d2, 0xe9d3,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe9ce,    BAD, 0xbbbd,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xe9cf, 0xc7c2,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe9d0, 0xe9d1, 0xe9db,    BAD,    BAD,    BAD, 0xe9d5,
/* 30 */ 0xe9d8,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9d4,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x26d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xe9d6,    BAD, 0xe9d7, 0xbcd8,
/* 08 */    BAD, 0xe9d9,    BAD, 0xc3c1,    BAD, 0xb7d6, 0xb3c2,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xe9dc,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xb3bf,    BAD, 0xe9e1,    BAD,    BAD, 0xe9dd, 0xe9e0,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xc8ba,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe9de,    BAD,    BAD, 0xe9df, 0xc9c8, 0xc8da, 0xe9e2,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xc2fd, 0xe9ec,    BAD, 0xe9e8,    BAD,    BAD, 0xb2eb,    BAD
},

/* Row 0x26e */
{
/* 00 */ 0xe9e6,    BAD, 0xcbaa, 0xe9e7,    BAD,    BAD, 0xe9e4,    BAD,
/* 08 */ 0xe9e5, 0xe9ea, 0xe9ed,    BAD,    BAD, 0xe9eb,    BAD,    BAD,
/* 10 */    BAD, 0xe9e9, 0xe9e3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xc3d8,    BAD, 0xe9f4,    BAD, 0xccaa,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9f2,    BAD,    BAD,
/* 28 */    BAD, 0xe9f3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe9ee,    BAD,    BAD, 0xe9f0,
/* 38 */    BAD,    BAD,    BAD, 0xe9f1,    BAD,    BAD,    BAD, 0xe9ef
},

/* Row 0x26f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xc0e6,    BAD, 0xcfb9, 0xe9f8,    BAD, 0xe9f9,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xeaa1,    BAD, 0xbfaa,    BAD, 0xe9fb,
/* 18 */    BAD, 0xe9fe,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9f6,
/* 20 */ 0xe9f5,    BAD,    BAD, 0xeaa2,    BAD,    BAD, 0xb2dc,    BAD,
/* 28 */ 0xe9fc,    BAD, 0xeaa3,    BAD,    BAD,    BAD, 0xe9fd,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xe9fa,    BAD, 0xc4b3,    BAD,
/* 38 */ 0xe9f7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc7e8
},

/* Row 0x270 */
{
/* 00 */    BAD,    BAD, 0xeaa7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcdbb,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeaa6,
/* 20 */    BAD,    BAD, 0xeaa5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xeaae,    BAD,    BAD,    BAD, 0xeaa8,
/* 30 */    BAD,    BAD,    BAD, 0xeab0,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xcde6, 0xeab3,    BAD, 0xeaaa,    BAD,    BAD
},

/* Row 0x271 */
{
/* 00 */ 0xeaab,    BAD,    BAD,    BAD, 0xeaaf,    BAD, 0xeab2, 0xeab1,
/* 08 */    BAD,    BAD,    BAD, 0xeaa9,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xeaac,    BAD, 0xeabd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xeab6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeab4,
/* 30 */    BAD,    BAD, 0xeab5,    BAD,    BAD,    BAD, 0xeaba, 0xeabb,
/* 38 */    BAD, 0xb3aa,    BAD, 0xb5c2,    BAD,    BAD, 0xeab9,    BAD
},

/* Row 0x272 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xeaa4,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xeab8, 0xeabc, 0xeab7,
/* 10 */    BAD, 0xeabe,    BAD,    BAD,    BAD, 0xeac0, 0xeabf,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xeac2, 0xeac1, 0xe9da,    BAD,    BAD,    BAD, 0xeac6,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xeac3,    BAD,    BAD,    BAD,    BAD, 0xeac4,    BAD,
/* 38 */    BAD, 0xeac5,    BAD, 0xeac7,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x273 */
{
/* 00 */ 0xb7ec,    BAD, 0xeac9,    BAD, 0xeac8,    BAD, 0xbdb0,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xb9d4, 0xdea7,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xeaca, 0xbdd1,    BAD,    BAD,    BAD, 0xb3b9,
/* 18 */    BAD, 0xeacb,    BAD, 0xb1d2,    BAD, 0xbed7, 0xeacc,    BAD,
/* 20 */    BAD, 0xb9d5, 0xeacd, 0xb0e1,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xc9bd,    BAD,    BAD, 0xeace,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xbfea,    BAD, 0xead5,    BAD,    BAD, 0xead2,    BAD, 0xc3ef,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xead3, 0xead0, 0xb6de
},

/* Row 0x274 */
{
/* 00 */    BAD, 0xeacf, 0xead6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xb7b6,    BAD,    BAD, 0xc2de,    BAD, 0xeadc,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xead8,    BAD,    BAD,    BAD, 0xc2b5, 0xead7,
/* 18 */    BAD, 0xeada,    BAD,    BAD,    BAD,    BAD, 0xead1,    BAD,
/* 20 */    BAD,    BAD, 0xeadb,    BAD, 0xeadd,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xc8ef,    BAD,    BAD, 0xead9,    BAD,
/* 30 */ 0xeade, 0xeae0,    BAD,    BAD, 0xb8d3, 0xead4,    BAD, 0xb0c1,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeadf
},

/* Row 0x275 */
{
/* 00 */    BAD, 0xbadb, 0xcef6, 0xeae1, 0xeae2, 0xc1f5,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcea2,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xeae3, 0xcdb5,    BAD,    BAD,
/* 18 */ 0xeae4, 0xeae5,    BAD,    BAD, 0xcae4, 0xeae6,    BAD, 0xbac0,
/* 20 */    BAD, 0xcea3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xeaeb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xeaec, 0xbed8, 0xeaea,    BAD,    BAD,    BAD,
/* 38 */ 0xcde7, 0xeae7,    BAD,    BAD, 0xeae9, 0xc0bd, 0xbffe,    BAD
},

/* Row 0x276 */
{
/* 00 */    BAD,    BAD, 0xeae8,    BAD, 0xeaed,    BAD,    BAD, 0xcaa3,
/* 08 */    BAD,    BAD, 0xeaef,    BAD, 0xeaee,    BAD,    BAD,    BAD,
/* 10 */ 0xb3ec,    BAD, 0xcbab, 0xeaf0,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xeafc, 0xeaf2,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xeaf3,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xeaf4, 0xeaf5,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeaf9,    BAD,
/* 38 */ 0xeafa,    BAD,    BAD, 0xeaf8,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x277 */
{
/* 00 */    BAD, 0xeaf6,    BAD, 0xeaf1, 0xeaf7,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xeafb, 0xf0b7,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb2a8,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeafe, 0xb6df,
/* 20 */ 0xeafd,    BAD,    BAD,    BAD, 0xeba2,    BAD, 0xeba1,    BAD,
/* 28 */    BAD,    BAD, 0xeba4,    BAD,    BAD, 0xeba3,    BAD, 0xeba5,
/* 30 */    BAD,    BAD, 0xbdb1,    BAD, 0xeba6,    BAD,    BAD, 0xeba7,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeba8, 0xc0be
},

/* Row 0x278 */
{
/* 00 */    BAD, 0xcdd7,    BAD, 0xeba9,    BAD,    BAD, 0xcaa4, 0xc7c6,
/* 08 */ 0xebaa,    BAD, 0xebab, 0xb8ab,    BAD,    BAD,    BAD, 0xb5ac,
/* 10 */    BAD,    BAD,    BAD, 0xebac,    BAD,    BAD, 0xbbeb, 0xc7c1,
/* 18 */ 0xebad,    BAD, 0xb3d0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xebae,    BAD,    BAD,    BAD,    BAD, 0xebb0, 0xcdf7,
/* 28 */    BAD, 0xebaf, 0xbfc6,    BAD, 0xebb1,    BAD,    BAD, 0xebb2,
/* 30 */    BAD,    BAD, 0xebb3, 0xb4d1,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xebb4,    BAD,    BAD, 0xebb5,    BAD, 0xebb6
},

/* Row 0x279 */
{
/* 00 */ 0xebb7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xb3d1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xebb8,    BAD, 0xebb9, 0xebba,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xb2f2,    BAD,    BAD, 0xbfa8, 0xebbb,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xebbc,    BAD,    BAD,    BAD,
/* 38 */ 0xebbd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x27a */
{
/* 00 */ 0xb8c0,    BAD, 0xc4fb, 0xebbe,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xb7d7,    BAD, 0xbfd6,    BAD, 0xebc1,    BAD, 0xc6a4,    BAD,
/* 10 */ 0xebc0,    BAD,    BAD, 0xb7b1,    BAD,    BAD, 0xebbf, 0xc2f7,
/* 18 */ 0xb5ad,    BAD,    BAD, 0xebc2,    BAD, 0xebc3,    BAD, 0xbed9,
/* 20 */    BAD,    BAD,    BAD, 0xb7ed,    BAD, 0xebc4,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xcbac,    BAD,    BAD, 0xc0df,    BAD,    BAD,
/* 30 */    BAD, 0xb5f6,    BAD, 0xccf5, 0xc1ca,    BAD, 0xebc5,    BAD,
/* 38 */    BAD,    BAD, 0xbfc7, 0xc3f0, 0xbeda,    BAD,    BAD,    BAD
},

/* Row 0x27b */
{
/* 00 */    BAD, 0xebc6,    BAD,    BAD,    BAD,    BAD, 0xebc9,    BAD,
/* 08 */ 0xebca,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xbabe, 0xc2c2, 0xebc8,    BAD, 0xbedb, 0xc9be,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xebc7,    BAD,    BAD, 0xbbec,    BAD,
/* 20 */ 0xb1d3,    BAD, 0xebce, 0xb7d8,    BAD,    BAD, 0xbbee,    BAD,
/* 28 */    BAD, 0xbbed,    BAD, 0xcfcd, 0xebcd, 0xebcc, 0xc1a7,    BAD,
/* 30 */ 0xb5cd, 0xcfc3, 0xb3ba, 0xbedc,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xebcb,    BAD,    BAD,    BAD
},

/* Row 0x27c */
{
/* 00 */    BAD,    BAD, 0xebd0,    BAD, 0xebd1, 0xebcf,    BAD, 0xb8d8,
/* 08 */    BAD, 0xcdc0,    BAD,    BAD, 0xbbef, 0xc7a7,    BAD,    BAD,
/* 10 */    BAD, 0xebd4,    BAD, 0xc0c0,    BAD, 0xc3c2,    BAD,    BAD,
/* 18 */ 0xcdb6,    BAD, 0xebd7,    BAD,    BAD,    BAD, 0xb8ec,    BAD,
/* 20 */ 0xc0bf, 0xebd3,    BAD, 0xebd8, 0xb8ed, 0xebd5, 0xebd6,    BAD,
/* 28 */ 0xebd2,    BAD,    BAD,    BAD, 0xc0e2, 0xc6c9,    BAD,    BAD,
/* 30 */ 0xc3af,    BAD, 0xb2dd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xc8f0,    BAD,    BAD, 0xb5c3,    BAD,    BAD, 0xc4b4
},

/* Row 0x27d */
{
/* 00 */    BAD,    BAD, 0xebdb,    BAD, 0xebd9,    BAD,    BAD, 0xc3cc,
/* 08 */    BAD,    BAD,    BAD, 0xc0c1, 0xb4d2, 0xebda,    BAD, 0xbfdb,
/* 10 */    BAD,    BAD, 0xceca,    BAD,    BAD,    BAD, 0xcfc0,    BAD,
/* 18 */    BAD,    BAD, 0xebdc, 0xebe7, 0xc4b5,    BAD, 0xebe6,    BAD,
/* 20 */ 0xebe3, 0xebeb, 0xebe4,    BAD, 0xebe0,    BAD, 0xc4fc, 0xebdf,
/* 28 */    BAD,    BAD,    BAD, 0xebdd,    BAD, 0xcda1, 0xbbf0,    BAD,
/* 30 */    BAD, 0xebe1,    BAD, 0xebde,    BAD,    BAD,    BAD, 0xebe5,
/* 38 */ 0xbdf4,    BAD, 0xb8c1,    BAD,    BAD,    BAD, 0xc2fa,    BAD
},

/* Row 0x27e */
{
/* 00 */ 0xcbc5, 0xb1da, 0xb0e2,    BAD, 0xc6a5,    BAD,    BAD, 0xebe9,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xebe8,    BAD, 0xc6e6,    BAD,
/* 10 */ 0xebed,    BAD,    BAD,    BAD, 0xebe2,    BAD, 0xebec, 0xebee,
/* 18 */    BAD, 0xb8ac, 0xebea, 0xb9d6,    BAD, 0xbcd5,    BAD,    BAD,
/* 20 */ 0xebef, 0xcdd8,    BAD,    BAD,    BAD,    BAD, 0xebf2,    BAD,
/* 28 */ 0xebf5,    BAD,    BAD, 0xebf3, 0xc9b5,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xebf0,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb6e0,    BAD,    BAD,    BAD,    BAD, 0xebf4,    BAD
},

/* Row 0x27f */
{
/* 00 */    BAD, 0xebf6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xebfa,    BAD,    BAD, 0xebf7,    BAD, 0xebf9, 0xebf8,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xebfb,    BAD,
/* 18 */ 0xbcb1,    BAD, 0xebfd, 0xebfc, 0xc9e8,    BAD,    BAD, 0xeca1,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7d9,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xebfe, 0xeca2,    BAD,    BAD, 0xeca3,
/* 30 */ 0xb5c4, 0xe6c1, 0xbef9,    BAD, 0xeca4,    BAD,    BAD, 0xb8ee,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xeca5,    BAD,    BAD
},

/* Row 0x280 */
{
/* 00 */ 0xeca6,    BAD,    BAD, 0xbbbe,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xdace,    BAD, 0xeca7,    BAD, 0xeca8,    BAD,
/* 10 */ 0xbdb2,    BAD, 0xeca9, 0xecaa,    BAD,    BAD, 0xecab,    BAD,
/* 18 */    BAD, 0xecac, 0xecad,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x281 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc3ab,
/* 38 */    BAD,    BAD, 0xecae,    BAD,    BAD,    BAD,    BAD, 0xecb0
},

/* Row 0x282 */
{
/* 00 */    BAD, 0xecaf,    BAD,    BAD,    BAD,    BAD, 0xc6a6,    BAD,
/* 08 */ 0xecb1,    BAD, 0xcbad,    BAD, 0xecb2,    BAD, 0xecb3,    BAD,
/* 10 */ 0xecb4,    BAD,    BAD,    BAD,    BAD, 0xecb5,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xc6da,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xbedd, 0xecb6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xb9eb, 0xd0ae, 0xecb7,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xecb8, 0xc9bf, 0xecb9,    BAD, 0xecc1,    BAD,    BAD,    BAD
},

/* Row 0x283 */
{
/* 00 */    BAD,    BAD, 0xecba,    BAD,    BAD, 0xecbc,    BAD,    BAD,
/* 08 */    BAD, 0xecbb, 0xecbd,    BAD, 0xcbc6, 0xecbe, 0xecbf,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xecc0,    BAD,    BAD,    BAD,
/* 18 */ 0xecc2,    BAD,    BAD,    BAD,    BAD, 0xb3ad, 0xc4e7,    BAD,
/* 20 */ 0xc9e9, 0xbae2, 0xb9d7,    BAD,    BAD,    BAD,    BAD, 0xc9cf,
/* 28 */ 0xb2df, 0xc8ce, 0xecc5, 0xb4d3, 0xc0d5, 0xecc4, 0xecc9, 0xc3f9,
/* 30 */ 0xcce3,    BAD, 0xecc7, 0xecc8, 0xb5ae,    BAD, 0xecca, 0xc7e3,
/* 38 */ 0xc2df,    BAD,    BAD, 0xc8f1, 0xc5bd, 0xecc6,    BAD, 0xcbc7
},

/* Row 0x284 */
{
/* 00 */ 0xb2ec, 0xeccc, 0xcfa8, 0xc4c2, 0xcfc5,    BAD,    BAD, 0xbbf1,
/* 08 */ 0xeccb,    BAD, 0xc2b1,    BAD,    BAD, 0xecdc, 0xc1a8,    BAD,
/* 10 */    BAD, 0xc6f8,    BAD, 0xc9d0,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xeccf, 0xbbbf, 0xbbf2,    BAD, 0xbede,    BAD,
/* 20 */ 0xc7e5,    BAD, 0xb8ad, 0xecce, 0xeccd,    BAD, 0xc9ea,    BAD,
/* 28 */    BAD,    BAD, 0xbcc1,    BAD,    BAD, 0xc5d2,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xecd1, 0xecd2, 0xb9d8, 0xecd0,    BAD,    BAD
},

/* Row 0x285 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xecd3, 0xecd4,    BAD, 0xecd6,
/* 08 */ 0xc2a3,    BAD, 0xecd5, 0xb4e6,    BAD, 0xecd8,    BAD, 0xecd7,
/* 10 */ 0xecd9,    BAD,    BAD, 0xecdb, 0xecdd,    BAD, 0xecde,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x286 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xc0d6,    BAD, 0xbccf, 0xecdf,
/* 28 */    BAD,    BAD,    BAD, 0xb3d2,    BAD, 0xece0,    BAD,    BAD,
/* 30 */ 0xc1f6, 0xece1,    BAD, 0xece2, 0xc9eb,    BAD,    BAD, 0xb5af,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x287 */
{
/* 00 */    BAD, 0xece3,    BAD,    BAD,    BAD, 0xc4b6,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xb1db,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xece4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xbcf1,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xbff6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xc2ad,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xece7,    BAD,    BAD,    BAD, 0xece6,    BAD
},

/* Row 0x288 */
{
/* 00 */    BAD,    BAD, 0xece5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xeced, 0xeceb,    BAD,    BAD, 0xece8,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xecea,    BAD,
/* 18 */    BAD,    BAD, 0xece9, 0xecec,    BAD, 0xb5f7,    BAD, 0xecf0,
/* 20 */    BAD, 0xc0d7,    BAD, 0xecf1,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb8d9,    BAD, 0xecee, 0xecef,    BAD,    BAD,    BAD, 0xcfa9,
/* 30 */    BAD,    BAD,    BAD, 0xc4b7,    BAD, 0xc1a9,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xecf2,    BAD,    BAD, 0xecf5
},

/* Row 0x289 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xecf3, 0xecf4, 0xcdd9,    BAD,    BAD,    BAD,    BAD, 0xc6a7,
/* 10 */ 0xecf8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xecf6, 0xecf7, 0xecf9,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xeda9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xecfc,    BAD,    BAD,    BAD, 0xecfd, 0xecfb,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x28a */
{
/* 00 */    BAD,    BAD, 0xecfa,    BAD, 0xc4fd,    BAD,    BAD, 0xeda1,
/* 08 */ 0xeda5, 0xeda2, 0xecfe,    BAD, 0xeda3,    BAD,    BAD,    BAD,
/* 10 */ 0xeda4,    BAD,    BAD,    BAD,    BAD, 0xedab,    BAD,    BAD,
/* 18 */    BAD, 0xeda6,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc0d8,
/* 20 */ 0xeda8,    BAD,    BAD, 0xedaa, 0xeda7,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xedad,    BAD, 0xbdb3,    BAD, 0xedac,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xedae,    BAD,    BAD,    BAD
},

/* Row 0x28b */
{
/* 00 */    BAD, 0xedaf,    BAD,    BAD, 0xedb2, 0xedb1,    BAD, 0xedb0,
/* 08 */    BAD,    BAD, 0xedb4, 0xedb3,    BAD, 0xccf6,    BAD,    BAD,
/* 10 */    BAD, 0xedb6,    BAD, 0xedb5, 0xedb7,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xedb8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xedba,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xedb9, 0xbfc8, 0xedbb,    BAD,    BAD, 0xb6ed,
/* 30 */ 0xedbc, 0xedbe,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xedbf,    BAD
},

/* Row 0x28c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xedc0, 0xedbd,    BAD,
/* 08 */ 0xedc1,    BAD, 0xbcd6, 0xedc2, 0xb5b0, 0xb7b3,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xb8ae,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xedc3,    BAD,    BAD,    BAD, 0xc6f0,
/* 20 */    BAD,    BAD, 0xc5be, 0xedc4,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xedc7,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xbcb4,    BAD,    BAD, 0xedc6, 0xedc5, 0xb7da, 0xedc8,    BAD
},

/* Row 0x28d */
{
/* 00 */    BAD,    BAD,    BAD, 0xb3d3,    BAD, 0xedca,    BAD,    BAD,
/* 08 */    BAD, 0xbadc, 0xedc9,    BAD, 0xedd2,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xedcc, 0xedce, 0xcae5, 0xedcb,    BAD,    BAD,
/* 18 */    BAD, 0xedcd,    BAD, 0xedd1, 0xedcf, 0xb5b1,    BAD, 0xedd0,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xedd3,    BAD,
/* 28 */    BAD, 0xc7da, 0xced8,    BAD,    BAD,    BAD,    BAD, 0xbdb4,
/* 30 */    BAD,    BAD,    BAD, 0xedd4,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xcda2, 0xedd6,    BAD, 0xedd5,    BAD,    BAD, 0xedd9, 0xcdc1
},

/* Row 0x28e */
{
/* 00 */    BAD,    BAD, 0xedd8,    BAD, 0xb3ed, 0xedd7, 0xeddc,    BAD,
/* 08 */    BAD, 0xeddb,    BAD,    BAD, 0xedda, 0xc5b2, 0xeddd,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xedde,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xeddf,    BAD,    BAD, 0xb9ec,
/* 20 */    BAD, 0xb7a5, 0xede0, 0xede1, 0xede2,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x28f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xbfc9, 0xede3,    BAD, 0xbcad, 0xede4,
/* 20 */    BAD,    BAD,    BAD, 0xede5,    BAD,    BAD,    BAD, 0xd2a1,
/* 28 */ 0xd1fe,    BAD,    BAD,    BAD,    BAD, 0xede6, 0xe5f0, 0xede7,
/* 30 */ 0xc3a4, 0xbfab, 0xc7c0,    BAD,    BAD,    BAD,    BAD, 0xede8,
/* 38 */    BAD,    BAD, 0xcad5, 0xc4d4, 0xb9fe,    BAD,    BAD, 0xc3a9
},

/* Row 0x290 */
{
/* 00 */    BAD,    BAD, 0xb1aa,    BAD, 0xcbf8, 0xbfd7,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7de,    BAD,
/* 10 */    BAD, 0xb6e1,    BAD,    BAD, 0xcad6,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xede9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xedeb,    BAD,    BAD, 0xedea, 0xb2e0,    BAD,
/* 28 */    BAD, 0xc6f6, 0xedec, 0xc7f7,    BAD, 0xc5b3,    BAD, 0xeded,
/* 30 */ 0xbdd2,    BAD,    BAD,    BAD, 0xedef,    BAD,    BAD, 0xccc2,
/* 38 */ 0xedfe, 0xedf1, 0xedf2,    BAD,    BAD, 0xc4c9,    BAD,    BAD
},

/* Row 0x291 */
{
/* 00 */ 0xc2e0, 0xc1f7,    BAD, 0xc6a8,    BAD, 0xedf0, 0xb5d5,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xedf9,    BAD, 0xedf6, 0xeea5, 0xc6a9,
/* 10 */ 0xc3e0, 0xedf3,    BAD, 0xc4fe, 0xc5d3, 0xedf4, 0xedf8, 0xbfe0,
/* 18 */    BAD, 0xc7e7, 0xc4cc,    BAD,    BAD, 0xc0c2, 0xedf7, 0xc2ae,
/* 20 */ 0xc2a4, 0xedf5, 0xb0a9, 0xcfa2,    BAD,    BAD,    BAD, 0xedfa,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc2e1,    BAD,
/* 30 */    BAD, 0xbdb5, 0xbfca,    BAD,    BAD, 0xedfc, 0xedfb,    BAD,
/* 38 */ 0xb0ef, 0xedfd,    BAD,    BAD, 0xc9af,    BAD, 0xeea7,    BAD
},

/* Row 0x292 */
{
/* 00 */    BAD, 0xc6db, 0xbfeb,    BAD,    BAD, 0xc3d9,    BAD, 0xb6f8,
/* 08 */    BAD, 0xeea6, 0xcdb7, 0xb1bf,    BAD, 0xcad7, 0xb2e1, 0xeea1,
/* 10 */ 0xeea2, 0xeea3, 0xeea4, 0xc6bb, 0xc3a3, 0xb0e3, 0xeea8,    BAD,
/* 18 */ 0xeea9, 0xf4a3,    BAD,    BAD, 0xc2bd,    BAD, 0xeeaa,    BAD,
/* 20 */ 0xb1f3, 0xc1cc,    BAD, 0xb8af,    BAD, 0xcdda,    BAD,    BAD,
/* 28 */ 0xeeab, 0xc5ac,    BAD,    BAD,    BAD, 0xc1f8, 0xbcd7, 0xeeac,
/* 30 */    BAD,    BAD, 0xeeaf,    BAD,    BAD, 0xbde5, 0xeead, 0xc1ab,
/* 38 */ 0xc1aa,    BAD, 0xb0e4,    BAD, 0xcecb, 0xeeb1,    BAD, 0xc8f2
},

/* Row 0x293 */
{
/* 00 */ 0xeeb3, 0xeeb2, 0xeeb0, 0xe3e4, 0xb4d4,    BAD,    BAD, 0xedee,
/* 08 */    BAD, 0xeeb5, 0xeeb4,    BAD,    BAD,    BAD,    BAD, 0xeeb6,
/* 10 */    BAD, 0xcdb8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xc6e1,    BAD,    BAD, 0xcbae,    BAD,
/* 28 */ 0xeeb7,    BAD, 0xbcd9,    BAD,    BAD,    BAD,    BAD, 0xeeb8,
/* 30 */    BAD, 0xeeb9,    BAD,    BAD,    BAD, 0xeeba,    BAD,    BAD,
/* 38 */ 0xc5a1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x294 */
{
/* 00 */    BAD, 0xb0ea,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xb9d9,    BAD,    BAD,    BAD, 0xcfba,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xeebe,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xb7b4, 0xeebb,    BAD, 0xeebc,    BAD,    BAD,    BAD,
/* 28 */ 0xc9f4,    BAD,    BAD,    BAD,    BAD, 0xb3d4,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcdb9,    BAD, 0xb6bf,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5d4,    BAD,    BAD
},

/* Row 0x295 */
{
/* 00 */    BAD,    BAD, 0xeebf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xeec0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xeec1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5a2,    BAD,    BAD,
/* 30 */ 0xeec3,    BAD, 0xeec2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x296 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xc6d3, 0xeec4, 0xbdb6, 0xbce0, 0xc7db, 0xc3f1,    BAD,
/* 10 */    BAD,    BAD, 0xbcf2,    BAD, 0xbfec,    BAD, 0xeec5,    BAD,
/* 18 */ 0xeec6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xbfdd, 0xeec7,    BAD, 0xeec8,    BAD,    BAD,
/* 28 */    BAD, 0xeec9, 0xcdef,    BAD, 0xbdb7,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xeecb, 0xeeca,    BAD, 0xb9da,    BAD, 0xb9f3,
/* 38 */ 0xbbc0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x297 */
{
/* 00 */    BAD,    BAD, 0xeece,    BAD,    BAD,    BAD,    BAD, 0xbde6,
/* 08 */    BAD, 0xeecd,    BAD, 0xeecc,    BAD, 0xc2e9,    BAD,    BAD,
/* 10 */ 0xb8ef,    BAD, 0xc0c3,    BAD,    BAD,    BAD,    BAD, 0xc8b0,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xbdb9,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xeecf,    BAD, 0xbedf,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xeed2, 0xeed0,    BAD,    BAD,    BAD, 0xeed1,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xeed4, 0xeed3,    BAD,    BAD,
/* 38 */ 0xbefa,    BAD, 0xeed5,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x298 */
{
/* 00 */ 0xeed6, 0xeed7,    BAD,    BAD,    BAD,    BAD, 0xc8d0, 0xbad3,
/* 08 */ 0xbce1, 0xeed8,    BAD, 0xeed9, 0xcea4, 0xbdc5, 0xccee, 0xcecc,
/* 10 */ 0xeeda, 0xb6e2,    BAD,    BAD,    BAD,    BAD, 0xeedb,    BAD,
/* 18 */ 0xc5a3,    BAD,    BAD, 0xeede, 0xb3f8, 0xbfcb,    BAD, 0xeedc,
/* 20 */    BAD, 0xeedd,    BAD, 0xc4e0,    BAD,    BAD, 0xcbd5, 0xb6fc,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xeee0, 0xeee1,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xeedf,    BAD,    BAD, 0xeee3
},

/* Row 0x299 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc6df, 0xb3c3,    BAD,
/* 10 */    BAD, 0xeee7,    BAD,    BAD, 0xeee4, 0xeee6,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeee2,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xefcf,    BAD,    BAD, 0xeee5,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xceeb,    BAD,    BAD, 0xb8da,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeeef
},

/* Row 0x29a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xc5b4, 0xeeea,    BAD,    BAD,
/* 08 */ 0xeeed, 0xeeeb,    BAD, 0xeef0,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xeef1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeee9,
/* 18 */    BAD,    BAD, 0xeef6, 0xb1f4,    BAD,    BAD, 0xeee8,    BAD,
/* 20 */    BAD,    BAD, 0xc8ad,    BAD, 0xeeec,    BAD, 0xbee0,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xb9db,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcbc8,    BAD
},

/* Row 0x29b */
{
/* 00 */ 0xb6e4,    BAD,    BAD, 0xbdc6,    BAD, 0xc6bc,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xc1ad,    BAD, 0xeef4,    BAD, 0xeeee, 0xeef3,    BAD,
/* 18 */ 0xccc3,    BAD, 0xc4b8, 0xeef5, 0xeef2,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc1ac,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeef9,
/* 38 */    BAD, 0xeef8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x29c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeef7,
/* 10 */    BAD,    BAD, 0xcbaf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xbdfb,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xeefa, 0xcadf,    BAD,    BAD, 0xb1d4,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xc9c6, 0xc3f2,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xb5f8,    BAD, 0xeefc,    BAD, 0xb9dd,    BAD,    BAD,    BAD
},

/* Row 0x29d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbbac,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeefb,
/* 10 */ 0xbfed,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xbfee, 0xefa1, 0xefa3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xbefb,    BAD, 0xefa2, 0xefa4,    BAD,    BAD, 0xb6d3,    BAD,
/* 28 */ 0xc9c5,    BAD,    BAD, 0xbce2, 0xcfa3,    BAD, 0xeefe, 0xbaf8,
/* 30 */    BAD,    BAD, 0xcfbf,    BAD,    BAD, 0xefa6,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xefa5, 0xefa7,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x29e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xeefd,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xc6e9,    BAD, 0xc5d5,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xc4d7,    BAD, 0xefac,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xc3c3, 0xefa8,    BAD,    BAD,    BAD,
/* 20 */ 0xefa9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xb7ad,    BAD, 0xefab,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb8b0,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xefaa,    BAD, 0xbee1,    BAD
},

/* Row 0x29f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xb3f9,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xefb0,    BAD, 0xbabf, 0xc1f9,
/* 18 */    BAD,    BAD, 0xc4ca,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb3bb,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xefae, 0xefaf, 0xc4c3,    BAD,
/* 30 */ 0xefad,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xefb1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2a0 */
{
/* 00 */    BAD,    BAD,    BAD, 0xefb7,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xefba,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xefb9, 0xc5ad,    BAD,    BAD,    BAD,    BAD, 0xefb2, 0xefb3,
/* 18 */ 0xefb6,    BAD,    BAD,    BAD,    BAD, 0xefb8,    BAD,    BAD,
/* 20 */    BAD, 0xb6c0,    BAD,    BAD, 0xefbb, 0xefb5,    BAD,    BAD,
/* 28 */ 0xefb4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2a1 */
{
/* 00 */    BAD,    BAD,    BAD, 0xefbf,    BAD,    BAD,    BAD, 0xefc0,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xefc1,    BAD,    BAD, 0xefbe, 0xefbd,    BAD,    BAD,    BAD,
/* 18 */ 0xbee2, 0xc6aa, 0xefbc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xefc5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xefc3,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xefc4, 0xefc2,    BAD,
/* 38 */ 0xc2f8,    BAD, 0xefc6,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2a2 */
{
/* 00 */    BAD, 0xefc7,    BAD,    BAD, 0xefc9,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xb4d5, 0xefc8, 0xccfa,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xefd4, 0xefca,    BAD,    BAD, 0xefcd,    BAD,
/* 20 */ 0xefcb,    BAD, 0xefcc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xefce,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xefd0,    BAD,    BAD,    BAD,    BAD, 0xefd1,    BAD, 0xefd2,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xefd5, 0xefd3, 0xefd6, 0xefd8
},

/* Row 0x2a3 */
{
/* 00 */    BAD, 0xefd7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2a4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4b9,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2a5 */
{
/* 00 */ 0xcce7,    BAD, 0xefd9, 0xc1ae,    BAD,    BAD,    BAD, 0xefda,
/* 08 */    BAD, 0xcac4, 0xefdb, 0xb3ab,    BAD,    BAD,    BAD, 0xb1bc,
/* 10 */    BAD, 0xb4d7,    BAD, 0xb4d6, 0xefdc,    BAD, 0xefdd,    BAD,
/* 18 */ 0xefde, 0xefdf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xefe0,    BAD, 0xb4d8, 0xb3d5, 0xb9de, 0xc8b6,    BAD, 0xefe2,
/* 28 */ 0xefe1,    BAD,    BAD,    BAD,    BAD, 0xefe3,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xb1dc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xefe6,    BAD, 0xefe5, 0xefe4,    BAD, 0xefe7,    BAD
},

/* Row 0x2a6 */
{
/* 00 */    BAD,    BAD,    BAD, 0xefea,    BAD,    BAD,    BAD, 0xb0c7,
/* 08 */    BAD,    BAD, 0xefe8,    BAD, 0xefec, 0xefeb,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xefee, 0xefed, 0xefef,    BAD,
/* 18 */ 0xc6ae,    BAD,    BAD,    BAD, 0xeff0,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xeff1, 0xeff3,    BAD,    BAD, 0xeff2,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2a7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xc9ec,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xeff4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xeff5,    BAD, 0xbae5,    BAD,    BAD,    BAD, 0xeff6, 0xeff7,
/* 30 */    BAD,    BAD, 0xcbc9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xc1cb,    BAD,    BAD,    BAD, 0xb0a4
},

/* Row 0x2a8 */
{
/* 00 */ 0xc2cb,    BAD, 0xeff8,    BAD, 0xc9ed,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xeffb, 0xeff9, 0xb9df,    BAD, 0xeffa,
/* 10 */ 0xb8c2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xcac5, 0xeffd, 0xf0a1, 0xeffe, 0xf0a2,
/* 20 */    BAD,    BAD, 0xb1a1, 0xbfd8, 0xbdfc, 0xb4d9, 0xf0a3,    BAD,
/* 28 */    BAD,    BAD, 0xc7e6,    BAD, 0xf0a5,    BAD,    BAD,    BAD,
/* 30 */ 0xb1a2,    BAD, 0xf0a4, 0xc4c4,    BAD, 0xcecd, 0xc6ab, 0xeffc,
/* 38 */ 0xcea6,    BAD, 0xb8b1,    BAD,    BAD, 0xcddb,    BAD,    BAD
},

/* Row 0x2a9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb6f9, 0xceb4,    BAD,
/* 08 */ 0xb7a8,    BAD, 0xc2e2, 0xe7a1,    BAD, 0xf0a6, 0xb3ac, 0xbfef,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xb3d6, 0xf0a8,    BAD, 0xf0a9,
/* 18 */ 0xf0a7, 0xb7e4,    BAD, 0xbadd, 0xbee3,    BAD,    BAD,    BAD,
/* 20 */ 0xb1a3,    BAD,    BAD, 0xced9,    BAD,    BAD,    BAD, 0xf0ab,
/* 28 */ 0xeeae,    BAD, 0xf0aa,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xf0ae, 0xf0ac, 0xf0ad,    BAD, 0xf0af,    BAD, 0xf0b0, 0xceec,
/* 38 */ 0xf0b1, 0xf0b2,    BAD, 0xc0c9, 0xc8bb,    BAD,    BAD,    BAD
},

/* Row 0x2aa */
{
/* 00 */ 0xbffd, 0xb4e7,    BAD,    BAD, 0xcdba, 0xb2ed, 0xbdb8, 0xb8db,
/* 08 */    BAD, 0xf0b5,    BAD, 0xf0b4, 0xbbf3, 0xf0b6, 0xf0b3,    BAD,
/* 10 */    BAD, 0xbba8,    BAD,    BAD,    BAD, 0xf0ba, 0xeaad,    BAD,
/* 18 */    BAD, 0xd2d6,    BAD, 0xbff7, 0xf0b8,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xcea5, 0xc6f1,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb1ab,    BAD, 0xc0e3, 0xbcb6,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xcab7,    BAD, 0xb1c0,    BAD,    BAD,    BAD, 0xceed, 0xcdeb,
/* 38 */    BAD, 0xf0bb,    BAD, 0xc5c5,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2ab */
{
/* 00 */ 0xbcfb,    BAD,    BAD,    BAD, 0xf0bc,    BAD, 0xf0bd, 0xbfcc,
/* 08 */ 0xf0be,    BAD, 0xceee,    BAD,    BAD, 0xf0b9, 0xf0c0, 0xf0c2,
/* 10 */    BAD, 0xf0c1,    BAD, 0xf0bf,    BAD,    BAD, 0xf0c3,    BAD,
/* 18 */    BAD, 0xf0c4,    BAD,    BAD, 0xc1fa,    BAD, 0xb2e2,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xf0c5,    BAD,    BAD, 0xccb8,
/* 28 */    BAD,    BAD, 0xf0c6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xf0c7,    BAD, 0xcfaa,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xdbb1, 0xf0c8,    BAD,    BAD,    BAD, 0xf0c9, 0xf0ca,    BAD
},

/* Row 0x2ac */
{
/* 00 */    BAD,    BAD, 0xf0ce,    BAD, 0xf0cb,    BAD, 0xf0cc,    BAD,
/* 08 */ 0xf0cd, 0xf0cf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xc0c4,    BAD,    BAD,    BAD, 0xccf7,    BAD,
/* 18 */    BAD, 0xc0c5,    BAD,    BAD, 0xf0d0,    BAD, 0xc8f3,    BAD,
/* 20 */ 0xf0d1, 0xf3d3, 0xcccc,    BAD, 0xf0d2,    BAD, 0xf0d3,    BAD,
/* 28 */ 0xf0d4, 0xb3d7,    BAD, 0xf0d6,    BAD, 0xbfd9,    BAD,    BAD,
/* 30 */    BAD, 0xf0d7,    BAD,    BAD, 0xb7a4,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xf0d8, 0xf0dc,    BAD, 0xf0da,    BAD,    BAD,    BAD
},

/* Row 0x2ad */
{
/* 00 */    BAD, 0xf0db,    BAD,    BAD, 0xb3f3, 0xf0d9, 0xf0dd,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xf0de,    BAD, 0xb0c8,    BAD, 0xf0df,
/* 10 */ 0xf0e0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xbee4,    BAD,    BAD,    BAD, 0xf0e1,    BAD,    BAD,    BAD,
/* 20 */ 0xb5c7,    BAD,    BAD, 0xf0e4,    BAD,    BAD, 0xf0e3,    BAD,
/* 28 */ 0xf0e2,    BAD,    BAD, 0xebf1,    BAD, 0xcadc,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xf0e5, 0xf0e6,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2ae */
{
/* 00 */    BAD,    BAD,    BAD, 0xf0e7,    BAD,    BAD, 0xf0e8,    BAD,
/* 08 */ 0xf0e9,    BAD,    BAD, 0xf0ea,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xb4da,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xf0eb,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf0ec, 0xc7a3,    BAD,
/* 30 */    BAD,    BAD, 0xf0ee, 0xb2bb,    BAD, 0xf0f1, 0xf0f0,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xb1a4,    BAD,    BAD,    BAD, 0xb6c1
},

/* Row 0x2af */
{
/* 00 */    BAD, 0xcac7, 0xc4ba, 0xbaa2,    BAD, 0xb9e0, 0xbde7,    BAD,
/* 08 */ 0xbfdc,    BAD,    BAD,    BAD, 0xf0f3,    BAD,    BAD, 0xf0f2,
/* 10 */ 0xcdc2, 0xb4e8, 0xc8d2, 0xc6dc,    BAD,    BAD,    BAD, 0xbffc,
/* 18 */ 0xcece,    BAD, 0xb7db,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xf0f6,    BAD,    BAD, 0xf0f5,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xcbcb, 0xc6ac,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xb1d0,    BAD,    BAD, 0xf0f7,
/* 38 */ 0xf0f4,    BAD,    BAD, 0xc9d1, 0xcdea, 0xf0f8,    BAD,    BAD
},

/* Row 0x2b0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf0f9,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xf0fb, 0xc2ea, 0xb3db, 0xb3dc, 0xf0fa,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xb4e9, 0xb8b2,    BAD,    BAD,
/* 18 */ 0xb4ea,    BAD,    BAD, 0xc5bf,    BAD,    BAD, 0xcee0,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb8dc,
/* 28 */    BAD,    BAD,    BAD, 0xf0fc,    BAD,    BAD,    BAD, 0xf0fd,
/* 30 */ 0xf0fe, 0xf1a1,    BAD, 0xf1a3, 0xf1a2,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2b1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xc9f7,    BAD, 0xf1a4,    BAD,    BAD,    BAD,    BAD, 0xf1a5,
/* 30 */    BAD, 0xf1a6,    BAD,    BAD,    BAD,    BAD, 0xf1a7,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2b2 */
{
/* 00 */    BAD,    BAD,    BAD, 0xf1a9, 0xf1a8,    BAD, 0xf1aa,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xc8f4, 0xe6cc,    BAD,    BAD, 0xbfa9,
/* 20 */    BAD,    BAD, 0xb5b2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xf1ab,    BAD, 0xf1ac,    BAD, 0xd2ac, 0xddbb, 0xc8d3,
/* 30 */    BAD,    BAD, 0xb0fb,    BAD, 0xb0bb,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xbbf4, 0xcbb0, 0xbefe,    BAD
},

/* Row 0x2b3 */
{
/* 00 */    BAD,    BAD,    BAD, 0xf1ad,    BAD, 0xccdf,    BAD,    BAD,
/* 08 */    BAD, 0xf1ae, 0xcddc,    BAD, 0xb1c2,    BAD,    BAD,    BAD,
/* 10 */ 0xbbc1,    BAD, 0xf1af, 0xb2ee, 0xf1b0,    BAD,    BAD,    BAD,
/* 18 */ 0xf1b1,    BAD,    BAD,    BAD,    BAD, 0xf1b3, 0xf1b4,    BAD,
/* 20 */ 0xf1b6, 0xf1b2,    BAD,    BAD, 0xf1b5,    BAD,    BAD,    BAD,
/* 28 */ 0xb4db,    BAD,    BAD,    BAD, 0xf1b7,    BAD, 0xf1b8,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1b9, 0xf1ba,    BAD
},

/* Row 0x2b4 */
{
/* 00 */    BAD,    BAD, 0xf1bb,    BAD,    BAD, 0xf1bd,    BAD,    BAD,
/* 08 */    BAD, 0xf1bc,    BAD, 0xf1bf, 0xf1c2,    BAD,    BAD,    BAD,
/* 10 */ 0xf1be, 0xf1c0, 0xf1c1,    BAD,    BAD, 0xf1c3,    BAD, 0xb6c2,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2b5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbcf3, 0xf1c4,
/* 18 */ 0xf1c5, 0xb9e1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1c6,    BAD,    BAD,
/* 28 */ 0xb3be,    BAD,    BAD,    BAD, 0xc7cf, 0xf1c7, 0xf1c8,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xc3da, 0xc6eb,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xf1c9,    BAD,    BAD,    BAD
},

/* Row 0x2b6 */
{
/* 00 */    BAD, 0xc7fd,    BAD,    BAD, 0xc2cc, 0xb1d8, 0xb6ee,    BAD,
/* 08 */ 0xb6ef,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xc3f3, 0xf1ce, 0xb6f0,    BAD,    BAD, 0xb2ef,    BAD,    BAD,
/* 18 */ 0xf1cd,    BAD,    BAD, 0xf1cb,    BAD, 0xf1cc,    BAD, 0xf1ca,
/* 20 */    BAD,    BAD, 0xf1d8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1cf, 0xf1d0,    BAD,
/* 30 */    BAD, 0xf1d1, 0xf1d2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xf1d4,    BAD,    BAD, 0xf1d3,    BAD,    BAD,    BAD, 0xbdd9
},

/* Row 0x2b7 */
{
/* 00 */    BAD, 0xf1d5,    BAD,    BAD,    BAD, 0xf1d7,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb5b3, 0xf1d6,
/* 10 */    BAD,    BAD, 0xc1fb, 0xb8b3,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xf1d9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xc2cd,    BAD,    BAD, 0xf1da,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xc6ad,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1db,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1e0,    BAD
},

/* Row 0x2b8 */
{
/* 00 */ 0xf1de,    BAD, 0xf1dd, 0xf1df,    BAD, 0xf1dc,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1e2,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1e1,    BAD, 0xf1e4,
/* 18 */    BAD,    BAD, 0xb6c3, 0xf1e3,    BAD,    BAD,    BAD, 0xf1e5,
/* 20 */    BAD,    BAD, 0xf1e6,    BAD, 0xf1e8, 0xf1e7,    BAD,    BAD,
/* 28 */    BAD, 0xf1e9, 0xf1eb, 0xf1ea,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2b9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb9fc,    BAD,    BAD,    BAD,    BAD, 0xf1ec,    BAD,    BAD,
/* 30 */ 0xf1ed,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xb3bc,    BAD,    BAD,    BAD, 0xf1ee,    BAD,    BAD,    BAD
},

/* Row 0x2ba */
{
/* 00 */ 0xf1ef,    BAD,    BAD,    BAD, 0xbff1,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1f0,
/* 10 */    BAD, 0xf1f1,    BAD, 0xf1f2, 0xf1f3,    BAD,    BAD,    BAD,
/* 18 */ 0xb9e2,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1f4, 0xf1f5,
/* 20 */    BAD,    BAD, 0xf1f6, 0xf1f7,    BAD,    BAD, 0xf1f8,    BAD,
/* 28 */    BAD,    BAD, 0xc8b1, 0xf1fa,    BAD, 0xc9a6, 0xf1fb, 0xf1f9,
/* 30 */    BAD, 0xf1fd,    BAD,    BAD, 0xf1fc,    BAD,    BAD, 0xf1fe,
/* 38 */    BAD,    BAD,    BAD, 0xf2a1,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2bb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf2a2,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xf2a3,    BAD, 0xf2a4,    BAD,    BAD,    BAD,    BAD, 0xf2a5,
/* 20 */    BAD,    BAD, 0xf2a6, 0xf2a7,    BAD, 0xf2a8,    BAD, 0xf2a9,
/* 28 */ 0xf2aa, 0xf2ab, 0xf2ac,    BAD,    BAD,    BAD, 0xf2ad, 0xf2ae,
/* 30 */    BAD, 0xddb5, 0xf2af,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe4f8, 0xb5b4,    BAD,    BAD,    BAD
},

/* Row 0x2bc */
{
/* 00 */    BAD, 0xb3a1, 0xbab2, 0xf2b1, 0xf2b0, 0xcca5,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf2b3, 0xf2b4, 0xf2b2,
/* 10 */    BAD, 0xf2b5,    BAD,    BAD, 0xcbe2,    BAD,    BAD,    BAD,
/* 18 */ 0xf2b6,    BAD, 0xb5fb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcfa5,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xf2b7,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2bd */
{
/* 00 */    BAD,    BAD,    BAD, 0xf2b9,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb0be,    BAD,
/* 10 */    BAD, 0xf2ba, 0xcaab, 0xf2b8,    BAD,    BAD, 0xf2bb, 0xf2bc,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf2bd,
/* 20 */ 0xf2be,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xf2bf,    BAD, 0xcbee, 0xbbad,    BAD, 0xbafa, 0xc1af,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xf2c0,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xf2c3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2be */
{
/* 00 */ 0xf2c1,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf2c4,    BAD,
/* 08 */    BAD, 0xb8f1, 0xf2c2,    BAD,    BAD,    BAD,    BAD, 0xf2c5,
/* 10 */    BAD, 0xf2c6, 0xf2c7,    BAD, 0xf2cb,    BAD, 0xbbaa,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xc2e4,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xf2cc, 0xf2c9, 0xf2c8, 0xf2ca,    BAD,    BAD,    BAD,
/* 28 */ 0xb7df,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xf2d0, 0xf2cf, 0xf2ce,    BAD,    BAD, 0xb0b3,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2bf */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xf2da,    BAD, 0xf2d6,    BAD,
/* 08 */ 0xf2d7, 0xf2d3, 0xf2d9,    BAD, 0xf2d5, 0xb3e2,    BAD,    BAD,
/* 10 */ 0xcfcc,    BAD, 0xf2d8, 0xf2d4, 0xf2d2, 0xf2d1,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xf2dc,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xf2df,    BAD,    BAD, 0xf2de, 0xf2dd,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc9c9, 0xf2db, 0xb0f3,
/* 30 */ 0xf2e0,    BAD, 0xf2e2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb3ef, 0xf2cd, 0xb1b7,    BAD,    BAD, 0xf2e4,    BAD
},

/* Row 0x2c0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf2e3, 0xf2e1,
/* 08 */ 0xc3ad,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xcbf0,    BAD,    BAD,    BAD,    BAD, 0xceda,
/* 18 */    BAD,    BAD, 0xf2e5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xf2e6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf2e7,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf2e8,    BAD,
/* 38 */ 0xf2e9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2c1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4bb,    BAD, 0xf2ea,
/* 28 */    BAD, 0xc8b7,    BAD, 0xf2ef, 0xf2eb,    BAD,    BAD,    BAD,
/* 30 */ 0xf2ec,    BAD,    BAD, 0xcbb1, 0xccc4,    BAD, 0xc6d0,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2c2 */
{
/* 00 */    BAD,    BAD,    BAD, 0xf2f0,    BAD,    BAD, 0xf2f1, 0xc6be,
/* 08 */ 0xf2ee, 0xf2ed,    BAD,    BAD,    BAD,    BAD, 0xb2aa,    BAD,
/* 10 */    BAD,    BAD, 0xf2f9,    BAD,    BAD, 0xf2f8,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xb1f5,    BAD,    BAD,    BAD, 0xf2f6,
/* 20 */    BAD,    BAD,    BAD, 0xf2f5,    BAD,    BAD, 0xf2f3,    BAD,
/* 28 */ 0xb3fb,    BAD, 0xf2f2, 0xbcb2, 0xb2a9,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xb9e3,    BAD,    BAD, 0xf2fc, 0xf2fb
},

/* Row 0x2c3 */
{
/* 00 */    BAD, 0xf2fa,    BAD,    BAD, 0xf2f7,    BAD, 0xf2fd,    BAD,
/* 08 */ 0xf2fe,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xf3a5, 0xf3a4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xf3a6,    BAD,    BAD, 0xb1ad, 0xf3a1, 0xf3a2,    BAD,
/* 20 */ 0xb9f4, 0xccb9,    BAD,    BAD, 0xf3a3,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xcbb2,    BAD,    BAD, 0xf3ab,
/* 30 */    BAD,    BAD, 0xf3a7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xf3ac,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2c4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3a9,
/* 08 */    BAD, 0xf3a8,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7dc,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xf3ad,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xf3ae,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xf3af,    BAD, 0xf3aa,    BAD,    BAD,    BAD, 0xf2f4,
/* 30 */    BAD,    BAD, 0xf3b0,    BAD, 0xc4e1,    BAD,    BAD,    BAD,
/* 38 */ 0xf3b4,    BAD, 0xf3b5, 0xf3b3,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2c5 */
{
/* 00 */    BAD, 0xf3b2, 0xf3b8,    BAD, 0xf3b1,    BAD, 0xf3b6,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3b7,
/* 10 */    BAD,    BAD,    BAD, 0xf3ba,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xf3b9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3bc,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3bd,    BAD, 0xf3be,
/* 30 */    BAD,    BAD, 0xcfc9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xf3bb, 0xc2eb, 0xbaed,    BAD,    BAD, 0xf3bf,    BAD,    BAD
},

/* Row 0x2c6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xf3c0, 0xf3c1,    BAD,    BAD, 0xf3c2,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2c7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3c3,    BAD,    BAD,
/* 38 */ 0xb8b4, 0xf3c4,    BAD,    BAD,    BAD, 0xf3c5,    BAD, 0xbcaf
},

/* Row 0x2c8 */
{
/* 00 */    BAD, 0xf3c6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xf3c7,    BAD,    BAD, 0xf3c8, 0xf3c9,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xf3cc, 0xf3ca, 0xcfbc,    BAD, 0xf3cb,    BAD, 0xceef,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3cd,    BAD, 0xcedb,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3ce, 0xc7fe,    BAD,
/* 28 */    BAD, 0xf3cf, 0xf3d1,    BAD,    BAD, 0xf3d2,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xf3d0, 0xb9ed, 0xcccd, 0xcbe3, 0xd6f7,    BAD, 0xdde0, 0xcbfb
},

/* Row 0x2c9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb2ab,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xf3d4, 0xb5d0, 0xf3d5, 0xf3d6,
/* 10 */ 0xf3d7,    BAD, 0xb9f5,    BAD, 0xf3d8,    BAD,    BAD,    BAD,
/* 18 */ 0xe0d4, 0xccdb,    BAD, 0xc2e3, 0xf3d9, 0xf3db, 0xf3da,    BAD,
/* 20 */ 0xf3dc,    BAD,    BAD,    BAD,    BAD, 0xf3dd,    BAD,    BAD,
/* 28 */ 0xf3de,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3df,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xf3e0,    BAD, 0xf3e1, 0xf3e2,
/* 38 */    BAD, 0xf3e3,    BAD, 0xf3e4, 0xf3e5, 0xf3e6,    BAD,    BAD
},

/* Row 0x2ca */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3e7,
/* 08 */ 0xf3e8,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5a4,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xb8dd,    BAD, 0xf3ea,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xc1cd, 0xf3eb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xf3ec,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xc9a1,    BAD,    BAD, 0xf3ed,    BAD
},

/* Row 0x2cb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xf3ee, 0xe3b7,    BAD,    BAD, 0xecda, 0xf0ed,
/* 10 */    BAD,    BAD, 0xf3ef,    BAD, 0xf3f0,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3f2,
/* 20 */ 0xf3f3, 0xf3f4, 0xcef0, 0xf3f1,    BAD,    BAD, 0xf3f5, 0xf3f6,
/* 28 */    BAD,    BAD, 0xf3f8,    BAD, 0xf3f7,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xf3fa,    BAD,    BAD,    BAD, 0xf3fb, 0xf3f9,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2cc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xceb6,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3fc,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xf3fd, 0xe3d4,    BAD,    BAD,
/* 20 */ 0xf3fe,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2cd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xa2af, 0xa2b0, 0xa2b1, 0xa2b2, 0xa2b3, 0xa2b4,
/* 30 */ 0xa2b5, 0xa2b6, 0xa2b7, 0xa2b8, 0xa2b9, 0xa2c2, 0xa2c3, 0xa2c4,
/* 38 */ 0xa2c5, 0xa2c6, 0xa2c7, 0xa2c8, 0xa2c9, 0xa2d1, 0xa2d2, 0xa2d3
},

/* Row 0x2ce */
{
/* 00 */ 0xa2d4, 0xa2d5, 0xa2d6, 0xa2d7, 0xa2d8, 0xa2d9, 0xa2da, 0xa2db,
/* 08 */ 0xa2eb, 0xa2ec, 0xa2ed, 0xa2ee, 0xa2ef, 0xa2f0, 0xa2f1, 0xa2fa,
/* 10 */ 0xa2fb, 0xa2fc, 0xa2fd, 0xa3a1, 0xa3a2, 0xa3a3, 0xa3a4, 0xa3a5,
/* 18 */ 0xa3a6, 0xa3a7, 0xa3a8, 0xa3a9, 0xa3aa, 0xa3ab, 0xa3ac, 0xa3ad,
/* 20 */ 0xa3ae, 0xa3af, 0xa3ba, 0xa3bb, 0xa3bc, 0xa3bd, 0xa3be, 0xa3bf,
/* 28 */ 0xa3c0, 0xa3db, 0xa3dc, 0xa3dd, 0xa3de, 0xa3df, 0xa3e0, 0xa3fb,
/* 30 */ 0xa3fc, 0xa3fd, 0xa3fe, 0xa4f4, 0xa4f5, 0xa4f6, 0xa4f7, 0xa4f8,
/* 38 */ 0xa4f9, 0xa4fa, 0xa4fb, 0xa4fc, 0xa4fd, 0xa4fe, 0xa5f7, 0xa5f8
},

/* Row 0x2cf */
{
/* 00 */ 0xa5f9, 0xa5fa, 0xa5fb, 0xa5fc, 0xa5fd, 0xa5fe, 0xa6b9, 0xa6ba,
/* 08 */ 0xa6bb, 0xa6bc, 0xa6bd, 0xa6be, 0xa6bf, 0xa6c0, 0xa6d9, 0xa6da,
/* 10 */ 0xa6db, 0xa6dc, 0xa6dd, 0xa6de, 0xa6df, 0xa6e0, 0xa6e1, 0xa6e2,
/* 18 */ 0xa6e3, 0xa6e4, 0xa6e5, 0xa6e6, 0xa6e7, 0xa6e8, 0xa6e9, 0xa6ea,
/* 20 */ 0xa6eb, 0xa6ec, 0xa6ed, 0xa6ee, 0xa6ef, 0xa6f0, 0xa6f1, 0xa6f2,
/* 28 */ 0xa6f3, 0xa6f4, 0xa6f5, 0xa6f6, 0xa6f7, 0xa6f8, 0xa6f9, 0xa6fa,
/* 30 */ 0xa6fb, 0xa6fc, 0xa6fd, 0xa6fe, 0xa7c2, 0xa7c3, 0xa7c4, 0xa7c5,
/* 38 */ 0xa7c6, 0xa7c7, 0xa7c8, 0xa7c9, 0xa7ca, 0xa7cb, 0xa7cc, 0xa7cd
},

/* Row 0x2d0 */
{
/* 00 */ 0xa7ce, 0xa7cf, 0xa7d0, 0xa7f2, 0xa7f3, 0xa7f4, 0xa7f5, 0xa7f6,
/* 08 */ 0xa7f7, 0xa7f8, 0xa7f9, 0xa7fa, 0xa7fb, 0xa7fc, 0xa7fd, 0xa7fe,
/* 10 */ 0xa8c1, 0xa8c2, 0xa8c3, 0xa8c4, 0xa8c5, 0xa8c6, 0xa8c7, 0xa8c8,
/* 18 */ 0xa8c9, 0xa8ca, 0xa8cb, 0xa8cc, 0xa8cd, 0xa8ce, 0xa8cf, 0xa8d0,
/* 20 */ 0xa8d1, 0xa8d2, 0xa8d3, 0xa8d4, 0xa8d5, 0xa8d6, 0xa8d7, 0xa8d8,
/* 28 */ 0xa8d9, 0xa8da, 0xa8db, 0xa8dc, 0xa8dd, 0xa8de, 0xa8df, 0xa8e0,
/* 30 */ 0xa8e1, 0xa8e2, 0xa8e3, 0xa8e4, 0xa8e5, 0xa8e6, 0xa8e7, 0xa8e8,
/* 38 */ 0xa8e9, 0xa8ea, 0xa8eb, 0xa8ec, 0xa8ed, 0xa8ee, 0xa8ef, 0xa8f0
},

/* Row 0x2d1 */
{
/* 00 */ 0xa8f1, 0xa8f2, 0xa8f3, 0xa8f4, 0xa8f5, 0xa8f6, 0xa8f7, 0xa8f8,
/* 08 */ 0xa8f9, 0xa8fa, 0xa8fb, 0xa8fc, 0xa8fd, 0xa8fe, 0xa9a1, 0xa9a2,
/* 10 */ 0xa9a3, 0xa9a4, 0xa9a5, 0xa9a6, 0xa9a7, 0xa9a8, 0xa9a9, 0xa9aa,
/* 18 */ 0xa9ab, 0xa9ac, 0xa9ad, 0xa9ae, 0xa9af, 0xa9b0, 0xa9b1, 0xa9b2,
/* 20 */ 0xa9b3, 0xa9b4, 0xa9b5, 0xa9b6, 0xa9b7, 0xa9b8, 0xa9b9, 0xa9ba,
/* 28 */ 0xa9bb, 0xa9bc, 0xa9bd, 0xa9be, 0xa9bf, 0xa9c0, 0xa9c1, 0xa9c2,
/* 30 */ 0xa9c3, 0xa9c4, 0xa9c5, 0xa9c6, 0xa9c7, 0xa9c8, 0xa9c9, 0xa9ca,
/* 38 */ 0xa9cb, 0xa9cc, 0xa9cd, 0xa9ce, 0xa9cf, 0xa9d0, 0xa9d1, 0xa9d2
},

/* Row 0x2d2 */
{
/* 00 */ 0xa9d3, 0xa9d4, 0xa9d5, 0xa9d6, 0xa9d7, 0xa9d8, 0xa9d9, 0xa9da,
/* 08 */ 0xa9db, 0xa9dc, 0xa9dd, 0xa9de, 0xa9df, 0xa9e0, 0xa9e1, 0xa9e2,
/* 10 */ 0xa9e3, 0xa9e4, 0xa9e5, 0xa9e6, 0xa9e7, 0xa9e8, 0xa9e9, 0xa9ea,
/* 18 */ 0xa9eb, 0xa9ec, 0xa9ed, 0xa9ee, 0xa9ef, 0xa9f0, 0xa9f1, 0xa9f2,
/* 20 */ 0xa9f3, 0xa9f4, 0xa9f5, 0xa9f6, 0xa9f7, 0xa9f8, 0xa9f9, 0xa9fa,
/* 28 */ 0xa9fb, 0xa9fc, 0xa9fd, 0xa9fe, 0xaaa1, 0xaaa2, 0xaaa3, 0xaaa4,
/* 30 */ 0xaaa5, 0xaaa6, 0xaaa7, 0xaaa8, 0xaaa9, 0xaaaa, 0xaaab, 0xaaac,
/* 38 */ 0xaaad, 0xaaae, 0xaaaf, 0xaab0, 0xaab1, 0xaab2, 0xaab3, 0xaab4
},

/* Row 0x2d3 */
{
/* 00 */ 0xaab5, 0xaab6, 0xaab7, 0xaab8, 0xaab9, 0xaaba, 0xaabb, 0xaabc,
/* 08 */ 0xaabd, 0xaabe, 0xaabf, 0xaac0, 0xaac1, 0xaac2, 0xaac3, 0xaac4,
/* 10 */ 0xaac5, 0xaac6, 0xaac7, 0xaac8, 0xaac9, 0xaaca, 0xaacb, 0xaacc,
/* 18 */ 0xaacd, 0xaace, 0xaacf, 0xaad0, 0xaad1, 0xaad2, 0xaad3, 0xaad4,
/* 20 */ 0xaad5, 0xaad6, 0xaad7, 0xaad8, 0xaad9, 0xaada, 0xaadb, 0xaadc,
/* 28 */ 0xaadd, 0xaade, 0xaadf, 0xaae0, 0xaae1, 0xaae2, 0xaae3, 0xaae4,
/* 30 */ 0xaae5, 0xaae6, 0xaae7, 0xaae8, 0xaae9, 0xaaea, 0xaaeb, 0xaaec,
/* 38 */ 0xaaed, 0xaaee, 0xaaef, 0xaaf0, 0xaaf1, 0xaaf2, 0xaaf3, 0xaaf4
},

/* Row 0x2d4 */
{
/* 00 */ 0xaaf5, 0xaaf6, 0xaaf7, 0xaaf8, 0xaaf9, 0xaafa, 0xaafb, 0xaafc,
/* 08 */ 0xaafd, 0xaafe, 0xaba1, 0xaba2, 0xaba3, 0xaba4, 0xaba5, 0xaba6,
/* 10 */ 0xaba7, 0xaba8, 0xaba9, 0xabaa, 0xabab, 0xabac, 0xabad, 0xabae,
/* 18 */ 0xabaf, 0xabb0, 0xabb1, 0xabb2, 0xabb3, 0xabb4, 0xabb5, 0xabb6,
/* 20 */ 0xabb7, 0xabb8, 0xabb9, 0xabba, 0xabbb, 0xabbc, 0xabbd, 0xabbe,
/* 28 */ 0xabbf, 0xabc0, 0xabc1, 0xabc2, 0xabc3, 0xabc4, 0xabc5, 0xabc6,
/* 30 */ 0xabc7, 0xabc8, 0xabc9, 0xabca, 0xabcb, 0xabcc, 0xabcd, 0xabce,
/* 38 */ 0xabcf, 0xabd0, 0xabd1, 0xabd2, 0xabd3, 0xabd4, 0xabd5, 0xabd6
},

/* Row 0x2d5 */
{
/* 00 */ 0xabd7, 0xabd8, 0xabd9, 0xabda, 0xabdb, 0xabdc, 0xabdd, 0xabde,
/* 08 */ 0xabdf, 0xabe0, 0xabe1, 0xabe2, 0xabe3, 0xabe4, 0xabe5, 0xabe6,
/* 10 */ 0xabe7, 0xabe8, 0xabe9, 0xabea, 0xabeb, 0xabec, 0xabed, 0xabee,
/* 18 */ 0xabef, 0xabf0, 0xabf1, 0xabf2, 0xabf3, 0xabf4, 0xabf5, 0xabf6,
/* 20 */ 0xabf7, 0xabf8, 0xabf9, 0xabfa, 0xabfb, 0xabfc, 0xabfd, 0xabfe,
/* 28 */ 0xaca1, 0xaca2, 0xaca3, 0xaca4, 0xaca5, 0xaca6, 0xaca7, 0xaca8,
/* 30 */ 0xaca9, 0xacaa, 0xacab, 0xacac, 0xacad, 0xacae, 0xacaf, 0xacb0,
/* 38 */ 0xacb1, 0xacb2, 0xacb3, 0xacb4, 0xacb5, 0xacb6, 0xacb7, 0xacb8
},

/* Row 0x2d6 */
{
/* 00 */ 0xacb9, 0xacba, 0xacbb, 0xacbc, 0xacbd, 0xacbe, 0xacbf, 0xacc0,
/* 08 */ 0xacc1, 0xacc2, 0xacc3, 0xacc4, 0xacc5, 0xacc6, 0xacc7, 0xacc8,
/* 10 */ 0xacc9, 0xacca, 0xaccb, 0xaccc, 0xaccd, 0xacce, 0xaccf, 0xacd0,
/* 18 */ 0xacd1, 0xacd2, 0xacd3, 0xacd4, 0xacd5, 0xacd6, 0xacd7, 0xacd8,
/* 20 */ 0xacd9, 0xacda, 0xacdb, 0xacdc, 0xacdd, 0xacde, 0xacdf, 0xace0,
/* 28 */ 0xace1, 0xace2, 0xace3, 0xace4, 0xace5, 0xace6, 0xace7, 0xace8,
/* 30 */ 0xace9, 0xacea, 0xaceb, 0xacec, 0xaced, 0xacee, 0xacef, 0xacf0,
/* 38 */ 0xacf1, 0xacf2, 0xacf3, 0xacf4, 0xacf5, 0xacf6, 0xacf7, 0xacf8
},

/* Row 0x2d7 */
{
/* 00 */ 0xacf9, 0xacfa, 0xacfb, 0xacfc, 0xacfd, 0xacfe, 0xada1, 0xada2,
/* 08 */ 0xada3, 0xada4, 0xada5, 0xada6, 0xada7, 0xada8, 0xada9, 0xadaa,
/* 10 */ 0xadab, 0xadac, 0xadad, 0xadae, 0xadaf, 0xadb0, 0xadb1, 0xadb2,
/* 18 */ 0xadb3, 0xadb4, 0xadb5, 0xadb6, 0xadb7, 0xadb8, 0xadb9, 0xadba,
/* 20 */ 0xadbb, 0xadbc, 0xadbd, 0xadbe, 0xadbf, 0xadc0, 0xadc1, 0xadc2,
/* 28 */ 0xadc3, 0xadc4, 0xadc5, 0xadc6, 0xadc7, 0xadc8, 0xadc9, 0xadca,
/* 30 */ 0xadcb, 0xadcc, 0xadcd, 0xadce, 0xadcf, 0xadd0, 0xadd1, 0xadd2,
/* 38 */ 0xadd3, 0xadd4, 0xadd5, 0xadd6, 0xadd7, 0xadd8, 0xadd9, 0xadda
},

/* Row 0x2d8 */
{
/* 00 */ 0xaddb, 0xaddc, 0xaddd, 0xadde, 0xaddf, 0xade0, 0xade1, 0xade2,
/* 08 */ 0xade3, 0xade4, 0xade5, 0xade6, 0xade7, 0xade8, 0xade9, 0xadea,
/* 10 */ 0xadeb, 0xadec, 0xaded, 0xadee, 0xadef, 0xadf0, 0xadf1, 0xadf2,
/* 18 */ 0xadf3, 0xadf4, 0xadf5, 0xadf6, 0xadf7, 0xadf8, 0xadf9, 0xadfa,
/* 20 */ 0xadfb, 0xadfc, 0xadfd, 0xadfe, 0xaea1, 0xaea2, 0xaea3, 0xaea4,
/* 28 */ 0xaea5, 0xaea6, 0xaea7, 0xaea8, 0xaea9, 0xaeaa, 0xaeab, 0xaeac,
/* 30 */ 0xaead, 0xaeae, 0xaeaf, 0xaeb0, 0xaeb1, 0xaeb2, 0xaeb3, 0xaeb4,
/* 38 */ 0xaeb5, 0xaeb6, 0xaeb7, 0xaeb8, 0xaeb9, 0xaeba, 0xaebb, 0xaebc
},

/* Row 0x2d9 */
{
/* 00 */ 0xaebd, 0xaebe, 0xaebf, 0xaec0, 0xaec1, 0xaec2, 0xaec3, 0xaec4,
/* 08 */ 0xaec5, 0xaec6, 0xaec7, 0xaec8, 0xaec9, 0xaeca, 0xaecb, 0xaecc,
/* 10 */ 0xaecd, 0xaece, 0xaecf, 0xaed0, 0xaed1, 0xaed2, 0xaed3, 0xaed4,
/* 18 */ 0xaed5, 0xaed6, 0xaed7, 0xaed8, 0xaed9, 0xaeda, 0xaedb, 0xaedc,
/* 20 */ 0xaedd, 0xaede, 0xaedf, 0xaee0, 0xaee1, 0xaee2, 0xaee3, 0xaee4,
/* 28 */ 0xaee5, 0xaee6, 0xaee7, 0xaee8, 0xaee9, 0xaeea, 0xaeeb, 0xaeec,
/* 30 */ 0xaeed, 0xaeee, 0xaeef, 0xaef0, 0xaef1, 0xaef2, 0xaef3, 0xaef4,
/* 38 */ 0xaef5, 0xaef6, 0xaef7, 0xaef8, 0xaef9, 0xaefa, 0xaefb, 0xaefc
},

/* Row 0x2da */
{
/* 00 */ 0xaefd, 0xaefe, 0xafa1, 0xafa2, 0xafa3, 0xafa4, 0xafa5, 0xafa6,
/* 08 */ 0xafa7, 0xafa8, 0xafa9, 0xafaa, 0xafab, 0xafac, 0xafad, 0xafae,
/* 10 */ 0xafaf, 0xafb0, 0xafb1, 0xafb2, 0xafb3, 0xafb4, 0xafb5, 0xafb6,
/* 18 */ 0xafb7, 0xafb8, 0xafb9, 0xafba, 0xafbb, 0xafbc, 0xafbd, 0xafbe,
/* 20 */ 0xafbf, 0xafc0, 0xafc1, 0xafc2, 0xafc3, 0xafc4, 0xafc5, 0xafc6,
/* 28 */ 0xafc7, 0xafc8, 0xafc9, 0xafca, 0xafcb, 0xafcc, 0xafcd, 0xafce,
/* 30 */ 0xafcf, 0xafd0, 0xafd1, 0xafd2, 0xafd3, 0xafd4, 0xafd5, 0xafd6,
/* 38 */ 0xafd7, 0xafd8, 0xafd9, 0xafda, 0xafdb, 0xafdc, 0xafdd, 0xafde
},

/* Row 0x2db */
{
/* 00 */ 0xafdf, 0xafe0, 0xafe1, 0xafe2, 0xafe3, 0xafe4, 0xafe5, 0xafe6,
/* 08 */ 0xafe7, 0xafe8, 0xafe9, 0xafea, 0xafeb, 0xafec, 0xafed, 0xafee,
/* 10 */ 0xafef, 0xaff0, 0xaff1, 0xaff2, 0xaff3, 0xaff4, 0xaff5, 0xaff6,
/* 18 */ 0xaff7, 0xaff8, 0xaff9, 0xaffa, 0xaffb, 0xaffc, 0xaffd, 0xaffe,
/* 20 */ 0xcfd4, 0xcfd5, 0xcfd6, 0xcfd7, 0xcfd8, 0xcfd9, 0xcfda, 0xcfdb,
/* 28 */ 0xcfdc, 0xcfdd, 0xcfde, 0xcfdf, 0xcfe0, 0xcfe1, 0xcfe2, 0xcfe3,
/* 30 */ 0xcfe4, 0xcfe5, 0xcfe6, 0xcfe7, 0xcfe8, 0xcfe9, 0xcfea, 0xcfeb,
/* 38 */ 0xcfec, 0xcfed, 0xcfee, 0xcfef, 0xcff0, 0xcff1, 0xcff2, 0xcff3
},

/* Row 0x2dc */
{
/* 00 */ 0xcff4, 0xcff5, 0xcff6, 0xcff7, 0xcff8, 0xcff9, 0xcffa, 0xcffb,
/* 08 */ 0xcffc, 0xcffd, 0xcffe, 0xf4a7, 0xf4a8, 0xf4a9, 0xf4aa, 0xf4ab,
/* 10 */ 0xf4ac, 0xf4ad, 0xf4ae, 0xf4af, 0xf4b0, 0xf4b1, 0xf4b2, 0xf4b3,
/* 18 */ 0xf4b4, 0xf4b5, 0xf4b6, 0xf4b7, 0xf4b8, 0xf4b9, 0xf4ba, 0xf4bb,
/* 20 */ 0xf4bc, 0xf4bd, 0xf4be, 0xf4bf, 0xf4c0, 0xf4c1, 0xf4c2, 0xf4c3,
/* 28 */ 0xf4c4, 0xf4c5, 0xf4c6, 0xf4c7, 0xf4c8, 0xf4c9, 0xf4ca, 0xf4cb,
/* 30 */ 0xf4cc, 0xf4cd, 0xf4ce, 0xf4cf, 0xf4d0, 0xf4d1, 0xf4d2, 0xf4d3,
/* 38 */ 0xf4d4, 0xf4d5, 0xf4d6, 0xf4d7, 0xf4d8, 0xf4d9, 0xf4da, 0xf4db
},

/* Row 0x2dd */
{
/* 00 */ 0xf4dc, 0xf4dd, 0xf4de, 0xf4df, 0xf4e0, 0xf4e1, 0xf4e2, 0xf4e3,
/* 08 */ 0xf4e4, 0xf4e5, 0xf4e6, 0xf4e7, 0xf4e8, 0xf4e9, 0xf4ea, 0xf4eb,
/* 10 */ 0xf4ec, 0xf4ed, 0xf4ee, 0xf4ef, 0xf4f0, 0xf4f1, 0xf4f2, 0xf4f3,
/* 18 */ 0xf4f4, 0xf4f5, 0xf4f6, 0xf4f7, 0xf4f8, 0xf4f9, 0xf4fa, 0xf4fb,
/* 20 */ 0xf4fc, 0xf4fd, 0xf4fe,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2de */
{
/* 00 */    BAD, 0xa1aa,    BAD, 0xa1f4, 0xa1f0, 0xa1f3, 0xa1f5,    BAD,
/* 08 */ 0xa1ca, 0xa1cb, 0xa1f6, 0xa1dc, 0xa1a4,    BAD, 0xa1a5, 0xa1bf,
/* 10 */ 0xa3b0, 0xa3b1, 0xa3b2, 0xa3b3, 0xa3b4, 0xa3b5, 0xa3b6, 0xa3b7,
/* 18 */ 0xa3b8, 0xa3b9, 0xa1a7, 0xa1a8, 0xa1e3, 0xa1e1, 0xa1e4, 0xa1a9,
/* 20 */ 0xa1f7, 0xa3c1, 0xa3c2, 0xa3c3, 0xa3c4, 0xa3c5, 0xa3c6, 0xa3c7,
/* 28 */ 0xa3c8, 0xa3c9, 0xa3ca, 0xa3cb, 0xa3cc, 0xa3cd, 0xa3ce, 0xa3cf,
/* 30 */ 0xa3d0, 0xa3d1, 0xa3d2, 0xa3d3, 0xa3d4, 0xa3d5, 0xa3d6, 0xa3d7,
/* 38 */ 0xa3d8, 0xa3d9, 0xa3da, 0xa1ce, 0xa1c0, 0xa1cf, 0xa1b0, 0xa1b2
},

/* Row 0x2df */
{
/* 00 */ 0xa1ae, 0xa3e1, 0xa3e2, 0xa3e3, 0xa3e4, 0xa3e5, 0xa3e6, 0xa3e7,
/* 08 */ 0xa3e8, 0xa3e9, 0xa3ea, 0xa3eb, 0xa3ec, 0xa3ed, 0xa3ee, 0xa3ef,
/* 10 */ 0xa3f0, 0xa3f1, 0xa3f2, 0xa3f3, 0xa3f4, 0xa3f5, 0xa3f6, 0xa3f7,
/* 18 */ 0xa3f8, 0xa3f9, 0xa3fa, 0xa1d0, 0xa1c3, 0xa1d1, 0xa1c1,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2e0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xa1b1,    BAD, 0xa1ef,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2e1 */
{
/* 00 */ 0xa1ae, 0xa3e1, 0xa3e2, 0xa3e3, 0xa3e4, 0xa3e5, 0xa3e6, 0xa3e7,
/* 08 */ 0xa3e8, 0xa3e9, 0xa3ea, 0xa3eb, 0xa3ec, 0xa3ed, 0xa3ee, 0xa3ef,
/* 10 */ 0xa3f0, 0xa3f1, 0xa3f2, 0xa3f3, 0xa3f4, 0xa3f5, 0xa3f6, 0xa3f7,
/* 18 */ 0xa3f8, 0xa3f9, 0xa3fa, 0xa1d0, 0xa1c3, 0xa1d1, 0xa1c1,    BAD,
/* 20 */    BAD, 0x8ea1, 0x8ea2, 0x8ea3, 0x8ea4, 0x8ea5, 0x8ea6, 0x8ea7,
/* 28 */ 0x8ea8, 0x8ea9, 0x8eaa, 0x8eab, 0x8eac, 0x8ead, 0x8eae, 0x8eaf,
/* 30 */ 0x8eb0, 0x8eb1, 0x8eb2, 0x8eb3, 0x8eb4, 0x8eb5, 0x8eb6, 0x8eb7,
/* 38 */ 0x8eb8, 0x8eb9, 0x8eba, 0x8ebb, 0x8ebc, 0x8ebd, 0x8ebe, 0x8ebf
},

/* Row 0x2e2 */
{
/* 00 */ 0x8ec0, 0x8ec1, 0x8ec2, 0x8ec3, 0x8ec4, 0x8ec5, 0x8ec6, 0x8ec7,
/* 08 */ 0x8ec8, 0x8ec9, 0x8eca, 0x8ecb, 0x8ecc, 0x8ecd, 0x8ece, 0x8ecf,
/* 10 */ 0x8ed0, 0x8ed1, 0x8ed2, 0x8ed3, 0x8ed4, 0x8ed5, 0x8ed6, 0x8ed7,
/* 18 */ 0x8ed8, 0x8ed9, 0x8eda, 0x8edb, 0x8edc, 0x8edd, 0x8ede, 0x8edf,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
}
};

/* Mapping table from Unicode to Japanese */

static cell4_t _ucs_to_jp_cell4[] = {
/* Row 0x800 */
{
/* 00 */ 0x0080, 0x0081, 0x0082, 0x0083, 0x0084, 0x0085, 0x0086, 0x0087,
/* 08 */ 0x0088, 0x0089, 0x008a, 0x008b, 0x008c, 0x008d,    BAD,    BAD,
/* 10 */ 0x0090, 0x0091, 0x0092, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097,
/* 18 */ 0x0098, 0x0099, 0x009a, 0x009b, 0x009c, 0x009d, 0x009e, 0x009f,
/* 20 */    BAD, 0x8fa2c2, 0xa1f1, 0xa1f2, 0x8fa2f0,    BAD, 0x8fa2c3, 0xa1f8,
/* 28 */ 0xa1af, 0x8fa2ed, 0x8fa2ec,    BAD, 0xa2cc,    BAD, 0x8fa2ee, 0x8fa2b4,
/* 30 */ 0xa1eb, 0xa1de,    BAD,    BAD, 0xa1ad,    BAD, 0xa2f9,    BAD,
/* 38 */ 0x8fa2b1,    BAD, 0x8fa2eb,    BAD,    BAD,    BAD,    BAD, 0x8fa2c4
},

/* Row 0x801 */
{
/* 00 */ 0x8faaa2, 0x8faaa1, 0x8faaa4, 0x8faaaa, 0x8faaa3, 0x8faaa9, 0x8fa9a1, 0x8faaae,
/* 08 */ 0x8faab2, 0x8faab1, 0x8faab4, 0x8faab3, 0x8faac0, 0x8faabf, 0x8faac2, 0x8faac1,
/* 10 */    BAD, 0x8faad0, 0x8faad2, 0x8faad1, 0x8faad4, 0x8faad8, 0x8faad3, 0xa1df,
/* 18 */ 0x8fa9ac, 0x8faae3, 0x8faae2, 0x8faae5, 0x8faae4, 0x8faaf2, 0x8fa9b0, 0x8fa9ce,
/* 20 */ 0x8faba2, 0x8faba1, 0x8faba4, 0x8fabaa, 0x8faba3, 0x8faba9, 0x8fa9c1, 0x8fabae,
/* 28 */ 0x8fabb2, 0x8fabb1, 0x8fabb4, 0x8fabb3, 0x8fabc0, 0x8fabbf, 0x8fabc2, 0x8fabc1,
/* 30 */ 0x8fa9c3, 0x8fabd0, 0x8fabd2, 0x8fabd1, 0x8fabd4, 0x8fabd8, 0x8fabd3, 0xa1e0,
/* 38 */ 0x8fa9cc, 0x8fabe3, 0x8fabe2, 0x8fabe5, 0x8fabe4, 0x8fabf2, 0x8fa9d0, 0x8fabf3
},

/* Row 0x802 */
{
/* 00 */ 0x8faaa7, 0x8faba7, 0x8faaa5, 0x8faba5, 0x8faaa8, 0x8faba8, 0x8faaab, 0x8fabab,
/* 08 */ 0x8faaac, 0x8fabac, 0x8faaaf, 0x8fabaf, 0x8faaad, 0x8fabad, 0x8faab0, 0x8fabb0,
/* 10 */ 0x8fa9a2, 0x8fa9c2, 0x8faab7, 0x8fabb7,    BAD,    BAD, 0x8faab6, 0x8fabb6,
/* 18 */ 0x8faab8, 0x8fabb8, 0x8faab5, 0x8fabb5, 0x8faaba, 0x8fabba, 0x8faabb, 0x8fabbb,
/* 20 */ 0x8faabd, 0x8fabbd, 0x8faabc,    BAD, 0x8faabe, 0x8fabbe, 0x8fa9a4, 0x8fa9c4,
/* 28 */ 0x8faac7, 0x8fabc7, 0x8faac5, 0x8fabc5,    BAD,    BAD, 0x8faac6, 0x8fabc6,
/* 30 */ 0x8faac4, 0x8fa9c5, 0x8fa9a6, 0x8fa9c6, 0x8faac8, 0x8fabc8, 0x8faac9, 0x8fabc9,
/* 38 */ 0x8fa9c7, 0x8faaca, 0x8fabca, 0x8faacc, 0x8fabcc, 0x8faacb, 0x8fabcb, 0x8fa9a9
},

/* Row 0x803 */
{
/* 00 */ 0x8fa9c9, 0x8fa9a8, 0x8fa9c8, 0x8faacd, 0x8fabcd, 0x8faacf, 0x8fabcf, 0x8faace,
/* 08 */ 0x8fabce, 0x8fa9ca, 0x8fa9ab, 0x8fa9cb, 0x8faad7, 0x8fabd7,    BAD,    BAD,
/* 10 */ 0x8faad6, 0x8fabd6, 0x8fa9ad, 0x8fa9cd, 0x8faad9, 0x8fabd9, 0x8faadb, 0x8fabdb,
/* 18 */ 0x8faada, 0x8fabda, 0x8faadc, 0x8fabdc, 0x8faadd, 0x8fabdd, 0x8faadf, 0x8fabdf,
/* 20 */ 0x8faade, 0x8fabde, 0x8faae1, 0x8fabe1, 0x8faae0, 0x8fabe0, 0x8fa9af, 0x8fa9cf,
/* 28 */ 0x8faaec, 0x8fabec, 0x8faae9, 0x8fabe9, 0x8faae6, 0x8fabe6, 0x8faaeb, 0x8fabeb,
/* 30 */ 0x8faae8, 0x8fabe8, 0x8faaea, 0x8fabea, 0x8faaf1, 0x8fabf1, 0x8faaf4, 0x8fabf4,
/* 38 */ 0x8faaf3, 0x8faaf5, 0x8fabf5, 0x8faaf7, 0x8fabf7, 0x8faaf6, 0x8fabf6,    BAD
},

/* Row 0x804 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8faaa6, 0x8faba6, 0x8faac3,
/* 10 */ 0x8fabc3, 0x8faad5, 0x8fabd5, 0x8faae7, 0x8fabe7, 0x8faaf0, 0x8fabf0, 0x8faaed,
/* 18 */ 0x8fabed, 0x8faaef, 0x8fabef, 0x8faaee, 0x8fabee,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fabb9,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x805 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fa2b0,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8fa2af, 0x8fa2b2, 0x8fa2b6, 0x8fa2b5,    BAD, 0x8fa2b3,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x806 */
{
/* 00 */ 0x0060, 0xa1ad, 0x005e,    BAD, 0x8fa2b4,    BAD, 0x8fa2b5, 0x8fa2b2,
/* 08 */ 0xa1af,    BAD, 0x8fa2b6, 0x8fa2b3, 0x8fa2b0,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fa2b1,
/* 28 */ 0x8fa2b5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x005f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x807 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8fa2b8, 0x8fa2b9, 0x8fa6e1,    BAD,
/* 08 */ 0x8fa6e2, 0x8fa6e3, 0x8fa6e4,    BAD, 0x8fa6e7,    BAD, 0x8fa6e9, 0x8fa6ec,
/* 10 */ 0x8fa6f6, 0xa6a1, 0xa6a2, 0xa6a3, 0xa6a4, 0xa6a5, 0xa6a6, 0xa6a7,
/* 18 */ 0xa6a8, 0xa6a9, 0xa6aa, 0xa6ab, 0xa6ac, 0xa6ad, 0xa6ae, 0xa6af,
/* 20 */ 0xa6b0, 0xa6b1,    BAD, 0xa6b2, 0xa6b3, 0xa6b4, 0xa6b5, 0xa6b6,
/* 28 */ 0xa6b7, 0xa6b8, 0x8fa6e5, 0x8fa6ea, 0x8fa6f1, 0x8fa6f2, 0x8fa6f3, 0x8fa6f4,
/* 30 */ 0x8fa6fb, 0xa6c1, 0xa6c2, 0xa6c3, 0xa6c4, 0xa6c5, 0xa6c6, 0xa6c7,
/* 38 */ 0xa6c8, 0xa6c9, 0xa6ca, 0xa6cb, 0xa6cc, 0xa6cd, 0xa6ce, 0xa6cf
},

/* Row 0x808 */
{
/* 00 */ 0xa6d0, 0xa6d1, 0x8fa6f8, 0xa6d2, 0xa6d3, 0xa6d4, 0xa6d5, 0xa6d6,
/* 08 */ 0xa6d7, 0xa6d8, 0x8fa6f5, 0x8fa6fa, 0x8fa6f7, 0x8fa6f9, 0x8fa6fc,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x809 */
{
/* 00 */    BAD, 0xa7a7, 0x8fa7c2, 0x8fa7c3, 0x8fa7c4, 0x8fa7c5, 0x8fa7c6, 0x8fa7c7,
/* 08 */ 0x8fa7c8, 0x8fa7c9, 0x8fa7ca, 0x8fa7cb, 0x8fa7cc,    BAD, 0x8fa7cd, 0x8fa7ce,
/* 10 */ 0xa7a1, 0xa7a2, 0xa7a3, 0xa7a4, 0xa7a5, 0xa7a6, 0xa7a8, 0xa7a9,
/* 18 */ 0xa7aa, 0xa7ab, 0xa7ac, 0xa7ad, 0xa7ae, 0xa7af, 0xa7b0, 0xa7b1,
/* 20 */ 0xa7b2, 0xa7b3, 0xa7b4, 0xa7b5, 0xa7b6, 0xa7b7, 0xa7b8, 0xa7b9,
/* 28 */ 0xa7ba, 0xa7bb, 0xa7bc, 0xa7bd, 0xa7be, 0xa7bf, 0xa7c0, 0xa7c1,
/* 30 */ 0xa7d1, 0xa7d2, 0xa7d3, 0xa7d4, 0xa7d5, 0xa7d6, 0xa7d8, 0xa7d9,
/* 38 */ 0xa7da, 0xa7db, 0xa7dc, 0xa7dd, 0xa7de, 0xa7df, 0xa7e0, 0xa7e1
},

/* Row 0x80a */
{
/* 00 */ 0xa7e2, 0xa7e3, 0xa7e4, 0xa7e5, 0xa7e6, 0xa7e7, 0xa7e8, 0xa7e9,
/* 08 */ 0xa7ea, 0xa7eb, 0xa7ec, 0xa7ed, 0xa7ee, 0xa7ef, 0xa7f0, 0xa7f1,
/* 10 */    BAD, 0xa7d7, 0x8fa7f2, 0x8fa7f3, 0x8fa7f4, 0x8fa7f5, 0x8fa7f6, 0x8fa7f7,
/* 18 */ 0x8fa7f8, 0x8fa7f9, 0x8fa7fa, 0x8fa7fb, 0x8fa7fc,    BAD, 0x8fa7fd, 0x8fa7fe,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x80b */
{
/* 00 */    BAD,    BAD,    BAD, 0xa1ee,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fa2f1,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8fa2ef,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xa2f2,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x80c */
{
/* 00 */ 0xa1a1, 0xa1a2, 0xa1a3, 0xa1b7,    BAD, 0xa1b9, 0xa1ba, 0xa1bb,
/* 08 */ 0xa1d2, 0xa1d3, 0xa1d4, 0xa1d5, 0xa1d6, 0xa1d7, 0xa1d8, 0xa1d9,
/* 10 */ 0xa1da, 0xa1db, 0xa2a9, 0xa2ae, 0xa1cc, 0xa1cd,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x8fa2b7,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x80d */
{
/* 00 */ 0xb0ec, 0xc3fa, 0x8fb0a1, 0xbcb7, 0x8fb0a2, 0x8fb0a3,    BAD, 0xcbfc,
/* 08 */ 0xbee6, 0xbbb0, 0xbee5, 0xb2bc, 0x8fb0a4, 0xc9d4, 0xcdbf,    BAD,
/* 10 */ 0xd0a2, 0xb1af, 0x8fb0a5,    BAD, 0xb3ee, 0xd0a3, 0xc0a4, 0xd2c2,
/* 18 */ 0xb5d6, 0xcaba,    BAD,    BAD,    BAD,    BAD, 0xbee7, 0x8fb0a6,
/* 20 */    BAD, 0xcebe,    BAD, 0x8fb0a7, 0x8fb0a8,    BAD, 0xcac2,    BAD,
/* 28 */ 0x8fb0a9,    BAD, 0xd0a4, 0x8fb0aa,    BAD, 0xc3e6, 0x8fb0ab, 0x8fb0ac,
/* 30 */ 0x8fb0ad, 0xd0a5, 0xb6fa,    BAD,    BAD, 0x8fb0ae, 0xd0a6,    BAD,
/* 38 */ 0xb4dd, 0xc3b0,    BAD, 0xbce7, 0xd0a7,    BAD,    BAD, 0xd0a8
},

/* Row 0x80e */
{
/* 00 */ 0x8fb0af, 0x8fb0b0, 0xd0a9, 0xc7b5, 0x8fb0b1, 0xb5d7,    BAD, 0x8fb0b2,
/* 08 */    BAD,    BAD,    BAD, 0xc7b7,    BAD, 0xc6e3, 0xb8c3, 0xcbb3,
/* 10 */    BAD, 0x8fb0b3,    BAD,    BAD,    BAD, 0xe9c9, 0xd0aa, 0xbee8,
/* 18 */ 0xd0ab, 0xb2b5, 0x8fb0b4,    BAD, 0x8fb0b5, 0xb6e5, 0xb8f0, 0xcce9,
/* 20 */    BAD,    BAD, 0xd6a6, 0x8fb0b6,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8fb0b7, 0x8fb0b8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xcdf0,    BAD, 0xc6fd, 0x8fb0b9, 0x8fb0ba,    BAD,    BAD,
/* 38 */    BAD, 0x8fb0bb,    BAD,    BAD,    BAD,    BAD, 0xb4a5, 0x8fb0bc
},

/* Row 0x80f */
{
/* 00 */ 0xb5b5,    BAD, 0xd0ac,    BAD,    BAD, 0xd0ad, 0xcebb,    BAD,
/* 08 */ 0xcdbd, 0xc1e8, 0xd0af, 0xbbf6, 0xc6f3, 0x8fb0bd, 0xd0b2,    BAD,
/* 10 */    BAD, 0xb1be, 0xb8df,    BAD, 0xb8de, 0xb0e6, 0x8fb0be, 0x8fb0bf,
/* 18 */ 0xcfcb, 0xcfca,    BAD, 0xbab3, 0xb0a1, 0x8fb0c0, 0xd0b3, 0xd0b4,
/* 20 */ 0xd0b5, 0xcbb4, 0xd0b6,    BAD, 0xb8f2, 0xb0e7, 0xcbf2,    BAD,
/* 28 */ 0xb5fc,    BAD,    BAD, 0xb5fd, 0xb5fe, 0xc4e2, 0xcebc, 0x8fb0c1,
/* 30 */ 0xd0b7,    BAD,    BAD, 0xd0b8,    BAD,    BAD, 0xd0b9,    BAD,
/* 38 */    BAD, 0x8fb0c2, 0xbfcd,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x810 */
{
/* 00 */ 0xbdba, 0xbfce, 0xd0be, 0x8fb0c3, 0xd0bc,    BAD, 0xd0bd, 0xb5d8,
/* 08 */    BAD,    BAD, 0xbaa3, 0xb2f0,    BAD, 0xd0bb, 0xd0ba, 0xcaa9,
/* 10 */ 0x8fb0c4,    BAD,    BAD,    BAD, 0xbbc6, 0xbbc5, 0xc2be, 0xd0bf,
/* 18 */ 0xc9d5, 0xc0e7, 0x8fb0c5, 0x8fb0c6,    BAD, 0xa1b8, 0xd0c0, 0xd0c2,
/* 20 */ 0x8fb0c7, 0x8fb0c8, 0x8fb0c9, 0xc2e5, 0xcee1, 0xb0ca,    BAD,    BAD,
/* 28 */ 0x8fb0ca,    BAD,    BAD,    BAD,    BAD, 0xd0c1, 0xb2be, 0x8fb0cb,
/* 30 */ 0xb6c4, 0x8fb0cc, 0xc3e7, 0x8fb0cd,    BAD, 0x8fb0ce, 0xb7ef, 0xd0c3,
/* 38 */    BAD,    BAD,    BAD, 0xc7a4,    BAD, 0x8fb0cf, 0x8fb0d0, 0x8fb0d1
},

/* Row 0x811 */
{
/* 00 */ 0x8fb0d2, 0xb4eb, 0x8fb0d3, 0x8fb0d4,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8fb0d5, 0xd0c4, 0xb0cb, 0x8fb0d6, 0x8fb0d7, 0xb8e0, 0xb4ec, 0xc9fa,
/* 10 */ 0xc8b2, 0xb5d9, 0x8fb0d8,    BAD,    BAD, 0x8fb0d9, 0x8fb0da, 0x8fb0db,
/* 18 */    BAD, 0x8fb0dc, 0xb2f1,    BAD, 0xd0e7, 0xc5c1,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fb0dd, 0xc7ec,
/* 30 */ 0xd0c6, 0x8fb0de,    BAD, 0x8fb0e0, 0xc8bc, 0x8fb0e1, 0xcee2, 0x8fb0e2,
/* 38 */ 0xbfad, 0x8fb0e3, 0xbbc7, 0x8fb0e4, 0xbbf7, 0xb2c0, 0x8fb0e5,    BAD
},

/* Row 0x812 */
{
/* 00 */ 0x8fb0e6,    BAD, 0x8fb0e7, 0xc4d1,    BAD,    BAD, 0xc3a2, 0xd0ca,
/* 08 */ 0x8fb0e8, 0x8fb0e9,    BAD, 0x8fb0ea, 0x8fb0eb, 0xb0cc, 0xc4e3, 0xbdbb,
/* 10 */ 0xbab4, 0xcda4, 0x8fb0ec, 0xc2ce, 0x8fb0ed, 0xb2bf, 0x8fb0ee, 0xd0c9,
/* 18 */ 0x8fb0ef, 0xcdbe, 0xd0c5, 0xd0c7, 0xbaee, 0xd0c8, 0xd5a4, 0x8fb0f0,
/* 20 */ 0x8fb0df,    BAD,    BAD, 0x8fb0f1,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xd0d0, 0x8fb0f2,    BAD, 0x8fb0f3,    BAD, 0x8fb0f4, 0xd0d3,
/* 30 */ 0xd0d1, 0x8fb0f5,    BAD, 0xb2c2,    BAD, 0xcabb, 0xd0cb, 0x8fb0f6,
/* 38 */ 0x8fb0f7, 0x8fb0f8, 0x8fb0f9, 0xd0cf, 0xb8f3, 0x8fb0fa, 0x8fb0fb, 0xbbc8
},

/* Row 0x813 */
{
/* 00 */    BAD, 0x8fb0fc, 0x8fb0fd, 0xb4a6, 0x8fb0fe, 0x8fb1a1, 0xd0d4,    BAD,
/* 08 */ 0xd0cc, 0x8fb1a2, 0x8fb1a3, 0xcee3, 0x8fb1a4, 0xbbf8, 0x8fb1a5, 0xd0cd,
/* 10 */ 0x8fb1a6, 0xd0d2, 0x8fb1a7, 0x8fb1a8, 0x8fb1a9,    BAD, 0xd0d5, 0x8fb1aa,
/* 18 */ 0xd0ce, 0x8fb1ab, 0x8fb1ac, 0xb6a1,    BAD, 0xb0cd, 0x8fb1ad, 0x8fb1ae,
/* 20 */ 0xb6a2, 0xb2c1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xd5a5,    BAD, 0xcbf9, 0xc9ee, 0xb8f4,
/* 30 */    BAD,    BAD, 0x8fb1af,    BAD,    BAD, 0xbfaf, 0xceb7, 0x8fb1b0,
/* 38 */    BAD, 0x8fb1b1,    BAD, 0x8fb1b2, 0x8fb1b3, 0x8fb1b4, 0x8fb1b5, 0xcad8
},

/* Row 0x814 */
{
/* 00 */ 0x8fb1b6, 0x8fb1b7, 0xb7b8, 0xc2a5, 0xb2e4, 0x8fb1b8, 0x8fb1b9,    BAD,
/* 08 */ 0x8fb1ba, 0x8fb1bb, 0xbdd3, 0x8fb1bc, 0x8fb1bd, 0x8fb1be, 0xd0d9, 0x8fb1bf,
/* 10 */ 0xd0de, 0xd0dc, 0x8fb1c0,    BAD, 0xd0d7,    BAD,    BAD, 0xc2af,
/* 18 */ 0xd0da,    BAD, 0xd0dd, 0xd0db, 0x8fb1c1, 0xcadd,    BAD, 0xd0d8,
/* 20 */ 0x8fb1c2, 0xbfae, 0x8fb1c3, 0xcbf3, 0xd0df, 0xd0e0,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbda4, 0xd0ed,
/* 30 */ 0x8fb1c4,    BAD, 0x8fb1c5, 0xc7d0,    BAD, 0xc9b6, 0xd0e8,    BAD,
/* 38 */ 0xcaf0,    BAD, 0xb2b6,    BAD, 0x8fb1c6, 0x8fb1c7, 0xd0ec, 0x8fb1c8
},

/* Row 0x815 */
{
/* 00 */ 0x8fb1c9, 0x8fb1ca,    BAD,    BAD, 0x8fb1cb, 0xd0e6, 0xd0ef, 0x8fb1cc,
/* 08 */    BAD, 0xc1d2, 0x8fb1cd, 0xb8c4, 0x8fb1ce, 0xc7dc, 0x8fb1cf, 0xe0c7,
/* 10 */ 0x8fb1d0, 0xd0ee, 0xc5dd, 0x8fb1d1, 0xd0e3,    BAD, 0xb8f6, 0x8fb1d2,
/* 18 */ 0x8fb1d3, 0xb8f5, 0xd0e1, 0x8fb1d4, 0x8fb1d5, 0x8fb1d6, 0x8fb1d7, 0xbcda,
/* 20 */    BAD, 0xd0e9, 0x8fb1d8, 0xcaef, 0xc3cd, 0xd0e5, 0xb7f1, 0x8fb1d9,
/* 28 */ 0xd0e2, 0xd0ea, 0xd0e4, 0xced1, 0xd0eb, 0xcfc1, 0x8fb1da,    BAD,
/* 30 */ 0x8fb1db,    BAD, 0x8fb1dc, 0x8fb1dd,    BAD, 0x8fb1de, 0xb6e6,    BAD,
/* 38 */    BAD, 0xb7f0,    BAD, 0x8fb1f6,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x816 */
{
/* 00 */ 0x8fb1df, 0x8fb1e0, 0x8fb1e1, 0xd0f0,    BAD, 0x8fb1e2, 0x8fb1e3, 0xd0f1,
/* 08 */ 0xd0f5, 0xb0ce, 0x8fb1e4,    BAD, 0x8fb1e5,    BAD, 0x8fb1e6, 0xcad0,
/* 10 */ 0xd0f4, 0x8fb1e7, 0x8fb1e8, 0x8fb1e9,    BAD, 0xd0f3, 0xd0f7, 0x8fb1ea,
/* 18 */    BAD, 0x8fb1eb, 0xd0f6,    BAD, 0xc4e4,    BAD,    BAD, 0x8fb1ec,
/* 20 */ 0x8fb1ed,    BAD, 0x8fb1ee, 0x8fb1ef,    BAD, 0xb7f2, 0x8fb1f0, 0x8fb1f1,
/* 28 */    BAD,    BAD, 0x8fb1f2,    BAD, 0xd0f8, 0x8fb1f3,    BAD,    BAD,
/* 30 */ 0x8fb1f4, 0x8fb1f5, 0xbcc5,    BAD, 0xc2a6, 0xc4e5, 0xb6f6,    BAD,
/* 38 */ 0xd0f9,    BAD,    BAD,    BAD,    BAD, 0xb5b6,    BAD,    BAD
},

/* Row 0x817 */
{
/* 00 */ 0xd0fa, 0x8fb1f7,    BAD, 0x8fb1f8, 0x8fb1f9, 0xd0fc, 0x8fb1fa,    BAD,
/* 08 */    BAD,    BAD, 0x8fb1fb,    BAD,    BAD, 0xcbb5, 0x8fb1fc, 0x8fb1fd,
/* 10 */ 0x8fb1fe, 0xb7e6, 0x8fb2a1, 0x8fb2a2, 0x8fb2a3,    BAD, 0x8fb2a4,    BAD,
/* 18 */ 0xbbb1, 0xc8f7, 0xd0fb, 0x8fb2a5, 0x8fb2a6,    BAD, 0x8fb2a7, 0x8fb2a8,
/* 20 */ 0x8fb2a9, 0x8fb2aa, 0x8fb2ab,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8fb2ac,    BAD, 0xbac5, 0xcdc3,    BAD, 0x8fb2ad,
/* 30 */ 0x8fb2ae,    BAD, 0xd0fe, 0xd1a3, 0xd0fd, 0xbac4,    BAD, 0xbdfd,
/* 38 */    BAD, 0x8fb2af, 0x8fb2b0,    BAD,    BAD, 0x8fb2b1, 0xb7b9,    BAD
},

/* Row 0x818 */
{
/* 00 */ 0x8fb2b2,    BAD, 0xd1a4, 0x8fb2b3, 0x8fb2b4, 0xb6cf,    BAD, 0x8fb2b5,
/* 08 */    BAD, 0xd1a1, 0xd1a2,    BAD, 0x8fb2b6, 0xc6af, 0x8fb2b7, 0xc1fc,
/* 10 */ 0x8fb2b8, 0xb6a3,    BAD, 0x8fb2b9, 0x8fb2ba, 0xcbcd, 0xd1a5,    BAD,
/* 18 */ 0x8fb2bb,    BAD, 0xcebd,    BAD, 0x8fb2bc, 0x8fb2bd, 0xd1a6, 0x8fb2be,
/* 20 */    BAD,    BAD, 0x8fb2bf, 0xd1a9, 0x8fb2c0, 0xd1a7, 0x8fb2c1, 0xc1ce,
/* 28 */ 0x8fb2c2, 0x8fb2c3,    BAD,    BAD,    BAD, 0xd1a8, 0xd1aa, 0x8fb2c4,
/* 30 */    BAD, 0x8fb2c5, 0x8fb2d1,    BAD,    BAD, 0xd1ac, 0x8fb2c6,    BAD,
/* 38 */    BAD, 0xd1ab, 0x8fb2c7, 0xcac8,    BAD,    BAD, 0x8fb2c8,    BAD
},

/* Row 0x819 */
{
/* 00 */ 0xb5b7, 0xd1ae, 0xd1af, 0x8fb2c9, 0xb2af,    BAD, 0x8fb2ca, 0x8fb2cb,
/* 08 */ 0x8fb2cc, 0xd1ad,    BAD, 0x8fb2cd, 0x8fb2ce, 0x8fb2cf, 0x8fb2d0,    BAD,
/* 10 */ 0x8fb2d2,    BAD, 0xbcf4,    BAD, 0xd1b2, 0xd1b1, 0xd1b0, 0x8fb2d3,
/* 18 */ 0xd0d6, 0x8fb2d4, 0xd1b3, 0x8fb2d5, 0x8fb2d6, 0x8fb2d7, 0x8fb2d8, 0xbdfe,
/* 20 */    BAD, 0xd1b4,    BAD, 0x8fb2d9,    BAD,    BAD,    BAD, 0x8fb2da,
/* 28 */ 0x8fb2db,    BAD, 0xcda5,    BAD, 0x8fb2dc, 0x8fb2dd,    BAD, 0x8fb2de,
/* 30 */    BAD, 0x8fb2df, 0xccd9, 0x8fb2e0, 0x8fb2e1, 0x8fb2e2,    BAD, 0xd1b6,
/* 38 */ 0x8fb2e3, 0x8fb2e4, 0xd1b5, 0xd1b8, 0xd1b7,    BAD,    BAD, 0xd1b9
},

/* Row 0x81a */
{
/* 00 */ 0xd1ba, 0xb0f4, 0x8fb2e5, 0xb8b5, 0xb7bb, 0xbdbc, 0xc3fb, 0xb6a4,
/* 08 */ 0xc0e8, 0xb8f7, 0x8fb2e6, 0xb9ee, 0xd1bc, 0xccc8, 0xc5c6, 0x8fb2e7,
/* 10 */ 0xbbf9,    BAD, 0xd1bb, 0x8fb2e8, 0xd1bd, 0x8fb2e9,    BAD, 0x8fb2ea,
/* 18 */ 0x8fb2eb,    BAD, 0xc5de,    BAD, 0xb3f5,    BAD,    BAD, 0x8fb2ec,
/* 20 */    BAD,    BAD, 0xd1be,    BAD, 0x8fb2ed, 0xc6fe, 0x8fb2ee,    BAD,
/* 28 */ 0xc1b4, 0xd1c0, 0xd1c1, 0xc8ac, 0xb8f8, 0xcfbb, 0xd1c2,    BAD,
/* 30 */    BAD, 0xb6a6,    BAD,    BAD,    BAD, 0xcabc, 0xc2b6, 0xb6f1,
/* 38 */ 0xc5b5,    BAD,    BAD,    BAD, 0xb7f3,    BAD, 0x8fb2ef,    BAD
},

/* Row 0x81b */
{
/* 00 */ 0xd1c3,    BAD, 0xd1c4, 0x8fb2f0, 0x8fb2f1, 0xc6e2, 0xb1df,    BAD,
/* 08 */    BAD, 0xd1c7, 0xbafd, 0x8fb2f2, 0xd1c6, 0xbac6, 0x8fb2f3, 0xd1c8,
/* 10 */ 0xe6ee, 0xd1c9, 0xcbc1, 0xd1ca,    BAD, 0xd1cb, 0xd1cc, 0xbee9,
/* 18 */ 0x8fb2f4, 0xbccc,    BAD,    BAD,    BAD, 0x8fb2f5,    BAD,    BAD,
/* 20 */ 0xb4a7, 0x8fb2f6, 0xd1cf, 0x8fb2f7, 0xd1cd, 0xccbd, 0xd1ce,    BAD,
/* 28 */ 0xc9da, 0xd1d0, 0xd1d1, 0xd1d2, 0xc5df, 0x8fb2f8,    BAD,    BAD,
/* 30 */ 0xd1d6, 0xd1d4, 0xd1d5, 0xd1d3, 0xbae3, 0xd1d7, 0xccea, 0xcee4,
/* 38 */ 0x8fb2f9,    BAD, 0x8fb2fa,    BAD, 0x8fb2fb, 0xd1d8, 0x8fb2fc, 0x8fb2fd
},

/* Row 0x81c */
{
/* 00 */    BAD,    BAD, 0x8fb2fe,    BAD, 0xc0a8, 0xd1d9, 0xbdda,    BAD,
/* 08 */ 0x8fb3a1, 0xd1da,    BAD, 0xc3fc, 0xcebf, 0xc5e0,    BAD, 0x8fb3a2,
/* 10 */    BAD, 0x8fb3a3, 0x8fb3a4, 0x8fb3a5,    BAD, 0x8fb3a6, 0xd2c5,    BAD,
/* 18 */ 0x8fb3a7,    BAD,    BAD, 0xd1db, 0xf4a5, 0xb6c5, 0x8fb3a8,    BAD,
/* 20 */ 0xd1dc, 0xcbde, 0x8fb3a9,    BAD,    BAD, 0x8fb3aa, 0xbde8, 0xc2fc,
/* 28 */    BAD, 0xd1de, 0xc6e4,    BAD,    BAD, 0xd1df, 0x8fb3ab,    BAD,
/* 30 */ 0xd1e0, 0xb3ae, 0x8fb3ac, 0x8fb3ad, 0x8fb3ae, 0xd1e1, 0xb6a7, 0x8fb3af,
/* 38 */ 0xc6cc, 0xb1fa, 0xbdd0,    BAD,    BAD, 0xc8a1, 0xd1e2,    BAD
},

/* Row 0x81d */
{
/* 00 */ 0xc5e1, 0x8fb3b0, 0x8fb3b1, 0xbfcf, 0xd1e3, 0x8fb3b2, 0xcaac, 0xc0da,
/* 08 */ 0xb4a2,    BAD, 0xb4a9, 0xd1e4,    BAD,    BAD, 0xd1e6,    BAD,
/* 10 */    BAD, 0xb7ba, 0x8fb3b3, 0x8fb3b4, 0xd1e5, 0x8fb3b5, 0x8fb3b6, 0xcef3,
/* 18 */ 0x8fb3b7,    BAD,    BAD,    BAD,    BAD, 0xbde9,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8fb3b8,    BAD, 0xc8bd, 0xcacc,    BAD, 0xd1e7,
/* 28 */ 0x8fb3b9, 0xcdf8, 0xd1e8,    BAD,    BAD,    BAD, 0xd1e9,    BAD,
/* 30 */ 0xc5fe, 0x8fb3ba, 0x8fb3bb, 0xd1ea,    BAD, 0x8fb3bc, 0xc0a9, 0xbafe,
/* 38 */ 0xb7f4, 0xd1eb, 0xbbc9, 0xb9ef, 0x8fb3bd,    BAD,    BAD,    BAD
},

/* Row 0x81e */
{
/* 00 */    BAD,    BAD,    BAD, 0xc4e6, 0xd1ed, 0x8fb3be,    BAD, 0xc2a7,
/* 08 */    BAD, 0x8fb3bf, 0xbaef, 0xd1ee, 0xd1ef, 0xc1b0,    BAD, 0xd1ec,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd1f1, 0x8fb3c0, 0xcbb6, 0x8fb3c1,
/* 18 */ 0x8fb3c2,    BAD, 0x8fb3c3, 0xb9e4, 0x8fb3c4,    BAD, 0xd1f0, 0x8fb3c5,
/* 20 */ 0x8fb3c6, 0x8fb3c7,    BAD, 0xb7f5, 0xbade, 0xc7ed, 0x8fb3c8,    BAD,
/* 28 */    BAD, 0xd1f4, 0xd1f2,    BAD,    BAD,    BAD, 0x8fb3c9, 0xc9fb,
/* 30 */ 0xbeea, 0xd1fb, 0xb3e4, 0xd1f5, 0xd1f3, 0xc1cf,    BAD, 0x8fb3ca,
/* 38 */ 0x8fb3cb, 0x8fb3cc,    BAD,    BAD,    BAD, 0xd1f7,    BAD, 0xd1f6
},

/* Row 0x81f */
{
/* 00 */ 0x8fb3cd,    BAD, 0x8fb3ce, 0xb3c4,    BAD, 0x8fb3cf,    BAD, 0xb7e0,
/* 08 */ 0xd1fc, 0xcead, 0x8fb3d0,    BAD, 0x8fb3d1, 0xd1f8,    BAD,    BAD,
/* 10 */    BAD, 0xd1fd, 0xd1fa, 0x8fb3d2, 0xd1f9, 0x8fb3d3, 0x8fb3d4, 0x8fb3d5,
/* 18 */ 0x8fb3d6,    BAD, 0x8fb3d7, 0xcecf, 0x8fb3d8,    BAD,    BAD, 0xb8f9,
/* 20 */ 0xb2c3,    BAD,    BAD, 0xcef4, 0x8fb3d9, 0x8fb3da, 0x8fb3db, 0x8fb3dc,
/* 28 */    BAD, 0xbdf5, 0xc5d8, 0xb9e5, 0xd2a2, 0xd2a3,    BAD, 0x8fb3dd,
/* 30 */ 0x8fb3de, 0xcee5,    BAD,    BAD, 0xcfab, 0xd2a5, 0x8fb3df, 0x8fb3e0,
/* 38 */ 0x8fb3e1, 0xb8fa, 0x8fb3e2, 0x8fb3e3, 0xd2a4, 0x8fb3e4, 0xb3af,    BAD
},

/* Row 0x820 */
{
/* 00 */ 0x8fb3e5, 0xd2a6,    BAD, 0xcbd6, 0x8fb3e6, 0xc4bc, 0x8fb3e7, 0xcda6,
/* 08 */ 0x8fb3e8, 0xcad9,    BAD,    BAD, 0x8fb3e9, 0xd2a7,    BAD, 0x8fb3ea,
/* 10 */    BAD, 0x8fb3eb, 0xf0d5,    BAD, 0x8fb3ec, 0xc6b0, 0x8fb3ed, 0xd2a8,
/* 18 */ 0xb4aa, 0xccb3,    BAD, 0x8fb3ee, 0x8fb3ef, 0xbea1, 0xd2a9, 0xcae7,
/* 20 */ 0xd2ad, 0x8fb3f0, 0xc0aa, 0xd2aa, 0xb6d0, 0x8fb3f1, 0xd2ab, 0xb4ab,
/* 28 */ 0x8fb3f2, 0x8fb3f3, 0x8fb3f4,    BAD, 0x8fb3f5,    BAD,    BAD,    BAD,
/* 30 */ 0x8fb3f6, 0x8fb3f7, 0xb7ae, 0xd2ae, 0x8fb3f8, 0xd2af, 0x8fb3f9, 0x8fb3fa,
/* 38 */ 0xd2b0, 0xd2b1, 0xbcdb,    BAD,    BAD,    BAD, 0xb8fb, 0xccde
},

/* Row 0x821 */
{
/* 00 */ 0x8fb3fb, 0xcce8, 0xc6f7, 0x8fb3fc,    BAD, 0xcaf1, 0xd2b2,    BAD,
/* 08 */ 0xd2b3,    BAD, 0x8fb3fd, 0x8fb3fe, 0x8fb4a1, 0xd2b5,    BAD, 0xd2b7,
/* 10 */ 0xd2b6, 0x8fb4a2,    BAD, 0x8fb4a3,    BAD, 0xd2b8, 0xb2bd, 0xcbcc,
/* 18 */ 0x8fb4a4, 0xbafc, 0xd2b9, 0x8fb4a5, 0x8fb4a6, 0xc1d9, 0x8fb4a7, 0x8fb4a8,
/* 20 */ 0xbea2, 0xb6a9,    BAD, 0xd2ba,    BAD, 0x8fb4a9,    BAD, 0x8fb4aa,
/* 28 */ 0x8fb4ab, 0x8fb4ac, 0xc8db, 0x8fb4ad, 0x8fb4ae, 0x8fb4af,    BAD, 0xd2bb,
/* 30 */ 0x8fb4b0, 0xd2bc, 0x8fb4b1, 0xd2bd,    BAD, 0x8fb4b2,    BAD,    BAD,
/* 38 */ 0xd2be, 0xc9a4, 0xb6e8, 0xb0e5, 0x8fb4b3, 0x8fb4b4, 0x8fb4b5, 0xc6bf
},

/* Row 0x822 */
{
/* 00 */ 0xd2bf, 0xbdbd, 0x8fb4b6, 0xc0e9,    BAD, 0xd2c1, 0xd2c0, 0xbea3,
/* 08 */ 0xb8e1, 0xd2c3, 0xc8be, 0x8fb4b8, 0x8fb4b7, 0xd2c4,    BAD,    BAD,
/* 10 */    BAD, 0xc8dc, 0xc2b4, 0xc2ee, 0xb6a8,    BAD,    BAD, 0xc6ee,
/* 18 */ 0xc3b1, 0x8fb4b9, 0xc7ee, 0x8fb4ba, 0xcbce,    BAD, 0xd2c6,    BAD,
/* 20 */ 0xc0ea, 0x8fb4bb,    BAD, 0x8fb4bc,    BAD, 0x8fb4bd, 0xb7b5,    BAD,
/* 28 */    BAD, 0xd2c7,    BAD,    BAD, 0x8fb4be, 0x8fb4bf, 0xd2c8, 0xb1ac,
/* 30 */ 0xb0f5, 0xb4ed, 0x8fb4c0, 0xc2a8, 0xb5d1, 0xcdf1,    BAD, 0xd2cb,
/* 38 */ 0xb2b7, 0x8fb4c1,    BAD, 0xd2ca,    BAD,    BAD, 0x8fb4c2, 0xb6aa
},

/* Row 0x823 */
{
/* 00 */    BAD,    BAD, 0xd2cc, 0x8fb4c3, 0xccf1,    BAD,    BAD, 0x8fb4c4,
/* 08 */ 0x8fb4c5,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fb4c6,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8fb4c7, 0x8fb4c8,    BAD, 0xd2cd,    BAD,
/* 18 */ 0xced2, 0x8fb4c9, 0xb8fc,    BAD,    BAD, 0x8fb4ca,    BAD, 0xb8b6,
/* 20 */ 0xd2ce, 0x8fb4cb,    BAD,    BAD, 0x8fb4cc, 0xd2d0, 0xd2cf,    BAD,
/* 28 */ 0xbfdf, 0xb1b9, 0x8fb4cd, 0x8fb4ce,    BAD, 0xb1de, 0xd2d1, 0x8fb4cf,
/* 30 */ 0xd2d2,    BAD, 0x8fb4d0, 0xb8b7, 0x8fb4d1, 0x8fb4d2, 0xd2d3, 0x8fb4d3,
/* 38 */ 0x8fb4d4,    BAD, 0x8fb4d5, 0xb5ee,    BAD, 0x8fb4d6,    BAD,    BAD
},

/* Row 0x824 */
{
/* 00 */ 0x8fb4d7,    BAD, 0xbbb2, 0xd2d4,    BAD, 0x8fb4d8,    BAD,    BAD,
/* 08 */ 0xcbf4, 0xbab5, 0xb5da, 0xcda7, 0xc1d0, 0xc8bf, 0xbcfd, 0x8fb4d9,
/* 10 */    BAD,    BAD, 0x8fb4da, 0x8fb4db, 0xbdc7, 0x8fb4dc, 0xbce8, 0xbcf5,
/* 18 */    BAD, 0xbdf6, 0x8fb4dd, 0xc8c0,    BAD, 0x8fb4de, 0x8fb4df, 0xd2d7,
/* 20 */ 0x8fb4e0, 0xb1c3, 0xc1d1, 0xb8fd, 0xb8c5, 0xb6e7, 0x8fb4e1, 0x8fb4e2,
/* 28 */ 0xd2db, 0xc3a1, 0xc2fe, 0xb6ab, 0xbea4, 0xd2dc, 0xd2da, 0xb2c4,
/* 30 */ 0xc2e6, 0xbcb8, 0xbbcb, 0xb1a6,    BAD, 0x8fb4e3, 0xb3f0, 0xb9e6,
/* 38 */ 0xbbca,    BAD, 0xd2dd,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x825 */
{
/* 00 */    BAD, 0xd2de, 0x8fb4e4, 0xb5c9, 0xb3c6,    BAD,    BAD,    BAD,
/* 08 */ 0xb9e7, 0xb5c8, 0xc4df, 0xb1a5, 0xc6b1, 0xccbe, 0xb9a1, 0xcdf9,
/* 10 */ 0xc5c7, 0xb8fe,    BAD, 0x8fb4e5,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8fb4e6, 0xb7af,    BAD, 0xd2e7,    BAD, 0xb6e3,
/* 20 */ 0xcbca, 0x8fb4e7,    BAD,    BAD,    BAD,    BAD, 0xc8dd, 0x8fb4e8,
/* 28 */ 0x8fb4e9, 0xd2e6, 0x8fb4ea, 0xb4de, 0xd2e1, 0xd2e2, 0xd2e4, 0x8fb4eb,
/* 30 */    BAD, 0x8fb4ec,    BAD,    BAD, 0x8fb4ed, 0x8fb4ee, 0xd2e5,    BAD,
/* 38 */ 0xb5db, 0xbfe1,    BAD, 0xcaad, 0xd2e3, 0xd2df, 0xb8e3,    BAD
},

/* Row 0x826 */
{
/* 00 */ 0xd2e0,    BAD, 0xcfa4, 0x8fb4ef, 0x8fb4f0,    BAD, 0xcaf2, 0x8fb4f1,
/* 08 */ 0xc4e8, 0xb8e2, 0xb9f0,    BAD,    BAD, 0x8fb4f2, 0xd2e8, 0x8fb4f3,
/* 10 */    BAD, 0xc6dd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fb4f4, 0xd2ec,
/* 20 */    BAD,    BAD, 0x8fb4f5,    BAD, 0x8fb4f6,    BAD, 0x8fb4f7, 0x8fb4f8,
/* 28 */ 0xbcfe, 0x8fb4f9, 0xbcf6, 0x8fb4fa,    BAD, 0x8fb4fb, 0x8fb4fc,    BAD,
/* 30 */ 0xd2ef, 0xd2ed,    BAD, 0xcca3, 0x8fb4fd, 0xd2ea, 0xd2f3, 0xd2ee,
/* 38 */    BAD,    BAD,    BAD, 0xd2f1, 0xb8c6, 0xccbf,    BAD, 0x8fb4fe
},

/* Row 0x827 */
{
/* 00 */ 0xd2f2, 0x8fb5a1,    BAD, 0x8fb5a2, 0xd2f4, 0x8fb5a3, 0xd2f6,    BAD,
/* 08 */ 0x8fb5a4, 0x8fb5a5,    BAD, 0xbaf0, 0xcfc2, 0x8fb5a6, 0xd2eb, 0xd2e9,
/* 10 */ 0xd2f5, 0x8fb5a7, 0xd2f0,    BAD,    BAD, 0x8fb5a8, 0x8fb5a9,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x8fb5aa,    BAD,    BAD, 0x8fb5ab,
/* 20 */    BAD, 0x8fb5ac, 0xd2f8,    BAD, 0xd3a3, 0xd2fa, 0x8fb5ad, 0x8fb5ae,
/* 28 */ 0xd2fe, 0x8fb5af, 0x8fb5b0, 0xd3a1, 0xd2fb, 0x8fb5b1, 0x8fb5b2, 0xd3be,
/* 30 */    BAD, 0x8fb5b3, 0xbae9, 0xb3b1,    BAD,    BAD,    BAD, 0x8fb5b4,
/* 38 */ 0xd2f9, 0x8fb5b5, 0x8fb5b6, 0x8fb5b7, 0xd3a5, 0xb0f6, 0xd3a4, 0x8fb5b8
},

/* Row 0x828 */
{
/* 00 */ 0xb0a5, 0xc9ca, 0xd3a2,    BAD, 0xd2fc,    BAD, 0x8fb5b9, 0xd2f7,
/* 08 */ 0xd2fd, 0xbac8, 0x8fb5ba,    BAD,    BAD, 0x8fb5bb, 0x8fb5bc,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xd3a6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8fb5bd, 0xb0f7, 0xd3af,    BAD,    BAD, 0xd3a7, 0xd3a8,    BAD,
/* 28 */ 0xbea5, 0xcbe9, 0x8fb5be,    BAD, 0x8fb5bf, 0xd3ad, 0xd3ac, 0x8fb5c0,
/* 30 */    BAD,    BAD, 0xc5af,    BAD,    BAD,    BAD, 0x8fb5c1,    BAD,
/* 38 */    BAD,    BAD, 0xd3ae,    BAD, 0x8fb5c2, 0xd3ab, 0x8fb5c3, 0x8fb5c4
},

/* Row 0x829 */
{
/* 00 */ 0x8fb5c5, 0x8fb5c6,    BAD,    BAD, 0xb1b4, 0x8fb5c7, 0xbab6, 0xbfb0,
/* 08 */ 0x8fb5c8, 0x8fb5c9,    BAD,    BAD, 0x8fb5ca, 0x8fb5cb, 0x8fb5cc, 0xd3a9,
/* 10 */ 0xc5e2,    BAD,    BAD,    BAD, 0xd3aa, 0x8fb5cd, 0xb0a2,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8fb5ce, 0x8fb5cf,    BAD,    BAD, 0xd3b4, 0xcda3,
/* 30 */    BAD, 0xbea7, 0x8fb5d0, 0xd3ba,    BAD, 0x8fb5d1, 0x8fb5d2,    BAD,
/* 38 */ 0xd3b9, 0xd3b0,    BAD, 0x8fb5d3, 0x8fb5d4, 0x8fb5d5, 0xc2c3,    BAD
},

/* Row 0x82a */
{
/* 00 */ 0xd3b1, 0x8fb5d6,    BAD,    BAD, 0xc2ef, 0xd3b6, 0xbea6, 0x8fb5d7,
/* 08 */    BAD, 0x8fb5d8, 0x8fb5d9,    BAD, 0xd3b3, 0x8fb5da,    BAD, 0xcce4,
/* 10 */ 0x8fb5db, 0x8fb5dc,    BAD, 0xb7bc,    BAD,    BAD, 0xd3b7, 0xd3b8,
/* 18 */ 0x8fb5dd,    BAD, 0x8fb5de, 0x8fb5df, 0xd3b5, 0xd3bb, 0x8fb5e0,    BAD,
/* 20 */ 0x8fb5e1, 0x8fb5e2,    BAD, 0xd3b2, 0x8fb5e3,    BAD, 0x8fb5e4,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xd3c1, 0xd3c6,    BAD, 0xd3c2, 0x8fb5e5
},

/* Row 0x82b */
{
/* 00 */ 0xd3bd, 0x8fb5e6, 0x8fb5e7, 0xd3c7, 0xc1b1,    BAD, 0x8fb5e8, 0xd3c9,
/* 08 */ 0x8fb5e9, 0xb9a2, 0xd3bf, 0xc3fd,    BAD,    BAD, 0x8fb5ea, 0x8fb5eb,
/* 10 */    BAD, 0x8fb5ec, 0x8fb5ed, 0x8fb5ee, 0x8fb5ef,    BAD,    BAD, 0x8fb5f0,
/* 18 */ 0xd3c3, 0xd3bc, 0xb4ad,    BAD, 0xb4ee, 0xb3e5, 0xd3c4, 0xd3c0,
/* 20 */    BAD,    BAD,    BAD, 0x8fb5f1, 0x8fb5f2,    BAD,    BAD, 0xb7f6,
/* 28 */ 0xd3ca, 0xd3c8, 0xc1d3, 0xb5ca, 0xb6ac, 0x8fb5f3, 0xd3c5,    BAD,
/* 30 */ 0xb6f4,    BAD, 0x8fb5f4,    BAD,    BAD,    BAD, 0xb1c4,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fb5f5
},

/* Row 0x82c */
{
/* 00 */    BAD, 0x8fb5f6,    BAD, 0x8fb5f7, 0xd3ce, 0xd3cc, 0x8fb5f8, 0xd4a7,
/* 08 */    BAD, 0x8fb5f9,    BAD, 0x8fb5fa, 0x8fb5fb,    BAD, 0x8fb5fc,    BAD,
/* 10 */    BAD, 0x8fb5fd, 0x8fb5fe, 0x8fb6a1, 0xd3d1,    BAD,    BAD, 0x8fb6a2,
/* 18 */ 0x8fb6a3,    BAD, 0xd3cb, 0x8fb6a4, 0xd3cf,    BAD, 0x8fb6a5, 0xd3cd,
/* 20 */    BAD,    BAD, 0x8fb6a6, 0xbbcc, 0xd3d0,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8fb6a7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fb6a8, 0xd3d3,
/* 38 */    BAD, 0xd3d8,    BAD,    BAD,    BAD, 0xd3d6, 0xd3d5, 0x8fb6a9
},

/* Row 0x82d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fb6aa, 0xc3b2,    BAD,
/* 08 */ 0x8fb6ab, 0xb2c5, 0x8fb6ac,    BAD,    BAD, 0x8fb6ad, 0x8fb6ae, 0x8fb6af,
/* 10 */ 0x8fb6b0, 0x8fb6b1, 0x8fb6b2,    BAD, 0xd3d2,    BAD, 0xd3d4, 0xbea8,
/* 18 */ 0xb1b3, 0x8fb6b3,    BAD, 0xd3d7,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xb2de,    BAD,    BAD, 0x8fb6b4,    BAD,    BAD, 0xd3e2,
/* 30 */ 0x8fb6b5, 0xbefc, 0xd3de, 0x8fb6b6, 0xd3dc, 0x8fb6b7, 0xd3dd, 0x8fb6b8,
/* 38 */ 0xd3df, 0x8fb6b9,    BAD, 0x8fb6ba, 0x8fb6bb, 0x8fb6bc,    BAD, 0x8fb6bd
},

/* Row 0x82e */
{
/* 00 */ 0x8fb6be, 0x8fb6bf, 0xb1bd, 0x8fb6c0, 0x8fb6c1,    BAD, 0x8fb6c2,    BAD,
/* 08 */    BAD, 0x8fb6c3,    BAD, 0x8fb6c4, 0xc1b9, 0x8fb6c5, 0xd3d9, 0x8fb6c6,
/* 10 */ 0xd3da,    BAD,    BAD,    BAD, 0x8fb6c7,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xb3fa,    BAD,    BAD, 0x8fb6c8,    BAD,
/* 20 */ 0x8fb6c9, 0x8fb6ca, 0x8fb6cb, 0x8fb6cc, 0xd3e1,    BAD, 0x8fb6cd,    BAD,
/* 28 */ 0xb4ef, 0x8fb6ce, 0xd3e4, 0xd3e0, 0xd3e3, 0x8fb6cf,    BAD, 0x8fb6d0,
/* 30 */    BAD, 0x8fb6d1, 0x8fb6d2,    BAD, 0xcaae, 0x8fb6d3,    BAD,    BAD,
/* 38 */ 0xc6d5,    BAD, 0xc8b8,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x82f */
{
/* 00 */ 0xd3e6,    BAD,    BAD,    BAD, 0x8fb6d4, 0x8fb6d5, 0xd3e5, 0xb3c5,
/* 08 */ 0x8fb6d6,    BAD, 0xd3e7, 0x8fb6d7, 0x8fb6d8,    BAD,    BAD, 0xd3ea,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd3e9, 0x8fb6d9,    BAD,    BAD,
/* 18 */    BAD, 0x8fb6da, 0x8fb6db,    BAD,    BAD, 0x8fb6dc, 0x8fb6dd, 0x8fb6de,
/* 20 */ 0xd3e8,    BAD, 0xc7b9,    BAD,    BAD, 0xd3eb, 0x8fb6df, 0x8fb6e0,
/* 28 */ 0x8fb6e1, 0x8fb6e2,    BAD, 0x8fb6e3, 0x8fb6e4, 0x8fb6e5, 0xd3ec,    BAD,
/* 30 */    BAD, 0x8fb6e6,    BAD, 0x8fb6e7, 0xd3ee,    BAD, 0xd3ed, 0x8fb6e8,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xd3f0,    BAD, 0x8fb6e9,    BAD
},

/* Row 0x830 */
{
/* 00 */ 0xd3f3, 0xd3f1, 0xd3ef, 0xd3f2,    BAD, 0x8fb6ea,    BAD,    BAD,
/* 08 */ 0xd3f4, 0x8fb6eb, 0x8fb6ec, 0x8fb6ed, 0x8fb6f0, 0x8fb6f1, 0xd3f5, 0x8fb6ee,
/* 10 */ 0x8fb6ef, 0xd3f6,    BAD, 0xd3f7,    BAD,    BAD,    BAD, 0xd3f8,
/* 18 */ 0xd1c5, 0x8fb6f2, 0xbcfc, 0xbbcd, 0x8fb6f3, 0x8fb6f4, 0xb2f3, 0x8fb6f5,
/* 20 */ 0xb0f8, 0x8fb6f6,    BAD, 0xc3c4, 0x8fb6f7, 0x8fb6f8, 0x8fb6f9, 0x8fb6fa,
/* 28 */ 0x8fb6fb,    BAD,    BAD, 0x8fb6fd,    BAD, 0x8fb6fe, 0xd3f9,    BAD,
/* 30 */ 0xbaa4, 0x8fb6fc, 0xb0cf, 0xbfde,    BAD,    BAD, 0x8fb7a1, 0x8fb7a2,
/* 38 */    BAD, 0xd3fa, 0xb8c7,    BAD,    BAD, 0xb9f1,    BAD, 0xd3fc
},

/* Row 0x831 */
{
/* 00 */ 0xd3fb, 0x8fb7a3, 0x8fb7a4, 0xcae0, 0xd3fd,    BAD,    BAD, 0x8fb7a5,
/* 08 */ 0xd4a1, 0xd3fe, 0x8fb7a6, 0xd4a2, 0x8fb7a7, 0xd4a3,    BAD, 0xb7f7,
/* 10 */    BAD, 0x8fb7a8, 0xb1e0, 0xd4a4,    BAD, 0x8fb7a9, 0xd4a6,    BAD,
/* 18 */ 0xd4a5,    BAD, 0x8fb7aa, 0x8fb7ab, 0xd4a8, 0x8fb7ac,    BAD, 0xc5da,
/* 20 */ 0x8fb7ad,    BAD, 0x8fb7ae, 0x8fb7af, 0x8fb7b0, 0x8fb7b1, 0xd4a9, 0xb0b5,
/* 28 */ 0xbadf, 0x8fb7b2, 0x8fb7b3,    BAD, 0x8fb7b4, 0xb7bd, 0x8fb7b5, 0x8fb7b6,
/* 30 */ 0xc3cf,    BAD,    BAD, 0x8fb7b7, 0x8fb7b8,    BAD,    BAD, 0xd4aa,
/* 38 */ 0xd4ab,    BAD,    BAD, 0xd4ad,    BAD, 0x8fb7b9, 0x8fb7ba, 0x8fb7bb
},

/* Row 0x832 */
{
/* 00 */ 0xd4ae,    BAD, 0xbae4,    BAD,    BAD, 0x8fb7bc, 0x8fb7bd, 0xb6d1,
/* 08 */    BAD,    BAD, 0xcbb7,    BAD, 0x8fb7be, 0x8fb7bf, 0xd4ac, 0xd4af,
/* 10 */ 0xbac1, 0xb9a3, 0x8fb7c0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xd4b3, 0x8fb7c1,    BAD, 0xbaa5, 0x8fb7c2, 0xc3b3, 0x8fb7c3,
/* 28 */ 0x8fb7c4, 0xd4b0, 0xc4da, 0x8fb7c5,    BAD, 0x8fb7c6, 0x8fb7c7, 0x8fb7c8,
/* 30 */ 0x8fb7c9, 0x8fb7ca,    BAD, 0x8fb7cb, 0x8fb7cc, 0x8fb7cd,    BAD, 0x8fb7ce,
/* 38 */    BAD, 0x8fb7cf, 0x8fb7d0, 0x8fb7d1, 0x8fb7d2,    BAD, 0x8fb7d3, 0xd4b4
},

/* Row 0x833 */
{
/* 00 */    BAD, 0x8fb7d4, 0xbfe2, 0x8fb7d5,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd4b2, 0xd4b5,    BAD, 0xb7bf, 0x8fb7d6,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xd4b6, 0x8fb7d7, 0x8fb7e0,    BAD, 0x8fb7d8,
/* 18 */    BAD, 0x8fb7d9, 0x8fb7da,    BAD, 0x8fb7db, 0x8fb7dc, 0x8fb7dd, 0x8fb7de,
/* 20 */ 0xd4b7, 0x8fb7df, 0xb9a4, 0xb3c0, 0xd4b9,    BAD,    BAD, 0x8fb7e1,
/* 28 */ 0x8fb7e2, 0x8fb7e3, 0xd4ba,    BAD, 0x8fb7e4,    BAD,    BAD,    BAD,
/* 30 */ 0xd4bb,    BAD,    BAD, 0xd4b8,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8fb7e5,    BAD,    BAD,    BAD,    BAD, 0x8fb7e6,    BAD,    BAD
},

/* Row 0x834 */
{
/* 00 */ 0xd4b1,    BAD,    BAD, 0xd4bc,    BAD,    BAD, 0xd4bd, 0x8fb7e7,
/* 08 */ 0x8fb7e8,    BAD,    BAD, 0xcbe4, 0x8fb7e9,    BAD, 0xbeeb, 0x8fb7ea,
/* 10 */    BAD,    BAD, 0xd4bf, 0xd4c0, 0xd4be, 0x8fb7eb, 0xd4c2,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xc7b8, 0x8fb7ec, 0x8fb7ed, 0xb0e8,
/* 20 */ 0xc9d6, 0x8fb7fe,    BAD, 0xd4c3, 0x8fb7ee,    BAD, 0x8fb7ef, 0x8fb7f0,
/* 28 */    BAD, 0x8fb7f1,    BAD,    BAD,    BAD, 0x8fb7f2,    BAD,    BAD,
/* 30 */ 0x8fb7f3,    BAD,    BAD,    BAD, 0xbefd, 0x8fb7f4, 0x8fb7f5, 0xbcb9,
/* 38 */ 0x8fb7f6, 0xc7dd, 0xb4f0,    BAD, 0xbaeb, 0x8fb7f7, 0x8fb7f8, 0x8fb7f9
},

/* Row 0x835 */
{
/* 00 */ 0xcbd9,    BAD, 0xc6b2, 0x8fb7fa, 0x8fb7fb, 0xb7f8, 0xc2cf,    BAD,
/* 08 */ 0x8fb7fc, 0x8fb7fd, 0xd4c1, 0xd4c4, 0x8fb8a1, 0x8fb8a2,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc2c4,    BAD,    BAD,
/* 18 */    BAD, 0xd4c5,    BAD, 0x8fb8a3,    BAD, 0xd4c6, 0x8fb8a4, 0x8fb8a5,
/* 20 */ 0x8fb8a6, 0xd4c8,    BAD,    BAD, 0xc4e9,    BAD, 0x8fb8a7, 0x8fb8a8,
/* 28 */    BAD,    BAD, 0xb4ae,    BAD,    BAD, 0x8fb8a9,    BAD, 0xf4a1,
/* 30 */ 0xb1e1, 0xcaf3, 0x8fb8aa,    BAD, 0xbeec, 0xc5c8,    BAD,    BAD,
/* 38 */    BAD, 0x8fb8ab, 0xbae6,    BAD,    BAD, 0xd4ce,    BAD, 0x8fb8ac
},

/* Row 0x836 */
{
/* 00 */ 0xcabd, 0xcedd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8fb8ad, 0xb2f4, 0xd4ca, 0x8fb8ae, 0x8fb8af,    BAD, 0x8fb8b0,
/* 10 */ 0x8fb8b1, 0xc1ba, 0xd4cd,    BAD, 0xc5e3, 0x8fb8b2,    BAD, 0xc5c9,
/* 18 */ 0xc5e4, 0xc8b9, 0xc4cd,    BAD,    BAD,    BAD, 0xbac9, 0x8fb8b3,
/* 20 */    BAD, 0x8fb8b4, 0xd4c9,    BAD, 0x8fb8b5,    BAD,    BAD, 0x8fb8b6,
/* 28 */ 0x8fb8b7, 0xb1f6,    BAD, 0xc5b6,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd4cb,    BAD, 0xd4c7,    BAD,    BAD, 0xbfd0,    BAD,    BAD,
/* 38 */ 0x8fb8b8, 0xd4cf,    BAD,    BAD, 0x8fb8b9,    BAD, 0xbdce, 0x8fb8ba
},

/* Row 0x837 */
{
/* 00 */ 0x8fb8bb, 0x8fb8bc,    BAD, 0xb6ad,    BAD, 0xd4d0,    BAD, 0x8fb8bd,
/* 08 */ 0x8fb8be, 0x8fb8bf, 0x8fb8c0,    BAD, 0x8fb8c1, 0x8fb8c2,    BAD, 0x8fb8c3,
/* 10 */ 0x8fb8c4,    BAD,    BAD, 0xcae8, 0x8fb8c5,    BAD, 0x8fb8c6, 0xc1fd,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xc4c6, 0x8fb8c7,    BAD, 0xd4d2,
/* 20 */ 0x8fb8c8, 0x8fb8c9, 0x8fb8ca,    BAD,    BAD,    BAD, 0x8fb8cb,    BAD,
/* 28 */ 0xcbcf, 0x8fb8cc,    BAD, 0xd4d3,    BAD,    BAD, 0xd4d8,    BAD,
/* 30 */    BAD, 0x8fb8cd, 0x8fb8ce, 0xcaaf,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xd4d7, 0xd4d1, 0xd4d4, 0xd4d6, 0x8fb8d0,    BAD, 0xbaa6,    BAD
},

/* Row 0x838 */
{
/* 00 */    BAD, 0xcac9, 0x8fb8d1,    BAD, 0x8fb8cf, 0xd4d9,    BAD, 0xc3c5,
/* 08 */ 0x8fb8d2,    BAD, 0xb2f5,    BAD, 0xbeed, 0x8fb8d3, 0x8fb8d4,    BAD,
/* 10 */ 0x8fb8d5, 0xd4db, 0x8fb8d6, 0xd4da, 0x8fb8d7, 0xb9e8, 0x8fb8d8, 0xd4dc,
/* 18 */ 0xd4de, 0xd4dd, 0x8fb8d9,    BAD, 0xd4e0, 0x8fb8da, 0xd4d5, 0xd4e2,
/* 20 */    BAD, 0x8fb8db, 0x8fb8dc,    BAD, 0xd4e1, 0xd4df,    BAD,    BAD,
/* 28 */    BAD, 0x8fb8dd,    BAD, 0xbbce, 0xbfd1,    BAD, 0xc1d4, 0xd4e3,
/* 30 */ 0xc0bc, 0xb0ed, 0xc7e4, 0x8fb8de,    BAD,    BAD,    BAD, 0xc4db,
/* 38 */    BAD, 0xd4e5, 0xd4e4, 0xd4e6, 0xd4e7, 0xd4e8,    BAD,    BAD
},

/* Row 0x839 */
{
/* 00 */    BAD,    BAD, 0xd4e9,    BAD,    BAD, 0x8fb8df, 0x8fb8e0,    BAD,
/* 08 */    BAD, 0xcad1, 0xd4ea, 0x8fb8e1, 0x8fb8e2,    BAD,    BAD, 0xb2c6,
/* 10 */ 0xd4eb,    BAD, 0x8fb8e3, 0x8fb8e4, 0x8fb8e5, 0xcdbc, 0xb3b0,    BAD,
/* 18 */ 0xd2c9, 0xbdc8, 0xc2bf, 0xd4ec, 0xcceb, 0x8fb8e7,    BAD,    BAD,
/* 20 */    BAD, 0x8fb8e8, 0xccb4, 0x8fb8e9, 0x8fb8ea, 0xd4ee,    BAD, 0xc2e7,
/* 28 */ 0x8fb8eb, 0xc5b7, 0xc2c0, 0xc9d7, 0xd4ef, 0xd4f0, 0xb1fb, 0x8fb8ec,
/* 30 */ 0x8fb8ed, 0xbcba, 0xd4f1, 0x8fb8ee,    BAD, 0x8fb8ef, 0x8fb8f0, 0xb0d0,
/* 38 */ 0xd4f2,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd4f3, 0x8fb8f1
},

/* Row 0x83a */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fb8f2, 0xb1e2,    BAD, 0x8fb8f3, 0xb4f1,
/* 08 */ 0xc6e0, 0xcaf4,    BAD,    BAD,    BAD,    BAD, 0xd4f7, 0xc1d5,
/* 10 */ 0xd4f6, 0xb7c0, 0x8fb8f4, 0x8fb8f5, 0xcbdb, 0xd4f5,    BAD, 0xc5e5,
/* 18 */ 0xd4f9, 0x8fb8f6, 0xd4f8, 0x8fb8f7,    BAD, 0x8fb8f8, 0x8fb8f9, 0x8fb8fa,
/* 20 */ 0xd4fb, 0x8fb8fb, 0xd4fa, 0x8fb8fc,    BAD, 0xb1fc,    BAD, 0xd4fc,
/* 28 */ 0xbea9, 0xd4fe, 0xc3a5, 0x8fb8fd, 0xd4fd, 0x8fb8fe, 0xcab3, 0x8fb9a1,
/* 30 */    BAD,    BAD, 0x8fb9a2, 0xbdf7, 0xc5db, 0x8fb9a3, 0x8fb9a4,    BAD,
/* 38 */ 0xd5a1, 0x8fb9a5,    BAD, 0x8fb9a6, 0x8fb9a7, 0xb9a5,    BAD,    BAD
},

/* Row 0x83b */
{
/* 00 */    BAD, 0xd5a2, 0xc7a1, 0xc8de, 0xccd1,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xc7a5, 0x8fb9a8, 0x8fb9a9, 0xd5ab, 0x8fb9aa,    BAD,
/* 10 */    BAD,    BAD, 0x8fb9ab, 0xb5b8,    BAD, 0x8fb9ac, 0xcdc5, 0x8fb9ad,
/* 18 */    BAD, 0xccaf,    BAD, 0xd6ac,    BAD, 0xd5a3,    BAD, 0x8fb9ae,
/* 20 */    BAD,    BAD,    BAD, 0xd5a6, 0x8fb9af, 0xc2c5,    BAD, 0x8fb9b0,
/* 28 */ 0xcbb8,    BAD,    BAD,    BAD, 0xc5ca, 0x8fb9b1, 0x8fb9b2, 0x8fb9b3,
/* 30 */ 0x8fb9b4,    BAD, 0xd5a7, 0x8fb9b5,    BAD,    BAD,    BAD, 0x8fb9b6,
/* 38 */    BAD, 0xcbe5, 0x8fb9b7, 0xbaca, 0x8fb9b8,    BAD, 0xbeaa,    BAD
},

/* Row 0x83c */
{
/* 00 */    BAD, 0x8fb9b9,    BAD, 0x8fb9ba, 0x8fb9bb,    BAD, 0xd5a8,    BAD,
/* 08 */ 0x8fb9bc, 0xbbd0, 0x8fb9bd, 0xbbcf,    BAD, 0x8fb9be,    BAD,    BAD,
/* 10 */ 0xb0b9, 0xb8c8, 0x8fb9bf, 0xc0ab, 0xb0d1,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xd5ac, 0xd5ad,    BAD, 0xd5aa, 0x8fb9c0, 0x8fb9c1, 0x8fb9c2,
/* 20 */    BAD,    BAD,    BAD, 0x8fb9c3, 0x8fb9c4, 0xb1b8, 0xb4af, 0x8fb9c5,
/* 28 */ 0xd5a9,    BAD, 0xccc5, 0xc9b1,    BAD,    BAD, 0x8fb9c6, 0x8fb9c7,
/* 30 */    BAD, 0x8fb9c8, 0x8fb9c9,    BAD, 0x8fb9ca,    BAD, 0xb0a8, 0x8fb9cb,
/* 38 */    BAD,    BAD,    BAD, 0xb0f9,    BAD,    BAD,    BAD, 0xbbd1
},

/* Row 0x83d */
{
/* 00 */ 0x8fb9cc, 0xb0d2,    BAD, 0xb0a3, 0x8fb9cd,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xd5b2,    BAD,    BAD, 0x8fb9ce, 0x8fb9cf, 0x8fb9d0,    BAD,
/* 10 */    BAD, 0xd5b0, 0x8fb9d1, 0x8fb9d2,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xccbc,    BAD, 0xd5b3,    BAD, 0xd5b1,    BAD, 0x8fb9d3, 0xd5af,
/* 20 */ 0xbfb1,    BAD,    BAD, 0x8fb9d4, 0x8fb9d5, 0xd5ae,    BAD, 0x8fb9d6,
/* 28 */ 0x8fb9d7, 0xcada, 0x8fb9d8,    BAD,    BAD, 0x8fb9d9,    BAD, 0xb8e4,
/* 30 */ 0x8fb9da,    BAD,    BAD,    BAD,    BAD, 0xd5b7, 0xd5b8,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xbeab,    BAD,    BAD,    BAD
},

/* Row 0x83e */
{
/* 00 */ 0xd5b4, 0xcfac,    BAD,    BAD, 0x8fb9db, 0x8fb9dc, 0xc7cc, 0x8fb9dd,
/* 08 */ 0x8fb9de, 0xd5b6,    BAD,    BAD, 0x8fb9df,    BAD,    BAD,    BAD,
/* 10 */ 0x8fb9e0,    BAD,    BAD,    BAD,    BAD, 0x8fb9e1,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xbaa7,    BAD,    BAD,    BAD, 0x8fb9e2,    BAD,
/* 20 */    BAD,    BAD, 0xd5b9, 0x8fb9e3,    BAD, 0x8fb9e4, 0xc9d8, 0x8fb9e5,
/* 28 */    BAD,    BAD, 0xd5ba,    BAD, 0xd5b5, 0x8fb9e6,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fb9e7,
/* 38 */    BAD,    BAD, 0x8fb9e8, 0x8fb9e9,    BAD,    BAD, 0x8fb9ea, 0xccbb
},

/* Row 0x83f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8fb9eb,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8fb9ec,    BAD, 0xc7de, 0x8fb9ed,    BAD,    BAD, 0x8fb9ee,    BAD,
/* 18 */    BAD, 0x8fb9ef, 0xd5bb, 0xc9b2, 0x8fb9f0,    BAD, 0x8fb9f1, 0x8fb9f2,
/* 20 */ 0x8fb9f3,    BAD, 0x8fb9f4,    BAD,    BAD,    BAD,    BAD, 0x8fb9f5,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8fb9f6,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8fb9f7, 0x8fb9f8, 0x8fb9f9,    BAD, 0x8fb9fa,    BAD,    BAD,
/* 38 */ 0x8fb9fb,    BAD, 0x8fb9fc, 0x8fb9fd, 0xd5bc, 0xd5c0, 0xd5bd, 0x8fb9fe
},

/* Row 0x840 */
{
/* 00 */    BAD, 0xb2c7, 0xd5bf,    BAD, 0x8fbaa1,    BAD, 0x8fbaa2,    BAD,
/* 08 */ 0x8fbaa3, 0xbcbb,    BAD, 0xd5be, 0xb7f9,    BAD,    BAD, 0x8fbaa4,
/* 10 */ 0xd5cc,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd5c5, 0xd5c2,
/* 18 */    BAD,    BAD, 0x8fbaa5,    BAD, 0x8fbaa6,    BAD,    BAD,    BAD,
/* 20 */ 0x8fbaa7, 0xc3e4,    BAD, 0xd5c1,    BAD, 0x8fbaa8, 0xd5c3,    BAD,
/* 28 */    BAD, 0xd5c4, 0x8fbaa9,    BAD,    BAD,    BAD, 0x8fbaaa,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbaab, 0x8fbaac,    BAD,
/* 38 */    BAD,    BAD, 0xd5c6, 0xd5c7,    BAD, 0x8fbaad,    BAD,    BAD
},

/* Row 0x841 */
{
/* 00 */ 0x8fbaae, 0x8fbaaf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8fbab0, 0xb4f2,    BAD, 0xd5c9, 0xd5c8,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd5ca, 0x8fbab1,
/* 18 */    BAD, 0x8fbab3,    BAD, 0x8fbab4,    BAD, 0x8fbab5,    BAD,    BAD,
/* 20 */    BAD, 0x8fbab6, 0xbeee,    BAD,    BAD, 0x8fbab7,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xd5cd,    BAD, 0xc4dc, 0x8fbab8,    BAD,    BAD,
/* 30 */ 0xb1c5,    BAD, 0xd5cb,    BAD, 0x8fbab2,    BAD, 0xd5ce,    BAD,
/* 38 */ 0x8fbab9,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd5cf,    BAD
},

/* Row 0x842 */
{
/* 00 */ 0xd5d2, 0x8fbaba,    BAD, 0xd5d0,    BAD, 0xd5d1,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8fbabb, 0x8fbabc,    BAD,    BAD,    BAD,
/* 10 */ 0xbbd2, 0xd5d3, 0x8fbabd,    BAD, 0xb9a6, 0xd5d4, 0x8fbabe, 0xbbfa,
/* 18 */ 0xc2b8,    BAD, 0xd5d5, 0xd5d6, 0xbbda, 0xb9a7, 0x8fbabf, 0xccd2,
/* 20 */    BAD,    BAD,    BAD, 0xb5a8, 0xb8c9, 0xd5d7, 0xb3d8,    BAD,
/* 28 */ 0x8fbac0, 0xd5d8,    BAD, 0xc2b9,    BAD,    BAD, 0x8fbac1, 0x8fbac2,
/* 30 */ 0xd5d9, 0xd6a3,    BAD, 0xd5da,    BAD, 0xd5db,    BAD,    BAD,
/* 38 */ 0xd5dc,    BAD, 0xd5de,    BAD, 0x8fbac3, 0x8fbac4, 0x8fbac5, 0x8fbac6
},

/* Row 0x843 */
{
/* 00 */ 0xd5df, 0x8fbac7,    BAD, 0xd5e0, 0x8fbac8, 0xc2f0, 0x8fbac9, 0xb1a7,
/* 08 */ 0xbce9, 0xb0c2, 0x8fbaca, 0xc1d7, 0xb4b0, 0xbcb5, 0x8fbacb, 0xb9a8,
/* 10 */ 0x8fbacc, 0x8fbacd,    BAD, 0x8fbace, 0x8fbacf, 0xc5e6, 0x8fbad0, 0xbda1,
/* 18 */ 0xb4b1, 0xc3e8, 0xc4ea, 0xb0b8, 0xb5b9, 0xcaf5,    BAD, 0xbcc2,
/* 20 */    BAD,    BAD, 0xb5d2, 0xc0eb, 0xbcbc, 0xcda8, 0xd5e1,    BAD,
/* 28 */ 0x8fbad1, 0x8fbad2,    BAD,    BAD, 0x8fbad3, 0x8fbad4, 0xb5dc, 0x8fbad5,
/* 30 */ 0xbacb, 0x8fbad6, 0x8fbad7, 0xb3b2, 0xb1e3, 0xbeac, 0xb2c8, 0x8fbad8,
/* 38 */ 0xd5e2, 0xcdc6, 0x8fbad9,    BAD, 0x8fbada,    BAD,    BAD, 0xbdc9
},

/* Row 0x844 */
{
/* 00 */ 0x8fbadb, 0x8fbadc, 0xbce4, 0xd5e3, 0xb4f3, 0xc6d2, 0xcca9, 0xd5e4,
/* 08 */    BAD, 0xd5e5,    BAD,    BAD, 0xc9d9, 0x8fbadd,    BAD, 0x8fbade,
/* 10 */ 0xd5e7,    BAD, 0xb4a8, 0xb6f7, 0xd5e6,    BAD, 0x8fbadf, 0x8fbae0,
/* 18 */ 0x8fbae1, 0x8fbae2, 0x8fbae3, 0xb4b2,    BAD, 0xbfb2, 0xd5eb, 0xbba1,
/* 20 */ 0x8fbae4, 0xb2c9, 0xd5ea,    BAD, 0xd5e8, 0xd5ec, 0xd5e9, 0xc7ab,
/* 28 */ 0xdccd, 0xbfb3,    BAD, 0xd5ed,    BAD,    BAD, 0xcec0, 0x8fbae5,
/* 30 */ 0xd5ee, 0x8fbae6,    BAD, 0xd5f0, 0x8fbae7, 0xc3fe, 0xd5ef,    BAD,
/* 38 */ 0xc0a3,    BAD, 0xbbfb,    BAD,    BAD, 0x8fbae8, 0xc2d0, 0xbcf7
},

/* Row 0x845 */
{
/* 00 */    BAD, 0xc9f5, 0xc0ec,    BAD, 0xbccd, 0xd5f1, 0xbead, 0xd5f2,
/* 08 */ 0xd5f3, 0xb0d3, 0xc2ba, 0xbfd2, 0x8fbae9, 0xd5f4, 0xc6b3, 0xbeae,
/* 10 */    BAD, 0xbeaf,    BAD, 0xd5f5,    BAD,    BAD, 0xc0ed, 0x8fbaea,
/* 18 */    BAD,    BAD, 0xbeb0,    BAD,    BAD,    BAD, 0x8fbaeb, 0x8fbaec,
/* 20 */ 0xd5f6,    BAD, 0xd5f7, 0x8fbaed, 0xcce0,    BAD, 0x8fbaee,    BAD,
/* 28 */ 0xd5f8, 0x8fbaef,    BAD, 0x8fbaf0, 0x8fbaf1, 0xb6c6, 0x8fbaf2,    BAD,
/* 30 */ 0x8fbaf3, 0xbda2, 0x8fbaf4,    BAD,    BAD, 0x8fbaf5, 0x8fbaf6,    BAD,
/* 38 */ 0xd5f9, 0xd5fa, 0xbcdc, 0xbfac, 0xc6f4, 0xbfd4, 0xc8f8, 0xc7a2
},

/* Row 0x846 */
{
/* 00 */ 0xb6c9, 0xd5fb,    BAD,    BAD,    BAD, 0xb5ef, 0xd5fc,    BAD,
/* 08 */ 0xb6fe,    BAD, 0xc6cf, 0xb2b0,    BAD, 0xbbd3, 0xd5fd, 0xd6a2,
/* 10 */ 0xd6a1, 0xb6fd,    BAD, 0xd5fe,    BAD, 0xc5b8,    BAD,    BAD,
/* 18 */    BAD, 0x8fbaf7, 0x8fbaf8,    BAD, 0x8fbaf9,    BAD, 0xc2b0,    BAD,
/* 20 */ 0xc5cb, 0xbcc8, 0x8fbafa, 0x8fbafb, 0xc1d8, 0xcdfa,    BAD, 0x8fbafc,
/* 28 */ 0x8fbafd, 0x8fbafe,    BAD,    BAD, 0xd6a4, 0x8fbba1, 0xd6a5, 0xc6d6,
/* 30 */ 0x8fbba2, 0xbbb3,    BAD,    BAD, 0x8fbba3, 0x8fbba4, 0xd6a7,    BAD,
/* 38 */    BAD, 0xd6a8, 0x8fbba5, 0x8fbba6, 0x8fbba7, 0x8fbba8,    BAD,    BAD
},

/* Row 0x847 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbba9,
/* 08 */ 0x8fbbaa,    BAD, 0x8fbbab,    BAD, 0xd6a9,    BAD,    BAD, 0x8fbbac,
/* 10 */ 0xb4f4, 0xd6aa, 0x8fbbad,    BAD, 0xd6ab,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbbae,    BAD, 0x8fbbaf,
/* 20 */ 0x8fbbb0, 0xb2ac, 0x8fbbb1, 0x8fbbb2,    BAD,    BAD, 0x8fbbb3,    BAD,
/* 28 */ 0xc1bb, 0xb4e4, 0x8fbbb4, 0xd6ad, 0xcca8,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xc2d2, 0x8fbbb5, 0xb3d9, 0x8fbbb6, 0x8fbbb7, 0xd6af, 0xd6b1,
/* 38 */ 0xb4df,    BAD, 0x8fbbb8, 0xd6ae, 0xd6b0,    BAD, 0xd6b3,    BAD
},

/* Row 0x848 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd6b2,    BAD, 0xd6b4,
/* 08 */    BAD, 0x8fbbb9,    BAD, 0x8fbbba,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8fbbbb,    BAD,    BAD,    BAD,    BAD, 0x8fbbbd,
/* 18 */    BAD, 0xd6b5,    BAD,    BAD,    BAD, 0x8fbbbc,    BAD,    BAD,
/* 20 */ 0xc6bd, 0xb6ae,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb2e5, 0xd6b6, 0xd6bb,    BAD,    BAD, 0xd6b9, 0x8fbbbe, 0xcaf7,
/* 30 */ 0xcaf6, 0x8fbbbf, 0x8fbbc0,    BAD, 0x8fbbc1,    BAD, 0xc5e7,    BAD,
/* 38 */    BAD,    BAD, 0xd6b8, 0xbdd4,    BAD, 0xd6b7,    BAD,    BAD
},

/* Row 0x849 */
{
/* 00 */    BAD, 0x8fbbc2,    BAD,    BAD,    BAD,    BAD, 0x8fbbc3, 0xbff2,
/* 08 */    BAD,    BAD,    BAD, 0xd6bc,    BAD, 0x8fbbc4, 0xbaea,    BAD,
/* 10 */    BAD, 0xd6c2, 0x8fbbc5,    BAD, 0xd6c3, 0xd6bd, 0xb3b3, 0xd6be,
/* 18 */ 0xd6c7, 0xd6c6, 0xd6c5, 0xd6c1,    BAD,    BAD,    BAD, 0xd6c0,
/* 20 */    BAD,    BAD, 0xd6c4, 0x8fbbc7, 0x8fbbc8,    BAD, 0x8fbbc9, 0x8fbbca,
/* 28 */    BAD, 0xcaf8,    BAD, 0x8fbbc6,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8fbbcb,    BAD,    BAD, 0x8fbbcc,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8fbbcd,    BAD,    BAD,    BAD, 0x8fbbce,    BAD, 0x8fbbcf
},

/* Row 0x84a */
{
/* 00 */    BAD,    BAD, 0x8fbbd0, 0x8fbbd1,    BAD,    BAD, 0x8fbbd2,    BAD,
/* 08 */ 0x8fbbd3,    BAD, 0x8fbbd7, 0xd6cb, 0xd6c8,    BAD, 0xd6ca,    BAD,
/* 10 */ 0xcdf2, 0x8fbbd5, 0xd6c9,    BAD,    BAD, 0x8fbbd4,    BAD,    BAD,
/* 18 */    BAD, 0x8fbbd6,    BAD,    BAD, 0xd6bf,    BAD,    BAD, 0x8fbbd8,
/* 20 */ 0x8fbbd9, 0x8fbbda, 0x8fbbdb,    BAD, 0x8fbbdc,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xbff3, 0x8fbbdd,    BAD, 0xd6cc, 0x8fbbde,    BAD, 0xbab7,
/* 30 */ 0x8fbbdf,    BAD,    BAD, 0xd6cd,    BAD,    BAD, 0xd6ce,    BAD,
/* 38 */    BAD, 0x8fbbe0, 0x8fbbe1,    BAD,    BAD,    BAD, 0x8fbbe2, 0x8fbbe3
},

/* Row 0x84b */
{
/* 00 */    BAD, 0x8fbbe4, 0xd6d1, 0x8fbbe5, 0xd6d0,    BAD,    BAD, 0xd6cf,
/* 08 */ 0x8fbbe6,    BAD, 0x8fbbe7, 0xc5e8, 0xd6ba,    BAD,    BAD,    BAD,
/* 10 */ 0xd6d7,    BAD, 0x8fbbe8, 0x8fbbe9, 0x8fbbea, 0x8fbbeb,    BAD,    BAD,
/* 18 */    BAD, 0x8fbbec,    BAD, 0x8fbbed,    BAD, 0xd6d3,    BAD, 0x8fbbee,
/* 20 */ 0x8fbbef,    BAD, 0xd6d2,    BAD,    BAD,    BAD,    BAD, 0x8fbbf0,
/* 28 */    BAD,    BAD,    BAD, 0x8fbbf1, 0xd6d4,    BAD, 0xd6d5,    BAD,
/* 30 */ 0x8fbbf2,    BAD, 0x8fe6f4,    BAD, 0x8fbbf3,    BAD,    BAD, 0xd6d8,
/* 38 */ 0x8fbbf4, 0x8fbbf5, 0xcee6,    BAD, 0xd6d9, 0xd6d6,    BAD,    BAD
},

/* Row 0x84c */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fbbf6,    BAD,    BAD,    BAD, 0x8fbbf7,
/* 08 */    BAD, 0xd6da,    BAD, 0x8fbbf8, 0xb4e0, 0xd6db, 0x8fbbfa,    BAD,
/* 10 */ 0x8fbbf9,    BAD, 0xd6dd, 0xd6dc,    BAD,    BAD, 0xd6de,    BAD,
/* 18 */ 0x8fbbfb, 0x8fbbfc,    BAD, 0xd6df,    BAD, 0xc0ee, 0xbda3,    BAD,
/* 20 */ 0x8fbbfd, 0xbde4,    BAD, 0xc1e3, 0x8fbbfe, 0xb9a9, 0xbab8, 0xb9aa,
/* 28 */ 0xb5f0, 0x8fbca1,    BAD, 0xd6e0,    BAD,    BAD, 0xbab9,    BAD,
/* 30 */    BAD, 0xb8ca, 0xd6e1, 0xcca6, 0xc7c3, 0xd6e2,    BAD, 0xb9ab,
/* 38 */ 0x8fbca2, 0x8fbca3,    BAD, 0xb4ac,    BAD, 0xc3a7, 0xb6d2,    BAD
},

/* Row 0x84d */
{
/* 00 */ 0x8fbca4,    BAD, 0xbbd4, 0xc9db,    BAD,    BAD, 0xc8c1, 0x8fbca5,
/* 08 */    BAD,    BAD,    BAD, 0xd6e3, 0xb4f5, 0x8fbca6,    BAD,    BAD,
/* 10 */    BAD, 0xd6e6, 0x8fbca7,    BAD, 0x8fbca8, 0x8fbca9, 0xc4a1,    BAD,
/* 18 */ 0x8fbcaa, 0xd6e5, 0xd6e4, 0xd6e7,    BAD, 0xc4eb,    BAD, 0x8fbcab,
/* 20 */ 0x8fbcac,    BAD,    BAD,    BAD,    BAD, 0xbfe3,    BAD,    BAD,
/* 28 */ 0x8fbcae,    BAD,    BAD, 0xbbd5,    BAD, 0xc0ca, 0x8fbcad, 0xc2d3,
/* 30 */ 0xb5a2,    BAD, 0x8fbcaf, 0xc4a2,    BAD, 0x8fbcb0, 0xd6e8, 0xd6e9,
/* 38 */ 0xbeef,    BAD,    BAD,    BAD,    BAD, 0xcbb9, 0x8fbcb1,    BAD
},

/* Row 0x84e */
{
/* 00 */ 0xd6ec,    BAD,    BAD, 0xd6eb, 0xd6ea, 0xc9fd,    BAD, 0xd6f3,
/* 08 */    BAD, 0x8fbcb4,    BAD, 0x8fbcb2, 0xcbda,    BAD, 0xd6ed,    BAD,
/* 10 */ 0x8fbcb3, 0x8fbcb5,    BAD,    BAD, 0xd6ef, 0xcbeb, 0x8fbcb6, 0xd6ee,
/* 18 */ 0x8fbcb7,    BAD,    BAD, 0x8fbcb8, 0x8fbcb9,    BAD, 0x8fbcba, 0xd6f0,
/* 20 */    BAD, 0xc8a8, 0xd6f1, 0xcabe, 0xd6f2,    BAD,    BAD,    BAD,
/* 28 */ 0x8fbcbb,    BAD, 0x8fbcbc, 0x8fbcbd, 0x8fbcbe, 0x8fbcbf, 0x8fbcc0,    BAD,
/* 30 */ 0x8fbcc1,    BAD, 0xb4b3, 0xcabf, 0xc7af, 0xd6f4, 0xd6f5,    BAD,
/* 38 */ 0xb9ac, 0xb4b4, 0xd6f6, 0xb8b8, 0xcdc4, 0xcda9, 0xb4f6, 0xd6f8
},

/* Row 0x84f */
{
/* 00 */ 0x8fbcc2, 0xc4a3,    BAD, 0xb9ad, 0xbeb1,    BAD,    BAD, 0xc8df,
/* 08 */    BAD,    BAD, 0xbeb2, 0x8fbcc3,    BAD,    BAD, 0x8fbcc4, 0xbdf8,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4ec, 0xcaf9, 0xc5b9,
/* 18 */    BAD,    BAD, 0xb9ae,    BAD, 0xc9dc,    BAD,    BAD,    BAD,
/* 20 */ 0xd6f9,    BAD, 0x8fbcc5,    BAD, 0x8fbcc6, 0x8fbcc7, 0xc5d9, 0xbac2,
/* 28 */ 0x8fbcc8,    BAD, 0x8fbcc9, 0xb8cb, 0x8fbcca, 0xc4ed,    BAD,    BAD,
/* 30 */    BAD, 0x8fbccb,    BAD, 0x8fbccc,    BAD, 0xb0c3, 0xbdee, 0xb9af,
/* 38 */ 0xcdc7,    BAD,    BAD,    BAD,    BAD, 0x8fbccd, 0x8fbcce, 0x8fbccf
},

/* Row 0x850 */
{
/* 00 */    BAD, 0xd6fa, 0xd6fb, 0xc7d1,    BAD,    BAD, 0x8fbcd0,    BAD,
/* 08 */ 0xd6fc, 0xcef7, 0xcfad, 0x8fbcd2, 0x8fbcd1,    BAD, 0x8fbcd3, 0xd6fe,
/* 10 */ 0xd6fd, 0x8fbcd4, 0x8fbcd5, 0xb3c7, 0x8fbcd6, 0x8fbcd7, 0xd7a1,    BAD,
/* 18 */    BAD,    BAD, 0xd7a4, 0xd7a5, 0x8fbcd8, 0xd7a3, 0x8fbcd9, 0xc9c0,
/* 20 */ 0xbeb3, 0xd7a7, 0xd7a6, 0xd7a2,    BAD, 0x8fbcda,    BAD,    BAD,
/* 28 */ 0xd7a8, 0xd7a9,    BAD, 0x8fbcdb, 0xd7aa,    BAD,    BAD,    BAD,
/* 30 */ 0xd7ad, 0xd7ab,    BAD, 0xd7ac, 0xd7ae,    BAD, 0xb1e4, 0xc4ee,
/* 38 */ 0xd7af,    BAD, 0xb7fa, 0xb2f6, 0xc7b6,    BAD, 0xd7b0, 0xc6fb
},

/* Row 0x851 */
{
/* 00 */    BAD, 0xcadb, 0x8fbcdc, 0xd7b1, 0xcfae,    BAD, 0x8fbcdd, 0x8fbcde,
/* 08 */ 0x8fbcdf, 0xd7b2, 0xcac0, 0xd7b5, 0xd0a1, 0xd0b1, 0x8fbce0, 0xbcb0,
/* 10 */ 0xc6f5, 0xd7b6,    BAD, 0xb5dd, 0xc4a4, 0xb0fa, 0xd7b7, 0xcaa6,
/* 18 */ 0xb9b0, 0x8fbce1,    BAD, 0xc3d0, 0x8fbce2, 0x8fbce3,    BAD, 0xc4ef,
/* 20 */    BAD, 0x8fbce4, 0x8fbce5, 0x8fbce6, 0x8fbce7, 0xccef, 0xb8b9, 0xb8cc,
/* 28 */ 0x8fbce8, 0xd7b8,    BAD, 0x8fbce9, 0x8fbcea, 0xd7b9, 0x8fbceb, 0xd7bf,
/* 30 */ 0x8fbcec, 0xbce5,    BAD,    BAD, 0x8fbced, 0xc4a5, 0x8fbcee, 0xb6af,
/* 38 */ 0xd7ba,    BAD,    BAD, 0x8fbcef, 0xc9ab, 0x8fbcf0, 0xc3c6, 0x8fbcf1
},

/* Row 0x852 */
{
/* 00 */ 0x8fbcf2, 0xd7bb,    BAD,    BAD, 0x8fbcf3, 0x8fbcf4,    BAD, 0x8fbcf5,
/* 08 */ 0xd7bc,    BAD, 0xb6b0,    BAD, 0xd7bd, 0x8fbcf6, 0xd7be,    BAD,
/* 10 */ 0x8fbcf7, 0xd7c0,    BAD, 0xc5f6, 0x8fbcf8,    BAD, 0xd7c1, 0xd7c2,
/* 18 */ 0x8fbcf9, 0xd7c3,    BAD, 0x8fbcfa, 0xd7b4, 0xd7b3,    BAD,    BAD,
/* 20 */ 0x8fbcfb, 0xd7c4, 0xb7c1, 0x8fbcfc, 0x8fbcfd,    BAD, 0xc9a7, 0x8fbcfe,
/* 28 */    BAD, 0xbacc, 0xc9b7, 0xc4a6, 0xc9cb, 0xd7c5,    BAD, 0x8fbda1,
/* 30 */ 0xbeb4, 0xb1c6, 0x8fbda2, 0xd7c6, 0x8fbda3, 0x8fbda4,    BAD, 0xd7c7,
/* 38 */ 0x8fbda5, 0xccf2, 0x8fbda6,    BAD, 0xc8e0, 0x8fbda7, 0x8fbda8, 0xd7ca
},

/* Row 0x853 */
{
/* 00 */ 0xb1fd, 0xc0ac, 0xd7c9, 0xd7c8, 0xb7c2, 0xc2d4,    BAD, 0xd7ce,
/* 08 */ 0xd7cc, 0x8fbda9, 0xd7cb, 0xcea7, 0xb8e5, 0x8fbdaa,    BAD, 0x8fbdab,
/* 10 */ 0xbdf9, 0xd7cd, 0xc5cc, 0xbdbe,    BAD,    BAD, 0x8fbdac, 0xc6c0,
/* 18 */ 0xd7d1, 0xd7d0,    BAD,    BAD, 0x8fbdad, 0x8fbdae, 0xd7cf,    BAD,
/* 20 */ 0xd7d2, 0xb8e6, 0x8fbdaf,    BAD, 0x8fbdb2,    BAD,    BAD, 0x8fbdb0,
/* 28 */ 0xd7d3, 0xc9fc, 0xbddb, 0x8fbdb1, 0x8fbdb3, 0xd7d4, 0xc8f9, 0x8fbdb4,
/* 30 */ 0x8fbdb5, 0x8fbdb6,    BAD, 0xc6c1, 0xc4a7,    BAD,    BAD,    BAD,
/* 38 */ 0x8fbdb7, 0xc5b0,    BAD,    BAD, 0xd7d5, 0xb5ab,    BAD,    BAD
},

/* Row 0x854 */
{
/* 00 */    BAD,    BAD,    BAD, 0xbfb4, 0x8fbdb8, 0xc9ac,    BAD, 0x8fbdb9,
/* 08 */ 0x8fbdba, 0x8fbdbb,    BAD, 0x8fbdbc, 0xb4f7, 0xc7a6,    BAD,    BAD,
/* 10 */ 0x8fbdbd, 0x8fbdbe, 0x8fbdbf, 0x8fbdc0, 0x8fbdc1,    BAD, 0xd7d6, 0xbbd6,
/* 18 */ 0xcbba, 0xcbbb,    BAD,    BAD, 0xb1fe, 0xd7db, 0x8fbdc2,    BAD,
/* 20 */ 0xc3e9, 0x8fbdc3, 0x8fbdc4,    BAD, 0xd7d8,    BAD,    BAD,    BAD,
/* 28 */ 0x8fbdc5, 0x8fbdc6, 0x8fbdc7, 0xb2f7, 0x8fbdc8, 0x8fbdc9, 0x8fbdca, 0x8fbdcb,
/* 30 */ 0xd8ad, 0xd7da, 0x8fbdcc, 0x8fbdcd,    BAD, 0xc7b0, 0x8fbdce,    BAD,
/* 38 */ 0xd7d9,    BAD, 0x8fbdcf, 0xd7d7, 0x8fbdd0, 0xb9fa,    BAD, 0xd7dd
},

/* Row 0x855 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbdd1,
/* 08 */    BAD,    BAD, 0x8fbdd2,    BAD,    BAD, 0x8fbdd3, 0xd7e3, 0xd7e9,
/* 10 */ 0xd7e1,    BAD, 0xc5dc, 0x8fbdd4, 0x8fbdd5, 0xd7e6, 0xc9dd, 0x8fbdd6,
/* 18 */ 0x8fbdd7, 0xd7e0, 0x8fbdd8, 0xd7e5, 0xcee7, 0xbbd7,    BAD, 0x8fbdd9,
/* 20 */ 0xc2d5, 0xd7de,    BAD,    BAD, 0x8fbdda, 0xb5de, 0xd7e8, 0xc0ad,
/* 28 */ 0xb1e5, 0xd7e2, 0xb2f8, 0xd7e7,    BAD, 0x8fbddb,    BAD, 0xb6b1,
/* 30 */    BAD, 0xd7e4,    BAD, 0x8fbddc,    BAD, 0x8fbddd,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xd7ea,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x856 */
{
/* 00 */ 0x8fbdde, 0xd7ec, 0xd7f6, 0xd7f4,    BAD,    BAD, 0xd7f1, 0x8fbddf,
/* 08 */ 0x8fbde0, 0x8fbde1, 0xd7f0, 0xcef8, 0x8fbde2, 0xd7f2,    BAD,    BAD,
/* 10 */ 0xb6b2, 0x8fbde3, 0xb9b1,    BAD, 0x8fbde4, 0xbdfa, 0x8fbde5, 0x8fbde6,
/* 18 */    BAD, 0xd7f9, 0xd7eb,    BAD,    BAD, 0x8fbde7,    BAD, 0xd7ef,
/* 20 */ 0xd7df, 0x8fbde8, 0xb2fa, 0xd7f3, 0xd7f5, 0xc3d1,    BAD, 0x8fbde9,
/* 28 */ 0xbaa8, 0xb2b8, 0xd7ed, 0xd7f8, 0xd7f7, 0xb6b3,    BAD, 0xc2a9,
/* 30 */ 0xb3e6, 0x8fbdea,    BAD,    BAD,    BAD, 0xb7c3,    BAD, 0xd7ee,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbdeb, 0x8fbdec
},

/* Row 0x857 */
{
/* 00 */    BAD, 0xd7fa, 0x8fbded, 0xd7fd, 0xd8a1,    BAD, 0x8fbdee,    BAD,
/* 08 */ 0x8fbdef, 0xbcbd, 0x8fbdf0, 0xd8a7, 0xc4f0, 0xd7fb, 0x8fbdf1,    BAD,
/* 10 */    BAD, 0x8fbdf2, 0xd8a5, 0x8fbdf3, 0xb2f9, 0x8fbdf4, 0xd8a3, 0xd8a4,
/* 18 */ 0x8fbdf5,    BAD, 0xd7fe, 0xd8a2,    BAD, 0x8fbdf6, 0x8fbdf7, 0xb8e7,
/* 20 */ 0xcdaa,    BAD, 0x8fbdf8, 0xb4b5, 0x8fbdf9, 0x8fbdfa, 0xb1d9, 0xd8a6,
/* 28 */ 0x8fbdfb, 0xc7ba, 0xb0ad,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8fbdfc, 0x8fbdfd, 0xc8e1, 0xd7dc, 0xd8ac, 0xd8b0, 0xcce5, 0x8fbdfe,
/* 38 */ 0xd8a9,    BAD,    BAD, 0x8fbea1, 0xc5e9, 0xd8ae, 0x8fbea2,    BAD
},

/* Row 0x858 */
{
/* 00 */    BAD,    BAD, 0x8fbea3,    BAD, 0x8fbea4, 0xbef0, 0xd8af, 0xc6d7,
/* 08 */ 0x8fbea5, 0x8fbea6, 0x8fbea7, 0x8fbea8,    BAD,    BAD, 0x8fbea9, 0x8fbeaa,
/* 10 */    BAD, 0xcfc7,    BAD, 0xd8ab, 0x8fbeab, 0x8fbeac,    BAD,    BAD,
/* 18 */ 0xd8b1, 0x8fbead, 0xb9fb, 0x8fbeae, 0xc0cb, 0x8fbeaf, 0x8fbeb0, 0xb0d4,
/* 20 */ 0xd8aa, 0xd8a8, 0x8fbeb1, 0xc1da,    BAD, 0x8fbeb2,    BAD, 0xd7fc,
/* 28 */ 0xbbb4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xc2c6, 0xd8bd, 0x8fbeb3, 0xc1db, 0xd8b8, 0x8fbeb4, 0xd8b5, 0xd8b6,
/* 38 */ 0x8fbeb5, 0xbce6, 0xd8b9, 0xd8bc, 0x8fbeb6, 0x8fbeb7,    BAD,    BAD
},

/* Row 0x859 */
{
/* 00 */ 0xd8b7, 0xbda5, 0x8fbeb8, 0xd8ba,    BAD,    BAD, 0xd8b4, 0x8fbeb9,
/* 08 */ 0xccfc, 0xccfb, 0x8fbeba,    BAD, 0x8fbebb, 0xd8be, 0xd8bf, 0xb0d5,
/* 10 */ 0x8fbebc, 0x8fbebd, 0x8fbebe, 0x8fbebf, 0x8fbec0, 0xd8b3, 0x8fbec1, 0x8fbec2,
/* 18 */    BAD, 0x8fbec3, 0xb6f2, 0xb0a6, 0x8fbec4,    BAD, 0x8fbec5, 0xb4b6,
/* 20 */    BAD, 0xd8bb, 0x8fbec6,    BAD,    BAD,    BAD,    BAD, 0xd8c3,
/* 28 */ 0xd8c2,    BAD, 0x8fbec7, 0x8fbec8, 0xd8c7,    BAD,    BAD,    BAD,
/* 30 */ 0x8fbec9, 0x8fbeca,    BAD,    BAD, 0xd8c8, 0x8fbecb, 0x8fbecc, 0x8fbecd,
/* 38 */    BAD, 0x8fbece,    BAD,    BAD, 0xd8c6, 0xd8c9, 0xd8c1, 0xd8c5
},

/* Row 0x85a */
{
/* 00 */    BAD, 0x8fbecf, 0xd8ca,    BAD, 0xd8cb, 0x8fbed0, 0x8fbed1, 0xd8c0,
/* 08 */ 0xbbfc, 0x8fbed2, 0xd8c4, 0xc2d6, 0xb9b2, 0xd8b2, 0xbfb5,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xd8d8,    BAD, 0xcae9,    BAD,    BAD,
/* 18 */ 0xd8ce, 0xd8cf, 0xd8d0,    BAD,    BAD, 0xd8d7, 0x8fbed3, 0xd8d6,
/* 20 */ 0x8fbed4,    BAD, 0xcbfd, 0xb4b7,    BAD, 0xd8d4,    BAD, 0xb7c5,
/* 28 */ 0xb3b4,    BAD,    BAD, 0xd8d1, 0x8fbed5,    BAD, 0xceb8, 0xd8d3,
/* 30 */ 0xb0d6, 0xd8d5, 0x8fbed6, 0xd8cc, 0xd8d2, 0xd8d9, 0xb7c4, 0xd8cd,
/* 38 */ 0x8fbed7,    BAD,    BAD, 0x8fbed8, 0x8fbed9,    BAD, 0xcddd, 0x8fbeda
},

/* Row 0x85b */
{
/* 00 */ 0x8fbedb, 0x8fbedc, 0xcdab, 0x8fbedd, 0x8fbede,    BAD,    BAD, 0xd8dc,
/* 08 */    BAD,    BAD, 0xd8e0, 0x8fbedf,    BAD, 0x8fbee0, 0xc1fe,    BAD,
/* 10 */ 0xcef9, 0xd8e1, 0x8fbee1, 0x8fbee2, 0xd8de,    BAD, 0xd8db, 0x8fbee3,
/* 18 */ 0x8fbee4, 0xd8da, 0xd8df,    BAD, 0x8fbee5, 0x8fbee6,    BAD, 0x8fbee7,
/* 20 */ 0x8fbee8,    BAD,    BAD,    BAD, 0xcab0, 0x8fbee9,    BAD, 0xc6b4,
/* 28 */ 0x8fbeea, 0xb7c6, 0x8fbeeb, 0xd8e2, 0xd8dd, 0x8fbeec, 0xd8e3,    BAD,
/* 30 */    BAD,    BAD, 0xb7fb,    BAD,    BAD,    BAD, 0xb2b1,    BAD,
/* 38 */ 0x8fbeed, 0x8fbeee, 0xd8eb,    BAD, 0x8fbeef,    BAD, 0xb4b8,    BAD
},

/* Row 0x85c */
{
/* 00 */ 0x8fbef0, 0x8fbef1, 0x8fbef2, 0xd8e9,    BAD,    BAD, 0xd8ea, 0xbaa9,
/* 08 */ 0xd8e8, 0xd8e6, 0xd8e5, 0xd8ec, 0xd8e4, 0xd8ee, 0x8fbef3, 0x8fbef4,
/* 10 */ 0xb2fb,    BAD,    BAD,    BAD,    BAD, 0x8fbef5,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x8fbef6, 0x8fbef7, 0x8fbef8, 0x8fbef9,
/* 20 */    BAD, 0x8fbefa, 0x8fbefb, 0xd8f0,    BAD, 0x8fbefe, 0xd8ef, 0x8fbefc,
/* 28 */    BAD, 0x8fbefd,    BAD,    BAD, 0x8fbfa1, 0x8fbfa2,    BAD, 0x8fbfa3,
/* 30 */    BAD,    BAD, 0xc4a8,    BAD, 0xd8f3,    BAD, 0xd8f1, 0xd8e7,
/* 38 */ 0xb7fc,    BAD, 0xd8f2,    BAD, 0xd8f6, 0xd8f5, 0xd8f7, 0xd8f4
},

/* Row 0x85d */
{
/* 00 */ 0xd8f8, 0x8fbfa4,    BAD, 0x8fbfa5, 0x8fbfa6,    BAD,    BAD, 0x8fbfa7,
/* 08 */ 0xd8f9, 0xd8fa, 0xcaea,    BAD, 0xd8fc, 0xd8fb, 0xbdbf,    BAD,
/* 10 */ 0xc0ae, 0xb2e6, 0xb2fc, 0x8fbfa8, 0xd8fd, 0x8fbfa9, 0xb0bf,    BAD,
/* 18 */    BAD,    BAD, 0xc0cc, 0xd8fe, 0x8fbfaa, 0xecc3, 0xd9a1, 0xb7e1,
/* 20 */ 0x8fbfab, 0xd9a2, 0x8fbfac, 0x8fbfad,    BAD,    BAD, 0xc0ef, 0x8fbfae,
/* 28 */    BAD, 0x8fbfaf, 0xd9a3, 0x8fbfb0,    BAD,    BAD, 0xd9a4, 0xb5ba,
/* 30 */ 0xd9a5,    BAD, 0xd9a6, 0xd9a7, 0xc2d7,    BAD,    BAD,    BAD,
/* 38 */ 0xb8cd, 0x8fbfb1,    BAD, 0xcce1,    BAD, 0x8fbfb2,    BAD, 0xcbbc
},

/* Row 0x85e */
{
/* 00 */ 0xbdea, 0xd9a8, 0x8fbfb3, 0x8fbfb4, 0x8fbfb5,    BAD, 0x8fbfb6, 0xc0f0,
/* 08 */ 0xeebd, 0xc8e2,    BAD, 0xbcea, 0x8fbfb7, 0xbacd, 0xd9a9,    BAD,
/* 10 */ 0x8fbfb8, 0x8fbfb9, 0x8fbfba, 0xc2c7, 0x8fbfbb, 0xcaa7, 0x8fbfbc,    BAD,
/* 18 */ 0xc2f1,    BAD, 0x8fbfbd, 0xd9ac, 0x8fbfbe,    BAD, 0xd9aa,    BAD,
/* 20 */ 0xd9ad,    BAD,    BAD, 0xd9ab, 0x8fbfbf,    BAD,    BAD,    BAD,
/* 28 */ 0xd9ae,    BAD,    BAD,    BAD,    BAD, 0x8fbfc0, 0xcab1, 0x8fbfc1,
/* 30 */    BAD, 0xb0b7,    BAD, 0x8fbfc2,    BAD,    BAD, 0xc9de,    BAD,
/* 38 */    BAD, 0xc8e3, 0x8fbfc3,    BAD, 0xd9af, 0x8fbfc4, 0xd9b2, 0xbeb5
},

/* Row 0x85f */
{
/* 00 */ 0xb5bb,    BAD, 0xd9b0, 0xd9b7, 0xbeb6,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xd9b1, 0xc7c4,    BAD,    BAD, 0x8fbfc5, 0x8fbfc6, 0x8fbfc7,
/* 10 */ 0x8fbfc8, 0xcdde, 0xd9b3, 0xd9b4, 0xd9b8, 0xc5ea, 0xd9b5, 0xb9b3,
/* 18 */ 0xc0de,    BAD,    BAD, 0xd9c6, 0xc8b4,    BAD, 0xc2f2,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbfc9,    BAD,
/* 28 */ 0x8fbfca,    BAD,    BAD, 0xc8e4, 0xdaad,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xcafa,    BAD, 0x8fbfcb,    BAD, 0xc4f1, 0x8fbfcc, 0x8fbfcd,
/* 38 */    BAD, 0xcbf5, 0x8fbfce, 0xd9bb, 0xb2a1, 0xc3ea, 0x8fbfcf, 0x8fbfd0
},

/* Row 0x860 */
{
/* 00 */    BAD,    BAD, 0xd9c4,    BAD, 0x8fbfd1, 0xc3b4, 0xd9be, 0xd9c5,
/* 08 */ 0xd9c0, 0xd9c7, 0xd9c3,    BAD, 0xd9c2, 0xc7ef, 0x8fbfd2, 0xd9bc,
/* 10 */ 0xb2fd, 0xd9ba, 0xb5f1, 0xc2f3, 0xd9b6, 0x8fbfd3, 0x8fbfd4, 0xd9b9,
/* 18 */ 0xb9b4, 0xc0db, 0x8fbfd5, 0xbeb7, 0xd9c1, 0xc7d2,    BAD,    BAD,
/* 20 */ 0xb5f2, 0xb3c8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8fbfd6,    BAD, 0xb3e7, 0xbfa1, 0xd9c9, 0xd9ce,
/* 30 */    BAD, 0xd9ca, 0x8fbfd7, 0xb7fd, 0x8fbfd8, 0xd9cf, 0xbba2, 0xb9e9,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x8fbfd9, 0x8fbfda, 0xbda6, 0xd9bd
},

/* Row 0x861 */
{
/* 00 */    BAD, 0xbbfd, 0xd9cc, 0x8fbfdb, 0x8fbfdc,    BAD,    BAD, 0xbbd8,
/* 08 */ 0xd9cd, 0xb0c4, 0x8fbfdd, 0x8fbfde, 0xd9c8, 0x8fbfdf,    BAD,    BAD,
/* 10 */ 0x8fbfe0, 0xc4a9,    BAD, 0x8fbfe1,    BAD,    BAD, 0x8fbfe2,    BAD,
/* 18 */ 0x8fbfe3, 0xb5f3,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb6b4,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9cb,
/* 28 */ 0xb0a7, 0x8fbfe4, 0x8fbfe5, 0xbac3,    BAD, 0x8fbfe6,    BAD, 0xbfb6,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbfe7, 0x8fbfe8,    BAD,
/* 38 */    BAD, 0x8fbfe9, 0xc4f2,    BAD, 0x8fbfea, 0xc8d4, 0xd9d1, 0xc1de
},

/* Row 0x862 */
{
/* 00 */    BAD, 0x8fbfeb, 0x8fbfec, 0x8fbfed, 0x8fbfee,    BAD, 0x8fbfef,    BAD,
/* 08 */    BAD, 0xc2aa, 0x8fbff0, 0x8fbff1, 0xbbab, 0xd9d2, 0x8fbff2, 0xd9d4,
/* 10 */ 0xd9d0,    BAD, 0x8fbff3, 0x8fbff4, 0x8fbff5, 0xcae1,    BAD, 0xc4bd,
/* 18 */ 0x8fbff6,    BAD,    BAD, 0x8fbff7, 0xc1dc,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fbff8, 0x8fbff9, 0xcafb,
/* 28 */ 0xbcce, 0xd9e0,    BAD, 0xd9df, 0x8fbffa, 0x8fbffb, 0xbff8,    BAD,
/* 30 */    BAD, 0x8fbffc, 0xb7fe,    BAD, 0x8fbffd, 0x8fbffe, 0xd9d9, 0xbeb9,
/* 38 */ 0x8fc0a1,    BAD, 0xc6e8, 0xc7b1, 0x8fc0a2, 0x8fc0a3,    BAD, 0x8fc0a4
},

/* Row 0x863 */
{
/* 00 */ 0xd9d7,    BAD, 0x8fc0a5, 0xc1dd, 0x8fc0a6,    BAD,    BAD, 0x8fc0a7,
/* 08 */ 0xbcf8, 0xd9dc, 0x8fc0a8,    BAD, 0xbeb8,    BAD, 0xd9d6, 0xd9db,
/* 10 */ 0x8fc0a9,    BAD, 0xc7d3,    BAD, 0x8fc0aa, 0x8fc0ab, 0xd9d5,    BAD,
/* 18 */ 0xb7a1, 0x8fc0ac, 0x8fc0ad, 0xb3dd,    BAD,    BAD, 0x8fc0ae, 0xd9dd,
/* 20 */ 0xceab, 0xbace, 0xc3b5, 0xd9da, 0x8fc0af, 0xc0dc, 0x8fc0b0, 0xb9b5,
/* 28 */ 0xbfe4, 0xb1e6, 0xc1bc, 0xd9d8, 0xb5c5, 0x8fc0b1, 0x8fc0b2, 0x8fc0b3,
/* 30 */    BAD,    BAD, 0xb7c7,    BAD, 0xc4cf, 0xd9de,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xc1df,    BAD, 0x8fc0b4, 0xd9e1,    BAD
},

/* Row 0x864 */
{
/* 00 */ 0xd9e3, 0x8fc0b5,    BAD, 0xc2b7, 0xd9e9, 0x8fc0b6, 0xd9e4,    BAD,
/* 08 */ 0x8fc0b7, 0xd9e6,    BAD,    BAD,    BAD,    BAD, 0x8fc0b8, 0xc9c1,
/* 10 */ 0xc4f3, 0x8fc0b9, 0xd9e7, 0x8fc0ba, 0x8fc0bb, 0x8fc0bc, 0xcdac,    BAD,
/* 18 */    BAD,    BAD, 0xcdc8, 0xb4b9, 0x8fc0bd,    BAD,    BAD,    BAD,
/* 20 */ 0x8fc0be, 0xb0ae,    BAD, 0xd9e5,    BAD, 0x8fc0bf,    BAD,    BAD,
/* 28 */    BAD, 0xd9e2, 0x8fc0c0,    BAD, 0x8fc0c1,    BAD, 0xb4f8,    BAD,
/* 30 */    BAD,    BAD, 0x8fc0c2, 0x8fc0c3, 0xb1e7, 0x8fc0c4, 0xd9e8,    BAD,
/* 38 */ 0x8fc0c5, 0x8fc0c6, 0xcdc9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x865 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9ec,    BAD,
/* 08 */    BAD, 0x8fc0c7, 0x8fc0c8,    BAD,    BAD, 0xc2bb,    BAD, 0xd9f3,
/* 10 */ 0x8fc0c9,    BAD, 0x8fc0ca, 0xd9ed, 0x8fc0cb,    BAD, 0xd9ea, 0xd9f1,
/* 18 */ 0x8fc0cc,    BAD,    BAD,    BAD, 0xd9d3,    BAD, 0x8fc0cd,    BAD,
/* 20 */ 0x8fc0ce,    BAD, 0x8fc0cf,    BAD, 0x8fc0d0, 0x8fc0d1, 0xd9ee,    BAD,
/* 28 */ 0xd9f2, 0x8fc0d2, 0x8fc0d3,    BAD, 0xc8c2, 0xc5eb,    BAD, 0x8fc0d4,
/* 30 */ 0x8fc0d5,    BAD,    BAD,    BAD, 0xd9eb, 0x8fc0d6, 0xd9ef,    BAD,
/* 38 */    BAD,    BAD, 0xb7c8,    BAD,    BAD, 0x8fc0d7, 0xbaf1, 0x8fc0d8
},

/* Row 0x866 */
{
/* 00 */    BAD,    BAD, 0xc0dd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8fc0d9,    BAD,    BAD, 0xd9f7, 0x8fc0da,
/* 10 */    BAD, 0x8fc0db, 0x8fc0dc, 0x8fc0dd, 0x8fc0de,    BAD,    BAD,    BAD,
/* 18 */ 0xc5a6,    BAD, 0x8fc0df, 0x8fc0e0, 0x8fc0e1, 0x8fc0e2,    BAD, 0x8fc0e3,
/* 20 */ 0x8fc0e4, 0x8fc0e5,    BAD, 0x8fc0e6,    BAD,    BAD,    BAD, 0xd9f4,
/* 28 */    BAD, 0xcbe0,    BAD,    BAD,    BAD, 0x8fc0e7,    BAD, 0xd9f5,
/* 30 */    BAD,    BAD,    BAD, 0x8fc0e8, 0x8fc0e9,    BAD, 0xd9f6,    BAD,
/* 38 */ 0xccce,    BAD, 0xc0a2, 0x8fc0ea,    BAD, 0x8fc0eb,    BAD,    BAD
},

/* Row 0x867 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb7e2,    BAD, 0x8fc0ec,    BAD, 0x8fc0ed,
/* 08 */ 0xd9fd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fc0ee,
/* 10 */ 0x8fc0ef, 0x8fc0f0, 0xbbb5, 0xd9fa,    BAD, 0xd9f9,    BAD,    BAD,
/* 18 */ 0x8fc0f1, 0x8fc0f2, 0xc7b2, 0x8fc0f3,    BAD, 0x8fc0f4, 0xc6b5, 0x8fc0f5,
/* 20 */    BAD, 0x8fc0f6,    BAD, 0x8fc0f7, 0xc5b1, 0xd9fb, 0x8fc0f8,    BAD,
/* 28 */ 0x8fc0f9, 0xd9fc,    BAD, 0xc9ef, 0x8fc0fa, 0xc7c5, 0xbba3,    BAD,
/* 30 */ 0xc0f1,    BAD, 0xcbd0, 0x8fc0fb,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb3c9,    BAD, 0xdaa5, 0xd9fe, 0x8fc0fc, 0x8fc0fd, 0x8fc0fe
},

/* Row 0x868 */
{
/* 00 */    BAD, 0xcdca, 0xdaa7,    BAD, 0x8fc1a1, 0xdaa3,    BAD, 0xdaa4,
/* 08 */    BAD, 0x8fc1a2, 0x8fc1a3, 0x8fc1a4, 0x8fc1a5, 0xc1e0, 0x8fc1a6,    BAD,
/* 10 */ 0x8fc1a7, 0x8fc1a8, 0xdaa2,    BAD, 0xd9bf, 0x8fc1a9,    BAD, 0x8fc1aa,
/* 18 */ 0xdaa6,    BAD, 0xdaa1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xdaab, 0xdaac, 0xc5a7, 0xdaae, 0x8fc1ab, 0x8fc1ac, 0xbba4, 0xdaa9,
/* 28 */    BAD, 0x8fc1ad, 0x8fc1ae,    BAD, 0xb5bc, 0x8fc1af,    BAD, 0xdaaf,
/* 30 */ 0x8fc1b0, 0xdaa8, 0xdab3,    BAD, 0xdab2, 0x8fc1b1, 0xdab1, 0x8fc1b2,
/* 38 */    BAD,    BAD, 0xdab4, 0x8fc1b3,    BAD, 0xdab6, 0xbef1, 0x8fc1b4
},

/* Row 0x869 */
{
/* 00 */ 0xdab5, 0x8fc1b5,    BAD,    BAD, 0x8fc1b6, 0xdab9,    BAD,    BAD,
/* 08 */ 0x8fc1b7, 0x8fc1b8, 0x8fc1b9,    BAD,    BAD,    BAD,    BAD, 0x8fc1ba,
/* 10 */    BAD,    BAD,    BAD, 0x8fc1bb, 0x8fc1bc,    BAD, 0x8fc1bd,    BAD,
/* 18 */ 0xdab7, 0x8fc1be,    BAD, 0x8fc1bf, 0xdab8, 0xd9f0, 0x8fc1c0, 0x8fc1c1,
/* 20 */    BAD,    BAD, 0x8fc1c2, 0xdabb, 0xdaba,    BAD, 0x8fc1c3,    BAD,
/* 28 */    BAD, 0x8fc1c4, 0xd9f8, 0xdabc, 0xdab0,    BAD, 0x8fc1c5, 0xbbd9,
/* 30 */    BAD, 0x8fc1c6,    BAD,    BAD, 0xdabd, 0xdabe, 0xdac0, 0xdabf,
/* 38 */ 0xdac1, 0xb2fe, 0x8fc1c7, 0xb9b6, 0x8fc1c8, 0x8fc1c9, 0xcafc, 0xc0af
},

/* Row 0x86a */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fc1ca,    BAD, 0xb8ce,    BAD, 0x8fc1cb,
/* 08 */ 0xdac3, 0x8fc1cc,    BAD,    BAD,    BAD, 0xdac6,    BAD, 0xc9d2,
/* 10 */ 0x8fc1cd, 0xb5df, 0x8fc1ce,    BAD, 0x8fc1cf, 0xdac5, 0xdac4, 0xc7d4,
/* 18 */ 0xdac7, 0xb6b5,    BAD,    BAD,    BAD, 0xdac9, 0xdac8, 0x8fc1d0,
/* 20 */ 0x8fc1d1,    BAD, 0xb4ba, 0xbbb6,    BAD,    BAD, 0xc6d8, 0x8fc1d2,
/* 28 */    BAD,    BAD,    BAD, 0x8fc1d3, 0xb7c9,    BAD,    BAD,    BAD,
/* 30 */ 0xbff4,    BAD, 0xdaca,    BAD, 0xc0b0, 0xc5a8,    BAD, 0xc9df,
/* 38 */ 0xdacb,    BAD, 0x8fc1d4,    BAD,    BAD, 0x8fc1d5,    BAD,    BAD
},

/* Row 0x86b */
{
/* 00 */    BAD, 0x8fc1d6, 0xdacc, 0xdacd,    BAD, 0x8fc1d7,    BAD, 0xcab8,
/* 08 */ 0xd5dd, 0xc0c6, 0x8fc1d8,    BAD, 0xc9cc,    BAD, 0xbad8,    BAD,
/* 10 */ 0xc8e5, 0xc8c3, 0x8fc1d9,    BAD,    BAD, 0x8fc1da,    BAD, 0xc5cd,
/* 18 */ 0x8fc1db, 0xcec1,    BAD, 0xdacf, 0xbcd0, 0x8fc1dc,    BAD, 0xdad0,
/* 20 */ 0x8fc1dd, 0xb0b6,    BAD, 0x8fc1de, 0xb6d4, 0xc0cd, 0x8fc1df, 0xc9e0,
/* 28 */    BAD,    BAD,    BAD, 0xdad1, 0xbbc2, 0xc3c7, 0x8fc1e0, 0xbbdb,
/* 30 */ 0xbfb7,    BAD, 0x8fc1e1, 0x8fc1e2, 0x8fc1e3,    BAD,    BAD, 0xdad2,
/* 38 */    BAD, 0xcafd,    BAD,    BAD, 0xb1f7, 0xbbdc,    BAD, 0x8fc1e4
},

/* Row 0x86c */
{
/* 00 */    BAD, 0xdad5, 0x8fc1e5, 0xdad3, 0xdad6, 0xceb9, 0xdad4,    BAD,
/* 08 */ 0x8fc1e6, 0x8fc1e7,    BAD, 0xc0fb, 0xdad7,    BAD, 0x8fc1e8, 0xc2b2,
/* 10 */ 0x8fc1e9,    BAD, 0xdad8,    BAD, 0x8fc1ea,    BAD, 0x8fc1eb, 0xb4fa,
/* 18 */ 0x8fc1ec, 0xdada,    BAD, 0xdad9,    BAD,    BAD,    BAD, 0x8fc1ed,
/* 20 */ 0xdadb, 0xdadc, 0xb4fb,    BAD,    BAD, 0xc6fc, 0xc3b6, 0xb5ec,
/* 28 */ 0xbbdd, 0xc1e1,    BAD,    BAD, 0xbddc, 0xb0b0,    BAD,    BAD,
/* 30 */ 0x8fc1ee, 0xdadd, 0x8fc1ef,    BAD, 0x8fc1f0, 0x8fc1f1,    BAD,    BAD,
/* 38 */    BAD, 0x8fc1f2, 0xb2a2, 0xdae1,    BAD,    BAD, 0x8fc1f3, 0x8fc1f4
},

/* Row 0x86d */
{
/* 00 */ 0x8fc1f5,    BAD, 0xb9b7, 0xdae0, 0x8fc1f6,    BAD, 0xbaab, 0xbeba,
/* 08 */ 0x8fc1f7, 0x8fc1f8, 0xdadf,    BAD, 0xbebb, 0x8fc1f9, 0xccc0, 0xbaaa,
/* 10 */    BAD, 0x8fc1fa, 0x8fc1fb, 0xb0d7, 0xc0ce, 0x8fc1fc, 0x8fc1fd,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xdae6, 0x8fc1fe, 0x8fc2a1, 0xc0b1,
/* 20 */ 0xb1c7, 0x8fc2a2, 0x8fc2a3, 0x8fc2a4, 0x8fc2a5, 0xbdd5, 0x8fc2a6, 0xcbe6,
/* 28 */ 0xbaf2, 0x8fc2a7, 0x8fc2a8, 0x8fc2a9, 0x8fc2aa, 0xbebc, 0x8fc2ab, 0xc0a7,
/* 30 */ 0x8fc2ac, 0x8fc2ad,    BAD, 0x8fc2ae, 0xdae5, 0xdae3, 0xdae4, 0x8fc2b0,
/* 38 */    BAD, 0x8fc2af,    BAD,    BAD, 0xc3eb,    BAD,    BAD, 0xdba6
},

/* Row 0x86e */
{
/* 00 */ 0x8fc2b1, 0xdaea, 0xbbfe, 0xb9b8, 0xdae8, 0x8fc2b2, 0x8fc2b3,    BAD,
/* 08 */    BAD, 0xdae9, 0x8fc2b4, 0xbfb8, 0x8fc2b5,    BAD, 0x8fc2b7, 0xdae7,
/* 10 */    BAD, 0x8fc2b6, 0xbbaf,    BAD,    BAD,    BAD,    BAD, 0x8fc2b8,
/* 18 */ 0x8fc2b9, 0x8fc2ba,    BAD, 0x8fc2bb, 0x8fc2bc, 0xdaec, 0xdaeb, 0xdaf0,
/* 20 */ 0x8fc2bd, 0x8fc2be, 0xdaf1,    BAD, 0xdaed,    BAD, 0xb3a2, 0xdaee,
/* 28 */ 0xdaef, 0xc8d5, 0x8fc2c0, 0x8fc2c1, 0x8fc2c2,    BAD, 0xc9e1, 0xb7ca,
/* 30 */ 0xdaf2,    BAD,    BAD, 0x8fc2c4, 0xc0b2, 0x8fc2c5, 0xbebd, 0x8fc2c7,
/* 38 */ 0x8fc2c8, 0x8fc2c9, 0xc3d2, 0x8fc2ca, 0x8fc2cc,    BAD, 0x8fc2c3, 0x8fc2c6
},

/* Row 0x86f */
{
/* 00 */ 0x8fc2cb, 0xb6c7,    BAD, 0xdaf3, 0xdaf7,    BAD,    BAD, 0xb2cb,
/* 08 */ 0xdaf4, 0xdaf6,    BAD, 0x8fc2cd, 0x8fc2ce, 0x8fc2cf, 0xdaf5,    BAD,
/* 10 */ 0x8fc2d0, 0xbdeb, 0x8fc2d1,    BAD,    BAD,    BAD, 0xc3c8, 0xb0c5,
/* 18 */ 0xdaf8, 0x8fc2d2, 0x8fc2d3, 0x8fc2d4, 0x8fc2d5, 0xdaf9,    BAD, 0x8fc2d6,
/* 20 */ 0x8fc2d7,    BAD, 0xc4aa,    BAD, 0x8fc2d8,    BAD, 0xcef1,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xbbc3,    BAD, 0x8fc2d9, 0xcaeb,    BAD,
/* 30 */    BAD, 0x8fc2da, 0x8fc2db,    BAD, 0xcbbd, 0x8fc2dc,    BAD,    BAD,
/* 38 */ 0xdba2, 0xdafb,    BAD, 0x8fc2dd, 0xdafe,    BAD, 0xdafd, 0x8fc2de
},

/* Row 0x870 */
{
/* 00 */ 0x8fc2df, 0xdafa, 0x8fc2e0, 0x8fc2e1, 0xdba1,    BAD,    BAD, 0xc6de,
/* 08 */ 0x8fc2e2, 0xdafc,    BAD,    BAD, 0x8fc2e3,    BAD, 0x8fc2e4, 0x8fc2e5,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8fc2e6,    BAD, 0xdba3,    BAD,
/* 18 */    BAD, 0xbdec, 0xdba4, 0x8fc2e7, 0xcdcb, 0xc7f8,    BAD, 0x8fc2e8,
/* 20 */ 0xdba5,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdba7,    BAD,
/* 28 */ 0x8fc2e9, 0xdba8,    BAD, 0x8fc2ea, 0x8fc2eb,    BAD, 0x8fc2ec,    BAD,
/* 30 */ 0xdba9,    BAD, 0xb6ca, 0xb1c8, 0xb9b9, 0xdbaa,    BAD, 0xdbab,
/* 38 */ 0xbdf1, 0xc1e2, 0x8fc2ed, 0x8fc2bf, 0xd2d8, 0xc1be, 0xc1bd, 0xc2d8
},

/* Row 0x871 */
{
/* 00 */ 0xbac7,    BAD,    BAD, 0xd0f2,    BAD, 0x8fc2ee,    BAD, 0x8fc2ef,
/* 08 */ 0xb7ee, 0xcdad,    BAD, 0xcafe,    BAD, 0xc9fe, 0x8fc2f0, 0xdbac,
/* 10 */    BAD,    BAD,    BAD, 0x8fc2f1, 0xbaf3, 0xc4bf, 0xdbad, 0xcfaf,
/* 18 */    BAD, 0x8fc2f2,    BAD, 0xcbbe, 0x8fc2f3, 0xc4ab, 0xdbae, 0xb4fc,
/* 20 */ 0x8fc2f4,    BAD, 0x8fc2f5,    BAD,    BAD,    BAD, 0xdbaf, 0xdbb0,
/* 28 */ 0xccda,    BAD, 0xcca4, 0xcbf6, 0xcbdc, 0xbba5, 0xdbb2,    BAD,
/* 30 */    BAD, 0xbceb,    BAD, 0x8fc2f6, 0xcbd1,    BAD, 0xdbb4, 0xdbb7,
/* 38 */ 0xdbb6,    BAD, 0xb4f9,    BAD,    BAD, 0xb5e0, 0x8fc2f7, 0xdbb3
},

/* Row 0x872 */
{
/* 00 */    BAD, 0xdbb5,    BAD,    BAD,    BAD, 0x8fc2f8, 0xdbb8, 0x8fc2f9,
/* 08 */ 0x8fc2fa, 0xbff9,    BAD,    BAD, 0x8fc2fb,    BAD, 0xcdfb, 0xb0c9,
/* 10 */ 0xbae0, 0xc2bc,    BAD, 0xbcdd, 0x8fc2fc, 0x8fc2fd, 0xbef3,    BAD,
/* 18 */    BAD, 0xdbbb,    BAD,    BAD, 0xc5ce, 0x8fc2fe, 0xdbb9, 0xc2ab,
/* 20 */ 0xdbba, 0xbef2, 0xccdd, 0xdbbc, 0xdbbd, 0xcde8, 0x8fc3a1,    BAD,
/* 28 */    BAD,    BAD, 0xdbc2,    BAD, 0x8fc3a2, 0xb9ba, 0x8fc3a3, 0xc7d5,
/* 30 */ 0xdbbf, 0xc5ec, 0xdade, 0xdae2, 0x8fc3a4, 0xb5cf, 0x8fc3a5, 0xc7c7,
/* 38 */    BAD,    BAD,    BAD, 0x8fc3a6, 0xdbc1,    BAD, 0xbebe, 0xc8c4
},

/* Row 0x873 */
{
/* 00 */    BAD, 0x8fc3a7,    BAD,    BAD, 0x8fc3a8, 0xdbc7,    BAD, 0xc8fa,
/* 08 */    BAD, 0xdbbe,    BAD, 0xdbc4, 0xdbc3,    BAD, 0x8fc3a9, 0x8fc3aa,
/* 10 */ 0xc0cf, 0x8fc3ab,    BAD, 0x8fc3ac,    BAD, 0xcbed, 0x8fc3ad, 0xced3,
/* 18 */ 0x8fc3ae, 0x8fc3af, 0xcbe7, 0x8fc3b0, 0xb2cc, 0xbbde,    BAD,    BAD,
/* 20 */ 0xcfc8, 0xdbc6, 0xbff5,    BAD,    BAD,    BAD, 0xdbc5,    BAD,
/* 28 */    BAD, 0xdbc0,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb8cf,
/* 30 */ 0x8fc3b1, 0x8fc3b2, 0x8fc3b3, 0xdbcc, 0xdbca, 0x8fc3b4, 0xb2cd, 0xdbc8,
/* 38 */ 0xdbce, 0xdbd4,    BAD, 0x8fc3b5, 0x8fc3b6, 0x8fc3b7,    BAD,    BAD
},

/* Row 0x874 */
{
/* 00 */ 0x8fc3b9, 0xc2c8, 0x8fc3ba, 0x8fc3bb, 0xcac1, 0x8fc3bc, 0xdbd6,    BAD,
/* 08 */ 0x8fc3bd, 0x8fc3be, 0xc9a2,    BAD,    BAD,    BAD, 0xdbd5, 0xc7f0,
/* 10 */ 0xcbbf, 0xb4bb, 0x8fc3bf, 0xc0f7, 0xbdc0,    BAD,    BAD, 0x8fc3c0,
/* 18 */ 0xc4d3, 0x8fc3c1, 0xcdae,    BAD, 0x8fc3c2, 0xdbd1, 0xdbd0,    BAD,
/* 20 */    BAD, 0x8fc3c3, 0xdbd2,    BAD, 0xdbcf,    BAD, 0x8fc3c4, 0xdbd7,
/* 28 */    BAD, 0xdbcd,    BAD,    BAD, 0xdbcb,    BAD, 0xdbd3, 0xdbc9,
/* 30 */ 0x8fc3c5, 0xc3ec, 0x8fc3c6, 0xccf8, 0xbcc6, 0xbaf4, 0x8fc3c7, 0x8fc3c8,
/* 38 */    BAD, 0x8fc3b8,    BAD, 0xbaba,    BAD,    BAD, 0xcbef, 0xb3c1
},

/* Row 0x875 */
{
/* 00 */    BAD,    BAD, 0xc4ce, 0xc6ca, 0xb1c9,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xc0f2, 0x8fc3ca,    BAD, 0xc0b4, 0xb7aa,
/* 18 */    BAD, 0x8fc3cb,    BAD,    BAD,    BAD, 0x8fc3cc, 0xdbd9, 0x8fc3cd,
/* 20 */    BAD, 0xb9bb, 0xb3fc,    BAD,    BAD,    BAD,    BAD, 0x8fc3cf,
/* 28 */ 0x8fc3ce, 0xdbdb, 0xb3f4, 0xdbe1, 0x8fc3d0, 0x8fc3d1,    BAD, 0x8fc3d2,
/* 30 */ 0x8fc3d3, 0x8fc3d4, 0xdbde, 0x8fc3d5, 0xc0f3,    BAD,    BAD,    BAD,
/* 38 */ 0xb3cb, 0xbaac,    BAD, 0x8fc3d6, 0xb3ca, 0xbacf,    BAD, 0x8fc3d7
},

/* Row 0x876 */
{
/* 00 */ 0xdbdc, 0xb7e5, 0xb7cb, 0xc5ed, 0x8fc3d8, 0x8fc3d9, 0xdbda,    BAD,
/* 08 */ 0xb0c6,    BAD, 0x8fc3da,    BAD, 0x8fc3db, 0xdbdd, 0xdbdf,    BAD,
/* 10 */ 0xb6cd, 0xb7ac, 0x8fc3c9, 0xb4bc, 0xb5cb, 0x8fc3dc,    BAD, 0x8fc3dd,
/* 18 */ 0x8fc3de, 0xdbe2,    BAD, 0x8fc3df, 0xbaf9, 0xcbf1,    BAD, 0xbbb7,
/* 20 */    BAD,    BAD,    BAD, 0xdbe3,    BAD,    BAD,    BAD, 0xc9b0,
/* 28 */    BAD,    BAD,    BAD, 0x8fc3e0,    BAD,    BAD, 0x8fc3e1, 0x8fc3e2,
/* 30 */ 0x8fc3e3, 0x8fc3e4, 0x8fc3e5,    BAD, 0xdbef, 0x8fc3e6, 0xb2b3, 0xdbe4,
/* 38 */    BAD, 0x8fc3e7, 0x8fc3e8, 0x8fc3e9, 0x8fc3ea,    BAD, 0xdbf5, 0xdbe5
},

/* Row 0x877 */
{
/* 00 */    BAD, 0xcec2, 0x8fc3eb, 0xdbec, 0x8fc3ec, 0xc7df, 0x8fc3ed,    BAD,
/* 08 */ 0x8fc3ee,    BAD,    BAD,    BAD,    BAD, 0xdbf4,    BAD, 0xdbe7,
/* 10 */    BAD,    BAD,    BAD, 0xb0b4, 0xdbe9,    BAD, 0x8fc3ef, 0xb9bc,
/* 18 */ 0x8fc3f0,    BAD, 0x8fc3f1, 0xdbeb, 0x8fc3f2, 0xdbea,    BAD, 0xdbe6,
/* 20 */ 0xdbf1, 0x8fc3f3, 0xbebf, 0x8fc3f4,    BAD, 0x8fc3f5, 0xd4ed, 0xb8e8,
/* 28 */ 0xcdfc, 0x8fc3f6, 0x8fc3f7,    BAD,    BAD, 0xdbe8, 0x8fc3f8, 0xc4f4,
/* 30 */ 0xb3a3, 0xbaad, 0x8fc3f9, 0xdbe0,    BAD, 0xdbf0, 0xb3e1,    BAD,
/* 38 */    BAD, 0xdbee, 0xdbf2, 0x8fc3fa, 0xc5ee,    BAD,    BAD,    BAD
},

/* Row 0x878 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb4fe, 0x8fc3fb, 0xdcb2,    BAD,
/* 08 */ 0x8fc3fc, 0xccc9, 0xdbf7, 0xb4fd, 0x8fc3fd, 0xdbfe,    BAD, 0x8fc3fe,
/* 10 */ 0x8fc4a1, 0x8fc4a2, 0xcbc0, 0x8fc4a3, 0xdca1, 0xdca3, 0x8fc4a4, 0xdca7,
/* 18 */ 0xdbf9, 0x8fc4a5, 0xc3aa,    BAD, 0x8fc4a6, 0x8fc4a7,    BAD, 0xc5ef,
/* 20 */ 0xdcab, 0xdbfc,    BAD, 0xdca8,    BAD, 0x8fc4a8,    BAD, 0xdca2,
/* 28 */ 0x8fc4a9,    BAD, 0x8fc4aa, 0x8fc4ab, 0x8fc4ac, 0x8fc4ad, 0xbfb9, 0xdcac,
/* 30 */ 0x8fc4ae, 0x8fc4af, 0xc0b3,    BAD,    BAD, 0x8fc4b0, 0x8fc4b1,    BAD,
/* 38 */    BAD, 0xdcaa, 0xb4bd, 0x8fc4b2, 0x8fc4b3, 0x8fc4b4,    BAD,    BAD
},

/* Row 0x879 */
{
/* 00 */ 0xcfd0, 0xdbf6,    BAD,    BAD, 0xdca6, 0xb0d8, 0x8fc4b5,    BAD,
/* 08 */ 0xdbf8, 0x8fc4b6, 0x8fc4b7, 0xccba, 0xdbfd, 0xbfa2, 0xc4c7, 0xdbf3,
/* 10 */ 0x8fc4b8, 0x8fc4b9, 0xdca5, 0x8fc4ba,    BAD,    BAD, 0x8fc4bb, 0x8fc4bc,
/* 18 */    BAD, 0xbffa, 0xdcaf, 0xb3f1, 0xb8a1,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xdcb1, 0xdbfa, 0xdcb0,    BAD, 0xdca9, 0xdbfb,    BAD,
/* 28 */ 0xdcad,    BAD, 0xdcae,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xdcbf, 0x8fc4bd,    BAD, 0x8fc4be, 0xc6ce, 0x8fc4bf, 0xdca4,    BAD,
/* 38 */ 0x8fc4c0, 0xdcbb,    BAD, 0x8fc4c1,    BAD, 0xdcbd,    BAD, 0xc4d8
},

/* Row 0x87a */
{
/* 00 */    BAD,    BAD, 0x8fc4c2,    BAD,    BAD, 0x8fc4c3,    BAD,    BAD,
/* 08 */    BAD, 0x8fc4c4, 0xcdcc,    BAD,    BAD,    BAD, 0x8fc4c5,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xc9f6, 0xdcb8, 0xc2ca,    BAD, 0x8fc4c6,
/* 18 */    BAD, 0xdcbe, 0xc1bf, 0x8fc4c7, 0xdcb5, 0xdcc2, 0xdcc1,    BAD,
/* 20 */ 0xc6ef, 0xdcc0, 0xc6ea, 0x8fc4c8, 0x8fc4c9, 0x8fc4ca, 0x8fc4cb,    BAD,
/* 28 */ 0x8fc4cc, 0x8fc4cd, 0xdcc4, 0xdcb7, 0x8fc4ce, 0xb6c8, 0xdcba, 0xbddd,
/* 30 */ 0x8fc4cf, 0x8fc4d0, 0x8fc4d1, 0xc7e0, 0xdcbc, 0xb6cb,    BAD, 0xdcb4,
/* 38 */ 0xdcb6, 0xdcb3, 0x8fc4d2, 0x8fc4d3, 0xcfb0, 0xb3da, 0xdcb9, 0x8fc4d4
},

/* Row 0x87b */
{
/* 00 */ 0x8fc4d5, 0xdcc3, 0xb3b5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xbae7,    BAD,    BAD, 0x8fc4d6, 0xb1dd,    BAD,
/* 10 */    BAD, 0xdcd4, 0x8fc4d7,    BAD, 0xcfb1, 0xdcd7, 0x8fc4d8,    BAD,
/* 18 */ 0x8fc4d9,    BAD,    BAD, 0xbfba, 0xdcd6,    BAD,    BAD,    BAD,
/* 20 */ 0xdcd5, 0x8fc4da,    BAD,    BAD,    BAD, 0x8fc4db, 0x8fc4dc, 0xdcd2,
/* 28 */ 0x8fc4dd,    BAD,    BAD, 0x8fc4de,    BAD, 0x8fc4df, 0xdcc6, 0x8fc4e0,
/* 30 */    BAD, 0xdce3, 0xdcc5,    BAD, 0xdcd8,    BAD,    BAD, 0x8fc4e1,
/* 38 */ 0x8fc4e2,    BAD, 0x8fc4e3, 0xdcd0, 0x8fc4e4,    BAD, 0xdccb, 0xdcc8
},

/* Row 0x87c */
{
/* 00 */    BAD, 0xdcc9,    BAD, 0xdcd1,    BAD, 0x8fc4e5,    BAD, 0xf4a2,
/* 08 */ 0x8fc4e6,    BAD, 0xdcce, 0xb9bd, 0xc4c8, 0xc1e4, 0xdccc,    BAD,
/* 10 */ 0xdcc7, 0x8fc4e7,    BAD, 0xdcca,    BAD,    BAD, 0x8fc4e8, 0x8fc4e9,
/* 18 */ 0xcdcd, 0xcbea,    BAD,    BAD,    BAD, 0xdccf, 0xdcd9,    BAD,
/* 20 */    BAD,    BAD, 0x8fc4ea,    BAD,    BAD, 0x8fc4eb,    BAD, 0xdce1,
/* 28 */ 0xdcda,    BAD,    BAD, 0xdce7,    BAD, 0xdce5, 0x8fc4ec, 0x8fc4ed,
/* 30 */    BAD, 0x8fc4ee, 0xdce0, 0x8fc4ef,    BAD, 0x8fc4f0,    BAD,    BAD,
/* 38 */    BAD, 0xdcdf,    BAD, 0xc4d0,    BAD, 0xc1e5, 0x8fc4f1, 0xdcdd
},

/* Row 0x87d */
{
/* 00 */ 0x8fc4f2, 0x8fc4f3, 0xdcdb, 0x8fc4f4,    BAD, 0xdce2,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xdce8, 0xc8f5, 0xdcee,    BAD,    BAD, 0x8fc4f5,
/* 10 */    BAD, 0x8fc4f6, 0xdce9, 0xdcec, 0xdce6, 0x8fc4f7,    BAD, 0xc3f4,
/* 18 */    BAD, 0xc9b8, 0x8fc4f8, 0xdcdc,    BAD, 0x8fc4f9, 0xdce4, 0xbec0,
/* 20 */ 0x8fc4fa, 0xcccf, 0xdcf8, 0xdceb, 0x8fc4fb,    BAD,    BAD,    BAD,
/* 28 */ 0x8fc4fc, 0xb8a2, 0xb2a3, 0xb3df,    BAD,    BAD, 0xdcd3,    BAD,
/* 30 */ 0x8fc4fd,    BAD, 0x8fc4fe,    BAD, 0x8fc5a1, 0xbec1, 0xdcf0, 0x8fc5a2,
/* 38 */ 0xdcf7, 0xbcf9, 0xb3f2, 0x8fc5a3,    BAD, 0xc3ae, 0x8fc5a4, 0x8fc5a5
},

/* Row 0x87e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xdced, 0x8fc5a6, 0x8fc5a7, 0xdcf2,
/* 08 */ 0xdcf6, 0x8fc5a8, 0x8fc5a9, 0xb6b6,    BAD,    BAD, 0x8fc5aa,    BAD,
/* 10 */ 0x8fc5ab, 0x8fc5ac, 0x8fc5ad,    BAD,    BAD, 0x8fc5ae, 0x8fc5af,    BAD,
/* 18 */ 0xb5cc, 0xdcf4,    BAD, 0x8fc5b0,    BAD,    BAD,    BAD, 0xb5a1,
/* 20 */    BAD, 0xc6cb, 0xdcf3,    BAD, 0x8fc5b1,    BAD, 0xdcf5, 0x8fc5b2,
/* 28 */    BAD,    BAD, 0x8fc5b3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8fc5b4, 0xdcef, 0x8fc5b5,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xdcf1,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fc5b6, 0xb3e0
},

/* Row 0x87f */
{
/* 00 */ 0xc3c9, 0x8fc5b7,    BAD, 0x8fc5b8, 0xdcfc,    BAD, 0x8fc5b9, 0x8fc5ba,
/* 08 */    BAD, 0x8fc5bb,    BAD, 0x8fc5bc,    BAD, 0xdcfa, 0xb8e9,    BAD,
/* 10 */ 0xdcf9, 0x8fc5bd,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdda1,
/* 18 */    BAD,    BAD,    BAD, 0x8fc5be, 0xdbd8, 0x8fc5bf, 0x8fc5c0, 0x8fc5c1,
/* 20 */ 0xdcfb,    BAD, 0xdcfd, 0xdcfe,    BAD, 0x8fc5c2,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xddac, 0x8fc5c3, 0xdda8,    BAD, 0xdbed, 0x8fc5c4,
/* 30 */ 0x8fc5c5, 0x8fc5c6,    BAD, 0xdda7, 0x8fc5c7,    BAD,    BAD,    BAD,
/* 38 */ 0xdda6,    BAD,    BAD, 0xdda3,    BAD, 0x8fc5c8, 0x8fc5c9, 0x8fc5ca
},

/* Row 0x880 */
{
/* 00 */    BAD, 0xdcea, 0xdda5, 0xdda4,    BAD,    BAD, 0x8fc5cb,    BAD,
/* 08 */ 0x8fc5cd, 0x8fc5cc,    BAD,    BAD, 0x8fc5ce,    BAD,    BAD,    BAD,
/* 10 */ 0x8fc5cf, 0xddaa,    BAD, 0xcfa6, 0x8fc5d0, 0x8fc5d1, 0x8fc5d2,    BAD,
/* 18 */    BAD,    BAD, 0xddad, 0xb6fb, 0x8fc5d3, 0x8fc5d4, 0xdda9, 0xddab,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8fc5d5,    BAD,    BAD, 0x8fc5d6,
/* 28 */ 0xc8a7,    BAD, 0xddae,    BAD, 0x8fc5d7,    BAD,    BAD,    BAD,
/* 30 */ 0x8fc5d8, 0x8fc5d9, 0x8fc5da,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xddb2, 0xddaf, 0x8fc5db, 0x8fc5dc,    BAD,    BAD
},

/* Row 0x881 */
{
/* 00 */    BAD,    BAD, 0x8fc5dd, 0x8fc5de, 0xcdf3, 0xddb0, 0x8fc5df, 0x8fc5e0,
/* 08 */    BAD, 0x8fc5e1, 0xdcde,    BAD,    BAD,    BAD,    BAD, 0x8fc5e2,
/* 10 */ 0x8fc5e3, 0x8fc5e4, 0xddb3,    BAD,    BAD,    BAD, 0xddb4, 0x8fc5e5,
/* 18 */    BAD,    BAD,    BAD, 0x8fc5e6,    BAD, 0xb1b5, 0x8fc5e7, 0xddb6,
/* 20 */ 0xb7e7, 0xbca1,    BAD, 0xb6d5, 0x8fc5e8,    BAD,    BAD, 0xb2a4,
/* 28 */ 0x8fc5e9,    BAD,    BAD, 0x8fc5ea, 0x8fc5eb,    BAD,    BAD, 0x8fc5ec,
/* 30 */    BAD,    BAD, 0xcddf,    BAD,    BAD, 0x8fc5ed, 0x8fc5ee, 0xddb8,
/* 38 */ 0xddb7, 0xddba, 0xb5bd, 0x8fc5ef,    BAD, 0xb6d6, 0xb4be, 0x8fc5f0
},

/* Row 0x882 */
{
/* 00 */    BAD,    BAD,    BAD, 0xddbd,    BAD,    BAD, 0x8fc5f1, 0xddbc,
/* 08 */    BAD, 0xddbe, 0x8fc5f2,    BAD, 0xb2ce, 0x8fc5f3, 0xc3b7,    BAD,
/* 10 */ 0xddbf,    BAD, 0x8fc5f4, 0xb4bf, 0xddc1,    BAD, 0x8fc5f5,    BAD,
/* 18 */ 0x8fc5f6, 0xddc0,    BAD, 0xddc2,    BAD, 0x8fc5f7,    BAD, 0xddc3,
/* 20 */ 0x8fc5f8, 0xddc4, 0xbbdf, 0xc0b5, 0xbaa1,    BAD, 0xc9f0, 0x8fc5f9,
/* 28 */    BAD, 0xcae2, 0xcfc4, 0x8fc5fa,    BAD,    BAD, 0x8fc5fb, 0xbbf5,
/* 30 */ 0x8fc5fc,    BAD,    BAD, 0xbad0, 0xcef2, 0x8fc5fd,    BAD,    BAD,
/* 38 */ 0xddc5, 0xddc6,    BAD, 0xbbe0,    BAD, 0x8fc5fe, 0x8fc6a1, 0xddc7
},

/* Row 0x883 */
{
/* 00 */ 0xddc8,    BAD, 0x8fc6a2, 0xddca, 0xddc9, 0x8fc6a3, 0xcbd8,    BAD,
/* 08 */    BAD, 0xbdde, 0xbcec, 0xbbc4,    BAD, 0xddcb,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xddcd, 0xbfa3, 0x8fc6a4,
/* 18 */ 0xddcc,    BAD,    BAD, 0x8fc6a5,    BAD,    BAD, 0xddce, 0x8fc6a6,
/* 20 */ 0x8fc6a7,    BAD, 0x8fc6a8, 0x8fc6a9, 0xddcf,    BAD,    BAD,    BAD,
/* 28 */ 0x8fc6aa, 0x8fc6ab, 0xddd0, 0xddd1, 0x8fc6ac, 0x8fc6ad, 0x8fc6ae, 0xddd2,
/* 30 */ 0x8fc6af, 0xddd4, 0xddd3, 0xddd5, 0xb2a5, 0xc3ca,    BAD, 0xddd6,
/* 38 */ 0x8fc6b0, 0x8fc6b1, 0xbba6, 0xb3cc, 0xddd7, 0x8fc6b2, 0x8fc6b3, 0xc5c2
},

/* Row 0x884 */
{
/* 00 */ 0xd4cc,    BAD,    BAD, 0x8fc6b4, 0x8fc6b5, 0xb5a3, 0xddd8,    BAD,
/* 08 */    BAD, 0x8fc6b6,    BAD, 0xddd9, 0x8fc6b7, 0xcaec, 0xcbe8,    BAD,
/* 10 */    BAD,    BAD, 0xc6c7, 0xddda, 0xc8e6,    BAD, 0x8fc6b8,    BAD,
/* 18 */ 0xc8fb,    BAD, 0x8fc6b9, 0xccd3,    BAD,    BAD,    BAD, 0xdddb,
/* 20 */    BAD, 0x8fc6ba,    BAD, 0x8fc6bb,    BAD,    BAD, 0x8fc6bc, 0x8fc6bd,
/* 28 */    BAD,    BAD,    BAD, 0xdddd, 0xdddc,    BAD, 0x8fc6be, 0xdddf,
/* 30 */    BAD, 0x8fc6bf,    BAD, 0xddde,    BAD,    BAD,    BAD, 0x8fc6c0,
/* 38 */    BAD, 0x8fc6c1,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fc6c2
},

/* Row 0x885 */
{
/* 00 */    BAD,    BAD, 0x8fc6c3,    BAD, 0x8fc6c4, 0x8fc6c5,    BAD,    BAD,
/* 08 */ 0xdde1, 0x8fc6c6,    BAD,    BAD,    BAD, 0x8fc6c7, 0x8fc6c8, 0xbbe1,
/* 10 */ 0x8fc6c9, 0xccb1, 0x8fc6ca, 0xdde2, 0xdde3,    BAD,    BAD, 0xb5a4,
/* 18 */    BAD, 0x8fc6cb,    BAD, 0xdde4,    BAD,    BAD,    BAD, 0x8fc6cc,
/* 20 */    BAD,    BAD,    BAD, 0xdde6, 0xdde5,    BAD, 0x8fc6cd, 0x8fc6ce,
/* 28 */ 0x8fc6cf,    BAD,    BAD,    BAD, 0x8fc6d0,    BAD, 0x8fc6d1,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x8fc6d2, 0xbfe5, 0x8fc6d3, 0x8fc6d4, 0xc9b9,
/* 38 */ 0xb1ca,    BAD, 0x8fc6d5, 0x8fc6d6,    BAD,    BAD, 0xc8c5, 0x8fc6d7
},

/* Row 0x886 */
{
/* 00 */ 0xc4f5, 0xbdc1, 0xb5e1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8fc6d8, 0x8fc6d9,    BAD, 0x8fc6da, 0xc8c6, 0x8fc6db,
/* 10 */ 0xbcae,    BAD, 0x8fc6dc,    BAD, 0x8fc6dd, 0xdde8,    BAD, 0xb4c0,
/* 18 */    BAD, 0x8fc6de, 0xb1f8, 0x8fc6df, 0x8fc6e0, 0xc6f2, 0xdde7, 0xb9be,
/* 20 */ 0xc3d3,    BAD, 0xdde9,    BAD,    BAD,    BAD,    BAD, 0x8fc7b6,
/* 28 */ 0xddf1,    BAD, 0xddea, 0x8fc6e1,    BAD, 0x8fc6e2,    BAD, 0x8fc6e3,
/* 30 */ 0xc2c1,    BAD, 0xb5e2, 0xddf2, 0x8fc6e4,    BAD, 0x8fc6e5,    BAD,
/* 38 */ 0x8fc6e6, 0x8fc6e7, 0xb7e8, 0x8fc6e8,    BAD, 0xb5a5, 0xddf0,    BAD
},

/* Row 0x887 */
{
/* 00 */    BAD, 0xddee, 0xddeb, 0xcde0,    BAD, 0x8fc6e9, 0x8fc6ea, 0x8fc6eb,
/* 08 */ 0xc4c0, 0x8fc6ec,    BAD,    BAD, 0xc6d9, 0xddec,    BAD,    BAD,
/* 10 */ 0xddf4,    BAD, 0xddf3, 0xb7a3, 0x8fc6ed, 0x8fc6ee, 0xb2ad, 0x8fc6ef,
/* 18 */ 0x8fc6f0, 0xbabb, 0xdded, 0xddef, 0x8fc6f1,    BAD,    BAD, 0x8fc6f2,
/* 20 */    BAD, 0xcbd7, 0xc2f4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xcbf7,    BAD,    BAD, 0xddfc,    BAD,
/* 30 */ 0x8fc6f3, 0xddfd, 0x8fc6f4, 0xb2cf, 0x8fc6f5,    BAD,    BAD,    BAD,
/* 38 */ 0xcaa8, 0xccfd, 0xdea1, 0xbca3, 0xbec2, 0xddf8, 0xddfe, 0xb1e8
},

/* Row 0x888 */
{
/* 00 */    BAD, 0xb6b7, 0x8fc6f6,    BAD, 0xddf5, 0xddfa, 0x8fc6f7,    BAD,
/* 08 */    BAD, 0xc0f4, 0xc7f1,    BAD, 0xc8e7, 0x8fc6f8,    BAD, 0x8fc6f9,
/* 10 */ 0x8fc6fa, 0x8fc6fb, 0x8fc6fc, 0xddf7, 0x8fc6fd, 0xcba1, 0x8fc6fe, 0xddf9,
/* 18 */    BAD, 0xdea4, 0x8fc7a1, 0xdea2, 0x8fc7a2, 0xddfb,    BAD,    BAD,
/* 20 */ 0x8fc7a3, 0xcba2, 0xc7c8, 0xb5e3,    BAD, 0xc5a5,    BAD, 0x8fc7a4,
/* 28 */ 0xc3ed, 0x8fc7a5, 0xdea5, 0x8fc7a6, 0x8fc7a7,    BAD, 0x8fc7a8, 0xdea3,
/* 30 */ 0xc2d9, 0xddf6, 0x8fc7a9, 0xb1cb, 0x8fc7aa,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x889 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8fc7ab,    BAD,    BAD, 0x8fc7ac,
/* 08 */    BAD,    BAD, 0x8fc7ad, 0xcdce, 0xdeb0,    BAD, 0x8fc7ae, 0x8fc7af,
/* 10 */    BAD, 0x8fc7b0, 0xdeaf, 0x8fc7b1,    BAD,    BAD,    BAD, 0xc0f6,
/* 18 */    BAD, 0xdeac, 0x8fc7b2, 0xcdec,    BAD,    BAD, 0xc6b6, 0xdea6,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4c5, 0x8fc7b3, 0x8fc7b4,
/* 28 */ 0x8fc7b5, 0xb1cc, 0xb9bf, 0xdea9,    BAD,    BAD, 0x8fc7b7, 0x8fc7b8,
/* 30 */    BAD, 0x8fc7b9, 0xbda7, 0xdeae,    BAD, 0xdead, 0xdea8,    BAD,
/* 38 */ 0xdeab, 0x8fc7ba,    BAD, 0xb3e8, 0x8fc7bb, 0xdeaa, 0xc7c9, 0x8fc7bc
},

/* Row 0x88a */
{
/* 00 */    BAD, 0xceae,    BAD,    BAD, 0xbef4, 0xc0f5,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fc7bd,
/* 18 */    BAD, 0xdeb6, 0xdeb4,    BAD, 0xc9cd,    BAD, 0x8fc7be, 0x8fc7bf,
/* 20 */    BAD, 0x8fc7c0,    BAD, 0xdeb1, 0xdeb3, 0x8fc7c1, 0xb1ba, 0x8fc7c2,
/* 28 */    BAD, 0xb9c0, 0xcfb2,    BAD, 0xb3bd,    BAD, 0xc9e2, 0x8fc7c3,
/* 30 */ 0x8fc7c4,    BAD,    BAD,    BAD, 0xcde1,    BAD,    BAD, 0xb3a4,
/* 38 */ 0xbfbb, 0xdeb5,    BAD,    BAD, 0x8fc7c5,    BAD,    BAD,    BAD
},

/* Row 0x88b */
{
/* 00 */    BAD,    BAD, 0x8fc7c6,    BAD,    BAD, 0xdeba,    BAD, 0x8fc7c7,
/* 08 */ 0xbec3,    BAD,    BAD,    BAD, 0xcdb0,    BAD, 0xdeb7,    BAD,
/* 10 */    BAD, 0x8fc7c8, 0x8fc7c9, 0xdeb2, 0x8fc7ca, 0xdeb8, 0x8fc7cb, 0x8fc7cc,
/* 18 */ 0x8fc7cd, 0xcede,    BAD, 0xc5f3, 0xc6c2,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8fc7ce,    BAD, 0x8fc7cf,    BAD,    BAD, 0xb3b6,
/* 30 */    BAD,    BAD, 0xb1d5,    BAD, 0x8fc7d0, 0xdebe,    BAD, 0x8fc7d1,
/* 38 */ 0xdec1, 0x8fc7d2,    BAD,    BAD, 0xcec3, 0x8fc7d3,    BAD, 0x8fc7d4
},

/* Row 0x88c */
{
/* 00 */ 0xcde4,    BAD,    BAD,    BAD, 0x8fc7d5, 0xdec8, 0xdec2, 0xdebf,
/* 08 */ 0x8fc7d6,    BAD, 0x8fc7d7, 0xced4, 0xdec5,    BAD, 0x8fc7d8, 0x8fc7d9,
/* 10 */    BAD, 0xbdca, 0xdec7,    BAD,    BAD, 0xdecc, 0x8fc7da,    BAD,
/* 18 */ 0xc5f1, 0xdeca,    BAD, 0x8fc7db,    BAD, 0x8fc7dc, 0xdec4, 0x8fc7dd,
/* 20 */ 0x8fc7de, 0xc3b8, 0x8fc7df,    BAD, 0xdecb, 0x8fc7e0, 0xdec0,    BAD,
/* 28 */ 0xdec6, 0x8fc7e1, 0xdecd, 0xb0fc, 0xdec3,    BAD, 0xdece, 0x8fc7e2,
/* 30 */ 0x8fc7e3, 0xbfbc,    BAD, 0xbddf, 0x8fc7e4, 0xcaa5, 0x8fc7e5, 0xbaae,
/* 38 */    BAD, 0xdebb, 0xdec9, 0xc5ba, 0x8fc7e6,    BAD,    BAD,    BAD
},

/* Row 0x88d */
{
/* 00 */ 0x8fc7e7,    BAD,    BAD,    BAD, 0x8fc7e8, 0xc0b6,    BAD, 0xb3e9,
/* 08 */ 0xbad1, 0xbec4, 0xdebd, 0xbdc2,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xb7cc,    BAD, 0xdebc,    BAD,    BAD,
/* 18 */    BAD, 0xded2, 0xbded, 0xb8ba,    BAD, 0xdee1, 0x8fc7e9, 0xdedb,
/* 20 */ 0xb5f4, 0xc5cf, 0x8fc7ea, 0xded6, 0xdedf, 0xb0af, 0xb1b2, 0x8fc7eb,
/* 28 */    BAD, 0xb2b9,    BAD, 0xded8, 0xc2ac, 0xdecf, 0xded1, 0xb9c1,
/* 30 */    BAD,    BAD, 0x8fc7ec,    BAD,    BAD,    BAD, 0x8fc7ed,    BAD,
/* 38 */ 0xdee2, 0x8fc7ee, 0xdedd, 0x8fc7ef, 0x8fc7f0,    BAD, 0xded5,    BAD
},

/* Row 0x88e */
{
/* 00 */    BAD,    BAD,    BAD, 0xdedc, 0x8fc7f1, 0x8fc7f2,    BAD,    BAD,
/* 08 */ 0x8fc7f3, 0x8fc7f4, 0xccab, 0x8fc7f5,    BAD, 0xdeda, 0xdede, 0x8fc7f6,
/* 10 */    BAD, 0x8fc7f7, 0x8fc7f8, 0x8fc7f9, 0x8fc7fa,    BAD, 0xb8d0, 0x8fc7fb,
/* 18 */ 0xbec5,    BAD,    BAD, 0xc3b9, 0x8fc7fc, 0x8fc7fd, 0x8fc7fe, 0xded4,
/* 20 */    BAD,    BAD, 0x8fc8a1, 0x8fc8a2,    BAD,    BAD,    BAD, 0xcdaf,
/* 28 */ 0x8fc8a3,    BAD,    BAD, 0xded7,    BAD,    BAD, 0xded0, 0xc5f2,
/* 30 */    BAD,    BAD, 0xded3, 0x8fc8a4,    BAD,    BAD, 0xded9,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8fc8a5,    BAD, 0x8fc8a6, 0xcfd1, 0xbcbe
},

/* Row 0x88f */
{
/* 00 */ 0xcbfe,    BAD, 0xdee3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xc8ae, 0x8fc8a7,    BAD, 0xdeef,
/* 10 */ 0xb8bb,    BAD,    BAD, 0x8fc8a8,    BAD,    BAD, 0xbde0,    BAD,
/* 18 */ 0xdee5, 0x8fc8a9,    BAD,    BAD, 0xceaf, 0xb9c2,    BAD, 0xdef2,
/* 20 */ 0x8fc8aa,    BAD, 0xb0ee,    BAD,    BAD, 0xdef0,    BAD, 0x8fc8ab,
/* 28 */    BAD,    BAD, 0xdee4,    BAD,    BAD, 0x8fc8ac, 0x8fc8ad, 0xdeea,
/* 30 */    BAD, 0x8fc8ae, 0xdeec, 0x8fc8af,    BAD,    BAD, 0xcdcf, 0xdee7,
/* 38 */    BAD,    BAD, 0xc5ae, 0x8fc8b0,    BAD, 0xdee9,    BAD, 0x8fc8b1
},

/* Row 0x890 */
{
/* 00 */ 0x8fc8b2, 0x8fc8b3, 0xdef1, 0x8fc8b4, 0xdeeb, 0xccc7,    BAD, 0x8fc8b5,
/* 08 */ 0x8fc8b6, 0xdee6, 0x8fc8b7, 0xbca2, 0xdefe, 0x8fc8b8, 0x8fc8b9, 0x8fc8ba,
/* 10 */    BAD, 0xb3ea,    BAD, 0xdee8, 0xdeed, 0xdeee,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc2ec, 0xc2da,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8fc8bb, 0xdef6, 0x8fc8bc, 0x8fc8bd, 0xdefc,
/* 30 */    BAD,    BAD, 0xdefa,    BAD, 0xc5a9,    BAD,    BAD, 0xdfa3,
/* 38 */ 0xdef7, 0x8fc8be,    BAD, 0x8fc8bf,    BAD, 0x8fc8c0, 0xdef8, 0xdee0
},

/* Row 0x891 */
{
/* 00 */    BAD, 0xb5f9, 0xc9ba,    BAD, 0x8fc8c1,    BAD, 0xbcbf,    BAD,
/* 08 */ 0x8fc8c2, 0xb9f7, 0x8fc8c3,    BAD, 0x8fc8c4, 0x8fc8c5,    BAD, 0xcfb3,
/* 10 */    BAD, 0xdef4,    BAD, 0xdfa2, 0xb1e9, 0xc1e6, 0x8fc8c6,    BAD,
/* 18 */ 0x8fc8c7,    BAD, 0x8fc8c8, 0x8fc8c9,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xc7f9,    BAD, 0xb4c1, 0xcefa,    BAD,    BAD, 0x8fc8ca,    BAD,
/* 28 */    BAD, 0x8fc8cb, 0x8fc8cc, 0xcca1, 0xc4d2, 0x8fc8d3,    BAD, 0x8fc8cd,
/* 30 */ 0x8fc8ce, 0xdefb, 0xdefd, 0x8fc8cf,    BAD,    BAD, 0x8fc8d0,    BAD,
/* 38 */ 0xc1b2,    BAD,    BAD, 0x8fc8d1, 0x8fc8d2,    BAD, 0xdfa1, 0xdef9
},

/* Row 0x892 */
{
/* 00 */    BAD, 0xdef3,    BAD,    BAD,    BAD, 0xb4c3,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fc8d4,
/* 10 */    BAD, 0x8fc8d5, 0x8fc8d6, 0x8fc8d7, 0xb7e9,    BAD,    BAD, 0x8fc8d8,
/* 18 */ 0xdfaf, 0x8fc8d9, 0x8fc8da, 0xdfaa, 0xc0f8, 0x8fc8db, 0x8fc8dc, 0xb3e3,
/* 20 */    BAD, 0x8fc8dd, 0x8fc8de,    BAD, 0xbde1,    BAD, 0xdfb3,    BAD,
/* 28 */ 0x8fc8df,    BAD,    BAD,    BAD, 0x8fc8e0, 0xdfac, 0xc4ac, 0xdfa9,
/* 30 */ 0xc4d9,    BAD,    BAD,    BAD, 0xdfcc,    BAD,    BAD,    BAD,
/* 38 */ 0xdfa6,    BAD, 0xdfa5,    BAD, 0xdfae, 0x8fc8e1, 0x8fc8e2,    BAD
},

/* Row 0x893 */
{
/* 00 */ 0xdfa8, 0xdfa7, 0xdfad, 0x8fc8e3, 0xc0a1,    BAD, 0xdfa4, 0x8fc8e4,
/* 08 */ 0x8fc8e5,    BAD,    BAD, 0x8fc8e6, 0x8fc8e7, 0x8fc8e8, 0xdfb0,    BAD,
/* 10 */ 0x8fc8e9, 0xdfb1, 0x8fc8ea, 0x8fc8eb, 0x8fc8ec,    BAD, 0x8fc8ed, 0xb4c2,
/* 18 */    BAD,    BAD, 0x8fc8ee,    BAD,    BAD,    BAD,    BAD, 0x8fc8ef,
/* 20 */ 0x8fc8f0, 0xdfb6,    BAD, 0xdfb5, 0xdfb7, 0x8fc8f1, 0x8fc8f2, 0x8fc8f3,
/* 28 */ 0x8fc8f4,    BAD, 0xdfba,    BAD,    BAD,    BAD, 0x8fc8f5, 0x8fc8f6,
/* 30 */ 0x8fc8f7, 0xc5c3,    BAD, 0xdfb4,    BAD, 0x8fc8f8, 0x8fc8f9,    BAD,
/* 38 */    BAD, 0xdfb8,    BAD,    BAD, 0x8fc8fa,    BAD,    BAD,    BAD
},

/* Row 0x894 */
{
/* 00 */ 0xb7e3, 0xc2f9, 0xdfb2, 0xc7bb,    BAD, 0x8fc8fb, 0xdfb9, 0x8fc8fc,
/* 08 */ 0x8fc8fd,    BAD, 0x8fc8fe,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xdfbe, 0xdfbc,    BAD,    BAD,
/* 18 */ 0xdfbf,    BAD, 0x8fc9a1, 0xdfc2,    BAD,    BAD, 0x8fc9a2, 0xdfbb,
/* 20 */ 0xb9ea, 0xc7a8,    BAD,    BAD, 0xdeb9,    BAD,    BAD,    BAD,
/* 28 */ 0x8fc9a3, 0x8fc9a4,    BAD, 0xcdf4, 0xdfbd,    BAD, 0xdfc1, 0xc2f5,
/* 30 */ 0x8fc9a5, 0xdfc0,    BAD, 0xdfab,    BAD, 0x8fc9a6, 0xefe9,    BAD,
/* 38 */    BAD, 0x8fc9a7, 0xdfc5,    BAD, 0x8fc9a8, 0x8fc9a9, 0xdfc9,    BAD
},

/* Row 0x895 */
{
/* 00 */ 0x8fc9aa, 0xdfc7,    BAD,    BAD,    BAD, 0x8fc9ab, 0x8fc9ac, 0x8fc9ad,
/* 08 */    BAD, 0xdfc3,    BAD, 0xdfc4,    BAD, 0x8fc9ae,    BAD, 0xdfc8,
/* 10 */    BAD, 0xdfc6,    BAD,    BAD,    BAD, 0xc9ce,    BAD, 0x8fc9af,
/* 18 */ 0xdfce,    BAD, 0xdfcb, 0xdfca,    BAD, 0xdfcd, 0xc6d4, 0xdfcf,
/* 20 */ 0x8fc9b0,    BAD,    BAD, 0x8fc9b1,    BAD,    BAD, 0xc3f5, 0xc2ed,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xc0a5,    BAD,    BAD, 0x8fc9b2,
/* 30 */ 0xdfd0,    BAD, 0xdfd2,    BAD, 0x8fc9b3,    BAD,    BAD, 0x8fc9b4,
/* 38 */    BAD, 0x8fc9b5,    BAD,    BAD, 0x8fc9b6,    BAD, 0xdfd1,    BAD
},

/* Row 0x896 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fc9b7, 0x8fc9b8,    BAD,    BAD,    BAD,
/* 08 */ 0x8fc9b9, 0x8fc9ba, 0x8fc9bb, 0x8fc9bc, 0xdef5,    BAD, 0x8fc9c1,    BAD,
/* 10 */    BAD, 0xdfd3,    BAD,    BAD, 0x8fc9bd, 0x8fc9be,    BAD,    BAD,
/* 18 */ 0xc6e7,    BAD,    BAD,    BAD,    BAD, 0x8fc9bf, 0x8fc9c0,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xdfd4, 0x8fc9c2, 0x8fc9c3,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xb2d0, 0x8fc9c4,    BAD, 0x8fc9c5, 0xc5f4,
/* 30 */ 0xb3a5,    BAD,    BAD,    BAD,    BAD, 0x8fc9c6, 0x8fc9c7,    BAD,
/* 38 */ 0xb5e4,    BAD,    BAD,    BAD, 0xbcde, 0xbad2, 0x8fc9c8,    BAD
},

/* Row 0x897 */
{
/* 00 */    BAD, 0x8fc9c9,    BAD,    BAD,    BAD, 0x8fc9ca, 0x8fc9cb,    BAD,
/* 08 */    BAD, 0xcfa7, 0xbfe6,    BAD,    BAD,    BAD, 0xb1ea,    BAD,
/* 10 */    BAD,    BAD, 0xdfd6,    BAD, 0x8fc9cc, 0x8fc9cd, 0x8fc9ce, 0x8fc9cf,
/* 18 */ 0x8fc9d0, 0xdfd5,    BAD, 0x8fc9d1,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8fc9d2,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8fc9d3, 0xdfd9, 0xc3ba, 0xdfdc, 0xdfd7,
/* 30 */ 0x8fc9d4, 0x8fc9d5,    BAD, 0xdfdb, 0x8fc9d6,    BAD,    BAD, 0x8fc9d7,
/* 38 */ 0xdfda, 0xc5c0, 0xb0d9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x898 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xcef5,    BAD, 0x8fc9d8, 0xdfde,    BAD,    BAD,    BAD, 0xb1a8,
/* 10 */    BAD, 0x8fc9d9,    BAD, 0x8fc9da, 0x8fc9db, 0x8fc9dc, 0x8fc9dd,    BAD,
/* 18 */ 0x8fc9de, 0xdfe0,    BAD,    BAD, 0x8fc9df, 0xdfdf,    BAD, 0xdfdd,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8fc9e0,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xdfd8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xcba3, 0x8fc9e1,    BAD,    BAD, 0xdfe2,    BAD,    BAD
},

/* Row 0x899 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fc9e2, 0x8fc9e3, 0x8fc9e4, 0x8fc9e5, 0x8fc9e6,
/* 08 */    BAD, 0xdfe1,    BAD, 0x8fc9e7, 0x8fc9e8,    BAD,    BAD, 0x8fc9e9,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xb1eb,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xdfe4, 0xcab2,    BAD, 0xdfe3,    BAD, 0x8fc9ea,    BAD,
/* 20 */ 0x8fc9eb, 0xccb5,    BAD,    BAD,    BAD,    BAD, 0xbec7,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8fc9ec,    BAD, 0x8fc9ed,    BAD, 0x8fc9ee,
/* 30 */ 0x8fc9ef, 0x8fc9f0,    BAD,    BAD,    BAD,    BAD, 0xc1b3,    BAD,
/* 38 */ 0x8fc9f1,    BAD,    BAD,    BAD, 0xbec6,    BAD,    BAD,    BAD
},

/* Row 0x89a */
{
/* 00 */    BAD, 0x8fc9f2,    BAD,    BAD,    BAD, 0x8fc9f3, 0x8fc9f4, 0x8fc9f5,
/* 08 */    BAD, 0xcefb, 0x8fc9f6, 0x8fc9f7, 0xdfea,    BAD, 0xc0f9,    BAD,
/* 10 */ 0x8fc9f8,    BAD, 0x8fc9f9,    BAD,    BAD, 0xdfe6, 0xdfeb, 0x8fc9fa,
/* 18 */    BAD, 0xb1ec, 0x8fc9fb,    BAD, 0x8fc9fc,    BAD, 0x8fc9fd,    BAD,
/* 20 */ 0x8fc9fe,    BAD, 0xdfe9,    BAD, 0xc7e1, 0xdfe5, 0xdfe8, 0xbec8,
/* 28 */ 0x8fcaa1, 0xc8d1,    BAD,    BAD, 0xdfec,    BAD, 0xbcd1,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8fcaa2,    BAD,    BAD,    BAD, 0xc0fa,    BAD,    BAD
},

/* Row 0x89b */
{
/* 00 */ 0x8fcaa3,    BAD,    BAD,    BAD, 0xdfef, 0x8fcaa4,    BAD, 0x8fcaa5,
/* 08 */ 0xdfe7,    BAD, 0xb7a7,    BAD, 0x8fcaa6,    BAD,    BAD, 0xdfed,
/* 10 */    BAD,    BAD, 0x8fcaa7,    BAD, 0xcdd0, 0xdff0,    BAD,    BAD,
/* 18 */    BAD, 0xf4a6, 0x8fcaa8, 0x8fcaa9,    BAD,    BAD,    BAD, 0xbdcf,
/* 20 */ 0x8fcaaa,    BAD, 0x8fcaab,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xdff1,    BAD,    BAD,    BAD, 0xdff2,    BAD,    BAD, 0x8fcaac,
/* 30 */ 0x8fcaad, 0xc7ae, 0x8fcaae, 0x8fcaaf,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdff4, 0x8fcab0,    BAD,    BAD,    BAD, 0xdff5, 0x8fcab1
},

/* Row 0x89c */
{
/* 00 */ 0x8fcab2, 0x8fcab3,    BAD, 0xc7b3, 0x8fcab4,    BAD,    BAD,    BAD,
/* 08 */ 0xc5f5, 0xdff7,    BAD, 0x8fcab5, 0x8fcab6,    BAD, 0xdff9,    BAD,
/* 10 */ 0xced5,    BAD, 0xdff6, 0x8fcab7, 0xdff8, 0xb1ed, 0x8fcab8, 0xdff3,
/* 18 */    BAD, 0x8fcab9, 0x8fcaba,    BAD, 0x8fcabb,    BAD,    BAD, 0xd3db,
/* 20 */ 0xdffa,    BAD,    BAD,    BAD,    BAD, 0xc1e7, 0xbbb8, 0xdffc,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xdffb, 0xbfa4, 0xd2d9,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdffd,    BAD,    BAD,
/* 38 */ 0x8fcabc, 0xe0a1,    BAD, 0xdfee, 0xdffe,    BAD, 0x8fcabd, 0xe0a2
},

/* Row 0x89d */
{
/* 00 */ 0x8fcabe,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc7fa, 0x8fcabf,
/* 08 */ 0x8fcac0, 0x8fcac1,    BAD,    BAD,    BAD, 0xe0a3,    BAD,    BAD,
/* 10 */ 0xe0a4,    BAD,    BAD, 0x8fcac2,    BAD,    BAD,    BAD, 0x8fcac3,
/* 18 */    BAD,    BAD, 0x8fcac4, 0xe0a5,    BAD, 0x8fcac5,    BAD, 0x8fcac6,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8fcac7,    BAD,    BAD,    BAD,
/* 28 */ 0xe0a6,    BAD, 0xc4de, 0x8fcac8, 0xe0a8, 0xe0a7,    BAD, 0x8fcac9,
/* 30 */ 0xe0a9,    BAD, 0xe0aa,    BAD, 0x8fcaca, 0xbcdf, 0xc9e3,    BAD,
/* 38 */ 0x8fcacb, 0x8fcacc, 0xccec, 0xe0ab, 0xe0ac, 0xc1d6, 0xbca4, 0xe0ad
},

/* Row 0x89e */
{
/* 00 */ 0xe0ae, 0x8fcacd, 0x8fcace, 0x8fcacf,    BAD, 0x8fcad0, 0xe0af, 0xcad2,
/* 08 */ 0xc8c7,    BAD,    BAD, 0xe0b0, 0xc7d7,    BAD, 0x8fcad1, 0x8fcad2,
/* 10 */ 0x8fcad3,    BAD, 0xc4ad, 0x8fcad4,    BAD, 0x8fcad5, 0x8fcad6,    BAD,
/* 18 */ 0xe0b1, 0xb2e7, 0x8fcad7, 0xb5ed, 0x8fcad8, 0xccc6, 0x8fcad9, 0xccb6,
/* 20 */ 0x8fcada, 0xb2b4, 0xcfb4, 0x8fcadb,    BAD,    BAD,    BAD, 0xcbd2,
/* 28 */ 0x8fcadc, 0xcaaa,    BAD, 0x8fcadd,    BAD,    BAD, 0x8fcade, 0x8fcadf,
/* 30 */    BAD, 0x8fcae0, 0xc0b7,    BAD, 0xe0b2,    BAD,    BAD, 0x8fcae1,
/* 38 */ 0x8fcae2, 0xc6c3,    BAD, 0x8fcae3, 0x8fcae4, 0xb8a3, 0xe0b3, 0x8fcae5
},

/* Row 0x89f */
{
/* 00 */ 0xbad4, 0xe0b5, 0xe0b4,    BAD, 0x8fcae6,    BAD,    BAD, 0xe0b6,
/* 08 */    BAD, 0x8fcae7,    BAD,    BAD,    BAD, 0x8fcae8, 0x8fcae9,    BAD,
/* 10 */    BAD,    BAD, 0xe0b7, 0x8fcaea,    BAD,    BAD, 0xe0b8,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8fcaeb,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xb5be,    BAD, 0xe0b9,    BAD,    BAD,    BAD,    BAD, 0xe0ba,
/* 28 */ 0x8fcaec,    BAD,    BAD,    BAD, 0xb8a4, 0x8fcaed, 0x8fcaee, 0xc8c8,
/* 30 */    BAD, 0x8fcaef, 0xe0bc,    BAD, 0x8fcaf0,    BAD, 0xbef5,    BAD,
/* 38 */    BAD, 0xe0bb,    BAD,    BAD,    BAD,    BAD, 0x8fcaf1,    BAD
},

/* Row 0x8a0 */
{
/* 00 */    BAD, 0x8fcaf2, 0xb6b8, 0xe0bd, 0xe0bf,    BAD, 0xe0be, 0x8fcaf3,
/* 08 */    BAD, 0x8fcaf4,    BAD,    BAD, 0x8fcaf5,    BAD, 0xe0c0,    BAD,
/* 10 */ 0xb8d1,    BAD, 0xe0c1,    BAD,    BAD, 0x8fcaf6, 0x8fcaf7, 0xb6e9,
/* 18 */ 0x8fcaf8, 0xc1c0,    BAD, 0xb9fd,    BAD,    BAD,    BAD, 0x8fcaf9,
/* 20 */ 0xe0c3, 0xe0c4, 0xe0c2,    BAD,    BAD, 0x8fcafa,    BAD,    BAD,
/* 28 */    BAD, 0xbced,    BAD,    BAD, 0xc6c8, 0xb6b9,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x8fcafb, 0x8fcafc,    BAD,    BAD, 0xe0c6,
/* 38 */ 0xc3ac, 0xe0c5, 0x8fcafd, 0x8fcafe, 0xcfb5, 0xc7e2, 0x8fcba1,    BAD
},

/* Row 0x8a1 */
{
/* 00 */    BAD,    BAD, 0x8fcba2,    BAD, 0x8fcba3, 0x8fcba4,    BAD, 0x8fcba5,
/* 08 */    BAD,    BAD, 0xe0c9, 0x8fcba6,    BAD, 0x8fcba7,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8fcba8, 0x8fcba9,    BAD,    BAD, 0xe0cb, 0xe0c8,
/* 18 */ 0x8fcbaa, 0x8fcbab,    BAD, 0xccd4, 0xe0ca, 0xe0cc, 0x8fcbac, 0xcec4,
/* 20 */    BAD,    BAD, 0x8fcbad,    BAD, 0x8fcbae, 0xe0d0,    BAD, 0x8fcbaf,
/* 28 */ 0x8fcbb0, 0xe0cf, 0xc3f6, 0xc7ad, 0x8fcbb1,    BAD, 0xb8a5, 0xe0ce,
/* 30 */    BAD, 0x8fcbb2, 0x8fcbb3,    BAD, 0xe0cd, 0x8fcbb4, 0xcdb1, 0xcdb2,
/* 38 */    BAD,    BAD, 0x8fcbb5, 0x8fcbb6,    BAD, 0x8fcbb7, 0xe0d1, 0xb1ee
},

/* Row 0x8a2 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fcbb8, 0xb9f6, 0xbbe2,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fcbb9, 0xe0d2, 0xe0d3,
/* 10 */ 0x8fcbba,    BAD, 0x8fcbbb,    BAD,    BAD,    BAD, 0x8fcbbc, 0xe0d5,
/* 18 */ 0x8fcbbd,    BAD,    BAD,    BAD,    BAD, 0x8fcbbe, 0x8fcbbf, 0x8fcbc0,
/* 20 */ 0x8fcbc1,    BAD,    BAD, 0xbdc3,    BAD,    BAD, 0x8fcbc2, 0x8fcbc3,
/* 28 */ 0xe0d7, 0x8fcbc4, 0xe0d6, 0x8fcbc5, 0x8fcbc6,    BAD, 0x8fcbc7, 0x8fcbc8,
/* 30 */ 0xe0d8, 0x8fcbc9, 0xb3cd,    BAD,    BAD, 0xe0da,    BAD, 0x8fcbca,
/* 38 */ 0xe0d9, 0x8fcbcb, 0xe0dc, 0xe0db, 0x8fcbcc,    BAD,    BAD,    BAD
},

/* Row 0x8a3 */
{
/* 00 */ 0x8fcbcd, 0x8fcbce,    BAD, 0x8fcbcf, 0xb8bc, 0x8fcbd0, 0x8fcbd1, 0xcea8,
/* 08 */    BAD, 0xb6cc,    BAD, 0xb2a6,    BAD,    BAD, 0x8fcbd2,    BAD,
/* 10 */ 0x8fcbd3,    BAD,    BAD, 0x8fcbd4,    BAD, 0x8fcbd5, 0xb6ea, 0x8fcbd6,
/* 18 */ 0x8fcbd7,    BAD,    BAD,    BAD, 0x8fcbd8,    BAD, 0x8fcbd9, 0x8fcbda,
/* 20 */ 0x8fcbdb,    BAD, 0x8fcbdc,    BAD,    BAD, 0x8fcbdd, 0x8fcbde,    BAD,
/* 28 */    BAD, 0xb4e1, 0x8fcbdf, 0x8fcbe0,    BAD, 0x8fcbe1,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xcee8, 0xe0de,    BAD, 0x8fcbe2,    BAD, 0x8fcbe3,
/* 38 */    BAD, 0x8fcbe4,    BAD, 0xe0e0, 0x8fcbe5, 0x8fcbe6,    BAD, 0x8fcbe7
},

/* Row 0x8a4 */
{
/* 00 */ 0xe0e1,    BAD, 0xb2d1,    BAD,    BAD, 0x8fcbe8, 0x8fcbe9,    BAD,
/* 08 */ 0xe0dd, 0x8fcbea, 0xbbb9, 0x8fcbeb, 0x8fcbec, 0xc4c1, 0xe0df, 0x8fcbed,
/* 10 */    BAD,    BAD, 0x8fcbee, 0x8fcbef,    BAD,    BAD, 0x8fcbf0,    BAD,
/* 18 */    BAD, 0x8fcbf1,    BAD,    BAD,    BAD, 0x8fcbf2, 0xe0e4,    BAD,
/* 20 */ 0xbcee, 0x8fcbf3,    BAD, 0x8fcbf4,    BAD, 0xe0e2, 0x8fcbf5, 0x8fcbf6,
/* 28 */    BAD, 0x8fcbf7, 0xb7be,    BAD,    BAD, 0xc8c9, 0xe0e3,    BAD,
/* 30 */    BAD, 0xe0fe,    BAD,    BAD, 0x8fcbf8, 0x8fcbf9,    BAD, 0x8fcbfa,
/* 38 */ 0xe0e9, 0x8fcbfb, 0x8fcbfc, 0x8fcbfd,    BAD, 0x8fcbfe, 0xb8bd, 0x8fcca1
},

/* Row 0x8a5 */
{
/* 00 */ 0x8fcca2, 0x8fcca3,    BAD, 0xb5e5, 0x8fcca4, 0xe0e6, 0xcdfd, 0x8fcca5,
/* 08 */    BAD, 0xceb0, 0x8fcca6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8fcca7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8fcca8, 0x8fcca9,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xc2f6,    BAD, 0x8fccaa, 0xe0e8, 0x8fccab,    BAD,
/* 28 */ 0x8fccac, 0x8fccad, 0x8fccae, 0x8fccaf, 0x8fccb0, 0x8fccb1, 0x8fccb2, 0x8fccb3,
/* 30 */ 0x8fccb4, 0x8fccb5, 0xe0ea, 0xced6, 0xb6d7, 0xc8fc, 0xc7ca,    BAD,
/* 38 */    BAD, 0x8fccb6, 0xe0eb,    BAD,    BAD,    BAD,    BAD, 0xe0ed
},

/* Row 0x8a6 */
{
/* 00 */ 0x8fccb7, 0xe0f0,    BAD, 0x8fccb8, 0x8fccb9,    BAD, 0x8fccba, 0x8fccbb,
/* 08 */    BAD,    BAD,    BAD, 0x8fccbc,    BAD, 0x8fccbd,    BAD,    BAD,
/* 10 */    BAD, 0x8fccbe, 0x8fccbf,    BAD,    BAD, 0xe0ec,    BAD, 0x8fccc0,
/* 18 */    BAD, 0xe0ef, 0xb8ea, 0xb1cd, 0xe0f1, 0x8fccc1, 0xbff0, 0xe0ee,
/* 20 */ 0xcedc,    BAD, 0x8fccc2, 0xe0f4, 0xf4a4,    BAD, 0x8fccc3, 0x8fccc4,
/* 28 */ 0x8fccc5, 0xe0f2, 0xe0f5, 0x8fccc6,    BAD, 0x8fccc7, 0x8fccc8, 0xe0e7,
/* 30 */ 0xe0f3, 0x8fccc9, 0x8fccca, 0xbabc,    BAD,    BAD, 0xe0f6,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe0f7,    BAD
},

/* Row 0x8a7 */
{
/* 00 */ 0x8fcccb, 0x8fcccc,    BAD, 0xcdfe,    BAD, 0x8fcccd, 0x8fccce, 0x8fcccf,
/* 08 */    BAD, 0x8fccd0,    BAD, 0xe0f8,    BAD,    BAD,    BAD, 0x8fccd1,
/* 10 */ 0x8fccd2, 0x8fccd3, 0x8fccd4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8fccd5, 0x8fccd6, 0x8fccd7,    BAD, 0x8fccd8,    BAD, 0xe0f9, 0x8fccd9,
/* 20 */ 0x8fccda, 0x8fccdb, 0xe0e5, 0x8fccdc,    BAD,    BAD, 0x8fccdd, 0xe0fa,
/* 28 */ 0x8fccde, 0x8fccdf, 0x8fcce0, 0x8fcce1,    BAD,    BAD, 0x8fcce2, 0x8fcce3,
/* 30 */ 0xb4c4, 0x8fcce4, 0x8fcce5,    BAD,    BAD, 0x8fcce6,    BAD,    BAD,
/* 38 */    BAD, 0x8fcce7,    BAD, 0x8fcce8,    BAD, 0xbca5,    BAD, 0x8fcce9
},

/* Row 0x8a8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8fccea, 0x8fcceb, 0xe0fb,    BAD, 0x8fccec,    BAD,    BAD, 0xe0fc,
/* 10 */ 0x8fcced,    BAD,    BAD, 0x8fccee, 0xe0fd,    BAD,    BAD,    BAD,
/* 18 */ 0x8fccef,    BAD, 0x8fccf0, 0x8fccf1, 0xb1bb,    BAD, 0x8fccf2, 0x8fccf3,
/* 20 */ 0xe1a1,    BAD, 0xc9bb, 0xe1a2, 0x8fccf4,    BAD, 0xb4a4, 0xe1a3,
/* 28 */ 0x8fccf5, 0xe1a4, 0x8fccf6, 0x8fccf7,    BAD,    BAD, 0xe1a5, 0x8fccf8,
/* 30 */ 0xe1a7, 0xe1a8, 0xe1a6,    BAD, 0x8fccf9,    BAD, 0xc9d3, 0xe1aa,
/* 38 */ 0xe1a9,    BAD, 0x8fccfa, 0x8fccfb, 0x8fccfc,    BAD,    BAD, 0x8fccfd
},

/* Row 0x8a9 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe1ac, 0xe1ab, 0xe1ad, 0x8fccfe,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe1ae, 0xe1b0, 0xe1af,    BAD,
/* 10 */    BAD, 0xb9f9, 0x8fcda1, 0xe1b2,    BAD, 0xe1b1, 0x8fcda2, 0x8fcda3,
/* 18 */ 0xb4c5,    BAD, 0xbfd3,    BAD, 0xc5bc,    BAD, 0xe1b3, 0xc0b8,
/* 20 */ 0x8fcda4, 0x8fcda5,    BAD, 0xbbba, 0x8fcda6, 0xb1f9, 0xe1b4, 0x8fcda7,
/* 28 */ 0xcdd1, 0x8fcda8, 0x8fcda9, 0xcae3, 0xe1b5,    BAD,    BAD, 0x8fcdaa,
/* 30 */ 0xc5c4, 0xcdb3, 0xb9c3, 0xbfbd,    BAD,    BAD, 0x8fcdab, 0xc3cb,
/* 38 */ 0xd2b4, 0x8fcdac, 0xc4ae, 0xb2e8, 0xe1b6, 0x8fcdad, 0x8fcdae, 0x8fcdaf
},

/* Row 0x8aa */
{
/* 00 */ 0x8fcdb0,    BAD,    BAD, 0x8fcdb1, 0xe1b7,    BAD, 0xe1bc, 0x8fcdb2,
/* 08 */ 0x8fcdb3, 0xe1ba, 0xe1b9, 0xdac2, 0xb3a6, 0xe1b8, 0x8fcdb4, 0xb0da,
/* 10 */ 0x8fcdb5, 0xc8aa, 0x8fcdb6,    BAD, 0xc8ca,    BAD,    BAD, 0x8fcdb7,
/* 18 */    BAD, 0xceb1, 0xe1bd, 0xe1bb, 0xc3dc, 0xc0a6, 0x8fcdb8, 0x8fcdb9,
/* 20 */ 0xc8ab, 0x8fcdba, 0xc9ad,    BAD, 0xe1bf, 0xceac, 0xb7cd, 0xe1c0,
/* 28 */    BAD, 0xe1be, 0xc8d6, 0xe1c1,    BAD, 0xe1c2,    BAD, 0x8fcdbb,
/* 30 */ 0xb0db, 0x8fcdbc,    BAD, 0xbef6, 0xe1c7,    BAD, 0xe1c4, 0xc6ed,
/* 38 */ 0xe1c3, 0x8fcdbd, 0x8fcdbe, 0x8fcdbf, 0x8fcdc0, 0x8fcdc1, 0x8fcdc2, 0xb5a6
},

/* Row 0x8ab */
{
/* 00 */    BAD, 0x8fcdc3, 0xe1ca,    BAD,    BAD, 0x8fcdc4, 0xe1c5, 0xe1c6,
/* 08 */    BAD, 0xe1c9, 0xe1c8, 0xc9a5,    BAD,    BAD, 0xc1c2, 0xc1c1,
/* 10 */ 0x8fcdc5, 0xb5bf, 0x8fcdc6, 0x8fcdc7, 0xe1cb, 0x8fcdc8,    BAD,    BAD,
/* 18 */    BAD, 0x8fcdc9, 0xe1cc,    BAD, 0x8fcdca, 0xe1cd,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8fcdcb, 0xe1cf, 0x8fcdcc, 0xe1ce,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xb1d6,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xe1d7, 0xc8e8, 0xe1d1, 0x8fcdcd, 0xe1d3,    BAD,    BAD,
/* 38 */ 0xe1d5, 0xbfbe, 0x8fcdce,    BAD, 0xe1d6, 0xe1d4, 0xbcc0, 0x8fcdcf
},

/* Row 0x8ac */
{
/* 00 */ 0x8fcdd0, 0x8fcdd1, 0xe1d0, 0xe1d2, 0x8fcdd2, 0xc9c2, 0x8fcdd3, 0xbec9,
/* 08 */    BAD,    BAD, 0xe1d9,    BAD, 0x8fcdd4, 0xe1d8, 0x8fcdd5, 0x8fcdd6,
/* 10 */    BAD,    BAD, 0xe1da,    BAD, 0xbca6, 0xbaaf,    BAD, 0x8fcdd7,
/* 18 */ 0xc5f7, 0xe1db,    BAD, 0xc4cb, 0x8fcdd8,    BAD, 0xe1dd, 0x8fcdd9,
/* 20 */ 0x8fcdda, 0x8fcddb, 0xcea1, 0xe1dc, 0x8fcddc,    BAD,    BAD, 0x8fcddd,
/* 28 */    BAD, 0xc1e9,    BAD,    BAD, 0x8fcdde,    BAD, 0x8fcddf, 0x8fcde0,
/* 30 */ 0xe1e2, 0x8fcde1, 0xe1e4, 0xe1e5, 0xc3d4,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8fcde2, 0xe1e3,    BAD, 0xe1e0,    BAD, 0xe1de, 0xe1df
},

/* Row 0x8ad */
{
/* 00 */ 0x8fcde3, 0xe1e1, 0x8fcde4, 0x8fcde5, 0x8fcde6,    BAD,    BAD, 0x8fcde7,
/* 08 */ 0x8fcde8, 0xe1e8, 0x8fcde9, 0xe1e6, 0x8fcdea, 0xe1e7,    BAD, 0x8fcdeb,
/* 10 */    BAD,    BAD, 0x8fcdec, 0x8fcded,    BAD, 0x8fcdee, 0x8fcdef,    BAD,
/* 18 */    BAD, 0x8fcdf0,    BAD, 0x8fcdf1, 0x8fcdf2, 0x8fcdf3, 0x8fcdf4, 0xe1e9,
/* 20 */ 0xe1eb, 0xe1ec, 0xe1ed, 0x8fcdf5, 0xe1ee, 0x8fcdf6, 0x8fcdf7, 0xe1ea,
/* 28 */    BAD, 0x8fcdf8,    BAD,    BAD,    BAD, 0x8fcdf9,    BAD,    BAD,
/* 30 */ 0xe1f0,    BAD, 0x8fcdfa, 0x8fcdfb, 0xe1ef, 0x8fcdfc,    BAD,    BAD,
/* 38 */ 0x8fcdfd, 0x8fcdfe, 0x8fcea1, 0xe1f1, 0x8fcea2,    BAD,    BAD,    BAD
},

/* Row 0x8ae */
{
/* 00 */ 0x8fcea4, 0x8fcea5, 0xcec5, 0x8fcea6, 0x8fcea7, 0x8fcea8, 0xe1f4, 0xe1f2,
/* 08 */ 0xe1f3, 0x8fcea9, 0x8fcea3, 0x8fceaa, 0xb4e2,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xccfe,    BAD,    BAD, 0x8fceab, 0xcaca,    BAD,
/* 18 */ 0xe1f6, 0x8fceac,    BAD,    BAD, 0xe1f5,    BAD,    BAD, 0x8fcead,
/* 20 */    BAD, 0xe1f7, 0xe1f8,    BAD, 0x8fceae, 0x8fceaf,    BAD, 0xe1fc,
/* 28 */ 0xe1f9, 0xe1fa, 0xe1fb,    BAD, 0xe1fd, 0x8fceb0, 0x8fceb1, 0x8fceb2,
/* 30 */ 0xe1fe, 0x8fceb3, 0xe2a1,    BAD, 0x8fceb4,    BAD, 0xe2a2,    BAD,
/* 38 */ 0xe2a3,    BAD, 0xc8af, 0xc5d0, 0xe2a4, 0xc7f2, 0xc9b4,    BAD
},

/* Row 0x8af */
{
/* 00 */ 0xe2a5, 0x8fceb5,    BAD, 0xe2a6, 0xc5aa, 0x8fceb6, 0xb3a7, 0xb9c4,
/* 08 */ 0xe2a7,    BAD,    BAD, 0xe2a8, 0x8fceb7, 0x8fceb8, 0xe2a9,    BAD,
/* 10 */ 0xbba9,    BAD,    BAD, 0xe2ab,    BAD, 0x8fceb9, 0xe2aa,    BAD,
/* 18 */    BAD, 0xe2ac, 0xe2ad, 0x8fceba, 0x8fcebb, 0x8fcebc,    BAD, 0x8fcebd,
/* 20 */ 0x8fcebe,    BAD, 0x8fcebf, 0x8fcec0, 0x8fcec1, 0x8fcec2, 0x8fcec3, 0x8fcec4,
/* 28 */ 0x8fcec5,    BAD, 0x8fcec6,    BAD,    BAD, 0x8fcec7, 0xc8e9,    BAD,
/* 30 */ 0xe2ae,    BAD,    BAD,    BAD, 0xe2af,    BAD,    BAD, 0xf3e9,
/* 38 */ 0xe2b0, 0xe2b1, 0xe2b2,    BAD,    BAD, 0x8fcec8,    BAD, 0xbbae
},

/* Row 0x8b0 */
{
/* 00 */    BAD, 0x8fcec9, 0xe2b3, 0xc7d6,    BAD, 0x8fceca, 0xcbdf,    BAD,
/* 08 */ 0xb1ce, 0x8fcecb, 0xb1d7, 0x8fcecc, 0x8fcecd, 0xe2b4, 0x8fcece,    BAD,
/* 10 */    BAD,    BAD, 0xe2b6,    BAD, 0x8fcecf,    BAD, 0xe2b5, 0xc5f0,
/* 18 */    BAD, 0x8fced0,    BAD, 0xc0b9, 0xddb9,    BAD, 0xe2b7, 0xccc1,
/* 20 */ 0x8fced1, 0xe2b8,    BAD, 0xb4c6, 0xc8d7, 0xe2b9, 0x8fced2, 0xe2ba,
/* 28 */ 0x8fced3,    BAD, 0xe2bb,    BAD, 0x8fced4,    BAD, 0xccdc,    BAD,
/* 30 */ 0x8fced5, 0x8fced6, 0xccd5,    BAD, 0xc4be,    BAD, 0x8fced7,    BAD,
/* 38 */ 0xc1ea, 0x8fced8,    BAD, 0xe2bd, 0x8fced9,    BAD, 0xbde2,    BAD
},

/* Row 0x8b1 */
{
/* 00 */ 0x8fceda, 0xbeca,    BAD,    BAD, 0xe2c0,    BAD, 0x8fcedb, 0xe2bf,
/* 08 */ 0xe2be, 0xc8fd, 0x8fcedc, 0xb4c7, 0xb8a9,    BAD, 0x8fcedd,    BAD,
/* 10 */    BAD,    BAD, 0x8fcede,    BAD, 0x8fcedf, 0x8fcee0,    BAD, 0x8fcee1,
/* 18 */    BAD, 0x8fcee2, 0x8fcee3, 0xe2c6, 0x8fcee4,    BAD, 0xe2c3, 0xbfbf,
/* 20 */ 0xccb2,    BAD, 0x8fcee5,    BAD, 0xe2c2, 0xe2c4, 0xe2c5,    BAD,
/* 28 */ 0x8fcee6, 0xe2c1,    BAD,    BAD,    BAD, 0x8fcee7, 0x8fcee8, 0x8fcee9,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8fceea, 0x8fceeb, 0x8fceec, 0xe2c7,
/* 38 */ 0xe2c8, 0x8fceed, 0xc4af,    BAD, 0xb4e3, 0x8fceee, 0x8fceef,    BAD
},

/* Row 0x8b2 */
{
/* 00 */ 0xc3e5,    BAD, 0x8fcef0,    BAD,    BAD, 0x8fcef1, 0x8fcef2, 0xe2c9,
/* 08 */    BAD,    BAD, 0x8fcef3,    BAD,    BAD, 0x8fcef4, 0x8fcef5, 0x8fcef6,
/* 10 */    BAD,    BAD, 0x8fcef7,    BAD,    BAD,    BAD, 0x8fcef8, 0x8fcef9,
/* 18 */    BAD,    BAD, 0xe2ca, 0xe2cd, 0x8fcefa,    BAD, 0x8fcefb, 0x8fcefc,
/* 20 */ 0x8fcefd, 0xbfe7, 0x8fcefe, 0xc6c4, 0x8fcfa1, 0xe2ce, 0xcbd3, 0x8fcfa2,
/* 28 */ 0xe2cb,    BAD, 0x8fcfa3, 0xe2cc, 0x8fcfa4,    BAD,    BAD,    BAD,
/* 30 */ 0x8fcfa5,    BAD, 0x8fcfa6, 0x8fcfa7, 0x8fcfa8,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe2d1, 0x8fcfa9,    BAD,    BAD, 0x8fcfaa, 0xe2d0, 0xe2cf
},

/* Row 0x8b3 */
{
/* 00 */ 0x8fcfab,    BAD,    BAD,    BAD, 0x8fcfac,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe2d3, 0x8fcfad, 0x8fcfae, 0xe2d2,    BAD,
/* 10 */    BAD, 0xe2d4,    BAD,    BAD, 0x8fcfaf, 0x8fcfb0, 0x8fcfb1,    BAD,
/* 18 */    BAD,    BAD, 0x8fcfb2,    BAD,    BAD,    BAD, 0xe2d6, 0x8fcfb3,
/* 20 */ 0xe2d5,    BAD, 0x8fcfb4,    BAD,    BAD, 0xcacd,    BAD, 0x8fcfb5,
/* 28 */    BAD,    BAD, 0x8fcfb6,    BAD, 0xbdd6, 0xcec6, 0x8fcfb7, 0x8fcfb8,
/* 30 */ 0xe2d7, 0x8fcfb9,    BAD, 0xc6b7,    BAD, 0x8fcfba, 0xe2d8,    BAD,
/* 38 */    BAD, 0xe2d9,    BAD, 0xe2dd, 0xe2db, 0xe2dc, 0x8fcfbb, 0xe2da
},

/* Row 0x8b4 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fcfbc,    BAD,    BAD,    BAD, 0xe2de,
/* 08 */    BAD, 0x8fcfbd,    BAD,    BAD,    BAD, 0xe2df,    BAD,    BAD,
/* 10 */    BAD, 0x8fcfbe, 0x8fcfbf,    BAD,    BAD, 0x8fcfc0,    BAD, 0xe2e0,
/* 18 */    BAD, 0x8fcfc1, 0xe2e1, 0xccb7, 0xe2e2,    BAD, 0x8fcfc2, 0x8fcfc3,
/* 20 */ 0x8fcfc4,    BAD, 0xccf0, 0xe2e3, 0x8fcfc5, 0xc3ce, 0x8fcfc6, 0xc7ea,
/* 28 */    BAD, 0xb6eb, 0x8fcfc7,    BAD, 0x8fcfc8, 0xc3bb, 0xe2e4, 0xb6ba,
/* 30 */ 0x8fcfc9, 0x8fcfca,    BAD, 0xc0d0, 0x8fcfcb,    BAD,    BAD,    BAD,
/* 38 */ 0x8fcfcc,    BAD,    BAD, 0x8fcfcd, 0xe2e5,    BAD,    BAD,    BAD
},

/* Row 0x8b5 */
{
/* 00 */    BAD,    BAD, 0xbabd,    BAD,    BAD, 0x8fcfce, 0x8fcfcf,    BAD,
/* 08 */    BAD, 0x8fcfd0,    BAD,    BAD, 0xe2e6, 0x8fcfd1, 0x8fcfd2,    BAD,
/* 10 */    BAD, 0x8fcfd3, 0xe2e7,    BAD, 0xb8a6, 0xbad5,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fcfd4,    BAD,    BAD,
/* 20 */ 0xe2e9, 0x8fcfd5, 0x8fcfd6, 0x8fcfd7,    BAD, 0xc5d6, 0xbad6, 0xb5ce,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fcfd8, 0x8fcfd9,    BAD,
/* 30 */ 0x8fcfda,    BAD, 0xcba4,    BAD, 0xc7cb, 0x8fcfdb,    BAD, 0x8fcfdc,
/* 38 */    BAD,    BAD, 0xc5d7,    BAD,    BAD,    BAD,    BAD, 0xb9dc
},

/* Row 0x8b6 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fcfdd, 0x8fcfde, 0xe2eb,    BAD, 0x8fcfdf,
/* 08 */ 0x8fcfe0,    BAD,    BAD,    BAD, 0x8fcfe1,    BAD, 0x8fcfe2,    BAD,
/* 10 */    BAD,    BAD, 0x8fcfe3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x8fcfe4, 0xbecb, 0x8fcfe5,    BAD,
/* 20 */ 0x8fcfe6, 0x8fcfe7,    BAD, 0x8fcfe8, 0x8fcfe9,    BAD,    BAD,    BAD,
/* 28 */ 0x8fcfea,    BAD, 0x8fcfeb, 0xceb2, 0xb9c5,    BAD, 0x8fcfec, 0xb8a7,
/* 30 */    BAD,    BAD, 0xc8a3,    BAD, 0xe2ed,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8fcfed,    BAD, 0xe2ef,    BAD, 0x8fcfee,    BAD
},

/* Row 0x8b7 */
{
/* 00 */    BAD, 0xb8eb,    BAD,    BAD,    BAD,    BAD, 0xe2ee, 0xc4f6,
/* 08 */    BAD,    BAD, 0x8fcfef,    BAD, 0xe2f1, 0xb3b7, 0xe2ec, 0x8fcff0,
/* 10 */    BAD, 0xc8ea,    BAD, 0xb1b0, 0x8fcff1, 0xbaec,    BAD, 0xcfd2,
/* 18 */ 0x8fcff2,    BAD, 0xe2f0,    BAD,    BAD, 0x8fcff4, 0x8fcff5, 0x8fcff6,
/* 20 */    BAD, 0x8fcff3,    BAD, 0xe2f2, 0x8fcff7,    BAD,    BAD, 0xcacb,
/* 28 */ 0x8fcff8, 0xc0d9, 0xe2f4,    BAD, 0x8fcff9, 0x8fcffa,    BAD, 0xe2f5,
/* 30 */ 0x8fcffb, 0x8fcffc, 0x8fcffd, 0x8fcffe,    BAD, 0xe2f3,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xb3ce, 0x8fd0a1, 0xe2fb, 0x8fd0a2, 0xe2fa, 0x8fd0a3
},

/* Row 0x8b8 */
{
/* 00 */    BAD, 0xbca7,    BAD,    BAD,    BAD, 0xe2fc, 0xe2f7, 0x8fd0a4,
/* 08 */ 0x8fd0a5, 0x8fd0a6, 0xe2fd, 0xe2f8, 0x8fd0a7,    BAD, 0x8fd0a8,    BAD,
/* 10 */ 0xc8d8, 0xe2f6, 0x8fd0a9, 0x8fd0aa, 0xe2f9, 0x8fd0ab, 0x8fd0ac,    BAD,
/* 18 */    BAD,    BAD, 0xe3a2, 0x8fd0ae,    BAD,    BAD,    BAD, 0x8fd0af,
/* 20 */ 0x8fd0b0, 0x8fd0b1,    BAD,    BAD, 0x8fd0ad,    BAD, 0x8fd0b2, 0xe3a1,
/* 28 */ 0xcbe1,    BAD, 0x8fd0b3,    BAD, 0xe2fe,    BAD,    BAD, 0xb0eb,
/* 30 */    BAD,    BAD, 0x8fd0b4, 0x8fd0b5, 0xe3a4,    BAD, 0x8fd0b7, 0x8fd0b8,
/* 38 */    BAD,    BAD, 0x8fd0b9, 0x8fd0ba,    BAD, 0xe3a3,    BAD, 0x8fd0bb
},

/* Row 0x8b9 */
{
/* 00 */ 0x8fd0b6, 0xbecc,    BAD,    BAD,    BAD,    BAD, 0x8fd0bc, 0xe3a5,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x8fd0bd,    BAD, 0xc1c3,    BAD,
/* 10 */ 0x8fd0be, 0xe3a7, 0xe3a6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe3a8, 0x8fd0bf,    BAD, 0x8fd0c0,    BAD, 0x8fd0c1, 0x8fd0c2,
/* 20 */ 0x8fd0c3,    BAD,    BAD,    BAD,    BAD, 0x8fd0c4, 0xe2e8, 0x8fd0c5,
/* 28 */    BAD, 0x8fd0c6, 0xe2ea, 0xe3aa, 0xe3a9, 0x8fd0c7,    BAD,    BAD,
/* 30 */    BAD, 0x8fd0c8,    BAD,    BAD, 0x8fd0c9, 0x8fd0ca,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xbca8, 0x8fd0cb, 0xcee9, 0x8fd0cc, 0xbcd2, 0x8fd0cd
},

/* Row 0x8ba */
{
/* 00 */ 0xe3ab, 0xb7b7,    BAD,    BAD, 0x8fd0ce, 0x8fd0cf, 0x8fd0d0, 0xb5c0,
/* 08 */ 0xb5a7, 0xbbe3, 0x8fd0d1, 0x8fd0d2,    BAD,    BAD,    BAD, 0x8fd0d3,
/* 10 */ 0xcdb4, 0x8fd0d4,    BAD, 0xe3b1, 0x8fd0d5, 0xe3b0, 0xc1c4, 0xe3ad,
/* 18 */ 0x8fd0d6,    BAD, 0xe3af, 0x8fd0d7, 0x8fd0d8, 0xbdcb, 0xbfc0, 0xe3ae,
/* 20 */ 0xe3ac,    BAD, 0xc7aa,    BAD,    BAD, 0xbecd,    BAD, 0x8fd0d9,
/* 28 */ 0xc9bc, 0x8fd0da,    BAD, 0x8fd0db,    BAD, 0xbad7,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8fd0dc,    BAD,    BAD,    BAD,    BAD, 0xc5f8,
/* 38 */    BAD, 0x8fd0dd, 0xe3b2, 0x8fd0de, 0x8fd0df,    BAD, 0x8fd0e0, 0xe3b3
},

/* Row 0x8bb */
{
/* 00 */ 0xe3c9, 0xb6d8,    BAD,    BAD, 0xcfbd, 0xc1b5,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xe3b4, 0x8fd0e1, 0x8fd0e2, 0xb2d2, 0xc4f7, 0xcaa1,
/* 10 */    BAD, 0x8fd0e3,    BAD, 0x8fd0e4, 0x8fd0e5, 0x8fd0e6, 0x8fd0e7,    BAD,
/* 18 */ 0x8fd0e8,    BAD,    BAD, 0x8fd0e9, 0x8fd0ea, 0xe3b5,    BAD,    BAD,
/* 20 */    BAD, 0x8fd0eb,    BAD,    BAD,    BAD,    BAD, 0xb5fa, 0xe3b6,
/* 28 */ 0x8fd0ec, 0x8fd0ed, 0xe3b8, 0x8fd0ee,    BAD,    BAD, 0xe3b9, 0x8fd0ef,
/* 30 */ 0xc7a9, 0x8fd0f0,    BAD, 0xe3ba, 0x8fd0f1,    BAD,    BAD,    BAD,
/* 38 */ 0x8fd0f2, 0xe3bb, 0xe3bc, 0x8fd0f3,    BAD, 0xb6d9, 0xb2d3, 0xc6c5
},

/* Row 0x8bc */
{
/* 00 */ 0xbda8, 0xbbe4, 0x8fd0f4,    BAD, 0x8fd0f5,    BAD,    BAD, 0x8fd0f6,
/* 08 */ 0x8fd0f7, 0xe3bd, 0x8fd0f8, 0xbda9,    BAD,    BAD,    BAD, 0x8fd0f9,
/* 10 */    BAD, 0xb2ca, 0xc9c3,    BAD, 0x8fd0fa, 0xe3be, 0x8fd0fb,    BAD,
/* 18 */ 0xc8eb,    BAD, 0x8fd0fc,    BAD,    BAD, 0x8fd0fd, 0x8fd0fe, 0xc1c5,
/* 20 */ 0x8fd1a1, 0xe3c1, 0x8fd1a2, 0xe3c2, 0xc7e9, 0x8fd1a3, 0xbfc1, 0xe3bf,
/* 28 */    BAD, 0xc3e1, 0x8fd1a4, 0x8fd1a5, 0xe3c0, 0x8fd1a6,    BAD,    BAD,
/* 30 */ 0xbece, 0x8fd1a7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8fd1a8,    BAD,    BAD, 0xb0dc, 0x8fd1a9,    BAD,    BAD,    BAD
},

/* Row 0x8bd */
{
/* 00 */ 0xb5a9,    BAD, 0x8fd1aa, 0x8fd1ab,    BAD,    BAD,    BAD, 0x8fd1ac,
/* 08 */ 0xe3c3, 0x8fd1ad, 0x8fd1ae, 0xc4f8, 0x8fd1af, 0xe3c4, 0xc0c7,    BAD,
/* 10 */    BAD, 0x8fd1b0,    BAD,    BAD, 0xccad, 0x8fd1b1,    BAD, 0xc9a3,
/* 18 */ 0xe3c5, 0xe3c6, 0xc3d5, 0x8fd1b2, 0xcec7,    BAD, 0x8fd1b3, 0xe3c8,
/* 20 */ 0xe3c7, 0x8fd1b4,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fd1b5,
/* 28 */    BAD,    BAD,    BAD, 0x8fd1b6,    BAD, 0x8fd1b7, 0xbcef, 0x8fd1b8,
/* 30 */ 0x8fd1b9, 0xe3ca, 0xb0f0,    BAD, 0x8fd1ba, 0x8fd1bb,    BAD, 0xe3cd,
/* 38 */ 0x8fd1bc, 0x8fd1bd, 0x8fd1be, 0xe3cb, 0xb2d4, 0xb7ce, 0xe3cc, 0xb9c6
},

/* Row 0x8be */
{
/* 00 */ 0xb9f2,    BAD, 0xcae6, 0xe3ce, 0x8fd1bf, 0x8fd1c0, 0xcbd4, 0x8fd1c1,
/* 08 */ 0x8fd1c2, 0xe3d0,    BAD,    BAD, 0x8fd1c3, 0xc0d1, 0xb1cf, 0xb2ba,
/* 10 */ 0xb0ac,    BAD,    BAD,    BAD,    BAD, 0x8fd1c4, 0x8fd1c5, 0xe3cf,
/* 18 */    BAD, 0x8fd1c6,    BAD,    BAD, 0x8fd1c7, 0x8fd1c8,    BAD, 0x8fd1c9,
/* 20 */ 0x8fd1ca, 0xe3d1, 0xe3d2, 0xbef7,    BAD, 0x8fd1cb,    BAD, 0x8fd1cc,
/* 28 */    BAD, 0xe3d3, 0x8fd1cd, 0xb3cf,    BAD, 0x8fd1ce,    BAD,    BAD,
/* 30 */ 0xe3d5,    BAD,    BAD,    BAD, 0xb7ea, 0x8fd1cf, 0xb5e6,    BAD,
/* 38 */ 0x8fd1d0, 0xe3d6, 0xb6f5,    BAD,    BAD, 0xe3d7, 0x8fd1d1, 0xc0fc
},

/* Row 0x8bf */
{
/* 00 */ 0x8fd1d2, 0xc6cd, 0x8fd1d3, 0xc0e0, 0xbaf5, 0x8fd1d4, 0x8fd1d5,    BAD,
/* 08 */ 0xe3d8,    BAD, 0x8fd1d6, 0x8fd1d7,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8fd1d8, 0x8fd1d9, 0xc3e2, 0xc1eb, 0x8fd1da, 0xe3da, 0xe3dc, 0xe3d9,
/* 18 */ 0xe3db,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fd1db, 0xb7a2,
/* 20 */ 0x8fd1dc,    BAD,    BAD, 0x8fd1dd,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xe3dd, 0xb7a6,    BAD, 0x8fd1de,    BAD, 0xb5e7, 0xcdd2,
/* 30 */ 0xe3df,    BAD,    BAD, 0x8fd1df,    BAD, 0x8fd1e0, 0xe3e0,    BAD,
/* 38 */    BAD, 0x8fd1e1, 0xb1ae, 0x8fd1e2, 0x8fd1e3,    BAD,    BAD, 0xe3e3
},

/* Row 0x8c0 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb3f6, 0xe3e2, 0xe3e1, 0x8fd1e4, 0xe3e5,
/* 08 */ 0xe3de, 0x8fd1e5, 0xe3e6, 0xcea9, 0x8fd1e6, 0xe3e7, 0x8fd1e7, 0xe3e8,
/* 10 */    BAD, 0x8fd1e8, 0xd4f4, 0xe3ea,    BAD, 0xe3e9,    BAD,    BAD,
/* 18 */    BAD, 0xe3eb, 0xe3ec, 0x8fd1e9, 0xceb5, 0xe3ed,    BAD, 0xf0ef,
/* 20 */ 0xbecf, 0xe3ee, 0xe3ef, 0xbdd7,    BAD, 0xc6b8, 0xe3f0,    BAD,
/* 28 */ 0x8fd1ea, 0x8fd1eb, 0xc3a8, 0x8fd1ec, 0x8fd1ed, 0xe3f1,    BAD, 0xc3bc,
/* 30 */ 0xe3f2, 0x8fd1ee,    BAD,    BAD, 0x8fd1ef,    BAD, 0xb6a5,    BAD,
/* 38 */ 0xd1bf, 0xc3dd, 0xbcb3, 0x8fd1f0,    BAD, 0x8fd1f1, 0x8fd1f2, 0xb4c8
},

/* Row 0x8c1 */
{
/* 00 */    BAD,    BAD, 0xe3f3,    BAD, 0xe4a2,    BAD, 0xe3f6, 0x8fd1f3,
/* 08 */ 0xb5e8,    BAD, 0xe3f5, 0xe4a4,    BAD,    BAD,    BAD, 0xe3f4,
/* 10 */    BAD, 0xbed0,    BAD,    BAD, 0x8fd1f4,    BAD,    BAD,    BAD,
/* 18 */ 0xe3f8, 0xe3f9,    BAD, 0xc5ab,    BAD,    BAD, 0xe3fa, 0x8fd1f5,
/* 20 */ 0xb3de,    BAD,    BAD, 0x8fd1f6,    BAD, 0xbfda, 0xc9e4, 0x8fd1f7,
/* 28 */ 0xe3fc, 0x8fd1f8, 0x8fd1f9, 0x8fd1fa, 0xc2e8, 0x8fd1fb, 0x8fd1fc, 0x8fd1fd,
/* 30 */ 0x8fd1fe, 0x8fd2a1,    BAD, 0xe3f7, 0x8fd2a2, 0xe3fb, 0xe3fd,    BAD,
/* 38 */    BAD, 0xbafb,    BAD,    BAD,    BAD, 0x8fd2a3,    BAD, 0x8fd2a4
},

/* Row 0x8c2 */
{
/* 00 */ 0x8fd2a5, 0x8fd2a6,    BAD,    BAD,    BAD, 0xe4a6, 0xc9ae, 0x8fd2a7,
/* 08 */ 0xc8a6, 0xc5f9,    BAD, 0xb6da, 0xe4a5, 0xe4a3, 0x8fd2a8, 0xc8b5,
/* 10 */ 0xe3fe, 0xc3de, 0xc5fb,    BAD, 0xc5fa, 0x8fd2a9, 0xbaf6,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4b8,    BAD,    BAD,
/* 20 */ 0x8fd2aa,    BAD,    BAD,    BAD, 0x8fd2ab, 0xe4a8, 0x8fd2ac, 0xe4aa,
/* 28 */    BAD, 0x8fd2ad, 0x8fd2ae,    BAD, 0xe4ad, 0x8fd2af, 0xe4ae, 0x8fd2b0,
/* 30 */ 0xe4ab, 0xe4ac, 0x8fd2b1, 0x8fd2b2, 0xe4a9, 0xe4a7,    BAD, 0x8fd2b3,
/* 38 */    BAD,    BAD, 0xe4a1,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x8c3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8fd2b4,    BAD, 0xcacf, 0xb2d5,
/* 08 */    BAD, 0x8fd2b5,    BAD, 0xe4b5,    BAD, 0xe4b2, 0x8fd2b6, 0xe4b7,
/* 10 */ 0x8fd2b7, 0x8fd2b8, 0xe4b6,    BAD, 0xc7f3, 0xcca7, 0x8fd2b9, 0xbbbb,
/* 18 */ 0xe4b0, 0xe4b9, 0xe4b4, 0x8fd2ba, 0xe4b3, 0xe4af, 0x8fd2bb, 0xe4b1,
/* 20 */ 0x8fd2bc, 0xb4c9,    BAD,    BAD,    BAD, 0x8fd2bd,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xc3bd,    BAD, 0x8fd2be, 0xc0fd,    BAD, 0x8fd2bf,
/* 30 */ 0x8fd2c0, 0xc8a2, 0x8fd2c1,    BAD, 0xe4be, 0x8fd2c2, 0x8fd2c3,    BAD,
/* 38 */ 0xc8a4,    BAD, 0x8fd2c4, 0x8fd2c5, 0x8fd2c6, 0x8fd2c7,    BAD,    BAD
},

/* Row 0x8c4 */
{
/* 00 */ 0xc0e1, 0xe4bb, 0x8fd2c8,    BAD, 0xc8cf, 0x8fd2c9, 0xe4bf, 0xcad3,
/* 08 */ 0x8fd2ca, 0xc3db, 0x8fd2cb, 0xe4ba, 0xe4bc,    BAD,    BAD, 0xe4bd,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8fd2cc,    BAD, 0x8fd2cd, 0x8fd2ce,
/* 18 */    BAD, 0x8fd2cf, 0x8fd2d0, 0x8fd2d1,    BAD, 0xe4c0,    BAD,    BAD,
/* 20 */ 0xbcc4,    BAD,    BAD,    BAD, 0xc6c6, 0xe4c5, 0xe4c4,    BAD,
/* 28 */ 0x8fd2d2, 0xe4c1, 0x8fd2d3,    BAD,    BAD, 0xcfb6,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8fd2d4, 0xe4ca, 0x8fd2d5, 0x8fd2d6, 0xe4ce, 0xe4cb,
/* 38 */ 0x8fd2d7, 0x8fd2d8, 0x8fd2d9,    BAD, 0x8fd2da,    BAD, 0x8fd2db,    BAD
},

/* Row 0x8c5 */
{
/* 00 */ 0xe4c7, 0x8fd2dc, 0x8fd2dd, 0x8fd2de, 0x8fd2df,    BAD, 0x8fd2e0, 0xe4c8,
/* 08 */    BAD, 0x8fd2e1,    BAD, 0x8fd2e2, 0x8fd2e3, 0xe4cd, 0x8fd2e4, 0x8fd2e5,
/* 10 */    BAD, 0xe4c2, 0xd2d5, 0xe4c9, 0xe4c3,    BAD,    BAD, 0xe4cc,
/* 18 */    BAD, 0x8fd2e6,    BAD, 0x8fd2e7,    BAD,    BAD,    BAD, 0xe4d2,
/* 20 */ 0x8fd2e8, 0xb4ca,    BAD, 0xe4cf,    BAD, 0x8fd2e9, 0x8fd2ea, 0xe4d0,
/* 28 */ 0x8fd2eb,    BAD, 0xe4d1, 0xe4d4, 0x8fd2ec,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8fd2ed,    BAD, 0x8fd2ee, 0x8fd2ef,    BAD, 0x8fd2f0, 0xe4d3,
/* 38 */ 0xc8f6, 0x8fd2f1, 0x8fd2f2,    BAD,    BAD, 0xe4d5, 0xcefc, 0xcaed
},

/* Row 0x8c6 */
{
/* 00 */ 0xe4da,    BAD,    BAD, 0xe4d7,    BAD,    BAD, 0x8fd2f3,    BAD,
/* 08 */    BAD,    BAD, 0x8fd2f4,    BAD, 0xe4d6, 0xc0d2,    BAD, 0xe4d9,
/* 10 */ 0xe4db, 0x8fd2f6, 0x8fd2f7, 0x8fd2f8, 0xe4d8, 0x8fd2f5, 0xe4df,    BAD,
/* 18 */ 0xe4dc, 0x8fd2f9, 0x8fd2fa, 0x8fd2fb, 0x8fd2fc, 0x8fd2fd, 0x8fd2fe, 0xe4dd,
/* 20 */ 0xe4c6, 0x8fd3a1,    BAD, 0x8fd3a2, 0xe4de, 0xe4e0,    BAD, 0x8fd3a3,
/* 28 */    BAD, 0x8fd3a4,    BAD,    BAD, 0xe4e1, 0x8fd3a5, 0x8fd3a6,    BAD,
/* 30 */ 0x8fd3a7,    BAD, 0x8fd3a8, 0xcac6,    BAD, 0xe4e2,    BAD,    BAD,
/* 38 */    BAD, 0x8fd3a9,    BAD,    BAD, 0x8fd3aa, 0x8fd3ab, 0xcce2,    BAD
},

/* Row 0x8c7 */
{
/* 00 */    BAD, 0xb6ce, 0xb7a9, 0xe4e3,    BAD,    BAD, 0x8fd3ac, 0x8fd3ad,
/* 08 */    BAD, 0xcab4,    BAD, 0xbfe8,    BAD, 0xccb0,    BAD, 0x8fd3ae,
/* 10 */ 0xe4e4,    BAD, 0xceb3,    BAD, 0x8fd3af, 0xc7f4,    BAD, 0xc1c6,
/* 18 */ 0xc7b4,    BAD,    BAD, 0xbdcd,    BAD,    BAD, 0x8fd3b0, 0xb0c0,
/* 20 */ 0x8fd3b1, 0xe4e9, 0xe4e7,    BAD, 0xe4e5, 0xb4a1, 0x8fd3b2, 0xbed1,
/* 28 */ 0xe4ea,    BAD,    BAD, 0xe4e8,    BAD, 0xe4e6, 0xe4ee,    BAD,
/* 30 */ 0x8fd3b3, 0xe4ed, 0xe4ec, 0xe4eb,    BAD,    BAD, 0x8fd3b4, 0x8fd3b5,
/* 38 */    BAD, 0xe4ef, 0x8fd3b6, 0x8fd3b7, 0x8fd3b8, 0xe4f0, 0xc0ba, 0x8fd3b9
},

/* Row 0x8c8 */
{
/* 00 */ 0xe4f1,    BAD, 0xe4f3,    BAD, 0x8fd3ba, 0xe4f2,    BAD, 0x8fd3bb,
/* 08 */ 0x8fd3bc, 0x8fd3bd, 0xb8d2,    BAD,    BAD, 0x8fd3be, 0xc1b8, 0x8fd3bf,
/* 10 */    BAD,    BAD, 0xe4f5, 0x8fd3c0, 0x8fd3c1, 0x8fd3c2, 0xc5fc, 0x8fd3c3,
/* 18 */ 0xe4f4, 0x8fd3c4, 0x8fd3c5,    BAD, 0xe4f6, 0x8fd3c6, 0xcab5, 0xc1ec,
/* 20 */ 0xb9c7,    BAD, 0xe4f7,    BAD,    BAD,    BAD, 0x8fd3c7, 0xcec8,
/* 28 */    BAD, 0x8fd3c8,    BAD, 0x8fd3c9,    BAD,    BAD,    BAD, 0xe4f9,
/* 30 */    BAD,    BAD, 0xe4fa,    BAD, 0xe4fb, 0x8fd3ca, 0xe4fc,    BAD,
/* 38 */ 0xbbe5,    BAD, 0xe4fd, 0xb7cf,    BAD,    BAD, 0xb5ea,    BAD
},

/* Row 0x8c9 */
{
/* 00 */ 0xb5aa,    BAD, 0xe5a1, 0x8fd3cb, 0xccf3, 0xb9c8, 0xe4fe, 0x8fd3cc,
/* 08 */ 0x8fd3cd, 0x8fd3ce, 0xe5a4, 0xcce6,    BAD, 0xc7bc,    BAD, 0x8fd3cf,
/* 10 */ 0xc9b3, 0x8fd3d0, 0x8fd3d1, 0x8fd3d2, 0xbde3, 0xe5a3, 0x8fd3d3, 0xbcd3,
/* 18 */ 0xb9c9, 0xbbe6, 0xb5e9, 0xcab6, 0xe5a2, 0x8fd3d4, 0x8fd3d5,    BAD,
/* 20 */ 0xc1c7, 0xcbc2, 0xbaf7, 0x8fd3d6,    BAD,    BAD, 0x8fd3d7,    BAD,
/* 28 */    BAD,    BAD, 0x8fd3d8, 0xbbe7, 0xc4dd, 0x8fd3d9, 0xe5a7, 0xcedf,
/* 30 */ 0xbad9, 0x8fd3da, 0xe5a8, 0xbfc2,    BAD, 0xe5aa,    BAD,    BAD,
/* 38 */    BAD, 0xbed2, 0xbab0,    BAD, 0x8fd3db, 0x8fd3dc, 0x8fd3dd, 0xe5a9
},

/* Row 0x8ca */
{
/* 00 */ 0x8fd3de, 0x8fd3df, 0xbdaa, 0xb8be, 0xc1c8, 0xe5a5, 0xe5ab, 0x8fd3e0,
/* 08 */ 0x8fd3e1,    BAD,    BAD, 0xe5a6, 0xb7d0, 0x8fd3e2, 0xe5ae, 0xe5b2,
/* 10 */ 0xb7eb, 0x8fd3e3,    BAD, 0x8fd3e4,    BAD,    BAD, 0xe5ad, 0x8fd3e5,
/* 18 */    BAD, 0x8fd3e6, 0x8fd3e7, 0xe5b6, 0x8fd3e8, 0x8fd3e9, 0xb9ca,    BAD,
/* 20 */    BAD, 0xcded, 0xb0bc, 0xe5b3,    BAD, 0x8fd3ea, 0xb5eb, 0x8fd3eb,
/* 28 */ 0xe5b0,    BAD, 0x8fd3ec,    BAD,    BAD,    BAD, 0xe5b1,    BAD,
/* 30 */ 0x8fd3ed, 0xc5fd, 0xe5af, 0xe5ac,    BAD, 0xb3a8, 0xc0e4,    BAD,
/* 38 */ 0x8fd3ee, 0xb8a8, 0x8fd3ef, 0x8fd3f0,    BAD, 0xe5b8,    BAD, 0x8fd3f1
},

/* Row 0x8cb */
{
/* 00 */    BAD, 0x8fd3f2, 0x8fd3f3, 0x8fd3f4,    BAD, 0x8fd3f5, 0x8fd3f6,    BAD,
/* 08 */ 0x8fd3f7, 0xe5b5,    BAD, 0x8fd3f8, 0x8fd3f9, 0x8fd3fa,    BAD, 0xe5b7,
/* 10 */    BAD, 0x8fd3fb,    BAD, 0xe5b4,    BAD,    BAD, 0x8fd3fc, 0x8fd3fd,
/* 18 */    BAD, 0xb7d1, 0xc2b3, 0xe5b9, 0xc1ee, 0x8fd3fe, 0x8fd4a1, 0xe5c6,
/* 20 */    BAD,    BAD, 0xe5c2, 0xe5bc,    BAD,    BAD, 0x8fd4a2, 0x8fd4a3,
/* 28 */    BAD,    BAD, 0x8fd4a4, 0xe5c0, 0xbcfa, 0xb0dd, 0xe5bb, 0xe5c3,
/* 30 */ 0xe5c7, 0xb9cb, 0xccd6, 0x8fd4a5, 0xc4d6, 0xe5bd, 0x8fd4a6, 0x8fd4a7,
/* 38 */ 0xe5c5, 0x8fd4a8, 0xe5ba, 0xc3be,    BAD, 0xe5bf, 0xb0bd, 0xccca
},

/* Row 0x8cc */
{
/* 00 */    BAD,    BAD, 0x8fd4a9, 0x8fd4aa, 0x8fd4ab, 0x8fd4ac, 0x8fd4ad, 0xe5be,
/* 08 */    BAD,    BAD, 0xb6db, 0xc8ec, 0x8fd4ae, 0x8fd4af, 0x8fd4b0, 0xc1ed,
/* 10 */    BAD, 0xced0, 0xbdef,    BAD,    BAD, 0xe5ee,    BAD, 0x8fd4b1,
/* 18 */ 0xe5c8, 0x8fd4b2, 0xc0fe,    BAD, 0xe5c4, 0xe5c9, 0xe5cb,    BAD,
/* 20 */ 0xc4f9, 0xe5ce, 0x8fd4b4,    BAD, 0xe5ca, 0x8fd4b5, 0x8fd4b6,    BAD,
/* 28 */ 0xcad4, 0xb4cb, 0x8fd4b7, 0x8fd4b8, 0xcccb, 0x8fd4b9,    BAD, 0xb0de,
/* 30 */    BAD, 0x8fd4ba, 0xe5cd,    BAD, 0xcefd, 0x8fd4bb, 0x8fd4bc,    BAD,
/* 38 */    BAD, 0x8fd4bd, 0x8fd4be, 0xe5cc,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x8cd */
{
/* 00 */ 0x8fd4b3, 0xb1ef,    BAD,    BAD, 0xc6ec, 0xe5cf,    BAD,    BAD,
/* 08 */ 0x8fd4bf, 0xe5d6, 0xe5d0, 0xe5d7,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8fd4c0, 0x8fd4c1, 0xe5d3,    BAD,    BAD, 0x8fd4c2,    BAD, 0x8fd4c3,
/* 18 */    BAD,    BAD,    BAD, 0xc7fb, 0x8fd4c4, 0x8fd4c5, 0xbcca, 0xe5d5,
/* 20 */ 0x8fd4c6, 0xe5d2, 0xe5d8, 0xe5d1,    BAD,    BAD, 0xbdc4, 0x8fd4c7,
/* 28 */ 0x8fd4c8,    BAD,    BAD, 0xcba5, 0x8fd4c9, 0x8fd4ca, 0xbdcc, 0x8fd4cb,
/* 30 */    BAD, 0xe5d4, 0xe5e0, 0x8fd4cc,    BAD, 0xe5dc, 0x8fd4cd, 0xe5df,
/* 38 */    BAD, 0xe5dd, 0xe5e1, 0xe5db,    BAD, 0xe5c1, 0xc0d3, 0x8fd4ce
},

/* Row 0x8ce */
{
/* 00 */    BAD, 0xc8cb,    BAD, 0xe5de, 0x8fd4cf, 0x8fd4d0, 0xe5d9, 0x8fd4d1,
/* 08 */    BAD,    BAD, 0xc1a1, 0xb7d2,    BAD, 0xbdab, 0x8fd4d2,    BAD,
/* 10 */ 0x8fd4d3,    BAD, 0x8fd4d4,    BAD, 0xbfa5, 0xc1b6, 0xe5e4,    BAD,
/* 18 */ 0x8fd4d5, 0xe5e6, 0xe5e7,    BAD,    BAD, 0xe5e3, 0xe5e5, 0x8fd4d6,
/* 20 */    BAD, 0x8fd4d7, 0x8fd4d8,    BAD,    BAD, 0x8fd4d9, 0xe5da, 0xe5e2,
/* 28 */    BAD, 0xe5ea, 0xe5e9, 0x8fd4da,    BAD, 0xcbfa, 0x8fd4db, 0x8fd4dc,
/* 30 */ 0xb7ab,    BAD,    BAD, 0x8fd4dd,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8fd4de, 0xe5e8,    BAD, 0xe5ec, 0xe5eb, 0xe5ef, 0x8fd4df, 0xe5f1
},

/* Row 0x8cf */
{
/* 00 */    BAD, 0x8fd4e0, 0xbbbc, 0xe5ed,    BAD,    BAD, 0x8fd4e1, 0x8fd4e2,
/* 08 */ 0xe5f2, 0xe5f3, 0x8fd4e3,    BAD, 0xe5f4, 0x8fd4e4, 0xe5fa, 0xc5bb,
/* 10 */ 0xe5f6, 0x8fd4e5, 0xe5f5, 0xe5f7, 0xe5f8, 0x8fd4e6, 0xe5f9,    BAD,
/* 18 */ 0x8fd4e7,    BAD, 0x8fd4e8, 0xe5fb, 0xe5fc, 0x8fd4e9, 0x8fd4ea,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x8d0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb4cc,    BAD,
/* 38 */ 0xe5fd,    BAD, 0xe5fe, 0x8fd4ec, 0x8fd4eb, 0x8fd4ed, 0x8fd4ee, 0x8fd4ef
},

/* Row 0x8d1 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fd4f0, 0x8fd4f1, 0xe6a1,    BAD, 0x8fd4f2,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xe6a2, 0xe6a3, 0xe6a4, 0x8fd4f3,
/* 10 */ 0xe6a5, 0xe6a6, 0x8fd4f4, 0x8fd4f5, 0xe6a8, 0xe6a7,    BAD,    BAD,
/* 18 */ 0xe6a9,    BAD,    BAD, 0x8fd4f6, 0x8fd4f7, 0x8fd4f8,    BAD, 0xe6aa,
/* 20 */ 0xe6ab, 0x8fd4f9,    BAD, 0x8fd4fa, 0x8fd4fb, 0x8fd4fc, 0x8fd4fd, 0xe6ae,
/* 28 */ 0xe6ac, 0xe6ad, 0xbae1, 0xb7d3,    BAD, 0x8fd4fe, 0xc3d6,    BAD,
/* 30 */ 0xc8b3, 0x8fd5a1, 0xbdf0,    BAD,    BAD, 0xc7cd,    BAD, 0xc8ed,
/* 38 */ 0xe6af, 0xd8ed,    BAD,    BAD,    BAD, 0x8fd5a2, 0x8fd5a3, 0x8fd5a4
},

/* Row 0x8d2 */
{
/* 00 */ 0x8fd5a5,    BAD, 0xe6b0, 0xe6b2,    BAD, 0xcde5, 0xe6b1, 0xe6b4,
/* 08 */ 0xe6b3,    BAD, 0xcdd3, 0x8fd5a6, 0xe6b5, 0x8fd5a7, 0xc8fe, 0x8fd5a8,
/* 10 */ 0x8fd5a9, 0x8fd5aa,    BAD,    BAD, 0xe6b6,    BAD, 0x8fd5ab, 0x8fd5ac,
/* 18 */    BAD,    BAD, 0xe6b9,    BAD, 0x8fd5ad, 0xe6b8, 0xe6b7,    BAD,
/* 20 */    BAD, 0x8fd5ae, 0x8fd5af, 0xe6ba, 0xb7b2,    BAD, 0x8fd5b0,    BAD,
/* 28 */ 0xc1a2, 0xb5c1, 0x8fd5b1,    BAD,    BAD, 0x8fd5b2, 0xe6be, 0xe6bb,
/* 30 */    BAD,    BAD, 0xe6bc,    BAD, 0x8fd5b3,    BAD, 0xe6bf,    BAD,
/* 38 */ 0xe6c0, 0xe6bd,    BAD,    BAD, 0x8fd5b4, 0xb1a9,    BAD, 0x8fd5b5
},

/* Row 0x8d3 */
{
/* 00 */ 0x8fd5b6, 0xb2a7,    BAD, 0x8fd5b7,    BAD, 0xe6c2, 0xe6c3,    BAD,
/* 08 */ 0x8fd5b8,    BAD, 0xe6c4,    BAD, 0xcde2,    BAD, 0x8fd5b9, 0x8fd5ba,
/* 10 */    BAD,    BAD, 0xbdac,    BAD, 0xe6c6, 0xe6c5,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8fd5bb,    BAD,    BAD,    BAD, 0x8fd5bc,
/* 20 */ 0xbfe9, 0xe6c7,    BAD, 0x8fd5bd,    BAD, 0x8fd5be, 0xe6c8,    BAD,
/* 28 */ 0x8fd5bf, 0xe6c9,    BAD, 0xb4e5, 0x8fd5c0,    BAD, 0x8fd5c1, 0x8fd5c2,
/* 30 */ 0xb4cd,    BAD, 0x8fd5c3, 0xe6ca,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xe6cb, 0x8fd5c4, 0xcbdd, 0xcde3, 0x8fd5c5, 0x8fd5c6, 0x8fd5c7
},

/* Row 0x8d4 */
{
/* 00 */ 0xcdd4, 0xcfb7,    BAD, 0xb9cd, 0xe6ce, 0xbcd4, 0xe6cd, 0x8fd5c8,
/* 08 */ 0x8fd5c9,    BAD, 0x8fd5ca, 0xe6cf, 0xbca9, 0x8fd5cb, 0x8fd5cc, 0x8fd5cd,
/* 10 */ 0xc2d1, 0x8fd5ce, 0xe6d0, 0x8fd5cf, 0x8fd5d0, 0xb9cc, 0x8fd5d1, 0xccd7,
/* 18 */ 0xe6d1, 0xe6d2,    BAD,    BAD, 0xe6d3, 0x8fd5d2, 0x8fd5d3, 0x8fd5d4,
/* 20 */ 0x8fd5d5, 0xe6d4,    BAD,    BAD, 0x8fd5d6,    BAD, 0x8fd5d7,    BAD,
/* 28 */ 0xe6d5,    BAD,    BAD,    BAD, 0x8fd5d8,    BAD, 0x8fd5d9,    BAD,
/* 30 */ 0x8fd5da,    BAD,    BAD, 0xbcaa, 0x8fd5db, 0x8fd5dc, 0xcced, 0x8fd5dd,
/* 38 */    BAD, 0x8fd5de, 0x8fd5df, 0xe6d7, 0x8fd5e0, 0xc3bf, 0x8fd5e1, 0xe6d6
},

/* Row 0x8d5 */
{
/* 00 */ 0x8fd5e2,    BAD,    BAD,    BAD, 0x8fd5e3,    BAD, 0xe6d9,    BAD,
/* 08 */    BAD,    BAD, 0xe6d8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe6da,    BAD,    BAD,    BAD, 0xc0bb,    BAD,
/* 18 */ 0xe6db,    BAD, 0xe6dc,    BAD,    BAD,    BAD, 0xcab9, 0xe6dd,
/* 20 */ 0x8fd5e4, 0xc1ef, 0xe6de,    BAD, 0x8fd5e5,    BAD, 0x8fd5e6,    BAD,
/* 28 */ 0xe6df,    BAD,    BAD,    BAD,    BAD, 0x8fd5e7,    BAD, 0xcefe,
/* 30 */ 0xe6e2, 0x8fd5e8, 0xe6e1, 0xe6e0, 0xc4b0, 0x8fd5e9, 0xe6e3, 0xbfa6,
/* 38 */    BAD, 0xe6e4,    BAD,    BAD,    BAD, 0xe6e5, 0xcfb8, 0xe6e6
},

/* Row 0x8d6 */
{
/* 00 */    BAD, 0x8fd5ea,    BAD,    BAD, 0xe6e7, 0xe6e9, 0xe6e8, 0xc8a5,
/* 08 */ 0x8fd5eb, 0xc6f9,    BAD, 0xcfbe, 0xc8a9,    BAD, 0x8fd5ec,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xe6eb,    BAD,    BAD, 0xbed3,    BAD,
/* 18 */ 0xc9aa,    BAD, 0xe6ec, 0xe6ea, 0x8fd5ed, 0xb4ce, 0x8fd5ee,    BAD,
/* 20 */    BAD, 0xb8d4, 0xbbe8,    BAD,    BAD, 0xc8ee, 0x8fd5ef, 0x8fd5f0,
/* 28 */    BAD, 0xb8aa, 0xcbc3, 0x8fd5f1, 0xe6ef, 0xe6ed,    BAD, 0xb9ce,
/* 30 */    BAD, 0xb9cf, 0xb0e9,    BAD, 0xbae8,    BAD,    BAD,    BAD,
/* 38 */ 0x8fd5f2, 0x8fd5f3, 0xc7d9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x8d7 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb0df, 0xe6f4,    BAD, 0xc3c0,    BAD,
/* 08 */ 0x8fd5f4,    BAD,    BAD,    BAD, 0xc7d8, 0x8fd5f5, 0xc2db, 0x8fd5f6,
/* 10 */    BAD,    BAD, 0x8fd5f7,    BAD, 0x8fd5f8, 0x8fd5f9, 0xe6f6, 0x8fd5fa,
/* 18 */ 0x8fd5fb, 0xe6f2, 0xe6f5, 0xe6f0,    BAD, 0xe6f3, 0xcba6,    BAD,
/* 20 */ 0x8fd5fc, 0xb8d5,    BAD,    BAD, 0xb0fd, 0xe6f1,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fd5fd, 0x8fd5fe, 0xe6f8,
/* 30 */ 0x8fd6a1, 0xe6f9, 0x8fd6a2, 0x8fd6a3, 0xc6b9,    BAD, 0x8fd6a4,    BAD,
/* 38 */ 0xb6bb, 0x8fd6a5, 0x8fd6a6,    BAD, 0xe7a6, 0xc7bd, 0x8fd6a7,    BAD
},

/* Row 0x8d8 */
{
/* 00 */    BAD,    BAD, 0xbbe9, 0x8fd6a8,    BAD, 0xb6bc, 0xc0c8, 0xcfc6,
/* 08 */ 0xccae, 0xe6f7, 0xc0d4, 0x8fd6a9,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fd6aa, 0x8fd6ab,
/* 18 */ 0x8fd6ac,    BAD, 0xb5d3, 0xe6fa, 0x8fd6ad,    BAD, 0x8fd6ae,    BAD,
/* 20 */ 0x8fd6af,    BAD,    BAD, 0xe6fc, 0x8fd6b0,    BAD,    BAD, 0x8fd6b1,
/* 28 */    BAD, 0xe6fb,    BAD,    BAD, 0x8fd6b2,    BAD,    BAD, 0xe6fd,
/* 30 */ 0x8fd6b3, 0xc3a6,    BAD, 0xc7be,    BAD, 0x8fd6b4,    BAD,    BAD,
/* 38 */    BAD, 0xc4b1, 0x8fd6b5,    BAD, 0x8fd6b6,    BAD, 0xe7a3,    BAD
},

/* Row 0x8d9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fd6b7, 0xe7a2, 0x8fd6b8,
/* 08 */    BAD,    BAD, 0x8fd6b9, 0xe6fe, 0x8fd6ba,    BAD, 0xbfd5,    BAD,
/* 10 */ 0xc9e5, 0xe7a5, 0x8fd6bb, 0xe7a4, 0xb9d0, 0xcfd3,    BAD, 0x8fd6bc,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe7b5,
/* 20 */ 0x8fd6bd, 0x8fd6be,    BAD,    BAD,    BAD, 0xe7a9, 0xe7aa, 0x8fd6bf,
/* 28 */ 0x8fd6c0, 0x8fd6c1,    BAD, 0xbcf0,    BAD, 0x8fd6c2, 0xe7a8, 0x8fd6c3,
/* 30 */ 0xb9f8, 0xe7a7,    BAD,    BAD, 0xe7ab,    BAD,    BAD, 0x8fd6c4,
/* 38 */ 0xc4b2, 0xcaa2, 0xc1a3,    BAD,    BAD,    BAD,    BAD, 0xc2dc
},

/* Row 0x8da */
{
/* 00 */ 0xe7af, 0x8fd6c5, 0xe7b0, 0xe7ac, 0x8fd6c7, 0x8fd6c8, 0x8fd6c9,    BAD,
/* 08 */ 0xe7ad,    BAD, 0xe7ae, 0x8fd6ca,    BAD,    BAD, 0x8fd6cb, 0xb9d1,
/* 10 */ 0x8fd6c6,    BAD,    BAD, 0xe7b6,    BAD, 0xe7b2, 0x8fd6cc,    BAD,
/* 18 */ 0x8fd6cd,    BAD, 0xc9e6, 0x8fd6ce, 0xcbec, 0xc9a8, 0x8fd6cf,    BAD,
/* 20 */ 0xe7b1,    BAD, 0x8fd6d0, 0xe7b4, 0xe7b3,    BAD,    BAD,    BAD,
/* 28 */ 0xcbc4, 0xe7b7,    BAD,    BAD,    BAD,    BAD, 0x8fd6d1,    BAD,
/* 30 */ 0xe7b8,    BAD, 0x8fd6d2, 0xc1b7, 0x8fd6d3, 0xe7b9,    BAD,    BAD,
/* 38 */ 0xe7bb,    BAD, 0xe7bf, 0x8fd6d4,    BAD, 0xe7bc, 0xe7ba, 0xc7bf
},

/* Row 0x8db */
{
/* 00 */ 0xe7bd,    BAD, 0xe7be, 0x8fd6d6,    BAD, 0x8fd6d7, 0xb2b2,    BAD,
/* 08 */ 0xe7c5, 0xe7c0, 0x8fd6d8, 0x8fd6d5,    BAD, 0xe7c1, 0x8fd6d9, 0x8fd6da,
/* 10 */    BAD, 0xe7c2,    BAD, 0xc2a1,    BAD, 0x8fd6db,    BAD, 0x8fd6dc,
/* 18 */ 0xe7c4, 0xe7c3, 0xe7c6, 0x8fd6dd,    BAD, 0x8fd6de, 0x8fd6df, 0xe7c7,
/* 20 */ 0xe7c8, 0x8fd6e0,    BAD, 0xbfc3, 0x8fd6e1, 0xb2e9,    BAD, 0xe7c9,
/* 28 */ 0xced7,    BAD, 0xbcab, 0x8fd6e2, 0x8fd6e3, 0xbdad,    BAD,    BAD,
/* 30 */ 0x8fd6e4, 0x8fd6e5, 0x8fd6e6, 0xbbea, 0xc3d7, 0x8fd6e7, 0x8fd6e8,    BAD,
/* 38 */ 0x8fd6e9, 0x8fd6ea, 0xe7ca, 0xe7cb, 0xb1b1, 0x8fd6eb, 0xe7cc, 0x8fd6ec
},

/* Row 0x8dc */
{
/* 00 */ 0x8fd6ed, 0xe7cd, 0xe7ce, 0x8fd6ee,    BAD, 0xe7cf,    BAD, 0xe7d0,
/* 08 */ 0xb6bd, 0xdaaa, 0xe7d1,    BAD, 0xc0e5, 0xe7d2, 0xbccb, 0x8fd6ef,
/* 10 */ 0xe7d3,    BAD, 0xd0b0, 0x8fd6f0, 0x8fd6f1,    BAD, 0xe7d4, 0xcade,
/* 18 */ 0xb4dc, 0x8fd6f2, 0x8fd6f3, 0xc1a4, 0xbdd8, 0x8fd6f4, 0xc9f1, 0xbdae,
/* 20 */    BAD, 0x8fd6f5, 0x8fd6f6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8fd6f7, 0xe7d5, 0xb9d2, 0xe7d6, 0xc8cc,    BAD, 0xe7e4,    BAD,
/* 30 */    BAD,    BAD, 0x8fd6f8, 0xe7d8, 0x8fd6f9, 0xc2c9, 0xc7f5, 0xb8bf,
/* 38 */ 0xe7d7, 0xc1a5, 0x8fd6fa,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x8dd */
{
/* 00 */ 0xe7d9,    BAD,    BAD, 0x8fd6fb, 0x8fd6fc, 0x8fd6fd, 0x8fd6fe, 0xc4fa,
/* 08 */    BAD,    BAD,    BAD, 0x8fd7a1,    BAD,    BAD, 0x8fd7a2, 0x8fd7a3,
/* 10 */    BAD, 0x8fd7a4,    BAD,    BAD,    BAD,    BAD, 0x8fd7a5,    BAD,
/* 18 */ 0xe7db, 0xe7da, 0xe7dd,    BAD, 0x8fd7a6, 0xe7dc,    BAD, 0xe7de,
/* 20 */ 0x8fd7a7,    BAD, 0xe7e0, 0x8fd7a8, 0xe7df,    BAD, 0xb4cf, 0x8fd7a9,
/* 28 */ 0xe7e1,    BAD, 0xe7e2, 0xe7e3,    BAD, 0x8fd7aa, 0xbab1, 0xcec9,
/* 30 */    BAD, 0xe7e5, 0xbfa7,    BAD, 0x8fd7ab,    BAD, 0xb1f0, 0xe7e6,
/* 38 */ 0xe7e7,    BAD,    BAD, 0x8fd7ac,    BAD, 0x8fd7ad, 0xe7e8, 0x8fd7ae
},

/* Row 0x8de */
{
/* 00 */ 0x8fd7af, 0x8fd7b0,    BAD, 0x8fd7b1, 0x8fd7b2,    BAD,    BAD, 0x8fd7b3,
/* 08 */    BAD, 0x8fd7b4, 0x8fd7b5, 0xb0f2,    BAD, 0xe7e9, 0x8fd7b6,    BAD,
/* 10 */    BAD, 0x8fd7b7, 0xe7ea,    BAD, 0x8fd7b8,    BAD, 0x8fd7b9,    BAD,
/* 18 */ 0x8fd7ba, 0xc9e7, 0x8fd7bb, 0x8fd7bc,    BAD, 0xbcc7,    BAD, 0xe7ec,
/* 20 */ 0x8fd7bd, 0x8fd7be,    BAD, 0x8fd7bf, 0x8fd7c0, 0xb3a9, 0xb0b2, 0x8fd7c1,
/* 28 */ 0x8fd7c2, 0x8fd7c3, 0x8fd7c4, 0xe7eb, 0xe7ee, 0xc7ce, 0x8fd7c5, 0xbfc4,
/* 30 */ 0x8fd7c6, 0xb2d6, 0x8fd7c7, 0xcba7, 0x8fd7c8,    BAD,    BAD, 0x8fd7c9,
/* 38 */ 0xb7dd, 0xb6dc, 0x8fd7ca, 0xe7ed, 0x8fd7cb, 0xb2ea, 0x8fd7cc, 0x8fd7cd
},

/* Row 0x8df */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb4a3, 0x8fd7ce,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8fd7cf, 0xb1f1, 0xe7f2, 0xceea, 0xc2dd, 0x8fd7d0,    BAD, 0xc9c4,
/* 18 */    BAD, 0xe7fe, 0x8fd7d1, 0xb2d7, 0xe7fc,    BAD, 0xe7fa, 0xe7f1,
/* 20 */ 0x8fd7d2, 0xe7ef, 0x8fd7d3, 0xe7f0, 0x8fd7d4, 0xbce3, 0xb6ec, 0xc3f7,
/* 28 */ 0x8fd7d5,    BAD, 0x8fd7d6, 0xc6d1,    BAD, 0x8fd7d7,    BAD, 0x8fd7d8,
/* 30 */    BAD, 0xb1d1,    BAD, 0xe7f4, 0xe7f3,    BAD, 0x8fd7d9, 0x8fd7da,
/* 38 */    BAD, 0xe7f9, 0xe7f5, 0xe7f8,    BAD, 0x8fd7db, 0x8fd7dc,    BAD
},

/* Row 0x8e0 */
{
/* 00 */ 0x8fd7dd, 0x8fd7de, 0xccd0, 0xe7f7, 0xb2d8, 0xb3fd, 0xe7fb, 0x8fd7df,
/* 08 */ 0x8fd7e0, 0xe7fd, 0x8fd7e1, 0x8fd7e2,    BAD,    BAD, 0xb7d4,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8a3, 0xe8ac,
/* 18 */ 0xe8ad,    BAD,    BAD, 0x8fd7e4, 0xb0ab, 0x8fd7e5, 0x8fd7e6, 0x8fd7e7,
/* 20 */    BAD, 0x8fd7e8, 0x8fd7e9, 0xe8b4,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb0f1,    BAD,    BAD, 0xe8ab, 0x8fd7ea, 0x8fd7eb, 0x8fd7ec, 0xe8aa,
/* 30 */ 0x8fd7ed, 0xe8a5, 0xe8a4, 0x8fd7ee, 0xe8a2, 0xe8a1, 0xc3e3, 0x8fd7ef,
/* 38 */ 0xc2fb, 0xe8a7, 0x8fd7f0,    BAD, 0x8fd7f1, 0x8fd7f2,    BAD,    BAD
},

/* Row 0x8e1 */
{
/* 00 */ 0xe8a6,    BAD, 0x8fd7f3, 0x8fd7f4, 0x8fd7f5, 0xe8a9,    BAD, 0x8fd7f6,
/* 08 */    BAD, 0xc1f0, 0xb7d5,    BAD,    BAD, 0x8fd7f7, 0x8fd7f8, 0xb1c1,
/* 10 */ 0xe8a8, 0x8fd7f9, 0xb9d3, 0x8fd8be, 0x8fd7e3, 0x8fd7fa, 0x8fd7fb, 0x8fd7fc,
/* 18 */ 0xc1f1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8fd7fd,    BAD,    BAD, 0xe8ba,    BAD, 0xe8bb,    BAD, 0xb2d9,
/* 38 */ 0x8fd7fe,    BAD,    BAD, 0xb2ae, 0xe8b8, 0x8fd8a1,    BAD, 0x8fd8a2
},

/* Row 0x8e2 */
{
/* 00 */ 0x8fd8a3,    BAD, 0x8fd8a4,    BAD, 0x8fd8a5, 0xe8ae, 0x8fd8a6, 0xe8b6,
/* 08 */    BAD, 0xe8bd, 0xe8b7,    BAD,    BAD, 0x8fd8a7, 0xe8b5,    BAD,
/* 10 */    BAD,    BAD, 0x8fd8a8, 0xe7f6, 0x8fd8a9, 0x8fd8aa, 0xe8b3,    BAD,
/* 18 */ 0x8fd8ab, 0x8fd8ac, 0xe8af, 0x8fd8ad, 0x8fd8ae, 0x8fd8af, 0xb4d0, 0xe8b1,
/* 20 */ 0xe8bc,    BAD, 0xe8b2,    BAD,    BAD,    BAD, 0x8fd8b0, 0x8fd8b1,
/* 28 */ 0xe8be, 0x8fd8b2, 0xe8b0, 0xc7fc, 0x8fd8b3, 0x8fd8cc,    BAD,    BAD,
/* 30 */    BAD, 0xcde9,    BAD,    BAD,    BAD, 0xe8b9,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe8cf, 0x8fd8b4, 0x8fd8b5
},

/* Row 0x8e3 */
{
/* 00 */ 0x8fd8b6, 0xe8c7,    BAD,    BAD,    BAD, 0xbffb,    BAD, 0x8fd8b7,
/* 08 */    BAD, 0x8fd8b8, 0xb5c6,    BAD, 0xb6dd,    BAD, 0xe8c2, 0x8fd8b9,
/* 10 */ 0x8fd8ba, 0x8fd8bb,    BAD, 0xb2db, 0x8fd8bc,    BAD, 0xbed4,    BAD,
/* 18 */ 0xe8c5,    BAD,    BAD,    BAD, 0xbada, 0x8fd8bd,    BAD, 0xc5d1,
/* 20 */ 0xe8ca,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8fd8bf, 0xcaee, 0x8fd8c0, 0xe8c1,    BAD,    BAD,    BAD, 0xb2da,
/* 30 */ 0xb8d6, 0xc9a9, 0xe8cb,    BAD, 0xe8bf,    BAD, 0x8fd8c1, 0xe8c8,
/* 38 */ 0x8fd8c2, 0x8fd8c3,    BAD, 0xe8d2, 0x8fd8c4, 0xe8c3,    BAD,    BAD
},

/* Row 0x8e4 */
{
/* 00 */    BAD, 0x8fd8c5,    BAD, 0xe8c4, 0xc6ba,    BAD, 0x8fd8c6, 0xe8c9,
/* 08 */    BAD,    BAD, 0x8fd8c7, 0xe8c6, 0xcba8, 0xe8cc, 0xb0e0, 0x8fd8c8,
/* 10 */    BAD, 0x8fd8c9,    BAD, 0xe8c0,    BAD, 0x8fd8ca,    BAD,    BAD,
/* 18 */    BAD, 0x8fd8cb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xe8ce,    BAD, 0xe8cd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xc7eb, 0xe8d4,    BAD, 0xe8df,    BAD,    BAD, 0x8fd8cd,
/* 30 */    BAD, 0xb3fe,    BAD,    BAD,    BAD, 0xe8e2,    BAD,    BAD,
/* 38 */ 0xe8d0, 0x8fd8ce,    BAD,    BAD, 0xe8d5, 0xcdee,    BAD,    BAD
},

/* Row 0x8e5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fd8cf, 0xe8de, 0x8fd8d0,
/* 08 */ 0x8fd8d1, 0xcdd5, 0x8fd8d2,    BAD,    BAD, 0x8fd8d3, 0xceaa, 0x8fd8d4,
/* 10 */    BAD, 0x8fd8d5, 0x8fd8d6,    BAD,    BAD,    BAD, 0x8fd8d7, 0xc3f8,
/* 18 */ 0x8fd8d8, 0x8fd8d9, 0x8fd8da, 0xb3eb, 0x8fd8db,    BAD,    BAD,    BAD,
/* 20 */ 0x8fd8dc, 0xc9f2, 0xe8e4, 0xc6a1, 0x8fd8dd, 0x8fd8de, 0xb0b1, 0x8fd8df,
/* 28 */    BAD, 0xe8dd, 0x8fd8e0, 0xe8d9, 0xc1f2, 0xe8d3, 0xe8db, 0xe8e0,
/* 30 */ 0x8fd8e1, 0xc7ac,    BAD, 0x8fd8e2, 0x8fd8e3, 0xb0aa, 0x8fd8e4, 0xe8d8,
/* 38 */ 0x8fd8e5, 0xe8e1, 0xc9f8,    BAD, 0x8fd8e6, 0x8fd8e7,    BAD,    BAD
},

/* Row 0x8e6 */
{
/* 00 */    BAD, 0x8fd8e8, 0xe8dc,    BAD, 0xe8d7, 0x8fd8e9,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xbed5,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xbdaf,    BAD, 0x8fd8ea, 0x8fd8eb, 0xbcac, 0x8fd8ec,    BAD,    BAD,
/* 18 */    BAD, 0xccd8,    BAD,    BAD, 0xc9c7,    BAD, 0x8fd8ed, 0xe8e7,
/* 20 */    BAD, 0xe8f0,    BAD,    BAD,    BAD,    BAD, 0x8fd8ee,    BAD,
/* 28 */ 0x8fd8ef, 0x8fd8f0, 0x8fd8f1,    BAD,    BAD, 0xe8da,    BAD, 0x8fd8f2,
/* 30 */    BAD, 0x8fd8f3, 0xb3f7,    BAD, 0x8fd8f4,    BAD,    BAD,    BAD,
/* 38 */ 0xbef8, 0xe8e5, 0x8fd8f5, 0xe8ea, 0xc1f3, 0x8fd8f6, 0x8fd8f7, 0xe8e6
},

/* Row 0x8e7 */
{
/* 00 */ 0x8fd8f8, 0xe8ed, 0x8fd8f9,    BAD, 0xc3df,    BAD, 0xe8ee, 0x8fd8fa,
/* 08 */ 0x8fd8fb, 0xcdd6, 0xe8e3, 0xb3b8, 0x8fd8fc, 0xe8e9,    BAD, 0x8fd8fd,
/* 10 */ 0xe8ec, 0xccac,    BAD, 0x8fd8fe,    BAD,    BAD, 0xe8ef,    BAD,
/* 18 */    BAD, 0xe8e8, 0xe8eb,    BAD, 0x8fd9a1,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fd9a2,
/* 28 */    BAD,    BAD, 0x8fd9a3,    BAD, 0xcba9,    BAD, 0xcfa1, 0x8fd9a4,
/* 30 */ 0x8fd9a5, 0x8fd9a6, 0x8fd9a7,    BAD, 0xe8f3,    BAD,    BAD, 0x8fd9a8,
/* 38 */    BAD,    BAD, 0x8fd9aa, 0x8fd9ab, 0xe8fa, 0x8fd9ac,    BAD, 0xe8f2
},

/* Row 0x8e8 */
{
/* 00 */ 0xbcc3,    BAD, 0x8fd9ad, 0x8fd9ae,    BAD,    BAD, 0xe8d1, 0x8fd9af,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x8fd9b0,    BAD, 0x8fd9b1,    BAD,
/* 10 */ 0x8fd9b2, 0xcace,    BAD, 0xcca2, 0xe8f9, 0xe8f8,    BAD, 0xe8f4,
/* 18 */ 0xe8f5,    BAD, 0xb1b6,    BAD, 0x8fd9b3,    BAD, 0x8fd9b4, 0xe8f7,
/* 20 */    BAD, 0xe8f1, 0x8fd9b5, 0x8fd9b6, 0x8fd9b7, 0x8fd9b8, 0xc4d5, 0x8fd9b9,
/* 28 */    BAD,    BAD, 0x8fd9ba, 0x8fd9bb, 0xe8f6, 0xb0fe,    BAD, 0x8fd9bc,
/* 30 */    BAD,    BAD, 0x8fd9a9, 0x8fd9bd, 0x8fd9be, 0xc2a2, 0x8fd9bf,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcac3,    BAD, 0x8fd9c0
},

/* Row 0x8e9 */
{
/* 00 */ 0xe8fb, 0xe9a1,    BAD, 0xc8d9,    BAD,    BAD, 0x8fd9c1,    BAD,
/* 08 */ 0xe8fe, 0xbed6, 0xbcc9, 0xe9a3,    BAD,    BAD, 0xb6be, 0x8fd9c2,
/* 10 */ 0x8fd9c3, 0x8fd9c4, 0x8fd9c5, 0x8fd9c6,    BAD, 0xe9a4, 0x8fd9c7, 0xc9f9,
/* 18 */ 0xe8fd, 0x8fd9c8, 0xe8d6,    BAD, 0x8fd9c9, 0x8fd9ca, 0x8fd9cb, 0x8fd9cc,
/* 20 */ 0x8fd9cd, 0x8fd9ce, 0x8fd9cf, 0xe8fc, 0x8fd9d0,    BAD,    BAD,    BAD,
/* 28 */ 0xcfcf, 0xc6a2, 0xc9f3, 0x8fd9d1,    BAD, 0xe9ab,    BAD, 0x8fd9d2,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9b1,
/* 38 */    BAD, 0x8fd9d3, 0x8fd9d4, 0x8fd9d5,    BAD, 0x8fd9d6, 0xe9b2, 0x8fd9d7
},

/* Row 0x8ea */
{
/* 00 */ 0xe9a5, 0x8fd9d8,    BAD,    BAD, 0xc7f6, 0x8fd9d9, 0x8fd9da, 0xe9af,
/* 08 */ 0xe9a7, 0x8fd9db, 0xe9a9, 0x8fd9dc, 0x8fd9dd,    BAD,    BAD, 0x8fd9de,
/* 10 */ 0xe9b3, 0xe9a8,    BAD, 0x8fd9df, 0xe9ac,    BAD,    BAD, 0xb1f2,
/* 18 */ 0x8fd9e0, 0xc6e5,    BAD, 0xe9ad, 0xe9b0, 0x8fd9e1,    BAD, 0x8fd9e2,
/* 20 */ 0x8fd9e3,    BAD, 0x8fd9e4,    BAD, 0xe9a6, 0x8fd9e5, 0xc1a6, 0x8fd9e6,
/* 28 */ 0xe9aa, 0xbba7, 0xbfc5, 0xb7b0, 0xccf4, 0x8fd9f4, 0xccf9, 0xbdf2,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8fd9e7,    BAD, 0x8fd9e8, 0x8fd9e9,
/* 38 */ 0x8fd9ea, 0xe9b7, 0xe9b5,    BAD, 0x8fd9eb, 0x8fd9ec, 0x8fd9ed, 0x8fd9ee
},

/* Row 0x8eb */
{
/* 00 */    BAD, 0xcfce, 0x8fd9ef,    BAD,    BAD,    BAD,    BAD, 0x8fd9f0,
/* 08 */    BAD, 0xe9b4, 0x8fd9f1, 0x8fd9f2,    BAD, 0xcdf5, 0x8fd9f3, 0xe9b6,
/* 10 */ 0xe9b8,    BAD,    BAD,    BAD,    BAD, 0xe9b9,    BAD,    BAD,
/* 18 */ 0x8fd9f5,    BAD, 0x8fd9f6,    BAD, 0xe9bc, 0xe9ba,    BAD, 0x8fd9f7,
/* 20 */ 0x8fd9f8,    BAD,    BAD,    BAD, 0xc6a3, 0xe9bb, 0x8fd9f9,    BAD,
/* 28 */ 0x8fd9fa, 0xc8cd, 0xe9ae,    BAD,    BAD, 0x8fd9fb,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x8fd9fc,    BAD,    BAD, 0x8fd9fd, 0xbdf3,
/* 38 */    BAD, 0xe9bd, 0xe9c2, 0xc1f4, 0x8fd9fe,    BAD, 0xe9c1, 0x8fdaa1
},

/* Row 0x8ec */
{
/* 00 */ 0x8fdaa2,    BAD, 0xe9a2,    BAD, 0x8fdaa3, 0x8fdaa4, 0xe9c3, 0xc1c9,
/* 08 */    BAD,    BAD, 0xe9be, 0xe9c0,    BAD, 0x8fdaa5, 0x8fdaa6,    BAD,
/* 10 */ 0x8fdaa7, 0x8fdaa8, 0x8fdaa9, 0xe9bf,    BAD,    BAD, 0xddb1, 0xdda2,
/* 18 */ 0x8fdaaa, 0x8fdaab, 0xe9c5, 0x8fdaac,    BAD,    BAD, 0x8fdaad,    BAD,
/* 20 */    BAD, 0x8fdaae, 0xe9c4,    BAD,    BAD,    BAD,    BAD, 0x8fdaaf,
/* 28 */    BAD, 0x8fdab0,    BAD,    BAD,    BAD, 0xcdf6,    BAD, 0xe2bc,
/* 30 */ 0xe9c6,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fdab1,    BAD,
/* 38 */ 0x8fdab2,    BAD, 0x8fdab3,    BAD, 0x8fdab4, 0x8fdab5,    BAD, 0xe9c7
},

/* Row 0x8ed */
{
/* 00 */ 0x8fdab6, 0x8fb8e6, 0x8fdab7,    BAD,    BAD,    BAD, 0x8fdab8,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9c8, 0xb8d7,    BAD,
/* 10 */ 0xb5d4,    BAD, 0x8fdab9, 0x8fdaba, 0xe9ca, 0xd1dd, 0x8fdabb, 0x8fdabc,
/* 18 */ 0x8fdabd, 0x8fdabe, 0xb5f5,    BAD, 0xceba, 0x8fdabf, 0xb6f3, 0xe9cb,
/* 20 */ 0x8fdac0, 0x8fdac1, 0x8fdac2, 0x8fdac3, 0x8fdac4,    BAD,    BAD, 0xe9cc,
/* 28 */    BAD, 0x8fdac5,    BAD, 0xc3ee, 0x8fdac6,    BAD,    BAD, 0x8fdac7,
/* 30 */    BAD, 0xe9cd,    BAD,    BAD,    BAD, 0x8fdac8, 0x8fdac9, 0x8fdaca,
/* 38 */    BAD, 0xc6fa, 0x8fdacb, 0xb0ba,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x8ee */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8fdaed,    BAD, 0xb2e3, 0xe9d2, 0xe9d3, 0x8fdacc,    BAD,    BAD,
/* 10 */    BAD, 0x8fdacd,    BAD, 0xe9ce,    BAD, 0xbbbd, 0x8fdace,    BAD,
/* 18 */ 0x8fdacf,    BAD, 0x8fdad0,    BAD, 0x8fdad1,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8fdad2,    BAD, 0xe9cf, 0xc7c2,    BAD, 0x8fdad3, 0x8fdad4,
/* 28 */ 0x8fdad5, 0xe9d0, 0xe9d1, 0xe9db,    BAD, 0x8fdad6,    BAD, 0xe9d5,
/* 30 */ 0xe9d8, 0x8fdad7,    BAD, 0x8fdad8, 0x8fdad9, 0x8fdada, 0xe9d4, 0x8fdadb,
/* 38 */ 0x8fdadc, 0x8fdadd,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fdade
},

/* Row 0x8ef */
{
/* 00 */ 0x8fdadf, 0x8fdae0,    BAD, 0x8fdae1, 0xe9d6, 0x8fdae2, 0xe9d7, 0xbcd8,
/* 08 */    BAD, 0xe9d9,    BAD, 0xc3c1,    BAD, 0xb7d6, 0xb3c2,    BAD,
/* 10 */    BAD, 0x8fdae3, 0x8fdae4,    BAD, 0xe9dc, 0x8fdae5,    BAD, 0x8fdae6,
/* 18 */    BAD, 0xb3bf, 0x8fdae7, 0xe9e1, 0x8fdae8,    BAD, 0xe9dd, 0xe9e0,
/* 20 */ 0x8fdae9,    BAD,    BAD, 0x8fdaea, 0xc8ba, 0x8fdaeb,    BAD, 0x8fdaec,
/* 28 */    BAD, 0xe9de,    BAD,    BAD, 0xe9df, 0xc9c8, 0xc8da, 0xe9e2,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xc2fd, 0xe9ec, 0x8fdaee, 0xe9e8, 0x8fdaef, 0x8fdaf0, 0xb2eb,    BAD
},

/* Row 0x8f0 */
{
/* 00 */ 0xe9e6,    BAD, 0xcbaa, 0xe9e7, 0x8fdaf1, 0x8fdaf2, 0xe9e4, 0x8fdaf3,
/* 08 */ 0xe9e5, 0xe9ea, 0xe9ed, 0x8fdaf4,    BAD, 0xe9eb, 0x8fdaf5, 0x8fdaf6,
/* 10 */ 0x8fdaf7, 0xe9e9, 0xe9e3, 0x8fdaf8, 0x8fdaf9,    BAD,    BAD,    BAD,
/* 18 */ 0xc3d8, 0x8fdafa, 0xe9f4,    BAD, 0xccaa,    BAD, 0x8fdafb, 0x8fdafc,
/* 20 */    BAD, 0x8fdafd,    BAD, 0x8fdafe,    BAD, 0xe9f2,    BAD,    BAD,
/* 28 */ 0x8fdba1, 0xe9f3,    BAD,    BAD,    BAD,    BAD, 0x8fdba2, 0x8fdba3,
/* 30 */    BAD, 0x8fdba4, 0x8fdba5,    BAD, 0xe9ee,    BAD,    BAD, 0xe9f0,
/* 38 */    BAD, 0x8fdba6, 0x8fdba7, 0xe9f1, 0x8fdba8, 0x8fdba9, 0x8fdbaa, 0xe9ef
},

/* Row 0x8f1 */
{
/* 00 */ 0x8fdbab,    BAD,    BAD, 0x8fdbac,    BAD, 0x8fdbad,    BAD,    BAD,
/* 08 */    BAD, 0xc0e6,    BAD, 0xcfb9, 0xe9f8, 0x8fdbae, 0xe9f9,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xeaa1,    BAD, 0xbfaa,    BAD, 0xe9fb,
/* 18 */ 0x8fdbaf, 0xe9fe,    BAD,    BAD,    BAD, 0x8fdbb0,    BAD, 0xe9f6,
/* 20 */ 0xe9f5, 0x8fdbb1,    BAD, 0xeaa2, 0x8fdbb2, 0x8fdbb3, 0xb2dc,    BAD,
/* 28 */ 0xe9fc,    BAD, 0xeaa3,    BAD,    BAD,    BAD, 0xe9fd, 0x8fdbb4,
/* 30 */    BAD, 0x8fdbb5, 0x8fdbb6,    BAD, 0xe9fa,    BAD, 0xc4b3,    BAD,
/* 38 */ 0xe9f7,    BAD,    BAD, 0x8fdbb7,    BAD,    BAD,    BAD, 0xc7e8
},

/* Row 0x8f2 */
{
/* 00 */    BAD,    BAD, 0xeaa7, 0x8fdbb8, 0x8fdbb9, 0x8fdbba, 0x8fdbbb, 0x8fdbbc,
/* 08 */ 0x8fdbbd, 0x8fdbbe,    BAD, 0x8fdbbf, 0x8fdbc0, 0xcdbb,    BAD,    BAD,
/* 10 */ 0x8fdbc1,    BAD,    BAD, 0x8fdbc2,    BAD, 0x8fdbc3,    BAD, 0x8fdbc4,
/* 18 */ 0x8fdbc5, 0x8fdbc6,    BAD,    BAD,    BAD,    BAD, 0x8fdbc7, 0xeaa6,
/* 20 */ 0x8fdbc8,    BAD, 0xeaa5, 0x8fdbc9,    BAD,    BAD,    BAD, 0x8fdbca,
/* 28 */    BAD,    BAD,    BAD, 0xeaae, 0x8fdbcb, 0x8fdbcc, 0x8fdbcd, 0xeaa8,
/* 30 */    BAD, 0x8fdbce,    BAD, 0xeab0,    BAD, 0x8fdbcf,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xcde6, 0xeab3,    BAD, 0xeaaa, 0x8fdbd0, 0x8fdbd1
},

/* Row 0x8f3 */
{
/* 00 */ 0xeaab, 0x8fdbd2,    BAD,    BAD, 0xeaaf,    BAD, 0xeab2, 0xeab1,
/* 08 */ 0x8fdbd3, 0x8fdbd4, 0x8fdbd5, 0xeaa9,    BAD,    BAD, 0x8fdbd6,    BAD,
/* 10 */ 0xeaac,    BAD, 0xeabd,    BAD,    BAD, 0x8fdbd7, 0x8fdbd8,    BAD,
/* 18 */    BAD, 0x8fdbd9, 0x8fdbda,    BAD, 0x8fdbdb,    BAD,    BAD, 0x8fdbdc,
/* 20 */ 0xeab6,    BAD, 0x8fdbdd, 0x8fdbde, 0x8fdbdf,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8fdbe0, 0x8fdbe1,    BAD, 0x8fdbe2,    BAD, 0xeab4,
/* 30 */    BAD, 0x8fdbe3, 0xeab5, 0x8fdbe4,    BAD,    BAD, 0xeaba, 0xeabb,
/* 38 */ 0x8fdbe5, 0xb3aa, 0x8fdbe6, 0xb5c2,    BAD,    BAD, 0xeab9, 0x8fdbe7
},

/* Row 0x8f4 */
{
/* 00 */    BAD, 0x8fdbe8,    BAD, 0x8fdbe9,    BAD, 0xeaa4, 0x8fdbea,    BAD,
/* 08 */    BAD, 0x8fdbeb, 0x8fdbec, 0x8fdbed,    BAD, 0xeab8, 0xeabc, 0xeab7,
/* 10 */ 0x8fdbee, 0xeabe, 0x8fdbf0, 0x8fdbf1, 0x8fdbf2, 0xeac0, 0xeabf,    BAD,
/* 18 */ 0x8fdbf3, 0x8fdbef, 0x8fdbf4, 0x8fdbf5, 0x8fdbf6,    BAD, 0x8fdbf7, 0x8fdbf8,
/* 20 */    BAD, 0xeac2, 0xeac1, 0xe9da,    BAD,    BAD,    BAD, 0xeac6,
/* 28 */ 0x8fdbf9,    BAD,    BAD,    BAD,    BAD, 0x8fdbfa, 0x8fdbfb,    BAD,
/* 30 */ 0x8fdbfc, 0xeac3, 0x8fdbfd,    BAD,    BAD, 0x8fdbfe, 0xeac4,    BAD,
/* 38 */    BAD, 0xeac5, 0x8fdca1, 0xeac7, 0x8fdca2,    BAD,    BAD,    BAD
},

/* Row 0x8f5 */
{
/* 00 */ 0xb7ec, 0x8fdca3, 0xeac9, 0x8fdca4, 0xeac8, 0x8fdca5, 0xbdb0,    BAD,
/* 08 */ 0x8fdca6, 0x8fdca7, 0x8fdca8, 0x8fdca9, 0xb9d4, 0xdea7, 0x8fdcaa,    BAD,
/* 10 */    BAD, 0x8fdcab, 0xeaca, 0xbdd1,    BAD, 0x8fdcac, 0x8fdcad, 0xb3b9,
/* 18 */ 0x8fdcae, 0xeacb, 0x8fdcaf, 0xb1d2, 0x8fdcb0, 0xbed7, 0xeacc, 0x8fdcb1,
/* 20 */ 0x8fdcb2, 0xb9d5, 0xeacd, 0xb0e1, 0x8fdcb3,    BAD,    BAD,    BAD,
/* 28 */ 0xc9bd, 0x8fdcb4,    BAD, 0xeace,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xbfea, 0x8fdcb5, 0xead5,    BAD,    BAD, 0xead2,    BAD, 0xc3ef,
/* 38 */    BAD, 0x8fdcb6,    BAD, 0x8fdcb7,    BAD, 0xead3, 0xead0, 0xb6de
},

/* Row 0x8f6 */
{
/* 00 */ 0x8fdcb8, 0xeacf, 0xead6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xb7b6,    BAD,    BAD, 0xc2de,    BAD, 0xeadc,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xead8,    BAD,    BAD,    BAD, 0xc2b5, 0xead7,
/* 18 */ 0x8fdcb9, 0xeada, 0x8fdcba, 0x8fdcbb, 0x8fdcbc,    BAD, 0xead1, 0x8fdcbd,
/* 20 */ 0x8fdcbe,    BAD, 0xeadb,    BAD, 0xeadd,    BAD,    BAD,    BAD,
/* 28 */ 0x8fdcbf,    BAD, 0x8fdcc0, 0xc8ef,    BAD,    BAD, 0xead9,    BAD,
/* 30 */ 0xeade, 0xeae0,    BAD,    BAD, 0xb8d3, 0xead4,    BAD, 0xb0c1,
/* 38 */    BAD,    BAD, 0x8fdcc1,    BAD,    BAD, 0x8fdcc2, 0x8fdcc3, 0xeadf
},

/* Row 0x8f7 */
{
/* 00 */ 0x8fdcc4, 0xbadb, 0xcef6, 0xeae1, 0xeae2, 0xc1f5,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8fdcc5, 0x8fdcc6, 0x8fdcc7, 0x8fdcc8, 0x8fdcc9, 0xcea2,
/* 10 */    BAD, 0x8fdcca, 0x8fdccb, 0x8fdccc, 0xeae3, 0xcdb5,    BAD,    BAD,
/* 18 */ 0xeae4, 0xeae5,    BAD, 0x8fdccd, 0xcae4, 0xeae6, 0x8fdcce, 0xbac0,
/* 20 */    BAD, 0xcea3,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fdccf,
/* 28 */ 0xeaeb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fdcd0,
/* 30 */ 0x8fdcd1, 0x8fdcd2, 0xeaec, 0xbed8, 0xeaea, 0x8fdcd3,    BAD, 0x8fdcd4,
/* 38 */ 0xcde7, 0xeae7,    BAD,    BAD, 0xeae9, 0xc0bd, 0xbffe,    BAD
},

/* Row 0x8f8 */
{
/* 00 */    BAD, 0x8fdcd5, 0xeae8,    BAD, 0xeaed,    BAD, 0x8fdcd6, 0xcaa3,
/* 08 */    BAD,    BAD, 0xeaef,    BAD, 0xeaee, 0x8fdcd7, 0x8fdcd8, 0x8fdcd9,
/* 10 */ 0xb3ec,    BAD, 0xcbab, 0xeaf0,    BAD, 0x8fdcda, 0x8fdcdb,    BAD,
/* 18 */ 0x8fdcdc, 0x8fdcdd, 0x8fdcde,    BAD, 0x8fdcdf, 0xeafc, 0xeaf2,    BAD,
/* 20 */ 0x8fdce0,    BAD,    BAD,    BAD,    BAD, 0xeaf3, 0x8fdce1, 0x8fdce2,
/* 28 */ 0x8fdce3,    BAD, 0xeaf4, 0xeaf5,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8fdce4, 0x8fdce5, 0x8fdce6,    BAD,    BAD, 0x8fdce7, 0xeaf9,    BAD,
/* 38 */ 0xeafa, 0x8fdce8, 0x8fdce9, 0xeaf8,    BAD,    BAD, 0x8fdcea,    BAD
},

/* Row 0x8f9 */
{
/* 00 */ 0x8fdceb, 0xeaf6, 0x8fdcec, 0xeaf1, 0xeaf7, 0x8fdced, 0x8fdcee,    BAD,
/* 08 */    BAD, 0x8fdcef,    BAD,    BAD, 0xeafb, 0xf0b7,    BAD, 0x8fdcf0,
/* 10 */    BAD,    BAD, 0x8fdcf1,    BAD,    BAD,    BAD, 0xb2a8, 0x8fdcf2,
/* 18 */    BAD,    BAD, 0x8fdcf3, 0x8fdcf4, 0x8fdcf5,    BAD, 0xeafe, 0xb6df,
/* 20 */ 0xeafd, 0x8fdcf6, 0x8fdcf7, 0x8fdcf8, 0xeba2,    BAD, 0xeba1,    BAD,
/* 28 */    BAD,    BAD, 0xeba4, 0x8fdcf9,    BAD, 0xeba3, 0x8fdcfa, 0xeba5,
/* 30 */ 0x8fdcfb,    BAD, 0xbdb1, 0x8fdcfc, 0xeba6, 0x8fdcfd,    BAD, 0xeba7,
/* 38 */    BAD,    BAD, 0x8fdcfe, 0x8fdda1, 0x8fdda2, 0x8fdda3, 0xeba8, 0xc0be
},

/* Row 0x8fa */
{
/* 00 */    BAD, 0xcdd7,    BAD, 0xeba9,    BAD,    BAD, 0xcaa4, 0xc7c6,
/* 08 */ 0xebaa, 0x8fdda4, 0xebab, 0xb8ab,    BAD, 0x8fdda5,    BAD, 0xb5ac,
/* 10 */ 0x8fdda6,    BAD,    BAD, 0xebac, 0x8fdda7, 0x8fdda8, 0xbbeb, 0xc7c1,
/* 18 */ 0xebad,    BAD, 0xb3d0, 0x8fdda9, 0x8fddaa,    BAD,    BAD, 0x8fddab,
/* 20 */ 0x8fddac, 0xebae,    BAD,    BAD,    BAD, 0x8fddad, 0xebb0, 0xcdf7,
/* 28 */    BAD, 0xebaf, 0xbfc6,    BAD, 0xebb1,    BAD,    BAD, 0xebb2,
/* 30 */ 0x8fddae,    BAD, 0xebb3, 0xb4d1, 0x8fddaf, 0x8fddb0, 0x8fddb1, 0x8fddb2,
/* 38 */    BAD,    BAD, 0xebb4,    BAD, 0x8fddb3, 0xebb5,    BAD, 0xebb6
},

/* Row 0x8fb */
{
/* 00 */ 0xebb7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xb3d1,    BAD, 0x8fddb4, 0x8fddb5, 0x8fddb6, 0x8fddb7,
/* 18 */ 0x8fddb8,    BAD, 0xebb8,    BAD, 0xebb9, 0xebba,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xb2f2,    BAD, 0x8fddb9, 0xbfa8, 0xebbb,
/* 28 */    BAD, 0x8fddba,    BAD, 0x8fddbb,    BAD, 0x8fddbc,    BAD,    BAD,
/* 30 */    BAD, 0x8fddbd,    BAD, 0x8fddbe, 0xebbc,    BAD, 0x8fddbf,    BAD,
/* 38 */ 0xebbd, 0x8fddc0,    BAD,    BAD,    BAD, 0x8fddc1,    BAD, 0x8fddc2
},

/* Row 0x8fc */
{
/* 00 */ 0xb8c0,    BAD, 0xc4fb, 0xebbe, 0x8fddc3, 0x8fddc4,    BAD, 0x8fddc5,
/* 08 */ 0xb7d7,    BAD, 0xbfd6,    BAD, 0xebc1,    BAD, 0xc6a4, 0x8fddc6,
/* 10 */ 0xebc0, 0x8fddc7, 0x8fddc8, 0xb7b1, 0x8fddc9, 0x8fddca, 0xebbf, 0xc2f7,
/* 18 */ 0xb5ad,    BAD,    BAD, 0xebc2,    BAD, 0xebc3, 0x8fddcb, 0xbed9,
/* 20 */ 0x8fddcc,    BAD, 0x8fddcd, 0xb7ed, 0x8fddce, 0xebc4, 0x8fddcf,    BAD,
/* 28 */    BAD,    BAD, 0xcbac, 0x8fddd0, 0x8fddd1, 0xc0df,    BAD, 0x8fddd2,
/* 30 */    BAD, 0xb5f6,    BAD, 0xccf5, 0xc1ca, 0x8fddd3, 0xebc5, 0x8fddd4,
/* 38 */    BAD,    BAD, 0xbfc7, 0xc3f0, 0xbeda, 0x8fddd5, 0x8fddd6,    BAD
},

/* Row 0x8fd */
{
/* 00 */ 0x8fddd7, 0xebc6,    BAD, 0x8fddd8,    BAD, 0x8fddd9, 0xebc9, 0x8fddda,
/* 08 */ 0xebca, 0x8fdddb,    BAD,    BAD,    BAD, 0x8fdddc, 0x8fdddd,    BAD,
/* 10 */ 0xbabe, 0xc2c2, 0xebc8, 0x8fddde, 0xbedb, 0xc9be, 0x8fdddf, 0x8fdde0,
/* 18 */ 0x8fdde1,    BAD,    BAD, 0xebc7, 0x8fdde2, 0x8fdde3, 0xbbec,    BAD,
/* 20 */ 0xb1d3, 0x8fdde4, 0xebce, 0xb7d8,    BAD, 0x8fdde5, 0xbbee, 0x8fdde6,
/* 28 */    BAD, 0xbbed,    BAD, 0xcfcd, 0xebcd, 0xebcc, 0xc1a7,    BAD,
/* 30 */ 0xb5cd, 0xcfc3, 0xb3ba, 0xbedc,    BAD, 0x8fdde7, 0x8fdde8, 0x8fdde9,
/* 38 */    BAD, 0x8fddea, 0x8fddeb, 0x8fddec, 0xebcb,    BAD, 0x8fdded, 0x8fddee
},

/* Row 0x8fe */
{
/* 00 */ 0x8fddef,    BAD, 0xebd0, 0x8fddf0, 0xebd1, 0xebcf, 0x8fddf1, 0xb8d8,
/* 08 */    BAD, 0xcdc0,    BAD, 0x8fddf2, 0xbbef, 0xc7a7,    BAD, 0x8fddf3,
/* 10 */ 0x8fddf4, 0xebd4, 0x8fddf5, 0xc0c0,    BAD, 0xc3c2, 0x8fddf6, 0x8fddf7,
/* 18 */ 0xcdb6, 0x8fddf8, 0xebd7,    BAD,    BAD,    BAD, 0xb8ec, 0x8fddf9,
/* 20 */ 0xc0bf, 0xebd3,    BAD, 0xebd8, 0xb8ed, 0xebd5, 0xebd6, 0x8fddfa,
/* 28 */ 0xebd2, 0x8fddfb,    BAD,    BAD, 0xc0e2, 0xc6c9, 0x8fddfc, 0x8fddfd,
/* 30 */ 0xc3af,    BAD, 0xb2dd, 0x8fddfe,    BAD,    BAD, 0x8fdea1, 0x8fdea2,
/* 38 */    BAD, 0xc8f0,    BAD, 0x8fdea3, 0xb5c3,    BAD, 0x8fdea4, 0xc4b4
},

/* Row 0x8ff */
{
/* 00 */    BAD,    BAD, 0xebdb, 0x8fdea5, 0xebd9,    BAD, 0x8fdea6, 0xc3cc,
/* 08 */ 0x8fdea7, 0x8fdea8, 0x8fdea9, 0xc0c1, 0xb4d2, 0xebda,    BAD, 0xbfdb,
/* 10 */    BAD, 0x8fdeaa, 0xceca, 0x8fdeab, 0x8fdeac, 0x8fdead, 0xcfc0, 0x8fdeae,
/* 18 */    BAD,    BAD, 0xebdc, 0xebe7, 0xc4b5, 0x8fdeaf, 0xebe6, 0x8fdeb0,
/* 20 */ 0xebe3, 0xebeb, 0xebe4,    BAD, 0xebe0,    BAD, 0xc4fc, 0xebdf,
/* 28 */    BAD,    BAD,    BAD, 0xebdd, 0x8fdeb1, 0xcda1, 0xbbf0,    BAD,
/* 30 */ 0x8fdeb2, 0xebe1,    BAD, 0xebde, 0x8fdeb3, 0x8fdeb4, 0x8fdeb5, 0xebe5,
/* 38 */ 0xbdf4,    BAD, 0xb8c1,    BAD, 0x8fdeb6,    BAD, 0xc2fa, 0x8fdeb7
},

/* Row 0x900 */
{
/* 00 */ 0xcbc5, 0xb1da, 0xb0e2,    BAD, 0xc6a5, 0x8fdeb8, 0x8fdeb9, 0xebe9,
/* 08 */    BAD,    BAD, 0x8fdebf, 0x8fdeba, 0xebe8,    BAD, 0xc6e6,    BAD,
/* 10 */ 0xebed, 0x8fdebb,    BAD,    BAD, 0xebe2,    BAD, 0xebec, 0xebee,
/* 18 */    BAD, 0xb8ac, 0xebea, 0xb9d6, 0x8fdebc, 0xbcd5, 0x8fdebd, 0x8fdebe,
/* 20 */ 0xebef, 0xcdd8,    BAD,    BAD,    BAD,    BAD, 0xebf2,    BAD,
/* 28 */ 0xebf5,    BAD,    BAD, 0xebf3, 0xc9b5, 0x8fdec0,    BAD,    BAD,
/* 30 */ 0x8fdec1,    BAD,    BAD, 0xebf0,    BAD,    BAD,    BAD, 0x8fdec2,
/* 38 */    BAD, 0xb6e0,    BAD,    BAD, 0x8fdec3,    BAD, 0xebf4,    BAD
},

/* Row 0x901 */
{
/* 00 */    BAD, 0xebf6, 0x8fdec4, 0x8fdec5, 0x8fdec6, 0x8fdec7, 0x8fdec8,    BAD,
/* 08 */ 0x8fdec9, 0xebfa,    BAD,    BAD, 0xebf7, 0x8fdece, 0xebf9, 0xebf8,
/* 10 */    BAD,    BAD, 0x8fdeca, 0x8fdecb, 0x8fdecc,    BAD, 0xebfb,    BAD,
/* 18 */ 0xbcb1, 0x8fdecd, 0xebfd, 0xebfc, 0xc9e8,    BAD, 0x8fdecf, 0xeca1,
/* 20 */    BAD,    BAD,    BAD, 0x8fded0,    BAD,    BAD, 0xb7d9,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xebfe, 0xeca2, 0x8fded1,    BAD, 0xeca3,
/* 30 */ 0xb5c4, 0xe6c1, 0xbef9,    BAD, 0xeca4,    BAD, 0x8fded2, 0xb8ee,
/* 38 */ 0x8fded3, 0x8fded4,    BAD,    BAD, 0x8fded5, 0xeca5, 0x8fded6,    BAD
},

/* Row 0x902 */
{
/* 00 */ 0xeca6, 0x8fded7,    BAD, 0xbbbe, 0x8fded8, 0x8fded9,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xdace, 0x8fdeda, 0xeca7, 0x8fdedb, 0xeca8, 0x8fdedc,
/* 10 */ 0xbdb2,    BAD, 0xeca9, 0xecaa, 0x8fdedd, 0x8fdede, 0xecab,    BAD,
/* 18 */    BAD, 0xecac, 0xecad,    BAD, 0x8fdedf,    BAD, 0x8fdee0, 0x8fdee1,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x903 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc3ab,
/* 38 */ 0x8fdee2, 0x8fdee3, 0xecae,    BAD,    BAD, 0x8fdee4, 0x8fdee5, 0xecb0
},

/* Row 0x904 */
{
/* 00 */    BAD, 0xecaf,    BAD,    BAD,    BAD, 0x8fdee6, 0xc6a6, 0x8fdee7,
/* 08 */ 0xecb1, 0x8fdee8, 0xcbad, 0x8fdee9, 0xecb2,    BAD, 0xecb3, 0x8fdeea,
/* 10 */ 0xecb4, 0x8fdeeb,    BAD, 0x8fdeec, 0x8fdeed, 0xecb5,    BAD, 0x8fdeee,
/* 18 */ 0x8fdeef, 0x8fdef2, 0xc6da, 0x8fdef0,    BAD, 0x8fdef1,    BAD,    BAD,
/* 20 */    BAD, 0xbedd, 0xecb6, 0x8fdef3, 0x8fdef4,    BAD, 0x8fdef5,    BAD,
/* 28 */ 0x8fdef6, 0x8fdef7, 0xb9eb, 0xd0ae, 0xecb7, 0x8fdef8,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x8fdef9,    BAD, 0x8fdefa, 0x8fdefb,    BAD,
/* 38 */ 0xecb8, 0xc9bf, 0xecb9, 0x8fdefc, 0xecc1,    BAD, 0x8fdefd,    BAD
},

/* Row 0x905 */
{
/* 00 */    BAD,    BAD, 0xecba,    BAD,    BAD, 0xecbc, 0x8fdefe, 0x8fdfa1,
/* 08 */    BAD, 0xecbb, 0xecbd, 0x8fdfa2, 0xcbc6, 0xecbe, 0xecbf,    BAD,
/* 10 */ 0x8fdfa3,    BAD, 0x8fdfa4, 0x8fdfa5, 0xecc0,    BAD,    BAD,    BAD,
/* 18 */ 0xecc2, 0x8fdfa6,    BAD, 0x8fdfa7, 0x8fdfa8, 0xb3ad, 0xc4e7,    BAD,
/* 20 */ 0xc9e9, 0xbae2, 0xb9d7,    BAD, 0x8fdfa9,    BAD,    BAD, 0xc9cf,
/* 28 */ 0xb2df, 0xc8ce, 0xecc5, 0xb4d3, 0xc0d5, 0xecc4, 0xecc9, 0xc3f9,
/* 30 */ 0xcce3,    BAD, 0xecc7, 0xecc8, 0xb5ae,    BAD, 0xecca, 0xc7e3,
/* 38 */ 0xc2df, 0x8fdfaa, 0x8fdfab, 0xc8f1, 0xc5bd, 0xecc6,    BAD, 0xcbc7
},

/* Row 0x906 */
{
/* 00 */ 0xb2ec, 0xeccc, 0xcfa8, 0xc4c2, 0xcfc5, 0x8fdfac, 0x8fdfad, 0xbbf1,
/* 08 */ 0xeccb, 0x8fdfae, 0xc2b1, 0x8fdfaf,    BAD, 0xecdc, 0xc1a8, 0x8fdfb0,
/* 10 */    BAD, 0xc6f8,    BAD, 0xc9d0,    BAD, 0x8fdfb2, 0x8fdfb1,    BAD,
/* 18 */    BAD, 0x8fdfb3, 0xeccf, 0xbbbf, 0xbbf2, 0x8fdfb4, 0xbede,    BAD,
/* 20 */ 0xc7e5, 0x8fdfb5, 0xb8ad, 0xecce, 0xeccd,    BAD, 0xc9ea,    BAD,
/* 28 */ 0x8fdfb6,    BAD, 0xbcc1,    BAD, 0x8fdfb7, 0xc5d2,    BAD, 0x8fdfb8,
/* 30 */ 0x8fdfb9,    BAD, 0x8fdfba,    BAD,    BAD, 0x8fdfbb,    BAD, 0x8fdfbc,
/* 38 */ 0x8fdfbd,    BAD, 0xecd1, 0xecd2, 0xb9d8, 0xecd0, 0x8fdfbe, 0x8fdfbf
},

/* Row 0x907 */
{
/* 00 */    BAD, 0x8fdfc0,    BAD, 0x8fdfc1, 0xecd3, 0xecd4,    BAD, 0xecd6,
/* 08 */ 0xc2a3, 0x8fdfc2, 0xecd5, 0xb4e6,    BAD, 0xecd8,    BAD, 0xecd7,
/* 10 */ 0xecd9,    BAD, 0x8fdfc3, 0xecdb, 0xecdd,    BAD, 0xecde, 0x8fdfc4,
/* 18 */    BAD,    BAD,    BAD, 0x8fdfc5,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x908 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xc0d6, 0x8fdfc6, 0xbccf, 0xecdf,
/* 28 */    BAD, 0x8fdfc7,    BAD, 0xb3d2, 0x8fdfc8, 0xece0, 0x8fdfc9,    BAD,
/* 30 */ 0xc1f6, 0xece1,    BAD, 0xece2, 0xc9eb,    BAD,    BAD, 0xb5af,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fdfca
},

/* Row 0x909 */
{
/* 00 */    BAD, 0xece3, 0x8fdfcb,    BAD, 0x8fdfcc, 0xc4b6,    BAD,    BAD,
/* 08 */ 0x8fdfcd,    BAD, 0xb1db,    BAD,    BAD, 0x8fdfce,    BAD,    BAD,
/* 10 */ 0x8fdfcf, 0x8fdfd0,    BAD,    BAD,    BAD, 0x8fdfd1,    BAD,    BAD,
/* 18 */    BAD, 0xece4,    BAD,    BAD,    BAD,    BAD, 0x8fdfd2, 0x8fdfd3,
/* 20 */ 0x8fdfd4,    BAD,    BAD, 0xbcf1,    BAD,    BAD, 0x8fdfd5,    BAD,
/* 28 */ 0xbff6,    BAD,    BAD, 0x8fdfd6, 0x8fdfd7,    BAD,    BAD, 0x8fdfd8,
/* 30 */    BAD,    BAD, 0x8fdfd9, 0xc2ad,    BAD, 0x8fdfda,    BAD, 0x8fdfdb,
/* 38 */    BAD, 0x8fdfdc, 0xece7, 0x8fdfdd, 0x8fdfef,    BAD, 0xece6,    BAD
},

/* Row 0x90a */
{
/* 00 */ 0x8fdfde,    BAD, 0xece5,    BAD,    BAD, 0x8fdfdf, 0x8fdfe0, 0x8fdfe1,
/* 08 */ 0x8fdfe2,    BAD, 0x8fdfe3, 0xeced, 0xeceb,    BAD, 0x8fdfe4, 0xece8,
/* 10 */    BAD, 0x8fdfe5,    BAD,    BAD, 0x8fdfe6, 0x8fdfe7, 0xecea, 0x8fdfe8,
/* 18 */    BAD, 0x8fdfe9, 0xece9, 0xecec,    BAD, 0xb5f7,    BAD, 0xecf0,
/* 20 */    BAD, 0xc0d7,    BAD, 0xecf1, 0x8fdfea, 0x8fdfeb,    BAD, 0x8fdfec,
/* 28 */ 0xb8d9,    BAD, 0xecee, 0xecef, 0x8fdfed,    BAD,    BAD, 0xcfa9,
/* 30 */ 0x8fdfee, 0x8fdff0, 0x8fdff1, 0xc4b7, 0x8fdff2, 0xc1a9,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xecf2, 0x8fdff3,    BAD, 0xecf5
},

/* Row 0x90b */
{
/* 00 */    BAD, 0x8fdff4,    BAD,    BAD, 0x8fdff5, 0x8fdff6, 0x8fdff7,    BAD,
/* 08 */ 0xecf3, 0xecf4, 0xcdd9, 0x8fdff8,    BAD,    BAD,    BAD, 0xc6a7,
/* 10 */ 0xecf8, 0x8fdff9,    BAD,    BAD, 0x8fdffa,    BAD, 0x8fdffb,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xecf6, 0xecf7, 0xecf9,
/* 20 */ 0x8fdffc, 0x8fdffd, 0x8fdffe, 0x8fe0a1,    BAD,    BAD, 0x8fe0a2, 0x8fe0a3,
/* 28 */    BAD,    BAD, 0xeda9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xecfc, 0x8fe0a4,    BAD, 0x8fe0a5, 0xecfd, 0xecfb, 0x8fe0a6, 0x8fe0a7,
/* 38 */ 0x8fe0a8, 0x8fe0a9,    BAD,    BAD,    BAD, 0x8fe0aa,    BAD,    BAD
},

/* Row 0x90c */
{
/* 00 */ 0x8fe0ab, 0x8fe0ac, 0xecfa,    BAD, 0xc4fd,    BAD,    BAD, 0xeda1,
/* 08 */ 0xeda5, 0xeda2, 0xecfe, 0x8fe0ad, 0xeda3, 0x8fe0ae, 0x8fe0af, 0x8fe0b0,
/* 10 */ 0xeda4,    BAD,    BAD,    BAD, 0x8fe0b1, 0xedab,    BAD,    BAD,
/* 18 */    BAD, 0xeda6,    BAD, 0x8fe0b2, 0x8fe0b3, 0x8fe0b4, 0x8fe0b5, 0xc0d8,
/* 20 */ 0xeda8, 0x8fe0b6, 0x8fe0b7, 0xedaa, 0xeda7,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8fe0b8,    BAD,    BAD, 0x8fe0b9, 0x8fe0ba,    BAD, 0x8fe0bb,
/* 30 */ 0x8fe0bc, 0x8fe0bd, 0xedad,    BAD, 0xbdb3,    BAD, 0xedac,    BAD,
/* 38 */    BAD, 0x8fe0be, 0x8fe0bf, 0x8fe0c0, 0xedae,    BAD,    BAD,    BAD
},

/* Row 0x90d */
{
/* 00 */    BAD, 0xedaf, 0x8fe0c1, 0x8fe0c2, 0xedb2, 0xedb1,    BAD, 0xedb0,
/* 08 */    BAD, 0x8fe0c3, 0xedb4, 0xedb3,    BAD, 0xccf6,    BAD,    BAD,
/* 10 */ 0x8fe0c4, 0xedb6, 0x8fe0c5, 0xedb5, 0xedb7, 0x8fe0c6,    BAD,    BAD,
/* 18 */    BAD, 0xedb8, 0x8fe0c7, 0x8fe0c8,    BAD, 0x8fe0c9, 0x8fe0ca,    BAD,
/* 20 */    BAD, 0xedba, 0x8fe0cb,    BAD,    BAD,    BAD,    BAD, 0x8fe0cc,
/* 28 */    BAD, 0x8fe0cd, 0xedb9, 0xbfc8, 0xedbb, 0x8fe0ce, 0x8fe0cf, 0xb6ed,
/* 30 */ 0xedbc, 0xedbe,    BAD, 0x8fe0d0,    BAD, 0x8fe0d1,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8fe0d2, 0x8fe0d3,    BAD,    BAD, 0xedbf,    BAD
},

/* Row 0x90e */
{
/* 00 */ 0x8fe0d4, 0x8fe0d5,    BAD, 0x8fe0d6, 0x8fe0d7, 0xedc0, 0xedbd, 0x8fe0d8,
/* 08 */ 0xedc1,    BAD, 0xbcd6, 0xedc2, 0xb5b0, 0xb7b3,    BAD, 0x8fe0d9,
/* 10 */    BAD, 0x8fe0da, 0xb8ae,    BAD, 0x8fe0db,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xedc3, 0x8fe0dc,    BAD,    BAD, 0xc6f0,
/* 20 */    BAD,    BAD, 0xc5be, 0xedc4,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8fe0dd,    BAD,    BAD, 0xedc7,    BAD, 0x8fe0e4, 0x8fe0de,    BAD,
/* 30 */ 0x8fe0df, 0x8fe0e0,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fe0e1,
/* 38 */ 0xbcb4, 0x8fe0e2, 0x8fe0e3, 0xedc6, 0xedc5, 0xb7da, 0xedc8,    BAD
},

/* Row 0x90f */
{
/* 00 */ 0x8fe0e5,    BAD, 0x8fe0e6, 0xb3d3,    BAD, 0xedca,    BAD, 0x8fe0e7,
/* 08 */ 0x8fe0e8, 0xbadc, 0xedc9,    BAD, 0xedd2,    BAD,    BAD, 0x8fe0e9,
/* 10 */ 0x8fe0ea,    BAD, 0xedcc, 0xedce, 0xcae5, 0xedcb, 0x8fe0eb, 0x8fe0ec,
/* 18 */ 0x8fe0ed, 0xedcd,    BAD, 0xedd1, 0xedcf, 0xb5b1, 0x8fe0ee, 0xedd0,
/* 20 */ 0x8fe0ef, 0x8fe0f0,    BAD, 0x8fe0f1,    BAD, 0x8fe0f2, 0xedd3, 0x8fe0f3,
/* 28 */ 0x8fe0f4, 0xc7da, 0xced8,    BAD, 0x8fe0f5, 0x8fe0f6, 0x8fe0f7, 0xbdb4,
/* 30 */    BAD,    BAD,    BAD, 0xedd4, 0x8fe0f8, 0x8fe0f9, 0x8fe0fa, 0x8fe0fb,
/* 38 */ 0xcda2, 0xedd6, 0x8fe0fc, 0xedd5,    BAD,    BAD, 0xedd9, 0xcdc1
},

/* Row 0x910 */
{
/* 00 */ 0x8fe0fd, 0x8fe0fe, 0xedd8, 0x8fe1a1, 0xb3ed, 0xedd7, 0xeddc, 0x8fe1a2,
/* 08 */    BAD, 0xeddb,    BAD,    BAD, 0xedda, 0xc5b2, 0xeddd, 0x8fe1a3,
/* 10 */    BAD, 0x8fe1a4, 0x8fe1a5, 0x8fe1a6, 0x8fe1a7, 0x8fe1a8,    BAD, 0xedde,
/* 18 */ 0x8fe1a9,    BAD,    BAD,    BAD, 0xeddf, 0x8fe1aa, 0x8fe1ab, 0xb9ec,
/* 20 */    BAD, 0xb7a5, 0xede0, 0xede1, 0xede2, 0x8fe1ac,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x911 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xbfc9, 0xede3, 0x8fe1ad, 0xbcad, 0xede4,
/* 20 */ 0x8fe1ae, 0x8fe1af,    BAD, 0xede5, 0x8fe1b0, 0x8fe1b1, 0x8fe1b2, 0xd2a1,
/* 28 */ 0xd1fe,    BAD,    BAD,    BAD,    BAD, 0xede6, 0xe5f0, 0xede7,
/* 30 */ 0xc3a4, 0xbfab, 0xc7c0,    BAD,    BAD, 0x8fe1b3, 0x8fe1b4, 0xede8,
/* 38 */ 0x8fe1b5,    BAD, 0xcad5, 0xc4d4, 0xb9fe,    BAD, 0x8fe1b6, 0xc3a9
},

/* Row 0x912 */
{
/* 00 */ 0x8fe1b7, 0x8fe1b8, 0xb1aa,    BAD, 0xcbf8, 0xbfd7, 0x8fe1b9,    BAD,
/* 08 */    BAD,    BAD, 0x8fe1ba, 0x8fe1bb,    BAD, 0x8fe1bc, 0xb7de,    BAD,
/* 10 */ 0x8fe1bd, 0xb6e1, 0x8fe1be, 0x8fe1bf, 0xcad6, 0x8fe1c0,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xede9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8fe1c1,    BAD, 0xedeb, 0x8fe1c2, 0x8fe1c3, 0xedea, 0xb2e0,    BAD,
/* 28 */ 0x8fe1c4, 0xc6f6, 0xedec, 0xc7f7,    BAD, 0xc5b3, 0x8fe1c5, 0xeded,
/* 30 */ 0xbdd2, 0x8fe1c6,    BAD,    BAD, 0xedef, 0x8fe1c7, 0x8fe1c8, 0xccc2,
/* 38 */ 0xedfe, 0xedf1, 0xedf2, 0x8fe1c9,    BAD, 0xc4c9, 0x8fe1ca,    BAD
},

/* Row 0x913 */
{
/* 00 */ 0xc2e0, 0xc1f7, 0x8fe1cb, 0xc6a8, 0x8fe1cc, 0xedf0, 0xb5d5,    BAD,
/* 08 */ 0x8fe1cd,    BAD,    BAD, 0xedf9, 0x8fe1ce, 0xedf6, 0xeea5, 0xc6a9,
/* 10 */ 0xc3e0, 0xedf3,    BAD, 0xc4fe, 0xc5d3, 0xedf4, 0xedf8, 0xbfe0,
/* 18 */ 0x8fe1cf, 0xc7e7, 0xc4cc, 0x8fe1d0,    BAD, 0xc0c2, 0xedf7, 0xc2ae,
/* 20 */ 0xc2a4, 0xedf5, 0xb0a9, 0xcfa2,    BAD,    BAD,    BAD, 0xedfa,
/* 28 */ 0x8fe1d1, 0x8fe1d2, 0x8fe1d4,    BAD, 0x8fe1d5, 0x8fe1d6, 0xc2e1, 0x8fe1d3,
/* 30 */    BAD, 0xbdb5, 0xbfca, 0x8fe1d7, 0x8fe1d8, 0xedfc, 0xedfb, 0x8fe1d9,
/* 38 */ 0xb0ef, 0xedfd,    BAD,    BAD, 0xc9af,    BAD, 0xeea7, 0x8fe1da
},

/* Row 0x914 */
{
/* 00 */    BAD, 0xc6db, 0xbfeb, 0x8fe1db, 0x8fe1dc, 0xc3d9,    BAD, 0xb6f8,
/* 08 */    BAD, 0xeea6, 0xcdb7, 0xb1bf, 0x8fe1dd, 0xcad7, 0xb2e1, 0xeea1,
/* 10 */ 0xeea2, 0xeea3, 0xeea4, 0xc6bb, 0xc3a3, 0xb0e3, 0xeea8,    BAD,
/* 18 */ 0xeea9, 0xf4a3,    BAD, 0x8fe1de, 0xc2bd, 0x8fe1df, 0xeeaa,    BAD,
/* 20 */ 0xb1f3, 0xc1cc, 0x8fe1e0, 0xb8af,    BAD, 0xcdda, 0x8fe1e1, 0x8fe1e2,
/* 28 */ 0xeeab, 0xc5ac,    BAD,    BAD, 0x8fe1e3, 0xc1f8, 0xbcd7, 0xeeac,
/* 30 */ 0x8fe1e4,    BAD, 0xeeaf,    BAD, 0x8fe1e5, 0xbde5, 0xeead, 0xc1ab,
/* 38 */ 0xc1aa, 0x8fe1e6, 0xb0e4,    BAD, 0xcecb, 0xeeb1,    BAD, 0xc8f2
},

/* Row 0x915 */
{
/* 00 */ 0xeeb3, 0xeeb2, 0xeeb0, 0xe3e4, 0xb4d4, 0x8fe1e7,    BAD, 0xedee,
/* 08 */ 0x8fe1e8, 0xeeb5, 0xeeb4, 0x8fe1e9, 0x8fe1ea,    BAD, 0x8fe1eb, 0xeeb6,
/* 10 */ 0x8fe1ec, 0xcdb8,    BAD,    BAD,    BAD, 0x8fe1ed,    BAD, 0x8fe1ee,
/* 18 */ 0x8fe1ef, 0x8fe1f0,    BAD, 0x8fe1f1,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8fe1f2, 0x8fe1f3, 0x8fe1f4, 0xc6e1,    BAD, 0x8fe1f5, 0xcbae,    BAD,
/* 28 */ 0xeeb7,    BAD, 0xbcd9,    BAD,    BAD,    BAD,    BAD, 0xeeb8,
/* 30 */ 0x8fe1f6, 0xeeb9, 0x8fe1f7, 0x8fe1f8, 0x8fe1f9, 0xeeba, 0x8fe1fa,    BAD,
/* 38 */ 0xc5a1,    BAD,    BAD,    BAD,    BAD, 0x8fe1fb, 0x8fe1fd,    BAD
},

/* Row 0x916 */
{
/* 00 */    BAD, 0xb0ea,    BAD, 0x8fe1fe, 0x8fe2a1, 0x8fe2a2,    BAD, 0x8fe2a3,
/* 08 */ 0x8fe2a4,    BAD, 0xb9d9,    BAD, 0x8fe1fc,    BAD, 0xcfba,    BAD,
/* 10 */    BAD,    BAD, 0x8fe2ad,    BAD,    BAD, 0x8fe2a5,    BAD, 0x8fe2a6,
/* 18 */ 0x8fe2a7, 0x8fe2a8,    BAD, 0xeebe, 0x8fe2a9, 0x8fe2aa,    BAD, 0x8fe2ab,
/* 20 */    BAD, 0xb7b4, 0xeebb,    BAD, 0xeebc, 0x8fe2ac,    BAD,    BAD,
/* 28 */ 0xc9f4,    BAD,    BAD, 0x8fe2af,    BAD, 0xb3d4,    BAD, 0x8fe2b0,
/* 30 */ 0x8fe2b1,    BAD,    BAD,    BAD, 0x8fe2b2, 0xcdb9, 0x8fe2ae, 0xb6bf,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc5d4, 0x8fe2b3, 0x8fe2b4
},

/* Row 0x917 */
{
/* 00 */ 0x8fe2b5,    BAD, 0xeebf,    BAD, 0x8fe2b6, 0x8fe2b7, 0x8fe2b8,    BAD,
/* 08 */ 0x8fe2b9,    BAD,    BAD,    BAD,    BAD, 0x8fe2ba,    BAD,    BAD,
/* 10 */ 0x8fe2bb,    BAD, 0xeec0,    BAD, 0x8fe2bc,    BAD, 0x8fe2bd, 0x8fe2be,
/* 18 */ 0x8fe2bf, 0xeec1, 0x8fe2c0,    BAD, 0x8fe2c1,    BAD, 0x8fe2c2,    BAD,
/* 20 */ 0x8fe2c3,    BAD, 0x8fe2c5, 0x8fe2c6,    BAD, 0x8fe2c4,    BAD, 0x8fe2c7,
/* 28 */    BAD, 0x8fe2c8,    BAD,    BAD,    BAD, 0xc5a2, 0x8fe2c9, 0x8fe2ca,
/* 30 */ 0xeec3, 0x8fe2cb, 0xeec2,    BAD, 0x8fe2cc,    BAD, 0x8fe2cd, 0x8fe2ce,
/* 38 */    BAD, 0x8fe2cf, 0x8fe2d0,    BAD, 0x8fe2d1, 0x8fe2d2,    BAD,    BAD
},

/* Row 0x918 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8fe2d3,    BAD,    BAD,    BAD, 0x8fe2d4,
/* 08 */ 0x8fe2d5, 0xc6d3, 0xeec4, 0xbdb6, 0xbce0, 0xc7db, 0xc3f1, 0x8fe2d6,
/* 10 */    BAD,    BAD, 0xbcf2, 0x8fe2d7, 0xbfec,    BAD, 0xeec5, 0x8fe2d8,
/* 18 */ 0xeec6, 0x8fe2d9, 0x8fe2da, 0x8fe2db,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8fe2dc, 0xbfdd, 0xeec7, 0x8fe2dd, 0xeec8,    BAD, 0x8fe2de,
/* 28 */    BAD, 0xeec9, 0xcdef,    BAD, 0xbdb7, 0x8fe2df,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xeecb, 0xeeca, 0x8fe2e0, 0xb9da,    BAD, 0xb9f3,
/* 38 */ 0xbbc0, 0x8fe2e1, 0x8fe2e2, 0x8fe2e3,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x919 */
{
/* 00 */    BAD, 0x8fe2e4, 0xeece, 0x8fe2e5,    BAD, 0x8fe2e6, 0x8fe2e7, 0xbde6,
/* 08 */    BAD, 0xeecd, 0x8fe2e8, 0xeecc,    BAD, 0xc2e9, 0x8fe2e9,    BAD,
/* 10 */ 0xb8ef, 0x8fe2ea, 0xc0c3, 0x8fe2eb, 0x8fe2ec, 0x8fe2ed,    BAD, 0xc8b0,
/* 18 */ 0x8fe2ee,    BAD,    BAD,    BAD, 0xbdb9,    BAD, 0x8fe2ef,    BAD,
/* 20 */    BAD, 0x8fe2f0, 0xeecf,    BAD, 0xbedf,    BAD, 0x8fe2f1,    BAD,
/* 28 */ 0x8fe2f2,    BAD, 0xeed2, 0xeed0, 0x8fe2f3, 0x8fe2f4, 0x8fe2f5, 0xeed1,
/* 30 */ 0x8fe2f6, 0x8fe2f7, 0x8fe2f8, 0x8fe2f9, 0xeed4, 0xeed3, 0x8fe2fa,    BAD,
/* 38 */ 0xbefa,    BAD, 0xeed5, 0x8fe2fb, 0x8fe2fc, 0x8fe2fd,    BAD, 0x8fe2fe
},

/* Row 0x91a */
{
/* 00 */ 0xeed6, 0xeed7, 0x8fe3a1, 0x8fe3a2,    BAD, 0x8fe3a3, 0xc8d0, 0xbad3,
/* 08 */ 0xbce1, 0xeed8,    BAD, 0xeed9, 0xcea4, 0xbdc5, 0xccee, 0xcecc,
/* 10 */ 0xeeda, 0xb6e2,    BAD, 0x8fe3a4, 0x8fe3a5,    BAD, 0xeedb, 0x8fe3a6,
/* 18 */ 0xc5a3, 0x8fe3a7, 0x8fe3a8, 0xeede, 0xb3f8, 0xbfcb, 0x8fe3a9, 0xeedc,
/* 20 */    BAD, 0xeedd,    BAD, 0xc4e0, 0x8fe3aa, 0x8fe3ab, 0xcbd5, 0xb6fc,
/* 28 */    BAD, 0x8fe3ac, 0x8fe3ad,    BAD, 0x8fe3ae, 0x8fe3af, 0x8fe3b0, 0x8fe3b1,
/* 30 */ 0x8fe3b2, 0x8fe3b3,    BAD,    BAD,    BAD, 0xeee0, 0xeee1, 0x8fe3b4,
/* 38 */    BAD, 0x8fe3b5,    BAD, 0x8fe3b6, 0xeedf, 0x8fe3b7,    BAD, 0xeee3
},

/* Row 0x91b */
{
/* 00 */ 0x8fe3b8, 0x8fe3b9,    BAD,    BAD, 0x8fe3ba, 0x8fe3bb, 0x8fe3bc, 0x8fe3bd,
/* 08 */    BAD, 0x8fe3be, 0x8fe3bf,    BAD, 0x8fe3c0, 0xc6df, 0xb3c3,    BAD,
/* 10 */ 0x8fe3c1, 0xeee7, 0x8fe3c2, 0x8fe3c3, 0xeee4, 0xeee6, 0x8fe3c4,    BAD,
/* 18 */ 0x8fe3c5,    BAD,    BAD,    BAD, 0x8fe3c6, 0x8fe3c7, 0xeee2,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x8fe3c8, 0x8fe3c9, 0x8fe3ca, 0x8fe3cb,    BAD,
/* 28 */ 0x8fe3cc, 0xefcf,    BAD,    BAD, 0xeee5,    BAD, 0x8fe3cd, 0x8fe3ce,
/* 30 */ 0x8fe3cf,    BAD,    BAD, 0x8fe3d0, 0xceeb, 0x8fe3d1, 0x8fe3d2, 0xb8da,
/* 38 */ 0x8fe3d3, 0x8fe3d4, 0x8fe3d5,    BAD, 0x8fe3d6,    BAD, 0x8fe3d7, 0xeeef
},

/* Row 0x91c */
{
/* 00 */ 0x8fe3d8,    BAD, 0x8fe3d9, 0x8fe3da, 0xc5b4, 0xeeea, 0x8fe3db, 0x8fe3dc,
/* 08 */ 0xeeed, 0xeeeb, 0x8fe3dd, 0xeef0,    BAD, 0x8fe3de, 0x8fe3df, 0x8fe3e0,
/* 10 */ 0xeef1, 0x8fe3e1,    BAD,    BAD,    BAD,    BAD,    BAD, 0xeee9,
/* 18 */ 0x8fe3e2, 0x8fe3e3, 0xeef6, 0xb1f4, 0x8fe3e4, 0x8fe3e5, 0xeee8,    BAD,
/* 20 */ 0x8fe3e6, 0x8fe3e7, 0xc8ad,    BAD, 0xeeec, 0x8fe3e8, 0xbee0, 0x8fe3e9,
/* 28 */ 0x8fe3ea, 0x8fe3eb,    BAD,    BAD,    BAD,    BAD, 0x8fe3ec, 0x8fe3ed,
/* 30 */ 0x8fe3ee, 0xb9db,    BAD,    BAD,    BAD, 0x8fe3ef, 0x8fe3f0, 0x8fe3f1,
/* 38 */ 0x8fe3f2, 0x8fe3f3,    BAD, 0x8fe3f4, 0x8fe3f5, 0x8fe3f6, 0xcbc8, 0x8fe3f7
},

/* Row 0x91d */
{
/* 00 */ 0xb6e4,    BAD,    BAD, 0xbdc6,    BAD, 0xc6bc,    BAD,    BAD,
/* 08 */ 0x8fe3f8, 0x8fe3f9, 0x8fe3fa,    BAD,    BAD, 0x8fe3fb, 0x8fe3fc,    BAD,
/* 10 */    BAD, 0xc1ad, 0x8fe3fd, 0xeef4,    BAD, 0xeeee, 0xeef3, 0x8fe3fe,
/* 18 */ 0xccc3, 0x8fe4a1, 0xc4b8, 0xeef5, 0xeef2,    BAD,    BAD, 0x8fe4a2,
/* 20 */ 0x8fe4a3,    BAD,    BAD,    BAD, 0x8fe4a4, 0x8fe4a5,    BAD, 0x8fe4a6,
/* 28 */ 0x8fe4a7,    BAD,    BAD, 0x8fe4a8,    BAD, 0xc1ac,    BAD, 0x8fe4a9,
/* 30 */    BAD,    BAD, 0x8fe4aa,    BAD,    BAD,    BAD, 0x8fe4ab, 0xeef9,
/* 38 */ 0x8fe4ac, 0xeef8, 0x8fe4ad, 0x8fe4ae, 0x8fe4af, 0x8fe4b0,    BAD, 0x8fe4b1
},

/* Row 0x91e */
{
/* 00 */ 0x8fe4b2, 0x8fe4b3, 0x8fe4b4, 0x8fe4b5,    BAD, 0x8fe4b6, 0x8fe4b7, 0x8fe4b8,
/* 08 */ 0x8fe4b9,    BAD,    BAD, 0x8fe4ba, 0x8fe4bb, 0x8fe4bc, 0x8fe4bd, 0xeef7,
/* 10 */ 0x8fe4be,    BAD, 0xcbaf, 0x8fe4bf,    BAD, 0x8fe4c0,    BAD, 0x8fe4c1,
/* 18 */ 0x8fe4c2, 0x8fe4c3,    BAD,    BAD, 0x8fe4c4, 0x8fe4c5,    BAD, 0x8fe4c6,
/* 20 */ 0x8fe4c7, 0x8fe4c8,    BAD, 0x8fe4c9, 0xbdfb, 0x8fe4ca,    BAD, 0x8fe4cb,
/* 28 */ 0x8fe4cc, 0xeefa, 0xcadf,    BAD, 0x8fe4cd, 0xb1d4, 0x8fe4ce,    BAD,
/* 30 */ 0x8fe4cf,    BAD, 0xc9c6, 0xc3f2,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xb5f8, 0x8fe4d0, 0xeefc, 0x8fe4d1, 0xb9dd,    BAD,    BAD, 0x8fe4d2
},

/* Row 0x91f */
{
/* 00 */ 0x8fe4d3,    BAD, 0x8fe4d4,    BAD,    BAD,    BAD, 0xbbac,    BAD,
/* 08 */ 0x8fe4d5,    BAD,    BAD,    BAD,    BAD, 0x8fe4d6,    BAD, 0xeefb,
/* 10 */ 0xbfed, 0x8fe4d7,    BAD,    BAD, 0x8fe4d8, 0x8fe4d9,    BAD,    BAD,
/* 18 */ 0xbfee, 0xefa1, 0xefa3,    BAD, 0x8fe4da, 0x8fe4db, 0x8fe4dc, 0x8fe4dd,
/* 20 */ 0xbefb, 0x8fe4de, 0xefa2, 0xefa4, 0x8fe4df, 0x8fe4e0, 0xb6d3, 0x8fe4e1,
/* 28 */ 0xc9c5, 0x8fe4e2, 0x8fe4e3, 0xbce2, 0xcfa3,    BAD, 0xeefe, 0xbaf8,
/* 30 */    BAD,    BAD, 0xcfbf, 0x8fe4e4, 0x8fe4e5, 0xefa6, 0x8fe4e6, 0x8fe4e7,
/* 38 */    BAD,    BAD, 0xefa5, 0xefa7,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x920 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xeefd,    BAD,    BAD, 0x8fe4e8,
/* 08 */ 0x8fe4e9, 0x8fe4ea,    BAD, 0xc6e9,    BAD, 0xc5d5,    BAD,    BAD,
/* 10 */ 0x8fe4eb, 0x8fe4ec, 0x8fe4ed,    BAD, 0xc4d7, 0x8fe4ee, 0xefac, 0x8fe4ef,
/* 18 */ 0x8fe4f0,    BAD, 0x8fe4f1, 0xc3c3, 0xefa8,    BAD, 0x8fe4f2,    BAD,
/* 20 */ 0xefa9,    BAD,    BAD,    BAD, 0x8fe4f3, 0x8fe4f4,    BAD, 0x8fe4f5,
/* 28 */    BAD, 0x8fe4f6, 0x8fe4f7,    BAD, 0xb7ad, 0x8fe4f8, 0xefab, 0x8fe4f9,
/* 30 */ 0x8fe4fa, 0x8fe4fb,    BAD, 0x8fe4fc, 0x8fe4fd, 0xb8b0, 0x8fe4fe,    BAD,
/* 38 */    BAD,    BAD, 0x8fe5a1,    BAD, 0xefaa, 0x8fe5a2, 0xbee1, 0x8fe5a3
},

/* Row 0x921 */
{
/* 00 */ 0x8fe5a4, 0x8fe5a5, 0x8fe5a6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8fe5a7,    BAD, 0x8fe5a8, 0x8fe5a9, 0xb3f9, 0x8fe5aa,    BAD, 0x8fe5ab,
/* 10 */    BAD,    BAD, 0x8fe5ac,    BAD, 0xefb0, 0x8fe5ad, 0xbabf, 0xc1f9,
/* 18 */ 0x8fe5ae,    BAD, 0xc4ca, 0x8fe5af,    BAD,    BAD, 0x8fe5b0,    BAD,
/* 20 */    BAD, 0x8fe5b1,    BAD, 0x8fe5b2, 0x8fe5b3,    BAD, 0x8fe5b4, 0xb3bb,
/* 28 */ 0x8fe5b5, 0x8fe5bb,    BAD, 0x8fe5b6, 0xefae, 0xefaf, 0xc4c3,    BAD,
/* 30 */ 0xefad,    BAD,    BAD,    BAD, 0x8fe5b7, 0x8fe5b8, 0x8fe5b9,    BAD,
/* 38 */    BAD, 0xefb1, 0x8fe5ba,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x922 */
{
/* 00 */    BAD, 0x8fe5bc,    BAD, 0xefb7, 0x8fe5bd, 0x8fe5be, 0x8fe5bf, 0x8fe5c0,
/* 08 */ 0xefba, 0x8fe5c1, 0x8fe5c2, 0x8fe5c3, 0x8fe5c4, 0x8fe5c5,    BAD,    BAD,
/* 10 */ 0xefb9, 0xc5ad,    BAD, 0x8fe5c6,    BAD,    BAD, 0xefb2, 0xefb3,
/* 18 */ 0xefb6, 0x8fe5c7,    BAD,    BAD, 0x8fe5c8, 0xefb8, 0x8fe5c9, 0x8fe5ca,
/* 20 */    BAD, 0xb6c0, 0x8fe5cb,    BAD, 0xefbb, 0xefb5, 0x8fe5cc, 0x8fe5cd,
/* 28 */ 0xefb4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fe5cf,
/* 38 */ 0x8fe5d0, 0x8fe5ce, 0x8fe5d1, 0x8fe5d2,    BAD, 0x8fe5d3,    BAD,    BAD
},

/* Row 0x923 */
{
/* 00 */    BAD, 0x8fe5d4, 0x8fe5d5, 0xefbf, 0x8fe5d6,    BAD,    BAD, 0xefc0,
/* 08 */ 0x8fe5d7, 0x8fe5d8,    BAD,    BAD,    BAD, 0x8fe5d9, 0x8fe5da, 0x8fe5db,
/* 10 */ 0xefc1,    BAD,    BAD, 0xefbe, 0xefbd, 0x8fe5dc, 0x8fe5dd, 0x8fe5de,
/* 18 */ 0xbee2, 0xc6aa, 0xefbc,    BAD,    BAD,    BAD,    BAD, 0x8fe5df,
/* 20 */    BAD, 0xefc5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xefc3,    BAD,    BAD, 0x8fe5e0, 0x8fe5e1,
/* 30 */    BAD, 0x8fe5e2, 0x8fe5e3, 0x8fe5e4, 0x8fe5e5, 0xefc4, 0xefc2,    BAD,
/* 38 */ 0xc2f8,    BAD, 0xefc6, 0x8fe5e6,    BAD, 0x8fe5e8,    BAD, 0x8fe5e7
},

/* Row 0x924 */
{
/* 00 */    BAD, 0xefc7,    BAD, 0x8fe5e9, 0xefc9, 0x8fe5ea,    BAD,    BAD,
/* 08 */ 0x8fe5eb,    BAD, 0x8fe5ec,    BAD, 0x8fe5ed,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xb4d5, 0xefc8, 0xccfa,    BAD, 0x8fe5ee,    BAD,    BAD,
/* 18 */    BAD, 0x8fe5ef, 0xefd4, 0xefca, 0x8fe5f0,    BAD, 0xefcd, 0x8fe5f1,
/* 20 */ 0xefcb, 0x8fe5f2, 0xefcc, 0x8fe5f3,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8fe5f4,    BAD, 0xefce, 0x8fe5f5,    BAD, 0x8fe5f6, 0x8fe5f7, 0x8fe5f8,
/* 30 */ 0xefd0, 0x8fe5f9, 0x8fe5fa,    BAD,    BAD, 0xefd1,    BAD, 0xefd2,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xefd5, 0xefd3, 0xefd6, 0xefd8
},

/* Row 0x925 */
{
/* 00 */    BAD, 0xefd7,    BAD, 0x8fe5fc, 0x8fe5fb,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x926 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4b9,
/* 38 */ 0x8fe5fd, 0x8fe5fe,    BAD,    BAD,    BAD,    BAD, 0x8fe6a1,    BAD
},

/* Row 0x927 */
{
/* 00 */ 0xcce7,    BAD, 0xefd9, 0xc1ae, 0x8fe6a2,    BAD,    BAD, 0xefda,
/* 08 */ 0x8fe6a3, 0xcac4, 0xefdb, 0xb3ab, 0x8fe6a4, 0x8fe6a5, 0x8fe6a6, 0xb1bc,
/* 10 */    BAD, 0xb4d7,    BAD, 0xb4d6, 0xefdc,    BAD, 0xefdd,    BAD,
/* 18 */ 0xefde, 0xefdf,    BAD,    BAD,    BAD, 0x8fe6a7, 0x8fe6a8, 0x8fe6a9,
/* 20 */ 0xefe0, 0x8fe6aa, 0xb4d8, 0xb3d5, 0xb9de, 0xc8b6, 0x8fe6ab, 0xefe2,
/* 28 */ 0xefe1, 0x8fe6ac,    BAD, 0x8fe6ad, 0x8fe6ae, 0xefe3,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xb1dc,    BAD, 0x8fe6af,    BAD, 0x8fe6b0,    BAD,
/* 38 */    BAD, 0xefe6, 0x8fe6b1, 0xefe5, 0xefe4, 0x8fe6b2, 0xefe7, 0x8fe6b3
},

/* Row 0x928 */
{
/* 00 */    BAD,    BAD,    BAD, 0xefea,    BAD,    BAD, 0x8fe6b4, 0xb0c7,
/* 08 */ 0x8fe6b5, 0x8fe6b6, 0xefe8, 0x8fe6b7, 0xefec, 0xefeb,    BAD,    BAD,
/* 10 */ 0x8fe6b8, 0x8fe6b9, 0x8fe6ba, 0x8fe6bb, 0xefee, 0xefed, 0xefef,    BAD,
/* 18 */ 0xc6ae, 0x8fe6bc, 0x8fe6bd,    BAD, 0xeff0, 0x8fe6be, 0x8fe6bf, 0x8fe6c0,
/* 20 */ 0x8fe6c1, 0xeff1, 0xeff3,    BAD, 0x8fe6c2, 0xeff2, 0x8fe6c3,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x929 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xc9ec, 0x8fe6c4, 0x8fe6c5,    BAD,
/* 20 */    BAD, 0xeff4, 0x8fe6c6,    BAD, 0x8fe6c7, 0x8fe6c8, 0x8fe6c9,    BAD,
/* 28 */ 0xeff5,    BAD, 0xbae5,    BAD, 0x8fe6ca,    BAD, 0xeff6, 0xeff7,
/* 30 */    BAD, 0x8fe6cb, 0xcbc9, 0x8fe6cc,    BAD,    BAD,    BAD, 0x8fe6cd,
/* 38 */ 0x8fe6ce, 0x8fe6cf, 0x8fe6d0, 0xc1cb, 0x8fe6d1, 0x8fe6d2,    BAD, 0xb0a4
},

/* Row 0x92a */
{
/* 00 */ 0xc2cb, 0x8fe6d3, 0xeff8,    BAD, 0xc9ed,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xeffb, 0xeff9, 0xb9df,    BAD, 0xeffa,
/* 10 */ 0xb8c2,    BAD, 0x8fe6d4,    BAD, 0x8fe6d5,    BAD, 0x8fe6d6, 0x8fe6d7,
/* 18 */ 0x8fe6d8,    BAD,    BAD, 0xcac5, 0xeffd, 0xf0a1, 0xeffe, 0xf0a2,
/* 20 */    BAD, 0x8fe6d9, 0xb1a1, 0xbfd8, 0xbdfc, 0xb4d9, 0xf0a3,    BAD,
/* 28 */    BAD,    BAD, 0xc7e6,    BAD, 0xf0a5,    BAD, 0x8fe6da,    BAD,
/* 30 */ 0xb1a2,    BAD, 0xf0a4, 0xc4c4, 0x8fe6db, 0xcecd, 0xc6ab, 0xeffc,
/* 38 */ 0xcea6,    BAD, 0xb8b1, 0x8fe6dc, 0x8fe6dd, 0xcddb, 0x8fe6de, 0x8fe6df
},

/* Row 0x92b */
{
/* 00 */    BAD, 0x8fe6e0, 0x8fe6e1, 0x8fe6e2, 0x8fe6e3, 0xb6f9, 0xceb4,    BAD,
/* 08 */ 0xb7a8, 0x8fe6e4, 0xc2e2, 0xe7a1,    BAD, 0xf0a6, 0xb3ac, 0xbfef,
/* 10 */    BAD, 0x8fe6e5,    BAD,    BAD, 0xb3d6, 0xf0a8, 0x8fe6e6, 0xf0a9,
/* 18 */ 0xf0a7, 0xb7e4, 0x8fe6e7, 0xbadd, 0xbee3, 0x8fe6e8,    BAD, 0x8fe6e9,
/* 20 */ 0xb1a3,    BAD,    BAD, 0xced9, 0x8fe6ea, 0x8fe6eb, 0x8fe6ec, 0xf0ab,
/* 28 */ 0xeeae, 0x8fe6ed, 0xf0aa,    BAD,    BAD,    BAD, 0x8fe6ee, 0x8fe6ef,
/* 30 */ 0xf0ae, 0xf0ac, 0xf0ad, 0x8fe6f0, 0xf0af,    BAD, 0xf0b0, 0xceec,
/* 38 */ 0xf0b1, 0xf0b2, 0x8fe6f1, 0xc0c9, 0xc8bb,    BAD,    BAD,    BAD
},

/* Row 0x92c */
{
/* 00 */ 0xbffd, 0xb4e7,    BAD,    BAD, 0xcdba, 0xb2ed, 0xbdb8, 0xb8db,
/* 08 */    BAD, 0xf0b5, 0x8fe6f2, 0xf0b4, 0xbbf3, 0xf0b6, 0xf0b3,    BAD,
/* 10 */    BAD, 0xbba8, 0x8fe6f3,    BAD,    BAD, 0xf0ba, 0xeaad,    BAD,
/* 18 */ 0x8fe6f5, 0xd2d6, 0x8fe6f6, 0xbff7, 0xf0b8, 0x8fe6f7, 0x8fe6f8, 0x8fe6f9,
/* 20 */    BAD,    BAD, 0xcea5, 0xc6f1,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb1ab, 0x8fe6fa, 0xc0e3, 0xbcb6,    BAD,    BAD,    BAD, 0x8fe6fb,
/* 30 */ 0xcab7, 0x8fe6fc, 0xb1c0,    BAD,    BAD,    BAD, 0xceed, 0xcdeb,
/* 38 */    BAD, 0xf0bb, 0x8fe6fd, 0xc5c5,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x92d */
{
/* 00 */ 0xbcfb,    BAD, 0x8fe6fe, 0x8fe7a1, 0xf0bc, 0x8fe7a2, 0xf0bd, 0xbfcc,
/* 08 */ 0xf0be, 0x8fe7a3, 0xceee,    BAD,    BAD, 0xf0b9, 0xf0c0, 0xf0c2,
/* 10 */    BAD, 0xf0c1,    BAD, 0xf0bf,    BAD,    BAD, 0xf0c3,    BAD,
/* 18 */    BAD, 0xf0c4, 0x8fe7a4, 0x8fe7a5, 0xc1fa, 0x8fe7a6, 0xb2e2,    BAD,
/* 20 */    BAD, 0x8fe7a7, 0x8fe7a8, 0x8fe7a9, 0xf0c5,    BAD,    BAD, 0xccb8,
/* 28 */ 0x8fe7aa,    BAD, 0xf0c6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xf0c7, 0x8fe7ab, 0xcfaa, 0x8fe7ac,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xdbb1, 0xf0c8,    BAD,    BAD,    BAD, 0xf0c9, 0xf0ca,    BAD
},

/* Row 0x92e */
{
/* 00 */    BAD, 0x8fe7ad, 0xf0ce, 0x8fe7ae, 0xf0cb,    BAD, 0xf0cc,    BAD,
/* 08 */ 0xf0cd, 0xf0cf, 0x8fe7af,    BAD,    BAD,    BAD, 0x8fe7b0, 0x8fe7b1,
/* 10 */    BAD,    BAD, 0xc0c4,    BAD,    BAD, 0x8fe7b2, 0xccf7, 0x8fe7b3,
/* 18 */ 0x8fe7b4, 0xc0c5, 0x8fe7b5, 0x8fe7b6, 0xf0d0,    BAD, 0xc8f3,    BAD,
/* 20 */ 0xf0d1, 0xf3d3, 0xcccc, 0x8fe7b7, 0xf0d2,    BAD, 0xf0d3, 0x8fe7b8,
/* 28 */ 0xf0d4, 0xb3d7, 0x8fe7b9, 0xf0d6,    BAD, 0xbfd9, 0x8fe7ba,    BAD,
/* 30 */    BAD, 0xf0d7,    BAD, 0x8fe7bb, 0xb7a4,    BAD, 0x8fe7bc, 0x8fe7bd,
/* 38 */ 0x8fe7be, 0xf0d8, 0xf0dc, 0x8fe7bf, 0xf0da, 0x8fe7c0,    BAD, 0x8fe7c1
},

/* Row 0x92f */
{
/* 00 */ 0x8fe7c2, 0xf0db,    BAD,    BAD, 0xb3f3, 0xf0d9, 0xf0dd,    BAD,
/* 08 */    BAD, 0x8fe7c3,    BAD, 0xf0de,    BAD, 0xb0c8,    BAD, 0xf0df,
/* 10 */ 0xf0e0,    BAD,    BAD,    BAD,    BAD, 0x8fe7c4, 0x8fe7c5, 0x8fe7c6,
/* 18 */ 0xbee4, 0x8fe7c7, 0x8fe7c8,    BAD, 0xf0e1,    BAD, 0x8fe7c9, 0x8fe7ca,
/* 20 */ 0xb5c7,    BAD, 0x8fe7cb, 0xf0e4,    BAD,    BAD, 0xf0e3,    BAD,
/* 28 */ 0xf0e2,    BAD,    BAD, 0xebf1, 0x8fe7cc, 0xcadc, 0x8fe7cd,    BAD,
/* 30 */    BAD, 0x8fe7ce, 0x8fe7cf, 0xf0e5, 0xf0e6, 0x8fe7d0, 0x8fe7d1,    BAD,
/* 38 */ 0x8fe7d2, 0x8fe7d3, 0x8fe7d4,    BAD, 0x8fe7d5,    BAD, 0x8fe7d6, 0x8fe7d7
},

/* Row 0x930 */
{
/* 00 */    BAD, 0x8fe7d8,    BAD, 0xf0e7, 0x8fe7d9, 0x8fe7da, 0xf0e8, 0x8fe7db,
/* 08 */ 0xf0e9, 0x8fe7dc, 0x8fe7dd, 0xf0ea, 0x8fe7de, 0x8fe7df, 0x8fe7e0,    BAD,
/* 10 */ 0x8fe7e1, 0x8fe7e2,    BAD, 0xb4da, 0x8fe7e3,    BAD,    BAD, 0x8fe7e4,
/* 18 */ 0x8fe7e5, 0x8fe7e6,    BAD, 0x8fe7ea, 0xf0eb, 0x8fe7e7, 0x8fe7e8,    BAD,
/* 20 */ 0x8fe7e9, 0x8fe7eb,    BAD,    BAD, 0x8fe7ec,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf0ec, 0xc7a3, 0x8fe7ed,
/* 30 */    BAD, 0x8fe7ee, 0xf0ee, 0xb2bb, 0x8fe7ef, 0xf0f1, 0xf0f0, 0x8fe7f0,
/* 38 */ 0x8fe7f1,    BAD, 0x8fe7f2, 0xb1a4,    BAD,    BAD,    BAD, 0xb6c1
},

/* Row 0x931 */
{
/* 00 */    BAD, 0xcac7, 0xc4ba, 0xbaa2,    BAD, 0xb9e0, 0xbde7, 0x8fe7f3,
/* 08 */ 0xbfdc,    BAD, 0x8fe7f4,    BAD, 0xf0f3, 0x8fe7f6, 0x8fe7f7, 0xf0f2,
/* 10 */ 0xcdc2, 0xb4e8, 0xc8d2, 0xc6dc, 0x8fe7f8,    BAD, 0x8fe7f9, 0xbffc,
/* 18 */ 0xcece, 0x8fe7f5, 0xb7db,    BAD, 0x8fe7fa,    BAD, 0x8fe7fb,    BAD,
/* 20 */ 0x8fe7fc, 0xf0f6,    BAD, 0x8fe7fd, 0xf0f5, 0x8fe8a8, 0x8fe7fe,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8fe8a1, 0xcbcb, 0xc6ac, 0x8fe8a2, 0x8fe8a3,
/* 30 */ 0x8fe8a4,    BAD, 0x8fe8a5, 0x8fe8a6, 0xb1d0, 0x8fe8a7,    BAD, 0xf0f7,
/* 38 */ 0xf0f4,    BAD,    BAD, 0xc9d1, 0xcdea, 0xf0f8, 0x8fe8a9,    BAD
},

/* Row 0x932 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x8fe8aa,    BAD, 0xf0f9, 0x8fe8ab,
/* 08 */    BAD,    BAD, 0x8fe8ac, 0xf0fb, 0xc2ea, 0xb3db, 0xb3dc, 0xf0fa,
/* 10 */    BAD, 0x8fe8ad, 0x8fe8ae, 0x8fe8af, 0xb4e9, 0xb8b2, 0x8fe8b0, 0x8fe8b1,
/* 18 */ 0xb4ea, 0x8fe8b2, 0x8fe8b3, 0xc5bf,    BAD,    BAD, 0xcee0,    BAD,
/* 20 */    BAD,    BAD, 0x8fe8b4, 0x8fe8b5,    BAD, 0x8fe8b6, 0x8fe8b7, 0xb8dc,
/* 28 */    BAD,    BAD, 0x8fe8b8, 0xf0fc, 0x8fe8b9,    BAD,    BAD, 0xf0fd,
/* 30 */ 0xf0fe, 0xf1a1,    BAD, 0xf1a3, 0xf1a2,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x933 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xc9f7,    BAD, 0xf1a4, 0x8fe8ba,    BAD, 0x8fe8bb, 0x8fe8bc, 0xf1a5,
/* 30 */ 0x8fe8bd, 0xf1a6,    BAD,    BAD, 0x8fe8be,    BAD, 0xf1a7, 0x8fe8bf,
/* 38 */ 0x8fe8c0,    BAD, 0x8fe8c1, 0x8fe8c2,    BAD,    BAD,    BAD, 0x8fe8c3
},

/* Row 0x934 */
{
/* 00 */    BAD,    BAD, 0x8fe8c4, 0xf1a9, 0xf1a8, 0x8fe8c5, 0xf1aa,    BAD,
/* 08 */ 0x8fe8c6,    BAD,    BAD,    BAD, 0x8fe8c7,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xc8f4, 0xe6cc,    BAD,    BAD, 0xbfa9,
/* 20 */    BAD, 0x8fe8c8, 0xb5b2, 0x8fe8c9,    BAD, 0x8fe8ca, 0x8fe8cb, 0x8fe8cc,
/* 28 */    BAD, 0xf1ab, 0x8fe8cd, 0xf1ac,    BAD, 0xd2ac, 0xddbb, 0xc8d3,
/* 30 */    BAD,    BAD, 0xb0fb, 0x8fe8ce, 0xb0bb,    BAD, 0x8fe8cf,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xbbf4, 0xcbb0, 0xbefe,    BAD
},

/* Row 0x935 */
{
/* 00 */    BAD,    BAD, 0x8fe8d0, 0xf1ad,    BAD, 0xccdf,    BAD, 0x8fe8d1,
/* 08 */ 0x8fe8d2, 0xf1ae, 0xcddc,    BAD, 0xb1c2,    BAD,    BAD,    BAD,
/* 10 */ 0xbbc1, 0x8fe8d3, 0xf1af, 0xb2ee, 0xf1b0, 0x8fe8d4, 0x8fe8d5, 0x8fe8d6,
/* 18 */ 0xf1b1,    BAD, 0x8fe8d7, 0x8fe8d8, 0x8fe8d9, 0xf1b3, 0xf1b4, 0x8fe8da,
/* 20 */ 0xf1b6, 0xf1b2, 0x8fe8db,    BAD, 0xf1b5,    BAD, 0x8fe8dc, 0x8fe8dd,
/* 28 */ 0xb4db,    BAD,    BAD, 0x8fe8de, 0xf1b7,    BAD, 0xf1b8,    BAD,
/* 30 */    BAD, 0x8fe8df, 0x8fe8e0, 0x8fe8e1, 0x8fe8e2, 0x8fe8e3,    BAD,    BAD,
/* 38 */    BAD, 0x8fe8e4, 0x8fe8e5, 0x8fe8e6, 0x8fe8e7, 0xf1b9, 0xf1ba,    BAD
},

/* Row 0x936 */
{
/* 00 */ 0x8fe8e8, 0x8fe8e9, 0xf1bb,    BAD,    BAD, 0xf1bd, 0x8fe8ea, 0x8fe8eb,
/* 08 */ 0x8fe8ec, 0xf1bc,    BAD, 0xf1bf, 0xf1c2, 0x8fe8ed, 0x8fe8ee,    BAD,
/* 10 */ 0xf1be, 0xf1c0, 0xf1c1,    BAD, 0x8fe8ef, 0xf1c3,    BAD, 0xb6c2,
/* 18 */ 0x8fe8f0, 0x8fe8f1,    BAD, 0x8fe8f2, 0x8fe8f3,    BAD, 0x8fe8f4, 0x8fe8f5,
/* 20 */ 0x8fe8f6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x937 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbcf3, 0xf1c4,
/* 18 */ 0xf1c5, 0xb9e1,    BAD, 0x8fe8f7,    BAD, 0x8fe8f8,    BAD, 0x8fe8f9,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1c6, 0x8fe8fa,    BAD,
/* 28 */ 0xb3be,    BAD,    BAD,    BAD, 0xc7cf, 0xf1c7, 0xf1c8,    BAD,
/* 30 */ 0x8fe8fb, 0x8fe8fc, 0x8fe8fd, 0xc3da, 0xc6eb, 0x8fe8fe,    BAD,    BAD,
/* 38 */    BAD, 0x8fe9a1, 0x8fe9a2,    BAD, 0xf1c9, 0x8fe9a3,    BAD, 0x8fe9a4
},

/* Row 0x938 */
{
/* 00 */    BAD, 0xc7fd,    BAD, 0x8fe9a5, 0xc2cc, 0xb1d8, 0xb6ee,    BAD,
/* 08 */ 0xb6ef, 0x8fe9a6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xc3f3, 0xf1ce, 0xb6f0, 0x8fe9a7, 0x8fe9a8, 0xb2ef,    BAD,    BAD,
/* 18 */ 0xf1cd, 0x8fe9a9, 0x8fe9aa, 0xf1cb, 0x8fe9ab, 0xf1cc, 0x8fe9ac, 0xf1ca,
/* 20 */    BAD,    BAD, 0xf1d8,    BAD,    BAD,    BAD,    BAD, 0x8fe9ad,
/* 28 */    BAD,    BAD, 0x8fe9ae, 0x8fe9af, 0x8fe9b0, 0xf1cf, 0xf1d0,    BAD,
/* 30 */ 0x8fe9b1, 0xf1d1, 0xf1d2,    BAD, 0x8fe9b2, 0x8fe9b3,    BAD,    BAD,
/* 38 */ 0xf1d4, 0x8fe9b4,    BAD, 0xf1d3,    BAD, 0x8fe9b5, 0x8fe9b6, 0xbdd9
},

/* Row 0x939 */
{
/* 00 */    BAD, 0xf1d5, 0x8fe9b7, 0x8fe9b8, 0x8fe9b9, 0xf1d7,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8fe9ba, 0x8fe9bb,    BAD, 0xb5b3, 0xf1d6,
/* 10 */ 0x8fe9bc, 0x8fe9bd, 0xc1fb, 0xb8b3,    BAD,    BAD, 0x8fe9be,    BAD,
/* 18 */    BAD, 0xf1d9,    BAD,    BAD,    BAD,    BAD, 0x8fe9bf,    BAD,
/* 20 */ 0x8fe9c0,    BAD, 0x8fe9c1, 0x8fe9c2, 0x8fe9c3,    BAD,    BAD, 0x8fe9c4,
/* 28 */ 0xc2cd,    BAD,    BAD, 0xf1da,    BAD, 0x8fe9c5, 0x8fe9c6,    BAD,
/* 30 */ 0xc6ad,    BAD,    BAD, 0x8fe9c7,    BAD, 0x8fe9c8, 0x8fe9c9, 0xf1db,
/* 38 */ 0x8fe9ca,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1e0,    BAD
},

/* Row 0x93a */
{
/* 00 */ 0xf1de, 0x8fe9cc, 0xf1dd, 0xf1df, 0x8fe9cd, 0xf1dc,    BAD, 0x8fe9cb,
/* 08 */    BAD,    BAD, 0x8fe9ce, 0x8fe9cf, 0x8fe9d0, 0xf1e2, 0x8fe9d1,    BAD,
/* 10 */    BAD, 0x8fe9d2,    BAD,    BAD, 0x8fe9d3, 0xf1e1, 0x8fe9d4, 0xf1e4,
/* 18 */    BAD,    BAD, 0xb6c3, 0xf1e3,    BAD, 0x8fe9d5,    BAD, 0xf1e5,
/* 20 */    BAD,    BAD, 0xf1e6,    BAD, 0xf1e8, 0xf1e7,    BAD,    BAD,
/* 28 */    BAD, 0xf1e9, 0xf1eb, 0xf1ea,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x93b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb9fc,    BAD, 0x8fe9d6,    BAD, 0x8fe9d7, 0xf1ec, 0x8fe9d8, 0x8fe9d9,
/* 30 */ 0xf1ed,    BAD, 0x8fe9da,    BAD, 0x8fe9db, 0x8fe9dc, 0x8fe9dd,    BAD,
/* 38 */ 0xb3bc, 0x8fe9de,    BAD, 0x8fe9df, 0xf1ee,    BAD, 0x8fe9e0, 0x8fe9e1
},

/* Row 0x93c */
{
/* 00 */ 0xf1ef, 0x8fe9e2,    BAD, 0x8fe9e3, 0xbff1,    BAD, 0x8fe9e4,    BAD,
/* 08 */ 0x8fe9e5,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fe9e6, 0xf1f0,
/* 10 */ 0x8fe9e7, 0xf1f1, 0x8fe9e8, 0xf1f2, 0xf1f3, 0x8fe9e9, 0x8fe9ea, 0x8fe9eb,
/* 18 */ 0xb9e2,    BAD,    BAD, 0x8fe9ec, 0x8fe9ed,    BAD, 0xf1f4, 0xf1f5,
/* 20 */ 0x8fe9ee,    BAD, 0xf1f6, 0xf1f7, 0x8fe9ef, 0x8fe9f0, 0xf1f8, 0x8fe9f1,
/* 28 */    BAD, 0x8fe9f2, 0xc8b1, 0xf1fa, 0x8fe9f3, 0xc9a6, 0xf1fb, 0xf1f9,
/* 30 */    BAD, 0xf1fd, 0x8fe9f4, 0x8fe9f5, 0xf1fc, 0x8fe9f6,    BAD, 0xf1fe,
/* 38 */    BAD, 0x8fe9f7, 0x8fe9f8, 0xf2a1,    BAD, 0x8fe9f9,    BAD, 0x8fe9fa
},

/* Row 0x93d */
{
/* 00 */ 0x8fe9fb, 0x8fe9fc, 0x8fe9fd, 0x8fe9fe, 0x8feaa1, 0x8feaa2, 0xf2a2,    BAD,
/* 08 */ 0x8feaa3, 0x8feaa4,    BAD, 0x8feaa5, 0x8feaa6, 0x8feaa7, 0x8feaa8,    BAD,
/* 10 */ 0x8feaa9,    BAD, 0x8feaaa,    BAD,    BAD,    BAD, 0x8feaab,    BAD,
/* 18 */ 0xf2a3, 0x8feaac, 0xf2a4, 0x8feaad, 0x8feaae,    BAD,    BAD, 0xf2a5,
/* 20 */ 0x8feaaf,    BAD, 0xf2a6, 0xf2a7,    BAD, 0xf2a8, 0x8feab0, 0xf2a9,
/* 28 */ 0xf2aa, 0xf2ab, 0xf2ac, 0x8feab1,    BAD, 0x8feab2, 0xf2ad, 0xf2ae,
/* 30 */    BAD, 0xddb5, 0xf2af, 0x8feab3, 0x8feab4, 0x8feab5,    BAD, 0x8feab6,
/* 38 */    BAD, 0x8feab7, 0x8feab8, 0xe4f8, 0xb5b4, 0x8feab9,    BAD,    BAD
},

/* Row 0x93e */
{
/* 00 */    BAD, 0xb3a1, 0xbab2, 0xf2b1, 0xf2b0, 0xcca5,    BAD,    BAD,
/* 08 */ 0x8feaba,    BAD,    BAD, 0x8feabb, 0x8feabc, 0xf2b3, 0xf2b4, 0xf2b2,
/* 10 */    BAD, 0xf2b5,    BAD,    BAD, 0xcbe2, 0x8feabd, 0x8feabe, 0x8feabf,
/* 18 */ 0xf2b6,    BAD, 0xb5fb, 0x8feac0,    BAD,    BAD, 0x8feac1,    BAD,
/* 20 */    BAD, 0x8feac2,    BAD, 0x8feac3,    BAD, 0x8feac4, 0x8feac5,    BAD,
/* 28 */ 0x8feac6,    BAD, 0x8feac7, 0x8feac8, 0x8feac9, 0x8feaca, 0x8feacb, 0xcfa5,
/* 30 */    BAD,    BAD,    BAD, 0x8feacc, 0xf2b7, 0x8feacd,    BAD, 0x8feace,
/* 38 */ 0x8feacf, 0x8fead0,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fead1
},

/* Row 0x93f */
{
/* 00 */ 0x8fead2,    BAD,    BAD, 0xf2b9, 0x8fead3, 0x8fead4, 0x8fead5, 0x8fead6,
/* 08 */    BAD, 0x8fead7, 0x8fead8, 0x8fead9,    BAD, 0x8feada, 0xb0be, 0x8feadb,
/* 10 */ 0x8feadc, 0xf2ba, 0xcaab, 0xf2b8, 0x8feadd,    BAD, 0xf2bb, 0xf2bc,
/* 18 */    BAD,    BAD, 0x8feade,    BAD,    BAD, 0x8feadf, 0x8feae0, 0xf2bd,
/* 20 */ 0xf2be,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8feae1, 0x8feae2,
/* 28 */ 0xf2bf, 0x8feae3, 0xcbee, 0xbbad, 0x8feae4, 0xbafa, 0xc1af,    BAD,
/* 30 */ 0x8feae5, 0x8feae6, 0x8feae7,    BAD, 0xf2c0,    BAD,    BAD, 0x8feae8,
/* 38 */ 0x8feae9, 0xf2c3,    BAD, 0x8feaea, 0x8feaeb,    BAD, 0x8feaec, 0x8feaed
},

/* Row 0x940 */
{
/* 00 */ 0xf2c1, 0x8feaee,    BAD,    BAD,    BAD,    BAD, 0xf2c4, 0x8feaef,
/* 08 */ 0x8feaf0, 0xb8f1, 0xf2c2,    BAD,    BAD,    BAD, 0x8feaf1, 0xf2c5,
/* 10 */ 0x8feaf2, 0xf2c6, 0xf2c7,    BAD, 0xf2cb,    BAD, 0xbbaa, 0x8feaf3,
/* 18 */ 0x8feaf4,    BAD,    BAD, 0xc2e4,    BAD, 0x8feaf5,    BAD, 0x8feaf6,
/* 20 */    BAD, 0xf2cc, 0xf2c9, 0xf2c8, 0xf2ca, 0x8feaf7,    BAD, 0x8feaf8,
/* 28 */ 0xb7df,    BAD, 0x8feaf9, 0x8feafa,    BAD,    BAD,    BAD, 0x8feafb,
/* 30 */ 0xf2d0, 0xf2cf, 0xf2ce, 0x8feafc,    BAD, 0xb0b3,    BAD, 0x8feafd,
/* 38 */ 0x8feafe, 0x8feba1, 0x8feba2,    BAD,    BAD, 0x8feba3,    BAD, 0x8feba4
},

/* Row 0x941 */
{
/* 00 */ 0x8feba5,    BAD, 0x8feba6,    BAD, 0xf2da,    BAD, 0xf2d6,    BAD,
/* 08 */ 0xf2d7, 0xf2d3, 0xf2d9, 0x8feba7, 0xf2d5, 0xb3e2,    BAD, 0x8feba8,
/* 10 */ 0xcfcc, 0x8feba9, 0xf2d8, 0xf2d4, 0xf2d2, 0xf2d1, 0x8febaa,    BAD,
/* 18 */ 0x8febab, 0x8febac, 0x8febad, 0xf2dc, 0x8febae,    BAD, 0x8febaf,    BAD,
/* 20 */    BAD, 0xf2df, 0x8febb0, 0x8febb1, 0xf2de, 0xf2dd, 0x8febb2, 0x8febb3,
/* 28 */ 0x8febb4, 0x8febb5, 0x8febb6,    BAD,    BAD, 0xc9c9, 0xf2db, 0xb0f3,
/* 30 */ 0xf2e0, 0x8febb7, 0xf2e2,    BAD,    BAD, 0x8febb8, 0x8febb9, 0x8febba,
/* 38 */    BAD, 0xb3ef, 0xf2cd, 0xb1b7,    BAD, 0x8febbb, 0xf2e4,    BAD
},

/* Row 0x942 */
{
/* 00 */    BAD, 0x8febbc,    BAD, 0x8febbd, 0x8febbe, 0x8febbf, 0xf2e3, 0xf2e1,
/* 08 */ 0xc3ad, 0x8febc0, 0x8febc1,    BAD,    BAD,    BAD, 0x8febc2, 0x8febc3,
/* 10 */ 0x8febc4,    BAD, 0xcbf0, 0x8febc5, 0x8febc6,    BAD, 0x8febc7, 0xceda,
/* 18 */ 0x8febc8,    BAD, 0xf2e5, 0x8febc9, 0x8febd0, 0x8febca, 0x8febcb, 0x8febcc,
/* 20 */ 0xf2e6,    BAD,    BAD, 0x8febcd,    BAD,    BAD,    BAD, 0xf2e7,
/* 28 */ 0x8febd2, 0x8febce, 0x8febcf, 0x8febd1,    BAD,    BAD, 0x8febd3,    BAD,
/* 30 */ 0x8febd4,    BAD, 0x8febd5,    BAD,    BAD, 0x8febd6, 0xf2e8, 0x8febd7,
/* 38 */ 0xf2e9,    BAD,    BAD, 0x8febd8,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x943 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4bb, 0x8febd9, 0xf2ea,
/* 28 */    BAD, 0xc8b7,    BAD, 0xf2ef, 0xf2eb,    BAD,    BAD,    BAD,
/* 30 */ 0xf2ec,    BAD, 0x8febda, 0xcbb1, 0xccc4,    BAD, 0xc6d0, 0x8febdb,
/* 38 */    BAD, 0x8febdc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x944 */
{
/* 00 */    BAD,    BAD, 0x8febde, 0xf2f0,    BAD,    BAD, 0xf2f1, 0xc6be,
/* 08 */ 0xf2ee, 0xf2ed,    BAD, 0x8febdd,    BAD,    BAD, 0xb2aa,    BAD,
/* 10 */    BAD, 0x8febdf, 0xf2f9,    BAD,    BAD, 0xf2f8,    BAD, 0x8febe0,
/* 18 */ 0x8febe1,    BAD,    BAD, 0xb1f5, 0x8febe2, 0x8febe3, 0x8febe4, 0xf2f6,
/* 20 */    BAD,    BAD,    BAD, 0xf2f5,    BAD,    BAD, 0xf2f3,    BAD,
/* 28 */ 0xb3fb,    BAD, 0xf2f2, 0xbcb2, 0xb2a9,    BAD,    BAD, 0x8febe5,
/* 30 */ 0x8febe6,    BAD, 0x8febe7, 0x8febe8, 0x8febe9,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8febea, 0xb9e3, 0x8febeb, 0x8febed, 0xf2fc, 0xf2fb
},

/* Row 0x945 */
{
/* 00 */    BAD, 0xf2fa, 0x8febee, 0x8febef, 0xf2f7, 0x8febec, 0xf2fd, 0x8febf0,
/* 08 */ 0xf2fe,    BAD, 0x8febf1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xf3a5, 0xf3a4,    BAD, 0x8febf2, 0x8febf3,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xf3a6,    BAD,    BAD, 0xb1ad, 0xf3a1, 0xf3a2, 0x8febf4,
/* 20 */ 0xb9f4, 0xccb9, 0x8febf6, 0x8febf5, 0xf3a3, 0x8febf7,    BAD,    BAD,
/* 28 */    BAD, 0x8febf8, 0x8febf9, 0x8febfa, 0xcbb2,    BAD,    BAD, 0xf3ab,
/* 30 */ 0x8febfb,    BAD, 0xf3a7,    BAD,    BAD,    BAD, 0x8febfc, 0x8febfd,
/* 38 */    BAD,    BAD, 0xf3ac, 0x8febfe, 0x8feca1,    BAD, 0x8feca2,    BAD
},

/* Row 0x946 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8feca3, 0x8feca4,    BAD, 0x8feca5, 0xf3a9,
/* 08 */    BAD, 0xf3a8, 0x8feca6,    BAD,    BAD, 0x8feca7, 0x8feca8, 0xb7dc,
/* 10 */    BAD,    BAD, 0x8feca9, 0x8fecaa,    BAD, 0x8fecab, 0x8fecac, 0x8fecad,
/* 18 */ 0x8fecae,    BAD, 0xf3ad,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8fecaf,    BAD,    BAD, 0xf3ae,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xf3af, 0x8fecb0, 0xf3aa, 0x8fecb1,    BAD, 0x8fecb2, 0xf2f4,
/* 30 */    BAD, 0x8fecb3, 0xf3b0,    BAD, 0xc4e1, 0x8fecb4,    BAD,    BAD,
/* 38 */ 0xf3b4, 0x8fecb5, 0xf3b5, 0xf3b3, 0x8fecb6,    BAD,    BAD, 0x8fecb7
},

/* Row 0x947 */
{
/* 00 */    BAD, 0xf3b2, 0xf3b8, 0x8fecb8, 0xf3b1,    BAD, 0xf3b6, 0x8fecb9,
/* 08 */    BAD, 0x8fecba, 0x8fecbb,    BAD,    BAD,    BAD,    BAD, 0xf3b7,
/* 10 */    BAD,    BAD,    BAD, 0xf3ba, 0x8fecbc, 0x8fecbd, 0x8fecbe, 0x8fecbf,
/* 18 */    BAD, 0xf3b9, 0x8fecc0,    BAD,    BAD,    BAD, 0x8fecc1, 0x8fecc2,
/* 20 */ 0x8fecc3,    BAD,    BAD,    BAD,    BAD, 0x8fecc4, 0xf3bc, 0x8fecc5,
/* 28 */    BAD, 0x8fecc6,    BAD, 0x8fecc7,    BAD, 0xf3bd, 0x8fecc8, 0xf3be,
/* 30 */ 0x8fecc9,    BAD, 0xcfc9, 0x8fecca, 0x8feccb,    BAD,    BAD,    BAD,
/* 38 */ 0xf3bb, 0xc2eb, 0xbaed,    BAD,    BAD, 0xf3bf, 0x8feccc,    BAD
},

/* Row 0x948 */
{
/* 00 */    BAD,    BAD, 0x8fecce,    BAD,    BAD,    BAD,    BAD, 0x8feccf,
/* 08 */    BAD,    BAD, 0x8feccd,    BAD,    BAD,    BAD, 0x8fecd0,    BAD,
/* 10 */ 0x8fecd1, 0x8fecd2, 0x8fecd3,    BAD,    BAD, 0x8fecd4, 0x8fecd5,    BAD,
/* 18 */    BAD, 0x8fecd6, 0xf3c0, 0xf3c1, 0x8fecd7, 0x8fecd8, 0xf3c2,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x949 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf3c3,    BAD,    BAD,
/* 38 */ 0xb8b4, 0xf3c4, 0x8fecd9, 0x8fecda, 0x8fecdb, 0xf3c5,    BAD, 0xbcaf
},

/* Row 0x94a */
{
/* 00 */ 0x8fecdc, 0xf3c6, 0x8fecdd, 0x8fecde, 0x8fecdf, 0x8fece0,    BAD, 0x8fece1,
/* 08 */ 0xf3c7,    BAD,    BAD, 0xf3c8, 0xf3c9,    BAD, 0x8fece2, 0x8fece3,
/* 10 */    BAD, 0xf3cc, 0xf3ca, 0xcfbc,    BAD, 0xf3cb, 0x8fece4, 0xceef,
/* 18 */ 0x8fece5,    BAD,    BAD, 0x8fece6,    BAD, 0xf3cd, 0x8fece7, 0xcedb,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8fece8, 0xf3ce, 0xc7fe,    BAD,
/* 28 */ 0x8fece9, 0xf3cf, 0xf3d1,    BAD, 0x8fecea, 0xf3d2, 0x8feceb, 0x8fecec,
/* 30 */ 0x8feced,    BAD,    BAD, 0x8fecee, 0x8fecef, 0x8fecf0,    BAD,    BAD,
/* 38 */ 0xf3d0, 0xb9ed, 0xcccd, 0xcbe3, 0xd6f7,    BAD, 0xdde0, 0xcbfb
},

/* Row 0x94b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb2ab,    BAD, 0x8fecf1,    BAD,
/* 08 */ 0x8fecf2,    BAD,    BAD, 0x8fecf3, 0xf3d4, 0xb5d0, 0xf3d5, 0xf3d6,
/* 10 */ 0xf3d7,    BAD, 0xb9f5,    BAD, 0xf3d8, 0x8fecf4,    BAD,    BAD,
/* 18 */ 0xe0d4, 0xccdb,    BAD, 0xc2e3, 0xf3d9, 0xf3db, 0xf3da, 0x8fecf5,
/* 20 */ 0xf3dc,    BAD,    BAD,    BAD, 0x8fecf6, 0xf3dd,    BAD, 0x8fecf7,
/* 28 */ 0xf3de,    BAD,    BAD,    BAD, 0x8fecf8, 0x8fecf9, 0x8fecfa, 0xf3df,
/* 30 */ 0x8fecfb, 0x8fecfc, 0x8fecfd,    BAD, 0xf3e0, 0x8fecfe, 0xf3e1, 0xf3e2,
/* 38 */ 0x8feda1, 0xf3e3,    BAD, 0xf3e4, 0xf3e5, 0xf3e6,    BAD, 0x8feda2
},

/* Row 0x94c */
{
/* 00 */    BAD,    BAD, 0x8feda3, 0x8feda4,    BAD,    BAD,    BAD, 0xf3e7,
/* 08 */ 0xf3e8, 0x8feda5,    BAD,    BAD,    BAD,    BAD, 0xc5a4, 0x8feda6,
/* 10 */ 0x8feda7, 0x8feda8, 0x8feda9, 0xb8dd, 0x8fedaa, 0xf3ea, 0x8fedab, 0x8fedac,
/* 18 */    BAD, 0x8fedad, 0x8fedae, 0x8fedaf,    BAD,    BAD,    BAD, 0x8fedb0,
/* 20 */ 0xc1cd, 0xf3eb, 0x8fedb1,    BAD,    BAD,    BAD, 0x8fedb2,    BAD,
/* 28 */    BAD,    BAD, 0x8fedb3, 0x8fedb4, 0xf3ec,    BAD,    BAD, 0x8fedb5,
/* 30 */    BAD, 0x8fedb6, 0x8fedb7,    BAD, 0x8fedb8,    BAD,    BAD, 0x8fedb9,
/* 38 */    BAD, 0x8fedba, 0x8fedbb, 0xc9a1, 0x8fedbc, 0x8fedbd, 0xf3ed, 0x8fedbe
},

/* Row 0x94d */
{
/* 00 */    BAD, 0x8fedbf,    BAD, 0x8fedc0, 0x8fedc1, 0x8fedc2, 0x8fedc3, 0x8fedc4,
/* 08 */    BAD,    BAD, 0xf3ee, 0xe3b7,    BAD,    BAD, 0xecda, 0xf0ed,
/* 10 */    BAD,    BAD, 0xf3ef, 0x8fedc5, 0xf3f0, 0x8fedc6, 0x8fedc7, 0x8fedc8,
/* 18 */ 0x8fedc9,    BAD, 0x8fedca,    BAD,    BAD, 0x8fedcb, 0x8fedcc, 0xf3f2,
/* 20 */ 0xf3f3, 0xf3f4, 0xcef0, 0xf3f1,    BAD,    BAD, 0xf3f5, 0xf3f6,
/* 28 */ 0x8fedcd, 0x8fedce, 0xf3f8,    BAD, 0xf3f7, 0x8fedcf, 0x8fedd0, 0x8fedd1,
/* 30 */ 0x8fedd2, 0x8fedd3, 0xf3fa, 0x8fedd4,    BAD, 0x8fedd5, 0xf3fb, 0xf3f9,
/* 38 */    BAD,    BAD, 0x8fedd6,    BAD,    BAD, 0x8fedd7,    BAD,    BAD
},

/* Row 0x94e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xceb6,    BAD, 0x8fedd8,
/* 10 */ 0x8fedd9, 0x8fedda, 0x8feddb,    BAD, 0x8feddc, 0xf3fc, 0x8feddd, 0x8fedde,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xf3fd, 0xe3d4, 0x8feddf,    BAD,
/* 20 */ 0xf3fe, 0x8fede0, 0x8fede1, 0x8fede2,    BAD, 0x8fede3,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x94f */
{
/* 00 */ 0xf4dc, 0xf4dd, 0xf4de, 0xf4df, 0xf4e0, 0xf4e1, 0xf4e2, 0xf4e3,
/* 08 */ 0xf4e4, 0xf4e5, 0xf4e6, 0xf4e7, 0xf4e8, 0xf4e9, 0xf4ea, 0xf4eb,
/* 10 */ 0xf4ec, 0xf4ed, 0xf4ee, 0xf4ef, 0xf4f0, 0xf4f1, 0xf4f2, 0xf4f3,
/* 18 */ 0xf4f4, 0xf4f5, 0xf4f6, 0xf4f7, 0xf4f8, 0xf4f9, 0xf4fa, 0xf4fb,
/* 20 */ 0xf4fc, 0xf4fd, 0xf4fe, 0x8fa1a1, 0x8fa1a2, 0x8fa1a3, 0x8fa1a4, 0x8fa1a5,
/* 28 */ 0x8fa1a6, 0x8fa1a7, 0x8fa1a8, 0x8fa1a9, 0x8fa1aa, 0x8fa1ab, 0x8fa1ac, 0x8fa1ad,
/* 30 */ 0x8fa1ae, 0x8fa1af, 0x8fa1b0, 0x8fa1b1, 0x8fa1b2, 0x8fa1b3, 0x8fa1b4, 0x8fa1b5,
/* 38 */ 0x8fa1b6, 0x8fa1b7, 0x8fa1b8, 0x8fa1b9, 0x8fa1ba, 0x8fa1bb, 0x8fa1bc, 0x8fa1bd
},

/* Row 0x950 */
{
/* 00 */ 0x8fa1be, 0x8fa1bf, 0x8fa1c0, 0x8fa1c1, 0x8fa1c2, 0x8fa1c3, 0x8fa1c4, 0x8fa1c5,
/* 08 */ 0x8fa1c6, 0x8fa1c7, 0x8fa1c8, 0x8fa1c9, 0x8fa1ca, 0x8fa1cb, 0x8fa1cc, 0x8fa1cd,
/* 10 */ 0x8fa1ce, 0x8fa1cf, 0x8fa1d0, 0x8fa1d1, 0x8fa1d2, 0x8fa1d3, 0x8fa1d4, 0x8fa1d5,
/* 18 */ 0x8fa1d6, 0x8fa1d7, 0x8fa1d8, 0x8fa1d9, 0x8fa1da, 0x8fa1db, 0x8fa1dc, 0x8fa1dd,
/* 20 */ 0x8fa1de, 0x8fa1df, 0x8fa1e0, 0x8fa1e1, 0x8fa1e2, 0x8fa1e3, 0x8fa1e4, 0x8fa1e5,
/* 28 */ 0x8fa1e6, 0x8fa1e7, 0x8fa1e8, 0x8fa1e9, 0x8fa1ea, 0x8fa1eb, 0x8fa1ec, 0x8fa1ed,
/* 30 */ 0x8fa1ee, 0x8fa1ef, 0x8fa1f0, 0x8fa1f1, 0x8fa1f2, 0x8fa1f3, 0x8fa1f4, 0x8fa1f5,
/* 38 */ 0x8fa1f6, 0x8fa1f7, 0x8fa1f8, 0x8fa1f9, 0x8fa1fa, 0x8fa1fb, 0x8fa1fc, 0x8fa1fd
},

/* Row 0x951 */
{
/* 00 */ 0x8fa1fe, 0x8fa2a1, 0x8fa2a2, 0x8fa2a3, 0x8fa2a4, 0x8fa2a5, 0x8fa2a6, 0x8fa2a7,
/* 08 */ 0x8fa2a8, 0x8fa2a9, 0x8fa2aa, 0x8fa2ab, 0x8fa2ac, 0x8fa2ad, 0x8fa2ae, 0x8fa2ba,
/* 10 */ 0x8fa2bb, 0x8fa2bc, 0x8fa2bd, 0x8fa2be, 0x8fa2bf, 0x8fa2c0, 0x8fa2c1, 0x8fa2c5,
/* 18 */ 0x8fa2c6, 0x8fa2c7, 0x8fa2c8, 0x8fa2c9, 0x8fa2ca, 0x8fa2cb, 0x8fa2cc, 0x8fa2cd,
/* 20 */ 0x8fa2ce, 0x8fa2cf, 0x8fa2d0, 0x8fa2d1, 0x8fa2d2, 0x8fa2d3, 0x8fa2d4, 0x8fa2d5,
/* 28 */ 0x8fa2d6, 0x8fa2d7, 0x8fa2d8, 0x8fa2d9, 0x8fa2da, 0x8fa2db, 0x8fa2dc, 0x8fa2dd,
/* 30 */ 0x8fa2de, 0x8fa2df, 0x8fa2e0, 0x8fa2e1, 0x8fa2e2, 0x8fa2e3, 0x8fa2e4, 0x8fa2e5,
/* 38 */ 0x8fa2e6, 0x8fa2e7, 0x8fa2e8, 0x8fa2e9, 0x8fa2ea, 0x8fa2f2, 0x8fa2f3, 0x8fa2f4
},

/* Row 0x952 */
{
/* 00 */ 0x8fa2f5, 0x8fa2f6, 0x8fa2f7, 0x8fa2f8, 0x8fa2f9, 0x8fa2fa, 0x8fa2fb, 0x8fa2fc,
/* 08 */ 0x8fa2fd, 0x8fa2fe, 0x8fa3a1, 0x8fa3a2, 0x8fa3a3, 0x8fa3a4, 0x8fa3a5, 0x8fa3a6,
/* 10 */ 0x8fa3a7, 0x8fa3a8, 0x8fa3a9, 0x8fa3aa, 0x8fa3ab, 0x8fa3ac, 0x8fa3ad, 0x8fa3ae,
/* 18 */ 0x8fa3af, 0x8fa3b0, 0x8fa3b1, 0x8fa3b2, 0x8fa3b3, 0x8fa3b4, 0x8fa3b5, 0x8fa3b6,
/* 20 */ 0x8fa3b7, 0x8fa3b8, 0x8fa3b9, 0x8fa3ba, 0x8fa3bb, 0x8fa3bc, 0x8fa3bd, 0x8fa3be,
/* 28 */ 0x8fa3bf, 0x8fa3c0, 0x8fa3c1, 0x8fa3c2, 0x8fa3c3, 0x8fa3c4, 0x8fa3c5, 0x8fa3c6,
/* 30 */ 0x8fa3c7, 0x8fa3c8, 0x8fa3c9, 0x8fa3ca, 0x8fa3cb, 0x8fa3cc, 0x8fa3cd, 0x8fa3ce,
/* 38 */ 0x8fa3cf, 0x8fa3d0, 0x8fa3d1, 0x8fa3d2, 0x8fa3d3, 0x8fa3d4, 0x8fa3d5, 0x8fa3d6
},

/* Row 0x953 */
{
/* 00 */ 0x8fa3d7, 0x8fa3d8, 0x8fa3d9, 0x8fa3da, 0x8fa3db, 0x8fa3dc, 0x8fa3dd, 0x8fa3de,
/* 08 */ 0x8fa3df, 0x8fa3e0, 0x8fa3e1, 0x8fa3e2, 0x8fa3e3, 0x8fa3e4, 0x8fa3e5, 0x8fa3e6,
/* 10 */ 0x8fa3e7, 0x8fa3e8, 0x8fa3e9, 0x8fa3ea, 0x8fa3eb, 0x8fa3ec, 0x8fa3ed, 0x8fa3ee,
/* 18 */ 0x8fa3ef, 0x8fa3f0, 0x8fa3f1, 0x8fa3f2, 0x8fa3f3, 0x8fa3f4, 0x8fa3f5, 0x8fa3f6,
/* 20 */ 0x8fa3f7, 0x8fa3f8, 0x8fa3f9, 0x8fa3fa, 0x8fa3fb, 0x8fa3fc, 0x8fa3fd, 0x8fa3fe,
/* 28 */ 0x8fa4a1, 0x8fa4a2, 0x8fa4a3, 0x8fa4a4, 0x8fa4a5, 0x8fa4a6, 0x8fa4a7, 0x8fa4a8,
/* 30 */ 0x8fa4a9, 0x8fa4aa, 0x8fa4ab, 0x8fa4ac, 0x8fa4ad, 0x8fa4ae, 0x8fa4af, 0x8fa4b0,
/* 38 */ 0x8fa4b1, 0x8fa4b2, 0x8fa4b3, 0x8fa4b4, 0x8fa4b5, 0x8fa4b6, 0x8fa4b7, 0x8fa4b8
},

/* Row 0x954 */
{
/* 00 */ 0x8fa4b9, 0x8fa4ba, 0x8fa4bb, 0x8fa4bc, 0x8fa4bd, 0x8fa4be, 0x8fa4bf, 0x8fa4c0,
/* 08 */ 0x8fa4c1, 0x8fa4c2, 0x8fa4c3, 0x8fa4c4, 0x8fa4c5, 0x8fa4c6, 0x8fa4c7, 0x8fa4c8,
/* 10 */ 0x8fa4c9, 0x8fa4ca, 0x8fa4cb, 0x8fa4cc, 0x8fa4cd, 0x8fa4ce, 0x8fa4cf, 0x8fa4d0,
/* 18 */ 0x8fa4d1, 0x8fa4d2, 0x8fa4d3, 0x8fa4d4, 0x8fa4d5, 0x8fa4d6, 0x8fa4d7, 0x8fa4d8,
/* 20 */ 0x8fa4d9, 0x8fa4da, 0x8fa4db, 0x8fa4dc, 0x8fa4dd, 0x8fa4de, 0x8fa4df, 0x8fa4e0,
/* 28 */ 0x8fa4e1, 0x8fa4e2, 0x8fa4e3, 0x8fa4e4, 0x8fa4e5, 0x8fa4e6, 0x8fa4e7, 0x8fa4e8,
/* 30 */ 0x8fa4e9, 0x8fa4ea, 0x8fa4eb, 0x8fa4ec, 0x8fa4ed, 0x8fa4ee, 0x8fa4ef, 0x8fa4f0,
/* 38 */ 0x8fa4f1, 0x8fa4f2, 0x8fa4f3, 0x8fa4f4, 0x8fa4f5, 0x8fa4f6, 0x8fa4f7, 0x8fa4f8
},

/* Row 0x955 */
{
/* 00 */ 0x8fa4f9, 0x8fa4fa, 0x8fa4fb, 0x8fa4fc, 0x8fa4fd, 0x8fa4fe, 0x8fa5a1, 0x8fa5a2,
/* 08 */ 0x8fa5a3, 0x8fa5a4, 0x8fa5a5, 0x8fa5a6, 0x8fa5a7, 0x8fa5a8, 0x8fa5a9, 0x8fa5aa,
/* 10 */ 0x8fa5ab, 0x8fa5ac, 0x8fa5ad, 0x8fa5ae, 0x8fa5af, 0x8fa5b0, 0x8fa5b1, 0x8fa5b2,
/* 18 */ 0x8fa5b3, 0x8fa5b4, 0x8fa5b5, 0x8fa5b6, 0x8fa5b7, 0x8fa5b8, 0x8fa5b9, 0x8fa5ba,
/* 20 */ 0x8fa5bb, 0x8fa5bc, 0x8fa5bd, 0x8fa5be, 0x8fa5bf, 0x8fa5c0, 0x8fa5c1, 0x8fa5c2,
/* 28 */ 0x8fa5c3, 0x8fa5c4, 0x8fa5c5, 0x8fa5c6, 0x8fa5c7, 0x8fa5c8, 0x8fa5c9, 0x8fa5ca,
/* 30 */ 0x8fa5cb, 0x8fa5cc, 0x8fa5cd, 0x8fa5ce, 0x8fa5cf, 0x8fa5d0, 0x8fa5d1, 0x8fa5d2,
/* 38 */ 0x8fa5d3, 0x8fa5d4, 0x8fa5d5, 0x8fa5d6, 0x8fa5d7, 0x8fa5d8, 0x8fa5d9, 0x8fa5da
},

/* Row 0x956 */
{
/* 00 */ 0x8fa5db, 0x8fa5dc, 0x8fa5dd, 0x8fa5de, 0x8fa5df, 0x8fa5e0, 0x8fa5e1, 0x8fa5e2,
/* 08 */ 0x8fa5e3, 0x8fa5e4, 0x8fa5e5, 0x8fa5e6, 0x8fa5e7, 0x8fa5e8, 0x8fa5e9, 0x8fa5ea,
/* 10 */ 0x8fa5eb, 0x8fa5ec, 0x8fa5ed, 0x8fa5ee, 0x8fa5ef, 0x8fa5f0, 0x8fa5f1, 0x8fa5f2,
/* 18 */ 0x8fa5f3, 0x8fa5f4, 0x8fa5f5, 0x8fa5f6, 0x8fa5f7, 0x8fa5f8, 0x8fa5f9, 0x8fa5fa,
/* 20 */ 0x8fa5fb, 0x8fa5fc, 0x8fa5fd, 0x8fa5fe, 0x8fa6a1, 0x8fa6a2, 0x8fa6a3, 0x8fa6a4,
/* 28 */ 0x8fa6a5, 0x8fa6a6, 0x8fa6a7, 0x8fa6a8, 0x8fa6a9, 0x8fa6aa, 0x8fa6ab, 0x8fa6ac,
/* 30 */ 0x8fa6ad, 0x8fa6ae, 0x8fa6af, 0x8fa6b0, 0x8fa6b1, 0x8fa6b2, 0x8fa6b3, 0x8fa6b4,
/* 38 */ 0x8fa6b5, 0x8fa6b6, 0x8fa6b7, 0x8fa6b8, 0x8fa6b9, 0x8fa6ba, 0x8fa6bb, 0x8fa6bc
},

/* Row 0x957 */
{
/* 00 */ 0x8fa6bd, 0x8fa6be, 0x8fa6bf, 0x8fa6c0, 0x8fa6c1, 0x8fa6c2, 0x8fa6c3, 0x8fa6c4,
/* 08 */ 0x8fa6c5, 0x8fa6c6, 0x8fa6c7, 0x8fa6c8, 0x8fa6c9, 0x8fa6ca, 0x8fa6cb, 0x8fa6cc,
/* 10 */ 0x8fa6cd, 0x8fa6ce, 0x8fa6cf, 0x8fa6d0, 0x8fa6d1, 0x8fa6d2, 0x8fa6d3, 0x8fa6d4,
/* 18 */ 0x8fa6d5, 0x8fa6d6, 0x8fa6d7, 0x8fa6d8, 0x8fa6d9, 0x8fa6da, 0x8fa6db, 0x8fa6dc,
/* 20 */ 0x8fa6dd, 0x8fa6de, 0x8fa6df, 0x8fa6e0, 0x8fa6e6, 0x8fa6e8, 0x8fa6eb, 0x8fa6ed,
/* 28 */ 0x8fa6ee, 0x8fa6ef, 0x8fa6f0, 0x8fa6fd, 0x8fa6fe, 0x8fa7a1, 0x8fa7a2, 0x8fa7a3,
/* 30 */ 0x8fa7a4, 0x8fa7a5, 0x8fa7a6, 0x8fa7a7, 0x8fa7a8, 0x8fa7a9, 0x8fa7aa, 0x8fa7ab,
/* 38 */ 0x8fa7ac, 0x8fa7ad, 0x8fa7ae, 0x8fa7af, 0x8fa7b0, 0x8fa7b1, 0x8fa7b2, 0x8fa7b3
},

/* Row 0x958 */
{
/* 00 */ 0x8fa7b4, 0x8fa7b5, 0x8fa7b6, 0x8fa7b7, 0x8fa7b8, 0x8fa7b9, 0x8fa7ba, 0x8fa7bb,
/* 08 */ 0x8fa7bc, 0x8fa7bd, 0x8fa7be, 0x8fa7bf, 0x8fa7c0, 0x8fa7c1, 0x8fa7cf, 0x8fa7d0,
/* 10 */ 0x8fa7d1, 0x8fa7d2, 0x8fa7d3, 0x8fa7d4, 0x8fa7d5, 0x8fa7d6, 0x8fa7d7, 0x8fa7d8,
/* 18 */ 0x8fa7d9, 0x8fa7da, 0x8fa7db, 0x8fa7dc, 0x8fa7dd, 0x8fa7de, 0x8fa7df, 0x8fa7e0,
/* 20 */ 0x8fa7e1, 0x8fa7e2, 0x8fa7e3, 0x8fa7e4, 0x8fa7e5, 0x8fa7e6, 0x8fa7e7, 0x8fa7e8,
/* 28 */ 0x8fa7e9, 0x8fa7ea, 0x8fa7eb, 0x8fa7ec, 0x8fa7ed, 0x8fa7ee, 0x8fa7ef, 0x8fa7f0,
/* 30 */ 0x8fa7f1, 0x8fa8a1, 0x8fa8a2, 0x8fa8a3, 0x8fa8a4, 0x8fa8a5, 0x8fa8a6, 0x8fa8a7,
/* 38 */ 0x8fa8a8, 0x8fa8a9, 0x8fa8aa, 0x8fa8ab, 0x8fa8ac, 0x8fa8ad, 0x8fa8ae, 0x8fa8af
},

/* Row 0x959 */
{
/* 00 */ 0x8fa8b0, 0x8fa8b1, 0x8fa8b2, 0x8fa8b3, 0x8fa8b4, 0x8fa8b5, 0x8fa8b6, 0x8fa8b7,
/* 08 */ 0x8fa8b8, 0x8fa8b9, 0x8fa8ba, 0x8fa8bb, 0x8fa8bc, 0x8fa8bd, 0x8fa8be, 0x8fa8bf,
/* 10 */ 0x8fa8c0, 0x8fa8c1, 0x8fa8c2, 0x8fa8c3, 0x8fa8c4, 0x8fa8c5, 0x8fa8c6, 0x8fa8c7,
/* 18 */ 0x8fa8c8, 0x8fa8c9, 0x8fa8ca, 0x8fa8cb, 0x8fa8cc, 0x8fa8cd, 0x8fa8ce, 0x8fa8cf,
/* 20 */ 0x8fa8d0, 0x8fa8d1, 0x8fa8d2, 0x8fa8d3, 0x8fa8d4, 0x8fa8d5, 0x8fa8d6, 0x8fa8d7,
/* 28 */ 0x8fa8d8, 0x8fa8d9, 0x8fa8da, 0x8fa8db, 0x8fa8dc, 0x8fa8dd, 0x8fa8de, 0x8fa8df,
/* 30 */ 0x8fa8e0, 0x8fa8e1, 0x8fa8e2, 0x8fa8e3, 0x8fa8e4, 0x8fa8e5, 0x8fa8e6, 0x8fa8e7,
/* 38 */ 0x8fa8e8, 0x8fa8e9, 0x8fa8ea, 0x8fa8eb, 0x8fa8ec, 0x8fa8ed, 0x8fa8ee, 0x8fa8ef
},

/* Row 0x95a */
{
/* 00 */ 0x8fa8f0, 0x8fa8f1, 0x8fa8f2, 0x8fa8f3, 0x8fa8f4, 0x8fa8f5, 0x8fa8f6, 0x8fa8f7,
/* 08 */ 0x8fa8f8, 0x8fa8f9, 0x8fa8fa, 0x8fa8fb, 0x8fa8fc, 0x8fa8fd, 0x8fa8fe, 0x8fa9a3,
/* 10 */ 0x8fa9a5, 0x8fa9a7, 0x8fa9aa, 0x8fa9ae, 0x8fa9b1, 0x8fa9b2, 0x8fa9b3, 0x8fa9b4,
/* 18 */ 0x8fa9b5, 0x8fa9b6, 0x8fa9b7, 0x8fa9b8, 0x8fa9b9, 0x8fa9ba, 0x8fa9bb, 0x8fa9bc,
/* 20 */ 0x8fa9bd, 0x8fa9be, 0x8fa9bf, 0x8fa9c0, 0x8fa9d1, 0x8fa9d2, 0x8fa9d3, 0x8fa9d4,
/* 28 */ 0x8fa9d5, 0x8fa9d6, 0x8fa9d7, 0x8fa9d8, 0x8fa9d9, 0x8fa9da, 0x8fa9db, 0x8fa9dc,
/* 30 */ 0x8fa9dd, 0x8fa9de, 0x8fa9df, 0x8fa9e0, 0x8fa9e1, 0x8fa9e2, 0x8fa9e3, 0x8fa9e4,
/* 38 */ 0x8fa9e5, 0x8fa9e6, 0x8fa9e7, 0x8fa9e8, 0x8fa9e9, 0x8fa9ea, 0x8fa9eb, 0x8fa9ec
},

/* Row 0x95b */
{
/* 00 */ 0x8fa9ed, 0x8fa9ee, 0x8fa9ef, 0x8fa9f0, 0x8fa9f1, 0x8fa9f2, 0x8fa9f3, 0x8fa9f4,
/* 08 */ 0x8fa9f5, 0x8fa9f6, 0x8fa9f7, 0x8fa9f8, 0x8fa9f9, 0x8fa9fa, 0x8fa9fb, 0x8fa9fc,
/* 10 */ 0x8fa9fd, 0x8fa9fe, 0x8faab9, 0x8faaf8, 0x8faaf9, 0x8faafa, 0x8faafb, 0x8faafc,
/* 18 */ 0x8faafd, 0x8faafe, 0x8fabbc, 0x8fabc4, 0x8fabf8, 0x8fabf9, 0x8fabfa, 0x8fabfb,
/* 20 */ 0x8fabfc, 0x8fabfd, 0x8fabfe, 0x8faca1, 0x8faca2, 0x8faca3, 0x8faca4, 0x8faca5,
/* 28 */ 0x8faca6, 0x8faca7, 0x8faca8, 0x8faca9, 0x8facaa, 0x8facab, 0x8facac, 0x8facad,
/* 30 */ 0x8facae, 0x8facaf, 0x8facb0, 0x8facb1, 0x8facb2, 0x8facb3, 0x8facb4, 0x8facb5,
/* 38 */ 0x8facb6, 0x8facb7, 0x8facb8, 0x8facb9, 0x8facba, 0x8facbb, 0x8facbc, 0x8facbd
},

/* Row 0x95c */
{
/* 00 */ 0x8facbe, 0x8facbf, 0x8facc0, 0x8facc1, 0x8facc2, 0x8facc3, 0x8facc4, 0x8facc5,
/* 08 */ 0x8facc6, 0x8facc7, 0x8facc8, 0x8facc9, 0x8facca, 0x8faccb, 0x8faccc, 0x8faccd,
/* 10 */ 0x8facce, 0x8faccf, 0x8facd0, 0x8facd1, 0x8facd2, 0x8facd3, 0x8facd4, 0x8facd5,
/* 18 */ 0x8facd6, 0x8facd7, 0x8facd8, 0x8facd9, 0x8facda, 0x8facdb, 0x8facdc, 0x8facdd,
/* 20 */ 0x8facde, 0x8facdf, 0x8face0, 0x8face1, 0x8face2, 0x8face3, 0x8face4, 0x8face5,
/* 28 */ 0x8face6, 0x8face7, 0x8face8, 0x8face9, 0x8facea, 0x8faceb, 0x8facec, 0x8faced,
/* 30 */ 0x8facee, 0x8facef, 0x8facf0, 0x8facf1, 0x8facf2, 0x8facf3, 0x8facf4, 0x8facf5,
/* 38 */ 0x8facf6, 0x8facf7, 0x8facf8, 0x8facf9, 0x8facfa, 0x8facfb, 0x8facfc, 0x8facfd
},

/* Row 0x95d */
{
/* 00 */ 0x8facfe, 0x8fada1, 0x8fada2, 0x8fada3, 0x8fada4, 0x8fada5, 0x8fada6, 0x8fada7,
/* 08 */ 0x8fada8, 0x8fada9, 0x8fadaa, 0x8fadab, 0x8fadac, 0x8fadad, 0x8fadae, 0x8fadaf,
/* 10 */ 0x8fadb0, 0x8fadb1, 0x8fadb2, 0x8fadb3, 0x8fadb4, 0x8fadb5, 0x8fadb6, 0x8fadb7,
/* 18 */ 0x8fadb8, 0x8fadb9, 0x8fadba, 0x8fadbb, 0x8fadbc, 0x8fadbd, 0x8fadbe, 0x8fadbf,
/* 20 */ 0x8fadc0, 0x8fadc1, 0x8fadc2, 0x8fadc3, 0x8fadc4, 0x8fadc5, 0x8fadc6, 0x8fadc7,
/* 28 */ 0x8fadc8, 0x8fadc9, 0x8fadca, 0x8fadcb, 0x8fadcc, 0x8fadcd, 0x8fadce, 0x8fadcf,
/* 30 */ 0x8fadd0, 0x8fadd1, 0x8fadd2, 0x8fadd3, 0x8fadd4, 0x8fadd5, 0x8fadd6, 0x8fadd7,
/* 38 */ 0x8fadd8, 0x8fadd9, 0x8fadda, 0x8faddb, 0x8faddc, 0x8faddd, 0x8fadde, 0x8faddf
},

/* Row 0x95e */
{
/* 00 */ 0x8fade0, 0x8fade1, 0x8fade2, 0x8fade3, 0x8fade4, 0x8fade5, 0x8fade6, 0x8fade7,
/* 08 */ 0x8fade8, 0x8fade9, 0x8fadea, 0x8fadeb, 0x8fadec, 0x8faded, 0x8fadee, 0x8fadef,
/* 10 */ 0x8fadf0, 0x8fadf1, 0x8fadf2, 0x8fadf3, 0x8fadf4, 0x8fadf5, 0x8fadf6, 0x8fadf7,
/* 18 */ 0x8fadf8, 0x8fadf9, 0x8fadfa, 0x8fadfb, 0x8fadfc, 0x8fadfd, 0x8fadfe, 0x8faea1,
/* 20 */ 0x8faea2, 0x8faea3, 0x8faea4, 0x8faea5, 0x8faea6, 0x8faea7, 0x8faea8, 0x8faea9,
/* 28 */ 0x8faeaa, 0x8faeab, 0x8faeac, 0x8faead, 0x8faeae, 0x8faeaf, 0x8faeb0, 0x8faeb1,
/* 30 */ 0x8faeb2, 0x8faeb3, 0x8faeb4, 0x8faeb5, 0x8faeb6, 0x8faeb7, 0x8faeb8, 0x8faeb9,
/* 38 */ 0x8faeba, 0x8faebb, 0x8faebc, 0x8faebd, 0x8faebe, 0x8faebf, 0x8faec0, 0x8faec1
},

/* Row 0x95f */
{
/* 00 */ 0x8faec2, 0x8faec3, 0x8faec4, 0x8faec5, 0x8faec6, 0x8faec7, 0x8faec8, 0x8faec9,
/* 08 */ 0x8faeca, 0x8faecb, 0x8faecc, 0x8faecd, 0x8faece, 0x8faecf, 0x8faed0, 0x8faed1,
/* 10 */ 0x8faed2, 0x8faed3, 0x8faed4, 0x8faed5, 0x8faed6, 0x8faed7, 0x8faed8, 0x8faed9,
/* 18 */ 0x8faeda, 0x8faedb, 0x8faedc, 0x8faedd, 0x8faede, 0x8faedf, 0x8faee0, 0x8faee1,
/* 20 */ 0x8faee2, 0x8faee3, 0x8faee4, 0x8faee5, 0x8faee6, 0x8faee7, 0x8faee8, 0x8faee9,
/* 28 */ 0x8faeea, 0x8faeeb, 0x8faeec, 0x8faeed, 0x8faeee, 0x8faeef, 0x8faef0, 0x8faef1,
/* 30 */ 0x8faef2, 0x8faef3, 0x8faef4, 0x8faef5, 0x8faef6, 0x8faef7, 0x8faef8, 0x8faef9,
/* 38 */ 0x8faefa, 0x8faefb, 0x8faefc, 0x8faefd, 0x8faefe, 0x8fafa1, 0x8fafa2, 0x8fafa3
},

/* Row 0x960 */
{
/* 00 */ 0x8fafa4, 0x8fafa5, 0x8fafa6, 0x8fafa7, 0x8fafa8, 0x8fafa9, 0x8fafaa, 0x8fafab,
/* 08 */ 0x8fafac, 0x8fafad, 0x8fafae, 0x8fafaf, 0x8fafb0, 0x8fafb1, 0x8fafb2, 0x8fafb3,
/* 10 */ 0x8fafb4, 0x8fafb5, 0x8fafb6, 0x8fafb7, 0x8fafb8, 0x8fafb9, 0x8fafba, 0x8fafbb,
/* 18 */ 0x8fafbc, 0x8fafbd, 0x8fafbe, 0x8fafbf, 0x8fafc0, 0x8fafc1, 0x8fafc2, 0x8fafc3,
/* 20 */ 0x8fafc4, 0x8fafc5, 0x8fafc6, 0x8fafc7, 0x8fafc8, 0x8fafc9, 0x8fafca, 0x8fafcb,
/* 28 */ 0x8fafcc, 0x8fafcd, 0x8fafce, 0x8fafcf, 0x8fafd0, 0x8fafd1, 0x8fafd2, 0x8fafd3,
/* 30 */ 0x8fafd4, 0x8fafd5, 0x8fafd6, 0x8fafd7, 0x8fafd8, 0x8fafd9, 0x8fafda, 0x8fafdb,
/* 38 */ 0x8fafdc, 0x8fafdd, 0x8fafde, 0x8fafdf, 0x8fafe0, 0x8fafe1, 0x8fafe2, 0x8fafe3
},

/* Row 0x961 */
{
/* 00 */ 0x8fafe4, 0x8fafe5, 0x8fafe6, 0x8fafe7, 0x8fafe8, 0x8fafe9, 0x8fafea, 0x8fafeb,
/* 08 */ 0x8fafec, 0x8fafed, 0x8fafee, 0x8fafef, 0x8faff0, 0x8faff1, 0x8faff2, 0x8faff3,
/* 10 */ 0x8faff4, 0x8faff5, 0x8faff6, 0x8faff7, 0x8faff8, 0x8faff9, 0x8faffa, 0x8faffb,
/* 18 */ 0x8faffc, 0x8faffd, 0x8faffe, 0x8fede4, 0x8fede5, 0x8fede6, 0x8fede7, 0x8fede8,
/* 20 */ 0x8fede9, 0x8fedea, 0x8fedeb, 0x8fedec, 0x8feded, 0x8fedee, 0x8fedef, 0x8fedf0,
/* 28 */ 0x8fedf1, 0x8fedf2, 0x8fedf3, 0x8fedf4, 0x8fedf5, 0x8fedf6, 0x8fedf7, 0x8fedf8,
/* 30 */ 0x8fedf9, 0x8fedfa, 0x8fedfb, 0x8fedfc, 0x8fedfd, 0x8fedfe,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
}
};

#else /* USE_OUR_MB_WC_DATA_TABLES */
/*
 * Data tables for use by the character conversion routines.
 *
 * NOTE: These tables should not be manually edited.
 * These tables were generated by the cs_cnv_test
 * program that can be run in the NT regression test
 * environment.  The program is given an input file (via
 * stdin) which is one of the *_input_files under the
 * w:/common directory.  The program writes its output to stdout.
 * The tables below come directly from the program's output.
 * See the w:/sqlutils/cs_cnv_test directory for the source for the
 * cs_cnv_test program.
 */
static const unsigned short Our_MS_sjis_tableF[] = {
0x3000,0x3001,0x3002,0xff0c,0xff0e,0x30fb,0xff1a,0xff1b,
0xff1f,0xff01,0x309b,0x309c,0x00b4,0xff40,0x00a8,0xff3e,
0xffe3,0xff3f,0x30fd,0x30fe,0x309d,0x309e,0x3003,0x4edd,
0x3005,0x3006,0x3007,0x30fc,0x2015,0x2010,0xff0f,0xff3c,
0xff5e,0x2225,0xff5c,0x2026,0x2025,0x2018,0x2019,0x201c,
0x201d,0xff08,0xff09,0x3014,0x3015,0xff3b,0xff3d,0xff5b,
0xff5d,0x3008,0x3009,0x300a,0x300b,0x300c,0x300d,0x300e,
0x300f,0x3010,0x3011,0xff0b,0xff0d,0x00b1,0x00d7,0xffff,
0x00f7,0xff1d,0x2260,0xff1c,0xff1e,0x2266,0x2267,0x221e,
0x2234,0x2642,0x2640,0x00b0,0x2032,0x2033,0x2103,0xffe5,
0xff04,0xffe0,0xffe1,0xff05,0xff03,0xff06,0xff0a,0xff20,
0x00a7,0x2606,0x2605,0x25cb,0x25cf,0x25ce,0x25c7,0x25c6,
0x25a1,0x25a0,0x25b3,0x25b2,0x25bd,0x25bc,0x203b,0x3012,
0x2192,0x2190,0x2191,0x2193,0x3013,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x2208,0x220b,0x2286,0x2287,0x2282,0x2283,0x222a,0x2229,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x2227,0x2228,0xffe2,0x21d2,0x21d4,0x2200,0x2203,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x2220,0x22a5,0x2312,0x2202,0x2207,0x2261,
0x2252,0x226a,0x226b,0x221a,0x223d,0x221d,0x2235,0x222b,
0x222c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x212b,0x2030,0x266f,0x266d,0x266a,0x2020,0x2021,0x00b6,
0xffff,0xffff,0xffff,0xffff,0x25ef,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xff10,
0xff11,0xff12,0xff13,0xff14,0xff15,0xff16,0xff17,0xff18,
0xff19,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xff21,0xff22,0xff23,0xff24,0xff25,0xff26,0xff27,0xff28,
0xff29,0xff2a,0xff2b,0xff2c,0xff2d,0xff2e,0xff2f,0xff30,
0xff31,0xff32,0xff33,0xff34,0xff35,0xff36,0xff37,0xff38,
0xff39,0xff3a,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xff41,0xff42,0xff43,0xff44,0xff45,0xff46,0xff47,
0xff48,0xff49,0xff4a,0xff4b,0xff4c,0xff4d,0xff4e,0xff4f,
0xff50,0xff51,0xff52,0xff53,0xff54,0xff55,0xff56,0xff57,
0xff58,0xff59,0xff5a,0xffff,0xffff,0xffff,0xffff,0x3041,
0x3042,0x3043,0x3044,0x3045,0x3046,0x3047,0x3048,0x3049,
0x304a,0x304b,0x304c,0x304d,0x304e,0x304f,0x3050,0x3051,
0x3052,0x3053,0x3054,0x3055,0x3056,0x3057,0x3058,0x3059,
0x305a,0x305b,0x305c,0x305d,0x305e,0x305f,0x3060,0x3061,
0x3062,0x3063,0x3064,0x3065,0x3066,0x3067,0x3068,0x3069,
0x306a,0x306b,0x306c,0x306d,0x306e,0x306f,0x3070,0x3071,
0x3072,0x3073,0x3074,0x3075,0x3076,0x3077,0x3078,0x3079,
0x307a,0x307b,0x307c,0x307d,0x307e,0x307f,0x3080,0x3081,
0x3082,0x3083,0x3084,0x3085,0x3086,0x3087,0x3088,0x3089,
0x308a,0x308b,0x308c,0x308d,0x308e,0x308f,0x3090,0x3091,
0x3092,0x3093,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x30a1,0x30a2,0x30a3,0x30a4,0x30a5,0x30a6,0x30a7,0x30a8,
0x30a9,0x30aa,0x30ab,0x30ac,0x30ad,0x30ae,0x30af,0x30b0,
0x30b1,0x30b2,0x30b3,0x30b4,0x30b5,0x30b6,0x30b7,0x30b8,
0x30b9,0x30ba,0x30bb,0x30bc,0x30bd,0x30be,0x30bf,0x30c0,
0x30c1,0x30c2,0x30c3,0x30c4,0x30c5,0x30c6,0x30c7,0x30c8,
0x30c9,0x30ca,0x30cb,0x30cc,0x30cd,0x30ce,0x30cf,0x30d0,
0x30d1,0x30d2,0x30d3,0x30d4,0x30d5,0x30d6,0x30d7,0x30d8,
0x30d9,0x30da,0x30db,0x30dc,0x30dd,0x30de,0x30df,0xffff,
0x30e0,0x30e1,0x30e2,0x30e3,0x30e4,0x30e5,0x30e6,0x30e7,
0x30e8,0x30e9,0x30ea,0x30eb,0x30ec,0x30ed,0x30ee,0x30ef,
0x30f0,0x30f1,0x30f2,0x30f3,0x30f4,0x30f5,0x30f6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x0391,
0x0392,0x0393,0x0394,0x0395,0x0396,0x0397,0x0398,0x0399,
0x039a,0x039b,0x039c,0x039d,0x039e,0x039f,0x03a0,0x03a1,
0x03a3,0x03a4,0x03a5,0x03a6,0x03a7,0x03a8,0x03a9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x03b1,
0x03b2,0x03b3,0x03b4,0x03b5,0x03b6,0x03b7,0x03b8,0x03b9,
0x03ba,0x03bb,0x03bc,0x03bd,0x03be,0x03bf,0x03c0,0x03c1,
0x03c3,0x03c4,0x03c5,0x03c6,0x03c7,0x03c8,0x03c9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x0410,0x0411,0x0412,0x0413,0x0414,0x0415,0x0401,0x0416,
0x0417,0x0418,0x0419,0x041a,0x041b,0x041c,0x041d,0x041e,
0x041f,0x0420,0x0421,0x0422,0x0423,0x0424,0x0425,0x0426,
0x0427,0x0428,0x0429,0x042a,0x042b,0x042c,0x042d,0x042e,
0x042f,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x0430,0x0431,0x0432,0x0433,0x0434,0x0435,0x0451,0x0436,
0x0437,0x0438,0x0439,0x043a,0x043b,0x043c,0x043d,0xffff,
0x043e,0x043f,0x0440,0x0441,0x0442,0x0443,0x0444,0x0445,
0x0446,0x0447,0x0448,0x0449,0x044a,0x044b,0x044c,0x044d,
0x044e,0x044f,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x2500,
0x2502,0x250c,0x2510,0x2518,0x2514,0x251c,0x252c,0x2524,
0x2534,0x253c,0x2501,0x2503,0x250f,0x2513,0x251b,0x2517,
0x2523,0x2533,0x252b,0x253b,0x254b,0x2520,0x252f,0x2528,
0x2537,0x253f,0x251d,0x2530,0x2525,0x2538,0x2542,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x2460,0x2461,0x2462,0x2463,0x2464,0x2465,0x2466,0x2467,
0x2468,0x2469,0x246a,0x246b,0x246c,0x246d,0x246e,0x246f,
0x2470,0x2471,0x2472,0x2473,0x2160,0x2161,0x2162,0x2163,
0x2164,0x2165,0x2166,0x2167,0x2168,0x2169,0xffff,0x3349,
0x3314,0x3322,0x334d,0x3318,0x3327,0x3303,0x3336,0x3351,
0x3357,0x330d,0x3326,0x3323,0x332b,0x334a,0x333b,0x339c,
0x339d,0x339e,0x338e,0x338f,0x33c4,0x33a1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x337b,0xffff,
0x301d,0x301f,0x2116,0x33cd,0x2121,0x32a4,0x32a5,0x32a6,
0x32a7,0x32a8,0x3231,0x3232,0x3239,0x337e,0x337d,0x337c,
0x2252,0x2261,0x222b,0x222e,0x2211,0x221a,0x22a5,0x2220,
0x221f,0x22bf,0x2235,0x2229,0x222a,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x4e9c,
0x5516,0x5a03,0x963f,0x54c0,0x611b,0x6328,0x59f6,0x9022,
0x8475,0x831c,0x7a50,0x60aa,0x63e1,0x6e25,0x65ed,0x8466,
0x82a6,0x9bf5,0x6893,0x5727,0x65a1,0x6271,0x5b9b,0x59d0,
0x867b,0x98f4,0x7d62,0x7dbe,0x9b8e,0x6216,0x7c9f,0x88b7,
0x5b89,0x5eb5,0x6309,0x6697,0x6848,0x95c7,0x978d,0x674f,
0x4ee5,0x4f0a,0x4f4d,0x4f9d,0x5049,0x56f2,0x5937,0x59d4,
0x5a01,0x5c09,0x60df,0x610f,0x6170,0x6613,0x6905,0x70ba,
0x754f,0x7570,0x79fb,0x7dad,0x7def,0x80c3,0x840e,0x8863,
0x8b02,0x9055,0x907a,0x533b,0x4e95,0x4ea5,0x57df,0x80b2,
0x90c1,0x78ef,0x4e00,0x58f1,0x6ea2,0x9038,0x7a32,0x8328,
0x828b,0x9c2f,0x5141,0x5370,0x54bd,0x54e1,0x56e0,0x59fb,
0x5f15,0x98f2,0x6deb,0x80e4,0x852d,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9662,0x9670,0x96a0,0x97fb,0x540b,0x53f3,0x5b87,0x70cf,
0x7fbd,0x8fc2,0x96e8,0x536f,0x9d5c,0x7aba,0x4e11,0x7893,
0x81fc,0x6e26,0x5618,0x5504,0x6b1d,0x851a,0x9c3b,0x59e5,
0x53a9,0x6d66,0x74dc,0x958f,0x5642,0x4e91,0x904b,0x96f2,
0x834f,0x990c,0x53e1,0x55b6,0x5b30,0x5f71,0x6620,0x66f3,
0x6804,0x6c38,0x6cf3,0x6d29,0x745b,0x76c8,0x7a4e,0x9834,
0x82f1,0x885b,0x8a60,0x92ed,0x6db2,0x75ab,0x76ca,0x99c5,
0x60a6,0x8b01,0x8d8a,0x95b2,0x698e,0x53ad,0x5186,0xffff,
0x5712,0x5830,0x5944,0x5bb4,0x5ef6,0x6028,0x63a9,0x63f4,
0x6cbf,0x6f14,0x708e,0x7114,0x7159,0x71d5,0x733f,0x7e01,
0x8276,0x82d1,0x8597,0x9060,0x925b,0x9d1b,0x5869,0x65bc,
0x6c5a,0x7525,0x51f9,0x592e,0x5965,0x5f80,0x5fdc,0x62bc,
0x65fa,0x6a2a,0x6b27,0x6bb4,0x738b,0x7fc1,0x8956,0x9d2c,
0x9d0e,0x9ec4,0x5ca1,0x6c96,0x837b,0x5104,0x5c4b,0x61b6,
0x81c6,0x6876,0x7261,0x4e59,0x4ffa,0x5378,0x6069,0x6e29,
0x7a4f,0x97f3,0x4e0b,0x5316,0x4eee,0x4f55,0x4f3d,0x4fa1,
0x4f73,0x52a0,0x53ef,0x5609,0x590f,0x5ac1,0x5bb6,0x5be1,
0x79d1,0x6687,0x679c,0x67b6,0x6b4c,0x6cb3,0x706b,0x73c2,
0x798d,0x79be,0x7a3c,0x7b87,0x82b1,0x82db,0x8304,0x8377,
0x83ef,0x83d3,0x8766,0x8ab2,0x5629,0x8ca8,0x8fe6,0x904e,
0x971e,0x868a,0x4fc4,0x5ce8,0x6211,0x7259,0x753b,0x81e5,
0x82bd,0x86fe,0x8cc0,0x96c5,0x9913,0x99d5,0x4ecb,0x4f1a,
0x89e3,0x56de,0x584a,0x58ca,0x5efb,0x5feb,0x602a,0x6094,
0x6062,0x61d0,0x6212,0x62d0,0x6539,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9b41,0x6666,0x68b0,0x6d77,0x7070,0x754c,0x7686,0x7d75,
0x82a5,0x87f9,0x958b,0x968e,0x8c9d,0x51f1,0x52be,0x5916,
0x54b3,0x5bb3,0x5d16,0x6168,0x6982,0x6daf,0x788d,0x84cb,
0x8857,0x8a72,0x93a7,0x9ab8,0x6d6c,0x99a8,0x86d9,0x57a3,
0x67ff,0x86ce,0x920e,0x5283,0x5687,0x5404,0x5ed3,0x62e1,
0x64b9,0x683c,0x6838,0x6bbb,0x7372,0x78ba,0x7a6b,0x899a,
0x89d2,0x8d6b,0x8f03,0x90ed,0x95a3,0x9694,0x9769,0x5b66,
0x5cb3,0x697d,0x984d,0x984e,0x639b,0x7b20,0x6a2b,0xffff,
0x6a7f,0x68b6,0x9c0d,0x6f5f,0x5272,0x559d,0x6070,0x62ec,
0x6d3b,0x6e07,0x6ed1,0x845b,0x8910,0x8f44,0x4e14,0x9c39,
0x53f6,0x691b,0x6a3a,0x9784,0x682a,0x515c,0x7ac3,0x84b2,
0x91dc,0x938c,0x565b,0x9d28,0x6822,0x8305,0x8431,0x7ca5,
0x5208,0x82c5,0x74e6,0x4e7e,0x4f83,0x51a0,0x5bd2,0x520a,
0x52d8,0x52e7,0x5dfb,0x559a,0x582a,0x59e6,0x5b8c,0x5b98,
0x5bdb,0x5e72,0x5e79,0x60a3,0x611f,0x6163,0x61be,0x63db,
0x6562,0x67d1,0x6853,0x68fa,0x6b3e,0x6b53,0x6c57,0x6f22,
0x6f97,0x6f45,0x74b0,0x7518,0x76e3,0x770b,0x7aff,0x7ba1,
0x7c21,0x7de9,0x7f36,0x7ff0,0x809d,0x8266,0x839e,0x89b3,
0x8acc,0x8cab,0x9084,0x9451,0x9593,0x9591,0x95a2,0x9665,
0x97d3,0x9928,0x8218,0x4e38,0x542b,0x5cb8,0x5dcc,0x73a9,
0x764c,0x773c,0x5ca9,0x7feb,0x8d0b,0x96c1,0x9811,0x9854,
0x9858,0x4f01,0x4f0e,0x5371,0x559c,0x5668,0x57fa,0x5947,
0x5b09,0x5bc4,0x5c90,0x5e0c,0x5e7e,0x5fcc,0x63ee,0x673a,
0x65d7,0x65e2,0x671f,0x68cb,0x68c4,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6a5f,0x5e30,0x6bc5,0x6c17,0x6c7d,0x757f,0x7948,0x5b63,
0x7a00,0x7d00,0x5fbd,0x898f,0x8a18,0x8cb4,0x8d77,0x8ecc,
0x8f1d,0x98e2,0x9a0e,0x9b3c,0x4e80,0x507d,0x5100,0x5993,
0x5b9c,0x622f,0x6280,0x64ec,0x6b3a,0x72a0,0x7591,0x7947,
0x7fa9,0x87fb,0x8abc,0x8b70,0x63ac,0x83ca,0x97a0,0x5409,
0x5403,0x55ab,0x6854,0x6a58,0x8a70,0x7827,0x6775,0x9ecd,
0x5374,0x5ba2,0x811a,0x8650,0x9006,0x4e18,0x4e45,0x4ec7,
0x4f11,0x53ca,0x5438,0x5bae,0x5f13,0x6025,0x6551,0xffff,
0x673d,0x6c42,0x6c72,0x6ce3,0x7078,0x7403,0x7a76,0x7aae,
0x7b08,0x7d1a,0x7cfe,0x7d66,0x65e7,0x725b,0x53bb,0x5c45,
0x5de8,0x62d2,0x62e0,0x6319,0x6e20,0x865a,0x8a31,0x8ddd,
0x92f8,0x6f01,0x79a6,0x9b5a,0x4ea8,0x4eab,0x4eac,0x4f9b,
0x4fa0,0x50d1,0x5147,0x7af6,0x5171,0x51f6,0x5354,0x5321,
0x537f,0x53eb,0x55ac,0x5883,0x5ce1,0x5f37,0x5f4a,0x602f,
0x6050,0x606d,0x631f,0x6559,0x6a4b,0x6cc1,0x72c2,0x72ed,
0x77ef,0x80f8,0x8105,0x8208,0x854e,0x90f7,0x93e1,0x97ff,
0x9957,0x9a5a,0x4ef0,0x51dd,0x5c2d,0x6681,0x696d,0x5c40,
0x66f2,0x6975,0x7389,0x6850,0x7c81,0x50c5,0x52e4,0x5747,
0x5dfe,0x9326,0x65a4,0x6b23,0x6b3d,0x7434,0x7981,0x79bd,
0x7b4b,0x7dca,0x82b9,0x83cc,0x887f,0x895f,0x8b39,0x8fd1,
0x91d1,0x541f,0x9280,0x4e5d,0x5036,0x53e5,0x533a,0x72d7,
0x7396,0x77e9,0x82e6,0x8eaf,0x99c6,0x99c8,0x99d2,0x5177,
0x611a,0x865e,0x55b0,0x7a7a,0x5076,0x5bd3,0x9047,0x9685,
0x4e32,0x6adb,0x91e7,0x5c51,0x5c48,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6398,0x7a9f,0x6c93,0x9774,0x8f61,0x7aaa,0x718a,0x9688,
0x7c82,0x6817,0x7e70,0x6851,0x936c,0x52f2,0x541b,0x85ab,
0x8a13,0x7fa4,0x8ecd,0x90e1,0x5366,0x8888,0x7941,0x4fc2,
0x50be,0x5211,0x5144,0x5553,0x572d,0x73ea,0x578b,0x5951,
0x5f62,0x5f84,0x6075,0x6176,0x6167,0x61a9,0x63b2,0x643a,
0x656c,0x666f,0x6842,0x6e13,0x7566,0x7a3d,0x7cfb,0x7d4c,
0x7d99,0x7e4b,0x7f6b,0x830e,0x834a,0x86cd,0x8a08,0x8a63,
0x8b66,0x8efd,0x981a,0x9d8f,0x82b8,0x8fce,0x9be8,0xffff,
0x5287,0x621f,0x6483,0x6fc0,0x9699,0x6841,0x5091,0x6b20,
0x6c7a,0x6f54,0x7a74,0x7d50,0x8840,0x8a23,0x6708,0x4ef6,
0x5039,0x5026,0x5065,0x517c,0x5238,0x5263,0x55a7,0x570f,
0x5805,0x5acc,0x5efa,0x61b2,0x61f8,0x62f3,0x6372,0x691c,
0x6a29,0x727d,0x72ac,0x732e,0x7814,0x786f,0x7d79,0x770c,
0x80a9,0x898b,0x8b19,0x8ce2,0x8ed2,0x9063,0x9375,0x967a,
0x9855,0x9a13,0x9e78,0x5143,0x539f,0x53b3,0x5e7b,0x5f26,
0x6e1b,0x6e90,0x7384,0x73fe,0x7d43,0x8237,0x8a00,0x8afa,
0x9650,0x4e4e,0x500b,0x53e4,0x547c,0x56fa,0x59d1,0x5b64,
0x5df1,0x5eab,0x5f27,0x6238,0x6545,0x67af,0x6e56,0x72d0,
0x7cca,0x88b4,0x80a1,0x80e1,0x83f0,0x864e,0x8a87,0x8de8,
0x9237,0x96c7,0x9867,0x9f13,0x4e94,0x4e92,0x4f0d,0x5348,
0x5449,0x543e,0x5a2f,0x5f8c,0x5fa1,0x609f,0x68a7,0x6a8e,
0x745a,0x7881,0x8a9e,0x8aa4,0x8b77,0x9190,0x4e5e,0x9bc9,
0x4ea4,0x4f7c,0x4faf,0x5019,0x5016,0x5149,0x516c,0x529f,
0x52b9,0x52fe,0x539a,0x53e3,0x5411,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x540e,0x5589,0x5751,0x57a2,0x597d,0x5b54,0x5b5d,0x5b8f,
0x5de5,0x5de7,0x5df7,0x5e78,0x5e83,0x5e9a,0x5eb7,0x5f18,
0x6052,0x614c,0x6297,0x62d8,0x63a7,0x653b,0x6602,0x6643,
0x66f4,0x676d,0x6821,0x6897,0x69cb,0x6c5f,0x6d2a,0x6d69,
0x6e2f,0x6e9d,0x7532,0x7687,0x786c,0x7a3f,0x7ce0,0x7d05,
0x7d18,0x7d5e,0x7db1,0x8015,0x8003,0x80af,0x80b1,0x8154,
0x818f,0x822a,0x8352,0x884c,0x8861,0x8b1b,0x8ca2,0x8cfc,
0x90ca,0x9175,0x9271,0x783f,0x92fc,0x95a4,0x964d,0xffff,
0x9805,0x9999,0x9ad8,0x9d3b,0x525b,0x52ab,0x53f7,0x5408,
0x58d5,0x62f7,0x6fe0,0x8c6a,0x8f5f,0x9eb9,0x514b,0x523b,
0x544a,0x56fd,0x7a40,0x9177,0x9d60,0x9ed2,0x7344,0x6f09,
0x8170,0x7511,0x5ffd,0x60da,0x9aa8,0x72db,0x8fbc,0x6b64,
0x9803,0x4eca,0x56f0,0x5764,0x58be,0x5a5a,0x6068,0x61c7,
0x660f,0x6606,0x6839,0x68b1,0x6df7,0x75d5,0x7d3a,0x826e,
0x9b42,0x4e9b,0x4f50,0x53c9,0x5506,0x5d6f,0x5de6,0x5dee,
0x67fb,0x6c99,0x7473,0x7802,0x8a50,0x9396,0x88df,0x5750,
0x5ea7,0x632b,0x50b5,0x50ac,0x518d,0x6700,0x54c9,0x585e,
0x59bb,0x5bb0,0x5f69,0x624d,0x63a1,0x683d,0x6b73,0x6e08,
0x707d,0x91c7,0x7280,0x7815,0x7826,0x796d,0x658e,0x7d30,
0x83dc,0x88c1,0x8f09,0x969b,0x5264,0x5728,0x6750,0x7f6a,
0x8ca1,0x51b4,0x5742,0x962a,0x583a,0x698a,0x80b4,0x54b2,
0x5d0e,0x57fc,0x7895,0x9dfa,0x4f5c,0x524a,0x548b,0x643e,
0x6628,0x6714,0x67f5,0x7a84,0x7b56,0x7d22,0x932f,0x685c,
0x9bad,0x7b39,0x5319,0x518a,0x5237,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5bdf,0x62f6,0x64ae,0x64e6,0x672d,0x6bba,0x85a9,0x96d1,
0x7690,0x9bd6,0x634c,0x9306,0x9bab,0x76bf,0x6652,0x4e09,
0x5098,0x53c2,0x5c71,0x60e8,0x6492,0x6563,0x685f,0x71e6,
0x73ca,0x7523,0x7b97,0x7e82,0x8695,0x8b83,0x8cdb,0x9178,
0x9910,0x65ac,0x66ab,0x6b8b,0x4ed5,0x4ed4,0x4f3a,0x4f7f,
0x523a,0x53f8,0x53f2,0x55e3,0x56db,0x58eb,0x59cb,0x59c9,
0x59ff,0x5b50,0x5c4d,0x5e02,0x5e2b,0x5fd7,0x601d,0x6307,
0x652f,0x5b5c,0x65af,0x65bd,0x65e8,0x679d,0x6b62,0xffff,
0x6b7b,0x6c0f,0x7345,0x7949,0x79c1,0x7cf8,0x7d19,0x7d2b,
0x80a2,0x8102,0x81f3,0x8996,0x8a5e,0x8a69,0x8a66,0x8a8c,
0x8aee,0x8cc7,0x8cdc,0x96cc,0x98fc,0x6b6f,0x4e8b,0x4f3c,
0x4f8d,0x5150,0x5b57,0x5bfa,0x6148,0x6301,0x6642,0x6b21,
0x6ecb,0x6cbb,0x723e,0x74bd,0x75d4,0x78c1,0x793a,0x800c,
0x8033,0x81ea,0x8494,0x8f9e,0x6c50,0x9e7f,0x5f0f,0x8b58,
0x9d2b,0x7afa,0x8ef8,0x5b8d,0x96eb,0x4e03,0x53f1,0x57f7,
0x5931,0x5ac9,0x5ba4,0x6089,0x6e7f,0x6f06,0x75be,0x8cea,
0x5b9f,0x8500,0x7be0,0x5072,0x67f4,0x829d,0x5c61,0x854a,
0x7e1e,0x820e,0x5199,0x5c04,0x6368,0x8d66,0x659c,0x716e,
0x793e,0x7d17,0x8005,0x8b1d,0x8eca,0x906e,0x86c7,0x90aa,
0x501f,0x52fa,0x5c3a,0x6753,0x707c,0x7235,0x914c,0x91c8,
0x932b,0x82e5,0x5bc2,0x5f31,0x60f9,0x4e3b,0x53d6,0x5b88,
0x624b,0x6731,0x6b8a,0x72e9,0x73e0,0x7a2e,0x816b,0x8da3,
0x9152,0x9996,0x5112,0x53d7,0x546a,0x5bff,0x6388,0x6a39,
0x7dac,0x9700,0x56da,0x53ce,0x5468,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5b97,0x5c31,0x5dde,0x4fee,0x6101,0x62fe,0x6d32,0x79c0,
0x79cb,0x7d42,0x7e4d,0x7fd2,0x81ed,0x821f,0x8490,0x8846,
0x8972,0x8b90,0x8e74,0x8f2f,0x9031,0x914b,0x916c,0x96c6,
0x919c,0x4ec0,0x4f4f,0x5145,0x5341,0x5f93,0x620e,0x67d4,
0x6c41,0x6e0b,0x7363,0x7e26,0x91cd,0x9283,0x53d4,0x5919,
0x5bbf,0x6dd1,0x795d,0x7e2e,0x7c9b,0x587e,0x719f,0x51fa,
0x8853,0x8ff0,0x4fca,0x5cfb,0x6625,0x77ac,0x7ae3,0x821c,
0x99ff,0x51c6,0x5faa,0x65ec,0x696f,0x6b89,0x6df3,0xffff,
0x6e96,0x6f64,0x76fe,0x7d14,0x5de1,0x9075,0x9187,0x9806,
0x51e6,0x521d,0x6240,0x6691,0x66d9,0x6e1a,0x5eb6,0x7dd2,
0x7f72,0x66f8,0x85af,0x85f7,0x8af8,0x52a9,0x53d9,0x5973,
0x5e8f,0x5f90,0x6055,0x92e4,0x9664,0x50b7,0x511f,0x52dd,
0x5320,0x5347,0x53ec,0x54e8,0x5546,0x5531,0x5617,0x5968,
0x59be,0x5a3c,0x5bb5,0x5c06,0x5c0f,0x5c11,0x5c1a,0x5e84,
0x5e8a,0x5ee0,0x5f70,0x627f,0x6284,0x62db,0x638c,0x6377,
0x6607,0x660c,0x662d,0x6676,0x677e,0x68a2,0x6a1f,0x6a35,
0x6cbc,0x6d88,0x6e09,0x6e58,0x713c,0x7126,0x7167,0x75c7,
0x7701,0x785d,0x7901,0x7965,0x79f0,0x7ae0,0x7b11,0x7ca7,
0x7d39,0x8096,0x83d6,0x848b,0x8549,0x885d,0x88f3,0x8a1f,
0x8a3c,0x8a54,0x8a73,0x8c61,0x8cde,0x91a4,0x9266,0x937e,
0x9418,0x969c,0x9798,0x4e0a,0x4e08,0x4e1e,0x4e57,0x5197,
0x5270,0x57ce,0x5834,0x58cc,0x5b22,0x5e38,0x60c5,0x64fe,
0x6761,0x6756,0x6d44,0x72b6,0x7573,0x7a63,0x84b8,0x8b72,
0x91b8,0x9320,0x5631,0x57f4,0x98fe,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x62ed,0x690d,0x6b96,0x71ed,0x7e54,0x8077,0x8272,0x89e6,
0x98df,0x8755,0x8fb1,0x5c3b,0x4f38,0x4fe1,0x4fb5,0x5507,
0x5a20,0x5bdd,0x5be9,0x5fc3,0x614e,0x632f,0x65b0,0x664b,
0x68ee,0x699b,0x6d78,0x6df1,0x7533,0x75b9,0x771f,0x795e,
0x79e6,0x7d33,0x81e3,0x82af,0x85aa,0x89aa,0x8a3a,0x8eab,
0x8f9b,0x9032,0x91dd,0x9707,0x4eba,0x4ec1,0x5203,0x5875,
0x58ec,0x5c0b,0x751a,0x5c3d,0x814e,0x8a0a,0x8fc5,0x9663,
0x976d,0x7b25,0x8acf,0x9808,0x9162,0x56f3,0x53a8,0xffff,
0x9017,0x5439,0x5782,0x5e25,0x63a8,0x6c34,0x708a,0x7761,
0x7c8b,0x7fe0,0x8870,0x9042,0x9154,0x9310,0x9318,0x968f,
0x745e,0x9ac4,0x5d07,0x5d69,0x6570,0x67a2,0x8da8,0x96db,
0x636e,0x6749,0x6919,0x83c5,0x9817,0x96c0,0x88fe,0x6f84,
0x647a,0x5bf8,0x4e16,0x702c,0x755d,0x662f,0x51c4,0x5236,
0x52e2,0x59d3,0x5f81,0x6027,0x6210,0x653f,0x6574,0x661f,
0x6674,0x68f2,0x6816,0x6b63,0x6e05,0x7272,0x751f,0x76db,
0x7cbe,0x8056,0x58f0,0x88fd,0x897f,0x8aa0,0x8a93,0x8acb,
0x901d,0x9192,0x9752,0x9759,0x6589,0x7a0e,0x8106,0x96bb,
0x5e2d,0x60dc,0x621a,0x65a5,0x6614,0x6790,0x77f3,0x7a4d,
0x7c4d,0x7e3e,0x810a,0x8cac,0x8d64,0x8de1,0x8e5f,0x78a9,
0x5207,0x62d9,0x63a5,0x6442,0x6298,0x8a2d,0x7a83,0x7bc0,
0x8aac,0x96ea,0x7d76,0x820c,0x8749,0x4ed9,0x5148,0x5343,
0x5360,0x5ba3,0x5c02,0x5c16,0x5ddd,0x6226,0x6247,0x64b0,
0x6813,0x6834,0x6cc9,0x6d45,0x6d17,0x67d3,0x6f5c,0x714e,
0x717d,0x65cb,0x7a7f,0x7bad,0x7dda,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7e4a,0x7fa8,0x817a,0x821b,0x8239,0x85a6,0x8a6e,0x8cce,
0x8df5,0x9078,0x9077,0x92ad,0x9291,0x9583,0x9bae,0x524d,
0x5584,0x6f38,0x7136,0x5168,0x7985,0x7e55,0x81b3,0x7cce,
0x564c,0x5851,0x5ca8,0x63aa,0x66fe,0x66fd,0x695a,0x72d9,
0x758f,0x758e,0x790e,0x7956,0x79df,0x7c97,0x7d20,0x7d44,
0x8607,0x8a34,0x963b,0x9061,0x9f20,0x50e7,0x5275,0x53cc,
0x53e2,0x5009,0x55aa,0x58ee,0x594f,0x723d,0x5b8b,0x5c64,
0x531d,0x60e3,0x60f3,0x635c,0x6383,0x633f,0x63bb,0xffff,
0x64cd,0x65e9,0x66f9,0x5de3,0x69cd,0x69fd,0x6f15,0x71e5,
0x4e89,0x75e9,0x76f8,0x7a93,0x7cdf,0x7dcf,0x7d9c,0x8061,
0x8349,0x8358,0x846c,0x84bc,0x85fb,0x88c5,0x8d70,0x9001,
0x906d,0x9397,0x971c,0x9a12,0x50cf,0x5897,0x618e,0x81d3,
0x8535,0x8d08,0x9020,0x4fc3,0x5074,0x5247,0x5373,0x606f,
0x6349,0x675f,0x6e2c,0x8db3,0x901f,0x4fd7,0x5c5e,0x8cca,
0x65cf,0x7d9a,0x5352,0x8896,0x5176,0x63c3,0x5b58,0x5b6b,
0x5c0a,0x640d,0x6751,0x905c,0x4ed6,0x591a,0x592a,0x6c70,
0x8a51,0x553e,0x5815,0x59a5,0x60f0,0x6253,0x67c1,0x8235,
0x6955,0x9640,0x99c4,0x9a28,0x4f53,0x5806,0x5bfe,0x8010,
0x5cb1,0x5e2f,0x5f85,0x6020,0x614b,0x6234,0x66ff,0x6cf0,
0x6ede,0x80ce,0x817f,0x82d4,0x888b,0x8cb8,0x9000,0x902e,
0x968a,0x9edb,0x9bdb,0x4ee3,0x53f0,0x5927,0x7b2c,0x918d,
0x984c,0x9df9,0x6edd,0x7027,0x5353,0x5544,0x5b85,0x6258,
0x629e,0x62d3,0x6ca2,0x6fef,0x7422,0x8a17,0x9438,0x6fc1,
0x8afe,0x8338,0x51e7,0x86f8,0x53ea,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x53e9,0x4f46,0x9054,0x8fb0,0x596a,0x8131,0x5dfd,0x7aea,
0x8fbf,0x68da,0x8c37,0x72f8,0x9c48,0x6a3d,0x8ab0,0x4e39,
0x5358,0x5606,0x5766,0x62c5,0x63a2,0x65e6,0x6b4e,0x6de1,
0x6e5b,0x70ad,0x77ed,0x7aef,0x7baa,0x7dbb,0x803d,0x80c6,
0x86cb,0x8a95,0x935b,0x56e3,0x58c7,0x5f3e,0x65ad,0x6696,
0x6a80,0x6bb5,0x7537,0x8ac7,0x5024,0x77e5,0x5730,0x5f1b,
0x6065,0x667a,0x6c60,0x75f4,0x7a1a,0x7f6e,0x81f4,0x8718,
0x9045,0x99b3,0x7bc9,0x755c,0x7af9,0x7b51,0x84c4,0xffff,
0x9010,0x79e9,0x7a92,0x8336,0x5ae1,0x7740,0x4e2d,0x4ef2,
0x5b99,0x5fe0,0x62bd,0x663c,0x67f1,0x6ce8,0x866b,0x8877,
0x8a3b,0x914e,0x92f3,0x99d0,0x6a17,0x7026,0x732a,0x82e7,
0x8457,0x8caf,0x4e01,0x5146,0x51cb,0x558b,0x5bf5,0x5e16,
0x5e33,0x5e81,0x5f14,0x5f35,0x5f6b,0x5fb4,0x61f2,0x6311,
0x66a2,0x671d,0x6f6e,0x7252,0x753a,0x773a,0x8074,0x8139,
0x8178,0x8776,0x8abf,0x8adc,0x8d85,0x8df3,0x929a,0x9577,
0x9802,0x9ce5,0x52c5,0x6357,0x76f4,0x6715,0x6c88,0x73cd,
0x8cc3,0x93ae,0x9673,0x6d25,0x589c,0x690e,0x69cc,0x8ffd,
0x939a,0x75db,0x901a,0x585a,0x6802,0x63b4,0x69fb,0x4f43,
0x6f2c,0x67d8,0x8fbb,0x8526,0x7db4,0x9354,0x693f,0x6f70,
0x576a,0x58f7,0x5b2c,0x7d2c,0x722a,0x540a,0x91e3,0x9db4,
0x4ead,0x4f4e,0x505c,0x5075,0x5243,0x8c9e,0x5448,0x5824,
0x5b9a,0x5e1d,0x5e95,0x5ead,0x5ef7,0x5f1f,0x608c,0x62b5,
0x633a,0x63d0,0x68af,0x6c40,0x7887,0x798e,0x7a0b,0x7de0,
0x8247,0x8a02,0x8ae6,0x8e44,0x9013,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x90b8,0x912d,0x91d8,0x9f0e,0x6ce5,0x6458,0x64e2,0x6575,
0x6ef4,0x7684,0x7b1b,0x9069,0x93d1,0x6eba,0x54f2,0x5fb9,
0x64a4,0x8f4d,0x8fed,0x9244,0x5178,0x586b,0x5929,0x5c55,
0x5e97,0x6dfb,0x7e8f,0x751c,0x8cbc,0x8ee2,0x985b,0x70b9,
0x4f1d,0x6bbf,0x6fb1,0x7530,0x96fb,0x514e,0x5410,0x5835,
0x5857,0x59ac,0x5c60,0x5f92,0x6597,0x675c,0x6e21,0x767b,
0x83df,0x8ced,0x9014,0x90fd,0x934d,0x7825,0x783a,0x52aa,
0x5ea6,0x571f,0x5974,0x6012,0x5012,0x515a,0x51ac,0xffff,
0x51cd,0x5200,0x5510,0x5854,0x5858,0x5957,0x5b95,0x5cf6,
0x5d8b,0x60bc,0x6295,0x642d,0x6771,0x6843,0x68bc,0x68df,
0x76d7,0x6dd8,0x6e6f,0x6d9b,0x706f,0x71c8,0x5f53,0x75d8,
0x7977,0x7b49,0x7b54,0x7b52,0x7cd6,0x7d71,0x5230,0x8463,
0x8569,0x85e4,0x8a0e,0x8b04,0x8c46,0x8e0f,0x9003,0x900f,
0x9419,0x9676,0x982d,0x9a30,0x95d8,0x50cd,0x52d5,0x540c,
0x5802,0x5c0e,0x61a7,0x649e,0x6d1e,0x77b3,0x7ae5,0x80f4,
0x8404,0x9053,0x9285,0x5ce0,0x9d07,0x533f,0x5f97,0x5fb3,
0x6d9c,0x7279,0x7763,0x79bf,0x7be4,0x6bd2,0x72ec,0x8aad,
0x6803,0x6a61,0x51f8,0x7a81,0x6934,0x5c4a,0x9cf6,0x82eb,
0x5bc5,0x9149,0x701e,0x5678,0x5c6f,0x60c7,0x6566,0x6c8c,
0x8c5a,0x9041,0x9813,0x5451,0x66c7,0x920d,0x5948,0x90a3,
0x5185,0x4e4d,0x51ea,0x8599,0x8b0e,0x7058,0x637a,0x934b,
0x6962,0x99b4,0x7e04,0x7577,0x5357,0x6960,0x8edf,0x96e3,
0x6c5d,0x4e8c,0x5c3c,0x5f10,0x8fe9,0x5302,0x8cd1,0x8089,
0x8679,0x5eff,0x65e5,0x4e73,0x5165,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5982,0x5c3f,0x97ee,0x4efb,0x598a,0x5fcd,0x8a8d,0x6fe1,
0x79b0,0x7962,0x5be7,0x8471,0x732b,0x71b1,0x5e74,0x5ff5,
0x637b,0x649a,0x71c3,0x7c98,0x4e43,0x5efc,0x4e4b,0x57dc,
0x56a2,0x60a9,0x6fc3,0x7d0d,0x80fd,0x8133,0x81bf,0x8fb2,
0x8997,0x86a4,0x5df4,0x628a,0x64ad,0x8987,0x6777,0x6ce2,
0x6d3e,0x7436,0x7834,0x5a46,0x7f75,0x82ad,0x99ac,0x4ff3,
0x5ec3,0x62dd,0x6392,0x6557,0x676f,0x76c3,0x724c,0x80cc,
0x80ba,0x8f29,0x914d,0x500d,0x57f9,0x5a92,0x6885,0xffff,
0x6973,0x7164,0x72fd,0x8cb7,0x58f2,0x8ce0,0x966a,0x9019,
0x877f,0x79e4,0x77e7,0x8429,0x4f2f,0x5265,0x535a,0x62cd,
0x67cf,0x6cca,0x767d,0x7b94,0x7c95,0x8236,0x8584,0x8feb,
0x66dd,0x6f20,0x7206,0x7e1b,0x83ab,0x99c1,0x9ea6,0x51fd,
0x7bb1,0x7872,0x7bb8,0x8087,0x7b48,0x6ae8,0x5e61,0x808c,
0x7551,0x7560,0x516b,0x9262,0x6e8c,0x767a,0x9197,0x9aea,
0x4f10,0x7f70,0x629c,0x7b4f,0x95a5,0x9ce9,0x567a,0x5859,
0x86e4,0x96bc,0x4f34,0x5224,0x534a,0x53cd,0x53db,0x5e06,
0x642c,0x6591,0x677f,0x6c3e,0x6c4e,0x7248,0x72af,0x73ed,
0x7554,0x7e41,0x822c,0x85e9,0x8ca9,0x7bc4,0x91c6,0x7169,
0x9812,0x98ef,0x633d,0x6669,0x756a,0x76e4,0x78d0,0x8543,
0x86ee,0x532a,0x5351,0x5426,0x5983,0x5e87,0x5f7c,0x60b2,
0x6249,0x6279,0x62ab,0x6590,0x6bd4,0x6ccc,0x75b2,0x76ae,
0x7891,0x79d8,0x7dcb,0x7f77,0x80a5,0x88ab,0x8ab9,0x8cbb,
0x907f,0x975e,0x98db,0x6a0b,0x7c38,0x5099,0x5c3e,0x5fae,
0x6787,0x6bd8,0x7435,0x7709,0x7f8e,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9f3b,0x67ca,0x7a17,0x5339,0x758b,0x9aed,0x5f66,0x819d,
0x83f1,0x8098,0x5f3c,0x5fc5,0x7562,0x7b46,0x903c,0x6867,
0x59eb,0x5a9b,0x7d10,0x767e,0x8b2c,0x4ff5,0x5f6a,0x6a19,
0x6c37,0x6f02,0x74e2,0x7968,0x8868,0x8a55,0x8c79,0x5edf,
0x63cf,0x75c5,0x79d2,0x82d7,0x9328,0x92f2,0x849c,0x86ed,
0x9c2d,0x54c1,0x5f6c,0x658c,0x6d5c,0x7015,0x8ca7,0x8cd3,
0x983b,0x654f,0x74f6,0x4e0d,0x4ed8,0x57e0,0x592b,0x5a66,
0x5bcc,0x51a8,0x5e03,0x5e9c,0x6016,0x6276,0x6577,0xffff,
0x65a7,0x666e,0x6d6e,0x7236,0x7b26,0x8150,0x819a,0x8299,
0x8b5c,0x8ca0,0x8ce6,0x8d74,0x961c,0x9644,0x4fae,0x64ab,
0x6b66,0x821e,0x8461,0x856a,0x90e8,0x5c01,0x6953,0x98a8,
0x847a,0x8557,0x4f0f,0x526f,0x5fa9,0x5e45,0x670d,0x798f,
0x8179,0x8907,0x8986,0x6df5,0x5f17,0x6255,0x6cb8,0x4ecf,
0x7269,0x9b92,0x5206,0x543b,0x5674,0x58b3,0x61a4,0x626e,
0x711a,0x596e,0x7c89,0x7cde,0x7d1b,0x96f0,0x6587,0x805e,
0x4e19,0x4f75,0x5175,0x5840,0x5e63,0x5e73,0x5f0a,0x67c4,
0x4e26,0x853d,0x9589,0x965b,0x7c73,0x9801,0x50fb,0x58c1,
0x7656,0x78a7,0x5225,0x77a5,0x8511,0x7b86,0x504f,0x5909,
0x7247,0x7bc7,0x7de8,0x8fba,0x8fd4,0x904d,0x4fbf,0x52c9,
0x5a29,0x5f01,0x97ad,0x4fdd,0x8217,0x92ea,0x5703,0x6355,
0x6b69,0x752b,0x88dc,0x8f14,0x7a42,0x52df,0x5893,0x6155,
0x620a,0x66ae,0x6bcd,0x7c3f,0x83e9,0x5023,0x4ff8,0x5305,
0x5446,0x5831,0x5949,0x5b9d,0x5cf0,0x5cef,0x5d29,0x5e96,
0x62b1,0x6367,0x653e,0x65b9,0x670b,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6cd5,0x6ce1,0x70f9,0x7832,0x7e2b,0x80de,0x82b3,0x840c,
0x84ec,0x8702,0x8912,0x8a2a,0x8c4a,0x90a6,0x92d2,0x98fd,
0x9cf3,0x9d6c,0x4e4f,0x4ea1,0x508d,0x5256,0x574a,0x59a8,
0x5e3d,0x5fd8,0x5fd9,0x623f,0x66b4,0x671b,0x67d0,0x68d2,
0x5192,0x7d21,0x80aa,0x81a8,0x8b00,0x8c8c,0x8cbf,0x927e,
0x9632,0x5420,0x982c,0x5317,0x50d5,0x535c,0x58a8,0x64b2,
0x6734,0x7267,0x7766,0x7a46,0x91e6,0x52c3,0x6ca1,0x6b86,
0x5800,0x5e4c,0x5954,0x672c,0x7ffb,0x51e1,0x76c6,0xffff,
0x6469,0x78e8,0x9b54,0x9ebb,0x57cb,0x59b9,0x6627,0x679a,
0x6bce,0x54e9,0x69d9,0x5e55,0x819c,0x6795,0x9baa,0x67fe,
0x9c52,0x685d,0x4ea6,0x4fe3,0x53c8,0x62b9,0x672b,0x6cab,
0x8fc4,0x4fad,0x7e6d,0x9ebf,0x4e07,0x6162,0x6e80,0x6f2b,
0x8513,0x5473,0x672a,0x9b45,0x5df3,0x7b95,0x5cac,0x5bc6,
0x871c,0x6e4a,0x84d1,0x7a14,0x8108,0x5999,0x7c8d,0x6c11,
0x7720,0x52d9,0x5922,0x7121,0x725f,0x77db,0x9727,0x9d61,
0x690b,0x5a7f,0x5a18,0x51a5,0x540d,0x547d,0x660e,0x76df,
0x8ff7,0x9298,0x9cf4,0x59ea,0x725d,0x6ec5,0x514d,0x68c9,
0x7dbf,0x7dec,0x9762,0x9eba,0x6478,0x6a21,0x8302,0x5984,
0x5b5f,0x6bdb,0x731b,0x76f2,0x7db2,0x8017,0x8499,0x5132,
0x6728,0x9ed9,0x76ee,0x6762,0x52ff,0x9905,0x5c24,0x623b,
0x7c7e,0x8cb0,0x554f,0x60b6,0x7d0b,0x9580,0x5301,0x4e5f,
0x51b6,0x591c,0x723a,0x8036,0x91ce,0x5f25,0x77e2,0x5384,
0x5f79,0x7d04,0x85ac,0x8a33,0x8e8d,0x9756,0x67f3,0x85ae,
0x9453,0x6109,0x6108,0x6cb9,0x7652,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8aed,0x8f38,0x552f,0x4f51,0x512a,0x52c7,0x53cb,0x5ba5,
0x5e7d,0x60a0,0x6182,0x63d6,0x6709,0x67da,0x6e67,0x6d8c,
0x7336,0x7337,0x7531,0x7950,0x88d5,0x8a98,0x904a,0x9091,
0x90f5,0x96c4,0x878d,0x5915,0x4e88,0x4f59,0x4e0e,0x8a89,
0x8f3f,0x9810,0x50ad,0x5e7c,0x5996,0x5bb9,0x5eb8,0x63da,
0x63fa,0x64c1,0x66dc,0x694a,0x69d8,0x6d0b,0x6eb6,0x7194,
0x7528,0x7aaf,0x7f8a,0x8000,0x8449,0x84c9,0x8981,0x8b21,
0x8e0a,0x9065,0x967d,0x990a,0x617e,0x6291,0x6b32,0xffff,
0x6c83,0x6d74,0x7fcc,0x7ffc,0x6dc0,0x7f85,0x87ba,0x88f8,
0x6765,0x83b1,0x983c,0x96f7,0x6d1b,0x7d61,0x843d,0x916a,
0x4e71,0x5375,0x5d50,0x6b04,0x6feb,0x85cd,0x862d,0x89a7,
0x5229,0x540f,0x5c65,0x674e,0x68a8,0x7406,0x7483,0x75e2,
0x88cf,0x88e1,0x91cc,0x96e2,0x9678,0x5f8b,0x7387,0x7acb,
0x844e,0x63a0,0x7565,0x5289,0x6d41,0x6e9c,0x7409,0x7559,
0x786b,0x7c92,0x9686,0x7adc,0x9f8d,0x4fb6,0x616e,0x65c5,
0x865c,0x4e86,0x4eae,0x50da,0x4e21,0x51cc,0x5bee,0x6599,
0x6881,0x6dbc,0x731f,0x7642,0x77ad,0x7a1c,0x7ce7,0x826f,
0x8ad2,0x907c,0x91cf,0x9675,0x9818,0x529b,0x7dd1,0x502b,
0x5398,0x6797,0x6dcb,0x71d0,0x7433,0x81e8,0x8f2a,0x96a3,
0x9c57,0x9e9f,0x7460,0x5841,0x6d99,0x7d2f,0x985e,0x4ee4,
0x4f36,0x4f8b,0x51b7,0x52b1,0x5dba,0x601c,0x73b2,0x793c,
0x82d3,0x9234,0x96b7,0x96f6,0x970a,0x9e97,0x9f62,0x66a6,
0x6b74,0x5217,0x52a3,0x70c8,0x88c2,0x5ec9,0x604b,0x6190,
0x6f23,0x7149,0x7c3e,0x7df4,0x806f,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x84ee,0x9023,0x932c,0x5442,0x9b6f,0x6ad3,0x7089,0x8cc2,
0x8def,0x9732,0x52b4,0x5a41,0x5eca,0x5f04,0x6717,0x697c,
0x6994,0x6d6a,0x6f0f,0x7262,0x72fc,0x7bed,0x8001,0x807e,
0x874b,0x90ce,0x516d,0x9e93,0x7984,0x808b,0x9332,0x8ad6,
0x502d,0x548c,0x8a71,0x6b6a,0x8cc4,0x8107,0x60d1,0x67a0,
0x9df2,0x4e99,0x4e98,0x9c10,0x8a6b,0x85c1,0x8568,0x6900,
0x6e7e,0x7897,0x8155,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x5f0c,
0x4e10,0x4e15,0x4e2a,0x4e31,0x4e36,0x4e3c,0x4e3f,0x4e42,
0x4e56,0x4e58,0x4e82,0x4e85,0x8c6b,0x4e8a,0x8212,0x5f0d,
0x4e8e,0x4e9e,0x4e9f,0x4ea0,0x4ea2,0x4eb0,0x4eb3,0x4eb6,
0x4ece,0x4ecd,0x4ec4,0x4ec6,0x4ec2,0x4ed7,0x4ede,0x4eed,
0x4edf,0x4ef7,0x4f09,0x4f5a,0x4f30,0x4f5b,0x4f5d,0x4f57,
0x4f47,0x4f76,0x4f88,0x4f8f,0x4f98,0x4f7b,0x4f69,0x4f70,
0x4f91,0x4f6f,0x4f86,0x4f96,0x5118,0x4fd4,0x4fdf,0x4fce,
0x4fd8,0x4fdb,0x4fd1,0x4fda,0x4fd0,0x4fe4,0x4fe5,0x501a,
0x5028,0x5014,0x502a,0x5025,0x5005,0x4f1c,0x4ff6,0x5021,
0x5029,0x502c,0x4ffe,0x4fef,0x5011,0x5006,0x5043,0x5047,
0x6703,0x5055,0x5050,0x5048,0x505a,0x5056,0x506c,0x5078,
0x5080,0x509a,0x5085,0x50b4,0x50b2,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x50c9,0x50ca,0x50b3,0x50c2,0x50d6,0x50de,0x50e5,0x50ed,
0x50e3,0x50ee,0x50f9,0x50f5,0x5109,0x5101,0x5102,0x5116,
0x5115,0x5114,0x511a,0x5121,0x513a,0x5137,0x513c,0x513b,
0x513f,0x5140,0x5152,0x514c,0x5154,0x5162,0x7af8,0x5169,
0x516a,0x516e,0x5180,0x5182,0x56d8,0x518c,0x5189,0x518f,
0x5191,0x5193,0x5195,0x5196,0x51a4,0x51a6,0x51a2,0x51a9,
0x51aa,0x51ab,0x51b3,0x51b1,0x51b2,0x51b0,0x51b5,0x51bd,
0x51c5,0x51c9,0x51db,0x51e0,0x8655,0x51e9,0x51ed,0xffff,
0x51f0,0x51f5,0x51fe,0x5204,0x520b,0x5214,0x520e,0x5227,
0x522a,0x522e,0x5233,0x5239,0x524f,0x5244,0x524b,0x524c,
0x525e,0x5254,0x526a,0x5274,0x5269,0x5273,0x527f,0x527d,
0x528d,0x5294,0x5292,0x5271,0x5288,0x5291,0x8fa8,0x8fa7,
0x52ac,0x52ad,0x52bc,0x52b5,0x52c1,0x52cd,0x52d7,0x52de,
0x52e3,0x52e6,0x98ed,0x52e0,0x52f3,0x52f5,0x52f8,0x52f9,
0x5306,0x5308,0x7538,0x530d,0x5310,0x530f,0x5315,0x531a,
0x5323,0x532f,0x5331,0x5333,0x5338,0x5340,0x5346,0x5345,
0x4e17,0x5349,0x534d,0x51d6,0x535e,0x5369,0x536e,0x5918,
0x537b,0x5377,0x5382,0x5396,0x53a0,0x53a6,0x53a5,0x53ae,
0x53b0,0x53b6,0x53c3,0x7c12,0x96d9,0x53df,0x66fc,0x71ee,
0x53ee,0x53e8,0x53ed,0x53fa,0x5401,0x543d,0x5440,0x542c,
0x542d,0x543c,0x542e,0x5436,0x5429,0x541d,0x544e,0x548f,
0x5475,0x548e,0x545f,0x5471,0x5477,0x5470,0x5492,0x547b,
0x5480,0x5476,0x5484,0x5490,0x5486,0x54c7,0x54a2,0x54b8,
0x54a5,0x54ac,0x54c4,0x54c8,0x54a8,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x54ab,0x54c2,0x54a4,0x54be,0x54bc,0x54d8,0x54e5,0x54e6,
0x550f,0x5514,0x54fd,0x54ee,0x54ed,0x54fa,0x54e2,0x5539,
0x5540,0x5563,0x554c,0x552e,0x555c,0x5545,0x5556,0x5557,
0x5538,0x5533,0x555d,0x5599,0x5580,0x54af,0x558a,0x559f,
0x557b,0x557e,0x5598,0x559e,0x55ae,0x557c,0x5583,0x55a9,
0x5587,0x55a8,0x55da,0x55c5,0x55df,0x55c4,0x55dc,0x55e4,
0x55d4,0x5614,0x55f7,0x5616,0x55fe,0x55fd,0x561b,0x55f9,
0x564e,0x5650,0x71df,0x5634,0x5636,0x5632,0x5638,0xffff,
0x566b,0x5664,0x562f,0x566c,0x566a,0x5686,0x5680,0x568a,
0x56a0,0x5694,0x568f,0x56a5,0x56ae,0x56b6,0x56b4,0x56c2,
0x56bc,0x56c1,0x56c3,0x56c0,0x56c8,0x56ce,0x56d1,0x56d3,
0x56d7,0x56ee,0x56f9,0x5700,0x56ff,0x5704,0x5709,0x5708,
0x570b,0x570d,0x5713,0x5718,0x5716,0x55c7,0x571c,0x5726,
0x5737,0x5738,0x574e,0x573b,0x5740,0x574f,0x5769,0x57c0,
0x5788,0x5761,0x577f,0x5789,0x5793,0x57a0,0x57b3,0x57a4,
0x57aa,0x57b0,0x57c3,0x57c6,0x57d4,0x57d2,0x57d3,0x580a,
0x57d6,0x57e3,0x580b,0x5819,0x581d,0x5872,0x5821,0x5862,
0x584b,0x5870,0x6bc0,0x5852,0x583d,0x5879,0x5885,0x58b9,
0x589f,0x58ab,0x58ba,0x58de,0x58bb,0x58b8,0x58ae,0x58c5,
0x58d3,0x58d1,0x58d7,0x58d9,0x58d8,0x58e5,0x58dc,0x58e4,
0x58df,0x58ef,0x58fa,0x58f9,0x58fb,0x58fc,0x58fd,0x5902,
0x590a,0x5910,0x591b,0x68a6,0x5925,0x592c,0x592d,0x5932,
0x5938,0x593e,0x7ad2,0x5955,0x5950,0x594e,0x595a,0x5958,
0x5962,0x5960,0x5967,0x596c,0x5969,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5978,0x5981,0x599d,0x4f5e,0x4fab,0x59a3,0x59b2,0x59c6,
0x59e8,0x59dc,0x598d,0x59d9,0x59da,0x5a25,0x5a1f,0x5a11,
0x5a1c,0x5a09,0x5a1a,0x5a40,0x5a6c,0x5a49,0x5a35,0x5a36,
0x5a62,0x5a6a,0x5a9a,0x5abc,0x5abe,0x5acb,0x5ac2,0x5abd,
0x5ae3,0x5ad7,0x5ae6,0x5ae9,0x5ad6,0x5afa,0x5afb,0x5b0c,
0x5b0b,0x5b16,0x5b32,0x5ad0,0x5b2a,0x5b36,0x5b3e,0x5b43,
0x5b45,0x5b40,0x5b51,0x5b55,0x5b5a,0x5b5b,0x5b65,0x5b69,
0x5b70,0x5b73,0x5b75,0x5b78,0x6588,0x5b7a,0x5b80,0xffff,
0x5b83,0x5ba6,0x5bb8,0x5bc3,0x5bc7,0x5bc9,0x5bd4,0x5bd0,
0x5be4,0x5be6,0x5be2,0x5bde,0x5be5,0x5beb,0x5bf0,0x5bf6,
0x5bf3,0x5c05,0x5c07,0x5c08,0x5c0d,0x5c13,0x5c20,0x5c22,
0x5c28,0x5c38,0x5c39,0x5c41,0x5c46,0x5c4e,0x5c53,0x5c50,
0x5c4f,0x5b71,0x5c6c,0x5c6e,0x4e62,0x5c76,0x5c79,0x5c8c,
0x5c91,0x5c94,0x599b,0x5cab,0x5cbb,0x5cb6,0x5cbc,0x5cb7,
0x5cc5,0x5cbe,0x5cc7,0x5cd9,0x5ce9,0x5cfd,0x5cfa,0x5ced,
0x5d8c,0x5cea,0x5d0b,0x5d15,0x5d17,0x5d5c,0x5d1f,0x5d1b,
0x5d11,0x5d14,0x5d22,0x5d1a,0x5d19,0x5d18,0x5d4c,0x5d52,
0x5d4e,0x5d4b,0x5d6c,0x5d73,0x5d76,0x5d87,0x5d84,0x5d82,
0x5da2,0x5d9d,0x5dac,0x5dae,0x5dbd,0x5d90,0x5db7,0x5dbc,
0x5dc9,0x5dcd,0x5dd3,0x5dd2,0x5dd6,0x5ddb,0x5deb,0x5df2,
0x5df5,0x5e0b,0x5e1a,0x5e19,0x5e11,0x5e1b,0x5e36,0x5e37,
0x5e44,0x5e43,0x5e40,0x5e4e,0x5e57,0x5e54,0x5e5f,0x5e62,
0x5e64,0x5e47,0x5e75,0x5e76,0x5e7a,0x9ebc,0x5e7f,0x5ea0,
0x5ec1,0x5ec2,0x5ec8,0x5ed0,0x5ecf,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5ed6,0x5ee3,0x5edd,0x5eda,0x5edb,0x5ee2,0x5ee1,0x5ee8,
0x5ee9,0x5eec,0x5ef1,0x5ef3,0x5ef0,0x5ef4,0x5ef8,0x5efe,
0x5f03,0x5f09,0x5f5d,0x5f5c,0x5f0b,0x5f11,0x5f16,0x5f29,
0x5f2d,0x5f38,0x5f41,0x5f48,0x5f4c,0x5f4e,0x5f2f,0x5f51,
0x5f56,0x5f57,0x5f59,0x5f61,0x5f6d,0x5f73,0x5f77,0x5f83,
0x5f82,0x5f7f,0x5f8a,0x5f88,0x5f91,0x5f87,0x5f9e,0x5f99,
0x5f98,0x5fa0,0x5fa8,0x5fad,0x5fbc,0x5fd6,0x5ffb,0x5fe4,
0x5ff8,0x5ff1,0x5fdd,0x60b3,0x5fff,0x6021,0x6060,0xffff,
0x6019,0x6010,0x6029,0x600e,0x6031,0x601b,0x6015,0x602b,
0x6026,0x600f,0x603a,0x605a,0x6041,0x606a,0x6077,0x605f,
0x604a,0x6046,0x604d,0x6063,0x6043,0x6064,0x6042,0x606c,
0x606b,0x6059,0x6081,0x608d,0x60e7,0x6083,0x609a,0x6084,
0x609b,0x6096,0x6097,0x6092,0x60a7,0x608b,0x60e1,0x60b8,
0x60e0,0x60d3,0x60b4,0x5ff0,0x60bd,0x60c6,0x60b5,0x60d8,
0x614d,0x6115,0x6106,0x60f6,0x60f7,0x6100,0x60f4,0x60fa,
0x6103,0x6121,0x60fb,0x60f1,0x610d,0x610e,0x6147,0x613e,
0x6128,0x6127,0x614a,0x613f,0x613c,0x612c,0x6134,0x613d,
0x6142,0x6144,0x6173,0x6177,0x6158,0x6159,0x615a,0x616b,
0x6174,0x616f,0x6165,0x6171,0x615f,0x615d,0x6153,0x6175,
0x6199,0x6196,0x6187,0x61ac,0x6194,0x619a,0x618a,0x6191,
0x61ab,0x61ae,0x61cc,0x61ca,0x61c9,0x61f7,0x61c8,0x61c3,
0x61c6,0x61ba,0x61cb,0x7f79,0x61cd,0x61e6,0x61e3,0x61f6,
0x61fa,0x61f4,0x61ff,0x61fd,0x61fc,0x61fe,0x6200,0x6208,
0x6209,0x620d,0x620c,0x6214,0x621b,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x621e,0x6221,0x622a,0x622e,0x6230,0x6232,0x6233,0x6241,
0x624e,0x625e,0x6263,0x625b,0x6260,0x6268,0x627c,0x6282,
0x6289,0x627e,0x6292,0x6293,0x6296,0x62d4,0x6283,0x6294,
0x62d7,0x62d1,0x62bb,0x62cf,0x62ff,0x62c6,0x64d4,0x62c8,
0x62dc,0x62cc,0x62ca,0x62c2,0x62c7,0x629b,0x62c9,0x630c,
0x62ee,0x62f1,0x6327,0x6302,0x6308,0x62ef,0x62f5,0x6350,
0x633e,0x634d,0x641c,0x634f,0x6396,0x638e,0x6380,0x63ab,
0x6376,0x63a3,0x638f,0x6389,0x639f,0x63b5,0x636b,0xffff,
0x6369,0x63be,0x63e9,0x63c0,0x63c6,0x63e3,0x63c9,0x63d2,
0x63f6,0x63c4,0x6416,0x6434,0x6406,0x6413,0x6426,0x6436,
0x651d,0x6417,0x6428,0x640f,0x6467,0x646f,0x6476,0x644e,
0x652a,0x6495,0x6493,0x64a5,0x64a9,0x6488,0x64bc,0x64da,
0x64d2,0x64c5,0x64c7,0x64bb,0x64d8,0x64c2,0x64f1,0x64e7,
0x8209,0x64e0,0x64e1,0x62ac,0x64e3,0x64ef,0x652c,0x64f6,
0x64f4,0x64f2,0x64fa,0x6500,0x64fd,0x6518,0x651c,0x6505,
0x6524,0x6523,0x652b,0x6534,0x6535,0x6537,0x6536,0x6538,
0x754b,0x6548,0x6556,0x6555,0x654d,0x6558,0x655e,0x655d,
0x6572,0x6578,0x6582,0x6583,0x8b8a,0x659b,0x659f,0x65ab,
0x65b7,0x65c3,0x65c6,0x65c1,0x65c4,0x65cc,0x65d2,0x65db,
0x65d9,0x65e0,0x65e1,0x65f1,0x6772,0x660a,0x6603,0x65fb,
0x6773,0x6635,0x6636,0x6634,0x661c,0x664f,0x6644,0x6649,
0x6641,0x665e,0x665d,0x6664,0x6667,0x6668,0x665f,0x6662,
0x6670,0x6683,0x6688,0x668e,0x6689,0x6684,0x6698,0x669d,
0x66c1,0x66b9,0x66c9,0x66be,0x66bc,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x66c4,0x66b8,0x66d6,0x66da,0x66e0,0x663f,0x66e6,0x66e9,
0x66f0,0x66f5,0x66f7,0x670f,0x6716,0x671e,0x6726,0x6727,
0x9738,0x672e,0x673f,0x6736,0x6741,0x6738,0x6737,0x6746,
0x675e,0x6760,0x6759,0x6763,0x6764,0x6789,0x6770,0x67a9,
0x677c,0x676a,0x678c,0x678b,0x67a6,0x67a1,0x6785,0x67b7,
0x67ef,0x67b4,0x67ec,0x67b3,0x67e9,0x67b8,0x67e4,0x67de,
0x67dd,0x67e2,0x67ee,0x67b9,0x67ce,0x67c6,0x67e7,0x6a9c,
0x681e,0x6846,0x6829,0x6840,0x684d,0x6832,0x684e,0xffff,
0x68b3,0x682b,0x6859,0x6863,0x6877,0x687f,0x689f,0x688f,
0x68ad,0x6894,0x689d,0x689b,0x6883,0x6aae,0x68b9,0x6874,
0x68b5,0x68a0,0x68ba,0x690f,0x688d,0x687e,0x6901,0x68ca,
0x6908,0x68d8,0x6922,0x6926,0x68e1,0x690c,0x68cd,0x68d4,
0x68e7,0x68d5,0x6936,0x6912,0x6904,0x68d7,0x68e3,0x6925,
0x68f9,0x68e0,0x68ef,0x6928,0x692a,0x691a,0x6923,0x6921,
0x68c6,0x6979,0x6977,0x695c,0x6978,0x696b,0x6954,0x697e,
0x696e,0x6939,0x6974,0x693d,0x6959,0x6930,0x6961,0x695e,
0x695d,0x6981,0x696a,0x69b2,0x69ae,0x69d0,0x69bf,0x69c1,
0x69d3,0x69be,0x69ce,0x5be8,0x69ca,0x69dd,0x69bb,0x69c3,
0x69a7,0x6a2e,0x6991,0x69a0,0x699c,0x6995,0x69b4,0x69de,
0x69e8,0x6a02,0x6a1b,0x69ff,0x6b0a,0x69f9,0x69f2,0x69e7,
0x6a05,0x69b1,0x6a1e,0x69ed,0x6a14,0x69eb,0x6a0a,0x6a12,
0x6ac1,0x6a23,0x6a13,0x6a44,0x6a0c,0x6a72,0x6a36,0x6a78,
0x6a47,0x6a62,0x6a59,0x6a66,0x6a48,0x6a38,0x6a22,0x6a90,
0x6a8d,0x6aa0,0x6a84,0x6aa2,0x6aa3,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6a97,0x8617,0x6abb,0x6ac3,0x6ac2,0x6ab8,0x6ab3,0x6aac,
0x6ade,0x6ad1,0x6adf,0x6aaa,0x6ada,0x6aea,0x6afb,0x6b05,
0x8616,0x6afa,0x6b12,0x6b16,0x9b31,0x6b1f,0x6b38,0x6b37,
0x76dc,0x6b39,0x98ee,0x6b47,0x6b43,0x6b49,0x6b50,0x6b59,
0x6b54,0x6b5b,0x6b5f,0x6b61,0x6b78,0x6b79,0x6b7f,0x6b80,
0x6b84,0x6b83,0x6b8d,0x6b98,0x6b95,0x6b9e,0x6ba4,0x6baa,
0x6bab,0x6baf,0x6bb2,0x6bb1,0x6bb3,0x6bb7,0x6bbc,0x6bc6,
0x6bcb,0x6bd3,0x6bdf,0x6bec,0x6beb,0x6bf3,0x6bef,0xffff,
0x9ebe,0x6c08,0x6c13,0x6c14,0x6c1b,0x6c24,0x6c23,0x6c5e,
0x6c55,0x6c62,0x6c6a,0x6c82,0x6c8d,0x6c9a,0x6c81,0x6c9b,
0x6c7e,0x6c68,0x6c73,0x6c92,0x6c90,0x6cc4,0x6cf1,0x6cd3,
0x6cbd,0x6cd7,0x6cc5,0x6cdd,0x6cae,0x6cb1,0x6cbe,0x6cba,
0x6cdb,0x6cef,0x6cd9,0x6cea,0x6d1f,0x884d,0x6d36,0x6d2b,
0x6d3d,0x6d38,0x6d19,0x6d35,0x6d33,0x6d12,0x6d0c,0x6d63,
0x6d93,0x6d64,0x6d5a,0x6d79,0x6d59,0x6d8e,0x6d95,0x6fe4,
0x6d85,0x6df9,0x6e15,0x6e0a,0x6db5,0x6dc7,0x6de6,0x6db8,
0x6dc6,0x6dec,0x6dde,0x6dcc,0x6de8,0x6dd2,0x6dc5,0x6dfa,
0x6dd9,0x6de4,0x6dd5,0x6dea,0x6dee,0x6e2d,0x6e6e,0x6e2e,
0x6e19,0x6e72,0x6e5f,0x6e3e,0x6e23,0x6e6b,0x6e2b,0x6e76,
0x6e4d,0x6e1f,0x6e43,0x6e3a,0x6e4e,0x6e24,0x6eff,0x6e1d,
0x6e38,0x6e82,0x6eaa,0x6e98,0x6ec9,0x6eb7,0x6ed3,0x6ebd,
0x6eaf,0x6ec4,0x6eb2,0x6ed4,0x6ed5,0x6e8f,0x6ea5,0x6ec2,
0x6e9f,0x6f41,0x6f11,0x704c,0x6eec,0x6ef8,0x6efe,0x6f3f,
0x6ef2,0x6f31,0x6eef,0x6f32,0x6ecc,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6f3e,0x6f13,0x6ef7,0x6f86,0x6f7a,0x6f78,0x6f81,0x6f80,
0x6f6f,0x6f5b,0x6ff3,0x6f6d,0x6f82,0x6f7c,0x6f58,0x6f8e,
0x6f91,0x6fc2,0x6f66,0x6fb3,0x6fa3,0x6fa1,0x6fa4,0x6fb9,
0x6fc6,0x6faa,0x6fdf,0x6fd5,0x6fec,0x6fd4,0x6fd8,0x6ff1,
0x6fee,0x6fdb,0x7009,0x700b,0x6ffa,0x7011,0x7001,0x700f,
0x6ffe,0x701b,0x701a,0x6f74,0x701d,0x7018,0x701f,0x7030,
0x703e,0x7032,0x7051,0x7063,0x7099,0x7092,0x70af,0x70f1,
0x70ac,0x70b8,0x70b3,0x70ae,0x70df,0x70cb,0x70dd,0xffff,
0x70d9,0x7109,0x70fd,0x711c,0x7119,0x7165,0x7155,0x7188,
0x7166,0x7162,0x714c,0x7156,0x716c,0x718f,0x71fb,0x7184,
0x7195,0x71a8,0x71ac,0x71d7,0x71b9,0x71be,0x71d2,0x71c9,
0x71d4,0x71ce,0x71e0,0x71ec,0x71e7,0x71f5,0x71fc,0x71f9,
0x71ff,0x720d,0x7210,0x721b,0x7228,0x722d,0x722c,0x7230,
0x7232,0x723b,0x723c,0x723f,0x7240,0x7246,0x724b,0x7258,
0x7274,0x727e,0x7282,0x7281,0x7287,0x7292,0x7296,0x72a2,
0x72a7,0x72b9,0x72b2,0x72c3,0x72c6,0x72c4,0x72ce,0x72d2,
0x72e2,0x72e0,0x72e1,0x72f9,0x72f7,0x500f,0x7317,0x730a,
0x731c,0x7316,0x731d,0x7334,0x732f,0x7329,0x7325,0x733e,
0x734e,0x734f,0x9ed8,0x7357,0x736a,0x7368,0x7370,0x7378,
0x7375,0x737b,0x737a,0x73c8,0x73b3,0x73ce,0x73bb,0x73c0,
0x73e5,0x73ee,0x73de,0x74a2,0x7405,0x746f,0x7425,0x73f8,
0x7432,0x743a,0x7455,0x743f,0x745f,0x7459,0x7441,0x745c,
0x7469,0x7470,0x7463,0x746a,0x7476,0x747e,0x748b,0x749e,
0x74a7,0x74ca,0x74cf,0x74d4,0x73f1,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x74e0,0x74e3,0x74e7,0x74e9,0x74ee,0x74f2,0x74f0,0x74f1,
0x74f8,0x74f7,0x7504,0x7503,0x7505,0x750c,0x750e,0x750d,
0x7515,0x7513,0x751e,0x7526,0x752c,0x753c,0x7544,0x754d,
0x754a,0x7549,0x755b,0x7546,0x755a,0x7569,0x7564,0x7567,
0x756b,0x756d,0x7578,0x7576,0x7586,0x7587,0x7574,0x758a,
0x7589,0x7582,0x7594,0x759a,0x759d,0x75a5,0x75a3,0x75c2,
0x75b3,0x75c3,0x75b5,0x75bd,0x75b8,0x75bc,0x75b1,0x75cd,
0x75ca,0x75d2,0x75d9,0x75e3,0x75de,0x75fe,0x75ff,0xffff,
0x75fc,0x7601,0x75f0,0x75fa,0x75f2,0x75f3,0x760b,0x760d,
0x7609,0x761f,0x7627,0x7620,0x7621,0x7622,0x7624,0x7634,
0x7630,0x763b,0x7647,0x7648,0x7646,0x765c,0x7658,0x7661,
0x7662,0x7668,0x7669,0x766a,0x7667,0x766c,0x7670,0x7672,
0x7676,0x7678,0x767c,0x7680,0x7683,0x7688,0x768b,0x768e,
0x7696,0x7693,0x7699,0x769a,0x76b0,0x76b4,0x76b8,0x76b9,
0x76ba,0x76c2,0x76cd,0x76d6,0x76d2,0x76de,0x76e1,0x76e5,
0x76e7,0x76ea,0x862f,0x76fb,0x7708,0x7707,0x7704,0x7729,
0x7724,0x771e,0x7725,0x7726,0x771b,0x7737,0x7738,0x7747,
0x775a,0x7768,0x776b,0x775b,0x7765,0x777f,0x777e,0x7779,
0x778e,0x778b,0x7791,0x77a0,0x779e,0x77b0,0x77b6,0x77b9,
0x77bf,0x77bc,0x77bd,0x77bb,0x77c7,0x77cd,0x77d7,0x77da,
0x77dc,0x77e3,0x77ee,0x77fc,0x780c,0x7812,0x7926,0x7820,
0x792a,0x7845,0x788e,0x7874,0x7886,0x787c,0x789a,0x788c,
0x78a3,0x78b5,0x78aa,0x78af,0x78d1,0x78c6,0x78cb,0x78d4,
0x78be,0x78bc,0x78c5,0x78ca,0x78ec,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x78e7,0x78da,0x78fd,0x78f4,0x7907,0x7912,0x7911,0x7919,
0x792c,0x792b,0x7940,0x7960,0x7957,0x795f,0x795a,0x7955,
0x7953,0x797a,0x797f,0x798a,0x799d,0x79a7,0x9f4b,0x79aa,
0x79ae,0x79b3,0x79b9,0x79ba,0x79c9,0x79d5,0x79e7,0x79ec,
0x79e1,0x79e3,0x7a08,0x7a0d,0x7a18,0x7a19,0x7a20,0x7a1f,
0x7980,0x7a31,0x7a3b,0x7a3e,0x7a37,0x7a43,0x7a57,0x7a49,
0x7a61,0x7a62,0x7a69,0x9f9d,0x7a70,0x7a79,0x7a7d,0x7a88,
0x7a97,0x7a95,0x7a98,0x7a96,0x7aa9,0x7ac8,0x7ab0,0xffff,
0x7ab6,0x7ac5,0x7ac4,0x7abf,0x9083,0x7ac7,0x7aca,0x7acd,
0x7acf,0x7ad5,0x7ad3,0x7ad9,0x7ada,0x7add,0x7ae1,0x7ae2,
0x7ae6,0x7aed,0x7af0,0x7b02,0x7b0f,0x7b0a,0x7b06,0x7b33,
0x7b18,0x7b19,0x7b1e,0x7b35,0x7b28,0x7b36,0x7b50,0x7b7a,
0x7b04,0x7b4d,0x7b0b,0x7b4c,0x7b45,0x7b75,0x7b65,0x7b74,
0x7b67,0x7b70,0x7b71,0x7b6c,0x7b6e,0x7b9d,0x7b98,0x7b9f,
0x7b8d,0x7b9c,0x7b9a,0x7b8b,0x7b92,0x7b8f,0x7b5d,0x7b99,
0x7bcb,0x7bc1,0x7bcc,0x7bcf,0x7bb4,0x7bc6,0x7bdd,0x7be9,
0x7c11,0x7c14,0x7be6,0x7be5,0x7c60,0x7c00,0x7c07,0x7c13,
0x7bf3,0x7bf7,0x7c17,0x7c0d,0x7bf6,0x7c23,0x7c27,0x7c2a,
0x7c1f,0x7c37,0x7c2b,0x7c3d,0x7c4c,0x7c43,0x7c54,0x7c4f,
0x7c40,0x7c50,0x7c58,0x7c5f,0x7c64,0x7c56,0x7c65,0x7c6c,
0x7c75,0x7c83,0x7c90,0x7ca4,0x7cad,0x7ca2,0x7cab,0x7ca1,
0x7ca8,0x7cb3,0x7cb2,0x7cb1,0x7cae,0x7cb9,0x7cbd,0x7cc0,
0x7cc5,0x7cc2,0x7cd8,0x7cd2,0x7cdc,0x7ce2,0x9b3b,0x7cef,
0x7cf2,0x7cf4,0x7cf6,0x7cfa,0x7d06,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7d02,0x7d1c,0x7d15,0x7d0a,0x7d45,0x7d4b,0x7d2e,0x7d32,
0x7d3f,0x7d35,0x7d46,0x7d73,0x7d56,0x7d4e,0x7d72,0x7d68,
0x7d6e,0x7d4f,0x7d63,0x7d93,0x7d89,0x7d5b,0x7d8f,0x7d7d,
0x7d9b,0x7dba,0x7dae,0x7da3,0x7db5,0x7dc7,0x7dbd,0x7dab,
0x7e3d,0x7da2,0x7daf,0x7ddc,0x7db8,0x7d9f,0x7db0,0x7dd8,
0x7ddd,0x7de4,0x7dde,0x7dfb,0x7df2,0x7de1,0x7e05,0x7e0a,
0x7e23,0x7e21,0x7e12,0x7e31,0x7e1f,0x7e09,0x7e0b,0x7e22,
0x7e46,0x7e66,0x7e3b,0x7e35,0x7e39,0x7e43,0x7e37,0xffff,
0x7e32,0x7e3a,0x7e67,0x7e5d,0x7e56,0x7e5e,0x7e59,0x7e5a,
0x7e79,0x7e6a,0x7e69,0x7e7c,0x7e7b,0x7e83,0x7dd5,0x7e7d,
0x8fae,0x7e7f,0x7e88,0x7e89,0x7e8c,0x7e92,0x7e90,0x7e93,
0x7e94,0x7e96,0x7e8e,0x7e9b,0x7e9c,0x7f38,0x7f3a,0x7f45,
0x7f4c,0x7f4d,0x7f4e,0x7f50,0x7f51,0x7f55,0x7f54,0x7f58,
0x7f5f,0x7f60,0x7f68,0x7f69,0x7f67,0x7f78,0x7f82,0x7f86,
0x7f83,0x7f88,0x7f87,0x7f8c,0x7f94,0x7f9e,0x7f9d,0x7f9a,
0x7fa3,0x7faf,0x7fb2,0x7fb9,0x7fae,0x7fb6,0x7fb8,0x8b71,
0x7fc5,0x7fc6,0x7fca,0x7fd5,0x7fd4,0x7fe1,0x7fe6,0x7fe9,
0x7ff3,0x7ff9,0x98dc,0x8006,0x8004,0x800b,0x8012,0x8018,
0x8019,0x801c,0x8021,0x8028,0x803f,0x803b,0x804a,0x8046,
0x8052,0x8058,0x805a,0x805f,0x8062,0x8068,0x8073,0x8072,
0x8070,0x8076,0x8079,0x807d,0x807f,0x8084,0x8086,0x8085,
0x809b,0x8093,0x809a,0x80ad,0x5190,0x80ac,0x80db,0x80e5,
0x80d9,0x80dd,0x80c4,0x80da,0x80d6,0x8109,0x80ef,0x80f1,
0x811b,0x8129,0x8123,0x812f,0x814b,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x968b,0x8146,0x813e,0x8153,0x8151,0x80fc,0x8171,0x816e,
0x8165,0x8166,0x8174,0x8183,0x8188,0x818a,0x8180,0x8182,
0x81a0,0x8195,0x81a4,0x81a3,0x815f,0x8193,0x81a9,0x81b0,
0x81b5,0x81be,0x81b8,0x81bd,0x81c0,0x81c2,0x81ba,0x81c9,
0x81cd,0x81d1,0x81d9,0x81d8,0x81c8,0x81da,0x81df,0x81e0,
0x81e7,0x81fa,0x81fb,0x81fe,0x8201,0x8202,0x8205,0x8207,
0x820a,0x820d,0x8210,0x8216,0x8229,0x822b,0x8238,0x8233,
0x8240,0x8259,0x8258,0x825d,0x825a,0x825f,0x8264,0xffff,
0x8262,0x8268,0x826a,0x826b,0x822e,0x8271,0x8277,0x8278,
0x827e,0x828d,0x8292,0x82ab,0x829f,0x82bb,0x82ac,0x82e1,
0x82e3,0x82df,0x82d2,0x82f4,0x82f3,0x82fa,0x8393,0x8303,
0x82fb,0x82f9,0x82de,0x8306,0x82dc,0x8309,0x82d9,0x8335,
0x8334,0x8316,0x8332,0x8331,0x8340,0x8339,0x8350,0x8345,
0x832f,0x832b,0x8317,0x8318,0x8385,0x839a,0x83aa,0x839f,
0x83a2,0x8396,0x8323,0x838e,0x8387,0x838a,0x837c,0x83b5,
0x8373,0x8375,0x83a0,0x8389,0x83a8,0x83f4,0x8413,0x83eb,
0x83ce,0x83fd,0x8403,0x83d8,0x840b,0x83c1,0x83f7,0x8407,
0x83e0,0x83f2,0x840d,0x8422,0x8420,0x83bd,0x8438,0x8506,
0x83fb,0x846d,0x842a,0x843c,0x855a,0x8484,0x8477,0x846b,
0x84ad,0x846e,0x8482,0x8469,0x8446,0x842c,0x846f,0x8479,
0x8435,0x84ca,0x8462,0x84b9,0x84bf,0x849f,0x84d9,0x84cd,
0x84bb,0x84da,0x84d0,0x84c1,0x84c6,0x84d6,0x84a1,0x8521,
0x84ff,0x84f4,0x8517,0x8518,0x852c,0x851f,0x8515,0x8514,
0x84fc,0x8540,0x8563,0x8558,0x8548,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8541,0x8602,0x854b,0x8555,0x8580,0x85a4,0x8588,0x8591,
0x858a,0x85a8,0x856d,0x8594,0x859b,0x85ea,0x8587,0x859c,
0x8577,0x857e,0x8590,0x85c9,0x85ba,0x85cf,0x85b9,0x85d0,
0x85d5,0x85dd,0x85e5,0x85dc,0x85f9,0x860a,0x8613,0x860b,
0x85fe,0x85fa,0x8606,0x8622,0x861a,0x8630,0x863f,0x864d,
0x4e55,0x8654,0x865f,0x8667,0x8671,0x8693,0x86a3,0x86a9,
0x86aa,0x868b,0x868c,0x86b6,0x86af,0x86c4,0x86c6,0x86b0,
0x86c9,0x8823,0x86ab,0x86d4,0x86de,0x86e9,0x86ec,0xffff,
0x86df,0x86db,0x86ef,0x8712,0x8706,0x8708,0x8700,0x8703,
0x86fb,0x8711,0x8709,0x870d,0x86f9,0x870a,0x8734,0x873f,
0x8737,0x873b,0x8725,0x8729,0x871a,0x8760,0x875f,0x8778,
0x874c,0x874e,0x8774,0x8757,0x8768,0x876e,0x8759,0x8753,
0x8763,0x876a,0x8805,0x87a2,0x879f,0x8782,0x87af,0x87cb,
0x87bd,0x87c0,0x87d0,0x96d6,0x87ab,0x87c4,0x87b3,0x87c7,
0x87c6,0x87bb,0x87ef,0x87f2,0x87e0,0x880f,0x880d,0x87fe,
0x87f6,0x87f7,0x880e,0x87d2,0x8811,0x8816,0x8815,0x8822,
0x8821,0x8831,0x8836,0x8839,0x8827,0x883b,0x8844,0x8842,
0x8852,0x8859,0x885e,0x8862,0x886b,0x8881,0x887e,0x889e,
0x8875,0x887d,0x88b5,0x8872,0x8882,0x8897,0x8892,0x88ae,
0x8899,0x88a2,0x888d,0x88a4,0x88b0,0x88bf,0x88b1,0x88c3,
0x88c4,0x88d4,0x88d8,0x88d9,0x88dd,0x88f9,0x8902,0x88fc,
0x88f4,0x88e8,0x88f2,0x8904,0x890c,0x890a,0x8913,0x8943,
0x891e,0x8925,0x892a,0x892b,0x8941,0x8944,0x893b,0x8936,
0x8938,0x894c,0x891d,0x8960,0x895e,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8966,0x8964,0x896d,0x896a,0x896f,0x8974,0x8977,0x897e,
0x8983,0x8988,0x898a,0x8993,0x8998,0x89a1,0x89a9,0x89a6,
0x89ac,0x89af,0x89b2,0x89ba,0x89bd,0x89bf,0x89c0,0x89da,
0x89dc,0x89dd,0x89e7,0x89f4,0x89f8,0x8a03,0x8a16,0x8a10,
0x8a0c,0x8a1b,0x8a1d,0x8a25,0x8a36,0x8a41,0x8a5b,0x8a52,
0x8a46,0x8a48,0x8a7c,0x8a6d,0x8a6c,0x8a62,0x8a85,0x8a82,
0x8a84,0x8aa8,0x8aa1,0x8a91,0x8aa5,0x8aa6,0x8a9a,0x8aa3,
0x8ac4,0x8acd,0x8ac2,0x8ada,0x8aeb,0x8af3,0x8ae7,0xffff,
0x8ae4,0x8af1,0x8b14,0x8ae0,0x8ae2,0x8af7,0x8ade,0x8adb,
0x8b0c,0x8b07,0x8b1a,0x8ae1,0x8b16,0x8b10,0x8b17,0x8b20,
0x8b33,0x97ab,0x8b26,0x8b2b,0x8b3e,0x8b28,0x8b41,0x8b4c,
0x8b4f,0x8b4e,0x8b49,0x8b56,0x8b5b,0x8b5a,0x8b6b,0x8b5f,
0x8b6c,0x8b6f,0x8b74,0x8b7d,0x8b80,0x8b8c,0x8b8e,0x8b92,
0x8b93,0x8b96,0x8b99,0x8b9a,0x8c3a,0x8c41,0x8c3f,0x8c48,
0x8c4c,0x8c4e,0x8c50,0x8c55,0x8c62,0x8c6c,0x8c78,0x8c7a,
0x8c82,0x8c89,0x8c85,0x8c8a,0x8c8d,0x8c8e,0x8c94,0x8c7c,
0x8c98,0x621d,0x8cad,0x8caa,0x8cbd,0x8cb2,0x8cb3,0x8cae,
0x8cb6,0x8cc8,0x8cc1,0x8ce4,0x8ce3,0x8cda,0x8cfd,0x8cfa,
0x8cfb,0x8d04,0x8d05,0x8d0a,0x8d07,0x8d0f,0x8d0d,0x8d10,
0x9f4e,0x8d13,0x8ccd,0x8d14,0x8d16,0x8d67,0x8d6d,0x8d71,
0x8d73,0x8d81,0x8d99,0x8dc2,0x8dbe,0x8dba,0x8dcf,0x8dda,
0x8dd6,0x8dcc,0x8ddb,0x8dcb,0x8dea,0x8deb,0x8ddf,0x8de3,
0x8dfc,0x8e08,0x8e09,0x8dff,0x8e1d,0x8e1e,0x8e10,0x8e1f,
0x8e42,0x8e35,0x8e30,0x8e34,0x8e4a,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8e47,0x8e49,0x8e4c,0x8e50,0x8e48,0x8e59,0x8e64,0x8e60,
0x8e2a,0x8e63,0x8e55,0x8e76,0x8e72,0x8e7c,0x8e81,0x8e87,
0x8e85,0x8e84,0x8e8b,0x8e8a,0x8e93,0x8e91,0x8e94,0x8e99,
0x8eaa,0x8ea1,0x8eac,0x8eb0,0x8ec6,0x8eb1,0x8ebe,0x8ec5,
0x8ec8,0x8ecb,0x8edb,0x8ee3,0x8efc,0x8efb,0x8eeb,0x8efe,
0x8f0a,0x8f05,0x8f15,0x8f12,0x8f19,0x8f13,0x8f1c,0x8f1f,
0x8f1b,0x8f0c,0x8f26,0x8f33,0x8f3b,0x8f39,0x8f45,0x8f42,
0x8f3e,0x8f4c,0x8f49,0x8f46,0x8f4e,0x8f57,0x8f5c,0xffff,
0x8f62,0x8f63,0x8f64,0x8f9c,0x8f9f,0x8fa3,0x8fad,0x8faf,
0x8fb7,0x8fda,0x8fe5,0x8fe2,0x8fea,0x8fef,0x9087,0x8ff4,
0x9005,0x8ff9,0x8ffa,0x9011,0x9015,0x9021,0x900d,0x901e,
0x9016,0x900b,0x9027,0x9036,0x9035,0x9039,0x8ff8,0x904f,
0x9050,0x9051,0x9052,0x900e,0x9049,0x903e,0x9056,0x9058,
0x905e,0x9068,0x906f,0x9076,0x96a8,0x9072,0x9082,0x907d,
0x9081,0x9080,0x908a,0x9089,0x908f,0x90a8,0x90af,0x90b1,
0x90b5,0x90e2,0x90e4,0x6248,0x90db,0x9102,0x9112,0x9119,
0x9132,0x9130,0x914a,0x9156,0x9158,0x9163,0x9165,0x9169,
0x9173,0x9172,0x918b,0x9189,0x9182,0x91a2,0x91ab,0x91af,
0x91aa,0x91b5,0x91b4,0x91ba,0x91c0,0x91c1,0x91c9,0x91cb,
0x91d0,0x91d6,0x91df,0x91e1,0x91db,0x91fc,0x91f5,0x91f6,
0x921e,0x91ff,0x9214,0x922c,0x9215,0x9211,0x925e,0x9257,
0x9245,0x9249,0x9264,0x9248,0x9295,0x923f,0x924b,0x9250,
0x929c,0x9296,0x9293,0x929b,0x925a,0x92cf,0x92b9,0x92b7,
0x92e9,0x930f,0x92fa,0x9344,0x932e,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9319,0x9322,0x931a,0x9323,0x933a,0x9335,0x933b,0x935c,
0x9360,0x937c,0x936e,0x9356,0x93b0,0x93ac,0x93ad,0x9394,
0x93b9,0x93d6,0x93d7,0x93e8,0x93e5,0x93d8,0x93c3,0x93dd,
0x93d0,0x93c8,0x93e4,0x941a,0x9414,0x9413,0x9403,0x9407,
0x9410,0x9436,0x942b,0x9435,0x9421,0x943a,0x9441,0x9452,
0x9444,0x945b,0x9460,0x9462,0x945e,0x946a,0x9229,0x9470,
0x9475,0x9477,0x947d,0x945a,0x947c,0x947e,0x9481,0x947f,
0x9582,0x9587,0x958a,0x9594,0x9596,0x9598,0x9599,0xffff,
0x95a0,0x95a8,0x95a7,0x95ad,0x95bc,0x95bb,0x95b9,0x95be,
0x95ca,0x6ff6,0x95c3,0x95cd,0x95cc,0x95d5,0x95d4,0x95d6,
0x95dc,0x95e1,0x95e5,0x95e2,0x9621,0x9628,0x962e,0x962f,
0x9642,0x964c,0x964f,0x964b,0x9677,0x965c,0x965e,0x965d,
0x965f,0x9666,0x9672,0x966c,0x968d,0x9698,0x9695,0x9697,
0x96aa,0x96a7,0x96b1,0x96b2,0x96b0,0x96b4,0x96b6,0x96b8,
0x96b9,0x96ce,0x96cb,0x96c9,0x96cd,0x894d,0x96dc,0x970d,
0x96d5,0x96f9,0x9704,0x9706,0x9708,0x9713,0x970e,0x9711,
0x970f,0x9716,0x9719,0x9724,0x972a,0x9730,0x9739,0x973d,
0x973e,0x9744,0x9746,0x9748,0x9742,0x9749,0x975c,0x9760,
0x9764,0x9766,0x9768,0x52d2,0x976b,0x9771,0x9779,0x9785,
0x977c,0x9781,0x977a,0x9786,0x978b,0x978f,0x9790,0x979c,
0x97a8,0x97a6,0x97a3,0x97b3,0x97b4,0x97c3,0x97c6,0x97c8,
0x97cb,0x97dc,0x97ed,0x9f4f,0x97f2,0x7adf,0x97f6,0x97f5,
0x980f,0x980c,0x9838,0x9824,0x9821,0x9837,0x983d,0x9846,
0x984f,0x984b,0x986b,0x986f,0x9870,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9871,0x9874,0x9873,0x98aa,0x98af,0x98b1,0x98b6,0x98c4,
0x98c3,0x98c6,0x98e9,0x98eb,0x9903,0x9909,0x9912,0x9914,
0x9918,0x9921,0x991d,0x991e,0x9924,0x9920,0x992c,0x992e,
0x993d,0x993e,0x9942,0x9949,0x9945,0x9950,0x994b,0x9951,
0x9952,0x994c,0x9955,0x9997,0x9998,0x99a5,0x99ad,0x99ae,
0x99bc,0x99df,0x99db,0x99dd,0x99d8,0x99d1,0x99ed,0x99ee,
0x99f1,0x99f2,0x99fb,0x99f8,0x9a01,0x9a0f,0x9a05,0x99e2,
0x9a19,0x9a2b,0x9a37,0x9a45,0x9a42,0x9a40,0x9a43,0xffff,
0x9a3e,0x9a55,0x9a4d,0x9a5b,0x9a57,0x9a5f,0x9a62,0x9a65,
0x9a64,0x9a69,0x9a6b,0x9a6a,0x9aad,0x9ab0,0x9abc,0x9ac0,
0x9acf,0x9ad1,0x9ad3,0x9ad4,0x9ade,0x9adf,0x9ae2,0x9ae3,
0x9ae6,0x9aef,0x9aeb,0x9aee,0x9af4,0x9af1,0x9af7,0x9afb,
0x9b06,0x9b18,0x9b1a,0x9b1f,0x9b22,0x9b23,0x9b25,0x9b27,
0x9b28,0x9b29,0x9b2a,0x9b2e,0x9b2f,0x9b32,0x9b44,0x9b43,
0x9b4f,0x9b4d,0x9b4e,0x9b51,0x9b58,0x9b74,0x9b93,0x9b83,
0x9b91,0x9b96,0x9b97,0x9b9f,0x9ba0,0x9ba8,0x9bb4,0x9bc0,
0x9bca,0x9bb9,0x9bc6,0x9bcf,0x9bd1,0x9bd2,0x9be3,0x9be2,
0x9be4,0x9bd4,0x9be1,0x9c3a,0x9bf2,0x9bf1,0x9bf0,0x9c15,
0x9c14,0x9c09,0x9c13,0x9c0c,0x9c06,0x9c08,0x9c12,0x9c0a,
0x9c04,0x9c2e,0x9c1b,0x9c25,0x9c24,0x9c21,0x9c30,0x9c47,
0x9c32,0x9c46,0x9c3e,0x9c5a,0x9c60,0x9c67,0x9c76,0x9c78,
0x9ce7,0x9cec,0x9cf0,0x9d09,0x9d08,0x9ceb,0x9d03,0x9d06,
0x9d2a,0x9d26,0x9daf,0x9d23,0x9d1f,0x9d44,0x9d15,0x9d12,
0x9d41,0x9d3f,0x9d3e,0x9d46,0x9d48,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9d5d,0x9d5e,0x9d64,0x9d51,0x9d50,0x9d59,0x9d72,0x9d89,
0x9d87,0x9dab,0x9d6f,0x9d7a,0x9d9a,0x9da4,0x9da9,0x9db2,
0x9dc4,0x9dc1,0x9dbb,0x9db8,0x9dba,0x9dc6,0x9dcf,0x9dc2,
0x9dd9,0x9dd3,0x9df8,0x9de6,0x9ded,0x9def,0x9dfd,0x9e1a,
0x9e1b,0x9e1e,0x9e75,0x9e79,0x9e7d,0x9e81,0x9e88,0x9e8b,
0x9e8c,0x9e92,0x9e95,0x9e91,0x9e9d,0x9ea5,0x9ea9,0x9eb8,
0x9eaa,0x9ead,0x9761,0x9ecc,0x9ece,0x9ecf,0x9ed0,0x9ed4,
0x9edc,0x9ede,0x9edd,0x9ee0,0x9ee5,0x9ee8,0x9eef,0xffff,
0x9ef4,0x9ef6,0x9ef7,0x9ef9,0x9efb,0x9efc,0x9efd,0x9f07,
0x9f08,0x76b7,0x9f15,0x9f21,0x9f2c,0x9f3e,0x9f4a,0x9f52,
0x9f54,0x9f63,0x9f5f,0x9f60,0x9f61,0x9f66,0x9f67,0x9f6c,
0x9f6a,0x9f77,0x9f72,0x9f76,0x9f95,0x9f9c,0x9fa0,0x582f,
0x69c7,0x9059,0x7464,0x51dc,0x7199,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7e8a,0x891c,0x9348,0x9288,0x84dc,0x4fc9,0x70bb,0x6631,
0x68c8,0x92f9,0x66fb,0x5f45,0x4e28,0x4ee1,0x4efc,0x4f00,
0x4f03,0x4f39,0x4f56,0x4f92,0x4f8a,0x4f9a,0x4f94,0x4fcd,
0x5040,0x5022,0x4fff,0x501e,0x5046,0x5070,0x5042,0x5094,
0x50f4,0x50d8,0x514a,0x5164,0x519d,0x51be,0x51ec,0x5215,
0x529c,0x52a6,0x52c0,0x52db,0x5300,0x5307,0x5324,0x5372,
0x5393,0x53b2,0x53dd,0xfa0e,0x549c,0x548a,0x54a9,0x54ff,
0x5586,0x5759,0x5765,0x57ac,0x57c8,0x57c7,0xfa0f,0xffff,
0xfa10,0x589e,0x58b2,0x590b,0x5953,0x595b,0x595d,0x5963,
0x59a4,0x59ba,0x5b56,0x5bc0,0x752f,0x5bd8,0x5bec,0x5c1e,
0x5ca6,0x5cba,0x5cf5,0x5d27,0x5d53,0xfa11,0x5d42,0x5d6d,
0x5db8,0x5db9,0x5dd0,0x5f21,0x5f34,0x5f67,0x5fb7,0x5fde,
0x605d,0x6085,0x608a,0x60de,0x60d5,0x6120,0x60f2,0x6111,
0x6137,0x6130,0x6198,0x6213,0x62a6,0x63f5,0x6460,0x649d,
0x64ce,0x654e,0x6600,0x6615,0x663b,0x6609,0x662e,0x661e,
0x6624,0x6665,0x6657,0x6659,0xfa12,0x6673,0x6699,0x66a0,
0x66b2,0x66bf,0x66fa,0x670e,0xf929,0x6766,0x67bb,0x6852,
0x67c0,0x6801,0x6844,0x68cf,0xfa13,0x6968,0xfa14,0x6998,
0x69e2,0x6a30,0x6a6b,0x6a46,0x6a73,0x6a7e,0x6ae2,0x6ae4,
0x6bd6,0x6c3f,0x6c5c,0x6c86,0x6c6f,0x6cda,0x6d04,0x6d87,
0x6d6f,0x6d96,0x6dac,0x6dcf,0x6df8,0x6df2,0x6dfc,0x6e39,
0x6e5c,0x6e27,0x6e3c,0x6ebf,0x6f88,0x6fb5,0x6ff5,0x7005,
0x7007,0x7028,0x7085,0x70ab,0x710f,0x7104,0x715c,0x7146,
0x7147,0xfa15,0x71c1,0x71fe,0x72b1,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x72be,0x7324,0xfa16,0x7377,0x73bd,0x73c9,0x73d6,0x73e3,
0x73d2,0x7407,0x73f5,0x7426,0x742a,0x7429,0x742e,0x7462,
0x7489,0x749f,0x7501,0x756f,0x7682,0x769c,0x769e,0x769b,
0x76a6,0xfa17,0x7746,0x52af,0x7821,0x784e,0x7864,0x787a,
0x7930,0xfa18,0xfa19,0xfa1a,0x7994,0xfa1b,0x799b,0x7ad1,
0x7ae7,0xfa1c,0x7aeb,0x7b9e,0xfa1d,0x7d48,0x7d5c,0x7db7,
0x7da0,0x7dd6,0x7e52,0x7f47,0x7fa1,0xfa1e,0x8301,0x8362,
0x837f,0x83c7,0x83f6,0x8448,0x84b4,0x8553,0x8559,0xffff,
0x856b,0xfa1f,0x85b0,0xfa20,0xfa21,0x8807,0x88f5,0x8a12,
0x8a37,0x8a79,0x8aa7,0x8abe,0x8adf,0xfa22,0x8af6,0x8b53,
0x8b7f,0x8cf0,0x8cf4,0x8d12,0x8d76,0xfa23,0x8ecf,0xfa24,
0xfa25,0x9067,0x90de,0xfa26,0x9115,0x9127,0x91da,0x91d7,
0x91de,0x91ed,0x91ee,0x91e4,0x91e5,0x9206,0x9210,0x920a,
0x923a,0x9240,0x923c,0x924e,0x9259,0x9251,0x9239,0x9267,
0x92a7,0x9277,0x9278,0x92e7,0x92d7,0x92d9,0x92d0,0xfa27,
0x92d5,0x92e0,0x92d3,0x9325,0x9321,0x92fb,0xfa28,0x931e,
0x92ff,0x931d,0x9302,0x9370,0x9357,0x93a4,0x93c6,0x93de,
0x93f8,0x9431,0x9445,0x9448,0x9592,0xf9dc,0xfa29,0x969d,
0x96af,0x9733,0x973b,0x9743,0x974d,0x974f,0x9751,0x9755,
0x9857,0x9865,0xfa2a,0xfa2b,0x9927,0xfa2c,0x999e,0x9a4e,
0x9ad9,0x9adc,0x9b75,0x9b72,0x9b8f,0x9bb1,0x9bbb,0x9c00,
0x9d70,0x9d6b,0xfa2d,0x9e19,0x9ed1,0xffff,0xffff,0x2170,
0x2171,0x2172,0x2173,0x2174,0x2175,0x2176,0x2177,0x2178,
0x2179,0xffe2,0xffe4,0xff07,0xff02,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x2170,0x2171,0x2172,0x2173,0x2174,0x2175,0x2176,0x2177,
0x2178,0x2179,0x2160,0x2161,0x2162,0x2163,0x2164,0x2165,
0x2166,0x2167,0x2168,0x2169,0xffe2,0xffe4,0xff07,0xff02,
0x3231,0x2116,0x2121,0x2235,0x7e8a,0x891c,0x9348,0x9288,
0x84dc,0x4fc9,0x70bb,0x6631,0x68c8,0x92f9,0x66fb,0x5f45,
0x4e28,0x4ee1,0x4efc,0x4f00,0x4f03,0x4f39,0x4f56,0x4f92,
0x4f8a,0x4f9a,0x4f94,0x4fcd,0x5040,0x5022,0x4fff,0x501e,
0x5046,0x5070,0x5042,0x5094,0x50f4,0x50d8,0x514a,0xffff,
0x5164,0x519d,0x51be,0x51ec,0x5215,0x529c,0x52a6,0x52c0,
0x52db,0x5300,0x5307,0x5324,0x5372,0x5393,0x53b2,0x53dd,
0xfa0e,0x549c,0x548a,0x54a9,0x54ff,0x5586,0x5759,0x5765,
0x57ac,0x57c8,0x57c7,0xfa0f,0xfa10,0x589e,0x58b2,0x590b,
0x5953,0x595b,0x595d,0x5963,0x59a4,0x59ba,0x5b56,0x5bc0,
0x752f,0x5bd8,0x5bec,0x5c1e,0x5ca6,0x5cba,0x5cf5,0x5d27,
0x5d53,0xfa11,0x5d42,0x5d6d,0x5db8,0x5db9,0x5dd0,0x5f21,
0x5f34,0x5f67,0x5fb7,0x5fde,0x605d,0x6085,0x608a,0x60de,
0x60d5,0x6120,0x60f2,0x6111,0x6137,0x6130,0x6198,0x6213,
0x62a6,0x63f5,0x6460,0x649d,0x64ce,0x654e,0x6600,0x6615,
0x663b,0x6609,0x662e,0x661e,0x6624,0x6665,0x6657,0x6659,
0xfa12,0x6673,0x6699,0x66a0,0x66b2,0x66bf,0x66fa,0x670e,
0xf929,0x6766,0x67bb,0x6852,0x67c0,0x6801,0x6844,0x68cf,
0xfa13,0x6968,0xfa14,0x6998,0x69e2,0x6a30,0x6a6b,0x6a46,
0x6a73,0x6a7e,0x6ae2,0x6ae4,0x6bd6,0x6c3f,0x6c5c,0x6c86,
0x6c6f,0x6cda,0x6d04,0x6d87,0x6d6f,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6d96,0x6dac,0x6dcf,0x6df8,0x6df2,0x6dfc,0x6e39,0x6e5c,
0x6e27,0x6e3c,0x6ebf,0x6f88,0x6fb5,0x6ff5,0x7005,0x7007,
0x7028,0x7085,0x70ab,0x710f,0x7104,0x715c,0x7146,0x7147,
0xfa15,0x71c1,0x71fe,0x72b1,0x72be,0x7324,0xfa16,0x7377,
0x73bd,0x73c9,0x73d6,0x73e3,0x73d2,0x7407,0x73f5,0x7426,
0x742a,0x7429,0x742e,0x7462,0x7489,0x749f,0x7501,0x756f,
0x7682,0x769c,0x769e,0x769b,0x76a6,0xfa17,0x7746,0x52af,
0x7821,0x784e,0x7864,0x787a,0x7930,0xfa18,0xfa19,0xffff,
0xfa1a,0x7994,0xfa1b,0x799b,0x7ad1,0x7ae7,0xfa1c,0x7aeb,
0x7b9e,0xfa1d,0x7d48,0x7d5c,0x7db7,0x7da0,0x7dd6,0x7e52,
0x7f47,0x7fa1,0xfa1e,0x8301,0x8362,0x837f,0x83c7,0x83f6,
0x8448,0x84b4,0x8553,0x8559,0x856b,0xfa1f,0x85b0,0xfa20,
0xfa21,0x8807,0x88f5,0x8a12,0x8a37,0x8a79,0x8aa7,0x8abe,
0x8adf,0xfa22,0x8af6,0x8b53,0x8b7f,0x8cf0,0x8cf4,0x8d12,
0x8d76,0xfa23,0x8ecf,0xfa24,0xfa25,0x9067,0x90de,0xfa26,
0x9115,0x9127,0x91da,0x91d7,0x91de,0x91ed,0x91ee,0x91e4,
0x91e5,0x9206,0x9210,0x920a,0x923a,0x9240,0x923c,0x924e,
0x9259,0x9251,0x9239,0x9267,0x92a7,0x9277,0x9278,0x92e7,
0x92d7,0x92d9,0x92d0,0xfa27,0x92d5,0x92e0,0x92d3,0x9325,
0x9321,0x92fb,0xfa28,0x931e,0x92ff,0x931d,0x9302,0x9370,
0x9357,0x93a4,0x93c6,0x93de,0x93f8,0x9431,0x9445,0x9448,
0x9592,0xf9dc,0xfa29,0x969d,0x96af,0x9733,0x973b,0x9743,
0x974d,0x974f,0x9751,0x9755,0x9857,0x9865,0xfa2a,0xfa2b,
0x9927,0xfa2c,0x999e,0x9a4e,0x9ad9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9adc,0x9b75,0x9b72,0x9b8f,0x9bb1,0x9bbb,0x9c00,0x9d70,
0x9d6b,0xfa2d,0x9e19,0x9ed1
};
static const unsigned short Our_MS_sjis_tableB[] = {
0x0000,0x0001,0x0002,0x0003,0x0004,0x0005,0x0006,0x0007,
0x0008,0x0009,0x000a,0x000b,0x000c,0x000d,0x000e,0x000f,
0x0010,0x0011,0x0012,0x0013,0x0014,0x0015,0x0016,0x0017,
0x0018,0x0019,0x001a,0x001b,0x001c,0x001d,0x001e,0x001f,
0x0020,0x0021,0x0022,0x0023,0x0024,0x0025,0x0026,0x0027,
0x0028,0x0029,0x002a,0x002b,0x002c,0x002d,0x002e,0x002f,
0x0030,0x0031,0x0032,0x0033,0x0034,0x0035,0x0036,0x0037,
0x0038,0x0039,0x003a,0x003b,0x003c,0x003d,0x003e,0x003f,
0x0040,0x0041,0x0042,0x0043,0x0044,0x0045,0x0046,0x0047,
0x0048,0x0049,0x004a,0x004b,0x004c,0x004d,0x004e,0x004f,
0x0050,0x0051,0x0052,0x0053,0x0054,0x0055,0x0056,0x0057,
0x0058,0x0059,0x005a,0x005b,0x005c,0x005d,0x005e,0x005f,
0x0060,0x0061,0x0062,0x0063,0x0064,0x0065,0x0066,0x0067,
0x0068,0x0069,0x006a,0x006b,0x006c,0x006d,0x006e,0x006f,
0x0070,0x0071,0x0072,0x0073,0x0074,0x0075,0x0076,0x0077,
0x0078,0x0079,0x007a,0x007b,0x007c,0x007d,0x007e,0x007f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8191,0x8192,0xffff,0x818f,0xffff,0x8198,
0x814e,0xffff,0xffff,0xffff,0x81ca,0xffff,0xffff,0xffff,
0x818b,0x817d,0xffff,0xffff,0x814c,0xffff,0x81f7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x817e,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8180,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x839f,0x83a0,0x83a1,0x83a2,0x83a3,0x83a4,0x83a5,
0x83a6,0x83a7,0x83a8,0x83a9,0x83aa,0x83ab,0x83ac,0x83ad,
0x83ae,0x83af,0xffff,0x83b0,0x83b1,0x83b2,0x83b3,0x83b4,
0x83b5,0x83b6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x83bf,0x83c0,0x83c1,0x83c2,0x83c3,0x83c4,0x83c5,
0x83c6,0x83c7,0x83c8,0x83c9,0x83ca,0x83cb,0x83cc,0x83cd,
0x83ce,0x83cf,0xffff,0x83d0,0x83d1,0x83d2,0x83d3,0x83d4,
0x83d5,0x83d6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8446,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8440,0x8441,0x8442,0x8443,0x8444,0x8445,0x8447,0x8448,
0x8449,0x844a,0x844b,0x844c,0x844d,0x844e,0x844f,0x8450,
0x8451,0x8452,0x8453,0x8454,0x8455,0x8456,0x8457,0x8458,
0x8459,0x845a,0x845b,0x845c,0x845d,0x845e,0x845f,0x8460,
0x8470,0x8471,0x8472,0x8473,0x8474,0x8475,0x8477,0x8478,
0x8479,0x847a,0x847b,0x847c,0x847d,0x847e,0x8480,0x8481,
0x8482,0x8483,0x8484,0x8485,0x8486,0x8487,0x8488,0x8489,
0x848a,0x848b,0x848c,0x848d,0x848e,0x848f,0x8490,0x8491,
0xffff,0x8476,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x815d,0xffff,0xffff,0xffff,0x815c,0x815c,0x8161,0xffff,
0x8165,0x8166,0xffff,0xffff,0x8167,0x8168,0xffff,0xffff,
0x81f5,0x81f6,0xffff,0xffff,0xffff,0x8164,0x8163,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x81f1,0xffff,0x818c,0x818d,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x81a6,0xffff,0xffff,0x8150,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x818e,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8782,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8784,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x81f0,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8754,0x8755,0x8756,0x8757,0x8758,0x8759,0x875a,0x875b,
0x875c,0x875d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xfa40,0xfa41,0xfa42,0xfa43,0xfa44,0xfa45,0xfa46,0xfa47,
0xfa48,0xfa49,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x81a9,0x81aa,0x81a8,0x81ab,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x81cb,0xffff,0x81cc,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x81cd,0xffff,0x81dd,0x81ce,0xffff,0xffff,0xffff,0x81de,
0x81b8,0xffff,0xffff,0x81b9,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8794,0x817c,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x81e3,0xffff,0xffff,0x81e5,0x8187,0x8798,
0x81da,0xffff,0xffff,0xffff,0xffff,0x8161,0xffff,0x81c8,
0x81c9,0x81bf,0x81be,0x81e7,0x81e8,0xffff,0x8793,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8188,0x81e6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x81e4,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x81e0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8182,0x81df,0xffff,0xffff,0xffff,0xffff,0x8185,0x8186,
0xffff,0xffff,0x81e1,0x81e2,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x81bc,0x81bd,0xffff,0xffff,0x81ba,0x81bb,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x81db,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8799,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x81dc,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8740,0x8741,0x8742,0x8743,0x8744,0x8745,0x8746,0x8747,
0x8748,0x8749,0x874a,0x874b,0x874c,0x874d,0x874e,0x874f,
0x8750,0x8751,0x8752,0x8753,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x849f,0x84aa,0x84a0,0x84ab,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x84a1,0xffff,0xffff,0x84ac,
0x84a2,0xffff,0xffff,0x84ad,0x84a4,0xffff,0xffff,0x84af,
0x84a3,0xffff,0xffff,0x84ae,0x84a5,0x84ba,0xffff,0xffff,
0x84b5,0xffff,0xffff,0x84b0,0x84a7,0x84bc,0xffff,0xffff,
0x84b7,0xffff,0xffff,0x84b2,0x84a6,0xffff,0xffff,0x84b6,
0x84bb,0xffff,0xffff,0x84b1,0x84a8,0xffff,0xffff,0x84b8,
0x84bd,0xffff,0xffff,0x84b3,0x84a9,0xffff,0xffff,0x84b9,
0xffff,0xffff,0x84be,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x84b4,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x81a1,0x81a0,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x81a3,0x81a2,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x81a5,0x81a4,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x819f,0x819e,
0xffff,0xffff,0xffff,0x819b,0xffff,0xffff,0x819d,0x819c,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x81fc,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x819a,0x8199,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x818a,0xffff,0x8189,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x81f4,0xffff,0xffff,0x81f3,0xffff,0x81f2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8140,0x8141,0x8142,0x8156,0xffff,0x8158,0x8159,0x815a,
0x8171,0x8172,0x8173,0x8174,0x8175,0x8176,0x8177,0x8178,
0x8179,0x817a,0x81a7,0x81ac,0x816b,0x816c,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8160,0x8780,0xffff,0x8781,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x829f,0x82a0,0x82a1,0x82a2,0x82a3,0x82a4,0x82a5,
0x82a6,0x82a7,0x82a8,0x82a9,0x82aa,0x82ab,0x82ac,0x82ad,
0x82ae,0x82af,0x82b0,0x82b1,0x82b2,0x82b3,0x82b4,0x82b5,
0x82b6,0x82b7,0x82b8,0x82b9,0x82ba,0x82bb,0x82bc,0x82bd,
0x82be,0x82bf,0x82c0,0x82c1,0x82c2,0x82c3,0x82c4,0x82c5,
0x82c6,0x82c7,0x82c8,0x82c9,0x82ca,0x82cb,0x82cc,0x82cd,
0x82ce,0x82cf,0x82d0,0x82d1,0x82d2,0x82d3,0x82d4,0x82d5,
0x82d6,0x82d7,0x82d8,0x82d9,0x82da,0x82db,0x82dc,0x82dd,
0x82de,0x82df,0x82e0,0x82e1,0x82e2,0x82e3,0x82e4,0x82e5,
0x82e6,0x82e7,0x82e8,0x82e9,0x82ea,0x82eb,0x82ec,0x82ed,
0x82ee,0x82ef,0x82f0,0x82f1,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x814a,0x814b,0x8154,0x8155,0xffff,
0xffff,0x8340,0x8341,0x8342,0x8343,0x8344,0x8345,0x8346,
0x8347,0x8348,0x8349,0x834a,0x834b,0x834c,0x834d,0x834e,
0x834f,0x8350,0x8351,0x8352,0x8353,0x8354,0x8355,0x8356,
0x8357,0x8358,0x8359,0x835a,0x835b,0x835c,0x835d,0x835e,
0x835f,0x8360,0x8361,0x8362,0x8363,0x8364,0x8365,0x8366,
0x8367,0x8368,0x8369,0x836a,0x836b,0x836c,0x836d,0x836e,
0x836f,0x8370,0x8371,0x8372,0x8373,0x8374,0x8375,0x8376,
0x8377,0x8378,0x8379,0x837a,0x837b,0x837c,0x837d,0x837e,
0x8380,0x8381,0x8382,0x8383,0x8384,0x8385,0x8386,0x8387,
0x8388,0x8389,0x838a,0x838b,0x838c,0x838d,0x838e,0x838f,
0x8390,0x8391,0x8392,0x8393,0x8394,0x8395,0x8396,0xffff,
0xffff,0xffff,0xffff,0x8145,0x815b,0x8152,0x8153,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x878a,0x878b,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x878c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8785,0x8786,0x8787,0x8788,
0x8789,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8765,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8769,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8760,0xffff,0xffff,0xffff,
0x8763,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8761,0x876b,0xffff,0xffff,0x876a,0x8764,
0xffff,0xffff,0xffff,0x876c,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8766,0xffff,
0xffff,0xffff,0xffff,0x876e,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x875f,0x876d,0xffff,0xffff,0x8762,0xffff,0xffff,
0xffff,0x8767,0xffff,0xffff,0xffff,0xffff,0xffff,0x8768,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x877e,0x878f,0x878e,0x878d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8772,0x8773,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x876f,0x8770,0x8771,0xffff,
0xffff,0x8775,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8774,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8783,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x88ea,0x929a,0xffff,0x8eb5,0xffff,0xffff,0xffff,0x969c,
0x8fe4,0x8e4f,0x8fe3,0x89ba,0xffff,0x9573,0x975e,0xffff,
0x98a0,0x894e,0xffff,0xffff,0x8a8e,0x98a1,0x90a2,0x99c0,
0x8b75,0x95b8,0xffff,0xffff,0xffff,0xffff,0x8fe5,0xffff,
0xffff,0x97bc,0xffff,0xffff,0xffff,0xffff,0x95c0,0xffff,
0xfa68,0xffff,0x98a2,0xffff,0xffff,0x9286,0xffff,0xffff,
0xffff,0x98a3,0x8bf8,0xffff,0xffff,0xffff,0x98a4,0xffff,
0x8adb,0x924f,0xffff,0x8ee5,0x98a5,0xffff,0xffff,0x98a6,
0xffff,0xffff,0x98a7,0x9454,0xffff,0x8b76,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9456,0xffff,0x93e1,0x8cc1,0x9652,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe568,0x98a8,0x8fe6,
0x98a9,0x89b3,0xffff,0xffff,0xffff,0x8be3,0x8cee,0x96e7,
0xffff,0xffff,0x9ba4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9790,0xffff,0x93fb,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8aa3,0xffff,
0x8b54,0xffff,0x98aa,0xffff,0xffff,0x98ab,0x97b9,0xffff,
0x975c,0x9188,0x98ad,0x8e96,0x93f1,0xffff,0x98b0,0xffff,
0xffff,0x895d,0x8cdd,0xffff,0x8cdc,0x88e4,0xffff,0xffff,
0x986a,0x9869,0xffff,0x8db1,0x889f,0xffff,0x98b1,0x98b2,
0x98b3,0x9653,0x98b4,0xffff,0x8cf0,0x88e5,0x9692,0xffff,
0x8b9c,0xffff,0xffff,0x8b9d,0x8b9e,0x92e0,0x97ba,0xffff,
0x98b5,0xffff,0xffff,0x98b6,0xffff,0xffff,0x98b7,0xffff,
0xffff,0xffff,0x906c,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8f59,0x906d,0x98bc,0xffff,0x98ba,0xffff,0x98bb,0x8b77,
0xffff,0xffff,0x8da1,0x89ee,0xffff,0x98b9,0x98b8,0x95a7,
0xffff,0xffff,0xffff,0xffff,0x8e65,0x8e64,0x91bc,0x98bd,
0x9574,0x90e5,0xffff,0xffff,0xffff,0x8157,0x98be,0x98c0,
0xffff,0xfa69,0xffff,0x91e3,0x97df,0x88c8,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x98bf,0x89bc,0xffff,
0x8bc2,0xffff,0x9287,0xffff,0xffff,0xffff,0x8c8f,0x98c1,
0xffff,0xffff,0xffff,0x9443,0xfa6a,0xffff,0xffff,0xffff,
0xfa6b,0x8ae9,0xffff,0xfa6c,0xffff,0xffff,0xffff,0xffff,
0xffff,0x98c2,0x88c9,0xffff,0xffff,0x8cde,0x8aea,0x959a,
0x94b0,0x8b78,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x89ef,0xffff,0x98e5,0x9360,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x948c,
0x98c4,0xffff,0xffff,0xffff,0x94ba,0xffff,0x97e0,0xffff,
0x904c,0xfa6d,0x8e66,0xffff,0x8e97,0x89be,0xffff,0xffff,
0xffff,0xffff,0xffff,0x92cf,0xffff,0xffff,0x9241,0x98c8,
0xffff,0xffff,0xffff,0xffff,0xffff,0x88ca,0x92e1,0x8f5a,
0x8db2,0x9743,0xffff,0x91cc,0xffff,0x89bd,0xfa6e,0x98c7,
0xffff,0x975d,0x98c3,0x98c5,0x8dec,0x98c6,0x9b43,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x98ce,0xffff,0xffff,0xffff,0xffff,0xffff,0x98d1,
0x98cf,0xffff,0xffff,0x89c0,0xffff,0x95b9,0x98c9,0xffff,
0xffff,0xffff,0xffff,0x98cd,0x8cf1,0xffff,0xffff,0x8e67,
0xffff,0xffff,0xffff,0x8aa4,0xffff,0xffff,0x98d2,0xffff,
0x98ca,0xffff,0xfa70,0x97e1,0xffff,0x8e98,0xffff,0x98cb,
0xffff,0x98d0,0xfa6f,0xffff,0xfa72,0xffff,0x98d3,0xffff,
0x98cc,0xffff,0xfa71,0x8b9f,0xffff,0x88cb,0xffff,0xffff,
0x8ba0,0x89bf,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9b44,0xffff,0x9699,0x958e,0x8cf2,
0xffff,0xffff,0xffff,0xffff,0xffff,0x904e,0x97b5,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x95d6,
0xffff,0xffff,0x8c57,0x91a3,0x89e2,0xffff,0xffff,0xffff,
0xffff,0xfa61,0x8f72,0xffff,0xffff,0xfa73,0x98d7,0xffff,
0x98dc,0x98da,0xffff,0xffff,0x98d5,0xffff,0xffff,0x91ad,
0x98d8,0xffff,0x98db,0x98d9,0xffff,0x95db,0xffff,0x98d6,
0xffff,0x904d,0xffff,0x9693,0x98dd,0x98de,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8f43,0x98eb,
0xffff,0xffff,0xffff,0x946f,0xffff,0x9555,0x98e6,0xffff,
0x95ee,0xffff,0x89b4,0xffff,0xffff,0xffff,0x98ea,0xfa76,
0xffff,0xffff,0xffff,0xffff,0xffff,0x98e4,0x98ed,0xffff,
0xffff,0x9171,0xffff,0x8cc2,0xffff,0x947b,0xffff,0xe0c5,
0xffff,0x98ec,0x937c,0xffff,0x98e1,0xffff,0x8cf4,0xffff,
0xffff,0x8cf3,0x98df,0xffff,0xffff,0xffff,0xfa77,0x8ed8,
0xffff,0x98e7,0xfa75,0x95ed,0x926c,0x98e3,0x8c91,0xffff,
0x98e0,0x98e8,0x98e2,0x97cf,0x98e9,0x9860,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8be4,0xffff,
0xffff,0x8c90,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xfa74,0xffff,0xfa7a,0x98ee,0xffff,0xffff,0xfa78,0x98ef,
0x98f3,0x88cc,0xffff,0xffff,0xffff,0xffff,0xffff,0x95ce,
0x98f2,0xffff,0xffff,0xffff,0xffff,0x98f1,0x98f5,0xffff,
0xffff,0xffff,0x98f4,0xffff,0x92e2,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8c92,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x98f6,0xffff,0xffff,0xffff,
0xfa79,0xffff,0x8ec3,0xffff,0x91a4,0x92e3,0x8bf4,0xffff,
0x98f7,0xffff,0xffff,0xffff,0xffff,0x8b55,0xffff,0xffff,
0x98f8,0xffff,0xffff,0xffff,0xffff,0x98fa,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9654,0xffff,0xffff,
0xffff,0x8c86,0xffff,0xffff,0xfa7b,0xffff,0xffff,0xffff,
0x8e50,0x94f5,0x98f9,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8dc3,0x9762,0xffff,0xffff,
0xffff,0xffff,0x98fc,0x9942,0x98fb,0x8dc2,0xffff,0x8f9d,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8c58,0xffff,
0xffff,0xffff,0x9943,0xffff,0xffff,0x8bcd,0xffff,0xffff,
0xffff,0x9940,0x9941,0xffff,0xffff,0x93ad,0xffff,0x919c,
0xffff,0x8ba1,0xffff,0xffff,0xffff,0x966c,0x9944,0xffff,
0xfa7d,0xffff,0x97bb,0xffff,0xffff,0xffff,0x9945,0xffff,
0xffff,0xffff,0xffff,0x9948,0xffff,0x9946,0xffff,0x916d,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9947,0x9949,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfa7c,0x994b,0xffff,0xffff,
0xffff,0x994a,0xffff,0x95c6,0xffff,0xffff,0xffff,0xffff,
0x8b56,0x994d,0x994e,0xffff,0x89ad,0xffff,0xffff,0xffff,
0xffff,0x994c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8ef2,0xffff,0x9951,0x9950,0x994f,0xffff,
0x98d4,0xffff,0x9952,0xffff,0xffff,0xffff,0xffff,0x8f9e,
0xffff,0x9953,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9744,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x96d7,0xffff,0xffff,0xffff,0xffff,0x9955,
0xffff,0xffff,0x9954,0x9957,0x9956,0xffff,0xffff,0x9958,
0x9959,0x88f2,0xffff,0x8cb3,0x8c5a,0x8f5b,0x929b,0x8ba2,
0x90e6,0x8cf5,0xfa7e,0x8d8e,0x995b,0x96c6,0x9365,0xffff,
0x8e99,0xffff,0x995a,0xffff,0x995c,0xffff,0xffff,0xffff,
0xffff,0xffff,0x937d,0xffff,0x8a95,0xffff,0xffff,0xffff,
0xffff,0xffff,0x995d,0xffff,0xfa80,0x93fc,0xffff,0xffff,
0x9153,0x995f,0x9960,0x94aa,0x8cf6,0x985a,0x9961,0xffff,
0xffff,0x8ba4,0xffff,0xffff,0xffff,0x95ba,0x91b4,0x8bef,
0x9354,0xffff,0xffff,0xffff,0x8c93,0xffff,0xffff,0xffff,
0x9962,0xffff,0x9963,0xffff,0xffff,0x93e0,0x897e,0xffff,
0xffff,0x9966,0x8dfb,0xffff,0x9965,0x8dc4,0xffff,0x9967,
0xe3ec,0x9968,0x9660,0x9969,0xffff,0x996a,0x996b,0x8fe7,
0xffff,0x8eca,0xffff,0xffff,0xffff,0xfa81,0xffff,0xffff,
0x8aa5,0xffff,0x996e,0xffff,0x996c,0x96bb,0x996d,0xffff,
0x9579,0x996f,0x9970,0x9971,0x937e,0xffff,0xffff,0xffff,
0x9975,0x9973,0x9974,0x9972,0x8de1,0x9976,0x96e8,0x97e2,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9977,0xfa82,0xffff,
0xffff,0xffff,0xffff,0xffff,0x90a6,0x9978,0x8f79,0xffff,
0xffff,0x9979,0xffff,0x929c,0x97bd,0x9380,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x99c3,0xffff,
0xffff,0xffff,0xffff,0x997a,0xeaa3,0x8bc3,0xffff,0xffff,
0x997b,0x967d,0xffff,0xffff,0xffff,0xffff,0x8f88,0x91fa,
0xffff,0x997d,0x93e2,0xffff,0xfa83,0x997e,0xffff,0xffff,
0x9980,0x8a4d,0xffff,0xffff,0xffff,0x9981,0x8ba5,0xffff,
0x93ca,0x899a,0x8f6f,0xffff,0xffff,0x949f,0x9982,0xffff,
0x9381,0xffff,0xffff,0x906e,0x9983,0xffff,0x95aa,0x90d8,
0x8aa0,0xffff,0x8aa7,0x9984,0xffff,0xffff,0x9986,0xffff,
0xffff,0x8c59,0xffff,0xffff,0x9985,0xfa84,0xffff,0x97f1,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8f89,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x94bb,0x95ca,0xffff,0x9987,
0xffff,0x9798,0x9988,0xffff,0xffff,0xffff,0x9989,0xffff,
0x939e,0xffff,0xffff,0x998a,0xffff,0xffff,0x90a7,0x8dfc,
0x8c94,0x998b,0x8e68,0x8d8f,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x92e4,0x998d,0xffff,0xffff,0x91a5,
0xffff,0xffff,0x8ded,0x998e,0x998f,0x914f,0xffff,0x998c,
0xffff,0xffff,0xffff,0xffff,0x9991,0xffff,0x9655,0xffff,
0xffff,0xffff,0xffff,0x8d84,0xffff,0xffff,0x9990,0xffff,
0xffff,0xffff,0xffff,0x8c95,0x8ddc,0x948d,0xffff,0xffff,
0xffff,0x9994,0x9992,0xffff,0xffff,0xffff,0xffff,0x959b,
0x8fe8,0x999b,0x8a84,0x9995,0x9993,0x916e,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9997,0xffff,0x9996,
0xffff,0xffff,0xffff,0x8a63,0xffff,0xffff,0xffff,0x8c80,
0x999c,0x97ab,0xffff,0xffff,0xffff,0x9998,0xffff,0xffff,
0xffff,0x999d,0x999a,0xffff,0x9999,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x97cd,0xfa85,0xffff,0xffff,0x8cf7,
0x89c1,0xffff,0xffff,0x97f2,0xffff,0xffff,0xfa86,0xffff,
0xffff,0x8f95,0x9377,0x8d85,0x99a0,0x99a1,0xffff,0xfb77,
0xffff,0x97e3,0xffff,0xffff,0x984a,0x99a3,0xffff,0xffff,
0xffff,0x8cf8,0xffff,0xffff,0x99a2,0xffff,0x8a4e,0xffff,
0xfa87,0x99a4,0xffff,0x9675,0xffff,0x92ba,0xffff,0x9745,
0xffff,0x95d7,0xffff,0xffff,0xffff,0x99a5,0xffff,0xffff,
0xffff,0xffff,0xe8d3,0xffff,0xffff,0x93ae,0xffff,0x99a6,
0x8aa8,0x96b1,0xffff,0xfa88,0xffff,0x8f9f,0x99a7,0x95e5,
0x99ab,0xffff,0x90a8,0x99a8,0x8bce,0xffff,0x99a9,0x8aa9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8c4d,0x99ac,0xffff,0x99ad,0xffff,0xffff,
0x99ae,0x99af,0x8ed9,0xffff,0xffff,0xffff,0x8cf9,0x96dc,
0xfa89,0x96e6,0x93f5,0xffff,0xffff,0x95ef,0x99b0,0xfa8a,
0x99b1,0xffff,0xffff,0xffff,0xffff,0x99b3,0xffff,0x99b5,
0x99b4,0xffff,0xffff,0xffff,0xffff,0x99b6,0x89bb,0x966b,
0xffff,0x8dfa,0x99b7,0xffff,0xffff,0x9178,0xffff,0xffff,
0x8fa0,0x8ba7,0xffff,0x99b8,0xfa8b,0xffff,0xffff,0xffff,
0xffff,0xffff,0x94d9,0xffff,0xffff,0xffff,0xffff,0x99b9,
0xffff,0x99ba,0xffff,0x99bb,0xffff,0xffff,0xffff,0xffff,
0x99bc,0x9543,0x8be6,0x88e3,0xffff,0xffff,0xffff,0x93bd,
0x99bd,0x8f5c,0xffff,0x90e7,0xffff,0x99bf,0x99be,0x8fa1,
0x8cdf,0x99c1,0x94bc,0xffff,0xffff,0x99c2,0xffff,0xffff,
0xffff,0x94da,0x91b2,0x91ec,0x8ba6,0xffff,0xffff,0x93ec,
0x9250,0xffff,0x948e,0xffff,0x966d,0xffff,0x99c4,0xffff,
0x90e8,0xffff,0xffff,0xffff,0xffff,0xffff,0x8c54,0xffff,
0xffff,0x99c5,0xffff,0xffff,0xffff,0xffff,0x99c6,0x894b,
0x88f3,0x8aeb,0xfa8c,0x91a6,0x8b70,0x9791,0xffff,0x99c9,
0x89b5,0xffff,0xffff,0x99c8,0xffff,0xffff,0xffff,0x8ba8,
0xffff,0xffff,0x99ca,0xffff,0x96ef,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xfa8d,0xffff,0xffff,0x99cb,0xffff,
0x97d0,0xffff,0x8cfa,0xffff,0xffff,0xffff,0xffff,0x8cb4,
0x99cc,0xffff,0xffff,0xffff,0xffff,0x99ce,0x99cd,0xffff,
0x907e,0x8958,0xffff,0xffff,0xffff,0x897d,0x99cf,0xffff,
0x99d0,0xffff,0xfa8e,0x8cb5,0xffff,0xffff,0x99d1,0xffff,
0xffff,0xffff,0xffff,0x8b8e,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8e51,0x99d2,0xffff,0xffff,0xffff,0xffff,
0x9694,0x8db3,0x8b79,0x9746,0x916f,0x94bd,0x8efb,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8f66,0xffff,0x8ee6,0x8ef3,
0xffff,0x8f96,0xffff,0x94be,0xffff,0xfa8f,0xffff,0x99d5,
0xffff,0x8962,0x9170,0x8cfb,0x8cc3,0x8be5,0xffff,0xffff,
0x99d9,0x9240,0x91fc,0x8ba9,0x8fa2,0x99da,0x99d8,0x89c2,
0x91e4,0x8eb6,0x8e6a,0x8945,0xffff,0xffff,0x8a90,0x8d86,
0x8e69,0xffff,0x99db,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x99dc,0xffff,0x8b68,0x8a65,0xffff,0xffff,0xffff,
0x8d87,0x8b67,0x92dd,0x8944,0x93af,0x96bc,0x8d40,0x9799,
0x9366,0x8cfc,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8c4e,0xffff,0x99e5,0xffff,0x8be1,
0x9669,0xffff,0xffff,0xffff,0xffff,0xffff,0x94db,0xffff,
0xffff,0x99e4,0xffff,0x8adc,0x99df,0x99e0,0x99e2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x99e3,0xffff,
0x8b7a,0x9081,0xffff,0x95ab,0x99e1,0x99dd,0x8ce1,0xffff,
0x99de,0xffff,0x9843,0xffff,0xffff,0xffff,0x95f0,0xffff,
0x92e6,0x8ce0,0x8d90,0xffff,0xffff,0xffff,0x99e6,0xffff,
0xffff,0x93db,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x99ea,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8efc,0xffff,0x8ef4,0xffff,0xffff,0xffff,0xffff,0xffff,
0x99ed,0x99eb,0xffff,0x96a1,0xffff,0x99e8,0x99f1,0x99ec,
0xffff,0xffff,0xffff,0x99ef,0x8cc4,0x96bd,0xffff,0xffff,
0x99f0,0xffff,0xffff,0xffff,0x99f2,0xffff,0x99f4,0xffff,
0xffff,0xffff,0xfa92,0x8dee,0x9861,0xffff,0x99e9,0x99e7,
0x99f3,0xffff,0x99ee,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfa91,0xffff,0xffff,0xffff,
0xffff,0xffff,0x99f6,0xffff,0x9a42,0x99f8,0xffff,0xffff,
0x99fc,0xfa93,0xffff,0x9a40,0x99f9,0xffff,0xffff,0x9a5d,
0xffff,0xffff,0x8de7,0x8a50,0xffff,0xffff,0xffff,0xffff,
0x99f7,0xffff,0xffff,0xffff,0x9a44,0x88f4,0x9a43,0xffff,
0x88a3,0x9569,0x9a41,0xffff,0x99fa,0xffff,0xffff,0x99f5,
0x99fb,0x8dc6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9a45,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x88f5,0x9a4e,0xffff,0xffff,0x9a46,0x9a47,0xffff,
0x8fa3,0x9689,0xffff,0xffff,0xffff,0x9a4c,0x9a4b,0xffff,
0xffff,0xffff,0x934e,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9a4d,0xffff,0xffff,0x9a4a,0xffff,0xfa94,
0xffff,0xffff,0xffff,0xffff,0x8953,0xffff,0x8db4,0x904f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a48,
0x9382,0xffff,0xffff,0xffff,0x9a49,0xffff,0x88a0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a53,0x9742,
0xffff,0x8fa5,0xffff,0x9a59,0xffff,0xffff,0xffff,0xffff,
0x9a58,0x9a4f,0xffff,0xffff,0xffff,0xffff,0x91c1,0xffff,
0x9a50,0xffff,0xffff,0xffff,0x91ed,0x9a55,0x8fa4,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9a52,0xffff,0xffff,0x96e2,
0xffff,0xffff,0xffff,0x8c5b,0xffff,0xffff,0x9a56,0x9a57,
0xffff,0xffff,0xffff,0xffff,0x9a54,0x9a5a,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9a51,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9a60,0x9a65,0xffff,0x9a61,0xffff,
0x9a5c,0xffff,0xffff,0x9a66,0x9150,0xffff,0xfa95,0x9a68,
0xffff,0x8d41,0x9a5e,0x929d,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9a62,0x9a5b,0x8aab,0xffff,0x8aec,0x8a85,0x9a63,0x9a5f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8c96,
0x9a69,0x9a67,0x9172,0x8b69,0x8baa,0xffff,0x9a64,0xffff,
0x8bf2,0xffff,0xffff,0xffff,0xffff,0xffff,0x8963,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9a6d,0x9a6b,0xffff,0x9aa5,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9a70,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9a6a,0xffff,0x9a6e,0xffff,0xffff,0x9a6c,
0xffff,0xffff,0xffff,0x8e6b,0x9a6f,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a72,
0xffff,0x9a77,0xffff,0xffff,0xffff,0x9a75,0x9a74,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9251,0xffff,
0xffff,0x89c3,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9a71,0xffff,0x9a73,0x8fa6,
0x8952,0xffff,0xffff,0x9a76,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x89dc,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a82,
0xffff,0x8ffa,0x9a7d,0xffff,0x9a7b,0xffff,0x9a7c,0xffff,
0x9a7e,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x895c,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9158,0xffff,0x9a78,0xffff,
0x9a79,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8a9a,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9a81,0xffff,0xffff,0xffff,
0x8aed,0xffff,0x9a84,0x9a80,0x9a83,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x95ac,0xffff,0xffff,0xffff,
0x93d3,0xffff,0x94b6,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9a86,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a85,0x8a64,
0xffff,0xffff,0x9a87,0xffff,0xffff,0xffff,0xffff,0x9a8a,
0xffff,0xffff,0xffff,0xffff,0x9a89,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9a88,0xffff,0x9458,0xffff,0xffff,0x9a8b,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a8c,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9a8e,0xffff,0x9a8d,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9a90,0xffff,0xffff,0xffff,
0x9a93,0x9a91,0x9a8f,0x9a92,0xffff,0xffff,0xffff,0xffff,
0x9a94,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a95,0xffff,
0xffff,0x9a96,0xffff,0x9a97,0xffff,0xffff,0xffff,0x9a98,
0x9964,0xffff,0x8efa,0x8e6c,0xffff,0xffff,0x89f1,0xffff,
0x88f6,0xffff,0xffff,0x9263,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a99,0xffff,
0x8da2,0xffff,0x88cd,0x907d,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9a9a,0x8cc5,0xffff,0xffff,0x8d91,0xffff,0x9a9c,
0x9a9b,0xffff,0xffff,0x95de,0x9a9d,0xffff,0xffff,0xffff,
0x9a9f,0x9a9e,0xffff,0x9aa0,0xffff,0x9aa1,0xffff,0x8c97,
0xffff,0xffff,0x8980,0x9aa2,0xffff,0xffff,0x9aa4,0xffff,
0x9aa3,0xffff,0xffff,0xffff,0x9aa6,0xffff,0xffff,0x9379,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9aa7,0x88b3,
0x8ddd,0xffff,0xffff,0xffff,0xffff,0x8c5c,0xffff,0xffff,
0x926e,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9aa8,
0x9aa9,0xffff,0xffff,0x9aab,0xffff,0xffff,0xffff,0xffff,
0x9aac,0xffff,0x8de2,0xffff,0xffff,0xffff,0xffff,0x8bcf,
0xffff,0xffff,0x9656,0xffff,0xffff,0xffff,0x9aaa,0x9aad,
0x8dbf,0x8d42,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfa96,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9ab1,0xffff,0xffff,0x8da3,0xfa97,0x9252,0xffff,
0xffff,0x9aae,0x92d8,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9ab2,
0xffff,0xffff,0x9082,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9ab0,0x9ab3,0xffff,0x8c5e,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9ab4,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9ab5,0xffff,0x8d43,0x8a5f,0x9ab7,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9ab8,0xffff,0xfa98,0xffff,0xffff,0xffff,
0x9ab9,0xffff,0xffff,0x9ab6,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9aaf,0xffff,0xffff,0x9aba,0xffff,0xffff,0x9abb,0xfa9a,
0xfa99,0xffff,0xffff,0x9684,0xffff,0xffff,0x8fe9,0xffff,
0xffff,0xffff,0x9abd,0x9abe,0x9abc,0xffff,0x9ac0,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9457,0xffff,0xffff,0x88e6,
0x9575,0xffff,0xffff,0x9ac1,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8ffb,0xffff,0xffff,0x8eb7,
0xffff,0x947c,0x8aee,0xffff,0x8de9,0xffff,0xffff,0xffff,
0x9678,0xffff,0x93b0,0xffff,0xffff,0x8c98,0x91cd,0xffff,
0xffff,0xffff,0x9abf,0x9ac2,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x91c2,0xffff,0xffff,
0xffff,0x9ac3,0xffff,0xffff,0xffff,0x9ac4,0xffff,0xffff,
0xffff,0x9ac6,0xffff,0xffff,0x92e7,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8aac,0xffff,0xffff,0xffff,0xffff,0xea9f,
0x8981,0x95f1,0xffff,0xffff,0x8fea,0x9367,0xffff,0xffff,
0xffff,0xffff,0x8de4,0xffff,0xffff,0x9acc,0xffff,0xffff,
0x95bb,0x97db,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x89f2,0x9ac8,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9159,0x9acb,0xffff,0x9383,0xffff,0xffff,0x9368,
0x9384,0x94b7,0x92cb,0xffff,0xffff,0xffff,0x8dc7,0xffff,
0xffff,0xffff,0x9ac7,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8996,0xffff,0x9355,0xffff,0xffff,0xffff,0xffff,
0x9ac9,0xffff,0x9ac5,0xffff,0xffff,0x906f,0xffff,0xffff,
0xffff,0x9acd,0xffff,0xffff,0xffff,0xffff,0x8f6d,0xffff,
0xffff,0xffff,0xffff,0x8bab,0xffff,0x9ace,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x95e6,0xffff,0xffff,0xffff,0x919d,
0xffff,0xffff,0xffff,0xffff,0x92c4,0xffff,0xfa9d,0x9ad0,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x966e,0xffff,0xffff,0x9ad1,0xffff,0xffff,0x9ad6,0xffff,
0xffff,0xffff,0xfa9e,0x95ad,0xffff,0xffff,0xffff,0xffff,
0x9ad5,0x9acf,0x9ad2,0x9ad4,0xffff,0xffff,0x8da4,0xffff,
0xffff,0x95c7,0xffff,0xffff,0xffff,0x9ad7,0xffff,0x9264,
0xffff,0xffff,0x89f3,0xffff,0x8feb,0xffff,0xffff,0xffff,
0xffff,0x9ad9,0xffff,0x9ad8,0xffff,0x8d88,0xffff,0x9ada,
0x9adc,0x9adb,0xffff,0xffff,0x9ade,0xffff,0x9ad3,0x9ae0,
0xffff,0xffff,0xffff,0xffff,0x9adf,0x9add,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8e6d,0x9070,0xffff,0x9173,0x9ae1,
0x90ba,0x88eb,0x9484,0xffff,0xffff,0xffff,0xffff,0x92d9,
0xffff,0x9ae3,0x9ae2,0x9ae4,0x9ae5,0x9ae6,0xffff,0xffff,
0xffff,0xffff,0x9ae7,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x95cf,0x9ae8,0xfa9f,0xffff,0xffff,0xffff,0x89c4,
0x9ae9,0xffff,0xffff,0xffff,0xffff,0x975b,0x8a4f,0xffff,
0x99c7,0x8f67,0x91bd,0x9aea,0x96e9,0xffff,0xffff,0xffff,
0xffff,0xffff,0x96b2,0xffff,0xffff,0x9aec,0xffff,0x91e5,
0xffff,0x9356,0x91be,0x9576,0x9aed,0x9aee,0x899b,0xffff,
0xffff,0x8eb8,0x9aef,0xffff,0xffff,0xffff,0xffff,0x88ce,
0x9af0,0xffff,0xffff,0xffff,0xffff,0xffff,0x9af1,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8982,0xffff,0xffff,0x8aef,
0x93de,0x95f2,0xffff,0xffff,0xffff,0xffff,0x9af5,0x9174,
0x9af4,0x8c5f,0xffff,0xfaa0,0x967a,0x9af3,0xffff,0x9385,
0x9af7,0xffff,0x9af6,0xfaa1,0xffff,0xfaa2,0xffff,0xffff,
0x9af9,0xffff,0x9af8,0xfaa3,0xffff,0x899c,0xffff,0x9afa,
0x8fa7,0x9afc,0x9244,0xffff,0x9afb,0xffff,0x95b1,0xffff,
0xffff,0xffff,0xffff,0x8f97,0x937a,0xffff,0xffff,0xffff,
0x9b40,0xffff,0xffff,0xffff,0xffff,0x8d44,0xffff,0xffff,
0xffff,0x9b41,0x9440,0x94dc,0x96cf,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9444,0xffff,0xffff,0x9b4a,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8b57,0xffff,0xffff,0x9764,0xffff,
0xffff,0x96ad,0xffff,0x9baa,0xffff,0x9b42,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9b45,0xfaa4,0x91c3,0xffff,0xffff,
0x9657,0xffff,0xffff,0xffff,0x9369,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9b46,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9685,0xfaa5,0x8dc8,0xffff,0xffff,0x8fa8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9b47,0xffff,
0xffff,0x8e6f,0xffff,0x8e6e,0xffff,0xffff,0xffff,0xffff,
0x88b7,0x8cc6,0xffff,0x90a9,0x88cf,0xffff,0xffff,0xffff,
0xffff,0x9b4b,0x9b4c,0xffff,0x9b49,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8957,0x8aad,0xffff,
0x9b48,0xffff,0x96c3,0x9550,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x88a6,0xffff,
0xffff,0xffff,0xffff,0x88f7,0xffff,0xffff,0xffff,0x8e70,
0xffff,0x88d0,0xffff,0x88a1,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9b51,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9b4f,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x96ba,0xffff,0x9b52,0xffff,0x9b50,0xffff,0xffff,0x9b4e,
0x9050,0xffff,0xffff,0xffff,0xffff,0x9b4d,0xffff,0xffff,
0xffff,0x95d8,0xffff,0xffff,0xffff,0xffff,0xffff,0x8ce2,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9b56,0x9b57,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8fa9,0xffff,0xffff,0xffff,
0x9b53,0x984b,0xffff,0xffff,0xffff,0xffff,0x946b,0xffff,
0xffff,0x9b55,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8da5,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9b58,0xffff,0xffff,0xffff,0x9577,0xffff,
0xffff,0xffff,0x9b59,0xffff,0x9b54,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x96b9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x947d,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9b5a,0x9551,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9b5b,0x9b5f,0x9b5c,0xffff,
0xffff,0x89c5,0x9b5e,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8eb9,0xffff,0x9b5d,0x8c99,0xffff,0xffff,0xffff,
0x9b6b,0xffff,0xffff,0xffff,0xffff,0xffff,0x9b64,0x9b61,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9284,0xffff,0x9b60,0xffff,0xffff,0x9b62,0xffff,
0xffff,0x9b63,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9b65,0x9b66,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8af0,0xffff,0x9b68,0x9b67,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9b69,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8fec,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9b6c,0xffff,0x92da,0xffff,0xffff,0xffff,
0x8964,0xffff,0x9b6a,0xffff,0xffff,0xffff,0x9b6d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9b6e,0xffff,
0x9b71,0xffff,0xffff,0x9b6f,0xffff,0x9b70,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8e71,0x9b72,0xffff,0xffff,0x8d45,0x9b73,0xfaa6,0x8e9a,
0x91b6,0xffff,0x9b74,0x9b75,0x8e79,0x8d46,0xffff,0x96d0,
0xffff,0xffff,0xffff,0x8b47,0x8cc7,0x9b76,0x8a77,0xffff,
0xffff,0x9b77,0xffff,0x91b7,0xffff,0xffff,0xffff,0xffff,
0x9b78,0x9ba1,0xffff,0x9b79,0xffff,0x9b7a,0xffff,0xffff,
0x9b7b,0xffff,0x9b7d,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9b7e,0xffff,0xffff,0x9b80,0xffff,0x91ee,0xffff,0x8946,
0x8ee7,0x88c0,0xffff,0x9176,0x8aae,0x8eb3,0xffff,0x8d47,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9386,0xffff,0x8f40,
0x8aaf,0x9288,0x92e8,0x88b6,0x8b58,0x95f3,0xffff,0x8ec0,
0xffff,0xffff,0x8b71,0x90e9,0x8eba,0x9747,0x9b81,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8b7b,0xffff,
0x8dc9,0xffff,0xffff,0x8a51,0x8983,0x8faa,0x89c6,0xffff,
0x9b82,0x9765,0xffff,0xffff,0xffff,0xffff,0xffff,0x8f68,
0xfaa7,0xffff,0x8ee2,0x9b83,0x8af1,0x93d0,0x96a7,0x9b84,
0xffff,0x9b85,0xffff,0xffff,0x9578,0xffff,0xffff,0xffff,
0x9b87,0xffff,0x8aa6,0x8bf5,0x9b86,0xffff,0xffff,0xffff,
0xfaa9,0xffff,0xffff,0x8ab0,0xffff,0x9051,0x9b8b,0x8e40,
0xffff,0x89c7,0x9b8a,0xffff,0x9b88,0x9b8c,0x9b89,0x944a,
0x9ecb,0x9052,0xffff,0x9b8d,0xfaaa,0xffff,0x97be,0xffff,
0x9b8e,0xffff,0xffff,0x9b90,0xffff,0x929e,0x9b8f,0xffff,
0x90a1,0xffff,0x8e9b,0xffff,0xffff,0xffff,0x91ce,0x8ef5,
0xffff,0x9595,0x90ea,0xffff,0x8ecb,0x9b91,0x8fab,0x9b92,
0x9b93,0x88d1,0x91b8,0x9071,0xffff,0x9b94,0x93b1,0x8fac,
0xffff,0x8fad,0xffff,0x9b95,0xffff,0xffff,0x90eb,0xffff,
0xffff,0xffff,0x8fae,0xffff,0xffff,0xffff,0xfaab,0xffff,
0x9b96,0xffff,0x9b97,0xffff,0x96de,0xffff,0xffff,0xffff,
0x9b98,0xffff,0xffff,0xffff,0xffff,0x8bc4,0xffff,0xffff,
0xffff,0x8f41,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9b99,0x9b9a,0x8eda,0x904b,0x93f2,0x9073,0x94f6,0x9441,
0x8bc7,0x9b9b,0xffff,0xffff,0xffff,0x8b8f,0x9b9c,0xffff,
0x8bfc,0xffff,0x93cd,0x89ae,0xffff,0x8e72,0x9b9d,0x9ba0,
0x9b9f,0x8bfb,0xffff,0x9b9e,0xffff,0x9357,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x91ae,0xffff,
0x936a,0x8ec6,0xffff,0xffff,0x9177,0x979a,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9ba2,0xffff,0x9ba3,0x93d4,
0xffff,0x8e52,0xffff,0xffff,0xffff,0xffff,0x9ba5,0xffff,
0xffff,0x9ba6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9ba7,0xffff,0xffff,0xffff,
0x8af2,0x9ba8,0xffff,0xffff,0x9ba9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x89aa,0xffff,0xffff,0xffff,0xffff,0xfaac,0xffff,
0x915a,0x8ae2,0xffff,0x9bab,0x96a6,0xffff,0xffff,0xffff,
0xffff,0x91d0,0xffff,0x8a78,0xffff,0xffff,0x9bad,0x9baf,
0x8add,0xffff,0xfaad,0x9bac,0x9bae,0xffff,0x9bb1,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9bb0,0xffff,0x9bb2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9bb3,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x93bb,0x8bac,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x89e3,0x9bb4,0x9bb9,0xffff,0xffff,0x9bb7,0xffff,0x95f5,
0x95f4,0xffff,0xffff,0xffff,0xffff,0xfaae,0x9387,0xffff,
0xffff,0xffff,0x9bb6,0x8f73,0xffff,0x9bb5,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9092,
0xffff,0xffff,0xffff,0x9bba,0xffff,0xffff,0x8de8,0xffff,
0xffff,0x9bc0,0xffff,0xffff,0x9bc1,0x9bbb,0x8a52,0x9bbc,
0x9bc5,0x9bc4,0x9bc3,0x9bbf,0xffff,0xffff,0xffff,0x9bbe,
0xffff,0xffff,0x9bc2,0xffff,0xffff,0xffff,0xffff,0xfaaf,
0xffff,0x95f6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xfab2,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9bc9,0x9bc6,0xffff,0x9bc8,0xffff,
0x9792,0xffff,0x9bc7,0xfab0,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9bbd,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9093,0xffff,0xffff,0x9bca,0xfab3,0xffff,0x8db5,
0xffff,0xffff,0xffff,0x9bcb,0xffff,0xffff,0x9bcc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9bcf,0xffff,0x9bce,0xffff,0xffff,0x9bcd,
0xffff,0xffff,0xffff,0x9388,0x9bb8,0xffff,0xffff,0xffff,
0x9bd5,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9bd1,0xffff,0xffff,
0xffff,0xffff,0x9bd0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9bd2,0xffff,0x9bd3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9bd6,
0xfab4,0xfab5,0x97e4,0xffff,0x9bd7,0x9bd4,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9bd8,0xffff,0xffff,0x8ade,0x9bd9,0xffff,0xffff,
0xfab6,0xffff,0x9bdb,0x9bda,0xffff,0xffff,0x9bdc,0xffff,
0xffff,0xffff,0xffff,0x9bdd,0xffff,0x90ec,0x8f42,0xffff,
0xffff,0x8f84,0xffff,0x9183,0xffff,0x8d48,0x8db6,0x8d49,
0x8b90,0xffff,0xffff,0x9bde,0xffff,0xffff,0x8db7,0xffff,
0xffff,0x8cc8,0x9bdf,0x96a4,0x9462,0x9be0,0xffff,0x8d4a,
0xffff,0xffff,0xffff,0x8aaa,0xffff,0x9246,0x8bd0,0xffff,
0xffff,0xffff,0x8e73,0x957a,0xffff,0xffff,0x94bf,0xffff,
0xffff,0xffff,0xffff,0x9be1,0x8af3,0xffff,0xffff,0xffff,
0xffff,0x9be4,0xffff,0xffff,0xffff,0xffff,0x929f,0xffff,
0xffff,0x9be3,0x9be2,0x9be5,0xffff,0x92e9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9083,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8e74,0xffff,0x90c8,0xffff,0x91d1,
0x8b41,0xffff,0xffff,0x92a0,0xffff,0xffff,0x9be6,0x9be7,
0x8fed,0xffff,0xffff,0xffff,0xffff,0x9658,0xffff,0xffff,
0x9bea,0xffff,0xffff,0x9be9,0x9be8,0x959d,0xffff,0x9bf1,
0xffff,0xffff,0xffff,0xffff,0x9679,0xffff,0x9beb,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9bed,0x968b,0xffff,0x9bec,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9bee,
0xffff,0x94a6,0x9bef,0x95bc,0x9bf0,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8ab1,0x95bd,0x944e,0x9bf2,0x9bf3,0xffff,
0x8d4b,0x8ab2,0x9bf4,0x8cb6,0x9763,0x9748,0x8af4,0x9bf6,
0xffff,0x92a1,0xffff,0x8d4c,0x8faf,0xffff,0xffff,0x94dd,
0xffff,0xffff,0x8fb0,0xffff,0xffff,0xffff,0xffff,0x8f98,
0xffff,0xffff,0xffff,0xffff,0xffff,0x92ea,0x95f7,0x9358,
0xffff,0xffff,0x8d4d,0xffff,0x957b,0xffff,0xffff,0xffff,
0x9bf7,0xffff,0xffff,0xffff,0xffff,0xffff,0x9378,0x8dc0,
0xffff,0xffff,0xffff,0x8cc9,0xffff,0x92eb,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x88c1,0x8f8e,0x8d4e,
0x9766,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9bf8,0x9bf9,0x9470,0xffff,0xffff,0xffff,0xffff,
0x9bfa,0x97f5,0x984c,0xffff,0xffff,0xffff,0xffff,0x9bfc,
0x9bfb,0xffff,0xffff,0x8a66,0xffff,0xffff,0x9c40,0xffff,
0xffff,0xffff,0x9c43,0x9c44,0xffff,0x9c42,0xffff,0x955f,
0x8fb1,0x9c46,0x9c45,0x9c41,0xffff,0xffff,0xffff,0xffff,
0x9c47,0x9c48,0xffff,0xffff,0x9c49,0xffff,0xffff,0xffff,
0x9c4c,0x9c4a,0xffff,0x9c4b,0x9c4d,0xffff,0x8984,0x92ec,
0x9c4e,0xffff,0x8c9a,0x89f4,0x9455,0xffff,0x9c4f,0x93f9,
0xffff,0x95d9,0xffff,0x9c50,0x984d,0xffff,0xffff,0xffff,
0xffff,0x9c51,0x95be,0x9c54,0x989f,0x98af,0xffff,0x8eae,
0x93f3,0x9c55,0xffff,0x8b7c,0x92a2,0x88f8,0x9c56,0x95a4,
0x8d4f,0xffff,0xffff,0x926f,0xffff,0xffff,0xffff,0x92ed,
0xffff,0xfab7,0xffff,0xffff,0xffff,0x96ed,0x8cb7,0x8cca,
0xffff,0x9c57,0xffff,0xffff,0xffff,0x9c58,0xffff,0x9c5e,
0xffff,0x8ee3,0xffff,0xffff,0xfab8,0x92a3,0xffff,0x8bad,
0x9c59,0xffff,0xffff,0xffff,0x954a,0xffff,0x9265,0xffff,
0xffff,0x9c5a,0xffff,0xffff,0xffff,0xfa67,0xffff,0xffff,
0x9c5b,0xffff,0x8bae,0xffff,0x9c5c,0xffff,0x9c5d,0xffff,
0xffff,0x9c5f,0xffff,0x9396,0xffff,0xffff,0x9c60,0x9c61,
0xffff,0x9c62,0xffff,0xffff,0x9c53,0x9c52,0xffff,0xffff,
0xffff,0x9c63,0x8c60,0xffff,0xffff,0xffff,0x9546,0xfab9,
0xffff,0x8dca,0x9556,0x92a4,0x956a,0x9c64,0xffff,0xffff,
0x8fb2,0x8965,0xffff,0x9c65,0xffff,0xffff,0xffff,0x9c66,
0xffff,0x96f0,0xffff,0xffff,0x94de,0xffff,0xffff,0x9c69,
0x899d,0x90aa,0x9c68,0x9c67,0x8c61,0x91d2,0xffff,0x9c6d,
0x9c6b,0xffff,0x9c6a,0x97a5,0x8ce3,0xffff,0xffff,0xffff,
0x8f99,0x9c6c,0x936b,0x8f5d,0xffff,0xffff,0xffff,0x93be,
0x9c70,0x9c6f,0xffff,0xffff,0xffff,0xffff,0x9c6e,0xffff,
0x9c71,0x8ce4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9c72,0x959c,0x8f7a,0xffff,0xffff,0x9c73,0x94f7,0xffff,
0xffff,0xffff,0xffff,0x93bf,0x92a5,0xffff,0xffff,0xfaba,
0xffff,0x934f,0xffff,0xffff,0x9c74,0x8b4a,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9053,0xffff,0x954b,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8af5,0x9445,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9c75,0x8e75,
0x9659,0x965a,0xffff,0xffff,0x899e,0x9c7a,0xfabb,0xffff,
0x9289,0xffff,0xffff,0xffff,0x9c77,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x89f5,0xffff,0xffff,0xffff,0xffff,
0x9cab,0x9c79,0xffff,0xffff,0xffff,0x944f,0xffff,0xffff,
0x9c78,0xffff,0xffff,0x9c76,0xffff,0x8d9a,0xffff,0x9c7c,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9c83,0x9c89,
0x9c81,0xffff,0x937b,0xffff,0xffff,0x9c86,0x957c,0xffff,
0xffff,0x9c80,0xffff,0x9c85,0x97e5,0x8e76,0xffff,0xffff,
0x91d3,0x9c7d,0xffff,0xffff,0xffff,0x8b7d,0x9c88,0x90ab,
0x8985,0x9c82,0x89f6,0x9c87,0xffff,0xffff,0xffff,0x8baf,
0xffff,0x9c84,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9c8a,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9c8c,0x9c96,0x9c94,0xffff,0xffff,0x9c91,0xffff,
0xffff,0xffff,0x9c90,0x97f6,0xffff,0x9c92,0xffff,0xffff,
0x8bb0,0xffff,0x8d50,0xffff,0xffff,0x8f9a,0xffff,0xffff,
0xffff,0x9c99,0x9c8b,0xffff,0xffff,0xfabc,0xffff,0x9c8f,
0x9c7e,0xffff,0x89f8,0x9c93,0x9c95,0x9270,0xffff,0xffff,
0x8da6,0x89b6,0x9c8d,0x9c98,0x9c97,0x8bb1,0xffff,0x91a7,
0x8a86,0xffff,0xffff,0xffff,0xffff,0x8c62,0xffff,0x9c8e,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9c9a,0xffff,0x9c9d,0x9c9f,0xfabd,0xffff,0xffff,
0xffff,0x8ebb,0xfabe,0x9ca5,0x92ee,0x9c9b,0xffff,0xffff,
0xffff,0xffff,0x9ca3,0xffff,0x89f7,0xffff,0x9ca1,0x9ca2,
0xffff,0xffff,0x9c9e,0x9ca0,0xffff,0xffff,0xffff,0x8ce5,
0x9749,0xffff,0xffff,0x8ab3,0xffff,0xffff,0x8978,0x9ca4,
0xffff,0x9459,0x88ab,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x94df,0x9c7b,0x9caa,0x9cae,0x96e3,0xffff,
0x9ca7,0xffff,0xffff,0xffff,0x9389,0x9cac,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8fee,0x9cad,0x93d5,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9866,0xffff,0x9ca9,0xffff,0xfac0,0xffff,0xffff,
0x9caf,0xffff,0x8d9b,0xffff,0x90c9,0xffff,0xfabf,0x88d2,
0x9ca8,0x9ca6,0xffff,0x9179,0xffff,0xffff,0xffff,0x9c9c,
0x8e53,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x91c4,0x9cbb,0xfac2,0x917a,0x9cb6,0xffff,0x9cb3,0x9cb4,
0xffff,0x8ee4,0x9cb7,0x9cba,0xffff,0xffff,0xffff,0xffff,
0x9cb5,0x8f44,0xffff,0x9cb8,0xffff,0xffff,0x9cb2,0xffff,
0x96fa,0x96f9,0xffff,0xffff,0xffff,0x9cbc,0x9cbd,0x88d3,
0xffff,0xfac3,0xffff,0xffff,0xffff,0x9cb1,0xffff,0xffff,
0xffff,0xffff,0x8bf0,0x88a4,0xffff,0xffff,0xffff,0x8ab4,
0xfac1,0x9cb9,0xffff,0xffff,0xffff,0xffff,0xffff,0x9cc1,
0x9cc0,0xffff,0xffff,0xffff,0x9cc5,0xffff,0xffff,0xffff,
0xfac5,0xffff,0xffff,0xffff,0x9cc6,0xffff,0xffff,0xfac4,
0xffff,0xffff,0xffff,0xffff,0x9cc4,0x9cc7,0x9cbf,0x9cc3,
0xffff,0xffff,0x9cc8,0xffff,0x9cc9,0xffff,0xffff,0x9cbe,
0x8e9c,0xffff,0x9cc2,0x91d4,0x8d51,0x9cb0,0x9054,0xffff,
0xffff,0xffff,0xffff,0x9cd6,0xffff,0x95e7,0xffff,0xffff,
0x9ccc,0x9ccd,0x9cce,0xffff,0xffff,0x9cd5,0xffff,0x9cd4,
0xffff,0xffff,0x969d,0x8ab5,0xffff,0x9cd2,0xffff,0x8c64,
0x8a53,0xffff,0xffff,0x9ccf,0xffff,0xffff,0x97b6,0x9cd1,
0x88d4,0x9cd3,0xffff,0x9cca,0x9cd0,0x9cd7,0x8c63,0x9ccb,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x977c,0xffff,
0xffff,0xffff,0x974a,0xffff,0xffff,0xffff,0xffff,0x9cda,
0xffff,0xffff,0x9cde,0xffff,0xffff,0xffff,0x919e,0xffff,
0x97f7,0x9cdf,0xffff,0xffff,0x9cdc,0xffff,0x9cd9,0xffff,
0xfac6,0x9cd8,0x9cdd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x95ae,0xffff,0xffff,0x93b2,
0xffff,0x8c65,0xffff,0x9ce0,0x9cdb,0xffff,0x9ce1,0xffff,
0xffff,0xffff,0x8c9b,0xffff,0xffff,0xffff,0x89af,0xffff,
0xffff,0xffff,0x9ce9,0xffff,0xffff,0xffff,0x8ab6,0xffff,
0xffff,0xffff,0xffff,0x9ce7,0xffff,0xffff,0x9ce8,0x8da7,
0x9ce6,0x9ce4,0x9ce3,0x9cea,0x9ce2,0x9cec,0xffff,0xffff,
0x89f9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9cee,0xffff,0xffff,0x9ced,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x92a6,0xffff,0x9cf1,0xffff,0x9cef,0x9ce5,
0x8c9c,0xffff,0x9cf0,0xffff,0x9cf4,0x9cf3,0x9cf5,0x9cf2,
0x9cf6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9cf7,0x9cf8,0x95e8,0xffff,0x9cfa,0x9cf9,0x8f5e,0xffff,
0x90ac,0x89e4,0x89fa,0xfac7,0x9cfb,0xffff,0x88bd,0xffff,
0xffff,0xffff,0x90ca,0x9cfc,0xffff,0xe6c1,0x9d40,0x8c81,
0xffff,0x9d41,0xffff,0xffff,0xffff,0xffff,0x90ed,0xffff,
0xffff,0xffff,0x9d42,0xffff,0xffff,0xffff,0x9d43,0x8b59,
0x9d44,0xffff,0x9d45,0x9d46,0x91d5,0xffff,0xffff,0xffff,
0x8ccb,0xffff,0xffff,0x96df,0xffff,0xffff,0xffff,0x965b,
0x8f8a,0x9d47,0xffff,0xffff,0xffff,0xffff,0xffff,0x90ee,
0xe7bb,0x94e0,0xffff,0x8ee8,0xffff,0x8dcb,0x9d48,0xffff,
0xffff,0xffff,0xffff,0x91c5,0xffff,0x95a5,0xffff,0xffff,
0x91ef,0xffff,0xffff,0x9d4b,0xffff,0xffff,0x9d49,0xffff,
0x9d4c,0xffff,0xffff,0x9d4a,0xffff,0xffff,0xffff,0xffff,
0x9d4d,0xffff,0xffff,0xffff,0xffff,0xffff,0x95af,0xffff,
0xffff,0x88b5,0xffff,0xffff,0xffff,0xffff,0x957d,0xffff,
0xffff,0x94e1,0xffff,0xffff,0x9d4e,0xffff,0x9d51,0x8fb3,
0x8b5a,0xffff,0x9d4f,0x9d56,0x8fb4,0xffff,0xffff,0xffff,
0xffff,0x9d50,0x9463,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x977d,0x9d52,0x9d53,0x9d57,0x938a,0x9d54,0x8d52,
0x90dc,0xffff,0xffff,0x9d65,0x94b2,0xffff,0x91f0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfac8,0xffff,
0xffff,0xffff,0xffff,0x94e2,0x9dab,0xffff,0xffff,0xffff,
0xffff,0x95f8,0xffff,0xffff,0xffff,0x92ef,0xffff,0xffff,
0xffff,0x9695,0xffff,0x9d5a,0x899f,0x928a,0xffff,0xffff,
0xffff,0xffff,0x9d63,0xffff,0xffff,0x9253,0x9d5d,0x9d64,
0x9d5f,0x9d66,0x9d62,0xffff,0x9d61,0x948f,0xffff,0x9d5b,
0x89fb,0x9d59,0x8b91,0x91f1,0x9d55,0xffff,0xffff,0x9d58,
0x8d53,0x90d9,0xffff,0x8fb5,0x9d60,0x9471,0xffff,0xffff,
0x8b92,0x8a67,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8a87,0x9040,0x9d68,0x9d6d,
0xffff,0x9d69,0xffff,0x8c9d,0xffff,0x9d6e,0x8e41,0x8d89,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8f45,0x9d5c,
0xffff,0x8e9d,0x9d6b,0xffff,0xffff,0xffff,0xffff,0x8e77,
0x9d6c,0x88c2,0xffff,0xffff,0x9d67,0xffff,0xffff,0xffff,
0xffff,0x92a7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8b93,0xffff,0xffff,0xffff,0xffff,0xffff,0x8bb2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9d6a,
0x88a5,0xffff,0xffff,0x8dc1,0xffff,0xffff,0xffff,0x9055,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x92f0,0xffff,0xffff,0x94d2,0x9d70,0x917d,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x91a8,0xffff,0xffff,0x8e4a,0x9d71,0xffff,0x9d73,
0x9d6f,0xffff,0xffff,0xffff,0xffff,0x95df,0xffff,0x92bb,
0xffff,0xffff,0xffff,0xffff,0x917b,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x95f9,
0x8ecc,0x9d80,0xffff,0x9d7e,0xffff,0xffff,0x9098,0xffff,
0xffff,0xffff,0x8c9e,0xffff,0xffff,0xffff,0x9d78,0x8fb7,
0xffff,0xffff,0x93e6,0x9450,0xffff,0xffff,0xffff,0xffff,
0x9d76,0xffff,0xffff,0x917c,0xffff,0xffff,0xffff,0xffff,
0x8ef6,0x9d7b,0xffff,0xffff,0x8fb6,0xffff,0x9d75,0x9d7a,
0xffff,0xffff,0x9472,0xffff,0xffff,0xffff,0x9d74,0xffff,
0x8c40,0xffff,0xffff,0x8a7c,0xffff,0xffff,0xffff,0x9d7c,
0x97a9,0x8dcc,0x9254,0x9d79,0xffff,0x90da,0xffff,0x8d54,
0x9084,0x8986,0x915b,0x9d77,0x8b64,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8c66,0xffff,0x92cd,0x9d7d,0xffff,0xffff,
0xffff,0xffff,0xffff,0x917e,0xffff,0xffff,0x9d81,0xffff,
0x9d83,0xffff,0xffff,0x91b5,0x9d89,0xffff,0x9d84,0xffff,
0xffff,0x9d86,0xffff,0xffff,0xffff,0xffff,0xffff,0x9560,
0x92f1,0xffff,0x9d87,0xffff,0xffff,0xffff,0x974b,0xffff,
0xffff,0xffff,0x9767,0x8ab7,0xffff,0xffff,0xffff,0xffff,
0xffff,0x88ac,0xffff,0x9d85,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9d82,0xffff,0xffff,0xffff,0xffff,0x8af6,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8987,0xfac9,0x9d88,0xffff,
0xffff,0xffff,0x9768,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9d8c,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x91b9,0xffff,0x9d93,
0xffff,0xffff,0xffff,0x9d8d,0xffff,0xffff,0x9d8a,0x9d91,
0xffff,0xffff,0xffff,0xffff,0x9d72,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9d8e,0xffff,
0x9d92,0xffff,0xffff,0xffff,0x94c0,0x938b,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9d8b,0xffff,0x9d8f,0xffff,
0xffff,0xffff,0x8c67,0xffff,0xffff,0xffff,0x8def,0xffff,
0xffff,0xffff,0x90db,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9d97,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9345,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xfaca,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9d94,
0xffff,0x9680,0xffff,0xffff,0xffff,0xffff,0xffff,0x9d95,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9d96,0xffff,
0x96cc,0xffff,0x90a0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8c82,0xffff,0xffff,0xffff,0xffff,
0x9d9d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8e54,0x9d9a,0xffff,0x9d99,0xffff,0xffff,
0xffff,0xffff,0x9451,0xffff,0xffff,0xfacb,0x93b3,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9350,0x9d9b,0xffff,0xffff,
0xffff,0x9d9c,0xffff,0x958f,0xffff,0x9464,0x8e42,0xffff,
0x90ef,0xffff,0x966f,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8a68,0xffff,0x9da3,0x9d9e,0xffff,0xffff,0xffff,
0xffff,0x9769,0x9da5,0xffff,0xffff,0x9da1,0xffff,0x9da2,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9180,0xfacc,0xffff,
0xffff,0xffff,0x9da0,0xffff,0x9d5e,0xffff,0xffff,0xffff,
0x9da4,0xffff,0x9d9f,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9da9,0x9daa,0x9346,0x9dac,0xffff,0xffff,0x8e43,0x9da7,
0xffff,0xffff,0xffff,0xffff,0x8b5b,0xffff,0xffff,0x9dad,
0xffff,0x9da6,0x9db1,0xffff,0x9db0,0xffff,0x9daf,0xffff,
0xffff,0xffff,0x9db2,0xffff,0xffff,0x9db4,0x8fef,0xffff,
0x9db3,0xffff,0xffff,0xffff,0xffff,0x9db7,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9db5,0xffff,0xffff,0xffff,0x9db6,0x9d90,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9db9,0x9db8,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9d98,0x9dba,0x9dae,0xffff,0xffff,0x8e78,
0xffff,0xffff,0xffff,0xffff,0x9dbb,0x9dbc,0x9dbe,0x9dbd,
0x9dbf,0x89fc,0xffff,0x8d55,0xffff,0xffff,0x95fa,0x90ad,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8ccc,0xffff,0xffff,
0x9dc1,0xffff,0xffff,0xffff,0xffff,0x9dc4,0xfacd,0x9571,
0xffff,0x8b7e,0xffff,0xffff,0xffff,0x9dc3,0x9dc2,0x9473,
0x9dc5,0x8bb3,0xffff,0xffff,0xffff,0x9dc7,0x9dc6,0xffff,
0xffff,0xffff,0x8ab8,0x8e55,0xffff,0xffff,0x93d6,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8c68,0xffff,0xffff,0xffff,
0x9094,0xffff,0x9dc8,0xffff,0x90ae,0x9347,0xffff,0x957e,
0x9dc9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9dca,0x9dcb,0xffff,0xffff,0xffff,0x95b6,
0x9b7c,0x90c4,0xffff,0xffff,0x956b,0xffff,0x8dd6,0xffff,
0x94e3,0x94c1,0xffff,0xffff,0xffff,0xffff,0xffff,0x936c,
0xffff,0x97bf,0xffff,0x9dcd,0x8ece,0xffff,0xffff,0x9dce,
0xffff,0x88b4,0xffff,0xffff,0x8bd2,0x90cb,0xffff,0x9580,
0xffff,0xffff,0xffff,0x9dcf,0x8e61,0x9266,0xffff,0x8e7a,
0x9056,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9dd0,
0xffff,0x95fb,0xffff,0xffff,0x8997,0x8e7b,0xffff,0xffff,
0xffff,0x9dd3,0xffff,0x9dd1,0x9dd4,0x97b7,0x9dd2,0xffff,
0xffff,0xffff,0xffff,0x90f9,0x9dd5,0xffff,0xffff,0x91b0,
0xffff,0xffff,0x9dd6,0xffff,0xffff,0xffff,0xffff,0x8af8,
0xffff,0x9dd8,0xffff,0x9dd7,0xffff,0xffff,0xffff,0xffff,
0x9dd9,0x9dda,0x8af9,0xffff,0xffff,0x93fa,0x9255,0x8b8c,
0x8e7c,0x9181,0xffff,0xffff,0x8f7b,0x88ae,0xffff,0xffff,
0xffff,0x9ddb,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x89a0,0x9ddf,0xffff,0xffff,0xffff,0xffff,
0xface,0xffff,0x8d56,0x9dde,0xffff,0xffff,0x8da9,0x8fb8,
0xffff,0xfad1,0x9ddd,0xffff,0x8fb9,0xffff,0x96be,0x8da8,
0xffff,0xffff,0xffff,0x88d5,0x90cc,0xfacf,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9de4,0xffff,0xfad3,0x90af,
0x8966,0xffff,0xffff,0xffff,0xfad4,0x8f74,0xffff,0x9686,
0x8df0,0xffff,0xffff,0xffff,0xffff,0x8fba,0xfad2,0x90a5,
0xffff,0xfa63,0xffff,0xffff,0x9de3,0x9de1,0x9de2,0xffff,
0xffff,0xffff,0xffff,0xfad0,0x928b,0xffff,0xffff,0x9e45,
0xffff,0x9de8,0x8e9e,0x8d57,0x9de6,0xffff,0xffff,0xffff,
0xffff,0x9de7,0xffff,0x9057,0xffff,0xffff,0xffff,0x9de5,
0xffff,0xffff,0x8e4e,0xffff,0xffff,0xffff,0xffff,0xfad6,
0xffff,0xfad7,0xffff,0xffff,0xffff,0x9dea,0x9de9,0x9dee,
0xffff,0xffff,0x9def,0xffff,0x9deb,0xfad5,0x8a41,0x9dec,
0x9ded,0x94d3,0xffff,0xffff,0xffff,0xffff,0x9581,0x8c69,
0x9df0,0xffff,0xffff,0xfad9,0x90b0,0xffff,0x8fbb,0xffff,
0xffff,0xffff,0x9271,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8bc5,0xffff,0x9df1,0x9df5,0xffff,0xffff,0x89c9,
0x9df2,0x9df4,0xffff,0xffff,0xffff,0xffff,0x9df3,0xffff,
0xffff,0x8f8b,0xffff,0xffff,0xffff,0xffff,0x9267,0x88c3,
0x9df6,0xfada,0xffff,0xffff,0xffff,0x9df7,0xffff,0xffff,
0xfadb,0xffff,0x92a8,0xffff,0xffff,0xffff,0x97ef,0xffff,
0xffff,0xffff,0xffff,0x8e62,0xffff,0xffff,0x95e9,0xffff,
0xffff,0xffff,0xfadc,0xffff,0x965c,0xffff,0xffff,0xffff,
0x9e41,0x9df9,0xffff,0xffff,0x9dfc,0xffff,0x9dfb,0xfadd,
0xffff,0x9df8,0xffff,0xffff,0x9e40,0xffff,0xffff,0x93dc,
0xffff,0x9dfa,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9e42,0xffff,
0xffff,0x8f8c,0x9e43,0xffff,0x976a,0x9498,0xffff,0xffff,
0x9e44,0xffff,0xffff,0xffff,0xffff,0xffff,0x9e46,0xffff,
0xffff,0x9e47,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9e48,0xffff,0x8bc8,0x8967,0x8d58,0x9e49,0xffff,0x9e4a,
0x8f91,0x9182,0xfade,0xfa66,0x99d6,0x915d,0x915c,0x91d6,
0x8dc5,0xffff,0xffff,0x98f0,0xffff,0xffff,0xffff,0xffff,
0x8c8e,0x974c,0xffff,0x95fc,0xffff,0x959e,0xfadf,0x9e4b,
0xffff,0xffff,0xffff,0xffff,0x8df1,0x92bd,0x9e4c,0x984e,
0xffff,0xffff,0xffff,0x965d,0xffff,0x92a9,0x9e4d,0x8afa,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9e4e,0x9e4f,
0x96d8,0xffff,0x96a2,0x9696,0x967b,0x8e44,0x9e51,0xffff,
0xffff,0x8ee9,0xffff,0xffff,0x9670,0xffff,0x9e53,0x9e56,
0x9e55,0xffff,0x8af7,0xffff,0xffff,0x8b80,0xffff,0x9e52,
0xffff,0x9e54,0xffff,0xffff,0xffff,0xffff,0x9e57,0xffff,
0xffff,0x9099,0xffff,0xffff,0xffff,0xffff,0x979b,0x88c7,
0x8dde,0x91ba,0xffff,0x8edb,0xffff,0xffff,0x8ff1,0xffff,
0xffff,0x9e5a,0xffff,0xffff,0x936d,0xffff,0x9e58,0x91a9,
0x9e59,0x8ff0,0x96db,0x9e5b,0x9e5c,0x9788,0xfae1,0xffff,
0xffff,0xffff,0x9e61,0xffff,0xffff,0x8d59,0xffff,0x9474,
0x9e5e,0x938c,0x9ddc,0x9de0,0xffff,0x8b6e,0xffff,0x9466,
0xffff,0xffff,0xffff,0xffff,0x9e60,0xffff,0x8fbc,0x94c2,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9e66,0xffff,0x94f8,
0xffff,0x9e5d,0xffff,0x9e63,0x9e62,0xffff,0xffff,0xffff,
0x90cd,0xffff,0xffff,0xffff,0xffff,0x968d,0xffff,0x97d1,
0xffff,0xffff,0x9687,0xffff,0x89ca,0x8e7d,0xffff,0xffff,
0x9867,0x9e65,0x9095,0xffff,0xffff,0xffff,0x9e64,0xffff,
0xffff,0x9e5f,0xffff,0xffff,0xffff,0xffff,0xffff,0x8ccd,
0xffff,0xffff,0xffff,0x9e6b,0x9e69,0xffff,0x89cb,0x9e67,
0x9e6d,0x9e73,0xffff,0xfae2,0xffff,0xffff,0xffff,0xffff,
0xfae4,0x91c6,0xffff,0xffff,0x95bf,0xffff,0x9e75,0xffff,
0xffff,0xffff,0x9541,0xffff,0xffff,0xffff,0x9e74,0x9490,
0x965e,0x8ab9,0xffff,0x90f5,0x8f5f,0xffff,0xffff,0xffff,
0x92d1,0xffff,0x974d,0xffff,0xffff,0x9e70,0x9e6f,0xffff,
0xffff,0xffff,0x9e71,0xffff,0x9e6e,0xffff,0xffff,0x9e76,
0xffff,0x9e6c,0xffff,0xffff,0x9e6a,0xffff,0x9e72,0x9e68,
0xffff,0x928c,0xffff,0x96f6,0x8ec4,0x8df2,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8db8,0xffff,0xffff,0x968f,0x8a60,
0xffff,0xfae5,0x92cc,0x93c8,0x8968,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x90f0,0xffff,0xffff,0x90b2,0x8c49,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9e78,0xffff,
0xffff,0x8d5a,0x8a9c,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9e7a,0x8a94,0x9e81,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9e7d,0xffff,0x90f1,0xffff,0xffff,0xffff,
0x8a6a,0x8daa,0xffff,0xffff,0x8a69,0x8dcd,0xffff,0xffff,
0x9e7b,0x8c85,0x8c6a,0x938d,0xfae6,0xffff,0x9e79,0xffff,
0x88c4,0xffff,0xffff,0xffff,0xffff,0x9e7c,0x9e7e,0xffff,
0x8bcb,0x8c4b,0xfae3,0x8aba,0x8b6a,0xffff,0xffff,0xffff,
0xffff,0x9e82,0xffff,0xffff,0x8df7,0x9691,0xffff,0x8e56,
0xffff,0xffff,0xffff,0x9e83,0xffff,0xffff,0xffff,0x954f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9e8f,0xffff,0x89b1,0x9e84,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9e95,0x9e85,
0xffff,0x97c0,0xffff,0x9e8c,0xffff,0x947e,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9e94,0xffff,0x9e87,
0xffff,0xffff,0xffff,0x88b2,0x9e89,0xffff,0xffff,0x8d5b,
0xffff,0xffff,0xffff,0x9e8b,0xffff,0x9e8a,0xffff,0x9e86,
0x9e91,0xffff,0x8fbd,0xffff,0xffff,0xffff,0x9aeb,0x8ce6,
0x979c,0xffff,0xffff,0xffff,0xffff,0x9e88,0xffff,0x92f2,
0x8a42,0x8dab,0xffff,0x9e80,0xffff,0x9e90,0x8a81,0xffff,
0xffff,0x9e8e,0x9e92,0xffff,0x938e,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8afc,0xffff,0x9eb0,0xffff,
0xfa64,0x96c7,0x9e97,0x8afb,0xffff,0x9e9e,0xffff,0xfae7,
0xffff,0xffff,0x965f,0xffff,0x9e9f,0x9ea1,0xffff,0x9ea5,
0x9e99,0xffff,0x9249,0xffff,0xffff,0xffff,0xffff,0x938f,
0x9ea9,0x9e9c,0xffff,0x9ea6,0xffff,0xffff,0xffff,0x9ea0,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9058,0x9eaa,
0xffff,0xffff,0x90b1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9ea8,0x8abb,0xffff,0xffff,0xffff,0xffff,0xffff,
0x986f,0x9e96,0xffff,0xffff,0x9ea4,0x88d6,0xffff,0xffff,
0x9e98,0xffff,0xffff,0x96b8,0x9e9d,0x9041,0x92c5,0x9e93,
0xffff,0xffff,0x9ea3,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x909a,0x9ead,0x8a91,0x8c9f,0xffff,0xffff,0xffff,
0xffff,0x9eaf,0x9e9a,0x9eae,0xffff,0x9ea7,0x9e9b,0xffff,
0x9eab,0xffff,0x9eac,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9ebd,0xffff,0xffff,0xffff,0x93cc,0xffff,0x9ea2,0xffff,
0xffff,0x9eb9,0xffff,0xffff,0xffff,0x9ebb,0xffff,0x92d6,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x976b,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9596,0x9eb6,0x91c8,0xffff,0xffff,
0xffff,0x9ebc,0x915e,0xffff,0x9eb3,0x9ec0,0x9ebf,0xffff,
0x93ed,0x9ebe,0x93e8,0xffff,0xffff,0xffff,0xffff,0xffff,
0xfae9,0xffff,0x9ec2,0x9eb5,0xffff,0x8bc6,0x9eb8,0x8f7c,
0xffff,0xffff,0xffff,0x9480,0x9eba,0x8bc9,0xffff,0x9eb2,
0x9eb4,0x9eb1,0xffff,0xffff,0x984f,0x8a79,0x9eb7,0xffff,
0xffff,0x9ec1,0x8a54,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8de5,0xffff,0xffff,0xffff,0x897c,0xffff,
0xffff,0x9ed2,0xffff,0xffff,0x9850,0x9ed5,0xffff,0xffff,
0xfaeb,0xffff,0xffff,0x9059,0x9ed4,0xffff,0xffff,0xffff,
0x9ed3,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9ed0,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9ec4,0xffff,
0xffff,0x9ee1,0x9ec3,0xffff,0x9ed6,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9ece,0xffff,0xffff,0x9ec9,0x9ec6,
0xffff,0x9ec7,0xffff,0x9ecf,0xffff,0xffff,0xffff,0xeaa0,
0xffff,0xffff,0x9ecc,0x8d5c,0x92c6,0x9184,0x9eca,0xffff,
0x9ec5,0xffff,0xffff,0x9ec8,0xffff,0xffff,0xffff,0xffff,
0x976c,0x968a,0xffff,0xffff,0xffff,0x9ecd,0x9ed7,0xffff,
0xffff,0xffff,0xfaec,0xffff,0xffff,0xffff,0xffff,0x9edf,
0x9ed8,0xffff,0xffff,0x9ee5,0xffff,0x9ee3,0xffff,0xffff,
0xffff,0xffff,0x9ede,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9edd,0xffff,0x92ce,0xffff,0x9185,0xffff,0x9edb,
0xffff,0xffff,0x9ed9,0xffff,0xffff,0x9ee0,0xffff,0xffff,
0xffff,0xffff,0x9ee6,0x94f3,0x9eec,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9ee7,0x9eea,0x9ee4,0xffff,0xffff,0x9294,
0xffff,0x9557,0xffff,0x9eda,0xffff,0xffff,0x9ee2,0x8fbe,
0xffff,0x96cd,0x9ef6,0x9ee9,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8ca0,0x89a1,0x8a7e,0xffff,0xffff,0x9ed1,0xffff,
0xfaed,0xffff,0xffff,0xffff,0xffff,0x8fbf,0x9eee,0xffff,
0x9ef5,0x8ef7,0x8a92,0xffff,0xffff,0x924d,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9eeb,0xffff,0xfaef,0x9ef0,
0x9ef4,0xffff,0xffff,0x8bb4,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8b6b,0x9ef2,0xffff,0xffff,0xffff,0xffff,0xffff,0x8b40,
0xffff,0x93c9,0x9ef1,0xffff,0xffff,0xffff,0x9ef3,0xffff,
0xffff,0xffff,0xffff,0xfaee,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9eed,0xfaf0,0xffff,0xffff,0xffff,0xffff,
0x9eef,0xffff,0xffff,0xffff,0xffff,0xffff,0xfaf1,0x8a80,
0x9268,0xffff,0xffff,0xffff,0x9efa,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9ef8,0x8ce7,0xffff,
0x9ef7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9f40,
0xffff,0xffff,0xffff,0xffff,0x9e77,0xffff,0xffff,0xffff,
0x9ef9,0xffff,0x9efb,0x9efc,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9f4b,0xffff,0x9f47,0xffff,0x9e8d,0xffff,
0xffff,0xffff,0xffff,0x9f46,0xffff,0xffff,0xffff,0xffff,
0x9f45,0xffff,0xffff,0x9f42,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9ee8,0x9f44,0x9f43,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9f49,0xffff,0x9845,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9f4c,0x8bf9,0xffff,0xffff,0x9f48,0x9f4a,
0xffff,0xffff,0xfaf2,0xffff,0xfaf3,0xffff,0xffff,0xffff,
0x94a5,0xffff,0x9f4d,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9f51,0x9f4e,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9793,0x9f4f,0xffff,0xffff,
0xffff,0xffff,0x9edc,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9f52,0xffff,0xffff,0xffff,0x9f53,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8954,0xffff,0x9f55,
0x8c87,0x8e9f,0xffff,0x8bd3,0xffff,0xffff,0xffff,0x89a2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x977e,0xffff,0xffff,0xffff,0xffff,0x9f57,
0x9f56,0x9f59,0x8b5c,0xffff,0xffff,0x8bd4,0x8abc,0xffff,
0xffff,0xffff,0xffff,0x9f5c,0xffff,0xffff,0xffff,0x9f5b,
0xffff,0x9f5d,0xffff,0xffff,0x89cc,0xffff,0x9256,0xffff,
0x9f5e,0xffff,0xffff,0x8abd,0x9f60,0xffff,0xffff,0xffff,
0xffff,0x9f5f,0xffff,0x9f61,0xffff,0xffff,0xffff,0x9f62,
0xffff,0x9f63,0x8e7e,0x90b3,0x8d9f,0xffff,0x9590,0xffff,
0xffff,0x95e0,0x9863,0xffff,0xffff,0xffff,0xffff,0x8e95,
0xffff,0xffff,0xffff,0x8dce,0x97f0,0xffff,0xffff,0xffff,
0x9f64,0x9f65,0xffff,0x8e80,0xffff,0xffff,0xffff,0x9f66,
0x9f67,0xffff,0xffff,0x9f69,0x9f68,0xffff,0x9677,0xffff,
0xffff,0x8f7d,0x8eea,0x8e63,0xffff,0x9f6a,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9f6c,0x9042,0xffff,
0x9f6b,0xffff,0xffff,0xffff,0xffff,0xffff,0x9f6d,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9f6e,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9f6f,0x9f70,0xffff,0xffff,0xffff,0x9f71,
0xffff,0x9f73,0x9f72,0x9f74,0x89a3,0x9269,0xffff,0x9f75,
0xffff,0xffff,0x8e45,0x8a6b,0x9f76,0xffff,0xffff,0x9361,
0x9aca,0xffff,0xffff,0xffff,0xffff,0x8b42,0x9f77,0xffff,
0xffff,0xffff,0xffff,0x9f78,0xffff,0x95ea,0x9688,0xffff,
0xffff,0xffff,0x93c5,0x9f79,0x94e4,0xffff,0xfaf4,0xffff,
0x94f9,0xffff,0xffff,0x96d1,0xffff,0xffff,0xffff,0x9f7a,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9f7c,0x9f7b,0xffff,0xffff,0x9f7e,
0xffff,0xffff,0xffff,0x9f7d,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9f81,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8e81,
0xffff,0x96af,0xffff,0x9f82,0x9f83,0xffff,0xffff,0x8b43,
0xffff,0xffff,0xffff,0x9f84,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9f86,0x9f85,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9085,0xffff,0xffff,0x9558,
0x8969,0xffff,0xffff,0xffff,0xffff,0xffff,0x94c3,0xfaf5,
0x92f3,0x8f60,0x8b81,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x94c4,0xffff,
0x8eac,0xffff,0xffff,0xffff,0xffff,0x9f88,0xffff,0x8abe,
0xffff,0xffff,0x8998,0xffff,0xfaf6,0x93f0,0x9f87,0x8d5d,
0x9272,0xffff,0x9f89,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9f91,0xffff,0x9f8a,0xffff,0xffff,0xffff,0xffff,0xfaf8,
0x91bf,0xffff,0x8b82,0x9f92,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8c88,0xffff,0xffff,0x8b44,0x9f90,0xffff,
0xffff,0x9f8e,0x9f8b,0x9780,0xffff,0xffff,0xfaf7,0xffff,
0x92be,0xffff,0xffff,0xffff,0x93d7,0x9f8c,0xffff,0xffff,
0x9f94,0xffff,0x9f93,0x8c42,0xffff,0xffff,0x89ab,0xffff,
0xffff,0x8db9,0x9f8d,0x9f8f,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9676,0x91f2,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9697,0xffff,0xffff,0x9f9c,0xffff,
0xffff,0x9f9d,0xffff,0x89cd,0xffff,0xffff,0xffff,0xffff,
0x95a6,0x96fb,0x9f9f,0x8ea1,0x8fc0,0x9f98,0x9f9e,0x8988,
0xffff,0x8bb5,0xffff,0xffff,0x9f95,0x9f9a,0xffff,0xffff,
0xffff,0x90f2,0x9491,0xffff,0x94e5,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9f97,0xffff,0x9640,0xffff,0x9f99,
0xffff,0x9fa2,0xfaf9,0x9fa0,0xffff,0x9f9b,0xffff,0xffff,
0xffff,0x9641,0x9467,0x8b83,0xffff,0x9344,0xffff,0xffff,
0x928d,0xffff,0x9fa3,0xffff,0xffff,0xffff,0xffff,0x9fa1,
0x91d7,0x9f96,0xffff,0x896a,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfafa,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x976d,0x9fae,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9fad,0xffff,0xffff,0xffff,0xffff,0x90f4,
0xffff,0x9faa,0xffff,0x978c,0xffff,0xffff,0x93b4,0x9fa4,
0xffff,0xffff,0xffff,0xffff,0xffff,0x92c3,0xffff,0xffff,
0xffff,0x896b,0x8d5e,0x9fa7,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8f46,0x9fac,0xffff,0x9fab,0x9fa6,0xffff,
0x9fa9,0xffff,0xffff,0x8a88,0xffff,0x9fa8,0x9468,0xffff,
0xffff,0x97ac,0xffff,0xffff,0x8ff2,0x90f3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9fb4,0x9fb2,0xffff,0x956c,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9faf,0x9fb1,0xffff,0x8959,0xffff,
0xffff,0x8d5f,0x9851,0xffff,0x8a5c,0xffff,0x9582,0xfafc,
0xffff,0xffff,0xffff,0xffff,0x9781,0xffff,0xffff,0x8a43,
0x905a,0x9fb3,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9fb8,0xffff,0xfafb,
0x8fc1,0xffff,0xffff,0xffff,0x974f,0xffff,0x9fb5,0xffff,
0xffff,0xffff,0xffff,0x9fb0,0xffff,0x9fb6,0xfb40,0xffff,
0xffff,0x97dc,0xffff,0x9393,0x93c0,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfb41,0xffff,0xffff,0x8a55,
0xffff,0xffff,0x8974,0xffff,0xffff,0x9fbc,0xffff,0xffff,
0x9fbf,0xffff,0xffff,0xffff,0x97c1,0xffff,0xffff,0xffff,
0x9784,0xffff,0xffff,0xffff,0xffff,0x9fc6,0x9fc0,0x9fbd,
0xffff,0xffff,0xffff,0x97d2,0x9fc3,0xffff,0xffff,0xfb42,
0xffff,0x8f69,0x9fc5,0xffff,0xffff,0x9fca,0xffff,0xffff,
0x9391,0x9fc8,0xffff,0xffff,0xffff,0xffff,0x9fc2,0xffff,
0xffff,0x9257,0xffff,0xffff,0x9fc9,0xffff,0x9fbe,0xffff,
0x9fc4,0xffff,0x9fcb,0x88fa,0x9fc1,0xffff,0x9fcc,0xffff,
0xffff,0x905b,0xfb44,0x8f7e,0xffff,0x95a3,0xffff,0x8dac,
0xfb43,0x9fb9,0x9fc7,0x9359,0xfb45,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x90b4,0xffff,0x8a89,
0x8dcf,0x8fc2,0x9fbb,0x8f61,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8c6b,0xffff,0x9fba,0xffff,0xffff,
0xffff,0x9fd0,0x8f8d,0x8cb8,0xffff,0x9fdf,0xffff,0x9fd9,
0x8b94,0x936e,0xffff,0x9fd4,0x9fdd,0x88ad,0x8951,0xfb48,
0xffff,0x89b7,0xffff,0x9fd6,0x91aa,0x9fcd,0x9fcf,0x8d60,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9fe0,0xfb46,0x9fdb,0xffff,0xfb49,0xffff,0x9fd3,0xffff,
0xffff,0xffff,0xffff,0x9fda,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x96a9,0xffff,0xffff,0x9fd8,0x9fdc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8cce,0xffff,
0x8fc3,0xffff,0xffff,0x9258,0xfb47,0xffff,0xffff,0x9fd2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x974e,
0xffff,0xffff,0xffff,0x9fd5,0xffff,0xffff,0x9fce,0x9392,
0xffff,0xffff,0x9fd1,0xffff,0xffff,0xffff,0x9fd7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9870,0x8ebc,
0x969e,0xffff,0x9fe1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x94ac,0xffff,0xffff,0x9fed,
0x8cb9,0xffff,0xffff,0xffff,0xffff,0xffff,0x8f80,0xffff,
0x9fe3,0xffff,0xffff,0xffff,0x97ad,0x8d61,0xffff,0x9ff0,
0xffff,0xffff,0x88ec,0xffff,0xffff,0x9fee,0xffff,0xffff,
0xffff,0xffff,0x9fe2,0xffff,0xffff,0xffff,0xffff,0x9fe8,
0xffff,0xffff,0x9fea,0xffff,0xffff,0xffff,0x976e,0x9fe5,
0xffff,0xffff,0x934d,0xffff,0xffff,0x9fe7,0xffff,0xfb4a,
0xffff,0xffff,0x9fef,0xffff,0x9fe9,0x96c5,0xffff,0xffff,
0xffff,0x9fe4,0xffff,0x8ea0,0x9ffc,0xffff,0xffff,0xffff,
0xffff,0x8a8a,0xffff,0x9fe6,0x9feb,0x9fec,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x91ea,0x91d8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9ff4,0xffff,0xffff,0x9ffa,
0xffff,0xffff,0x9ff8,0xffff,0x9348,0xffff,0xffff,0xe042,
0x9ff5,0xffff,0xffff,0xffff,0xffff,0xffff,0x9ff6,0x9fde,
0xffff,0x8b99,0x9559,0xffff,0xffff,0xffff,0x8ebd,0xffff,
0xffff,0x8d97,0xffff,0xffff,0xffff,0xffff,0xffff,0x9852,
0xffff,0x9ff2,0xffff,0xe041,0x8989,0x9186,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9499,0xffff,0x8abf,0x97f8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x969f,0x92d0,0xffff,0xffff,0xffff,
0xffff,0x9ff9,0x9ffb,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9151,0xffff,0xffff,0xffff,0xffff,0xffff,0xe040,0x9ff7,
0xffff,0x9ff1,0xffff,0xffff,0xffff,0x8ac1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8c89,0xffff,0xffff,0xffff,
0xe04e,0xffff,0xffff,0xe049,0x90f6,0xffff,0xffff,0x8a83,
0xffff,0xffff,0xffff,0xffff,0x8f81,0xffff,0xe052,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe04b,0x92aa,0xe048,
0x92d7,0xffff,0xffff,0xffff,0xe06b,0xffff,0xffff,0xffff,
0xe045,0xffff,0xe044,0xffff,0xe04d,0xffff,0xffff,0xffff,
0xe047,0xe046,0xe04c,0xffff,0x909f,0xffff,0xe043,0xffff,
0xfb4b,0xffff,0xffff,0xffff,0xffff,0xffff,0xe04f,0xffff,
0xffff,0xe050,0xffff,0xffff,0xffff,0xffff,0xffff,0x8ac0,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe055,0xffff,0xe054,0xe056,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe059,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9362,0xffff,0xe053,0xffff,0xfb4c,0xffff,0xffff,
0xffff,0xe057,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8c83,0x91f7,0xe051,0x945a,0xffff,0xffff,0xe058,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe05d,0xe05b,0xffff,0xffff,
0xe05e,0xffff,0xffff,0xe061,0xffff,0xffff,0xffff,0xe05a,
0x8d8a,0x9447,0xffff,0xffff,0x9fb7,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9794,0xe05c,0xffff,0xe060,0x91f3,
0xffff,0xe05f,0xffff,0xe04a,0xffff,0xfb4d,0xe889,0xffff,
0xffff,0xffff,0xe064,0xffff,0xffff,0xffff,0xe068,0xffff,
0xffff,0xe066,0xffff,0xffff,0xffff,0xfb4e,0xffff,0xfb4f,
0xffff,0xe062,0xffff,0xe063,0xffff,0xffff,0xffff,0xe067,
0xffff,0xe065,0xffff,0xffff,0xffff,0x956d,0xffff,0xffff,
0xe06d,0xffff,0xe06a,0xe069,0xffff,0xe06c,0x93d2,0xe06e,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9295,0x91eb,
0xfb50,0xffff,0xffff,0xffff,0x90a3,0xffff,0xffff,0xffff,
0xe06f,0xffff,0xe071,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe070,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9ff3,0xffff,0xffff,0xffff,
0xffff,0xe072,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x93e5,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe073,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x89ce,0xffff,0xffff,0xffff,0x9394,
0x8a44,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8b84,0xffff,0xffff,0xffff,0x8edc,0x8dd0,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xfb51,0xffff,0xffff,
0xffff,0x9846,0x9086,0xffff,0xffff,0xffff,0x898a,0xffff,
0xffff,0xffff,0xe075,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe074,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xfb52,0xe078,0x9259,0xe07b,0xe076,
0xffff,0xffff,0xffff,0xe07a,0xffff,0xffff,0xffff,0xffff,
0xe079,0x935f,0x88d7,0xfa62,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x97f3,0xffff,0xffff,0xe07d,0xffff,0xffff,0xffff,0x8947,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe080,0xffff,0xffff,0xffff,0xe07e,0xffff,0xe07c,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe077,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9642,0xffff,0xffff,0xffff,0xe082,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfb54,0xffff,0xffff,0xffff,
0xffff,0xe081,0xffff,0xffff,0xffff,0xffff,0xffff,0xfb53,
0xffff,0xffff,0xffff,0xffff,0x898b,0xffff,0xffff,0xffff,
0xffff,0xe084,0x95b0,0xffff,0xe083,0xffff,0xffff,0xffff,
0xffff,0x96b3,0xffff,0xffff,0xffff,0xffff,0x8fc5,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9152,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8fc4,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfb56,0xfb57,
0xffff,0x97f9,0xffff,0xffff,0xe08a,0xffff,0x90f7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe086,0xe08b,0xffff,
0xffff,0x898c,0xffff,0xffff,0xfb55,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe089,0xffff,0x9481,0xe085,0xe088,0x8fc6,
0xffff,0x94cf,0xffff,0xffff,0xe08c,0xffff,0x8ecf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x90f8,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe08f,0xffff,0xffff,0xffff,
0xe087,0xffff,0x8c46,0xffff,0xffff,0xffff,0xffff,0xe08d,
0xffff,0xffff,0xffff,0xffff,0x976f,0xe090,0xffff,0xffff,
0xffff,0xeaa4,0xffff,0xffff,0xffff,0xffff,0xffff,0x8f6e,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe091,0xffff,0xffff,0xffff,0xe092,0xffff,0xffff,0xffff,
0xffff,0x944d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe094,0xffff,0xffff,0xffff,0xffff,0xe095,0xffff,
0xffff,0xfb59,0xffff,0x9452,0xffff,0xffff,0xffff,0xffff,
0x9395,0xe097,0xffff,0xffff,0xffff,0xffff,0xe099,0xffff,
0x97d3,0xffff,0xe096,0xffff,0xe098,0x898d,0xffff,0xe093,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9a7a,
0xe09a,0xffff,0xffff,0xffff,0xffff,0x9187,0x8e57,0xe09c,
0xffff,0xffff,0xffff,0xffff,0xe09b,0x9043,0x99d7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe09d,0xffff,0xffff,
0xffff,0xe09f,0xffff,0xe08e,0xe09e,0xffff,0xfb5a,0xe0a0,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x949a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe0a1,0xffff,0xffff,
0xe0a2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe0a3,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe0a4,0xffff,0x92dc,0xffff,0xe0a6,0xe0a5,0xffff,0xffff,
0xe0a7,0xffff,0xe0a8,0xffff,0xffff,0x8edd,0x9583,0xffff,
0xffff,0xffff,0x96ea,0xe0a9,0xe0aa,0x9175,0x8ea2,0xe0ab,
0xe0ac,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0ad,0x95d0,
0x94c5,0xffff,0xffff,0xe0ae,0x9476,0xffff,0xffff,0xffff,
0xffff,0xffff,0x92ab,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe0af,0x89e5,0xffff,0x8b8d,0xffff,0x96c4,0xffff,0x96b4,
0xffff,0x89b2,0x9853,0xffff,0xffff,0xffff,0xffff,0x9671,
0xffff,0x95a8,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x90b5,0xffff,0xe0b0,0xffff,0xffff,0xffff,
0xffff,0x93c1,0xffff,0xffff,0xffff,0x8ca1,0xe0b1,0xffff,
0x8dd2,0xe0b3,0xe0b2,0xffff,0xffff,0xffff,0xffff,0xe0b4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe0b5,0xffff,0xffff,0xffff,0xe0b6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8b5d,0xffff,0xe0b7,0xffff,0xffff,0xffff,0xffff,0xe0b8,
0xffff,0xffff,0xffff,0xffff,0x8ca2,0xffff,0xffff,0x94c6,
0xffff,0xfb5b,0xe0ba,0xffff,0xffff,0xffff,0x8ff3,0xffff,
0xffff,0xe0b9,0xffff,0xffff,0xffff,0xffff,0xfb5c,0xffff,
0xffff,0xffff,0x8bb6,0xe0bb,0xe0bd,0xffff,0xe0bc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0be,0xffff,
0x8ccf,0xffff,0xe0bf,0xffff,0xffff,0xffff,0xffff,0x8be7,
0xffff,0x915f,0xffff,0x8d9d,0xffff,0xffff,0xffff,0xffff,
0xe0c1,0xe0c2,0xe0c0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8eeb,0xffff,0xffff,0x93c6,0x8bb7,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0c4,
0x924b,0xe0c3,0xffff,0xffff,0x9854,0x9482,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe0c7,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0c9,0xe0c6,
0xffff,0xffff,0xffff,0x96d2,0xe0c8,0xe0ca,0xffff,0x97c2,
0xffff,0xffff,0xffff,0xffff,0xfb5d,0xe0ce,0xffff,0xffff,
0xffff,0xe0cd,0x9296,0x944c,0xffff,0xffff,0x8ca3,0xe0cc,
0xffff,0xffff,0xffff,0xffff,0xe0cb,0xffff,0x9750,0x9751,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0cf,0x898e,
0xffff,0xffff,0xffff,0xffff,0x8d96,0x8e82,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0d0,0xe0d1,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0d3,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8f62,0xffff,0xffff,0xffff,0xffff,
0xe0d5,0xffff,0xe0d4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe0d6,0xffff,0x8a6c,0xffff,0xffff,0xe0d8,0xffff,0xfb5f,
0xe0d7,0xffff,0xe0da,0xe0d9,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8cba,0xffff,0xffff,0x97a6,
0xffff,0x8bca,0xffff,0x89a4,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8be8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8adf,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x97e6,0xe0dc,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe0de,0xffff,0xfb60,0xffff,0xffff,
0xe0df,0xffff,0x89cf,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe0db,0xfb61,0x8e58,0xffff,0xffff,0x92bf,0xe0dd,0xffff,
0xffff,0xffff,0xfb64,0xffff,0xffff,0xffff,0xfb62,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0e2,0xffff,
0x8eec,0xffff,0xffff,0xfb63,0xffff,0xe0e0,0xffff,0xffff,
0xffff,0xffff,0x8c5d,0xffff,0xffff,0x94c7,0xe0e1,0xffff,
0xffff,0xe0fc,0xffff,0xffff,0xffff,0xfb66,0xffff,0xffff,
0xe0e7,0xffff,0xffff,0xffff,0xffff,0xffff,0x8cbb,0xffff,
0xffff,0xffff,0xffff,0x8b85,0xffff,0xe0e4,0x979d,0xfb65,
0xffff,0x97ae,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x91f4,0xffff,0xffff,0xe0e6,0xfb67,0xffff,
0xffff,0xfb69,0xfb68,0xffff,0xffff,0xffff,0xfb6a,0xffff,
0xffff,0xffff,0xe0e8,0x97d4,0x8bd5,0x94fa,0x9469,0xffff,
0xffff,0xffff,0xe0e9,0xffff,0xffff,0xffff,0xffff,0xe0eb,
0xffff,0xe0ee,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe0ea,0xffff,0xffff,
0xffff,0xe0ed,0x8ce8,0x896c,0xe0ef,0xffff,0x9090,0xe0ec,
0x97da,0xffff,0xfb6b,0xe0f2,0xeaa2,0xffff,0xffff,0xffff,
0xffff,0xe0f0,0xe0f3,0xffff,0xffff,0xffff,0xffff,0xe0e5,
0xe0f1,0xffff,0xffff,0x8dba,0xffff,0xffff,0xe0f4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0f5,0xffff,
0xffff,0xffff,0xffff,0x979e,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfb6c,0xffff,0xe0f6,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0f7,0xfb6d,
0xffff,0xffff,0xe0e3,0xffff,0xffff,0xffff,0xffff,0xe0f8,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8ac2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8ea3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe0f9,0xffff,0xffff,0xffff,0xffff,0xe0fa,
0xffff,0xffff,0xffff,0xffff,0xe0fb,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x895a,0xffff,0xffff,0xffff,
0xe140,0xffff,0x955a,0xe141,0xffff,0xffff,0x8aa2,0xe142,
0xffff,0xe143,0xffff,0xffff,0xffff,0xffff,0xe144,0xffff,
0xe146,0xe147,0xe145,0xffff,0xffff,0xffff,0x9572,0xe149,
0xe148,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfb6e,0xffff,0xe14b,0xe14a,0xe14c,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe14d,0xe14f,0xe14e,0xffff,
0xffff,0x8d99,0xffff,0xe151,0xffff,0xe150,0xffff,0xffff,
0x8ac3,0xffff,0x9072,0xffff,0x935b,0xffff,0xe152,0x90b6,
0xffff,0xffff,0xffff,0x8e59,0xffff,0x8999,0xe153,0xffff,
0x9770,0xffff,0xffff,0x95e1,0xe154,0xffff,0xffff,0xfaa8,
0x9363,0x9752,0x8d62,0x905c,0xffff,0xffff,0xffff,0x926a,
0x99b2,0xffff,0x92ac,0x89e6,0xe155,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe156,0xffff,0xe15b,0xffff,
0xffff,0xe159,0xe158,0x9dc0,0x8a45,0xe157,0xffff,0x88d8,
0xffff,0x94a8,0xffff,0xffff,0x94c8,0xffff,0xffff,0xffff,
0xffff,0x97af,0xe15c,0xe15a,0x927b,0x90a4,0xffff,0xffff,
0x94a9,0xffff,0x954c,0xffff,0xe15e,0x97aa,0x8c6c,0xe15f,
0xffff,0xe15d,0x94d4,0xe160,0xffff,0xe161,0xffff,0xfb6f,
0x88d9,0xffff,0xffff,0x8ff4,0xe166,0xffff,0xe163,0x93eb,
0xe162,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8b45,
0xffff,0xffff,0xe169,0xffff,0xffff,0xffff,0xe164,0xe165,
0xffff,0xe168,0xe167,0x9544,0xffff,0xffff,0x9161,0x9160,
0xffff,0x8b5e,0xffff,0xffff,0xe16a,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe16b,0xffff,0xffff,0xe16c,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe16e,0xffff,0xe16d,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8975,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe176,0x94e6,0xe170,0xffff,0xe172,0xffff,0xffff,
0xe174,0x905d,0xffff,0xffff,0xe175,0xe173,0x8ebe,0xffff,
0xffff,0xffff,0xe16f,0xe171,0xffff,0x9561,0xffff,0x8fc7,
0xffff,0xffff,0xe178,0xffff,0xffff,0xe177,0xffff,0xffff,
0xffff,0xffff,0xe179,0xffff,0x8ea4,0x8dad,0xffff,0xffff,
0x9397,0xe17a,0xffff,0x92c9,0xffff,0xffff,0xe17c,0xffff,
0xffff,0xffff,0x979f,0xe17b,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9189,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe182,0xffff,0xe184,0xe185,0x9273,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe183,0xffff,0xe180,0xffff,0xe17d,0xe17e,
0xffff,0xe181,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe188,0xffff,0xe186,0xffff,0xe187,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe189,
0xe18b,0xe18c,0xe18d,0xffff,0xe18e,0xffff,0xffff,0xe18a,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe190,0xffff,0xffff,0xffff,0xe18f,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe191,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x97c3,0xffff,0xffff,0xffff,0xe194,0xe192,
0xe193,0xffff,0xffff,0xffff,0x8ae0,0xffff,0xffff,0xffff,
0xffff,0xffff,0x96fc,0xffff,0xffff,0xffff,0x95c8,0xffff,
0xe196,0xffff,0xffff,0xffff,0xe195,0xffff,0xffff,0xffff,
0xffff,0xe197,0xe198,0xffff,0xffff,0xffff,0xffff,0xe19c,
0xe199,0xe19a,0xe19b,0xffff,0xe19d,0xffff,0xffff,0xffff,
0xe19e,0xffff,0xe19f,0xffff,0xffff,0xffff,0xe1a0,0xffff,
0xe1a1,0xffff,0x94ad,0x936f,0xe1a2,0x9492,0x9553,0xffff,
0xe1a3,0xffff,0xfb70,0xe1a4,0x9349,0xffff,0x8a46,0x8d63,
0xe1a5,0xffff,0xffff,0xe1a6,0xffff,0xffff,0xe1a7,0xffff,
0x8e48,0xffff,0xffff,0xe1a9,0xffff,0xffff,0xe1a8,0xffff,
0xffff,0xe1aa,0xe1ab,0xfb73,0xfb71,0xffff,0xfb72,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfb74,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x94e7,0xffff,
0xe1ac,0xffff,0xffff,0xffff,0xe1ad,0xffff,0xffff,0xea89,
0xe1ae,0xe1af,0xe1b0,0xffff,0xffff,0xffff,0xffff,0x8e4d,
0xffff,0xffff,0xe1b1,0x9475,0xffff,0xffff,0x967e,0xffff,
0x896d,0xffff,0x8976,0xffff,0xffff,0xe1b2,0xffff,0xffff,
0xffff,0xffff,0xe1b4,0xffff,0xffff,0xffff,0xe1b3,0x9390,
0xffff,0xffff,0xffff,0x90b7,0x9f58,0xffff,0xe1b5,0x96bf,
0xffff,0xe1b6,0xffff,0x8ac4,0x94d5,0xe1b7,0xffff,0xe1b8,
0xffff,0xffff,0xe1b9,0xffff,0xffff,0xffff,0x96da,0xffff,
0xffff,0xffff,0x96d3,0xffff,0x92bc,0xffff,0xffff,0xffff,
0x918a,0xffff,0xffff,0xe1bb,0xffff,0xffff,0x8f82,0xffff,
0xffff,0x8fc8,0xffff,0xffff,0xe1be,0xffff,0xffff,0xe1bd,
0xe1bc,0x94fb,0xffff,0x8ac5,0x8ca7,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe1c4,0xffff,0xffff,0xe1c1,0x905e,
0x96b0,0xffff,0xffff,0xffff,0xe1c0,0xe1c2,0xe1c3,0xffff,
0xffff,0xe1bf,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe1c5,
0xe1c6,0xffff,0x92ad,0xffff,0x8ae1,0xffff,0xffff,0xffff,
0x9285,0xffff,0xffff,0xffff,0xffff,0xffff,0xfb76,0xe1c7,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe1c8,0xe1cb,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9087,0xffff,0x93c2,0xffff,0xe1cc,0x9672,0xffff,
0xe1c9,0xffff,0xffff,0xe1ca,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe1cf,0xffff,0xffff,0xffff,0xffff,0xe1ce,0xe1cd,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe1d1,0xffff,0xffff,0xe1d0,0xffff,
0xffff,0xe1d2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe1d4,0xffff,
0xe1d3,0xffff,0xffff,0xffff,0xffff,0x95cb,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8f75,0x97c4,0xffff,0xffff,
0xe1d5,0xffff,0xffff,0x93b5,0xffff,0xffff,0xe1d6,0xffff,
0xffff,0xe1d7,0xffff,0xe1db,0xe1d9,0xe1da,0xffff,0xe1d8,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe1dc,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe1dd,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe1de,
0xffff,0xffff,0xe1df,0x96b5,0xe1e0,0xffff,0xffff,0xffff,
0xffff,0xffff,0x96ee,0xe1e1,0xffff,0x926d,0xffff,0x948a,
0xffff,0x8be9,0xffff,0xffff,0xffff,0x925a,0xe1e2,0x8bb8,
0xffff,0xffff,0xffff,0x90ce,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe1e3,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8dbb,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe1e4,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe1e5,0xffff,0x8ca4,0x8dd3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe1e7,0xfb78,0xffff,0xffff,0xffff,0x9375,0x8dd4,0x8b6d,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9643,0xffff,0x946a,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9376,0xffff,0xffff,0xffff,0xffff,0x8d7b,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe1e9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfb79,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8fc9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfb7a,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x97b0,0x8d64,0xffff,0xffff,0x8ca5,
0xffff,0xffff,0x94a1,0xffff,0xe1eb,0xffff,0xffff,0xffff,
0xffff,0xffff,0xfb7b,0xffff,0xe1ed,0xffff,0xffff,0xffff,
0xffff,0x8ce9,0xffff,0xffff,0xffff,0xffff,0xe1ec,0x92f4,
0xffff,0xffff,0xffff,0xffff,0xe1ef,0x8a56,0xe1ea,0xffff,
0xffff,0x94e8,0xffff,0x894f,0xffff,0x8dea,0xffff,0x9871,
0xffff,0xffff,0xe1ee,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe1f0,0xffff,0xffff,0xffff,0x95c9,
0xffff,0x90d7,0xe1f2,0xffff,0xffff,0xffff,0xffff,0xe1f3,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe1f1,0xffff,0xffff,
0xffff,0xffff,0x8a6d,0xffff,0xe1f9,0xffff,0xe1f8,0xffff,
0xffff,0x8ea5,0xffff,0xffff,0xffff,0xe1fa,0xe1f5,0xffff,
0xffff,0xffff,0xe1fb,0xe1f6,0xffff,0xffff,0xffff,0xffff,
0x94d6,0xe1f4,0xffff,0xffff,0xe1f7,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe241,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe240,
0x9681,0xffff,0xffff,0xffff,0xe1fc,0xffff,0xffff,0x88e9,
0xffff,0xffff,0xffff,0xffff,0xe243,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe242,0xffff,0xffff,
0xffff,0x8fca,0xffff,0xffff,0xffff,0xffff,0xffff,0xe244,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9162,0xffff,
0xffff,0xe246,0xe245,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe247,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe1e6,0xffff,
0xffff,0xffff,0xe1e8,0xe249,0xe248,0xffff,0xffff,0xffff,
0xfb7c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8ea6,0xffff,0x97e7,0xffff,0x8ed0,0xffff,
0xe24a,0x8c56,0xffff,0xffff,0xffff,0xffff,0xffff,0x8b5f,
0x8b46,0x8e83,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9753,0xffff,0xffff,0xe250,0xffff,0xe24f,0x9163,0xe24c,
0xffff,0xffff,0xe24e,0xffff,0xffff,0x8f6a,0x905f,0xe24d,
0xe24b,0xffff,0x9449,0xffff,0xffff,0x8fcb,0xffff,0xffff,
0x955b,0xffff,0xffff,0xffff,0xffff,0x8dd5,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9398,
0xffff,0xffff,0xe251,0xffff,0xffff,0xffff,0xffff,0xe252,
0xe268,0x8bd6,0xffff,0xffff,0x985c,0x9154,0xffff,0xffff,
0xffff,0xffff,0xe253,0xffff,0xffff,0x89d0,0x92f5,0x959f,
0xffff,0xffff,0xffff,0xffff,0xfb81,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xfb83,0xffff,0xe254,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8b9a,0xe255,
0xffff,0xffff,0xe257,0xffff,0xffff,0xffff,0xe258,0xffff,
0x9448,0xffff,0xffff,0xe259,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe25a,0xe25b,0xffff,0xffff,0x8bd7,0x89d1,0x93c3,
0x8f47,0x8e84,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe25c,0xffff,0x8f48,0xffff,0xffff,0xffff,0xffff,
0xffff,0x89c8,0x9562,0xffff,0xffff,0xe25d,0xffff,0xffff,
0x94e9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9164,
0xffff,0xe260,0xffff,0xe261,0x9489,0xffff,0x9060,0xe25e,
0xffff,0x9281,0xffff,0xffff,0xe25f,0xffff,0xffff,0xffff,
0x8fcc,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x88da,0xffff,0xffff,0xffff,0xffff,
0x8b48,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe262,0xffff,0xffff,0x92f6,0xffff,0xe263,0x90c5,0xffff,
0xffff,0xffff,0xffff,0xffff,0x96ab,0xffff,0xffff,0x9542,
0xe264,0xe265,0x9274,0xffff,0x97c5,0xffff,0xffff,0xe267,
0xe266,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8eed,0xffff,
0xffff,0xe269,0x88ee,0xffff,0xffff,0xffff,0xffff,0xe26c,
0xffff,0xffff,0xffff,0xe26a,0x89d2,0x8c6d,0xe26b,0x8d65,
0x8d92,0xffff,0x95e4,0xe26d,0xffff,0xffff,0x9673,0xffff,
0xffff,0xe26f,0xffff,0xffff,0xffff,0x90cf,0x896e,0x89b8,
0x88aa,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe26e,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe270,0xe271,0x8ff5,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe272,0xffff,0x8a6e,0xffff,0xffff,0xffff,0xffff,
0xe274,0xffff,0xffff,0xffff,0x8c8a,0xffff,0x8b86,0xffff,
0xffff,0xe275,0x8bf3,0xffff,0xffff,0xe276,0xffff,0x90fa,
0xffff,0x93cb,0xffff,0x90de,0x8df3,0xffff,0xffff,0xffff,
0xe277,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9282,0x918b,0xffff,0xe279,0xe27b,0xe278,
0xe27a,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8c41,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe27c,0x8c45,0xffff,0xffff,0xffff,0x8b87,0x9771,
0xe27e,0xffff,0xffff,0xffff,0xffff,0xffff,0xe280,0xffff,
0xffff,0xffff,0x894d,0xffff,0xffff,0xffff,0xffff,0xe283,
0xffff,0xffff,0xffff,0x8a96,0xe282,0xe281,0xffff,0xe285,
0xe27d,0xffff,0xe286,0x97a7,0xffff,0xe287,0xffff,0xe288,
0xffff,0xfb84,0x9af2,0xe28a,0xffff,0xe289,0xffff,0xffff,
0xffff,0xe28b,0xe28c,0xffff,0x97b3,0xe28d,0xffff,0xe8ed,
0x8fcd,0xe28e,0xe28f,0x8f76,0xffff,0x93b6,0xe290,0xfb85,
0xffff,0xffff,0x9247,0xfb87,0xffff,0xe291,0xffff,0x925b,
0xe292,0xffff,0xffff,0xffff,0xffff,0xffff,0x8ba3,0xffff,
0x995e,0x927c,0x8eb1,0xffff,0xffff,0xffff,0xffff,0x8ac6,
0xffff,0xffff,0xe293,0xffff,0xe2a0,0xffff,0xe296,0xffff,
0x8b88,0xffff,0xe295,0xe2a2,0xffff,0xffff,0xffff,0xe294,
0xffff,0x8fce,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe298,0xe299,0xffff,0x934a,0xffff,0xffff,0xe29a,0xffff,
0x8a7d,0xffff,0xffff,0xffff,0xffff,0x9079,0x9584,0xffff,
0xe29c,0xffff,0xffff,0xffff,0x91e6,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe297,0xffff,0xe29b,0xe29d,0xffff,
0xffff,0x8df9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe2a4,0x954d,0xffff,
0x94a4,0x9399,0xffff,0x8bd8,0xe2a3,0xe2a1,0xffff,0x94b3,
0xe29e,0x927d,0x939b,0xffff,0x939a,0xffff,0x8df4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe2b6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe2a6,0xffff,0xe2a8,
0xffff,0xffff,0xffff,0xffff,0xe2ab,0xffff,0xe2ac,0xffff,
0xe2a9,0xe2aa,0xffff,0xffff,0xe2a7,0xe2a5,0xffff,0xffff,
0xffff,0xffff,0xe29f,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x95cd,0x89d3,
0xffff,0xffff,0xffff,0xe2b3,0xffff,0xe2b0,0xffff,0xe2b5,
0xffff,0xffff,0xe2b4,0xffff,0x9493,0x96a5,0xffff,0x8e5a,
0xe2ae,0xe2b7,0xe2b2,0xffff,0xe2b1,0xe2ad,0xfb88,0xe2af,
0xffff,0x8ac7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x925c,0xffff,0xffff,0x90fb,0xffff,0xffff,
0xffff,0x94a0,0xffff,0xffff,0xe2bc,0xffff,0xffff,0xffff,
0x94a2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x90df,0xe2b9,0xffff,0xffff,0x94cd,0xffff,0xe2bd,0x95d1,
0xffff,0x927a,0xffff,0xe2b8,0xe2ba,0xffff,0xffff,0xe2bb,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe2be,0xffff,0xffff,
0x8ec2,0xffff,0xffff,0xffff,0x93c4,0xe2c3,0xe2c2,0xffff,
0xffff,0xe2bf,0xffff,0xffff,0xffff,0x9855,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe2c8,0xffff,0xffff,0xe2cc,0xe2c9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe2c5,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe2c6,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe2cb,0xffff,0xffff,
0xffff,0xe2c0,0x99d3,0xe2c7,0xe2c1,0xffff,0xffff,0xe2ca,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe2d0,
0xffff,0x8ac8,0xffff,0xe2cd,0xffff,0xffff,0xffff,0xe2ce,
0xffff,0xffff,0xe2cf,0xe2d2,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe2d1,
0x94f4,0xffff,0xffff,0xffff,0xffff,0xe2d3,0x97fa,0x95eb,
0xe2d8,0xffff,0xffff,0xe2d5,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe2d4,0x90d0,0xffff,0xe2d7,
0xe2d9,0xffff,0xffff,0xffff,0xe2d6,0xffff,0xe2dd,0xffff,
0xe2da,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe2db,
0xe2c4,0xffff,0xffff,0xffff,0xe2dc,0xe2de,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe2df,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x95c4,0xffff,0xe2e0,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x96e0,0xffff,
0xffff,0x8bcc,0x8c48,0xe2e1,0xffff,0xffff,0xffff,0xffff,
0xffff,0x95b2,0xffff,0x9088,0xffff,0x96ae,0xffff,0xffff,
0xe2e2,0xffff,0x97b1,0xffff,0xffff,0x9494,0xffff,0x9165,
0x9453,0xffff,0xffff,0x8f6c,0xffff,0xffff,0xffff,0x88be,
0xffff,0xe2e7,0xe2e5,0xffff,0xe2e3,0x8a9f,0xffff,0x8fcf,
0xe2e8,0xffff,0xffff,0xe2e6,0xffff,0xe2e4,0xe2ec,0xffff,
0xffff,0xe2eb,0xe2ea,0xe2e9,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe2ed,0xffff,0xffff,0xffff,0xe2ee,0x90b8,0xffff,
0xe2ef,0xffff,0xe2f1,0xffff,0xffff,0xe2f0,0xffff,0xffff,
0xffff,0xffff,0x8cd0,0xffff,0xffff,0xffff,0x9157,0xffff,
0xffff,0xffff,0xe2f3,0xffff,0xffff,0xffff,0x939c,0xffff,
0xe2f2,0xffff,0xffff,0xffff,0xe2f4,0xffff,0x95b3,0x918c,
0x8d66,0xffff,0xe2f5,0xffff,0xffff,0xffff,0xffff,0x97c6,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe2f7,
0xffff,0xffff,0xe2f8,0xffff,0xe2f9,0xffff,0xe2fa,0xffff,
0x8e85,0xffff,0xe2fb,0x8c6e,0xffff,0xffff,0x8b8a,0xffff,
0x8b49,0xffff,0xe340,0xffff,0x96f1,0x8d67,0xe2fc,0xffff,
0xffff,0xffff,0xe343,0x96e4,0xffff,0x945b,0xffff,0xffff,
0x9552,0xffff,0xffff,0xffff,0x8f83,0xe342,0xffff,0x8ed1,
0x8d68,0x8e86,0x8b89,0x95b4,0xe341,0xffff,0xffff,0xffff,
0x9166,0x9661,0x8df5,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8e87,0x92db,0xffff,0xe346,0x97dd,
0x8dd7,0xffff,0xe347,0x9061,0xffff,0xe349,0xffff,0xffff,
0xffff,0x8fd0,0x8dae,0xffff,0xffff,0xffff,0xffff,0xe348,
0xffff,0xffff,0x8f49,0x8cbc,0x9167,0xe344,0xe34a,0xffff,
0xfb8a,0xffff,0xffff,0xe345,0x8c6f,0xffff,0xe34d,0xe351,
0x8c8b,0xffff,0xffff,0xffff,0xffff,0xffff,0xe34c,0xffff,
0xffff,0xffff,0xffff,0xe355,0xfb8b,0xffff,0x8d69,0xffff,
0xffff,0x978d,0x88ba,0xe352,0xffff,0xffff,0x8b8b,0xffff,
0xe34f,0xffff,0xffff,0xffff,0xffff,0xffff,0xe350,0xffff,
0xffff,0x939d,0xe34e,0xe34b,0xffff,0x8a47,0x90e2,0xffff,
0xffff,0x8ca6,0xffff,0xffff,0xffff,0xe357,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe354,0xffff,0xffff,0xffff,0xffff,0xffff,0xe356,
0xffff,0xffff,0xffff,0xe353,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8c70,0x91b1,0xe358,0x918e,0xffff,0xffff,0xe365,
0xfb8d,0xffff,0xe361,0xe35b,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe35f,0x8ef8,0x88db,0xe35a,0xe362,
0xe366,0x8d6a,0x96d4,0xffff,0x92d4,0xe35c,0xffff,0xfb8c,
0xe364,0xffff,0xe359,0x925d,0xffff,0xe35e,0x88bb,0x96c8,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe35d,
0xffff,0xffff,0x8bd9,0x94ea,0xffff,0xffff,0xffff,0x918d,
0xffff,0x97ce,0x8f8f,0xffff,0xffff,0xe38e,0xfb8e,0xffff,
0xe367,0xffff,0x90fc,0xffff,0xe363,0xe368,0xe36a,0xffff,
0x92f7,0xe36d,0xffff,0xffff,0xe369,0xffff,0xffff,0xffff,
0x95d2,0x8ac9,0xffff,0xffff,0x96c9,0xffff,0xffff,0x88dc,
0xffff,0xffff,0xe36c,0xffff,0x97fb,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe36b,0xffff,0xffff,0xffff,0xffff,
0xffff,0x898f,0xffff,0xffff,0x93ea,0xe36e,0xffff,0xffff,
0xffff,0xe375,0xe36f,0xe376,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe372,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x949b,0xffff,0xffff,0x8ec8,0xe374,
0xffff,0xe371,0xe377,0xe370,0xffff,0xffff,0x8f63,0xffff,
0xffff,0xffff,0xffff,0x9644,0xffff,0xffff,0x8f6b,0xffff,
0xffff,0xe373,0xe380,0xffff,0xffff,0xe37b,0xffff,0xe37e,
0xffff,0xe37c,0xe381,0xe37a,0xffff,0xe360,0x90d1,0xffff,
0xffff,0x94c9,0xffff,0xe37d,0xffff,0xffff,0xe378,0xffff,
0xffff,0xffff,0x9140,0x8c71,0xffff,0x8f4a,0xffff,0xffff,
0xffff,0xffff,0xfb8f,0xffff,0x9044,0x9155,0xe384,0xffff,
0xffff,0xe386,0xe387,0xffff,0xffff,0xe383,0xe385,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe379,0xe382,
0xffff,0xe38a,0xe389,0xffff,0xffff,0x969a,0xffff,0xffff,
0x8c4a,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe388,0xffff,0xe38c,0xe38b,0xe38f,0xffff,0xe391,
0xffff,0xffff,0x8e5b,0xe38d,0xffff,0xffff,0xffff,0xffff,
0xe392,0xe393,0xfa5c,0xffff,0xe394,0xffff,0xe39a,0x935a,
0xe396,0xffff,0xe395,0xe397,0xe398,0xffff,0xe399,0xffff,
0xffff,0xffff,0xffff,0xe39b,0xe39c,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8aca,0xffff,
0xe39d,0xffff,0xe39e,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe39f,0xffff,0xfb90,
0xffff,0xffff,0xffff,0xffff,0xe3a0,0xe3a1,0xe3a2,0xffff,
0xe3a3,0xe3a4,0xffff,0xffff,0xe3a6,0xe3a5,0xffff,0xffff,
0xe3a7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe3a8,
0xe3a9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe3ac,
0xe3aa,0xe3ab,0x8ddf,0x8c72,0xffff,0xffff,0x9275,0xffff,
0x94b1,0xffff,0x8f90,0xffff,0xffff,0x946c,0xffff,0x94eb,
0xe3ad,0x9ceb,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe3ae,0xe3b0,0xffff,0x9785,0xe3af,0xe3b2,
0xe3b1,0xffff,0x9772,0xffff,0xe3b3,0xffff,0x94fc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe3b4,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe3b7,0xffff,0xffff,0xe3b6,0xe3b5,0xffff,
0xffff,0xfb91,0xffff,0xe3b8,0x8c51,0xffff,0xffff,0xffff,
0x9141,0x8b60,0xffff,0xffff,0xffff,0xffff,0xe3bc,0xe3b9,
0xffff,0xffff,0xe3ba,0xffff,0xffff,0xffff,0xe3bd,0xffff,
0xe3be,0xe3bb,0xffff,0xffff,0xffff,0x8948,0xffff,0xffff,
0xffff,0x89a5,0xffff,0xffff,0xffff,0xe3c0,0xe3c1,0xffff,
0xffff,0xffff,0xe3c2,0xffff,0x9782,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8f4b,0xffff,0xe3c4,0xe3c3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9089,0xe3c5,0xffff,0xffff,0xffff,0xffff,0xe3c6,0xffff,
0xffff,0xe3c7,0xffff,0x8ae3,0xffff,0xffff,0xffff,0xffff,
0x8acb,0xffff,0xffff,0xe3c8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe3c9,0xffff,0x967c,0x9783,0xffff,0xffff,0xffff,
0x9773,0x9856,0xffff,0x8d6c,0xe3cc,0x8ed2,0xe3cb,0xffff,
0xffff,0xffff,0xffff,0xe3cd,0x8ea7,0xffff,0xffff,0xffff,
0x91cf,0xffff,0xe3ce,0xffff,0xffff,0x8d6b,0xffff,0x96d5,
0xe3cf,0xe3d0,0xffff,0xffff,0xe3d1,0xffff,0xffff,0xffff,
0xffff,0xe3d2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe3d3,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8ea8,0xffff,0xffff,0x96eb,0xffff,
0xffff,0xffff,0xffff,0xe3d5,0xffff,0x925e,0xffff,0xe3d4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe3d7,0xffff,
0xffff,0xffff,0xe3d6,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe3d8,0xffff,0xffff,0xffff,0x90b9,0xffff,
0xe3d9,0xffff,0xe3da,0xffff,0xffff,0xffff,0x95b7,0xe3db,
0xffff,0x918f,0xe3dc,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe3dd,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x97fc,
0xe3e0,0xffff,0xe3df,0xe3de,0x92ae,0xffff,0xe3e1,0x9045,
0xffff,0xe3e2,0xffff,0xffff,0xffff,0xe3e3,0x9857,0xe3e4,
0xffff,0xffff,0xffff,0xffff,0xe3e5,0xe3e7,0xe3e6,0x94a3,
0xffff,0x93f7,0xffff,0x985d,0x94a7,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe3e9,0xffff,0xffff,0x8fd1,0xffff,
0x9549,0xffff,0xe3ea,0xe3e8,0xffff,0x8acc,0xffff,0xffff,
0xffff,0x8cd2,0x8e88,0xffff,0xffff,0x94ec,0xffff,0xffff,
0xffff,0x8ca8,0x9662,0xffff,0xe3ed,0xe3eb,0xffff,0x8d6d,
0xffff,0x8d6e,0x88e7,0xffff,0x8de6,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9478,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x88dd,0xe3f2,0xffff,0x925f,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9477,0xffff,0x91d9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe3f4,0xffff,
0xffff,0xe3f0,0xe3f3,0xe3ee,0xffff,0xe3f1,0x9645,0xffff,
0xffff,0x8cd3,0xffff,0xffff,0x88fb,0xe3ef,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe3f6,
0xffff,0xe3f7,0xffff,0xffff,0x93b7,0xffff,0xffff,0xffff,
0x8bb9,0xffff,0xffff,0xffff,0xe445,0x945c,0xffff,0xffff,
0xffff,0xffff,0x8e89,0xffff,0xffff,0x8bba,0x90c6,0x9865,
0x96ac,0xe3f5,0x90d2,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8b72,0xe3f8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe3fa,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe3f9,0xffff,0xffff,0xffff,0xffff,0xffff,0xe3fb,
0xffff,0x9245,0xffff,0x945d,0xffff,0xffff,0xffff,0xffff,
0xffff,0x92af,0xffff,0xffff,0xffff,0xffff,0xe442,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe441,0xffff,
0xffff,0xffff,0xffff,0xe3fc,0xffff,0xffff,0x9074,0xffff,
0x9585,0xe444,0xffff,0xe443,0x8d6f,0x9872,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe454,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe448,0xe449,0xffff,
0xffff,0xffff,0xffff,0x8eee,0xffff,0xffff,0xe447,0xffff,
0x8d98,0xe446,0xffff,0xffff,0xe44a,0xffff,0xffff,0xffff,
0x92b0,0x95a0,0x9142,0xffff,0xffff,0xffff,0xffff,0x91da,
0xe44e,0xffff,0xe44f,0xe44b,0xffff,0xffff,0xffff,0xffff,
0xe44c,0xffff,0xe44d,0xffff,0xffff,0xffff,0xffff,0x8d70,
0xffff,0xffff,0xffff,0xe455,0xffff,0xe451,0xffff,0xffff,
0xffff,0xffff,0x9586,0xffff,0x968c,0x9547,0xffff,0xffff,
0xe450,0xffff,0xffff,0xe453,0xe452,0xffff,0xffff,0xffff,
0x9663,0xe456,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe457,0xffff,0xffff,0x9156,0xffff,0xe458,0xffff,0xffff,
0xe45a,0xffff,0xe45e,0xffff,0xffff,0xe45b,0xe459,0x945e,
0xe45c,0xffff,0xe45d,0xffff,0xffff,0xffff,0x89b0,0xffff,
0xe464,0xe45f,0xffff,0xffff,0xffff,0xe460,0xffff,0xffff,
0xffff,0xe461,0xffff,0x919f,0xffff,0xffff,0xffff,0xffff,
0xe463,0xe462,0xe465,0xffff,0xffff,0xffff,0xffff,0xe466,
0xe467,0xffff,0xffff,0x9062,0xffff,0x89e7,0xffff,0xe468,
0x97d5,0xffff,0x8ea9,0xffff,0xffff,0x8f4c,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8e8a,0x9276,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe469,0xe46a,0x8950,0xffff,0xe46b,0xffff,
0xffff,0xe46c,0xe46d,0xffff,0xffff,0xe46e,0xffff,0xe46f,
0x8bbb,0x9da8,0xe470,0xffff,0x90e3,0xe471,0x8ec9,0xffff,
0xe472,0xffff,0x98ae,0xffff,0xffff,0xffff,0xe473,0x95dc,
0x8ada,0xffff,0xffff,0x9143,0x8f77,0xffff,0x9591,0x8f4d,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe474,0x8d71,0xe475,0x94ca,0xffff,0xe484,0xffff,
0xffff,0xffff,0xffff,0xe477,0xffff,0x91c7,0x9495,0x8cbd,
0xe476,0x9144,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe478,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x92f8,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe47a,0xe479,0xe47c,0xffff,0xffff,0xe47b,0xffff,0xe47d,
0xffff,0xffff,0xe480,0xffff,0xe47e,0xffff,0x8acd,0xffff,
0xe481,0xffff,0xe482,0xe483,0xffff,0xffff,0x8daf,0x97c7,
0xffff,0xe485,0x9046,0xffff,0xffff,0xffff,0x8990,0xe486,
0xe487,0xffff,0xffff,0xffff,0xffff,0xffff,0xe488,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x88f0,0xffff,0xe489,0xffff,0xffff,
0xffff,0xffff,0xe48a,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9587,0xffff,0xffff,0xffff,0x8ec5,0xffff,0xe48c,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8a48,0x88b0,0xffff,
0xffff,0xffff,0xffff,0xe48b,0xe48e,0x946d,0xffff,0x9063,
0xffff,0x89d4,0xffff,0x9646,0xffff,0xffff,0xffff,0xffff,
0x8c7c,0x8bda,0xffff,0xe48d,0xffff,0x89e8,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8aa1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8991,0xe492,0x97e8,0x91db,0xffff,0xffff,0x9563,
0xffff,0xe49e,0xffff,0x89d5,0xe49c,0xffff,0xe49a,0xe491,
0xffff,0xe48f,0xffff,0xe490,0xffff,0x8ee1,0x8bea,0x9297,
0xffff,0xffff,0xffff,0x93cf,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8970,0xffff,0xe494,0xe493,0xffff,0xffff,0xffff,
0xffff,0xe499,0xe495,0xe498,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfb93,0x96ce,0xe497,0x89d6,0x8a9d,0xe49b,0xffff,
0xffff,0xe49d,0xffff,0xffff,0xffff,0xffff,0x8c73,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe4a1,0xe4aa,
0xe4ab,0xffff,0xffff,0xffff,0x88a9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe4b2,0xffff,0xffff,0xffff,0xffff,
0x88ef,0xffff,0xffff,0xe4a9,0xffff,0xffff,0xffff,0xe4a8,
0xffff,0xe4a3,0xe4a2,0xffff,0xe4a0,0xe49f,0x9283,0xffff,
0x91f9,0xe4a5,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe4a4,0xffff,0xffff,0xffff,0xffff,0xe4a7,0xffff,0xffff,
0xffff,0x9190,0x8c74,0xffff,0xffff,0xffff,0xffff,0x8960,
0xe4a6,0xffff,0x8d72,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9191,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xfb94,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe4b8,0xffff,0xe4b9,0xffff,0x89d7,
0xffff,0xffff,0xffff,0x89ac,0xe4b6,0xffff,0xffff,0xfb95,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe4ac,0xffff,0xe4b4,
0xffff,0xe4bb,0xe4b5,0xffff,0xffff,0xffff,0xe4b3,0xffff,
0xffff,0xffff,0xffff,0xe496,0xffff,0xffff,0xe4b1,0xffff,
0xffff,0xffff,0xe4ad,0xffff,0xffff,0xffff,0x8ace,0xe4af,
0xe4ba,0xffff,0xe4b0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe4bc,0xffff,0xe4ae,0x949c,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9789,0xffff,0xffff,0xffff,0xe4b7,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe4cd,0xffff,0xffff,
0xffff,0xe4c5,0xffff,0xffff,0xffff,0x909b,0xffff,0xfb96,
0xffff,0xffff,0x8b65,0xffff,0x8bdb,0xffff,0xe4c0,0xffff,
0xffff,0xffff,0xffff,0x89d9,0xffff,0xffff,0x8fd2,0xffff,
0xe4c3,0xffff,0xffff,0xffff,0x8dd8,0xffff,0xffff,0x9370,
0xe4c8,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x95ec,0xffff,0xe4bf,0xffff,0xffff,0xffff,0x89d8,
0x8cd4,0x9548,0xe4c9,0xffff,0xe4bd,0xffff,0xfb97,0xe4c6,
0xffff,0xffff,0xffff,0xe4d0,0xffff,0xe4c1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe4c2,0x93b8,0xffff,0xffff,0xe4c7,
0xffff,0xffff,0xffff,0xe4c4,0x9647,0xe4ca,0x88de,0xffff,
0xffff,0xffff,0xffff,0xe4be,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe4cc,0xffff,0xe4cb,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x948b,0xe4d2,0xffff,0xe4dd,0xffff,0xffff,0xffff,
0xffff,0x8a9e,0xffff,0xffff,0xffff,0xe4e0,0xffff,0xffff,
0xe4ce,0xffff,0xffff,0xffff,0xe4d3,0x978e,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe4dc,0xffff,
0xfb98,0x9774,0xffff,0xffff,0xffff,0xffff,0x97a8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9298,
0xffff,0xffff,0xffff,0x8a8b,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9592,0xe4e2,0x939f,0xffff,0xffff,0x88af,0xffff,
0xffff,0xe4db,0xffff,0xe4d7,0x9192,0xe4d1,0xe4d9,0xe4de,
0xffff,0x944b,0xffff,0xffff,0xffff,0x88a8,0xffff,0xe4d6,
0xffff,0xe4df,0x9598,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe4da,0xffff,0xe4d5,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8fd3,0xffff,0xffff,0xffff,0xffff,
0x8f4e,0xffff,0xffff,0xffff,0x8eaa,0xffff,0xffff,0xffff,
0xffff,0x96d6,0xffff,0xffff,0x9566,0xffff,0xffff,0xe4e5,
0xffff,0xe4ee,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe4d8,0xffff,0xffff,
0xffff,0xffff,0x8a97,0xffff,0xfb99,0xffff,0xffff,0xffff,
0x8ff6,0xe4e3,0xffff,0xe4e8,0x9193,0xffff,0xffff,0xe4e4,
0xffff,0xe4eb,0xffff,0xffff,0x927e,0xffff,0xe4ec,0xffff,
0xffff,0x9775,0xe4e1,0x8a57,0xffff,0xe4e7,0xffff,0xffff,
0xe4ea,0x96aa,0xffff,0xffff,0xffff,0xffff,0xe4ed,0xffff,
0xffff,0xe4e6,0xe4e9,0xffff,0xfa60,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x9648,0xffff,0x9840,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe4f1,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe4f8,0xffff,0xffff,0xe4f0,
0x8ec1,0xffff,0xffff,0xffff,0xffff,0xffff,0xe4cf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x95cc,0xffff,0x96a0,0xe4f7,0xe4f6,0xffff,0xe4f2,
0xe4f3,0xffff,0x8955,0xffff,0xffff,0xffff,0xffff,0xe4f5,
0xffff,0xe4ef,0xffff,0xffff,0xffff,0xffff,0x92d3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe4f4,0x88fc,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x91a0,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x95c1,0xffff,0xffff,
0xe4f9,0xe540,0xffff,0x94d7,0xffff,0xffff,0xffff,0xffff,
0xe4fc,0x8fd4,0x8ec7,0xe542,0xffff,0xffff,0x8bbc,0xffff,
0xffff,0xffff,0xffff,0xfb9a,0xffff,0xe543,0xffff,0x9599,
0xe4fb,0xfb9b,0xe4d4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe4fa,0xffff,0xffff,0xffff,0xffff,
0x986e,0x93a0,0x9593,0xfb9c,0xffff,0xe54a,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe550,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe551,0xffff,
0xe544,0xffff,0xffff,0xffff,0x9496,0xffff,0xffff,0xe54e,
0xe546,0xffff,0xe548,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe552,0xe547,0xffff,0xffff,0xe54b,0xffff,0xffff,0x8992,
0xffff,0x93e3,0xffff,0xe54c,0xe54f,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe545,0xffff,0x9145,0xffff,
0xe549,0x8e46,0x9064,0x8c4f,0x96f2,0xffff,0x96f7,0x8f92,
0xfb9e,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe556,0xe554,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x986d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe553,0xffff,0xffff,0xffff,0x9795,0xffff,0xe555,
0xe557,0xffff,0xffff,0xffff,0xffff,0xe558,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe55b,0xe559,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x93a1,0xe55a,0xffff,0xffff,
0xffff,0x94cb,0xe54d,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8f93,
0xffff,0xe55c,0xe561,0x9194,0xffff,0xffff,0xe560,0xffff,
0xffff,0xffff,0xe541,0xffff,0xffff,0xffff,0xe562,0x9168,
0xffff,0xffff,0xe55d,0xe55f,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe55e,0xffff,0xffff,0x9f50,0x9f41,
0xffff,0xffff,0xe564,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe563,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9796,0xffff,0xe1ba,
0xe565,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe566,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe567,0x8cd5,0xffff,
0x8b73,0xffff,0xffff,0xffff,0xe569,0x997c,0xffff,0xffff,
0xffff,0xffff,0x8b95,0xffff,0x97b8,0xffff,0x8bf1,0xe56a,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe56b,
0xffff,0xffff,0xffff,0x928e,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe56c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x93f8,0xffff,0x88b8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x89e1,0xe571,0xe572,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe56d,0xffff,0x8e5c,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe56e,0x9461,0xffff,0xffff,0xffff,
0xffff,0xe56f,0xe570,0xe57a,0xffff,0xffff,0xffff,0xe574,
0xe577,0xffff,0xffff,0xffff,0xffff,0xffff,0xe573,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe575,0xffff,0xe576,0x8ed6,
0xffff,0xe578,0xffff,0x9260,0xffff,0x8c75,0x8a61,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe57b,0xffff,0xffff,0xffff,
0xffff,0x8a5e,0xffff,0xe581,0xffff,0xffff,0xe57c,0xe580,
0xffff,0xffff,0xffff,0xffff,0x94b8,0xffff,0xffff,0xffff,
0xffff,0xe57d,0xffff,0xffff,0xe57e,0x9567,0x94d8,0xe582,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x91fb,0xe58c,0xffff,0xe588,0xffff,0xffff,0x89e9,0xffff,
0xe586,0xffff,0x9649,0xe587,0xffff,0xffff,0xe584,0xffff,
0xe585,0xe58a,0xe58d,0xffff,0xffff,0xe58b,0xffff,0xffff,
0xffff,0xe589,0xe583,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9277,0xffff,0xe594,0xffff,0x96a8,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe592,0xffff,0xffff,
0xffff,0xe593,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe58e,0xffff,0xffff,0xe590,
0xffff,0xffff,0xffff,0xe591,0xffff,0xffff,0xffff,0xe58f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x90e4,0xffff,0x9858,0xe598,0xffff,0xe599,0xffff,
0xffff,0xffff,0xffff,0xe59f,0xffff,0x9049,0xffff,0xe59b,
0xffff,0xe59e,0xffff,0xffff,0xffff,0xffff,0xffff,0xe596,
0xe595,0xffff,0xffff,0xe5a0,0xffff,0xffff,0x89da,0xffff,
0xe59c,0xffff,0xe5a1,0xffff,0xffff,0xffff,0xe59d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe59a,0xffff,0x92b1,0xffff,
0xe597,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9488,
0xffff,0xffff,0xe5a5,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x975a,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe5a4,
0xffff,0xffff,0xe5a3,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe5ac,0xffff,0xffff,0xffff,0xe5a6,
0xffff,0xffff,0xffff,0xe5ae,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9786,0xe5b1,0xffff,0xe5a8,0xffff,0xffff,
0xe5a9,0xffff,0xffff,0xffff,0xe5ad,0xffff,0xe5b0,0xe5af,
0xffff,0xffff,0xffff,0xe5a7,0xffff,0xffff,0xffff,0xffff,
0xe5aa,0xffff,0xe5bb,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe5b4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe5b2,
0xffff,0xffff,0xe5b3,0xffff,0xffff,0xffff,0xe5b8,0xe5b9,
0xffff,0x8a49,0xffff,0x8b61,0xffff,0xffff,0xe5b7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe5a2,0xffff,0xfba1,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe5b6,0xe5ba,0xe5b5,
0xffff,0xe5bc,0xffff,0xffff,0xffff,0xe5be,0xe5bd,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe5c0,0xe5bf,0xe579,0xffff,0xffff,0xffff,0xe5c4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe5c1,0xffff,0xffff,0xffff,0xffff,0xe5c2,0xffff,
0xffff,0xe5c3,0xffff,0xe5c5,0xffff,0xffff,0xffff,0xffff,
0x8c8c,0xffff,0xe5c7,0xffff,0xe5c6,0xffff,0x8f4f,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8d73,0x9fa5,0xffff,0xffff,
0xffff,0xffff,0xe5c8,0x8f70,0xffff,0xffff,0xffff,0x8a58,
0xffff,0xe5c9,0xffff,0x8971,0xffff,0x8fd5,0xe5ca,0xffff,
0xffff,0x8d74,0xe5cb,0x88df,0xffff,0xffff,0xffff,0xffff,
0x955c,0xffff,0xffff,0xe5cc,0xffff,0xffff,0xffff,0xffff,
0x908a,0xffff,0xe5d3,0xffff,0xffff,0xe5d0,0xffff,0x928f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe5d1,0xe5ce,0x8bdc,
0xffff,0xe5cd,0xe5d4,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8c55,0xffff,0xffff,0x91dc,0xffff,0xe5da,0xffff,0xffff,
0xffff,0xffff,0xe5d6,0xffff,0xffff,0xffff,0x91b3,0xe5d5,
0xffff,0xe5d8,0xffff,0xffff,0xffff,0xffff,0xe5cf,0xffff,
0xffff,0xffff,0xe5d9,0xffff,0xe5db,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x94ed,0xffff,0xffff,0xe5d7,0xffff,
0xe5dc,0xe5de,0xffff,0xffff,0x8cd1,0xe5d2,0xffff,0x88bf,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe5dd,
0xffff,0x8dd9,0x97f4,0xe5df,0xe5e0,0x9195,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x97a0,
0xffff,0xffff,0xffff,0xffff,0xe5e1,0x9754,0xffff,0xffff,
0xe5e2,0xe5e3,0xffff,0xffff,0x95e2,0xe5e4,0xffff,0x8dbe,
0xffff,0x97a1,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe5e9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe5ea,0x8fd6,0xe5e8,0xfba2,0xffff,0xffff,
0x9787,0xe5e5,0xffff,0xffff,0xe5e7,0x90bb,0x909e,0xffff,
0xffff,0xffff,0xe5e6,0xffff,0xe5eb,0xffff,0xffff,0x95a1,
0xffff,0xffff,0xe5ed,0xffff,0xe5ec,0xffff,0xffff,0xffff,
0x8a8c,0xffff,0x964a,0xe5ee,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfa5d,0xe5fa,0xe5f0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe5f1,0xffff,0xffff,
0xffff,0xffff,0xe5f2,0xe5f3,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe5f7,0xffff,
0xe5f8,0xffff,0xffff,0xe5f6,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe5f4,0xffff,0xe5ef,0xe5f5,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe5f9,0xe8b5,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x89a6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe5fc,0x8bdd,
0xe5fb,0xffff,0xffff,0xffff,0xe641,0xffff,0xe640,0xffff,
0xffff,0xffff,0xe643,0xffff,0xffff,0xe642,0xffff,0xe644,
0xffff,0xffff,0x8f50,0xffff,0xe645,0xffff,0xffff,0xe646,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe647,0x90bc,
0xffff,0x9776,0xffff,0xe648,0xffff,0xffff,0x95a2,0x9465,
0xe649,0xffff,0xe64a,0x8ca9,0xffff,0xffff,0xffff,0x8b4b,
0xffff,0xffff,0xffff,0xe64b,0xffff,0xffff,0x8e8b,0x9460,
0xe64c,0xffff,0x8a6f,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe64d,0xffff,0xffff,0xffff,0xffff,0xe64f,0x9797,
0xffff,0xe64e,0x9065,0xffff,0xe650,0xffff,0xffff,0xe651,
0xffff,0xffff,0xe652,0x8acf,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe653,0xffff,0xffff,0xe654,0xffff,0xe655,
0xe656,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8a70,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe657,0xffff,0xe658,0xe659,0xffff,0xffff,
0xffff,0xffff,0xffff,0x89f0,0xffff,0xffff,0x9047,0xe65a,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe65b,0xffff,0xffff,0xffff,
0xe65c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8cbe,0xffff,0x92f9,0xe65d,0xffff,0xffff,0xffff,0xffff,
0x8c76,0xffff,0x9075,0xffff,0xe660,0xffff,0x93a2,0xffff,
0xe65f,0xffff,0xfba3,0x8c50,0xffff,0xffff,0xe65e,0x91f5,
0x8b4c,0xffff,0xffff,0xe661,0xffff,0xe662,0xffff,0x8fd7,
0xffff,0xffff,0xffff,0x8c8d,0xffff,0xe663,0xffff,0xffff,
0xffff,0xffff,0x964b,0xffff,0xffff,0x90dd,0xffff,0xffff,
0xffff,0x8b96,0xffff,0x96f3,0x9169,0xffff,0xe664,0xfba4,
0xffff,0xffff,0x9066,0x9290,0x8fd8,0xffff,0xffff,0xffff,
0xffff,0xe665,0xffff,0xffff,0xffff,0xffff,0xe668,0xffff,
0xe669,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8dbc,0x91c0,0xe667,0xffff,0x8fd9,0x955d,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe666,0xffff,0xffff,0x8e8c,0xffff,
0x8972,0xffff,0xe66d,0x8c77,0xffff,0xffff,0x8e8e,0xffff,
0xffff,0x8e8d,0xffff,0x986c,0xe66c,0xe66b,0x9146,0xffff,
0x8b6c,0x9862,0x8a59,0x8fda,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfba5,0xffff,0xffff,0xe66a,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe66f,0xffff,0xe670,0xe66e,0xffff,0x8cd6,
0xffff,0x975f,0xffff,0xffff,0x8e8f,0x9446,0xffff,0xffff,
0xffff,0xe673,0xffff,0x90be,0xffff,0x9261,0xffff,0xffff,
0x9755,0xffff,0xe676,0xffff,0xffff,0xffff,0x8cea,0xffff,
0x90bd,0xe672,0xffff,0xe677,0x8ceb,0xe674,0xe675,0xfba6,
0xe671,0xffff,0xffff,0xffff,0x90e0,0x93c7,0xffff,0xffff,
0x924e,0xffff,0x89db,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x94ee,0xffff,0xffff,0x8b62,0xffff,0xfba7,0x92b2,
0xffff,0xffff,0xe67a,0xffff,0xe678,0xffff,0xffff,0x926b,
0xffff,0xffff,0xffff,0x90bf,0x8ad0,0xe679,0xffff,0x907a,
0xffff,0xffff,0x97c8,0xffff,0xffff,0xffff,0x985f,0xffff,
0xffff,0xffff,0xe67b,0xe687,0x92b3,0xffff,0xe686,0xfba8,
0xe683,0xe68b,0xe684,0xffff,0xe680,0xffff,0x92fa,0xe67e,
0xffff,0xffff,0xffff,0xe67c,0xffff,0x9740,0x8e90,0xffff,
0xffff,0xe681,0xffff,0xe67d,0xffff,0xffff,0xfbaa,0xe685,
0x8f94,0xffff,0x8cbf,0xffff,0xffff,0xffff,0x91f8,0xffff,
0x9664,0x8979,0x88e0,0xffff,0x93a3,0xffff,0xffff,0xe689,
0xffff,0xffff,0xffff,0xffff,0xe688,0xffff,0x93e4,0xffff,
0xe68d,0xffff,0xffff,0xffff,0xe682,0xffff,0xe68c,0xe68e,
0xffff,0x8caa,0xe68a,0x8d75,0xffff,0x8ed3,0xffff,0xffff,
0xe68f,0x9777,0xffff,0xffff,0xffff,0xffff,0xe692,0xffff,
0xe695,0xffff,0xffff,0xe693,0x9554,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe690,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8bde,0xffff,0xffff,0xffff,0xffff,0xe694,0xffff,
0xffff,0xe696,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe69a,0xffff,0xffff,0xe697,0xffff,0xe699,0xe698,
0xffff,0xffff,0xffff,0xfbab,0xffff,0xffff,0xe69b,0xffff,
0x8eaf,0xffff,0xe69d,0xe69c,0x9588,0xffff,0xffff,0xe69f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8c78,0xffff,
0xffff,0xffff,0xffff,0xe69e,0xe6a0,0xffff,0xffff,0xe6a1,
0x8b63,0xe3bf,0x8ff7,0xffff,0xe6a2,0xffff,0xffff,0x8cec,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe6a3,0xffff,0xfbac,
0xe6a4,0xffff,0xffff,0x8e5d,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9dcc,0xffff,0xe6a5,0xffff,0xe6a6,0xffff,
0x8f51,0xffff,0xe6a7,0xe6a8,0xffff,0xffff,0xe6a9,0xffff,
0xffff,0xe6aa,0xe6ab,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x924a,
0xffff,0xffff,0xe6ac,0xffff,0xffff,0xffff,0xffff,0xe6ae,
0xffff,0xe6ad,0xffff,0xffff,0xffff,0xffff,0x93a4,0xffff,
0xe6af,0xffff,0x964c,0xffff,0xe6b0,0xffff,0xe6b1,0xffff,
0xe6b2,0xffff,0xffff,0xffff,0xffff,0xe6b3,0xffff,0xffff,
0xffff,0xffff,0x93d8,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8fdb,0xe6b4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8d8b,0x98ac,0xe6b5,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe6b6,0x955e,0xe6b7,0xffff,0xe6bf,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe6b8,0xffff,0xffff,0xe6ba,0xffff,0xffff,
0xffff,0xe6b9,0xe6bb,0xffff,0x9665,0xe6bc,0xe6bd,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe6be,0xffff,0xffff,0xffff,
0xe6c0,0xffff,0xffff,0xffff,0xffff,0x8a4c,0x92e5,0xffff,
0x9589,0x8de0,0x8d76,0xffff,0xffff,0xffff,0xffff,0x956e,
0x89dd,0x94cc,0xe6c3,0x8ad1,0x90d3,0xe6c2,0xe6c7,0x9299,
0x96e1,0xffff,0xe6c5,0xe6c6,0x8b4d,0xffff,0xe6c8,0x9483,
0x91dd,0xffff,0xffff,0x94ef,0x935c,0xe6c4,0xffff,0x9666,
0x89ea,0xe6ca,0x9847,0x92c0,0x9864,0xffff,0xffff,0x8e91,
0xe6c9,0xffff,0x91af,0xffff,0xffff,0xe6da,0x9147,0xffff,
0xffff,0x93f6,0xffff,0x956f,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe6cd,0x8e5e,0x8e92,0xffff,0x8fdc,0xffff,
0x9485,0xffff,0x8cab,0xe6cc,0xe6cb,0xffff,0x958a,0xffff,
0xffff,0xffff,0x8ebf,0xffff,0xffff,0x9371,0xffff,0xffff,
0xfbad,0xffff,0xffff,0xffff,0xfbae,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe6cf,0xe6d0,0x8d77,0xe6ce,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe6d1,0xe6d2,0xffff,0xe6d4,
0x91a1,0xffff,0xe6d3,0x8ae4,0xffff,0xe6d6,0xffff,0xe6d5,
0xe6d7,0xffff,0xfbaf,0xe6d9,0xe6db,0xffff,0xe6dc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x90d4,0xffff,0x8ecd,0xe6dd,
0xffff,0xffff,0xffff,0x8a71,0xffff,0xe6de,0xffff,0xffff,
0x9196,0xe6df,0xffff,0xe6e0,0x958b,0xffff,0xfbb0,0x8b4e,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe6e1,0xffff,0xffff,0xffff,0x92b4,0xffff,0xffff,
0xffff,0xffff,0x897a,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe6e2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8eef,0xffff,0xffff,0xffff,0xffff,
0x9096,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x91ab,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe6e5,0xffff,0xffff,0xffff,0xe6e4,0xffff,
0xffff,0xffff,0xe6e3,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe6eb,0xe6e9,0xffff,0xffff,0xe6e6,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe6e8,0xffff,
0xffff,0xffff,0xe6e7,0xe6ea,0xffff,0x8b97,0xffff,0xe6ee,
0xffff,0x90d5,0xffff,0xe6ef,0xffff,0xffff,0xffff,0xffff,
0x8cd7,0xffff,0xe6ec,0xe6ed,0xffff,0xffff,0xffff,0x9848,
0xffff,0xffff,0xffff,0x92b5,0xffff,0x9148,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe6f0,0xffff,0xffff,0xe6f3,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe6f1,0xe6f2,0x9778,0xffff,0xffff,0xffff,0xffff,0x93a5,
0xe6f6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe6f4,0xe6f5,0xe6f7,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe748,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe6fa,0xffff,0xffff,0xffff,0xe6fb,0xe6f9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe6f8,0xffff,0x92fb,0xffff,0xffff,0xe740,
0xe744,0xe741,0xe6fc,0xffff,0xe742,0xffff,0xffff,0xffff,
0xe743,0xffff,0xffff,0xffff,0xffff,0xe74a,0xffff,0xffff,
0xffff,0xe745,0xffff,0xffff,0xffff,0xffff,0xffff,0x90d6,
0xe747,0xffff,0xffff,0xe749,0xe746,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe74c,0xffff,0x8f52,0xffff,0xe74b,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe74d,0xffff,0xffff,0xffff,
0xffff,0xe74e,0xffff,0xffff,0xe751,0xe750,0xffff,0xe74f,
0xffff,0xffff,0xe753,0xe752,0xffff,0x96f4,0xffff,0xffff,
0xffff,0xe755,0xffff,0xe754,0xe756,0xffff,0xffff,0xffff,
0xffff,0xe757,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe759,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe758,0x9067,0xe75a,0xffff,0xffff,0x8beb,
0xe75b,0xe75d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe75e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe75f,0xe75c,0xffff,
0xe760,0xffff,0x8ed4,0xe761,0x8b4f,0x8c52,0xffff,0xfbb2,
0xffff,0xffff,0x8cac,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe762,0xffff,0xffff,0xffff,0x93ee,
0xffff,0xffff,0x935d,0xe763,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe766,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8eb2,0xffff,0xffff,0xe765,0xe764,0x8c79,0xe767,0xffff,
0xffff,0xffff,0xffff,0x8a72,0xffff,0xe769,0xffff,0xffff,
0xffff,0x8dda,0xe768,0xffff,0xe771,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe76b,0xe76d,0x95e3,0xe76a,0xffff,0xffff,
0xffff,0xe76c,0xffff,0xe770,0xe76e,0x8b50,0xffff,0xe76f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe772,0xffff,
0xffff,0x9479,0x97d6,0xffff,0xffff,0xffff,0xffff,0x8f53,
0xffff,0xffff,0xffff,0xe773,0xffff,0xffff,0xffff,0xffff,
0x9741,0xe775,0xffff,0xe774,0xffff,0xffff,0xe778,0x9760,
0xffff,0xffff,0xe777,0xffff,0x8a8d,0xe776,0xe77b,0xffff,
0xffff,0xe77a,0xffff,0xffff,0xe779,0x9351,0xe77c,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe77d,
0xffff,0xffff,0xffff,0xffff,0xe77e,0xffff,0xffff,0x8d8c,
0xffff,0x8c44,0xe780,0xe781,0xe782,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9068,0xe783,0xffff,0x8eab,0xe784,
0xffff,0xffff,0xffff,0xe785,0xffff,0xffff,0xffff,0x999f,
0x999e,0xffff,0xffff,0xffff,0xffff,0xe786,0xe390,0xe787,
0x9243,0x904a,0x945f,0xffff,0xffff,0xffff,0xffff,0xe788,
0xffff,0xffff,0x95d3,0x92d2,0x8d9e,0xffff,0xffff,0x9248,
0xffff,0xffff,0x8949,0xffff,0x9698,0x9076,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8c7d,0xffff,
0xffff,0x8bdf,0xffff,0xffff,0x95d4,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe789,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe78b,0xffff,0xffff,0xe78a,0x89de,0xffff,
0xffff,0x93f4,0xe78c,0x9497,0xffff,0x9352,0xffff,0xe78d,
0x8f71,0xffff,0xffff,0xffff,0xe78f,0xffff,0xffff,0x96c0,
0xe79e,0xe791,0xe792,0xffff,0xffff,0x92c7,0xffff,0xffff,
0x91de,0x9197,0xffff,0x93a6,0xffff,0xe790,0x8b74,0xffff,
0xffff,0xffff,0xffff,0xe799,0xffff,0xe796,0xe7a3,0x93a7,
0x9280,0xe793,0xffff,0x92fc,0x9372,0xe794,0xe798,0x9080,
0xffff,0x9487,0x92ca,0xffff,0xffff,0x90c0,0xe797,0x91ac,
0x91a2,0xe795,0x88a7,0x9841,0xffff,0xffff,0xffff,0xe79a,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x91df,0xffff,
0xffff,0x8f54,0x9069,0xffff,0xffff,0xe79c,0xe79b,0xffff,
0x88ed,0xe79d,0xffff,0xffff,0x954e,0xffff,0xe7a5,0xffff,
0xffff,0x93d9,0x908b,0xffff,0xffff,0x9278,0xffff,0x8bf6,
0xffff,0xe7a4,0x9756,0x895e,0xffff,0x95d5,0x89df,0xe79f,
0xe7a0,0xe7a1,0xe7a2,0x93b9,0x9242,0x88e1,0xe7a6,0xffff,
0xe7a7,0xeaa1,0xffff,0xffff,0x91bb,0xffff,0xe7a8,0xffff,
0x8993,0x916b,0xffff,0x8cad,0xffff,0x9779,0xffff,0xfbb5,
0xe7a9,0x934b,0xffff,0xffff,0xffff,0x9198,0x8ed5,0xe7aa,
0xffff,0xffff,0xe7ad,0xffff,0xffff,0x8f85,0xe7ab,0x914a,
0x9149,0xffff,0x88e2,0xffff,0x97c9,0xe7af,0xffff,0x94f0,
0xe7b1,0xe7b0,0xe7ae,0xe284,0x8ad2,0xffff,0xffff,0xe78e,
0xffff,0xe7b3,0xe7b2,0xffff,0xffff,0xffff,0xffff,0xe7b4,
0xffff,0x9757,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x93df,0xffff,0xffff,0x964d,0xffff,
0xe7b5,0xffff,0x8ed7,0xffff,0xffff,0xffff,0xffff,0xe7b6,
0xffff,0xe7b7,0xffff,0xffff,0xffff,0xe7b8,0xffff,0xffff,
0x9340,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x88e8,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x8d78,0xffff,0xffff,0xffff,0x9859,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe7bc,0xffff,0xffff,0xfbb6,0xffff,
0xffff,0x8c53,0xe7b9,0xffff,0xe7ba,0xffff,0xffff,0xffff,
0x9594,0xffff,0xffff,0xffff,0xffff,0x8a73,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9758,0xffff,0x8bbd,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9373,0xffff,0xffff,
0xffff,0xffff,0xe7bd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe7be,0xffff,0xffff,0xfbb8,0xffff,0xffff,
0xffff,0xe7bf,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfbb9,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9341,0xffff,0xffff,
0xe7c1,0xffff,0xe7c0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x93d1,0xe7c2,0x8f55,0x8ede,0x947a,0x9291,0xffff,
0xffff,0xffff,0x8ef0,0xffff,0x908c,0xffff,0xe7c3,0xffff,
0xe7c4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x907c,0xe7c5,0xffff,0xe7c6,0xffff,0xffff,
0xffff,0xe7c7,0x978f,0xffff,0x8f56,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe7c9,0xe7c8,0xffff,0x8d79,0xffff,0x8d93,
0x8e5f,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe7cc,0xffff,0xffff,0xffff,0xffff,0x8f86,
0xffff,0xe7cb,0xffff,0xe7ca,0xffff,0x91e7,0xffff,0xffff,
0x8ced,0xffff,0x90c1,0xffff,0xffff,0xffff,0xffff,0x94ae,
0xffff,0xffff,0xffff,0xffff,0x8f58,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe7cd,0xffff,0x8fdd,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe7d0,0xe7ce,0xffff,0xffff,0xffff,0xe7cf,
0xffff,0xffff,0xffff,0xffff,0xe7d2,0xe7d1,0xffff,0xffff,
0x8ff8,0xffff,0xe7d3,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe7d4,0xe7d5,0xffff,0xffff,0xffff,0xffff,0x94ce,0x8dd1,
0x8edf,0xe7d6,0xffff,0xe7d7,0x97a2,0x8f64,0x96ec,0x97ca,
0xe7d8,0x8be0,0xffff,0xffff,0xffff,0xffff,0xe7d9,0xfbbb,
0x9342,0xffff,0xfbba,0xe7dc,0x8a98,0x906a,0xfbbc,0xe7da,
0xffff,0xe7db,0xffff,0x92de,0xfbbf,0xfbc0,0x9674,0x8bfa,
0xffff,0xffff,0xffff,0xffff,0xffff,0xfbbd,0xfbbe,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe7de,0xe7df,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe7dd,0xffff,0xffff,0xe7e1,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfbc1,0xffff,
0xffff,0xffff,0xfbc3,0xffff,0xffff,0x93dd,0x8a62,0xffff,
0xfbc2,0xe7e5,0xffff,0xffff,0xe7e2,0xe7e4,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe7e0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe86e,0xffff,0xffff,0xe7e3,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x97e9,0xffff,0xffff,0x8cd8,
0xffff,0xfbca,0xfbc4,0xffff,0xfbc6,0xffff,0xffff,0xe7ed,
0xfbc5,0xffff,0xffff,0xffff,0x9353,0xe7e8,0xffff,0xffff,
0xe7eb,0xe7e9,0xffff,0xe7ee,0xffff,0xffff,0xfbc7,0xffff,
0xe7ef,0xfbc9,0xffff,0xffff,0xffff,0xffff,0xffff,0xe7e7,
0xffff,0xfbc8,0xe7f4,0x8994,0xffff,0xffff,0xe7e6,0xffff,
0xffff,0xffff,0x94ab,0xffff,0xe7ea,0xffff,0x8fde,0xfbcb,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8d7a,0xffff,0xffff,0xffff,0xffff,0xffff,0xfbcd,
0xfbce,0xffff,0xffff,0xffff,0xffff,0xffff,0x9667,0xffff,
0x8be2,0xffff,0xffff,0x8f65,0xffff,0x93ba,0xffff,0xffff,
0xfa5f,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x914c,0xffff,0xe7f2,0xffff,0xe7ec,0xe7f1,0xffff,
0x96c1,0xffff,0x92b6,0xe7f3,0xe7f0,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfbcc,
0xffff,0xffff,0xffff,0xffff,0xffff,0x914b,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe7f7,
0xffff,0xe7f6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe7f5,
0xfbd2,0xffff,0x964e,0xfbd6,0xffff,0xfbd4,0xffff,0xfbd0,
0xffff,0xfbd1,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xfbd5,0xffff,0xffff,0xffff,0x8f9b,0xffff,0xffff,0xfbcf,
0xffff,0xe7f8,0x95dd,0xffff,0xffff,0x8973,0xffff,0xffff,
0xffff,0xffff,0x9565,0x9292,0xffff,0xffff,0xffff,0xffff,
0x8b98,0xfa65,0xe7fa,0xfbd9,0x8d7c,0xffff,0xffff,0xfbdc,
0xffff,0xffff,0xfbde,0xffff,0xffff,0xffff,0x8e4b,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe7f9,
0x908d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x908e,0xe840,0xe842,0xffff,0xffff,0xfbdd,0xfbdb,0xffff,
0x8ff9,0xfbd8,0xe841,0xe843,0xffff,0xfbd7,0x8bd1,0xffff,
0x9564,0xffff,0xffff,0x8ee0,0x9842,0xffff,0xe7fc,0x8df6,
0xffff,0xffff,0x985e,0xffff,0xffff,0xe845,0xffff,0xffff,
0xffff,0xffff,0xe844,0xe846,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe7fb,0xffff,0xffff,0xffff,
0xfa5e,0xffff,0xffff,0x93e7,0xffff,0x9374,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x92d5,0xffff,0xe84b,0xfbe0,
0xffff,0xffff,0xffff,0x9262,0xe847,0xffff,0xffff,0xffff,
0xe848,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8c4c,0xffff,0xe84a,0xffff,
0xfbdf,0xffff,0xffff,0xffff,0xffff,0x8cae,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe849,0xffff,0x8fdf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8a99,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe84f,0xffff,0x8dbd,0x9199,
0xffff,0xffff,0x92c8,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfbe1,0xffff,0xffff,0x8a5a,
0xffff,0xffff,0xffff,0xffff,0xe84d,0xe84e,0x92c1,0xffff,
0xe84c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe850,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe856,0xffff,0xffff,0xfbe2,0xffff,
0xe859,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe858,0x934c,0xffff,0xffff,0xffff,0xffff,0xe851,0xe852,
0xe855,0xffff,0xffff,0xffff,0xffff,0xe857,0xfbe3,0xffff,
0xffff,0x8bbe,0xffff,0xffff,0xe85a,0xe854,0xffff,0xffff,
0xe853,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xfbe4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe85e,0xffff,0xffff,0xffff,0xe85f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe860,0xffff,0xffff,0xe85d,0xe85c,0xffff,0xffff,0xffff,
0x8fe0,0x93a8,0xe85b,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe864,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe862,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfbe5,0xffff,0xffff,0xffff,0xe863,0xe861,0xffff,
0x91f6,0xffff,0xe865,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe866,0xffff,0xffff,0xe868,0xfbe6,0xffff,0xffff,
0xfbe7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8ad3,0xe867,0x96f8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe873,0xe869,0xffff,0xffff,0xe86c,0xffff,
0xe86a,0xffff,0xe86b,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe86d,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe86f,0xffff,0xffff,0xffff,0xffff,0xe870,0xffff,0xe871,
0xffff,0xffff,0xffff,0xffff,0xe874,0xe872,0xe875,0xe877,
0xffff,0xe876,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x92b7,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x96e5,0xffff,0xe878,0x914d,0xffff,0xffff,0xffff,0xe879,
0xffff,0x95c2,0xe87a,0x8a4a,0xffff,0xffff,0xffff,0x895b,
0xffff,0x8ad5,0xfbe8,0x8ad4,0xe87b,0xffff,0xe87c,0xffff,
0xe87d,0xe87e,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe880,0xffff,0x8ad6,0x8a74,0x8d7d,0x94b4,0xffff,0xe882,
0xe881,0xffff,0xffff,0xffff,0xffff,0xe883,0xffff,0xffff,
0xffff,0xffff,0x897b,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe886,0xffff,0xe885,0xe884,0xffff,0xe887,0xffff,
0xffff,0xffff,0xffff,0xe88a,0xffff,0xffff,0xffff,0x88c5,
0xffff,0xffff,0xe888,0xffff,0xe88c,0xe88b,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe88e,0xe88d,0xe88f,0xffff,
0x93ac,0xffff,0xffff,0xffff,0xe890,0xffff,0xffff,0xffff,
0xffff,0xe891,0xe893,0xffff,0xffff,0xe892,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x958c,0xffff,0xffff,0xffff,
0xffff,0xe894,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe895,0xffff,0x8de3,0xffff,0xffff,0xffff,0xe896,0xe897,
0xffff,0xffff,0x9668,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x916a,0xffff,0xffff,0xffff,0x88a2,
0x91c9,0xffff,0xe898,0xffff,0x958d,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe89b,0xe899,0x8d7e,0xffff,0xe89a,
0x8cc0,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x95c3,0xe89d,0xe89f,0xe89e,0xe8a0,
0xffff,0xffff,0x8940,0x9077,0x8f9c,0x8ad7,0xe8a1,0xffff,
0xffff,0xffff,0x9486,0xffff,0xe8a3,0xffff,0xffff,0xffff,
0x8941,0xffff,0xe8a2,0x92c2,0xffff,0x97cb,0x93a9,0xe89c,
0x97a4,0xffff,0x8caf,0xffff,0xffff,0x977a,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x8bf7,0x97b2,0xffff,
0x8c47,0xffff,0x91e0,0xe440,0xffff,0xe8a4,0x8a4b,0x908f,
0xffff,0xffff,0xffff,0xffff,0x8a75,0xe8a6,0xffff,0xe8a7,
0xe8a5,0x8c84,0xffff,0x8ddb,0x8fe1,0xfbeb,0xffff,0xffff,
0x8942,0xffff,0xffff,0x97d7,0xffff,0xffff,0xffff,0xe8a9,
0xe7ac,0xffff,0xe8a8,0xffff,0xffff,0xffff,0xffff,0xfbec,
0xe8ac,0xe8aa,0xe8ab,0xffff,0xe8ad,0xffff,0xe8ae,0x97ea,
0xe8af,0xe8b0,0xffff,0x90c7,0x94b9,0xffff,0xffff,0xffff,
0x909d,0x8ae5,0xffff,0xffff,0x9759,0x89eb,0x8f57,0x8cd9,
0xffff,0xe8b3,0xffff,0xe8b2,0x8e93,0xe8b4,0xe8b1,0xffff,
0xffff,0x8e47,0xffff,0xffff,0xffff,0xe8b8,0xe5ab,0xffff,
0xffff,0x99d4,0xffff,0x9097,0xe8b6,0xffff,0xffff,0xffff,
0xffff,0xffff,0x97a3,0x93ef,0xffff,0xffff,0xffff,0xffff,
0x894a,0xffff,0x90e1,0x8eb4,0xffff,0xffff,0xffff,0xffff,
0x95b5,0xffff,0x895f,0xffff,0xffff,0xffff,0x97eb,0x978b,
0xffff,0xe8b9,0xffff,0x9364,0xffff,0xffff,0xffff,0xffff,
0x8ef9,0xffff,0xffff,0xffff,0xe8ba,0xffff,0xe8bb,0x906b,
0xe8bc,0xffff,0x97ec,0xffff,0xffff,0xe8b7,0xe8be,0xe8c0,
0xffff,0xe8bf,0xffff,0xe8bd,0xffff,0xffff,0xe8c1,0xffff,
0xffff,0xe8c2,0xffff,0xffff,0x919a,0xffff,0x89e0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe8c3,0xffff,0xffff,0x96b6,
0xffff,0xffff,0xe8c4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe8c5,0xffff,0x9849,0xfbed,0xffff,0xffff,0xffff,0xffff,
0x9e50,0xe8c6,0xffff,0xfbee,0xffff,0xe8c7,0xe8c8,0xffff,
0xffff,0xffff,0xe8cc,0xfbef,0xe8c9,0xffff,0xe8ca,0xffff,
0xe8cb,0xe8cd,0xffff,0xffff,0xffff,0xfbf0,0xffff,0xfbf1,
0xffff,0xfbf2,0x90c2,0xffff,0xffff,0xfbf3,0x96f5,0xffff,
0xffff,0x90c3,0xffff,0xffff,0xe8ce,0xffff,0x94f1,0xffff,
0xe8cf,0xea72,0x96ca,0xffff,0xe8d0,0xffff,0xe8d1,0xffff,
0xe8d2,0x8a76,0xffff,0xe8d4,0xffff,0x9078,0xffff,0xffff,
0xffff,0xe8d5,0xffff,0xffff,0x8c43,0xffff,0xffff,0xffff,
0xffff,0xe8d6,0xe8da,0xffff,0xe8d8,0xffff,0xffff,0xffff,
0xffff,0xe8d9,0xffff,0xffff,0x8a93,0xe8d7,0xe8db,0xffff,
0xffff,0xffff,0xffff,0xe8dc,0xffff,0x88c6,0xffff,0xe8dd,
0xe8de,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8fe2,0xffff,0xffff,0xffff,0xe8df,0xffff,0xffff,0xffff,
0x8b66,0xffff,0xffff,0xe8e2,0xffff,0xffff,0xe8e1,0xffff,
0xe8e0,0xffff,0xffff,0xe691,0xffff,0x95da,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe8e3,0xe8e4,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe8e5,0xffff,0xffff,0xe8e6,0xffff,
0xe8e7,0xffff,0xffff,0xe8e8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8ad8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe8e9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe8ea,0x9442,0xffff,
0xffff,0xffff,0xe8ec,0x89b9,0xffff,0xe8ef,0xe8ee,0xffff,
0xffff,0xffff,0xffff,0x8943,0xffff,0xffff,0xffff,0x8bbf,
0xffff,0x95c5,0x92b8,0x8da0,0xffff,0x8d80,0x8f87,0xffff,
0x907b,0xffff,0xffff,0xffff,0xe8f1,0xffff,0xffff,0xe8f0,
0x9761,0x8ae6,0x94d0,0x93da,0xffff,0xffff,0xffff,0x909c,
0x97cc,0xffff,0x8c7a,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe8f4,0xffff,0xffff,0xe8f3,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x966a,0x93aa,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x896f,0xffff,0xffff,0xe8f5,
0xe8f2,0xffff,0xffff,0x9570,0x978a,0xe8f6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe8f7,0xffff,
0xffff,0xffff,0xffff,0xe8f9,0x91e8,0x8a7a,0x8a7b,0xe8f8,
0xffff,0xffff,0xffff,0xffff,0x8ae7,0x8cb0,0xffff,0xfbf4,
0x8ae8,0xffff,0xffff,0x935e,0xffff,0xffff,0x97de,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xfbf5,0xffff,0x8cda,
0xffff,0xffff,0xffff,0xe8fa,0xffff,0xffff,0xffff,0xe8fb,
0xe8fc,0xe940,0xffff,0xe942,0xe941,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9597,0xffff,0xe943,0xffff,0xffff,0xffff,0xffff,0xe944,
0xffff,0xe945,0xffff,0xffff,0xffff,0xffff,0xe946,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe948,0xe947,0xffff,0xe949,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x94f2,0xe3ca,0xffff,0xffff,0x9048,
0xffff,0xffff,0x8b51,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe94a,0xffff,0xe94b,0xffff,0x99aa,0x9f5a,0x94d1,
0xffff,0xffff,0x88f9,0xffff,0x88b9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x8e94,0x964f,0x8ffc,0xffff,
0xffff,0xffff,0xffff,0xe94c,0xffff,0x96dd,0xffff,0xffff,
0xffff,0xe94d,0x977b,0xffff,0x8961,0xffff,0xffff,0xffff,
0x8e60,0xffff,0xe94e,0x89ec,0xe94f,0xffff,0xffff,0xffff,
0xe950,0xffff,0xffff,0xffff,0xffff,0xe952,0xe953,0xffff,
0xe955,0xe951,0xffff,0xffff,0xe954,0xffff,0xffff,0xfbf8,
0x8ad9,0xffff,0xffff,0xffff,0xe956,0xffff,0xe957,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe958,0xe959,0xffff,
0xffff,0xffff,0xe95a,0xffff,0xffff,0xe95c,0xffff,0xffff,
0xffff,0xe95b,0xffff,0xe95e,0xe961,0xffff,0xffff,0xffff,
0xe95d,0xe95f,0xe960,0xffff,0xffff,0xe962,0xffff,0x8bc0,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8ef1,0xe963,
0xe964,0x8d81,0xffff,0xffff,0xffff,0xffff,0xfbfa,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe965,0xffff,0xffff,
0x8a5d,0xffff,0xffff,0xffff,0x946e,0xe966,0xe967,0xffff,
0xffff,0xffff,0xffff,0x9279,0x93e9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe968,0xffff,0xffff,0xffff,
0xffff,0x949d,0xffff,0xffff,0x91ca,0x8977,0x8bec,0xffff,
0x8bed,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9293,0xe96d,0x8bee,0xffff,0xffff,0x89ed,0xffff,0xffff,
0xe96c,0xffff,0xffff,0xe96a,0xffff,0xe96b,0xffff,0xe969,
0xffff,0xffff,0xe977,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe96e,0xe96f,0xffff,
0xffff,0xe970,0xe971,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe973,0xffff,0xffff,0xe972,0xffff,0xffff,0xffff,0x8f78,
0xffff,0xe974,0xffff,0xffff,0xffff,0xe976,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x8b52,0xe975,
0xffff,0xffff,0x919b,0x8cb1,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe978,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x91cb,0xffff,0xffff,0xe979,0xffff,0xffff,0xffff,0xffff,
0x93ab,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe97a,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe980,0xffff,
0xe97d,0xffff,0xe97c,0xe97e,0xffff,0xe97b,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe982,0xfbfb,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe981,0xffff,0xe984,
0xffff,0xffff,0x8bc1,0xe983,0xffff,0xffff,0xffff,0xe985,
0xffff,0xffff,0xe986,0xffff,0xe988,0xe987,0xffff,0xffff,
0xffff,0xe989,0xe98b,0xe98a,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8d9c,0xffff,0xffff,0xffff,0xffff,0xe98c,0xffff,0xffff,
0xe98d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8a5b,0xffff,0xffff,0xffff,0xe98e,0xffff,0xffff,0xffff,
0xe98f,0xffff,0xffff,0xffff,0x9091,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe990,
0xffff,0xe991,0xffff,0xe992,0xe993,0xffff,0xffff,0xffff,
0x8d82,0xfbfc,0xffff,0xffff,0xfc40,0xffff,0xe994,0xe995,
0xffff,0xffff,0xe996,0xe997,0xffff,0xffff,0xe998,0xffff,
0xffff,0xffff,0x94af,0xe99a,0xffff,0x9545,0xe99b,0xe999,
0xffff,0xe99d,0xffff,0xffff,0xe99c,0xffff,0xffff,0xe99e,
0xffff,0xffff,0xffff,0xe99f,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9a0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe9a1,0xffff,0xe9a2,0xffff,0xffff,0xffff,0xffff,0xe9a3,
0xffff,0xffff,0xe9a4,0xe9a5,0xffff,0xe9a6,0xffff,0xe9a7,
0xe9a8,0xe9a9,0xe9aa,0xffff,0xffff,0xffff,0xe9ab,0xe9ac,
0xffff,0x9f54,0xe9ad,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe2f6,0x8b53,0xffff,0xffff,0xffff,
0xffff,0x8a40,0x8db0,0xe9af,0xe9ae,0x96a3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe9b1,0xe9b2,0xe9b0,
0xffff,0xe9b3,0xffff,0xffff,0x9682,0xffff,0xffff,0xffff,
0xe9b4,0xffff,0x8b9b,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x9844,
0xffff,0xffff,0xfc42,0xffff,0xe9b5,0xfc41,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe9b7,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x88bc,0xfc43,
0xffff,0xe9b8,0x95a9,0xe9b6,0xffff,0xffff,0xe9b9,0xe9ba,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9bb,
0xe9bc,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe9bd,0xffff,0x968e,0x8e4c,0xffff,0x8df8,0x914e,0xffff,
0xffff,0xfc44,0xffff,0xffff,0xe9be,0xffff,0xffff,0xffff,
0xffff,0xe9c1,0xffff,0xfc45,0xffff,0xffff,0xffff,0xffff,
0xe9bf,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9c2,0xffff,
0xffff,0x8cef,0xe9c0,0xffff,0xffff,0xffff,0xffff,0xe9c3,
0xffff,0xe9c4,0xe9c5,0xffff,0xe9c9,0xffff,0x8e49,0xffff,
0xffff,0xffff,0xffff,0x91e2,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe9ca,0xe9c7,0xe9c6,0xe9c8,0xffff,0xffff,0xffff,
0x8c7e,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe9ce,0xe9cd,0xe9cc,0xffff,0xffff,0x88b1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xfc46,0xffff,0xffff,0xffff,0xe9d8,0xffff,0xe9d4,0xffff,
0xe9d5,0xe9d1,0xe9d7,0xffff,0xe9d3,0x8a82,0xffff,0xffff,
0x986b,0xffff,0xe9d6,0xe9d2,0xe9d0,0xe9cf,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe9da,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe9dd,0xffff,0xffff,0xe9dc,0xe9db,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x9568,0xe9d9,0x88f1,
0xe9de,0xffff,0xe9e0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8a8f,0xe9cb,0x8956,0xffff,0xffff,0xe9e2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9e1,0xe9df,
0x924c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x9690,0xffff,0xffff,0xffff,0xffff,0x97d8,
0xffff,0xffff,0xe9e3,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe9e4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9e5,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9e6,0xffff,
0xe9e7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x92b9,0xffff,0xe9e8,
0xffff,0x94b5,0xffff,0xe9ed,0xe9e9,0xffff,0xffff,0xffff,
0xe9ea,0xffff,0xffff,0x9650,0x96c2,0xffff,0x93ce,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe9ee,0xffff,0xffff,0xe9ef,0x93bc,
0xe9ec,0xe9eb,0xffff,0xffff,0xffff,0xffff,0x89a8,0xffff,
0xffff,0xffff,0xe9f7,0xffff,0xffff,0xe9f6,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8995,0xffff,0xffff,0xffff,0xe9f4,
0xffff,0xffff,0xffff,0xe9f3,0xffff,0xffff,0xe9f1,0xffff,
0x8a9b,0xffff,0xe9f0,0x8eb0,0x89a7,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x8d83,0xffff,0xffff,0xe9fa,0xe9f9,
0xffff,0xe9f8,0xffff,0xffff,0xe9f5,0xffff,0xe9fb,0xffff,
0xe9fc,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xea44,0xea43,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xea45,0xffff,0xffff,0x894c,0xea40,0xea41,0xffff,
0x8d94,0x96b7,0xffff,0xffff,0xea42,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xfc48,0x9651,0xffff,0xffff,0xea4a,
0xfc47,0xffff,0xea46,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xea4b,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xea48,
0xffff,0xea47,0xffff,0xffff,0xffff,0xffff,0xffff,0x8c7b,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xea4c,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xea4d,0xffff,0xffff,0xffff,
0xffff,0xea4e,0xffff,0xea49,0xffff,0xffff,0xffff,0xe9f2,
0xffff,0xffff,0xea4f,0xffff,0x92df,0xffff,0xffff,0xffff,
0xea53,0xffff,0xea54,0xea52,0xffff,0xffff,0xffff,0xffff,
0xffff,0xea51,0xea57,0xffff,0xea50,0xffff,0xea55,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xea56,
0xffff,0xffff,0xffff,0xea59,0xffff,0xffff,0xffff,0xffff,
0xffff,0xea58,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xea5b,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xea5c,0xffff,0xea5d,
0xffff,0xffff,0x9868,0xffff,0xffff,0xffff,0xffff,0xffff,
0xea5a,0x91e9,0x8deb,0xffff,0xffff,0xea5e,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfc4a,0xea5f,0xea60,0xffff,0xffff,0xea61,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xea62,0xffff,0xffff,
0x8cb2,0xea63,0xffff,0xffff,0xffff,0xea64,0xffff,0x8ead,
0xffff,0xea65,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xea66,0xffff,0xffff,0xea67,0xea68,0xffff,0xffff,0xffff,
0xffff,0xea6b,0xea69,0x985b,0xffff,0xea6a,0xffff,0x97ed,
0xffff,0xffff,0xffff,0xffff,0xffff,0xea6c,0xffff,0x97d9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xea6d,0x949e,0xffff,
0xffff,0xea6e,0xea70,0xffff,0xffff,0xea71,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xea6f,0x8d8d,0x96cb,0x9683,0x9bf5,0xffff,0x9f80,0x969b,
0xffff,0xffff,0xffff,0xffff,0x89a9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xea73,0x8b6f,0xea74,0xea75,
0xea76,0xfc4b,0x8d95,0xffff,0xea77,0xffff,0xffff,0xffff,
0xe0d2,0x96d9,0xffff,0x91e1,0xea78,0xea7a,0xea79,0xffff,
0xea7b,0xffff,0xffff,0xffff,0xffff,0xea7c,0xffff,0xffff,
0xea7d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xea7e,
0xffff,0xffff,0xffff,0xffff,0xea80,0xffff,0xea81,0xea82,
0xffff,0xea83,0xffff,0xea84,0xea85,0xea86,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xea87,
0xea88,0xffff,0xffff,0xffff,0xffff,0xffff,0x9343,0xffff,
0xffff,0xffff,0xffff,0x8cdb,0xffff,0xea8a,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x916c,0xea8b,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xea8c,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0x9540,0xffff,0xffff,0xea8d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xea8e,0xe256,0xffff,0xffff,0xe6d8,0xe8eb,
0xffff,0xffff,0xea8f,0xffff,0xea90,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xea92,
0xea93,0xea94,0x97ee,0xea91,0xffff,0xffff,0xea95,0xea96,
0xffff,0xffff,0xea98,0xffff,0xea97,0xffff,0xffff,0xffff,
0xffff,0xffff,0xea9a,0xffff,0xffff,0xffff,0xea9b,0xea99,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x97b4,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xea9c,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xea9d,0xe273,0xffff,0xffff,
0xea9e,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfae0,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xfbe9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfa90,0xfa9b,
0xfa9c,0xfab1,0xfad8,0xfae8,0xfaea,0xfb58,0xfb5e,0xfb75,
0xfb7d,0xfb7e,0xfb80,0xfb82,0xfb86,0xfb89,0xfb92,0xfb9d,
0xfb9f,0xfba0,0xfba9,0xfbb1,0xfbb3,0xfbb4,0xfbb7,0xfbd3,
0xfbda,0xfbea,0xfbf6,0xfbf7,0xfbf9,0xfc49,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8149,0xfa57,0x8194,0x8190,0x8193,0x8195,0xfa56,
0x8169,0x816a,0x8196,0x817b,0x8143,0x817c,0x8144,0x815e,
0x824f,0x8250,0x8251,0x8252,0x8253,0x8254,0x8255,0x8256,
0x8257,0x8258,0x8146,0x8147,0x8183,0x8181,0x8184,0x8148,
0x8197,0x8260,0x8261,0x8262,0x8263,0x8264,0x8265,0x8266,
0x8267,0x8268,0x8269,0x826a,0x826b,0x826c,0x826d,0x826e,
0x826f,0x8270,0x8271,0x8272,0x8273,0x8274,0x8275,0x8276,
0x8277,0x8278,0x8279,0x816d,0x815f,0x816e,0x814f,0x8151,
0x814d,0x8281,0x8282,0x8283,0x8284,0x8285,0x8286,0x8287,
0x8288,0x8289,0x828a,0x828b,0x828c,0x828d,0x828e,0x828f,
0x8290,0x8291,0x8292,0x8293,0x8294,0x8295,0x8296,0x8297,
0x8298,0x8299,0x829a,0x816f,0x8162,0x8170,0x8160,0xffff,
0xffff,0x00a1,0x00a2,0x00a3,0x00a4,0x00a5,0x00a6,0x00a7,
0x00a8,0x00a9,0x00aa,0x00ab,0x00ac,0x00ad,0x00ae,0x00af,
0x00b0,0x00b1,0x00b2,0x00b3,0x00b4,0x00b5,0x00b6,0x00b7,
0x00b8,0x00b9,0x00ba,0x00bb,0x00bc,0x00bd,0x00be,0x00bf,
0x00c0,0x00c1,0x00c2,0x00c3,0x00c4,0x00c5,0x00c6,0x00c7,
0x00c8,0x00c9,0x00ca,0x00cb,0x00cc,0x00cd,0x00ce,0x00cf,
0x00d0,0x00d1,0x00d2,0x00d3,0x00d4,0x00d5,0x00d6,0x00d7,
0x00d8,0x00d9,0x00da,0x00db,0x00dc,0x00dd,0x00de,0x00df,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8191,0x8192,0x81ca,0x8150,0xfa55,0x818f,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff
};
static const unsigned short Our_eucJP_tableF00[] = {
0x3000,0x3001,0x3002,0xff0c,0xff0e,0x30fb,0xff1a,0xff1b,
0xff1f,0xff01,0x309b,0x309c,0x00b4,0xff40,0x00a8,0xff3e,
0xffe3,0xff3f,0x30fd,0x30fe,0x309d,0x309e,0x3003,0x4edd,
0x3005,0x3006,0x3007,0x30fc,0x2014,0x2010,0xff0f,0xff3c,
0x301c,0x2016,0xff5c,0x2026,0x2025,0x2018,0x2019,0x201c,
0x201d,0xff08,0xff09,0x3014,0x3015,0xff3b,0xff3d,0xff5b,
0xff5d,0x3008,0x3009,0x300a,0x300b,0x300c,0x300d,0x300e,
0x300f,0x3010,0x3011,0xff0b,0x2212,0x00b1,0x00d7,0x00f7,
0xff1d,0x2260,0xff1c,0xff1e,0x2266,0x2267,0x221e,0x2234,
0x2642,0x2640,0x00b0,0x2032,0x2033,0x2103,0xffe5,0xff04,
0x00a2,0x00a3,0xff05,0xff03,0xff06,0xff0a,0xff20,0x00a7,
0x2606,0x2605,0x25cb,0x25cf,0x25ce,0x25c7,0x25c6,0x25a1,
0x25a0,0x25b3,0x25b2,0x25bd,0x25bc,0x203b,0x3012,0x2192,
0x2190,0x2191,0x2193,0x3013,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x2208,
0x220b,0x2286,0x2287,0x2282,0x2283,0x222a,0x2229,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x2227,
0x2228,0x00ac,0x21d2,0x21d4,0x2200,0x2203,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x2220,0x22a5,0x2312,0x2202,0x2207,0x2261,0x2252,
0x226a,0x226b,0x221a,0x223d,0x221d,0x2235,0x222b,0x222c,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x212b,
0x2030,0x266f,0x266d,0x266a,0x2020,0x2021,0x00b6,0xffff,
0xffff,0xffff,0xffff,0x25ef,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xff10,0xff11,0xff12,0xff13,0xff14,
0xff15,0xff16,0xff17,0xff18,0xff19,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xff21,0xff22,0xff23,0xff24,
0xff25,0xff26,0xff27,0xff28,0xff29,0xff2a,0xff2b,0xff2c,
0xff2d,0xff2e,0xff2f,0xff30,0xff31,0xff32,0xff33,0xff34,
0xff35,0xff36,0xff37,0xff38,0xff39,0xff3a,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xff41,0xff42,0xff43,0xff44,
0xff45,0xff46,0xff47,0xff48,0xff49,0xff4a,0xff4b,0xff4c,
0xff4d,0xff4e,0xff4f,0xff50,0xff51,0xff52,0xff53,0xff54,
0xff55,0xff56,0xff57,0xff58,0xff59,0xff5a,0xffff,0xffff,
0xffff,0xffff,0x3041,0x3042,0x3043,0x3044,0x3045,0x3046,
0x3047,0x3048,0x3049,0x304a,0x304b,0x304c,0x304d,0x304e,
0x304f,0x3050,0x3051,0x3052,0x3053,0x3054,0x3055,0x3056,
0x3057,0x3058,0x3059,0x305a,0x305b,0x305c,0x305d,0x305e,
0x305f,0x3060,0x3061,0x3062,0x3063,0x3064,0x3065,0x3066,
0x3067,0x3068,0x3069,0x306a,0x306b,0x306c,0x306d,0x306e,
0x306f,0x3070,0x3071,0x3072,0x3073,0x3074,0x3075,0x3076,
0x3077,0x3078,0x3079,0x307a,0x307b,0x307c,0x307d,0x307e,
0x307f,0x3080,0x3081,0x3082,0x3083,0x3084,0x3085,0x3086,
0x3087,0x3088,0x3089,0x308a,0x308b,0x308c,0x308d,0x308e,
0x308f,0x3090,0x3091,0x3092,0x3093,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x30a1,0x30a2,0x30a3,0x30a4,0x30a5,0x30a6,0x30a7,0x30a8,
0x30a9,0x30aa,0x30ab,0x30ac,0x30ad,0x30ae,0x30af,0x30b0,
0x30b1,0x30b2,0x30b3,0x30b4,0x30b5,0x30b6,0x30b7,0x30b8,
0x30b9,0x30ba,0x30bb,0x30bc,0x30bd,0x30be,0x30bf,0x30c0,
0x30c1,0x30c2,0x30c3,0x30c4,0x30c5,0x30c6,0x30c7,0x30c8,
0x30c9,0x30ca,0x30cb,0x30cc,0x30cd,0x30ce,0x30cf,0x30d0,
0x30d1,0x30d2,0x30d3,0x30d4,0x30d5,0x30d6,0x30d7,0x30d8,
0x30d9,0x30da,0x30db,0x30dc,0x30dd,0x30de,0x30df,0x30e0,
0x30e1,0x30e2,0x30e3,0x30e4,0x30e5,0x30e6,0x30e7,0x30e8,
0x30e9,0x30ea,0x30eb,0x30ec,0x30ed,0x30ee,0x30ef,0x30f0,
0x30f1,0x30f2,0x30f3,0x30f4,0x30f5,0x30f6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x0391,0x0392,
0x0393,0x0394,0x0395,0x0396,0x0397,0x0398,0x0399,0x039a,
0x039b,0x039c,0x039d,0x039e,0x039f,0x03a0,0x03a1,0x03a3,
0x03a4,0x03a5,0x03a6,0x03a7,0x03a8,0x03a9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x03b1,0x03b2,
0x03b3,0x03b4,0x03b5,0x03b6,0x03b7,0x03b8,0x03b9,0x03ba,
0x03bb,0x03bc,0x03bd,0x03be,0x03bf,0x03c0,0x03c1,0x03c3,
0x03c4,0x03c5,0x03c6,0x03c7,0x03c8,0x03c9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x0410,0x0411,0x0412,0x0413,
0x0414,0x0415,0x0401,0x0416,0x0417,0x0418,0x0419,0x041a,
0x041b,0x041c,0x041d,0x041e,0x041f,0x0420,0x0421,0x0422,
0x0423,0x0424,0x0425,0x0426,0x0427,0x0428,0x0429,0x042a,
0x042b,0x042c,0x042d,0x042e,0x042f,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x0430,0x0431,0x0432,0x0433,
0x0434,0x0435,0x0451,0x0436,0x0437,0x0438,0x0439,0x043a,
0x043b,0x043c,0x043d,0x043e,0x043f,0x0440,0x0441,0x0442,
0x0443,0x0444,0x0445,0x0446,0x0447,0x0448,0x0449,0x044a,
0x044b,0x044c,0x044d,0x044e,0x044f,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x2500,0x2502,0x250c,0x2510,0x2518,0x2514,
0x251c,0x252c,0x2524,0x2534,0x253c,0x2501,0x2503,0x250f,
0x2513,0x251b,0x2517,0x2523,0x2533,0x252b,0x253b,0x254b,
0x2520,0x252f,0x2528,0x2537,0x253f,0x251d,0x2530,0x2525,
0x2538,0x2542,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x2460,0x2461,0x2462,0x2463,0x2464,0x2465,0x2466,0x2467,
0x2468,0x2469,0x246a,0x246b,0x246c,0x246d,0x246e,0x246f,
0x2470,0x2471,0x2472,0x2473,0x2160,0x2161,0x2162,0x2163,
0x2164,0x2165,0x2166,0x2167,0x2168,0x2169,0xffff,0x3349,
0x3314,0x3322,0x334d,0x3318,0x3327,0x3303,0x3336,0x3351,
0x3357,0x330d,0x3326,0x3323,0x332b,0x334a,0x333b,0x339c,
0x339d,0x339e,0x338e,0x338f,0x33c4,0x33a1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x337b,0x301d,
0x301f,0x2116,0x33cd,0x2121,0x32a4,0x32a5,0x32a6,0x32a7,
0x32a8,0x3231,0x3232,0x3239,0x337e,0x337d,0x337c,0x2252,
0x2261,0x222b,0x222e,0x2211,0x221a,0x22a5,0x2220,0x221f,
0x22bf,0x2235,0x2229,0x222a,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x4e9c,0x5516,0x5a03,0x963f,0x54c0,0x611b,
0x6328,0x59f6,0x9022,0x8475,0x831c,0x7a50,0x60aa,0x63e1,
0x6e25,0x65ed,0x8466,0x82a6,0x9bf5,0x6893,0x5727,0x65a1,
0x6271,0x5b9b,0x59d0,0x867b,0x98f4,0x7d62,0x7dbe,0x9b8e,
0x6216,0x7c9f,0x88b7,0x5b89,0x5eb5,0x6309,0x6697,0x6848,
0x95c7,0x978d,0x674f,0x4ee5,0x4f0a,0x4f4d,0x4f9d,0x5049,
0x56f2,0x5937,0x59d4,0x5a01,0x5c09,0x60df,0x610f,0x6170,
0x6613,0x6905,0x70ba,0x754f,0x7570,0x79fb,0x7dad,0x7def,
0x80c3,0x840e,0x8863,0x8b02,0x9055,0x907a,0x533b,0x4e95,
0x4ea5,0x57df,0x80b2,0x90c1,0x78ef,0x4e00,0x58f1,0x6ea2,
0x9038,0x7a32,0x8328,0x828b,0x9c2f,0x5141,0x5370,0x54bd,
0x54e1,0x56e0,0x59fb,0x5f15,0x98f2,0x6deb,0x80e4,0x852d,
0x9662,0x9670,0x96a0,0x97fb,0x540b,0x53f3,0x5b87,0x70cf,
0x7fbd,0x8fc2,0x96e8,0x536f,0x9d5c,0x7aba,0x4e11,0x7893,
0x81fc,0x6e26,0x5618,0x5504,0x6b1d,0x851a,0x9c3b,0x59e5,
0x53a9,0x6d66,0x74dc,0x958f,0x5642,0x4e91,0x904b,0x96f2,
0x834f,0x990c,0x53e1,0x55b6,0x5b30,0x5f71,0x6620,0x66f3,
0x6804,0x6c38,0x6cf3,0x6d29,0x745b,0x76c8,0x7a4e,0x9834,
0x82f1,0x885b,0x8a60,0x92ed,0x6db2,0x75ab,0x76ca,0x99c5,
0x60a6,0x8b01,0x8d8a,0x95b2,0x698e,0x53ad,0x5186,0x5712,
0x5830,0x5944,0x5bb4,0x5ef6,0x6028,0x63a9,0x63f4,0x6cbf,
0x6f14,0x708e,0x7114,0x7159,0x71d5,0x733f,0x7e01,0x8276,
0x82d1,0x8597,0x9060,0x925b,0x9d1b,0x5869,0x65bc,0x6c5a,
0x7525,0x51f9,0x592e,0x5965,0x5f80,0x5fdc,0x62bc,0x65fa,
0x6a2a,0x6b27,0x6bb4,0x738b,0x7fc1,0x8956,0x9d2c,0x9d0e,
0x9ec4,0x5ca1,0x6c96,0x837b,0x5104,0x5c4b,0x61b6,0x81c6,
0x6876,0x7261,0x4e59,0x4ffa,0x5378,0x6069,0x6e29,0x7a4f,
0x97f3,0x4e0b,0x5316,0x4eee,0x4f55,0x4f3d,0x4fa1,0x4f73,
0x52a0,0x53ef,0x5609,0x590f,0x5ac1,0x5bb6,0x5be1,0x79d1,
0x6687,0x679c,0x67b6,0x6b4c,0x6cb3,0x706b,0x73c2,0x798d,
0x79be,0x7a3c,0x7b87,0x82b1,0x82db,0x8304,0x8377,0x83ef,
0x83d3,0x8766,0x8ab2,0x5629,0x8ca8,0x8fe6,0x904e,0x971e,
0x868a,0x4fc4,0x5ce8,0x6211,0x7259,0x753b,0x81e5,0x82bd,
0x86fe,0x8cc0,0x96c5,0x9913,0x99d5,0x4ecb,0x4f1a,0x89e3,
0x56de,0x584a,0x58ca,0x5efb,0x5feb,0x602a,0x6094,0x6062,
0x61d0,0x6212,0x62d0,0x6539,0x9b41,0x6666,0x68b0,0x6d77,
0x7070,0x754c,0x7686,0x7d75,0x82a5,0x87f9,0x958b,0x968e,
0x8c9d,0x51f1,0x52be,0x5916,0x54b3,0x5bb3,0x5d16,0x6168,
0x6982,0x6daf,0x788d,0x84cb,0x8857,0x8a72,0x93a7,0x9ab8,
0x6d6c,0x99a8,0x86d9,0x57a3,0x67ff,0x86ce,0x920e,0x5283,
0x5687,0x5404,0x5ed3,0x62e1,0x64b9,0x683c,0x6838,0x6bbb,
0x7372,0x78ba,0x7a6b,0x899a,0x89d2,0x8d6b,0x8f03,0x90ed,
0x95a3,0x9694,0x9769,0x5b66,0x5cb3,0x697d,0x984d,0x984e,
0x639b,0x7b20,0x6a2b,0x6a7f,0x68b6,0x9c0d,0x6f5f,0x5272,
0x559d,0x6070,0x62ec,0x6d3b,0x6e07,0x6ed1,0x845b,0x8910,
0x8f44,0x4e14,0x9c39,0x53f6,0x691b,0x6a3a,0x9784,0x682a,
0x515c,0x7ac3,0x84b2,0x91dc,0x938c,0x565b,0x9d28,0x6822,
0x8305,0x8431,0x7ca5,0x5208,0x82c5,0x74e6,0x4e7e,0x4f83,
0x51a0,0x5bd2,0x520a,0x52d8,0x52e7,0x5dfb,0x559a,0x582a,
0x59e6,0x5b8c,0x5b98,0x5bdb,0x5e72,0x5e79,0x60a3,0x611f,
0x6163,0x61be,0x63db,0x6562,0x67d1,0x6853,0x68fa,0x6b3e,
0x6b53,0x6c57,0x6f22,0x6f97,0x6f45,0x74b0,0x7518,0x76e3,
0x770b,0x7aff,0x7ba1,0x7c21,0x7de9,0x7f36,0x7ff0,0x809d,
0x8266,0x839e,0x89b3,0x8acc,0x8cab,0x9084,0x9451,0x9593,
0x9591,0x95a2,0x9665,0x97d3,0x9928,0x8218,0x4e38,0x542b,
0x5cb8,0x5dcc,0x73a9,0x764c,0x773c,0x5ca9,0x7feb,0x8d0b,
0x96c1,0x9811,0x9854,0x9858,0x4f01,0x4f0e,0x5371,0x559c,
0x5668,0x57fa,0x5947,0x5b09,0x5bc4,0x5c90,0x5e0c,0x5e7e,
0x5fcc,0x63ee,0x673a,0x65d7,0x65e2,0x671f,0x68cb,0x68c4,
0x6a5f,0x5e30,0x6bc5,0x6c17,0x6c7d,0x757f,0x7948,0x5b63,
0x7a00,0x7d00,0x5fbd,0x898f,0x8a18,0x8cb4,0x8d77,0x8ecc,
0x8f1d,0x98e2,0x9a0e,0x9b3c,0x4e80,0x507d,0x5100,0x5993,
0x5b9c,0x622f,0x6280,0x64ec,0x6b3a,0x72a0,0x7591,0x7947,
0x7fa9,0x87fb,0x8abc,0x8b70,0x63ac,0x83ca,0x97a0,0x5409,
0x5403,0x55ab,0x6854,0x6a58,0x8a70,0x7827,0x6775,0x9ecd,
0x5374,0x5ba2,0x811a,0x8650,0x9006,0x4e18,0x4e45,0x4ec7,
0x4f11,0x53ca,0x5438,0x5bae,0x5f13,0x6025,0x6551,0x673d,
0x6c42,0x6c72,0x6ce3,0x7078,0x7403,0x7a76,0x7aae,0x7b08,
0x7d1a,0x7cfe,0x7d66,0x65e7,0x725b,0x53bb,0x5c45,0x5de8,
0x62d2,0x62e0,0x6319,0x6e20,0x865a,0x8a31,0x8ddd,0x92f8,
0x6f01,0x79a6,0x9b5a,0x4ea8,0x4eab,0x4eac,0x4f9b,0x4fa0,
0x50d1,0x5147,0x7af6,0x5171,0x51f6,0x5354,0x5321,0x537f,
0x53eb,0x55ac,0x5883,0x5ce1,0x5f37,0x5f4a,0x602f,0x6050,
0x606d,0x631f,0x6559,0x6a4b,0x6cc1,0x72c2,0x72ed,0x77ef,
0x80f8,0x8105,0x8208,0x854e,0x90f7,0x93e1,0x97ff,0x9957,
0x9a5a,0x4ef0,0x51dd,0x5c2d,0x6681,0x696d,0x5c40,0x66f2,
0x6975,0x7389,0x6850,0x7c81,0x50c5,0x52e4,0x5747,0x5dfe,
0x9326,0x65a4,0x6b23,0x6b3d,0x7434,0x7981,0x79bd,0x7b4b,
0x7dca,0x82b9,0x83cc,0x887f,0x895f,0x8b39,0x8fd1,0x91d1,
0x541f,0x9280,0x4e5d,0x5036,0x53e5,0x533a,0x72d7,0x7396,
0x77e9,0x82e6,0x8eaf,0x99c6,0x99c8,0x99d2,0x5177,0x611a,
0x865e,0x55b0,0x7a7a,0x5076,0x5bd3,0x9047,0x9685,0x4e32,
0x6adb,0x91e7,0x5c51,0x5c48,0x6398,0x7a9f,0x6c93,0x9774,
0x8f61,0x7aaa,0x718a,0x9688,0x7c82,0x6817,0x7e70,0x6851,
0x936c,0x52f2,0x541b,0x85ab,0x8a13,0x7fa4,0x8ecd,0x90e1,
0x5366,0x8888,0x7941,0x4fc2,0x50be,0x5211,0x5144,0x5553,
0x572d,0x73ea,0x578b,0x5951,0x5f62,0x5f84,0x6075,0x6176,
0x6167,0x61a9,0x63b2,0x643a,0x656c,0x666f,0x6842,0x6e13,
0x7566,0x7a3d,0x7cfb,0x7d4c,0x7d99,0x7e4b,0x7f6b,0x830e,
0x834a,0x86cd,0x8a08,0x8a63,0x8b66,0x8efd,0x981a,0x9d8f,
0x82b8,0x8fce,0x9be8,0x5287,0x621f,0x6483,0x6fc0,0x9699,
0x6841,0x5091,0x6b20,0x6c7a,0x6f54,0x7a74,0x7d50,0x8840,
0x8a23,0x6708,0x4ef6,0x5039,0x5026,0x5065,0x517c,0x5238,
0x5263,0x55a7,0x570f,0x5805,0x5acc,0x5efa,0x61b2,0x61f8,
0x62f3,0x6372,0x691c,0x6a29,0x727d,0x72ac,0x732e,0x7814,
0x786f,0x7d79,0x770c,0x80a9,0x898b,0x8b19,0x8ce2,0x8ed2,
0x9063,0x9375,0x967a,0x9855,0x9a13,0x9e78,0x5143,0x539f,
0x53b3,0x5e7b,0x5f26,0x6e1b,0x6e90,0x7384,0x73fe,0x7d43,
0x8237,0x8a00,0x8afa,0x9650,0x4e4e,0x500b,0x53e4,0x547c,
0x56fa,0x59d1,0x5b64,0x5df1,0x5eab,0x5f27,0x6238,0x6545,
0x67af,0x6e56,0x72d0,0x7cca,0x88b4,0x80a1,0x80e1,0x83f0,
0x864e,0x8a87,0x8de8,0x9237,0x96c7,0x9867,0x9f13,0x4e94,
0x4e92,0x4f0d,0x5348,0x5449,0x543e,0x5a2f,0x5f8c,0x5fa1,
0x609f,0x68a7,0x6a8e,0x745a,0x7881,0x8a9e,0x8aa4,0x8b77,
0x9190,0x4e5e,0x9bc9,0x4ea4,0x4f7c,0x4faf,0x5019,0x5016,
0x5149,0x516c,0x529f,0x52b9,0x52fe,0x539a,0x53e3,0x5411,
0x540e,0x5589,0x5751,0x57a2,0x597d,0x5b54,0x5b5d,0x5b8f,
0x5de5,0x5de7,0x5df7,0x5e78,0x5e83,0x5e9a,0x5eb7,0x5f18,
0x6052,0x614c,0x6297,0x62d8,0x63a7,0x653b,0x6602,0x6643,
0x66f4,0x676d,0x6821,0x6897,0x69cb,0x6c5f,0x6d2a,0x6d69,
0x6e2f,0x6e9d,0x7532,0x7687,0x786c,0x7a3f,0x7ce0,0x7d05,
0x7d18,0x7d5e,0x7db1,0x8015,0x8003,0x80af,0x80b1,0x8154,
0x818f,0x822a,0x8352,0x884c,0x8861,0x8b1b,0x8ca2,0x8cfc,
0x90ca,0x9175,0x9271,0x783f,0x92fc,0x95a4,0x964d,0x9805,
0x9999,0x9ad8,0x9d3b,0x525b,0x52ab,0x53f7,0x5408,0x58d5,
0x62f7,0x6fe0,0x8c6a,0x8f5f,0x9eb9,0x514b,0x523b,0x544a,
0x56fd,0x7a40,0x9177,0x9d60,0x9ed2,0x7344,0x6f09,0x8170,
0x7511,0x5ffd,0x60da,0x9aa8,0x72db,0x8fbc,0x6b64,0x9803,
0x4eca,0x56f0,0x5764,0x58be,0x5a5a,0x6068,0x61c7,0x660f,
0x6606,0x6839,0x68b1,0x6df7,0x75d5,0x7d3a,0x826e,0x9b42,
0x4e9b,0x4f50,0x53c9,0x5506,0x5d6f,0x5de6,0x5dee,0x67fb,
0x6c99,0x7473,0x7802,0x8a50,0x9396,0x88df,0x5750,0x5ea7,
0x632b,0x50b5,0x50ac,0x518d,0x6700,0x54c9,0x585e,0x59bb,
0x5bb0,0x5f69,0x624d,0x63a1,0x683d,0x6b73,0x6e08,0x707d,
0x91c7,0x7280,0x7815,0x7826,0x796d,0x658e,0x7d30,0x83dc,
0x88c1,0x8f09,0x969b,0x5264,0x5728,0x6750,0x7f6a,0x8ca1,
0x51b4,0x5742,0x962a,0x583a,0x698a,0x80b4,0x54b2,0x5d0e,
0x57fc,0x7895,0x9dfa,0x4f5c,0x524a,0x548b,0x643e,0x6628,
0x6714,0x67f5,0x7a84,0x7b56,0x7d22,0x932f,0x685c,0x9bad,
0x7b39,0x5319,0x518a,0x5237,0x5bdf,0x62f6,0x64ae,0x64e6,
0x672d,0x6bba,0x85a9,0x96d1,0x7690,0x9bd6,0x634c,0x9306,
0x9bab,0x76bf,0x6652,0x4e09,0x5098,0x53c2,0x5c71,0x60e8,
0x6492,0x6563,0x685f,0x71e6,0x73ca,0x7523,0x7b97,0x7e82,
0x8695,0x8b83,0x8cdb,0x9178,0x9910,0x65ac,0x66ab,0x6b8b,
0x4ed5,0x4ed4,0x4f3a,0x4f7f,0x523a,0x53f8,0x53f2,0x55e3,
0x56db,0x58eb,0x59cb,0x59c9,0x59ff,0x5b50,0x5c4d,0x5e02,
0x5e2b,0x5fd7,0x601d,0x6307,0x652f,0x5b5c,0x65af,0x65bd,
0x65e8,0x679d,0x6b62,0x6b7b,0x6c0f,0x7345,0x7949,0x79c1,
0x7cf8,0x7d19,0x7d2b,0x80a2,0x8102,0x81f3,0x8996,0x8a5e,
0x8a69,0x8a66,0x8a8c,0x8aee,0x8cc7,0x8cdc,0x96cc,0x98fc,
0x6b6f,0x4e8b,0x4f3c,0x4f8d,0x5150,0x5b57,0x5bfa,0x6148,
0x6301,0x6642,0x6b21,0x6ecb,0x6cbb,0x723e,0x74bd,0x75d4,
0x78c1,0x793a,0x800c,0x8033,0x81ea,0x8494,0x8f9e,0x6c50,
0x9e7f,0x5f0f,0x8b58,0x9d2b,0x7afa,0x8ef8,0x5b8d,0x96eb,
0x4e03,0x53f1,0x57f7,0x5931,0x5ac9,0x5ba4,0x6089,0x6e7f,
0x6f06,0x75be,0x8cea,0x5b9f,0x8500,0x7be0,0x5072,0x67f4,
0x829d,0x5c61,0x854a,0x7e1e,0x820e,0x5199,0x5c04,0x6368,
0x8d66,0x659c,0x716e,0x793e,0x7d17,0x8005,0x8b1d,0x8eca,
0x906e,0x86c7,0x90aa,0x501f,0x52fa,0x5c3a,0x6753,0x707c,
0x7235,0x914c,0x91c8,0x932b,0x82e5,0x5bc2,0x5f31,0x60f9,
0x4e3b,0x53d6,0x5b88,0x624b,0x6731,0x6b8a,0x72e9,0x73e0,
0x7a2e,0x816b,0x8da3,0x9152,0x9996,0x5112,0x53d7,0x546a,
0x5bff,0x6388,0x6a39,0x7dac,0x9700,0x56da,0x53ce,0x5468,
0x5b97,0x5c31,0x5dde,0x4fee,0x6101,0x62fe,0x6d32,0x79c0,
0x79cb,0x7d42,0x7e4d,0x7fd2,0x81ed,0x821f,0x8490,0x8846,
0x8972,0x8b90,0x8e74,0x8f2f,0x9031,0x914b,0x916c,0x96c6,
0x919c,0x4ec0,0x4f4f,0x5145,0x5341,0x5f93,0x620e,0x67d4,
0x6c41,0x6e0b,0x7363,0x7e26,0x91cd,0x9283,0x53d4,0x5919,
0x5bbf,0x6dd1,0x795d,0x7e2e,0x7c9b,0x587e,0x719f,0x51fa,
0x8853,0x8ff0,0x4fca,0x5cfb,0x6625,0x77ac,0x7ae3,0x821c,
0x99ff,0x51c6,0x5faa,0x65ec,0x696f,0x6b89,0x6df3,0x6e96,
0x6f64,0x76fe,0x7d14,0x5de1,0x9075,0x9187,0x9806,0x51e6,
0x521d,0x6240,0x6691,0x66d9,0x6e1a,0x5eb6,0x7dd2,0x7f72,
0x66f8,0x85af,0x85f7,0x8af8,0x52a9,0x53d9,0x5973,0x5e8f,
0x5f90,0x6055,0x92e4,0x9664,0x50b7,0x511f,0x52dd,0x5320,
0x5347,0x53ec,0x54e8,0x5546,0x5531,0x5617,0x5968,0x59be,
0x5a3c,0x5bb5,0x5c06,0x5c0f,0x5c11,0x5c1a,0x5e84,0x5e8a,
0x5ee0,0x5f70,0x627f,0x6284,0x62db,0x638c,0x6377,0x6607,
0x660c,0x662d,0x6676,0x677e,0x68a2,0x6a1f,0x6a35,0x6cbc,
0x6d88,0x6e09,0x6e58,0x713c,0x7126,0x7167,0x75c7,0x7701,
0x785d,0x7901,0x7965,0x79f0,0x7ae0,0x7b11,0x7ca7,0x7d39,
0x8096,0x83d6,0x848b,0x8549,0x885d,0x88f3,0x8a1f,0x8a3c,
0x8a54,0x8a73,0x8c61,0x8cde,0x91a4,0x9266,0x937e,0x9418,
0x969c,0x9798,0x4e0a,0x4e08,0x4e1e,0x4e57,0x5197,0x5270,
0x57ce,0x5834,0x58cc,0x5b22,0x5e38,0x60c5,0x64fe,0x6761,
0x6756,0x6d44,0x72b6,0x7573,0x7a63,0x84b8,0x8b72,0x91b8,
0x9320,0x5631,0x57f4,0x98fe,0x62ed,0x690d,0x6b96,0x71ed,
0x7e54,0x8077,0x8272,0x89e6,0x98df,0x8755,0x8fb1,0x5c3b,
0x4f38,0x4fe1,0x4fb5,0x5507,0x5a20,0x5bdd,0x5be9,0x5fc3,
0x614e,0x632f,0x65b0,0x664b,0x68ee,0x699b,0x6d78,0x6df1,
0x7533,0x75b9,0x771f,0x795e,0x79e6,0x7d33,0x81e3,0x82af,
0x85aa,0x89aa,0x8a3a,0x8eab,0x8f9b,0x9032,0x91dd,0x9707,
0x4eba,0x4ec1,0x5203,0x5875,0x58ec,0x5c0b,0x751a,0x5c3d,
0x814e,0x8a0a,0x8fc5,0x9663,0x976d,0x7b25,0x8acf,0x9808,
0x9162,0x56f3,0x53a8,0x9017,0x5439,0x5782,0x5e25,0x63a8,
0x6c34,0x708a,0x7761,0x7c8b,0x7fe0,0x8870,0x9042,0x9154,
0x9310,0x9318,0x968f,0x745e,0x9ac4,0x5d07,0x5d69,0x6570,
0x67a2,0x8da8,0x96db,0x636e,0x6749,0x6919,0x83c5,0x9817,
0x96c0,0x88fe,0x6f84,0x647a,0x5bf8,0x4e16,0x702c,0x755d,
0x662f,0x51c4,0x5236,0x52e2,0x59d3,0x5f81,0x6027,0x6210,
0x653f,0x6574,0x661f,0x6674,0x68f2,0x6816,0x6b63,0x6e05,
0x7272,0x751f,0x76db,0x7cbe,0x8056,0x58f0,0x88fd,0x897f,
0x8aa0,0x8a93,0x8acb,0x901d,0x9192,0x9752,0x9759,0x6589,
0x7a0e,0x8106,0x96bb,0x5e2d,0x60dc,0x621a,0x65a5,0x6614,
0x6790,0x77f3,0x7a4d,0x7c4d,0x7e3e,0x810a,0x8cac,0x8d64,
0x8de1,0x8e5f,0x78a9,0x5207,0x62d9,0x63a5,0x6442,0x6298,
0x8a2d,0x7a83,0x7bc0,0x8aac,0x96ea,0x7d76,0x820c,0x8749,
0x4ed9,0x5148,0x5343,0x5360,0x5ba3,0x5c02,0x5c16,0x5ddd,
0x6226,0x6247,0x64b0,0x6813,0x6834,0x6cc9,0x6d45,0x6d17,
0x67d3,0x6f5c,0x714e,0x717d,0x65cb,0x7a7f,0x7bad,0x7dda,
0x7e4a,0x7fa8,0x817a,0x821b,0x8239,0x85a6,0x8a6e,0x8cce,
0x8df5,0x9078,0x9077,0x92ad,0x9291,0x9583,0x9bae,0x524d,
0x5584,0x6f38,0x7136,0x5168,0x7985,0x7e55,0x81b3,0x7cce,
0x564c,0x5851,0x5ca8,0x63aa,0x66fe,0x66fd,0x695a,0x72d9,
0x758f,0x758e,0x790e,0x7956,0x79df,0x7c97,0x7d20,0x7d44,
0x8607,0x8a34,0x963b,0x9061,0x9f20,0x50e7,0x5275,0x53cc,
0x53e2,0x5009,0x55aa,0x58ee,0x594f,0x723d,0x5b8b,0x5c64,
0x531d,0x60e3,0x60f3,0x635c,0x6383,0x633f,0x63bb,0x64cd,
0x65e9,0x66f9,0x5de3,0x69cd,0x69fd,0x6f15,0x71e5,0x4e89,
0x75e9,0x76f8,0x7a93,0x7cdf,0x7dcf,0x7d9c,0x8061,0x8349,
0x8358,0x846c,0x84bc,0x85fb,0x88c5,0x8d70,0x9001,0x906d,
0x9397,0x971c,0x9a12,0x50cf,0x5897,0x618e,0x81d3,0x8535,
0x8d08,0x9020,0x4fc3,0x5074,0x5247,0x5373,0x606f,0x6349,
0x675f,0x6e2c,0x8db3,0x901f,0x4fd7,0x5c5e,0x8cca,0x65cf,
0x7d9a,0x5352,0x8896,0x5176,0x63c3,0x5b58,0x5b6b,0x5c0a,
0x640d,0x6751,0x905c,0x4ed6,0x591a,0x592a,0x6c70,0x8a51,
0x553e,0x5815,0x59a5,0x60f0,0x6253,0x67c1,0x8235,0x6955,
0x9640,0x99c4,0x9a28,0x4f53,0x5806,0x5bfe,0x8010,0x5cb1,
0x5e2f,0x5f85,0x6020,0x614b,0x6234,0x66ff,0x6cf0,0x6ede,
0x80ce,0x817f,0x82d4,0x888b,0x8cb8,0x9000,0x902e,0x968a,
0x9edb,0x9bdb,0x4ee3,0x53f0,0x5927,0x7b2c,0x918d,0x984c,
0x9df9,0x6edd,0x7027,0x5353,0x5544,0x5b85,0x6258,0x629e,
0x62d3,0x6ca2,0x6fef,0x7422,0x8a17,0x9438,0x6fc1,0x8afe,
0x8338,0x51e7,0x86f8,0x53ea,0x53e9,0x4f46,0x9054,0x8fb0,
0x596a,0x8131,0x5dfd,0x7aea,0x8fbf,0x68da,0x8c37,0x72f8,
0x9c48,0x6a3d,0x8ab0,0x4e39,0x5358,0x5606,0x5766,0x62c5,
0x63a2,0x65e6,0x6b4e,0x6de1,0x6e5b,0x70ad,0x77ed,0x7aef,
0x7baa,0x7dbb,0x803d,0x80c6,0x86cb,0x8a95,0x935b,0x56e3,
0x58c7,0x5f3e,0x65ad,0x6696,0x6a80,0x6bb5,0x7537,0x8ac7,
0x5024,0x77e5,0x5730,0x5f1b,0x6065,0x667a,0x6c60,0x75f4,
0x7a1a,0x7f6e,0x81f4,0x8718,0x9045,0x99b3,0x7bc9,0x755c,
0x7af9,0x7b51,0x84c4,0x9010,0x79e9,0x7a92,0x8336,0x5ae1,
0x7740,0x4e2d,0x4ef2,0x5b99,0x5fe0,0x62bd,0x663c,0x67f1,
0x6ce8,0x866b,0x8877,0x8a3b,0x914e,0x92f3,0x99d0,0x6a17,
0x7026,0x732a,0x82e7,0x8457,0x8caf,0x4e01,0x5146,0x51cb,
0x558b,0x5bf5,0x5e16,0x5e33,0x5e81,0x5f14,0x5f35,0x5f6b,
0x5fb4,0x61f2,0x6311,0x66a2,0x671d,0x6f6e,0x7252,0x753a,
0x773a,0x8074,0x8139,0x8178,0x8776,0x8abf,0x8adc,0x8d85,
0x8df3,0x929a,0x9577,0x9802,0x9ce5,0x52c5,0x6357,0x76f4,
0x6715,0x6c88,0x73cd,0x8cc3,0x93ae,0x9673,0x6d25,0x589c,
0x690e,0x69cc,0x8ffd,0x939a,0x75db,0x901a,0x585a,0x6802,
0x63b4,0x69fb,0x4f43,0x6f2c,0x67d8,0x8fbb,0x8526,0x7db4,
0x9354,0x693f,0x6f70,0x576a,0x58f7,0x5b2c,0x7d2c,0x722a,
0x540a,0x91e3,0x9db4,0x4ead,0x4f4e,0x505c,0x5075,0x5243,
0x8c9e,0x5448,0x5824,0x5b9a,0x5e1d,0x5e95,0x5ead,0x5ef7,
0x5f1f,0x608c,0x62b5,0x633a,0x63d0,0x68af,0x6c40,0x7887,
0x798e,0x7a0b,0x7de0,0x8247,0x8a02,0x8ae6,0x8e44,0x9013,
0x90b8,0x912d,0x91d8,0x9f0e,0x6ce5,0x6458,0x64e2,0x6575,
0x6ef4,0x7684,0x7b1b,0x9069,0x93d1,0x6eba,0x54f2,0x5fb9,
0x64a4,0x8f4d,0x8fed,0x9244,0x5178,0x586b,0x5929,0x5c55,
0x5e97,0x6dfb,0x7e8f,0x751c,0x8cbc,0x8ee2,0x985b,0x70b9,
0x4f1d,0x6bbf,0x6fb1,0x7530,0x96fb,0x514e,0x5410,0x5835,
0x5857,0x59ac,0x5c60,0x5f92,0x6597,0x675c,0x6e21,0x767b,
0x83df,0x8ced,0x9014,0x90fd,0x934d,0x7825,0x783a,0x52aa,
0x5ea6,0x571f,0x5974,0x6012,0x5012,0x515a,0x51ac,0x51cd,
0x5200,0x5510,0x5854,0x5858,0x5957,0x5b95,0x5cf6,0x5d8b,
0x60bc,0x6295,0x642d,0x6771,0x6843,0x68bc,0x68df,0x76d7,
0x6dd8,0x6e6f,0x6d9b,0x706f,0x71c8,0x5f53,0x75d8,0x7977,
0x7b49,0x7b54,0x7b52,0x7cd6,0x7d71,0x5230,0x8463,0x8569,
0x85e4,0x8a0e,0x8b04,0x8c46,0x8e0f,0x9003,0x900f,0x9419,
0x9676,0x982d,0x9a30,0x95d8,0x50cd,0x52d5,0x540c,0x5802,
0x5c0e,0x61a7,0x649e,0x6d1e,0x77b3,0x7ae5,0x80f4,0x8404,
0x9053,0x9285,0x5ce0,0x9d07,0x533f,0x5f97,0x5fb3,0x6d9c,
0x7279,0x7763,0x79bf,0x7be4,0x6bd2,0x72ec,0x8aad,0x6803,
0x6a61,0x51f8,0x7a81,0x6934,0x5c4a,0x9cf6,0x82eb,0x5bc5,
0x9149,0x701e,0x5678,0x5c6f,0x60c7,0x6566,0x6c8c,0x8c5a,
0x9041,0x9813,0x5451,0x66c7,0x920d,0x5948,0x90a3,0x5185,
0x4e4d,0x51ea,0x8599,0x8b0e,0x7058,0x637a,0x934b,0x6962,
0x99b4,0x7e04,0x7577,0x5357,0x6960,0x8edf,0x96e3,0x6c5d,
0x4e8c,0x5c3c,0x5f10,0x8fe9,0x5302,0x8cd1,0x8089,0x8679,
0x5eff,0x65e5,0x4e73,0x5165,0x5982,0x5c3f,0x97ee,0x4efb,
0x598a,0x5fcd,0x8a8d,0x6fe1,0x79b0,0x7962,0x5be7,0x8471,
0x732b,0x71b1,0x5e74,0x5ff5,0x637b,0x649a,0x71c3,0x7c98,
0x4e43,0x5efc,0x4e4b,0x57dc,0x56a2,0x60a9,0x6fc3,0x7d0d,
0x80fd,0x8133,0x81bf,0x8fb2,0x8997,0x86a4,0x5df4,0x628a,
0x64ad,0x8987,0x6777,0x6ce2,0x6d3e,0x7436,0x7834,0x5a46,
0x7f75,0x82ad,0x99ac,0x4ff3,0x5ec3,0x62dd,0x6392,0x6557,
0x676f,0x76c3,0x724c,0x80cc,0x80ba,0x8f29,0x914d,0x500d,
0x57f9,0x5a92,0x6885,0x6973,0x7164,0x72fd,0x8cb7,0x58f2,
0x8ce0,0x966a,0x9019,0x877f,0x79e4,0x77e7,0x8429,0x4f2f,
0x5265,0x535a,0x62cd,0x67cf,0x6cca,0x767d,0x7b94,0x7c95,
0x8236,0x8584,0x8feb,0x66dd,0x6f20,0x7206,0x7e1b,0x83ab,
0x99c1,0x9ea6,0x51fd,0x7bb1,0x7872,0x7bb8,0x8087,0x7b48,
0x6ae8,0x5e61,0x808c,0x7551,0x7560,0x516b,0x9262,0x6e8c,
0x767a,0x9197,0x9aea,0x4f10,0x7f70,0x629c,0x7b4f,0x95a5,
0x9ce9,0x567a,0x5859,0x86e4,0x96bc,0x4f34,0x5224,0x534a,
0x53cd,0x53db,0x5e06,0x642c,0x6591,0x677f,0x6c3e,0x6c4e,
0x7248,0x72af,0x73ed,0x7554,0x7e41,0x822c,0x85e9,0x8ca9,
0x7bc4,0x91c6,0x7169,0x9812,0x98ef,0x633d,0x6669,0x756a,
0x76e4,0x78d0,0x8543,0x86ee,0x532a,0x5351,0x5426,0x5983,
0x5e87,0x5f7c,0x60b2,0x6249,0x6279,0x62ab,0x6590,0x6bd4,
0x6ccc,0x75b2,0x76ae,0x7891,0x79d8,0x7dcb,0x7f77,0x80a5,
0x88ab,0x8ab9,0x8cbb,0x907f,0x975e,0x98db,0x6a0b,0x7c38,
0x5099,0x5c3e,0x5fae,0x6787,0x6bd8,0x7435,0x7709,0x7f8e,
0x9f3b,0x67ca,0x7a17,0x5339,0x758b,0x9aed,0x5f66,0x819d,
0x83f1,0x8098,0x5f3c,0x5fc5,0x7562,0x7b46,0x903c,0x6867,
0x59eb,0x5a9b,0x7d10,0x767e,0x8b2c,0x4ff5,0x5f6a,0x6a19,
0x6c37,0x6f02,0x74e2,0x7968,0x8868,0x8a55,0x8c79,0x5edf,
0x63cf,0x75c5,0x79d2,0x82d7,0x9328,0x92f2,0x849c,0x86ed,
0x9c2d,0x54c1,0x5f6c,0x658c,0x6d5c,0x7015,0x8ca7,0x8cd3,
0x983b,0x654f,0x74f6,0x4e0d,0x4ed8,0x57e0,0x592b,0x5a66,
0x5bcc,0x51a8,0x5e03,0x5e9c,0x6016,0x6276,0x6577,0x65a7,
0x666e,0x6d6e,0x7236,0x7b26,0x8150,0x819a,0x8299,0x8b5c,
0x8ca0,0x8ce6,0x8d74,0x961c,0x9644,0x4fae,0x64ab,0x6b66,
0x821e,0x8461,0x856a,0x90e8,0x5c01,0x6953,0x98a8,0x847a,
0x8557,0x4f0f,0x526f,0x5fa9,0x5e45,0x670d,0x798f,0x8179,
0x8907,0x8986,0x6df5,0x5f17,0x6255,0x6cb8,0x4ecf,0x7269,
0x9b92,0x5206,0x543b,0x5674,0x58b3,0x61a4,0x626e,0x711a,
0x596e,0x7c89,0x7cde,0x7d1b,0x96f0,0x6587,0x805e,0x4e19,
0x4f75,0x5175,0x5840,0x5e63,0x5e73,0x5f0a,0x67c4,0x4e26,
0x853d,0x9589,0x965b,0x7c73,0x9801,0x50fb,0x58c1,0x7656,
0x78a7,0x5225,0x77a5,0x8511,0x7b86,0x504f,0x5909,0x7247,
0x7bc7,0x7de8,0x8fba,0x8fd4,0x904d,0x4fbf,0x52c9,0x5a29,
0x5f01,0x97ad,0x4fdd,0x8217,0x92ea,0x5703,0x6355,0x6b69,
0x752b,0x88dc,0x8f14,0x7a42,0x52df,0x5893,0x6155,0x620a,
0x66ae,0x6bcd,0x7c3f,0x83e9,0x5023,0x4ff8,0x5305,0x5446,
0x5831,0x5949,0x5b9d,0x5cf0,0x5cef,0x5d29,0x5e96,0x62b1,
0x6367,0x653e,0x65b9,0x670b,0x6cd5,0x6ce1,0x70f9,0x7832,
0x7e2b,0x80de,0x82b3,0x840c,0x84ec,0x8702,0x8912,0x8a2a,
0x8c4a,0x90a6,0x92d2,0x98fd,0x9cf3,0x9d6c,0x4e4f,0x4ea1,
0x508d,0x5256,0x574a,0x59a8,0x5e3d,0x5fd8,0x5fd9,0x623f,
0x66b4,0x671b,0x67d0,0x68d2,0x5192,0x7d21,0x80aa,0x81a8,
0x8b00,0x8c8c,0x8cbf,0x927e,0x9632,0x5420,0x982c,0x5317,
0x50d5,0x535c,0x58a8,0x64b2,0x6734,0x7267,0x7766,0x7a46,
0x91e6,0x52c3,0x6ca1,0x6b86,0x5800,0x5e4c,0x5954,0x672c,
0x7ffb,0x51e1,0x76c6,0x6469,0x78e8,0x9b54,0x9ebb,0x57cb,
0x59b9,0x6627,0x679a,0x6bce,0x54e9,0x69d9,0x5e55,0x819c,
0x6795,0x9baa,0x67fe,0x9c52,0x685d,0x4ea6,0x4fe3,0x53c8,
0x62b9,0x672b,0x6cab,0x8fc4,0x4fad,0x7e6d,0x9ebf,0x4e07,
0x6162,0x6e80,0x6f2b,0x8513,0x5473,0x672a,0x9b45,0x5df3,
0x7b95,0x5cac,0x5bc6,0x871c,0x6e4a,0x84d1,0x7a14,0x8108,
0x5999,0x7c8d,0x6c11,0x7720,0x52d9,0x5922,0x7121,0x725f,
0x77db,0x9727,0x9d61,0x690b,0x5a7f,0x5a18,0x51a5,0x540d,
0x547d,0x660e,0x76df,0x8ff7,0x9298,0x9cf4,0x59ea,0x725d,
0x6ec5,0x514d,0x68c9,0x7dbf,0x7dec,0x9762,0x9eba,0x6478,
0x6a21,0x8302,0x5984,0x5b5f,0x6bdb,0x731b,0x76f2,0x7db2,
0x8017,0x8499,0x5132,0x6728,0x9ed9,0x76ee,0x6762,0x52ff,
0x9905,0x5c24,0x623b,0x7c7e,0x8cb0,0x554f,0x60b6,0x7d0b,
0x9580,0x5301,0x4e5f,0x51b6,0x591c,0x723a,0x8036,0x91ce,
0x5f25,0x77e2,0x5384,0x5f79,0x7d04,0x85ac,0x8a33,0x8e8d,
0x9756,0x67f3,0x85ae,0x9453,0x6109,0x6108,0x6cb9,0x7652,
0x8aed,0x8f38,0x552f,0x4f51,0x512a,0x52c7,0x53cb,0x5ba5,
0x5e7d,0x60a0,0x6182,0x63d6,0x6709,0x67da,0x6e67,0x6d8c,
0x7336,0x7337,0x7531,0x7950,0x88d5,0x8a98,0x904a,0x9091,
0x90f5,0x96c4,0x878d,0x5915,0x4e88,0x4f59,0x4e0e,0x8a89,
0x8f3f,0x9810,0x50ad,0x5e7c,0x5996,0x5bb9,0x5eb8,0x63da,
0x63fa,0x64c1,0x66dc,0x694a,0x69d8,0x6d0b,0x6eb6,0x7194,
0x7528,0x7aaf,0x7f8a,0x8000,0x8449,0x84c9,0x8981,0x8b21,
0x8e0a,0x9065,0x967d,0x990a,0x617e,0x6291,0x6b32,0x6c83,
0x6d74,0x7fcc,0x7ffc,0x6dc0,0x7f85,0x87ba,0x88f8,0x6765,
0x83b1,0x983c,0x96f7,0x6d1b,0x7d61,0x843d,0x916a,0x4e71,
0x5375,0x5d50,0x6b04,0x6feb,0x85cd,0x862d,0x89a7,0x5229,
0x540f,0x5c65,0x674e,0x68a8,0x7406,0x7483,0x75e2,0x88cf,
0x88e1,0x91cc,0x96e2,0x9678,0x5f8b,0x7387,0x7acb,0x844e,
0x63a0,0x7565,0x5289,0x6d41,0x6e9c,0x7409,0x7559,0x786b,
0x7c92,0x9686,0x7adc,0x9f8d,0x4fb6,0x616e,0x65c5,0x865c,
0x4e86,0x4eae,0x50da,0x4e21,0x51cc,0x5bee,0x6599,0x6881,
0x6dbc,0x731f,0x7642,0x77ad,0x7a1c,0x7ce7,0x826f,0x8ad2,
0x907c,0x91cf,0x9675,0x9818,0x529b,0x7dd1,0x502b,0x5398,
0x6797,0x6dcb,0x71d0,0x7433,0x81e8,0x8f2a,0x96a3,0x9c57,
0x9e9f,0x7460,0x5841,0x6d99,0x7d2f,0x985e,0x4ee4,0x4f36,
0x4f8b,0x51b7,0x52b1,0x5dba,0x601c,0x73b2,0x793c,0x82d3,
0x9234,0x96b7,0x96f6,0x970a,0x9e97,0x9f62,0x66a6,0x6b74,
0x5217,0x52a3,0x70c8,0x88c2,0x5ec9,0x604b,0x6190,0x6f23,
0x7149,0x7c3e,0x7df4,0x806f,0x84ee,0x9023,0x932c,0x5442,
0x9b6f,0x6ad3,0x7089,0x8cc2,0x8def,0x9732,0x52b4,0x5a41,
0x5eca,0x5f04,0x6717,0x697c,0x6994,0x6d6a,0x6f0f,0x7262,
0x72fc,0x7bed,0x8001,0x807e,0x874b,0x90ce,0x516d,0x9e93,
0x7984,0x808b,0x9332,0x8ad6,0x502d,0x548c,0x8a71,0x6b6a,
0x8cc4,0x8107,0x60d1,0x67a0,0x9df2,0x4e99,0x4e98,0x9c10,
0x8a6b,0x85c1,0x8568,0x6900,0x6e7e,0x7897,0x8155,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x5f0c,0x4e10,0x4e15,0x4e2a,0x4e31,0x4e36,
0x4e3c,0x4e3f,0x4e42,0x4e56,0x4e58,0x4e82,0x4e85,0x8c6b,
0x4e8a,0x8212,0x5f0d,0x4e8e,0x4e9e,0x4e9f,0x4ea0,0x4ea2,
0x4eb0,0x4eb3,0x4eb6,0x4ece,0x4ecd,0x4ec4,0x4ec6,0x4ec2,
0x4ed7,0x4ede,0x4eed,0x4edf,0x4ef7,0x4f09,0x4f5a,0x4f30,
0x4f5b,0x4f5d,0x4f57,0x4f47,0x4f76,0x4f88,0x4f8f,0x4f98,
0x4f7b,0x4f69,0x4f70,0x4f91,0x4f6f,0x4f86,0x4f96,0x5118,
0x4fd4,0x4fdf,0x4fce,0x4fd8,0x4fdb,0x4fd1,0x4fda,0x4fd0,
0x4fe4,0x4fe5,0x501a,0x5028,0x5014,0x502a,0x5025,0x5005,
0x4f1c,0x4ff6,0x5021,0x5029,0x502c,0x4ffe,0x4fef,0x5011,
0x5006,0x5043,0x5047,0x6703,0x5055,0x5050,0x5048,0x505a,
0x5056,0x506c,0x5078,0x5080,0x509a,0x5085,0x50b4,0x50b2,
0x50c9,0x50ca,0x50b3,0x50c2,0x50d6,0x50de,0x50e5,0x50ed,
0x50e3,0x50ee,0x50f9,0x50f5,0x5109,0x5101,0x5102,0x5116,
0x5115,0x5114,0x511a,0x5121,0x513a,0x5137,0x513c,0x513b,
0x513f,0x5140,0x5152,0x514c,0x5154,0x5162,0x7af8,0x5169,
0x516a,0x516e,0x5180,0x5182,0x56d8,0x518c,0x5189,0x518f,
0x5191,0x5193,0x5195,0x5196,0x51a4,0x51a6,0x51a2,0x51a9,
0x51aa,0x51ab,0x51b3,0x51b1,0x51b2,0x51b0,0x51b5,0x51bd,
0x51c5,0x51c9,0x51db,0x51e0,0x8655,0x51e9,0x51ed,0x51f0,
0x51f5,0x51fe,0x5204,0x520b,0x5214,0x520e,0x5227,0x522a,
0x522e,0x5233,0x5239,0x524f,0x5244,0x524b,0x524c,0x525e,
0x5254,0x526a,0x5274,0x5269,0x5273,0x527f,0x527d,0x528d,
0x5294,0x5292,0x5271,0x5288,0x5291,0x8fa8,0x8fa7,0x52ac,
0x52ad,0x52bc,0x52b5,0x52c1,0x52cd,0x52d7,0x52de,0x52e3,
0x52e6,0x98ed,0x52e0,0x52f3,0x52f5,0x52f8,0x52f9,0x5306,
0x5308,0x7538,0x530d,0x5310,0x530f,0x5315,0x531a,0x5323,
0x532f,0x5331,0x5333,0x5338,0x5340,0x5346,0x5345,0x4e17,
0x5349,0x534d,0x51d6,0x535e,0x5369,0x536e,0x5918,0x537b,
0x5377,0x5382,0x5396,0x53a0,0x53a6,0x53a5,0x53ae,0x53b0,
0x53b6,0x53c3,0x7c12,0x96d9,0x53df,0x66fc,0x71ee,0x53ee,
0x53e8,0x53ed,0x53fa,0x5401,0x543d,0x5440,0x542c,0x542d,
0x543c,0x542e,0x5436,0x5429,0x541d,0x544e,0x548f,0x5475,
0x548e,0x545f,0x5471,0x5477,0x5470,0x5492,0x547b,0x5480,
0x5476,0x5484,0x5490,0x5486,0x54c7,0x54a2,0x54b8,0x54a5,
0x54ac,0x54c4,0x54c8,0x54a8,0x54ab,0x54c2,0x54a4,0x54be,
0x54bc,0x54d8,0x54e5,0x54e6,0x550f,0x5514,0x54fd,0x54ee,
0x54ed,0x54fa,0x54e2,0x5539,0x5540,0x5563,0x554c,0x552e,
0x555c,0x5545,0x5556,0x5557,0x5538,0x5533,0x555d,0x5599,
0x5580,0x54af,0x558a,0x559f,0x557b,0x557e,0x5598,0x559e,
0x55ae,0x557c,0x5583,0x55a9,0x5587,0x55a8,0x55da,0x55c5,
0x55df,0x55c4,0x55dc,0x55e4,0x55d4,0x5614,0x55f7,0x5616,
0x55fe,0x55fd,0x561b,0x55f9,0x564e,0x5650,0x71df,0x5634,
0x5636,0x5632,0x5638,0x566b,0x5664,0x562f,0x566c,0x566a,
0x5686,0x5680,0x568a,0x56a0,0x5694,0x568f,0x56a5,0x56ae,
0x56b6,0x56b4,0x56c2,0x56bc,0x56c1,0x56c3,0x56c0,0x56c8,
0x56ce,0x56d1,0x56d3,0x56d7,0x56ee,0x56f9,0x5700,0x56ff,
0x5704,0x5709,0x5708,0x570b,0x570d,0x5713,0x5718,0x5716,
0x55c7,0x571c,0x5726,0x5737,0x5738,0x574e,0x573b,0x5740,
0x574f,0x5769,0x57c0,0x5788,0x5761,0x577f,0x5789,0x5793,
0x57a0,0x57b3,0x57a4,0x57aa,0x57b0,0x57c3,0x57c6,0x57d4,
0x57d2,0x57d3,0x580a,0x57d6,0x57e3,0x580b,0x5819,0x581d,
0x5872,0x5821,0x5862,0x584b,0x5870,0x6bc0,0x5852,0x583d,
0x5879,0x5885,0x58b9,0x589f,0x58ab,0x58ba,0x58de,0x58bb,
0x58b8,0x58ae,0x58c5,0x58d3,0x58d1,0x58d7,0x58d9,0x58d8,
0x58e5,0x58dc,0x58e4,0x58df,0x58ef,0x58fa,0x58f9,0x58fb,
0x58fc,0x58fd,0x5902,0x590a,0x5910,0x591b,0x68a6,0x5925,
0x592c,0x592d,0x5932,0x5938,0x593e,0x7ad2,0x5955,0x5950,
0x594e,0x595a,0x5958,0x5962,0x5960,0x5967,0x596c,0x5969,
0x5978,0x5981,0x599d,0x4f5e,0x4fab,0x59a3,0x59b2,0x59c6,
0x59e8,0x59dc,0x598d,0x59d9,0x59da,0x5a25,0x5a1f,0x5a11,
0x5a1c,0x5a09,0x5a1a,0x5a40,0x5a6c,0x5a49,0x5a35,0x5a36,
0x5a62,0x5a6a,0x5a9a,0x5abc,0x5abe,0x5acb,0x5ac2,0x5abd,
0x5ae3,0x5ad7,0x5ae6,0x5ae9,0x5ad6,0x5afa,0x5afb,0x5b0c,
0x5b0b,0x5b16,0x5b32,0x5ad0,0x5b2a,0x5b36,0x5b3e,0x5b43,
0x5b45,0x5b40,0x5b51,0x5b55,0x5b5a,0x5b5b,0x5b65,0x5b69,
0x5b70,0x5b73,0x5b75,0x5b78,0x6588,0x5b7a,0x5b80,0x5b83,
0x5ba6,0x5bb8,0x5bc3,0x5bc7,0x5bc9,0x5bd4,0x5bd0,0x5be4,
0x5be6,0x5be2,0x5bde,0x5be5,0x5beb,0x5bf0,0x5bf6,0x5bf3,
0x5c05,0x5c07,0x5c08,0x5c0d,0x5c13,0x5c20,0x5c22,0x5c28,
0x5c38,0x5c39,0x5c41,0x5c46,0x5c4e,0x5c53,0x5c50,0x5c4f,
0x5b71,0x5c6c,0x5c6e,0x4e62,0x5c76,0x5c79,0x5c8c,0x5c91,
0x5c94,0x599b,0x5cab,0x5cbb,0x5cb6,0x5cbc,0x5cb7,0x5cc5,
0x5cbe,0x5cc7,0x5cd9,0x5ce9,0x5cfd,0x5cfa,0x5ced,0x5d8c,
0x5cea,0x5d0b,0x5d15,0x5d17,0x5d5c,0x5d1f,0x5d1b,0x5d11,
0x5d14,0x5d22,0x5d1a,0x5d19,0x5d18,0x5d4c,0x5d52,0x5d4e,
0x5d4b,0x5d6c,0x5d73,0x5d76,0x5d87,0x5d84,0x5d82,0x5da2,
0x5d9d,0x5dac,0x5dae,0x5dbd,0x5d90,0x5db7,0x5dbc,0x5dc9,
0x5dcd,0x5dd3,0x5dd2,0x5dd6,0x5ddb,0x5deb,0x5df2,0x5df5,
0x5e0b,0x5e1a,0x5e19,0x5e11,0x5e1b,0x5e36,0x5e37,0x5e44,
0x5e43,0x5e40,0x5e4e,0x5e57,0x5e54,0x5e5f,0x5e62,0x5e64,
0x5e47,0x5e75,0x5e76,0x5e7a,0x9ebc,0x5e7f,0x5ea0,0x5ec1,
0x5ec2,0x5ec8,0x5ed0,0x5ecf,0x5ed6,0x5ee3,0x5edd,0x5eda,
0x5edb,0x5ee2,0x5ee1,0x5ee8,0x5ee9,0x5eec,0x5ef1,0x5ef3,
0x5ef0,0x5ef4,0x5ef8,0x5efe,0x5f03,0x5f09,0x5f5d,0x5f5c,
0x5f0b,0x5f11,0x5f16,0x5f29,0x5f2d,0x5f38,0x5f41,0x5f48,
0x5f4c,0x5f4e,0x5f2f,0x5f51,0x5f56,0x5f57,0x5f59,0x5f61,
0x5f6d,0x5f73,0x5f77,0x5f83,0x5f82,0x5f7f,0x5f8a,0x5f88,
0x5f91,0x5f87,0x5f9e,0x5f99,0x5f98,0x5fa0,0x5fa8,0x5fad,
0x5fbc,0x5fd6,0x5ffb,0x5fe4,0x5ff8,0x5ff1,0x5fdd,0x60b3,
0x5fff,0x6021,0x6060,0x6019,0x6010,0x6029,0x600e,0x6031,
0x601b,0x6015,0x602b,0x6026,0x600f,0x603a,0x605a,0x6041,
0x606a,0x6077,0x605f,0x604a,0x6046,0x604d,0x6063,0x6043,
0x6064,0x6042,0x606c,0x606b,0x6059,0x6081,0x608d,0x60e7,
0x6083,0x609a,0x6084,0x609b,0x6096,0x6097,0x6092,0x60a7,
0x608b,0x60e1,0x60b8,0x60e0,0x60d3,0x60b4,0x5ff0,0x60bd,
0x60c6,0x60b5,0x60d8,0x614d,0x6115,0x6106,0x60f6,0x60f7,
0x6100,0x60f4,0x60fa,0x6103,0x6121,0x60fb,0x60f1,0x610d,
0x610e,0x6147,0x613e,0x6128,0x6127,0x614a,0x613f,0x613c,
0x612c,0x6134,0x613d,0x6142,0x6144,0x6173,0x6177,0x6158,
0x6159,0x615a,0x616b,0x6174,0x616f,0x6165,0x6171,0x615f,
0x615d,0x6153,0x6175,0x6199,0x6196,0x6187,0x61ac,0x6194,
0x619a,0x618a,0x6191,0x61ab,0x61ae,0x61cc,0x61ca,0x61c9,
0x61f7,0x61c8,0x61c3,0x61c6,0x61ba,0x61cb,0x7f79,0x61cd,
0x61e6,0x61e3,0x61f6,0x61fa,0x61f4,0x61ff,0x61fd,0x61fc,
0x61fe,0x6200,0x6208,0x6209,0x620d,0x620c,0x6214,0x621b,
0x621e,0x6221,0x622a,0x622e,0x6230,0x6232,0x6233,0x6241,
0x624e,0x625e,0x6263,0x625b,0x6260,0x6268,0x627c,0x6282,
0x6289,0x627e,0x6292,0x6293,0x6296,0x62d4,0x6283,0x6294,
0x62d7,0x62d1,0x62bb,0x62cf,0x62ff,0x62c6,0x64d4,0x62c8,
0x62dc,0x62cc,0x62ca,0x62c2,0x62c7,0x629b,0x62c9,0x630c,
0x62ee,0x62f1,0x6327,0x6302,0x6308,0x62ef,0x62f5,0x6350,
0x633e,0x634d,0x641c,0x634f,0x6396,0x638e,0x6380,0x63ab,
0x6376,0x63a3,0x638f,0x6389,0x639f,0x63b5,0x636b,0x6369,
0x63be,0x63e9,0x63c0,0x63c6,0x63e3,0x63c9,0x63d2,0x63f6,
0x63c4,0x6416,0x6434,0x6406,0x6413,0x6426,0x6436,0x651d,
0x6417,0x6428,0x640f,0x6467,0x646f,0x6476,0x644e,0x652a,
0x6495,0x6493,0x64a5,0x64a9,0x6488,0x64bc,0x64da,0x64d2,
0x64c5,0x64c7,0x64bb,0x64d8,0x64c2,0x64f1,0x64e7,0x8209,
0x64e0,0x64e1,0x62ac,0x64e3,0x64ef,0x652c,0x64f6,0x64f4,
0x64f2,0x64fa,0x6500,0x64fd,0x6518,0x651c,0x6505,0x6524,
0x6523,0x652b,0x6534,0x6535,0x6537,0x6536,0x6538,0x754b,
0x6548,0x6556,0x6555,0x654d,0x6558,0x655e,0x655d,0x6572,
0x6578,0x6582,0x6583,0x8b8a,0x659b,0x659f,0x65ab,0x65b7,
0x65c3,0x65c6,0x65c1,0x65c4,0x65cc,0x65d2,0x65db,0x65d9,
0x65e0,0x65e1,0x65f1,0x6772,0x660a,0x6603,0x65fb,0x6773,
0x6635,0x6636,0x6634,0x661c,0x664f,0x6644,0x6649,0x6641,
0x665e,0x665d,0x6664,0x6667,0x6668,0x665f,0x6662,0x6670,
0x6683,0x6688,0x668e,0x6689,0x6684,0x6698,0x669d,0x66c1,
0x66b9,0x66c9,0x66be,0x66bc,0x66c4,0x66b8,0x66d6,0x66da,
0x66e0,0x663f,0x66e6,0x66e9,0x66f0,0x66f5,0x66f7,0x670f,
0x6716,0x671e,0x6726,0x6727,0x9738,0x672e,0x673f,0x6736,
0x6741,0x6738,0x6737,0x6746,0x675e,0x6760,0x6759,0x6763,
0x6764,0x6789,0x6770,0x67a9,0x677c,0x676a,0x678c,0x678b,
0x67a6,0x67a1,0x6785,0x67b7,0x67ef,0x67b4,0x67ec,0x67b3,
0x67e9,0x67b8,0x67e4,0x67de,0x67dd,0x67e2,0x67ee,0x67b9,
0x67ce,0x67c6,0x67e7,0x6a9c,0x681e,0x6846,0x6829,0x6840,
0x684d,0x6832,0x684e,0x68b3,0x682b,0x6859,0x6863,0x6877,
0x687f,0x689f,0x688f,0x68ad,0x6894,0x689d,0x689b,0x6883,
0x6aae,0x68b9,0x6874,0x68b5,0x68a0,0x68ba,0x690f,0x688d,
0x687e,0x6901,0x68ca,0x6908,0x68d8,0x6922,0x6926,0x68e1,
0x690c,0x68cd,0x68d4,0x68e7,0x68d5,0x6936,0x6912,0x6904,
0x68d7,0x68e3,0x6925,0x68f9,0x68e0,0x68ef,0x6928,0x692a,
0x691a,0x6923,0x6921,0x68c6,0x6979,0x6977,0x695c,0x6978,
0x696b,0x6954,0x697e,0x696e,0x6939,0x6974,0x693d,0x6959,
0x6930,0x6961,0x695e,0x695d,0x6981,0x696a,0x69b2,0x69ae,
0x69d0,0x69bf,0x69c1,0x69d3,0x69be,0x69ce,0x5be8,0x69ca,
0x69dd,0x69bb,0x69c3,0x69a7,0x6a2e,0x6991,0x69a0,0x699c,
0x6995,0x69b4,0x69de,0x69e8,0x6a02,0x6a1b,0x69ff,0x6b0a,
0x69f9,0x69f2,0x69e7,0x6a05,0x69b1,0x6a1e,0x69ed,0x6a14,
0x69eb,0x6a0a,0x6a12,0x6ac1,0x6a23,0x6a13,0x6a44,0x6a0c,
0x6a72,0x6a36,0x6a78,0x6a47,0x6a62,0x6a59,0x6a66,0x6a48,
0x6a38,0x6a22,0x6a90,0x6a8d,0x6aa0,0x6a84,0x6aa2,0x6aa3,
0x6a97,0x8617,0x6abb,0x6ac3,0x6ac2,0x6ab8,0x6ab3,0x6aac,
0x6ade,0x6ad1,0x6adf,0x6aaa,0x6ada,0x6aea,0x6afb,0x6b05,
0x8616,0x6afa,0x6b12,0x6b16,0x9b31,0x6b1f,0x6b38,0x6b37,
0x76dc,0x6b39,0x98ee,0x6b47,0x6b43,0x6b49,0x6b50,0x6b59,
0x6b54,0x6b5b,0x6b5f,0x6b61,0x6b78,0x6b79,0x6b7f,0x6b80,
0x6b84,0x6b83,0x6b8d,0x6b98,0x6b95,0x6b9e,0x6ba4,0x6baa,
0x6bab,0x6baf,0x6bb2,0x6bb1,0x6bb3,0x6bb7,0x6bbc,0x6bc6,
0x6bcb,0x6bd3,0x6bdf,0x6bec,0x6beb,0x6bf3,0x6bef,0x9ebe,
0x6c08,0x6c13,0x6c14,0x6c1b,0x6c24,0x6c23,0x6c5e,0x6c55,
0x6c62,0x6c6a,0x6c82,0x6c8d,0x6c9a,0x6c81,0x6c9b,0x6c7e,
0x6c68,0x6c73,0x6c92,0x6c90,0x6cc4,0x6cf1,0x6cd3,0x6cbd,
0x6cd7,0x6cc5,0x6cdd,0x6cae,0x6cb1,0x6cbe,0x6cba,0x6cdb,
0x6cef,0x6cd9,0x6cea,0x6d1f,0x884d,0x6d36,0x6d2b,0x6d3d,
0x6d38,0x6d19,0x6d35,0x6d33,0x6d12,0x6d0c,0x6d63,0x6d93,
0x6d64,0x6d5a,0x6d79,0x6d59,0x6d8e,0x6d95,0x6fe4,0x6d85,
0x6df9,0x6e15,0x6e0a,0x6db5,0x6dc7,0x6de6,0x6db8,0x6dc6,
0x6dec,0x6dde,0x6dcc,0x6de8,0x6dd2,0x6dc5,0x6dfa,0x6dd9,
0x6de4,0x6dd5,0x6dea,0x6dee,0x6e2d,0x6e6e,0x6e2e,0x6e19,
0x6e72,0x6e5f,0x6e3e,0x6e23,0x6e6b,0x6e2b,0x6e76,0x6e4d,
0x6e1f,0x6e43,0x6e3a,0x6e4e,0x6e24,0x6eff,0x6e1d,0x6e38,
0x6e82,0x6eaa,0x6e98,0x6ec9,0x6eb7,0x6ed3,0x6ebd,0x6eaf,
0x6ec4,0x6eb2,0x6ed4,0x6ed5,0x6e8f,0x6ea5,0x6ec2,0x6e9f,
0x6f41,0x6f11,0x704c,0x6eec,0x6ef8,0x6efe,0x6f3f,0x6ef2,
0x6f31,0x6eef,0x6f32,0x6ecc,0x6f3e,0x6f13,0x6ef7,0x6f86,
0x6f7a,0x6f78,0x6f81,0x6f80,0x6f6f,0x6f5b,0x6ff3,0x6f6d,
0x6f82,0x6f7c,0x6f58,0x6f8e,0x6f91,0x6fc2,0x6f66,0x6fb3,
0x6fa3,0x6fa1,0x6fa4,0x6fb9,0x6fc6,0x6faa,0x6fdf,0x6fd5,
0x6fec,0x6fd4,0x6fd8,0x6ff1,0x6fee,0x6fdb,0x7009,0x700b,
0x6ffa,0x7011,0x7001,0x700f,0x6ffe,0x701b,0x701a,0x6f74,
0x701d,0x7018,0x701f,0x7030,0x703e,0x7032,0x7051,0x7063,
0x7099,0x7092,0x70af,0x70f1,0x70ac,0x70b8,0x70b3,0x70ae,
0x70df,0x70cb,0x70dd,0x70d9,0x7109,0x70fd,0x711c,0x7119,
0x7165,0x7155,0x7188,0x7166,0x7162,0x714c,0x7156,0x716c,
0x718f,0x71fb,0x7184,0x7195,0x71a8,0x71ac,0x71d7,0x71b9,
0x71be,0x71d2,0x71c9,0x71d4,0x71ce,0x71e0,0x71ec,0x71e7,
0x71f5,0x71fc,0x71f9,0x71ff,0x720d,0x7210,0x721b,0x7228,
0x722d,0x722c,0x7230,0x7232,0x723b,0x723c,0x723f,0x7240,
0x7246,0x724b,0x7258,0x7274,0x727e,0x7282,0x7281,0x7287,
0x7292,0x7296,0x72a2,0x72a7,0x72b9,0x72b2,0x72c3,0x72c6,
0x72c4,0x72ce,0x72d2,0x72e2,0x72e0,0x72e1,0x72f9,0x72f7,
0x500f,0x7317,0x730a,0x731c,0x7316,0x731d,0x7334,0x732f,
0x7329,0x7325,0x733e,0x734e,0x734f,0x9ed8,0x7357,0x736a,
0x7368,0x7370,0x7378,0x7375,0x737b,0x737a,0x73c8,0x73b3,
0x73ce,0x73bb,0x73c0,0x73e5,0x73ee,0x73de,0x74a2,0x7405,
0x746f,0x7425,0x73f8,0x7432,0x743a,0x7455,0x743f,0x745f,
0x7459,0x7441,0x745c,0x7469,0x7470,0x7463,0x746a,0x7476,
0x747e,0x748b,0x749e,0x74a7,0x74ca,0x74cf,0x74d4,0x73f1,
0x74e0,0x74e3,0x74e7,0x74e9,0x74ee,0x74f2,0x74f0,0x74f1,
0x74f8,0x74f7,0x7504,0x7503,0x7505,0x750c,0x750e,0x750d,
0x7515,0x7513,0x751e,0x7526,0x752c,0x753c,0x7544,0x754d,
0x754a,0x7549,0x755b,0x7546,0x755a,0x7569,0x7564,0x7567,
0x756b,0x756d,0x7578,0x7576,0x7586,0x7587,0x7574,0x758a,
0x7589,0x7582,0x7594,0x759a,0x759d,0x75a5,0x75a3,0x75c2,
0x75b3,0x75c3,0x75b5,0x75bd,0x75b8,0x75bc,0x75b1,0x75cd,
0x75ca,0x75d2,0x75d9,0x75e3,0x75de,0x75fe,0x75ff,0x75fc,
0x7601,0x75f0,0x75fa,0x75f2,0x75f3,0x760b,0x760d,0x7609,
0x761f,0x7627,0x7620,0x7621,0x7622,0x7624,0x7634,0x7630,
0x763b,0x7647,0x7648,0x7646,0x765c,0x7658,0x7661,0x7662,
0x7668,0x7669,0x766a,0x7667,0x766c,0x7670,0x7672,0x7676,
0x7678,0x767c,0x7680,0x7683,0x7688,0x768b,0x768e,0x7696,
0x7693,0x7699,0x769a,0x76b0,0x76b4,0x76b8,0x76b9,0x76ba,
0x76c2,0x76cd,0x76d6,0x76d2,0x76de,0x76e1,0x76e5,0x76e7,
0x76ea,0x862f,0x76fb,0x7708,0x7707,0x7704,0x7729,0x7724,
0x771e,0x7725,0x7726,0x771b,0x7737,0x7738,0x7747,0x775a,
0x7768,0x776b,0x775b,0x7765,0x777f,0x777e,0x7779,0x778e,
0x778b,0x7791,0x77a0,0x779e,0x77b0,0x77b6,0x77b9,0x77bf,
0x77bc,0x77bd,0x77bb,0x77c7,0x77cd,0x77d7,0x77da,0x77dc,
0x77e3,0x77ee,0x77fc,0x780c,0x7812,0x7926,0x7820,0x792a,
0x7845,0x788e,0x7874,0x7886,0x787c,0x789a,0x788c,0x78a3,
0x78b5,0x78aa,0x78af,0x78d1,0x78c6,0x78cb,0x78d4,0x78be,
0x78bc,0x78c5,0x78ca,0x78ec,0x78e7,0x78da,0x78fd,0x78f4,
0x7907,0x7912,0x7911,0x7919,0x792c,0x792b,0x7940,0x7960,
0x7957,0x795f,0x795a,0x7955,0x7953,0x797a,0x797f,0x798a,
0x799d,0x79a7,0x9f4b,0x79aa,0x79ae,0x79b3,0x79b9,0x79ba,
0x79c9,0x79d5,0x79e7,0x79ec,0x79e1,0x79e3,0x7a08,0x7a0d,
0x7a18,0x7a19,0x7a20,0x7a1f,0x7980,0x7a31,0x7a3b,0x7a3e,
0x7a37,0x7a43,0x7a57,0x7a49,0x7a61,0x7a62,0x7a69,0x9f9d,
0x7a70,0x7a79,0x7a7d,0x7a88,0x7a97,0x7a95,0x7a98,0x7a96,
0x7aa9,0x7ac8,0x7ab0,0x7ab6,0x7ac5,0x7ac4,0x7abf,0x9083,
0x7ac7,0x7aca,0x7acd,0x7acf,0x7ad5,0x7ad3,0x7ad9,0x7ada,
0x7add,0x7ae1,0x7ae2,0x7ae6,0x7aed,0x7af0,0x7b02,0x7b0f,
0x7b0a,0x7b06,0x7b33,0x7b18,0x7b19,0x7b1e,0x7b35,0x7b28,
0x7b36,0x7b50,0x7b7a,0x7b04,0x7b4d,0x7b0b,0x7b4c,0x7b45,
0x7b75,0x7b65,0x7b74,0x7b67,0x7b70,0x7b71,0x7b6c,0x7b6e,
0x7b9d,0x7b98,0x7b9f,0x7b8d,0x7b9c,0x7b9a,0x7b8b,0x7b92,
0x7b8f,0x7b5d,0x7b99,0x7bcb,0x7bc1,0x7bcc,0x7bcf,0x7bb4,
0x7bc6,0x7bdd,0x7be9,0x7c11,0x7c14,0x7be6,0x7be5,0x7c60,
0x7c00,0x7c07,0x7c13,0x7bf3,0x7bf7,0x7c17,0x7c0d,0x7bf6,
0x7c23,0x7c27,0x7c2a,0x7c1f,0x7c37,0x7c2b,0x7c3d,0x7c4c,
0x7c43,0x7c54,0x7c4f,0x7c40,0x7c50,0x7c58,0x7c5f,0x7c64,
0x7c56,0x7c65,0x7c6c,0x7c75,0x7c83,0x7c90,0x7ca4,0x7cad,
0x7ca2,0x7cab,0x7ca1,0x7ca8,0x7cb3,0x7cb2,0x7cb1,0x7cae,
0x7cb9,0x7cbd,0x7cc0,0x7cc5,0x7cc2,0x7cd8,0x7cd2,0x7cdc,
0x7ce2,0x9b3b,0x7cef,0x7cf2,0x7cf4,0x7cf6,0x7cfa,0x7d06,
0x7d02,0x7d1c,0x7d15,0x7d0a,0x7d45,0x7d4b,0x7d2e,0x7d32,
0x7d3f,0x7d35,0x7d46,0x7d73,0x7d56,0x7d4e,0x7d72,0x7d68,
0x7d6e,0x7d4f,0x7d63,0x7d93,0x7d89,0x7d5b,0x7d8f,0x7d7d,
0x7d9b,0x7dba,0x7dae,0x7da3,0x7db5,0x7dc7,0x7dbd,0x7dab,
0x7e3d,0x7da2,0x7daf,0x7ddc,0x7db8,0x7d9f,0x7db0,0x7dd8,
0x7ddd,0x7de4,0x7dde,0x7dfb,0x7df2,0x7de1,0x7e05,0x7e0a,
0x7e23,0x7e21,0x7e12,0x7e31,0x7e1f,0x7e09,0x7e0b,0x7e22,
0x7e46,0x7e66,0x7e3b,0x7e35,0x7e39,0x7e43,0x7e37,0x7e32,
0x7e3a,0x7e67,0x7e5d,0x7e56,0x7e5e,0x7e59,0x7e5a,0x7e79,
0x7e6a,0x7e69,0x7e7c,0x7e7b,0x7e83,0x7dd5,0x7e7d,0x8fae,
0x7e7f,0x7e88,0x7e89,0x7e8c,0x7e92,0x7e90,0x7e93,0x7e94,
0x7e96,0x7e8e,0x7e9b,0x7e9c,0x7f38,0x7f3a,0x7f45,0x7f4c,
0x7f4d,0x7f4e,0x7f50,0x7f51,0x7f55,0x7f54,0x7f58,0x7f5f,
0x7f60,0x7f68,0x7f69,0x7f67,0x7f78,0x7f82,0x7f86,0x7f83,
0x7f88,0x7f87,0x7f8c,0x7f94,0x7f9e,0x7f9d,0x7f9a,0x7fa3,
0x7faf,0x7fb2,0x7fb9,0x7fae,0x7fb6,0x7fb8,0x8b71,0x7fc5,
0x7fc6,0x7fca,0x7fd5,0x7fd4,0x7fe1,0x7fe6,0x7fe9,0x7ff3,
0x7ff9,0x98dc,0x8006,0x8004,0x800b,0x8012,0x8018,0x8019,
0x801c,0x8021,0x8028,0x803f,0x803b,0x804a,0x8046,0x8052,
0x8058,0x805a,0x805f,0x8062,0x8068,0x8073,0x8072,0x8070,
0x8076,0x8079,0x807d,0x807f,0x8084,0x8086,0x8085,0x809b,
0x8093,0x809a,0x80ad,0x5190,0x80ac,0x80db,0x80e5,0x80d9,
0x80dd,0x80c4,0x80da,0x80d6,0x8109,0x80ef,0x80f1,0x811b,
0x8129,0x8123,0x812f,0x814b,0x968b,0x8146,0x813e,0x8153,
0x8151,0x80fc,0x8171,0x816e,0x8165,0x8166,0x8174,0x8183,
0x8188,0x818a,0x8180,0x8182,0x81a0,0x8195,0x81a4,0x81a3,
0x815f,0x8193,0x81a9,0x81b0,0x81b5,0x81be,0x81b8,0x81bd,
0x81c0,0x81c2,0x81ba,0x81c9,0x81cd,0x81d1,0x81d9,0x81d8,
0x81c8,0x81da,0x81df,0x81e0,0x81e7,0x81fa,0x81fb,0x81fe,
0x8201,0x8202,0x8205,0x8207,0x820a,0x820d,0x8210,0x8216,
0x8229,0x822b,0x8238,0x8233,0x8240,0x8259,0x8258,0x825d,
0x825a,0x825f,0x8264,0x8262,0x8268,0x826a,0x826b,0x822e,
0x8271,0x8277,0x8278,0x827e,0x828d,0x8292,0x82ab,0x829f,
0x82bb,0x82ac,0x82e1,0x82e3,0x82df,0x82d2,0x82f4,0x82f3,
0x82fa,0x8393,0x8303,0x82fb,0x82f9,0x82de,0x8306,0x82dc,
0x8309,0x82d9,0x8335,0x8334,0x8316,0x8332,0x8331,0x8340,
0x8339,0x8350,0x8345,0x832f,0x832b,0x8317,0x8318,0x8385,
0x839a,0x83aa,0x839f,0x83a2,0x8396,0x8323,0x838e,0x8387,
0x838a,0x837c,0x83b5,0x8373,0x8375,0x83a0,0x8389,0x83a8,
0x83f4,0x8413,0x83eb,0x83ce,0x83fd,0x8403,0x83d8,0x840b,
0x83c1,0x83f7,0x8407,0x83e0,0x83f2,0x840d,0x8422,0x8420,
0x83bd,0x8438,0x8506,0x83fb,0x846d,0x842a,0x843c,0x855a,
0x8484,0x8477,0x846b,0x84ad,0x846e,0x8482,0x8469,0x8446,
0x842c,0x846f,0x8479,0x8435,0x84ca,0x8462,0x84b9,0x84bf,
0x849f,0x84d9,0x84cd,0x84bb,0x84da,0x84d0,0x84c1,0x84c6,
0x84d6,0x84a1,0x8521,0x84ff,0x84f4,0x8517,0x8518,0x852c,
0x851f,0x8515,0x8514,0x84fc,0x8540,0x8563,0x8558,0x8548,
0x8541,0x8602,0x854b,0x8555,0x8580,0x85a4,0x8588,0x8591,
0x858a,0x85a8,0x856d,0x8594,0x859b,0x85ea,0x8587,0x859c,
0x8577,0x857e,0x8590,0x85c9,0x85ba,0x85cf,0x85b9,0x85d0,
0x85d5,0x85dd,0x85e5,0x85dc,0x85f9,0x860a,0x8613,0x860b,
0x85fe,0x85fa,0x8606,0x8622,0x861a,0x8630,0x863f,0x864d,
0x4e55,0x8654,0x865f,0x8667,0x8671,0x8693,0x86a3,0x86a9,
0x86aa,0x868b,0x868c,0x86b6,0x86af,0x86c4,0x86c6,0x86b0,
0x86c9,0x8823,0x86ab,0x86d4,0x86de,0x86e9,0x86ec,0x86df,
0x86db,0x86ef,0x8712,0x8706,0x8708,0x8700,0x8703,0x86fb,
0x8711,0x8709,0x870d,0x86f9,0x870a,0x8734,0x873f,0x8737,
0x873b,0x8725,0x8729,0x871a,0x8760,0x875f,0x8778,0x874c,
0x874e,0x8774,0x8757,0x8768,0x876e,0x8759,0x8753,0x8763,
0x876a,0x8805,0x87a2,0x879f,0x8782,0x87af,0x87cb,0x87bd,
0x87c0,0x87d0,0x96d6,0x87ab,0x87c4,0x87b3,0x87c7,0x87c6,
0x87bb,0x87ef,0x87f2,0x87e0,0x880f,0x880d,0x87fe,0x87f6,
0x87f7,0x880e,0x87d2,0x8811,0x8816,0x8815,0x8822,0x8821,
0x8831,0x8836,0x8839,0x8827,0x883b,0x8844,0x8842,0x8852,
0x8859,0x885e,0x8862,0x886b,0x8881,0x887e,0x889e,0x8875,
0x887d,0x88b5,0x8872,0x8882,0x8897,0x8892,0x88ae,0x8899,
0x88a2,0x888d,0x88a4,0x88b0,0x88bf,0x88b1,0x88c3,0x88c4,
0x88d4,0x88d8,0x88d9,0x88dd,0x88f9,0x8902,0x88fc,0x88f4,
0x88e8,0x88f2,0x8904,0x890c,0x890a,0x8913,0x8943,0x891e,
0x8925,0x892a,0x892b,0x8941,0x8944,0x893b,0x8936,0x8938,
0x894c,0x891d,0x8960,0x895e,0x8966,0x8964,0x896d,0x896a,
0x896f,0x8974,0x8977,0x897e,0x8983,0x8988,0x898a,0x8993,
0x8998,0x89a1,0x89a9,0x89a6,0x89ac,0x89af,0x89b2,0x89ba,
0x89bd,0x89bf,0x89c0,0x89da,0x89dc,0x89dd,0x89e7,0x89f4,
0x89f8,0x8a03,0x8a16,0x8a10,0x8a0c,0x8a1b,0x8a1d,0x8a25,
0x8a36,0x8a41,0x8a5b,0x8a52,0x8a46,0x8a48,0x8a7c,0x8a6d,
0x8a6c,0x8a62,0x8a85,0x8a82,0x8a84,0x8aa8,0x8aa1,0x8a91,
0x8aa5,0x8aa6,0x8a9a,0x8aa3,0x8ac4,0x8acd,0x8ac2,0x8ada,
0x8aeb,0x8af3,0x8ae7,0x8ae4,0x8af1,0x8b14,0x8ae0,0x8ae2,
0x8af7,0x8ade,0x8adb,0x8b0c,0x8b07,0x8b1a,0x8ae1,0x8b16,
0x8b10,0x8b17,0x8b20,0x8b33,0x97ab,0x8b26,0x8b2b,0x8b3e,
0x8b28,0x8b41,0x8b4c,0x8b4f,0x8b4e,0x8b49,0x8b56,0x8b5b,
0x8b5a,0x8b6b,0x8b5f,0x8b6c,0x8b6f,0x8b74,0x8b7d,0x8b80,
0x8b8c,0x8b8e,0x8b92,0x8b93,0x8b96,0x8b99,0x8b9a,0x8c3a,
0x8c41,0x8c3f,0x8c48,0x8c4c,0x8c4e,0x8c50,0x8c55,0x8c62,
0x8c6c,0x8c78,0x8c7a,0x8c82,0x8c89,0x8c85,0x8c8a,0x8c8d,
0x8c8e,0x8c94,0x8c7c,0x8c98,0x621d,0x8cad,0x8caa,0x8cbd,
0x8cb2,0x8cb3,0x8cae,0x8cb6,0x8cc8,0x8cc1,0x8ce4,0x8ce3,
0x8cda,0x8cfd,0x8cfa,0x8cfb,0x8d04,0x8d05,0x8d0a,0x8d07,
0x8d0f,0x8d0d,0x8d10,0x9f4e,0x8d13,0x8ccd,0x8d14,0x8d16,
0x8d67,0x8d6d,0x8d71,0x8d73,0x8d81,0x8d99,0x8dc2,0x8dbe,
0x8dba,0x8dcf,0x8dda,0x8dd6,0x8dcc,0x8ddb,0x8dcb,0x8dea,
0x8deb,0x8ddf,0x8de3,0x8dfc,0x8e08,0x8e09,0x8dff,0x8e1d,
0x8e1e,0x8e10,0x8e1f,0x8e42,0x8e35,0x8e30,0x8e34,0x8e4a,
0x8e47,0x8e49,0x8e4c,0x8e50,0x8e48,0x8e59,0x8e64,0x8e60,
0x8e2a,0x8e63,0x8e55,0x8e76,0x8e72,0x8e7c,0x8e81,0x8e87,
0x8e85,0x8e84,0x8e8b,0x8e8a,0x8e93,0x8e91,0x8e94,0x8e99,
0x8eaa,0x8ea1,0x8eac,0x8eb0,0x8ec6,0x8eb1,0x8ebe,0x8ec5,
0x8ec8,0x8ecb,0x8edb,0x8ee3,0x8efc,0x8efb,0x8eeb,0x8efe,
0x8f0a,0x8f05,0x8f15,0x8f12,0x8f19,0x8f13,0x8f1c,0x8f1f,
0x8f1b,0x8f0c,0x8f26,0x8f33,0x8f3b,0x8f39,0x8f45,0x8f42,
0x8f3e,0x8f4c,0x8f49,0x8f46,0x8f4e,0x8f57,0x8f5c,0x8f62,
0x8f63,0x8f64,0x8f9c,0x8f9f,0x8fa3,0x8fad,0x8faf,0x8fb7,
0x8fda,0x8fe5,0x8fe2,0x8fea,0x8fef,0x9087,0x8ff4,0x9005,
0x8ff9,0x8ffa,0x9011,0x9015,0x9021,0x900d,0x901e,0x9016,
0x900b,0x9027,0x9036,0x9035,0x9039,0x8ff8,0x904f,0x9050,
0x9051,0x9052,0x900e,0x9049,0x903e,0x9056,0x9058,0x905e,
0x9068,0x906f,0x9076,0x96a8,0x9072,0x9082,0x907d,0x9081,
0x9080,0x908a,0x9089,0x908f,0x90a8,0x90af,0x90b1,0x90b5,
0x90e2,0x90e4,0x6248,0x90db,0x9102,0x9112,0x9119,0x9132,
0x9130,0x914a,0x9156,0x9158,0x9163,0x9165,0x9169,0x9173,
0x9172,0x918b,0x9189,0x9182,0x91a2,0x91ab,0x91af,0x91aa,
0x91b5,0x91b4,0x91ba,0x91c0,0x91c1,0x91c9,0x91cb,0x91d0,
0x91d6,0x91df,0x91e1,0x91db,0x91fc,0x91f5,0x91f6,0x921e,
0x91ff,0x9214,0x922c,0x9215,0x9211,0x925e,0x9257,0x9245,
0x9249,0x9264,0x9248,0x9295,0x923f,0x924b,0x9250,0x929c,
0x9296,0x9293,0x929b,0x925a,0x92cf,0x92b9,0x92b7,0x92e9,
0x930f,0x92fa,0x9344,0x932e,0x9319,0x9322,0x931a,0x9323,
0x933a,0x9335,0x933b,0x935c,0x9360,0x937c,0x936e,0x9356,
0x93b0,0x93ac,0x93ad,0x9394,0x93b9,0x93d6,0x93d7,0x93e8,
0x93e5,0x93d8,0x93c3,0x93dd,0x93d0,0x93c8,0x93e4,0x941a,
0x9414,0x9413,0x9403,0x9407,0x9410,0x9436,0x942b,0x9435,
0x9421,0x943a,0x9441,0x9452,0x9444,0x945b,0x9460,0x9462,
0x945e,0x946a,0x9229,0x9470,0x9475,0x9477,0x947d,0x945a,
0x947c,0x947e,0x9481,0x947f,0x9582,0x9587,0x958a,0x9594,
0x9596,0x9598,0x9599,0x95a0,0x95a8,0x95a7,0x95ad,0x95bc,
0x95bb,0x95b9,0x95be,0x95ca,0x6ff6,0x95c3,0x95cd,0x95cc,
0x95d5,0x95d4,0x95d6,0x95dc,0x95e1,0x95e5,0x95e2,0x9621,
0x9628,0x962e,0x962f,0x9642,0x964c,0x964f,0x964b,0x9677,
0x965c,0x965e,0x965d,0x965f,0x9666,0x9672,0x966c,0x968d,
0x9698,0x9695,0x9697,0x96aa,0x96a7,0x96b1,0x96b2,0x96b0,
0x96b4,0x96b6,0x96b8,0x96b9,0x96ce,0x96cb,0x96c9,0x96cd,
0x894d,0x96dc,0x970d,0x96d5,0x96f9,0x9704,0x9706,0x9708,
0x9713,0x970e,0x9711,0x970f,0x9716,0x9719,0x9724,0x972a,
0x9730,0x9739,0x973d,0x973e,0x9744,0x9746,0x9748,0x9742,
0x9749,0x975c,0x9760,0x9764,0x9766,0x9768,0x52d2,0x976b,
0x9771,0x9779,0x9785,0x977c,0x9781,0x977a,0x9786,0x978b,
0x978f,0x9790,0x979c,0x97a8,0x97a6,0x97a3,0x97b3,0x97b4,
0x97c3,0x97c6,0x97c8,0x97cb,0x97dc,0x97ed,0x9f4f,0x97f2,
0x7adf,0x97f6,0x97f5,0x980f,0x980c,0x9838,0x9824,0x9821,
0x9837,0x983d,0x9846,0x984f,0x984b,0x986b,0x986f,0x9870,
0x9871,0x9874,0x9873,0x98aa,0x98af,0x98b1,0x98b6,0x98c4,
0x98c3,0x98c6,0x98e9,0x98eb,0x9903,0x9909,0x9912,0x9914,
0x9918,0x9921,0x991d,0x991e,0x9924,0x9920,0x992c,0x992e,
0x993d,0x993e,0x9942,0x9949,0x9945,0x9950,0x994b,0x9951,
0x9952,0x994c,0x9955,0x9997,0x9998,0x99a5,0x99ad,0x99ae,
0x99bc,0x99df,0x99db,0x99dd,0x99d8,0x99d1,0x99ed,0x99ee,
0x99f1,0x99f2,0x99fb,0x99f8,0x9a01,0x9a0f,0x9a05,0x99e2,
0x9a19,0x9a2b,0x9a37,0x9a45,0x9a42,0x9a40,0x9a43,0x9a3e,
0x9a55,0x9a4d,0x9a5b,0x9a57,0x9a5f,0x9a62,0x9a65,0x9a64,
0x9a69,0x9a6b,0x9a6a,0x9aad,0x9ab0,0x9abc,0x9ac0,0x9acf,
0x9ad1,0x9ad3,0x9ad4,0x9ade,0x9adf,0x9ae2,0x9ae3,0x9ae6,
0x9aef,0x9aeb,0x9aee,0x9af4,0x9af1,0x9af7,0x9afb,0x9b06,
0x9b18,0x9b1a,0x9b1f,0x9b22,0x9b23,0x9b25,0x9b27,0x9b28,
0x9b29,0x9b2a,0x9b2e,0x9b2f,0x9b32,0x9b44,0x9b43,0x9b4f,
0x9b4d,0x9b4e,0x9b51,0x9b58,0x9b74,0x9b93,0x9b83,0x9b91,
0x9b96,0x9b97,0x9b9f,0x9ba0,0x9ba8,0x9bb4,0x9bc0,0x9bca,
0x9bb9,0x9bc6,0x9bcf,0x9bd1,0x9bd2,0x9be3,0x9be2,0x9be4,
0x9bd4,0x9be1,0x9c3a,0x9bf2,0x9bf1,0x9bf0,0x9c15,0x9c14,
0x9c09,0x9c13,0x9c0c,0x9c06,0x9c08,0x9c12,0x9c0a,0x9c04,
0x9c2e,0x9c1b,0x9c25,0x9c24,0x9c21,0x9c30,0x9c47,0x9c32,
0x9c46,0x9c3e,0x9c5a,0x9c60,0x9c67,0x9c76,0x9c78,0x9ce7,
0x9cec,0x9cf0,0x9d09,0x9d08,0x9ceb,0x9d03,0x9d06,0x9d2a,
0x9d26,0x9daf,0x9d23,0x9d1f,0x9d44,0x9d15,0x9d12,0x9d41,
0x9d3f,0x9d3e,0x9d46,0x9d48,0x9d5d,0x9d5e,0x9d64,0x9d51,
0x9d50,0x9d59,0x9d72,0x9d89,0x9d87,0x9dab,0x9d6f,0x9d7a,
0x9d9a,0x9da4,0x9da9,0x9db2,0x9dc4,0x9dc1,0x9dbb,0x9db8,
0x9dba,0x9dc6,0x9dcf,0x9dc2,0x9dd9,0x9dd3,0x9df8,0x9de6,
0x9ded,0x9def,0x9dfd,0x9e1a,0x9e1b,0x9e1e,0x9e75,0x9e79,
0x9e7d,0x9e81,0x9e88,0x9e8b,0x9e8c,0x9e92,0x9e95,0x9e91,
0x9e9d,0x9ea5,0x9ea9,0x9eb8,0x9eaa,0x9ead,0x9761,0x9ecc,
0x9ece,0x9ecf,0x9ed0,0x9ed4,0x9edc,0x9ede,0x9edd,0x9ee0,
0x9ee5,0x9ee8,0x9eef,0x9ef4,0x9ef6,0x9ef7,0x9ef9,0x9efb,
0x9efc,0x9efd,0x9f07,0x9f08,0x76b7,0x9f15,0x9f21,0x9f2c,
0x9f3e,0x9f4a,0x9f52,0x9f54,0x9f63,0x9f5f,0x9f60,0x9f61,
0x9f66,0x9f67,0x9f6c,0x9f6a,0x9f77,0x9f72,0x9f76,0x9f95,
0x9f9c,0x9fa0,0x582f,0x69c7,0x9059,0x7464,0x51dc,0x7199,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,};
static const unsigned short Our_eucJP_tableF8F[] = {
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x02d8,0x02c7,0x00b8,0x02d9,
0x02dd,0x00af,0x02db,0x02da,0xff5e,0x0384,0x0385,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x00a1,
0x00a6,0x00bf,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x00ba,0x00aa,0x00a9,0x00ae,0x2122,0x00a4,0x2116,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x0386,0x0388,
0x0389,0x038a,0x03aa,0xffff,0x038c,0xffff,0x038e,0x03ab,
0xffff,0x038f,0xffff,0xffff,0xffff,0xffff,0x03ac,0x03ad,
0x03ae,0x03af,0x03ca,0x0390,0x03cc,0x03c2,0x03cd,0x03cb,
0x03b0,0x03ce,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x0402,0x0403,0x0404,
0x0405,0x0406,0x0407,0x0408,0x0409,0x040a,0x040b,0x040c,
0x040e,0x040f,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0x0452,0x0453,0x0454,
0x0455,0x0456,0x0457,0x0458,0x0459,0x045a,0x045b,0x045c,
0x045e,0x045f,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x00c6,0x0110,0xffff,0x0126,0xffff,0x0132,0xffff,0x0141,
0x013f,0xffff,0x014a,0x00d8,0x0152,0xffff,0x0166,0x00de,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x00e6,0x0111,0x00f0,0x0127,0x0131,0x0133,0x0138,0x0142,
0x0140,0x0149,0x014b,0x00f8,0x0153,0x00df,0x0167,0x00fe,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0x00c1,0x00c0,
0x00c4,0x00c2,0x0102,0x01cd,0x0100,0x0104,0x00c5,0x00c3,
0x0106,0x0108,0x010c,0x00c7,0x010a,0x010e,0x00c9,0x00c8,
0x00cb,0x00ca,0x011a,0x0116,0x0112,0x0118,0xffff,0x011c,
0x011e,0x0122,0x0120,0x0124,0x00cd,0x00cc,0x00cf,0x00ce,
0x01cf,0x0130,0x012a,0x012e,0x0128,0x0134,0x0136,0x0139,
0x013d,0x013b,0x0143,0x0147,0x0145,0x00d1,0x00d3,0x00d2,
0x00d6,0x00d4,0x01d1,0x0150,0x014c,0x00d5,0x0154,0x0158,
0x0156,0x015a,0x015c,0x0160,0x015e,0x0164,0x0162,0x00da,
0x00d9,0x00dc,0x00db,0x016c,0x01d3,0x0170,0x016a,0x0172,
0x016e,0x0168,0x01d7,0x01db,0x01d9,0x01d5,0x0174,0x00dd,
0x0178,0x0176,0x0179,0x017d,0x017b,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0x00e1,0x00e0,0x00e4,0x00e2,
0x0103,0x01ce,0x0101,0x0105,0x00e5,0x00e3,0x0107,0x0109,
0x010d,0x00e7,0x010b,0x010f,0x00e9,0x00e8,0x00eb,0x00ea,
0x011b,0x0117,0x0113,0x0119,0x01f5,0x011d,0x011f,0xffff,
0x0121,0x0125,0x00ed,0x00ec,0x00ef,0x00ee,0x01d0,0xffff,
0x012b,0x012f,0x0129,0x0135,0x0137,0x013a,0x013e,0x013c,
0x0144,0x0148,0x0146,0x00f1,0x00f3,0x00f2,0x00f6,0x00f4,
0x01d2,0x0151,0x014d,0x00f5,0x0155,0x0159,0x0157,0x015b,
0x015d,0x0161,0x015f,0x0165,0x0163,0x00fa,0x00f9,0x00fc,
0x00fb,0x016d,0x01d4,0x0171,0x016b,0x0173,0x016f,0x0169,
0x01d8,0x01dc,0x01da,0x01d6,0x0175,0x00fd,0x00ff,0x0177,
0x017a,0x017e,0x017c,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0x4e02,0x4e04,0x4e05,0x4e0c,0x4e12,0x4e1f,
0x4e23,0x4e24,0x4e28,0x4e2b,0x4e2e,0x4e2f,0x4e30,0x4e35,
0x4e40,0x4e41,0x4e44,0x4e47,0x4e51,0x4e5a,0x4e5c,0x4e63,
0x4e68,0x4e69,0x4e74,0x4e75,0x4e79,0x4e7f,0x4e8d,0x4e96,
0x4e97,0x4e9d,0x4eaf,0x4eb9,0x4ec3,0x4ed0,0x4eda,0x4edb,
0x4ee0,0x4ee1,0x4ee2,0x4ee8,0x4eef,0x4ef1,0x4ef3,0x4ef5,
0x4efd,0x4efe,0x4eff,0x4f00,0x4f02,0x4f03,0x4f08,0x4f0b,
0x4f0c,0x4f12,0x4f15,0x4f16,0x4f17,0x4f19,0x4f2e,0x4f31,
0x4f60,0x4f33,0x4f35,0x4f37,0x4f39,0x4f3b,0x4f3e,0x4f40,
0x4f42,0x4f48,0x4f49,0x4f4b,0x4f4c,0x4f52,0x4f54,0x4f56,
0x4f58,0x4f5f,0x4f63,0x4f6a,0x4f6c,0x4f6e,0x4f71,0x4f77,
0x4f78,0x4f79,0x4f7a,0x4f7d,0x4f7e,0x4f81,0x4f82,0x4f84,
0x4f85,0x4f89,0x4f8a,0x4f8c,0x4f8e,0x4f90,0x4f92,0x4f93,
0x4f94,0x4f97,0x4f99,0x4f9a,0x4f9e,0x4f9f,0x4fb2,0x4fb7,
0x4fb9,0x4fbb,0x4fbc,0x4fbd,0x4fbe,0x4fc0,0x4fc1,0x4fc5,
0x4fc6,0x4fc8,0x4fc9,0x4fcb,0x4fcc,0x4fcd,0x4fcf,0x4fd2,
0x4fdc,0x4fe0,0x4fe2,0x4ff0,0x4ff2,0x4ffc,0x4ffd,0x4fff,
0x5000,0x5001,0x5004,0x5007,0x500a,0x500c,0x500e,0x5010,
0x5013,0x5017,0x5018,0x501b,0x501c,0x501d,0x501e,0x5022,
0x5027,0x502e,0x5030,0x5032,0x5033,0x5035,0x5040,0x5041,
0x5042,0x5045,0x5046,0x504a,0x504c,0x504e,0x5051,0x5052,
0x5053,0x5057,0x5059,0x505f,0x5060,0x5062,0x5063,0x5066,
0x5067,0x506a,0x506d,0x5070,0x5071,0x503b,0x5081,0x5083,
0x5084,0x5086,0x508a,0x508e,0x508f,0x5090,0x5092,0x5093,
0x5094,0x5096,0x509b,0x509c,0x509e,0x509f,0x50a0,0x50a1,
0x50a2,0x50aa,0x50af,0x50b0,0x50b9,0x50ba,0x50bd,0x50c0,
0x50c3,0x50c4,0x50c7,0x50cc,0x50ce,0x50d0,0x50d3,0x50d4,
0x50d8,0x50dc,0x50dd,0x50df,0x50e2,0x50e4,0x50e6,0x50e8,
0x50e9,0x50ef,0x50f1,0x50f6,0x50fa,0x50fe,0x5103,0x5106,
0x5107,0x5108,0x510b,0x510c,0x510d,0x510e,0x50f2,0x5110,
0x5117,0x5119,0x511b,0x511c,0x511d,0x511e,0x5123,0x5127,
0x5128,0x512c,0x512d,0x512f,0x5131,0x5133,0x5134,0x5135,
0x5138,0x5139,0x5142,0x514a,0x514f,0x5153,0x5155,0x5157,
0x5158,0x515f,0x5164,0x5166,0x517e,0x5183,0x5184,0x518b,
0x518e,0x5198,0x519d,0x51a1,0x51a3,0x51ad,0x51b8,0x51ba,
0x51bc,0x51be,0x51bf,0x51c2,0x51c8,0x51cf,0x51d1,0x51d2,
0x51d3,0x51d5,0x51d8,0x51de,0x51e2,0x51e5,0x51ee,0x51f2,
0x51f3,0x51f4,0x51f7,0x5201,0x5202,0x5205,0x5212,0x5213,
0x5215,0x5216,0x5218,0x5222,0x5228,0x5231,0x5232,0x5235,
0x523c,0x5245,0x5249,0x5255,0x5257,0x5258,0x525a,0x525c,
0x525f,0x5260,0x5261,0x5266,0x526e,0x5277,0x5278,0x5279,
0x5280,0x5282,0x5285,0x528a,0x528c,0x5293,0x5295,0x5296,
0x5297,0x5298,0x529a,0x529c,0x52a4,0x52a5,0x52a6,0x52a7,
0x52af,0x52b0,0x52b6,0x52b7,0x52b8,0x52ba,0x52bb,0x52bd,
0x52c0,0x52c4,0x52c6,0x52c8,0x52cc,0x52cf,0x52d1,0x52d4,
0x52d6,0x52db,0x52dc,0x52e1,0x52e5,0x52e8,0x52e9,0x52ea,
0x52ec,0x52f0,0x52f1,0x52f4,0x52f6,0x52f7,0x5300,0x5303,
0x530a,0x530b,0x530c,0x5311,0x5313,0x5318,0x531b,0x531c,
0x531e,0x531f,0x5325,0x5327,0x5328,0x5329,0x532b,0x532c,
0x532d,0x5330,0x5332,0x5335,0x533c,0x533d,0x533e,0x5342,
0x534c,0x534b,0x5359,0x535b,0x5361,0x5363,0x5365,0x536c,
0x536d,0x5372,0x5379,0x537e,0x5383,0x5387,0x5388,0x538e,
0x5393,0x5394,0x5399,0x539d,0x53a1,0x53a4,0x53aa,0x53ab,
0x53af,0x53b2,0x53b4,0x53b5,0x53b7,0x53b8,0x53ba,0x53bd,
0x53c0,0x53c5,0x53cf,0x53d2,0x53d3,0x53d5,0x53da,0x53dd,
0x53de,0x53e0,0x53e6,0x53e7,0x53f5,0x5402,0x5413,0x541a,
0x5421,0x5427,0x5428,0x542a,0x542f,0x5431,0x5434,0x5435,
0x5443,0x5444,0x5447,0x544d,0x544f,0x545e,0x5462,0x5464,
0x5466,0x5467,0x5469,0x546b,0x546d,0x546e,0x5474,0x547f,
0x5481,0x5483,0x5485,0x5488,0x5489,0x548d,0x5491,0x5495,
0x5496,0x549c,0x549f,0x54a1,0x54a6,0x54a7,0x54a9,0x54aa,
0x54ad,0x54ae,0x54b1,0x54b7,0x54b9,0x54ba,0x54bb,0x54bf,
0x54c6,0x54ca,0x54cd,0x54ce,0x54e0,0x54ea,0x54ec,0x54ef,
0x54f6,0x54fc,0x54fe,0x54ff,0x5500,0x5501,0x5505,0x5508,
0x5509,0x550c,0x550d,0x550e,0x5515,0x552a,0x552b,0x5532,
0x5535,0x5536,0x553b,0x553c,0x553d,0x5541,0x5547,0x5549,
0x554a,0x554d,0x5550,0x5551,0x5558,0x555a,0x555b,0x555e,
0x5560,0x5561,0x5564,0x5566,0x557f,0x5581,0x5582,0x5586,
0x5588,0x558e,0x558f,0x5591,0x5592,0x5593,0x5594,0x5597,
0x55a3,0x55a4,0x55ad,0x55b2,0x55bf,0x55c1,0x55c3,0x55c6,
0x55c9,0x55cb,0x55cc,0x55ce,0x55d1,0x55d2,0x55d3,0x55d7,
0x55d8,0x55db,0x55de,0x55e2,0x55e9,0x55f6,0x55ff,0x5605,
0x5608,0x560a,0x560d,0x560e,0x560f,0x5610,0x5611,0x5612,
0x5619,0x562c,0x5630,0x5633,0x5635,0x5637,0x5639,0x563b,
0x563c,0x563d,0x563f,0x5640,0x5641,0x5643,0x5644,0x5646,
0x5649,0x564b,0x564d,0x564f,0x5654,0x565e,0x5660,0x5661,
0x5662,0x5663,0x5666,0x5669,0x566d,0x566f,0x5671,0x5672,
0x5675,0x5684,0x5685,0x5688,0x568b,0x568c,0x5695,0x5699,
0x569a,0x569d,0x569e,0x569f,0x56a6,0x56a7,0x56a8,0x56a9,
0x56ab,0x56ac,0x56ad,0x56b1,0x56b3,0x56b7,0x56be,0x56c5,
0x56c9,0x56ca,0x56cb,0x56cf,0x56d0,0x56cc,0x56cd,0x56d9,
0x56dc,0x56dd,0x56df,0x56e1,0x56e4,0x56e5,0x56e6,0x56e7,
0x56e8,0x56f1,0x56eb,0x56ed,0x56f6,0x56f7,0x5701,0x5702,
0x5707,0x570a,0x570c,0x5711,0x5715,0x571a,0x571b,0x571d,
0x5720,0x5722,0x5723,0x5724,0x5725,0x5729,0x572a,0x572c,
0x572e,0x572f,0x5733,0x5734,0x573d,0x573e,0x573f,0x5745,
0x5746,0x574c,0x574d,0x5752,0x5762,0x5765,0x5767,0x5768,
0x576b,0x576d,0x576e,0x576f,0x5770,0x5771,0x5773,0x5774,
0x5775,0x5777,0x5779,0x577a,0x577b,0x577c,0x577e,0x5781,
0x5783,0x578c,0x5794,0x5797,0x5799,0x579a,0x579c,0x579d,
0x579e,0x579f,0x57a1,0x5795,0x57a7,0x57a8,0x57a9,0x57ac,
0x57b8,0x57bd,0x57c7,0x57c8,0x57cc,0x57cf,0x57d5,0x57dd,
0x57de,0x57e4,0x57e6,0x57e7,0x57e9,0x57ed,0x57f0,0x57f5,
0x57f6,0x57f8,0x57fd,0x57fe,0x57ff,0x5803,0x5804,0x5808,
0x5809,0x57e1,0x580c,0x580d,0x581b,0x581e,0x581f,0x5820,
0x5826,0x5827,0x582d,0x5832,0x5839,0x583f,0x5849,0x584c,
0x584d,0x584f,0x5850,0x5855,0x585f,0x5861,0x5864,0x5867,
0x5868,0x5878,0x587c,0x587f,0x5880,0x5881,0x5887,0x5888,
0x5889,0x588a,0x588c,0x588d,0x588f,0x5890,0x5894,0x5896,
0x589d,0x58a0,0x58a1,0x58a2,0x58a6,0x58a9,0x58b1,0x58b2,
0x58c4,0x58bc,0x58c2,0x58c8,0x58cd,0x58ce,0x58d0,0x58d2,
0x58d4,0x58d6,0x58da,0x58dd,0x58e1,0x58e2,0x58e9,0x58f3,
0x5905,0x5906,0x590b,0x590c,0x5912,0x5913,0x5914,0x8641,
0x591d,0x5921,0x5923,0x5924,0x5928,0x592f,0x5930,0x5933,
0x5935,0x5936,0x593f,0x5943,0x5946,0x5952,0x5953,0x5959,
0x595b,0x595d,0x595e,0x595f,0x5961,0x5963,0x596b,0x596d,
0x596f,0x5972,0x5975,0x5976,0x5979,0x597b,0x597c,0x598b,
0x598c,0x598e,0x5992,0x5995,0x5997,0x599f,0x59a4,0x59a7,
0x59ad,0x59ae,0x59af,0x59b0,0x59b3,0x59b7,0x59ba,0x59bc,
0x59c1,0x59c3,0x59c4,0x59c8,0x59ca,0x59cd,0x59d2,0x59dd,
0x59de,0x59df,0x59e3,0x59e4,0x59e7,0x59ee,0x59ef,0x59f1,
0x59f2,0x59f4,0x59f7,0x5a00,0x5a04,0x5a0c,0x5a0d,0x5a0e,
0x5a12,0x5a13,0x5a1e,0x5a23,0x5a24,0x5a27,0x5a28,0x5a2a,
0x5a2d,0x5a30,0x5a44,0x5a45,0x5a47,0x5a48,0x5a4c,0x5a50,
0x5a55,0x5a5e,0x5a63,0x5a65,0x5a67,0x5a6d,0x5a77,0x5a7a,
0x5a7b,0x5a7e,0x5a8b,0x5a90,0x5a93,0x5a96,0x5a99,0x5a9c,
0x5a9e,0x5a9f,0x5aa0,0x5aa2,0x5aa7,0x5aac,0x5ab1,0x5ab2,
0x5ab3,0x5ab5,0x5ab8,0x5aba,0x5abb,0x5abf,0x5ac4,0x5ac6,
0x5ac8,0x5acf,0x5ada,0x5adc,0x5ae0,0x5ae5,0x5aea,0x5aee,
0x5af5,0x5af6,0x5afd,0x5b00,0x5b01,0x5b08,0x5b17,0x5b34,
0x5b19,0x5b1b,0x5b1d,0x5b21,0x5b25,0x5b2d,0x5b38,0x5b41,
0x5b4b,0x5b4c,0x5b52,0x5b56,0x5b5e,0x5b68,0x5b6e,0x5b6f,
0x5b7c,0x5b7d,0x5b7e,0x5b7f,0x5b81,0x5b84,0x5b86,0x5b8a,
0x5b8e,0x5b90,0x5b91,0x5b93,0x5b94,0x5b96,0x5ba8,0x5ba9,
0x5bac,0x5bad,0x5baf,0x5bb1,0x5bb2,0x5bb7,0x5bba,0x5bbc,
0x5bc0,0x5bc1,0x5bcd,0x5bcf,0x5bd6,0x5bd7,0x5bd8,0x5bd9,
0x5bda,0x5be0,0x5bef,0x5bf1,0x5bf4,0x5bfd,0x5c0c,0x5c17,
0x5c1e,0x5c1f,0x5c23,0x5c26,0x5c29,0x5c2b,0x5c2c,0x5c2e,
0x5c30,0x5c32,0x5c35,0x5c36,0x5c59,0x5c5a,0x5c5c,0x5c62,
0x5c63,0x5c67,0x5c68,0x5c69,0x5c6d,0x5c70,0x5c74,0x5c75,
0x5c7a,0x5c7b,0x5c7c,0x5c7d,0x5c87,0x5c88,0x5c8a,0x5c8f,
0x5c92,0x5c9d,0x5c9f,0x5ca0,0x5ca2,0x5ca3,0x5ca6,0x5caa,
0x5cb2,0x5cb4,0x5cb5,0x5cba,0x5cc9,0x5ccb,0x5cd2,0x5cdd,
0x5cd7,0x5cee,0x5cf1,0x5cf2,0x5cf4,0x5d01,0x5d06,0x5d0d,
0x5d12,0x5d2b,0x5d23,0x5d24,0x5d26,0x5d27,0x5d31,0x5d34,
0x5d39,0x5d3d,0x5d3f,0x5d42,0x5d43,0x5d46,0x5d48,0x5d55,
0x5d51,0x5d59,0x5d4a,0x5d5f,0x5d60,0x5d61,0x5d62,0x5d64,
0x5d6a,0x5d6d,0x5d70,0x5d79,0x5d7a,0x5d7e,0x5d7f,0x5d81,
0x5d83,0x5d88,0x5d8a,0x5d92,0x5d93,0x5d94,0x5d95,0x5d99,
0x5d9b,0x5d9f,0x5da0,0x5da7,0x5dab,0x5db0,0x5db4,0x5db8,
0x5db9,0x5dc3,0x5dc7,0x5dcb,0x5dd0,0x5dce,0x5dd8,0x5dd9,
0x5de0,0x5de4,0x5de9,0x5df8,0x5df9,0x5e00,0x5e07,0x5e0d,
0x5e12,0x5e14,0x5e15,0x5e18,0x5e1f,0x5e20,0x5e2e,0x5e28,
0x5e32,0x5e35,0x5e3e,0x5e4b,0x5e50,0x5e49,0x5e51,0x5e56,
0x5e58,0x5e5b,0x5e5c,0x5e5e,0x5e68,0x5e6a,0x5e6b,0x5e6c,
0x5e6d,0x5e6e,0x5e70,0x5e80,0x5e8b,0x5e8e,0x5ea2,0x5ea4,
0x5ea5,0x5ea8,0x5eaa,0x5eac,0x5eb1,0x5eb3,0x5ebd,0x5ebe,
0x5ebf,0x5ec6,0x5ecc,0x5ecb,0x5ece,0x5ed1,0x5ed2,0x5ed4,
0x5ed5,0x5edc,0x5ede,0x5ee5,0x5eeb,0x5f02,0x5f06,0x5f07,
0x5f08,0x5f0e,0x5f19,0x5f1c,0x5f1d,0x5f21,0x5f22,0x5f23,
0x5f24,0x5f28,0x5f2b,0x5f2c,0x5f2e,0x5f30,0x5f34,0x5f36,
0x5f3b,0x5f3d,0x5f3f,0x5f40,0x5f44,0x5f45,0x5f47,0x5f4d,
0x5f50,0x5f54,0x5f58,0x5f5b,0x5f60,0x5f63,0x5f64,0x5f67,
0x5f6f,0x5f72,0x5f74,0x5f75,0x5f78,0x5f7a,0x5f7d,0x5f7e,
0x5f89,0x5f8d,0x5f8f,0x5f96,0x5f9c,0x5f9d,0x5fa2,0x5fa7,
0x5fab,0x5fa4,0x5fac,0x5faf,0x5fb0,0x5fb1,0x5fb8,0x5fc4,
0x5fc7,0x5fc8,0x5fc9,0x5fcb,0x5fd0,0x5fd1,0x5fd2,0x5fd3,
0x5fd4,0x5fde,0x5fe1,0x5fe2,0x5fe8,0x5fe9,0x5fea,0x5fec,
0x5fed,0x5fee,0x5fef,0x5ff2,0x5ff3,0x5ff6,0x5ffa,0x5ffc,
0x6007,0x600a,0x600d,0x6013,0x6014,0x6017,0x6018,0x601a,
0x601f,0x6024,0x602d,0x6033,0x6035,0x6040,0x6047,0x6048,
0x6049,0x604c,0x6051,0x6054,0x6056,0x6057,0x605d,0x6061,
0x6067,0x6071,0x607e,0x607f,0x6082,0x6086,0x6088,0x608a,
0x608e,0x6091,0x6093,0x6095,0x6098,0x609d,0x609e,0x60a2,
0x60a4,0x60a5,0x60a8,0x60b0,0x60b1,0x60b7,0x60bb,0x60be,
0x60c2,0x60c4,0x60c8,0x60c9,0x60ca,0x60cb,0x60ce,0x60cf,
0x60d4,0x60d5,0x60d9,0x60db,0x60dd,0x60de,0x60e2,0x60e5,
0x60f2,0x60f5,0x60f8,0x60fc,0x60fd,0x6102,0x6107,0x610a,
0x610c,0x6110,0x6111,0x6112,0x6113,0x6114,0x6116,0x6117,
0x6119,0x611c,0x611e,0x6122,0x612a,0x612b,0x6130,0x6131,
0x6135,0x6136,0x6137,0x6139,0x6141,0x6145,0x6146,0x6149,
0x615e,0x6160,0x616c,0x6172,0x6178,0x617b,0x617c,0x617f,
0x6180,0x6181,0x6183,0x6184,0x618b,0x618d,0x6192,0x6193,
0x6197,0x6198,0x619c,0x619d,0x619f,0x61a0,0x61a5,0x61a8,
0x61aa,0x61ad,0x61b8,0x61b9,0x61bc,0x61c0,0x61c1,0x61c2,
0x61ce,0x61cf,0x61d5,0x61dc,0x61dd,0x61de,0x61df,0x61e1,
0x61e2,0x61e7,0x61e9,0x61e5,0x61ec,0x61ed,0x61ef,0x6201,
0x6203,0x6204,0x6207,0x6213,0x6215,0x621c,0x6220,0x6222,
0x6223,0x6227,0x6229,0x622b,0x6239,0x623d,0x6242,0x6243,
0x6244,0x6246,0x624c,0x6250,0x6251,0x6252,0x6254,0x6256,
0x625a,0x625c,0x6264,0x626d,0x626f,0x6273,0x627a,0x627d,
0x628d,0x628e,0x628f,0x6290,0x62a6,0x62a8,0x62b3,0x62b6,
0x62b7,0x62ba,0x62be,0x62bf,0x62c4,0x62ce,0x62d5,0x62d6,
0x62da,0x62ea,0x62f2,0x62f4,0x62fc,0x62fd,0x6303,0x6304,
0x630a,0x630b,0x630d,0x6310,0x6313,0x6316,0x6318,0x6329,
0x632a,0x632d,0x6335,0x6336,0x6339,0x633c,0x6341,0x6342,
0x6343,0x6344,0x6346,0x634a,0x634b,0x634e,0x6352,0x6353,
0x6354,0x6358,0x635b,0x6365,0x6366,0x636c,0x636d,0x6371,
0x6374,0x6375,0x6378,0x637c,0x637d,0x637f,0x6382,0x6384,
0x6387,0x638a,0x6390,0x6394,0x6395,0x6399,0x639a,0x639e,
0x63a4,0x63a6,0x63ad,0x63ae,0x63af,0x63bd,0x63c1,0x63c5,
0x63c8,0x63ce,0x63d1,0x63d3,0x63d4,0x63d5,0x63dc,0x63e0,
0x63e5,0x63ea,0x63ec,0x63f2,0x63f3,0x63f5,0x63f8,0x63f9,
0x6409,0x640a,0x6410,0x6412,0x6414,0x6418,0x641e,0x6420,
0x6422,0x6424,0x6425,0x6429,0x642a,0x642f,0x6430,0x6435,
0x643d,0x643f,0x644b,0x644f,0x6451,0x6452,0x6453,0x6454,
0x645a,0x645b,0x645c,0x645d,0x645f,0x6460,0x6461,0x6463,
0x646d,0x6473,0x6474,0x647b,0x647d,0x6485,0x6487,0x648f,
0x6490,0x6491,0x6498,0x6499,0x649b,0x649d,0x649f,0x64a1,
0x64a3,0x64a6,0x64a8,0x64ac,0x64b3,0x64bd,0x64be,0x64bf,
0x64c4,0x64c9,0x64ca,0x64cb,0x64cc,0x64ce,0x64d0,0x64d1,
0x64d5,0x64d7,0x64e4,0x64e5,0x64e9,0x64ea,0x64ed,0x64f0,
0x64f5,0x64f7,0x64fb,0x64ff,0x6501,0x6504,0x6508,0x6509,
0x650a,0x650f,0x6513,0x6514,0x6516,0x6519,0x651b,0x651e,
0x651f,0x6522,0x6526,0x6529,0x652e,0x6531,0x653a,0x653c,
0x653d,0x6543,0x6547,0x6549,0x6550,0x6552,0x6554,0x655f,
0x6560,0x6567,0x656b,0x657a,0x657d,0x6581,0x6585,0x658a,
0x6592,0x6595,0x6598,0x659d,0x65a0,0x65a3,0x65a6,0x65ae,
0x65b2,0x65b3,0x65b4,0x65bf,0x65c2,0x65c8,0x65c9,0x65ce,
0x65d0,0x65d4,0x65d6,0x65d8,0x65df,0x65f0,0x65f2,0x65f4,
0x65f5,0x65f9,0x65fe,0x65ff,0x6600,0x6604,0x6608,0x6609,
0x660d,0x6611,0x6612,0x6615,0x6616,0x661d,0x661e,0x6621,
0x6622,0x6623,0x6624,0x6626,0x6629,0x662a,0x662b,0x662c,
0x662e,0x6630,0x6631,0x6633,0x6639,0x6637,0x6640,0x6645,
0x6646,0x664a,0x664c,0x6651,0x664e,0x6657,0x6658,0x6659,
0x665b,0x665c,0x6660,0x6661,0x66fb,0x666a,0x666b,0x666c,
0x667e,0x6673,0x6675,0x667f,0x6677,0x6678,0x6679,0x667b,
0x6680,0x667c,0x668b,0x668c,0x668d,0x6690,0x6692,0x6699,
0x669a,0x669b,0x669c,0x669f,0x66a0,0x66a4,0x66ad,0x66b1,
0x66b2,0x66b5,0x66bb,0x66bf,0x66c0,0x66c2,0x66c3,0x66c8,
0x66cc,0x66ce,0x66cf,0x66d4,0x66db,0x66df,0x66e8,0x66eb,
0x66ec,0x66ee,0x66fa,0x6705,0x6707,0x670e,0x6713,0x6719,
0x671c,0x6720,0x6722,0x6733,0x673e,0x6745,0x6747,0x6748,
0x674c,0x6754,0x6755,0x675d,0x6766,0x676c,0x676e,0x6774,
0x6776,0x677b,0x6781,0x6784,0x678e,0x678f,0x6791,0x6793,
0x6796,0x6798,0x6799,0x679b,0x67b0,0x67b1,0x67b2,0x67b5,
0x67bb,0x67bc,0x67bd,0x67f9,0x67c0,0x67c2,0x67c3,0x67c5,
0x67c8,0x67c9,0x67d2,0x67d7,0x67d9,0x67dc,0x67e1,0x67e6,
0x67f0,0x67f2,0x67f6,0x67f7,0x6852,0x6814,0x6819,0x681d,
0x681f,0x6828,0x6827,0x682c,0x682d,0x682f,0x6830,0x6831,
0x6833,0x683b,0x683f,0x6844,0x6845,0x684a,0x684c,0x6855,
0x6857,0x6858,0x685b,0x686b,0x686e,0x686f,0x6870,0x6871,
0x6872,0x6875,0x6879,0x687a,0x687b,0x687c,0x6882,0x6884,
0x6886,0x6888,0x6896,0x6898,0x689a,0x689c,0x68a1,0x68a3,
0x68a5,0x68a9,0x68aa,0x68ae,0x68b2,0x68bb,0x68c5,0x68c8,
0x68cc,0x68cf,0x68d0,0x68d1,0x68d3,0x68d6,0x68d9,0x68dc,
0x68dd,0x68e5,0x68e8,0x68ea,0x68eb,0x68ec,0x68ed,0x68f0,
0x68f1,0x68f5,0x68f6,0x68fb,0x68fc,0x68fd,0x6906,0x6909,
0x690a,0x6910,0x6911,0x6913,0x6916,0x6917,0x6931,0x6933,
0x6935,0x6938,0x693b,0x6942,0x6945,0x6949,0x694e,0x6957,
0x695b,0x6963,0x6964,0x6965,0x6966,0x6968,0x6969,0x696c,
0x6970,0x6971,0x6972,0x697a,0x697b,0x697f,0x6980,0x698d,
0x6992,0x6996,0x6998,0x69a1,0x69a5,0x69a6,0x69a8,0x69ab,
0x69ad,0x69af,0x69b7,0x69b8,0x69ba,0x69bc,0x69c5,0x69c8,
0x69d1,0x69d6,0x69d7,0x69e2,0x69e5,0x69ee,0x69ef,0x69f1,
0x69f3,0x69f5,0x69fe,0x6a00,0x6a01,0x6a03,0x6a0f,0x6a11,
0x6a15,0x6a1a,0x6a1d,0x6a20,0x6a24,0x6a28,0x6a30,0x6a32,
0x6a34,0x6a37,0x6a3b,0x6a3e,0x6a3f,0x6a45,0x6a46,0x6a49,
0x6a4a,0x6a4e,0x6a50,0x6a51,0x6a52,0x6a55,0x6a56,0x6a5b,
0x6a64,0x6a67,0x6a6a,0x6a71,0x6a73,0x6a7e,0x6a81,0x6a83,
0x6a86,0x6a87,0x6a89,0x6a8b,0x6a91,0x6a9b,0x6a9d,0x6a9e,
0x6a9f,0x6aa5,0x6aab,0x6aaf,0x6ab0,0x6ab1,0x6ab4,0x6abd,
0x6abe,0x6abf,0x6ac6,0x6ac9,0x6ac8,0x6acc,0x6ad0,0x6ad4,
0x6ad5,0x6ad6,0x6adc,0x6add,0x6ae4,0x6ae7,0x6aec,0x6af0,
0x6af1,0x6af2,0x6afc,0x6afd,0x6b02,0x6b03,0x6b06,0x6b07,
0x6b09,0x6b0f,0x6b10,0x6b11,0x6b17,0x6b1b,0x6b1e,0x6b24,
0x6b28,0x6b2b,0x6b2c,0x6b2f,0x6b35,0x6b36,0x6b3b,0x6b3f,
0x6b46,0x6b4a,0x6b4d,0x6b52,0x6b56,0x6b58,0x6b5d,0x6b60,
0x6b67,0x6b6b,0x6b6e,0x6b70,0x6b75,0x6b7d,0x6b7e,0x6b82,
0x6b85,0x6b97,0x6b9b,0x6b9f,0x6ba0,0x6ba2,0x6ba3,0x6ba8,
0x6ba9,0x6bac,0x6bad,0x6bae,0x6bb0,0x6bb8,0x6bb9,0x6bbd,
0x6bbe,0x6bc3,0x6bc4,0x6bc9,0x6bcc,0x6bd6,0x6bda,0x6be1,
0x6be3,0x6be6,0x6be7,0x6bee,0x6bf1,0x6bf7,0x6bf9,0x6bff,
0x6c02,0x6c04,0x6c05,0x6c09,0x6c0d,0x6c0e,0x6c10,0x6c12,
0x6c19,0x6c1f,0x6c26,0x6c27,0x6c28,0x6c2c,0x6c2e,0x6c33,
0x6c35,0x6c36,0x6c3a,0x6c3b,0x6c3f,0x6c4a,0x6c4b,0x6c4d,
0x6c4f,0x6c52,0x6c54,0x6c59,0x6c5b,0x6c5c,0x6c6b,0x6c6d,
0x6c6f,0x6c74,0x6c76,0x6c78,0x6c79,0x6c7b,0x6c85,0x6c86,
0x6c87,0x6c89,0x6c94,0x6c95,0x6c97,0x6c98,0x6c9c,0x6c9f,
0x6cb0,0x6cb2,0x6cb4,0x6cc2,0x6cc6,0x6ccd,0x6ccf,0x6cd0,
0x6cd1,0x6cd2,0x6cd4,0x6cd6,0x6cda,0x6cdc,0x6ce0,0x6ce7,
0x6ce9,0x6ceb,0x6cec,0x6cee,0x6cf2,0x6cf4,0x6d04,0x6d07,
0x6d0a,0x6d0e,0x6d0f,0x6d11,0x6d13,0x6d1a,0x6d26,0x6d27,
0x6d28,0x6c67,0x6d2e,0x6d2f,0x6d31,0x6d39,0x6d3c,0x6d3f,
0x6d57,0x6d5e,0x6d5f,0x6d61,0x6d65,0x6d67,0x6d6f,0x6d70,
0x6d7c,0x6d82,0x6d87,0x6d91,0x6d92,0x6d94,0x6d96,0x6d97,
0x6d98,0x6daa,0x6dac,0x6db4,0x6db7,0x6db9,0x6dbd,0x6dbf,
0x6dc4,0x6dc8,0x6dca,0x6dce,0x6dcf,0x6dd6,0x6ddb,0x6ddd,
0x6ddf,0x6de0,0x6de2,0x6de5,0x6de9,0x6def,0x6df0,0x6df4,
0x6df6,0x6dfc,0x6e00,0x6e04,0x6e1e,0x6e22,0x6e27,0x6e32,
0x6e36,0x6e39,0x6e3b,0x6e3c,0x6e44,0x6e45,0x6e48,0x6e49,
0x6e4b,0x6e4f,0x6e51,0x6e52,0x6e53,0x6e54,0x6e57,0x6e5c,
0x6e5d,0x6e5e,0x6e62,0x6e63,0x6e68,0x6e73,0x6e7b,0x6e7d,
0x6e8d,0x6e93,0x6e99,0x6ea0,0x6ea7,0x6ead,0x6eae,0x6eb1,
0x6eb3,0x6ebb,0x6ebf,0x6ec0,0x6ec1,0x6ec3,0x6ec7,0x6ec8,
0x6eca,0x6ecd,0x6ece,0x6ecf,0x6eeb,0x6eed,0x6eee,0x6ef9,
0x6efb,0x6efd,0x6f04,0x6f08,0x6f0a,0x6f0c,0x6f0d,0x6f16,
0x6f18,0x6f1a,0x6f1b,0x6f26,0x6f29,0x6f2a,0x6f2f,0x6f30,
0x6f33,0x6f36,0x6f3b,0x6f3c,0x6f2d,0x6f4f,0x6f51,0x6f52,
0x6f53,0x6f57,0x6f59,0x6f5a,0x6f5d,0x6f5e,0x6f61,0x6f62,
0x6f68,0x6f6c,0x6f7d,0x6f7e,0x6f83,0x6f87,0x6f88,0x6f8b,
0x6f8c,0x6f8d,0x6f90,0x6f92,0x6f93,0x6f94,0x6f96,0x6f9a,
0x6f9f,0x6fa0,0x6fa5,0x6fa6,0x6fa7,0x6fa8,0x6fae,0x6faf,
0x6fb0,0x6fb5,0x6fb6,0x6fbc,0x6fc5,0x6fc7,0x6fc8,0x6fca,
0x6fda,0x6fde,0x6fe8,0x6fe9,0x6ff0,0x6ff5,0x6ff9,0x6ffc,
0x6ffd,0x7000,0x7005,0x7006,0x7007,0x700d,0x7017,0x7020,
0x7023,0x702f,0x7034,0x7037,0x7039,0x703c,0x7043,0x7044,
0x7048,0x7049,0x704a,0x704b,0x7054,0x7055,0x705d,0x705e,
0x704e,0x7064,0x7065,0x706c,0x706e,0x7075,0x7076,0x707e,
0x7081,0x7085,0x7086,0x7094,0x7095,0x7096,0x7097,0x7098,
0x709b,0x70a4,0x70ab,0x70b0,0x70b1,0x70b4,0x70b7,0x70ca,
0x70d1,0x70d3,0x70d4,0x70d5,0x70d6,0x70d8,0x70dc,0x70e4,
0x70fa,0x7103,0x7104,0x7105,0x7106,0x7107,0x710b,0x710c,
0x710f,0x711e,0x7120,0x712b,0x712d,0x712f,0x7130,0x7131,
0x7138,0x7141,0x7145,0x7146,0x7147,0x714a,0x714b,0x7150,
0x7152,0x7157,0x715a,0x715c,0x715e,0x7160,0x7168,0x7179,
0x7180,0x7185,0x7187,0x718c,0x7192,0x719a,0x719b,0x71a0,
0x71a2,0x71af,0x71b0,0x71b2,0x71b3,0x71ba,0x71bf,0x71c0,
0x71c1,0x71c4,0x71cb,0x71cc,0x71d3,0x71d6,0x71d9,0x71da,
0x71dc,0x71f8,0x71fe,0x7200,0x7207,0x7208,0x7209,0x7213,
0x7217,0x721a,0x721d,0x721f,0x7224,0x722b,0x722f,0x7234,
0x7238,0x7239,0x7241,0x7242,0x7243,0x7245,0x724e,0x724f,
0x7250,0x7253,0x7255,0x7256,0x725a,0x725c,0x725e,0x7260,
0x7263,0x7268,0x726b,0x726e,0x726f,0x7271,0x7277,0x7278,
0x727b,0x727c,0x727f,0x7284,0x7289,0x728d,0x728e,0x7293,
0x729b,0x72a8,0x72ad,0x72ae,0x72b1,0x72b4,0x72be,0x72c1,
0x72c7,0x72c9,0x72cc,0x72d5,0x72d6,0x72d8,0x72df,0x72e5,
0x72f3,0x72f4,0x72fa,0x72fb,0x72fe,0x7302,0x7304,0x7305,
0x7307,0x730b,0x730d,0x7312,0x7313,0x7318,0x7319,0x731e,
0x7322,0x7324,0x7327,0x7328,0x732c,0x7331,0x7332,0x7335,
0x733a,0x733b,0x733d,0x7343,0x734d,0x7350,0x7352,0x7356,
0x7358,0x735d,0x735e,0x735f,0x7360,0x7366,0x7367,0x7369,
0x736b,0x736c,0x736e,0x736f,0x7371,0x7377,0x7379,0x737c,
0x7380,0x7381,0x7383,0x7385,0x7386,0x738e,0x7390,0x7393,
0x7395,0x7397,0x7398,0x739c,0x739e,0x739f,0x73a0,0x73a2,
0x73a5,0x73a6,0x73aa,0x73ab,0x73ad,0x73b5,0x73b7,0x73b9,
0x73bc,0x73bd,0x73bf,0x73c5,0x73c6,0x73c9,0x73cb,0x73cc,
0x73cf,0x73d2,0x73d3,0x73d6,0x73d9,0x73dd,0x73e1,0x73e3,
0x73e6,0x73e7,0x73e9,0x73f4,0x73f5,0x73f7,0x73f9,0x73fa,
0x73fb,0x73fd,0x73ff,0x7400,0x7401,0x7404,0x7407,0x740a,
0x7411,0x741a,0x741b,0x7424,0x7426,0x7428,0x7429,0x742a,
0x742b,0x742c,0x742d,0x742e,0x742f,0x7430,0x7431,0x7439,
0x7440,0x7443,0x7444,0x7446,0x7447,0x744b,0x744d,0x7451,
0x7452,0x7457,0x745d,0x7462,0x7466,0x7467,0x7468,0x746b,
0x746d,0x746e,0x7471,0x7472,0x7480,0x7481,0x7485,0x7486,
0x7487,0x7489,0x748f,0x7490,0x7491,0x7492,0x7498,0x7499,
0x749a,0x749c,0x749f,0x74a0,0x74a1,0x74a3,0x74a6,0x74a8,
0x74a9,0x74aa,0x74ab,0x74ae,0x74af,0x74b1,0x74b2,0x74b5,
0x74b9,0x74bb,0x74bf,0x74c8,0x74c9,0x74cc,0x74d0,0x74d3,
0x74d8,0x74da,0x74db,0x74de,0x74df,0x74e4,0x74e8,0x74ea,
0x74eb,0x74ef,0x74f4,0x74fa,0x74fb,0x74fc,0x74ff,0x7506,
0x7512,0x7516,0x7517,0x7520,0x7521,0x7524,0x7527,0x7529,
0x752a,0x752f,0x7536,0x7539,0x753d,0x753e,0x753f,0x7540,
0x7543,0x7547,0x7548,0x754e,0x7550,0x7552,0x7557,0x755e,
0x755f,0x7561,0x756f,0x7571,0x7579,0x757a,0x757b,0x757c,
0x757d,0x757e,0x7581,0x7585,0x7590,0x7592,0x7593,0x7595,
0x7599,0x759c,0x75a2,0x75a4,0x75b4,0x75ba,0x75bf,0x75c0,
0x75c1,0x75c4,0x75c6,0x75cc,0x75ce,0x75cf,0x75d7,0x75dc,
0x75df,0x75e0,0x75e1,0x75e4,0x75e7,0x75ec,0x75ee,0x75ef,
0x75f1,0x75f9,0x7600,0x7602,0x7603,0x7604,0x7607,0x7608,
0x760a,0x760c,0x760f,0x7612,0x7613,0x7615,0x7616,0x7619,
0x761b,0x761c,0x761d,0x761e,0x7623,0x7625,0x7626,0x7629,
0x762d,0x7632,0x7633,0x7635,0x7638,0x7639,0x763a,0x763c,
0x764a,0x7640,0x7641,0x7643,0x7644,0x7645,0x7649,0x764b,
0x7655,0x7659,0x765f,0x7664,0x7665,0x766d,0x766e,0x766f,
0x7671,0x7674,0x7681,0x7685,0x768c,0x768d,0x7695,0x769b,
0x769c,0x769d,0x769f,0x76a0,0x76a2,0x76a3,0x76a4,0x76a5,
0x76a6,0x76a7,0x76a8,0x76aa,0x76ad,0x76bd,0x76c1,0x76c5,
0x76c9,0x76cb,0x76cc,0x76ce,0x76d4,0x76d9,0x76e0,0x76e6,
0x76e8,0x76ec,0x76f0,0x76f1,0x76f6,0x76f9,0x76fc,0x7700,
0x7706,0x770a,0x770e,0x7712,0x7714,0x7715,0x7717,0x7719,
0x771a,0x771c,0x7722,0x7728,0x772d,0x772e,0x772f,0x7734,
0x7735,0x7736,0x7739,0x773d,0x773e,0x7742,0x7745,0x7746,
0x774a,0x774d,0x774e,0x774f,0x7752,0x7756,0x7757,0x775c,
0x775e,0x775f,0x7760,0x7762,0x7764,0x7767,0x776a,0x776c,
0x7770,0x7772,0x7773,0x7774,0x777a,0x777d,0x7780,0x7784,
0x778c,0x778d,0x7794,0x7795,0x7796,0x779a,0x779f,0x77a2,
0x77a7,0x77aa,0x77ae,0x77af,0x77b1,0x77b5,0x77be,0x77c3,
0x77c9,0x77d1,0x77d2,0x77d5,0x77d9,0x77de,0x77df,0x77e0,
0x77e4,0x77e6,0x77ea,0x77ec,0x77f0,0x77f1,0x77f4,0x77f8,
0x77fb,0x7805,0x7806,0x7809,0x780d,0x780e,0x7811,0x781d,
0x7821,0x7822,0x7823,0x782d,0x782e,0x7830,0x7835,0x7837,
0x7843,0x7844,0x7847,0x7848,0x784c,0x784e,0x7852,0x785c,
0x785e,0x7860,0x7861,0x7863,0x7864,0x7868,0x786a,0x786e,
0x787a,0x787e,0x788a,0x788f,0x7894,0x7898,0x78a1,0x789d,
0x789e,0x789f,0x78a4,0x78a8,0x78ac,0x78ad,0x78b0,0x78b1,
0x78b2,0x78b3,0x78bb,0x78bd,0x78bf,0x78c7,0x78c8,0x78c9,
0x78cc,0x78ce,0x78d2,0x78d3,0x78d5,0x78d6,0x78e4,0x78db,
0x78df,0x78e0,0x78e1,0x78e6,0x78ea,0x78f2,0x78f3,0x7900,
0x78f6,0x78f7,0x78fa,0x78fb,0x78ff,0x7906,0x790c,0x7910,
0x791a,0x791c,0x791e,0x791f,0x7920,0x7925,0x7927,0x7929,
0x792d,0x7931,0x7934,0x7935,0x793b,0x793d,0x793f,0x7944,
0x7945,0x7946,0x794a,0x794b,0x794f,0x7951,0x7954,0x7958,
0x795b,0x795c,0x7967,0x7969,0x796b,0x7972,0x7979,0x797b,
0x797c,0x797e,0x798b,0x798c,0x7991,0x7993,0x7994,0x7995,
0x7996,0x7998,0x799b,0x799c,0x79a1,0x79a8,0x79a9,0x79ab,
0x79af,0x79b1,0x79b4,0x79b8,0x79bb,0x79c2,0x79c4,0x79c7,
0x79c8,0x79ca,0x79cf,0x79d4,0x79d6,0x79da,0x79dd,0x79de,
0x79e0,0x79e2,0x79e5,0x79ea,0x79eb,0x79ed,0x79f1,0x79f8,
0x79fc,0x7a02,0x7a03,0x7a07,0x7a09,0x7a0a,0x7a0c,0x7a11,
0x7a15,0x7a1b,0x7a1e,0x7a21,0x7a27,0x7a2b,0x7a2d,0x7a2f,
0x7a30,0x7a34,0x7a35,0x7a38,0x7a39,0x7a3a,0x7a44,0x7a45,
0x7a47,0x7a48,0x7a4c,0x7a55,0x7a56,0x7a59,0x7a5c,0x7a5d,
0x7a5f,0x7a60,0x7a65,0x7a67,0x7a6a,0x7a6d,0x7a75,0x7a78,
0x7a7e,0x7a80,0x7a82,0x7a85,0x7a86,0x7a8a,0x7a8b,0x7a90,
0x7a91,0x7a94,0x7a9e,0x7aa0,0x7aa3,0x7aac,0x7ab3,0x7ab5,
0x7ab9,0x7abb,0x7abc,0x7ac6,0x7ac9,0x7acc,0x7ace,0x7ad1,
0x7adb,0x7ae8,0x7ae9,0x7aeb,0x7aec,0x7af1,0x7af4,0x7afb,
0x7afd,0x7afe,0x7b07,0x7b14,0x7b1f,0x7b23,0x7b27,0x7b29,
0x7b2a,0x7b2b,0x7b2d,0x7b2e,0x7b2f,0x7b30,0x7b31,0x7b34,
0x7b3d,0x7b3f,0x7b40,0x7b41,0x7b47,0x7b4e,0x7b55,0x7b60,
0x7b64,0x7b66,0x7b69,0x7b6a,0x7b6d,0x7b6f,0x7b72,0x7b73,
0x7b77,0x7b84,0x7b89,0x7b8e,0x7b90,0x7b91,0x7b96,0x7b9b,
0x7b9e,0x7ba0,0x7ba5,0x7bac,0x7baf,0x7bb0,0x7bb2,0x7bb5,
0x7bb6,0x7bba,0x7bbb,0x7bbc,0x7bbd,0x7bc2,0x7bc5,0x7bc8,
0x7bca,0x7bd4,0x7bd6,0x7bd7,0x7bd9,0x7bda,0x7bdb,0x7be8,
0x7bea,0x7bf2,0x7bf4,0x7bf5,0x7bf8,0x7bf9,0x7bfa,0x7bfc,
0x7bfe,0x7c01,0x7c02,0x7c03,0x7c04,0x7c06,0x7c09,0x7c0b,
0x7c0c,0x7c0e,0x7c0f,0x7c19,0x7c1b,0x7c20,0x7c25,0x7c26,
0x7c28,0x7c2c,0x7c31,0x7c33,0x7c34,0x7c36,0x7c39,0x7c3a,
0x7c46,0x7c4a,0x7c55,0x7c51,0x7c52,0x7c53,0x7c59,0x7c5a,
0x7c5b,0x7c5c,0x7c5d,0x7c5e,0x7c61,0x7c63,0x7c67,0x7c69,
0x7c6d,0x7c6e,0x7c70,0x7c72,0x7c79,0x7c7c,0x7c7d,0x7c86,
0x7c87,0x7c8f,0x7c94,0x7c9e,0x7ca0,0x7ca6,0x7cb0,0x7cb6,
0x7cb7,0x7cba,0x7cbb,0x7cbc,0x7cbf,0x7cc4,0x7cc7,0x7cc8,
0x7cc9,0x7ccd,0x7ccf,0x7cd3,0x7cd4,0x7cd5,0x7cd7,0x7cd9,
0x7cda,0x7cdd,0x7ce6,0x7ce9,0x7ceb,0x7cf5,0x7d03,0x7d07,
0x7d08,0x7d09,0x7d0f,0x7d11,0x7d12,0x7d13,0x7d16,0x7d1d,
0x7d1e,0x7d23,0x7d26,0x7d2a,0x7d2d,0x7d31,0x7d3c,0x7d3d,
0x7d3e,0x7d40,0x7d41,0x7d47,0x7d48,0x7d4d,0x7d51,0x7d53,
0x7d57,0x7d59,0x7d5a,0x7d5c,0x7d5d,0x7d65,0x7d67,0x7d6a,
0x7d70,0x7d78,0x7d7a,0x7d7b,0x7d7f,0x7d81,0x7d82,0x7d83,
0x7d85,0x7d86,0x7d88,0x7d8b,0x7d8c,0x7d8d,0x7d91,0x7d96,
0x7d97,0x7d9d,0x7d9e,0x7da6,0x7da7,0x7daa,0x7db3,0x7db6,
0x7db7,0x7db9,0x7dc2,0x7dc3,0x7dc4,0x7dc5,0x7dc6,0x7dcc,
0x7dcd,0x7dce,0x7dd7,0x7dd9,0x7e00,0x7de2,0x7de5,0x7de6,
0x7dea,0x7deb,0x7ded,0x7df1,0x7df5,0x7df6,0x7df9,0x7dfa,
0x7e08,0x7e10,0x7e11,0x7e15,0x7e17,0x7e1c,0x7e1d,0x7e20,
0x7e27,0x7e28,0x7e2c,0x7e2d,0x7e2f,0x7e33,0x7e36,0x7e3f,
0x7e44,0x7e45,0x7e47,0x7e4e,0x7e50,0x7e52,0x7e58,0x7e5f,
0x7e61,0x7e62,0x7e65,0x7e6b,0x7e6e,0x7e6f,0x7e73,0x7e78,
0x7e7e,0x7e81,0x7e86,0x7e87,0x7e8a,0x7e8d,0x7e91,0x7e95,
0x7e98,0x7e9a,0x7e9d,0x7e9e,0x7f3c,0x7f3b,0x7f3d,0x7f3e,
0x7f3f,0x7f43,0x7f44,0x7f47,0x7f4f,0x7f52,0x7f53,0x7f5b,
0x7f5c,0x7f5d,0x7f61,0x7f63,0x7f64,0x7f65,0x7f66,0x7f6d,
0x7f71,0x7f7d,0x7f7e,0x7f7f,0x7f80,0x7f8b,0x7f8d,0x7f8f,
0x7f90,0x7f91,0x7f96,0x7f97,0x7f9c,0x7fa1,0x7fa2,0x7fa6,
0x7faa,0x7fad,0x7fb4,0x7fbc,0x7fbf,0x7fc0,0x7fc3,0x7fc8,
0x7fce,0x7fcf,0x7fdb,0x7fdf,0x7fe3,0x7fe5,0x7fe8,0x7fec,
0x7fee,0x7fef,0x7ff2,0x7ffa,0x7ffd,0x7ffe,0x7fff,0x8007,
0x8008,0x800a,0x800d,0x800e,0x800f,0x8011,0x8013,0x8014,
0x8016,0x801d,0x801e,0x801f,0x8020,0x8024,0x8026,0x802c,
0x802e,0x8030,0x8034,0x8035,0x8037,0x8039,0x803a,0x803c,
0x803e,0x8040,0x8044,0x8060,0x8064,0x8066,0x806d,0x8071,
0x8075,0x8081,0x8088,0x808e,0x809c,0x809e,0x80a6,0x80a7,
0x80ab,0x80b8,0x80b9,0x80c8,0x80cd,0x80cf,0x80d2,0x80d4,
0x80d5,0x80d7,0x80d8,0x80e0,0x80ed,0x80ee,0x80f0,0x80f2,
0x80f3,0x80f6,0x80f9,0x80fa,0x80fe,0x8103,0x810b,0x8116,
0x8117,0x8118,0x811c,0x811e,0x8120,0x8124,0x8127,0x812c,
0x8130,0x8135,0x813a,0x813c,0x8145,0x8147,0x814a,0x814c,
0x8152,0x8157,0x8160,0x8161,0x8167,0x8168,0x8169,0x816d,
0x816f,0x8177,0x8181,0x8190,0x8184,0x8185,0x8186,0x818b,
0x818e,0x8196,0x8198,0x819b,0x819e,0x81a2,0x81ae,0x81b2,
0x81b4,0x81bb,0x81cb,0x81c3,0x81c5,0x81ca,0x81ce,0x81cf,
0x81d5,0x81d7,0x81db,0x81dd,0x81de,0x81e1,0x81e4,0x81eb,
0x81ec,0x81f0,0x81f1,0x81f2,0x81f5,0x81f6,0x81f8,0x81f9,
0x81fd,0x81ff,0x8200,0x8203,0x820f,0x8213,0x8214,0x8219,
0x821a,0x821d,0x8221,0x8222,0x8228,0x8232,0x8234,0x823a,
0x8243,0x8244,0x8245,0x8246,0x824b,0x824e,0x824f,0x8251,
0x8256,0x825c,0x8260,0x8263,0x8267,0x826d,0x8274,0x827b,
0x827d,0x827f,0x8280,0x8281,0x8283,0x8284,0x8287,0x8289,
0x828a,0x828e,0x8291,0x8294,0x8296,0x8298,0x829a,0x829b,
0x82a0,0x82a1,0x82a3,0x82a4,0x82a7,0x82a8,0x82a9,0x82aa,
0x82ae,0x82b0,0x82b2,0x82b4,0x82b7,0x82ba,0x82bc,0x82be,
0x82bf,0x82c6,0x82d0,0x82d5,0x82da,0x82e0,0x82e2,0x82e4,
0x82e8,0x82ea,0x82ed,0x82ef,0x82f6,0x82f7,0x82fd,0x82fe,
0x8300,0x8301,0x8307,0x8308,0x830a,0x830b,0x8354,0x831b,
0x831d,0x831e,0x831f,0x8321,0x8322,0x832c,0x832d,0x832e,
0x8330,0x8333,0x8337,0x833a,0x833c,0x833d,0x8342,0x8343,
0x8344,0x8347,0x834d,0x834e,0x8351,0x8355,0x8356,0x8357,
0x8370,0x8378,0x837d,0x837f,0x8380,0x8382,0x8384,0x8386,
0x838d,0x8392,0x8394,0x8395,0x8398,0x8399,0x839b,0x839c,
0x839d,0x83a6,0x83a7,0x83a9,0x83ac,0x83be,0x83bf,0x83c0,
0x83c7,0x83c9,0x83cf,0x83d0,0x83d1,0x83d4,0x83dd,0x8353,
0x83e8,0x83ea,0x83f6,0x83f8,0x83f9,0x83fc,0x8401,0x8406,
0x840a,0x840f,0x8411,0x8415,0x8419,0x83ad,0x842f,0x8439,
0x8445,0x8447,0x8448,0x844a,0x844d,0x844f,0x8451,0x8452,
0x8456,0x8458,0x8459,0x845a,0x845c,0x8460,0x8464,0x8465,
0x8467,0x846a,0x8470,0x8473,0x8474,0x8476,0x8478,0x847c,
0x847d,0x8481,0x8485,0x8492,0x8493,0x8495,0x849e,0x84a6,
0x84a8,0x84a9,0x84aa,0x84af,0x84b1,0x84b4,0x84ba,0x84bd,
0x84be,0x84c0,0x84c2,0x84c7,0x84c8,0x84cc,0x84cf,0x84d3,
0x84dc,0x84e7,0x84ea,0x84ef,0x84f0,0x84f1,0x84f2,0x84f7,
0x8532,0x84fa,0x84fb,0x84fd,0x8502,0x8503,0x8507,0x850c,
0x850e,0x8510,0x851c,0x851e,0x8522,0x8523,0x8524,0x8525,
0x8527,0x852a,0x852b,0x852f,0x8533,0x8534,0x8536,0x853f,
0x8546,0x854f,0x8550,0x8551,0x8552,0x8553,0x8556,0x8559,
0x855c,0x855d,0x855e,0x855f,0x8560,0x8561,0x8562,0x8564,
0x856b,0x856f,0x8579,0x857a,0x857b,0x857d,0x857f,0x8581,
0x8585,0x8586,0x8589,0x858b,0x858c,0x858f,0x8593,0x8598,
0x859d,0x859f,0x85a0,0x85a2,0x85a5,0x85a7,0x85b4,0x85b6,
0x85b7,0x85b8,0x85bc,0x85bd,0x85be,0x85bf,0x85c2,0x85c7,
0x85ca,0x85cb,0x85ce,0x85ad,0x85d8,0x85da,0x85df,0x85e0,
0x85e6,0x85e8,0x85ed,0x85f3,0x85f6,0x85fc,0x85ff,0x8600,
0x8604,0x8605,0x860d,0x860e,0x8610,0x8611,0x8612,0x8618,
0x8619,0x861b,0x861e,0x8621,0x8627,0x8629,0x8636,0x8638,
0x863a,0x863c,0x863d,0x8640,0x8642,0x8646,0x8652,0x8653,
0x8656,0x8657,0x8658,0x8659,0x865d,0x8660,0x8661,0x8662,
0x8663,0x8664,0x8669,0x866c,0x866f,0x8675,0x8676,0x8677,
0x867a,0x868d,0x8691,0x8696,0x8698,0x869a,0x869c,0x86a1,
0x86a6,0x86a7,0x86a8,0x86ad,0x86b1,0x86b3,0x86b4,0x86b5,
0x86b7,0x86b8,0x86b9,0x86bf,0x86c0,0x86c1,0x86c3,0x86c5,
0x86d1,0x86d2,0x86d5,0x86d7,0x86da,0x86dc,0x86e0,0x86e3,
0x86e5,0x86e7,0x8688,0x86fa,0x86fc,0x86fd,0x8704,0x8705,
0x8707,0x870b,0x870e,0x870f,0x8710,0x8713,0x8714,0x8719,
0x871e,0x871f,0x8721,0x8723,0x8728,0x872e,0x872f,0x8731,
0x8732,0x8739,0x873a,0x873c,0x873d,0x873e,0x8740,0x8743,
0x8745,0x874d,0x8758,0x875d,0x8761,0x8764,0x8765,0x876f,
0x8771,0x8772,0x877b,0x8783,0x8784,0x8785,0x8786,0x8787,
0x8788,0x8789,0x878b,0x878c,0x8790,0x8793,0x8795,0x8797,
0x8798,0x8799,0x879e,0x87a0,0x87a3,0x87a7,0x87ac,0x87ad,
0x87ae,0x87b1,0x87b5,0x87be,0x87bf,0x87c1,0x87c8,0x87c9,
0x87ca,0x87ce,0x87d5,0x87d6,0x87d9,0x87da,0x87dc,0x87df,
0x87e2,0x87e3,0x87e4,0x87ea,0x87eb,0x87ed,0x87f1,0x87f3,
0x87f8,0x87fa,0x87ff,0x8801,0x8803,0x8806,0x8809,0x880a,
0x880b,0x8810,0x8819,0x8812,0x8813,0x8814,0x8818,0x881a,
0x881b,0x881c,0x881e,0x881f,0x8828,0x882d,0x882e,0x8830,
0x8832,0x8835,0x883a,0x883c,0x8841,0x8843,0x8845,0x8848,
0x8849,0x884a,0x884b,0x884e,0x8851,0x8855,0x8856,0x8858,
0x885a,0x885c,0x885f,0x8860,0x8864,0x8869,0x8871,0x8879,
0x887b,0x8880,0x8898,0x889a,0x889b,0x889c,0x889f,0x88a0,
0x88a8,0x88aa,0x88ba,0x88bd,0x88be,0x88c0,0x88ca,0x88cb,
0x88cc,0x88cd,0x88ce,0x88d1,0x88d2,0x88d3,0x88db,0x88de,
0x88e7,0x88ef,0x88f0,0x88f1,0x88f5,0x88f7,0x8901,0x8906,
0x890d,0x890e,0x890f,0x8915,0x8916,0x8918,0x8919,0x891a,
0x891c,0x8920,0x8926,0x8927,0x8928,0x8930,0x8931,0x8932,
0x8935,0x8939,0x893a,0x893e,0x8940,0x8942,0x8945,0x8946,
0x8949,0x894f,0x8952,0x8957,0x895a,0x895b,0x895c,0x8961,
0x8962,0x8963,0x896b,0x896e,0x8970,0x8973,0x8975,0x897a,
0x897b,0x897c,0x897d,0x8989,0x898d,0x8990,0x8994,0x8995,
0x899b,0x899c,0x899f,0x89a0,0x89a5,0x89b0,0x89b4,0x89b5,
0x89b6,0x89b7,0x89bc,0x89d4,0x89d5,0x89d6,0x89d7,0x89d8,
0x89e5,0x89e9,0x89eb,0x89ed,0x89f1,0x89f3,0x89f6,0x89f9,
0x89fd,0x89ff,0x8a04,0x8a05,0x8a07,0x8a0f,0x8a11,0x8a12,
0x8a14,0x8a15,0x8a1e,0x8a20,0x8a22,0x8a24,0x8a26,0x8a2b,
0x8a2c,0x8a2f,0x8a35,0x8a37,0x8a3d,0x8a3e,0x8a40,0x8a43,
0x8a45,0x8a47,0x8a49,0x8a4d,0x8a4e,0x8a53,0x8a56,0x8a57,
0x8a58,0x8a5c,0x8a5d,0x8a61,0x8a65,0x8a67,0x8a75,0x8a76,
0x8a77,0x8a79,0x8a7a,0x8a7b,0x8a7e,0x8a7f,0x8a80,0x8a83,
0x8a86,0x8a8b,0x8a8f,0x8a90,0x8a92,0x8a96,0x8a97,0x8a99,
0x8a9f,0x8aa7,0x8aa9,0x8aae,0x8aaf,0x8ab3,0x8ab6,0x8ab7,
0x8abb,0x8abe,0x8ac3,0x8ac6,0x8ac8,0x8ac9,0x8aca,0x8ad1,
0x8ad3,0x8ad4,0x8ad5,0x8ad7,0x8add,0x8adf,0x8aec,0x8af0,
0x8af4,0x8af5,0x8af6,0x8afc,0x8aff,0x8b05,0x8b06,0x8b0b,
0x8b11,0x8b1c,0x8b1e,0x8b1f,0x8b0a,0x8b2d,0x8b30,0x8b37,
0x8b3c,0x8b42,0x8b43,0x8b44,0x8b45,0x8b46,0x8b48,0x8b52,
0x8b53,0x8b54,0x8b59,0x8b4d,0x8b5e,0x8b63,0x8b6d,0x8b76,
0x8b78,0x8b79,0x8b7c,0x8b7e,0x8b81,0x8b84,0x8b85,0x8b8b,
0x8b8d,0x8b8f,0x8b94,0x8b95,0x8b9c,0x8b9e,0x8b9f,0x8c38,
0x8c39,0x8c3d,0x8c3e,0x8c45,0x8c47,0x8c49,0x8c4b,0x8c4f,
0x8c51,0x8c53,0x8c54,0x8c57,0x8c58,0x8c5b,0x8c5d,0x8c59,
0x8c63,0x8c64,0x8c66,0x8c68,0x8c69,0x8c6d,0x8c73,0x8c75,
0x8c76,0x8c7b,0x8c7e,0x8c86,0x8c87,0x8c8b,0x8c90,0x8c92,
0x8c93,0x8c99,0x8c9b,0x8c9c,0x8ca4,0x8cb9,0x8cba,0x8cc5,
0x8cc6,0x8cc9,0x8ccb,0x8ccf,0x8cd6,0x8cd5,0x8cd9,0x8cdd,
0x8ce1,0x8ce8,0x8cec,0x8cef,0x8cf0,0x8cf2,0x8cf5,0x8cf7,
0x8cf8,0x8cfe,0x8cff,0x8d01,0x8d03,0x8d09,0x8d12,0x8d17,
0x8d1b,0x8d65,0x8d69,0x8d6c,0x8d6e,0x8d7f,0x8d82,0x8d84,
0x8d88,0x8d8d,0x8d90,0x8d91,0x8d95,0x8d9e,0x8d9f,0x8da0,
0x8da6,0x8dab,0x8dac,0x8daf,0x8db2,0x8db5,0x8db7,0x8db9,
0x8dbb,0x8dc0,0x8dc5,0x8dc6,0x8dc7,0x8dc8,0x8dca,0x8dce,
0x8dd1,0x8dd4,0x8dd5,0x8dd7,0x8dd9,0x8de4,0x8de5,0x8de7,
0x8dec,0x8df0,0x8dbc,0x8df1,0x8df2,0x8df4,0x8dfd,0x8e01,
0x8e04,0x8e05,0x8e06,0x8e0b,0x8e11,0x8e14,0x8e16,0x8e20,
0x8e21,0x8e22,0x8e23,0x8e26,0x8e27,0x8e31,0x8e33,0x8e36,
0x8e37,0x8e38,0x8e39,0x8e3d,0x8e40,0x8e41,0x8e4b,0x8e4d,
0x8e4e,0x8e4f,0x8e54,0x8e5b,0x8e5c,0x8e5d,0x8e5e,0x8e61,
0x8e62,0x8e69,0x8e6c,0x8e6d,0x8e6f,0x8e70,0x8e71,0x8e79,
0x8e7a,0x8e7b,0x8e82,0x8e83,0x8e89,0x8e90,0x8e92,0x8e95,
0x8e9a,0x8e9b,0x8e9d,0x8e9e,0x8ea2,0x8ea7,0x8ea9,0x8ead,
0x8eae,0x8eb3,0x8eb5,0x8eba,0x8ebb,0x8ec0,0x8ec1,0x8ec3,
0x8ec4,0x8ec7,0x8ecf,0x8ed1,0x8ed4,0x8edc,0x8ee8,0x8eee,
0x8ef0,0x8ef1,0x8ef7,0x8ef9,0x8efa,0x8eed,0x8f00,0x8f02,
0x8f07,0x8f08,0x8f0f,0x8f10,0x8f16,0x8f17,0x8f18,0x8f1e,
0x8f20,0x8f21,0x8f23,0x8f25,0x8f27,0x8f28,0x8f2c,0x8f2d,
0x8f2e,0x8f34,0x8f35,0x8f36,0x8f37,0x8f3a,0x8f40,0x8f41,
0x8f43,0x8f47,0x8f4f,0x8f51,0x8f52,0x8f53,0x8f54,0x8f55,
0x8f58,0x8f5d,0x8f5e,0x8f65,0x8f9d,0x8fa0,0x8fa1,0x8fa4,
0x8fa5,0x8fa6,0x8fb5,0x8fb6,0x8fb8,0x8fbe,0x8fc0,0x8fc1,
0x8fc6,0x8fca,0x8fcb,0x8fcd,0x8fd0,0x8fd2,0x8fd3,0x8fd5,
0x8fe0,0x8fe3,0x8fe4,0x8fe8,0x8fee,0x8ff1,0x8ff5,0x8ff6,
0x8ffb,0x8ffe,0x9002,0x9004,0x9008,0x900c,0x9018,0x901b,
0x9028,0x9029,0x902f,0x902a,0x902c,0x902d,0x9033,0x9034,
0x9037,0x903f,0x9043,0x9044,0x904c,0x905b,0x905d,0x9062,
0x9066,0x9067,0x906c,0x9070,0x9074,0x9079,0x9085,0x9088,
0x908b,0x908c,0x908e,0x9090,0x9095,0x9097,0x9098,0x9099,
0x909b,0x90a0,0x90a1,0x90a2,0x90a5,0x90b0,0x90b2,0x90b3,
0x90b4,0x90b6,0x90bd,0x90cc,0x90be,0x90c3,0x90c4,0x90c5,
0x90c7,0x90c8,0x90d5,0x90d7,0x90d8,0x90d9,0x90dc,0x90dd,
0x90df,0x90e5,0x90d2,0x90f6,0x90eb,0x90ef,0x90f0,0x90f4,
0x90fe,0x90ff,0x9100,0x9104,0x9105,0x9106,0x9108,0x910d,
0x9110,0x9114,0x9116,0x9117,0x9118,0x911a,0x911c,0x911e,
0x9120,0x9125,0x9122,0x9123,0x9127,0x9129,0x912e,0x912f,
0x9131,0x9134,0x9136,0x9137,0x9139,0x913a,0x913c,0x913d,
0x9143,0x9147,0x9148,0x914f,0x9153,0x9157,0x9159,0x915a,
0x915b,0x9161,0x9164,0x9167,0x916d,0x9174,0x9179,0x917a,
0x917b,0x9181,0x9183,0x9185,0x9186,0x918a,0x918e,0x9191,
0x9193,0x9194,0x9195,0x9198,0x919e,0x91a1,0x91a6,0x91a8,
0x91ac,0x91ad,0x91ae,0x91b0,0x91b1,0x91b2,0x91b3,0x91b6,
0x91bb,0x91bc,0x91bd,0x91bf,0x91c2,0x91c3,0x91c5,0x91d3,
0x91d4,0x91d7,0x91d9,0x91da,0x91de,0x91e4,0x91e5,0x91e9,
0x91ea,0x91ec,0x91ed,0x91ee,0x91ef,0x91f0,0x91f1,0x91f7,
0x91f9,0x91fb,0x91fd,0x9200,0x9201,0x9204,0x9205,0x9206,
0x9207,0x9209,0x920a,0x920c,0x9210,0x9212,0x9213,0x9216,
0x9218,0x921c,0x921d,0x9223,0x9224,0x9225,0x9226,0x9228,
0x922e,0x922f,0x9230,0x9233,0x9235,0x9236,0x9238,0x9239,
0x923a,0x923c,0x923e,0x9240,0x9242,0x9243,0x9246,0x9247,
0x924a,0x924d,0x924e,0x924f,0x9251,0x9258,0x9259,0x925c,
0x925d,0x9260,0x9261,0x9265,0x9267,0x9268,0x9269,0x926e,
0x926f,0x9270,0x9275,0x9276,0x9277,0x9278,0x9279,0x927b,
0x927c,0x927d,0x927f,0x9288,0x9289,0x928a,0x928d,0x928e,
0x9292,0x9297,0x9299,0x929f,0x92a0,0x92a4,0x92a5,0x92a7,
0x92a8,0x92ab,0x92af,0x92b2,0x92b6,0x92b8,0x92ba,0x92bb,
0x92bc,0x92bd,0x92bf,0x92c0,0x92c1,0x92c2,0x92c3,0x92c5,
0x92c6,0x92c7,0x92c8,0x92cb,0x92cc,0x92cd,0x92ce,0x92d0,
0x92d3,0x92d5,0x92d7,0x92d8,0x92d9,0x92dc,0x92dd,0x92df,
0x92e0,0x92e1,0x92e3,0x92e5,0x92e7,0x92e8,0x92ec,0x92ee,
0x92f0,0x92f9,0x92fb,0x92ff,0x9300,0x9302,0x9308,0x930d,
0x9311,0x9314,0x9315,0x931c,0x931d,0x931e,0x931f,0x9321,
0x9324,0x9325,0x9327,0x9329,0x932a,0x9333,0x9334,0x9336,
0x9337,0x9347,0x9348,0x9349,0x9350,0x9351,0x9352,0x9355,
0x9357,0x9358,0x935a,0x935e,0x9364,0x9365,0x9367,0x9369,
0x936a,0x936d,0x936f,0x9370,0x9371,0x9373,0x9374,0x9376,
0x937a,0x937d,0x937f,0x9380,0x9381,0x9382,0x9388,0x938a,
0x938b,0x938d,0x938f,0x9392,0x9395,0x9398,0x939b,0x939e,
0x93a1,0x93a3,0x93a4,0x93a6,0x93a8,0x93ab,0x93b4,0x93b5,
0x93b6,0x93ba,0x93a9,0x93c1,0x93c4,0x93c5,0x93c6,0x93c7,
0x93c9,0x93ca,0x93cb,0x93cc,0x93cd,0x93d3,0x93d9,0x93dc,
0x93de,0x93df,0x93e2,0x93e6,0x93e7,0x93f9,0x93f7,0x93f8,
0x93fa,0x93fb,0x93fd,0x9401,0x9402,0x9404,0x9408,0x9409,
0x940d,0x940e,0x940f,0x9415,0x9416,0x9417,0x941f,0x942e,
0x942f,0x9431,0x9432,0x9433,0x9434,0x943b,0x943f,0x943d,
0x9443,0x9445,0x9448,0x944a,0x944c,0x9455,0x9459,0x945c,
0x945f,0x9461,0x9463,0x9468,0x946b,0x946d,0x946e,0x946f,
0x9471,0x9472,0x9484,0x9483,0x9578,0x9579,0x957e,0x9584,
0x9588,0x958c,0x958d,0x958e,0x959d,0x959e,0x959f,0x95a1,
0x95a6,0x95a9,0x95ab,0x95ac,0x95b4,0x95b6,0x95ba,0x95bd,
0x95bf,0x95c6,0x95c8,0x95c9,0x95cb,0x95d0,0x95d1,0x95d2,
0x95d3,0x95d9,0x95da,0x95dd,0x95de,0x95df,0x95e0,0x95e4,
0x95e6,0x961d,0x961e,0x9622,0x9624,0x9625,0x9626,0x962c,
0x9631,0x9633,0x9637,0x9638,0x9639,0x963a,0x963c,0x963d,
0x9641,0x9652,0x9654,0x9656,0x9657,0x9658,0x9661,0x966e,
0x9674,0x967b,0x967c,0x967e,0x967f,0x9681,0x9682,0x9683,
0x9684,0x9689,0x9691,0x9696,0x969a,0x969d,0x969f,0x96a4,
0x96a5,0x96a6,0x96a9,0x96ae,0x96af,0x96b3,0x96ba,0x96ca,
0x96d2,0x5db2,0x96d8,0x96da,0x96dd,0x96de,0x96df,0x96e9,
0x96ef,0x96f1,0x96fa,0x9702,0x9703,0x9705,0x9709,0x971a,
0x971b,0x971d,0x9721,0x9722,0x9723,0x9728,0x9731,0x9733,
0x9741,0x9743,0x974a,0x974e,0x974f,0x9755,0x9757,0x9758,
0x975a,0x975b,0x9763,0x9767,0x976a,0x976e,0x9773,0x9776,
0x9777,0x9778,0x977b,0x977d,0x977f,0x9780,0x9789,0x9795,
0x9796,0x9797,0x9799,0x979a,0x979e,0x979f,0x97a2,0x97ac,
0x97ae,0x97b1,0x97b2,0x97b5,0x97b6,0x97b8,0x97b9,0x97ba,
0x97bc,0x97be,0x97bf,0x97c1,0x97c4,0x97c5,0x97c7,0x97c9,
0x97ca,0x97cc,0x97cd,0x97ce,0x97d0,0x97d1,0x97d4,0x97d7,
0x97d8,0x97d9,0x97dd,0x97de,0x97e0,0x97db,0x97e1,0x97e4,
0x97ef,0x97f1,0x97f4,0x97f7,0x97f8,0x97fa,0x9807,0x980a,
0x9819,0x980d,0x980e,0x9814,0x9816,0x981c,0x981e,0x9820,
0x9823,0x9826,0x982b,0x982e,0x982f,0x9830,0x9832,0x9833,
0x9835,0x9825,0x983e,0x9844,0x9847,0x984a,0x9851,0x9852,
0x9853,0x9856,0x9857,0x9859,0x985a,0x9862,0x9863,0x9865,
0x9866,0x986a,0x986c,0x98ab,0x98ad,0x98ae,0x98b0,0x98b4,
0x98b7,0x98b8,0x98ba,0x98bb,0x98bf,0x98c2,0x98c5,0x98c8,
0x98cc,0x98e1,0x98e3,0x98e5,0x98e6,0x98e7,0x98ea,0x98f3,
0x98f6,0x9902,0x9907,0x9908,0x9911,0x9915,0x9916,0x9917,
0x991a,0x991b,0x991c,0x991f,0x9922,0x9926,0x9927,0x992b,
0x9931,0x9932,0x9933,0x9934,0x9935,0x9939,0x993a,0x993b,
0x993c,0x9940,0x9941,0x9946,0x9947,0x9948,0x994d,0x994e,
0x9954,0x9958,0x9959,0x995b,0x995c,0x995e,0x995f,0x9960,
0x999b,0x999d,0x999f,0x99a6,0x99b0,0x99b1,0x99b2,0x99b5,
0x99b9,0x99ba,0x99bd,0x99bf,0x99c3,0x99c9,0x99d3,0x99d4,
0x99d9,0x99da,0x99dc,0x99de,0x99e7,0x99ea,0x99eb,0x99ec,
0x99f0,0x99f4,0x99f5,0x99f9,0x99fd,0x99fe,0x9a02,0x9a03,
0x9a04,0x9a0b,0x9a0c,0x9a10,0x9a11,0x9a16,0x9a1e,0x9a20,
0x9a22,0x9a23,0x9a24,0x9a27,0x9a2d,0x9a2e,0x9a33,0x9a35,
0x9a36,0x9a38,0x9a47,0x9a41,0x9a44,0x9a4a,0x9a4b,0x9a4c,
0x9a4e,0x9a51,0x9a54,0x9a56,0x9a5d,0x9aaa,0x9aac,0x9aae,
0x9aaf,0x9ab2,0x9ab4,0x9ab5,0x9ab6,0x9ab9,0x9abb,0x9abe,
0x9abf,0x9ac1,0x9ac3,0x9ac6,0x9ac8,0x9ace,0x9ad0,0x9ad2,
0x9ad5,0x9ad6,0x9ad7,0x9adb,0x9adc,0x9ae0,0x9ae4,0x9ae5,
0x9ae7,0x9ae9,0x9aec,0x9af2,0x9af3,0x9af5,0x9af9,0x9afa,
0x9afd,0x9aff,0x9b00,0x9b01,0x9b02,0x9b03,0x9b04,0x9b05,
0x9b08,0x9b09,0x9b0b,0x9b0c,0x9b0d,0x9b0e,0x9b10,0x9b12,
0x9b16,0x9b19,0x9b1b,0x9b1c,0x9b20,0x9b26,0x9b2b,0x9b2d,
0x9b33,0x9b34,0x9b35,0x9b37,0x9b39,0x9b3a,0x9b3d,0x9b48,
0x9b4b,0x9b4c,0x9b55,0x9b56,0x9b57,0x9b5b,0x9b5e,0x9b61,
0x9b63,0x9b65,0x9b66,0x9b68,0x9b6a,0x9b6b,0x9b6c,0x9b6d,
0x9b6e,0x9b73,0x9b75,0x9b77,0x9b78,0x9b79,0x9b7f,0x9b80,
0x9b84,0x9b85,0x9b86,0x9b87,0x9b89,0x9b8a,0x9b8b,0x9b8d,
0x9b8f,0x9b90,0x9b94,0x9b9a,0x9b9d,0x9b9e,0x9ba6,0x9ba7,
0x9ba9,0x9bac,0x9bb0,0x9bb1,0x9bb2,0x9bb7,0x9bb8,0x9bbb,
0x9bbc,0x9bbe,0x9bbf,0x9bc1,0x9bc7,0x9bc8,0x9bce,0x9bd0,
0x9bd7,0x9bd8,0x9bdd,0x9bdf,0x9be5,0x9be7,0x9bea,0x9beb,
0x9bef,0x9bf3,0x9bf7,0x9bf8,0x9bf9,0x9bfa,0x9bfd,0x9bff,
0x9c00,0x9c02,0x9c0b,0x9c0f,0x9c11,0x9c16,0x9c18,0x9c19,
0x9c1a,0x9c1c,0x9c1e,0x9c22,0x9c23,0x9c26,0x9c27,0x9c28,
0x9c29,0x9c2a,0x9c31,0x9c35,0x9c36,0x9c37,0x9c3d,0x9c41,
0x9c43,0x9c44,0x9c45,0x9c49,0x9c4a,0x9c4e,0x9c4f,0x9c50,
0x9c53,0x9c54,0x9c56,0x9c58,0x9c5b,0x9c5d,0x9c5e,0x9c5f,
0x9c63,0x9c69,0x9c6a,0x9c5c,0x9c6b,0x9c68,0x9c6e,0x9c70,
0x9c72,0x9c75,0x9c77,0x9c7b,0x9ce6,0x9cf2,0x9cf7,0x9cf9,
0x9d0b,0x9d02,0x9d11,0x9d17,0x9d18,0x9d1c,0x9d1d,0x9d1e,
0x9d2f,0x9d30,0x9d32,0x9d33,0x9d34,0x9d3a,0x9d3c,0x9d45,
0x9d3d,0x9d42,0x9d43,0x9d47,0x9d4a,0x9d53,0x9d54,0x9d5f,
0x9d63,0x9d62,0x9d65,0x9d69,0x9d6a,0x9d6b,0x9d70,0x9d76,
0x9d77,0x9d7b,0x9d7c,0x9d7e,0x9d83,0x9d84,0x9d86,0x9d8a,
0x9d8d,0x9d8e,0x9d92,0x9d93,0x9d95,0x9d96,0x9d97,0x9d98,
0x9da1,0x9daa,0x9dac,0x9dae,0x9db1,0x9db5,0x9db9,0x9dbc,
0x9dbf,0x9dc3,0x9dc7,0x9dc9,0x9dca,0x9dd4,0x9dd5,0x9dd6,
0x9dd7,0x9dda,0x9dde,0x9ddf,0x9de0,0x9de5,0x9de7,0x9de9,
0x9deb,0x9dee,0x9df0,0x9df3,0x9df4,0x9dfe,0x9e0a,0x9e02,
0x9e07,0x9e0e,0x9e10,0x9e11,0x9e12,0x9e15,0x9e16,0x9e19,
0x9e1c,0x9e1d,0x9e7a,0x9e7b,0x9e7c,0x9e80,0x9e82,0x9e83,
0x9e84,0x9e85,0x9e87,0x9e8e,0x9e8f,0x9e96,0x9e98,0x9e9b,
0x9e9e,0x9ea4,0x9ea8,0x9eac,0x9eae,0x9eaf,0x9eb0,0x9eb3,
0x9eb4,0x9eb5,0x9ec6,0x9ec8,0x9ecb,0x9ed5,0x9edf,0x9ee4,
0x9ee7,0x9eec,0x9eed,0x9eee,0x9ef0,0x9ef1,0x9ef2,0x9ef5,
0x9ef8,0x9eff,0x9f02,0x9f03,0x9f09,0x9f0f,0x9f10,0x9f11,
0x9f12,0x9f14,0x9f16,0x9f17,0x9f19,0x9f1a,0x9f1b,0x9f1f,
0x9f22,0x9f26,0x9f2a,0x9f2b,0x9f2f,0x9f31,0x9f32,0x9f34,
0x9f37,0x9f39,0x9f3a,0x9f3c,0x9f3d,0x9f3f,0x9f41,0x9f43,
0x9f44,0x9f45,0x9f46,0x9f47,0x9f53,0x9f55,0x9f56,0x9f57,
0x9f58,0x9f5a,0x9f5d,0x9f5e,0x9f68,0x9f69,0x9f6d,0x9f6e,
0x9f6f,0x9f70,0x9f71,0x9f73,0x9f75,0x9f7a,0x9f7d,0x9f8f,
0x9f90,0x9f91,0x9f92,0x9f94,0x9f96,0x9f97,0x9f9e,0x9fa1,
0x9fa2,0x9fa3,0x9fa5,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,};
static const unsigned short Our_eucJP_tableB[] = {
0x0000,0x0001,0x0002,0x0003,0x0004,0x0005,0x0006,0x0007,
0x0008,0x0009,0x000a,0x000b,0x000c,0x000d,0x000e,0x000f,
0x0010,0x0011,0x0012,0x0013,0x0014,0x0015,0x0016,0x0017,
0x0018,0x0019,0x001a,0x001b,0x001c,0x001d,0x001e,0x001f,
0x0020,0x0021,0x0022,0x0023,0x0024,0x0025,0x0026,0x0027,
0x0028,0x0029,0x002a,0x002b,0x002c,0x002d,0x002e,0x002f,
0x0030,0x0031,0x0032,0x0033,0x0034,0x0035,0x0036,0x0037,
0x0038,0x0039,0x003a,0x003b,0x003c,0x003d,0x003e,0x003f,
0x0040,0x0041,0x0042,0x0043,0x0044,0x0045,0x0046,0x0047,
0x0048,0x0049,0x004a,0x004b,0x004c,0x004d,0x004e,0x004f,
0x0050,0x0051,0x0052,0x0053,0x0054,0x0055,0x0056,0x0057,
0x0058,0x0059,0x005a,0x005b,0x005c,0x005d,0x005e,0x005f,
0x0060,0x0061,0x0062,0x0063,0x0064,0x0065,0x0066,0x0067,
0x0068,0x0069,0x006a,0x006b,0x006c,0x006d,0x006e,0x006f,
0x0070,0x0071,0x0072,0x0073,0x0074,0x0075,0x0076,0x0077,
0x0078,0x0079,0x007a,0x007b,0x007c,0x007d,0x007e,0x007f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa2c2,0xa1f1,0xa1f2,0xa2f0,0xa1ef,0xa2c3,0xa1f8,
0xa1af,0xa2ed,0xa2ec,0xffff,0xa2cc,0xffff,0xa2ee,0xa2b4,
0xa1eb,0xa1de,0xffff,0xffff,0xa1ad,0xffff,0xa2f9,0xffff,
0xa2b1,0xffff,0xa2eb,0xffff,0xffff,0xffff,0xffff,0xa2c4,
0xaaa2,0xaaa1,0xaaa4,0xaaaa,0xaaa3,0xaaa9,0xa9a1,0xaaae,
0xaab2,0xaab1,0xaab4,0xaab3,0xaac0,0xaabf,0xaac2,0xaac1,
0xffff,0xaad0,0xaad2,0xaad1,0xaad4,0xaad8,0xaad3,0xa1df,
0xa9ac,0xaae3,0xaae2,0xaae5,0xaae4,0xaaf2,0xa9b0,0xa9ce,
0xaba2,0xaba1,0xaba4,0xabaa,0xaba3,0xaba9,0xa9c1,0xabae,
0xabb2,0xabb1,0xabb4,0xabb3,0xabc0,0xabbf,0xabc2,0xabc1,
0xa9c3,0xabd0,0xabd2,0xabd1,0xabd4,0xabd8,0xabd3,0xa1e0,
0xa9cc,0xabe3,0xabe2,0xabe5,0xabe4,0xabf2,0xa9d0,0xabf3,
0xaaa7,0xaba7,0xaaa5,0xaba5,0xaaa8,0xaba8,0xaaab,0xabab,
0xaaac,0xabac,0xaaaf,0xabaf,0xaaad,0xabad,0xaab0,0xabb0,
0xa9a2,0xa9c2,0xaab7,0xabb7,0xffff,0xffff,0xaab6,0xabb6,
0xaab8,0xabb8,0xaab5,0xabb5,0xaaba,0xabba,0xaabb,0xabbb,
0xaabd,0xabbd,0xaabc,0xffff,0xaabe,0xabbe,0xa9a4,0xa9c4,
0xaac7,0xabc7,0xaac5,0xabc5,0xffff,0xffff,0xaac6,0xabc6,
0xaac4,0xa9c5,0xa9a6,0xa9c6,0xaac8,0xabc8,0xaac9,0xabc9,
0xa9c7,0xaaca,0xabca,0xaacc,0xabcc,0xaacb,0xabcb,0xa9a9,
0xa9c9,0xa9a8,0xa9c8,0xaacd,0xabcd,0xaacf,0xabcf,0xaace,
0xabce,0xa9ca,0xa9ab,0xa9cb,0xaad7,0xabd7,0xffff,0xffff,
0xaad6,0xabd6,0xa9ad,0xa9cd,0xaad9,0xabd9,0xaadb,0xabdb,
0xaada,0xabda,0xaadc,0xabdc,0xaadd,0xabdd,0xaadf,0xabdf,
0xaade,0xabde,0xaae1,0xabe1,0xaae0,0xabe0,0xa9af,0xa9cf,
0xaaec,0xabec,0xaae9,0xabe9,0xaae6,0xabe6,0xaaeb,0xabeb,
0xaae8,0xabe8,0xaaea,0xabea,0xaaf1,0xabf1,0xaaf4,0xabf4,
0xaaf3,0xaaf5,0xabf5,0xaaf7,0xabf7,0xaaf6,0xabf6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xaaa6,0xaba6,0xaac3,
0xabc3,0xaad5,0xabd5,0xaae7,0xabe7,0xaaf0,0xabf0,0xaaed,
0xabed,0xaaef,0xabef,0xaaee,0xabee,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xabb9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa2b0,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa2af,0xa2b2,0xa2b6,0xa2b5,0xffff,0xa2b3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa2b8,0xa2b9,0xa6e1,0xffff,
0xa6e2,0xa6e3,0xa6e4,0xffff,0xa6e7,0xffff,0xa6e9,0xa6ec,
0xa6f6,0xa6a1,0xa6a2,0xa6a3,0xa6a4,0xa6a5,0xa6a6,0xa6a7,
0xa6a8,0xa6a9,0xa6aa,0xa6ab,0xa6ac,0xa6ad,0xa6ae,0xa6af,
0xa6b0,0xa6b1,0xffff,0xa6b2,0xa6b3,0xa6b4,0xa6b5,0xa6b6,
0xa6b7,0xa6b8,0xa6e5,0xa6ea,0xa6f1,0xa6f2,0xa6f3,0xa6f4,
0xa6fb,0xa6c1,0xa6c2,0xa6c3,0xa6c4,0xa6c5,0xa6c6,0xa6c7,
0xa6c8,0xa6c9,0xa6ca,0xa6cb,0xa6cc,0xa6cd,0xa6ce,0xa6cf,
0xa6d0,0xa6d1,0xa6f8,0xa6d2,0xa6d3,0xa6d4,0xa6d5,0xa6d6,
0xa6d7,0xa6d8,0xa6f5,0xa6fa,0xa6f7,0xa6f9,0xa6fc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa7a7,0xa7c2,0xa7c3,0xa7c4,0xa7c5,0xa7c6,0xa7c7,
0xa7c8,0xa7c9,0xa7ca,0xa7cb,0xa7cc,0xffff,0xa7cd,0xa7ce,
0xa7a1,0xa7a2,0xa7a3,0xa7a4,0xa7a5,0xa7a6,0xa7a8,0xa7a9,
0xa7aa,0xa7ab,0xa7ac,0xa7ad,0xa7ae,0xa7af,0xa7b0,0xa7b1,
0xa7b2,0xa7b3,0xa7b4,0xa7b5,0xa7b6,0xa7b7,0xa7b8,0xa7b9,
0xa7ba,0xa7bb,0xa7bc,0xa7bd,0xa7be,0xa7bf,0xa7c0,0xa7c1,
0xa7d1,0xa7d2,0xa7d3,0xa7d4,0xa7d5,0xa7d6,0xa7d8,0xa7d9,
0xa7da,0xa7db,0xa7dc,0xa7dd,0xa7de,0xa7df,0xa7e0,0xa7e1,
0xa7e2,0xa7e3,0xa7e4,0xa7e5,0xa7e6,0xa7e7,0xa7e8,0xa7e9,
0xa7ea,0xa7eb,0xa7ec,0xa7ed,0xa7ee,0xa7ef,0xa7f0,0xa7f1,
0xffff,0xa7d7,0xa7f2,0xa7f3,0xa7f4,0xa7f5,0xa7f6,0xa7f7,
0xa7f8,0xa7f9,0xa7fa,0xa7fb,0xa7fc,0xffff,0xa7fd,0xa7fe,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa1be,0xffff,0xffff,0xffff,0xa1bd,0xffff,0xa1c2,0xffff,
0xa1c6,0xa1c7,0xffff,0xffff,0xa1c8,0xa1c9,0xffff,0xffff,
0xa2f7,0xa2f8,0xffff,0xffff,0xffff,0xa1c5,0xa1c4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa2f3,0xffff,0xa1ec,0xa1ed,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa2a8,0xffff,0xffff,0xa1b1,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa1ee,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa2f1,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xade4,0xa2ef,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa2f2,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xadb5,0xadb6,0xadb7,0xadb8,0xadb9,0xadba,0xadbb,0xadbc,
0xadbd,0xadbe,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa2ab,0xa2ac,0xa2aa,0xa2ad,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa2cd,0xffff,0xa2ce,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa2cf,0xffff,0xa2df,0xa2d0,0xffff,0xffff,0xffff,0xa2e0,
0xa2ba,0xffff,0xffff,0xa2bb,0xffff,0xffff,0xffff,0xffff,
0xffff,0xadf4,0xa1dd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa2e5,0xffff,0xffff,0xa2e7,0xa1e7,0xadf8,
0xa2dc,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa2ca,
0xa2cb,0xa2c1,0xa2c0,0xa2e9,0xa2ea,0xffff,0xadf3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa1e8,0xa2e8,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa2e6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa2e2,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa1e2,0xa2e1,0xffff,0xffff,0xffff,0xffff,0xa1e5,0xa1e6,
0xffff,0xffff,0xa2e3,0xa2e4,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa2be,0xa2bf,0xffff,0xffff,0xa2bc,0xa2bd,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa2dd,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xadf9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa2de,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xada1,0xada2,0xada3,0xada4,0xada5,0xada6,0xada7,0xada8,
0xada9,0xadaa,0xadab,0xadac,0xadad,0xadae,0xadaf,0xadb0,
0xadb1,0xadb2,0xadb3,0xadb4,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa8a1,0xa8ac,0xa8a2,0xa8ad,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa8a3,0xffff,0xffff,0xa8ae,
0xa8a4,0xffff,0xffff,0xa8af,0xa8a6,0xffff,0xffff,0xa8b1,
0xa8a5,0xffff,0xffff,0xa8b0,0xa8a7,0xa8bc,0xffff,0xffff,
0xa8b7,0xffff,0xffff,0xa8b2,0xa8a9,0xa8be,0xffff,0xffff,
0xa8b9,0xffff,0xffff,0xa8b4,0xa8a8,0xffff,0xffff,0xa8b8,
0xa8bd,0xffff,0xffff,0xa8b3,0xa8aa,0xffff,0xffff,0xa8ba,
0xa8bf,0xffff,0xffff,0xa8b5,0xa8ab,0xffff,0xffff,0xa8bb,
0xffff,0xffff,0xa8c0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa8b6,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa2a3,0xa2a2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa2a5,0xa2a4,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa2a7,0xa2a6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa2a1,0xa1fe,
0xffff,0xffff,0xffff,0xa1fb,0xffff,0xffff,0xa1fd,0xa1fc,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa2fe,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa1fa,0xa1f9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa1ea,0xffff,0xa1e9,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa2f6,0xffff,0xffff,0xa2f5,0xffff,0xa2f4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa1a1,0xa1a2,0xa1a3,0xa1b7,0xffff,0xa1b9,0xa1ba,0xa1bb,
0xa1d2,0xa1d3,0xa1d4,0xa1d5,0xa1d6,0xa1d7,0xa1d8,0xa1d9,
0xa1da,0xa1db,0xa2a9,0xa2ae,0xa1cc,0xa1cd,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa1c1,0xade0,0xffff,0xade1,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa4a1,0xa4a2,0xa4a3,0xa4a4,0xa4a5,0xa4a6,0xa4a7,
0xa4a8,0xa4a9,0xa4aa,0xa4ab,0xa4ac,0xa4ad,0xa4ae,0xa4af,
0xa4b0,0xa4b1,0xa4b2,0xa4b3,0xa4b4,0xa4b5,0xa4b6,0xa4b7,
0xa4b8,0xa4b9,0xa4ba,0xa4bb,0xa4bc,0xa4bd,0xa4be,0xa4bf,
0xa4c0,0xa4c1,0xa4c2,0xa4c3,0xa4c4,0xa4c5,0xa4c6,0xa4c7,
0xa4c8,0xa4c9,0xa4ca,0xa4cb,0xa4cc,0xa4cd,0xa4ce,0xa4cf,
0xa4d0,0xa4d1,0xa4d2,0xa4d3,0xa4d4,0xa4d5,0xa4d6,0xa4d7,
0xa4d8,0xa4d9,0xa4da,0xa4db,0xa4dc,0xa4dd,0xa4de,0xa4df,
0xa4e0,0xa4e1,0xa4e2,0xa4e3,0xa4e4,0xa4e5,0xa4e6,0xa4e7,
0xa4e8,0xa4e9,0xa4ea,0xa4eb,0xa4ec,0xa4ed,0xa4ee,0xa4ef,
0xa4f0,0xa4f1,0xa4f2,0xa4f3,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa1ab,0xa1ac,0xa1b5,0xa1b6,0xffff,
0xffff,0xa5a1,0xa5a2,0xa5a3,0xa5a4,0xa5a5,0xa5a6,0xa5a7,
0xa5a8,0xa5a9,0xa5aa,0xa5ab,0xa5ac,0xa5ad,0xa5ae,0xa5af,
0xa5b0,0xa5b1,0xa5b2,0xa5b3,0xa5b4,0xa5b5,0xa5b6,0xa5b7,
0xa5b8,0xa5b9,0xa5ba,0xa5bb,0xa5bc,0xa5bd,0xa5be,0xa5bf,
0xa5c0,0xa5c1,0xa5c2,0xa5c3,0xa5c4,0xa5c5,0xa5c6,0xa5c7,
0xa5c8,0xa5c9,0xa5ca,0xa5cb,0xa5cc,0xa5cd,0xa5ce,0xa5cf,
0xa5d0,0xa5d1,0xa5d2,0xa5d3,0xa5d4,0xa5d5,0xa5d6,0xa5d7,
0xa5d8,0xa5d9,0xa5da,0xa5db,0xa5dc,0xa5dd,0xa5de,0xa5df,
0xa5e0,0xa5e1,0xa5e2,0xa5e3,0xa5e4,0xa5e5,0xa5e6,0xa5e7,
0xa5e8,0xa5e9,0xa5ea,0xa5eb,0xa5ec,0xa5ed,0xa5ee,0xa5ef,
0xa5f0,0xa5f1,0xa5f2,0xa5f3,0xa5f4,0xa5f5,0xa5f6,0xffff,
0xffff,0xffff,0xffff,0xa1a6,0xa1bc,0xa1b3,0xa1b4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xadea,0xadeb,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xadec,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xade5,0xade6,0xade7,0xade8,
0xade9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xadc6,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xadca,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xadc1,0xffff,0xffff,0xffff,
0xadc4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xadc2,0xadcc,0xffff,0xffff,0xadcb,0xadc5,
0xffff,0xffff,0xffff,0xadcd,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xadc7,0xffff,
0xffff,0xffff,0xffff,0xadcf,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xadc0,0xadce,0xffff,0xffff,0xadc3,0xffff,0xffff,
0xffff,0xadc8,0xffff,0xffff,0xffff,0xffff,0xffff,0xadc9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xaddf,0xadef,0xadee,0xaded,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xadd3,0xadd4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xadd0,0xadd1,0xadd2,0xffff,
0xffff,0xadd6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xadd5,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xade3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb0ec,0xc3fa,0xb0a1,0xbcb7,0xb0a2,0xb0a3,0xffff,0xcbfc,
0xbee6,0xbbb0,0xbee5,0xb2bc,0xb0a4,0xc9d4,0xcdbf,0xffff,
0xd0a2,0xb1af,0xb0a5,0xffff,0xb3ee,0xd0a3,0xc0a4,0xd2c2,
0xb5d6,0xcaba,0xffff,0xffff,0xffff,0xffff,0xbee7,0xb0a6,
0xffff,0xcebe,0xffff,0xb0a7,0xb0a8,0xffff,0xcac2,0xffff,
0xb0a9,0xffff,0xd0a4,0xb0aa,0xffff,0xc3e6,0xb0ab,0xb0ac,
0xb0ad,0xd0a5,0xb6fa,0xffff,0xffff,0xb0ae,0xd0a6,0xffff,
0xb4dd,0xc3b0,0xffff,0xbce7,0xd0a7,0xffff,0xffff,0xd0a8,
0xb0af,0xb0b0,0xd0a9,0xc7b5,0xb0b1,0xb5d7,0xffff,0xb0b2,
0xffff,0xffff,0xffff,0xc7b7,0xffff,0xc6e3,0xb8c3,0xcbb3,
0xffff,0xb0b3,0xffff,0xffff,0xffff,0xe9c9,0xd0aa,0xbee8,
0xd0ab,0xb2b5,0xb0b4,0xffff,0xb0b5,0xb6e5,0xb8f0,0xcce9,
0xffff,0xffff,0xd6a6,0xb0b6,0xffff,0xffff,0xffff,0xffff,
0xb0b7,0xb0b8,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xcdf0,0xffff,0xc6fd,0xb0b9,0xb0ba,0xffff,0xffff,
0xffff,0xb0bb,0xffff,0xffff,0xffff,0xffff,0xb4a5,0xb0bc,
0xb5b5,0xffff,0xd0ac,0xffff,0xffff,0xd0ad,0xcebb,0xffff,
0xcdbd,0xc1e8,0xd0af,0xbbf6,0xc6f3,0xb0bd,0xd0b2,0xffff,
0xffff,0xb1be,0xb8df,0xffff,0xb8de,0xb0e6,0xb0be,0xb0bf,
0xcfcb,0xcfca,0xffff,0xbab3,0xb0a1,0xb0c0,0xd0b3,0xd0b4,
0xd0b5,0xcbb4,0xd0b6,0xffff,0xb8f2,0xb0e7,0xcbf2,0xffff,
0xb5fc,0xffff,0xffff,0xb5fd,0xb5fe,0xc4e2,0xcebc,0xb0c1,
0xd0b7,0xffff,0xffff,0xd0b8,0xffff,0xffff,0xd0b9,0xffff,
0xffff,0xb0c2,0xbfcd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xbdba,0xbfce,0xd0be,0xb0c3,0xd0bc,0xffff,0xd0bd,0xb5d8,
0xffff,0xffff,0xbaa3,0xb2f0,0xffff,0xd0bb,0xd0ba,0xcaa9,
0xb0c4,0xffff,0xffff,0xffff,0xbbc6,0xbbc5,0xc2be,0xd0bf,
0xc9d5,0xc0e7,0xb0c5,0xb0c6,0xffff,0xa1b8,0xd0c0,0xd0c2,
0xb0c7,0xb0c8,0xb0c9,0xc2e5,0xcee1,0xb0ca,0xffff,0xffff,
0xb0ca,0xffff,0xffff,0xffff,0xffff,0xd0c1,0xb2be,0xb0cb,
0xb6c4,0xb0cc,0xc3e7,0xb0cd,0xffff,0xb0ce,0xb7ef,0xd0c3,
0xffff,0xffff,0xffff,0xc7a4,0xffff,0xb0cf,0xb0d0,0xb0d1,
0xb0d2,0xb4eb,0xb0d3,0xb0d4,0xffff,0xffff,0xffff,0xffff,
0xb0d5,0xd0c4,0xb0cb,0xb0d6,0xb0d7,0xb8e0,0xb4ec,0xc9fa,
0xc8b2,0xb5d9,0xb0d8,0xffff,0xffff,0xb0d9,0xb0da,0xb0db,
0xffff,0xb0dc,0xb2f1,0xffff,0xd0e7,0xc5c1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb0dd,0xc7ec,
0xd0c6,0xb0de,0xffff,0xb0e0,0xc8bc,0xb0e1,0xcee2,0xb0e2,
0xbfad,0xb0e3,0xbbc7,0xb0e4,0xbbf7,0xb2c0,0xb0e5,0xffff,
0xb0e6,0xffff,0xb0e7,0xc4d1,0xffff,0xffff,0xc3a2,0xd0ca,
0xb0e8,0xb0e9,0xffff,0xb0ea,0xb0eb,0xb0cc,0xc4e3,0xbdbb,
0xbab4,0xcda4,0xb0ec,0xc2ce,0xb0ed,0xb2bf,0xb0ee,0xd0c9,
0xb0ef,0xcdbe,0xd0c5,0xd0c7,0xbaee,0xd0c8,0xd5a4,0xb0f0,
0xb0df,0xffff,0xffff,0xb0f1,0xffff,0xffff,0xffff,0xffff,
0xffff,0xd0d0,0xb0f2,0xffff,0xb0f3,0xffff,0xb0f4,0xd0d3,
0xd0d1,0xb0f5,0xffff,0xb2c2,0xffff,0xcabb,0xd0cb,0xb0f6,
0xb0f7,0xb0f8,0xb0f9,0xd0cf,0xb8f3,0xb0fa,0xb0fb,0xbbc8,
0xffff,0xb0fc,0xb0fd,0xb4a6,0xb0fe,0xb1a1,0xd0d4,0xffff,
0xd0cc,0xb1a2,0xb1a3,0xcee3,0xb1a4,0xbbf8,0xb1a5,0xd0cd,
0xb1a6,0xd0d2,0xb1a7,0xb1a8,0xb1a9,0xffff,0xd0d5,0xb1aa,
0xd0ce,0xb1ab,0xb1ac,0xb6a1,0xffff,0xb0cd,0xb1ad,0xb1ae,
0xb6a2,0xb2c1,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xd5a5,0xffff,0xcbf9,0xc9ee,0xb8f4,
0xffff,0xffff,0xb1af,0xffff,0xffff,0xbfaf,0xceb7,0xb1b0,
0xffff,0xb1b1,0xffff,0xb1b2,0xb1b3,0xb1b4,0xb1b5,0xcad8,
0xb1b6,0xb1b7,0xb7b8,0xc2a5,0xb2e4,0xb1b8,0xb1b9,0xffff,
0xb1ba,0xb1bb,0xbdd3,0xb1bc,0xb1bd,0xb1be,0xd0d9,0xb1bf,
0xd0de,0xd0dc,0xb1c0,0xffff,0xd0d7,0xffff,0xffff,0xc2af,
0xd0da,0xffff,0xd0dd,0xd0db,0xb1c1,0xcadd,0xffff,0xd0d8,
0xb1c2,0xbfae,0xb1c3,0xcbf3,0xd0df,0xd0e0,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xbda4,0xd0ed,
0xb1c4,0xffff,0xb1c5,0xc7d0,0xffff,0xc9b6,0xd0e8,0xffff,
0xcaf0,0xffff,0xb2b6,0xffff,0xb1c6,0xb1c7,0xd0ec,0xb1c8,
0xb1c9,0xb1ca,0xffff,0xffff,0xb1cb,0xd0e6,0xd0ef,0xb1cc,
0xffff,0xc1d2,0xb1cd,0xb8c4,0xb1ce,0xc7dc,0xb1cf,0xe0c7,
0xb1d0,0xd0ee,0xc5dd,0xb1d1,0xd0e3,0xffff,0xb8f6,0xb1d2,
0xb1d3,0xb8f5,0xd0e1,0xb1d4,0xb1d5,0xb1d6,0xb1d7,0xbcda,
0xffff,0xd0e9,0xb1d8,0xcaef,0xc3cd,0xd0e5,0xb7f1,0xb1d9,
0xd0e2,0xd0ea,0xd0e4,0xced1,0xd0eb,0xcfc1,0xb1da,0xffff,
0xb1db,0xffff,0xb1dc,0xb1dd,0xffff,0xb1de,0xb6e6,0xffff,
0xffff,0xb7f0,0xffff,0xb1f6,0xffff,0xffff,0xffff,0xffff,
0xb1df,0xb1e0,0xb1e1,0xd0f0,0xffff,0xb1e2,0xb1e3,0xd0f1,
0xd0f5,0xb0ce,0xb1e4,0xffff,0xb1e5,0xffff,0xb1e6,0xcad0,
0xd0f4,0xb1e7,0xb1e8,0xb1e9,0xffff,0xd0f3,0xd0f7,0xb1ea,
0xffff,0xb1eb,0xd0f6,0xffff,0xc4e4,0xffff,0xffff,0xb1ec,
0xb1ed,0xffff,0xb1ee,0xb1ef,0xffff,0xb7f2,0xb1f0,0xb1f1,
0xffff,0xffff,0xb1f2,0xffff,0xd0f8,0xb1f3,0xffff,0xffff,
0xb1f4,0xb1f5,0xbcc5,0xffff,0xc2a6,0xc4e5,0xb6f6,0xffff,
0xd0f9,0xffff,0xffff,0xffff,0xffff,0xb5b6,0xffff,0xffff,
0xd0fa,0xb1f7,0xffff,0xb1f8,0xb1f9,0xd0fc,0xb1fa,0xffff,
0xffff,0xffff,0xb1fb,0xffff,0xffff,0xcbb5,0xb1fc,0xb1fd,
0xb1fe,0xb7e6,0xb2a1,0xb2a2,0xb2a3,0xffff,0xb2a4,0xffff,
0xbbb1,0xc8f7,0xd0fb,0xb2a5,0xb2a6,0xffff,0xb2a7,0xb2a8,
0xb2a9,0xb2aa,0xb2ab,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb2ac,0xffff,0xbac5,0xcdc3,0xffff,0xb2ad,
0xb2ae,0xffff,0xd0fe,0xd1a3,0xd0fd,0xbac4,0xffff,0xbdfd,
0xffff,0xb2af,0xb2b0,0xffff,0xffff,0xb2b1,0xb7b9,0xffff,
0xb2b2,0xffff,0xd1a4,0xb2b3,0xb2b4,0xb6cf,0xffff,0xb2b5,
0xffff,0xd1a1,0xd1a2,0xffff,0xb2b6,0xc6af,0xb2b7,0xc1fc,
0xb2b8,0xb6a3,0xffff,0xb2b9,0xb2ba,0xcbcd,0xd1a5,0xffff,
0xb2bb,0xffff,0xcebd,0xffff,0xb2bc,0xb2bd,0xd1a6,0xb2be,
0xffff,0xffff,0xb2bf,0xd1a9,0xb2c0,0xd1a7,0xb2c1,0xc1ce,
0xb2c2,0xb2c3,0xffff,0xffff,0xffff,0xd1a8,0xd1aa,0xb2c4,
0xffff,0xb2c5,0xb2d1,0xffff,0xffff,0xd1ac,0xb2c6,0xffff,
0xffff,0xd1ab,0xb2c7,0xcac8,0xffff,0xffff,0xb2c8,0xffff,
0xb5b7,0xd1ae,0xd1af,0xb2c9,0xb2af,0xffff,0xb2ca,0xb2cb,
0xb2cc,0xd1ad,0xffff,0xb2cd,0xb2ce,0xb2cf,0xb2d0,0xffff,
0xb2d2,0xffff,0xbcf4,0xffff,0xd1b2,0xd1b1,0xd1b0,0xb2d3,
0xd0d6,0xb2d4,0xd1b3,0xb2d5,0xb2d6,0xb2d7,0xb2d8,0xbdfe,
0xffff,0xd1b4,0xffff,0xb2d9,0xffff,0xffff,0xffff,0xb2da,
0xb2db,0xffff,0xcda5,0xffff,0xb2dc,0xb2dd,0xffff,0xb2de,
0xffff,0xb2df,0xccd9,0xb2e0,0xb2e1,0xb2e2,0xffff,0xd1b6,
0xb2e3,0xb2e4,0xd1b5,0xd1b8,0xd1b7,0xffff,0xffff,0xd1b9,
0xd1ba,0xb0f4,0xb2e5,0xb8b5,0xb7bb,0xbdbc,0xc3fb,0xb6a4,
0xc0e8,0xb8f7,0xb2e6,0xb9ee,0xd1bc,0xccc8,0xc5c6,0xb2e7,
0xbbf9,0xffff,0xd1bb,0xb2e8,0xd1bd,0xb2e9,0xffff,0xb2ea,
0xb2eb,0xffff,0xc5de,0xffff,0xb3f5,0xffff,0xffff,0xb2ec,
0xffff,0xffff,0xd1be,0xffff,0xb2ed,0xc6fe,0xb2ee,0xffff,
0xc1b4,0xd1c0,0xd1c1,0xc8ac,0xb8f8,0xcfbb,0xd1c2,0xffff,
0xffff,0xb6a6,0xffff,0xffff,0xffff,0xcabc,0xc2b6,0xb6f1,
0xc5b5,0xffff,0xffff,0xffff,0xb7f3,0xffff,0xb2ef,0xffff,
0xd1c3,0xffff,0xd1c4,0xb2f0,0xb2f1,0xc6e2,0xb1df,0xffff,
0xffff,0xd1c7,0xbafd,0xb2f2,0xd1c6,0xbac6,0xb2f3,0xd1c8,
0xe6ee,0xd1c9,0xcbc1,0xd1ca,0xffff,0xd1cb,0xd1cc,0xbee9,
0xb2f4,0xbccc,0xffff,0xffff,0xffff,0xb2f5,0xffff,0xffff,
0xb4a7,0xb2f6,0xd1cf,0xb2f7,0xd1cd,0xccbd,0xd1ce,0xffff,
0xc9da,0xd1d0,0xd1d1,0xd1d2,0xc5df,0xb2f8,0xffff,0xffff,
0xd1d6,0xd1d4,0xd1d5,0xd1d3,0xbae3,0xd1d7,0xccea,0xcee4,
0xb2f9,0xffff,0xb2fa,0xffff,0xb2fb,0xd1d8,0xb2fc,0xb2fd,
0xffff,0xffff,0xb2fe,0xffff,0xc0a8,0xd1d9,0xbdda,0xffff,
0xb3a1,0xd1da,0xffff,0xc3fc,0xcebf,0xc5e0,0xffff,0xb3a2,
0xffff,0xb3a3,0xb3a4,0xb3a5,0xffff,0xb3a6,0xd2c5,0xffff,
0xb3a7,0xffff,0xffff,0xd1db,0xf4a5,0xb6c5,0xb3a8,0xffff,
0xd1dc,0xcbde,0xb3a9,0xffff,0xffff,0xb3aa,0xbde8,0xc2fc,
0xffff,0xd1de,0xc6e4,0xffff,0xffff,0xd1df,0xb3ab,0xffff,
0xd1e0,0xb3ae,0xb3ac,0xb3ad,0xb3ae,0xd1e1,0xb6a7,0xb3af,
0xc6cc,0xb1fa,0xbdd0,0xffff,0xffff,0xc8a1,0xd1e2,0xffff,
0xc5e1,0xb3b0,0xb3b1,0xbfcf,0xd1e3,0xb3b2,0xcaac,0xc0da,
0xb4a2,0xffff,0xb4a9,0xd1e4,0xffff,0xffff,0xd1e6,0xffff,
0xffff,0xb7ba,0xb3b3,0xb3b4,0xd1e5,0xb3b5,0xb3b6,0xcef3,
0xb3b7,0xffff,0xffff,0xffff,0xffff,0xbde9,0xffff,0xffff,
0xffff,0xffff,0xb3b8,0xffff,0xc8bd,0xcacc,0xffff,0xd1e7,
0xb3b9,0xcdf8,0xd1e8,0xffff,0xffff,0xffff,0xd1e9,0xffff,
0xc5fe,0xb3ba,0xb3bb,0xd1ea,0xffff,0xb3bc,0xc0a9,0xbafe,
0xb7f4,0xd1eb,0xbbc9,0xb9ef,0xb3bd,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xc4e6,0xd1ed,0xb3be,0xffff,0xc2a7,
0xffff,0xb3bf,0xbaef,0xd1ee,0xd1ef,0xc1b0,0xffff,0xd1ec,
0xffff,0xffff,0xffff,0xffff,0xd1f1,0xb3c0,0xcbb6,0xb3c1,
0xb3c2,0xffff,0xb3c3,0xb9e4,0xb3c4,0xffff,0xd1f0,0xb3c5,
0xb3c6,0xb3c7,0xffff,0xb7f5,0xbade,0xc7ed,0xb3c8,0xffff,
0xffff,0xd1f4,0xd1f2,0xffff,0xffff,0xffff,0xb3c9,0xc9fb,
0xbeea,0xd1fb,0xb3e4,0xd1f5,0xd1f3,0xc1cf,0xffff,0xb3ca,
0xb3cb,0xb3cc,0xffff,0xffff,0xffff,0xd1f7,0xffff,0xd1f6,
0xb3cd,0xffff,0xb3ce,0xb3c4,0xffff,0xb3cf,0xffff,0xb7e0,
0xd1fc,0xcead,0xb3d0,0xffff,0xb3d1,0xd1f8,0xffff,0xffff,
0xffff,0xd1fd,0xd1fa,0xb3d2,0xd1f9,0xb3d3,0xb3d4,0xb3d5,
0xb3d6,0xffff,0xb3d7,0xcecf,0xb3d8,0xffff,0xffff,0xb8f9,
0xb2c3,0xffff,0xffff,0xcef4,0xb3d9,0xb3da,0xb3db,0xb3dc,
0xffff,0xbdf5,0xc5d8,0xb9e5,0xd2a2,0xd2a3,0xffff,0xb3dd,
0xb3de,0xcee5,0xffff,0xffff,0xcfab,0xd2a5,0xb3df,0xb3e0,
0xb3e1,0xb8fa,0xb3e2,0xb3e3,0xd2a4,0xb3e4,0xb3af,0xffff,
0xb3e5,0xd2a6,0xffff,0xcbd6,0xb3e6,0xc4bc,0xb3e7,0xcda6,
0xb3e8,0xcad9,0xffff,0xffff,0xb3e9,0xd2a7,0xffff,0xb3ea,
0xffff,0xb3eb,0xf0d5,0xffff,0xb3ec,0xc6b0,0xb3ed,0xd2a8,
0xb4aa,0xccb3,0xffff,0xb3ee,0xb3ef,0xbea1,0xd2a9,0xcae7,
0xd2ad,0xb3f0,0xc0aa,0xd2aa,0xb6d0,0xb3f1,0xd2ab,0xb4ab,
0xb3f2,0xb3f3,0xb3f4,0xffff,0xb3f5,0xffff,0xffff,0xffff,
0xb3f6,0xb3f7,0xb7ae,0xd2ae,0xb3f8,0xd2af,0xb3f9,0xb3fa,
0xd2b0,0xd2b1,0xbcdb,0xffff,0xffff,0xffff,0xb8fb,0xccde,
0xb3fb,0xcce8,0xc6f7,0xb3fc,0xffff,0xcaf1,0xd2b2,0xffff,
0xd2b3,0xffff,0xb3fd,0xb3fe,0xb4a1,0xd2b5,0xffff,0xd2b7,
0xd2b6,0xb4a2,0xffff,0xb4a3,0xffff,0xd2b8,0xb2bd,0xcbcc,
0xb4a4,0xbafc,0xd2b9,0xb4a5,0xb4a6,0xc1d9,0xb4a7,0xb4a8,
0xbea2,0xb6a9,0xffff,0xd2ba,0xffff,0xb4a9,0xffff,0xb4aa,
0xb4ab,0xb4ac,0xc8db,0xb4ad,0xb4ae,0xb4af,0xffff,0xd2bb,
0xb4b0,0xd2bc,0xb4b1,0xd2bd,0xffff,0xb4b2,0xffff,0xffff,
0xd2be,0xc9a4,0xb6e8,0xb0e5,0xb4b3,0xb4b4,0xb4b5,0xc6bf,
0xd2bf,0xbdbd,0xb4b6,0xc0e9,0xffff,0xd2c1,0xd2c0,0xbea3,
0xb8e1,0xd2c3,0xc8be,0xb4b8,0xb4b7,0xd2c4,0xffff,0xffff,
0xffff,0xc8dc,0xc2b4,0xc2ee,0xb6a8,0xffff,0xffff,0xc6ee,
0xc3b1,0xb4b9,0xc7ee,0xb4ba,0xcbce,0xffff,0xd2c6,0xffff,
0xc0ea,0xb4bb,0xffff,0xb4bc,0xffff,0xb4bd,0xb7b5,0xffff,
0xffff,0xd2c7,0xffff,0xffff,0xb4be,0xb4bf,0xd2c8,0xb1ac,
0xb0f5,0xb4ed,0xb4c0,0xc2a8,0xb5d1,0xcdf1,0xffff,0xd2cb,
0xb2b7,0xb4c1,0xffff,0xd2ca,0xffff,0xffff,0xb4c2,0xb6aa,
0xffff,0xffff,0xd2cc,0xb4c3,0xccf1,0xffff,0xffff,0xb4c4,
0xb4c5,0xffff,0xffff,0xffff,0xffff,0xffff,0xb4c6,0xffff,
0xffff,0xffff,0xffff,0xb4c7,0xb4c8,0xffff,0xd2cd,0xffff,
0xced2,0xb4c9,0xb8fc,0xffff,0xffff,0xb4ca,0xffff,0xb8b6,
0xd2ce,0xb4cb,0xffff,0xffff,0xb4cc,0xd2d0,0xd2cf,0xffff,
0xbfdf,0xb1b9,0xb4cd,0xb4ce,0xffff,0xb1de,0xd2d1,0xb4cf,
0xd2d2,0xffff,0xb4d0,0xb8b7,0xb4d1,0xb4d2,0xd2d3,0xb4d3,
0xb4d4,0xffff,0xb4d5,0xb5ee,0xffff,0xb4d6,0xffff,0xffff,
0xb4d7,0xffff,0xbbb2,0xd2d4,0xffff,0xb4d8,0xffff,0xffff,
0xcbf4,0xbab5,0xb5da,0xcda7,0xc1d0,0xc8bf,0xbcfd,0xb4d9,
0xffff,0xffff,0xb4da,0xb4db,0xbdc7,0xb4dc,0xbce8,0xbcf5,
0xffff,0xbdf6,0xb4dd,0xc8c0,0xffff,0xb4de,0xb4df,0xd2d7,
0xb4e0,0xb1c3,0xc1d1,0xb8fd,0xb8c5,0xb6e7,0xb4e1,0xb4e2,
0xd2db,0xc3a1,0xc2fe,0xb6ab,0xbea4,0xd2dc,0xd2da,0xb2c4,
0xc2e6,0xbcb8,0xbbcb,0xb1a6,0xffff,0xb4e3,0xb3f0,0xb9e6,
0xbbca,0xffff,0xd2dd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xd2de,0xb4e4,0xb5c9,0xb3c6,0xffff,0xffff,0xffff,
0xb9e7,0xb5c8,0xc4df,0xb1a5,0xc6b1,0xccbe,0xb9a1,0xcdf9,
0xc5c7,0xb8fe,0xffff,0xb4e5,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb4e6,0xb7af,0xffff,0xd2e7,0xffff,0xb6e3,
0xcbca,0xb4e7,0xffff,0xffff,0xffff,0xffff,0xc8dd,0xb4e8,
0xb4e9,0xd2e6,0xb4ea,0xb4de,0xd2e1,0xd2e2,0xd2e4,0xb4eb,
0xffff,0xb4ec,0xffff,0xffff,0xb4ed,0xb4ee,0xd2e5,0xffff,
0xb5db,0xbfe1,0xffff,0xcaad,0xd2e3,0xd2df,0xb8e3,0xffff,
0xd2e0,0xffff,0xcfa4,0xb4ef,0xb4f0,0xffff,0xcaf2,0xb4f1,
0xc4e8,0xb8e2,0xb9f0,0xffff,0xffff,0xb4f2,0xd2e8,0xb4f3,
0xffff,0xc6dd,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb4f4,0xd2ec,
0xffff,0xffff,0xb4f5,0xffff,0xb4f6,0xffff,0xb4f7,0xb4f8,
0xbcfe,0xb4f9,0xbcf6,0xb4fa,0xffff,0xb4fb,0xb4fc,0xffff,
0xd2ef,0xd2ed,0xffff,0xcca3,0xb4fd,0xd2ea,0xd2f3,0xd2ee,
0xffff,0xffff,0xffff,0xd2f1,0xb8c6,0xccbf,0xffff,0xb4fe,
0xd2f2,0xb5a1,0xffff,0xb5a2,0xd2f4,0xb5a3,0xd2f6,0xffff,
0xb5a4,0xb5a5,0xffff,0xbaf0,0xcfc2,0xb5a6,0xd2eb,0xd2e9,
0xd2f5,0xb5a7,0xd2f0,0xffff,0xffff,0xb5a8,0xb5a9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xb5aa,0xffff,0xffff,0xb5ab,
0xffff,0xb5ac,0xd2f8,0xffff,0xd3a3,0xd2fa,0xb5ad,0xb5ae,
0xd2fe,0xb5af,0xb5b0,0xd3a1,0xd2fb,0xb5b1,0xb5b2,0xd3be,
0xffff,0xb5b3,0xbae9,0xb3b1,0xffff,0xffff,0xffff,0xb5b4,
0xd2f9,0xb5b5,0xb5b6,0xb5b7,0xd3a5,0xb0f6,0xd3a4,0xb5b8,
0xb0a5,0xc9ca,0xd3a2,0xffff,0xd2fc,0xffff,0xb5b9,0xd2f7,
0xd2fd,0xbac8,0xb5ba,0xffff,0xffff,0xb5bb,0xb5bc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd3a6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb5bd,0xb0f7,0xd3af,0xffff,0xffff,0xd3a7,0xd3a8,0xffff,
0xbea5,0xcbe9,0xb5be,0xffff,0xb5bf,0xd3ad,0xd3ac,0xb5c0,
0xffff,0xffff,0xc5af,0xffff,0xffff,0xffff,0xb5c1,0xffff,
0xffff,0xffff,0xd3ae,0xffff,0xb5c2,0xd3ab,0xb5c3,0xb5c4,
0xb5c5,0xb5c6,0xffff,0xffff,0xb1b4,0xb5c7,0xbab6,0xbfb0,
0xb5c8,0xb5c9,0xffff,0xffff,0xb5ca,0xb5cb,0xb5cc,0xd3a9,
0xc5e2,0xffff,0xffff,0xffff,0xd3aa,0xb5cd,0xb0a2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb5ce,0xb5cf,0xffff,0xffff,0xd3b4,0xcda3,
0xffff,0xbea7,0xb5d0,0xd3ba,0xffff,0xb5d1,0xb5d2,0xffff,
0xd3b9,0xd3b0,0xffff,0xb5d3,0xb5d4,0xb5d5,0xc2c3,0xffff,
0xd3b1,0xb5d6,0xffff,0xffff,0xc2ef,0xd3b6,0xbea6,0xb5d7,
0xffff,0xb5d8,0xb5d9,0xffff,0xd3b3,0xb5da,0xffff,0xcce4,
0xb5db,0xb5dc,0xffff,0xb7bc,0xffff,0xffff,0xd3b7,0xd3b8,
0xb5dd,0xffff,0xb5de,0xb5df,0xd3b5,0xd3bb,0xb5e0,0xffff,
0xb5e1,0xb5e2,0xffff,0xd3b2,0xb5e3,0xffff,0xb5e4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xd3c1,0xd3c6,0xffff,0xd3c2,0xb5e5,
0xd3bd,0xb5e6,0xb5e7,0xd3c7,0xc1b1,0xffff,0xb5e8,0xd3c9,
0xb5e9,0xb9a2,0xd3bf,0xc3fd,0xffff,0xffff,0xb5ea,0xb5eb,
0xffff,0xb5ec,0xb5ed,0xb5ee,0xb5ef,0xffff,0xffff,0xb5f0,
0xd3c3,0xd3bc,0xb4ad,0xffff,0xb4ee,0xb3e5,0xd3c4,0xd3c0,
0xffff,0xffff,0xffff,0xb5f1,0xb5f2,0xffff,0xffff,0xb7f6,
0xd3ca,0xd3c8,0xc1d3,0xb5ca,0xb6ac,0xb5f3,0xd3c5,0xffff,
0xb6f4,0xffff,0xb5f4,0xffff,0xffff,0xffff,0xb1c4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb5f5,
0xffff,0xb5f6,0xffff,0xb5f7,0xd3ce,0xd3cc,0xb5f8,0xd4a7,
0xffff,0xb5f9,0xffff,0xb5fa,0xb5fb,0xffff,0xb5fc,0xffff,
0xffff,0xb5fd,0xb5fe,0xb6a1,0xd3d1,0xffff,0xffff,0xb6a2,
0xb6a3,0xffff,0xd3cb,0xb6a4,0xd3cf,0xffff,0xb6a5,0xd3cd,
0xffff,0xffff,0xb6a6,0xbbcc,0xd3d0,0xffff,0xffff,0xffff,
0xffff,0xb6a7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb6a8,0xd3d3,
0xffff,0xd3d8,0xffff,0xffff,0xffff,0xd3d6,0xd3d5,0xb6a9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xb6aa,0xc3b2,0xffff,
0xb6ab,0xb2c5,0xb6ac,0xffff,0xffff,0xb6ad,0xb6ae,0xb6af,
0xb6b0,0xb6b1,0xb6b2,0xffff,0xd3d2,0xffff,0xd3d4,0xbea8,
0xb1b3,0xb6b3,0xffff,0xd3d7,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xb2de,0xffff,0xffff,0xb6b4,0xffff,0xffff,0xd3e2,
0xb6b5,0xbefc,0xd3de,0xb6b6,0xd3dc,0xb6b7,0xd3dd,0xb6b8,
0xd3df,0xb6b9,0xffff,0xb6ba,0xb6bb,0xb6bc,0xffff,0xb6bd,
0xb6be,0xb6bf,0xb1bd,0xb6c0,0xb6c1,0xffff,0xb6c2,0xffff,
0xffff,0xb6c3,0xffff,0xb6c4,0xc1b9,0xb6c5,0xd3d9,0xb6c6,
0xd3da,0xffff,0xffff,0xffff,0xb6c7,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb3fa,0xffff,0xffff,0xb6c8,0xffff,
0xb6c9,0xb6ca,0xb6cb,0xb6cc,0xd3e1,0xffff,0xb6cd,0xffff,
0xb4ef,0xb6ce,0xd3e4,0xd3e0,0xd3e3,0xb6cf,0xffff,0xb6d0,
0xffff,0xb6d1,0xb6d2,0xffff,0xcaae,0xb6d3,0xffff,0xffff,
0xc6d5,0xffff,0xc8b8,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd3e6,0xffff,0xffff,0xffff,0xb6d4,0xb6d5,0xd3e5,0xb3c5,
0xb6d6,0xffff,0xd3e7,0xb6d7,0xb6d8,0xffff,0xffff,0xd3ea,
0xffff,0xffff,0xffff,0xffff,0xd3e9,0xb6d9,0xffff,0xffff,
0xffff,0xb6da,0xb6db,0xffff,0xffff,0xb6dc,0xb6dd,0xb6de,
0xd3e8,0xffff,0xc7b9,0xffff,0xffff,0xd3eb,0xb6df,0xb6e0,
0xb6e1,0xb6e2,0xffff,0xb6e3,0xb6e4,0xb6e5,0xd3ec,0xffff,
0xffff,0xb6e6,0xffff,0xb6e7,0xd3ee,0xffff,0xd3ed,0xb6e8,
0xffff,0xffff,0xffff,0xffff,0xd3f0,0xffff,0xb6e9,0xffff,
0xd3f3,0xd3f1,0xd3ef,0xd3f2,0xffff,0xb6ea,0xffff,0xffff,
0xd3f4,0xb6eb,0xb6ec,0xb6ed,0xb6f0,0xb6f1,0xd3f5,0xb6ee,
0xb6ef,0xd3f6,0xffff,0xd3f7,0xffff,0xffff,0xffff,0xd3f8,
0xd1c5,0xb6f2,0xbcfc,0xbbcd,0xb6f3,0xb6f4,0xb2f3,0xb6f5,
0xb0f8,0xb6f6,0xffff,0xc3c4,0xb6f7,0xb6f8,0xb6f9,0xb6fa,
0xb6fb,0xffff,0xffff,0xb6fd,0xffff,0xb6fe,0xd3f9,0xffff,
0xbaa4,0xb6fc,0xb0cf,0xbfde,0xffff,0xffff,0xb7a1,0xb7a2,
0xffff,0xd3fa,0xb8c7,0xffff,0xffff,0xb9f1,0xffff,0xd3fc,
0xd3fb,0xb7a3,0xb7a4,0xcae0,0xd3fd,0xffff,0xffff,0xb7a5,
0xd4a1,0xd3fe,0xb7a6,0xd4a2,0xb7a7,0xd4a3,0xffff,0xb7f7,
0xffff,0xb7a8,0xb1e0,0xd4a4,0xffff,0xb7a9,0xd4a6,0xffff,
0xd4a5,0xffff,0xb7aa,0xb7ab,0xd4a8,0xb7ac,0xffff,0xc5da,
0xb7ad,0xffff,0xb7ae,0xb7af,0xb7b0,0xb7b1,0xd4a9,0xb0b5,
0xbadf,0xb7b2,0xb7b3,0xffff,0xb7b4,0xb7bd,0xb7b5,0xb7b6,
0xc3cf,0xffff,0xffff,0xb7b7,0xb7b8,0xffff,0xffff,0xd4aa,
0xd4ab,0xffff,0xffff,0xd4ad,0xffff,0xb7b9,0xb7ba,0xb7bb,
0xd4ae,0xffff,0xbae4,0xffff,0xffff,0xb7bc,0xb7bd,0xb6d1,
0xffff,0xffff,0xcbb7,0xffff,0xb7be,0xb7bf,0xd4ac,0xd4af,
0xbac1,0xb9a3,0xb7c0,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xd4b3,0xb7c1,0xffff,0xbaa5,0xb7c2,0xc3b3,0xb7c3,
0xb7c4,0xd4b0,0xc4da,0xb7c5,0xffff,0xb7c6,0xb7c7,0xb7c8,
0xb7c9,0xb7ca,0xffff,0xb7cb,0xb7cc,0xb7cd,0xffff,0xb7ce,
0xffff,0xb7cf,0xb7d0,0xb7d1,0xb7d2,0xffff,0xb7d3,0xd4b4,
0xffff,0xb7d4,0xbfe2,0xb7d5,0xffff,0xffff,0xffff,0xffff,
0xd4b2,0xd4b5,0xffff,0xb7bf,0xb7d6,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xd4b6,0xb7d7,0xb7e0,0xffff,0xb7d8,
0xffff,0xb7d9,0xb7da,0xffff,0xb7db,0xb7dc,0xb7dd,0xb7de,
0xd4b7,0xb7df,0xb9a4,0xb3c0,0xd4b9,0xffff,0xffff,0xb7e1,
0xb7e2,0xb7e3,0xd4ba,0xffff,0xb7e4,0xffff,0xffff,0xffff,
0xd4bb,0xffff,0xffff,0xd4b8,0xffff,0xffff,0xffff,0xffff,
0xb7e5,0xffff,0xffff,0xffff,0xffff,0xb7e6,0xffff,0xffff,
0xd4b1,0xffff,0xffff,0xd4bc,0xffff,0xffff,0xd4bd,0xb7e7,
0xb7e8,0xffff,0xffff,0xcbe4,0xb7e9,0xffff,0xbeeb,0xb7ea,
0xffff,0xffff,0xd4bf,0xd4c0,0xd4be,0xb7eb,0xd4c2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc7b8,0xb7ec,0xb7ed,0xb0e8,
0xc9d6,0xb7fe,0xffff,0xd4c3,0xb7ee,0xffff,0xb7ef,0xb7f0,
0xffff,0xb7f1,0xffff,0xffff,0xffff,0xb7f2,0xffff,0xffff,
0xb7f3,0xffff,0xffff,0xffff,0xbefd,0xb7f4,0xb7f5,0xbcb9,
0xb7f6,0xc7dd,0xb4f0,0xffff,0xbaeb,0xb7f7,0xb7f8,0xb7f9,
0xcbd9,0xffff,0xc6b2,0xb7fa,0xb7fb,0xb7f8,0xc2cf,0xffff,
0xb7fc,0xb7fd,0xd4c1,0xd4c4,0xb8a1,0xb8a2,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xc2c4,0xffff,0xffff,
0xffff,0xd4c5,0xffff,0xb8a3,0xffff,0xd4c6,0xb8a4,0xb8a5,
0xb8a6,0xd4c8,0xffff,0xffff,0xc4e9,0xffff,0xb8a7,0xb8a8,
0xffff,0xffff,0xb4ae,0xffff,0xffff,0xb8a9,0xffff,0xf4a1,
0xb1e1,0xcaf3,0xb8aa,0xffff,0xbeec,0xc5c8,0xffff,0xffff,
0xffff,0xb8ab,0xbae6,0xffff,0xffff,0xd4ce,0xffff,0xb8ac,
0xcabd,0xcedd,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xb8ad,0xb2f4,0xd4ca,0xb8ae,0xb8af,0xffff,0xb8b0,
0xb8b1,0xc1ba,0xd4cd,0xffff,0xc5e3,0xb8b2,0xffff,0xc5c9,
0xc5e4,0xc8b9,0xc4cd,0xffff,0xffff,0xffff,0xbac9,0xb8b3,
0xffff,0xb8b4,0xd4c9,0xffff,0xb8b5,0xffff,0xffff,0xb8b6,
0xb8b7,0xb1f6,0xffff,0xc5b6,0xffff,0xffff,0xffff,0xffff,
0xd4cb,0xffff,0xd4c7,0xffff,0xffff,0xbfd0,0xffff,0xffff,
0xb8b8,0xd4cf,0xffff,0xffff,0xb8b9,0xffff,0xbdce,0xb8ba,
0xb8bb,0xb8bc,0xffff,0xb6ad,0xffff,0xd4d0,0xffff,0xb8bd,
0xb8be,0xb8bf,0xb8c0,0xffff,0xb8c1,0xb8c2,0xffff,0xb8c3,
0xb8c4,0xffff,0xffff,0xcae8,0xb8c5,0xffff,0xb8c6,0xc1fd,
0xffff,0xffff,0xffff,0xffff,0xc4c6,0xb8c7,0xffff,0xd4d2,
0xb8c8,0xb8c9,0xb8ca,0xffff,0xffff,0xffff,0xb8cb,0xffff,
0xcbcf,0xb8cc,0xffff,0xd4d3,0xffff,0xffff,0xd4d8,0xffff,
0xffff,0xb8cd,0xb8ce,0xcaaf,0xffff,0xffff,0xffff,0xffff,
0xd4d7,0xd4d1,0xd4d4,0xd4d6,0xb8d0,0xffff,0xbaa6,0xffff,
0xffff,0xcac9,0xb8d1,0xffff,0xb8cf,0xd4d9,0xffff,0xc3c5,
0xb8d2,0xffff,0xb2f5,0xffff,0xbeed,0xb8d3,0xb8d4,0xffff,
0xb8d5,0xd4db,0xb8d6,0xd4da,0xb8d7,0xb9e8,0xb8d8,0xd4dc,
0xd4de,0xd4dd,0xb8d9,0xffff,0xd4e0,0xb8da,0xd4d5,0xd4e2,
0xffff,0xb8db,0xb8dc,0xffff,0xd4e1,0xd4df,0xffff,0xffff,
0xffff,0xb8dd,0xffff,0xbbce,0xbfd1,0xffff,0xc1d4,0xd4e3,
0xc0bc,0xb0ed,0xc7e4,0xb8de,0xffff,0xffff,0xffff,0xc4db,
0xffff,0xd4e5,0xd4e4,0xd4e6,0xd4e7,0xd4e8,0xffff,0xffff,
0xffff,0xffff,0xd4e9,0xffff,0xffff,0xb8df,0xb8e0,0xffff,
0xffff,0xcad1,0xd4ea,0xb8e1,0xb8e2,0xffff,0xffff,0xb2c6,
0xd4eb,0xffff,0xb8e3,0xb8e4,0xb8e5,0xcdbc,0xb3b0,0xffff,
0xd2c9,0xbdc8,0xc2bf,0xd4ec,0xcceb,0xb8e7,0xffff,0xffff,
0xffff,0xb8e8,0xccb4,0xb8e9,0xb8ea,0xd4ee,0xffff,0xc2e7,
0xb8eb,0xc5b7,0xc2c0,0xc9d7,0xd4ef,0xd4f0,0xb1fb,0xb8ec,
0xb8ed,0xbcba,0xd4f1,0xb8ee,0xffff,0xb8ef,0xb8f0,0xb0d0,
0xd4f2,0xffff,0xffff,0xffff,0xffff,0xffff,0xd4f3,0xb8f1,
0xffff,0xffff,0xffff,0xb8f2,0xb1e2,0xffff,0xb8f3,0xb4f1,
0xc6e0,0xcaf4,0xffff,0xffff,0xffff,0xffff,0xd4f7,0xc1d5,
0xd4f6,0xb7c0,0xb8f4,0xb8f5,0xcbdb,0xd4f5,0xffff,0xc5e5,
0xd4f9,0xb8f6,0xd4f8,0xb8f7,0xffff,0xb8f8,0xb8f9,0xb8fa,
0xd4fb,0xb8fb,0xd4fa,0xb8fc,0xffff,0xb1fc,0xffff,0xd4fc,
0xbea9,0xd4fe,0xc3a5,0xb8fd,0xd4fd,0xb8fe,0xcab3,0xb9a1,
0xffff,0xffff,0xb9a2,0xbdf7,0xc5db,0xb9a3,0xb9a4,0xffff,
0xd5a1,0xb9a5,0xffff,0xb9a6,0xb9a7,0xb9a5,0xffff,0xffff,
0xffff,0xd5a2,0xc7a1,0xc8de,0xccd1,0xffff,0xffff,0xffff,
0xffff,0xffff,0xc7a5,0xb9a8,0xb9a9,0xd5ab,0xb9aa,0xffff,
0xffff,0xffff,0xb9ab,0xb5b8,0xffff,0xb9ac,0xcdc5,0xb9ad,
0xffff,0xccaf,0xffff,0xd6ac,0xffff,0xd5a3,0xffff,0xb9ae,
0xffff,0xffff,0xffff,0xd5a6,0xb9af,0xc2c5,0xffff,0xb9b0,
0xcbb8,0xffff,0xffff,0xffff,0xc5ca,0xb9b1,0xb9b2,0xb9b3,
0xb9b4,0xffff,0xd5a7,0xb9b5,0xffff,0xffff,0xffff,0xb9b6,
0xffff,0xcbe5,0xb9b7,0xbaca,0xb9b8,0xffff,0xbeaa,0xffff,
0xffff,0xb9b9,0xffff,0xb9ba,0xb9bb,0xffff,0xd5a8,0xffff,
0xb9bc,0xbbd0,0xb9bd,0xbbcf,0xffff,0xb9be,0xffff,0xffff,
0xb0b9,0xb8c8,0xb9bf,0xc0ab,0xb0d1,0xffff,0xffff,0xffff,
0xffff,0xd5ac,0xd5ad,0xffff,0xd5aa,0xb9c0,0xb9c1,0xb9c2,
0xffff,0xffff,0xffff,0xb9c3,0xb9c4,0xb1b8,0xb4af,0xb9c5,
0xd5a9,0xffff,0xccc5,0xc9b1,0xffff,0xffff,0xb9c6,0xb9c7,
0xffff,0xb9c8,0xb9c9,0xffff,0xb9ca,0xffff,0xb0a8,0xb9cb,
0xffff,0xffff,0xffff,0xb0f9,0xffff,0xffff,0xffff,0xbbd1,
0xb9cc,0xb0d2,0xffff,0xb0a3,0xb9cd,0xffff,0xffff,0xffff,
0xffff,0xd5b2,0xffff,0xffff,0xb9ce,0xb9cf,0xb9d0,0xffff,
0xffff,0xd5b0,0xb9d1,0xb9d2,0xffff,0xffff,0xffff,0xffff,
0xccbc,0xffff,0xd5b3,0xffff,0xd5b1,0xffff,0xb9d3,0xd5af,
0xbfb1,0xffff,0xffff,0xb9d4,0xb9d5,0xd5ae,0xffff,0xb9d6,
0xb9d7,0xcada,0xb9d8,0xffff,0xffff,0xb9d9,0xffff,0xb8e4,
0xb9da,0xffff,0xffff,0xffff,0xffff,0xd5b7,0xd5b8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xbeab,0xffff,0xffff,0xffff,
0xd5b4,0xcfac,0xffff,0xffff,0xb9db,0xb9dc,0xc7cc,0xb9dd,
0xb9de,0xd5b6,0xffff,0xffff,0xb9df,0xffff,0xffff,0xffff,
0xb9e0,0xffff,0xffff,0xffff,0xffff,0xb9e1,0xffff,0xffff,
0xffff,0xffff,0xbaa7,0xffff,0xffff,0xffff,0xb9e2,0xffff,
0xffff,0xffff,0xd5b9,0xb9e3,0xffff,0xb9e4,0xc9d8,0xb9e5,
0xffff,0xffff,0xd5ba,0xffff,0xd5b5,0xb9e6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb9e7,
0xffff,0xffff,0xb9e8,0xb9e9,0xffff,0xffff,0xb9ea,0xccbb,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb9eb,0xffff,0xffff,0xffff,0xffff,
0xb9ec,0xffff,0xc7de,0xb9ed,0xffff,0xffff,0xb9ee,0xffff,
0xffff,0xb9ef,0xd5bb,0xc9b2,0xb9f0,0xffff,0xb9f1,0xb9f2,
0xb9f3,0xffff,0xb9f4,0xffff,0xffff,0xffff,0xffff,0xb9f5,
0xffff,0xffff,0xffff,0xffff,0xb9f6,0xffff,0xffff,0xffff,
0xffff,0xb9f7,0xb9f8,0xb9f9,0xffff,0xb9fa,0xffff,0xffff,
0xb9fb,0xffff,0xb9fc,0xb9fd,0xd5bc,0xd5c0,0xd5bd,0xb9fe,
0xffff,0xb2c7,0xd5bf,0xffff,0xbaa1,0xffff,0xbaa2,0xffff,
0xbaa3,0xbcbb,0xffff,0xd5be,0xb7f9,0xffff,0xffff,0xbaa4,
0xd5cc,0xffff,0xffff,0xffff,0xffff,0xffff,0xd5c5,0xd5c2,
0xffff,0xffff,0xbaa5,0xffff,0xbaa6,0xffff,0xffff,0xffff,
0xbaa7,0xc3e4,0xffff,0xd5c1,0xffff,0xbaa8,0xd5c3,0xffff,
0xffff,0xd5c4,0xbaa9,0xffff,0xffff,0xffff,0xbaaa,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xbaab,0xbaac,0xffff,
0xffff,0xffff,0xd5c6,0xd5c7,0xffff,0xbaad,0xffff,0xffff,
0xbaae,0xbaaf,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xbab0,0xb4f2,0xffff,0xd5c9,0xd5c8,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xd5ca,0xbab1,
0xffff,0xbab3,0xffff,0xbab4,0xffff,0xbab5,0xffff,0xffff,
0xffff,0xbab6,0xbeee,0xffff,0xffff,0xbab7,0xffff,0xffff,
0xffff,0xffff,0xd5cd,0xffff,0xc4dc,0xbab8,0xffff,0xffff,
0xb1c5,0xffff,0xd5cb,0xffff,0xbab2,0xffff,0xd5ce,0xffff,
0xbab9,0xffff,0xffff,0xffff,0xffff,0xffff,0xd5cf,0xffff,
0xd5d2,0xbaba,0xffff,0xd5d0,0xffff,0xd5d1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xbabb,0xbabc,0xffff,0xffff,0xffff,
0xbbd2,0xd5d3,0xbabd,0xffff,0xb9a6,0xd5d4,0xbabe,0xbbfa,
0xc2b8,0xffff,0xd5d5,0xd5d6,0xbbda,0xb9a7,0xbabf,0xccd2,
0xffff,0xffff,0xffff,0xb5a8,0xb8c9,0xd5d7,0xb3d8,0xffff,
0xbac0,0xd5d8,0xffff,0xc2b9,0xffff,0xffff,0xbac1,0xbac2,
0xd5d9,0xd6a3,0xffff,0xd5da,0xffff,0xd5db,0xffff,0xffff,
0xd5dc,0xffff,0xd5de,0xffff,0xbac3,0xbac4,0xbac5,0xbac6,
0xd5df,0xbac7,0xffff,0xd5e0,0xbac8,0xc2f0,0xbac9,0xb1a7,
0xbce9,0xb0c2,0xbaca,0xc1d7,0xb4b0,0xbcb5,0xbacb,0xb9a8,
0xbacc,0xbacd,0xffff,0xbace,0xbacf,0xc5e6,0xbad0,0xbda1,
0xb4b1,0xc3e8,0xc4ea,0xb0b8,0xb5b9,0xcaf5,0xffff,0xbcc2,
0xffff,0xffff,0xb5d2,0xc0eb,0xbcbc,0xcda8,0xd5e1,0xffff,
0xbad1,0xbad2,0xffff,0xffff,0xbad3,0xbad4,0xb5dc,0xbad5,
0xbacb,0xbad6,0xbad7,0xb3b2,0xb1e3,0xbeac,0xb2c8,0xbad8,
0xd5e2,0xcdc6,0xbad9,0xffff,0xbada,0xffff,0xffff,0xbdc9,
0xbadb,0xbadc,0xbce4,0xd5e3,0xb4f3,0xc6d2,0xcca9,0xd5e4,
0xffff,0xd5e5,0xffff,0xffff,0xc9d9,0xbadd,0xffff,0xbade,
0xd5e7,0xffff,0xb4a8,0xb6f7,0xd5e6,0xffff,0xbadf,0xbae0,
0xbae1,0xbae2,0xbae3,0xb4b2,0xffff,0xbfb2,0xd5eb,0xbba1,
0xbae4,0xb2c9,0xd5ea,0xffff,0xd5e8,0xd5ec,0xd5e9,0xc7ab,
0xdccd,0xbfb3,0xffff,0xd5ed,0xffff,0xffff,0xcec0,0xbae5,
0xd5ee,0xbae6,0xffff,0xd5f0,0xbae7,0xc3fe,0xd5ef,0xffff,
0xc0a3,0xffff,0xbbfb,0xffff,0xffff,0xbae8,0xc2d0,0xbcf7,
0xffff,0xc9f5,0xc0ec,0xffff,0xbccd,0xd5f1,0xbead,0xd5f2,
0xd5f3,0xb0d3,0xc2ba,0xbfd2,0xbae9,0xd5f4,0xc6b3,0xbeae,
0xffff,0xbeaf,0xffff,0xd5f5,0xffff,0xffff,0xc0ed,0xbaea,
0xffff,0xffff,0xbeb0,0xffff,0xffff,0xffff,0xbaeb,0xbaec,
0xd5f6,0xffff,0xd5f7,0xbaed,0xcce0,0xffff,0xbaee,0xffff,
0xd5f8,0xbaef,0xffff,0xbaf0,0xbaf1,0xb6c6,0xbaf2,0xffff,
0xbaf3,0xbda2,0xbaf4,0xffff,0xffff,0xbaf5,0xbaf6,0xffff,
0xd5f9,0xd5fa,0xbcdc,0xbfac,0xc6f4,0xbfd4,0xc8f8,0xc7a2,
0xb6c9,0xd5fb,0xffff,0xffff,0xffff,0xb5ef,0xd5fc,0xffff,
0xb6fe,0xffff,0xc6cf,0xb2b0,0xffff,0xbbd3,0xd5fd,0xd6a2,
0xd6a1,0xb6fd,0xffff,0xd5fe,0xffff,0xc5b8,0xffff,0xffff,
0xffff,0xbaf7,0xbaf8,0xffff,0xbaf9,0xffff,0xc2b0,0xffff,
0xc5cb,0xbcc8,0xbafa,0xbafb,0xc1d8,0xcdfa,0xffff,0xbafc,
0xbafd,0xbafe,0xffff,0xffff,0xd6a4,0xbba1,0xd6a5,0xc6d6,
0xbba2,0xbbb3,0xffff,0xffff,0xbba3,0xbba4,0xd6a7,0xffff,
0xffff,0xd6a8,0xbba5,0xbba6,0xbba7,0xbba8,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xbba9,
0xbbaa,0xffff,0xbbab,0xffff,0xd6a9,0xffff,0xffff,0xbbac,
0xb4f4,0xd6aa,0xbbad,0xffff,0xd6ab,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xbbae,0xffff,0xbbaf,
0xbbb0,0xb2ac,0xbbb1,0xbbb2,0xffff,0xffff,0xbbb3,0xffff,
0xc1bb,0xb4e4,0xbbb4,0xd6ad,0xcca8,0xffff,0xffff,0xffff,
0xffff,0xc2d2,0xbbb5,0xb3d9,0xbbb6,0xbbb7,0xd6af,0xd6b1,
0xb4df,0xffff,0xbbb8,0xd6ae,0xd6b0,0xffff,0xd6b3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd6b2,0xffff,0xd6b4,
0xffff,0xbbb9,0xffff,0xbbba,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xbbbb,0xffff,0xffff,0xffff,0xffff,0xbbbd,
0xffff,0xd6b5,0xffff,0xffff,0xffff,0xbbbc,0xffff,0xffff,
0xc6bd,0xb6ae,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb2e5,0xd6b6,0xd6bb,0xffff,0xffff,0xd6b9,0xbbbe,0xcaf7,
0xcaf6,0xbbbf,0xbbc0,0xffff,0xbbc1,0xffff,0xc5e7,0xffff,
0xffff,0xffff,0xd6b8,0xbdd4,0xffff,0xd6b7,0xffff,0xffff,
0xffff,0xbbc2,0xffff,0xffff,0xffff,0xffff,0xbbc3,0xbff2,
0xffff,0xffff,0xffff,0xd6bc,0xffff,0xbbc4,0xbaea,0xffff,
0xffff,0xd6c2,0xbbc5,0xffff,0xd6c3,0xd6bd,0xb3b3,0xd6be,
0xd6c7,0xd6c6,0xd6c5,0xd6c1,0xffff,0xffff,0xffff,0xd6c0,
0xffff,0xffff,0xd6c4,0xbbc7,0xbbc8,0xffff,0xbbc9,0xbbca,
0xffff,0xcaf8,0xffff,0xbbc6,0xffff,0xffff,0xffff,0xffff,
0xffff,0xbbcb,0xffff,0xffff,0xbbcc,0xffff,0xffff,0xffff,
0xffff,0xbbcd,0xffff,0xffff,0xffff,0xbbce,0xffff,0xbbcf,
0xffff,0xffff,0xbbd0,0xbbd1,0xffff,0xffff,0xbbd2,0xffff,
0xbbd3,0xffff,0xbbd7,0xd6cb,0xd6c8,0xffff,0xd6ca,0xffff,
0xcdf2,0xbbd5,0xd6c9,0xffff,0xffff,0xbbd4,0xffff,0xffff,
0xffff,0xbbd6,0xffff,0xffff,0xd6bf,0xffff,0xffff,0xbbd8,
0xbbd9,0xbbda,0xbbdb,0xffff,0xbbdc,0xffff,0xffff,0xffff,
0xffff,0xbff3,0xbbdd,0xffff,0xd6cc,0xbbde,0xffff,0xbab7,
0xbbdf,0xffff,0xffff,0xd6cd,0xffff,0xffff,0xd6ce,0xffff,
0xffff,0xbbe0,0xbbe1,0xffff,0xffff,0xffff,0xbbe2,0xbbe3,
0xffff,0xbbe4,0xd6d1,0xbbe5,0xd6d0,0xffff,0xffff,0xd6cf,
0xbbe6,0xffff,0xbbe7,0xc5e8,0xd6ba,0xffff,0xffff,0xffff,
0xd6d7,0xffff,0xbbe8,0xbbe9,0xbbea,0xbbeb,0xffff,0xffff,
0xffff,0xbbec,0xffff,0xbbed,0xffff,0xd6d3,0xffff,0xbbee,
0xbbef,0xffff,0xd6d2,0xffff,0xffff,0xffff,0xffff,0xbbf0,
0xffff,0xffff,0xffff,0xbbf1,0xd6d4,0xffff,0xd6d5,0xffff,
0xbbf2,0xffff,0xe6f4,0xffff,0xbbf3,0xffff,0xffff,0xd6d8,
0xbbf4,0xbbf5,0xcee6,0xffff,0xd6d9,0xd6d6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xbbf6,0xffff,0xffff,0xffff,0xbbf7,
0xffff,0xd6da,0xffff,0xbbf8,0xb4e0,0xd6db,0xbbfa,0xffff,
0xbbf9,0xffff,0xd6dd,0xd6dc,0xffff,0xffff,0xd6de,0xffff,
0xbbfb,0xbbfc,0xffff,0xd6df,0xffff,0xc0ee,0xbda3,0xffff,
0xbbfd,0xbde4,0xffff,0xc1e3,0xbbfe,0xb9a9,0xbab8,0xb9aa,
0xb5f0,0xbca1,0xffff,0xd6e0,0xffff,0xffff,0xbab9,0xffff,
0xffff,0xb8ca,0xd6e1,0xcca6,0xc7c3,0xd6e2,0xffff,0xb9ab,
0xbca2,0xbca3,0xffff,0xb4ac,0xffff,0xc3a7,0xb6d2,0xffff,
0xbca4,0xffff,0xbbd4,0xc9db,0xffff,0xffff,0xc8c1,0xbca5,
0xffff,0xffff,0xffff,0xd6e3,0xb4f5,0xbca6,0xffff,0xffff,
0xffff,0xd6e6,0xbca7,0xffff,0xbca8,0xbca9,0xc4a1,0xffff,
0xbcaa,0xd6e5,0xd6e4,0xd6e7,0xffff,0xc4eb,0xffff,0xbcab,
0xbcac,0xffff,0xffff,0xffff,0xffff,0xbfe3,0xffff,0xffff,
0xbcae,0xffff,0xffff,0xbbd5,0xffff,0xc0ca,0xbcad,0xc2d3,
0xb5a2,0xffff,0xbcaf,0xc4a2,0xffff,0xbcb0,0xd6e8,0xd6e9,
0xbeef,0xffff,0xffff,0xffff,0xffff,0xcbb9,0xbcb1,0xffff,
0xd6ec,0xffff,0xffff,0xd6eb,0xd6ea,0xc9fd,0xffff,0xd6f3,
0xffff,0xbcb4,0xffff,0xbcb2,0xcbda,0xffff,0xd6ed,0xffff,
0xbcb3,0xbcb5,0xffff,0xffff,0xd6ef,0xcbeb,0xbcb6,0xd6ee,
0xbcb7,0xffff,0xffff,0xbcb8,0xbcb9,0xffff,0xbcba,0xd6f0,
0xffff,0xc8a8,0xd6f1,0xcabe,0xd6f2,0xffff,0xffff,0xffff,
0xbcbb,0xffff,0xbcbc,0xbcbd,0xbcbe,0xbcbf,0xbcc0,0xffff,
0xbcc1,0xffff,0xb4b3,0xcabf,0xc7af,0xd6f4,0xd6f5,0xffff,
0xb9ac,0xb4b4,0xd6f6,0xb8b8,0xcdc4,0xcda9,0xb4f6,0xd6f8,
0xbcc2,0xc4a3,0xffff,0xb9ad,0xbeb1,0xffff,0xffff,0xc8df,
0xffff,0xffff,0xbeb2,0xbcc3,0xffff,0xffff,0xbcc4,0xbdf8,
0xffff,0xffff,0xffff,0xffff,0xffff,0xc4ec,0xcaf9,0xc5b9,
0xffff,0xffff,0xb9ae,0xffff,0xc9dc,0xffff,0xffff,0xffff,
0xd6f9,0xffff,0xbcc5,0xffff,0xbcc6,0xbcc7,0xc5d9,0xbac2,
0xbcc8,0xffff,0xbcc9,0xb8cb,0xbcca,0xc4ed,0xffff,0xffff,
0xffff,0xbccb,0xffff,0xbccc,0xffff,0xb0c3,0xbdee,0xb9af,
0xcdc7,0xffff,0xffff,0xffff,0xffff,0xbccd,0xbcce,0xbccf,
0xffff,0xd6fa,0xd6fb,0xc7d1,0xffff,0xffff,0xbcd0,0xffff,
0xd6fc,0xcef7,0xcfad,0xbcd2,0xbcd1,0xffff,0xbcd3,0xd6fe,
0xd6fd,0xbcd4,0xbcd5,0xb3c7,0xbcd6,0xbcd7,0xd7a1,0xffff,
0xffff,0xffff,0xd7a4,0xd7a5,0xbcd8,0xd7a3,0xbcd9,0xc9c0,
0xbeb3,0xd7a7,0xd7a6,0xd7a2,0xffff,0xbcda,0xffff,0xffff,
0xd7a8,0xd7a9,0xffff,0xbcdb,0xd7aa,0xffff,0xffff,0xffff,
0xd7ad,0xd7ab,0xffff,0xd7ac,0xd7ae,0xffff,0xb1e4,0xc4ee,
0xd7af,0xffff,0xb7fa,0xb2f6,0xc7b6,0xffff,0xd7b0,0xc6fb,
0xffff,0xcadb,0xbcdc,0xd7b1,0xcfae,0xffff,0xbcdd,0xbcde,
0xbcdf,0xd7b2,0xcac0,0xd7b5,0xd0a1,0xd0b1,0xbce0,0xbcb0,
0xc6f5,0xd7b6,0xffff,0xb5dd,0xc4a4,0xb0fa,0xd7b7,0xcaa6,
0xb9b0,0xbce1,0xffff,0xc3d0,0xbce2,0xbce3,0xffff,0xc4ef,
0xffff,0xbce4,0xbce5,0xbce6,0xbce7,0xccef,0xb8b9,0xb8cc,
0xbce8,0xd7b8,0xffff,0xbce9,0xbcea,0xd7b9,0xbceb,0xd7bf,
0xbcec,0xbce5,0xffff,0xffff,0xbced,0xc4a5,0xbcee,0xb6af,
0xd7ba,0xffff,0xffff,0xbcef,0xc9ab,0xbcf0,0xc3c6,0xbcf1,
0xbcf2,0xd7bb,0xffff,0xffff,0xbcf3,0xbcf4,0xffff,0xbcf5,
0xd7bc,0xffff,0xb6b0,0xffff,0xd7bd,0xbcf6,0xd7be,0xffff,
0xbcf7,0xd7c0,0xffff,0xc5f6,0xbcf8,0xffff,0xd7c1,0xd7c2,
0xbcf9,0xd7c3,0xffff,0xbcfa,0xd7b4,0xd7b3,0xffff,0xffff,
0xbcfb,0xd7c4,0xb7c1,0xbcfc,0xbcfd,0xffff,0xc9a7,0xbcfe,
0xffff,0xbacc,0xc9b7,0xc4a6,0xc9cb,0xd7c5,0xffff,0xbda1,
0xbeb4,0xb1c6,0xbda2,0xd7c6,0xbda3,0xbda4,0xffff,0xd7c7,
0xbda5,0xccf2,0xbda6,0xffff,0xc8e0,0xbda7,0xbda8,0xd7ca,
0xb1fd,0xc0ac,0xd7c9,0xd7c8,0xb7c2,0xc2d4,0xffff,0xd7ce,
0xd7cc,0xbda9,0xd7cb,0xcea7,0xb8e5,0xbdaa,0xffff,0xbdab,
0xbdf9,0xd7cd,0xc5cc,0xbdbe,0xffff,0xffff,0xbdac,0xc6c0,
0xd7d1,0xd7d0,0xffff,0xffff,0xbdad,0xbdae,0xd7cf,0xffff,
0xd7d2,0xb8e6,0xbdaf,0xffff,0xbdb2,0xffff,0xffff,0xbdb0,
0xd7d3,0xc9fc,0xbddb,0xbdb1,0xbdb3,0xd7d4,0xc8f9,0xbdb4,
0xbdb5,0xbdb6,0xffff,0xc6c1,0xc4a7,0xffff,0xffff,0xffff,
0xbdb7,0xc5b0,0xffff,0xffff,0xd7d5,0xb5ab,0xffff,0xffff,
0xffff,0xffff,0xffff,0xbfb4,0xbdb8,0xc9ac,0xffff,0xbdb9,
0xbdba,0xbdbb,0xffff,0xbdbc,0xb4f7,0xc7a6,0xffff,0xffff,
0xbdbd,0xbdbe,0xbdbf,0xbdc0,0xbdc1,0xffff,0xd7d6,0xbbd6,
0xcbba,0xcbbb,0xffff,0xffff,0xb1fe,0xd7db,0xbdc2,0xffff,
0xc3e9,0xbdc3,0xbdc4,0xffff,0xd7d8,0xffff,0xffff,0xffff,
0xbdc5,0xbdc6,0xbdc7,0xb2f7,0xbdc8,0xbdc9,0xbdca,0xbdcb,
0xd8ad,0xd7da,0xbdcc,0xbdcd,0xffff,0xc7b0,0xbdce,0xffff,
0xd7d9,0xffff,0xbdcf,0xd7d7,0xbdd0,0xb9fa,0xffff,0xd7dd,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xbdd1,
0xffff,0xffff,0xbdd2,0xffff,0xffff,0xbdd3,0xd7e3,0xd7e9,
0xd7e1,0xffff,0xc5dc,0xbdd4,0xbdd5,0xd7e6,0xc9dd,0xbdd6,
0xbdd7,0xd7e0,0xbdd8,0xd7e5,0xcee7,0xbbd7,0xffff,0xbdd9,
0xc2d5,0xd7de,0xffff,0xffff,0xbdda,0xb5de,0xd7e8,0xc0ad,
0xb1e5,0xd7e2,0xb2f8,0xd7e7,0xffff,0xbddb,0xffff,0xb6b1,
0xffff,0xd7e4,0xffff,0xbddc,0xffff,0xbddd,0xffff,0xffff,
0xffff,0xffff,0xd7ea,0xffff,0xffff,0xffff,0xffff,0xffff,
0xbdde,0xd7ec,0xd7f6,0xd7f4,0xffff,0xffff,0xd7f1,0xbddf,
0xbde0,0xbde1,0xd7f0,0xcef8,0xbde2,0xd7f2,0xffff,0xffff,
0xb6b2,0xbde3,0xb9b1,0xffff,0xbde4,0xbdfa,0xbde5,0xbde6,
0xffff,0xd7f9,0xd7eb,0xffff,0xffff,0xbde7,0xffff,0xd7ef,
0xd7df,0xbde8,0xb2fa,0xd7f3,0xd7f5,0xc3d1,0xffff,0xbde9,
0xbaa8,0xb2b8,0xd7ed,0xd7f8,0xd7f7,0xb6b3,0xffff,0xc2a9,
0xb3e6,0xbdea,0xffff,0xffff,0xffff,0xb7c3,0xffff,0xd7ee,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xbdeb,0xbdec,
0xffff,0xd7fa,0xbded,0xd7fd,0xd8a1,0xffff,0xbdee,0xffff,
0xbdef,0xbcbd,0xbdf0,0xd8a7,0xc4f0,0xd7fb,0xbdf1,0xffff,
0xffff,0xbdf2,0xd8a5,0xbdf3,0xb2f9,0xbdf4,0xd8a3,0xd8a4,
0xbdf5,0xffff,0xd7fe,0xd8a2,0xffff,0xbdf6,0xbdf7,0xb8e7,
0xcdaa,0xffff,0xbdf8,0xb4b5,0xbdf9,0xbdfa,0xb1d9,0xd8a6,
0xbdfb,0xc7ba,0xb0ad,0xffff,0xffff,0xffff,0xffff,0xffff,
0xbdfc,0xbdfd,0xc8e1,0xd7dc,0xd8ac,0xd8b0,0xcce5,0xbdfe,
0xd8a9,0xffff,0xffff,0xbea1,0xc5e9,0xd8ae,0xbea2,0xffff,
0xffff,0xffff,0xbea3,0xffff,0xbea4,0xbef0,0xd8af,0xc6d7,
0xbea5,0xbea6,0xbea7,0xbea8,0xffff,0xffff,0xbea9,0xbeaa,
0xffff,0xcfc7,0xffff,0xd8ab,0xbeab,0xbeac,0xffff,0xffff,
0xd8b1,0xbead,0xb9fb,0xbeae,0xc0cb,0xbeaf,0xbeb0,0xb0d4,
0xd8aa,0xd8a8,0xbeb1,0xc1da,0xffff,0xbeb2,0xffff,0xd7fc,
0xbbb4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xc2c6,0xd8bd,0xbeb3,0xc1db,0xd8b8,0xbeb4,0xd8b5,0xd8b6,
0xbeb5,0xbce6,0xd8b9,0xd8bc,0xbeb6,0xbeb7,0xffff,0xffff,
0xd8b7,0xbda5,0xbeb8,0xd8ba,0xffff,0xffff,0xd8b4,0xbeb9,
0xccfc,0xccfb,0xbeba,0xffff,0xbebb,0xd8be,0xd8bf,0xb0d5,
0xbebc,0xbebd,0xbebe,0xbebf,0xbec0,0xd8b3,0xbec1,0xbec2,
0xffff,0xbec3,0xb6f2,0xb0a6,0xbec4,0xffff,0xbec5,0xb4b6,
0xffff,0xd8bb,0xbec6,0xffff,0xffff,0xffff,0xffff,0xd8c3,
0xd8c2,0xffff,0xbec7,0xbec8,0xd8c7,0xffff,0xffff,0xffff,
0xbec9,0xbeca,0xffff,0xffff,0xd8c8,0xbecb,0xbecc,0xbecd,
0xffff,0xbece,0xffff,0xffff,0xd8c6,0xd8c9,0xd8c1,0xd8c5,
0xffff,0xbecf,0xd8ca,0xffff,0xd8cb,0xbed0,0xbed1,0xd8c0,
0xbbfc,0xbed2,0xd8c4,0xc2d6,0xb9b2,0xd8b2,0xbfb5,0xffff,
0xffff,0xffff,0xffff,0xd8d8,0xffff,0xcae9,0xffff,0xffff,
0xd8ce,0xd8cf,0xd8d0,0xffff,0xffff,0xd8d7,0xbed3,0xd8d6,
0xbed4,0xffff,0xcbfd,0xb4b7,0xffff,0xd8d4,0xffff,0xb7c5,
0xb3b4,0xffff,0xffff,0xd8d1,0xbed5,0xffff,0xceb8,0xd8d3,
0xb0d6,0xd8d5,0xbed6,0xd8cc,0xd8d2,0xd8d9,0xb7c4,0xd8cd,
0xbed7,0xffff,0xffff,0xbed8,0xbed9,0xffff,0xcddd,0xbeda,
0xbedb,0xbedc,0xcdab,0xbedd,0xbede,0xffff,0xffff,0xd8dc,
0xffff,0xffff,0xd8e0,0xbedf,0xffff,0xbee0,0xc1fe,0xffff,
0xcef9,0xd8e1,0xbee1,0xbee2,0xd8de,0xffff,0xd8db,0xbee3,
0xbee4,0xd8da,0xd8df,0xffff,0xbee5,0xbee6,0xffff,0xbee7,
0xbee8,0xffff,0xffff,0xffff,0xcab0,0xbee9,0xffff,0xc6b4,
0xbeea,0xb7c6,0xbeeb,0xd8e2,0xd8dd,0xbeec,0xd8e3,0xffff,
0xffff,0xffff,0xb7fb,0xffff,0xffff,0xffff,0xb2b1,0xffff,
0xbeed,0xbeee,0xd8eb,0xffff,0xbeef,0xffff,0xb4b8,0xffff,
0xbef0,0xbef1,0xbef2,0xd8e9,0xffff,0xffff,0xd8ea,0xbaa9,
0xd8e8,0xd8e6,0xd8e5,0xd8ec,0xd8e4,0xd8ee,0xbef3,0xbef4,
0xb2fb,0xffff,0xffff,0xffff,0xffff,0xbef5,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xbef6,0xbef7,0xbef8,0xbef9,
0xffff,0xbefa,0xbefb,0xd8f0,0xffff,0xbefe,0xd8ef,0xbefc,
0xffff,0xbefd,0xffff,0xffff,0xbfa1,0xbfa2,0xffff,0xbfa3,
0xffff,0xffff,0xc4a8,0xffff,0xd8f3,0xffff,0xd8f1,0xd8e7,
0xb7fc,0xffff,0xd8f2,0xffff,0xd8f6,0xd8f5,0xd8f7,0xd8f4,
0xd8f8,0xbfa4,0xffff,0xbfa5,0xbfa6,0xffff,0xffff,0xbfa7,
0xd8f9,0xd8fa,0xcaea,0xffff,0xd8fc,0xd8fb,0xbdbf,0xffff,
0xc0ae,0xb2e6,0xb2fc,0xbfa8,0xd8fd,0xbfa9,0xb0bf,0xffff,
0xffff,0xffff,0xc0cc,0xd8fe,0xbfaa,0xecc3,0xd9a1,0xb7e1,
0xbfab,0xd9a2,0xbfac,0xbfad,0xffff,0xffff,0xc0ef,0xbfae,
0xffff,0xbfaf,0xd9a3,0xbfb0,0xffff,0xffff,0xd9a4,0xb5ba,
0xd9a5,0xffff,0xd9a6,0xd9a7,0xc2d7,0xffff,0xffff,0xffff,
0xb8cd,0xbfb1,0xffff,0xcce1,0xffff,0xbfb2,0xffff,0xcbbc,
0xbdea,0xd9a8,0xbfb3,0xbfb4,0xbfb5,0xffff,0xbfb6,0xc0f0,
0xeebd,0xc8e2,0xffff,0xbcea,0xbfb7,0xbacd,0xd9a9,0xffff,
0xbfb8,0xbfb9,0xbfba,0xc2c7,0xbfbb,0xcaa7,0xbfbc,0xffff,
0xc2f1,0xffff,0xbfbd,0xd9ac,0xbfbe,0xffff,0xd9aa,0xffff,
0xd9ad,0xffff,0xffff,0xd9ab,0xbfbf,0xffff,0xffff,0xffff,
0xd9ae,0xffff,0xffff,0xffff,0xffff,0xbfc0,0xcab1,0xbfc1,
0xffff,0xb0b7,0xffff,0xbfc2,0xffff,0xffff,0xc9de,0xffff,
0xffff,0xc8e3,0xbfc3,0xffff,0xd9af,0xbfc4,0xd9b2,0xbeb5,
0xb5bb,0xffff,0xd9b0,0xd9b7,0xbeb6,0xffff,0xffff,0xffff,
0xffff,0xd9b1,0xc7c4,0xffff,0xffff,0xbfc5,0xbfc6,0xbfc7,
0xbfc8,0xcdde,0xd9b3,0xd9b4,0xd9b8,0xc5ea,0xd9b5,0xb9b3,
0xc0de,0xffff,0xffff,0xd9c6,0xc8b4,0xffff,0xc2f2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xbfc9,0xffff,
0xbfca,0xffff,0xffff,0xc8e4,0xdaad,0xffff,0xffff,0xffff,
0xffff,0xcafa,0xffff,0xbfcb,0xffff,0xc4f1,0xbfcc,0xbfcd,
0xffff,0xcbf5,0xbfce,0xd9bb,0xb2a1,0xc3ea,0xbfcf,0xbfd0,
0xffff,0xffff,0xd9c4,0xffff,0xbfd1,0xc3b4,0xd9be,0xd9c5,
0xd9c0,0xd9c7,0xd9c3,0xffff,0xd9c2,0xc7ef,0xbfd2,0xd9bc,
0xb2fd,0xd9ba,0xb5f1,0xc2f3,0xd9b6,0xbfd3,0xbfd4,0xd9b9,
0xb9b4,0xc0db,0xbfd5,0xbeb7,0xd9c1,0xc7d2,0xffff,0xffff,
0xb5f2,0xb3c8,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xbfd6,0xffff,0xb3e7,0xbfa1,0xd9c9,0xd9ce,
0xffff,0xd9ca,0xbfd7,0xb7fd,0xbfd8,0xd9cf,0xbba2,0xb9e9,
0xffff,0xffff,0xffff,0xffff,0xbfd9,0xbfda,0xbda6,0xd9bd,
0xffff,0xbbfd,0xd9cc,0xbfdb,0xbfdc,0xffff,0xffff,0xbbd8,
0xd9cd,0xb0c4,0xbfdd,0xbfde,0xd9c8,0xbfdf,0xffff,0xffff,
0xbfe0,0xc4a9,0xffff,0xbfe1,0xffff,0xffff,0xbfe2,0xffff,
0xbfe3,0xb5f3,0xffff,0xffff,0xffff,0xffff,0xffff,0xb6b4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xd9cb,
0xb0a7,0xbfe4,0xbfe5,0xbac3,0xffff,0xbfe6,0xffff,0xbfb6,
0xffff,0xffff,0xffff,0xffff,0xffff,0xbfe7,0xbfe8,0xffff,
0xffff,0xbfe9,0xc4f2,0xffff,0xbfea,0xc8d4,0xd9d1,0xc1de,
0xffff,0xbfeb,0xbfec,0xbfed,0xbfee,0xffff,0xbfef,0xffff,
0xffff,0xc2aa,0xbff0,0xbff1,0xbbab,0xd9d2,0xbff2,0xd9d4,
0xd9d0,0xffff,0xbff3,0xbff4,0xbff5,0xcae1,0xffff,0xc4bd,
0xbff6,0xffff,0xffff,0xbff7,0xc1dc,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xbff8,0xbff9,0xcafb,
0xbcce,0xd9e0,0xffff,0xd9df,0xbffa,0xbffb,0xbff8,0xffff,
0xffff,0xbffc,0xb7fe,0xffff,0xbffd,0xbffe,0xd9d9,0xbeb9,
0xc0a1,0xffff,0xc6e8,0xc7b1,0xc0a2,0xc0a3,0xffff,0xc0a4,
0xd9d7,0xffff,0xc0a5,0xc1dd,0xc0a6,0xffff,0xffff,0xc0a7,
0xbcf8,0xd9dc,0xc0a8,0xffff,0xbeb8,0xffff,0xd9d6,0xd9db,
0xc0a9,0xffff,0xc7d3,0xffff,0xc0aa,0xc0ab,0xd9d5,0xffff,
0xb7a1,0xc0ac,0xc0ad,0xb3dd,0xffff,0xffff,0xc0ae,0xd9dd,
0xceab,0xbace,0xc3b5,0xd9da,0xc0af,0xc0dc,0xc0b0,0xb9b5,
0xbfe4,0xb1e6,0xc1bc,0xd9d8,0xb5c5,0xc0b1,0xc0b2,0xc0b3,
0xffff,0xffff,0xb7c7,0xffff,0xc4cf,0xd9de,0xffff,0xffff,
0xffff,0xffff,0xffff,0xc1df,0xffff,0xc0b4,0xd9e1,0xffff,
0xd9e3,0xc0b5,0xffff,0xc2b7,0xd9e9,0xc0b6,0xd9e4,0xffff,
0xc0b7,0xd9e6,0xffff,0xffff,0xffff,0xffff,0xc0b8,0xc9c1,
0xc4f3,0xc0b9,0xd9e7,0xc0ba,0xc0bb,0xc0bc,0xcdac,0xffff,
0xffff,0xffff,0xcdc8,0xb4b9,0xc0bd,0xffff,0xffff,0xffff,
0xc0be,0xb0ae,0xffff,0xd9e5,0xffff,0xc0bf,0xffff,0xffff,
0xffff,0xd9e2,0xc0c0,0xffff,0xc0c1,0xffff,0xb4f8,0xffff,
0xffff,0xffff,0xc0c2,0xc0c3,0xb1e7,0xc0c4,0xd9e8,0xffff,
0xc0c5,0xc0c6,0xcdc9,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xd9ec,0xffff,
0xffff,0xc0c7,0xc0c8,0xffff,0xffff,0xc2bb,0xffff,0xd9f3,
0xc0c9,0xffff,0xc0ca,0xd9ed,0xc0cb,0xffff,0xd9ea,0xd9f1,
0xc0cc,0xffff,0xffff,0xffff,0xd9d3,0xffff,0xc0cd,0xffff,
0xc0ce,0xffff,0xc0cf,0xffff,0xc0d0,0xc0d1,0xd9ee,0xffff,
0xd9f2,0xc0d2,0xc0d3,0xffff,0xc8c2,0xc5eb,0xffff,0xc0d4,
0xc0d5,0xffff,0xffff,0xffff,0xd9eb,0xc0d6,0xd9ef,0xffff,
0xffff,0xffff,0xb7c8,0xffff,0xffff,0xc0d7,0xbaf1,0xc0d8,
0xffff,0xffff,0xc0dd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xc0d9,0xffff,0xffff,0xd9f7,0xc0da,
0xffff,0xc0db,0xc0dc,0xc0dd,0xc0de,0xffff,0xffff,0xffff,
0xc5a6,0xffff,0xc0df,0xc0e0,0xc0e1,0xc0e2,0xffff,0xc0e3,
0xc0e4,0xc0e5,0xffff,0xc0e6,0xffff,0xffff,0xffff,0xd9f4,
0xffff,0xcbe0,0xffff,0xffff,0xffff,0xc0e7,0xffff,0xd9f5,
0xffff,0xffff,0xffff,0xc0e8,0xc0e9,0xffff,0xd9f6,0xffff,
0xccce,0xffff,0xc0a2,0xc0ea,0xffff,0xc0eb,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb7e2,0xffff,0xc0ec,0xffff,0xc0ed,
0xd9fd,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xc0ee,
0xc0ef,0xc0f0,0xbbb5,0xd9fa,0xffff,0xd9f9,0xffff,0xffff,
0xc0f1,0xc0f2,0xc7b2,0xc0f3,0xffff,0xc0f4,0xc6b5,0xc0f5,
0xffff,0xc0f6,0xffff,0xc0f7,0xc5b1,0xd9fb,0xc0f8,0xffff,
0xc0f9,0xd9fc,0xffff,0xc9ef,0xc0fa,0xc7c5,0xbba3,0xffff,
0xc0f1,0xffff,0xcbd0,0xc0fb,0xffff,0xffff,0xffff,0xffff,
0xffff,0xb3c9,0xffff,0xdaa5,0xd9fe,0xc0fc,0xc0fd,0xc0fe,
0xffff,0xcdca,0xdaa7,0xffff,0xc1a1,0xdaa3,0xffff,0xdaa4,
0xffff,0xc1a2,0xc1a3,0xc1a4,0xc1a5,0xc1e0,0xc1a6,0xffff,
0xc1a7,0xc1a8,0xdaa2,0xffff,0xd9bf,0xc1a9,0xffff,0xc1aa,
0xdaa6,0xffff,0xdaa1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xdaab,0xdaac,0xc5a7,0xdaae,0xc1ab,0xc1ac,0xbba4,0xdaa9,
0xffff,0xc1ad,0xc1ae,0xffff,0xb5bc,0xc1af,0xffff,0xdaaf,
0xc1b0,0xdaa8,0xdab3,0xffff,0xdab2,0xc1b1,0xdab1,0xc1b2,
0xffff,0xffff,0xdab4,0xc1b3,0xffff,0xdab6,0xbef1,0xc1b4,
0xdab5,0xc1b5,0xffff,0xffff,0xc1b6,0xdab9,0xffff,0xffff,
0xc1b7,0xc1b8,0xc1b9,0xffff,0xffff,0xffff,0xffff,0xc1ba,
0xffff,0xffff,0xffff,0xc1bb,0xc1bc,0xffff,0xc1bd,0xffff,
0xdab7,0xc1be,0xffff,0xc1bf,0xdab8,0xd9f0,0xc1c0,0xc1c1,
0xffff,0xffff,0xc1c2,0xdabb,0xdaba,0xffff,0xc1c3,0xffff,
0xffff,0xc1c4,0xd9f8,0xdabc,0xdab0,0xffff,0xc1c5,0xbbd9,
0xffff,0xc1c6,0xffff,0xffff,0xdabd,0xdabe,0xdac0,0xdabf,
0xdac1,0xb2fe,0xc1c7,0xb9b6,0xc1c8,0xc1c9,0xcafc,0xc0af,
0xffff,0xffff,0xffff,0xc1ca,0xffff,0xb8ce,0xffff,0xc1cb,
0xdac3,0xc1cc,0xffff,0xffff,0xffff,0xdac6,0xffff,0xc9d2,
0xc1cd,0xb5df,0xc1ce,0xffff,0xc1cf,0xdac5,0xdac4,0xc7d4,
0xdac7,0xb6b5,0xffff,0xffff,0xffff,0xdac9,0xdac8,0xc1d0,
0xc1d1,0xffff,0xb4ba,0xbbb6,0xffff,0xffff,0xc6d8,0xc1d2,
0xffff,0xffff,0xffff,0xc1d3,0xb7c9,0xffff,0xffff,0xffff,
0xbff4,0xffff,0xdaca,0xffff,0xc0b0,0xc5a8,0xffff,0xc9df,
0xdacb,0xffff,0xc1d4,0xffff,0xffff,0xc1d5,0xffff,0xffff,
0xffff,0xc1d6,0xdacc,0xdacd,0xffff,0xc1d7,0xffff,0xcab8,
0xd5dd,0xc0c6,0xc1d8,0xffff,0xc9cc,0xffff,0xbad8,0xffff,
0xc8e5,0xc8c3,0xc1d9,0xffff,0xffff,0xc1da,0xffff,0xc5cd,
0xc1db,0xcec1,0xffff,0xdacf,0xbcd0,0xc1dc,0xffff,0xdad0,
0xc1dd,0xb0b6,0xffff,0xc1de,0xb6d4,0xc0cd,0xc1df,0xc9e0,
0xffff,0xffff,0xffff,0xdad1,0xbbc2,0xc3c7,0xc1e0,0xbbdb,
0xbfb7,0xffff,0xc1e1,0xc1e2,0xc1e3,0xffff,0xffff,0xdad2,
0xffff,0xcafd,0xffff,0xffff,0xb1f7,0xbbdc,0xffff,0xc1e4,
0xffff,0xdad5,0xc1e5,0xdad3,0xdad6,0xceb9,0xdad4,0xffff,
0xc1e6,0xc1e7,0xffff,0xc0fb,0xdad7,0xffff,0xc1e8,0xc2b2,
0xc1e9,0xffff,0xdad8,0xffff,0xc1ea,0xffff,0xc1eb,0xb4fa,
0xc1ec,0xdada,0xffff,0xdad9,0xffff,0xffff,0xffff,0xc1ed,
0xdadb,0xdadc,0xb4fb,0xffff,0xffff,0xc6fc,0xc3b6,0xb5ec,
0xbbdd,0xc1e1,0xffff,0xffff,0xbddc,0xb0b0,0xffff,0xffff,
0xc1ee,0xdadd,0xc1ef,0xffff,0xc1f0,0xc1f1,0xffff,0xffff,
0xffff,0xc1f2,0xb2a2,0xdae1,0xffff,0xffff,0xc1f3,0xc1f4,
0xc1f5,0xffff,0xb9b7,0xdae0,0xc1f6,0xffff,0xbaab,0xbeba,
0xc1f7,0xc1f8,0xdadf,0xffff,0xbebb,0xc1f9,0xccc0,0xbaaa,
0xffff,0xc1fa,0xc1fb,0xb0d7,0xc0ce,0xc1fc,0xc1fd,0xffff,
0xffff,0xffff,0xffff,0xffff,0xdae6,0xc1fe,0xc2a1,0xc0b1,
0xb1c7,0xc2a2,0xc2a3,0xc2a4,0xc2a5,0xbdd5,0xc2a6,0xcbe6,
0xbaf2,0xc2a7,0xc2a8,0xc2a9,0xc2aa,0xbebc,0xc2ab,0xc0a7,
0xc2ac,0xc2ad,0xffff,0xc2ae,0xdae5,0xdae3,0xdae4,0xc2b0,
0xffff,0xc2af,0xffff,0xffff,0xc3eb,0xffff,0xffff,0xdba6,
0xc2b1,0xdaea,0xbbfe,0xb9b8,0xdae8,0xc2b2,0xc2b3,0xffff,
0xffff,0xdae9,0xc2b4,0xbfb8,0xc2b5,0xffff,0xc2b7,0xdae7,
0xffff,0xc2b6,0xbbaf,0xffff,0xffff,0xffff,0xffff,0xc2b8,
0xc2b9,0xc2ba,0xffff,0xc2bb,0xc2bc,0xdaec,0xdaeb,0xdaf0,
0xc2bd,0xc2be,0xdaf1,0xffff,0xdaed,0xffff,0xb3a2,0xdaee,
0xdaef,0xc8d5,0xc2c0,0xc2c1,0xc2c2,0xffff,0xc9e1,0xb7ca,
0xdaf2,0xffff,0xffff,0xc2c4,0xc0b2,0xc2c5,0xbebd,0xc2c7,
0xc2c8,0xc2c9,0xc3d2,0xc2ca,0xc2cc,0xffff,0xc2c3,0xc2c6,
0xc2cb,0xb6c7,0xffff,0xdaf3,0xdaf7,0xffff,0xffff,0xb2cb,
0xdaf4,0xdaf6,0xffff,0xc2cd,0xc2ce,0xc2cf,0xdaf5,0xffff,
0xc2d0,0xbdeb,0xc2d1,0xffff,0xffff,0xffff,0xc3c8,0xb0c5,
0xdaf8,0xc2d2,0xc2d3,0xc2d4,0xc2d5,0xdaf9,0xffff,0xc2d6,
0xc2d7,0xffff,0xc4aa,0xffff,0xc2d8,0xffff,0xcef1,0xffff,
0xffff,0xffff,0xffff,0xbbc3,0xffff,0xc2d9,0xcaeb,0xffff,
0xffff,0xc2da,0xc2db,0xffff,0xcbbd,0xc2dc,0xffff,0xffff,
0xdba2,0xdafb,0xffff,0xc2dd,0xdafe,0xffff,0xdafd,0xc2de,
0xc2df,0xdafa,0xc2e0,0xc2e1,0xdba1,0xffff,0xffff,0xc6de,
0xc2e2,0xdafc,0xffff,0xffff,0xc2e3,0xffff,0xc2e4,0xc2e5,
0xffff,0xffff,0xffff,0xffff,0xc2e6,0xffff,0xdba3,0xffff,
0xffff,0xbdec,0xdba4,0xc2e7,0xcdcb,0xc7f8,0xffff,0xc2e8,
0xdba5,0xffff,0xffff,0xffff,0xffff,0xffff,0xdba7,0xffff,
0xc2e9,0xdba8,0xffff,0xc2ea,0xc2eb,0xffff,0xc2ec,0xffff,
0xdba9,0xffff,0xb6ca,0xb1c8,0xb9b9,0xdbaa,0xffff,0xdbab,
0xbdf1,0xc1e2,0xc2ed,0xc2bf,0xd2d8,0xc1be,0xc1bd,0xc2d8,
0xbac7,0xffff,0xffff,0xd0f2,0xffff,0xc2ee,0xffff,0xc2ef,
0xb7ee,0xcdad,0xffff,0xcafe,0xffff,0xc9fe,0xc2f0,0xdbac,
0xffff,0xffff,0xffff,0xc2f1,0xbaf3,0xc4bf,0xdbad,0xcfaf,
0xffff,0xc2f2,0xffff,0xcbbe,0xc2f3,0xc4ab,0xdbae,0xb4fc,
0xc2f4,0xffff,0xc2f5,0xffff,0xffff,0xffff,0xdbaf,0xdbb0,
0xccda,0xffff,0xcca4,0xcbf6,0xcbdc,0xbba5,0xdbb2,0xffff,
0xffff,0xbceb,0xffff,0xc2f6,0xcbd1,0xffff,0xdbb4,0xdbb7,
0xdbb6,0xffff,0xb4f9,0xffff,0xffff,0xb5e0,0xc2f7,0xdbb3,
0xffff,0xdbb5,0xffff,0xffff,0xffff,0xc2f8,0xdbb8,0xc2f9,
0xc2fa,0xbff9,0xffff,0xffff,0xc2fb,0xffff,0xcdfb,0xb0c9,
0xbae0,0xc2bc,0xffff,0xbcdd,0xc2fc,0xc2fd,0xbef3,0xffff,
0xffff,0xdbbb,0xffff,0xffff,0xc5ce,0xc2fe,0xdbb9,0xc2ab,
0xdbba,0xbef2,0xccdd,0xdbbc,0xdbbd,0xcde8,0xc3a1,0xffff,
0xffff,0xffff,0xdbc2,0xffff,0xc3a2,0xb9ba,0xc3a3,0xc7d5,
0xdbbf,0xc5ec,0xdade,0xdae2,0xc3a4,0xb5cf,0xc3a5,0xc7c7,
0xffff,0xffff,0xffff,0xc3a6,0xdbc1,0xffff,0xbebe,0xc8c4,
0xffff,0xc3a7,0xffff,0xffff,0xc3a8,0xdbc7,0xffff,0xc8fa,
0xffff,0xdbbe,0xffff,0xdbc4,0xdbc3,0xffff,0xc3a9,0xc3aa,
0xc0cf,0xc3ab,0xffff,0xc3ac,0xffff,0xcbed,0xc3ad,0xced3,
0xc3ae,0xc3af,0xcbe7,0xc3b0,0xb2cc,0xbbde,0xffff,0xffff,
0xcfc8,0xdbc6,0xbff5,0xffff,0xffff,0xffff,0xdbc5,0xffff,
0xffff,0xdbc0,0xffff,0xffff,0xffff,0xffff,0xffff,0xb8cf,
0xc3b1,0xc3b2,0xc3b3,0xdbcc,0xdbca,0xc3b4,0xb2cd,0xdbc8,
0xdbce,0xdbd4,0xffff,0xc3b5,0xc3b6,0xc3b7,0xffff,0xffff,
0xc3b9,0xc2c8,0xc3ba,0xc3bb,0xcac1,0xc3bc,0xdbd6,0xffff,
0xc3bd,0xc3be,0xc9a2,0xffff,0xffff,0xffff,0xdbd5,0xc7f0,
0xcbbf,0xb4bb,0xc3bf,0xc0f7,0xbdc0,0xffff,0xffff,0xc3c0,
0xc4d3,0xc3c1,0xcdae,0xffff,0xc3c2,0xdbd1,0xdbd0,0xffff,
0xffff,0xc3c3,0xdbd2,0xffff,0xdbcf,0xffff,0xc3c4,0xdbd7,
0xffff,0xdbcd,0xffff,0xffff,0xdbcb,0xffff,0xdbd3,0xdbc9,
0xc3c5,0xc3ec,0xc3c6,0xccf8,0xbcc6,0xbaf4,0xc3c7,0xc3c8,
0xffff,0xc3b8,0xffff,0xbaba,0xffff,0xffff,0xcbef,0xb3c1,
0xffff,0xffff,0xc4ce,0xc6ca,0xb1c9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xc0f2,0xc3ca,0xffff,0xc0b4,0xb7aa,
0xffff,0xc3cb,0xffff,0xffff,0xffff,0xc3cc,0xdbd9,0xc3cd,
0xffff,0xb9bb,0xb3fc,0xffff,0xffff,0xffff,0xffff,0xc3cf,
0xc3ce,0xdbdb,0xb3f4,0xdbe1,0xc3d0,0xc3d1,0xffff,0xc3d2,
0xc3d3,0xc3d4,0xdbde,0xc3d5,0xc0f3,0xffff,0xffff,0xffff,
0xb3cb,0xbaac,0xffff,0xc3d6,0xb3ca,0xbacf,0xffff,0xc3d7,
0xdbdc,0xb7e5,0xb7cb,0xc5ed,0xc3d8,0xc3d9,0xdbda,0xffff,
0xb0c6,0xffff,0xc3da,0xffff,0xc3db,0xdbdd,0xdbdf,0xffff,
0xb6cd,0xb7ac,0xc3c9,0xb4bc,0xb5cb,0xc3dc,0xffff,0xc3dd,
0xc3de,0xdbe2,0xffff,0xc3df,0xbaf9,0xcbf1,0xffff,0xbbb7,
0xffff,0xffff,0xffff,0xdbe3,0xffff,0xffff,0xffff,0xc9b0,
0xffff,0xffff,0xffff,0xc3e0,0xffff,0xffff,0xc3e1,0xc3e2,
0xc3e3,0xc3e4,0xc3e5,0xffff,0xdbef,0xc3e6,0xb2b3,0xdbe4,
0xffff,0xc3e7,0xc3e8,0xc3e9,0xc3ea,0xffff,0xdbf5,0xdbe5,
0xffff,0xcec2,0xc3eb,0xdbec,0xc3ec,0xc7df,0xc3ed,0xffff,
0xc3ee,0xffff,0xffff,0xffff,0xffff,0xdbf4,0xffff,0xdbe7,
0xffff,0xffff,0xffff,0xb0b4,0xdbe9,0xffff,0xc3ef,0xb9bc,
0xc3f0,0xffff,0xc3f1,0xdbeb,0xc3f2,0xdbea,0xffff,0xdbe6,
0xdbf1,0xc3f3,0xbebf,0xc3f4,0xffff,0xc3f5,0xd4ed,0xb8e8,
0xcdfc,0xc3f6,0xc3f7,0xffff,0xffff,0xdbe8,0xc3f8,0xc4f4,
0xb3a3,0xbaad,0xc3f9,0xdbe0,0xffff,0xdbf0,0xb3e1,0xffff,
0xffff,0xdbee,0xdbf2,0xc3fa,0xc5ee,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xb4fe,0xc3fb,0xdcb2,0xffff,
0xc3fc,0xccc9,0xdbf7,0xb4fd,0xc3fd,0xdbfe,0xffff,0xc3fe,
0xc4a1,0xc4a2,0xcbc0,0xc4a3,0xdca1,0xdca3,0xc4a4,0xdca7,
0xdbf9,0xc4a5,0xc3aa,0xffff,0xc4a6,0xc4a7,0xffff,0xc5ef,
0xdcab,0xdbfc,0xffff,0xdca8,0xffff,0xc4a8,0xffff,0xdca2,
0xc4a9,0xffff,0xc4aa,0xc4ab,0xc4ac,0xc4ad,0xbfb9,0xdcac,
0xc4ae,0xc4af,0xc0b3,0xffff,0xffff,0xc4b0,0xc4b1,0xffff,
0xffff,0xdcaa,0xb4bd,0xc4b2,0xc4b3,0xc4b4,0xffff,0xffff,
0xcfd0,0xdbf6,0xffff,0xffff,0xdca6,0xb0d8,0xc4b5,0xffff,
0xdbf8,0xc4b6,0xc4b7,0xccba,0xdbfd,0xbfa2,0xc4c7,0xdbf3,
0xc4b8,0xc4b9,0xdca5,0xc4ba,0xffff,0xffff,0xc4bb,0xc4bc,
0xffff,0xbffa,0xdcaf,0xb3f1,0xb8a1,0xffff,0xffff,0xffff,
0xffff,0xdcb1,0xdbfa,0xdcb0,0xffff,0xdca9,0xdbfb,0xffff,
0xdcad,0xffff,0xdcae,0xffff,0xffff,0xffff,0xffff,0xffff,
0xdcbf,0xc4bd,0xffff,0xc4be,0xc6ce,0xc4bf,0xdca4,0xffff,
0xc4c0,0xdcbb,0xffff,0xc4c1,0xffff,0xdcbd,0xffff,0xc4d8,
0xffff,0xffff,0xc4c2,0xffff,0xffff,0xc4c3,0xffff,0xffff,
0xffff,0xc4c4,0xcdcc,0xffff,0xffff,0xffff,0xc4c5,0xffff,
0xffff,0xffff,0xffff,0xc9f6,0xdcb8,0xc2ca,0xffff,0xc4c6,
0xffff,0xdcbe,0xc1bf,0xc4c7,0xdcb5,0xdcc2,0xdcc1,0xffff,
0xc6ef,0xdcc0,0xc6ea,0xc4c8,0xc4c9,0xc4ca,0xc4cb,0xffff,
0xc4cc,0xc4cd,0xdcc4,0xdcb7,0xc4ce,0xb6c8,0xdcba,0xbddd,
0xc4cf,0xc4d0,0xc4d1,0xc7e0,0xdcbc,0xb6cb,0xffff,0xdcb4,
0xdcb6,0xdcb3,0xc4d2,0xc4d3,0xcfb0,0xb3da,0xdcb9,0xc4d4,
0xc4d5,0xdcc3,0xb3b5,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xbae7,0xffff,0xffff,0xc4d6,0xb1dd,0xffff,
0xffff,0xdcd4,0xc4d7,0xffff,0xcfb1,0xdcd7,0xc4d8,0xffff,
0xc4d9,0xffff,0xffff,0xbfba,0xdcd6,0xffff,0xffff,0xffff,
0xdcd5,0xc4da,0xffff,0xffff,0xffff,0xc4db,0xc4dc,0xdcd2,
0xc4dd,0xffff,0xffff,0xc4de,0xffff,0xc4df,0xdcc6,0xc4e0,
0xffff,0xdce3,0xdcc5,0xffff,0xdcd8,0xffff,0xffff,0xc4e1,
0xc4e2,0xffff,0xc4e3,0xdcd0,0xc4e4,0xffff,0xdccb,0xdcc8,
0xffff,0xdcc9,0xffff,0xdcd1,0xffff,0xc4e5,0xffff,0xf4a2,
0xc4e6,0xffff,0xdcce,0xb9bd,0xc4c8,0xc1e4,0xdccc,0xffff,
0xdcc7,0xc4e7,0xffff,0xdcca,0xffff,0xffff,0xc4e8,0xc4e9,
0xcdcd,0xcbea,0xffff,0xffff,0xffff,0xdccf,0xdcd9,0xffff,
0xffff,0xffff,0xc4ea,0xffff,0xffff,0xc4eb,0xffff,0xdce1,
0xdcda,0xffff,0xffff,0xdce7,0xffff,0xdce5,0xc4ec,0xc4ed,
0xffff,0xc4ee,0xdce0,0xc4ef,0xffff,0xc4f0,0xffff,0xffff,
0xffff,0xdcdf,0xffff,0xc4d0,0xffff,0xc1e5,0xc4f1,0xdcdd,
0xc4f2,0xc4f3,0xdcdb,0xc4f4,0xffff,0xdce2,0xffff,0xffff,
0xffff,0xffff,0xdce8,0xc8f5,0xdcee,0xffff,0xffff,0xc4f5,
0xffff,0xc4f6,0xdce9,0xdcec,0xdce6,0xc4f7,0xffff,0xc3f4,
0xffff,0xc9b8,0xc4f8,0xdcdc,0xffff,0xc4f9,0xdce4,0xbec0,
0xc4fa,0xcccf,0xdcf8,0xdceb,0xc4fb,0xffff,0xffff,0xffff,
0xc4fc,0xb8a2,0xb2a3,0xb3df,0xffff,0xffff,0xdcd3,0xffff,
0xc4fd,0xffff,0xc4fe,0xffff,0xc5a1,0xbec1,0xdcf0,0xc5a2,
0xdcf7,0xbcf9,0xb3f2,0xc5a3,0xffff,0xc3ae,0xc5a4,0xc5a5,
0xffff,0xffff,0xffff,0xffff,0xdced,0xc5a6,0xc5a7,0xdcf2,
0xdcf6,0xc5a8,0xc5a9,0xb6b6,0xffff,0xffff,0xc5aa,0xffff,
0xc5ab,0xc5ac,0xc5ad,0xffff,0xffff,0xc5ae,0xc5af,0xffff,
0xb5cc,0xdcf4,0xffff,0xc5b0,0xffff,0xffff,0xffff,0xb5a1,
0xffff,0xc6cb,0xdcf3,0xffff,0xc5b1,0xffff,0xdcf5,0xc5b2,
0xffff,0xffff,0xc5b3,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xc5b4,0xdcef,0xc5b5,0xffff,0xffff,0xffff,0xffff,
0xdcf1,0xffff,0xffff,0xffff,0xffff,0xffff,0xc5b6,0xb3e0,
0xc3c9,0xc5b7,0xffff,0xc5b8,0xdcfc,0xffff,0xc5b9,0xc5ba,
0xffff,0xc5bb,0xffff,0xc5bc,0xffff,0xdcfa,0xb8e9,0xffff,
0xdcf9,0xc5bd,0xffff,0xffff,0xffff,0xffff,0xffff,0xdda1,
0xffff,0xffff,0xffff,0xc5be,0xdbd8,0xc5bf,0xc5c0,0xc5c1,
0xdcfb,0xffff,0xdcfd,0xdcfe,0xffff,0xc5c2,0xffff,0xffff,
0xffff,0xffff,0xddac,0xc5c3,0xdda8,0xffff,0xdbed,0xc5c4,
0xc5c5,0xc5c6,0xffff,0xdda7,0xc5c7,0xffff,0xffff,0xffff,
0xdda6,0xffff,0xffff,0xdda3,0xffff,0xc5c8,0xc5c9,0xc5ca,
0xffff,0xdcea,0xdda5,0xdda4,0xffff,0xffff,0xc5cb,0xffff,
0xc5cd,0xc5cc,0xffff,0xffff,0xc5ce,0xffff,0xffff,0xffff,
0xc5cf,0xddaa,0xffff,0xcfa6,0xc5d0,0xc5d1,0xc5d2,0xffff,
0xffff,0xffff,0xddad,0xb6fb,0xc5d3,0xc5d4,0xdda9,0xddab,
0xffff,0xffff,0xffff,0xffff,0xc5d5,0xffff,0xffff,0xc5d6,
0xc8a7,0xffff,0xddae,0xffff,0xc5d7,0xffff,0xffff,0xffff,
0xc5d8,0xc5d9,0xc5da,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xddb2,0xddaf,0xc5db,0xc5dc,0xffff,0xffff,
0xffff,0xffff,0xc5dd,0xc5de,0xcdf3,0xddb0,0xc5df,0xc5e0,
0xffff,0xc5e1,0xdcde,0xffff,0xffff,0xffff,0xffff,0xc5e2,
0xc5e3,0xc5e4,0xddb3,0xffff,0xffff,0xffff,0xddb4,0xc5e5,
0xffff,0xffff,0xffff,0xc5e6,0xffff,0xb1b5,0xc5e7,0xddb6,
0xb7e7,0xbca1,0xffff,0xb6d5,0xc5e8,0xffff,0xffff,0xb2a4,
0xc5e9,0xffff,0xffff,0xc5ea,0xc5eb,0xffff,0xffff,0xc5ec,
0xffff,0xffff,0xcddf,0xffff,0xffff,0xc5ed,0xc5ee,0xddb8,
0xddb7,0xddba,0xb5bd,0xc5ef,0xffff,0xb6d6,0xb4be,0xc5f0,
0xffff,0xffff,0xffff,0xddbd,0xffff,0xffff,0xc5f1,0xddbc,
0xffff,0xddbe,0xc5f2,0xffff,0xb2ce,0xc5f3,0xc3b7,0xffff,
0xddbf,0xffff,0xc5f4,0xb4bf,0xddc1,0xffff,0xc5f5,0xffff,
0xc5f6,0xddc0,0xffff,0xddc2,0xffff,0xc5f7,0xffff,0xddc3,
0xc5f8,0xddc4,0xbbdf,0xc0b5,0xbaa1,0xffff,0xc9f0,0xc5f9,
0xffff,0xcae2,0xcfc4,0xc5fa,0xffff,0xffff,0xc5fb,0xbbf5,
0xc5fc,0xffff,0xffff,0xbad0,0xcef2,0xc5fd,0xffff,0xffff,
0xddc5,0xddc6,0xffff,0xbbe0,0xffff,0xc5fe,0xc6a1,0xddc7,
0xddc8,0xffff,0xc6a2,0xddca,0xddc9,0xc6a3,0xcbd8,0xffff,
0xffff,0xbdde,0xbcec,0xbbc4,0xffff,0xddcb,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xddcd,0xbfa3,0xc6a4,
0xddcc,0xffff,0xffff,0xc6a5,0xffff,0xffff,0xddce,0xc6a6,
0xc6a7,0xffff,0xc6a8,0xc6a9,0xddcf,0xffff,0xffff,0xffff,
0xc6aa,0xc6ab,0xddd0,0xddd1,0xc6ac,0xc6ad,0xc6ae,0xddd2,
0xc6af,0xddd4,0xddd3,0xddd5,0xb2a5,0xc3ca,0xffff,0xddd6,
0xc6b0,0xc6b1,0xbba6,0xb3cc,0xddd7,0xc6b2,0xc6b3,0xc5c2,
0xd4cc,0xffff,0xffff,0xc6b4,0xc6b5,0xb5a3,0xddd8,0xffff,
0xffff,0xc6b6,0xffff,0xddd9,0xc6b7,0xcaec,0xcbe8,0xffff,
0xffff,0xffff,0xc6c7,0xddda,0xc8e6,0xffff,0xc6b8,0xffff,
0xc8fb,0xffff,0xc6b9,0xccd3,0xffff,0xffff,0xffff,0xdddb,
0xffff,0xc6ba,0xffff,0xc6bb,0xffff,0xffff,0xc6bc,0xc6bd,
0xffff,0xffff,0xffff,0xdddd,0xdddc,0xffff,0xc6be,0xdddf,
0xffff,0xc6bf,0xffff,0xddde,0xffff,0xffff,0xffff,0xc6c0,
0xffff,0xc6c1,0xffff,0xffff,0xffff,0xffff,0xffff,0xc6c2,
0xffff,0xffff,0xc6c3,0xffff,0xc6c4,0xc6c5,0xffff,0xffff,
0xdde1,0xc6c6,0xffff,0xffff,0xffff,0xc6c7,0xc6c8,0xbbe1,
0xc6c9,0xccb1,0xc6ca,0xdde2,0xdde3,0xffff,0xffff,0xb5a4,
0xffff,0xc6cb,0xffff,0xdde4,0xffff,0xffff,0xffff,0xc6cc,
0xffff,0xffff,0xffff,0xdde6,0xdde5,0xffff,0xc6cd,0xc6ce,
0xc6cf,0xffff,0xffff,0xffff,0xc6d0,0xffff,0xc6d1,0xffff,
0xffff,0xffff,0xffff,0xc6d2,0xbfe5,0xc6d3,0xc6d4,0xc9b9,
0xb1ca,0xffff,0xc6d5,0xc6d6,0xffff,0xffff,0xc8c5,0xc6d7,
0xc4f5,0xbdc1,0xb5e1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xc6d8,0xc6d9,0xffff,0xc6da,0xc8c6,0xc6db,
0xbcae,0xffff,0xc6dc,0xffff,0xc6dd,0xdde8,0xffff,0xb4c0,
0xffff,0xc6de,0xb1f8,0xc6df,0xc6e0,0xc6f2,0xdde7,0xb9be,
0xc3d3,0xffff,0xdde9,0xffff,0xffff,0xffff,0xffff,0xc7b6,
0xddf1,0xffff,0xddea,0xc6e1,0xffff,0xc6e2,0xffff,0xc6e3,
0xc2c1,0xffff,0xb5e2,0xddf2,0xc6e4,0xffff,0xc6e5,0xffff,
0xc6e6,0xc6e7,0xb7e8,0xc6e8,0xffff,0xb5a5,0xddf0,0xffff,
0xffff,0xddee,0xddeb,0xcde0,0xffff,0xc6e9,0xc6ea,0xc6eb,
0xc4c0,0xc6ec,0xffff,0xffff,0xc6d9,0xddec,0xffff,0xffff,
0xddf4,0xffff,0xddf3,0xb7a3,0xc6ed,0xc6ee,0xb2ad,0xc6ef,
0xc6f0,0xbabb,0xdded,0xddef,0xc6f1,0xffff,0xffff,0xc6f2,
0xffff,0xcbd7,0xc2f4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xcbf7,0xffff,0xffff,0xddfc,0xffff,
0xc6f3,0xddfd,0xc6f4,0xb2cf,0xc6f5,0xffff,0xffff,0xffff,
0xcaa8,0xccfd,0xdea1,0xbca3,0xbec2,0xddf8,0xddfe,0xb1e8,
0xffff,0xb6b7,0xc6f6,0xffff,0xddf5,0xddfa,0xc6f7,0xffff,
0xffff,0xc0f4,0xc7f1,0xffff,0xc8e7,0xc6f8,0xffff,0xc6f9,
0xc6fa,0xc6fb,0xc6fc,0xddf7,0xc6fd,0xcba1,0xc6fe,0xddf9,
0xffff,0xdea4,0xc7a1,0xdea2,0xc7a2,0xddfb,0xffff,0xffff,
0xc7a3,0xcba2,0xc7c8,0xb5e3,0xffff,0xc5a5,0xffff,0xc7a4,
0xc3ed,0xc7a5,0xdea5,0xc7a6,0xc7a7,0xffff,0xc7a8,0xdea3,
0xc2d9,0xddf6,0xc7a9,0xb1cb,0xc7aa,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc7ab,0xffff,0xffff,0xc7ac,
0xffff,0xffff,0xc7ad,0xcdce,0xdeb0,0xffff,0xc7ae,0xc7af,
0xffff,0xc7b0,0xdeaf,0xc7b1,0xffff,0xffff,0xffff,0xc0f6,
0xffff,0xdeac,0xc7b2,0xcdec,0xffff,0xffff,0xc6b6,0xdea6,
0xffff,0xffff,0xffff,0xffff,0xffff,0xc4c5,0xc7b3,0xc7b4,
0xc7b5,0xb1cc,0xb9bf,0xdea9,0xffff,0xffff,0xc7b7,0xc7b8,
0xffff,0xc7b9,0xbda7,0xdeae,0xffff,0xdead,0xdea8,0xffff,
0xdeab,0xc7ba,0xffff,0xb3e8,0xc7bb,0xdeaa,0xc7c9,0xc7bc,
0xffff,0xceae,0xffff,0xffff,0xbef4,0xc0f5,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xc7bd,
0xffff,0xdeb6,0xdeb4,0xffff,0xc9cd,0xffff,0xc7be,0xc7bf,
0xffff,0xc7c0,0xffff,0xdeb1,0xdeb3,0xc7c1,0xb1ba,0xc7c2,
0xffff,0xb9c0,0xcfb2,0xffff,0xb3bd,0xffff,0xc9e2,0xc7c3,
0xc7c4,0xffff,0xffff,0xffff,0xcde1,0xffff,0xffff,0xb3a4,
0xbfbb,0xdeb5,0xffff,0xffff,0xc7c5,0xffff,0xffff,0xffff,
0xffff,0xffff,0xc7c6,0xffff,0xffff,0xdeba,0xffff,0xc7c7,
0xbec3,0xffff,0xffff,0xffff,0xcdb0,0xffff,0xdeb7,0xffff,
0xffff,0xc7c8,0xc7c9,0xdeb2,0xc7ca,0xdeb8,0xc7cb,0xc7cc,
0xc7cd,0xcede,0xffff,0xc5f3,0xc6c2,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xc7ce,0xffff,0xc7cf,0xffff,0xffff,0xb3b6,
0xffff,0xffff,0xb1d5,0xffff,0xc7d0,0xdebe,0xffff,0xc7d1,
0xdec1,0xc7d2,0xffff,0xffff,0xcec3,0xc7d3,0xffff,0xc7d4,
0xcde4,0xffff,0xffff,0xffff,0xc7d5,0xdec8,0xdec2,0xdebf,
0xc7d6,0xffff,0xc7d7,0xced4,0xdec5,0xffff,0xc7d8,0xc7d9,
0xffff,0xbdca,0xdec7,0xffff,0xffff,0xdecc,0xc7da,0xffff,
0xc5f1,0xdeca,0xffff,0xc7db,0xffff,0xc7dc,0xdec4,0xc7dd,
0xc7de,0xc3b8,0xc7df,0xffff,0xdecb,0xc7e0,0xdec0,0xffff,
0xdec6,0xc7e1,0xdecd,0xb0fc,0xdec3,0xffff,0xdece,0xc7e2,
0xc7e3,0xbfbc,0xffff,0xbddf,0xc7e4,0xcaa5,0xc7e5,0xbaae,
0xffff,0xdebb,0xdec9,0xc5ba,0xc7e6,0xffff,0xffff,0xffff,
0xc7e7,0xffff,0xffff,0xffff,0xc7e8,0xc0b6,0xffff,0xb3e9,
0xbad1,0xbec4,0xdebd,0xbdc2,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb7cc,0xffff,0xdebc,0xffff,0xffff,
0xffff,0xded2,0xbded,0xb8ba,0xffff,0xdee1,0xc7e9,0xdedb,
0xb5f4,0xc5cf,0xc7ea,0xded6,0xdedf,0xb0af,0xb1b2,0xc7eb,
0xffff,0xb2b9,0xffff,0xded8,0xc2ac,0xdecf,0xded1,0xb9c1,
0xffff,0xffff,0xc7ec,0xffff,0xffff,0xffff,0xc7ed,0xffff,
0xdee2,0xc7ee,0xdedd,0xc7ef,0xc7f0,0xffff,0xded5,0xffff,
0xffff,0xffff,0xffff,0xdedc,0xc7f1,0xc7f2,0xffff,0xffff,
0xc7f3,0xc7f4,0xccab,0xc7f5,0xffff,0xdeda,0xdede,0xc7f6,
0xffff,0xc7f7,0xc7f8,0xc7f9,0xc7fa,0xffff,0xb8d0,0xc7fb,
0xbec5,0xffff,0xffff,0xc3b9,0xc7fc,0xc7fd,0xc7fe,0xded4,
0xffff,0xffff,0xc8a1,0xc8a2,0xffff,0xffff,0xffff,0xcdaf,
0xc8a3,0xffff,0xffff,0xded7,0xffff,0xffff,0xded0,0xc5f2,
0xffff,0xffff,0xded3,0xc8a4,0xffff,0xffff,0xded9,0xffff,
0xffff,0xffff,0xffff,0xc8a5,0xffff,0xc8a6,0xcfd1,0xbcbe,
0xcbfe,0xffff,0xdee3,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc8ae,0xc8a7,0xffff,0xdeef,
0xb8bb,0xffff,0xffff,0xc8a8,0xffff,0xffff,0xbde0,0xffff,
0xdee5,0xc8a9,0xffff,0xffff,0xceaf,0xb9c2,0xffff,0xdef2,
0xc8aa,0xffff,0xb0ee,0xffff,0xffff,0xdef0,0xffff,0xc8ab,
0xffff,0xffff,0xdee4,0xffff,0xffff,0xc8ac,0xc8ad,0xdeea,
0xffff,0xc8ae,0xdeec,0xc8af,0xffff,0xffff,0xcdcf,0xdee7,
0xffff,0xffff,0xc5ae,0xc8b0,0xffff,0xdee9,0xffff,0xc8b1,
0xc8b2,0xc8b3,0xdef1,0xc8b4,0xdeeb,0xccc7,0xffff,0xc8b5,
0xc8b6,0xdee6,0xc8b7,0xbca2,0xdefe,0xc8b8,0xc8b9,0xc8ba,
0xffff,0xb3ea,0xffff,0xdee8,0xdeed,0xdeee,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xc2ec,0xc2da,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xc8bb,0xdef6,0xc8bc,0xc8bd,0xdefc,
0xffff,0xffff,0xdefa,0xffff,0xc5a9,0xffff,0xffff,0xdfa3,
0xdef7,0xc8be,0xffff,0xc8bf,0xffff,0xc8c0,0xdef8,0xdee0,
0xffff,0xb5f9,0xc9ba,0xffff,0xc8c1,0xffff,0xbcbf,0xffff,
0xc8c2,0xb9f7,0xc8c3,0xffff,0xc8c4,0xc8c5,0xffff,0xcfb3,
0xffff,0xdef4,0xffff,0xdfa2,0xb1e9,0xc1e6,0xc8c6,0xffff,
0xc8c7,0xffff,0xc8c8,0xc8c9,0xffff,0xffff,0xffff,0xffff,
0xc7f9,0xffff,0xb4c1,0xcefa,0xffff,0xffff,0xc8ca,0xffff,
0xffff,0xc8cb,0xc8cc,0xcca1,0xc4d2,0xc8d3,0xffff,0xc8cd,
0xc8ce,0xdefb,0xdefd,0xc8cf,0xffff,0xffff,0xc8d0,0xffff,
0xc1b2,0xffff,0xffff,0xc8d1,0xc8d2,0xffff,0xdfa1,0xdef9,
0xffff,0xdef3,0xffff,0xffff,0xffff,0xb4c3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xc8d4,
0xffff,0xc8d5,0xc8d6,0xc8d7,0xb7e9,0xffff,0xffff,0xc8d8,
0xdfaf,0xc8d9,0xc8da,0xdfaa,0xc0f8,0xc8db,0xc8dc,0xb3e3,
0xffff,0xc8dd,0xc8de,0xffff,0xbde1,0xffff,0xdfb3,0xffff,
0xc8df,0xffff,0xffff,0xffff,0xc8e0,0xdfac,0xc4ac,0xdfa9,
0xc4d9,0xffff,0xffff,0xffff,0xdfcc,0xffff,0xffff,0xffff,
0xdfa6,0xffff,0xdfa5,0xffff,0xdfae,0xc8e1,0xc8e2,0xffff,
0xdfa8,0xdfa7,0xdfad,0xc8e3,0xc0a1,0xffff,0xdfa4,0xc8e4,
0xc8e5,0xffff,0xffff,0xc8e6,0xc8e7,0xc8e8,0xdfb0,0xffff,
0xc8e9,0xdfb1,0xc8ea,0xc8eb,0xc8ec,0xffff,0xc8ed,0xb4c2,
0xffff,0xffff,0xc8ee,0xffff,0xffff,0xffff,0xffff,0xc8ef,
0xc8f0,0xdfb6,0xffff,0xdfb5,0xdfb7,0xc8f1,0xc8f2,0xc8f3,
0xc8f4,0xffff,0xdfba,0xffff,0xffff,0xffff,0xc8f5,0xc8f6,
0xc8f7,0xc5c3,0xffff,0xdfb4,0xffff,0xc8f8,0xc8f9,0xffff,
0xffff,0xdfb8,0xffff,0xffff,0xc8fa,0xffff,0xffff,0xffff,
0xb7e3,0xc2f9,0xdfb2,0xc7bb,0xffff,0xc8fb,0xdfb9,0xc8fc,
0xc8fd,0xffff,0xc8fe,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xdfbe,0xdfbc,0xffff,0xffff,
0xdfbf,0xffff,0xc9a1,0xdfc2,0xffff,0xffff,0xc9a2,0xdfbb,
0xb9ea,0xc7a8,0xffff,0xffff,0xdeb9,0xffff,0xffff,0xffff,
0xc9a3,0xc9a4,0xffff,0xcdf4,0xdfbd,0xffff,0xdfc1,0xc2f5,
0xc9a5,0xdfc0,0xffff,0xdfab,0xffff,0xc9a6,0xefe9,0xffff,
0xffff,0xc9a7,0xdfc5,0xffff,0xc9a8,0xc9a9,0xdfc9,0xffff,
0xc9aa,0xdfc7,0xffff,0xffff,0xffff,0xc9ab,0xc9ac,0xc9ad,
0xffff,0xdfc3,0xffff,0xdfc4,0xffff,0xc9ae,0xffff,0xdfc8,
0xffff,0xdfc6,0xffff,0xffff,0xffff,0xc9ce,0xffff,0xc9af,
0xdfce,0xffff,0xdfcb,0xdfca,0xffff,0xdfcd,0xc6d4,0xdfcf,
0xc9b0,0xffff,0xffff,0xc9b1,0xffff,0xffff,0xc3f5,0xc2ed,
0xffff,0xffff,0xffff,0xffff,0xc0a5,0xffff,0xffff,0xc9b2,
0xdfd0,0xffff,0xdfd2,0xffff,0xc9b3,0xffff,0xffff,0xc9b4,
0xffff,0xc9b5,0xffff,0xffff,0xc9b6,0xffff,0xdfd1,0xffff,
0xffff,0xffff,0xffff,0xc9b7,0xc9b8,0xffff,0xffff,0xffff,
0xc9b9,0xc9ba,0xc9bb,0xc9bc,0xdef5,0xffff,0xc9c1,0xffff,
0xffff,0xdfd3,0xffff,0xffff,0xc9bd,0xc9be,0xffff,0xffff,
0xc6e7,0xffff,0xffff,0xffff,0xffff,0xc9bf,0xc9c0,0xffff,
0xffff,0xffff,0xffff,0xdfd4,0xc9c2,0xc9c3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb2d0,0xc9c4,0xffff,0xc9c5,0xc5f4,
0xb3a5,0xffff,0xffff,0xffff,0xffff,0xc9c6,0xc9c7,0xffff,
0xb5e4,0xffff,0xffff,0xffff,0xbcde,0xbad2,0xc9c8,0xffff,
0xffff,0xc9c9,0xffff,0xffff,0xffff,0xc9ca,0xc9cb,0xffff,
0xffff,0xcfa7,0xbfe6,0xffff,0xffff,0xffff,0xb1ea,0xffff,
0xffff,0xffff,0xdfd6,0xffff,0xc9cc,0xc9cd,0xc9ce,0xc9cf,
0xc9d0,0xdfd5,0xffff,0xc9d1,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc9d2,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xc9d3,0xdfd9,0xc3ba,0xdfdc,0xdfd7,
0xc9d4,0xc9d5,0xffff,0xdfdb,0xc9d6,0xffff,0xffff,0xc9d7,
0xdfda,0xc5c0,0xb0d9,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xcef5,0xffff,0xc9d8,0xdfde,0xffff,0xffff,0xffff,0xb1a8,
0xffff,0xc9d9,0xffff,0xc9da,0xc9db,0xc9dc,0xc9dd,0xffff,
0xc9de,0xdfe0,0xffff,0xffff,0xc9df,0xdfdf,0xffff,0xdfdd,
0xffff,0xffff,0xffff,0xffff,0xc9e0,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xdfd8,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xcba3,0xc9e1,0xffff,0xffff,0xdfe2,0xffff,0xffff,
0xffff,0xffff,0xffff,0xc9e2,0xc9e3,0xc9e4,0xc9e5,0xc9e6,
0xffff,0xdfe1,0xffff,0xc9e7,0xc9e8,0xffff,0xffff,0xc9e9,
0xffff,0xffff,0xffff,0xffff,0xb1eb,0xffff,0xffff,0xffff,
0xffff,0xdfe4,0xcab2,0xffff,0xdfe3,0xffff,0xc9ea,0xffff,
0xc9eb,0xccb5,0xffff,0xffff,0xffff,0xffff,0xbec7,0xffff,
0xffff,0xffff,0xffff,0xc9ec,0xffff,0xc9ed,0xffff,0xc9ee,
0xc9ef,0xc9f0,0xffff,0xffff,0xffff,0xffff,0xc1b3,0xffff,
0xc9f1,0xffff,0xffff,0xffff,0xbec6,0xffff,0xffff,0xffff,
0xffff,0xc9f2,0xffff,0xffff,0xffff,0xc9f3,0xc9f4,0xc9f5,
0xffff,0xcefb,0xc9f6,0xc9f7,0xdfea,0xffff,0xc0f9,0xffff,
0xc9f8,0xffff,0xc9f9,0xffff,0xffff,0xdfe6,0xdfeb,0xc9fa,
0xffff,0xb1ec,0xc9fb,0xffff,0xc9fc,0xffff,0xc9fd,0xffff,
0xc9fe,0xffff,0xdfe9,0xffff,0xc7e1,0xdfe5,0xdfe8,0xbec8,
0xcaa1,0xc8d1,0xffff,0xffff,0xdfec,0xffff,0xbcd1,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xcaa2,0xffff,0xffff,0xffff,0xc0fa,0xffff,0xffff,
0xcaa3,0xffff,0xffff,0xffff,0xdfef,0xcaa4,0xffff,0xcaa5,
0xdfe7,0xffff,0xb7a7,0xffff,0xcaa6,0xffff,0xffff,0xdfed,
0xffff,0xffff,0xcaa7,0xffff,0xcdd0,0xdff0,0xffff,0xffff,
0xffff,0xf4a6,0xcaa8,0xcaa9,0xffff,0xffff,0xffff,0xbdcf,
0xcaaa,0xffff,0xcaab,0xffff,0xffff,0xffff,0xffff,0xffff,
0xdff1,0xffff,0xffff,0xffff,0xdff2,0xffff,0xffff,0xcaac,
0xcaad,0xc7ae,0xcaae,0xcaaf,0xffff,0xffff,0xffff,0xffff,
0xffff,0xdff4,0xcab0,0xffff,0xffff,0xffff,0xdff5,0xcab1,
0xcab2,0xcab3,0xffff,0xc7b3,0xcab4,0xffff,0xffff,0xffff,
0xc5f5,0xdff7,0xffff,0xcab5,0xcab6,0xffff,0xdff9,0xffff,
0xced5,0xffff,0xdff6,0xcab7,0xdff8,0xb1ed,0xcab8,0xdff3,
0xffff,0xcab9,0xcaba,0xffff,0xcabb,0xffff,0xffff,0xd3db,
0xdffa,0xffff,0xffff,0xffff,0xffff,0xc1e7,0xbbb8,0xdffc,
0xffff,0xffff,0xffff,0xffff,0xdffb,0xbfa4,0xd2d9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xdffd,0xffff,0xffff,
0xcabc,0xe0a1,0xffff,0xdfee,0xdffe,0xffff,0xcabd,0xe0a2,
0xcabe,0xffff,0xffff,0xffff,0xffff,0xffff,0xc7fa,0xcabf,
0xcac0,0xcac1,0xffff,0xffff,0xffff,0xe0a3,0xffff,0xffff,
0xe0a4,0xffff,0xffff,0xcac2,0xffff,0xffff,0xffff,0xcac3,
0xffff,0xffff,0xcac4,0xe0a5,0xffff,0xcac5,0xffff,0xcac6,
0xffff,0xffff,0xffff,0xffff,0xcac7,0xffff,0xffff,0xffff,
0xe0a6,0xffff,0xc4de,0xcac8,0xe0a8,0xe0a7,0xffff,0xcac9,
0xe0a9,0xffff,0xe0aa,0xffff,0xcaca,0xbcdf,0xc9e3,0xffff,
0xcacb,0xcacc,0xccec,0xe0ab,0xe0ac,0xc1d6,0xbca4,0xe0ad,
0xe0ae,0xcacd,0xcace,0xcacf,0xffff,0xcad0,0xe0af,0xcad2,
0xc8c7,0xffff,0xffff,0xe0b0,0xc7d7,0xffff,0xcad1,0xcad2,
0xcad3,0xffff,0xc4ad,0xcad4,0xffff,0xcad5,0xcad6,0xffff,
0xe0b1,0xb2e7,0xcad7,0xb5ed,0xcad8,0xccc6,0xcad9,0xccb6,
0xcada,0xb2b4,0xcfb4,0xcadb,0xffff,0xffff,0xffff,0xcbd2,
0xcadc,0xcaaa,0xffff,0xcadd,0xffff,0xffff,0xcade,0xcadf,
0xffff,0xcae0,0xc0b7,0xffff,0xe0b2,0xffff,0xffff,0xcae1,
0xcae2,0xc6c3,0xffff,0xcae3,0xcae4,0xb8a3,0xe0b3,0xcae5,
0xbad4,0xe0b5,0xe0b4,0xffff,0xcae6,0xffff,0xffff,0xe0b6,
0xffff,0xcae7,0xffff,0xffff,0xffff,0xcae8,0xcae9,0xffff,
0xffff,0xffff,0xe0b7,0xcaea,0xffff,0xffff,0xe0b8,0xffff,
0xffff,0xffff,0xffff,0xcaeb,0xffff,0xffff,0xffff,0xffff,
0xb5be,0xffff,0xe0b9,0xffff,0xffff,0xffff,0xffff,0xe0ba,
0xcaec,0xffff,0xffff,0xffff,0xb8a4,0xcaed,0xcaee,0xc8c8,
0xffff,0xcaef,0xe0bc,0xffff,0xcaf0,0xffff,0xbef5,0xffff,
0xffff,0xe0bb,0xffff,0xffff,0xffff,0xffff,0xcaf1,0xffff,
0xffff,0xcaf2,0xb6b8,0xe0bd,0xe0bf,0xffff,0xe0be,0xcaf3,
0xffff,0xcaf4,0xffff,0xffff,0xcaf5,0xffff,0xe0c0,0xffff,
0xb8d1,0xffff,0xe0c1,0xffff,0xffff,0xcaf6,0xcaf7,0xb6e9,
0xcaf8,0xc1c0,0xffff,0xb9fd,0xffff,0xffff,0xffff,0xcaf9,
0xe0c3,0xe0c4,0xe0c2,0xffff,0xffff,0xcafa,0xffff,0xffff,
0xffff,0xbced,0xffff,0xffff,0xc6c8,0xb6b9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xcafb,0xcafc,0xffff,0xffff,0xe0c6,
0xc3ac,0xe0c5,0xcafd,0xcafe,0xcfb5,0xc7e2,0xcba1,0xffff,
0xffff,0xffff,0xcba2,0xffff,0xcba3,0xcba4,0xffff,0xcba5,
0xffff,0xffff,0xe0c9,0xcba6,0xffff,0xcba7,0xffff,0xffff,
0xffff,0xffff,0xcba8,0xcba9,0xffff,0xffff,0xe0cb,0xe0c8,
0xcbaa,0xcbab,0xffff,0xccd4,0xe0ca,0xe0cc,0xcbac,0xcec4,
0xffff,0xffff,0xcbad,0xffff,0xcbae,0xe0d0,0xffff,0xcbaf,
0xcbb0,0xe0cf,0xc3f6,0xc7ad,0xcbb1,0xffff,0xb8a5,0xe0ce,
0xffff,0xcbb2,0xcbb3,0xffff,0xe0cd,0xcbb4,0xcdb1,0xcdb2,
0xffff,0xffff,0xcbb5,0xcbb6,0xffff,0xcbb7,0xe0d1,0xb1ee,
0xffff,0xffff,0xffff,0xcbb8,0xb9f6,0xbbe2,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xcbb9,0xe0d2,0xe0d3,
0xcbba,0xffff,0xcbbb,0xffff,0xffff,0xffff,0xcbbc,0xe0d5,
0xcbbd,0xffff,0xffff,0xffff,0xffff,0xcbbe,0xcbbf,0xcbc0,
0xcbc1,0xffff,0xffff,0xbdc3,0xffff,0xffff,0xcbc2,0xcbc3,
0xe0d7,0xcbc4,0xe0d6,0xcbc5,0xcbc6,0xffff,0xcbc7,0xcbc8,
0xe0d8,0xcbc9,0xb3cd,0xffff,0xffff,0xe0da,0xffff,0xcbca,
0xe0d9,0xcbcb,0xe0dc,0xe0db,0xcbcc,0xffff,0xffff,0xffff,
0xcbcd,0xcbce,0xffff,0xcbcf,0xb8bc,0xcbd0,0xcbd1,0xcea8,
0xffff,0xb6cc,0xffff,0xb2a6,0xffff,0xffff,0xcbd2,0xffff,
0xcbd3,0xffff,0xffff,0xcbd4,0xffff,0xcbd5,0xb6ea,0xcbd6,
0xcbd7,0xffff,0xffff,0xffff,0xcbd8,0xffff,0xcbd9,0xcbda,
0xcbdb,0xffff,0xcbdc,0xffff,0xffff,0xcbdd,0xcbde,0xffff,
0xffff,0xb4e1,0xcbdf,0xcbe0,0xffff,0xcbe1,0xffff,0xffff,
0xffff,0xffff,0xcee8,0xe0de,0xffff,0xcbe2,0xffff,0xcbe3,
0xffff,0xcbe4,0xffff,0xe0e0,0xcbe5,0xcbe6,0xffff,0xcbe7,
0xe0e1,0xffff,0xb2d1,0xffff,0xffff,0xcbe8,0xcbe9,0xffff,
0xe0dd,0xcbea,0xbbb9,0xcbeb,0xcbec,0xc4c1,0xe0df,0xcbed,
0xffff,0xffff,0xcbee,0xcbef,0xffff,0xffff,0xcbf0,0xffff,
0xffff,0xcbf1,0xffff,0xffff,0xffff,0xcbf2,0xe0e4,0xffff,
0xbcee,0xcbf3,0xffff,0xcbf4,0xffff,0xe0e2,0xcbf5,0xcbf6,
0xffff,0xcbf7,0xb7be,0xffff,0xffff,0xc8c9,0xe0e3,0xffff,
0xffff,0xe0fe,0xffff,0xffff,0xcbf8,0xcbf9,0xffff,0xcbfa,
0xe0e9,0xcbfb,0xcbfc,0xcbfd,0xffff,0xcbfe,0xb8bd,0xcca1,
0xcca2,0xcca3,0xffff,0xb5e5,0xcca4,0xe0e6,0xcdfd,0xcca5,
0xffff,0xceb0,0xcca6,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xcca7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xcca8,0xcca9,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xc2f6,0xffff,0xccaa,0xe0e8,0xccab,0xffff,
0xccac,0xccad,0xccae,0xccaf,0xccb0,0xccb1,0xccb2,0xccb3,
0xccb4,0xccb5,0xe0ea,0xced6,0xb6d7,0xc8fc,0xc7ca,0xffff,
0xffff,0xccb6,0xe0eb,0xffff,0xffff,0xffff,0xffff,0xe0ed,
0xccb7,0xe0f0,0xffff,0xccb8,0xccb9,0xffff,0xccba,0xccbb,
0xffff,0xffff,0xffff,0xccbc,0xffff,0xccbd,0xffff,0xffff,
0xffff,0xccbe,0xccbf,0xffff,0xffff,0xe0ec,0xffff,0xccc0,
0xffff,0xe0ef,0xb8ea,0xb1cd,0xe0f1,0xccc1,0xbff0,0xe0ee,
0xcedc,0xffff,0xccc2,0xe0f4,0xf4a4,0xffff,0xccc3,0xccc4,
0xccc5,0xe0f2,0xe0f5,0xccc6,0xffff,0xccc7,0xccc8,0xe0e7,
0xe0f3,0xccc9,0xccca,0xbabc,0xffff,0xffff,0xe0f6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0f7,0xffff,
0xcccb,0xcccc,0xffff,0xcdfe,0xffff,0xcccd,0xccce,0xcccf,
0xffff,0xccd0,0xffff,0xe0f8,0xffff,0xffff,0xffff,0xccd1,
0xccd2,0xccd3,0xccd4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xccd5,0xccd6,0xccd7,0xffff,0xccd8,0xffff,0xe0f9,0xccd9,
0xccda,0xccdb,0xe0e5,0xccdc,0xffff,0xffff,0xccdd,0xe0fa,
0xccde,0xccdf,0xcce0,0xcce1,0xffff,0xffff,0xcce2,0xcce3,
0xb4c4,0xcce4,0xcce5,0xffff,0xffff,0xcce6,0xffff,0xffff,
0xffff,0xcce7,0xffff,0xcce8,0xffff,0xbca5,0xffff,0xcce9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xccea,0xcceb,0xe0fb,0xffff,0xccec,0xffff,0xffff,0xe0fc,
0xcced,0xffff,0xffff,0xccee,0xe0fd,0xffff,0xffff,0xffff,
0xccef,0xffff,0xccf0,0xccf1,0xb1bb,0xffff,0xccf2,0xccf3,
0xe1a1,0xffff,0xc9bb,0xe1a2,0xccf4,0xffff,0xb4a4,0xe1a3,
0xccf5,0xe1a4,0xccf6,0xccf7,0xffff,0xffff,0xe1a5,0xccf8,
0xe1a7,0xe1a8,0xe1a6,0xffff,0xccf9,0xffff,0xc9d3,0xe1aa,
0xe1a9,0xffff,0xccfa,0xccfb,0xccfc,0xffff,0xffff,0xccfd,
0xffff,0xffff,0xffff,0xe1ac,0xe1ab,0xe1ad,0xccfe,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe1ae,0xe1b0,0xe1af,0xffff,
0xffff,0xb9f9,0xcda1,0xe1b2,0xffff,0xe1b1,0xcda2,0xcda3,
0xb4c5,0xffff,0xbfd3,0xffff,0xc5bc,0xffff,0xe1b3,0xc0b8,
0xcda4,0xcda5,0xffff,0xbbba,0xcda6,0xb1f9,0xe1b4,0xcda7,
0xcdd1,0xcda8,0xcda9,0xcae3,0xe1b5,0xffff,0xffff,0xcdaa,
0xc5c4,0xcdb3,0xb9c3,0xbfbd,0xffff,0xffff,0xcdab,0xc3cb,
0xd2b4,0xcdac,0xc4ae,0xb2e8,0xe1b6,0xcdad,0xcdae,0xcdaf,
0xcdb0,0xffff,0xffff,0xcdb1,0xe1b7,0xffff,0xe1bc,0xcdb2,
0xcdb3,0xe1ba,0xe1b9,0xdac2,0xb3a6,0xe1b8,0xcdb4,0xb0da,
0xcdb5,0xc8aa,0xcdb6,0xffff,0xc8ca,0xffff,0xffff,0xcdb7,
0xffff,0xceb1,0xe1bd,0xe1bb,0xc3dc,0xc0a6,0xcdb8,0xcdb9,
0xc8ab,0xcdba,0xc9ad,0xffff,0xe1bf,0xceac,0xb7cd,0xe1c0,
0xffff,0xe1be,0xc8d6,0xe1c1,0xffff,0xe1c2,0xffff,0xcdbb,
0xb0db,0xcdbc,0xffff,0xbef6,0xe1c7,0xffff,0xe1c4,0xc6ed,
0xe1c3,0xcdbd,0xcdbe,0xcdbf,0xcdc0,0xcdc1,0xcdc2,0xb5a6,
0xffff,0xcdc3,0xe1ca,0xffff,0xffff,0xcdc4,0xe1c5,0xe1c6,
0xffff,0xe1c9,0xe1c8,0xc9a5,0xffff,0xffff,0xc1c2,0xc1c1,
0xcdc5,0xb5bf,0xcdc6,0xcdc7,0xe1cb,0xcdc8,0xffff,0xffff,
0xffff,0xcdc9,0xe1cc,0xffff,0xcdca,0xe1cd,0xffff,0xffff,
0xffff,0xffff,0xcdcb,0xe1cf,0xcdcc,0xe1ce,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb1d6,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe1d7,0xc8e8,0xe1d1,0xcdcd,0xe1d3,0xffff,0xffff,
0xe1d5,0xbfbe,0xcdce,0xffff,0xe1d6,0xe1d4,0xbcc0,0xcdcf,
0xcdd0,0xcdd1,0xe1d0,0xe1d2,0xcdd2,0xc9c2,0xcdd3,0xbec9,
0xffff,0xffff,0xe1d9,0xffff,0xcdd4,0xe1d8,0xcdd5,0xcdd6,
0xffff,0xffff,0xe1da,0xffff,0xbca6,0xbaaf,0xffff,0xcdd7,
0xc5f7,0xe1db,0xffff,0xc4cb,0xcdd8,0xffff,0xe1dd,0xcdd9,
0xcdda,0xcddb,0xcea1,0xe1dc,0xcddc,0xffff,0xffff,0xcddd,
0xffff,0xc1e9,0xffff,0xffff,0xcdde,0xffff,0xcddf,0xcde0,
0xe1e2,0xcde1,0xe1e4,0xe1e5,0xc3d4,0xffff,0xffff,0xffff,
0xffff,0xcde2,0xe1e3,0xffff,0xe1e0,0xffff,0xe1de,0xe1df,
0xcde3,0xe1e1,0xcde4,0xcde5,0xcde6,0xffff,0xffff,0xcde7,
0xcde8,0xe1e8,0xcde9,0xe1e6,0xcdea,0xe1e7,0xffff,0xcdeb,
0xffff,0xffff,0xcdec,0xcded,0xffff,0xcdee,0xcdef,0xffff,
0xffff,0xcdf0,0xffff,0xcdf1,0xcdf2,0xcdf3,0xcdf4,0xe1e9,
0xe1eb,0xe1ec,0xe1ed,0xcdf5,0xe1ee,0xcdf6,0xcdf7,0xe1ea,
0xffff,0xcdf8,0xffff,0xffff,0xffff,0xcdf9,0xffff,0xffff,
0xe1f0,0xffff,0xcdfa,0xcdfb,0xe1ef,0xcdfc,0xffff,0xffff,
0xcdfd,0xcdfe,0xcea1,0xe1f1,0xcea2,0xffff,0xffff,0xffff,
0xcea4,0xcea5,0xcec5,0xcea6,0xcea7,0xcea8,0xe1f4,0xe1f2,
0xe1f3,0xcea9,0xcea3,0xceaa,0xb4e2,0xffff,0xffff,0xffff,
0xffff,0xffff,0xccfe,0xffff,0xffff,0xceab,0xcaca,0xffff,
0xe1f6,0xceac,0xffff,0xffff,0xe1f5,0xffff,0xffff,0xcead,
0xffff,0xe1f7,0xe1f8,0xffff,0xceae,0xceaf,0xffff,0xe1fc,
0xe1f9,0xe1fa,0xe1fb,0xffff,0xe1fd,0xceb0,0xceb1,0xceb2,
0xe1fe,0xceb3,0xe2a1,0xffff,0xceb4,0xffff,0xe2a2,0xffff,
0xe2a3,0xffff,0xc8af,0xc5d0,0xe2a4,0xc7f2,0xc9b4,0xffff,
0xe2a5,0xceb5,0xffff,0xe2a6,0xc5aa,0xceb6,0xb3a7,0xb9c4,
0xe2a7,0xffff,0xffff,0xe2a8,0xceb7,0xceb8,0xe2a9,0xffff,
0xbba9,0xffff,0xffff,0xe2ab,0xffff,0xceb9,0xe2aa,0xffff,
0xffff,0xe2ac,0xe2ad,0xceba,0xcebb,0xcebc,0xffff,0xcebd,
0xcebe,0xffff,0xcebf,0xcec0,0xcec1,0xcec2,0xcec3,0xcec4,
0xcec5,0xffff,0xcec6,0xffff,0xffff,0xcec7,0xc8e9,0xffff,
0xe2ae,0xffff,0xffff,0xffff,0xe2af,0xffff,0xffff,0xf3e9,
0xe2b0,0xe2b1,0xe2b2,0xffff,0xffff,0xcec8,0xffff,0xbbae,
0xffff,0xcec9,0xe2b3,0xc7d6,0xffff,0xceca,0xcbdf,0xffff,
0xb1ce,0xcecb,0xb1d7,0xcecc,0xcecd,0xe2b4,0xcece,0xffff,
0xffff,0xffff,0xe2b6,0xffff,0xcecf,0xffff,0xe2b5,0xc5f0,
0xffff,0xced0,0xffff,0xc0b9,0xddb9,0xffff,0xe2b7,0xccc1,
0xced1,0xe2b8,0xffff,0xb4c6,0xc8d7,0xe2b9,0xced2,0xe2ba,
0xced3,0xffff,0xe2bb,0xffff,0xced4,0xffff,0xccdc,0xffff,
0xced5,0xced6,0xccd5,0xffff,0xc4be,0xffff,0xced7,0xffff,
0xc1ea,0xced8,0xffff,0xe2bd,0xced9,0xffff,0xbde2,0xffff,
0xceda,0xbeca,0xffff,0xffff,0xe2c0,0xffff,0xcedb,0xe2bf,
0xe2be,0xc8fd,0xcedc,0xb4c7,0xb8a9,0xffff,0xcedd,0xffff,
0xffff,0xffff,0xcede,0xffff,0xcedf,0xcee0,0xffff,0xcee1,
0xffff,0xcee2,0xcee3,0xe2c6,0xcee4,0xffff,0xe2c3,0xbfbf,
0xccb2,0xffff,0xcee5,0xffff,0xe2c2,0xe2c4,0xe2c5,0xffff,
0xcee6,0xe2c1,0xffff,0xffff,0xffff,0xcee7,0xcee8,0xcee9,
0xffff,0xffff,0xffff,0xffff,0xceea,0xceeb,0xceec,0xe2c7,
0xe2c8,0xceed,0xc4af,0xffff,0xb4e3,0xceee,0xceef,0xffff,
0xc3e5,0xffff,0xcef0,0xffff,0xffff,0xcef1,0xcef2,0xe2c9,
0xffff,0xffff,0xcef3,0xffff,0xffff,0xcef4,0xcef5,0xcef6,
0xffff,0xffff,0xcef7,0xffff,0xffff,0xffff,0xcef8,0xcef9,
0xffff,0xffff,0xe2ca,0xe2cd,0xcefa,0xffff,0xcefb,0xcefc,
0xcefd,0xbfe7,0xcefe,0xc6c4,0xcfa1,0xe2ce,0xcbd3,0xcfa2,
0xe2cb,0xffff,0xcfa3,0xe2cc,0xcfa4,0xffff,0xffff,0xffff,
0xcfa5,0xffff,0xcfa6,0xcfa7,0xcfa8,0xffff,0xffff,0xffff,
0xffff,0xe2d1,0xcfa9,0xffff,0xffff,0xcfaa,0xe2d0,0xe2cf,
0xcfab,0xffff,0xffff,0xffff,0xcfac,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe2d3,0xcfad,0xcfae,0xe2d2,0xffff,
0xffff,0xe2d4,0xffff,0xffff,0xcfaf,0xcfb0,0xcfb1,0xffff,
0xffff,0xffff,0xcfb2,0xffff,0xffff,0xffff,0xe2d6,0xcfb3,
0xe2d5,0xffff,0xcfb4,0xffff,0xffff,0xcacd,0xffff,0xcfb5,
0xffff,0xffff,0xcfb6,0xffff,0xbdd6,0xcec6,0xcfb7,0xcfb8,
0xe2d7,0xcfb9,0xffff,0xc6b7,0xffff,0xcfba,0xe2d8,0xffff,
0xffff,0xe2d9,0xffff,0xe2dd,0xe2db,0xe2dc,0xcfbb,0xe2da,
0xffff,0xffff,0xffff,0xcfbc,0xffff,0xffff,0xffff,0xe2de,
0xffff,0xcfbd,0xffff,0xffff,0xffff,0xe2df,0xffff,0xffff,
0xffff,0xcfbe,0xcfbf,0xffff,0xffff,0xcfc0,0xffff,0xe2e0,
0xffff,0xcfc1,0xe2e1,0xccb7,0xe2e2,0xffff,0xcfc2,0xcfc3,
0xcfc4,0xffff,0xccf0,0xe2e3,0xcfc5,0xc3ce,0xcfc6,0xc7ea,
0xffff,0xb6eb,0xcfc7,0xffff,0xcfc8,0xc3bb,0xe2e4,0xb6ba,
0xcfc9,0xcfca,0xffff,0xc0d0,0xcfcb,0xffff,0xffff,0xffff,
0xcfcc,0xffff,0xffff,0xcfcd,0xe2e5,0xffff,0xffff,0xffff,
0xffff,0xffff,0xbabd,0xffff,0xffff,0xcfce,0xcfcf,0xffff,
0xffff,0xcfd0,0xffff,0xffff,0xe2e6,0xcfd1,0xcfd2,0xffff,
0xffff,0xcfd3,0xe2e7,0xffff,0xb8a6,0xbad5,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xcfd4,0xffff,0xffff,
0xe2e9,0xcfd5,0xcfd6,0xcfd7,0xffff,0xc5d6,0xbad6,0xb5ce,
0xffff,0xffff,0xffff,0xffff,0xffff,0xcfd8,0xcfd9,0xffff,
0xcfda,0xffff,0xcba4,0xffff,0xc7cb,0xcfdb,0xffff,0xcfdc,
0xffff,0xffff,0xc5d7,0xffff,0xffff,0xffff,0xffff,0xb9dc,
0xffff,0xffff,0xffff,0xcfdd,0xcfde,0xe2eb,0xffff,0xcfdf,
0xcfe0,0xffff,0xffff,0xffff,0xcfe1,0xffff,0xcfe2,0xffff,
0xffff,0xffff,0xcfe3,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xcfe4,0xbecb,0xcfe5,0xffff,
0xcfe6,0xcfe7,0xffff,0xcfe8,0xcfe9,0xffff,0xffff,0xffff,
0xcfea,0xffff,0xcfeb,0xceb2,0xb9c5,0xffff,0xcfec,0xb8a7,
0xffff,0xffff,0xc8a3,0xffff,0xe2ed,0xffff,0xffff,0xffff,
0xffff,0xffff,0xcfed,0xffff,0xe2ef,0xffff,0xcfee,0xffff,
0xffff,0xb8eb,0xffff,0xffff,0xffff,0xffff,0xe2ee,0xc4f6,
0xffff,0xffff,0xcfef,0xffff,0xe2f1,0xb3b7,0xe2ec,0xcff0,
0xffff,0xc8ea,0xffff,0xb1b0,0xcff1,0xbaec,0xffff,0xcfd2,
0xcff2,0xffff,0xe2f0,0xffff,0xffff,0xcff4,0xcff5,0xcff6,
0xffff,0xcff3,0xffff,0xe2f2,0xcff7,0xffff,0xffff,0xcacb,
0xcff8,0xc0d9,0xe2f4,0xffff,0xcff9,0xcffa,0xffff,0xe2f5,
0xcffb,0xcffc,0xcffd,0xcffe,0xffff,0xe2f3,0xffff,0xffff,
0xffff,0xffff,0xb3ce,0xd0a1,0xe2fb,0xd0a2,0xe2fa,0xd0a3,
0xffff,0xbca7,0xffff,0xffff,0xffff,0xe2fc,0xe2f7,0xd0a4,
0xd0a5,0xd0a6,0xe2fd,0xe2f8,0xd0a7,0xffff,0xd0a8,0xffff,
0xc8d8,0xe2f6,0xd0a9,0xd0aa,0xe2f9,0xd0ab,0xd0ac,0xffff,
0xffff,0xffff,0xe3a2,0xd0ae,0xffff,0xffff,0xffff,0xd0af,
0xd0b0,0xd0b1,0xffff,0xffff,0xd0ad,0xffff,0xd0b2,0xe3a1,
0xcbe1,0xffff,0xd0b3,0xffff,0xe2fe,0xffff,0xffff,0xb0eb,
0xffff,0xffff,0xd0b4,0xd0b5,0xe3a4,0xffff,0xd0b7,0xd0b8,
0xffff,0xffff,0xd0b9,0xd0ba,0xffff,0xe3a3,0xffff,0xd0bb,
0xd0b6,0xbecc,0xffff,0xffff,0xffff,0xffff,0xd0bc,0xe3a5,
0xffff,0xffff,0xffff,0xffff,0xd0bd,0xffff,0xc1c3,0xffff,
0xd0be,0xe3a7,0xe3a6,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe3a8,0xd0bf,0xffff,0xd0c0,0xffff,0xd0c1,0xd0c2,
0xd0c3,0xffff,0xffff,0xffff,0xffff,0xd0c4,0xe2e8,0xd0c5,
0xffff,0xd0c6,0xe2ea,0xe3aa,0xe3a9,0xd0c7,0xffff,0xffff,
0xffff,0xd0c8,0xffff,0xffff,0xd0c9,0xd0ca,0xffff,0xffff,
0xffff,0xffff,0xbca8,0xd0cb,0xcee9,0xd0cc,0xbcd2,0xd0cd,
0xe3ab,0xb7b7,0xffff,0xffff,0xd0ce,0xd0cf,0xd0d0,0xb5c0,
0xb5a7,0xbbe3,0xd0d1,0xd0d2,0xffff,0xffff,0xffff,0xd0d3,
0xcdb4,0xd0d4,0xffff,0xe3b1,0xd0d5,0xe3b0,0xc1c4,0xe3ad,
0xd0d6,0xffff,0xe3af,0xd0d7,0xd0d8,0xbdcb,0xbfc0,0xe3ae,
0xe3ac,0xffff,0xc7aa,0xffff,0xffff,0xbecd,0xffff,0xd0d9,
0xc9bc,0xd0da,0xffff,0xd0db,0xffff,0xbad7,0xffff,0xffff,
0xffff,0xffff,0xd0dc,0xffff,0xffff,0xffff,0xffff,0xc5f8,
0xffff,0xd0dd,0xe3b2,0xd0de,0xd0df,0xffff,0xd0e0,0xe3b3,
0xe3c9,0xb6d8,0xffff,0xffff,0xcfbd,0xc1b5,0xffff,0xffff,
0xffff,0xffff,0xe3b4,0xd0e1,0xd0e2,0xb2d2,0xc4f7,0xcaa1,
0xffff,0xd0e3,0xffff,0xd0e4,0xd0e5,0xd0e6,0xd0e7,0xffff,
0xd0e8,0xffff,0xffff,0xd0e9,0xd0ea,0xe3b5,0xffff,0xffff,
0xffff,0xd0eb,0xffff,0xffff,0xffff,0xffff,0xb5fa,0xe3b6,
0xd0ec,0xd0ed,0xe3b8,0xd0ee,0xffff,0xffff,0xe3b9,0xd0ef,
0xc7a9,0xd0f0,0xffff,0xe3ba,0xd0f1,0xffff,0xffff,0xffff,
0xd0f2,0xe3bb,0xe3bc,0xd0f3,0xffff,0xb6d9,0xb2d3,0xc6c5,
0xbda8,0xbbe4,0xd0f4,0xffff,0xd0f5,0xffff,0xffff,0xd0f6,
0xd0f7,0xe3bd,0xd0f8,0xbda9,0xffff,0xffff,0xffff,0xd0f9,
0xffff,0xb2ca,0xc9c3,0xffff,0xd0fa,0xe3be,0xd0fb,0xffff,
0xc8eb,0xffff,0xd0fc,0xffff,0xffff,0xd0fd,0xd0fe,0xc1c5,
0xd1a1,0xe3c1,0xd1a2,0xe3c2,0xc7e9,0xd1a3,0xbfc1,0xe3bf,
0xffff,0xc3e1,0xd1a4,0xd1a5,0xe3c0,0xd1a6,0xffff,0xffff,
0xbece,0xd1a7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd1a8,0xffff,0xffff,0xb0dc,0xd1a9,0xffff,0xffff,0xffff,
0xb5a9,0xffff,0xd1aa,0xd1ab,0xffff,0xffff,0xffff,0xd1ac,
0xe3c3,0xd1ad,0xd1ae,0xc4f8,0xd1af,0xe3c4,0xc0c7,0xffff,
0xffff,0xd1b0,0xffff,0xffff,0xccad,0xd1b1,0xffff,0xc9a3,
0xe3c5,0xe3c6,0xc3d5,0xd1b2,0xcec7,0xffff,0xd1b3,0xe3c8,
0xe3c7,0xd1b4,0xffff,0xffff,0xffff,0xffff,0xffff,0xd1b5,
0xffff,0xffff,0xffff,0xd1b6,0xffff,0xd1b7,0xbcef,0xd1b8,
0xd1b9,0xe3ca,0xb0f0,0xffff,0xd1ba,0xd1bb,0xffff,0xe3cd,
0xd1bc,0xd1bd,0xd1be,0xe3cb,0xb2d4,0xb7ce,0xe3cc,0xb9c6,
0xb9f2,0xffff,0xcae6,0xe3ce,0xd1bf,0xd1c0,0xcbd4,0xd1c1,
0xd1c2,0xe3d0,0xffff,0xffff,0xd1c3,0xc0d1,0xb1cf,0xb2ba,
0xb0ac,0xffff,0xffff,0xffff,0xffff,0xd1c4,0xd1c5,0xe3cf,
0xffff,0xd1c6,0xffff,0xffff,0xd1c7,0xd1c8,0xffff,0xd1c9,
0xd1ca,0xe3d1,0xe3d2,0xbef7,0xffff,0xd1cb,0xffff,0xd1cc,
0xffff,0xe3d3,0xd1cd,0xb3cf,0xffff,0xd1ce,0xffff,0xffff,
0xe3d5,0xffff,0xffff,0xffff,0xb7ea,0xd1cf,0xb5e6,0xffff,
0xd1d0,0xe3d6,0xb6f5,0xffff,0xffff,0xe3d7,0xd1d1,0xc0fc,
0xd1d2,0xc6cd,0xd1d3,0xc0e0,0xbaf5,0xd1d4,0xd1d5,0xffff,
0xe3d8,0xffff,0xd1d6,0xd1d7,0xffff,0xffff,0xffff,0xffff,
0xd1d8,0xd1d9,0xc3e2,0xc1eb,0xd1da,0xe3da,0xe3dc,0xe3d9,
0xe3db,0xffff,0xffff,0xffff,0xffff,0xffff,0xd1db,0xb7a2,
0xd1dc,0xffff,0xffff,0xd1dd,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe3dd,0xb7a6,0xffff,0xd1de,0xffff,0xb5e7,0xcdd2,
0xe3df,0xffff,0xffff,0xd1df,0xffff,0xd1e0,0xe3e0,0xffff,
0xffff,0xd1e1,0xb1ae,0xd1e2,0xd1e3,0xffff,0xffff,0xe3e3,
0xffff,0xffff,0xffff,0xb3f6,0xe3e2,0xe3e1,0xd1e4,0xe3e5,
0xe3de,0xd1e5,0xe3e6,0xcea9,0xd1e6,0xe3e7,0xd1e7,0xe3e8,
0xffff,0xd1e8,0xd4f4,0xe3ea,0xffff,0xe3e9,0xffff,0xffff,
0xffff,0xe3eb,0xe3ec,0xd1e9,0xceb5,0xe3ed,0xffff,0xf0ef,
0xbecf,0xe3ee,0xe3ef,0xbdd7,0xffff,0xc6b8,0xe3f0,0xffff,
0xd1ea,0xd1eb,0xc3a8,0xd1ec,0xd1ed,0xe3f1,0xffff,0xc3bc,
0xe3f2,0xd1ee,0xffff,0xffff,0xd1ef,0xffff,0xb6a5,0xffff,
0xd1bf,0xc3dd,0xbcb3,0xd1f0,0xffff,0xd1f1,0xd1f2,0xb4c8,
0xffff,0xffff,0xe3f3,0xffff,0xe4a2,0xffff,0xe3f6,0xd1f3,
0xb5e8,0xffff,0xe3f5,0xe4a4,0xffff,0xffff,0xffff,0xe3f4,
0xffff,0xbed0,0xffff,0xffff,0xd1f4,0xffff,0xffff,0xffff,
0xe3f8,0xe3f9,0xffff,0xc5ab,0xffff,0xffff,0xe3fa,0xd1f5,
0xb3de,0xffff,0xffff,0xd1f6,0xffff,0xbfda,0xc9e4,0xd1f7,
0xe3fc,0xd1f8,0xd1f9,0xd1fa,0xc2e8,0xd1fb,0xd1fc,0xd1fd,
0xd1fe,0xd2a1,0xffff,0xe3f7,0xd2a2,0xe3fb,0xe3fd,0xffff,
0xffff,0xbafb,0xffff,0xffff,0xffff,0xd2a3,0xffff,0xd2a4,
0xd2a5,0xd2a6,0xffff,0xffff,0xffff,0xe4a6,0xc9ae,0xd2a7,
0xc8a6,0xc5f9,0xffff,0xb6da,0xe4a5,0xe4a3,0xd2a8,0xc8b5,
0xe3fe,0xc3de,0xc5fb,0xffff,0xc5fa,0xd2a9,0xbaf6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe4b8,0xffff,0xffff,
0xd2aa,0xffff,0xffff,0xffff,0xd2ab,0xe4a8,0xd2ac,0xe4aa,
0xffff,0xd2ad,0xd2ae,0xffff,0xe4ad,0xd2af,0xe4ae,0xd2b0,
0xe4ab,0xe4ac,0xd2b1,0xd2b2,0xe4a9,0xe4a7,0xffff,0xd2b3,
0xffff,0xffff,0xe4a1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xd2b4,0xffff,0xcacf,0xb2d5,
0xffff,0xd2b5,0xffff,0xe4b5,0xffff,0xe4b2,0xd2b6,0xe4b7,
0xd2b7,0xd2b8,0xe4b6,0xffff,0xc7f3,0xcca7,0xd2b9,0xbbbb,
0xe4b0,0xe4b9,0xe4b4,0xd2ba,0xe4b3,0xe4af,0xd2bb,0xe4b1,
0xd2bc,0xb4c9,0xffff,0xffff,0xffff,0xd2bd,0xffff,0xffff,
0xffff,0xffff,0xc3bd,0xffff,0xd2be,0xc0fd,0xffff,0xd2bf,
0xd2c0,0xc8a2,0xd2c1,0xffff,0xe4be,0xd2c2,0xd2c3,0xffff,
0xc8a4,0xffff,0xd2c4,0xd2c5,0xd2c6,0xd2c7,0xffff,0xffff,
0xc0e1,0xe4bb,0xd2c8,0xffff,0xc8cf,0xd2c9,0xe4bf,0xcad3,
0xd2ca,0xc3db,0xd2cb,0xe4ba,0xe4bc,0xffff,0xffff,0xe4bd,
0xffff,0xffff,0xffff,0xffff,0xd2cc,0xffff,0xd2cd,0xd2ce,
0xffff,0xd2cf,0xd2d0,0xd2d1,0xffff,0xe4c0,0xffff,0xffff,
0xbcc4,0xffff,0xffff,0xffff,0xc6c6,0xe4c5,0xe4c4,0xffff,
0xd2d2,0xe4c1,0xd2d3,0xffff,0xffff,0xcfb6,0xffff,0xffff,
0xffff,0xffff,0xd2d4,0xe4ca,0xd2d5,0xd2d6,0xe4ce,0xe4cb,
0xd2d7,0xd2d8,0xd2d9,0xffff,0xd2da,0xffff,0xd2db,0xffff,
0xe4c7,0xd2dc,0xd2dd,0xd2de,0xd2df,0xffff,0xd2e0,0xe4c8,
0xffff,0xd2e1,0xffff,0xd2e2,0xd2e3,0xe4cd,0xd2e4,0xd2e5,
0xffff,0xe4c2,0xd2d5,0xe4c9,0xe4c3,0xffff,0xffff,0xe4cc,
0xffff,0xd2e6,0xffff,0xd2e7,0xffff,0xffff,0xffff,0xe4d2,
0xd2e8,0xb4ca,0xffff,0xe4cf,0xffff,0xd2e9,0xd2ea,0xe4d0,
0xd2eb,0xffff,0xe4d1,0xe4d4,0xd2ec,0xffff,0xffff,0xffff,
0xffff,0xd2ed,0xffff,0xd2ee,0xd2ef,0xffff,0xd2f0,0xe4d3,
0xc8f6,0xd2f1,0xd2f2,0xffff,0xffff,0xe4d5,0xcefc,0xcaed,
0xe4da,0xffff,0xffff,0xe4d7,0xffff,0xffff,0xd2f3,0xffff,
0xffff,0xffff,0xd2f4,0xffff,0xe4d6,0xc0d2,0xffff,0xe4d9,
0xe4db,0xd2f6,0xd2f7,0xd2f8,0xe4d8,0xd2f5,0xe4df,0xffff,
0xe4dc,0xd2f9,0xd2fa,0xd2fb,0xd2fc,0xd2fd,0xd2fe,0xe4dd,
0xe4c6,0xd3a1,0xffff,0xd3a2,0xe4de,0xe4e0,0xffff,0xd3a3,
0xffff,0xd3a4,0xffff,0xffff,0xe4e1,0xd3a5,0xd3a6,0xffff,
0xd3a7,0xffff,0xd3a8,0xcac6,0xffff,0xe4e2,0xffff,0xffff,
0xffff,0xd3a9,0xffff,0xffff,0xd3aa,0xd3ab,0xcce2,0xffff,
0xffff,0xb6ce,0xb7a9,0xe4e3,0xffff,0xffff,0xd3ac,0xd3ad,
0xffff,0xcab4,0xffff,0xbfe8,0xffff,0xccb0,0xffff,0xd3ae,
0xe4e4,0xffff,0xceb3,0xffff,0xd3af,0xc7f4,0xffff,0xc1c6,
0xc7b4,0xffff,0xffff,0xbdcd,0xffff,0xffff,0xd3b0,0xb0c0,
0xd3b1,0xe4e9,0xe4e7,0xffff,0xe4e5,0xb4a1,0xd3b2,0xbed1,
0xe4ea,0xffff,0xffff,0xe4e8,0xffff,0xe4e6,0xe4ee,0xffff,
0xd3b3,0xe4ed,0xe4ec,0xe4eb,0xffff,0xffff,0xd3b4,0xd3b5,
0xffff,0xe4ef,0xd3b6,0xd3b7,0xd3b8,0xe4f0,0xc0ba,0xd3b9,
0xe4f1,0xffff,0xe4f3,0xffff,0xd3ba,0xe4f2,0xffff,0xd3bb,
0xd3bc,0xd3bd,0xb8d2,0xffff,0xffff,0xd3be,0xc1b8,0xd3bf,
0xffff,0xffff,0xe4f5,0xd3c0,0xd3c1,0xd3c2,0xc5fc,0xd3c3,
0xe4f4,0xd3c4,0xd3c5,0xffff,0xe4f6,0xd3c6,0xcab5,0xc1ec,
0xb9c7,0xffff,0xe4f7,0xffff,0xffff,0xffff,0xd3c7,0xcec8,
0xffff,0xd3c8,0xffff,0xd3c9,0xffff,0xffff,0xffff,0xe4f9,
0xffff,0xffff,0xe4fa,0xffff,0xe4fb,0xd3ca,0xe4fc,0xffff,
0xbbe5,0xffff,0xe4fd,0xb7cf,0xffff,0xffff,0xb5ea,0xffff,
0xb5aa,0xffff,0xe5a1,0xd3cb,0xccf3,0xb9c8,0xe4fe,0xd3cc,
0xd3cd,0xd3ce,0xe5a4,0xcce6,0xffff,0xc7bc,0xffff,0xd3cf,
0xc9b3,0xd3d0,0xd3d1,0xd3d2,0xbde3,0xe5a3,0xd3d3,0xbcd3,
0xb9c9,0xbbe6,0xb5e9,0xcab6,0xe5a2,0xd3d4,0xd3d5,0xffff,
0xc1c7,0xcbc2,0xbaf7,0xd3d6,0xffff,0xffff,0xd3d7,0xffff,
0xffff,0xffff,0xd3d8,0xbbe7,0xc4dd,0xd3d9,0xe5a7,0xcedf,
0xbad9,0xd3da,0xe5a8,0xbfc2,0xffff,0xe5aa,0xffff,0xffff,
0xffff,0xbed2,0xbab0,0xffff,0xd3db,0xd3dc,0xd3dd,0xe5a9,
0xd3de,0xd3df,0xbdaa,0xb8be,0xc1c8,0xe5a5,0xe5ab,0xd3e0,
0xd3e1,0xffff,0xffff,0xe5a6,0xb7d0,0xd3e2,0xe5ae,0xe5b2,
0xb7eb,0xd3e3,0xffff,0xd3e4,0xffff,0xffff,0xe5ad,0xd3e5,
0xffff,0xd3e6,0xd3e7,0xe5b6,0xd3e8,0xd3e9,0xb9ca,0xffff,
0xffff,0xcded,0xb0bc,0xe5b3,0xffff,0xd3ea,0xb5eb,0xd3eb,
0xe5b0,0xffff,0xd3ec,0xffff,0xffff,0xffff,0xe5b1,0xffff,
0xd3ed,0xc5fd,0xe5af,0xe5ac,0xffff,0xb3a8,0xc0e4,0xffff,
0xd3ee,0xb8a8,0xd3ef,0xd3f0,0xffff,0xe5b8,0xffff,0xd3f1,
0xffff,0xd3f2,0xd3f3,0xd3f4,0xffff,0xd3f5,0xd3f6,0xffff,
0xd3f7,0xe5b5,0xffff,0xd3f8,0xd3f9,0xd3fa,0xffff,0xe5b7,
0xffff,0xd3fb,0xffff,0xe5b4,0xffff,0xffff,0xd3fc,0xd3fd,
0xffff,0xb7d1,0xc2b3,0xe5b9,0xc1ee,0xd3fe,0xd4a1,0xe5c6,
0xffff,0xffff,0xe5c2,0xe5bc,0xffff,0xffff,0xd4a2,0xd4a3,
0xffff,0xffff,0xd4a4,0xe5c0,0xbcfa,0xb0dd,0xe5bb,0xe5c3,
0xe5c7,0xb9cb,0xccd6,0xd4a5,0xc4d6,0xe5bd,0xd4a6,0xd4a7,
0xe5c5,0xd4a8,0xe5ba,0xc3be,0xffff,0xe5bf,0xb0bd,0xccca,
0xffff,0xffff,0xd4a9,0xd4aa,0xd4ab,0xd4ac,0xd4ad,0xe5be,
0xffff,0xffff,0xb6db,0xc8ec,0xd4ae,0xd4af,0xd4b0,0xc1ed,
0xffff,0xced0,0xbdef,0xffff,0xffff,0xe5ee,0xffff,0xd4b1,
0xe5c8,0xd4b2,0xc0fe,0xffff,0xe5c4,0xe5c9,0xe5cb,0xffff,
0xc4f9,0xe5ce,0xd4b4,0xffff,0xe5ca,0xd4b5,0xd4b6,0xffff,
0xcad4,0xb4cb,0xd4b7,0xd4b8,0xcccb,0xd4b9,0xffff,0xb0de,
0xffff,0xd4ba,0xe5cd,0xffff,0xcefd,0xd4bb,0xd4bc,0xffff,
0xffff,0xd4bd,0xd4be,0xe5cc,0xffff,0xffff,0xffff,0xffff,
0xd4b3,0xb1ef,0xffff,0xffff,0xc6ec,0xe5cf,0xffff,0xffff,
0xd4bf,0xe5d6,0xe5d0,0xe5d7,0xffff,0xffff,0xffff,0xffff,
0xd4c0,0xd4c1,0xe5d3,0xffff,0xffff,0xd4c2,0xffff,0xd4c3,
0xffff,0xffff,0xffff,0xc7fb,0xd4c4,0xd4c5,0xbcca,0xe5d5,
0xd4c6,0xe5d2,0xe5d8,0xe5d1,0xffff,0xffff,0xbdc4,0xd4c7,
0xd4c8,0xffff,0xffff,0xcba5,0xd4c9,0xd4ca,0xbdcc,0xd4cb,
0xffff,0xe5d4,0xe5e0,0xd4cc,0xffff,0xe5dc,0xd4cd,0xe5df,
0xffff,0xe5dd,0xe5e1,0xe5db,0xffff,0xe5c1,0xc0d3,0xd4ce,
0xffff,0xc8cb,0xffff,0xe5de,0xd4cf,0xd4d0,0xe5d9,0xd4d1,
0xffff,0xffff,0xc1a1,0xb7d2,0xffff,0xbdab,0xd4d2,0xffff,
0xd4d3,0xffff,0xd4d4,0xffff,0xbfa5,0xc1b6,0xe5e4,0xffff,
0xd4d5,0xe5e6,0xe5e7,0xffff,0xffff,0xe5e3,0xe5e5,0xd4d6,
0xffff,0xd4d7,0xd4d8,0xffff,0xffff,0xd4d9,0xe5da,0xe5e2,
0xffff,0xe5ea,0xe5e9,0xd4da,0xffff,0xcbfa,0xd4db,0xd4dc,
0xb7ab,0xffff,0xffff,0xd4dd,0xffff,0xffff,0xffff,0xffff,
0xd4de,0xe5e8,0xffff,0xe5ec,0xe5eb,0xe5ef,0xd4df,0xe5f1,
0xffff,0xd4e0,0xbbbc,0xe5ed,0xffff,0xffff,0xd4e1,0xd4e2,
0xe5f2,0xe5f3,0xd4e3,0xffff,0xe5f4,0xd4e4,0xe5fa,0xc5bb,
0xe5f6,0xd4e5,0xe5f5,0xe5f7,0xe5f8,0xd4e6,0xe5f9,0xffff,
0xd4e7,0xffff,0xd4e8,0xe5fb,0xe5fc,0xd4e9,0xd4ea,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb4cc,0xffff,
0xe5fd,0xffff,0xe5fe,0xd4ec,0xd4eb,0xd4ed,0xd4ee,0xd4ef,
0xffff,0xffff,0xffff,0xd4f0,0xd4f1,0xe6a1,0xffff,0xd4f2,
0xffff,0xffff,0xffff,0xffff,0xe6a2,0xe6a3,0xe6a4,0xd4f3,
0xe6a5,0xe6a6,0xd4f4,0xd4f5,0xe6a8,0xe6a7,0xffff,0xffff,
0xe6a9,0xffff,0xffff,0xd4f6,0xd4f7,0xd4f8,0xffff,0xe6aa,
0xe6ab,0xd4f9,0xffff,0xd4fa,0xd4fb,0xd4fc,0xd4fd,0xe6ae,
0xe6ac,0xe6ad,0xbae1,0xb7d3,0xffff,0xd4fe,0xc3d6,0xffff,
0xc8b3,0xd5a1,0xbdf0,0xffff,0xffff,0xc7cd,0xffff,0xc8ed,
0xe6af,0xd8ed,0xffff,0xffff,0xffff,0xd5a2,0xd5a3,0xd5a4,
0xd5a5,0xffff,0xe6b0,0xe6b2,0xffff,0xcde5,0xe6b1,0xe6b4,
0xe6b3,0xffff,0xcdd3,0xd5a6,0xe6b5,0xd5a7,0xc8fe,0xd5a8,
0xd5a9,0xd5aa,0xffff,0xffff,0xe6b6,0xffff,0xd5ab,0xd5ac,
0xffff,0xffff,0xe6b9,0xffff,0xd5ad,0xe6b8,0xe6b7,0xffff,
0xffff,0xd5ae,0xd5af,0xe6ba,0xb7b2,0xffff,0xd5b0,0xffff,
0xc1a2,0xb5c1,0xd5b1,0xffff,0xffff,0xd5b2,0xe6be,0xe6bb,
0xffff,0xffff,0xe6bc,0xffff,0xd5b3,0xffff,0xe6bf,0xffff,
0xe6c0,0xe6bd,0xffff,0xffff,0xd5b4,0xb1a9,0xffff,0xd5b5,
0xd5b6,0xb2a7,0xffff,0xd5b7,0xffff,0xe6c2,0xe6c3,0xffff,
0xd5b8,0xffff,0xe6c4,0xffff,0xcde2,0xffff,0xd5b9,0xd5ba,
0xffff,0xffff,0xbdac,0xffff,0xe6c6,0xe6c5,0xffff,0xffff,
0xffff,0xffff,0xffff,0xd5bb,0xffff,0xffff,0xffff,0xd5bc,
0xbfe9,0xe6c7,0xffff,0xd5bd,0xffff,0xd5be,0xe6c8,0xffff,
0xd5bf,0xe6c9,0xffff,0xb4e5,0xd5c0,0xffff,0xd5c1,0xd5c2,
0xb4cd,0xffff,0xd5c3,0xe6ca,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe6cb,0xd5c4,0xcbdd,0xcde3,0xd5c5,0xd5c6,0xd5c7,
0xcdd4,0xcfb7,0xffff,0xb9cd,0xe6ce,0xbcd4,0xe6cd,0xd5c8,
0xd5c9,0xffff,0xd5ca,0xe6cf,0xbca9,0xd5cb,0xd5cc,0xd5cd,
0xc2d1,0xd5ce,0xe6d0,0xd5cf,0xd5d0,0xb9cc,0xd5d1,0xccd7,
0xe6d1,0xe6d2,0xffff,0xffff,0xe6d3,0xd5d2,0xd5d3,0xd5d4,
0xd5d5,0xe6d4,0xffff,0xffff,0xd5d6,0xffff,0xd5d7,0xffff,
0xe6d5,0xffff,0xffff,0xffff,0xd5d8,0xffff,0xd5d9,0xffff,
0xd5da,0xffff,0xffff,0xbcaa,0xd5db,0xd5dc,0xcced,0xd5dd,
0xffff,0xd5de,0xd5df,0xe6d7,0xd5e0,0xc3bf,0xd5e1,0xe6d6,
0xd5e2,0xffff,0xffff,0xffff,0xd5e3,0xffff,0xe6d9,0xffff,
0xffff,0xffff,0xe6d8,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe6da,0xffff,0xffff,0xffff,0xc0bb,0xffff,
0xe6db,0xffff,0xe6dc,0xffff,0xffff,0xffff,0xcab9,0xe6dd,
0xd5e4,0xc1ef,0xe6de,0xffff,0xd5e5,0xffff,0xd5e6,0xffff,
0xe6df,0xffff,0xffff,0xffff,0xffff,0xd5e7,0xffff,0xcefe,
0xe6e2,0xd5e8,0xe6e1,0xe6e0,0xc4b0,0xd5e9,0xe6e3,0xbfa6,
0xffff,0xe6e4,0xffff,0xffff,0xffff,0xe6e5,0xcfb8,0xe6e6,
0xffff,0xd5ea,0xffff,0xffff,0xe6e7,0xe6e9,0xe6e8,0xc8a5,
0xd5eb,0xc6f9,0xffff,0xcfbe,0xc8a9,0xffff,0xd5ec,0xffff,
0xffff,0xffff,0xffff,0xe6eb,0xffff,0xffff,0xbed3,0xffff,
0xc9aa,0xffff,0xe6ec,0xe6ea,0xd5ed,0xb4ce,0xd5ee,0xffff,
0xffff,0xb8d4,0xbbe8,0xffff,0xffff,0xc8ee,0xd5ef,0xd5f0,
0xffff,0xb8aa,0xcbc3,0xd5f1,0xe6ef,0xe6ed,0xffff,0xb9ce,
0xffff,0xb9cf,0xb0e9,0xffff,0xbae8,0xffff,0xffff,0xffff,
0xd5f2,0xd5f3,0xc7d9,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb0df,0xe6f4,0xffff,0xc3c0,0xffff,
0xd5f4,0xffff,0xffff,0xffff,0xc7d8,0xd5f5,0xc2db,0xd5f6,
0xffff,0xffff,0xd5f7,0xffff,0xd5f8,0xd5f9,0xe6f6,0xd5fa,
0xd5fb,0xe6f2,0xe6f5,0xe6f0,0xffff,0xe6f3,0xcba6,0xffff,
0xd5fc,0xb8d5,0xffff,0xffff,0xb0fd,0xe6f1,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd5fd,0xd5fe,0xe6f8,
0xd6a1,0xe6f9,0xd6a2,0xd6a3,0xc6b9,0xffff,0xd6a4,0xffff,
0xb6bb,0xd6a5,0xd6a6,0xffff,0xe7a6,0xc7bd,0xd6a7,0xffff,
0xffff,0xffff,0xbbe9,0xd6a8,0xffff,0xb6bc,0xc0c8,0xcfc6,
0xccae,0xe6f7,0xc0d4,0xd6a9,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xd6aa,0xd6ab,
0xd6ac,0xffff,0xb5d3,0xe6fa,0xd6ad,0xffff,0xd6ae,0xffff,
0xd6af,0xffff,0xffff,0xe6fc,0xd6b0,0xffff,0xffff,0xd6b1,
0xffff,0xe6fb,0xffff,0xffff,0xd6b2,0xffff,0xffff,0xe6fd,
0xd6b3,0xc3a6,0xffff,0xc7be,0xffff,0xd6b4,0xffff,0xffff,
0xffff,0xc4b1,0xd6b5,0xffff,0xd6b6,0xffff,0xe7a3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd6b7,0xe7a2,0xd6b8,
0xffff,0xffff,0xd6b9,0xe6fe,0xd6ba,0xffff,0xbfd5,0xffff,
0xc9e5,0xe7a5,0xd6bb,0xe7a4,0xb9d0,0xcfd3,0xffff,0xd6bc,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe7b5,
0xd6bd,0xd6be,0xffff,0xffff,0xffff,0xe7a9,0xe7aa,0xd6bf,
0xd6c0,0xd6c1,0xffff,0xbcf0,0xffff,0xd6c2,0xe7a8,0xd6c3,
0xb9f8,0xe7a7,0xffff,0xffff,0xe7ab,0xffff,0xffff,0xd6c4,
0xc4b2,0xcaa2,0xc1a3,0xffff,0xffff,0xffff,0xffff,0xc2dc,
0xe7af,0xd6c5,0xe7b0,0xe7ac,0xd6c7,0xd6c8,0xd6c9,0xffff,
0xe7ad,0xffff,0xe7ae,0xd6ca,0xffff,0xffff,0xd6cb,0xb9d1,
0xd6c6,0xffff,0xffff,0xe7b6,0xffff,0xe7b2,0xd6cc,0xffff,
0xd6cd,0xffff,0xc9e6,0xd6ce,0xcbec,0xc9a8,0xd6cf,0xffff,
0xe7b1,0xffff,0xd6d0,0xe7b4,0xe7b3,0xffff,0xffff,0xffff,
0xcbc4,0xe7b7,0xffff,0xffff,0xffff,0xffff,0xd6d1,0xffff,
0xe7b8,0xffff,0xd6d2,0xc1b7,0xd6d3,0xe7b9,0xffff,0xffff,
0xe7bb,0xffff,0xe7bf,0xd6d4,0xffff,0xe7bc,0xe7ba,0xc7bf,
0xe7bd,0xffff,0xe7be,0xd6d6,0xffff,0xd6d7,0xb2b2,0xffff,
0xe7c5,0xe7c0,0xd6d8,0xd6d5,0xffff,0xe7c1,0xd6d9,0xd6da,
0xffff,0xe7c2,0xffff,0xc2a1,0xffff,0xd6db,0xffff,0xd6dc,
0xe7c4,0xe7c3,0xe7c6,0xd6dd,0xffff,0xd6de,0xd6df,0xe7c7,
0xe7c8,0xd6e0,0xffff,0xbfc3,0xd6e1,0xb2e9,0xffff,0xe7c9,
0xced7,0xffff,0xbcab,0xd6e2,0xd6e3,0xbdad,0xffff,0xffff,
0xd6e4,0xd6e5,0xd6e6,0xbbea,0xc3d7,0xd6e7,0xd6e8,0xffff,
0xd6e9,0xd6ea,0xe7ca,0xe7cb,0xb1b1,0xd6eb,0xe7cc,0xd6ec,
0xd6ed,0xe7cd,0xe7ce,0xd6ee,0xffff,0xe7cf,0xffff,0xe7d0,
0xb6bd,0xdaaa,0xe7d1,0xffff,0xc0e5,0xe7d2,0xbccb,0xd6ef,
0xe7d3,0xffff,0xd0b0,0xd6f0,0xd6f1,0xffff,0xe7d4,0xcade,
0xb4dc,0xd6f2,0xd6f3,0xc1a4,0xbdd8,0xd6f4,0xc9f1,0xbdae,
0xffff,0xd6f5,0xd6f6,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd6f7,0xe7d5,0xb9d2,0xe7d6,0xc8cc,0xffff,0xe7e4,0xffff,
0xffff,0xffff,0xd6f8,0xe7d8,0xd6f9,0xc2c9,0xc7f5,0xb8bf,
0xe7d7,0xc1a5,0xd6fa,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe7d9,0xffff,0xffff,0xd6fb,0xd6fc,0xd6fd,0xd6fe,0xc4fa,
0xffff,0xffff,0xffff,0xd7a1,0xffff,0xffff,0xd7a2,0xd7a3,
0xffff,0xd7a4,0xffff,0xffff,0xffff,0xffff,0xd7a5,0xffff,
0xe7db,0xe7da,0xe7dd,0xffff,0xd7a6,0xe7dc,0xffff,0xe7de,
0xd7a7,0xffff,0xe7e0,0xd7a8,0xe7df,0xffff,0xb4cf,0xd7a9,
0xe7e1,0xffff,0xe7e2,0xe7e3,0xffff,0xd7aa,0xbab1,0xcec9,
0xffff,0xe7e5,0xbfa7,0xffff,0xd7ab,0xffff,0xb1f0,0xe7e6,
0xe7e7,0xffff,0xffff,0xd7ac,0xffff,0xd7ad,0xe7e8,0xd7ae,
0xd7af,0xd7b0,0xffff,0xd7b1,0xd7b2,0xffff,0xffff,0xd7b3,
0xffff,0xd7b4,0xd7b5,0xb0f2,0xffff,0xe7e9,0xd7b6,0xffff,
0xffff,0xd7b7,0xe7ea,0xffff,0xd7b8,0xffff,0xd7b9,0xffff,
0xd7ba,0xc9e7,0xd7bb,0xd7bc,0xffff,0xbcc7,0xffff,0xe7ec,
0xd7bd,0xd7be,0xffff,0xd7bf,0xd7c0,0xb3a9,0xb0b2,0xd7c1,
0xd7c2,0xd7c3,0xd7c4,0xe7eb,0xe7ee,0xc7ce,0xd7c5,0xbfc4,
0xd7c6,0xb2d6,0xd7c7,0xcba7,0xd7c8,0xffff,0xffff,0xd7c9,
0xb7dd,0xb6dc,0xd7ca,0xe7ed,0xd7cb,0xb2ea,0xd7cc,0xd7cd,
0xffff,0xffff,0xffff,0xffff,0xffff,0xb4a3,0xd7ce,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd7cf,0xb1f1,0xe7f2,0xceea,0xc2dd,0xd7d0,0xffff,0xc9c4,
0xffff,0xe7fe,0xd7d1,0xb2d7,0xe7fc,0xffff,0xe7fa,0xe7f1,
0xd7d2,0xe7ef,0xd7d3,0xe7f0,0xd7d4,0xbce3,0xb6ec,0xc3f7,
0xd7d5,0xffff,0xd7d6,0xc6d1,0xffff,0xd7d7,0xffff,0xd7d8,
0xffff,0xb1d1,0xffff,0xe7f4,0xe7f3,0xffff,0xd7d9,0xd7da,
0xffff,0xe7f9,0xe7f5,0xe7f8,0xffff,0xd7db,0xd7dc,0xffff,
0xd7dd,0xd7de,0xccd0,0xe7f7,0xb2d8,0xb3fd,0xe7fb,0xd7df,
0xd7e0,0xe7fd,0xd7e1,0xd7e2,0xffff,0xffff,0xb7d4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe8a3,0xe8ac,
0xe8ad,0xffff,0xffff,0xd7e4,0xb0ab,0xd7e5,0xd7e6,0xd7e7,
0xffff,0xd7e8,0xd7e9,0xe8b4,0xffff,0xffff,0xffff,0xffff,
0xb0f1,0xffff,0xffff,0xe8ab,0xd7ea,0xd7eb,0xd7ec,0xe8aa,
0xd7ed,0xe8a5,0xe8a4,0xd7ee,0xe8a2,0xe8a1,0xc3e3,0xd7ef,
0xc2fb,0xe8a7,0xd7f0,0xffff,0xd7f1,0xd7f2,0xffff,0xffff,
0xe8a6,0xffff,0xd7f3,0xd7f4,0xd7f5,0xe8a9,0xffff,0xd7f6,
0xffff,0xc1f0,0xb7d5,0xffff,0xffff,0xd7f7,0xd7f8,0xb1c1,
0xe8a8,0xd7f9,0xb9d3,0xd8be,0xd7e3,0xd7fa,0xd7fb,0xd7fc,
0xc1f1,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd7fd,0xffff,0xffff,0xe8ba,0xffff,0xe8bb,0xffff,0xb2d9,
0xd7fe,0xffff,0xffff,0xb2ae,0xe8b8,0xd8a1,0xffff,0xd8a2,
0xd8a3,0xffff,0xd8a4,0xffff,0xd8a5,0xe8ae,0xd8a6,0xe8b6,
0xffff,0xe8bd,0xe8b7,0xffff,0xffff,0xd8a7,0xe8b5,0xffff,
0xffff,0xffff,0xd8a8,0xe7f6,0xd8a9,0xd8aa,0xe8b3,0xffff,
0xd8ab,0xd8ac,0xe8af,0xd8ad,0xd8ae,0xd8af,0xb4d0,0xe8b1,
0xe8bc,0xffff,0xe8b2,0xffff,0xffff,0xffff,0xd8b0,0xd8b1,
0xe8be,0xd8b2,0xe8b0,0xc7fc,0xd8b3,0xd8cc,0xffff,0xffff,
0xffff,0xcde9,0xffff,0xffff,0xffff,0xe8b9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe8cf,0xd8b4,0xd8b5,
0xd8b6,0xe8c7,0xffff,0xffff,0xffff,0xbffb,0xffff,0xd8b7,
0xffff,0xd8b8,0xb5c6,0xffff,0xb6dd,0xffff,0xe8c2,0xd8b9,
0xd8ba,0xd8bb,0xffff,0xb2db,0xd8bc,0xffff,0xbed4,0xffff,
0xe8c5,0xffff,0xffff,0xffff,0xbada,0xd8bd,0xffff,0xc5d1,
0xe8ca,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd8bf,0xcaee,0xd8c0,0xe8c1,0xffff,0xffff,0xffff,0xb2da,
0xb8d6,0xc9a9,0xe8cb,0xffff,0xe8bf,0xffff,0xd8c1,0xe8c8,
0xd8c2,0xd8c3,0xffff,0xe8d2,0xd8c4,0xe8c3,0xffff,0xffff,
0xffff,0xd8c5,0xffff,0xe8c4,0xc6ba,0xffff,0xd8c6,0xe8c9,
0xffff,0xffff,0xd8c7,0xe8c6,0xcba8,0xe8cc,0xb0e0,0xd8c8,
0xffff,0xd8c9,0xffff,0xe8c0,0xffff,0xd8ca,0xffff,0xffff,
0xffff,0xd8cb,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe8ce,0xffff,0xe8cd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xc7eb,0xe8d4,0xffff,0xe8df,0xffff,0xffff,0xd8cd,
0xffff,0xb3fe,0xffff,0xffff,0xffff,0xe8e2,0xffff,0xffff,
0xe8d0,0xd8ce,0xffff,0xffff,0xe8d5,0xcdee,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd8cf,0xe8de,0xd8d0,
0xd8d1,0xcdd5,0xd8d2,0xffff,0xffff,0xd8d3,0xceaa,0xd8d4,
0xffff,0xd8d5,0xd8d6,0xffff,0xffff,0xffff,0xd8d7,0xc3f8,
0xd8d8,0xd8d9,0xd8da,0xb3eb,0xd8db,0xffff,0xffff,0xffff,
0xd8dc,0xc9f2,0xe8e4,0xc6a1,0xd8dd,0xd8de,0xb0b1,0xd8df,
0xffff,0xe8dd,0xd8e0,0xe8d9,0xc1f2,0xe8d3,0xe8db,0xe8e0,
0xd8e1,0xc7ac,0xffff,0xd8e2,0xd8e3,0xb0aa,0xd8e4,0xe8d8,
0xd8e5,0xe8e1,0xc9f8,0xffff,0xd8e6,0xd8e7,0xffff,0xffff,
0xffff,0xd8e8,0xe8dc,0xffff,0xe8d7,0xd8e9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xbed5,0xffff,0xffff,0xffff,0xffff,
0xbdaf,0xffff,0xd8ea,0xd8eb,0xbcac,0xd8ec,0xffff,0xffff,
0xffff,0xccd8,0xffff,0xffff,0xc9c7,0xffff,0xd8ed,0xe8e7,
0xffff,0xe8f0,0xffff,0xffff,0xffff,0xffff,0xd8ee,0xffff,
0xd8ef,0xd8f0,0xd8f1,0xffff,0xffff,0xe8da,0xffff,0xd8f2,
0xffff,0xd8f3,0xb3f7,0xffff,0xd8f4,0xffff,0xffff,0xffff,
0xbef8,0xe8e5,0xd8f5,0xe8ea,0xc1f3,0xd8f6,0xd8f7,0xe8e6,
0xd8f8,0xe8ed,0xd8f9,0xffff,0xc3df,0xffff,0xe8ee,0xd8fa,
0xd8fb,0xcdd6,0xe8e3,0xb3b8,0xd8fc,0xe8e9,0xffff,0xd8fd,
0xe8ec,0xccac,0xffff,0xd8fe,0xffff,0xffff,0xe8ef,0xffff,
0xffff,0xe8e8,0xe8eb,0xffff,0xd9a1,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xd9a2,
0xffff,0xffff,0xd9a3,0xffff,0xcba9,0xffff,0xcfa1,0xd9a4,
0xd9a5,0xd9a6,0xd9a7,0xffff,0xe8f3,0xffff,0xffff,0xd9a8,
0xffff,0xffff,0xd9aa,0xd9ab,0xe8fa,0xd9ac,0xffff,0xe8f2,
0xbcc3,0xffff,0xd9ad,0xd9ae,0xffff,0xffff,0xe8d1,0xd9af,
0xffff,0xffff,0xffff,0xffff,0xd9b0,0xffff,0xd9b1,0xffff,
0xd9b2,0xcace,0xffff,0xcca2,0xe8f9,0xe8f8,0xffff,0xe8f4,
0xe8f5,0xffff,0xb1b6,0xffff,0xd9b3,0xffff,0xd9b4,0xe8f7,
0xffff,0xe8f1,0xd9b5,0xd9b6,0xd9b7,0xd9b8,0xc4d5,0xd9b9,
0xffff,0xffff,0xd9ba,0xd9bb,0xe8f6,0xb0fe,0xffff,0xd9bc,
0xffff,0xffff,0xd9a9,0xd9bd,0xd9be,0xc2a2,0xd9bf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xcac3,0xffff,0xd9c0,
0xe8fb,0xe9a1,0xffff,0xc8d9,0xffff,0xffff,0xd9c1,0xffff,
0xe8fe,0xbed6,0xbcc9,0xe9a3,0xffff,0xffff,0xb6be,0xd9c2,
0xd9c3,0xd9c4,0xd9c5,0xd9c6,0xffff,0xe9a4,0xd9c7,0xc9f9,
0xe8fd,0xd9c8,0xe8d6,0xffff,0xd9c9,0xd9ca,0xd9cb,0xd9cc,
0xd9cd,0xd9ce,0xd9cf,0xe8fc,0xd9d0,0xffff,0xffff,0xffff,
0xcfcf,0xc6a2,0xc9f3,0xd9d1,0xffff,0xe9ab,0xffff,0xd9d2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9b1,
0xffff,0xd9d3,0xd9d4,0xd9d5,0xffff,0xd9d6,0xe9b2,0xd9d7,
0xe9a5,0xd9d8,0xffff,0xffff,0xc7f6,0xd9d9,0xd9da,0xe9af,
0xe9a7,0xd9db,0xe9a9,0xd9dc,0xd9dd,0xffff,0xffff,0xd9de,
0xe9b3,0xe9a8,0xffff,0xd9df,0xe9ac,0xffff,0xffff,0xb1f2,
0xd9e0,0xc6e5,0xffff,0xe9ad,0xe9b0,0xd9e1,0xffff,0xd9e2,
0xd9e3,0xffff,0xd9e4,0xffff,0xe9a6,0xd9e5,0xc1a6,0xd9e6,
0xe9aa,0xbba7,0xbfc5,0xb7b0,0xccf4,0xd9f4,0xccf9,0xbdf2,
0xffff,0xffff,0xffff,0xffff,0xd9e7,0xffff,0xd9e8,0xd9e9,
0xd9ea,0xe9b7,0xe9b5,0xffff,0xd9eb,0xd9ec,0xd9ed,0xd9ee,
0xffff,0xcfce,0xd9ef,0xffff,0xffff,0xffff,0xffff,0xd9f0,
0xffff,0xe9b4,0xd9f1,0xd9f2,0xffff,0xcdf5,0xd9f3,0xe9b6,
0xe9b8,0xffff,0xffff,0xffff,0xffff,0xe9b9,0xffff,0xffff,
0xd9f5,0xffff,0xd9f6,0xffff,0xe9bc,0xe9ba,0xffff,0xd9f7,
0xd9f8,0xffff,0xffff,0xffff,0xc6a3,0xe9bb,0xd9f9,0xffff,
0xd9fa,0xc8cd,0xe9ae,0xffff,0xffff,0xd9fb,0xffff,0xffff,
0xffff,0xffff,0xffff,0xd9fc,0xffff,0xffff,0xd9fd,0xbdf3,
0xffff,0xe9bd,0xe9c2,0xc1f4,0xd9fe,0xffff,0xe9c1,0xdaa1,
0xdaa2,0xffff,0xe9a2,0xffff,0xdaa3,0xdaa4,0xe9c3,0xc1c9,
0xffff,0xffff,0xe9be,0xe9c0,0xffff,0xdaa5,0xdaa6,0xffff,
0xdaa7,0xdaa8,0xdaa9,0xe9bf,0xffff,0xffff,0xddb1,0xdda2,
0xdaaa,0xdaab,0xe9c5,0xdaac,0xffff,0xffff,0xdaad,0xffff,
0xffff,0xdaae,0xe9c4,0xffff,0xffff,0xffff,0xffff,0xdaaf,
0xffff,0xdab0,0xffff,0xffff,0xffff,0xcdf6,0xffff,0xe2bc,
0xe9c6,0xffff,0xffff,0xffff,0xffff,0xffff,0xdab1,0xffff,
0xdab2,0xffff,0xdab3,0xffff,0xdab4,0xdab5,0xffff,0xe9c7,
0xdab6,0xb8e6,0xdab7,0xffff,0xffff,0xffff,0xdab8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe9c8,0xb8d7,0xffff,
0xb5d4,0xffff,0xdab9,0xdaba,0xe9ca,0xd1dd,0xdabb,0xdabc,
0xdabd,0xdabe,0xb5f5,0xffff,0xceba,0xdabf,0xb6f3,0xe9cb,
0xdac0,0xdac1,0xdac2,0xdac3,0xdac4,0xffff,0xffff,0xe9cc,
0xffff,0xdac5,0xffff,0xc3ee,0xdac6,0xffff,0xffff,0xdac7,
0xffff,0xe9cd,0xffff,0xffff,0xffff,0xdac8,0xdac9,0xdaca,
0xffff,0xc6fa,0xdacb,0xb0ba,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xdaed,0xffff,0xb2e3,0xe9d2,0xe9d3,0xdacc,0xffff,0xffff,
0xffff,0xdacd,0xffff,0xe9ce,0xffff,0xbbbd,0xdace,0xffff,
0xdacf,0xffff,0xdad0,0xffff,0xdad1,0xffff,0xffff,0xffff,
0xffff,0xdad2,0xffff,0xe9cf,0xc7c2,0xffff,0xdad3,0xdad4,
0xdad5,0xe9d0,0xe9d1,0xe9db,0xffff,0xdad6,0xffff,0xe9d5,
0xe9d8,0xdad7,0xffff,0xdad8,0xdad9,0xdada,0xe9d4,0xdadb,
0xdadc,0xdadd,0xffff,0xffff,0xffff,0xffff,0xffff,0xdade,
0xdadf,0xdae0,0xffff,0xdae1,0xe9d6,0xdae2,0xe9d7,0xbcd8,
0xffff,0xe9d9,0xffff,0xc3c1,0xffff,0xb7d6,0xb3c2,0xffff,
0xffff,0xdae3,0xdae4,0xffff,0xe9dc,0xdae5,0xffff,0xdae6,
0xffff,0xb3bf,0xdae7,0xe9e1,0xdae8,0xffff,0xe9dd,0xe9e0,
0xdae9,0xffff,0xffff,0xdaea,0xc8ba,0xdaeb,0xffff,0xdaec,
0xffff,0xe9de,0xffff,0xffff,0xe9df,0xc9c8,0xc8da,0xe9e2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xc2fd,0xe9ec,0xdaee,0xe9e8,0xdaef,0xdaf0,0xb2eb,0xffff,
0xe9e6,0xffff,0xcbaa,0xe9e7,0xdaf1,0xdaf2,0xe9e4,0xdaf3,
0xe9e5,0xe9ea,0xe9ed,0xdaf4,0xffff,0xe9eb,0xdaf5,0xdaf6,
0xdaf7,0xe9e9,0xe9e3,0xdaf8,0xdaf9,0xffff,0xffff,0xffff,
0xc3d8,0xdafa,0xe9f4,0xffff,0xccaa,0xffff,0xdafb,0xdafc,
0xffff,0xdafd,0xffff,0xdafe,0xffff,0xe9f2,0xffff,0xffff,
0xdba1,0xe9f3,0xffff,0xffff,0xffff,0xffff,0xdba2,0xdba3,
0xffff,0xdba4,0xdba5,0xffff,0xe9ee,0xffff,0xffff,0xe9f0,
0xffff,0xdba6,0xdba7,0xe9f1,0xdba8,0xdba9,0xdbaa,0xe9ef,
0xdbab,0xffff,0xffff,0xdbac,0xffff,0xdbad,0xffff,0xffff,
0xffff,0xc0e6,0xffff,0xcfb9,0xe9f8,0xdbae,0xe9f9,0xffff,
0xffff,0xffff,0xffff,0xeaa1,0xffff,0xbfaa,0xffff,0xe9fb,
0xdbaf,0xe9fe,0xffff,0xffff,0xffff,0xdbb0,0xffff,0xe9f6,
0xe9f5,0xdbb1,0xffff,0xeaa2,0xdbb2,0xdbb3,0xb2dc,0xffff,
0xe9fc,0xffff,0xeaa3,0xffff,0xffff,0xffff,0xe9fd,0xdbb4,
0xffff,0xdbb5,0xdbb6,0xffff,0xe9fa,0xffff,0xc4b3,0xffff,
0xe9f7,0xffff,0xffff,0xdbb7,0xffff,0xffff,0xffff,0xc7e8,
0xffff,0xffff,0xeaa7,0xdbb8,0xdbb9,0xdbba,0xdbbb,0xdbbc,
0xdbbd,0xdbbe,0xffff,0xdbbf,0xdbc0,0xcdbb,0xffff,0xffff,
0xdbc1,0xffff,0xffff,0xdbc2,0xffff,0xdbc3,0xffff,0xdbc4,
0xdbc5,0xdbc6,0xffff,0xffff,0xffff,0xffff,0xdbc7,0xeaa6,
0xdbc8,0xffff,0xeaa5,0xdbc9,0xffff,0xffff,0xffff,0xdbca,
0xffff,0xffff,0xffff,0xeaae,0xdbcb,0xdbcc,0xdbcd,0xeaa8,
0xffff,0xdbce,0xffff,0xeab0,0xffff,0xdbcf,0xffff,0xffff,
0xffff,0xffff,0xcde6,0xeab3,0xffff,0xeaaa,0xdbd0,0xdbd1,
0xeaab,0xdbd2,0xffff,0xffff,0xeaaf,0xffff,0xeab2,0xeab1,
0xdbd3,0xdbd4,0xdbd5,0xeaa9,0xffff,0xffff,0xdbd6,0xffff,
0xeaac,0xffff,0xeabd,0xffff,0xffff,0xdbd7,0xdbd8,0xffff,
0xffff,0xdbd9,0xdbda,0xffff,0xdbdb,0xffff,0xffff,0xdbdc,
0xeab6,0xffff,0xdbdd,0xdbde,0xdbdf,0xffff,0xffff,0xffff,
0xffff,0xffff,0xdbe0,0xdbe1,0xffff,0xdbe2,0xffff,0xeab4,
0xffff,0xdbe3,0xeab5,0xdbe4,0xffff,0xffff,0xeaba,0xeabb,
0xdbe5,0xb3aa,0xdbe6,0xb5c2,0xffff,0xffff,0xeab9,0xdbe7,
0xffff,0xdbe8,0xffff,0xdbe9,0xffff,0xeaa4,0xdbea,0xffff,
0xffff,0xdbeb,0xdbec,0xdbed,0xffff,0xeab8,0xeabc,0xeab7,
0xdbee,0xeabe,0xdbf0,0xdbf1,0xdbf2,0xeac0,0xeabf,0xffff,
0xdbf3,0xdbef,0xdbf4,0xdbf5,0xdbf6,0xffff,0xdbf7,0xdbf8,
0xffff,0xeac2,0xeac1,0xe9da,0xffff,0xffff,0xffff,0xeac6,
0xdbf9,0xffff,0xffff,0xffff,0xffff,0xdbfa,0xdbfb,0xffff,
0xdbfc,0xeac3,0xdbfd,0xffff,0xffff,0xdbfe,0xeac4,0xffff,
0xffff,0xeac5,0xdca1,0xeac7,0xdca2,0xffff,0xffff,0xffff,
0xb7ec,0xdca3,0xeac9,0xdca4,0xeac8,0xdca5,0xbdb0,0xffff,
0xdca6,0xdca7,0xdca8,0xdca9,0xb9d4,0xdea7,0xdcaa,0xffff,
0xffff,0xdcab,0xeaca,0xbdd1,0xffff,0xdcac,0xdcad,0xb3b9,
0xdcae,0xeacb,0xdcaf,0xb1d2,0xdcb0,0xbed7,0xeacc,0xdcb1,
0xdcb2,0xb9d5,0xeacd,0xb0e1,0xdcb3,0xffff,0xffff,0xffff,
0xc9bd,0xdcb4,0xffff,0xeace,0xffff,0xffff,0xffff,0xffff,
0xbfea,0xdcb5,0xead5,0xffff,0xffff,0xead2,0xffff,0xc3ef,
0xffff,0xdcb6,0xffff,0xdcb7,0xffff,0xead3,0xead0,0xb6de,
0xdcb8,0xeacf,0xead6,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb7b6,0xffff,0xffff,0xc2de,0xffff,0xeadc,0xffff,0xffff,
0xffff,0xffff,0xead8,0xffff,0xffff,0xffff,0xc2b5,0xead7,
0xdcb9,0xeada,0xdcba,0xdcbb,0xdcbc,0xffff,0xead1,0xdcbd,
0xdcbe,0xffff,0xeadb,0xffff,0xeadd,0xffff,0xffff,0xffff,
0xdcbf,0xffff,0xdcc0,0xc8ef,0xffff,0xffff,0xead9,0xffff,
0xeade,0xeae0,0xffff,0xffff,0xb8d3,0xead4,0xffff,0xb0c1,
0xffff,0xffff,0xdcc1,0xffff,0xffff,0xdcc2,0xdcc3,0xeadf,
0xdcc4,0xbadb,0xcef6,0xeae1,0xeae2,0xc1f5,0xffff,0xffff,
0xffff,0xffff,0xdcc5,0xdcc6,0xdcc7,0xdcc8,0xdcc9,0xcea2,
0xffff,0xdcca,0xdccb,0xdccc,0xeae3,0xcdb5,0xffff,0xffff,
0xeae4,0xeae5,0xffff,0xdccd,0xcae4,0xeae6,0xdcce,0xbac0,
0xffff,0xcea3,0xffff,0xffff,0xffff,0xffff,0xffff,0xdccf,
0xeaeb,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xdcd0,
0xdcd1,0xdcd2,0xeaec,0xbed8,0xeaea,0xdcd3,0xffff,0xdcd4,
0xcde7,0xeae7,0xffff,0xffff,0xeae9,0xc0bd,0xbffe,0xffff,
0xffff,0xdcd5,0xeae8,0xffff,0xeaed,0xffff,0xdcd6,0xcaa3,
0xffff,0xffff,0xeaef,0xffff,0xeaee,0xdcd7,0xdcd8,0xdcd9,
0xb3ec,0xffff,0xcbab,0xeaf0,0xffff,0xdcda,0xdcdb,0xffff,
0xdcdc,0xdcdd,0xdcde,0xffff,0xdcdf,0xeafc,0xeaf2,0xffff,
0xdce0,0xffff,0xffff,0xffff,0xffff,0xeaf3,0xdce1,0xdce2,
0xdce3,0xffff,0xeaf4,0xeaf5,0xffff,0xffff,0xffff,0xffff,
0xdce4,0xdce5,0xdce6,0xffff,0xffff,0xdce7,0xeaf9,0xffff,
0xeafa,0xdce8,0xdce9,0xeaf8,0xffff,0xffff,0xdcea,0xffff,
0xdceb,0xeaf6,0xdcec,0xeaf1,0xeaf7,0xdced,0xdcee,0xffff,
0xffff,0xdcef,0xffff,0xffff,0xeafb,0xf0b7,0xffff,0xdcf0,
0xffff,0xffff,0xdcf1,0xffff,0xffff,0xffff,0xb2a8,0xdcf2,
0xffff,0xffff,0xdcf3,0xdcf4,0xdcf5,0xffff,0xeafe,0xb6df,
0xeafd,0xdcf6,0xdcf7,0xdcf8,0xeba2,0xffff,0xeba1,0xffff,
0xffff,0xffff,0xeba4,0xdcf9,0xffff,0xeba3,0xdcfa,0xeba5,
0xdcfb,0xffff,0xbdb1,0xdcfc,0xeba6,0xdcfd,0xffff,0xeba7,
0xffff,0xffff,0xdcfe,0xdda1,0xdda2,0xdda3,0xeba8,0xc0be,
0xffff,0xcdd7,0xffff,0xeba9,0xffff,0xffff,0xcaa4,0xc7c6,
0xebaa,0xdda4,0xebab,0xb8ab,0xffff,0xdda5,0xffff,0xb5ac,
0xdda6,0xffff,0xffff,0xebac,0xdda7,0xdda8,0xbbeb,0xc7c1,
0xebad,0xffff,0xb3d0,0xdda9,0xddaa,0xffff,0xffff,0xddab,
0xddac,0xebae,0xffff,0xffff,0xffff,0xddad,0xebb0,0xcdf7,
0xffff,0xebaf,0xbfc6,0xffff,0xebb1,0xffff,0xffff,0xebb2,
0xddae,0xffff,0xebb3,0xb4d1,0xddaf,0xddb0,0xddb1,0xddb2,
0xffff,0xffff,0xebb4,0xffff,0xddb3,0xebb5,0xffff,0xebb6,
0xebb7,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb3d1,0xffff,0xddb4,0xddb5,0xddb6,0xddb7,
0xddb8,0xffff,0xebb8,0xffff,0xebb9,0xebba,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb2f2,0xffff,0xddb9,0xbfa8,0xebbb,
0xffff,0xddba,0xffff,0xddbb,0xffff,0xddbc,0xffff,0xffff,
0xffff,0xddbd,0xffff,0xddbe,0xebbc,0xffff,0xddbf,0xffff,
0xebbd,0xddc0,0xffff,0xffff,0xffff,0xddc1,0xffff,0xddc2,
0xb8c0,0xffff,0xc4fb,0xebbe,0xddc3,0xddc4,0xffff,0xddc5,
0xb7d7,0xffff,0xbfd6,0xffff,0xebc1,0xffff,0xc6a4,0xddc6,
0xebc0,0xddc7,0xddc8,0xb7b1,0xddc9,0xddca,0xebbf,0xc2f7,
0xb5ad,0xffff,0xffff,0xebc2,0xffff,0xebc3,0xddcb,0xbed9,
0xddcc,0xffff,0xddcd,0xb7ed,0xddce,0xebc4,0xddcf,0xffff,
0xffff,0xffff,0xcbac,0xddd0,0xddd1,0xc0df,0xffff,0xddd2,
0xffff,0xb5f6,0xffff,0xccf5,0xc1ca,0xddd3,0xebc5,0xddd4,
0xffff,0xffff,0xbfc7,0xc3f0,0xbeda,0xddd5,0xddd6,0xffff,
0xddd7,0xebc6,0xffff,0xddd8,0xffff,0xddd9,0xebc9,0xddda,
0xebca,0xdddb,0xffff,0xffff,0xffff,0xdddc,0xdddd,0xffff,
0xbabe,0xc2c2,0xebc8,0xddde,0xbedb,0xc9be,0xdddf,0xdde0,
0xdde1,0xffff,0xffff,0xebc7,0xdde2,0xdde3,0xbbec,0xffff,
0xb1d3,0xdde4,0xebce,0xb7d8,0xffff,0xdde5,0xbbee,0xdde6,
0xffff,0xbbed,0xffff,0xcfcd,0xebcd,0xebcc,0xc1a7,0xffff,
0xb5cd,0xcfc3,0xb3ba,0xbedc,0xffff,0xdde7,0xdde8,0xdde9,
0xffff,0xddea,0xddeb,0xddec,0xebcb,0xffff,0xdded,0xddee,
0xddef,0xffff,0xebd0,0xddf0,0xebd1,0xebcf,0xddf1,0xb8d8,
0xffff,0xcdc0,0xffff,0xddf2,0xbbef,0xc7a7,0xffff,0xddf3,
0xddf4,0xebd4,0xddf5,0xc0c0,0xffff,0xc3c2,0xddf6,0xddf7,
0xcdb6,0xddf8,0xebd7,0xffff,0xffff,0xffff,0xb8ec,0xddf9,
0xc0bf,0xebd3,0xffff,0xebd8,0xb8ed,0xebd5,0xebd6,0xddfa,
0xebd2,0xddfb,0xffff,0xffff,0xc0e2,0xc6c9,0xddfc,0xddfd,
0xc3af,0xffff,0xb2dd,0xddfe,0xffff,0xffff,0xdea1,0xdea2,
0xffff,0xc8f0,0xffff,0xdea3,0xb5c3,0xffff,0xdea4,0xc4b4,
0xffff,0xffff,0xebdb,0xdea5,0xebd9,0xffff,0xdea6,0xc3cc,
0xdea7,0xdea8,0xdea9,0xc0c1,0xb4d2,0xebda,0xffff,0xbfdb,
0xffff,0xdeaa,0xceca,0xdeab,0xdeac,0xdead,0xcfc0,0xdeae,
0xffff,0xffff,0xebdc,0xebe7,0xc4b5,0xdeaf,0xebe6,0xdeb0,
0xebe3,0xebeb,0xebe4,0xffff,0xebe0,0xffff,0xc4fc,0xebdf,
0xffff,0xffff,0xffff,0xebdd,0xdeb1,0xcda1,0xbbf0,0xffff,
0xdeb2,0xebe1,0xffff,0xebde,0xdeb3,0xdeb4,0xdeb5,0xebe5,
0xbdf4,0xffff,0xb8c1,0xffff,0xdeb6,0xffff,0xc2fa,0xdeb7,
0xcbc5,0xb1da,0xb0e2,0xffff,0xc6a5,0xdeb8,0xdeb9,0xebe9,
0xffff,0xffff,0xdebf,0xdeba,0xebe8,0xffff,0xc6e6,0xffff,
0xebed,0xdebb,0xffff,0xffff,0xebe2,0xffff,0xebec,0xebee,
0xffff,0xb8ac,0xebea,0xb9d6,0xdebc,0xbcd5,0xdebd,0xdebe,
0xebef,0xcdd8,0xffff,0xffff,0xffff,0xffff,0xebf2,0xffff,
0xebf5,0xffff,0xffff,0xebf3,0xc9b5,0xdec0,0xffff,0xffff,
0xdec1,0xffff,0xffff,0xebf0,0xffff,0xffff,0xffff,0xdec2,
0xffff,0xb6e0,0xffff,0xffff,0xdec3,0xffff,0xebf4,0xffff,
0xffff,0xebf6,0xdec4,0xdec5,0xdec6,0xdec7,0xdec8,0xffff,
0xdec9,0xebfa,0xffff,0xffff,0xebf7,0xdece,0xebf9,0xebf8,
0xffff,0xffff,0xdeca,0xdecb,0xdecc,0xffff,0xebfb,0xffff,
0xbcb1,0xdecd,0xebfd,0xebfc,0xc9e8,0xffff,0xdecf,0xeca1,
0xffff,0xffff,0xffff,0xded0,0xffff,0xffff,0xb7d9,0xffff,
0xffff,0xffff,0xffff,0xebfe,0xeca2,0xded1,0xffff,0xeca3,
0xb5c4,0xe6c1,0xbef9,0xffff,0xeca4,0xffff,0xded2,0xb8ee,
0xded3,0xded4,0xffff,0xffff,0xded5,0xeca5,0xded6,0xffff,
0xeca6,0xded7,0xffff,0xbbbe,0xded8,0xded9,0xffff,0xffff,
0xffff,0xffff,0xdace,0xdeda,0xeca7,0xdedb,0xeca8,0xdedc,
0xbdb2,0xffff,0xeca9,0xecaa,0xdedd,0xdede,0xecab,0xffff,
0xffff,0xecac,0xecad,0xffff,0xdedf,0xffff,0xdee0,0xdee1,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xc3ab,
0xdee2,0xdee3,0xecae,0xffff,0xffff,0xdee4,0xdee5,0xecb0,
0xffff,0xecaf,0xffff,0xffff,0xffff,0xdee6,0xc6a6,0xdee7,
0xecb1,0xdee8,0xcbad,0xdee9,0xecb2,0xffff,0xecb3,0xdeea,
0xecb4,0xdeeb,0xffff,0xdeec,0xdeed,0xecb5,0xffff,0xdeee,
0xdeef,0xdef2,0xc6da,0xdef0,0xffff,0xdef1,0xffff,0xffff,
0xffff,0xbedd,0xecb6,0xdef3,0xdef4,0xffff,0xdef5,0xffff,
0xdef6,0xdef7,0xb9eb,0xd0ae,0xecb7,0xdef8,0xffff,0xffff,
0xffff,0xffff,0xffff,0xdef9,0xffff,0xdefa,0xdefb,0xffff,
0xecb8,0xc9bf,0xecb9,0xdefc,0xecc1,0xffff,0xdefd,0xffff,
0xffff,0xffff,0xecba,0xffff,0xffff,0xecbc,0xdefe,0xdfa1,
0xffff,0xecbb,0xecbd,0xdfa2,0xcbc6,0xecbe,0xecbf,0xffff,
0xdfa3,0xffff,0xdfa4,0xdfa5,0xecc0,0xffff,0xffff,0xffff,
0xecc2,0xdfa6,0xffff,0xdfa7,0xdfa8,0xb3ad,0xc4e7,0xffff,
0xc9e9,0xbae2,0xb9d7,0xffff,0xdfa9,0xffff,0xffff,0xc9cf,
0xb2df,0xc8ce,0xecc5,0xb4d3,0xc0d5,0xecc4,0xecc9,0xc3f9,
0xcce3,0xffff,0xecc7,0xecc8,0xb5ae,0xffff,0xecca,0xc7e3,
0xc2df,0xdfaa,0xdfab,0xc8f1,0xc5bd,0xecc6,0xffff,0xcbc7,
0xb2ec,0xeccc,0xcfa8,0xc4c2,0xcfc5,0xdfac,0xdfad,0xbbf1,
0xeccb,0xdfae,0xc2b1,0xdfaf,0xffff,0xecdc,0xc1a8,0xdfb0,
0xffff,0xc6f8,0xffff,0xc9d0,0xffff,0xdfb2,0xdfb1,0xffff,
0xffff,0xdfb3,0xeccf,0xbbbf,0xbbf2,0xdfb4,0xbede,0xffff,
0xc7e5,0xdfb5,0xb8ad,0xecce,0xeccd,0xffff,0xc9ea,0xffff,
0xdfb6,0xffff,0xbcc1,0xffff,0xdfb7,0xc5d2,0xffff,0xdfb8,
0xdfb9,0xffff,0xdfba,0xffff,0xffff,0xdfbb,0xffff,0xdfbc,
0xdfbd,0xffff,0xecd1,0xecd2,0xb9d8,0xecd0,0xdfbe,0xdfbf,
0xffff,0xdfc0,0xffff,0xdfc1,0xecd3,0xecd4,0xffff,0xecd6,
0xc2a3,0xdfc2,0xecd5,0xb4e6,0xffff,0xecd8,0xffff,0xecd7,
0xecd9,0xffff,0xdfc3,0xecdb,0xecdd,0xffff,0xecde,0xdfc4,
0xffff,0xffff,0xffff,0xdfc5,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc0d6,0xdfc6,0xbccf,0xecdf,
0xffff,0xdfc7,0xffff,0xb3d2,0xdfc8,0xece0,0xdfc9,0xffff,
0xc1f6,0xece1,0xffff,0xece2,0xc9eb,0xffff,0xffff,0xb5af,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xdfca,
0xffff,0xece3,0xdfcb,0xffff,0xdfcc,0xc4b6,0xffff,0xffff,
0xdfcd,0xffff,0xb1db,0xffff,0xffff,0xdfce,0xffff,0xffff,
0xdfcf,0xdfd0,0xffff,0xffff,0xffff,0xdfd1,0xffff,0xffff,
0xffff,0xece4,0xffff,0xffff,0xffff,0xffff,0xdfd2,0xdfd3,
0xdfd4,0xffff,0xffff,0xbcf1,0xffff,0xffff,0xdfd5,0xffff,
0xbff6,0xffff,0xffff,0xdfd6,0xdfd7,0xffff,0xffff,0xdfd8,
0xffff,0xffff,0xdfd9,0xc2ad,0xffff,0xdfda,0xffff,0xdfdb,
0xffff,0xdfdc,0xece7,0xdfdd,0xdfef,0xffff,0xece6,0xffff,
0xdfde,0xffff,0xece5,0xffff,0xffff,0xdfdf,0xdfe0,0xdfe1,
0xdfe2,0xffff,0xdfe3,0xeced,0xeceb,0xffff,0xdfe4,0xece8,
0xffff,0xdfe5,0xffff,0xffff,0xdfe6,0xdfe7,0xecea,0xdfe8,
0xffff,0xdfe9,0xece9,0xecec,0xffff,0xb5f7,0xffff,0xecf0,
0xffff,0xc0d7,0xffff,0xecf1,0xdfea,0xdfeb,0xffff,0xdfec,
0xb8d9,0xffff,0xecee,0xecef,0xdfed,0xffff,0xffff,0xcfa9,
0xdfee,0xdff0,0xdff1,0xc4b7,0xdff2,0xc1a9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xecf2,0xdff3,0xffff,0xecf5,
0xffff,0xdff4,0xffff,0xffff,0xdff5,0xdff6,0xdff7,0xffff,
0xecf3,0xecf4,0xcdd9,0xdff8,0xffff,0xffff,0xffff,0xc6a7,
0xecf8,0xdff9,0xffff,0xffff,0xdffa,0xffff,0xdffb,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xecf6,0xecf7,0xecf9,
0xdffc,0xdffd,0xdffe,0xe0a1,0xffff,0xffff,0xe0a2,0xe0a3,
0xffff,0xffff,0xeda9,0xffff,0xffff,0xffff,0xffff,0xffff,
0xecfc,0xe0a4,0xffff,0xe0a5,0xecfd,0xecfb,0xe0a6,0xe0a7,
0xe0a8,0xe0a9,0xffff,0xffff,0xffff,0xe0aa,0xffff,0xffff,
0xe0ab,0xe0ac,0xecfa,0xffff,0xc4fd,0xffff,0xffff,0xeda1,
0xeda5,0xeda2,0xecfe,0xe0ad,0xeda3,0xe0ae,0xe0af,0xe0b0,
0xeda4,0xffff,0xffff,0xffff,0xe0b1,0xedab,0xffff,0xffff,
0xffff,0xeda6,0xffff,0xe0b2,0xe0b3,0xe0b4,0xe0b5,0xc0d8,
0xeda8,0xe0b6,0xe0b7,0xedaa,0xeda7,0xffff,0xffff,0xffff,
0xffff,0xe0b8,0xffff,0xffff,0xe0b9,0xe0ba,0xffff,0xe0bb,
0xe0bc,0xe0bd,0xedad,0xffff,0xbdb3,0xffff,0xedac,0xffff,
0xffff,0xe0be,0xe0bf,0xe0c0,0xedae,0xffff,0xffff,0xffff,
0xffff,0xedaf,0xe0c1,0xe0c2,0xedb2,0xedb1,0xffff,0xedb0,
0xffff,0xe0c3,0xedb4,0xedb3,0xffff,0xccf6,0xffff,0xffff,
0xe0c4,0xedb6,0xe0c5,0xedb5,0xedb7,0xe0c6,0xffff,0xffff,
0xffff,0xedb8,0xe0c7,0xe0c8,0xffff,0xe0c9,0xe0ca,0xffff,
0xffff,0xedba,0xe0cb,0xffff,0xffff,0xffff,0xffff,0xe0cc,
0xffff,0xe0cd,0xedb9,0xbfc8,0xedbb,0xe0ce,0xe0cf,0xb6ed,
0xedbc,0xedbe,0xffff,0xe0d0,0xffff,0xe0d1,0xffff,0xffff,
0xffff,0xffff,0xe0d2,0xe0d3,0xffff,0xffff,0xedbf,0xffff,
0xe0d4,0xe0d5,0xffff,0xe0d6,0xe0d7,0xedc0,0xedbd,0xe0d8,
0xedc1,0xffff,0xbcd6,0xedc2,0xb5b0,0xb7b3,0xffff,0xe0d9,
0xffff,0xe0da,0xb8ae,0xffff,0xe0db,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xedc3,0xe0dc,0xffff,0xffff,0xc6f0,
0xffff,0xffff,0xc5be,0xedc4,0xffff,0xffff,0xffff,0xffff,
0xe0dd,0xffff,0xffff,0xedc7,0xffff,0xe0e4,0xe0de,0xffff,
0xe0df,0xe0e0,0xffff,0xffff,0xffff,0xffff,0xffff,0xe0e1,
0xbcb4,0xe0e2,0xe0e3,0xedc6,0xedc5,0xb7da,0xedc8,0xffff,
0xe0e5,0xffff,0xe0e6,0xb3d3,0xffff,0xedca,0xffff,0xe0e7,
0xe0e8,0xbadc,0xedc9,0xffff,0xedd2,0xffff,0xffff,0xe0e9,
0xe0ea,0xffff,0xedcc,0xedce,0xcae5,0xedcb,0xe0eb,0xe0ec,
0xe0ed,0xedcd,0xffff,0xedd1,0xedcf,0xb5b1,0xe0ee,0xedd0,
0xe0ef,0xe0f0,0xffff,0xe0f1,0xffff,0xe0f2,0xedd3,0xe0f3,
0xe0f4,0xc7da,0xced8,0xffff,0xe0f5,0xe0f6,0xe0f7,0xbdb4,
0xffff,0xffff,0xffff,0xedd4,0xe0f8,0xe0f9,0xe0fa,0xe0fb,
0xcda2,0xedd6,0xe0fc,0xedd5,0xffff,0xffff,0xedd9,0xcdc1,
0xe0fd,0xe0fe,0xedd8,0xe1a1,0xb3ed,0xedd7,0xeddc,0xe1a2,
0xffff,0xeddb,0xffff,0xffff,0xedda,0xc5b2,0xeddd,0xe1a3,
0xffff,0xe1a4,0xe1a5,0xe1a6,0xe1a7,0xe1a8,0xffff,0xedde,
0xe1a9,0xffff,0xffff,0xffff,0xeddf,0xe1aa,0xe1ab,0xb9ec,
0xffff,0xb7a5,0xede0,0xede1,0xede2,0xe1ac,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xbfc9,0xede3,0xe1ad,0xbcad,0xede4,
0xe1ae,0xe1af,0xffff,0xede5,0xe1b0,0xe1b1,0xe1b2,0xd2a1,
0xd1fe,0xffff,0xffff,0xffff,0xffff,0xede6,0xe5f0,0xede7,
0xc3a4,0xbfab,0xc7c0,0xffff,0xffff,0xe1b3,0xe1b4,0xede8,
0xe1b5,0xffff,0xcad5,0xc4d4,0xb9fe,0xffff,0xe1b6,0xc3a9,
0xe1b7,0xe1b8,0xb1aa,0xffff,0xcbf8,0xbfd7,0xe1b9,0xffff,
0xffff,0xffff,0xe1ba,0xe1bb,0xffff,0xe1bc,0xb7de,0xffff,
0xe1bd,0xb6e1,0xe1be,0xe1bf,0xcad6,0xe1c0,0xffff,0xffff,
0xffff,0xffff,0xede9,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe1c1,0xffff,0xedeb,0xe1c2,0xe1c3,0xedea,0xb2e0,0xffff,
0xe1c4,0xc6f6,0xedec,0xc7f7,0xffff,0xc5b3,0xe1c5,0xeded,
0xbdd2,0xe1c6,0xffff,0xffff,0xedef,0xe1c7,0xe1c8,0xccc2,
0xedfe,0xedf1,0xedf2,0xe1c9,0xffff,0xc4c9,0xe1ca,0xffff,
0xc2e0,0xc1f7,0xe1cb,0xc6a8,0xe1cc,0xedf0,0xb5d5,0xffff,
0xe1cd,0xffff,0xffff,0xedf9,0xe1ce,0xedf6,0xeea5,0xc6a9,
0xc3e0,0xedf3,0xffff,0xc4fe,0xc5d3,0xedf4,0xedf8,0xbfe0,
0xe1cf,0xc7e7,0xc4cc,0xe1d0,0xffff,0xc0c2,0xedf7,0xc2ae,
0xc2a4,0xedf5,0xb0a9,0xcfa2,0xffff,0xffff,0xffff,0xedfa,
0xe1d1,0xe1d2,0xe1d4,0xffff,0xe1d5,0xe1d6,0xc2e1,0xe1d3,
0xffff,0xbdb5,0xbfca,0xe1d7,0xe1d8,0xedfc,0xedfb,0xe1d9,
0xb0ef,0xedfd,0xffff,0xffff,0xc9af,0xffff,0xeea7,0xe1da,
0xffff,0xc6db,0xbfeb,0xe1db,0xe1dc,0xc3d9,0xffff,0xb6f8,
0xffff,0xeea6,0xcdb7,0xb1bf,0xe1dd,0xcad7,0xb2e1,0xeea1,
0xeea2,0xeea3,0xeea4,0xc6bb,0xc3a3,0xb0e3,0xeea8,0xffff,
0xeea9,0xf4a3,0xffff,0xe1de,0xc2bd,0xe1df,0xeeaa,0xffff,
0xb1f3,0xc1cc,0xe1e0,0xb8af,0xffff,0xcdda,0xe1e1,0xe1e2,
0xeeab,0xc5ac,0xffff,0xffff,0xe1e3,0xc1f8,0xbcd7,0xeeac,
0xe1e4,0xffff,0xeeaf,0xffff,0xe1e5,0xbde5,0xeead,0xc1ab,
0xc1aa,0xe1e6,0xb0e4,0xffff,0xcecb,0xeeb1,0xffff,0xc8f2,
0xeeb3,0xeeb2,0xeeb0,0xe3e4,0xb4d4,0xe1e7,0xffff,0xedee,
0xe1e8,0xeeb5,0xeeb4,0xe1e9,0xe1ea,0xffff,0xe1eb,0xeeb6,
0xe1ec,0xcdb8,0xffff,0xffff,0xffff,0xe1ed,0xffff,0xe1ee,
0xe1ef,0xe1f0,0xffff,0xe1f1,0xffff,0xffff,0xffff,0xffff,
0xe1f2,0xe1f3,0xe1f4,0xc6e1,0xffff,0xe1f5,0xcbae,0xffff,
0xeeb7,0xffff,0xbcd9,0xffff,0xffff,0xffff,0xffff,0xeeb8,
0xe1f6,0xeeb9,0xe1f7,0xe1f8,0xe1f9,0xeeba,0xe1fa,0xffff,
0xc5a1,0xffff,0xffff,0xffff,0xffff,0xe1fb,0xe1fd,0xffff,
0xffff,0xb0ea,0xffff,0xe1fe,0xe2a1,0xe2a2,0xffff,0xe2a3,
0xe2a4,0xffff,0xb9d9,0xffff,0xe1fc,0xffff,0xcfba,0xffff,
0xffff,0xffff,0xe2ad,0xffff,0xffff,0xe2a5,0xffff,0xe2a6,
0xe2a7,0xe2a8,0xffff,0xeebe,0xe2a9,0xe2aa,0xffff,0xe2ab,
0xffff,0xb7b4,0xeebb,0xffff,0xeebc,0xe2ac,0xffff,0xffff,
0xc9f4,0xffff,0xffff,0xe2af,0xffff,0xb3d4,0xffff,0xe2b0,
0xe2b1,0xffff,0xffff,0xffff,0xe2b2,0xcdb9,0xe2ae,0xb6bf,
0xffff,0xffff,0xffff,0xffff,0xffff,0xc5d4,0xe2b3,0xe2b4,
0xe2b5,0xffff,0xeebf,0xffff,0xe2b6,0xe2b7,0xe2b8,0xffff,
0xe2b9,0xffff,0xffff,0xffff,0xffff,0xe2ba,0xffff,0xffff,
0xe2bb,0xffff,0xeec0,0xffff,0xe2bc,0xffff,0xe2bd,0xe2be,
0xe2bf,0xeec1,0xe2c0,0xffff,0xe2c1,0xffff,0xe2c2,0xffff,
0xe2c3,0xffff,0xe2c5,0xe2c6,0xffff,0xe2c4,0xffff,0xe2c7,
0xffff,0xe2c8,0xffff,0xffff,0xffff,0xc5a2,0xe2c9,0xe2ca,
0xeec3,0xe2cb,0xeec2,0xffff,0xe2cc,0xffff,0xe2cd,0xe2ce,
0xffff,0xe2cf,0xe2d0,0xffff,0xe2d1,0xe2d2,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe2d3,0xffff,0xffff,0xffff,0xe2d4,
0xe2d5,0xc6d3,0xeec4,0xbdb6,0xbce0,0xc7db,0xc3f1,0xe2d6,
0xffff,0xffff,0xbcf2,0xe2d7,0xbfec,0xffff,0xeec5,0xe2d8,
0xeec6,0xe2d9,0xe2da,0xe2db,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe2dc,0xbfdd,0xeec7,0xe2dd,0xeec8,0xffff,0xe2de,
0xffff,0xeec9,0xcdef,0xffff,0xbdb7,0xe2df,0xffff,0xffff,
0xffff,0xffff,0xeecb,0xeeca,0xe2e0,0xb9da,0xffff,0xb9f3,
0xbbc0,0xe2e1,0xe2e2,0xe2e3,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe2e4,0xeece,0xe2e5,0xffff,0xe2e6,0xe2e7,0xbde6,
0xffff,0xeecd,0xe2e8,0xeecc,0xffff,0xc2e9,0xe2e9,0xffff,
0xb8ef,0xe2ea,0xc0c3,0xe2eb,0xe2ec,0xe2ed,0xffff,0xc8b0,
0xe2ee,0xffff,0xffff,0xffff,0xbdb9,0xffff,0xe2ef,0xffff,
0xffff,0xe2f0,0xeecf,0xffff,0xbedf,0xffff,0xe2f1,0xffff,
0xe2f2,0xffff,0xeed2,0xeed0,0xe2f3,0xe2f4,0xe2f5,0xeed1,
0xe2f6,0xe2f7,0xe2f8,0xe2f9,0xeed4,0xeed3,0xe2fa,0xffff,
0xbefa,0xffff,0xeed5,0xe2fb,0xe2fc,0xe2fd,0xffff,0xe2fe,
0xeed6,0xeed7,0xe3a1,0xe3a2,0xffff,0xe3a3,0xc8d0,0xbad3,
0xbce1,0xeed8,0xffff,0xeed9,0xcea4,0xbdc5,0xccee,0xcecc,
0xeeda,0xb6e2,0xffff,0xe3a4,0xe3a5,0xffff,0xeedb,0xe3a6,
0xc5a3,0xe3a7,0xe3a8,0xeede,0xb3f8,0xbfcb,0xe3a9,0xeedc,
0xffff,0xeedd,0xffff,0xc4e0,0xe3aa,0xe3ab,0xcbd5,0xb6fc,
0xffff,0xe3ac,0xe3ad,0xffff,0xe3ae,0xe3af,0xe3b0,0xe3b1,
0xe3b2,0xe3b3,0xffff,0xffff,0xffff,0xeee0,0xeee1,0xe3b4,
0xffff,0xe3b5,0xffff,0xe3b6,0xeedf,0xe3b7,0xffff,0xeee3,
0xe3b8,0xe3b9,0xffff,0xffff,0xe3ba,0xe3bb,0xe3bc,0xe3bd,
0xffff,0xe3be,0xe3bf,0xffff,0xe3c0,0xc6df,0xb3c3,0xffff,
0xe3c1,0xeee7,0xe3c2,0xe3c3,0xeee4,0xeee6,0xe3c4,0xffff,
0xe3c5,0xffff,0xffff,0xffff,0xe3c6,0xe3c7,0xeee2,0xffff,
0xffff,0xffff,0xffff,0xe3c8,0xe3c9,0xe3ca,0xe3cb,0xffff,
0xe3cc,0xefcf,0xffff,0xffff,0xeee5,0xffff,0xe3cd,0xe3ce,
0xe3cf,0xffff,0xffff,0xe3d0,0xceeb,0xe3d1,0xe3d2,0xb8da,
0xe3d3,0xe3d4,0xe3d5,0xffff,0xe3d6,0xffff,0xe3d7,0xeeef,
0xe3d8,0xffff,0xe3d9,0xe3da,0xc5b4,0xeeea,0xe3db,0xe3dc,
0xeeed,0xeeeb,0xe3dd,0xeef0,0xffff,0xe3de,0xe3df,0xe3e0,
0xeef1,0xe3e1,0xffff,0xffff,0xffff,0xffff,0xffff,0xeee9,
0xe3e2,0xe3e3,0xeef6,0xb1f4,0xe3e4,0xe3e5,0xeee8,0xffff,
0xe3e6,0xe3e7,0xc8ad,0xffff,0xeeec,0xe3e8,0xbee0,0xe3e9,
0xe3ea,0xe3eb,0xffff,0xffff,0xffff,0xffff,0xe3ec,0xe3ed,
0xe3ee,0xb9db,0xffff,0xffff,0xffff,0xe3ef,0xe3f0,0xe3f1,
0xe3f2,0xe3f3,0xffff,0xe3f4,0xe3f5,0xe3f6,0xcbc8,0xe3f7,
0xb6e4,0xffff,0xffff,0xbdc6,0xffff,0xc6bc,0xffff,0xffff,
0xe3f8,0xe3f9,0xe3fa,0xffff,0xffff,0xe3fb,0xe3fc,0xffff,
0xffff,0xc1ad,0xe3fd,0xeef4,0xffff,0xeeee,0xeef3,0xe3fe,
0xccc3,0xe4a1,0xc4b8,0xeef5,0xeef2,0xffff,0xffff,0xe4a2,
0xe4a3,0xffff,0xffff,0xffff,0xe4a4,0xe4a5,0xffff,0xe4a6,
0xe4a7,0xffff,0xffff,0xe4a8,0xffff,0xc1ac,0xffff,0xe4a9,
0xffff,0xffff,0xe4aa,0xffff,0xffff,0xffff,0xe4ab,0xeef9,
0xe4ac,0xeef8,0xe4ad,0xe4ae,0xe4af,0xe4b0,0xffff,0xe4b1,
0xe4b2,0xe4b3,0xe4b4,0xe4b5,0xffff,0xe4b6,0xe4b7,0xe4b8,
0xe4b9,0xffff,0xffff,0xe4ba,0xe4bb,0xe4bc,0xe4bd,0xeef7,
0xe4be,0xffff,0xcbaf,0xe4bf,0xffff,0xe4c0,0xffff,0xe4c1,
0xe4c2,0xe4c3,0xffff,0xffff,0xe4c4,0xe4c5,0xffff,0xe4c6,
0xe4c7,0xe4c8,0xffff,0xe4c9,0xbdfb,0xe4ca,0xffff,0xe4cb,
0xe4cc,0xeefa,0xcadf,0xffff,0xe4cd,0xb1d4,0xe4ce,0xffff,
0xe4cf,0xffff,0xc9c6,0xc3f2,0xffff,0xffff,0xffff,0xffff,
0xb5f8,0xe4d0,0xeefc,0xe4d1,0xb9dd,0xffff,0xffff,0xe4d2,
0xe4d3,0xffff,0xe4d4,0xffff,0xffff,0xffff,0xbbac,0xffff,
0xe4d5,0xffff,0xffff,0xffff,0xffff,0xe4d6,0xffff,0xeefb,
0xbfed,0xe4d7,0xffff,0xffff,0xe4d8,0xe4d9,0xffff,0xffff,
0xbfee,0xefa1,0xefa3,0xffff,0xe4da,0xe4db,0xe4dc,0xe4dd,
0xbefb,0xe4de,0xefa2,0xefa4,0xe4df,0xe4e0,0xb6d3,0xe4e1,
0xc9c5,0xe4e2,0xe4e3,0xbce2,0xcfa3,0xffff,0xeefe,0xbaf8,
0xffff,0xffff,0xcfbf,0xe4e4,0xe4e5,0xefa6,0xe4e6,0xe4e7,
0xffff,0xffff,0xefa5,0xefa7,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xeefd,0xffff,0xffff,0xe4e8,
0xe4e9,0xe4ea,0xffff,0xc6e9,0xffff,0xc5d5,0xffff,0xffff,
0xe4eb,0xe4ec,0xe4ed,0xffff,0xc4d7,0xe4ee,0xefac,0xe4ef,
0xe4f0,0xffff,0xe4f1,0xc3c3,0xefa8,0xffff,0xe4f2,0xffff,
0xefa9,0xffff,0xffff,0xffff,0xe4f3,0xe4f4,0xffff,0xe4f5,
0xffff,0xe4f6,0xe4f7,0xffff,0xb7ad,0xe4f8,0xefab,0xe4f9,
0xe4fa,0xe4fb,0xffff,0xe4fc,0xe4fd,0xb8b0,0xe4fe,0xffff,
0xffff,0xffff,0xe5a1,0xffff,0xefaa,0xe5a2,0xbee1,0xe5a3,
0xe5a4,0xe5a5,0xe5a6,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe5a7,0xffff,0xe5a8,0xe5a9,0xb3f9,0xe5aa,0xffff,0xe5ab,
0xffff,0xffff,0xe5ac,0xffff,0xefb0,0xe5ad,0xbabf,0xc1f9,
0xe5ae,0xffff,0xc4ca,0xe5af,0xffff,0xffff,0xe5b0,0xffff,
0xffff,0xe5b1,0xffff,0xe5b2,0xe5b3,0xffff,0xe5b4,0xb3bb,
0xe5b5,0xe5bb,0xffff,0xe5b6,0xefae,0xefaf,0xc4c3,0xffff,
0xefad,0xffff,0xffff,0xffff,0xe5b7,0xe5b8,0xe5b9,0xffff,
0xffff,0xefb1,0xe5ba,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe5bc,0xffff,0xefb7,0xe5bd,0xe5be,0xe5bf,0xe5c0,
0xefba,0xe5c1,0xe5c2,0xe5c3,0xe5c4,0xe5c5,0xffff,0xffff,
0xefb9,0xc5ad,0xffff,0xe5c6,0xffff,0xffff,0xefb2,0xefb3,
0xefb6,0xe5c7,0xffff,0xffff,0xe5c8,0xefb8,0xe5c9,0xe5ca,
0xffff,0xb6c0,0xe5cb,0xffff,0xefbb,0xefb5,0xe5cc,0xe5cd,
0xefb4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe5cf,
0xe5d0,0xe5ce,0xe5d1,0xe5d2,0xffff,0xe5d3,0xffff,0xffff,
0xffff,0xe5d4,0xe5d5,0xefbf,0xe5d6,0xffff,0xffff,0xefc0,
0xe5d7,0xe5d8,0xffff,0xffff,0xffff,0xe5d9,0xe5da,0xe5db,
0xefc1,0xffff,0xffff,0xefbe,0xefbd,0xe5dc,0xe5dd,0xe5de,
0xbee2,0xc6aa,0xefbc,0xffff,0xffff,0xffff,0xffff,0xe5df,
0xffff,0xefc5,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xefc3,0xffff,0xffff,0xe5e0,0xe5e1,
0xffff,0xe5e2,0xe5e3,0xe5e4,0xe5e5,0xefc4,0xefc2,0xffff,
0xc2f8,0xffff,0xefc6,0xe5e6,0xffff,0xe5e8,0xffff,0xe5e7,
0xffff,0xefc7,0xffff,0xe5e9,0xefc9,0xe5ea,0xffff,0xffff,
0xe5eb,0xffff,0xe5ec,0xffff,0xe5ed,0xffff,0xffff,0xffff,
0xffff,0xb4d5,0xefc8,0xccfa,0xffff,0xe5ee,0xffff,0xffff,
0xffff,0xe5ef,0xefd4,0xefca,0xe5f0,0xffff,0xefcd,0xe5f1,
0xefcb,0xe5f2,0xefcc,0xe5f3,0xffff,0xffff,0xffff,0xffff,
0xe5f4,0xffff,0xefce,0xe5f5,0xffff,0xe5f6,0xe5f7,0xe5f8,
0xefd0,0xe5f9,0xe5fa,0xffff,0xffff,0xefd1,0xffff,0xefd2,
0xffff,0xffff,0xffff,0xffff,0xefd5,0xefd3,0xefd6,0xefd8,
0xffff,0xefd7,0xffff,0xe5fc,0xe5fb,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xc4b9,
0xe5fd,0xe5fe,0xffff,0xffff,0xffff,0xffff,0xe6a1,0xffff,
0xcce7,0xffff,0xefd9,0xc1ae,0xe6a2,0xffff,0xffff,0xefda,
0xe6a3,0xcac4,0xefdb,0xb3ab,0xe6a4,0xe6a5,0xe6a6,0xb1bc,
0xffff,0xb4d7,0xffff,0xb4d6,0xefdc,0xffff,0xefdd,0xffff,
0xefde,0xefdf,0xffff,0xffff,0xffff,0xe6a7,0xe6a8,0xe6a9,
0xefe0,0xe6aa,0xb4d8,0xb3d5,0xb9de,0xc8b6,0xe6ab,0xefe2,
0xefe1,0xe6ac,0xffff,0xe6ad,0xe6ae,0xefe3,0xffff,0xffff,
0xffff,0xffff,0xb1dc,0xffff,0xe6af,0xffff,0xe6b0,0xffff,
0xffff,0xefe6,0xe6b1,0xefe5,0xefe4,0xe6b2,0xefe7,0xe6b3,
0xffff,0xffff,0xffff,0xefea,0xffff,0xffff,0xe6b4,0xb0c7,
0xe6b5,0xe6b6,0xefe8,0xe6b7,0xefec,0xefeb,0xffff,0xffff,
0xe6b8,0xe6b9,0xe6ba,0xe6bb,0xefee,0xefed,0xefef,0xffff,
0xc6ae,0xe6bc,0xe6bd,0xffff,0xeff0,0xe6be,0xe6bf,0xe6c0,
0xe6c1,0xeff1,0xeff3,0xffff,0xe6c2,0xeff2,0xe6c3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc9ec,0xe6c4,0xe6c5,0xffff,
0xffff,0xeff4,0xe6c6,0xffff,0xe6c7,0xe6c8,0xe6c9,0xffff,
0xeff5,0xffff,0xbae5,0xffff,0xe6ca,0xffff,0xeff6,0xeff7,
0xffff,0xe6cb,0xcbc9,0xe6cc,0xffff,0xffff,0xffff,0xe6cd,
0xe6ce,0xe6cf,0xe6d0,0xc1cb,0xe6d1,0xe6d2,0xffff,0xb0a4,
0xc2cb,0xe6d3,0xeff8,0xffff,0xc9ed,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xeffb,0xeff9,0xb9df,0xffff,0xeffa,
0xb8c2,0xffff,0xe6d4,0xffff,0xe6d5,0xffff,0xe6d6,0xe6d7,
0xe6d8,0xffff,0xffff,0xcac5,0xeffd,0xf0a1,0xeffe,0xf0a2,
0xffff,0xe6d9,0xb1a1,0xbfd8,0xbdfc,0xb4d9,0xf0a3,0xffff,
0xffff,0xffff,0xc7e6,0xffff,0xf0a5,0xffff,0xe6da,0xffff,
0xb1a2,0xffff,0xf0a4,0xc4c4,0xe6db,0xcecd,0xc6ab,0xeffc,
0xcea6,0xffff,0xb8b1,0xe6dc,0xe6dd,0xcddb,0xe6de,0xe6df,
0xffff,0xe6e0,0xe6e1,0xe6e2,0xe6e3,0xb6f9,0xceb4,0xffff,
0xb7a8,0xe6e4,0xc2e2,0xe7a1,0xffff,0xf0a6,0xb3ac,0xbfef,
0xffff,0xe6e5,0xffff,0xffff,0xb3d6,0xf0a8,0xe6e6,0xf0a9,
0xf0a7,0xb7e4,0xe6e7,0xbadd,0xbee3,0xe6e8,0xffff,0xe6e9,
0xb1a3,0xffff,0xffff,0xced9,0xe6ea,0xe6eb,0xe6ec,0xf0ab,
0xeeae,0xe6ed,0xf0aa,0xffff,0xffff,0xffff,0xe6ee,0xe6ef,
0xf0ae,0xf0ac,0xf0ad,0xe6f0,0xf0af,0xffff,0xf0b0,0xceec,
0xf0b1,0xf0b2,0xe6f1,0xc0c9,0xc8bb,0xffff,0xffff,0xffff,
0xbffd,0xb4e7,0xffff,0xffff,0xcdba,0xb2ed,0xbdb8,0xb8db,
0xffff,0xf0b5,0xe6f2,0xf0b4,0xbbf3,0xf0b6,0xf0b3,0xffff,
0xffff,0xbba8,0xe6f3,0xffff,0xffff,0xf0ba,0xeaad,0xffff,
0xe6f5,0xd2d6,0xe6f6,0xbff7,0xf0b8,0xe6f7,0xe6f8,0xe6f9,
0xffff,0xffff,0xcea5,0xc6f1,0xffff,0xffff,0xffff,0xffff,
0xb1ab,0xe6fa,0xc0e3,0xbcb6,0xffff,0xffff,0xffff,0xe6fb,
0xcab7,0xe6fc,0xb1c0,0xffff,0xffff,0xffff,0xceed,0xcdeb,
0xffff,0xf0bb,0xe6fd,0xc5c5,0xffff,0xffff,0xffff,0xffff,
0xbcfb,0xffff,0xe6fe,0xe7a1,0xf0bc,0xe7a2,0xf0bd,0xbfcc,
0xf0be,0xe7a3,0xceee,0xffff,0xffff,0xf0b9,0xf0c0,0xf0c2,
0xffff,0xf0c1,0xffff,0xf0bf,0xffff,0xffff,0xf0c3,0xffff,
0xffff,0xf0c4,0xe7a4,0xe7a5,0xc1fa,0xe7a6,0xb2e2,0xffff,
0xffff,0xe7a7,0xe7a8,0xe7a9,0xf0c5,0xffff,0xffff,0xccb8,
0xe7aa,0xffff,0xf0c6,0xffff,0xffff,0xffff,0xffff,0xffff,
0xf0c7,0xe7ab,0xcfaa,0xe7ac,0xffff,0xffff,0xffff,0xffff,
0xdbb1,0xf0c8,0xffff,0xffff,0xffff,0xf0c9,0xf0ca,0xffff,
0xffff,0xe7ad,0xf0ce,0xe7ae,0xf0cb,0xffff,0xf0cc,0xffff,
0xf0cd,0xf0cf,0xe7af,0xffff,0xffff,0xffff,0xe7b0,0xe7b1,
0xffff,0xffff,0xc0c4,0xffff,0xffff,0xe7b2,0xccf7,0xe7b3,
0xe7b4,0xc0c5,0xe7b5,0xe7b6,0xf0d0,0xffff,0xc8f3,0xffff,
0xf0d1,0xf3d3,0xcccc,0xe7b7,0xf0d2,0xffff,0xf0d3,0xe7b8,
0xf0d4,0xb3d7,0xe7b9,0xf0d6,0xffff,0xbfd9,0xe7ba,0xffff,
0xffff,0xf0d7,0xffff,0xe7bb,0xb7a4,0xffff,0xe7bc,0xe7bd,
0xe7be,0xf0d8,0xf0dc,0xe7bf,0xf0da,0xe7c0,0xffff,0xe7c1,
0xe7c2,0xf0db,0xffff,0xffff,0xb3f3,0xf0d9,0xf0dd,0xffff,
0xffff,0xe7c3,0xffff,0xf0de,0xffff,0xb0c8,0xffff,0xf0df,
0xf0e0,0xffff,0xffff,0xffff,0xffff,0xe7c4,0xe7c5,0xe7c6,
0xbee4,0xe7c7,0xe7c8,0xffff,0xf0e1,0xffff,0xe7c9,0xe7ca,
0xb5c7,0xffff,0xe7cb,0xf0e4,0xffff,0xffff,0xf0e3,0xffff,
0xf0e2,0xffff,0xffff,0xebf1,0xe7cc,0xcadc,0xe7cd,0xffff,
0xffff,0xe7ce,0xe7cf,0xf0e5,0xf0e6,0xe7d0,0xe7d1,0xffff,
0xe7d2,0xe7d3,0xe7d4,0xffff,0xe7d5,0xffff,0xe7d6,0xe7d7,
0xffff,0xe7d8,0xffff,0xf0e7,0xe7d9,0xe7da,0xf0e8,0xe7db,
0xf0e9,0xe7dc,0xe7dd,0xf0ea,0xe7de,0xe7df,0xe7e0,0xffff,
0xe7e1,0xe7e2,0xffff,0xb4da,0xe7e3,0xffff,0xffff,0xe7e4,
0xe7e5,0xe7e6,0xffff,0xe7ea,0xf0eb,0xe7e7,0xe7e8,0xffff,
0xe7e9,0xe7eb,0xffff,0xffff,0xe7ec,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xf0ec,0xc7a3,0xe7ed,
0xffff,0xe7ee,0xf0ee,0xb2bb,0xe7ef,0xf0f1,0xf0f0,0xe7f0,
0xe7f1,0xffff,0xe7f2,0xb1a4,0xffff,0xffff,0xffff,0xb6c1,
0xffff,0xcac7,0xc4ba,0xbaa2,0xffff,0xb9e0,0xbde7,0xe7f3,
0xbfdc,0xffff,0xe7f4,0xffff,0xf0f3,0xe7f6,0xe7f7,0xf0f2,
0xcdc2,0xb4e8,0xc8d2,0xc6dc,0xe7f8,0xffff,0xe7f9,0xbffc,
0xcece,0xe7f5,0xb7db,0xffff,0xe7fa,0xffff,0xe7fb,0xffff,
0xe7fc,0xf0f6,0xffff,0xe7fd,0xf0f5,0xe8a8,0xe7fe,0xffff,
0xffff,0xffff,0xffff,0xe8a1,0xcbcb,0xc6ac,0xe8a2,0xe8a3,
0xe8a4,0xffff,0xe8a5,0xe8a6,0xb1d0,0xe8a7,0xffff,0xf0f7,
0xf0f4,0xffff,0xffff,0xc9d1,0xcdea,0xf0f8,0xe8a9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe8aa,0xffff,0xf0f9,0xe8ab,
0xffff,0xffff,0xe8ac,0xf0fb,0xc2ea,0xb3db,0xb3dc,0xf0fa,
0xffff,0xe8ad,0xe8ae,0xe8af,0xb4e9,0xb8b2,0xe8b0,0xe8b1,
0xb4ea,0xe8b2,0xe8b3,0xc5bf,0xffff,0xffff,0xcee0,0xffff,
0xffff,0xffff,0xe8b4,0xe8b5,0xffff,0xe8b6,0xe8b7,0xb8dc,
0xffff,0xffff,0xe8b8,0xf0fc,0xe8b9,0xffff,0xffff,0xf0fd,
0xf0fe,0xf1a1,0xffff,0xf1a3,0xf1a2,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xc9f7,0xffff,0xf1a4,0xe8ba,0xffff,0xe8bb,0xe8bc,0xf1a5,
0xe8bd,0xf1a6,0xffff,0xffff,0xe8be,0xffff,0xf1a7,0xe8bf,
0xe8c0,0xffff,0xe8c1,0xe8c2,0xffff,0xffff,0xffff,0xe8c3,
0xffff,0xffff,0xe8c4,0xf1a9,0xf1a8,0xe8c5,0xf1aa,0xffff,
0xe8c6,0xffff,0xffff,0xffff,0xe8c7,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xc8f4,0xe6cc,0xffff,0xffff,0xbfa9,
0xffff,0xe8c8,0xb5b2,0xe8c9,0xffff,0xe8ca,0xe8cb,0xe8cc,
0xffff,0xf1ab,0xe8cd,0xf1ac,0xffff,0xd2ac,0xddbb,0xc8d3,
0xffff,0xffff,0xb0fb,0xe8ce,0xb0bb,0xffff,0xe8cf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xbbf4,0xcbb0,0xbefe,0xffff,
0xffff,0xffff,0xe8d0,0xf1ad,0xffff,0xccdf,0xffff,0xe8d1,
0xe8d2,0xf1ae,0xcddc,0xffff,0xb1c2,0xffff,0xffff,0xffff,
0xbbc1,0xe8d3,0xf1af,0xb2ee,0xf1b0,0xe8d4,0xe8d5,0xe8d6,
0xf1b1,0xffff,0xe8d7,0xe8d8,0xe8d9,0xf1b3,0xf1b4,0xe8da,
0xf1b6,0xf1b2,0xe8db,0xffff,0xf1b5,0xffff,0xe8dc,0xe8dd,
0xb4db,0xffff,0xffff,0xe8de,0xf1b7,0xffff,0xf1b8,0xffff,
0xffff,0xe8df,0xe8e0,0xe8e1,0xe8e2,0xe8e3,0xffff,0xffff,
0xffff,0xe8e4,0xe8e5,0xe8e6,0xe8e7,0xf1b9,0xf1ba,0xffff,
0xe8e8,0xe8e9,0xf1bb,0xffff,0xffff,0xf1bd,0xe8ea,0xe8eb,
0xe8ec,0xf1bc,0xffff,0xf1bf,0xf1c2,0xe8ed,0xe8ee,0xffff,
0xf1be,0xf1c0,0xf1c1,0xffff,0xe8ef,0xf1c3,0xffff,0xb6c2,
0xe8f0,0xe8f1,0xffff,0xe8f2,0xe8f3,0xffff,0xe8f4,0xe8f5,
0xe8f6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xbcf3,0xf1c4,
0xf1c5,0xb9e1,0xffff,0xe8f7,0xffff,0xe8f8,0xffff,0xe8f9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xf1c6,0xe8fa,0xffff,
0xb3be,0xffff,0xffff,0xffff,0xc7cf,0xf1c7,0xf1c8,0xffff,
0xe8fb,0xe8fc,0xe8fd,0xc3da,0xc6eb,0xe8fe,0xffff,0xffff,
0xffff,0xe9a1,0xe9a2,0xffff,0xf1c9,0xe9a3,0xffff,0xe9a4,
0xffff,0xc7fd,0xffff,0xe9a5,0xc2cc,0xb1d8,0xb6ee,0xffff,
0xb6ef,0xe9a6,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xc3f3,0xf1ce,0xb6f0,0xe9a7,0xe9a8,0xb2ef,0xffff,0xffff,
0xf1cd,0xe9a9,0xe9aa,0xf1cb,0xe9ab,0xf1cc,0xe9ac,0xf1ca,
0xffff,0xffff,0xf1d8,0xffff,0xffff,0xffff,0xffff,0xe9ad,
0xffff,0xffff,0xe9ae,0xe9af,0xe9b0,0xf1cf,0xf1d0,0xffff,
0xe9b1,0xf1d1,0xf1d2,0xffff,0xe9b2,0xe9b3,0xffff,0xffff,
0xf1d4,0xe9b4,0xffff,0xf1d3,0xffff,0xe9b5,0xe9b6,0xbdd9,
0xffff,0xf1d5,0xe9b7,0xe9b8,0xe9b9,0xf1d7,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe9ba,0xe9bb,0xffff,0xb5b3,0xf1d6,
0xe9bc,0xe9bd,0xc1fb,0xb8b3,0xffff,0xffff,0xe9be,0xffff,
0xffff,0xf1d9,0xffff,0xffff,0xffff,0xffff,0xe9bf,0xffff,
0xe9c0,0xffff,0xe9c1,0xe9c2,0xe9c3,0xffff,0xffff,0xe9c4,
0xc2cd,0xffff,0xffff,0xf1da,0xffff,0xe9c5,0xe9c6,0xffff,
0xc6ad,0xffff,0xffff,0xe9c7,0xffff,0xe9c8,0xe9c9,0xf1db,
0xe9ca,0xffff,0xffff,0xffff,0xffff,0xffff,0xf1e0,0xffff,
0xf1de,0xe9cc,0xf1dd,0xf1df,0xe9cd,0xf1dc,0xffff,0xe9cb,
0xffff,0xffff,0xe9ce,0xe9cf,0xe9d0,0xf1e2,0xe9d1,0xffff,
0xffff,0xe9d2,0xffff,0xffff,0xe9d3,0xf1e1,0xe9d4,0xf1e4,
0xffff,0xffff,0xb6c3,0xf1e3,0xffff,0xe9d5,0xffff,0xf1e5,
0xffff,0xffff,0xf1e6,0xffff,0xf1e8,0xf1e7,0xffff,0xffff,
0xffff,0xf1e9,0xf1eb,0xf1ea,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb9fc,0xffff,0xe9d6,0xffff,0xe9d7,0xf1ec,0xe9d8,0xe9d9,
0xf1ed,0xffff,0xe9da,0xffff,0xe9db,0xe9dc,0xe9dd,0xffff,
0xb3bc,0xe9de,0xffff,0xe9df,0xf1ee,0xffff,0xe9e0,0xe9e1,
0xf1ef,0xe9e2,0xffff,0xe9e3,0xbff1,0xffff,0xe9e4,0xffff,
0xe9e5,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9e6,0xf1f0,
0xe9e7,0xf1f1,0xe9e8,0xf1f2,0xf1f3,0xe9e9,0xe9ea,0xe9eb,
0xb9e2,0xffff,0xffff,0xe9ec,0xe9ed,0xffff,0xf1f4,0xf1f5,
0xe9ee,0xffff,0xf1f6,0xf1f7,0xe9ef,0xe9f0,0xf1f8,0xe9f1,
0xffff,0xe9f2,0xc8b1,0xf1fa,0xe9f3,0xc9a6,0xf1fb,0xf1f9,
0xffff,0xf1fd,0xe9f4,0xe9f5,0xf1fc,0xe9f6,0xffff,0xf1fe,
0xffff,0xe9f7,0xe9f8,0xf2a1,0xffff,0xe9f9,0xffff,0xe9fa,
0xe9fb,0xe9fc,0xe9fd,0xe9fe,0xeaa1,0xeaa2,0xf2a2,0xffff,
0xeaa3,0xeaa4,0xffff,0xeaa5,0xeaa6,0xeaa7,0xeaa8,0xffff,
0xeaa9,0xffff,0xeaaa,0xffff,0xffff,0xffff,0xeaab,0xffff,
0xf2a3,0xeaac,0xf2a4,0xeaad,0xeaae,0xffff,0xffff,0xf2a5,
0xeaaf,0xffff,0xf2a6,0xf2a7,0xffff,0xf2a8,0xeab0,0xf2a9,
0xf2aa,0xf2ab,0xf2ac,0xeab1,0xffff,0xeab2,0xf2ad,0xf2ae,
0xffff,0xddb5,0xf2af,0xeab3,0xeab4,0xeab5,0xffff,0xeab6,
0xffff,0xeab7,0xeab8,0xe4f8,0xb5b4,0xeab9,0xffff,0xffff,
0xffff,0xb3a1,0xbab2,0xf2b1,0xf2b0,0xcca5,0xffff,0xffff,
0xeaba,0xffff,0xffff,0xeabb,0xeabc,0xf2b3,0xf2b4,0xf2b2,
0xffff,0xf2b5,0xffff,0xffff,0xcbe2,0xeabd,0xeabe,0xeabf,
0xf2b6,0xffff,0xb5fb,0xeac0,0xffff,0xffff,0xeac1,0xffff,
0xffff,0xeac2,0xffff,0xeac3,0xffff,0xeac4,0xeac5,0xffff,
0xeac6,0xffff,0xeac7,0xeac8,0xeac9,0xeaca,0xeacb,0xcfa5,
0xffff,0xffff,0xffff,0xeacc,0xf2b7,0xeacd,0xffff,0xeace,
0xeacf,0xead0,0xffff,0xffff,0xffff,0xffff,0xffff,0xead1,
0xead2,0xffff,0xffff,0xf2b9,0xead3,0xead4,0xead5,0xead6,
0xffff,0xead7,0xead8,0xead9,0xffff,0xeada,0xb0be,0xeadb,
0xeadc,0xf2ba,0xcaab,0xf2b8,0xeadd,0xffff,0xf2bb,0xf2bc,
0xffff,0xffff,0xeade,0xffff,0xffff,0xeadf,0xeae0,0xf2bd,
0xf2be,0xffff,0xffff,0xffff,0xffff,0xffff,0xeae1,0xeae2,
0xf2bf,0xeae3,0xcbee,0xbbad,0xeae4,0xbafa,0xc1af,0xffff,
0xeae5,0xeae6,0xeae7,0xffff,0xf2c0,0xffff,0xffff,0xeae8,
0xeae9,0xf2c3,0xffff,0xeaea,0xeaeb,0xffff,0xeaec,0xeaed,
0xf2c1,0xeaee,0xffff,0xffff,0xffff,0xffff,0xf2c4,0xeaef,
0xeaf0,0xb8f1,0xf2c2,0xffff,0xffff,0xffff,0xeaf1,0xf2c5,
0xeaf2,0xf2c6,0xf2c7,0xffff,0xf2cb,0xffff,0xbbaa,0xeaf3,
0xeaf4,0xffff,0xffff,0xc2e4,0xffff,0xeaf5,0xffff,0xeaf6,
0xffff,0xf2cc,0xf2c9,0xf2c8,0xf2ca,0xeaf7,0xffff,0xeaf8,
0xb7df,0xffff,0xeaf9,0xeafa,0xffff,0xffff,0xffff,0xeafb,
0xf2d0,0xf2cf,0xf2ce,0xeafc,0xffff,0xb0b3,0xffff,0xeafd,
0xeafe,0xeba1,0xeba2,0xffff,0xffff,0xeba3,0xffff,0xeba4,
0xeba5,0xffff,0xeba6,0xffff,0xf2da,0xffff,0xf2d6,0xffff,
0xf2d7,0xf2d3,0xf2d9,0xeba7,0xf2d5,0xb3e2,0xffff,0xeba8,
0xcfcc,0xeba9,0xf2d8,0xf2d4,0xf2d2,0xf2d1,0xebaa,0xffff,
0xebab,0xebac,0xebad,0xf2dc,0xebae,0xffff,0xebaf,0xffff,
0xffff,0xf2df,0xebb0,0xebb1,0xf2de,0xf2dd,0xebb2,0xebb3,
0xebb4,0xebb5,0xebb6,0xffff,0xffff,0xc9c9,0xf2db,0xb0f3,
0xf2e0,0xebb7,0xf2e2,0xffff,0xffff,0xebb8,0xebb9,0xebba,
0xffff,0xb3ef,0xf2cd,0xb1b7,0xffff,0xebbb,0xf2e4,0xffff,
0xffff,0xebbc,0xffff,0xebbd,0xebbe,0xebbf,0xf2e3,0xf2e1,
0xc3ad,0xebc0,0xebc1,0xffff,0xffff,0xffff,0xebc2,0xebc3,
0xebc4,0xffff,0xcbf0,0xebc5,0xebc6,0xffff,0xebc7,0xceda,
0xebc8,0xffff,0xf2e5,0xebc9,0xebd0,0xebca,0xebcb,0xebcc,
0xf2e6,0xffff,0xffff,0xebcd,0xffff,0xffff,0xffff,0xf2e7,
0xebd2,0xebce,0xebcf,0xebd1,0xffff,0xffff,0xebd3,0xffff,
0xebd4,0xffff,0xebd5,0xffff,0xffff,0xebd6,0xf2e8,0xebd7,
0xf2e9,0xffff,0xffff,0xebd8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xc4bb,0xebd9,0xf2ea,
0xffff,0xc8b7,0xffff,0xf2ef,0xf2eb,0xffff,0xffff,0xffff,
0xf2ec,0xffff,0xebda,0xcbb1,0xccc4,0xffff,0xc6d0,0xebdb,
0xffff,0xebdc,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xebde,0xf2f0,0xffff,0xffff,0xf2f1,0xc6be,
0xf2ee,0xf2ed,0xffff,0xebdd,0xffff,0xffff,0xb2aa,0xffff,
0xffff,0xebdf,0xf2f9,0xffff,0xffff,0xf2f8,0xffff,0xebe0,
0xebe1,0xffff,0xffff,0xb1f5,0xebe2,0xebe3,0xebe4,0xf2f6,
0xffff,0xffff,0xffff,0xf2f5,0xffff,0xffff,0xf2f3,0xffff,
0xb3fb,0xffff,0xf2f2,0xbcb2,0xb2a9,0xffff,0xffff,0xebe5,
0xebe6,0xffff,0xebe7,0xebe8,0xebe9,0xffff,0xffff,0xffff,
0xffff,0xffff,0xebea,0xb9e3,0xebeb,0xebed,0xf2fc,0xf2fb,
0xffff,0xf2fa,0xebee,0xebef,0xf2f7,0xebec,0xf2fd,0xebf0,
0xf2fe,0xffff,0xebf1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xf3a5,0xf3a4,0xffff,0xebf2,0xebf3,0xffff,0xffff,0xffff,
0xffff,0xf3a6,0xffff,0xffff,0xb1ad,0xf3a1,0xf3a2,0xebf4,
0xb9f4,0xccb9,0xebf6,0xebf5,0xf3a3,0xebf7,0xffff,0xffff,
0xffff,0xebf8,0xebf9,0xebfa,0xcbb2,0xffff,0xffff,0xf3ab,
0xebfb,0xffff,0xf3a7,0xffff,0xffff,0xffff,0xebfc,0xebfd,
0xffff,0xffff,0xf3ac,0xebfe,0xeca1,0xffff,0xeca2,0xffff,
0xffff,0xffff,0xffff,0xeca3,0xeca4,0xffff,0xeca5,0xf3a9,
0xffff,0xf3a8,0xeca6,0xffff,0xffff,0xeca7,0xeca8,0xb7dc,
0xffff,0xffff,0xeca9,0xecaa,0xffff,0xecab,0xecac,0xecad,
0xecae,0xffff,0xf3ad,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xecaf,0xffff,0xffff,0xf3ae,0xffff,0xffff,0xffff,
0xffff,0xf3af,0xecb0,0xf3aa,0xecb1,0xffff,0xecb2,0xf2f4,
0xffff,0xecb3,0xf3b0,0xffff,0xc4e1,0xecb4,0xffff,0xffff,
0xf3b4,0xecb5,0xf3b5,0xf3b3,0xecb6,0xffff,0xffff,0xecb7,
0xffff,0xf3b2,0xf3b8,0xecb8,0xf3b1,0xffff,0xf3b6,0xecb9,
0xffff,0xecba,0xecbb,0xffff,0xffff,0xffff,0xffff,0xf3b7,
0xffff,0xffff,0xffff,0xf3ba,0xecbc,0xecbd,0xecbe,0xecbf,
0xffff,0xf3b9,0xecc0,0xffff,0xffff,0xffff,0xecc1,0xecc2,
0xecc3,0xffff,0xffff,0xffff,0xffff,0xecc4,0xf3bc,0xecc5,
0xffff,0xecc6,0xffff,0xecc7,0xffff,0xf3bd,0xecc8,0xf3be,
0xecc9,0xffff,0xcfc9,0xecca,0xeccb,0xffff,0xffff,0xffff,
0xf3bb,0xc2eb,0xbaed,0xffff,0xffff,0xf3bf,0xeccc,0xffff,
0xffff,0xffff,0xecce,0xffff,0xffff,0xffff,0xffff,0xeccf,
0xffff,0xffff,0xeccd,0xffff,0xffff,0xffff,0xecd0,0xffff,
0xecd1,0xecd2,0xecd3,0xffff,0xffff,0xecd4,0xecd5,0xffff,
0xffff,0xecd6,0xf3c0,0xf3c1,0xecd7,0xecd8,0xf3c2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xf3c3,0xffff,0xffff,
0xb8b4,0xf3c4,0xecd9,0xecda,0xecdb,0xf3c5,0xffff,0xbcaf,
0xecdc,0xf3c6,0xecdd,0xecde,0xecdf,0xece0,0xffff,0xece1,
0xf3c7,0xffff,0xffff,0xf3c8,0xf3c9,0xffff,0xece2,0xece3,
0xffff,0xf3cc,0xf3ca,0xcfbc,0xffff,0xf3cb,0xece4,0xceef,
0xece5,0xffff,0xffff,0xece6,0xffff,0xf3cd,0xece7,0xcedb,
0xffff,0xffff,0xffff,0xffff,0xece8,0xf3ce,0xc7fe,0xffff,
0xece9,0xf3cf,0xf3d1,0xffff,0xecea,0xf3d2,0xeceb,0xecec,
0xeced,0xffff,0xffff,0xecee,0xecef,0xecf0,0xffff,0xffff,
0xf3d0,0xb9ed,0xcccd,0xcbe3,0xd6f7,0xffff,0xdde0,0xcbfb,
0xffff,0xffff,0xffff,0xffff,0xb2ab,0xffff,0xecf1,0xffff,
0xecf2,0xffff,0xffff,0xecf3,0xf3d4,0xb5d0,0xf3d5,0xf3d6,
0xf3d7,0xffff,0xb9f5,0xffff,0xf3d8,0xecf4,0xffff,0xffff,
0xe0d4,0xccdb,0xffff,0xc2e3,0xf3d9,0xf3db,0xf3da,0xecf5,
0xf3dc,0xffff,0xffff,0xffff,0xecf6,0xf3dd,0xffff,0xecf7,
0xf3de,0xffff,0xffff,0xffff,0xecf8,0xecf9,0xecfa,0xf3df,
0xecfb,0xecfc,0xecfd,0xffff,0xf3e0,0xecfe,0xf3e1,0xf3e2,
0xeda1,0xf3e3,0xffff,0xf3e4,0xf3e5,0xf3e6,0xffff,0xeda2,
0xffff,0xffff,0xeda3,0xeda4,0xffff,0xffff,0xffff,0xf3e7,
0xf3e8,0xeda5,0xffff,0xffff,0xffff,0xffff,0xc5a4,0xeda6,
0xeda7,0xeda8,0xeda9,0xb8dd,0xedaa,0xf3ea,0xedab,0xedac,
0xffff,0xedad,0xedae,0xedaf,0xffff,0xffff,0xffff,0xedb0,
0xc1cd,0xf3eb,0xedb1,0xffff,0xffff,0xffff,0xedb2,0xffff,
0xffff,0xffff,0xedb3,0xedb4,0xf3ec,0xffff,0xffff,0xedb5,
0xffff,0xedb6,0xedb7,0xffff,0xedb8,0xffff,0xffff,0xedb9,
0xffff,0xedba,0xedbb,0xc9a1,0xedbc,0xedbd,0xf3ed,0xedbe,
0xffff,0xedbf,0xffff,0xedc0,0xedc1,0xedc2,0xedc3,0xedc4,
0xffff,0xffff,0xf3ee,0xe3b7,0xffff,0xffff,0xecda,0xf0ed,
0xffff,0xffff,0xf3ef,0xedc5,0xf3f0,0xedc6,0xedc7,0xedc8,
0xedc9,0xffff,0xedca,0xffff,0xffff,0xedcb,0xedcc,0xf3f2,
0xf3f3,0xf3f4,0xcef0,0xf3f1,0xffff,0xffff,0xf3f5,0xf3f6,
0xedcd,0xedce,0xf3f8,0xffff,0xf3f7,0xedcf,0xedd0,0xedd1,
0xedd2,0xedd3,0xf3fa,0xedd4,0xffff,0xedd5,0xf3fb,0xf3f9,
0xffff,0xffff,0xedd6,0xffff,0xffff,0xedd7,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xceb6,0xffff,0xedd8,
0xedd9,0xedda,0xeddb,0xffff,0xeddc,0xf3fc,0xeddd,0xedde,
0xffff,0xffff,0xffff,0xffff,0xf3fd,0xe3d4,0xeddf,0xffff,
0xf3fe,0xede0,0xede1,0xede2,0xffff,0xede3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa1aa,0xffff,0xa1f4,0xa1f0,0xa1f3,0xa1f5,0xffff,
0xa1ca,0xa1cb,0xa1f6,0xa1dc,0xa1a4,0xffff,0xa1a5,0xa1bf,
0xa3b0,0xa3b1,0xa3b2,0xa3b3,0xa3b4,0xa3b5,0xa3b6,0xa3b7,
0xa3b8,0xa3b9,0xa1a7,0xa1a8,0xa1e3,0xa1e1,0xa1e4,0xa1a9,
0xa1f7,0xa3c1,0xa3c2,0xa3c3,0xa3c4,0xa3c5,0xa3c6,0xa3c7,
0xa3c8,0xa3c9,0xa3ca,0xa3cb,0xa3cc,0xa3cd,0xa3ce,0xa3cf,
0xa3d0,0xa3d1,0xa3d2,0xa3d3,0xa3d4,0xa3d5,0xa3d6,0xa3d7,
0xa3d8,0xa3d9,0xa3da,0xa1ce,0xa1c0,0xa1cf,0xa1b0,0xa1b2,
0xa1ae,0xa3e1,0xa3e2,0xa3e3,0xa3e4,0xa3e5,0xa3e6,0xa3e7,
0xa3e8,0xa3e9,0xa3ea,0xa3eb,0xa3ec,0xa3ed,0xa3ee,0xa3ef,
0xa3f0,0xa3f1,0xa3f2,0xa3f3,0xa3f4,0xa3f5,0xa3f6,0xa3f7,
0xa3f8,0xa3f9,0xa3fa,0xa1d0,0xa1c3,0xa1d1,0xa2b7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa1b1,0xffff,0xa1ef,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff
};
static const unsigned int  Our_eucJP_tableB_8F_FB[] = {
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x4a6300a1,
0xffff7eff,0xfffffeff,0xfffff3ff,0xeff3ffff,0xfffcffff,0xfffffffe,
0x00000000,0x00000000,0x0007fff8,0x00000400,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x010000f4,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x0eeb8000,0x003f8000,
0x203e0000,0x00000000,0x3ffb0000,0x00000000,0x00003ffb,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000200,0x20000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x2c082001,0x18938400,0xc9004028,0x10c00c41,0x00040304,0x00010040,
0x10008030,0xe0815407,0xb0982740,0x00025552,0xa0d82a81,0x902a41e6,
0x6c6ab963,0x0000215e,0xc6dd2008,0xa000a00d,0xc92a919e,0x2102b410,
0xe62a7141,0xb324c000,0x5a23ba1b,0xe0218064,0x990a988d,0x2ac16222,
0x139e815e,0x118d5cc0,0x20211581,0x0a000002,0x18120084,0x500400ab,
0x20817482,0x24023900,0x64003680,0x20806408,0x044005a9,0xc20201c0,
0xa42817a8,0x0f0183b4,0x8a894a18,0x44e8cb00,0x9038509b,0x05dca40e,
0x20180050,0x540c2042,0x11821844,0x48312da4,0x84013426,0x83000400,
0x20001020,0x41a14c00,0x19050002,0x2b560801,0x54c44609,0x43664171,
0x02260000,0x8029020b,0xc4ce0400,0x0030261c,0x4164c0b2,0xca000001,
0x62837900,0x18042001,0x525a7192,0x20400201,0x04a7e040,0x0008955d,
0xda550802,0xf2456400,0x0c980467,0x03dc5102,0x047d804d,0x4f944300,
0x61284434,0xbc6b1807,0x060c2000,0x2597dd7a,0x50080d6f,0x41c80084,
0x01890406,0x4b448687,0x18cc0013,0x83042041,0x004d8401,0x49800089,
0xc1ed8a04,0xe2406008,0x2886aa24,0x60401000,0x06183804,0x58819601,
0x12003057,0x50152658,0x001a2501,0x09079128,0x58a42007,0x19036900,
0x880e3002,0x19a48000,0x0d888402,0x15040132,0x0010924b,0xa10874b1,
0x0a810028,0x84220604,0xc0800154,0x44040880,0x40182202,0x0083000f,
0x4a22da00,0x00cd6128,0xc00503e0,0x80014804,0x00080103,0x125aa600,
0x00000068,0x31c48c3c,0x01a12005,0xb2202c20,0x00502104,0x00026800,
0x42042000,0x1b104845,0x32a04441,0xe8248063,0x50a03c51,0x8110a8c0,
0x111280c0,0x884000c0,0x81042c81,0x80822402,0x0050c29a,0x00be8000,
0x80120000,0x2ca85007,0x021a6c0a,0x04100000,0x2382004c,0x789a8a15,
0x8d048890,0x99012ca6,0x0045020c,0x2919c080,0x09d0f802,0x60ef3228,
0x012419a1,0x08041400,0x81c84b04,0x41004003,0x22a25486,0x2c80c112,
0x28f30c56,0x2400248c,0x2128fb4a,0x2030c740,0x46400002,0x80082099,
0xd814318d,0x84a400c8,0xe003040f,0x654d0000,0x59001408,0xb1500044,
0x3a08ea28,0x08051024,0x00078000,0x02801323,0x08020620,0x0020280c,
0x18349280,0x00640648,0x7a323890,0x060c4c8d,0x29208c62,0x0a070004,
0x44825c08,0x842834c0,0x0060a882,0xac618405,0x0011783d,0xd0041814,
0x0501c0d5,0x52881007,0x087ac500,0x0c648511,0x48e11a53,0x2242402c,
0x1140a801,0x81100024,0x44202484,0x92023801,0x20c28a81,0x0000ac43,
0x88c46606,0x7a7ad140,0x862a41d8,0xc03815db,0x801ca079,0x88046411,
0xb08b0811,0x009a0030,0x05021048,0xa0001002,0x05880c04,0x020a0a10,
0x480352d0,0x0000e41c,0xb4c02148,0x4200a340,0x00000845,0x018dd011,
0x0c282590,0x0013e478,0x2a8002a8,0x54622010,0x0489d24c,0x04bcc61c,
0x0260d300,0x00005490,0x24420110,0x1ec8e031,0x80042280,0x469501a8,
0x04804300,0x24035402,0xd0014424,0x8880a913,0x0662e610,0x09205002,
0x53504017,0x0411c807,0x02c88e0c,0x0908e00c,0x3341c112,0x08990611,
0x02242284,0x81128406,0x24000111,0xb0ce80c6,0x18480220,0x53024141,
0x2c46a041,0x038a1631,0x00352858,0x01150ad0,0x07400d89,0x0000a800,
0x2205ea28,0x815a2800,0x09235020,0x03834049,0x00000103,0x45018008,
0x21006b80,0x00280945,0x08a30215,0xa4418a08,0x88000002,0x21002258,
0x0cd1790e,0x30801014,0x00041040,0x81065011,0xd1a70000,0x00160054,
0x08ac02b0,0x02659218,0x00017166,0x60880006,0x119cba21,0x87838608,
0x05a00022,0x00c0844c,0x87040100,0x90010948,0x18f20c06,0x0c0a0602,
0x46000f90,0x0810c900,0x00205e88,0x08000020,0x1f190002,0x8015c080,
0x4730a12a,0x80800040,0x85082030,0xa001b021,0xc8181268,0x00000082,
0x81c01125,0x081108c0,0x7403962a,0x90934199,0x08461010,0x00864802,
0x41480681,0x04001832,0x2d1430c2,0x29886434,0x1004a287,0x835b4148,
0xd602958b,0xa634054d,0x06593244,0x53400d75,0xc9204030,0x0affc040,
0x9b146104,0x23966000,0xc741e0e9,0xd2f36451,0x00c890b3,0x08b10839,
0x02002300,0xc9610247,0x9182a103,0x4001407e,0x4400b448,0x28000821,
0xca0b0109,0xc90b4040,0xb9a9365e,0x164434e8,0xdc700441,0x0c074800,
0x440c041d,0xbfa40004,0x445a0840,0x8288c248,0x82222d68,0x20870e46,
0x2627230b,0xa928b824,0x880c0e21,0x21234402,0x10406443,0x8a28c890,
0x06464004,0x70068500,0x198a200a,0xd8a20022,0x00210887,0x488cf015,
0x01ca3611,0xca203331,0x8208802b,0x85444c15,0x0e314898,0x0150205a,
0x00185e98,0x40d14890,0x29a10a26,0xa4344088,0x31684412,0x41158ce0,
0x0d88064d,0x85240482,0xa630c802,0x90081458,0x024a4010,0x00d84816,
0x01000801,0x1177c805,0xc1020400,0x8a653100,0x0842c212,0x8409a63c,
0x24a00b70,0x00a02cea,0x7a5b0050,0x86885a60,0x0220747e,0x5146a04c,
0x03010802,0x82008339,0x09c51d64,0x02500400,0x11c17206,0x1224400e,
0xc184516c,0x052080b1,0x769c4306,0x03201340,0x3e0e0140,0x26344660,
0x8080c50c,0x818d1201,0x0d02a081,0x64131082,0x432444a6,0x00000000,
0x00000000,0x00000000,0x00000000,0x0000001f,0x1901301c,0x5e044007,
0x8015c308,0x62240809,0x90830011,0x148b2027,0x01a75a07,0x8a0a8d6a,
0x88000000,0x8a044400,0x4082000a,0x031000c0,0x00852d80,0x8006b262,
0x1010038a,0x89088428,0x05282100,0xc1c50100,0x4e128292,0x20022810,
0x14330516,0x4818e6c5,0x90011864,0x60802820,0x1e134208,0x91040815,
0xd9624ab0,0xd9e2a92b,0x02008420,0xa8a50306,0xc1b00017,0x600e912c,
0x39065f00,0x00008085,0xaa042cdc,0x034c0003,0x8141c804,0x00a002c8,
0x42214440,0x00010040,0x05a562e8,0x8d209a8c,0x44003402,0x02e14826,
0xa1891008,0x0121e134,0x310a800a,0x3d313a01,0x0201f24f,0xe8110075,
0x46591085,0xa5040b8f,0x213200a1,0x82841209,0x8c06e0d2,0x414002ac,
0xe20033c4,0xf8490720,0x008442a8,0x43845dc1,0xd4006528,0x9500002c,
0x0d139843,0x5083606e,0x94040084,0x4c016010,0x1fd895c2,0x910e4403,
0x40e20669,0x383450a1,0x5270b8fb,0x0086a428,0x54f246a9,0x88404050,
0x800000b9,0x80a00026,0x803e7012,0x0101c500,0x420706e8,0x8380e462,
0xa6412138,0x7012943c,0x00448c19,0x84008f08,0x00000f80,0x04545245,
0x0d016c02,0xaa190506,0x9546138c,0x45000773,0x9211a341,0x01431312,
0x12e05d05,0x00088e09,0x0630400b,0x00048108,0x3e843842,0x100402ca,
0x4c150c0b,0x00000000,0x00000000,0x00000000,0x00000000,0x000000c6,
0x055159d4,0x1ac41612,0x0310b058,0x08000060,0x06510644,0x4089a583,
0x50402110,0x00000000,0x00000000,0x044a0001,0x2884c403,0x82192558,
0x87a24d40,0x0d08e804,0x4e104a00,0xf30053c4,0xc017081e,0x604dc070,
0x3040a436,0x21461430,0xd9014808,0x0086c160,0xa1818382,0xd58e0f20,
0xd1017c86,0x04000000,0x00000004,0xce000682,0xc234b400,0x98824612,
0x28880090,0x00ed1901,0x18080014,0x23088840,0x049a85d0,0xe400ba06,
0x1d8825cd,0x04118a03,0x8e848baa,0xb5434b6c,0x11811170,0x49040870,
0x56225c82,0x428ef21d,0x34001962,0x0c6fc154,0xcf68b28c,0x1e8396ea,
0xb32740cc,0xc5c387dd,0x00e62141,0x8d9122bd,0xf79e95cd,0xd58a8051,
0xa0844c0f,0x4d601b00,0x01c0e5a2,0x0d65da25,0xe0b52492,0x5ad00e20,
0x4f7c104b,0x230001f4,0x68c70701,0x00037815,0x14a80449,0x50976000,
0x18000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x000000c2,0x088e0007,0x42580a25,0x02d0f067,0x8a000000,
0x00000006,0x2e0851ec,0x40002b80,0x4002081b,0x78404225,0x0e431020,
0x002020a7,0x00414020,0x34400034,0x70805000,0x502305b0,0x11221395,
0x80400763,0x200a66eb,0x4d6ec9d6,0xc80149a0,0x01260a4a,0x9613b402,
0x09207360,0x36280000,0x00000000,0x001689b1,0x24880000,0x57201200,
0x21804739,0x23107c78,0xc38608db,0x80000000,0x00000015,0x0200e465,
0x1040186a,0x01388c46,0x3818c202,0xb9061680,0x493a4a04,0x00000000,
0x00000000,0x002b2e53,0x5282a718,0x8d483465,0xfcdea258,0x82141d64,
0x00980712,0x56be15c1,0x8f758826,0x0348e19b,0x41828185,0x053111e5,
0xa01142ea,0x33e04704,0x5c639a9f,0x10f2a510,0x00000000,0x00000000,
0x00000000,0x02002140,0x2010418e,0x0001b82c,0x35201801,0x3470831a,
0x1a263780,0x402a4449,0x11600f23,0x85529802,0x2122e64c,0x00000000,
0x00000000,0x00000038,0xbd030292,0x088b9c00,0x02900401,0x090ee481,
0x3041eb71,0x2231696d,0x5f0017a6,0x00c7d424,0x0001eb02,0x74000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000002,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,};
#endif /* USE_OUR_MB_WC_DATA_TABLES */
